-- filename : char-def.lua
-- comment  : companion to char-def.tex (in ConTeXt)
-- author   : Hans Hagen, PRAGMA-ADE, Hasselt NL
-- copyright: PRAGMA ADE / ConTeXt Development Team
-- license  : see context related readme files

-- remark   : compact version

-- 0x2061 FUNCTION APPLICATION -> relax

if not versions   then versions   = { } end versions['char-def'] = 1.001
if not characters then characters = { } end

characters.data={
 [0x0000]={
  ["category"]="cc",
  ["description"]="NULL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0000,
 },
 {
  ["category"]="cc",
  ["description"]="START OF HEADING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0001,
 },
 {
  ["category"]="cc",
  ["description"]="START OF TEXT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0002,
 },
 {
  ["category"]="cc",
  ["description"]="END OF TEXT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0003,
 },
 {
  ["category"]="cc",
  ["description"]="END OF TRANSMISSION",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0004,
 },
 {
  ["category"]="cc",
  ["description"]="ENQUIRY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0005,
 },
 {
  ["category"]="cc",
  ["description"]="ACKNOWLEDGE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0006,
 },
 {
  ["category"]="cc",
  ["description"]="BELL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0007,
 },
 {
  ["category"]="cc",
  ["description"]="BACKSPACE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0008,
 },
 {
  ["category"]="cc",
  ["description"]="CHARACTER TABULATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0009, --
 },
 {
  ["category"]="cc",
  ["description"]="LINE FEED (LF)",
  ["linebreak"]="lf",
  ["unicodeslot"]=0x000A, --

 },
 {
  ["category"]="cc",
  ["description"]="LINE TABULATION",
  ["linebreak"]="bk",
  ["unicodeslot"]=0x000B,
 },
 {
  ["category"]="cc",
  ["description"]="FORM FEED (FF)",
  ["linebreak"]="bk",
  ["unicodeslot"]=0x000C,
 },
 {
  ["category"]="cc",
  ["description"]="CARRIAGE RETURN (CR)",
  ["linebreak"]="cr",
  ["unicodeslot"]=0x000D, --
 },
 {
  ["category"]="cc",
  ["description"]="SHIFT OUT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x000E,
 },
 {
  ["category"]="cc",
  ["description"]="SHIFT IN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x000F,
 },
 {
  ["category"]="cc",
  ["description"]="DATA LINK ESCAPE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0010,
 },
 {
  ["category"]="cc",
  ["description"]="DEVICE CONTROL ONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0011,
 },
 {
  ["category"]="cc",
  ["description"]="DEVICE CONTROL TWO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0012,
 },
 {
  ["category"]="cc",
  ["description"]="DEVICE CONTROL THREE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0013,
 },
 {
  ["category"]="cc",
  ["description"]="DEVICE CONTROL FOUR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0014,
 },
 {
  ["category"]="cc",
  ["description"]="NEGATIVE ACKNOWLEDGE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0015,
 },
 {
  ["category"]="cc",
  ["description"]="SYNCHRONOUS IDLE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0016,
 },
 {
  ["category"]="cc",
  ["description"]="END OF TRANSMISSION BLOCK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0017,
 },
 {
  ["category"]="cc",
  ["description"]="CANCEL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0018,
 },
 {
  ["category"]="cc",
  ["description"]="END OF MEDIUM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0019,
 },
 {
  ["category"]="cc",
  ["description"]="SUBSTITUTE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x001A,
 },
 {
  ["category"]="cc",
  ["description"]="ESCAPE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x001B,
 },
 {
  ["category"]="cc",
  ["description"]="INFORMATION SEPARATOR FOUR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x001C,
 },
 {
  ["category"]="cc",
  ["description"]="INFORMATION SEPARATOR THREE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x001D,
 },
 {
  ["category"]="cc",
  ["description"]="INFORMATION SEPARATOR TWO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x001E,
 },
 {
  ["category"]="cc",
  ["description"]="INFORMATION SEPARATOR ONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x001F,
 },
 {
  ["adobename"]="space",
  ["category"]="zs",
  ["cjkwd"]="na",
  ["description"]="SPACE",
  ["linebreak"]="sp",
  ["unicodeslot"]=0x0020, --
 },
 {
  ["adobename"]="exclam",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="EXCLAMATION MARK",
  ["linebreak"]="ex",
  ["mathclass"]="close",
  ["unicodeslot"]=0x0021, -- !
 },
 {
  ["adobename"]="quotedbl",
  ["category"]="po",
  ["cjkwd"]="na",
  ["contextname"]="quotedbl",
  ["description"]="QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x0022, -- "
 },
 {
  ["adobename"]="numbersign",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="NUMBER SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0023, -- #
 },
 {
  ["adobename"]="dollar",
  ["category"]="sc",
  ["cjkwd"]="na",
  ["description"]="DOLLAR SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x0024, -- $
 },
 {
  ["adobename"]="percent",
  ["category"]="po",
  ["cjkwd"]="na",
  ["contextname"]="percent",
  ["description"]="PERCENT SIGN",
  ["linebreak"]="po",
  ["unicodeslot"]=0x0025, -- %
 },
 {
  ["adobename"]="ampersand",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="AMPERSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0026, -- &
 },
 {
  ["adobename"]="quotesingle",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="APOSTROPHE",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x0027, -- '
 },
 {
  ["adobename"]="parenleft",
  ["category"]="ps",
  ["cjkwd"]="na",
  ["description"]="LEFT PARENTHESIS",
  ["linebreak"]="op",
  ["mathclass"]="open",
  ["mathname"]="lparent",
  ["unicodeslot"]=0x0028, -- (
 },
 {
  ["adobename"]="parenright",
  ["category"]="pe",
  ["cjkwd"]="na",
  ["description"]="RIGHT PARENTHESIS",
  ["linebreak"]="cl",
  ["mathclass"]="close",
  ["mathname"]="rparent",
  ["unicodeslot"]=0x0029, -- )
 },
 {
  ["adobename"]="asterisk",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="ASTERISK",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["unicodeslot"]=0x002A, -- *
 },
 {
  ["adobename"]="plus",
  ["category"]="sm",
  ["cjkwd"]="na",
  ["description"]="PLUS SIGN",
  ["linebreak"]="pr",
  ["mathclass"]="binary",
  ["unicodeslot"]=0x002B, -- +
 },
 {
  ["adobename"]="comma",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="COMMA",
  ["linebreak"]="is",
  ["mathclass"]="punctuation",
  ["unicodeslot"]=0x002C, -- ,
 },
 {
  ["adobename"]="hyphen",
  ["category"]="pd",
  ["cjkwd"]="na",
  ["description"]="HYPHEN-MINUS",
  ["linebreak"]="hy",
  ["mathclass"]="binary",
  ["unicodeslot"]=0x002D, -- -
 },
 {
  ["adobename"]="period",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="FULL STOP",
  ["linebreak"]="is",
  ["mathclass"]="punctuation",
  ["unicodeslot"]=0x002E, -- .
 },
 {
  ["adobename"]="slash",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="SOLIDUS",
  ["linebreak"]="sy",
  ["mathclass"]="binary",
  ["unicodeslot"]=0x002F, -- /
 },
 {
  ["adobename"]="zero",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT ZERO",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0030, -- 0x0000
 },
 {
  ["adobename"]="one",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT ONE",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0031, -- 0x0001
 },
 {
  ["adobename"]="two",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT TWO",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0032, -- 0x0002
 },
 {
  ["adobename"]="three",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT THREE",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0033, -- 0x0003
 },
 {
  ["adobename"]="four",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT FOUR",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0034, -- 0x0004
 },
 {
  ["adobename"]="five",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT FIVE",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0035, -- 0x0005
 },
 {
  ["adobename"]="six",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT SIX",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0036, -- 0x0006
 },
 {
  ["adobename"]="seven",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT SEVEN",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0037, -- 0x0007
 },
 {
  ["adobename"]="eight",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT EIGHT",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0038, -- 0x0008
 },
 {
  ["adobename"]="nine",
  ["category"]="nd",
  ["cjkwd"]="na",
  ["description"]="DIGIT NINE",
  ["linebreak"]="nu",
  ["mathclass"]="number",
  ["unicodeslot"]=0x0039, -- 0x0009
 },
 {
  ["adobename"]="colon",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="COLON",
  ["linebreak"]="is",
  ["mathclass"]="punctuation",
  ["unicodeslot"]=0x003A, -- :
 },
 {
  ["adobename"]="semicolon",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="SEMICOLON",
  ["linebreak"]="is",
  ["mathclass"]="punctuation",
  ["unicodeslot"]=0x003B, -- ;
 },
 {
  ["adobename"]="less",
  ["category"]="sm",
  ["cjkwd"]="na",
  ["description"]="LESS-THAN SIGN",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="lt",
  ["unicodeslot"]=0x003C, -- <
 },
 {
  ["adobename"]="equal",
  ["category"]="sm",
  ["cjkwd"]="na",
  ["description"]="EQUALS SIGN",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="eq",
  ["unicodeslot"]=0x003D, -- =
 },
 {
  ["adobename"]="greater",
  ["category"]="sm",
  ["cjkwd"]="na",
  ["description"]="GREATER-THAN SIGN",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="gt",
  ["unicodeslot"]=0x003E, -- >
 },
 {
  ["adobename"]="question",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="QUESTION MARK",
  ["linebreak"]="ex",
  ["mathclass"]="close",
  ["unicodeslot"]=0x003F, -- ?
 },
 {
  ["adobename"]="at",
  ["category"]="po",
  ["cjkwd"]="na",
  ["description"]="COMMERCIAL AT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0040, -- @
 },
 {
  ["adobename"]="A",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER A",
  ["lccode"]=0x0061,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0041, -- A
 },
 {
  ["adobename"]="B",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER B",
  ["lccode"]=0x0062,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0042, -- B
 },
 {
  ["adobename"]="C",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER C",
  ["lccode"]=0x0063,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0043, -- C
 },
 {
  ["adobename"]="D",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER D",
  ["lccode"]=0x0064,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0044, -- D
 },
 {
  ["adobename"]="E",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER E",
  ["lccode"]=0x0065,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0045, -- E
 },
 {
  ["adobename"]="F",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER F",
  ["lccode"]=0x0066,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0046, -- F
 },
 {
  ["adobename"]="G",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER G",
  ["lccode"]=0x0067,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0047, -- G
 },
 {
  ["adobename"]="H",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER H",
  ["lccode"]=0x0068,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0048, -- H
 },
 {
  ["adobename"]="I",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER I",
  ["lccode"]=0x0069,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0049, -- I
 },
 {
  ["adobename"]="J",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER J",
  ["lccode"]=0x006A,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x004A, -- J
 },
 {
  ["adobename"]="K",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER K",
  ["lccode"]=0x006B,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x004B, -- K
 },
 {
  ["adobename"]="L",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER L",
  ["lccode"]=0x006C,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x004C, -- L
 },
 {
  ["adobename"]="M",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER M",
  ["lccode"]=0x006D,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x004D, -- M
 },
 {
  ["adobename"]="N",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER N",
  ["lccode"]=0x006E,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x004E, -- N
 },
 {
  ["adobename"]="O",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER O",
  ["lccode"]=0x006F,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x004F, -- O
 },
 {
  ["adobename"]="P",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER P",
  ["lccode"]=0x0070,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0050, -- P
 },
 {
  ["adobename"]="Q",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER Q",
  ["lccode"]=0x0071,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0051, -- Q
 },
 {
  ["adobename"]="R",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER R",
  ["lccode"]=0x0072,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0052, -- R
 },
 {
  ["adobename"]="S",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER S",
  ["lccode"]=0x0073,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0053, -- S
 },
 {
  ["adobename"]="T",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER T",
  ["lccode"]=0x0074,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0054, -- T
 },
 {
  ["adobename"]="U",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER U",
  ["lccode"]=0x0075,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0055, -- U
 },
 {
  ["adobename"]="V",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER V",
  ["lccode"]=0x0076,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0056, -- V
 },
 {
  ["adobename"]="W",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER W",
  ["lccode"]=0x0077,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0057, -- W
 },
 {
  ["adobename"]="X",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER X",
  ["lccode"]=0x0078,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0058, -- X
 },
 {
  ["adobename"]="Y",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER Y",
  ["lccode"]=0x0079,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x0059, -- Y
 },
 {
  ["adobename"]="Z",
  ["category"]="lu",
  ["cjkwd"]="na",
  ["description"]="LATIN CAPITAL LETTER Z",
  ["lccode"]=0x007A,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["unicodeslot"]=0x005A, -- Z
 },
 {
  ["adobename"]="bracketleft",
  ["category"]="ps",
  ["cjkwd"]="na",
  ["description"]="LEFT SQUARE BRACKET",
  ["linebreak"]="op",
  ["mathclass"]="open",
  ["unicodeslot"]=0x005B, -- [
 },
 {
  ["adobename"]="backslash",
  ["category"]="po",
  ["cjkwd"]="na",
  ["contextname"]="textbackslash",
  ["description"]="REVERSE SOLIDUS",
  ["linebreak"]="pr",
  ["mathclass"]="binary",
  ["unicodeslot"]=0x005C, -- \
 },
 {
  ["adobename"]="bracketright",
  ["category"]="pe",
  ["cjkwd"]="na",
  ["description"]="RIGHT SQUARE BRACKET",
  ["linebreak"]="cl",
  ["mathclass"]="close",
  ["unicodeslot"]=0x005D, -- ]
 },
 {
  ["adobename"]="asciicircum",
  ["category"]="sk",
  ["cjkwd"]="na",
  ["contextname"]="textasciicircum",
  ["description"]="CIRCUMFLEX ACCENT",
  ["mathclass"]="accent",
  ["mathname"]="widehat",
  ["linebreak"]="al",
  ["unicodeslot"]=0x005E, -- ^
 },
 {
  ["adobename"]="underscore",
  ["category"]="pc",
  ["cjkwd"]="na",
  ["contextname"]="textunderscore",
  ["description"]="LOW LINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x005F, -- _
 },
 {
  ["adobename"]="grave",
  ["category"]="sk",
  ["cjkwd"]="na",
  ["contextname"]="textgrave",
  ["description"]="GRAVE ACCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0060, -- `
 },
 {
  ["adobename"]="a",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER A",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0041,
  ["unicodeslot"]=0x0061, -- a
 },
 {
  ["adobename"]="b",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER B",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0042,
  ["unicodeslot"]=0x0062, -- b
 },
 {
  ["adobename"]="c",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER C",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0043,
  ["unicodeslot"]=0x0063, -- c
 },
 {
  ["adobename"]="d",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER D",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0044,
  ["unicodeslot"]=0x0064, -- d
 },
 {
  ["adobename"]="e",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER E",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0045,
  ["unicodeslot"]=0x0065, -- e
 },
 {
  ["adobename"]="f",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER F",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0046,
  ["unicodeslot"]=0x0066, -- f
 },
 {
  ["adobename"]="g",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER G",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0047,
  ["unicodeslot"]=0x0067, -- g
 },
 {
  ["adobename"]="h",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER H",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0048,
  ["unicodeslot"]=0x0068, -- h
 },
 {
  ["adobename"]="i",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER I",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0049,
  ["unicodeslot"]=0x0069, -- i
 },
 {
  ["adobename"]="j",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER J",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x004A,
  ["unicodeslot"]=0x006A, -- j
 },
 {
  ["adobename"]="k",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER K",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x004B,
  ["unicodeslot"]=0x006B, -- k
 },
 {
  ["adobename"]="l",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER L",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x004C,
  ["unicodeslot"]=0x006C, -- l
 },
 {
  ["adobename"]="m",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER M",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x004D,
  ["unicodeslot"]=0x006D, -- m
 },
 {
  ["adobename"]="n",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER N",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x004E,
  ["unicodeslot"]=0x006E, -- n
 },
 {
  ["adobename"]="o",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER O",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x004F,
  ["unicodeslot"]=0x006F, -- o
 },
 {
  ["adobename"]="p",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER P",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0050,
  ["unicodeslot"]=0x0070, -- p
 },
 {
  ["adobename"]="q",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER Q",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0051,
  ["unicodeslot"]=0x0071, -- q
 },
 {
  ["adobename"]="r",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER R",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0052,
  ["unicodeslot"]=0x0072, -- r
 },
 {
  ["adobename"]="s",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER S",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0053,
  ["unicodeslot"]=0x0073, -- s
 },
 {
  ["adobename"]="t",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER T",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0054,
  ["unicodeslot"]=0x0074, -- t
 },
 {
  ["adobename"]="u",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER U",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0055,
  ["unicodeslot"]=0x0075, -- u
 },
 {
  ["adobename"]="v",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER V",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0056,
  ["unicodeslot"]=0x0076, -- v
 },
 {
  ["adobename"]="w",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER W",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0057,
  ["unicodeslot"]=0x0077, -- w
 },
 {
  ["adobename"]="x",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER X",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0058,
  ["unicodeslot"]=0x0078, -- x
 },
 {
  ["adobename"]="y",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER Y",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x0059,
  ["unicodeslot"]=0x0079, -- y
 },
 {
  ["adobename"]="z",
  ["category"]="ll",
  ["cjkwd"]="na",
  ["description"]="LATIN SMALL LETTER Z",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["uccode"]=0x005A,
  ["unicodeslot"]=0x007A, -- z
 },
 {
  ["adobename"]="braceleft",
  ["category"]="ps",
  ["cjkwd"]="na",
  ["contextname"]="textbraceleft",
  ["description"]="LEFT CURLY BRACKET",
  ["linebreak"]="op",
  ["mathclass"]="open",
  ["mathname"]="lbrace",
  ["unicodeslot"]=0x007B, -- {
 },
 {
  ["adobename"]="bar",
  ["category"]="sm",
  ["cjkwd"]="na",
  ["contextname"]="textbar",
  ["description"]="VERTICAL LINE",
  ["linebreak"]="ba",
  ["mathclass"]="binary",
  ["mathname"]="bar",
  ["unicodeslot"]=0x007C, -- |
 },
 {
  ["adobename"]="braceright",
  ["category"]="pe",
  ["cjkwd"]="na",
  ["contextname"]="textbraceright",
  ["description"]="RIGHT CURLY BRACKET",
  ["linebreak"]="cl",
  ["mathclass"]="close",
  ["mathname"]="rbrace",
  ["unicodeslot"]=0x007D, -- }
 },
 {
  ["adobename"]="asciitilde",
  ["category"]="sm",
  ["cjkwd"]="na",
  ["contextname"]="textasciitilde",
  ["description"]="TILDE",
  ["linebreak"]="al",
  ["mathclass"]="accent",
  ["mathname"]="widetilde",
  ["unicodeslot"]=0x007E, -- ~
 },
 {
  ["category"]="cc",
  ["description"]="DELETE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x007F, -- 
 },
 {
  ["category"]="cc",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0080, -- 
 },
 {
  ["category"]="cc",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0081, -- 
 },
 {
  ["category"]="cc",
  ["description"]="BREAK PERMITTED HERE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0082, -- 
 },
 {
  ["category"]="cc",
  ["description"]="NO BREAK HERE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0083, -- 
 },
 {
  ["category"]="cc",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0084, -- 
 },
 {
  ["category"]="cc",
  ["description"]="NEXT LINE (NEL)",
  ["linebreak"]="nl",
  ["unicodeslot"]=0x0085, -- 
 },
 {
  ["category"]="cc",
  ["description"]="START OF SELECTED AREA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0086, -- 
 },
 {
  ["category"]="cc",
  ["description"]="END OF SELECTED AREA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0087, -- 
 },
 {
  ["category"]="cc",
  ["description"]="CHARACTER TABULATION SET",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0088, -- 
 },
 {
  ["category"]="cc",
  ["description"]="CHARACTER TABULATION WITH JUSTIFICATION",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0089, -- 
 },
 {
  ["category"]="cc",
  ["description"]="LINE TABULATION SET",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x008A, -- 
 },
 {
  ["category"]="cc",
  ["description"]="PARTIAL LINE FORWARD",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x008B, -- 
 },
 {
  ["category"]="cc",
  ["description"]="PARTIAL LINE BACKWARD",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x008C, -- 
 },
 {
  ["category"]="cc",
  ["description"]="REVERSE LINE FEED",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x008D, -- 
 },
 {
  ["category"]="cc",
  ["description"]="SINGLE SHIFT TWO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x008E, -- 
 },
 {
  ["category"]="cc",
  ["description"]="SINGLE SHIFT THREE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x008F, -- 
 },
 {
  ["category"]="cc",
  ["description"]="DEVICE CONTROL STRING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0090, -- 
 },
 {
  ["category"]="cc",
  ["description"]="PRIVATE USE ONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0091, -- 
 },
 {
  ["category"]="cc",
  ["description"]="PRIVATE USE TWO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0092, -- 
 },
 {
  ["category"]="cc",
  ["description"]="SET TRANSMIT STATE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0093, -- 
 },
 {
  ["category"]="cc",
  ["description"]="CANCEL CHARACTER",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0094, -- 
 },
 {
  ["category"]="cc",
  ["description"]="MESSAGE WAITING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0095, -- 
 },
 {
  ["category"]="cc",
  ["description"]="START OF GUARDED AREA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0096, -- 
 },
 {
  ["category"]="cc",
  ["description"]="END OF GUARDED AREA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0097, -- 
 },
 {
  ["category"]="cc",
  ["description"]="START OF STRING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0098, -- 
 },
 {
  ["category"]="cc",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0099, -- 
 },
 {
  ["category"]="cc",
  ["description"]="SINGLE CHARACTER INTRODUCER",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x009A, -- 
 },
 {
  ["category"]="cc",
  ["description"]="CONTROL SEQUENCE INTRODUCER",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x009B, -- 
 },
 {
  ["category"]="cc",
  ["description"]="STRING TERMINATOR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x009C, -- 
 },
 {
  ["category"]="cc",
  ["description"]="OPERATING SYSTEM COMMAND",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x009D, -- 
 },
 {
  ["category"]="cc",
  ["description"]="PRIVACY MESSAGE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x009E, -- 
 },
 {
  ["category"]="cc",
  ["description"]="APPLICATION PROGRAM COMMAND",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x009F, -- 
 },
 {
  ["category"]="zs",
  ["contextname"]="nonbreakablespace",
  ["description"]="NO-BREAK SPACE",
  ["linebreak"]="gl",
  ["specials"]={ "nobreak", 0x0020 },
  ["unicodeslot"]=0x00A0, --  
 },
 {
  ["adobename"]="exclamdown",
  ["category"]="po",
  ["cjkwd"]="a",
  ["contextname"]="exclamdown",
  ["description"]="INVERTED EXCLAMATION MARK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x00A1, -- ¡
 },
 {
  ["adobename"]="cent",
  ["category"]="sc",
  ["cjkwd"]="na",
  ["contextname"]="textcent",
  ["description"]="CENT SIGN",
  ["linebreak"]="po",
  ["unicodeslot"]=0x00A2, -- ¢
 },
 {
  ["adobename"]="sterling",
  ["category"]="sc",
  ["cjkwd"]="na",
  ["contextname"]="textsterling",
  ["description"]="POUND SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x00A3, -- £
 },
 {
  ["adobename"]="currency",
  ["category"]="sc",
  ["cjkwd"]="a",
  ["contextname"]="textcurrency",
  ["description"]="CURRENCY SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x00A4, -- ¤
 },
 {
  ["adobename"]="yen",
  ["category"]="sc",
  ["cjkwd"]="na",
  ["contextname"]="textyen",
  ["description"]="YEN SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x00A5, -- ¥
 },
 {
  ["adobename"]="brokenbar",
  ["category"]="so",
  ["cjkwd"]="na",
  ["contextname"]="textbrokenbar",
  ["description"]="BROKEN BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x00A6, -- ¦
 },
 {
  ["adobename"]="section",
  ["category"]="so",
  ["cjkwd"]="a",
  ["contextname"]="sectionmark",
  ["description"]="SECTION SIGN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x00A7, -- §
 },
 {
  ["adobename"]="dieresis",
  ["category"]="sk",
  ["cjkwd"]="a",
  ["contextname"]="textdiaeresis",
  ["description"]="DIAERESIS",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0020, 0x0308 },
  ["unicodeslot"]=0x00A8, -- ¨
 },
 {
  ["adobename"]="copyright",
  ["category"]="so",
  ["contextname"]="copyright",
  ["description"]="COPYRIGHT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x00A9, -- ©
 },
 {
  ["adobename"]="ordfeminine",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ordfeminine",
  ["description"]="FEMININE ORDINAL INDICATOR",
  ["linebreak"]="ai",
  ["specials"]={ "super", 0x0061 },
  ["unicodeslot"]=0x00AA, -- ª
 },
 {
  ["adobename"]="guillemotleft",
  ["category"]="pi",
  ["contextname"]="leftguillemot",
  ["description"]="LEFT-POINTING DOUBLE ANGLE QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x00AB, -- «
 },
 {
  ["adobename"]="logicalnot",
  ["category"]="sm",
  ["cjkwd"]="na",
  ["contextname"]="textlognot",
  ["description"]="NOT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x00AC, -- ¬
 },
 {
  ["category"]="cf",
  ["cjkwd"]="a",
  ["contextname"]="softhyphen",
  ["description"]="SOFT HYPHEN",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x00AD, -- ­
 },
 {
  ["adobename"]="registered",
  ["category"]="so",
  ["cjkwd"]="a",
  ["contextname"]="registered",
  ["description"]="REGISTERED SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x00AE, -- ®
 },
 {
  ["adobename"]="macron",
  ["category"]="sk",
  ["cjkwd"]="na",
  ["contextname"]="textmacron",
  ["description"]="MACRON",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0304 },
  ["unicodeslot"]=0x00AF, -- ¯
 },
 {
  ["adobename"]="degree",
  ["category"]="so",
  ["cjkwd"]="a",
  ["contextname"]="textdegree",
  ["description"]="DEGREE SIGN",
  ["linebreak"]="po",
  ["unicodeslot"]=0x00B0, -- °
 },
 {
  ["adobename"]="plusminus",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["contextname"]="textpm",
  ["description"]="PLUS-MINUS SIGN",
  ["linebreak"]="pr",
  ["mathclass"]="binary",
  ["mathname"]="pm",
  ["unicodeslot"]=0x00B1, -- ±
 },
 {
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="twosuperior",
  ["description"]="SUPERSCRIPT TWO",
  ["linebreak"]="ai",
  ["specials"]={ "super", 0x0032 },
  ["unicodeslot"]=0x00B2, -- ²
 },
 {
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="threesuperior",
  ["description"]="SUPERSCRIPT THREE",
  ["linebreak"]="ai",
  ["specials"]={ "super", 0x0033 },
  ["unicodeslot"]=0x00B3, -- ³
 },
 {
  ["adobename"]="acute",
  ["category"]="sk",
  ["cjkwd"]="a",
  ["contextname"]="textacute",
  ["description"]="ACUTE ACCENT",
  ["linebreak"]="bb",
  ["specials"]={ "compat", 0x0020, 0x0301 },
  ["unicodeslot"]=0x00B4, -- ´
 },
 {
  ["adobename"]="mu",
  ["category"]="ll",
  ["contextname"]="textmu",
  ["description"]="MICRO SIGN",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x03BC },
  ["uccode"]=0x039C,
  ["unicodeslot"]=0x00B5, -- µ
 },
 {
  ["adobename"]="paragraph",
  ["category"]="so",
  ["cjkwd"]="a",
  ["contextname"]="paragraphmark",
  ["description"]="PILCROW SIGN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x00B6, -- ¶
 },
 {
  ["adobename"]="periodcentered",
  ["category"]="po",
  ["cjkwd"]="a",
  ["contextname"]="periodcentered",
  ["description"]="MIDDLE DOT",
  ["linebreak"]="ai",
  ["mathclass"]="binary",
  ["unicodeslot"]=0x00B7, -- ·
 },
 {
  ["adobename"]="cedilla",
  ["category"]="sk",
  ["cjkwd"]="a",
  ["contextname"]="textcedilla",
  ["description"]="CEDILLA",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0020, 0x0327 },
  ["unicodeslot"]=0x00B8, -- ¸
 },
 {
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="onesuperior",
  ["description"]="SUPERSCRIPT ONE",
  ["linebreak"]="ai",
  ["specials"]={ "super", 0x0031 },
  ["unicodeslot"]=0x00B9, -- ¹
 },
 {
  ["adobename"]="ordmasculine",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ordmasculine",
  ["description"]="MASCULINE ORDINAL INDICATOR",
  ["linebreak"]="ai",
  ["specials"]={ "super", 0x006F },
  ["unicodeslot"]=0x00BA, -- º
 },
 {
  ["adobename"]="guillemotright",
  ["category"]="pf",
  ["contextname"]="rightguillemot",
  ["description"]="RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x00BB, -- »
 },
 {
  ["adobename"]="onequarter",
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="onequarter",
  ["description"]="VULGAR FRACTION ONE QUARTER",
  ["linebreak"]="ai",
  ["specials"]={ "fraction", 0x0031, 0x2044, 0x0034 },
  ["unicodeslot"]=0x00BC, -- ¼
 },
 {
  ["adobename"]="onehalf",
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="onehalf",
  ["description"]="VULGAR FRACTION ONE HALF",
  ["linebreak"]="ai",
  ["specials"]={ "fraction", 0x0031, 0x2044, 0x0032 },
  ["unicodeslot"]=0x00BD, -- ½
 },
 {
  ["adobename"]="threequarters",
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="threequarter",
  ["description"]="VULGAR FRACTION THREE QUARTERS",
  ["linebreak"]="ai",
  ["specials"]={ "fraction", 0x0033, 0x2044, 0x0034 },
  ["unicodeslot"]=0x00BE, -- ¾
 },
 {
  ["adobename"]="questiondown",
  ["category"]="po",
  ["cjkwd"]="a",
  ["contextname"]="questiondown",
  ["description"]="INVERTED QUESTION MARK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x00BF, -- ¿
 },
 {
  ["adobename"]="Agrave",
  ["category"]="lu",
  ["contextname"]="Agrave",
  ["description"]="LATIN CAPITAL LETTER A WITH GRAVE",
  ["lccode"]=0x00E0,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0300 },
  ["unicodeslot"]=0x00C0, -- À
 },
 {
  ["adobename"]="Aacute",
  ["category"]="lu",
  ["contextname"]="Aacute",
  ["description"]="LATIN CAPITAL LETTER A WITH ACUTE",
  ["lccode"]=0x00E1,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0301 },
  ["unicodeslot"]=0x00C1, -- Á
 },
 {
  ["adobename"]="Acircumflex",
  ["category"]="lu",
  ["contextname"]="Acircumflex",
  ["description"]="LATIN CAPITAL LETTER A WITH CIRCUMFLEX",
  ["lccode"]=0x00E2,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0302 },
  ["unicodeslot"]=0x00C2, -- Â
 },
 {
  ["adobename"]="Atilde",
  ["category"]="lu",
  ["contextname"]="Atilde",
  ["description"]="LATIN CAPITAL LETTER A WITH TILDE",
  ["lccode"]=0x00E3,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0303 },
  ["unicodeslot"]=0x00C3, -- Ã
 },
 {
  ["adobename"]="Adieresis",
  ["category"]="lu",
  ["contextname"]="Adiaeresis",
  ["description"]="LATIN CAPITAL LETTER A WITH DIAERESIS",
  ["lccode"]=0x00E4,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0308 },
  ["unicodeslot"]=0x00C4, -- Ä
 },
 {
  ["adobename"]="Aring",
  ["category"]="lu",
  ["contextname"]="Aring",
  ["description"]="LATIN CAPITAL LETTER A WITH RING ABOVE",
  ["lccode"]=0x00E5,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x030A },
  ["unicodeslot"]=0x00C5, -- Å
 },
 {
  ["adobename"]="AE",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="AEligature",
  ["description"]="LATIN CAPITAL LETTER AE",
  ["lccode"]=0x00E6,
  ["linebreak"]="al",
  ["shcode"]= { 0x0041, 0x0045 },
  ["unicodeslot"]=0x00C6, -- Æ
 },
 {
  ["adobename"]="Ccedilla",
  ["category"]="lu",
  ["contextname"]="Ccedilla",
  ["description"]="LATIN CAPITAL LETTER C WITH CEDILLA",
  ["lccode"]=0x00E7,
  ["linebreak"]="al",
  ["shcode"]=0x0043,
  ["specials"]={ "char", 0x0043, 0x0327 },
  ["unicodeslot"]=0x00C7, -- Ç
 },
 {
  ["adobename"]="Egrave",
  ["category"]="lu",
  ["contextname"]="Egrave",
  ["description"]="LATIN CAPITAL LETTER E WITH GRAVE",
  ["lccode"]=0x00E8,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0300 },
  ["unicodeslot"]=0x00C8, -- È
 },
 {
  ["adobename"]="Eacute",
  ["category"]="lu",
  ["contextname"]="Eacute",
  ["description"]="LATIN CAPITAL LETTER E WITH ACUTE",
  ["lccode"]=0x00E9,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0301 },
  ["unicodeslot"]=0x00C9, -- É
 },
 {
  ["adobename"]="Ecircumflex",
  ["category"]="lu",
  ["contextname"]="Ecircumflex",
  ["description"]="LATIN CAPITAL LETTER E WITH CIRCUMFLEX",
  ["lccode"]=0x00EA,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0302 },
  ["unicodeslot"]=0x00CA, -- Ê
 },
 {
  ["adobename"]="Edieresis",
  ["category"]="lu",
  ["contextname"]="Ediaeresis",
  ["description"]="LATIN CAPITAL LETTER E WITH DIAERESIS",
  ["lccode"]=0x00EB,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0308 },
  ["unicodeslot"]=0x00CB, -- Ë
 },
 {
  ["adobename"]="Igrave",
  ["category"]="lu",
  ["contextname"]="Igrave",
  ["description"]="LATIN CAPITAL LETTER I WITH GRAVE",
  ["lccode"]=0x00EC,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0300 },
  ["unicodeslot"]=0x00CC, -- Ì
 },
 {
  ["adobename"]="Iacute",
  ["category"]="lu",
  ["contextname"]="Iacute",
  ["description"]="LATIN CAPITAL LETTER I WITH ACUTE",
  ["lccode"]=0x00ED,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0301 },
  ["unicodeslot"]=0x00CD, -- Í
 },
 {
  ["adobename"]="Icircumflex",
  ["category"]="lu",
  ["contextname"]="Icircumflex",
  ["description"]="LATIN CAPITAL LETTER I WITH CIRCUMFLEX",
  ["lccode"]=0x00EE,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0302 },
  ["unicodeslot"]=0x00CE, -- Î
 },
 {
  ["adobename"]="Idieresis",
  ["category"]="lu",
  ["contextname"]="Idiaeresis",
  ["description"]="LATIN CAPITAL LETTER I WITH DIAERESIS",
  ["lccode"]=0x00EF,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0308 },
  ["unicodeslot"]=0x00CF, -- Ï
 },
 {
  ["adobename"]="Eth",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="Eth",
  ["description"]="LATIN CAPITAL LETTER ETH",
  ["lccode"]=0x00F0,
  ["linebreak"]="al",
  ["unicodeslot"]=0x00D0, -- Ð
 },
 {
  ["adobename"]="Ntilde",
  ["category"]="lu",
  ["contextname"]="Ntilde",
  ["description"]="LATIN CAPITAL LETTER N WITH TILDE",
  ["lccode"]=0x00F1,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["specials"]={ "char", 0x004E, 0x0303 },
  ["unicodeslot"]=0x00D1, -- Ñ
 },
 {
  ["adobename"]="Ograve",
  ["category"]="lu",
  ["contextname"]="Ograve",
  ["description"]="LATIN CAPITAL LETTER O WITH GRAVE",
  ["lccode"]=0x00F2,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0300 },
  ["unicodeslot"]=0x00D2, -- Ò
 },
 {
  ["adobename"]="Oacute",
  ["category"]="lu",
  ["contextname"]="Oacute",
  ["description"]="LATIN CAPITAL LETTER O WITH ACUTE",
  ["lccode"]=0x00F3,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0301 },
  ["unicodeslot"]=0x00D3, -- Ó
 },
 {
  ["adobename"]="Ocircumflex",
  ["category"]="lu",
  ["contextname"]="Ocircumflex",
  ["description"]="LATIN CAPITAL LETTER O WITH CIRCUMFLEX",
  ["lccode"]=0x00F4,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0302 },
  ["unicodeslot"]=0x00D4, -- Ô
 },
 {
  ["adobename"]="Otilde",
  ["category"]="lu",
  ["contextname"]="Otilde",
  ["description"]="LATIN CAPITAL LETTER O WITH TILDE",
  ["lccode"]=0x00F5,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0303 },
  ["unicodeslot"]=0x00D5, -- Õ
 },
 {
  ["adobename"]="Odieresis",
  ["category"]="lu",
  ["contextname"]="Odiaeresis",
  ["description"]="LATIN CAPITAL LETTER O WITH DIAERESIS",
  ["lccode"]=0x00F6,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0308 },
  ["unicodeslot"]=0x00D6, -- Ö
 },
 {
  ["adobename"]="multiply",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["contextname"]="textmultiply",
  ["description"]="MULTIPLICATION SIGN",
  ["linebreak"]="ai",
  ["mathclass"]="binary",
  ["mathname"]="times",
  ["unicodeslot"]=0x00D7, -- ×
 },
 {
  ["adobename"]="Oslash",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="Ostroke",
  ["description"]="LATIN CAPITAL LETTER O WITH STROKE",
  ["lccode"]=0x00F8,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["unicodeslot"]=0x00D8, -- Ø
 },
 {
  ["adobename"]="Ugrave",
  ["category"]="lu",
  ["contextname"]="Ugrave",
  ["description"]="LATIN CAPITAL LETTER U WITH GRAVE",
  ["lccode"]=0x00F9,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0300 },
  ["unicodeslot"]=0x00D9, -- Ù
 },
 {
  ["adobename"]="Uacute",
  ["category"]="lu",
  ["contextname"]="Uacute",
  ["description"]="LATIN CAPITAL LETTER U WITH ACUTE",
  ["lccode"]=0x00FA,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0301 },
  ["unicodeslot"]=0x00DA, -- Ú
 },
 {
  ["adobename"]="Ucircumflex",
  ["category"]="lu",
  ["contextname"]="Ucircumflex",
  ["description"]="LATIN CAPITAL LETTER U WITH CIRCUMFLEX",
  ["lccode"]=0x00FB,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0302 },
  ["unicodeslot"]=0x00DB, -- Û
 },
 {
  ["adobename"]="Udieresis",
  ["category"]="lu",
  ["contextname"]="Udiaeresis",
  ["description"]="LATIN CAPITAL LETTER U WITH DIAERESIS",
  ["lccode"]=0x00FC,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0308 },
  ["unicodeslot"]=0x00DC, -- Ü
 },
 {
  ["adobename"]="Yacute",
  ["category"]="lu",
  ["contextname"]="Yacute",
  ["description"]="LATIN CAPITAL LETTER Y WITH ACUTE",
  ["lccode"]=0x00FD,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["specials"]={ "char", 0x0059, 0x0301 },
  ["unicodeslot"]=0x00DD, -- Ý
 },
 {
  ["adobename"]="Thorn",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="Thorn",
  ["description"]="LATIN CAPITAL LETTER THORN",
  ["lccode"]=0x00FE,
  ["linebreak"]="al",
  ["unicodeslot"]=0x00DE, -- Þ
 },
 {
  ["adobename"]="germandbls",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ssharp",
  ["description"]="LATIN SMALL LETTER SHARP S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x00DF, -- ß
  ["uccodes"]={0x0053,0x0053},
 },
 {
  ["adobename"]="agrave",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="agrave",
  ["description"]="LATIN SMALL LETTER A WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0300 },
  ["uccode"]=0x00C0,
  ["unicodeslot"]=0x00E0, -- à
 },
 {
  ["adobename"]="aacute",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="aacute",
  ["description"]="LATIN SMALL LETTER A WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0301 },
  ["uccode"]=0x00C1,
  ["unicodeslot"]=0x00E1, -- á
 },
 {
  ["adobename"]="acircumflex",
  ["category"]="ll",
  ["contextname"]="acircumflex",
  ["description"]="LATIN SMALL LETTER A WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0302 },
  ["uccode"]=0x00C2,
  ["unicodeslot"]=0x00E2, -- â
 },
 {
  ["adobename"]="atilde",
  ["category"]="ll",
  ["contextname"]="atilde",
  ["description"]="LATIN SMALL LETTER A WITH TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0303 },
  ["uccode"]=0x00C3,
  ["unicodeslot"]=0x00E3, -- ã
 },
 {
  ["adobename"]="adieresis",
  ["category"]="ll",
  ["contextname"]="adiaeresis",
  ["description"]="LATIN SMALL LETTER A WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0308 },
  ["uccode"]=0x00C4,
  ["unicodeslot"]=0x00E4, -- ä
 },
 {
  ["adobename"]="aring",
  ["category"]="ll",
  ["contextname"]="aring",
  ["description"]="LATIN SMALL LETTER A WITH RING ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x030A },
  ["uccode"]=0x00C5,
  ["unicodeslot"]=0x00E5, -- å
 },
 {
  ["adobename"]="ae",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="aeligature",
  ["description"]="LATIN SMALL LETTER AE",
  ["linebreak"]="al",
  ["shcode"]= { 0x00E6, 0x00EA },
  ["uccode"]=0x00C6,
  ["unicodeslot"]=0x00E6, -- æ
 },
 {
  ["adobename"]="ccedilla",
  ["category"]="ll",
  ["contextname"]="ccedilla",
  ["description"]="LATIN SMALL LETTER C WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x0063,
  ["specials"]={ "char", 0x0063, 0x0327 },
  ["uccode"]=0x00C7,
  ["unicodeslot"]=0x00E7, -- ç
 },
 {
  ["adobename"]="egrave",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="egrave",
  ["description"]="LATIN SMALL LETTER E WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0300 },
  ["uccode"]=0x00C8,
  ["unicodeslot"]=0x00E8, -- è
 },
 {
  ["adobename"]="eacute",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="eacute",
  ["description"]="LATIN SMALL LETTER E WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0301 },
  ["uccode"]=0x00C9,
  ["unicodeslot"]=0x00E9, -- é
 },
 {
  ["adobename"]="ecircumflex",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ecircumflex",
  ["description"]="LATIN SMALL LETTER E WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0302 },
  ["uccode"]=0x00CA,
  ["unicodeslot"]=0x00EA, -- ê
 },
 {
  ["adobename"]="edieresis",
  ["category"]="ll",
  ["contextname"]="ediaeresis",
  ["description"]="LATIN SMALL LETTER E WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0308 },
  ["uccode"]=0x00CB,
  ["unicodeslot"]=0x00EB, -- ë
 },
 {
  ["adobename"]="igrave",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="igrave",
  ["description"]="LATIN SMALL LETTER I WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0300 },
  ["uccode"]=0x00CC,
  ["unicodeslot"]=0x00EC, -- ì
 },
 {
  ["adobename"]="iacute",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="iacute",
  ["description"]="LATIN SMALL LETTER I WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0301 },
  ["uccode"]=0x00CD,
  ["unicodeslot"]=0x00ED, -- í
 },
 {
  ["adobename"]="icircumflex",
  ["category"]="ll",
  ["contextname"]="icircumflex",
  ["description"]="LATIN SMALL LETTER I WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0302 },
  ["uccode"]=0x00CE,
  ["unicodeslot"]=0x00EE, -- î
 },
 {
  ["adobename"]="idieresis",
  ["category"]="ll",
  ["contextname"]="idiaeresis",
  ["description"]="LATIN SMALL LETTER I WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0308 },
  ["uccode"]=0x00CF,
  ["unicodeslot"]=0x00EF, -- ï
 },
 {
  ["adobename"]="eth",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="eth",
  ["description"]="LATIN SMALL LETTER ETH",
  ["linebreak"]="al",
  ["uccode"]=0x00D0,
  ["unicodeslot"]=0x00F0, -- ð
 },
 {
  ["adobename"]="ntilde",
  ["category"]="ll",
  ["contextname"]="ntilde",
  ["description"]="LATIN SMALL LETTER N WITH TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["specials"]={ "char", 0x006E, 0x0303 },
  ["uccode"]=0x00D1,
  ["unicodeslot"]=0x00F1, -- ñ
 },
 {
  ["adobename"]="ograve",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ograve",
  ["description"]="LATIN SMALL LETTER O WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0300 },
  ["uccode"]=0x00D2,
  ["unicodeslot"]=0x00F2, -- ò
 },
 {
  ["adobename"]="oacute",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="oacute",
  ["description"]="LATIN SMALL LETTER O WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0301 },
  ["uccode"]=0x00D3,
  ["unicodeslot"]=0x00F3, -- ó
 },
 {
  ["adobename"]="ocircumflex",
  ["category"]="ll",
  ["contextname"]="ocircumflex",
  ["description"]="LATIN SMALL LETTER O WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0302 },
  ["uccode"]=0x00D4,
  ["unicodeslot"]=0x00F4, -- ô
 },
 {
  ["adobename"]="otilde",
  ["category"]="ll",
  ["contextname"]="otilde",
  ["description"]="LATIN SMALL LETTER O WITH TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0303 },
  ["uccode"]=0x00D5,
  ["unicodeslot"]=0x00F5, -- õ
 },
 {
  ["adobename"]="odieresis",
  ["category"]="ll",
  ["contextname"]="odiaeresis",
  ["description"]="LATIN SMALL LETTER O WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0308 },
  ["uccode"]=0x00D6,
  ["unicodeslot"]=0x00F6, -- ö
 },
 {
  ["adobename"]="divide",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["contextname"]="textdiv",
  ["description"]="DIVISION SIGN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x00F7, -- ÷
 },
 {
  ["adobename"]="oslash",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ostroke",
  ["description"]="LATIN SMALL LETTER O WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["uccode"]=0x00D8,
  ["unicodeslot"]=0x00F8, -- ø
 },
 {
  ["adobename"]="ugrave",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ugrave",
  ["description"]="LATIN SMALL LETTER U WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0300 },
  ["uccode"]=0x00D9,
  ["unicodeslot"]=0x00F9, -- ù
 },
 {
  ["adobename"]="uacute",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="uacute",
  ["description"]="LATIN SMALL LETTER U WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0301 },
  ["uccode"]=0x00DA,
  ["unicodeslot"]=0x00FA, -- ú
 },
 {
  ["adobename"]="ucircumflex",
  ["category"]="ll",
  ["contextname"]="ucircumflex",
  ["description"]="LATIN SMALL LETTER U WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0302 },
  ["uccode"]=0x00DB,
  ["unicodeslot"]=0x00FB, -- û
 },
 {
  ["adobename"]="udieresis",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="udiaeresis",
  ["description"]="LATIN SMALL LETTER U WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0308 },
  ["uccode"]=0x00DC,
  ["unicodeslot"]=0x00FC, -- ü
 },
 {
  ["adobename"]="yacute",
  ["category"]="ll",
  ["contextname"]="yacute",
  ["description"]="LATIN SMALL LETTER Y WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x0301 },
  ["uccode"]=0x00DD,
  ["unicodeslot"]=0x00FD, -- ý
 },
 {
  ["adobename"]="thorn",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="thorn",
  ["description"]="LATIN SMALL LETTER THORN",
  ["linebreak"]="al",
  ["uccode"]=0x00DE,
  ["unicodeslot"]=0x00FE, -- þ
 },
 {
  ["adobename"]="ydieresis",
  ["category"]="ll",
  ["contextname"]="ydiaeresis",
  ["description"]="LATIN SMALL LETTER Y WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x0308 },
  ["uccode"]=0x0178,
  ["unicodeslot"]=0x00FF, -- ÿ
 },
 {
  ["adobename"]="Amacron",
  ["category"]="lu",
  ["contextname"]="Amacron",
  ["description"]="LATIN CAPITAL LETTER A WITH MACRON",
  ["lccode"]=0x0101,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0304 },
  ["unicodeslot"]=0x0100, -- Ā
 },
 {
  ["adobename"]="amacron",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="amacron",
  ["description"]="LATIN SMALL LETTER A WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0304 },
  ["uccode"]=0x0100,
  ["unicodeslot"]=0x0101, -- ā
 },
 {
  ["adobename"]="Abreve",
  ["category"]="lu",
  ["contextname"]="Abreve",
  ["description"]="LATIN CAPITAL LETTER A WITH BREVE",
  ["lccode"]=0x0103,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0306 },
  ["unicodeslot"]=0x0102, -- Ă
 },
 {
  ["adobename"]="abreve",
  ["category"]="ll",
  ["contextname"]="abreve",
  ["description"]="LATIN SMALL LETTER A WITH BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0306 },
  ["uccode"]=0x0102,
  ["unicodeslot"]=0x0103, -- ă
 },
 {
  ["adobename"]="Aogonek",
  ["category"]="lu",
  ["contextname"]="Aogonek",
  ["description"]="LATIN CAPITAL LETTER A WITH OGONEK",
  ["lccode"]=0x0105,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0328 },
  ["unicodeslot"]=0x0104, -- Ą
 },
 {
  ["adobename"]="aogonek",
  ["category"]="ll",
  ["contextname"]="aogonek",
  ["description"]="LATIN SMALL LETTER A WITH OGONEK",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0328 },
  ["uccode"]=0x0104,
  ["unicodeslot"]=0x0105, -- ą
 },
 {
  ["adobename"]="Cacute",
  ["category"]="lu",
  ["contextname"]="Cacute",
  ["description"]="LATIN CAPITAL LETTER C WITH ACUTE",
  ["lccode"]=0x0107,
  ["linebreak"]="al",
  ["shcode"]=0x0043,
  ["specials"]={ "char", 0x0043, 0x0301 },
  ["unicodeslot"]=0x0106, -- Ć
 },
 {
  ["adobename"]="cacute",
  ["category"]="ll",
  ["contextname"]="cacute",
  ["description"]="LATIN SMALL LETTER C WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0063,
  ["specials"]={ "char", 0x0063, 0x0301 },
  ["uccode"]=0x0106,
  ["unicodeslot"]=0x0107, -- ć
 },
 {
  ["adobename"]="Ccircumflex",
  ["category"]="lu",
  ["contextname"]="Ccircumflex",
  ["description"]="LATIN CAPITAL LETTER C WITH CIRCUMFLEX",
  ["lccode"]=0x0109,
  ["linebreak"]="al",
  ["shcode"]=0x0043,
  ["specials"]={ "char", 0x0043, 0x0302 },
  ["unicodeslot"]=0x0108, -- Ĉ
 },
 {
  ["adobename"]="ccircumflex",
  ["category"]="ll",
  ["contextname"]="ccircumflex",
  ["description"]="LATIN SMALL LETTER C WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0063,
  ["specials"]={ "char", 0x0063, 0x0302 },
  ["uccode"]=0x0108,
  ["unicodeslot"]=0x0109, -- ĉ
 },
 {
  ["adobename"]="Cdotaccent",
  ["category"]="lu",
  ["contextname"]="Cdotaccent",
  ["description"]="LATIN CAPITAL LETTER C WITH DOT ABOVE",
  ["lccode"]=0x010B,
  ["linebreak"]="al",
  ["shcode"]=0x0043,
  ["specials"]={ "char", 0x0043, 0x0307 },
  ["unicodeslot"]=0x010A, -- Ċ
 },
 {
  ["adobename"]="cdotaccent",
  ["category"]="ll",
  ["contextname"]="cdotaccent",
  ["description"]="LATIN SMALL LETTER C WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0063,
  ["specials"]={ "char", 0x0063, 0x0307 },
  ["uccode"]=0x010A,
  ["unicodeslot"]=0x010B, -- ċ
 },
 {
  ["adobename"]="Ccaron",
  ["category"]="lu",
  ["contextname"]="Ccaron",
  ["description"]="LATIN CAPITAL LETTER C WITH CARON",
  ["lccode"]=0x010D,
  ["linebreak"]="al",
  ["shcode"]=0x0043,
  ["specials"]={ "char", 0x0043, 0x030C },
  ["unicodeslot"]=0x010C, -- Č
 },
 {
  ["adobename"]="ccaron",
  ["category"]="ll",
  ["contextname"]="ccaron",
  ["description"]="LATIN SMALL LETTER C WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0063,
  ["specials"]={ "char", 0x0063, 0x030C },
  ["uccode"]=0x010C,
  ["unicodeslot"]=0x010D, -- č
 },
 {
  ["adobename"]="Dcaron",
  ["category"]="lu",
  ["contextname"]="Dcaron",
  ["description"]="LATIN CAPITAL LETTER D WITH CARON",
  ["lccode"]=0x010F,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["specials"]={ "char", 0x0044, 0x030C },
  ["unicodeslot"]=0x010E, -- Ď
 },
 {
  ["adobename"]="dcaron",
  ["category"]="ll",
  ["contextname"]="dcaron",
  ["description"]="LATIN SMALL LETTER D WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["specials"]={ "char", 0x0064, 0x030C },
  ["uccode"]=0x010E,
  ["unicodeslot"]=0x010F, -- ď
 },
 {
  ["adobename"]="Dcroat",
  ["category"]="lu",
  ["contextname"]="Dstroke",
  ["description"]="LATIN CAPITAL LETTER D WITH STROKE",
  ["lccode"]=0x0111,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["unicodeslot"]=0x0110, -- Đ
 },
 {
  ["adobename"]="dcroat",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="dstroke",
  ["description"]="LATIN SMALL LETTER D WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["uccode"]=0x0110,
  ["unicodeslot"]=0x0111, -- đ
 },
 {
  ["adobename"]="Emacron",
  ["category"]="lu",
  ["contextname"]="Emacron",
  ["description"]="LATIN CAPITAL LETTER E WITH MACRON",
  ["lccode"]=0x0113,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0304 },
  ["unicodeslot"]=0x0112, -- Ē
 },
 {
  ["adobename"]="emacron",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="emacron",
  ["description"]="LATIN SMALL LETTER E WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0304 },
  ["uccode"]=0x0112,
  ["unicodeslot"]=0x0113, -- ē
 },
 {
  ["adobename"]="Ebreve",
  ["category"]="lu",
  ["contextname"]="Ebreve",
  ["description"]="LATIN CAPITAL LETTER E WITH BREVE",
  ["lccode"]=0x0115,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0306 },
  ["unicodeslot"]=0x0114, -- Ĕ
 },
 {
  ["adobename"]="ebreve",
  ["category"]="ll",
  ["contextname"]="ebreve",
  ["description"]="LATIN SMALL LETTER E WITH BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0306 },
  ["uccode"]=0x0114,
  ["unicodeslot"]=0x0115, -- ĕ
 },
 {
  ["adobename"]="Edotaccent",
  ["category"]="lu",
  ["contextname"]="Edotaccent",
  ["description"]="LATIN CAPITAL LETTER E WITH DOT ABOVE",
  ["lccode"]=0x0117,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0307 },
  ["unicodeslot"]=0x0116, -- Ė
 },
 {
  ["adobename"]="edotaccent",
  ["category"]="ll",
  ["contextname"]="edotaccent",
  ["description"]="LATIN SMALL LETTER E WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0307 },
  ["uccode"]=0x0116,
  ["unicodeslot"]=0x0117, -- ė
 },
 {
  ["adobename"]="Eogonek",
  ["category"]="lu",
  ["contextname"]="Eogonek",
  ["description"]="LATIN CAPITAL LETTER E WITH OGONEK",
  ["lccode"]=0x0119,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0328 },
  ["unicodeslot"]=0x0118, -- Ę
 },
 {
  ["adobename"]="eogonek",
  ["category"]="ll",
  ["contextname"]="eogonek",
  ["description"]="LATIN SMALL LETTER E WITH OGONEK",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0328 },
  ["uccode"]=0x0118,
  ["unicodeslot"]=0x0119, -- ę
 },
 {
  ["adobename"]="Ecaron",
  ["category"]="lu",
  ["contextname"]="Ecaron",
  ["description"]="LATIN CAPITAL LETTER E WITH CARON",
  ["lccode"]=0x011B,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x030C },
  ["unicodeslot"]=0x011A, -- Ě
 },
 {
  ["adobename"]="ecaron",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ecaron",
  ["description"]="LATIN SMALL LETTER E WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x030C },
  ["uccode"]=0x011A,
  ["unicodeslot"]=0x011B, -- ě
 },
 {
  ["adobename"]="Gcircumflex",
  ["category"]="lu",
  ["contextname"]="Gcircumflex",
  ["description"]="LATIN CAPITAL LETTER G WITH CIRCUMFLEX",
  ["lccode"]=0x011D,
  ["linebreak"]="al",
  ["shcode"]=0x0047,
  ["specials"]={ "char", 0x0047, 0x0302 },
  ["unicodeslot"]=0x011C, -- Ĝ
 },
 {
  ["adobename"]="gcircumflex",
  ["category"]="ll",
  ["contextname"]="gcircumflex",
  ["description"]="LATIN SMALL LETTER G WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["specials"]={ "char", 0x0067, 0x0302 },
  ["uccode"]=0x011C,
  ["unicodeslot"]=0x011D, -- ĝ
 },
 {
  ["adobename"]="Gbreve",
  ["category"]="lu",
  ["contextname"]="Gbreve",
  ["description"]="LATIN CAPITAL LETTER G WITH BREVE",
  ["lccode"]=0x011F,
  ["linebreak"]="al",
  ["shcode"]=0x0047,
  ["specials"]={ "char", 0x0047, 0x0306 },
  ["unicodeslot"]=0x011E, -- Ğ
 },
 {
  ["adobename"]="gbreve",
  ["category"]="ll",
  ["contextname"]="gbreve",
  ["description"]="LATIN SMALL LETTER G WITH BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["specials"]={ "char", 0x0067, 0x0306 },
  ["uccode"]=0x011E,
  ["unicodeslot"]=0x011F, -- ğ
 },
 {
  ["adobename"]="Gdotaccent",
  ["category"]="lu",
  ["contextname"]="Gdotaccent",
  ["description"]="LATIN CAPITAL LETTER G WITH DOT ABOVE",
  ["lccode"]=0x0121,
  ["linebreak"]="al",
  ["shcode"]=0x0047,
  ["specials"]={ "char", 0x0047, 0x0307 },
  ["unicodeslot"]=0x0120, -- Ġ
 },
 {
  ["adobename"]="gdotaccent",
  ["category"]="ll",
  ["contextname"]="gdotaccent",
  ["description"]="LATIN SMALL LETTER G WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["specials"]={ "char", 0x0067, 0x0307 },
  ["uccode"]=0x0120,
  ["unicodeslot"]=0x0121, -- ġ
 },
 {
  ["adobename"]="Gcommaaccent",
  ["category"]="lu",
  ["contextname"]="Gcommaaccent",
  ["description"]="LATIN CAPITAL LETTER G WITH CEDILLA",
  ["lccode"]=0x0123,
  ["linebreak"]="al",
  ["shcode"]=0x0047,
  ["specials"]={ "char", 0x0047, 0x0327 },
  ["unicodeslot"]=0x0122, -- Ģ
 },
 {
  ["adobename"]="gcommaaccent",
  ["category"]="ll",
  ["contextname"]="gcommaaccent",
  ["description"]="LATIN SMALL LETTER G WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["specials"]={ "char", 0x0067, 0x0327 },
  ["uccode"]=0x0122,
  ["unicodeslot"]=0x0123, -- ģ
 },
 {
  ["adobename"]="Hcircumflex",
  ["category"]="lu",
  ["contextname"]="Hcircumflex",
  ["description"]="LATIN CAPITAL LETTER H WITH CIRCUMFLEX",
  ["lccode"]=0x0125,
  ["linebreak"]="al",
  ["shcode"]=0x0048,
  ["specials"]={ "char", 0x0048, 0x0302 },
  ["unicodeslot"]=0x0124, -- Ĥ
 },
 {
  ["adobename"]="hcircumflex",
  ["category"]="ll",
  ["contextname"]="hcircumflex",
  ["description"]="LATIN SMALL LETTER H WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["specials"]={ "char", 0x0068, 0x0302 },
  ["uccode"]=0x0124,
  ["unicodeslot"]=0x0125, -- ĥ
 },
 {
  ["adobename"]="Hbar",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="Hstroke",
  ["description"]="LATIN CAPITAL LETTER H WITH STROKE",
  ["lccode"]=0x0127,
  ["linebreak"]="al",
  ["shcode"]=0x0048,
  ["unicodeslot"]=0x0126, -- Ħ
 },
 {
  ["adobename"]="hbar",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="hstroke",
  ["description"]="LATIN SMALL LETTER H WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["uccode"]=0x0126,
  ["unicodeslot"]=0x0127, -- ħ
 },
 {
  ["adobename"]="Itilde",
  ["category"]="lu",
  ["contextname"]="Itilde",
  ["description"]="LATIN CAPITAL LETTER I WITH TILDE",
  ["lccode"]=0x0129,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0303 },
  ["unicodeslot"]=0x0128, -- Ĩ
 },
 {
  ["adobename"]="itilde",
  ["category"]="ll",
  ["contextname"]="itilde",
  ["description"]="LATIN SMALL LETTER I WITH TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0303 },
  ["uccode"]=0x0128,
  ["unicodeslot"]=0x0129, -- ĩ
 },
 {
  ["adobename"]="Imacron",
  ["category"]="lu",
  ["contextname"]="Imacron",
  ["description"]="LATIN CAPITAL LETTER I WITH MACRON",
  ["lccode"]=0x012B,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0304 },
  ["unicodeslot"]=0x012A, -- Ī
 },
 {
  ["adobename"]="imacron",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="imacron",
  ["description"]="LATIN SMALL LETTER I WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0304 },
  ["uccode"]=0x012A,
  ["unicodeslot"]=0x012B, -- ī
 },
 {
  ["adobename"]="Ibreve",
  ["category"]="lu",
  ["contextname"]="Ibreve",
  ["description"]="LATIN CAPITAL LETTER I WITH BREVE",
  ["lccode"]=0x012D,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0306 },
  ["unicodeslot"]=0x012C, -- Ĭ
 },
 {
  ["adobename"]="ibreve",
  ["category"]="ll",
  ["contextname"]="ibreve",
  ["description"]="LATIN SMALL LETTER I WITH BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0306 },
  ["uccode"]=0x012C,
  ["unicodeslot"]=0x012D, -- ĭ
 },
 {
  ["adobename"]="Iogonek",
  ["category"]="lu",
  ["contextname"]="Iogonek",
  ["description"]="LATIN CAPITAL LETTER I WITH OGONEK",
  ["lccode"]=0x012F,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0328 },
  ["unicodeslot"]=0x012E, -- Į
 },
 {
  ["adobename"]="iogonek",
  ["category"]="ll",
  ["contextname"]="iogonek",
  ["description"]="LATIN SMALL LETTER I WITH OGONEK",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0328 },
  ["uccode"]=0x012E,
  ["unicodeslot"]=0x012F, -- į
 },
 {
  ["adobename"]="Idotaccent",
  ["category"]="lu",
  ["contextname"]="Idotaccent",
  ["description"]="LATIN CAPITAL LETTER I WITH DOT ABOVE",
  ["lccode"]=0x0069,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0307 },
  ["unicodeslot"]=0x0130, -- İ
 },
 {
  ["adobename"]="dotlessi",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="dotlessi",
  ["description"]="LATIN SMALL LETTER DOTLESS I",
  ["linebreak"]="al",
  ["uccode"]=0x0049,
  ["unicodeslot"]=0x0131, -- ı
 },
 {
  ["adobename"]="IJ",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="IJligature",
  ["description"]="LATIN CAPITAL LIGATURE IJ",
  ["lccode"]=0x0133,
  ["linebreak"]="al",
  ["shcode"]={ 0x0049, 0x004A },
  ["specials"]={ "compat", 0x0049, 0x004A },
  ["unicodeslot"]=0x0132, -- Ĳ
 },
 {
  ["adobename"]="ij",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ijligature",
  ["description"]="LATIN SMALL LIGATURE IJ",
  ["linebreak"]="al",
  ["shcode"]={ 0x0069, 0x006A },
  ["specials"]={ "compat", 0x0069, 0x006A },
  ["uccode"]=0x0132,
  ["unicodeslot"]=0x0133, -- ĳ
 },
 {
  ["adobename"]="Jcircumflex",
  ["category"]="lu",
  ["contextname"]="Jcircumflex",
  ["description"]="LATIN CAPITAL LETTER J WITH CIRCUMFLEX",
  ["lccode"]=0x0135,
  ["linebreak"]="al",
  ["shcode"]=0x004A,
  ["specials"]={ "char", 0x004A, 0x0302 },
  ["unicodeslot"]=0x0134, -- Ĵ
 },
 {
  ["adobename"]="jcircumflex",
  ["category"]="ll",
  ["contextname"]="jcircumflex",
  ["description"]="LATIN SMALL LETTER J WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x006A,
  ["specials"]={ "char", 0x006A, 0x0302 },
  ["uccode"]=0x0134,
  ["unicodeslot"]=0x0135, -- ĵ
 },
 {
  ["adobename"]="Kcommaaccent",
  ["category"]="lu",
  ["contextname"]="Kcommaaccent",
  ["description"]="LATIN CAPITAL LETTER K WITH CEDILLA",
  ["lccode"]=0x0137,
  ["linebreak"]="al",
  ["shcode"]=0x004B,
  ["specials"]={ "char", 0x004B, 0x0327 },
  ["unicodeslot"]=0x0136, -- Ķ
 },
 {
  ["adobename"]="kcommaaccent",
  ["category"]="ll",
  ["contextname"]="kcommaaccent",
  ["description"]="LATIN SMALL LETTER K WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x006B,
  ["specials"]={ "char", 0x006B, 0x0327 },
  ["uccode"]=0x0136,
  ["unicodeslot"]=0x0137, -- ķ
 },
 {
  ["adobename"]="kgreenlandic",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="kkra",
  ["description"]="LATIN SMALL LETTER KRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0138, -- ĸ
 },
 {
  ["adobename"]="Lacute",
  ["category"]="lu",
  ["contextname"]="Lacute",
  ["description"]="LATIN CAPITAL LETTER L WITH ACUTE",
  ["lccode"]=0x013A,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["specials"]={ "char", 0x004C, 0x0301 },
  ["unicodeslot"]=0x0139, -- Ĺ
 },
 {
  ["adobename"]="lacute",
  ["category"]="ll",
  ["contextname"]="lacute",
  ["description"]="LATIN SMALL LETTER L WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["specials"]={ "char", 0x006C, 0x0301 },
  ["uccode"]=0x0139,
  ["unicodeslot"]=0x013A, -- ĺ
 },
 {
  ["adobename"]="Lcommaaccent",
  ["category"]="lu",
  ["contextname"]="Lcommaaccent",
  ["description"]="LATIN CAPITAL LETTER L WITH CEDILLA",
  ["lccode"]=0x013C,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["specials"]={ "char", 0x004C, 0x0327 },
  ["unicodeslot"]=0x013B, -- Ļ
 },
 {
  ["adobename"]="lcommaaccent",
  ["category"]="ll",
  ["contextname"]="lcommaaccent",
  ["description"]="LATIN SMALL LETTER L WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["specials"]={ "char", 0x006C, 0x0327 },
  ["uccode"]=0x013B,
  ["unicodeslot"]=0x013C, -- ļ
 },
 {
  ["adobename"]="Lcaron",
  ["category"]="lu",
  ["contextname"]="Lcaron",
  ["description"]="LATIN CAPITAL LETTER L WITH CARON",
  ["lccode"]=0x013E,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["specials"]={ "char", 0x004C, 0x030C },
  ["unicodeslot"]=0x013D, -- Ľ
 },
 {
  ["adobename"]="lcaron",
  ["category"]="ll",
  ["contextname"]="lcaron",
  ["description"]="LATIN SMALL LETTER L WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["specials"]={ "char", 0x006C, 0x030C },
  ["uccode"]=0x013D,
  ["unicodeslot"]=0x013E, -- ľ
 },
 {
  ["adobename"]="Ldot",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="Ldotmiddle",
  ["description"]="LATIN CAPITAL LETTER L WITH MIDDLE DOT",
  ["lccode"]=0x0140,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["specials"]={ "compat", 0x004C, 0x00B7 },
  ["unicodeslot"]=0x013F, -- Ŀ
 },
 {
  ["adobename"]="ldot",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ldotmiddle",
  ["description"]="LATIN SMALL LETTER L WITH MIDDLE DOT",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["specials"]={ "compat", 0x006C, 0x00B7 },
  ["uccode"]=0x013F,
  ["unicodeslot"]=0x0140, -- ŀ
 },
 {
  ["adobename"]="Lslash",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="Lstroke",
  ["description"]="LATIN CAPITAL LETTER L WITH STROKE",
  ["lccode"]=0x0142,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["unicodeslot"]=0x0141, -- Ł
 },
 {
  ["adobename"]="lslash",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="lstroke",
  ["description"]="LATIN SMALL LETTER L WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["uccode"]=0x0141,
  ["unicodeslot"]=0x0142, -- ł
 },
 {
  ["adobename"]="Nacute",
  ["category"]="lu",
  ["contextname"]="Nacute",
  ["description"]="LATIN CAPITAL LETTER N WITH ACUTE",
  ["lccode"]=0x0144,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["specials"]={ "char", 0x004E, 0x0301 },
  ["unicodeslot"]=0x0143, -- Ń
 },
 {
  ["adobename"]="nacute",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="nacute",
  ["description"]="LATIN SMALL LETTER N WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["specials"]={ "char", 0x006E, 0x0301 },
  ["uccode"]=0x0143,
  ["unicodeslot"]=0x0144, -- ń
 },
 {
  ["adobename"]="Ncommaaccent",
  ["category"]="lu",
  ["contextname"]="Ncommaaccent",
  ["description"]="LATIN CAPITAL LETTER N WITH CEDILLA",
  ["lccode"]=0x0146,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["specials"]={ "char", 0x004E, 0x0327 },
  ["unicodeslot"]=0x0145, -- Ņ
 },
 {
  ["adobename"]="ncommaaccent",
  ["category"]="ll",
  ["contextname"]="ncommaaccent",
  ["description"]="LATIN SMALL LETTER N WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["specials"]={ "char", 0x006E, 0x0327 },
  ["uccode"]=0x0145,
  ["unicodeslot"]=0x0146, -- ņ
 },
 {
  ["adobename"]="Ncaron",
  ["category"]="lu",
  ["contextname"]="Ncaron",
  ["description"]="LATIN CAPITAL LETTER N WITH CARON",
  ["lccode"]=0x0148,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["specials"]={ "char", 0x004E, 0x030C },
  ["unicodeslot"]=0x0147, -- Ň
 },
 {
  ["adobename"]="ncaron",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ncaron",
  ["description"]="LATIN SMALL LETTER N WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["specials"]={ "char", 0x006E, 0x030C },
  ["uccode"]=0x0147,
  ["unicodeslot"]=0x0148, -- ň
 },
 {
  ["adobename"]="napostrophe",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="napostrophe",
  ["description"]="LATIN SMALL LETTER N PRECEDED BY APOSTROPHE",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x02BC, 0x006E },
  ["unicodeslot"]=0x0149, -- ŉ
 },
 {
  ["adobename"]="Eng",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="Neng",
  ["description"]="LATIN CAPITAL LETTER ENG",
  ["lccode"]=0x014B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x014A, -- Ŋ
 },
 {
  ["adobename"]="eng",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="neng",
  ["description"]="LATIN SMALL LETTER ENG",
  ["linebreak"]="al",
  ["uccode"]=0x014A,
  ["unicodeslot"]=0x014B, -- ŋ
 },
 {
  ["adobename"]="Omacron",
  ["category"]="lu",
  ["contextname"]="Omacron",
  ["description"]="LATIN CAPITAL LETTER O WITH MACRON",
  ["lccode"]=0x014D,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0304 },
  ["unicodeslot"]=0x014C, -- Ō
 },
 {
  ["adobename"]="omacron",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="omacron",
  ["description"]="LATIN SMALL LETTER O WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0304 },
  ["uccode"]=0x014C,
  ["unicodeslot"]=0x014D, -- ō
 },
 {
  ["adobename"]="Obreve",
  ["category"]="lu",
  ["contextname"]="Obreve",
  ["description"]="LATIN CAPITAL LETTER O WITH BREVE",
  ["lccode"]=0x014F,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0306 },
  ["unicodeslot"]=0x014E, -- Ŏ
 },
 {
  ["adobename"]="obreve",
  ["category"]="ll",
  ["contextname"]="obreve",
  ["description"]="LATIN SMALL LETTER O WITH BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0306 },
  ["uccode"]=0x014E,
  ["unicodeslot"]=0x014F, -- ŏ
 },
 {
  ["adobename"]="Ohungarumlaut",
  ["category"]="lu",
  ["contextname"]="Ohungarumlaut",
  ["description"]="LATIN CAPITAL LETTER O WITH DOUBLE ACUTE",
  ["lccode"]=0x0151,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x030B },
  ["unicodeslot"]=0x0150, -- Ő
 },
 {
  ["adobename"]="ohungarumlaut",
  ["category"]="ll",
  ["contextname"]="ohungarumlaut",
  ["description"]="LATIN SMALL LETTER O WITH DOUBLE ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x030B },
  ["uccode"]=0x0150,
  ["unicodeslot"]=0x0151, -- ő
 },
 {
  ["adobename"]="OE",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="OEligature",
  ["description"]="LATIN CAPITAL LIGATURE OE",
  ["lccode"]=0x0153,
  ["linebreak"]="al",
  ["shcode"]={ 0x004F, 0x0045 },
  ["unicodeslot"]=0x0152, -- Œ
 },
 {
  ["adobename"]="oe",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="oeligature",
  ["description"]="LATIN SMALL LIGATURE OE",
  ["linebreak"]="al",
  ["shcode"]={ 0x006F, 0x0065 },
  ["uccode"]=0x0152,
  ["unicodeslot"]=0x0153, -- œ
 },
 {
  ["adobename"]="Racute",
  ["category"]="lu",
  ["contextname"]="Racute",
  ["description"]="LATIN CAPITAL LETTER R WITH ACUTE",
  ["lccode"]=0x0155,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["specials"]={ "char", 0x0052, 0x0301 },
  ["unicodeslot"]=0x0154, -- Ŕ
 },
 {
  ["adobename"]="racute",
  ["category"]="ll",
  ["contextname"]="racute",
  ["description"]="LATIN SMALL LETTER R WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["specials"]={ "char", 0x0072, 0x0301 },
  ["uccode"]=0x0154,
  ["unicodeslot"]=0x0155, -- ŕ
 },
 {
  ["adobename"]="Rcommaaccent",
  ["category"]="lu",
  ["contextname"]="Rcommaaccent",
  ["description"]="LATIN CAPITAL LETTER R WITH CEDILLA",
  ["lccode"]=0x0157,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["specials"]={ "char", 0x0052, 0x0327 },
  ["unicodeslot"]=0x0156, -- Ŗ
 },
 {
  ["adobename"]="rcommaaccent",
  ["category"]="ll",
  ["contextname"]="rcommaaccent",
  ["description"]="LATIN SMALL LETTER R WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["specials"]={ "char", 0x0072, 0x0327 },
  ["uccode"]=0x0156,
  ["unicodeslot"]=0x0157, -- ŗ
 },
 {
  ["adobename"]="Rcaron",
  ["category"]="lu",
  ["contextname"]="Rcaron",
  ["description"]="LATIN CAPITAL LETTER R WITH CARON",
  ["lccode"]=0x0159,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["specials"]={ "char", 0x0052, 0x030C },
  ["unicodeslot"]=0x0158, -- Ř
 },
 {
  ["adobename"]="rcaron",
  ["category"]="ll",
  ["contextname"]="rcaron",
  ["description"]="LATIN SMALL LETTER R WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["specials"]={ "char", 0x0072, 0x030C },
  ["uccode"]=0x0158,
  ["unicodeslot"]=0x0159, -- ř
 },
 {
  ["adobename"]="Sacute",
  ["category"]="lu",
  ["contextname"]="Sacute",
  ["description"]="LATIN CAPITAL LETTER S WITH ACUTE",
  ["lccode"]=0x015B,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x0053, 0x0301 },
  ["unicodeslot"]=0x015A, -- Ś
 },
 {
  ["adobename"]="sacute",
  ["category"]="ll",
  ["contextname"]="sacute",
  ["description"]="LATIN SMALL LETTER S WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x0073, 0x0301 },
  ["uccode"]=0x015A,
  ["unicodeslot"]=0x015B, -- ś
 },
 {
  ["adobename"]="Scircumflex",
  ["category"]="lu",
  ["contextname"]="Scircumflex",
  ["description"]="LATIN CAPITAL LETTER S WITH CIRCUMFLEX",
  ["lccode"]=0x015D,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x0053, 0x0302 },
  ["unicodeslot"]=0x015C, -- Ŝ
 },
 {
  ["adobename"]="scircumflex",
  ["category"]="ll",
  ["contextname"]="scircumflex",
  ["description"]="LATIN SMALL LETTER S WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x0073, 0x0302 },
  ["uccode"]=0x015C,
  ["unicodeslot"]=0x015D, -- ŝ
 },
 {
  ["adobename"]="Scedilla",
  ["category"]="lu",
  ["contextname"]="Scedilla",
  ["description"]="LATIN CAPITAL LETTER S WITH CEDILLA",
  ["lccode"]=0x015F,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x0053, 0x0327 },
  ["unicodeslot"]=0x015E, -- Ş
 },
 {
  ["adobename"]="scedilla",
  ["category"]="ll",
  ["contextname"]="scedilla",
  ["description"]="LATIN SMALL LETTER S WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x0073, 0x0327 },
  ["uccode"]=0x015E,
  ["unicodeslot"]=0x015F, -- ş
 },
 {
  ["adobename"]="Scaron",
  ["category"]="lu",
  ["contextname"]="Scaron",
  ["description"]="LATIN CAPITAL LETTER S WITH CARON",
  ["lccode"]=0x0161,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x0053, 0x030C },
  ["unicodeslot"]=0x0160, -- Š
 },
 {
  ["adobename"]="scaron",
  ["category"]="ll",
  ["contextname"]="scaron",
  ["description"]="LATIN SMALL LETTER S WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x0073, 0x030C },
  ["uccode"]=0x0160,
  ["unicodeslot"]=0x0161, -- š
 },
 {
  ["adobename"]="Tcommaaccent",
  ["category"]="lu",
  ["contextname"]="Tcedilla",
  ["description"]="LATIN CAPITAL LETTER T WITH CEDILLA",
  ["lccode"]=0x0163,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["specials"]={ "char", 0x0054, 0x0327 },
  ["unicodeslot"]=0x0162, -- Ţ
 },
 {
  ["adobename"]="tcommaaccent",
  ["category"]="ll",
  ["contextname"]="tcedilla",
  ["description"]="LATIN SMALL LETTER T WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["specials"]={ "char", 0x0074, 0x0327 },
  ["uccode"]=0x0162,
  ["unicodeslot"]=0x0163, -- ţ
 },
 {
  ["adobename"]="Tcaron",
  ["category"]="lu",
  ["contextname"]="Tcaron",
  ["description"]="LATIN CAPITAL LETTER T WITH CARON",
  ["lccode"]=0x0165,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["specials"]={ "char", 0x0054, 0x030C },
  ["unicodeslot"]=0x0164, -- Ť
 },
 {
  ["adobename"]="tcaron",
  ["category"]="ll",
  ["contextname"]="tcaron",
  ["description"]="LATIN SMALL LETTER T WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["specials"]={ "char", 0x0074, 0x030C },
  ["uccode"]=0x0164,
  ["unicodeslot"]=0x0165, -- ť
 },
 {
  ["adobename"]="Tbar",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="Tstroke",
  ["description"]="LATIN CAPITAL LETTER T WITH STROKE",
  ["lccode"]=0x0167,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["unicodeslot"]=0x0166, -- Ŧ
 },
 {
  ["adobename"]="tbar",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="tstroke",
  ["description"]="LATIN SMALL LETTER T WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["uccode"]=0x0166,
  ["unicodeslot"]=0x0167, -- ŧ
 },
 {
  ["adobename"]="Utilde",
  ["category"]="lu",
  ["contextname"]="Utilde",
  ["description"]="LATIN CAPITAL LETTER U WITH TILDE",
  ["lccode"]=0x0169,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0303 },
  ["unicodeslot"]=0x0168, -- Ũ
 },
 {
  ["adobename"]="utilde",
  ["category"]="ll",
  ["contextname"]="utilde",
  ["description"]="LATIN SMALL LETTER U WITH TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0303 },
  ["uccode"]=0x0168,
  ["unicodeslot"]=0x0169, -- ũ
 },
 {
  ["adobename"]="Umacron",
  ["category"]="lu",
  ["contextname"]="Umacron",
  ["description"]="LATIN CAPITAL LETTER U WITH MACRON",
  ["lccode"]=0x016B,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0304 },
  ["unicodeslot"]=0x016A, -- Ū
 },
 {
  ["adobename"]="umacron",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="umacron",
  ["description"]="LATIN SMALL LETTER U WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0304 },
  ["uccode"]=0x016A,
  ["unicodeslot"]=0x016B, -- ū
 },
 {
  ["adobename"]="Ubreve",
  ["category"]="lu",
  ["contextname"]="Ubreve",
  ["description"]="LATIN CAPITAL LETTER U WITH BREVE",
  ["lccode"]=0x016D,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0306 },
  ["unicodeslot"]=0x016C, -- Ŭ
 },
 {
  ["adobename"]="ubreve",
  ["category"]="ll",
  ["contextname"]="ubreve",
  ["description"]="LATIN SMALL LETTER U WITH BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0306 },
  ["uccode"]=0x016C,
  ["unicodeslot"]=0x016D, -- ŭ
 },
 {
  ["adobename"]="Uring",
  ["category"]="lu",
  ["contextname"]="Uring",
  ["description"]="LATIN CAPITAL LETTER U WITH RING ABOVE",
  ["lccode"]=0x016F,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x030A },
  ["unicodeslot"]=0x016E, -- Ů
 },
 {
  ["adobename"]="uring",
  ["category"]="ll",
  ["contextname"]="uring",
  ["description"]="LATIN SMALL LETTER U WITH RING ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x030A },
  ["uccode"]=0x016E,
  ["unicodeslot"]=0x016F, -- ů
 },
 {
  ["adobename"]="Uhungarumlaut",
  ["category"]="lu",
  ["contextname"]="Uhungarumlaut",
  ["description"]="LATIN CAPITAL LETTER U WITH DOUBLE ACUTE",
  ["lccode"]=0x0171,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x030B },
  ["unicodeslot"]=0x0170, -- Ű
 },
 {
  ["adobename"]="uhungarumlaut",
  ["category"]="ll",
  ["contextname"]="uhungarumlaut",
  ["description"]="LATIN SMALL LETTER U WITH DOUBLE ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x030B },
  ["uccode"]=0x0170,
  ["unicodeslot"]=0x0171, -- ű
 },
 {
  ["adobename"]="Uogonek",
  ["category"]="lu",
  ["contextname"]="Uogonek",
  ["description"]="LATIN CAPITAL LETTER U WITH OGONEK",
  ["lccode"]=0x0173,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0328 },
  ["unicodeslot"]=0x0172, -- Ų
 },
 {
  ["adobename"]="uogonek",
  ["category"]="ll",
  ["contextname"]="uogonek",
  ["description"]="LATIN SMALL LETTER U WITH OGONEK",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0328 },
  ["uccode"]=0x0172,
  ["unicodeslot"]=0x0173, -- ų
 },
 {
  ["adobename"]="Wcircumflex",
  ["category"]="lu",
  ["contextname"]="Wcircumflex",
  ["description"]="LATIN CAPITAL LETTER W WITH CIRCUMFLEX",
  ["lccode"]=0x0175,
  ["linebreak"]="al",
  ["shcode"]=0x0057,
  ["specials"]={ "char", 0x0057, 0x0302 },
  ["unicodeslot"]=0x0174, -- Ŵ
 },
 {
  ["adobename"]="wcircumflex",
  ["category"]="ll",
  ["contextname"]="wcircumflex",
  ["description"]="LATIN SMALL LETTER W WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0077,
  ["specials"]={ "char", 0x0077, 0x0302 },
  ["uccode"]=0x0174,
  ["unicodeslot"]=0x0175, -- ŵ
 },
 {
  ["adobename"]="Ycircumflex",
  ["category"]="lu",
  ["contextname"]="Ycircumflex",
  ["description"]="LATIN CAPITAL LETTER Y WITH CIRCUMFLEX",
  ["lccode"]=0x0177,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["specials"]={ "char", 0x0059, 0x0302 },
  ["unicodeslot"]=0x0176, -- Ŷ
 },
 {
  ["adobename"]="ycircumflex",
  ["category"]="ll",
  ["contextname"]="ycircumflex",
  ["description"]="LATIN SMALL LETTER Y WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x0302 },
  ["uccode"]=0x0176,
  ["unicodeslot"]=0x0177, -- ŷ
 },
 {
  ["adobename"]="Ydieresis",
  ["category"]="lu",
  ["contextname"]="Ydiaeresis",
  ["description"]="LATIN CAPITAL LETTER Y WITH DIAERESIS",
  ["lccode"]=0x00FF,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["specials"]={ "char", 0x0059, 0x0308 },
  ["unicodeslot"]=0x0178, -- Ÿ
 },
 {
  ["adobename"]="Zacute",
  ["category"]="lu",
  ["contextname"]="Zacute",
  ["description"]="LATIN CAPITAL LETTER Z WITH ACUTE",
  ["lccode"]=0x017A,
  ["linebreak"]="al",
  ["shcode"]=0x005A,
  ["specials"]={ "char", 0x005A, 0x0301 },
  ["unicodeslot"]=0x0179, -- Ź
 },
 {
  ["adobename"]="zacute",
  ["category"]="ll",
  ["contextname"]="zacute",
  ["description"]="LATIN SMALL LETTER Z WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["specials"]={ "char", 0x007A, 0x0301 },
  ["uccode"]=0x0179,
  ["unicodeslot"]=0x017A, -- ź
 },
 {
  ["adobename"]="Zdotaccent",
  ["category"]="lu",
  ["contextname"]="Zdotaccent",
  ["description"]="LATIN CAPITAL LETTER Z WITH DOT ABOVE",
  ["lccode"]=0x017C,
  ["linebreak"]="al",
  ["shcode"]=0x005A,
  ["specials"]={ "char", 0x005A, 0x0307 },
  ["unicodeslot"]=0x017B, -- Ż
 },
 {
  ["adobename"]="zdotaccent",
  ["category"]="ll",
  ["contextname"]="zdotaccent",
  ["description"]="LATIN SMALL LETTER Z WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["specials"]={ "char", 0x007A, 0x0307 },
  ["uccode"]=0x017B,
  ["unicodeslot"]=0x017C, -- ż
 },
 {
  ["adobename"]="Zcaron",
  ["category"]="lu",
  ["contextname"]="Zcaron",
  ["description"]="LATIN CAPITAL LETTER Z WITH CARON",
  ["lccode"]=0x017E,
  ["linebreak"]="al",
  ["shcode"]=0x005A,
  ["specials"]={ "char", 0x005A, 0x030C },
  ["unicodeslot"]=0x017D, -- Ž
 },
 {
  ["adobename"]="zcaron",
  ["category"]="ll",
  ["contextname"]="zcaron",
  ["description"]="LATIN SMALL LETTER Z WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["specials"]={ "char", 0x007A, 0x030C },
  ["uccode"]=0x017D,
  ["unicodeslot"]=0x017E, -- ž
 },
 {
  ["adobename"]="longs",
  ["category"]="ll",
  ["contextname"]="slong",
  ["description"]="LATIN SMALL LETTER LONG S",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0073 },
  ["uccode"]=0x0053,
  ["unicodeslot"]=0x017F, -- ſ
 },
 {
  ["category"]="ll",
  ["contextname"]="bstroke",
  ["description"]="LATIN SMALL LETTER B WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0062,
  ["uccode"]=0x0243,
  ["unicodeslot"]=0x0180, -- ƀ
 },
 {
  ["category"]="lu",
  ["contextname"]="Bhook",
  ["description"]="LATIN CAPITAL LETTER B WITH HOOK",
  ["lccode"]=0x0253,
  ["linebreak"]="al",
  ["shcode"]=0x0042,
  ["unicodeslot"]=0x0181, -- Ɓ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER B WITH TOPBAR",
  ["lccode"]=0x0183,
  ["linebreak"]="al",
  ["shcode"]=0x0042,
  ["unicodeslot"]=0x0182, -- Ƃ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER B WITH TOPBAR",
  ["linebreak"]="al",
  ["shcode"]=0x0062,
  ["uccode"]=0x0182,
  ["unicodeslot"]=0x0183, -- ƃ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER TONE SIX",
  ["lccode"]=0x0185,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0184, -- Ƅ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TONE SIX",
  ["linebreak"]="al",
  ["uccode"]=0x0184,
  ["unicodeslot"]=0x0185, -- ƅ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER OPEN O",
  ["lccode"]=0x0254,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0186, -- Ɔ
 },
 {
  ["category"]="lu",
  ["contextname"]="Chook",
  ["description"]="LATIN CAPITAL LETTER C WITH HOOK",
  ["lccode"]=0x0188,
  ["linebreak"]="al",
  ["shcode"]=0x0043,
  ["unicodeslot"]=0x0187, -- Ƈ
 },
 {
  ["category"]="ll",
  ["contextname"]="chook",
  ["description"]="LATIN SMALL LETTER C WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0063,
  ["uccode"]=0x0187,
  ["unicodeslot"]=0x0188, -- ƈ
 },
 {
  ["category"]="lu",
  ["contextname"]="Dafrican",
  ["description"]="LATIN CAPITAL LETTER AFRICAN D",
  ["lccode"]=0x0256,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0189, -- Ɖ
 },
 {
  ["category"]="lu",
  ["contextname"]="Dhook",
  ["description"]="LATIN CAPITAL LETTER D WITH HOOK",
  ["lccode"]=0x0257,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["unicodeslot"]=0x018A, -- Ɗ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER D WITH TOPBAR",
  ["lccode"]=0x018C,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["unicodeslot"]=0x018B, -- Ƌ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER D WITH TOPBAR",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["uccode"]=0x018B,
  ["unicodeslot"]=0x018C, -- ƌ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED DELTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x018D, -- ƍ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER REVERSED E",
  ["lccode"]=0x01DD,
  ["linebreak"]="al",
  ["unicodeslot"]=0x018E, -- Ǝ
 },
 {
  ["category"]="lu",
  ["contextname"]="Schwa",
  ["description"]="LATIN CAPITAL LETTER SCHWA",
  ["lccode"]=0x0259,
  ["linebreak"]="al",
  ["unicodeslot"]=0x018F, -- Ə
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER OPEN E",
  ["lccode"]=0x025B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0190, -- Ɛ
 },
 {
  ["category"]="lu",
  ["contextname"]="Fhook",
  ["description"]="LATIN CAPITAL LETTER F WITH HOOK",
  ["lccode"]=0x0192,
  ["linebreak"]="al",
  ["shcode"]=0x0046,
  ["unicodeslot"]=0x0191, -- Ƒ
 },
 {
  ["adobename"]="florin",
  ["category"]="ll",
  ["contextname"]="fhook",
  ["description"]="LATIN SMALL LETTER F WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0066,
  ["uccode"]=0x0191,
  ["unicodeslot"]=0x0192, -- ƒ
 },
 {
  ["category"]="lu",
  ["contextname"]="Ghook",
  ["description"]="LATIN CAPITAL LETTER G WITH HOOK",
  ["lccode"]=0x0260,
  ["linebreak"]="al",
  ["shcode"]=0x0047,
  ["unicodeslot"]=0x0193, -- Ɠ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER GAMMA",
  ["lccode"]=0x0263,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0194, -- Ɣ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER HV",
  ["linebreak"]="al",
  ["uccode"]=0x01F6,
  ["unicodeslot"]=0x0195, -- ƕ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER IOTA",
  ["lccode"]=0x0269,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0196, -- Ɩ
 },
 {
  ["category"]="lu",
  ["contextname"]="Istroke",
  ["description"]="LATIN CAPITAL LETTER I WITH STROKE",
  ["lccode"]=0x0268,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["unicodeslot"]=0x0197, -- Ɨ
 },
 {
  ["category"]="lu",
  ["contextname"]="Khook",
  ["description"]="LATIN CAPITAL LETTER K WITH HOOK",
  ["lccode"]=0x0199,
  ["linebreak"]="al",
  ["shcode"]=0x004B,
  ["unicodeslot"]=0x0198, -- Ƙ
 },
 {
  ["category"]="ll",
  ["contextname"]="khook",
  ["description"]="LATIN SMALL LETTER K WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x006B,
  ["uccode"]=0x0198,
  ["unicodeslot"]=0x0199, -- ƙ
 },
 {
  ["category"]="ll",
  ["contextname"]="lbar",
  ["description"]="LATIN SMALL LETTER L WITH BAR",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["uccode"]=0x023D,
  ["unicodeslot"]=0x019A, -- ƚ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER LAMBDA WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x019B, -- ƛ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER TURNED M",
  ["lccode"]=0x026F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x019C, -- Ɯ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER N WITH LEFT HOOK",
  ["lccode"]=0x0272,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["unicodeslot"]=0x019D, -- Ɲ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER N WITH LONG RIGHT LEG",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["uccode"]=0x0220,
  ["unicodeslot"]=0x019E, -- ƞ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER O WITH MIDDLE TILDE",
  ["lccode"]=0x0275,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["unicodeslot"]=0x019F, -- Ɵ
 },
 {
  ["adobename"]="Ohorn",
  ["category"]="lu",
  ["contextname"]="Ohorn",
  ["description"]="LATIN CAPITAL LETTER O WITH HORN",
  ["lccode"]=0x01A1,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x031B },
  ["unicodeslot"]=0x01A0, -- Ơ
 },
 {
  ["adobename"]="ohorn",
  ["category"]="ll",
  ["contextname"]="ohorn",
  ["description"]="LATIN SMALL LETTER O WITH HORN",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x031B },
  ["uccode"]=0x01A0,
  ["unicodeslot"]=0x01A1, -- ơ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER OI",
  ["lccode"]=0x01A3,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01A2, -- Ƣ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER OI",
  ["linebreak"]="al",
  ["uccode"]=0x01A2,
  ["unicodeslot"]=0x01A3, -- ƣ
 },
 {
  ["category"]="lu",
  ["contextname"]="Phook",
  ["description"]="LATIN CAPITAL LETTER P WITH HOOK",
  ["lccode"]=0x01A5,
  ["linebreak"]="al",
  ["shcode"]=0x0050,
  ["unicodeslot"]=0x01A4, -- Ƥ
 },
 {
  ["category"]="ll",
  ["contextname"]="phook",
  ["description"]="LATIN SMALL LETTER P WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0070,
  ["uccode"]=0x01A4,
  ["unicodeslot"]=0x01A5, -- ƥ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN LETTER YR",
  ["lccode"]=0x0280,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01A6, -- Ʀ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER TONE TWO",
  ["lccode"]=0x01A8,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01A7, -- Ƨ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TONE TWO",
  ["linebreak"]="al",
  ["uccode"]=0x01A7,
  ["unicodeslot"]=0x01A8, -- ƨ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER ESH",
  ["lccode"]=0x0283,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01A9, -- Ʃ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER REVERSED ESH LOOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x01AA, -- ƪ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER T WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["unicodeslot"]=0x01AB, -- ƫ
 },
 {
  ["category"]="lu",
  ["contextname"]="Thook",
  ["description"]="LATIN CAPITAL LETTER T WITH HOOK",
  ["lccode"]=0x01AD,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["unicodeslot"]=0x01AC, -- Ƭ
 },
 {
  ["category"]="ll",
  ["contextname"]="thook",
  ["description"]="LATIN SMALL LETTER T WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["uccode"]=0x01AC,
  ["unicodeslot"]=0x01AD, -- ƭ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER T WITH RETROFLEX HOOK",
  ["lccode"]=0x0288,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["unicodeslot"]=0x01AE, -- Ʈ
 },
 {
  ["adobename"]="Uhorn",
  ["category"]="lu",
  ["contextname"]="Uhorn",
  ["description"]="LATIN CAPITAL LETTER U WITH HORN",
  ["lccode"]=0x01B0,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x031B },
  ["unicodeslot"]=0x01AF, -- Ư
 },
 {
  ["adobename"]="uhorn",
  ["category"]="ll",
  ["contextname"]="uhorn",
  ["description"]="LATIN SMALL LETTER U WITH HORN",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x031B },
  ["uccode"]=0x01AF,
  ["unicodeslot"]=0x01B0, -- ư
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER UPSILON",
  ["lccode"]=0x028A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01B1, -- Ʊ
 },
 {
  ["category"]="lu",
  ["contextname"]="Uhook",
  ["description"]="LATIN CAPITAL LETTER V WITH HOOK",
  ["lccode"]=0x028B,
  ["linebreak"]="al",
  ["shcode"]=0x0056,
  ["unicodeslot"]=0x01B2, -- Ʋ
 },
 {
  ["category"]="lu",
  ["contextname"]="Yhook",
  ["description"]="LATIN CAPITAL LETTER Y WITH HOOK",
  ["lccode"]=0x01B4,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["unicodeslot"]=0x01B3, -- Ƴ
 },
 {
  ["category"]="ll",
  ["contextname"]="yhook",
  ["description"]="LATIN SMALL LETTER Y WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["uccode"]=0x01B3,
  ["unicodeslot"]=0x01B4, -- ƴ
 },
 {
  ["category"]="lu",
  ["contextname"]="Zstroke",
  ["description"]="LATIN CAPITAL LETTER Z WITH STROKE",
  ["lccode"]=0x01B6,
  ["linebreak"]="al",
  ["shcode"]=0x005A,
  ["unicodeslot"]=0x01B5, -- Ƶ
 },
 {
  ["category"]="ll",
  ["contextname"]="zstroke",
  ["description"]="LATIN SMALL LETTER Z WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["uccode"]=0x01B5,
  ["unicodeslot"]=0x01B6, -- ƶ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER EZH",
  ["lccode"]=0x0292,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01B7, -- Ʒ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER EZH REVERSED",
  ["lccode"]=0x01B9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01B8, -- Ƹ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER EZH REVERSED",
  ["linebreak"]="al",
  ["uccode"]=0x01B8,
  ["unicodeslot"]=0x01B9, -- ƹ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER EZH WITH TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x0292,
  ["unicodeslot"]=0x01BA, -- ƺ
 },
 {
  ["category"]="lo",
  ["description"]="LATIN LETTER TWO WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x01BB, -- ƻ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER TONE FIVE",
  ["lccode"]=0x01BD,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01BC, -- Ƽ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TONE FIVE",
  ["linebreak"]="al",
  ["uccode"]=0x01BC,
  ["unicodeslot"]=0x01BD, -- ƽ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER INVERTED GLOTTAL STOP WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x01BE, -- ƾ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER WYNN",
  ["linebreak"]="al",
  ["uccode"]=0x01F7,
  ["unicodeslot"]=0x01BF, -- ƿ
 },
 {
  ["category"]="lo",
  ["description"]="LATIN LETTER DENTAL CLICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x01C0, -- ǀ
 },
 {
  ["category"]="lo",
  ["description"]="LATIN LETTER LATERAL CLICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x01C1, -- ǁ
 },
 {
  ["category"]="lo",
  ["description"]="LATIN LETTER ALVEOLAR CLICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x01C2, -- ǂ
 },
 {
  ["category"]="lo",
  ["description"]="LATIN LETTER RETROFLEX CLICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x01C3, -- ǃ
 },
 {
  ["category"]="lu",
  ["contextname"]="DZcaronligature",
  ["description"]="LATIN CAPITAL LETTER DZ WITH CARON",
  ["lccode"]=0x01C6,
  ["linebreak"]="al",
  ["shcode"]=0x01F1,
  ["specials"]={ "compat", 0x0044, 0x017D },
  ["uccode"]=0x01C5,
  ["unicodeslot"]=0x01C4, -- Ǆ
 },
 {
  ["category"]="lt",
  ["contextname"]="Dzcaronligature",
  ["description"]="LATIN CAPITAL LETTER D WITH SMALL LETTER Z WITH CARON",
  ["lccode"]=0x01C6,
  ["linebreak"]="al",
  ["shcode"]=0x01F2,
  ["specials"]={ "compat", 0x0044, 0x017E },
  ["uccode"]=0x01C4,
  ["unicodeslot"]=0x01C5, -- ǅ
 },
 {
  ["category"]="ll",
  ["contextname"]="dzcaronligature",
  ["description"]="LATIN SMALL LETTER DZ WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x01F3,
  ["specials"]={ "compat", 0x0064, 0x017E },
  ["uccode"]=0x01C4,
  ["unicodeslot"]=0x01C6, -- ǆ
 },
 {
  ["category"]="lu",
  ["contextname"]="LJligature",
  ["description"]="LATIN CAPITAL LETTER LJ",
  ["lccode"]=0x01C9,
  ["linebreak"]="al",
  ["shcode"]={ 0x004C, 0x004A },
  ["specials"]={ "compat", 0x004C, 0x004A },
  ["uccode"]=0x01C8,
  ["unicodeslot"]=0x01C7, -- Ǉ
 },
 {
  ["category"]="lt",
  ["contextname"]="Ljligature",
  ["description"]="LATIN CAPITAL LETTER L WITH SMALL LETTER J",
  ["lccode"]=0x01C9,
  ["linebreak"]="al",
  ["shcode"]={ 0x004C, 0x006A },
  ["specials"]={ "compat", 0x004C, 0x006A },
  ["uccode"]=0x01C7,
  ["unicodeslot"]=0x01C8, -- ǈ
 },
 {
  ["category"]="ll",
  ["contextname"]="ljligature",
  ["description"]="LATIN SMALL LETTER LJ",
  ["linebreak"]="al",
  ["shcode"]={ 0x006C, 0x006A },
  ["specials"]={ "compat", 0x006C, 0x006A },
  ["uccode"]=0x01C7,
  ["unicodeslot"]=0x01C9, -- ǉ
 },
 {
  ["category"]="lu",
  ["contextname"]="NJligature",
  ["description"]="LATIN CAPITAL LETTER NJ",
  ["lccode"]=0x01CC,
  ["linebreak"]="al",
  ["shcode"]={ 0x004E, 0x004A },
  ["specials"]={ "compat", 0x004E, 0x004A },
  ["uccode"]=0x01CB,
  ["unicodeslot"]=0x01CA, -- Ǌ
 },
 {
  ["category"]="lt",
  ["contextname"]="Njligature",
  ["description"]="LATIN CAPITAL LETTER N WITH SMALL LETTER J",
  ["lccode"]=0x01CC,
  ["linebreak"]="al",
  ["shcode"]={ 0x004E, 0x006A },
  ["shcode"]=0x004E,
  ["specials"]={ "compat", 0x004E, 0x006A },
  ["uccode"]=0x01CA,
  ["unicodeslot"]=0x01CB, -- ǋ
 },
 {
  ["category"]="ll",
  ["contextname"]="njligature",
  ["description"]="LATIN SMALL LETTER NJ",
  ["linebreak"]="al",
  ["shcode"]={ 0x006E, 0x006A },
  ["specials"]={ "compat", 0x006E, 0x006A },
  ["uccode"]=0x01CA,
  ["unicodeslot"]=0x01CC, -- ǌ
 },
 {
  ["category"]="lu",
  ["contextname"]="Acaron",
  ["description"]="LATIN CAPITAL LETTER A WITH CARON",
  ["lccode"]=0x01CE,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x030C },
  ["unicodeslot"]=0x01CD, -- Ǎ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="acaron",
  ["description"]="LATIN SMALL LETTER A WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x030C },
  ["uccode"]=0x01CD,
  ["unicodeslot"]=0x01CE, -- ǎ
 },
 {
  ["category"]="lu",
  ["contextname"]="Icaron",
  ["description"]="LATIN CAPITAL LETTER I WITH CARON",
  ["lccode"]=0x01D0,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x030C },
  ["unicodeslot"]=0x01CF, -- Ǐ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="icaron",
  ["description"]="LATIN SMALL LETTER I WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x030C },
  ["uccode"]=0x01CF,
  ["unicodeslot"]=0x01D0, -- ǐ
 },
 {
  ["category"]="lu",
  ["contextname"]="Ocaron",
  ["description"]="LATIN CAPITAL LETTER O WITH CARON",
  ["lccode"]=0x01D2,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x030C },
  ["unicodeslot"]=0x01D1, -- Ǒ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ocaron",
  ["description"]="LATIN SMALL LETTER O WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x030C },
  ["uccode"]=0x01D1,
  ["unicodeslot"]=0x01D2, -- ǒ
 },
 {
  ["category"]="lu",
  ["contextname"]="Ucaron",
  ["description"]="LATIN CAPITAL LETTER U WITH CARON",
  ["lccode"]=0x01D4,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x030C },
  ["unicodeslot"]=0x01D3, -- Ǔ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="ucaron",
  ["description"]="LATIN SMALL LETTER U WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x030C },
  ["uccode"]=0x01D3,
  ["unicodeslot"]=0x01D4, -- ǔ
 },
 {
  ["category"]="lu",
  ["contextname"]="Udiaeresismacron",
  ["description"]="LATIN CAPITAL LETTER U WITH DIAERESIS AND MACRON",
  ["lccode"]=0x01D6,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x00DC, 0x0304 },
  ["unicodeslot"]=0x01D5, -- Ǖ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="udiaeresismacron",
  ["description"]="LATIN SMALL LETTER U WITH DIAERESIS AND MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x00FC, 0x0304 },
  ["uccode"]=0x01D5,
  ["unicodeslot"]=0x01D6, -- ǖ
 },
 {
  ["category"]="lu",
  ["contextname"]="Udiaeresisacute",
  ["description"]="LATIN CAPITAL LETTER U WITH DIAERESIS AND ACUTE",
  ["lccode"]=0x01D8,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x00DC, 0x0301 },
  ["unicodeslot"]=0x01D7, -- Ǘ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="udiaeresisacute",
  ["description"]="LATIN SMALL LETTER U WITH DIAERESIS AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x00FC, 0x0301 },
  ["uccode"]=0x01D7,
  ["unicodeslot"]=0x01D8, -- ǘ
 },
 {
  ["category"]="lu",
  ["contextname"]="Udiaeresiscaron",
  ["description"]="LATIN CAPITAL LETTER U WITH DIAERESIS AND CARON",
  ["lccode"]=0x01DA,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x00DC, 0x030C },
  ["unicodeslot"]=0x01D9, -- Ǚ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="udiaeresiscaron",
  ["description"]="LATIN SMALL LETTER U WITH DIAERESIS AND CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x00FC, 0x030C },
  ["uccode"]=0x01D9,
  ["unicodeslot"]=0x01DA, -- ǚ
 },
 {
  ["category"]="lu",
  ["contextname"]="Udiaeresisgrave",
  ["description"]="LATIN CAPITAL LETTER U WITH DIAERESIS AND GRAVE",
  ["lccode"]=0x01DC,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x00DC, 0x0300 },
  ["unicodeslot"]=0x01DB, -- Ǜ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="udiaeresisgrave",
  ["description"]="LATIN SMALL LETTER U WITH DIAERESIS AND GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x00FC, 0x0300 },
  ["uccode"]=0x01DB,
  ["unicodeslot"]=0x01DC, -- ǜ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED E",
  ["linebreak"]="al",
  ["uccode"]=0x018E,
  ["unicodeslot"]=0x01DD, -- ǝ
 },
 {
  ["category"]="lu",
  ["contextname"]="Adiaeresismacron",
  ["description"]="LATIN CAPITAL LETTER A WITH DIAERESIS AND MACRON",
  ["lccode"]=0x01DF,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x00C4, 0x0304 },
  ["unicodeslot"]=0x01DE, -- Ǟ
 },
 {
  ["category"]="ll",
  ["contextname"]="adiaeresismacron",
  ["description"]="LATIN SMALL LETTER A WITH DIAERESIS AND MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x00E4, 0x0304 },
  ["uccode"]=0x01DE,
  ["unicodeslot"]=0x01DF, -- ǟ
 },
 {
  ["category"]="lu",
  ["contextname"]="Adotaccentmacron",
  ["description"]="LATIN CAPITAL LETTER A WITH DOT ABOVE AND MACRON",
  ["lccode"]=0x01E1,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0226, 0x0304 },
  ["unicodeslot"]=0x01E0, -- Ǡ
 },
 {
  ["category"]="ll",
  ["contextname"]="adotaccentmacron",
  ["description"]="LATIN SMALL LETTER A WITH DOT ABOVE AND MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0227, 0x0304 },
  ["uccode"]=0x01E0,
  ["unicodeslot"]=0x01E1, -- ǡ
 },
 {
  ["category"]="lu",
  ["contextname"]="AEmacron",
  ["description"]="LATIN CAPITAL LETTER AE WITH MACRON",
  ["lccode"]=0x01E3,
  ["linebreak"]="al",
  ["shcode"]=0x00C6,
  ["specials"]={ "char", 0x00C6, 0x0304 },
  ["unicodeslot"]=0x01E2, -- Ǣ
 },
 {
  ["category"]="ll",
  ["contextname"]="aemacron",
  ["description"]="LATIN SMALL LETTER AE WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x00E6,
  ["specials"]={ "char", 0x00E6, 0x0304 },
  ["uccode"]=0x01E2,
  ["unicodeslot"]=0x01E3, -- ǣ
 },
 {
  ["category"]="lu",
  ["contextname"]="Gstroke",
  ["description"]="LATIN CAPITAL LETTER G WITH STROKE",
  ["lccode"]=0x01E5,
  ["linebreak"]="al",
  ["shcode"]=0x0047,
  ["unicodeslot"]=0x01E4, -- Ǥ
 },
 {
  ["category"]="ll",
  ["contextname"]="gstroke",
  ["description"]="LATIN SMALL LETTER G WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["uccode"]=0x01E4,
  ["unicodeslot"]=0x01E5, -- ǥ
 },
 {
  ["adobename"]="Gcaron",
  ["category"]="lu",
  ["contextname"]="Gcaron",
  ["description"]="LATIN CAPITAL LETTER G WITH CARON",
  ["lccode"]=0x01E7,
  ["linebreak"]="al",
  ["shcode"]=0x0047,
  ["specials"]={ "char", 0x0047, 0x030C },
  ["unicodeslot"]=0x01E6, -- Ǧ
 },
 {
  ["adobename"]="gcaron",
  ["category"]="ll",
  ["contextname"]="gcaron",
  ["description"]="LATIN SMALL LETTER G WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["specials"]={ "char", 0x0067, 0x030C },
  ["uccode"]=0x01E6,
  ["unicodeslot"]=0x01E7, -- ǧ
 },
 {
  ["category"]="lu",
  ["contextname"]="Kcaron",
  ["description"]="LATIN CAPITAL LETTER K WITH CARON",
  ["lccode"]=0x01E9,
  ["linebreak"]="al",
  ["shcode"]=0x004B,
  ["specials"]={ "char", 0x004B, 0x030C },
  ["unicodeslot"]=0x01E8, -- Ǩ
 },
 {
  ["category"]="ll",
  ["contextname"]="kcaron",
  ["description"]="LATIN SMALL LETTER K WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x006B,
  ["specials"]={ "char", 0x006B, 0x030C },
  ["uccode"]=0x01E8,
  ["unicodeslot"]=0x01E9, -- ǩ
 },
 {
  ["category"]="lu",
  ["contextname"]="Oogonek",
  ["description"]="LATIN CAPITAL LETTER O WITH OGONEK",
  ["lccode"]=0x01EB,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0328 },
  ["unicodeslot"]=0x01EA, -- Ǫ
 },
 {
  ["category"]="ll",
  ["contextname"]="oogonek",
  ["description"]="LATIN SMALL LETTER O WITH OGONEK",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0328 },
  ["uccode"]=0x01EA,
  ["unicodeslot"]=0x01EB, -- ǫ
 },
 {
  ["category"]="lu",
  ["contextname"]="Oogonekmacron",
  ["description"]="LATIN CAPITAL LETTER O WITH OGONEK AND MACRON",
  ["lccode"]=0x01ED,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x01EA, 0x0304 },
  ["unicodeslot"]=0x01EC, -- Ǭ
 },
 {
  ["category"]="ll",
  ["contextname"]="oogonekmacron",
  ["description"]="LATIN SMALL LETTER O WITH OGONEK AND MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x01EB, 0x0304 },
  ["uccode"]=0x01EC,
  ["unicodeslot"]=0x01ED, -- ǭ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER EZH WITH CARON",
  ["lccode"]=0x01EF,
  ["linebreak"]="al",
  ["shcode"]=0x01B7,
  ["specials"]={ "char", 0x01B7, 0x030C },
  ["unicodeslot"]=0x01EE, -- Ǯ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER EZH WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0292,
  ["specials"]={ "char", 0x0292, 0x030C },
  ["uccode"]=0x01EE,
  ["unicodeslot"]=0x01EF, -- ǯ
 },
 {
  ["category"]="ll",
  ["contextname"]="jcaron",
  ["description"]="LATIN SMALL LETTER J WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x006A,
  ["specials"]={ "char", 0x006A, 0x030C },
  ["unicodeslot"]=0x01F0, -- ǰ
 },
 {
  ["category"]="lu",
  ["contextname"]="DZligature",
  ["description"]="LATIN CAPITAL LETTER DZ",
  ["lccode"]=0x01F3,
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0044, 0x005A },
  ["uccode"]=0x01F2,
  ["unicodeslot"]=0x01F1, -- Ǳ
 },
 {
  ["category"]="lt",
  ["contextname"]="Dzligature",
  ["description"]="LATIN CAPITAL LETTER D WITH SMALL LETTER Z",
  ["lccode"]=0x01F3,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["specials"]={ "compat", 0x0044, 0x007A },
  ["uccode"]=0x01F1,
  ["unicodeslot"]=0x01F2, -- ǲ
 },
 {
  ["category"]="ll",
  ["contextname"]="dzligature",
  ["description"]="LATIN SMALL LETTER DZ",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0064, 0x007A },
  ["uccode"]=0x01F1,
  ["unicodeslot"]=0x01F3, -- ǳ
 },
 {
  ["category"]="lu",
  ["contextname"]="Gacute",
  ["description"]="LATIN CAPITAL LETTER G WITH ACUTE",
  ["lccode"]=0x01F5,
  ["linebreak"]="al",
  ["shcode"]=0x0047,
  ["specials"]={ "char", 0x0047, 0x0301 },
  ["unicodeslot"]=0x01F4, -- Ǵ
 },
 {
  ["category"]="ll",
  ["contextname"]="gacute",
  ["description"]="LATIN SMALL LETTER G WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["specials"]={ "char", 0x0067, 0x0301 },
  ["uccode"]=0x01F4,
  ["unicodeslot"]=0x01F5, -- ǵ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER HWAIR",
  ["lccode"]=0x0195,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01F6, -- Ƕ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER WYNN",
  ["lccode"]=0x01BF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x01F7, -- Ƿ
 },
 {
  ["category"]="lu",
  ["contextname"]="Ngrave",
  ["description"]="LATIN CAPITAL LETTER N WITH GRAVE",
  ["lccode"]=0x01F9,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["specials"]={ "char", 0x004E, 0x0300 },
  ["unicodeslot"]=0x01F8, -- Ǹ
 },
 {
  ["category"]="ll",
  ["contextname"]="ngrave",
  ["description"]="LATIN SMALL LETTER N WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["specials"]={ "char", 0x006E, 0x0300 },
  ["uccode"]=0x01F8,
  ["unicodeslot"]=0x01F9, -- ǹ
 },
 {
  ["adobename"]="Aringacute",
  ["category"]="lu",
  ["contextname"]="Aringacute",
  ["description"]="LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE",
  ["lccode"]=0x01FB,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x00C5, 0x0301 },
  ["unicodeslot"]=0x01FA, -- Ǻ
 },
 {
  ["adobename"]="aringacute",
  ["category"]="ll",
  ["contextname"]="aringacute",
  ["description"]="LATIN SMALL LETTER A WITH RING ABOVE AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x00E5, 0x0301 },
  ["uccode"]=0x01FA,
  ["unicodeslot"]=0x01FB, -- ǻ
 },
 {
  ["adobename"]="AEacute",
  ["category"]="lu",
  ["contextname"]="AEacute",
  ["description"]="LATIN CAPITAL LETTER AE WITH ACUTE",
  ["lccode"]=0x01FD,
  ["linebreak"]="al",
  ["shcode"]=0x00C6,
  ["specials"]={ "char", 0x00C6, 0x0301 },
  ["unicodeslot"]=0x01FC, -- Ǽ
 },
 {
  ["adobename"]="aeacute",
  ["category"]="ll",
  ["contextname"]="aeacute",
  ["description"]="LATIN SMALL LETTER AE WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x00E6,
  ["specials"]={ "char", 0x00E6, 0x0301 },
  ["uccode"]=0x01FC,
  ["unicodeslot"]=0x01FD, -- ǽ
 },
 {
  ["adobename"]="Oslashacute",
  ["category"]="lu",
  ["contextname"]="Ostrokeacute",
  ["description"]="LATIN CAPITAL LETTER O WITH STROKE AND ACUTE",
  ["lccode"]=0x01FF,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x00D8, 0x0301 },
  ["unicodeslot"]=0x01FE, -- Ǿ
 },
 {
  ["adobename"]="oslashacute",
  ["category"]="ll",
  ["contextname"]="ostrokeacute",
  ["description"]="LATIN SMALL LETTER O WITH STROKE AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x00F8, 0x0301 },
  ["uccode"]=0x01FE,
  ["unicodeslot"]=0x01FF, -- ǿ
 },
 {
  ["category"]="lu",
  ["contextname"]="Adoublegrave",
  ["description"]="LATIN CAPITAL LETTER A WITH DOUBLE GRAVE",
  ["lccode"]=0x0201,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x030F },
  ["unicodeslot"]=0x0200, -- Ȁ
 },
 {
  ["category"]="ll",
  ["contextname"]="adoublegrave",
  ["description"]="LATIN SMALL LETTER A WITH DOUBLE GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x030F },
  ["uccode"]=0x0200,
  ["unicodeslot"]=0x0201, -- ȁ
 },
 {
  ["category"]="lu",
  ["contextname"]="Ainvertedbreve",
  ["description"]="LATIN CAPITAL LETTER A WITH INVERTED BREVE",
  ["lccode"]=0x0203,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0311 },
  ["unicodeslot"]=0x0202, -- Ȃ
 },
 {
  ["category"]="ll",
  ["contextname"]="ainvertedbreve",
  ["description"]="LATIN SMALL LETTER A WITH INVERTED BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0311 },
  ["uccode"]=0x0202,
  ["unicodeslot"]=0x0203, -- ȃ
 },
 {
  ["category"]="lu",
  ["contextname"]="Edoublegrave",
  ["description"]="LATIN CAPITAL LETTER E WITH DOUBLE GRAVE",
  ["lccode"]=0x0205,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x030F },
  ["unicodeslot"]=0x0204, -- Ȅ
 },
 {
  ["category"]="ll",
  ["contextname"]="edoublegrave",
  ["description"]="LATIN SMALL LETTER E WITH DOUBLE GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x030F },
  ["uccode"]=0x0204,
  ["unicodeslot"]=0x0205, -- ȅ
 },
 {
  ["category"]="lu",
  ["contextname"]="Einvertedbreve",
  ["description"]="LATIN CAPITAL LETTER E WITH INVERTED BREVE",
  ["lccode"]=0x0207,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0311 },
  ["unicodeslot"]=0x0206, -- Ȇ
 },
 {
  ["category"]="ll",
  ["contextname"]="einvertedbreve",
  ["description"]="LATIN SMALL LETTER E WITH INVERTED BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0311 },
  ["uccode"]=0x0206,
  ["unicodeslot"]=0x0207, -- ȇ
 },
 {
  ["category"]="lu",
  ["contextname"]="Idoublegrave",
  ["description"]="LATIN CAPITAL LETTER I WITH DOUBLE GRAVE",
  ["lccode"]=0x0209,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x030F },
  ["unicodeslot"]=0x0208, -- Ȉ
 },
 {
  ["category"]="ll",
  ["contextname"]="idoublegrave",
  ["description"]="LATIN SMALL LETTER I WITH DOUBLE GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x030F },
  ["uccode"]=0x0208,
  ["unicodeslot"]=0x0209, -- ȉ
 },
 {
  ["category"]="lu",
  ["contextname"]="Iinvertedbreve",
  ["description"]="LATIN CAPITAL LETTER I WITH INVERTED BREVE",
  ["lccode"]=0x020B,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0311 },
  ["unicodeslot"]=0x020A, -- Ȋ
 },
 {
  ["category"]="ll",
  ["contextname"]="iinvertedbreve",
  ["description"]="LATIN SMALL LETTER I WITH INVERTED BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0311 },
  ["uccode"]=0x020A,
  ["unicodeslot"]=0x020B, -- ȋ
 },
 {
  ["category"]="lu",
  ["contextname"]="Odoublegrave",
  ["description"]="LATIN CAPITAL LETTER O WITH DOUBLE GRAVE",
  ["lccode"]=0x020D,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x030F },
  ["unicodeslot"]=0x020C, -- Ȍ
 },
 {
  ["category"]="ll",
  ["contextname"]="odoublegrave",
  ["description"]="LATIN SMALL LETTER O WITH DOUBLE GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x030F },
  ["uccode"]=0x020C,
  ["unicodeslot"]=0x020D, -- ȍ
 },
 {
  ["category"]="lu",
  ["contextname"]="Oinvertedbreve",
  ["description"]="LATIN CAPITAL LETTER O WITH INVERTED BREVE",
  ["lccode"]=0x020F,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0311 },
  ["unicodeslot"]=0x020E, -- Ȏ
 },
 {
  ["category"]="ll",
  ["contextname"]="oinvertedbreve",
  ["description"]="LATIN SMALL LETTER O WITH INVERTED BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0311 },
  ["uccode"]=0x020E,
  ["unicodeslot"]=0x020F, -- ȏ
 },
 {
  ["category"]="lu",
  ["contextname"]="Rdoublegrave",
  ["description"]="LATIN CAPITAL LETTER R WITH DOUBLE GRAVE",
  ["lccode"]=0x0211,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["specials"]={ "char", 0x0052, 0x030F },
  ["unicodeslot"]=0x0210, -- Ȑ
 },
 {
  ["category"]="ll",
  ["contextname"]="rdoublegrave",
  ["description"]="LATIN SMALL LETTER R WITH DOUBLE GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["specials"]={ "char", 0x0072, 0x030F },
  ["uccode"]=0x0210,
  ["unicodeslot"]=0x0211, -- ȑ
 },
 {
  ["category"]="lu",
  ["contextname"]="Rinvertedbreve",
  ["description"]="LATIN CAPITAL LETTER R WITH INVERTED BREVE",
  ["lccode"]=0x0213,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["specials"]={ "char", 0x0052, 0x0311 },
  ["unicodeslot"]=0x0212, -- Ȓ
 },
 {
  ["category"]="ll",
  ["contextname"]="rinvertedbreve",
  ["description"]="LATIN SMALL LETTER R WITH INVERTED BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["specials"]={ "char", 0x0072, 0x0311 },
  ["uccode"]=0x0212,
  ["unicodeslot"]=0x0213, -- ȓ
 },
 {
  ["category"]="lu",
  ["contextname"]="Udoublegrave",
  ["description"]="LATIN CAPITAL LETTER U WITH DOUBLE GRAVE",
  ["lccode"]=0x0215,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x030F },
  ["unicodeslot"]=0x0214, -- Ȕ
 },
 {
  ["category"]="ll",
  ["contextname"]="udoublegrave",
  ["description"]="LATIN SMALL LETTER U WITH DOUBLE GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x030F },
  ["uccode"]=0x0214,
  ["unicodeslot"]=0x0215, -- ȕ
 },
 {
  ["category"]="lu",
  ["contextname"]="Uinvertedbreve",
  ["description"]="LATIN CAPITAL LETTER U WITH INVERTED BREVE",
  ["lccode"]=0x0217,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0311 },
  ["unicodeslot"]=0x0216, -- Ȗ
 },
 {
  ["category"]="ll",
  ["contextname"]="uinvertedbreve",
  ["description"]="LATIN SMALL LETTER U WITH INVERTED BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0311 },
  ["uccode"]=0x0216,
  ["unicodeslot"]=0x0217, -- ȗ
 },
 {
  ["adobename"]="Scommaaccent",
  ["category"]="lu",
  ["contextname"]="Scommaaccent",
  ["description"]="LATIN CAPITAL LETTER S WITH COMMA BELOW",
  ["lccode"]=0x0219,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x0053, 0x0326 },
  ["unicodeslot"]=0x0218, -- Ș
 },
 {
  ["adobename"]="scommaaccent",
  ["category"]="ll",
  ["contextname"]="scommaaccent",
  ["description"]="LATIN SMALL LETTER S WITH COMMA BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x0073, 0x0326 },
  ["uccode"]=0x0218,
  ["unicodeslot"]=0x0219, -- ș
 },
 {
  ["category"]="lu",
  ["contextname"]="Tcommaaccent",
  ["description"]="LATIN CAPITAL LETTER T WITH COMMA BELOW",
  ["lccode"]=0x021B,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["specials"]={ "char", 0x0054, 0x0326 },
  ["unicodeslot"]=0x021A, -- Ț
 },
 {
  ["category"]="ll",
  ["contextname"]="tcommaaccent",
  ["description"]="LATIN SMALL LETTER T WITH COMMA BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["specials"]={ "char", 0x0074, 0x0326 },
  ["uccode"]=0x021A,
  ["unicodeslot"]=0x021B, -- ț
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER YOGH",
  ["lccode"]=0x021D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x021C, -- Ȝ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER YOGH",
  ["linebreak"]="al",
  ["uccode"]=0x021C,
  ["unicodeslot"]=0x021D, -- ȝ
 },
 {
  ["category"]="lu",
  ["contextname"]="Hcaron",
  ["description"]="LATIN CAPITAL LETTER H WITH CARON",
  ["lccode"]=0x021F,
  ["linebreak"]="al",
  ["shcode"]=0x0048,
  ["specials"]={ "char", 0x0048, 0x030C },
  ["unicodeslot"]=0x021E, -- Ȟ
 },
 {
  ["category"]="ll",
  ["contextname"]="hcaron",
  ["description"]="LATIN SMALL LETTER H WITH CARON",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["specials"]={ "char", 0x0068, 0x030C },
  ["uccode"]=0x021E,
  ["unicodeslot"]=0x021F, -- ȟ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER N WITH LONG RIGHT LEG",
  ["lccode"]=0x019E,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["unicodeslot"]=0x0220, -- Ƞ
 },
 {
  ["category"]="ll",
  ["contextname"]="dcurl",
  ["description"]="LATIN SMALL LETTER D WITH CURL",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["unicodeslot"]=0x0221, -- ȡ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER OU",
  ["lccode"]=0x0223,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0222, -- Ȣ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER OU",
  ["linebreak"]="al",
  ["uccode"]=0x0222,
  ["unicodeslot"]=0x0223, -- ȣ
 },
 {
  ["category"]="lu",
  ["contextname"]="Zhook",
  ["description"]="LATIN CAPITAL LETTER Z WITH HOOK",
  ["lccode"]=0x0225,
  ["linebreak"]="al",
  ["shcode"]=0x005A,
  ["unicodeslot"]=0x0224, -- Ȥ
 },
 {
  ["category"]="ll",
  ["contextname"]="zhook",
  ["description"]="LATIN SMALL LETTER Z WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["uccode"]=0x0224,
  ["unicodeslot"]=0x0225, -- ȥ
 },
 {
  ["category"]="lu",
  ["contextname"]="Adotaccent",
  ["description"]="LATIN CAPITAL LETTER A WITH DOT ABOVE",
  ["lccode"]=0x0227,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0307 },
  ["unicodeslot"]=0x0226, -- Ȧ
 },
 {
  ["category"]="ll",
  ["contextname"]="adotaccent",
  ["description"]="LATIN SMALL LETTER A WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0307 },
  ["uccode"]=0x0226,
  ["unicodeslot"]=0x0227, -- ȧ
 },
 {
  ["category"]="lu",
  ["contextname"]="Ecedilla",
  ["description"]="LATIN CAPITAL LETTER E WITH CEDILLA",
  ["lccode"]=0x0229,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0327 },
  ["unicodeslot"]=0x0228, -- Ȩ
 },
 {
  ["category"]="ll",
  ["contextname"]="ecedilla",
  ["description"]="LATIN SMALL LETTER E WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0327 },
  ["uccode"]=0x0228,
  ["unicodeslot"]=0x0229, -- ȩ
 },
 {
  ["category"]="lu",
  ["contextname"]="Odiaeresismacron",
  ["description"]="LATIN CAPITAL LETTER O WITH DIAERESIS AND MACRON",
  ["lccode"]=0x022B,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x00D6, 0x0304 },
  ["unicodeslot"]=0x022A, -- Ȫ
 },
 {
  ["category"]="ll",
  ["contextname"]="odiaeresismacron",
  ["description"]="LATIN SMALL LETTER O WITH DIAERESIS AND MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x00F6, 0x0304 },
  ["uccode"]=0x022A,
  ["unicodeslot"]=0x022B, -- ȫ
 },
 {
  ["category"]="lu",
  ["contextname"]="Otildemacron",
  ["description"]="LATIN CAPITAL LETTER O WITH TILDE AND MACRON",
  ["lccode"]=0x022D,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x00D5, 0x0304 },
  ["unicodeslot"]=0x022C, -- Ȭ
 },
 {
  ["category"]="ll",
  ["contextname"]="otildemacron",
  ["description"]="LATIN SMALL LETTER O WITH TILDE AND MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x00F5, 0x0304 },
  ["uccode"]=0x022C,
  ["unicodeslot"]=0x022D, -- ȭ
 },
 {
  ["category"]="lu",
  ["contextname"]="Odotaccent",
  ["description"]="LATIN CAPITAL LETTER O WITH DOT ABOVE",
  ["lccode"]=0x022F,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0307 },
  ["unicodeslot"]=0x022E, -- Ȯ
 },
 {
  ["category"]="ll",
  ["contextname"]="odotaccent",
  ["description"]="LATIN SMALL LETTER O WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0307 },
  ["uccode"]=0x022E,
  ["unicodeslot"]=0x022F, -- ȯ
 },
 {
  ["category"]="lu",
  ["contextname"]="Odotaccentmacron",
  ["description"]="LATIN CAPITAL LETTER O WITH DOT ABOVE AND MACRON",
  ["lccode"]=0x0231,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x022E, 0x0304 },
  ["unicodeslot"]=0x0230, -- Ȱ
 },
 {
  ["category"]="ll",
  ["contextname"]="odotaccentmacron",
  ["description"]="LATIN SMALL LETTER O WITH DOT ABOVE AND MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x022F, 0x0304 },
  ["uccode"]=0x0230,
  ["unicodeslot"]=0x0231, -- ȱ
 },
 {
  ["category"]="lu",
  ["contextname"]="Ymacron",
  ["description"]="LATIN CAPITAL LETTER Y WITH MACRON",
  ["lccode"]=0x0233,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["specials"]={ "char", 0x0059, 0x0304 },
  ["unicodeslot"]=0x0232, -- Ȳ
 },
 {
  ["category"]="ll",
  ["contextname"]="ymacron",
  ["description"]="LATIN SMALL LETTER Y WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x0304 },
  ["uccode"]=0x0232,
  ["unicodeslot"]=0x0233, -- ȳ
 },
 {
  ["category"]="ll",
  ["contextname"]="lcurl",
  ["description"]="LATIN SMALL LETTER L WITH CURL",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["unicodeslot"]=0x0234, -- ȴ
 },
 {
  ["category"]="ll",
  ["contextname"]="ncurl",
  ["description"]="LATIN SMALL LETTER N WITH CURL",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["unicodeslot"]=0x0235, -- ȵ
 },
 {
  ["category"]="ll",
  ["contextname"]="tcurl",
  ["description"]="LATIN SMALL LETTER T WITH CURL",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["unicodeslot"]=0x0236, -- ȶ
 },
 {
  ["category"]="ll",
  ["contextname"]="dotlessj",
  ["description"]="LATIN SMALL LETTER DOTLESS J",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0237, -- ȷ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER DB DIGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0238, -- ȸ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER QP DIGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0239, -- ȹ
 },
 {
  ["category"]="lu",
  ["contextname"]="Astroke",
  ["description"]="LATIN CAPITAL LETTER A WITH STROKE",
  ["lccode"]=0x2C65,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["unicodeslot"]=0x023A, -- Ⱥ
 },
 {
  ["category"]="lu",
  ["contextname"]="Cstroke",
  ["description"]="LATIN CAPITAL LETTER C WITH STROKE",
  ["lccode"]=0x023C,
  ["linebreak"]="al",
  ["shcode"]=0x0043,
  ["unicodeslot"]=0x023B, -- Ȼ
 },
 {
  ["category"]="ll",
  ["contextname"]="cstroke",
  ["description"]="LATIN SMALL LETTER C WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0063,
  ["uccode"]=0x023B,
  ["unicodeslot"]=0x023C, -- ȼ
 },
 {
  ["category"]="lu",
  ["contextname"]="Lbar",
  ["description"]="LATIN CAPITAL LETTER L WITH BAR",
  ["lccode"]=0x019A,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["unicodeslot"]=0x023D, -- Ƚ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER T WITH DIAGONAL STROKE",
  ["lccode"]=0x2C66,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["unicodeslot"]=0x023E, -- Ⱦ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER S WITH SWASH TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["unicodeslot"]=0x023F, -- ȿ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Z WITH SWASH TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["unicodeslot"]=0x0240, -- ɀ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER GLOTTAL STOP",
  ["lccode"]=0x0242,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0241, -- Ɂ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER GLOTTAL STOP",
  ["linebreak"]="al",
  ["uccode"]=0x0241,
  ["unicodeslot"]=0x0242, -- ɂ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER B WITH STROKE",
  ["lccode"]=0x0180,
  ["linebreak"]="al",
  ["shcode"]=0x0042,
  ["unicodeslot"]=0x0243, -- Ƀ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER U BAR",
  ["lccode"]=0x0289,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0244, -- Ʉ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER TURNED V",
  ["lccode"]=0x028C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0245, -- Ʌ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER E WITH STROKE",
  ["lccode"]=0x0247,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["unicodeslot"]=0x0246, -- Ɇ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER E WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["uccode"]=0x0246,
  ["unicodeslot"]=0x0247, -- ɇ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER J WITH STROKE",
  ["lccode"]=0x0249,
  ["linebreak"]="al",
  ["shcode"]=0x004A,
  ["unicodeslot"]=0x0248, -- Ɉ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER J WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x006A,
  ["uccode"]=0x0248,
  ["unicodeslot"]=0x0249, -- ɉ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER SMALL Q WITH HOOK TAIL",
  ["lccode"]=0x024B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x024A, -- Ɋ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Q WITH HOOK TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x0071,
  ["uccode"]=0x024A,
  ["unicodeslot"]=0x024B, -- ɋ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER R WITH STROKE",
  ["lccode"]=0x024D,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["unicodeslot"]=0x024C, -- Ɍ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["uccode"]=0x024C,
  ["unicodeslot"]=0x024D, -- ɍ
 },
 {
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER Y WITH STROKE",
  ["lccode"]=0x024F,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["unicodeslot"]=0x024E, -- Ɏ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Y WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["uccode"]=0x024E,
  ["unicodeslot"]=0x024F, -- ɏ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0250, -- ɐ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["description"]="LATIN SMALL LETTER ALPHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0251, -- ɑ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED ALPHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0252, -- ɒ
 },
 {
  ["category"]="ll",
  ["contextname"]="bhook",
  ["description"]="LATIN SMALL LETTER B WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0062,
  ["uccode"]=0x0181,
  ["unicodeslot"]=0x0253, -- ɓ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER OPEN O",
  ["linebreak"]="al",
  ["uccode"]=0x0186,
  ["unicodeslot"]=0x0254, -- ɔ
 },
 {
  ["category"]="ll",
  ["contextname"]="ccurl",
  ["description"]="LATIN SMALL LETTER C WITH CURL",
  ["linebreak"]="al",
  ["shcode"]=0x0063,
  ["unicodeslot"]=0x0255, -- ɕ
 },
 {
  ["category"]="ll",
  ["contextname"]="dtail",
  ["description"]="LATIN SMALL LETTER D WITH TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["uccode"]=0x0189,
  ["unicodeslot"]=0x0256, -- ɖ
 },
 {
  ["category"]="ll",
  ["contextname"]="dhook",
  ["description"]="LATIN SMALL LETTER D WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["uccode"]=0x018A,
  ["unicodeslot"]=0x0257, -- ɗ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER REVERSED E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0258, -- ɘ
 },
 {
  ["category"]="ll",
  ["contextname"]="schwa",
  ["description"]="LATIN SMALL LETTER SCHWA",
  ["linebreak"]="al",
  ["uccode"]=0x018F,
  ["unicodeslot"]=0x0259, -- ə
 },
 {
  ["category"]="ll",
  ["contextname"]="schwahook",
  ["description"]="LATIN SMALL LETTER SCHWA WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0259,
  ["unicodeslot"]=0x025A, -- ɚ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER OPEN E",
  ["linebreak"]="al",
  ["uccode"]=0x0190,
  ["unicodeslot"]=0x025B, -- ɛ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER REVERSED OPEN E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x025C, -- ɜ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER REVERSED OPEN E WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x025D, -- ɝ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER CLOSED REVERSED OPEN E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x025E, -- ɞ
 },
 {
  ["category"]="ll",
  ["contextname"]="dotlessjstroke",
  ["description"]="LATIN SMALL LETTER DOTLESS J WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x025F, -- ɟ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER G WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["uccode"]=0x0193,
  ["unicodeslot"]=0x0260, -- ɠ
 },
 {
  ["category"]="ll",
  ["cjkwd"]="a",
  ["description"]="LATIN SMALL LETTER SCRIPT G",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0261, -- ɡ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL G",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0262, -- ɢ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER GAMMA",
  ["linebreak"]="al",
  ["uccode"]=0x0194,
  ["unicodeslot"]=0x0263, -- ɣ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER RAMS HORN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0264, -- ɤ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED H",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0265, -- ɥ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER H WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["unicodeslot"]=0x0266, -- ɦ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER HENG WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0267, -- ɧ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER I WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["uccode"]=0x0197,
  ["unicodeslot"]=0x0268, -- ɨ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER IOTA",
  ["linebreak"]="al",
  ["uccode"]=0x0196,
  ["unicodeslot"]=0x0269, -- ɩ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x026A, -- ɪ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER L WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["uccode"]=0x2C62,
  ["unicodeslot"]=0x026B, -- ɫ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER L WITH BELT",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["unicodeslot"]=0x026C, -- ɬ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER L WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["unicodeslot"]=0x026D, -- ɭ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER LEZH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x026E, -- ɮ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED M",
  ["linebreak"]="al",
  ["uccode"]=0x019C,
  ["unicodeslot"]=0x026F, -- ɯ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED M WITH LONG LEG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0270, -- ɰ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER M WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x006D,
  ["unicodeslot"]=0x0271, -- ɱ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER N WITH LEFT HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["uccode"]=0x019D,
  ["unicodeslot"]=0x0272, -- ɲ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER N WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["unicodeslot"]=0x0273, -- ɳ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL N",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0274, -- ɴ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER BARRED O",
  ["linebreak"]="al",
  ["uccode"]=0x019F,
  ["unicodeslot"]=0x0275, -- ɵ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL OE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0276, -- ɶ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER CLOSED OMEGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0277, -- ɷ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER PHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0278, -- ɸ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0279, -- ɹ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED R WITH LONG LEG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x027A, -- ɺ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED R WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x027B, -- ɻ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH LONG LEG",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["unicodeslot"]=0x027C, -- ɼ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["uccode"]=0x2C64,
  ["unicodeslot"]=0x027D, -- ɽ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH FISHHOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["unicodeslot"]=0x027E, -- ɾ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER REVERSED R WITH FISHHOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x027F, -- ɿ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL R",
  ["linebreak"]="al",
  ["uccode"]=0x01A6,
  ["unicodeslot"]=0x0280, -- ʀ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL INVERTED R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0281, -- ʁ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER S WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["unicodeslot"]=0x0282, -- ʂ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER ESH",
  ["linebreak"]="al",
  ["uccode"]=0x01A9,
  ["unicodeslot"]=0x0283, -- ʃ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER DOTLESS J WITH STROKE AND HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0284, -- ʄ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER SQUAT REVERSED ESH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0285, -- ʅ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER ESH WITH CURL",
  ["linebreak"]="al",
  ["shcode"]=0x0283,
  ["unicodeslot"]=0x0286, -- ʆ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED T",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0287, -- ʇ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER T WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["uccode"]=0x01AE,
  ["unicodeslot"]=0x0288, -- ʈ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER U BAR",
  ["linebreak"]="al",
  ["uccode"]=0x0244,
  ["unicodeslot"]=0x0289, -- ʉ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER UPSILON",
  ["linebreak"]="al",
  ["uccode"]=0x01B1,
  ["unicodeslot"]=0x028A, -- ʊ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER V WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0076,
  ["uccode"]=0x01B2,
  ["unicodeslot"]=0x028B, -- ʋ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED V",
  ["linebreak"]="al",
  ["uccode"]=0x0245,
  ["unicodeslot"]=0x028C, -- ʌ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED W",
  ["linebreak"]="al",
  ["unicodeslot"]=0x028D, -- ʍ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED Y",
  ["linebreak"]="al",
  ["unicodeslot"]=0x028E, -- ʎ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL Y",
  ["linebreak"]="al",
  ["unicodeslot"]=0x028F, -- ʏ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Z WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["unicodeslot"]=0x0290, -- ʐ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Z WITH CURL",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["unicodeslot"]=0x0291, -- ʑ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER EZH",
  ["linebreak"]="al",
  ["uccode"]=0x01B7,
  ["unicodeslot"]=0x0292, -- ʒ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER EZH WITH CURL",
  ["linebreak"]="al",
  ["shcode"]=0x0292,
  ["unicodeslot"]=0x0293, -- ʓ
 },
 {
  ["category"]="lo",
  ["description"]="LATIN LETTER GLOTTAL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0294, -- ʔ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER PHARYNGEAL VOICED FRICATIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0295, -- ʕ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER INVERTED GLOTTAL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0296, -- ʖ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER STRETCHED C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0297, -- ʗ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER BILABIAL CLICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0298, -- ʘ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0299, -- ʙ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER CLOSED OPEN E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x029A, -- ʚ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL G WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x029B, -- ʛ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL H",
  ["linebreak"]="al",
  ["unicodeslot"]=0x029C, -- ʜ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER J WITH CROSSED-TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x006A,
  ["unicodeslot"]=0x029D, -- ʝ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED K",
  ["linebreak"]="al",
  ["unicodeslot"]=0x029E, -- ʞ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x029F, -- ʟ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Q WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0071,
  ["unicodeslot"]=0x02A0, -- ʠ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER GLOTTAL STOP WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02A1, -- ʡ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER REVERSED GLOTTAL STOP WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02A2, -- ʢ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER DZ DIGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02A3, -- ʣ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER DEZH DIGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02A4, -- ʤ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER DZ DIGRAPH WITH CURL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02A5, -- ʥ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TS DIGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02A6, -- ʦ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TESH DIGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02A7, -- ʧ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TC DIGRAPH WITH CURL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02A8, -- ʨ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER FENG DIGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02A9, -- ʩ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER LS DIGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02AA, -- ʪ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER LZ DIGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02AB, -- ʫ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER BILABIAL PERCUSSIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02AC, -- ʬ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN LETTER BIDENTAL PERCUSSIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02AD, -- ʭ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED H WITH FISHHOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02AE, -- ʮ
 },
 {
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED H WITH FISHHOOK AND TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02AF, -- ʯ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0068 },
  ["unicodeslot"]=0x02B0, -- ʰ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL H WITH HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0266 },
  ["unicodeslot"]=0x02B1, -- ʱ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x006A },
  ["unicodeslot"]=0x02B2, -- ʲ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0072 },
  ["unicodeslot"]=0x02B3, -- ʳ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED R",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0279 },
  ["unicodeslot"]=0x02B4, -- ʴ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED R WITH HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x027B },
  ["unicodeslot"]=0x02B5, -- ʵ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL CAPITAL INVERTED R",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0281 },
  ["unicodeslot"]=0x02B6, -- ʶ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0077 },
  ["unicodeslot"]=0x02B7, -- ʷ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0079 },
  ["unicodeslot"]=0x02B8, -- ʸ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER PRIME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02B9, -- ʹ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER DOUBLE PRIME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02BA, -- ʺ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER TURNED COMMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02BB, -- ʻ
 },
 {
  ["adobename"]="afii57929",
  ["category"]="lm",
  ["description"]="MODIFIER LETTER APOSTROPHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02BC, -- ʼ
 },
 {
  ["adobename"]="afii64937",
  ["category"]="lm",
  ["description"]="MODIFIER LETTER REVERSED COMMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02BD, -- ʽ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER RIGHT HALF RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02BE, -- ʾ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER LEFT HALF RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02BF, -- ʿ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER GLOTTAL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02C0, -- ˀ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER REVERSED GLOTTAL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02C1, -- ˁ
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LEFT ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02C2, -- ˂
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER RIGHT ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02C3, -- ˃
 },
 {
  ["category"]="sk",
  ["cjkwd"]="a",
  ["description"]="MODIFIER LETTER UP ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02C4, -- ˄
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER DOWN ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02C5, -- ˅
 },
 {
  ["adobename"]="circumflex",
  ["category"]="lm",
  ["contextname"]="textcircumflex",
  ["description"]="MODIFIER LETTER CIRCUMFLEX ACCENT",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0302 }, -- added by hh
  ["unicodeslot"]=0x02C6, -- ˆ
 },
 {
  ["adobename"]="caron",
  ["category"]="lm",
  ["cjkwd"]="a",
  ["contextname"]="textcaron",
  ["description"]="CARON",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0020, 0x030C }, -- added by hh
  ["unicodeslot"]=0x02C7, -- ˇ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER VERTICAL LINE",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x02C8, -- ˈ
 },
 {
  ["category"]="lm",
  ["cjkwd"]="a",
  ["description"]="MODIFIER LETTER MACRON",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x02C9, -- ˉ
 },
 {
  ["category"]="lm",
  ["cjkwd"]="a",
  ["description"]="MODIFIER LETTER ACUTE ACCENT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x02CA, -- ˊ
 },
 {
  ["category"]="lm",
  ["cjkwd"]="a",
  ["description"]="MODIFIER LETTER GRAVE ACCENT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x02CB, -- ˋ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER LOW VERTICAL LINE",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x02CC, -- ˌ
 },
 {
  ["category"]="lm",
  ["cjkwd"]="a",
  ["description"]="MODIFIER LETTER LOW MACRON",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x02CD, -- ˍ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER LOW GRAVE ACCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02CE, -- ˎ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER LOW ACUTE ACCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02CF, -- ˏ
 },
 {
  ["category"]="lm",
  ["cjkwd"]="a",
  ["description"]="MODIFIER LETTER TRIANGULAR COLON",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x02D0, -- ː
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER HALF TRIANGULAR COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02D1, -- ˑ
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CENTRED RIGHT HALF RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02D2, -- ˒
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CENTRED LEFT HALF RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02D3, -- ˓
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER UP TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02D4, -- ˔
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER DOWN TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02D5, -- ˕
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER PLUS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02D6, -- ˖
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER MINUS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02D7, -- ˗
 },
 {
  ["adobename"]="breve",
  ["category"]="sk",
  ["cjkwd"]="a",
  ["contextname"]="textbreve",
  ["description"]="BREVE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0020, 0x0306 },
  ["unicodeslot"]=0x02D8, -- ˘
 },
 {
  ["adobename"]="dotaccent",
  ["category"]="sk",
  ["cjkwd"]="a",
  ["contextname"]="textdotaccent",
  ["description"]="DOT ABOVE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0020, 0x0307 },
  ["unicodeslot"]=0x02D9, -- ˙
 },
 {
  ["adobename"]="ring",
  ["category"]="sk",
  ["cjkwd"]="a",
  ["contextname"]="textring",
  ["description"]="RING ABOVE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0020, 0x030A },
  ["unicodeslot"]=0x02DA, -- ˚
 },
 {
  ["adobename"]="ogonek",
  ["category"]="sk",
  ["cjkwd"]="a",
  ["contextname"]="textogonek",
  ["description"]="OGONEK",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0020, 0x0328 },
  ["unicodeslot"]=0x02DB, -- ˛
 },
 {
  ["adobename"]="tilde",
  ["category"]="sk",
  ["contextname"]="texttilde",
  ["description"]="SMALL TILDE",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0303 },
  ["unicodeslot"]=0x02DC, -- ˜
 },
 {
  ["adobename"]="hungarumlaut",
  ["category"]="sk",
  ["cjkwd"]="a",
  ["contextname"]="texthungarumlaut",
  ["description"]="DOUBLE ACUTE ACCENT",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0020, 0x030B },
  ["unicodeslot"]=0x02DD, -- ˝
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER RHOTIC HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02DE, -- ˞
 },
 {
  ["category"]="sk",
  ["cjkwd"]="a",
  ["description"]="MODIFIER LETTER CROSS ACCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02DF, -- ˟
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0263 },
  ["unicodeslot"]=0x02E0, -- ˠ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x006C },
  ["unicodeslot"]=0x02E1, -- ˡ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0073 },
  ["unicodeslot"]=0x02E2, -- ˢ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0078 },
  ["unicodeslot"]=0x02E3, -- ˣ
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL REVERSED GLOTTAL STOP",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0295 },
  ["unicodeslot"]=0x02E4, -- ˤ
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER EXTRA-HIGH TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02E5, -- ˥
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER HIGH TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02E6, -- ˦
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER MID TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02E7, -- ˧
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02E8, -- ˨
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER EXTRA-LOW TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02E9, -- ˩
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER YIN DEPARTING TONE MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02EA, -- ˪
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER YANG DEPARTING TONE MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02EB, -- ˫
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER VOICING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02EC, -- ˬ
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER UNASPIRATED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02ED, -- ˭
 },
 {
  ["category"]="lm",
  ["description"]="MODIFIER LETTER DOUBLE APOSTROPHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02EE, -- ˮ
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW DOWN ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02EF, -- ˯
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW UP ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F0, -- ˰
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW LEFT ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F1, -- ˱
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW RIGHT ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F2, -- ˲
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F3, -- ˳
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER MIDDLE GRAVE ACCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F4, -- ˴
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER MIDDLE DOUBLE GRAVE ACCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F5, -- ˵
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER MIDDLE DOUBLE ACUTE ACCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F6, -- ˶
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW TILDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F7, -- ˷
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER RAISED COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F8, -- ˸
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER BEGIN HIGH TONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02F9, -- ˹
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER END HIGH TONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02FA, -- ˺
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER BEGIN LOW TONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02FB, -- ˻
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER END LOW TONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02FC, -- ˼
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER SHELF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02FD, -- ˽
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER OPEN SHELF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02FE, -- ˾
 },
 {
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW LEFT ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x02FF, -- ˿
 },
 {
  ["adobename"]="gravecomb",
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING GRAVE ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0300, -- ̀
 },
 {
  ["adobename"]="acutecomb",
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING ACUTE ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0301, -- ́
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING CIRCUMFLEX ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0302, -- ̂
 },
 {
  ["adobename"]="tildecomb",
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING TILDE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0303, -- ̃
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING MACRON",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0304, -- ̄
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING OVERLINE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0305, -- ̅
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING BREVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0306, -- ̆
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOT ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0307, -- ̇
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DIAERESIS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0308, -- ̈
 },
 {
  ["adobename"]="hookabovecomb",
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING HOOK ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0309, -- ̉
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING RING ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x030A, -- ̊
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE ACUTE ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x030B, -- ̋
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING CARON",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x030C, -- ̌
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING VERTICAL LINE ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x030D, -- ̍
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE VERTICAL LINE ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x030E, -- ̎
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE GRAVE ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x030F, -- ̏
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING CANDRABINDU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0310, -- ̐
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING INVERTED BREVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0311, -- ̑
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING TURNED COMMA ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0312, -- ̒
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING COMMA ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0313, -- ̓
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING REVERSED COMMA ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0314, -- ̔
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING COMMA ABOVE RIGHT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0315, -- ̕
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING GRAVE ACCENT BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0316, -- ̖
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING ACUTE ACCENT BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0317, -- ̗
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LEFT TACK BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0318, -- ̘
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING RIGHT TACK BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0319, -- ̙
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LEFT ANGLE ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x031A, -- ̚
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING HORN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x031B, -- ̛
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LEFT HALF RING BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x031C, -- ̜
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING UP TACK BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x031D, -- ̝
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOWN TACK BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x031E, -- ̞
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING PLUS SIGN BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x031F, -- ̟
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING MINUS SIGN BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0320, -- ̠
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING PALATALIZED HOOK BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0321, -- ̡
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING RETROFLEX HOOK BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0322, -- ̢
 },
 {
  ["adobename"]="dotbelowcomb",
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOT BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0323, -- ̣
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DIAERESIS BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0324, -- ̤
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING RING BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0325, -- ̥
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING COMMA BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0326, -- ̦
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING CEDILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0327, -- ̧
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING OGONEK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0328, -- ̨
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING VERTICAL LINE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0329, -- ̩
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING BRIDGE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x032A, -- ̪
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING INVERTED DOUBLE ARCH BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x032B, -- ̫
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING CARON BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x032C, -- ̬
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING CIRCUMFLEX ACCENT BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x032D, -- ̭
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING BREVE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x032E, -- ̮
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING INVERTED BREVE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x032F, -- ̯
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING TILDE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0330, -- ̰
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING MACRON BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0331, -- ̱
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LOW LINE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0332, -- ̲
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE LOW LINE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0333, -- ̳
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING TILDE OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0334, -- ̴
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING SHORT STROKE OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0335, -- ̵
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LONG STROKE OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0336, -- ̶
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING SHORT SOLIDUS OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0337, -- ̷
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LONG SOLIDUS OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0338, -- ̸
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING RIGHT HALF RING BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0339, -- ̹
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING INVERTED BRIDGE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x033A, -- ̺
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING SQUARE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x033B, -- ̻
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING SEAGULL BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x033C, -- ̼
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING X ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x033D, -- ̽
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING VERTICAL TILDE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x033E, -- ̾
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE OVERLINE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x033F, -- ̿
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING GRAVE TONE MARK",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0300 },
  ["unicodeslot"]=0x0340, -- ̀
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING ACUTE TONE MARK",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0301 },
  ["unicodeslot"]=0x0341, -- ́
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING GREEK PERISPOMENI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0342, -- ͂
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING GREEK KORONIS",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0313 },
  ["unicodeslot"]=0x0343, -- ̓
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING GREEK DIALYTIKA TONOS",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0308, 0x0301 },
  ["unicodeslot"]=0x0344, -- ̈́
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING GREEK YPOGEGRAMMENI",
  ["linebreak"]="cm",
  ["uccode"]=0x0399,
  ["unicodeslot"]=0x0345, -- ͅ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING BRIDGE ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0346, -- ͆
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING EQUALS SIGN BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0347, -- ͇
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE VERTICAL LINE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0348, -- ͈
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LEFT ANGLE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0349, -- ͉
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING NOT TILDE ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x034A, -- ͊
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING HOMOTHETIC ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x034B, -- ͋
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING ALMOST EQUAL TO ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x034C, -- ͌
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LEFT RIGHT ARROW BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x034D, -- ͍
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING UPWARDS ARROW BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x034E, -- ͎
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING GRAPHEME JOINER",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x034F, -- ͏
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING RIGHT ARROWHEAD ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0350, -- ͐
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LEFT HALF RING ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0351, -- ͑
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING FERMATA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0352, -- ͒
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING X BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0353, -- ͓
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LEFT ARROWHEAD BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0354, -- ͔
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING RIGHT ARROWHEAD BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0355, -- ͕
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING RIGHT ARROWHEAD AND UP ARROWHEAD BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0356, -- ͖
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING RIGHT HALF RING ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0357, -- ͗
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOT ABOVE RIGHT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0358, -- ͘
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING ASTERISK BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0359, -- ͙
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE RING BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x035A, -- ͚
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING ZIGZAG ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x035B, -- ͛
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE BREVE BELOW",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x035C, -- ͜
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE BREVE",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x035D, -- ͝
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE MACRON",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x035E, -- ͞
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE MACRON BELOW",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x035F, -- ͟
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE TILDE",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x0360, -- ͠
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE INVERTED BREVE",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x0361, -- ͡
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING DOUBLE RIGHTWARDS ARROW BELOW",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x0362, -- ͢
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0363, -- ͣ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0364, -- ͤ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0365, -- ͥ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0366, -- ͦ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0367, -- ͧ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0368, -- ͨ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0369, -- ͩ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER H",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x036A, -- ͪ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER M",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x036B, -- ͫ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x036C, -- ͬ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER T",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x036D, -- ͭ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER V",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x036E, -- ͮ
 },
 {
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="COMBINING LATIN SMALL LETTER X",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x036F, -- ͯ
 },
 [0x0374]={
  ["category"]="sk",
  ["description"]="GREEK NUMERAL SIGN",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x02B9 },
  ["unicodeslot"]=0x0374, -- ʹ
 },
 [0x0375]={
  ["category"]="sk",
  ["description"]="GREEK LOWER NUMERAL SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0375, -- ͵
 },
 [0x037A]={
  ["category"]="lm",
  ["description"]="GREEK YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0345 },
  ["unicodeslot"]=0x037A, -- ͺ
 },
 [0x037B]={
  ["category"]="ll",
  ["description"]="GREEK SMALL REVERSED LUNATE SIGMA SYMBOL",
  ["linebreak"]="al",
  ["uccode"]=0x03FD,
  ["unicodeslot"]=0x037B, -- ͻ
 },
 [0x037C]={
  ["category"]="ll",
  ["description"]="GREEK SMALL DOTTED LUNATE SIGMA SYMBOL",
  ["linebreak"]="al",
  ["uccode"]=0x03FE,
  ["unicodeslot"]=0x037C, -- ͼ
 },
 [0x037D]={
  ["category"]="ll",
  ["description"]="GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL",
  ["linebreak"]="al",
  ["uccode"]=0x03FF,
  ["unicodeslot"]=0x037D, -- ͽ
 },
 [0x037E]={
  ["category"]="po",
  ["description"]="GREEK QUESTION MARK",
  ["linebreak"]="is",
  ["specials"]={ "char", 0x003B },
  ["unicodeslot"]=0x037E, -- ;
 },
 [0x0384]={
  ["adobename"]="tonos",
  ["category"]="sk",
  ["contextname"]="greektonos",
  ["description"]="GREEK TONOS",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0301 },
  ["unicodeslot"]=0x0384, -- ΄
 },
 [0x0385]={
  ["adobename"]="dieresistonos",
  ["category"]="sk",
  ["contextname"]="greekdialytikatonos",
  ["description"]="GREEK DIALYTIKA TONOS",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x00A8, 0x0301 },
  ["unicodeslot"]=0x0385, -- ΅
 },
 [0x0386]={
  ["adobename"]="Alphatonos",
  ["category"]="lu",
  ["contextname"]="greekAlphatonos",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH TONOS",
  ["lccode"]=0x03AC,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x0391, 0x0301 },
  ["unicodeslot"]=0x0386, -- Ά
 },
 [0x0387]={
  ["adobename"]="anoteleia",
  ["category"]="po",
  ["description"]="GREEK ANO TELEIA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x00B7 },
  ["unicodeslot"]=0x0387, -- ·
 },
 [0x0388]={
  ["adobename"]="Epsilontonos",
  ["category"]="lu",
  ["contextname"]="greekEpsilontonos",
  ["description"]="GREEK CAPITAL LETTER EPSILON WITH TONOS",
  ["lccode"]=0x03AD,
  ["linebreak"]="al",
  ["shcode"]=0x0395,
  ["specials"]={ "char", 0x0395, 0x0301 },
  ["unicodeslot"]=0x0388, -- Έ
 },
 [0x0389]={
  ["adobename"]="Etatonos",
  ["category"]="lu",
  ["contextname"]="greekEtatonos",
  ["description"]="GREEK CAPITAL LETTER ETA WITH TONOS",
  ["lccode"]=0x03AE,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x0397, 0x0301 },
  ["unicodeslot"]=0x0389, -- Ή
 },
 [0x038A]={
  ["adobename"]="Iotatonos",
  ["category"]="lu",
  ["contextname"]="greekIotatonos",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH TONOS",
  ["lccode"]=0x03AF,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x0399, 0x0301 },
  ["unicodeslot"]=0x038A, -- Ί
 },
 [0x038C]={
  ["adobename"]="Omicrontonos",
  ["category"]="lu",
  ["contextname"]="greekOmicrontonos",
  ["description"]="GREEK CAPITAL LETTER OMICRON WITH TONOS",
  ["lccode"]=0x03CC,
  ["linebreak"]="al",
  ["shcode"]=0x039F,
  ["specials"]={ "char", 0x039F, 0x0301 },
  ["unicodeslot"]=0x038C, -- Ό
 },
 [0x038E]={
  ["adobename"]="Upsilontonos",
  ["category"]="lu",
  ["contextname"]="greekUpsilontonos",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH TONOS",
  ["lccode"]=0x03CD,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x03A5, 0x0301 },
  ["unicodeslot"]=0x038E, -- Ύ
 },
 [0x038F]={
  ["adobename"]="Omegatonos",
  ["category"]="lu",
  ["contextname"]="greekOmegatonos",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH TONOS",
  ["lccode"]=0x03CE,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x03A9, 0x0301 },
  ["unicodeslot"]=0x038F, -- Ώ
 },
 [0x0390]={
  ["adobename"]="iotadieresistonos",
  ["category"]="ll",
  ["contextname"]="greekiotadialytikatonos",
  ["description"]="GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03CA, 0x0301 },
  ["unicodeslot"]=0x0390, -- ΐ
 },
 [0x0391]={
  ["adobename"]="Alpha",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekAlpha",
  ["description"]="GREEK CAPITAL LETTER ALPHA",
  ["lccode"]=0x03B1,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Alpha",
  ["unicodeslot"]=0x0391, -- Α
 },
 [0x0392]={
  ["adobename"]="Beta",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekBeta",
  ["description"]="GREEK CAPITAL LETTER BETA",
  ["lccode"]=0x03B2,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Beta",
  ["unicodeslot"]=0x0392, -- Β
 },
 [0x0393]={
  ["adobename"]="Gamma",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekGamma",
  ["description"]="GREEK CAPITAL LETTER GAMMA",
  ["lccode"]=0x03B3,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Gamma",
  ["unicodeslot"]=0x0393, -- Γ
 },
 [0x0394]={
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekDelta",
  ["description"]="GREEK CAPITAL LETTER DELTA",
  ["lccode"]=0x03B4,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Delta",
  ["unicodeslot"]=0x0394, -- Δ
 },
 [0x0395]={
  ["adobename"]="Epsilon",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekEpsilon",
  ["description"]="GREEK CAPITAL LETTER EPSILON",
  ["lccode"]=0x03B5,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Epsilon",
  ["unicodeslot"]=0x0395, -- Ε
 },
 [0x0396]={
  ["adobename"]="Zeta",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekZeta",
  ["description"]="GREEK CAPITAL LETTER ZETA",
  ["lccode"]=0x03B6,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Zeta",
  ["unicodeslot"]=0x0396, -- Ζ
 },
 [0x0397]={
  ["adobename"]="Eta",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekEta",
  ["description"]="GREEK CAPITAL LETTER ETA",
  ["lccode"]=0x03B7,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Eta",
  ["unicodeslot"]=0x0397, -- Η
 },
 [0x0398]={
  ["adobename"]="Theta",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekTheta",
  ["description"]="GREEK CAPITAL LETTER THETA",
  ["lccode"]=0x03B8,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Theta",
  ["unicodeslot"]=0x0398, -- Θ
 },
 [0x0399]={
  ["adobename"]="Iota",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekIota",
  ["description"]="GREEK CAPITAL LETTER IOTA",
  ["lccode"]=0x03B9,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Iota",
  ["unicodeslot"]=0x0399, -- Ι
 },
 [0x039A]={
  ["adobename"]="Kappa",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekKappa",
  ["description"]="GREEK CAPITAL LETTER KAPPA",
  ["lccode"]=0x03BA,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Kappa",
  ["unicodeslot"]=0x039A, -- Κ
 },
 [0x039B]={
  ["adobename"]="Lambda",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekLambda",
  ["description"]="GREEK CAPITAL LETTER LAMDA",
  ["lccode"]=0x03BB,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Lambda",
  ["unicodeslot"]=0x039B, -- Λ
 },
 [0x039C]={
  ["adobename"]="Mu",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekMu",
  ["description"]="GREEK CAPITAL LETTER MU",
  ["lccode"]=0x03BC,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Mu",
  ["unicodeslot"]=0x039C, -- Μ
 },
 [0x039D]={
  ["adobename"]="Nu",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekNu",
  ["description"]="GREEK CAPITAL LETTER NU",
  ["lccode"]=0x03BD,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Nu",
  ["unicodeslot"]=0x039D, -- Ν
 },
 [0x039E]={
  ["adobename"]="Xi",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekXi",
  ["description"]="GREEK CAPITAL LETTER XI",
  ["lccode"]=0x03BE,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Xi",
  ["unicodeslot"]=0x039E, -- Ξ
 },
 [0x039F]={
  ["adobename"]="Omicron",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekOmicron",
  ["description"]="GREEK CAPITAL LETTER OMICRON",
  ["lccode"]=0x03BF,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Omicron",
  ["unicodeslot"]=0x039F, -- Ο
 },
 [0x03A0]={
  ["adobename"]="Pi",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekPi",
  ["description"]="GREEK CAPITAL LETTER PI",
  ["lccode"]=0x03C0,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Pi",
  ["unicodeslot"]=0x03A0, -- Π
 },
 [0x03A1]={
  ["adobename"]="Rho",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekRho",
  ["description"]="GREEK CAPITAL LETTER RHO",
  ["lccode"]=0x03C1,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Rho",
  ["unicodeslot"]=0x03A1, -- Ρ
 },
 [0x03A3]={
  ["adobename"]="Sigma",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekSigma",
  ["description"]="GREEK CAPITAL LETTER SIGMA",
  ["lccode"]=0x03C3,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Sigma",
  ["unicodeslot"]=0x03A3, -- Σ
 },
 [0x03A4]={
  ["adobename"]="Tau",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekTau",
  ["description"]="GREEK CAPITAL LETTER TAU",
  ["lccode"]=0x03C4,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Tau",
  ["unicodeslot"]=0x03A4, -- Τ
 },
 [0x03A5]={
  ["adobename"]="Upsilon",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekUpsilon",
  ["description"]="GREEK CAPITAL LETTER UPSILON",
  ["lccode"]=0x03C5,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Upsilon",
  ["unicodeslot"]=0x03A5, -- Υ
 },
 [0x03A6]={
  ["adobename"]="Phi",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekPhi",
  ["description"]="GREEK CAPITAL LETTER PHI",
  ["lccode"]=0x03C6,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Phi",
  ["unicodeslot"]=0x03A6, -- Φ
 },
 [0x03A7]={
  ["adobename"]="Chi",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekChi",
  ["description"]="GREEK CAPITAL LETTER CHI",
  ["lccode"]=0x03C7,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Chi",
  ["unicodeslot"]=0x03A7, -- Χ
 },
 [0x03A8]={
  ["adobename"]="Psi",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekPsi",
  ["description"]="GREEK CAPITAL LETTER PSI",
  ["lccode"]=0x03C8,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Psi",
  ["unicodeslot"]=0x03A8, -- Ψ
 },
 [0x03A9]={
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="greekOmega",
  ["description"]="GREEK CAPITAL LETTER OMEGA",
  ["lccode"]=0x03C9,
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Omega",
  ["unicodeslot"]=0x03A9, -- Ω
 },
 [0x03AA]={
  ["adobename"]="Iotadieresis",
  ["category"]="lu",
  ["contextname"]="greekIotadialytika",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH DIALYTIKA",
  ["lccode"]=0x03CA,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x0399, 0x0308 },
  ["unicodeslot"]=0x03AA, -- Ϊ
 },
 [0x03AB]={
  ["adobename"]="Upsilondieresis",
  ["category"]="lu",
  ["contextname"]="greekUpsilondialytika",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA",
  ["lccode"]=0x03CB,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x03A5, 0x0308 },
  ["unicodeslot"]=0x03AB, -- Ϋ
 },
 [0x03AC]={
  ["adobename"]="alphatonos",
  ["category"]="ll",
  ["contextname"]="greekalphatonos",
  ["description"]="GREEK SMALL LETTER ALPHA WITH TONOS",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03B1, 0x0301 },
  ["uccode"]=0x0386,
  ["unicodeslot"]=0x03AC, -- ά
 },
 [0x03AD]={
  ["adobename"]="epsilontonos",
  ["category"]="ll",
  ["contextname"]="greekepsilontonos",
  ["description"]="GREEK SMALL LETTER EPSILON WITH TONOS",
  ["linebreak"]="al",
  ["shcode"]=0x03B5,
  ["specials"]={ "char", 0x03B5, 0x0301 },
  ["uccode"]=0x0388,
  ["unicodeslot"]=0x03AD, -- έ
 },
 [0x03AE]={
  ["adobename"]="etatonos",
  ["category"]="ll",
  ["contextname"]="greeketatonos",
  ["description"]="GREEK SMALL LETTER ETA WITH TONOS",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x03B7, 0x0301 },
  ["uccode"]=0x0389,
  ["unicodeslot"]=0x03AE, -- ή
 },
 [0x03AF]={
  ["adobename"]="iotatonos",
  ["category"]="ll",
  ["contextname"]="greekiotatonos",
  ["description"]="GREEK SMALL LETTER IOTA WITH TONOS",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03B9, 0x0301 },
  ["uccode"]=0x038A,
  ["unicodeslot"]=0x03AF, -- ί
 },
 [0x03B0]={
  ["adobename"]="upsilondieresistonos",
  ["category"]="ll",
  ["contextname"]="greekupsilondialytikatonos",
  ["description"]="GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03CB, 0x0301 },
  ["unicodeslot"]=0x03B0, -- ΰ
 },
 [0x03B1]={
  ["adobename"]="alpha",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekalpha",
  ["description"]="GREEK SMALL LETTER ALPHA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="alpha",
  ["uccode"]=0x0391,
  ["unicodeslot"]=0x03B1, -- α
 },
 [0x03B2]={
  ["adobename"]="beta",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekbeta",
  ["description"]="GREEK SMALL LETTER BETA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="beta",
  ["uccode"]=0x0392,
  ["unicodeslot"]=0x03B2, -- β
 },
 [0x03B3]={
  ["adobename"]="gamma",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekgamma",
  ["description"]="GREEK SMALL LETTER GAMMA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="gamma",
  ["uccode"]=0x0393,
  ["unicodeslot"]=0x03B3, -- γ
 },
 [0x03B4]={
  ["adobename"]="delta",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekdelta",
  ["description"]="GREEK SMALL LETTER DELTA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="delta",
  ["uccode"]=0x0394,
  ["unicodeslot"]=0x03B4, -- δ
 },
 [0x03B5]={
  ["adobename"]="epsilon",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekepsilon",
  ["description"]="GREEK SMALL LETTER EPSILON",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="epsilon",
  ["uccode"]=0x0395,
  ["unicodeslot"]=0x03B5, -- ε
 },
 [0x03B6]={
  ["adobename"]="zeta",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekzeta",
  ["description"]="GREEK SMALL LETTER ZETA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="zeta",
  ["uccode"]=0x0396,
  ["unicodeslot"]=0x03B6, -- ζ
 },
 [0x03B7]={
  ["adobename"]="eta",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greeketa",
  ["description"]="GREEK SMALL LETTER ETA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="eta",
  ["uccode"]=0x0397,
  ["unicodeslot"]=0x03B7, -- η
 },
 [0x03B8]={
  ["adobename"]="theta",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greektheta",
  ["description"]="GREEK SMALL LETTER THETA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="theta",
  ["uccode"]=0x0398,
  ["unicodeslot"]=0x03B8, -- θ
 },
 [0x03B9]={
  ["adobename"]="iota",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekiota",
  ["description"]="GREEK SMALL LETTER IOTA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="iota",
  ["uccode"]=0x0399,
  ["unicodeslot"]=0x03B9, -- ι
 },
 [0x03BA]={
  ["adobename"]="kappa",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekkappa",
  ["description"]="GREEK SMALL LETTER KAPPA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="kappa",
  ["uccode"]=0x039A,
  ["unicodeslot"]=0x03BA, -- κ
 },
 [0x03BB]={
  ["adobename"]="lambda",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greeklambda",
  ["description"]="GREEK SMALL LETTER LAMDA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="lambda",
  ["uccode"]=0x039B,
  ["unicodeslot"]=0x03BB, -- λ
 },
 [0x03BC]={
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekmu",
  ["description"]="GREEK SMALL LETTER MU",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="mu",
  ["uccode"]=0x039C,
  ["unicodeslot"]=0x03BC, -- μ
 },
 [0x03BD]={
  ["adobename"]="nu",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greeknu",
  ["description"]="GREEK SMALL LETTER NU",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="nu",
  ["uccode"]=0x039D,
  ["unicodeslot"]=0x03BD, -- ν
 },
 [0x03BE]={
  ["adobename"]="xi",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekxi",
  ["description"]="GREEK SMALL LETTER XI",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="xi",
  ["uccode"]=0x039E,
  ["unicodeslot"]=0x03BE, -- ξ
 },
 [0x03BF]={
  ["adobename"]="omicron",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekomicron",
  ["description"]="GREEK SMALL LETTER OMICRON",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="omicron",
  ["uccode"]=0x039F,
  ["unicodeslot"]=0x03BF, -- ο
 },
 [0x03C0]={
  ["adobename"]="pi",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekpi",
  ["description"]="GREEK SMALL LETTER PI",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="pi",
  ["uccode"]=0x03A0,
  ["unicodeslot"]=0x03C0, -- π
 },
 [0x03C1]={
  ["adobename"]="rho",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekrho",
  ["description"]="GREEK SMALL LETTER RHO",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="rho",
  ["uccode"]=0x03A1,
  ["unicodeslot"]=0x03C1, -- ρ
 },
 [0x03C2]={
  ["adobename"]="sigma1",
  ["category"]="ll",
  ["contextname"]="greekfinalsigma",
  ["description"]="GREEK SMALL LETTER FINAL SIGMA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="varsigma",
  ["uccode"]=0x03A3,
  ["unicodeslot"]=0x03C2, -- ς
 },
 [0x03C3]={
  ["adobename"]="sigma",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greeksigma",
  ["description"]="GREEK SMALL LETTER SIGMA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="sigma",
  ["uccode"]=0x03A3,
  ["unicodeslot"]=0x03C3, -- σ
 },
 [0x03C4]={
  ["adobename"]="tau",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greektau",
  ["description"]="GREEK SMALL LETTER TAU",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="tau",
  ["uccode"]=0x03A4,
  ["unicodeslot"]=0x03C4, -- τ
 },
 [0x03C5]={
  ["adobename"]="upsilon",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekupsilon",
  ["description"]="GREEK SMALL LETTER UPSILON",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="upsilon",
  ["uccode"]=0x03A5,
  ["unicodeslot"]=0x03C5, -- υ
 },
 [0x03C6]={
  ["adobename"]="phi",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekphi",
  ["description"]="GREEK SMALL LETTER PHI",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="varphi",
  ["uccode"]=0x03A6,
  ["unicodeslot"]=0x03C6, -- φ
 },
 [0x03C7]={
  ["adobename"]="chi",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekchi",
  ["description"]="GREEK SMALL LETTER CHI",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="chi",
  ["uccode"]=0x03A7,
  ["unicodeslot"]=0x03C7, -- χ
 },
 [0x03C8]={
  ["adobename"]="psi",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekpsi",
  ["description"]="GREEK SMALL LETTER PSI",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="psi",
  ["uccode"]=0x03A8,
  ["unicodeslot"]=0x03C8, -- ψ
 },
 [0x03C9]={
  ["adobename"]="omega",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="greekomega",
  ["description"]="GREEK SMALL LETTER OMEGA",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="omega",
  ["uccode"]=0x03A9,
  ["unicodeslot"]=0x03C9, -- ω
 },
 [0x03CA]={
  ["adobename"]="iotadieresis",
  ["category"]="ll",
  ["contextname"]="greekiotadialytika",
  ["description"]="GREEK SMALL LETTER IOTA WITH DIALYTIKA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03B9, 0x0308 },
  ["uccode"]=0x03AA,
  ["unicodeslot"]=0x03CA, -- ϊ
 },
 [0x03CB]={
  ["adobename"]="upsilondieresis",
  ["category"]="ll",
  ["contextname"]="greekupsilondiaeresis",
  ["description"]="GREEK SMALL LETTER UPSILON WITH DIALYTIKA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03C5, 0x0308 },
  ["uccode"]=0x03AB,
  ["unicodeslot"]=0x03CB, -- ϋ
 },
 [0x03CC]={
  ["adobename"]="omicrontonos",
  ["category"]="ll",
  ["contextname"]="greekomicrontonos",
  ["description"]="GREEK SMALL LETTER OMICRON WITH TONOS",
  ["linebreak"]="al",
  ["shcode"]=0x03BF,
  ["specials"]={ "char", 0x03BF, 0x0301 },
  ["uccode"]=0x038C,
  ["unicodeslot"]=0x03CC, -- ό
 },
 [0x03CD]={
  ["adobename"]="upsilontonos",
  ["category"]="ll",
  ["contextname"]="greekupsilontonos",
  ["description"]="GREEK SMALL LETTER UPSILON WITH TONOS",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03C5, 0x0301 },
  ["uccode"]=0x038E,
  ["unicodeslot"]=0x03CD, -- ύ
 },
 [0x03CE]={
  ["adobename"]="omegatonos",
  ["category"]="ll",
  ["contextname"]="greekomegatonos",
  ["description"]="GREEK SMALL LETTER OMEGA WITH TONOS",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x03C9, 0x0301 },
  ["uccode"]=0x038F,
  ["unicodeslot"]=0x03CE, -- ώ
 },
 [0x03D0]={
  ["category"]="ll",
  ["description"]="GREEK BETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x03B2 },
  ["uccode"]=0x0392,
  ["unicodeslot"]=0x03D0, -- ϐ
 },
 [0x03D1]={
  ["adobename"]="theta1",
  ["category"]="ll",
  ["contextname"]="greekthetaalt",
  ["description"]="GREEK THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x03B8 },
  ["mathclass"]="variable",
  ["mathname"]="vartheta",
  ["uccode"]=0x0398,
  ["unicodeslot"]=0x03D1, -- ϑ
 },
 [0x03D2]={
  ["adobename"]="Upsilon1",
  ["category"]="lu",
  ["description"]="GREEK UPSILON WITH HOOK SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x03A5 },
  ["unicodeslot"]=0x03D2, -- ϒ
 },
 [0x03D3]={
  ["category"]="lu",
  ["description"]="GREEK UPSILON WITH ACUTE AND HOOK SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x03D2, 0x0301 },
  ["unicodeslot"]=0x03D3, -- ϓ
 },
 [0x03D4]={
  ["category"]="lu",
  ["description"]="GREEK UPSILON WITH DIAERESIS AND HOOK SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x03D2, 0x0308 },
  ["unicodeslot"]=0x03D4, -- ϔ
 },
 [0x03D5]={
  ["adobename"]="phi1",
  ["category"]="ll",
  ["contextname"]="greekphialt",
  ["description"]="GREEK PHI SYMBOL",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="phi",
  ["specials"]={ "compat", 0x03C6 },
  ["uccode"]=0x03A6,
  ["unicodeslot"]=0x03D5, -- ϕ
 },
 [0x03D6]={
  ["adobename"]="omega1",
  ["category"]="ll",
  ["contextname"]="greekpialt",
  ["description"]="GREEK PI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x03C0 },
  ["mathclass"]="variable",
  ["mathname"]="varpi",
  ["uccode"]=0x03A0,
  ["unicodeslot"]=0x03D6, -- ϖ
 },
 [0x03D7]={
  ["category"]="ll",
  ["description"]="GREEK KAI SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x03D7, -- ϗ
 },
 [0x03D8]={
  ["category"]="lu",
  ["description"]="GREEK LETTER ARCHAIC KOPPA",
  ["lccode"]=0x03D9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03D8, -- Ϙ
 },
 [0x03D9]={
  ["category"]="ll",
  ["contextname"]="greekkoppa",
  ["description"]="GREEK SMALL LETTER ARCHAIC KOPPA",
  ["linebreak"]="al",
  ["uccode"]=0x03D8,
  ["unicodeslot"]=0x03D9, -- ϙ
 },
 [0x03DA]={
  ["category"]="lu",
  ["description"]="GREEK LETTER STIGMA",
  ["lccode"]=0x03DB,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03DA, -- Ϛ
 },
 [0x03DB]={
  ["category"]="ll",
  ["contextname"]="greekstigma",
  ["description"]="GREEK SMALL LETTER STIGMA",
  ["linebreak"]="al",
  ["uccode"]=0x03DA,
  ["unicodeslot"]=0x03DB, -- ϛ
 },
 [0x03DC]={
  ["category"]="lu",
  ["description"]="GREEK LETTER DIGAMMA",
  ["lccode"]=0x03DD,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03DC, -- Ϝ
 },
 [0x03DD]={
  ["category"]="ll",
  ["contextname"]="greekdigamma",
  ["description"]="GREEK SMALL LETTER DIGAMMA",
  ["linebreak"]="al",
  ["uccode"]=0x03DC,
  ["unicodeslot"]=0x03DD, -- ϝ
 },
 [0x03DE]={
  ["category"]="lu",
  ["description"]="GREEK LETTER KOPPA",
  ["lccode"]=0x03DF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03DE, -- Ϟ
 },
 [0x03DF]={
  ["category"]="ll",
  ["contextname"]="greeknumkoppa",
  ["description"]="GREEK SMALL LETTER KOPPA",
  ["linebreak"]="al",
  ["uccode"]=0x03DE,
  ["unicodeslot"]=0x03DF, -- ϟ
 },
 [0x03E0]={
  ["category"]="lu",
  ["description"]="GREEK LETTER SAMPI",
  ["lccode"]=0x03E1,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03E0, -- Ϡ
 },
 [0x03E1]={
  ["category"]="ll",
  ["contextname"]="greeksampi",
  ["description"]="GREEK SMALL LETTER SAMPI",
  ["linebreak"]="al",
  ["uccode"]=0x03E0,
  ["unicodeslot"]=0x03E1, -- ϡ
 },
 [0x03E2]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER SHEI",
  ["lccode"]=0x03E3,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03E2, -- Ϣ
 },
 [0x03E3]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER SHEI",
  ["linebreak"]="al",
  ["uccode"]=0x03E2,
  ["unicodeslot"]=0x03E3, -- ϣ
 },
 [0x03E4]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER FEI",
  ["lccode"]=0x03E5,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03E4, -- Ϥ
 },
 [0x03E5]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER FEI",
  ["linebreak"]="al",
  ["uccode"]=0x03E4,
  ["unicodeslot"]=0x03E5, -- ϥ
 },
 [0x03E6]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER KHEI",
  ["lccode"]=0x03E7,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03E6, -- Ϧ
 },
 [0x03E7]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER KHEI",
  ["linebreak"]="al",
  ["uccode"]=0x03E6,
  ["unicodeslot"]=0x03E7, -- ϧ
 },
 [0x03E8]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER HORI",
  ["lccode"]=0x03E9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03E8, -- Ϩ
 },
 [0x03E9]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER HORI",
  ["linebreak"]="al",
  ["uccode"]=0x03E8,
  ["unicodeslot"]=0x03E9, -- ϩ
 },
 [0x03EA]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER GANGIA",
  ["lccode"]=0x03EB,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03EA, -- Ϫ
 },
 [0x03EB]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER GANGIA",
  ["linebreak"]="al",
  ["uccode"]=0x03EA,
  ["unicodeslot"]=0x03EB, -- ϫ
 },
 [0x03EC]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER SHIMA",
  ["lccode"]=0x03ED,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03EC, -- Ϭ
 },
 [0x03ED]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER SHIMA",
  ["linebreak"]="al",
  ["uccode"]=0x03EC,
  ["unicodeslot"]=0x03ED, -- ϭ
 },
 [0x03EE]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER DEI",
  ["lccode"]=0x03EF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03EE, -- Ϯ
 },
 [0x03EF]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER DEI",
  ["linebreak"]="al",
  ["uccode"]=0x03EE,
  ["unicodeslot"]=0x03EF, -- ϯ
 },
 [0x03F0]={
  ["category"]="ll",
  ["description"]="GREEK KAPPA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x03BA },
  ["uccode"]=0x039A,
  ["unicodeslot"]=0x03F0, -- ϰ
 },
 [0x03F1]={
  ["category"]="ll",
  ["contextname"]="greekrhoalt",
  ["description"]="GREEK RHO SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x03C1 },
  ["mathclass"]="variable",
  ["mathname"]="varrho",
  ["uccode"]=0x03A1,
  ["unicodeslot"]=0x03F1, -- ϱ
 },
 [0x03F2]={
  ["category"]="ll",
  ["contextname"]="greeksigmalunate",
  ["description"]="GREEK LUNATE SIGMA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x03C2 },
  ["uccode"]=0x03F9,
  ["unicodeslot"]=0x03F2, -- ϲ
 },
 [0x03F3]={
  ["category"]="ll",
  ["description"]="GREEK LETTER YOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x03F3, -- ϳ
 },
 [0x03F4]={
  ["category"]="lu",
  ["description"]="GREEK CAPITAL THETA SYMBOL",
  ["lccode"]=0x03B8,
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0398 },
  ["unicodeslot"]=0x03F4, -- ϴ
 },
 [0x03F5]={
  ["category"]="ll",
  ["contextname"]="greekepsilonalt",
  ["description"]="GREEK LUNATE EPSILON SYMBOL",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="varepsilon",
  ["specials"]={ "compat", 0x03B5 },
  ["uccode"]=0x0395,
  ["unicodeslot"]=0x03F5, -- ϵ
 },
 [0x03F6]={
  ["category"]="sm",
  ["description"]="GREEK REVERSED LUNATE EPSILON SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x03F6, -- ϶
 },
 [0x03F7]={
  ["category"]="lu",
  ["description"]="GREEK CAPITAL LETTER SHO",
  ["lccode"]=0x03F8,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03F7, -- Ϸ
 },
 [0x03F8]={
  ["category"]="ll",
  ["description"]="GREEK SMALL LETTER SHO",
  ["linebreak"]="al",
  ["uccode"]=0x03F7,
  ["unicodeslot"]=0x03F8, -- ϸ
 },
 [0x03F9]={
  ["category"]="lu",
  ["contextname"]="greekSigmalunate",
  ["description"]="GREEK CAPITAL LUNATE SIGMA SYMBOL",
  ["lccode"]=0x03F2,
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x03A3 },
  ["unicodeslot"]=0x03F9, -- Ϲ
 },
 [0x03FA]={
  ["category"]="lu",
  ["description"]="GREEK CAPITAL LETTER SAN",
  ["lccode"]=0x03FB,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03FA, -- Ϻ
 },
 [0x03FB]={
  ["category"]="ll",
  ["description"]="GREEK SMALL LETTER SAN",
  ["linebreak"]="al",
  ["uccode"]=0x03FA,
  ["unicodeslot"]=0x03FB, -- ϻ
 },
 [0x03FC]={
  ["category"]="ll",
  ["description"]="GREEK RHO WITH STROKE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x03FC, -- ϼ
 },
 [0x03FD]={
  ["category"]="lu",
  ["description"]="GREEK CAPITAL REVERSED LUNATE SIGMA SYMBOL",
  ["lccode"]=0x037B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03FD, -- Ͻ
 },
 [0x03FE]={
  ["category"]="lu",
  ["description"]="GREEK CAPITAL DOTTED LUNATE SIGMA SYMBOL",
  ["lccode"]=0x037C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03FE, -- Ͼ
 },
 [0x03FF]={
  ["category"]="lu",
  ["description"]="GREEK CAPITAL REVERSED DOTTED LUNATE SIGMA SYMBOL",
  ["lccode"]=0x037D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x03FF, -- Ͽ
 },
 [0x0400]={
  ["category"]="lu",
  ["contextname"]="cyrillicEgrave",
  ["description"]="CYRILLIC CAPITAL LETTER IE WITH GRAVE",
  ["lccode"]=0x0450,
  ["linebreak"]="al",
  ["shcode"]=0x0415,
  ["specials"]={ "char", 0x0415, 0x0300 },
  ["unicodeslot"]=0x0400, -- Ѐ
 },
 [0x0401]={
  ["adobename"]="afii10023",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicYO",
  ["description"]="CYRILLIC CAPITAL LETTER IO",
  ["lccode"]=0x0451,
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0415, 0x0308 },
  ["unicodeslot"]=0x0401, -- Ё
 },
 [0x0402]={
  ["adobename"]="afii10051",
  ["category"]="lu",
  ["contextname"]="cyrillicDJE",
  ["description"]="CYRILLIC CAPITAL LETTER DJE",
  ["lccode"]=0x0452,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0402, -- Ђ
 },
 [0x0403]={
  ["adobename"]="afii10052",
  ["category"]="lu",
  ["contextname"]="cyrillicGJE",
  ["description"]="CYRILLIC CAPITAL LETTER GJE",
  ["lccode"]=0x0453,
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0413, 0x0301 },
  ["unicodeslot"]=0x0403, -- Ѓ
 },
 [0x0404]={
  ["adobename"]="afii10053",
  ["category"]="lu",
  ["contextname"]="cyrillicIE",
  ["description"]="CYRILLIC CAPITAL LETTER UKRAINIAN IE",
  ["lccode"]=0x0454,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0404, -- Є
 },
 [0x0405]={
  ["adobename"]="afii10054",
  ["category"]="lu",
  ["contextname"]="cyrillicDZE",
  ["description"]="CYRILLIC CAPITAL LETTER DZE",
  ["lccode"]=0x0455,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0405, -- Ѕ
 },
 [0x0406]={
  ["adobename"]="afii10055",
  ["category"]="lu",
  ["contextname"]="cyrillicII",
  ["description"]="CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I",
  ["lccode"]=0x0456,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0406, -- І
 },
 [0x0407]={
  ["adobename"]="afii10056",
  ["category"]="lu",
  ["contextname"]="cyrillicYI",
  ["description"]="CYRILLIC CAPITAL LETTER YI",
  ["lccode"]=0x0457,
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0406, 0x0308 },
  ["unicodeslot"]=0x0407, -- Ї
 },
 [0x0408]={
  ["adobename"]="afii10057",
  ["category"]="lu",
  ["contextname"]="cyrillicJE",
  ["description"]="CYRILLIC CAPITAL LETTER JE",
  ["lccode"]=0x0458,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0408, -- Ј
 },
 [0x0409]={
  ["adobename"]="afii10058",
  ["category"]="lu",
  ["contextname"]="cyrillicLJE",
  ["description"]="CYRILLIC CAPITAL LETTER LJE",
  ["lccode"]=0x0459,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0409, -- Љ
 },
 [0x040A]={
  ["adobename"]="afii10059",
  ["category"]="lu",
  ["contextname"]="cyrillicNJE",
  ["description"]="CYRILLIC CAPITAL LETTER NJE",
  ["lccode"]=0x045A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x040A, -- Њ
 },
 [0x040B]={
  ["adobename"]="afii10060",
  ["category"]="lu",
  ["contextname"]="cyrillicTSHE",
  ["description"]="CYRILLIC CAPITAL LETTER TSHE",
  ["lccode"]=0x045B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x040B, -- Ћ
 },
 [0x040C]={
  ["adobename"]="afii10061",
  ["category"]="lu",
  ["contextname"]="cyrillicKJE",
  ["description"]="CYRILLIC CAPITAL LETTER KJE",
  ["lccode"]=0x045C,
  ["linebreak"]="al",
  ["specials"]={ "char", 0x041A, 0x0301 },
  ["unicodeslot"]=0x040C, -- Ќ
 },
 [0x040D]={
  ["category"]="lu",
  ["contextname"]="cyrillicIgrave",
  ["description"]="CYRILLIC CAPITAL LETTER I WITH GRAVE",
  ["lccode"]=0x045D,
  ["linebreak"]="al",
  ["shcode"]=0x0418,
  ["specials"]={ "char", 0x0418, 0x0300 },
  ["unicodeslot"]=0x040D, -- Ѝ
 },
 [0x040E]={
  ["adobename"]="afii10062",
  ["category"]="lu",
  ["contextname"]="cyrillicUSHRT",
  ["description"]="CYRILLIC CAPITAL LETTER SHORT U",
  ["lccode"]=0x045E,
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0423, 0x0306 },
  ["unicodeslot"]=0x040E, -- Ў
 },
 [0x040F]={
  ["adobename"]="afii10145",
  ["category"]="lu",
  ["contextname"]="cyrillicDZHE",
  ["description"]="CYRILLIC CAPITAL LETTER DZHE",
  ["lccode"]=0x045F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x040F, -- Џ
 },
 [0x0410]={
  ["adobename"]="afii10017",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicA",
  ["description"]="CYRILLIC CAPITAL LETTER A",
  ["lccode"]=0x0430,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0410, -- А
 },
 [0x0411]={
  ["adobename"]="afii10018",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicB",
  ["description"]="CYRILLIC CAPITAL LETTER BE",
  ["lccode"]=0x0431,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0411, -- Б
 },
 [0x0412]={
  ["adobename"]="afii10019",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicV",
  ["description"]="CYRILLIC CAPITAL LETTER VE",
  ["lccode"]=0x0432,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0412, -- В
 },
 [0x0413]={
  ["adobename"]="afii10020",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicG",
  ["description"]="CYRILLIC CAPITAL LETTER GHE",
  ["lccode"]=0x0433,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0413, -- Г
 },
 [0x0414]={
  ["adobename"]="afii10021",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicD",
  ["description"]="CYRILLIC CAPITAL LETTER DE",
  ["lccode"]=0x0434,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0414, -- Д
 },
 [0x0415]={
  ["adobename"]="afii10022",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicE",
  ["description"]="CYRILLIC CAPITAL LETTER IE",
  ["lccode"]=0x0435,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0415, -- Е
 },
 [0x0416]={
  ["adobename"]="afii10024",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicZH",
  ["description"]="CYRILLIC CAPITAL LETTER ZHE",
  ["lccode"]=0x0436,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0416, -- Ж
 },
 [0x0417]={
  ["adobename"]="afii10025",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicZ",
  ["description"]="CYRILLIC CAPITAL LETTER ZE",
  ["lccode"]=0x0437,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0417, -- З
 },
 [0x0418]={
  ["adobename"]="afii10026",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicI",
  ["description"]="CYRILLIC CAPITAL LETTER I",
  ["lccode"]=0x0438,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0418, -- И
 },
 [0x0419]={
  ["adobename"]="afii10027",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicISHRT",
  ["description"]="CYRILLIC CAPITAL LETTER SHORT I",
  ["lccode"]=0x0439,
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0418, 0x0306 },
  ["unicodeslot"]=0x0419, -- Й
 },
 [0x041A]={
  ["adobename"]="afii10028",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicK",
  ["description"]="CYRILLIC CAPITAL LETTER KA",
  ["lccode"]=0x043A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x041A, -- К
 },
 [0x041B]={
  ["adobename"]="afii10029",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicL",
  ["description"]="CYRILLIC CAPITAL LETTER EL",
  ["lccode"]=0x043B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x041B, -- Л
 },
 [0x041C]={
  ["adobename"]="afii10030",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicM",
  ["description"]="CYRILLIC CAPITAL LETTER EM",
  ["lccode"]=0x043C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x041C, -- М
 },
 [0x041D]={
  ["adobename"]="afii10031",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicN",
  ["description"]="CYRILLIC CAPITAL LETTER EN",
  ["lccode"]=0x043D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x041D, -- Н
 },
 [0x041E]={
  ["adobename"]="afii10032",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicO",
  ["description"]="CYRILLIC CAPITAL LETTER O",
  ["lccode"]=0x043E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x041E, -- О
 },
 [0x041F]={
  ["adobename"]="afii10033",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicP",
  ["description"]="CYRILLIC CAPITAL LETTER PE",
  ["lccode"]=0x043F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x041F, -- П
 },
 [0x0420]={
  ["adobename"]="afii10034",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicR",
  ["description"]="CYRILLIC CAPITAL LETTER ER",
  ["lccode"]=0x0440,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0420, -- Р
 },
 [0x0421]={
  ["adobename"]="afii10035",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicS",
  ["description"]="CYRILLIC CAPITAL LETTER ES",
  ["lccode"]=0x0441,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0421, -- С
 },
 [0x0422]={
  ["adobename"]="afii10036",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicT",
  ["description"]="CYRILLIC CAPITAL LETTER TE",
  ["lccode"]=0x0442,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0422, -- Т
 },
 [0x0423]={
  ["adobename"]="afii10037",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicU",
  ["description"]="CYRILLIC CAPITAL LETTER U",
  ["lccode"]=0x0443,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0423, -- У
 },
 [0x0424]={
  ["adobename"]="afii10038",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicF",
  ["description"]="CYRILLIC CAPITAL LETTER EF",
  ["lccode"]=0x0444,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0424, -- Ф
 },
 [0x0425]={
  ["adobename"]="afii10039",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicH",
  ["description"]="CYRILLIC CAPITAL LETTER HA",
  ["lccode"]=0x0445,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0425, -- Х
 },
 [0x0426]={
  ["adobename"]="afii10040",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicC",
  ["description"]="CYRILLIC CAPITAL LETTER TSE",
  ["lccode"]=0x0446,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0426, -- Ц
 },
 [0x0427]={
  ["adobename"]="afii10041",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicCH",
  ["description"]="CYRILLIC CAPITAL LETTER CHE",
  ["lccode"]=0x0447,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0427, -- Ч
 },
 [0x0428]={
  ["adobename"]="afii10042",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicSH",
  ["description"]="CYRILLIC CAPITAL LETTER SHA",
  ["lccode"]=0x0448,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0428, -- Ш
 },
 [0x0429]={
  ["adobename"]="afii10043",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicSHCH",
  ["description"]="CYRILLIC CAPITAL LETTER SHCHA",
  ["lccode"]=0x0449,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0429, -- Щ
 },
 [0x042A]={
  ["adobename"]="afii10044",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicHRDSN",
  ["description"]="CYRILLIC CAPITAL LETTER HARD SIGN",
  ["lccode"]=0x044A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x042A, -- Ъ
 },
 [0x042B]={
  ["adobename"]="afii10045",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicERY",
  ["description"]="CYRILLIC CAPITAL LETTER YERU",
  ["lccode"]=0x044B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x042B, -- Ы
 },
 [0x042C]={
  ["adobename"]="afii10046",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicSFTSN",
  ["description"]="CYRILLIC CAPITAL LETTER SOFT SIGN",
  ["lccode"]=0x044C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x042C, -- Ь
 },
 [0x042D]={
  ["adobename"]="afii10047",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicEREV",
  ["description"]="CYRILLIC CAPITAL LETTER E",
  ["lccode"]=0x044D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x042D, -- Э
 },
 [0x042E]={
  ["adobename"]="afii10048",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicYU",
  ["description"]="CYRILLIC CAPITAL LETTER YU",
  ["lccode"]=0x044E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x042E, -- Ю
 },
 [0x042F]={
  ["adobename"]="afii10049",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicYA",
  ["description"]="CYRILLIC CAPITAL LETTER YA",
  ["lccode"]=0x044F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x042F, -- Я
 },
 [0x0430]={
  ["adobename"]="afii10065",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillica",
  ["description"]="CYRILLIC SMALL LETTER A",
  ["linebreak"]="al",
  ["uccode"]=0x0410,
  ["unicodeslot"]=0x0430, -- а
 },
 [0x0431]={
  ["adobename"]="afii10066",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicb",
  ["description"]="CYRILLIC SMALL LETTER BE",
  ["linebreak"]="al",
  ["uccode"]=0x0411,
  ["unicodeslot"]=0x0431, -- б
 },
 [0x0432]={
  ["adobename"]="afii10067",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicv",
  ["description"]="CYRILLIC SMALL LETTER VE",
  ["linebreak"]="al",
  ["uccode"]=0x0412,
  ["unicodeslot"]=0x0432, -- в
 },
 [0x0433]={
  ["adobename"]="afii10068",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicg",
  ["description"]="CYRILLIC SMALL LETTER GHE",
  ["linebreak"]="al",
  ["uccode"]=0x0413,
  ["unicodeslot"]=0x0433, -- г
 },
 [0x0434]={
  ["adobename"]="afii10069",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicd",
  ["description"]="CYRILLIC SMALL LETTER DE",
  ["linebreak"]="al",
  ["uccode"]=0x0414,
  ["unicodeslot"]=0x0434, -- д
 },
 [0x0435]={
  ["adobename"]="afii10070",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillice",
  ["description"]="CYRILLIC SMALL LETTER IE",
  ["linebreak"]="al",
  ["uccode"]=0x0415,
  ["unicodeslot"]=0x0435, -- е
 },
 [0x0436]={
  ["adobename"]="afii10072",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrilliczh",
  ["description"]="CYRILLIC SMALL LETTER ZHE",
  ["linebreak"]="al",
  ["uccode"]=0x0416,
  ["unicodeslot"]=0x0436, -- ж
 },
 [0x0437]={
  ["adobename"]="afii10073",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicz",
  ["description"]="CYRILLIC SMALL LETTER ZE",
  ["linebreak"]="al",
  ["uccode"]=0x0417,
  ["unicodeslot"]=0x0437, -- з
 },
 [0x0438]={
  ["adobename"]="afii10074",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillici",
  ["description"]="CYRILLIC SMALL LETTER I",
  ["linebreak"]="al",
  ["uccode"]=0x0418,
  ["unicodeslot"]=0x0438, -- и
 },
 [0x0439]={
  ["adobename"]="afii10075",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicishrt",
  ["description"]="CYRILLIC SMALL LETTER SHORT I",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0438, 0x0306 },
  ["uccode"]=0x0419,
  ["unicodeslot"]=0x0439, -- й
 },
 [0x043A]={
  ["adobename"]="afii10076",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillick",
  ["description"]="CYRILLIC SMALL LETTER KA",
  ["linebreak"]="al",
  ["uccode"]=0x041A,
  ["unicodeslot"]=0x043A, -- к
 },
 [0x043B]={
  ["adobename"]="afii10077",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicl",
  ["description"]="CYRILLIC SMALL LETTER EL",
  ["linebreak"]="al",
  ["uccode"]=0x041B,
  ["unicodeslot"]=0x043B, -- л
 },
 [0x043C]={
  ["adobename"]="afii10078",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicm",
  ["description"]="CYRILLIC SMALL LETTER EM",
  ["linebreak"]="al",
  ["uccode"]=0x041C,
  ["unicodeslot"]=0x043C, -- м
 },
 [0x043D]={
  ["adobename"]="afii10079",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicn",
  ["description"]="CYRILLIC SMALL LETTER EN",
  ["linebreak"]="al",
  ["uccode"]=0x041D,
  ["unicodeslot"]=0x043D, -- н
 },
 [0x043E]={
  ["adobename"]="afii10080",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillico",
  ["description"]="CYRILLIC SMALL LETTER O",
  ["linebreak"]="al",
  ["uccode"]=0x041E,
  ["unicodeslot"]=0x043E, -- о
 },
 [0x043F]={
  ["adobename"]="afii10081",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicp",
  ["description"]="CYRILLIC SMALL LETTER PE",
  ["linebreak"]="al",
  ["uccode"]=0x041F,
  ["unicodeslot"]=0x043F, -- п
 },
 [0x0440]={
  ["adobename"]="afii10082",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicr",
  ["description"]="CYRILLIC SMALL LETTER ER",
  ["linebreak"]="al",
  ["uccode"]=0x0420,
  ["unicodeslot"]=0x0440, -- р
 },
 [0x0441]={
  ["adobename"]="afii10083",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillics",
  ["description"]="CYRILLIC SMALL LETTER ES",
  ["linebreak"]="al",
  ["uccode"]=0x0421,
  ["unicodeslot"]=0x0441, -- с
 },
 [0x0442]={
  ["adobename"]="afii10084",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillict",
  ["description"]="CYRILLIC SMALL LETTER TE",
  ["linebreak"]="al",
  ["uccode"]=0x0422,
  ["unicodeslot"]=0x0442, -- т
 },
 [0x0443]={
  ["adobename"]="afii10085",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicu",
  ["description"]="CYRILLIC SMALL LETTER U",
  ["linebreak"]="al",
  ["uccode"]=0x0423,
  ["unicodeslot"]=0x0443, -- у
 },
 [0x0444]={
  ["adobename"]="afii10086",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicf",
  ["description"]="CYRILLIC SMALL LETTER EF",
  ["linebreak"]="al",
  ["uccode"]=0x0424,
  ["unicodeslot"]=0x0444, -- ф
 },
 [0x0445]={
  ["adobename"]="afii10087",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillich",
  ["description"]="CYRILLIC SMALL LETTER HA",
  ["linebreak"]="al",
  ["uccode"]=0x0425,
  ["unicodeslot"]=0x0445, -- х
 },
 [0x0446]={
  ["adobename"]="afii10088",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicc",
  ["description"]="CYRILLIC SMALL LETTER TSE",
  ["linebreak"]="al",
  ["uccode"]=0x0426,
  ["unicodeslot"]=0x0446, -- ц
 },
 [0x0447]={
  ["adobename"]="afii10089",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicch",
  ["description"]="CYRILLIC SMALL LETTER CHE",
  ["linebreak"]="al",
  ["uccode"]=0x0427,
  ["unicodeslot"]=0x0447, -- ч
 },
 [0x0448]={
  ["adobename"]="afii10090",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicsh",
  ["description"]="CYRILLIC SMALL LETTER SHA",
  ["linebreak"]="al",
  ["uccode"]=0x0428,
  ["unicodeslot"]=0x0448, -- ш
 },
 [0x0449]={
  ["adobename"]="afii10091",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicshch",
  ["description"]="CYRILLIC SMALL LETTER SHCHA",
  ["linebreak"]="al",
  ["uccode"]=0x0429,
  ["unicodeslot"]=0x0449, -- щ
 },
 [0x044A]={
  ["adobename"]="afii10092",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillichrdsn",
  ["description"]="CYRILLIC SMALL LETTER HARD SIGN",
  ["linebreak"]="al",
  ["uccode"]=0x042A,
  ["unicodeslot"]=0x044A, -- ъ
 },
 [0x044B]={
  ["adobename"]="afii10093",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicery",
  ["description"]="CYRILLIC SMALL LETTER YERU",
  ["linebreak"]="al",
  ["uccode"]=0x042B,
  ["unicodeslot"]=0x044B, -- ы
 },
 [0x044C]={
  ["adobename"]="afii10094",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicsftsn",
  ["description"]="CYRILLIC SMALL LETTER SOFT SIGN",
  ["linebreak"]="al",
  ["uccode"]=0x042C,
  ["unicodeslot"]=0x044C, -- ь
 },
 [0x044D]={
  ["adobename"]="afii10095",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicerev",
  ["description"]="CYRILLIC SMALL LETTER E",
  ["linebreak"]="al",
  ["uccode"]=0x042D,
  ["unicodeslot"]=0x044D, -- э
 },
 [0x044E]={
  ["adobename"]="afii10096",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicyu",
  ["description"]="CYRILLIC SMALL LETTER YU",
  ["linebreak"]="al",
  ["uccode"]=0x042E,
  ["unicodeslot"]=0x044E, -- ю
 },
 [0x044F]={
  ["adobename"]="afii10097",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicya",
  ["description"]="CYRILLIC SMALL LETTER YA",
  ["linebreak"]="al",
  ["uccode"]=0x042F,
  ["unicodeslot"]=0x044F, -- я
 },
 [0x0450]={
  ["category"]="ll",
  ["contextname"]="cyrillicegrave",
  ["description"]="CYRILLIC SMALL LETTER IE WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0435,
  ["specials"]={ "char", 0x0435, 0x0300 },
  ["uccode"]=0x0400,
  ["unicodeslot"]=0x0450, -- ѐ
 },
 [0x0451]={
  ["adobename"]="afii10071",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["contextname"]="cyrillicyo",
  ["description"]="CYRILLIC SMALL LETTER IO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0435, 0x0308 },
  ["uccode"]=0x0401,
  ["unicodeslot"]=0x0451, -- ё
 },
 [0x0452]={
  ["adobename"]="afii10099",
  ["category"]="ll",
  ["contextname"]="cyrillicdje",
  ["description"]="CYRILLIC SMALL LETTER DJE",
  ["linebreak"]="al",
  ["uccode"]=0x0402,
  ["unicodeslot"]=0x0452, -- ђ
 },
 [0x0453]={
  ["adobename"]="afii10100",
  ["category"]="ll",
  ["contextname"]="cyrillicgje",
  ["description"]="CYRILLIC SMALL LETTER GJE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0433, 0x0301 },
  ["uccode"]=0x0403,
  ["unicodeslot"]=0x0453, -- ѓ
 },
 [0x0454]={
  ["adobename"]="afii10101",
  ["category"]="ll",
  ["contextname"]="cyrillicie",
  ["description"]="CYRILLIC SMALL LETTER UKRAINIAN IE",
  ["linebreak"]="al",
  ["uccode"]=0x0404,
  ["unicodeslot"]=0x0454, -- є
 },
 [0x0455]={
  ["adobename"]="afii10102",
  ["category"]="ll",
  ["contextname"]="cyrillicdze",
  ["description"]="CYRILLIC SMALL LETTER DZE",
  ["linebreak"]="al",
  ["uccode"]=0x0405,
  ["unicodeslot"]=0x0455, -- ѕ
 },
 [0x0456]={
  ["adobename"]="afii10103",
  ["category"]="ll",
  ["contextname"]="cyrillicii",
  ["description"]="CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I",
  ["linebreak"]="al",
  ["uccode"]=0x0406,
  ["unicodeslot"]=0x0456, -- і
 },
 [0x0457]={
  ["adobename"]="afii10104",
  ["category"]="ll",
  ["contextname"]="cyrillicyi",
  ["description"]="CYRILLIC SMALL LETTER YI",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0456, 0x0308 },
  ["uccode"]=0x0407,
  ["unicodeslot"]=0x0457, -- ї
 },
 [0x0458]={
  ["adobename"]="afii10105",
  ["category"]="ll",
  ["contextname"]="cyrillicje",
  ["description"]="CYRILLIC SMALL LETTER JE",
  ["linebreak"]="al",
  ["uccode"]=0x0408,
  ["unicodeslot"]=0x0458, -- ј
 },
 [0x0459]={
  ["adobename"]="afii10106",
  ["category"]="ll",
  ["contextname"]="cyrilliclje",
  ["description"]="CYRILLIC SMALL LETTER LJE",
  ["linebreak"]="al",
  ["uccode"]=0x0409,
  ["unicodeslot"]=0x0459, -- љ
 },
 [0x045A]={
  ["adobename"]="afii10107",
  ["category"]="ll",
  ["contextname"]="cyrillicnje",
  ["description"]="CYRILLIC SMALL LETTER NJE",
  ["linebreak"]="al",
  ["uccode"]=0x040A,
  ["unicodeslot"]=0x045A, -- њ
 },
 [0x045B]={
  ["adobename"]="afii10108",
  ["category"]="ll",
  ["contextname"]="cyrillictshe",
  ["description"]="CYRILLIC SMALL LETTER TSHE",
  ["linebreak"]="al",
  ["uccode"]=0x040B,
  ["unicodeslot"]=0x045B, -- ћ
 },
 [0x045C]={
  ["adobename"]="afii10109",
  ["category"]="ll",
  ["contextname"]="cyrillickje",
  ["description"]="CYRILLIC SMALL LETTER KJE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x043A, 0x0301 },
  ["uccode"]=0x040C,
  ["unicodeslot"]=0x045C, -- ќ
 },
 [0x045D]={
  ["category"]="ll",
  ["contextname"]="cyrillicigrave",
  ["description"]="CYRILLIC SMALL LETTER I WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0438,
  ["specials"]={ "char", 0x0438, 0x0300 },
  ["uccode"]=0x040D,
  ["unicodeslot"]=0x045D, -- ѝ
 },
 [0x045E]={
  ["adobename"]="afii10110",
  ["category"]="ll",
  ["contextname"]="cyrillicushrt",
  ["description"]="CYRILLIC SMALL LETTER SHORT U",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0443, 0x0306 },
  ["uccode"]=0x040E,
  ["unicodeslot"]=0x045E, -- ў
 },
 [0x045F]={
  ["adobename"]="afii10193",
  ["category"]="ll",
  ["contextname"]="cyrillicdzhe",
  ["description"]="CYRILLIC SMALL LETTER DZHE",
  ["linebreak"]="al",
  ["uccode"]=0x040F,
  ["unicodeslot"]=0x045F, -- џ
 },
 [0x0460]={
  ["category"]="lu",
  ["contextname"]="cyrillicOMEGA",
  ["description"]="CYRILLIC CAPITAL LETTER OMEGA",
  ["lccode"]=0x0461,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0460, -- Ѡ
 },
 [0x0461]={
  ["category"]="ll",
  ["contextname"]="cyrillicomega",
  ["description"]="CYRILLIC SMALL LETTER OMEGA",
  ["linebreak"]="al",
  ["uccode"]=0x0460,
  ["unicodeslot"]=0x0461, -- ѡ
 },
 [0x0462]={
  ["adobename"]="afii10146",
  ["category"]="lu",
  ["contextname"]="cyrillicYAT",
  ["description"]="CYRILLIC CAPITAL LETTER YAT",
  ["lccode"]=0x0463,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0462, -- Ѣ
 },
 [0x0463]={
  ["adobename"]="afii10194",
  ["category"]="ll",
  ["contextname"]="cyrillicyat",
  ["description"]="CYRILLIC SMALL LETTER YAT",
  ["linebreak"]="al",
  ["uccode"]=0x0462,
  ["unicodeslot"]=0x0463, -- ѣ
 },
 [0x0464]={
  ["category"]="lu",
  ["contextname"]="cyrillicEiotified",
  ["description"]="CYRILLIC CAPITAL LETTER IOTIFIED E",
  ["lccode"]=0x0465,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0464, -- Ѥ
 },
 [0x0465]={
  ["category"]="ll",
  ["contextname"]="cyrilliceiotified",
  ["description"]="CYRILLIC SMALL LETTER IOTIFIED E",
  ["linebreak"]="al",
  ["uccode"]=0x0464,
  ["unicodeslot"]=0x0465, -- ѥ
 },
 [0x0466]={
  ["category"]="lu",
  ["contextname"]="cyrillicLITTLEYUS",
  ["description"]="CYRILLIC CAPITAL LETTER LITTLE YUS",
  ["lccode"]=0x0467,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0466, -- Ѧ
 },
 [0x0467]={
  ["category"]="ll",
  ["contextname"]="cyrilliclittleyus",
  ["description"]="CYRILLIC SMALL LETTER LITTLE YUS",
  ["linebreak"]="al",
  ["uccode"]=0x0466,
  ["unicodeslot"]=0x0467, -- ѧ
 },
 [0x0468]={
  ["category"]="lu",
  ["contextname"]="cyrillicLITTLEYUSiotified",
  ["description"]="CYRILLIC CAPITAL LETTER IOTIFIED LITTLE YUS",
  ["lccode"]=0x0469,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0468, -- Ѩ
 },
 [0x0469]={
  ["category"]="ll",
  ["contextname"]="cyrilliclittleyusiotified",
  ["description"]="CYRILLIC SMALL LETTER IOTIFIED LITTLE YUS",
  ["linebreak"]="al",
  ["uccode"]=0x0468,
  ["unicodeslot"]=0x0469, -- ѩ
 },
 [0x046A]={
  ["category"]="lu",
  ["contextname"]="cyrillicBIGYUS",
  ["description"]="CYRILLIC CAPITAL LETTER BIG YUS",
  ["lccode"]=0x046B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x046A, -- Ѫ
 },
 [0x046B]={
  ["category"]="ll",
  ["contextname"]="cyrillicbigyus",
  ["description"]="CYRILLIC SMALL LETTER BIG YUS",
  ["linebreak"]="al",
  ["uccode"]=0x046A,
  ["unicodeslot"]=0x046B, -- ѫ
 },
 [0x046C]={
  ["category"]="lu",
  ["contextname"]="cyrillicBIGYUSiotified",
  ["description"]="CYRILLIC CAPITAL LETTER IOTIFIED BIG YUS",
  ["lccode"]=0x046D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x046C, -- Ѭ
 },
 [0x046D]={
  ["category"]="ll",
  ["contextname"]="cyrillicbigyusiotified",
  ["description"]="CYRILLIC SMALL LETTER IOTIFIED BIG YUS",
  ["linebreak"]="al",
  ["uccode"]=0x046C,
  ["unicodeslot"]=0x046D, -- ѭ
 },
 [0x046E]={
  ["category"]="lu",
  ["contextname"]="cyrillicKSI",
  ["description"]="CYRILLIC CAPITAL LETTER KSI",
  ["lccode"]=0x046F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x046E, -- Ѯ
 },
 [0x046F]={
  ["category"]="ll",
  ["contextname"]="cyrillicksi",
  ["description"]="CYRILLIC SMALL LETTER KSI",
  ["linebreak"]="al",
  ["uccode"]=0x046E,
  ["unicodeslot"]=0x046F, -- ѯ
 },
 [0x0470]={
  ["category"]="lu",
  ["contextname"]="cyrillicPSI",
  ["description"]="CYRILLIC CAPITAL LETTER PSI",
  ["lccode"]=0x0471,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0470, -- Ѱ
 },
 [0x0471]={
  ["category"]="ll",
  ["contextname"]="cyrillicpsi",
  ["description"]="CYRILLIC SMALL LETTER PSI",
  ["linebreak"]="al",
  ["uccode"]=0x0470,
  ["unicodeslot"]=0x0471, -- ѱ
 },
 [0x0472]={
  ["adobename"]="afii10147",
  ["category"]="lu",
  ["contextname"]="cyrillicFITA",
  ["description"]="CYRILLIC CAPITAL LETTER FITA",
  ["lccode"]=0x0473,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0472, -- Ѳ
 },
 [0x0473]={
  ["adobename"]="afii10195",
  ["category"]="ll",
  ["contextname"]="cyrillicfita",
  ["description"]="CYRILLIC SMALL LETTER FITA",
  ["linebreak"]="al",
  ["uccode"]=0x0472,
  ["unicodeslot"]=0x0473, -- ѳ
 },
 [0x0474]={
  ["adobename"]="afii10148",
  ["category"]="lu",
  ["contextname"]="cyrillicIZHITSA",
  ["description"]="CYRILLIC CAPITAL LETTER IZHITSA",
  ["lccode"]=0x0475,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0474, -- Ѵ
 },
 [0x0475]={
  ["adobename"]="afii10196",
  ["category"]="ll",
  ["contextname"]="cyrillicizhitsa",
  ["description"]="CYRILLIC SMALL LETTER IZHITSA",
  ["linebreak"]="al",
  ["uccode"]=0x0474,
  ["unicodeslot"]=0x0475, -- ѵ
 },
 [0x0476]={
  ["category"]="lu",
  ["contextname"]="cyrillicIZHITSAdoublegrave",
  ["description"]="CYRILLIC CAPITAL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT",
  ["lccode"]=0x0477,
  ["linebreak"]="al",
  ["shcode"]=0x0474,
  ["specials"]={ "char", 0x0474, 0x030F },
  ["unicodeslot"]=0x0476, -- Ѷ
 },
 [0x0477]={
  ["category"]="ll",
  ["contextname"]="cyrillicizhitsadoublegrave",
  ["description"]="CYRILLIC SMALL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT",
  ["linebreak"]="al",
  ["shcode"]=0x0475,
  ["specials"]={ "char", 0x0475, 0x030F },
  ["uccode"]=0x0476,
  ["unicodeslot"]=0x0477, -- ѷ
 },
 [0x0478]={
  ["category"]="lu",
  ["contextname"]="cyrillicUK",
  ["description"]="CYRILLIC CAPITAL LETTER UK",
  ["lccode"]=0x0479,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0478, -- Ѹ
 },
 [0x0479]={
  ["category"]="ll",
  ["contextname"]="cyrillicuk",
  ["description"]="CYRILLIC SMALL LETTER UK",
  ["linebreak"]="al",
  ["uccode"]=0x0478,
  ["unicodeslot"]=0x0479, -- ѹ
 },
 [0x047A]={
  ["category"]="lu",
  ["contextname"]="cyrillicOMEGAround",
  ["description"]="CYRILLIC CAPITAL LETTER ROUND OMEGA",
  ["lccode"]=0x047B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x047A, -- Ѻ
 },
 [0x047B]={
  ["category"]="ll",
  ["contextname"]="cyrillicomegaround",
  ["description"]="CYRILLIC SMALL LETTER ROUND OMEGA",
  ["linebreak"]="al",
  ["uccode"]=0x047A,
  ["unicodeslot"]=0x047B, -- ѻ
 },
 [0x047C]={
  ["category"]="lu",
  ["contextname"]="cyrillicOMEGAtitlo",
  ["description"]="CYRILLIC CAPITAL LETTER OMEGA WITH TITLO",
  ["lccode"]=0x047D,
  ["linebreak"]="al",
  ["shcode"]=0x0460,
  ["unicodeslot"]=0x047C, -- Ѽ
 },
 [0x047D]={
  ["category"]="ll",
  ["contextname"]="cyrillicomegatitlo",
  ["description"]="CYRILLIC SMALL LETTER OMEGA WITH TITLO",
  ["linebreak"]="al",
  ["shcode"]=0x0461,
  ["uccode"]=0x047C,
  ["unicodeslot"]=0x047D, -- ѽ
 },
 [0x047E]={
  ["category"]="lu",
  ["contextname"]="cyrillicOT",
  ["description"]="CYRILLIC CAPITAL LETTER OT",
  ["lccode"]=0x047F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x047E, -- Ѿ
 },
 [0x047F]={
  ["category"]="ll",
  ["contextname"]="cyrillicot",
  ["description"]="CYRILLIC SMALL LETTER OT",
  ["linebreak"]="al",
  ["uccode"]=0x047E,
  ["unicodeslot"]=0x047F, -- ѿ
 },
 [0x0480]={
  ["category"]="lu",
  ["contextname"]="cyrillicKOPPA",
  ["description"]="CYRILLIC CAPITAL LETTER KOPPA",
  ["lccode"]=0x0481,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0480, -- Ҁ
 },
 [0x0481]={
  ["category"]="ll",
  ["contextname"]="cyrillickoppa",
  ["description"]="CYRILLIC SMALL LETTER KOPPA",
  ["linebreak"]="al",
  ["uccode"]=0x0480,
  ["unicodeslot"]=0x0481, -- ҁ
 },
 [0x0482]={
  ["category"]="so",
  ["description"]="CYRILLIC THOUSANDS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0482, -- ҂
 },
 [0x0483]={
  ["category"]="mn",
  ["contextname"]="cyrillicTITLO",
  ["description"]="COMBINING CYRILLIC TITLO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0483, -- ҃
 },
 [0x0484]={
  ["category"]="mn",
  ["contextname"]="cyrillicPALATALIZATION",
  ["description"]="COMBINING CYRILLIC PALATALIZATION",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0484, -- ҄
 },
 [0x0485]={
  ["category"]="mn",
  ["contextname"]="cyrillicDASIAPNEUMATA",
  ["description"]="COMBINING CYRILLIC DASIA PNEUMATA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0485, -- ҅
 },
 [0x0486]={
  ["category"]="mn",
  ["contextname"]="cyrillicPSILIPNEUMATA",
  ["description"]="COMBINING CYRILLIC PSILI PNEUMATA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0486, -- ҆
 },
 [0x0488]={
  ["category"]="me",
  ["description"]="COMBINING CYRILLIC HUNDRED THOUSANDS SIGN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0488, -- ҈
 },
 [0x0489]={
  ["category"]="me",
  ["description"]="COMBINING CYRILLIC MILLIONS SIGN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0489, -- ҉
 },
 [0x048A]={
  ["category"]="lu",
  ["contextname"]="cyrillicISHRTtail",
  ["description"]="CYRILLIC CAPITAL LETTER SHORT I WITH TAIL",
  ["lccode"]=0x048B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x048A, -- Ҋ
 },
 [0x048B]={
  ["category"]="ll",
  ["contextname"]="cyrillicishrttail",
  ["description"]="CYRILLIC SMALL LETTER SHORT I WITH TAIL",
  ["linebreak"]="al",
  ["uccode"]=0x048A,
  ["unicodeslot"]=0x048B, -- ҋ
 },
 [0x048C]={
  ["category"]="lu",
  ["contextname"]="cyrillicSEMISOFT",
  ["description"]="CYRILLIC CAPITAL LETTER SEMISOFT SIGN",
  ["lccode"]=0x048D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x048C, -- Ҍ
 },
 [0x048D]={
  ["category"]="ll",
  ["contextname"]="cyrillicsemisoft",
  ["description"]="CYRILLIC SMALL LETTER SEMISOFT SIGN",
  ["linebreak"]="al",
  ["uccode"]=0x048C,
  ["unicodeslot"]=0x048D, -- ҍ
 },
 [0x048E]={
  ["category"]="lu",
  ["contextname"]="cyrillicERtick",
  ["description"]="CYRILLIC CAPITAL LETTER ER WITH TICK",
  ["lccode"]=0x048F,
  ["linebreak"]="al",
  ["shcode"]=0x0420,
  ["unicodeslot"]=0x048E, -- Ҏ
 },
 [0x048F]={
  ["category"]="ll",
  ["contextname"]="cyrillicertick",
  ["description"]="CYRILLIC SMALL LETTER ER WITH TICK",
  ["linebreak"]="al",
  ["shcode"]=0x0440,
  ["uccode"]=0x048E,
  ["unicodeslot"]=0x048F, -- ҏ
 },
 [0x0490]={
  ["adobename"]="afii10050",
  ["category"]="lu",
  ["contextname"]="cyrillicGHEupturn",
  ["description"]="CYRILLIC CAPITAL LETTER GHE WITH UPTURN",
  ["lccode"]=0x0491,
  ["linebreak"]="al",
  ["shcode"]=0x0413,
  ["unicodeslot"]=0x0490, -- Ґ
 },
 [0x0491]={
  ["adobename"]="afii10098",
  ["category"]="ll",
  ["contextname"]="cyrillicgheupturn",
  ["description"]="CYRILLIC SMALL LETTER GHE WITH UPTURN",
  ["linebreak"]="al",
  ["shcode"]=0x0433,
  ["uccode"]=0x0490,
  ["unicodeslot"]=0x0491, -- ґ
 },
 [0x0492]={
  ["category"]="lu",
  ["contextname"]="cyrillicGHEstroke",
  ["description"]="CYRILLIC CAPITAL LETTER GHE WITH STROKE",
  ["lccode"]=0x0493,
  ["linebreak"]="al",
  ["shcode"]=0x0413,
  ["unicodeslot"]=0x0492, -- Ғ
 },
 [0x0493]={
  ["category"]="ll",
  ["contextname"]="cyrillicghestroke",
  ["description"]="CYRILLIC SMALL LETTER GHE WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0433,
  ["uccode"]=0x0492,
  ["unicodeslot"]=0x0493, -- ғ
 },
 [0x0494]={
  ["category"]="lu",
  ["contextname"]="cyrillicGHEmidhook",
  ["description"]="CYRILLIC CAPITAL LETTER GHE WITH MIDDLE HOOK",
  ["lccode"]=0x0495,
  ["linebreak"]="al",
  ["shcode"]=0x0413,
  ["unicodeslot"]=0x0494, -- Ҕ
 },
 [0x0495]={
  ["category"]="ll",
  ["contextname"]="cyrillicghemidhook",
  ["description"]="CYRILLIC SMALL LETTER GHE WITH MIDDLE HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0433,
  ["uccode"]=0x0494,
  ["unicodeslot"]=0x0495, -- ҕ
 },
 [0x0496]={
  ["category"]="lu",
  ["contextname"]="cyrillicZHEdescender",
  ["description"]="CYRILLIC CAPITAL LETTER ZHE WITH DESCENDER",
  ["lccode"]=0x0497,
  ["linebreak"]="al",
  ["shcode"]=0x0416,
  ["unicodeslot"]=0x0496, -- Җ
 },
 [0x0497]={
  ["category"]="ll",
  ["contextname"]="cyrilliczhedescender",
  ["description"]="CYRILLIC SMALL LETTER ZHE WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x0436,
  ["uccode"]=0x0496,
  ["unicodeslot"]=0x0497, -- җ
 },
 [0x0498]={
  ["category"]="lu",
  ["contextname"]="cyrillicZDSC",
  ["description"]="CYRILLIC CAPITAL LETTER ZE WITH DESCENDER",
  ["lccode"]=0x0499,
  ["linebreak"]="al",
  ["shcode"]=0x0417,
  ["unicodeslot"]=0x0498, -- Ҙ
 },
 [0x0499]={
  ["category"]="ll",
  ["contextname"]="cyrilliczdsc",
  ["description"]="CYRILLIC SMALL LETTER ZE WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x0437,
  ["uccode"]=0x0498,
  ["unicodeslot"]=0x0499, -- ҙ
 },
 [0x049A]={
  ["category"]="lu",
  ["contextname"]="cyrillicKADC",
  ["description"]="CYRILLIC CAPITAL LETTER KA WITH DESCENDER",
  ["lccode"]=0x049B,
  ["linebreak"]="al",
  ["shcode"]=0x041A,
  ["unicodeslot"]=0x049A, -- Қ
 },
 [0x049B]={
  ["category"]="ll",
  ["contextname"]="cyrillickadc",
  ["description"]="CYRILLIC SMALL LETTER KA WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x043A,
  ["uccode"]=0x049A,
  ["unicodeslot"]=0x049B, -- қ
 },
 [0x049C]={
  ["category"]="lu",
  ["contextname"]="cyrillicKAvertstroke",
  ["description"]="CYRILLIC CAPITAL LETTER KA WITH VERTICAL STROKE",
  ["lccode"]=0x049D,
  ["linebreak"]="al",
  ["shcode"]=0x041A,
  ["unicodeslot"]=0x049C, -- Ҝ
 },
 [0x049D]={
  ["category"]="ll",
  ["contextname"]="cyrillickavertstroke",
  ["description"]="CYRILLIC SMALL LETTER KA WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x043A,
  ["uccode"]=0x049C,
  ["unicodeslot"]=0x049D, -- ҝ
 },
 [0x049E]={
  ["category"]="lu",
  ["contextname"]="cyrillicKAstroke",
  ["description"]="CYRILLIC CAPITAL LETTER KA WITH STROKE",
  ["lccode"]=0x049F,
  ["linebreak"]="al",
  ["shcode"]=0x041A,
  ["unicodeslot"]=0x049E, -- Ҟ
 },
 [0x049F]={
  ["category"]="ll",
  ["contextname"]="cyrillickastroke",
  ["description"]="CYRILLIC SMALL LETTER KA WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x043A,
  ["uccode"]=0x049E,
  ["unicodeslot"]=0x049F, -- ҟ
 },
 [0x04A0]={
  ["category"]="lu",
  ["contextname"]="cyrillicKAbashkir",
  ["description"]="CYRILLIC CAPITAL LETTER BASHKIR KA",
  ["lccode"]=0x04A1,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04A0, -- Ҡ
 },
 [0x04A1]={
  ["category"]="ll",
  ["contextname"]="cyrillickabashkir",
  ["description"]="CYRILLIC SMALL LETTER BASHKIR KA",
  ["linebreak"]="al",
  ["uccode"]=0x04A0,
  ["unicodeslot"]=0x04A1, -- ҡ
 },
 [0x04A2]={
  ["category"]="lu",
  ["contextname"]="cyrillicENDC",
  ["description"]="CYRILLIC CAPITAL LETTER EN WITH DESCENDER",
  ["lccode"]=0x04A3,
  ["linebreak"]="al",
  ["shcode"]=0x041D,
  ["unicodeslot"]=0x04A2, -- Ң
 },
 [0x04A3]={
  ["category"]="ll",
  ["contextname"]="cyrillicendc",
  ["description"]="CYRILLIC SMALL LETTER EN WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x043D,
  ["uccode"]=0x04A2,
  ["unicodeslot"]=0x04A3, -- ң
 },
 [0x04A4]={
  ["category"]="lu",
  ["contextname"]="cyrillicENGHE",
  ["description"]="CYRILLIC CAPITAL LIGATURE EN GHE",
  ["lccode"]=0x04A5,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04A4, -- Ҥ
 },
 [0x04A5]={
  ["category"]="ll",
  ["contextname"]="cyrillicenghe",
  ["description"]="CYRILLIC SMALL LIGATURE EN GHE",
  ["linebreak"]="al",
  ["uccode"]=0x04A4,
  ["unicodeslot"]=0x04A5, -- ҥ
 },
 [0x04A6]={
  ["category"]="lu",
  ["contextname"]="cyrillicPEmidhook",
  ["description"]="CYRILLIC CAPITAL LETTER PE WITH MIDDLE HOOK",
  ["lccode"]=0x04A7,
  ["linebreak"]="al",
  ["shcode"]=0x041F,
  ["unicodeslot"]=0x04A6, -- Ҧ
 },
 [0x04A7]={
  ["category"]="ll",
  ["contextname"]="cyrillicpemidhook",
  ["description"]="CYRILLIC SMALL LETTER PE WITH MIDDLE HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x043F,
  ["uccode"]=0x04A6,
  ["unicodeslot"]=0x04A7, -- ҧ
 },
 [0x04A8]={
  ["category"]="lu",
  ["contextname"]="cyrillicHA",
  ["description"]="CYRILLIC CAPITAL LETTER ABKHASIAN HA",
  ["lccode"]=0x04A9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04A8, -- Ҩ
 },
 [0x04A9]={
  ["category"]="ll",
  ["contextname"]="cyrillicha",
  ["description"]="CYRILLIC SMALL LETTER ABKHASIAN HA",
  ["linebreak"]="al",
  ["uccode"]=0x04A8,
  ["unicodeslot"]=0x04A9, -- ҩ
 },
 [0x04AA]={
  ["category"]="lu",
  ["contextname"]="cyrillicSDSC",
  ["description"]="CYRILLIC CAPITAL LETTER ES WITH DESCENDER",
  ["lccode"]=0x04AB,
  ["linebreak"]="al",
  ["shcode"]=0x0421,
  ["unicodeslot"]=0x04AA, -- Ҫ
 },
 [0x04AB]={
  ["category"]="ll",
  ["contextname"]="cyrillicsdsc",
  ["description"]="CYRILLIC SMALL LETTER ES WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x0441,
  ["uccode"]=0x04AA,
  ["unicodeslot"]=0x04AB, -- ҫ
 },
 [0x04AC]={
  ["category"]="lu",
  ["contextname"]="cyrillicTEDC",
  ["description"]="CYRILLIC CAPITAL LETTER TE WITH DESCENDER",
  ["lccode"]=0x04AD,
  ["linebreak"]="al",
  ["shcode"]=0x0422,
  ["unicodeslot"]=0x04AC, -- Ҭ
 },
 [0x04AD]={
  ["category"]="ll",
  ["contextname"]="cyrillictedc",
  ["description"]="CYRILLIC SMALL LETTER TE WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x0442,
  ["uccode"]=0x04AC,
  ["unicodeslot"]=0x04AD, -- ҭ
 },
 [0x04AE]={
  ["category"]="lu",
  ["contextname"]="cyrillicYstr",
  ["description"]="CYRILLIC CAPITAL LETTER STRAIGHT U",
  ["lccode"]=0x04AF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04AE, -- Ү
 },
 [0x04AF]={
  ["category"]="ll",
  ["contextname"]="cyrillicystr",
  ["description"]="CYRILLIC SMALL LETTER STRAIGHT U",
  ["linebreak"]="al",
  ["uccode"]=0x04AE,
  ["unicodeslot"]=0x04AF, -- ү
 },
 [0x04B0]={
  ["category"]="lu",
  ["contextname"]="cyrillicYstrstroke",
  ["description"]="CYRILLIC CAPITAL LETTER STRAIGHT U WITH STROKE",
  ["lccode"]=0x04B1,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04B0, -- Ұ
 },
 [0x04B1]={
  ["category"]="ll",
  ["contextname"]="cyrillicystrstroke",
  ["description"]="CYRILLIC SMALL LETTER STRAIGHT U WITH STROKE",
  ["linebreak"]="al",
  ["uccode"]=0x04B0,
  ["unicodeslot"]=0x04B1, -- ұ
 },
 [0x04B2]={
  ["category"]="lu",
  ["contextname"]="cyrillicHADC",
  ["description"]="CYRILLIC CAPITAL LETTER HA WITH DESCENDER",
  ["lccode"]=0x04B3,
  ["linebreak"]="al",
  ["shcode"]=0x0425,
  ["unicodeslot"]=0x04B2, -- Ҳ
 },
 [0x04B3]={
  ["category"]="ll",
  ["contextname"]="cyrillichadc",
  ["description"]="CYRILLIC SMALL LETTER HA WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x0445,
  ["uccode"]=0x04B2,
  ["unicodeslot"]=0x04B3, -- ҳ
 },
 [0x04B4]={
  ["category"]="lu",
  ["contextname"]="cyrillicTETSE",
  ["description"]="CYRILLIC CAPITAL LIGATURE TE TSE",
  ["lccode"]=0x04B5,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04B4, -- Ҵ
 },
 [0x04B5]={
  ["category"]="ll",
  ["contextname"]="cyrillictetse",
  ["description"]="CYRILLIC SMALL LIGATURE TE TSE",
  ["linebreak"]="al",
  ["uccode"]=0x04B4,
  ["unicodeslot"]=0x04B5, -- ҵ
 },
 [0x04B6]={
  ["category"]="lu",
  ["contextname"]="cyrillicCHEDC",
  ["description"]="CYRILLIC CAPITAL LETTER CHE WITH DESCENDER",
  ["lccode"]=0x04B7,
  ["linebreak"]="al",
  ["shcode"]=0x0427,
  ["unicodeslot"]=0x04B6, -- Ҷ
 },
 [0x04B7]={
  ["category"]="ll",
  ["contextname"]="cyrillicchedc",
  ["description"]="CYRILLIC SMALL LETTER CHE WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x0447,
  ["uccode"]=0x04B6,
  ["unicodeslot"]=0x04B7, -- ҷ
 },
 [0x04B8]={
  ["category"]="lu",
  ["contextname"]="cyrillicCHEvertstroke",
  ["description"]="CYRILLIC CAPITAL LETTER CHE WITH VERTICAL STROKE",
  ["lccode"]=0x04B9,
  ["linebreak"]="al",
  ["shcode"]=0x0427,
  ["unicodeslot"]=0x04B8, -- Ҹ
 },
 [0x04B9]={
  ["category"]="ll",
  ["contextname"]="cyrillicchevertstroke",
  ["description"]="CYRILLIC SMALL LETTER CHE WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0447,
  ["uccode"]=0x04B8,
  ["unicodeslot"]=0x04B9, -- ҹ
 },
 [0x04BA]={
  ["category"]="lu",
  ["contextname"]="cyrillicSHHA",
  ["description"]="CYRILLIC CAPITAL LETTER SHHA",
  ["lccode"]=0x04BB,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04BA, -- Һ
 },
 [0x04BB]={
  ["category"]="ll",
  ["contextname"]="cyrillicshha",
  ["description"]="CYRILLIC SMALL LETTER SHHA",
  ["linebreak"]="al",
  ["uccode"]=0x04BA,
  ["unicodeslot"]=0x04BB, -- һ
 },
 [0x04BC]={
  ["category"]="lu",
  ["contextname"]="cyrillicCHEabkhasian",
  ["description"]="CYRILLIC CAPITAL LETTER ABKHASIAN CHE",
  ["lccode"]=0x04BD,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04BC, -- Ҽ
 },
 [0x04BD]={
  ["category"]="ll",
  ["contextname"]="cyrilliccheabkhasian",
  ["description"]="CYRILLIC SMALL LETTER ABKHASIAN CHE",
  ["linebreak"]="al",
  ["uccode"]=0x04BC,
  ["unicodeslot"]=0x04BD, -- ҽ
 },
 [0x04BE]={
  ["category"]="lu",
  ["contextname"]="cyrillicCHEDCabkhasian",
  ["description"]="CYRILLIC CAPITAL LETTER ABKHASIAN CHE WITH DESCENDER",
  ["lccode"]=0x04BF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04BE, -- Ҿ
 },
 [0x04BF]={
  ["category"]="ll",
  ["contextname"]="cyrillicchedcabkhasian",
  ["description"]="CYRILLIC SMALL LETTER ABKHASIAN CHE WITH DESCENDER",
  ["linebreak"]="al",
  ["uccode"]=0x04BE,
  ["unicodeslot"]=0x04BF, -- ҿ
 },
 [0x04C0]={
  ["category"]="lu",
  ["contextname"]="cyrillicPALOCHKA",
  ["description"]="CYRILLIC LETTER PALOCHKA",
  ["lccode"]=0x04CF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04C0, -- Ӏ
 },
 [0x04C1]={
  ["category"]="lu",
  ["contextname"]="cyrillicZHEbreve",
  ["description"]="CYRILLIC CAPITAL LETTER ZHE WITH BREVE",
  ["lccode"]=0x04C2,
  ["linebreak"]="al",
  ["shcode"]=0x0416,
  ["specials"]={ "char", 0x0416, 0x0306 },
  ["unicodeslot"]=0x04C1, -- Ӂ
 },
 [0x04C2]={
  ["category"]="ll",
  ["contextname"]="cyrilliczhebreve",
  ["description"]="CYRILLIC SMALL LETTER ZHE WITH BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0436,
  ["specials"]={ "char", 0x0436, 0x0306 },
  ["uccode"]=0x04C1,
  ["unicodeslot"]=0x04C2, -- ӂ
 },
 [0x04C3]={
  ["category"]="lu",
  ["contextname"]="cyrillicKAhook",
  ["description"]="CYRILLIC CAPITAL LETTER KA WITH HOOK",
  ["lccode"]=0x04C4,
  ["linebreak"]="al",
  ["shcode"]=0x041A,
  ["unicodeslot"]=0x04C3, -- Ӄ
 },
 [0x04C4]={
  ["category"]="ll",
  ["contextname"]="cyrillickahook",
  ["description"]="CYRILLIC SMALL LETTER KA WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x043A,
  ["uccode"]=0x04C3,
  ["unicodeslot"]=0x04C4, -- ӄ
 },
 [0x04C5]={
  ["category"]="lu",
  ["contextname"]="cyrillicELtail",
  ["description"]="CYRILLIC CAPITAL LETTER EL WITH TAIL",
  ["lccode"]=0x04C6,
  ["linebreak"]="al",
  ["shcode"]=0x041B,
  ["unicodeslot"]=0x04C5, -- Ӆ
 },
 [0x04C6]={
  ["category"]="ll",
  ["contextname"]="cyrilliceltail",
  ["description"]="CYRILLIC SMALL LETTER EL WITH TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x043B,
  ["uccode"]=0x04C5,
  ["unicodeslot"]=0x04C6, -- ӆ
 },
 [0x04C7]={
  ["category"]="lu",
  ["contextname"]="cyrillicENhook",
  ["description"]="CYRILLIC CAPITAL LETTER EN WITH HOOK",
  ["lccode"]=0x04C8,
  ["linebreak"]="al",
  ["shcode"]=0x041D,
  ["unicodeslot"]=0x04C7, -- Ӈ
 },
 [0x04C8]={
  ["category"]="ll",
  ["contextname"]="cyrillicenhook",
  ["description"]="CYRILLIC SMALL LETTER EN WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x043D,
  ["uccode"]=0x04C7,
  ["unicodeslot"]=0x04C8, -- ӈ
 },
 [0x04C9]={
  ["category"]="lu",
  ["contextname"]="cyrillicENtail",
  ["description"]="CYRILLIC CAPITAL LETTER EN WITH TAIL",
  ["lccode"]=0x04CA,
  ["linebreak"]="al",
  ["shcode"]=0x041D,
  ["unicodeslot"]=0x04C9, -- Ӊ
 },
 [0x04CA]={
  ["category"]="ll",
  ["contextname"]="cyrillicentail",
  ["description"]="CYRILLIC SMALL LETTER EN WITH TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x043D,
  ["uccode"]=0x04C9,
  ["unicodeslot"]=0x04CA, -- ӊ
 },
 [0x04CB]={
  ["category"]="lu",
  ["contextname"]="cyrillicCHEkhakassian",
  ["description"]="CYRILLIC CAPITAL LETTER KHAKASSIAN CHE",
  ["lccode"]=0x04CC,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04CB, -- Ӌ
 },
 [0x04CC]={
  ["category"]="ll",
  ["contextname"]="cyrillicchekhakassian",
  ["description"]="CYRILLIC SMALL LETTER KHAKASSIAN CHE",
  ["linebreak"]="al",
  ["uccode"]=0x04CB,
  ["unicodeslot"]=0x04CC, -- ӌ
 },
 [0x04CD]={
  ["category"]="lu",
  ["contextname"]="cyrillicEMtail",
  ["description"]="CYRILLIC CAPITAL LETTER EM WITH TAIL",
  ["lccode"]=0x04CE,
  ["linebreak"]="al",
  ["shcode"]=0x041C,
  ["unicodeslot"]=0x04CD, -- Ӎ
 },
 [0x04CE]={
  ["category"]="ll",
  ["contextname"]="cyrillicemtail",
  ["description"]="CYRILLIC SMALL LETTER EM WITH TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x043C,
  ["uccode"]=0x04CD,
  ["unicodeslot"]=0x04CE, -- ӎ
 },
 [0x04CF]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER PALOCHKA",
  ["linebreak"]="al",
  ["uccode"]=0x04C0,
  ["unicodeslot"]=0x04CF, -- ӏ
 },
 [0x04D0]={
  ["category"]="lu",
  ["contextname"]="cyrillicAbreve",
  ["description"]="CYRILLIC CAPITAL LETTER A WITH BREVE",
  ["lccode"]=0x04D1,
  ["linebreak"]="al",
  ["shcode"]=0x0410,
  ["specials"]={ "char", 0x0410, 0x0306 },
  ["unicodeslot"]=0x04D0, -- Ӑ
 },
 [0x04D1]={
  ["category"]="ll",
  ["contextname"]="cyrillicabreve",
  ["description"]="CYRILLIC SMALL LETTER A WITH BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0430,
  ["specials"]={ "char", 0x0430, 0x0306 },
  ["uccode"]=0x04D0,
  ["unicodeslot"]=0x04D1, -- ӑ
 },
 [0x04D2]={
  ["category"]="lu",
  ["contextname"]="cyrillicAdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER A WITH DIAERESIS",
  ["lccode"]=0x04D3,
  ["linebreak"]="al",
  ["shcode"]=0x0410,
  ["specials"]={ "char", 0x0410, 0x0308 },
  ["unicodeslot"]=0x04D2, -- Ӓ
 },
 [0x04D3]={
  ["category"]="ll",
  ["contextname"]="cyrillicadiaeresis",
  ["description"]="CYRILLIC SMALL LETTER A WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0430,
  ["specials"]={ "char", 0x0430, 0x0308 },
  ["uccode"]=0x04D2,
  ["unicodeslot"]=0x04D3, -- ӓ
 },
 [0x04D4]={
  ["category"]="lu",
  ["contextname"]="cyrillicAE",
  ["description"]="CYRILLIC CAPITAL LIGATURE A IE",
  ["lccode"]=0x04D5,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04D4, -- Ӕ
 },
 [0x04D5]={
  ["category"]="ll",
  ["contextname"]="cyrillicae",
  ["description"]="CYRILLIC SMALL LIGATURE A IE",
  ["linebreak"]="al",
  ["uccode"]=0x04D4,
  ["unicodeslot"]=0x04D5, -- ӕ
 },
 [0x04D6]={
  ["category"]="lu",
  ["contextname"]="cyrillicEbreve",
  ["description"]="CYRILLIC CAPITAL LETTER IE WITH BREVE",
  ["lccode"]=0x04D7,
  ["linebreak"]="al",
  ["shcode"]=0x0415,
  ["specials"]={ "char", 0x0415, 0x0306 },
  ["unicodeslot"]=0x04D6, -- Ӗ
 },
 [0x04D7]={
  ["category"]="ll",
  ["contextname"]="cyrillicebreve",
  ["description"]="CYRILLIC SMALL LETTER IE WITH BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0435,
  ["specials"]={ "char", 0x0435, 0x0306 },
  ["uccode"]=0x04D6,
  ["unicodeslot"]=0x04D7, -- ӗ
 },
 [0x04D8]={
  ["category"]="lu",
  ["contextname"]="cyrillicSCHWA",
  ["description"]="CYRILLIC CAPITAL LETTER SCHWA",
  ["lccode"]=0x04D9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04D8, -- Ә
 },
 [0x04D9]={
  ["adobename"]="afii10846",
  ["category"]="ll",
  ["contextname"]="cyrillicschwa",
  ["description"]="CYRILLIC SMALL LETTER SCHWA",
  ["linebreak"]="al",
  ["uccode"]=0x04D8,
  ["unicodeslot"]=0x04D9, -- ә
 },
 [0x04DA]={
  ["category"]="lu",
  ["contextname"]="cyrillicSCHWAdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER SCHWA WITH DIAERESIS",
  ["lccode"]=0x04DB,
  ["linebreak"]="al",
  ["shcode"]=0x04D8,
  ["specials"]={ "char", 0x04D8, 0x0308 },
  ["unicodeslot"]=0x04DA, -- Ӛ
 },
 [0x04DB]={
  ["category"]="ll",
  ["contextname"]="cyrillicschwadiaeresis",
  ["description"]="CYRILLIC SMALL LETTER SCHWA WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x04D9,
  ["specials"]={ "char", 0x04D9, 0x0308 },
  ["uccode"]=0x04DA,
  ["unicodeslot"]=0x04DB, -- ӛ
 },
 [0x04DC]={
  ["category"]="lu",
  ["contextname"]="cyrillicZHEdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER ZHE WITH DIAERESIS",
  ["lccode"]=0x04DD,
  ["linebreak"]="al",
  ["shcode"]=0x0416,
  ["specials"]={ "char", 0x0416, 0x0308 },
  ["unicodeslot"]=0x04DC, -- Ӝ
 },
 [0x04DD]={
  ["category"]="ll",
  ["contextname"]="cyrilliczhediaeresis",
  ["description"]="CYRILLIC SMALL LETTER ZHE WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0436,
  ["specials"]={ "char", 0x0436, 0x0308 },
  ["uccode"]=0x04DC,
  ["unicodeslot"]=0x04DD, -- ӝ
 },
 [0x04DE]={
  ["category"]="lu",
  ["contextname"]="cyrillicZEdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER ZE WITH DIAERESIS",
  ["lccode"]=0x04DF,
  ["linebreak"]="al",
  ["shcode"]=0x0417,
  ["specials"]={ "char", 0x0417, 0x0308 },
  ["unicodeslot"]=0x04DE, -- Ӟ
 },
 [0x04DF]={
  ["category"]="ll",
  ["contextname"]="cyrilliczediaeresis",
  ["description"]="CYRILLIC SMALL LETTER ZE WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0437,
  ["specials"]={ "char", 0x0437, 0x0308 },
  ["uccode"]=0x04DE,
  ["unicodeslot"]=0x04DF, -- ӟ
 },
 [0x04E0]={
  ["category"]="lu",
  ["contextname"]="cyrillicDZEabkhasian",
  ["description"]="CYRILLIC CAPITAL LETTER ABKHASIAN DZE",
  ["lccode"]=0x04E1,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04E0, -- Ӡ
 },
 [0x04E1]={
  ["category"]="ll",
  ["contextname"]="cyrillicdzeabkhasian",
  ["description"]="CYRILLIC SMALL LETTER ABKHASIAN DZE",
  ["linebreak"]="al",
  ["uccode"]=0x04E0,
  ["unicodeslot"]=0x04E1, -- ӡ
 },
 [0x04E2]={
  ["category"]="lu",
  ["contextname"]="cyrillicImacron",
  ["description"]="CYRILLIC CAPITAL LETTER I WITH MACRON",
  ["lccode"]=0x04E3,
  ["linebreak"]="al",
  ["shcode"]=0x0418,
  ["specials"]={ "char", 0x0418, 0x0304 },
  ["unicodeslot"]=0x04E2, -- Ӣ
 },
 [0x04E3]={
  ["category"]="ll",
  ["contextname"]="cyrillicimacron",
  ["description"]="CYRILLIC SMALL LETTER I WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0438,
  ["specials"]={ "char", 0x0438, 0x0304 },
  ["uccode"]=0x04E2,
  ["unicodeslot"]=0x04E3, -- ӣ
 },
 [0x04E4]={
  ["category"]="lu",
  ["contextname"]="cyrillicIdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER I WITH DIAERESIS",
  ["lccode"]=0x04E5,
  ["linebreak"]="al",
  ["shcode"]=0x0418,
  ["specials"]={ "char", 0x0418, 0x0308 },
  ["unicodeslot"]=0x04E4, -- Ӥ
 },
 [0x04E5]={
  ["category"]="ll",
  ["contextname"]="cyrillicidiaeresis",
  ["description"]="CYRILLIC SMALL LETTER I WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0438,
  ["specials"]={ "char", 0x0438, 0x0308 },
  ["uccode"]=0x04E4,
  ["unicodeslot"]=0x04E5, -- ӥ
 },
 [0x04E6]={
  ["category"]="lu",
  ["contextname"]="cyrillicOdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER O WITH DIAERESIS",
  ["lccode"]=0x04E7,
  ["linebreak"]="al",
  ["shcode"]=0x041E,
  ["specials"]={ "char", 0x041E, 0x0308 },
  ["unicodeslot"]=0x04E6, -- Ӧ
 },
 [0x04E7]={
  ["category"]="ll",
  ["contextname"]="cyrillicodiaeresis",
  ["description"]="CYRILLIC SMALL LETTER O WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x043E,
  ["specials"]={ "char", 0x043E, 0x0308 },
  ["uccode"]=0x04E6,
  ["unicodeslot"]=0x04E7, -- ӧ
 },
 [0x04E8]={
  ["category"]="lu",
  ["contextname"]="cyrillicObarred",
  ["description"]="CYRILLIC CAPITAL LETTER BARRED O",
  ["lccode"]=0x04E9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x04E8, -- Ө
 },
 [0x04E9]={
  ["category"]="ll",
  ["contextname"]="cyrillicobarred",
  ["description"]="CYRILLIC SMALL LETTER BARRED O",
  ["linebreak"]="al",
  ["uccode"]=0x04E8,
  ["unicodeslot"]=0x04E9, -- ө
 },
 [0x04EA]={
  ["category"]="lu",
  ["contextname"]="cyrillicObarreddiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER BARRED O WITH DIAERESIS",
  ["lccode"]=0x04EB,
  ["linebreak"]="al",
  ["specials"]={ "char", 0x04E8, 0x0308 },
  ["unicodeslot"]=0x04EA, -- Ӫ
 },
 [0x04EB]={
  ["category"]="ll",
  ["contextname"]="cyrillicobarreddiaeresis",
  ["description"]="CYRILLIC SMALL LETTER BARRED O WITH DIAERESIS",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x04E9, 0x0308 },
  ["uccode"]=0x04EA,
  ["unicodeslot"]=0x04EB, -- ӫ
 },
 [0x04EC]={
  ["category"]="lu",
  ["contextname"]="cyrillicEdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER E WITH DIAERESIS",
  ["lccode"]=0x04ED,
  ["linebreak"]="al",
  ["shcode"]=0x042D,
  ["specials"]={ "char", 0x042D, 0x0308 },
  ["unicodeslot"]=0x04EC, -- Ӭ
 },
 [0x04ED]={
  ["category"]="ll",
  ["contextname"]="cyrillicediaeresis",
  ["description"]="CYRILLIC SMALL LETTER E WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x044D,
  ["specials"]={ "char", 0x044D, 0x0308 },
  ["uccode"]=0x04EC,
  ["unicodeslot"]=0x04ED, -- ӭ
 },
 [0x04EE]={
  ["category"]="lu",
  ["contextname"]="cyrillicUmacron",
  ["description"]="CYRILLIC CAPITAL LETTER U WITH MACRON",
  ["lccode"]=0x04EF,
  ["linebreak"]="al",
  ["shcode"]=0x0423,
  ["specials"]={ "char", 0x0423, 0x0304 },
  ["unicodeslot"]=0x04EE, -- Ӯ
 },
 [0x04EF]={
  ["category"]="ll",
  ["contextname"]="cyrillicumacron",
  ["description"]="CYRILLIC SMALL LETTER U WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0443,
  ["specials"]={ "char", 0x0443, 0x0304 },
  ["uccode"]=0x04EE,
  ["unicodeslot"]=0x04EF, -- ӯ
 },
 [0x04F0]={
  ["category"]="lu",
  ["contextname"]="cyrillicUdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER U WITH DIAERESIS",
  ["lccode"]=0x04F1,
  ["linebreak"]="al",
  ["shcode"]=0x0423,
  ["specials"]={ "char", 0x0423, 0x0308 },
  ["unicodeslot"]=0x04F0, -- Ӱ
 },
 [0x04F1]={
  ["category"]="ll",
  ["contextname"]="cyrillicudiaeresis",
  ["description"]="CYRILLIC SMALL LETTER U WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0443,
  ["specials"]={ "char", 0x0443, 0x0308 },
  ["uccode"]=0x04F0,
  ["unicodeslot"]=0x04F1, -- ӱ
 },
 [0x04F2]={
  ["category"]="lu",
  ["contextname"]="cyrillicUdoubleacute",
  ["description"]="CYRILLIC CAPITAL LETTER U WITH DOUBLE ACUTE",
  ["lccode"]=0x04F3,
  ["linebreak"]="al",
  ["shcode"]=0x0423,
  ["specials"]={ "char", 0x0423, 0x030B },
  ["unicodeslot"]=0x04F2, -- Ӳ
 },
 [0x04F3]={
  ["category"]="ll",
  ["contextname"]="cyrillicudoubleacute",
  ["description"]="CYRILLIC SMALL LETTER U WITH DOUBLE ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0443,
  ["specials"]={ "char", 0x0443, 0x030B },
  ["uccode"]=0x04F2,
  ["unicodeslot"]=0x04F3, -- ӳ
 },
 [0x04F4]={
  ["category"]="lu",
  ["contextname"]="cyrillicCHEdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER CHE WITH DIAERESIS",
  ["lccode"]=0x04F5,
  ["linebreak"]="al",
  ["shcode"]=0x0427,
  ["specials"]={ "char", 0x0427, 0x0308 },
  ["unicodeslot"]=0x04F4, -- Ӵ
 },
 [0x04F5]={
  ["category"]="ll",
  ["contextname"]="cyrillicchediaeresis",
  ["description"]="CYRILLIC SMALL LETTER CHE WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0447,
  ["specials"]={ "char", 0x0447, 0x0308 },
  ["uccode"]=0x04F4,
  ["unicodeslot"]=0x04F5, -- ӵ
 },
 [0x04F6]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER GHE WITH DESCENDER",
  ["lccode"]=0x04F7,
  ["linebreak"]="al",
  ["shcode"]=0x0413,
  ["unicodeslot"]=0x04F6, -- Ӷ
 },
 [0x04F7]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER GHE WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x0433,
  ["uccode"]=0x04F6,
  ["unicodeslot"]=0x04F7, -- ӷ
 },
 [0x04F8]={
  ["category"]="lu",
  ["contextname"]="cyrillicYERUdiaeresis",
  ["description"]="CYRILLIC CAPITAL LETTER YERU WITH DIAERESIS",
  ["lccode"]=0x04F9,
  ["linebreak"]="al",
  ["shcode"]=0x042B,
  ["specials"]={ "char", 0x042B, 0x0308 },
  ["unicodeslot"]=0x04F8, -- Ӹ
 },
 [0x04F9]={
  ["category"]="ll",
  ["contextname"]="cyrillicyerudiaeresis",
  ["description"]="CYRILLIC SMALL LETTER YERU WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x044B,
  ["specials"]={ "char", 0x044B, 0x0308 },
  ["uccode"]=0x04F8,
  ["unicodeslot"]=0x04F9, -- ӹ
 },
 [0x04FA]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER GHE WITH STROKE AND HOOK",
  ["lccode"]=0x04FB,
  ["linebreak"]="al",
  ["shcode"]=0x0413,
  ["unicodeslot"]=0x04FA, -- Ӻ
 },
 [0x04FB]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER GHE WITH STROKE AND HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0433,
  ["uccode"]=0x04FA,
  ["unicodeslot"]=0x04FB, -- ӻ
 },
 [0x04FC]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER HA WITH HOOK",
  ["lccode"]=0x04FD,
  ["linebreak"]="al",
  ["shcode"]=0x0425,
  ["unicodeslot"]=0x04FC, -- Ӽ
 },
 [0x04FD]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER HA WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0445,
  ["uccode"]=0x04FC,
  ["unicodeslot"]=0x04FD, -- ӽ
 },
 [0x04FE]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER HA WITH STROKE",
  ["lccode"]=0x04FF,
  ["linebreak"]="al",
  ["shcode"]=0x0425,
  ["unicodeslot"]=0x04FE, -- Ӿ
 },
 [0x04FF]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER HA WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0445,
  ["uccode"]=0x04FE,
  ["unicodeslot"]=0x04FF, -- ӿ
 },
 [0x0500]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER KOMI DE",
  ["lccode"]=0x0501,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0500, -- Ԁ
 },
 [0x0501]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER KOMI DE",
  ["linebreak"]="al",
  ["uccode"]=0x0500,
  ["unicodeslot"]=0x0501, -- ԁ
 },
 [0x0502]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER KOMI DJE",
  ["lccode"]=0x0503,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0502, -- Ԃ
 },
 [0x0503]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER KOMI DJE",
  ["linebreak"]="al",
  ["uccode"]=0x0502,
  ["unicodeslot"]=0x0503, -- ԃ
 },
 [0x0504]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER KOMI ZJE",
  ["lccode"]=0x0505,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0504, -- Ԅ
 },
 [0x0505]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER KOMI ZJE",
  ["linebreak"]="al",
  ["uccode"]=0x0504,
  ["unicodeslot"]=0x0505, -- ԅ
 },
 [0x0506]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER KOMI DZJE",
  ["lccode"]=0x0507,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0506, -- Ԇ
 },
 [0x0507]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER KOMI DZJE",
  ["linebreak"]="al",
  ["uccode"]=0x0506,
  ["unicodeslot"]=0x0507, -- ԇ
 },
 [0x0508]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER KOMI LJE",
  ["lccode"]=0x0509,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0508, -- Ԉ
 },
 [0x0509]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER KOMI LJE",
  ["linebreak"]="al",
  ["uccode"]=0x0508,
  ["unicodeslot"]=0x0509, -- ԉ
 },
 [0x050A]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER KOMI NJE",
  ["lccode"]=0x050B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x050A, -- Ԋ
 },
 [0x050B]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER KOMI NJE",
  ["linebreak"]="al",
  ["uccode"]=0x050A,
  ["unicodeslot"]=0x050B, -- ԋ
 },
 [0x050C]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER KOMI SJE",
  ["lccode"]=0x050D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x050C, -- Ԍ
 },
 [0x050D]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER KOMI SJE",
  ["linebreak"]="al",
  ["uccode"]=0x050C,
  ["unicodeslot"]=0x050D, -- ԍ
 },
 [0x050E]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER KOMI TJE",
  ["lccode"]=0x050F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x050E, -- Ԏ
 },
 [0x050F]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER KOMI TJE",
  ["linebreak"]="al",
  ["uccode"]=0x050E,
  ["unicodeslot"]=0x050F, -- ԏ
 },
 [0x0510]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER REVERSED ZE",
  ["lccode"]=0x0511,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0510, -- Ԑ
 },
 [0x0511]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER REVERSED ZE",
  ["linebreak"]="al",
  ["uccode"]=0x0510,
  ["unicodeslot"]=0x0511, -- ԑ
 },
 [0x0512]={
  ["category"]="lu",
  ["description"]="CYRILLIC CAPITAL LETTER EL WITH HOOK",
  ["lccode"]=0x0513,
  ["linebreak"]="al",
  ["shcode"]=0x041B,
  ["unicodeslot"]=0x0512, -- Ԓ
 },
 [0x0513]={
  ["category"]="ll",
  ["description"]="CYRILLIC SMALL LETTER EL WITH HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x043B,
  ["uccode"]=0x0512,
  ["unicodeslot"]=0x0513, -- ԓ
 },
 [0x0531]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER AYB",
  ["lccode"]=0x0561,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0531, -- Ա
 },
 [0x0532]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER BEN",
  ["lccode"]=0x0562,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0532, -- Բ
 },
 [0x0533]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER GIM",
  ["lccode"]=0x0563,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0533, -- Գ
 },
 [0x0534]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER DA",
  ["lccode"]=0x0564,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0534, -- Դ
 },
 [0x0535]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER ECH",
  ["lccode"]=0x0565,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0535, -- Ե
 },
 [0x0536]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER ZA",
  ["lccode"]=0x0566,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0536, -- Զ
 },
 [0x0537]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER EH",
  ["lccode"]=0x0567,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0537, -- Է
 },
 [0x0538]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER ET",
  ["lccode"]=0x0568,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0538, -- Ը
 },
 [0x0539]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER TO",
  ["lccode"]=0x0569,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0539, -- Թ
 },
 [0x053A]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER ZHE",
  ["lccode"]=0x056A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x053A, -- Ժ
 },
 [0x053B]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER INI",
  ["lccode"]=0x056B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x053B, -- Ի
 },
 [0x053C]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER LIWN",
  ["lccode"]=0x056C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x053C, -- Լ
 },
 [0x053D]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER XEH",
  ["lccode"]=0x056D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x053D, -- Խ
 },
 [0x053E]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER CA",
  ["lccode"]=0x056E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x053E, -- Ծ
 },
 [0x053F]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER KEN",
  ["lccode"]=0x056F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x053F, -- Կ
 },
 [0x0540]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER HO",
  ["lccode"]=0x0570,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0540, -- Հ
 },
 [0x0541]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER JA",
  ["lccode"]=0x0571,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0541, -- Ձ
 },
 [0x0542]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER GHAD",
  ["lccode"]=0x0572,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0542, -- Ղ
 },
 [0x0543]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER CHEH",
  ["lccode"]=0x0573,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0543, -- Ճ
 },
 [0x0544]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER MEN",
  ["lccode"]=0x0574,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0544, -- Մ
 },
 [0x0545]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER YI",
  ["lccode"]=0x0575,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0545, -- Յ
 },
 [0x0546]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER NOW",
  ["lccode"]=0x0576,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0546, -- Ն
 },
 [0x0547]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER SHA",
  ["lccode"]=0x0577,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0547, -- Շ
 },
 [0x0548]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER VO",
  ["lccode"]=0x0578,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0548, -- Ո
 },
 [0x0549]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER CHA",
  ["lccode"]=0x0579,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0549, -- Չ
 },
 [0x054A]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER PEH",
  ["lccode"]=0x057A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x054A, -- Պ
 },
 [0x054B]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER JHEH",
  ["lccode"]=0x057B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x054B, -- Ջ
 },
 [0x054C]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER RA",
  ["lccode"]=0x057C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x054C, -- Ռ
 },
 [0x054D]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER SEH",
  ["lccode"]=0x057D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x054D, -- Ս
 },
 [0x054E]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER VEW",
  ["lccode"]=0x057E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x054E, -- Վ
 },
 [0x054F]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER TIWN",
  ["lccode"]=0x057F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x054F, -- Տ
 },
 [0x0550]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER REH",
  ["lccode"]=0x0580,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0550, -- Ր
 },
 [0x0551]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER CO",
  ["lccode"]=0x0581,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0551, -- Ց
 },
 [0x0552]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER YIWN",
  ["lccode"]=0x0582,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0552, -- Ւ
 },
 [0x0553]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER PIWR",
  ["lccode"]=0x0583,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0553, -- Փ
 },
 [0x0554]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER KEH",
  ["lccode"]=0x0584,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0554, -- Ք
 },
 [0x0555]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER OH",
  ["lccode"]=0x0585,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0555, -- Օ
 },
 [0x0556]={
  ["category"]="lu",
  ["description"]="ARMENIAN CAPITAL LETTER FEH",
  ["lccode"]=0x0586,
  ["linebreak"]="al",
  ["unicodeslot"]=0x0556, -- Ֆ
 },
 [0x0559]={
  ["category"]="lm",
  ["description"]="ARMENIAN MODIFIER LETTER LEFT HALF RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0559, -- ՙ
 },
 [0x055A]={
  ["category"]="po",
  ["description"]="ARMENIAN APOSTROPHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x055A, -- ՚
 },
 [0x055B]={
  ["category"]="po",
  ["description"]="ARMENIAN EMPHASIS MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x055B, -- ՛
 },
 [0x055C]={
  ["category"]="po",
  ["description"]="ARMENIAN EXCLAMATION MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x055C, -- ՜
 },
 [0x055D]={
  ["category"]="po",
  ["description"]="ARMENIAN COMMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x055D, -- ՝
 },
 [0x055E]={
  ["category"]="po",
  ["description"]="ARMENIAN QUESTION MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x055E, -- ՞
 },
 [0x055F]={
  ["category"]="po",
  ["description"]="ARMENIAN ABBREVIATION MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x055F, -- ՟
 },
 [0x0561]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER AYB",
  ["linebreak"]="al",
  ["uccode"]=0x0531,
  ["unicodeslot"]=0x0561, -- ա
 },
 [0x0562]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER BEN",
  ["linebreak"]="al",
  ["uccode"]=0x0532,
  ["unicodeslot"]=0x0562, -- բ
 },
 [0x0563]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER GIM",
  ["linebreak"]="al",
  ["uccode"]=0x0533,
  ["unicodeslot"]=0x0563, -- գ
 },
 [0x0564]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER DA",
  ["linebreak"]="al",
  ["uccode"]=0x0534,
  ["unicodeslot"]=0x0564, -- դ
 },
 [0x0565]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER ECH",
  ["linebreak"]="al",
  ["uccode"]=0x0535,
  ["unicodeslot"]=0x0565, -- ե
 },
 [0x0566]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER ZA",
  ["linebreak"]="al",
  ["uccode"]=0x0536,
  ["unicodeslot"]=0x0566, -- զ
 },
 [0x0567]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER EH",
  ["linebreak"]="al",
  ["uccode"]=0x0537,
  ["unicodeslot"]=0x0567, -- է
 },
 [0x0568]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER ET",
  ["linebreak"]="al",
  ["uccode"]=0x0538,
  ["unicodeslot"]=0x0568, -- ը
 },
 [0x0569]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER TO",
  ["linebreak"]="al",
  ["uccode"]=0x0539,
  ["unicodeslot"]=0x0569, -- թ
 },
 [0x056A]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER ZHE",
  ["linebreak"]="al",
  ["uccode"]=0x053A,
  ["unicodeslot"]=0x056A, -- ժ
 },
 [0x056B]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER INI",
  ["linebreak"]="al",
  ["uccode"]=0x053B,
  ["unicodeslot"]=0x056B, -- ի
 },
 [0x056C]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER LIWN",
  ["linebreak"]="al",
  ["uccode"]=0x053C,
  ["unicodeslot"]=0x056C, -- լ
 },
 [0x056D]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER XEH",
  ["linebreak"]="al",
  ["uccode"]=0x053D,
  ["unicodeslot"]=0x056D, -- խ
 },
 [0x056E]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER CA",
  ["linebreak"]="al",
  ["uccode"]=0x053E,
  ["unicodeslot"]=0x056E, -- ծ
 },
 [0x056F]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER KEN",
  ["linebreak"]="al",
  ["uccode"]=0x053F,
  ["unicodeslot"]=0x056F, -- կ
 },
 [0x0570]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER HO",
  ["linebreak"]="al",
  ["uccode"]=0x0540,
  ["unicodeslot"]=0x0570, -- հ
 },
 [0x0571]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER JA",
  ["linebreak"]="al",
  ["uccode"]=0x0541,
  ["unicodeslot"]=0x0571, -- ձ
 },
 [0x0572]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER GHAD",
  ["linebreak"]="al",
  ["uccode"]=0x0542,
  ["unicodeslot"]=0x0572, -- ղ
 },
 [0x0573]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER CHEH",
  ["linebreak"]="al",
  ["uccode"]=0x0543,
  ["unicodeslot"]=0x0573, -- ճ
 },
 [0x0574]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER MEN",
  ["linebreak"]="al",
  ["uccode"]=0x0544,
  ["unicodeslot"]=0x0574, -- մ
 },
 [0x0575]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER YI",
  ["linebreak"]="al",
  ["uccode"]=0x0545,
  ["unicodeslot"]=0x0575, -- յ
 },
 [0x0576]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER NOW",
  ["linebreak"]="al",
  ["uccode"]=0x0546,
  ["unicodeslot"]=0x0576, -- ն
 },
 [0x0577]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER SHA",
  ["linebreak"]="al",
  ["uccode"]=0x0547,
  ["unicodeslot"]=0x0577, -- շ
 },
 [0x0578]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER VO",
  ["linebreak"]="al",
  ["uccode"]=0x0548,
  ["unicodeslot"]=0x0578, -- ո
 },
 [0x0579]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER CHA",
  ["linebreak"]="al",
  ["uccode"]=0x0549,
  ["unicodeslot"]=0x0579, -- չ
 },
 [0x057A]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER PEH",
  ["linebreak"]="al",
  ["uccode"]=0x054A,
  ["unicodeslot"]=0x057A, -- պ
 },
 [0x057B]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER JHEH",
  ["linebreak"]="al",
  ["uccode"]=0x054B,
  ["unicodeslot"]=0x057B, -- ջ
 },
 [0x057C]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER RA",
  ["linebreak"]="al",
  ["uccode"]=0x054C,
  ["unicodeslot"]=0x057C, -- ռ
 },
 [0x057D]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER SEH",
  ["linebreak"]="al",
  ["uccode"]=0x054D,
  ["unicodeslot"]=0x057D, -- ս
 },
 [0x057E]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER VEW",
  ["linebreak"]="al",
  ["uccode"]=0x054E,
  ["unicodeslot"]=0x057E, -- վ
 },
 [0x057F]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER TIWN",
  ["linebreak"]="al",
  ["uccode"]=0x054F,
  ["unicodeslot"]=0x057F, -- տ
 },
 [0x0580]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER REH",
  ["linebreak"]="al",
  ["uccode"]=0x0550,
  ["unicodeslot"]=0x0580, -- ր
 },
 [0x0581]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER CO",
  ["linebreak"]="al",
  ["uccode"]=0x0551,
  ["unicodeslot"]=0x0581, -- ց
 },
 [0x0582]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER YIWN",
  ["linebreak"]="al",
  ["uccode"]=0x0552,
  ["unicodeslot"]=0x0582, -- ւ
 },
 [0x0583]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER PIWR",
  ["linebreak"]="al",
  ["uccode"]=0x0553,
  ["unicodeslot"]=0x0583, -- փ
 },
 [0x0584]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER KEH",
  ["linebreak"]="al",
  ["uccode"]=0x0554,
  ["unicodeslot"]=0x0584, -- ք
 },
 [0x0585]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER OH",
  ["linebreak"]="al",
  ["uccode"]=0x0555,
  ["unicodeslot"]=0x0585, -- օ
 },
 [0x0586]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LETTER FEH",
  ["linebreak"]="al",
  ["uccode"]=0x0556,
  ["unicodeslot"]=0x0586, -- ֆ
 },
 [0x0587]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LIGATURE ECH YIWN",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0565, 0x0582 },
  ["unicodeslot"]=0x0587, -- և
 },
 [0x0589]={
  ["category"]="po",
  ["description"]="ARMENIAN FULL STOP",
  ["linebreak"]="is",
  ["unicodeslot"]=0x0589, -- ։
 },
 [0x058A]={
  ["category"]="pd",
  ["description"]="ARMENIAN HYPHEN",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x058A, -- ֊
 },
 [0x0591]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT ETNAHTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0591, -- ֑
 },
 [0x0592]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT SEGOL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0592, -- ֒
 },
 [0x0593]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT SHALSHELET",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0593, -- ֓
 },
 [0x0594]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT ZAQEF QATAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0594, -- ֔
 },
 [0x0595]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT ZAQEF GADOL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0595, -- ֕
 },
 [0x0596]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT TIPEHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0596, -- ֖
 },
 [0x0597]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT REVIA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0597, -- ֗
 },
 [0x0598]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT ZARQA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0598, -- ֘
 },
 [0x0599]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT PASHTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0599, -- ֙
 },
 [0x059A]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT YETIV",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x059A, -- ֚
 },
 [0x059B]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT TEVIR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x059B, -- ֛
 },
 [0x059C]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT GERESH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x059C, -- ֜
 },
 [0x059D]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT GERESH MUQDAM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x059D, -- ֝
 },
 [0x059E]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT GERSHAYIM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x059E, -- ֞
 },
 [0x059F]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT QARNEY PARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x059F, -- ֟
 },
 [0x05A0]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT TELISHA GEDOLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A0, -- ֠
 },
 [0x05A1]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT PAZER",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A1, -- ֡
 },
 [0x05A2]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT ATNAH HAFUKH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A2, -- ֢
 },
 [0x05A3]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT MUNAH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A3, -- ֣
 },
 [0x05A4]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT MAHAPAKH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A4, -- ֤
 },
 [0x05A5]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT MERKHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A5, -- ֥
 },
 [0x05A6]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT MERKHA KEFULA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A6, -- ֦
 },
 [0x05A7]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT DARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A7, -- ֧
 },
 [0x05A8]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT QADMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A8, -- ֨
 },
 [0x05A9]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT TELISHA QETANA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05A9, -- ֩
 },
 [0x05AA]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT YERAH BEN YOMO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05AA, -- ֪
 },
 [0x05AB]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT OLE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05AB, -- ֫
 },
 [0x05AC]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT ILUY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05AC, -- ֬
 },
 [0x05AD]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT DEHI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05AD, -- ֭
 },
 [0x05AE]={
  ["category"]="mn",
  ["description"]="HEBREW ACCENT ZINOR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05AE, -- ֮
 },
 [0x05AF]={
  ["category"]="mn",
  ["description"]="HEBREW MARK MASORA CIRCLE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05AF, -- ֯
 },
 [0x05B0]={
  ["adobename"]="afii57799",
  ["category"]="mn",
  ["description"]="HEBREW POINT SHEVA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B0, -- ְ
 },
 [0x05B1]={
  ["adobename"]="afii57801",
  ["category"]="mn",
  ["description"]="HEBREW POINT HATAF SEGOL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B1, -- ֱ
 },
 [0x05B2]={
  ["adobename"]="afii57800",
  ["category"]="mn",
  ["description"]="HEBREW POINT HATAF PATAH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B2, -- ֲ
 },
 [0x05B3]={
  ["adobename"]="afii57802",
  ["category"]="mn",
  ["description"]="HEBREW POINT HATAF QAMATS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B3, -- ֳ
 },
 [0x05B4]={
  ["adobename"]="afii57793",
  ["category"]="mn",
  ["description"]="HEBREW POINT HIRIQ",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B4, -- ִ
 },
 [0x05B5]={
  ["adobename"]="afii57794",
  ["category"]="mn",
  ["description"]="HEBREW POINT TSERE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B5, -- ֵ
 },
 [0x05B6]={
  ["adobename"]="afii57795",
  ["category"]="mn",
  ["description"]="HEBREW POINT SEGOL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B6, -- ֶ
 },
 [0x05B7]={
  ["adobename"]="afii57798",
  ["category"]="mn",
  ["description"]="HEBREW POINT PATAH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B7, -- ַ
 },
 [0x05B8]={
  ["adobename"]="afii57797",
  ["category"]="mn",
  ["description"]="HEBREW POINT QAMATS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B8, -- ָ
 },
 [0x05B9]={
  ["adobename"]="afii57806",
  ["category"]="mn",
  ["description"]="HEBREW POINT HOLAM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05B9, -- ֹ
 },
 [0x05BA]={
  ["category"]="mn",
  ["description"]="HEBREW POINT HOLAM HASER FOR VAV",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05BA, -- ֺ
 },
 [0x05BB]={
  ["adobename"]="afii57796",
  ["category"]="mn",
  ["description"]="HEBREW POINT QUBUTS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05BB, -- ֻ
 },
 [0x05BC]={
  ["adobename"]="afii57807",
  ["category"]="mn",
  ["description"]="HEBREW POINT DAGESH OR MAPIQ",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05BC, -- ּ
 },
 [0x05BD]={
  ["adobename"]="afii57839",
  ["category"]="mn",
  ["description"]="HEBREW POINT METEG",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05BD, -- ֽ
 },
 [0x05BE]={
  ["adobename"]="afii57645",
  ["category"]="po",
  ["description"]="HEBREW PUNCTUATION MAQAF",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x05BE, -- ־
 },
 [0x05BF]={
  ["adobename"]="afii57841",
  ["category"]="mn",
  ["description"]="HEBREW POINT RAFE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05BF, -- ֿ
 },
 [0x05C0]={
  ["adobename"]="afii57842",
  ["category"]="po",
  ["description"]="HEBREW PUNCTUATION PASEQ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05C0, -- ׀
 },
 [0x05C1]={
  ["adobename"]="afii57804",
  ["category"]="mn",
  ["description"]="HEBREW POINT SHIN DOT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05C1, -- ׁ
 },
 [0x05C2]={
  ["adobename"]="afii57803",
  ["category"]="mn",
  ["description"]="HEBREW POINT SIN DOT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05C2, -- ׂ
 },
 [0x05C3]={
  ["adobename"]="afii57658",
  ["category"]="po",
  ["description"]="HEBREW PUNCTUATION SOF PASUQ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05C3, -- ׃
 },
 [0x05C4]={
  ["category"]="mn",
  ["description"]="HEBREW MARK UPPER DOT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05C4, -- ׄ
 },
 [0x05C5]={
  ["category"]="mn",
  ["description"]="HEBREW MARK LOWER DOT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05C5, -- ׅ
 },
 [0x05C6]={
  ["category"]="po",
  ["description"]="HEBREW PUNCTUATION NUN HAFUKHA",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x05C6, -- ׆
 },
 [0x05C7]={
  ["category"]="mn",
  ["description"]="HEBREW POINT QAMATS QATAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x05C7, -- ׇ
 },
 [0x05D0]={
  ["adobename"]="afii57664",
  ["category"]="lo",
  ["contextname"]="hebrewAlef",
  ["description"]="HEBREW LETTER ALEF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D0, -- א
 },
 [0x05D1]={
  ["adobename"]="afii57665",
  ["category"]="lo",
  ["contextname"]="hebrewBet",
  ["description"]="HEBREW LETTER BET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D1, -- ב
 },
 [0x05D2]={
  ["adobename"]="afii57666",
  ["category"]="lo",
  ["contextname"]="hebrewGimel",
  ["description"]="HEBREW LETTER GIMEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D2, -- ג
 },
 [0x05D3]={
  ["adobename"]="afii57667",
  ["category"]="lo",
  ["contextname"]="hebrewDalet",
  ["description"]="HEBREW LETTER DALET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D3, -- ד
 },
 [0x05D4]={
  ["adobename"]="afii57668",
  ["category"]="lo",
  ["contextname"]="hebrewHe",
  ["description"]="HEBREW LETTER HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D4, -- ה
 },
 [0x05D5]={
  ["adobename"]="afii57669",
  ["category"]="lo",
  ["contextname"]="hebrewVav",
  ["description"]="HEBREW LETTER VAV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D5, -- ו
 },
 [0x05D6]={
  ["adobename"]="afii57670",
  ["category"]="lo",
  ["contextname"]="hebrewZayin",
  ["description"]="HEBREW LETTER ZAYIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D6, -- ז
 },
 [0x05D7]={
  ["adobename"]="afii57671",
  ["category"]="lo",
  ["contextname"]="hebrewHet",
  ["description"]="HEBREW LETTER HET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D7, -- ח
 },
 [0x05D8]={
  ["adobename"]="afii57672",
  ["category"]="lo",
  ["contextname"]="hebrewTet",
  ["description"]="HEBREW LETTER TET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D8, -- ט
 },
 [0x05D9]={
  ["adobename"]="afii57673",
  ["category"]="lo",
  ["contextname"]="hebrewYod",
  ["description"]="HEBREW LETTER YOD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05D9, -- י
 },
 [0x05DA]={
  ["adobename"]="afii57674",
  ["category"]="lo",
  ["contextname"]="hebrewKaffinal",
  ["description"]="HEBREW LETTER FINAL KAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05DA, -- ך
 },
 [0x05DB]={
  ["adobename"]="afii57675",
  ["category"]="lo",
  ["contextname"]="hebrewKaf",
  ["description"]="HEBREW LETTER KAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05DB, -- כ
 },
 [0x05DC]={
  ["adobename"]="afii57676",
  ["category"]="lo",
  ["contextname"]="hebrewLamed",
  ["description"]="HEBREW LETTER LAMED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05DC, -- ל
 },
 [0x05DD]={
  ["adobename"]="afii57677",
  ["category"]="lo",
  ["contextname"]="hebrewMemfinal",
  ["description"]="HEBREW LETTER FINAL MEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05DD, -- ם
 },
 [0x05DE]={
  ["adobename"]="afii57678",
  ["category"]="lo",
  ["contextname"]="hebrewMem",
  ["description"]="HEBREW LETTER MEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05DE, -- מ
 },
 [0x05DF]={
  ["adobename"]="afii57679",
  ["category"]="lo",
  ["contextname"]="hebrewNunfinal",
  ["description"]="HEBREW LETTER FINAL NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05DF, -- ן
 },
 [0x05E0]={
  ["adobename"]="afii57680",
  ["category"]="lo",
  ["contextname"]="hebrewNun",
  ["description"]="HEBREW LETTER NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E0, -- נ
 },
 [0x05E1]={
  ["adobename"]="afii57681",
  ["category"]="lo",
  ["contextname"]="hebrewSamekh",
  ["description"]="HEBREW LETTER SAMEKH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E1, -- ס
 },
 [0x05E2]={
  ["adobename"]="afii57682",
  ["category"]="lo",
  ["contextname"]="hebrewAyin",
  ["description"]="HEBREW LETTER AYIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E2, -- ע
 },
 [0x05E3]={
  ["adobename"]="afii57683",
  ["category"]="lo",
  ["contextname"]="hebrewPefinal",
  ["description"]="HEBREW LETTER FINAL PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E3, -- ף
 },
 [0x05E4]={
  ["adobename"]="afii57684",
  ["category"]="lo",
  ["contextname"]="hebrewPe",
  ["description"]="HEBREW LETTER PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E4, -- פ
 },
 [0x05E5]={
  ["adobename"]="afii57685",
  ["category"]="lo",
  ["contextname"]="hebrewTsadifinal",
  ["description"]="HEBREW LETTER FINAL TSADI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E5, -- ץ
 },
 [0x05E6]={
  ["adobename"]="afii57686",
  ["category"]="lo",
  ["contextname"]="hebrewTsadi",
  ["description"]="HEBREW LETTER TSADI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E6, -- צ
 },
 [0x05E7]={
  ["adobename"]="afii57687",
  ["category"]="lo",
  ["contextname"]="hebrewQof",
  ["description"]="HEBREW LETTER QOF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E7, -- ק
 },
 [0x05E8]={
  ["adobename"]="afii57688",
  ["category"]="lo",
  ["contextname"]="hebrewResh",
  ["description"]="HEBREW LETTER RESH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E8, -- ר
 },
 [0x05E9]={
  ["adobename"]="afii57689",
  ["category"]="lo",
  ["contextname"]="hebrewShin",
  ["description"]="HEBREW LETTER SHIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05E9, -- ש
 },
 [0x05EA]={
  ["adobename"]="afii57690",
  ["category"]="lo",
  ["contextname"]="hebrewTav",
  ["description"]="HEBREW LETTER TAV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05EA, -- ת
 },
 [0x05F0]={
  ["adobename"]="afii57716",
  ["category"]="lo",
  ["description"]="HEBREW LIGATURE YIDDISH DOUBLE VAV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05F0, -- װ
 },
 [0x05F1]={
  ["adobename"]="afii57717",
  ["category"]="lo",
  ["description"]="HEBREW LIGATURE YIDDISH VAV YOD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05F1, -- ױ
 },
 [0x05F2]={
  ["adobename"]="afii57718",
  ["category"]="lo",
  ["description"]="HEBREW LIGATURE YIDDISH DOUBLE YOD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05F2, -- ײ
 },
 [0x05F3]={
  ["category"]="po",
  ["description"]="HEBREW PUNCTUATION GERESH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05F3, -- ׳
 },
 [0x05F4]={
  ["category"]="po",
  ["description"]="HEBREW PUNCTUATION GERSHAYIM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x05F4, -- ״
 },
 [0x0600]={
  ["category"]="cf",
  ["description"]="ARABIC NUMBER SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0600, -- ؀
 },
 [0x0601]={
  ["category"]="cf",
  ["description"]="ARABIC SIGN SANAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0601, -- ؁
 },
 [0x0602]={
  ["category"]="cf",
  ["description"]="ARABIC FOOTNOTE MARKER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0602, -- ؂
 },
 [0x0603]={
  ["category"]="cf",
  ["description"]="ARABIC SIGN SAFHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0603, -- ؃
 },
 [0x060B]={
  ["category"]="sc",
  ["description"]="AFGHANI SIGN",
  ["linebreak"]="po",
  ["unicodeslot"]=0x060B, -- ؋
 },
 [0x060C]={
  ["adobename"]="afii57388",
  ["category"]="po",
  ["description"]="ARABIC COMMA",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x060C, -- ،
 },
 [0x060D]={
  ["category"]="po",
  ["description"]="ARABIC DATE SEPARATOR",
  ["linebreak"]="is",
  ["unicodeslot"]=0x060D, -- ؍
 },
 [0x060E]={
  ["category"]="so",
  ["description"]="ARABIC POETIC VERSE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x060E, -- ؎
 },
 [0x060F]={
  ["category"]="so",
  ["description"]="ARABIC SIGN MISRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x060F, -- ؏
 },
 [0x0610]={
  ["category"]="mn",
  ["description"]="ARABIC SIGN SALLALLAHOU ALAYHE WASSALLAM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0610, -- ؐ
 },
 [0x0611]={
  ["category"]="mn",
  ["description"]="ARABIC SIGN ALAYHE ASSALLAM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0611, -- ؑ
 },
 [0x0612]={
  ["category"]="mn",
  ["description"]="ARABIC SIGN RAHMATULLAH ALAYHE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0612, -- ؒ
 },
 [0x0613]={
  ["category"]="mn",
  ["description"]="ARABIC SIGN RADI ALLAHOU ANHU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0613, -- ؓ
 },
 [0x0614]={
  ["category"]="mn",
  ["description"]="ARABIC SIGN TAKHALLUS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0614, -- ؔ
 },
 [0x0615]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH TAH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0615, -- ؕ
 },
 [0x061B]={
  ["adobename"]="afii57403",
  ["category"]="po",
  ["description"]="ARABIC SEMICOLON",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x061B, -- ؛
 },
 [0x061E]={
  ["category"]="po",
  ["description"]="ARABIC TRIPLE DOT PUNCTUATION MARK",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x061E, -- ؞
 },
 [0x061F]={
  ["adobename"]="afii57407",
  ["category"]="po",
  ["description"]="ARABIC QUESTION MARK",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x061F, -- ؟
 },
 [0x0621]={
  ["adobename"]="afii57409",
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAMZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0621, -- ء
 },
 [0x0622]={
  ["adobename"]="afii57410",
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH MADDA ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["specials"]={ "char", 0x0627, 0x0653 },
  ["unicodeslot"]=0x0622, -- آ
 },
 [0x0623]={
  ["adobename"]="afii57411",
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH HAMZA ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["specials"]={ "char", 0x0627, 0x0654 },
  ["unicodeslot"]=0x0623, -- أ
 },
 [0x0624]={
  ["adobename"]="afii57412",
  ["category"]="lo",
  ["description"]="ARABIC LETTER WAW WITH HAMZA ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0648,
  ["specials"]={ "char", 0x0648, 0x0654 },
  ["unicodeslot"]=0x0624, -- ؤ
 },
 [0x0625]={
  ["adobename"]="afii57413",
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH HAMZA BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["specials"]={ "char", 0x0627, 0x0655 },
  ["unicodeslot"]=0x0625, -- إ
 },
 [0x0626]={
  ["adobename"]="afii57414",
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH WITH HAMZA ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x064A,
  ["specials"]={ "char", 0x064A, 0x0654 },
  ["unicodeslot"]=0x0626, -- ئ
 },
 [0x0627]={
  ["adobename"]="afii57415",
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0627, -- ا
 },
 [0x0628]={
  ["adobename"]="afii57416",
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0628, -- ب
 },
 [0x0629]={
  ["adobename"]="afii57417",
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH MARBUTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0629, -- ة
 },
 [0x062A]={
  ["adobename"]="afii57418",
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x062A, -- ت
 },
 [0x062B]={
  ["adobename"]="afii57419",
  ["category"]="lo",
  ["description"]="ARABIC LETTER THEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x062B, -- ث
 },
 [0x062C]={
  ["adobename"]="afii57420",
  ["category"]="lo",
  ["description"]="ARABIC LETTER JEEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x062C, -- ج
 },
 [0x062D]={
  ["adobename"]="afii57421",
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x062D, -- ح
 },
 [0x062E]={
  ["adobename"]="afii57422",
  ["category"]="lo",
  ["description"]="ARABIC LETTER KHAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x062E, -- خ
 },
 [0x062F]={
  ["adobename"]="afii57423",
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x062F, -- د
 },
 [0x0630]={
  ["adobename"]="afii57424",
  ["category"]="lo",
  ["description"]="ARABIC LETTER THAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0630, -- ذ
 },
 [0x0631]={
  ["adobename"]="afii57425",
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0631, -- ر
 },
 [0x0632]={
  ["adobename"]="afii57426",
  ["category"]="lo",
  ["description"]="ARABIC LETTER ZAIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0632, -- ز
 },
 [0x0633]={
  ["adobename"]="afii57427",
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0633, -- س
 },
 [0x0634]={
  ["adobename"]="afii57428",
  ["category"]="lo",
  ["description"]="ARABIC LETTER SHEEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0634, -- ش
 },
 [0x0635]={
  ["adobename"]="afii57429",
  ["category"]="lo",
  ["description"]="ARABIC LETTER SAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0635, -- ص
 },
 [0x0636]={
  ["adobename"]="afii57430",
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0636, -- ض
 },
 [0x0637]={
  ["adobename"]="afii57431",
  ["category"]="lo",
  ["description"]="ARABIC LETTER TAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0637, -- ط
 },
 [0x0638]={
  ["adobename"]="afii57432",
  ["category"]="lo",
  ["description"]="ARABIC LETTER ZAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0638, -- ظ
 },
 [0x0639]={
  ["adobename"]="afii57433",
  ["category"]="lo",
  ["description"]="ARABIC LETTER AIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0639, -- ع
 },
 [0x063A]={
  ["adobename"]="afii57434",
  ["category"]="lo",
  ["description"]="ARABIC LETTER GHAIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x063A, -- غ
 },
 [0x0640]={
  ["adobename"]="afii57440",
  ["category"]="lm",
  ["description"]="ARABIC TATWEEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0640, -- ـ
 },
 [0x0641]={
  ["adobename"]="afii57441",
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0641, -- ف
 },
 [0x0642]={
  ["adobename"]="afii57442",
  ["category"]="lo",
  ["description"]="ARABIC LETTER QAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0642, -- ق
 },
 [0x0643]={
  ["adobename"]="afii57443",
  ["category"]="lo",
  ["description"]="ARABIC LETTER KAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0643, -- ك
 },
 [0x0644]={
  ["adobename"]="afii57444",
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0644, -- ل
 },
 [0x0645]={
  ["adobename"]="afii57445",
  ["category"]="lo",
  ["description"]="ARABIC LETTER MEEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0645, -- م
 },
 [0x0646]={
  ["adobename"]="afii57446",
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0646, -- ن
 },
 [0x0647]={
  ["adobename"]="afii57470",
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0647, -- ه
 },
 [0x0648]={
  ["adobename"]="afii57448",
  ["category"]="lo",
  ["description"]="ARABIC LETTER WAW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0648, -- و
 },
 [0x0649]={
  ["adobename"]="afii57449",
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF MAKSURA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0649, -- ى
 },
 [0x064A]={
  ["adobename"]="afii57450",
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x064A, -- ي
 },
 [0x064B]={
  ["adobename"]="afii57451",
  ["category"]="mn",
  ["description"]="ARABIC FATHATAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x064B, -- ً
 },
 [0x064C]={
  ["adobename"]="afii57452",
  ["category"]="mn",
  ["description"]="ARABIC DAMMATAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x064C, -- ٌ
 },
 [0x064D]={
  ["adobename"]="afii57453",
  ["category"]="mn",
  ["description"]="ARABIC KASRATAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x064D, -- ٍ
 },
 [0x064E]={
  ["adobename"]="afii57454",
  ["category"]="mn",
  ["description"]="ARABIC FATHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x064E, -- َ
 },
 [0x064F]={
  ["adobename"]="afii57455",
  ["category"]="mn",
  ["description"]="ARABIC DAMMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x064F, -- ُ
 },
 [0x0650]={
  ["adobename"]="afii57456",
  ["category"]="mn",
  ["description"]="ARABIC KASRA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0650, -- ِ
 },
 [0x0651]={
  ["adobename"]="afii57457",
  ["category"]="mn",
  ["description"]="ARABIC SHADDA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0651, -- ّ
 },
 [0x0652]={
  ["adobename"]="afii57458",
  ["category"]="mn",
  ["description"]="ARABIC SUKUN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0652, -- ْ
 },
 [0x0653]={
  ["category"]="mn",
  ["description"]="ARABIC MADDAH ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0653, -- ٓ
 },
 [0x0654]={
  ["category"]="mn",
  ["description"]="ARABIC HAMZA ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0654, -- ٔ
 },
 [0x0655]={
  ["category"]="mn",
  ["description"]="ARABIC HAMZA BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0655, -- ٕ
 },
 [0x0656]={
  ["category"]="mn",
  ["description"]="ARABIC SUBSCRIPT ALEF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0656, -- ٖ
 },
 [0x0657]={
  ["category"]="mn",
  ["description"]="ARABIC INVERTED DAMMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0657, -- ٗ
 },
 [0x0658]={
  ["category"]="mn",
  ["description"]="ARABIC MARK NOON GHUNNA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0658, -- ٘
 },
 [0x0659]={
  ["category"]="mn",
  ["description"]="ARABIC ZWARAKAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0659, -- ٙ
 },
 [0x065A]={
  ["category"]="mn",
  ["description"]="ARABIC VOWEL SIGN SMALL V ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x065A, -- ٚ
 },
 [0x065B]={
  ["category"]="mn",
  ["description"]="ARABIC VOWEL SIGN INVERTED SMALL V ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x065B, -- ٛ
 },
 [0x065C]={
  ["category"]="mn",
  ["description"]="ARABIC VOWEL SIGN DOT BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x065C, -- ٜ
 },
 [0x065D]={
  ["category"]="mn",
  ["description"]="ARABIC REVERSED DAMMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x065D, -- ٝ
 },
 [0x065E]={
  ["category"]="mn",
  ["description"]="ARABIC FATHA WITH TWO DOTS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x065E, -- ٞ
 },
 [0x0660]={
  ["adobename"]="afii57392",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0660, -- ٠
 },
 [0x0661]={
  ["adobename"]="afii57393",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0661, -- ١
 },
 [0x0662]={
  ["adobename"]="afii57394",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0662, -- ٢
 },
 [0x0663]={
  ["adobename"]="afii57395",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0663, -- ٣
 },
 [0x0664]={
  ["adobename"]="afii57396",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0664, -- ٤
 },
 [0x0665]={
  ["adobename"]="afii57397",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0665, -- ٥
 },
 [0x0666]={
  ["adobename"]="afii57398",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0666, -- ٦
 },
 [0x0667]={
  ["adobename"]="afii57399",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0667, -- ٧
 },
 [0x0668]={
  ["adobename"]="afii57400",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0668, -- ٨
 },
 [0x0669]={
  ["adobename"]="afii57401",
  ["category"]="nd",
  ["description"]="ARABIC-INDIC DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0669, -- ٩
 },
 [0x066A]={
  ["adobename"]="afii57381",
  ["category"]="po",
  ["description"]="ARABIC PERCENT SIGN",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x066A, -- ٪
 },
 [0x066B]={
  ["category"]="po",
  ["description"]="ARABIC DECIMAL SEPARATOR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x066B, -- ٫
 },
 [0x066C]={
  ["category"]="po",
  ["description"]="ARABIC THOUSANDS SEPARATOR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x066C, -- ٬
 },
 [0x066D]={
  ["adobename"]="afii63167",
  ["category"]="po",
  ["description"]="ARABIC FIVE POINTED STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x066D, -- ٭
 },
 [0x066E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DOTLESS BEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x066E, -- ٮ
 },
 [0x066F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DOTLESS QAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x066F, -- ٯ
 },
 [0x0670]={
  ["category"]="mn",
  ["description"]="ARABIC LETTER SUPERSCRIPT ALEF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0670, -- ٰ
 },
 [0x0671]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WASLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0671, -- ٱ
 },
 [0x0672]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH WAVY HAMZA ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["unicodeslot"]=0x0672, -- ٲ
 },
 [0x0673]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH WAVY HAMZA BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["unicodeslot"]=0x0673, -- ٳ
 },
 [0x0674]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HIGH HAMZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0674, -- ٴ
 },
 [0x0675]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HIGH HAMZA ALEF",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0627, 0x0674 },
  ["unicodeslot"]=0x0675, -- ٵ
 },
 [0x0676]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HIGH HAMZA WAW",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0648, 0x0674 },
  ["unicodeslot"]=0x0676, -- ٶ
 },
 [0x0677]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER U WITH HAMZA ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x06C7,
  ["specials"]={ "compat", 0x06C7, 0x0674 },
  ["unicodeslot"]=0x0677, -- ٷ
 },
 [0x0678]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HIGH HAMZA YEH",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x064A, 0x0674 },
  ["unicodeslot"]=0x0678, -- ٸ
 },
 [0x0679]={
  ["adobename"]="afii57511",
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0679, -- ٹ
 },
 [0x067A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEHEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x067A, -- ٺ
 },
 [0x067B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x067B, -- ٻ
 },
 [0x067C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH WITH RING",
  ["linebreak"]="al",
  ["shcode"]=0x062A,
  ["unicodeslot"]=0x067C, -- ټ
 },
 [0x067D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH WITH THREE DOTS ABOVE DOWNWARDS",
  ["linebreak"]="al",
  ["shcode"]=0x062A,
  ["unicodeslot"]=0x067D, -- ٽ
 },
 [0x067E]={
  ["adobename"]="afii57506",
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x067E, -- پ
 },
 [0x067F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEHEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x067F, -- ٿ
 },
 [0x0680]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEHEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0680, -- ڀ
 },
 [0x0681]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH WITH HAMZA ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x062D,
  ["unicodeslot"]=0x0681, -- ځ
 },
 [0x0682]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH WITH TWO DOTS VERTICAL ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x062D,
  ["unicodeslot"]=0x0682, -- ڂ
 },
 [0x0683]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NYEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0683, -- ڃ
 },
 [0x0684]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DYEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0684, -- ڄ
 },
 [0x0685]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH WITH THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x062D,
  ["unicodeslot"]=0x0685, -- څ
 },
 [0x0686]={
  ["adobename"]="afii57507",
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0686, -- چ
 },
 [0x0687]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEHEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0687, -- ڇ
 },
 [0x0688]={
  ["adobename"]="afii57512",
  ["category"]="lo",
  ["description"]="ARABIC LETTER DDAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0688, -- ڈ
 },
 [0x0689]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL WITH RING",
  ["linebreak"]="al",
  ["shcode"]=0x062F,
  ["unicodeslot"]=0x0689, -- ډ
 },
 [0x068A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x062F,
  ["unicodeslot"]=0x068A, -- ڊ
 },
 [0x068B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL WITH DOT BELOW AND SMALL TAH",
  ["linebreak"]="al",
  ["shcode"]=0x062F,
  ["unicodeslot"]=0x068B, -- ڋ
 },
 [0x068C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAHAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x068C, -- ڌ
 },
 [0x068D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DDAHAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x068D, -- ڍ
 },
 [0x068E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DUL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x068E, -- ڎ
 },
 [0x068F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL WITH THREE DOTS ABOVE DOWNWARDS",
  ["linebreak"]="al",
  ["shcode"]=0x062F,
  ["unicodeslot"]=0x068F, -- ڏ
 },
 [0x0690]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL WITH FOUR DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x062F,
  ["unicodeslot"]=0x0690, -- ڐ
 },
 [0x0691]={
  ["adobename"]="afii57513",
  ["category"]="lo",
  ["description"]="ARABIC LETTER RREH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0691, -- ڑ
 },
 [0x0692]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH SMALL V",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x0692, -- ڒ
 },
 [0x0693]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH RING",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x0693, -- ړ
 },
 [0x0694]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x0694, -- ڔ
 },
 [0x0695]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH SMALL V BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x0695, -- ڕ
 },
 [0x0696]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH DOT BELOW AND DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x0696, -- ږ
 },
 [0x0697]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH TWO DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x0697, -- ڗ
 },
 [0x0698]={
  ["adobename"]="afii57508",
  ["category"]="lo",
  ["description"]="ARABIC LETTER JEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0698, -- ژ
 },
 [0x0699]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH FOUR DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x0699, -- ڙ
 },
 [0x069A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN WITH DOT BELOW AND DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0633,
  ["unicodeslot"]=0x069A, -- ښ
 },
 [0x069B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN WITH THREE DOTS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0633,
  ["unicodeslot"]=0x069B, -- ڛ
 },
 [0x069C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN WITH THREE DOTS BELOW AND THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0633,
  ["unicodeslot"]=0x069C, -- ڜ
 },
 [0x069D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SAD WITH TWO DOTS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0635,
  ["unicodeslot"]=0x069D, -- ڝ
 },
 [0x069E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SAD WITH THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0635,
  ["unicodeslot"]=0x069E, -- ڞ
 },
 [0x069F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TAH WITH THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0637,
  ["unicodeslot"]=0x069F, -- ڟ
 },
 [0x06A0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER AIN WITH THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0639,
  ["unicodeslot"]=0x06A0, -- ڠ
 },
 [0x06A1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DOTLESS FEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06A1, -- ڡ
 },
 [0x06A2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH WITH DOT MOVED BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0641,
  ["unicodeslot"]=0x06A2, -- ڢ
 },
 [0x06A3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0641,
  ["unicodeslot"]=0x06A3, -- ڣ
 },
 [0x06A4]={
  ["adobename"]="afii57505",
  ["category"]="lo",
  ["description"]="ARABIC LETTER VEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06A4, -- ڤ
 },
 [0x06A5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH WITH THREE DOTS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0641,
  ["unicodeslot"]=0x06A5, -- ڥ
 },
 [0x06A6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEHEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06A6, -- ڦ
 },
 [0x06A7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER QAF WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0642,
  ["unicodeslot"]=0x06A7, -- ڧ
 },
 [0x06A8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER QAF WITH THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0642,
  ["unicodeslot"]=0x06A8, -- ڨ
 },
 [0x06A9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KEHEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06A9, -- ک
 },
 [0x06AA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SWASH KAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06AA, -- ڪ
 },
 [0x06AB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KAF WITH RING",
  ["linebreak"]="al",
  ["shcode"]=0x0643,
  ["unicodeslot"]=0x06AB, -- ګ
 },
 [0x06AC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KAF WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0643,
  ["unicodeslot"]=0x06AC, -- ڬ
 },
 [0x06AD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06AD, -- ڭ
 },
 [0x06AE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KAF WITH THREE DOTS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0643,
  ["unicodeslot"]=0x06AE, -- ڮ
 },
 [0x06AF]={
  ["adobename"]="afii57509",
  ["category"]="lo",
  ["description"]="ARABIC LETTER GAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06AF, -- گ
 },
 [0x06B0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GAF WITH RING",
  ["linebreak"]="al",
  ["shcode"]=0x06AF,
  ["unicodeslot"]=0x06B0, -- ڰ
 },
 [0x06B1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NGOEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06B1, -- ڱ
 },
 [0x06B2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GAF WITH TWO DOTS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x06AF,
  ["unicodeslot"]=0x06B2, -- ڲ
 },
 [0x06B3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GUEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06B3, -- ڳ
 },
 [0x06B4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GAF WITH THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x06AF,
  ["unicodeslot"]=0x06B4, -- ڴ
 },
 [0x06B5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM WITH SMALL V",
  ["linebreak"]="al",
  ["shcode"]=0x0644,
  ["unicodeslot"]=0x06B5, -- ڵ
 },
 [0x06B6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0644,
  ["unicodeslot"]=0x06B6, -- ڶ
 },
 [0x06B7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM WITH THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0644,
  ["unicodeslot"]=0x06B7, -- ڷ
 },
 [0x06B8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM WITH THREE DOTS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0644,
  ["unicodeslot"]=0x06B8, -- ڸ
 },
 [0x06B9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0646,
  ["unicodeslot"]=0x06B9, -- ڹ
 },
 [0x06BA]={
  ["adobename"]="afii57514",
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON GHUNNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06BA, -- ں
 },
 [0x06BB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER RNOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06BB, -- ڻ
 },
 [0x06BC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON WITH RING",
  ["linebreak"]="al",
  ["shcode"]=0x0646,
  ["unicodeslot"]=0x06BC, -- ڼ
 },
 [0x06BD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON WITH THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0646,
  ["unicodeslot"]=0x06BD, -- ڽ
 },
 [0x06BE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH DOACHASHMEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06BE, -- ھ
 },
 [0x06BF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEH WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0686,
  ["unicodeslot"]=0x06BF, -- ڿ
 },
 [0x06C0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH WITH YEH ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0647,
  ["specials"]={ "char", 0x06D5, 0x0654 },
  ["unicodeslot"]=0x06C0, -- ۀ
 },
 [0x06C1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH GOAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06C1, -- ہ
 },
 [0x06C2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH GOAL WITH HAMZA ABOVE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x06C1, 0x0654 },
  ["unicodeslot"]=0x06C2, -- ۂ
 },
 [0x06C3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH MARBUTA GOAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06C3, -- ۃ
 },
 [0x06C4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER WAW WITH RING",
  ["linebreak"]="al",
  ["shcode"]=0x0648,
  ["unicodeslot"]=0x06C4, -- ۄ
 },
 [0x06C5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KIRGHIZ OE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06C5, -- ۅ
 },
 [0x06C6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER OE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06C6, -- ۆ
 },
 [0x06C7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06C7, -- ۇ
 },
 [0x06C8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06C8, -- ۈ
 },
 [0x06C9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KIRGHIZ YU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06C9, -- ۉ
 },
 [0x06CA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER WAW WITH TWO DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0648,
  ["unicodeslot"]=0x06CA, -- ۊ
 },
 [0x06CB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER VE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06CB, -- ۋ
 },
 [0x06CC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FARSI YEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06CC, -- ی
 },
 [0x06CD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH WITH TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x064A,
  ["unicodeslot"]=0x06CD, -- ۍ
 },
 [0x06CE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH WITH SMALL V",
  ["linebreak"]="al",
  ["shcode"]=0x064A,
  ["unicodeslot"]=0x06CE, -- ێ
 },
 [0x06CF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER WAW WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0648,
  ["unicodeslot"]=0x06CF, -- ۏ
 },
 [0x06D0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06D0, -- ې
 },
 [0x06D1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH WITH THREE DOTS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x064A,
  ["unicodeslot"]=0x06D1, -- ۑ
 },
 [0x06D2]={
  ["adobename"]="afii57519",
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH BARREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06D2, -- ے
 },
 [0x06D3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH BARREE WITH HAMZA ABOVE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x06D2, 0x0654 },
  ["unicodeslot"]=0x06D3, -- ۓ
 },
 [0x06D4]={
  ["category"]="po",
  ["description"]="ARABIC FULL STOP",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x06D4, -- ۔
 },
 [0x06D5]={
  ["adobename"]="afii57534",
  ["category"]="lo",
  ["description"]="ARABIC LETTER AE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06D5, -- ە
 },
 [0x06D6]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH LIGATURE SAD WITH LAM WITH ALEF MAKSURA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06D6, -- ۖ
 },
 [0x06D7]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH LIGATURE QAF WITH LAM WITH ALEF MAKSURA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06D7, -- ۗ
 },
 [0x06D8]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH MEEM INITIAL FORM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06D8, -- ۘ
 },
 [0x06D9]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH LAM ALEF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06D9, -- ۙ
 },
 [0x06DA]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH JEEM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06DA, -- ۚ
 },
 [0x06DB]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH THREE DOTS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06DB, -- ۛ
 },
 [0x06DC]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH SEEN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06DC, -- ۜ
 },
 [0x06DD]={
  ["category"]="cf",
  ["description"]="ARABIC END OF AYAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06DD, -- ۝
 },
 [0x06DE]={
  ["category"]="me",
  ["description"]="ARABIC START OF RUB EL HIZB",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06DE, -- ۞
 },
 [0x06DF]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH ROUNDED ZERO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06DF, -- ۟
 },
 [0x06E0]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH UPRIGHT RECTANGULAR ZERO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06E0, -- ۠
 },
 [0x06E1]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH DOTLESS HEAD OF KHAH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06E1, -- ۡ
 },
 [0x06E2]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH MEEM ISOLATED FORM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06E2, -- ۢ
 },
 [0x06E3]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL LOW SEEN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06E3, -- ۣ
 },
 [0x06E4]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH MADDA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06E4, -- ۤ
 },
 [0x06E5]={
  ["category"]="lm",
  ["description"]="ARABIC SMALL WAW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06E5, -- ۥ
 },
 [0x06E6]={
  ["category"]="lm",
  ["description"]="ARABIC SMALL YEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06E6, -- ۦ
 },
 [0x06E7]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH YEH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06E7, -- ۧ
 },
 [0x06E8]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL HIGH NOON",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06E8, -- ۨ
 },
 [0x06E9]={
  ["category"]="so",
  ["description"]="ARABIC PLACE OF SAJDAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06E9, -- ۩
 },
 [0x06EA]={
  ["category"]="mn",
  ["description"]="ARABIC EMPTY CENTRE LOW STOP",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06EA, -- ۪
 },
 [0x06EB]={
  ["category"]="mn",
  ["description"]="ARABIC EMPTY CENTRE HIGH STOP",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06EB, -- ۫
 },
 [0x06EC]={
  ["category"]="mn",
  ["description"]="ARABIC ROUNDED HIGH STOP WITH FILLED CENTRE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06EC, -- ۬
 },
 [0x06ED]={
  ["category"]="mn",
  ["description"]="ARABIC SMALL LOW MEEM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x06ED, -- ۭ
 },
 [0x06EE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL WITH INVERTED V",
  ["linebreak"]="al",
  ["shcode"]=0x062F,
  ["unicodeslot"]=0x06EE, -- ۮ
 },
 [0x06EF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH INVERTED V",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x06EF, -- ۯ
 },
 [0x06F0]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F0, -- ۰
 },
 [0x06F1]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F1, -- ۱
 },
 [0x06F2]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F2, -- ۲
 },
 [0x06F3]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F3, -- ۳
 },
 [0x06F4]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F4, -- ۴
 },
 [0x06F5]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F5, -- ۵
 },
 [0x06F6]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F6, -- ۶
 },
 [0x06F7]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F7, -- ۷
 },
 [0x06F8]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F8, -- ۸
 },
 [0x06F9]={
  ["category"]="nd",
  ["description"]="EXTENDED ARABIC-INDIC DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x06F9, -- ۹
 },
 [0x06FA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SHEEN WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0634,
  ["unicodeslot"]=0x06FA, -- ۺ
 },
 [0x06FB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAD WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0636,
  ["unicodeslot"]=0x06FB, -- ۻ
 },
 [0x06FC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GHAIN WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x063A,
  ["unicodeslot"]=0x06FC, -- ۼ
 },
 [0x06FD]={
  ["category"]="so",
  ["description"]="ARABIC SIGN SINDHI AMPERSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06FD, -- ۽
 },
 [0x06FE]={
  ["category"]="so",
  ["description"]="ARABIC SIGN SINDHI POSTPOSITION MEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x06FE, -- ۾
 },
 [0x06FF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH WITH INVERTED V",
  ["linebreak"]="al",
  ["shcode"]=0x0647,
  ["unicodeslot"]=0x06FF, -- ۿ
 },
 [0x0700]={
  ["category"]="po",
  ["description"]="SYRIAC END OF PARAGRAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0700, -- ܀
 },
 [0x0701]={
  ["category"]="po",
  ["description"]="SYRIAC SUPRALINEAR FULL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0701, -- ܁
 },
 [0x0702]={
  ["category"]="po",
  ["description"]="SYRIAC SUBLINEAR FULL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0702, -- ܂
 },
 [0x0703]={
  ["category"]="po",
  ["description"]="SYRIAC SUPRALINEAR COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0703, -- ܃
 },
 [0x0704]={
  ["category"]="po",
  ["description"]="SYRIAC SUBLINEAR COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0704, -- ܄
 },
 [0x0705]={
  ["category"]="po",
  ["description"]="SYRIAC HORIZONTAL COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0705, -- ܅
 },
 [0x0706]={
  ["category"]="po",
  ["description"]="SYRIAC COLON SKEWED LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0706, -- ܆
 },
 [0x0707]={
  ["category"]="po",
  ["description"]="SYRIAC COLON SKEWED RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0707, -- ܇
 },
 [0x0708]={
  ["category"]="po",
  ["description"]="SYRIAC SUPRALINEAR COLON SKEWED LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0708, -- ܈
 },
 [0x0709]={
  ["category"]="po",
  ["description"]="SYRIAC SUBLINEAR COLON SKEWED RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0709, -- ܉
 },
 [0x070A]={
  ["category"]="po",
  ["description"]="SYRIAC CONTRACTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x070A, -- ܊
 },
 [0x070B]={
  ["category"]="po",
  ["description"]="SYRIAC HARKLEAN OBELUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x070B, -- ܋
 },
 [0x070C]={
  ["category"]="po",
  ["description"]="SYRIAC HARKLEAN METOBELUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x070C, -- ܌
 },
 [0x070D]={
  ["category"]="po",
  ["description"]="SYRIAC HARKLEAN ASTERISCUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x070D, -- ܍
 },
 [0x070F]={
  ["category"]="cf",
  ["description"]="SYRIAC ABBREVIATION MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x070F, -- ܏
 },
 [0x0710]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER ALAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0710, -- ܐ
 },
 [0x0711]={
  ["category"]="mn",
  ["description"]="SYRIAC LETTER SUPERSCRIPT ALAPH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0711, -- ܑ
 },
 [0x0712]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER BETH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0712, -- ܒ
 },
 [0x0713]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER GAMAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0713, -- ܓ
 },
 [0x0714]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER GAMAL GARSHUNI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0714, -- ܔ
 },
 [0x0715]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER DALATH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0715, -- ܕ
 },
 [0x0716]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER DOTLESS DALATH RISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0716, -- ܖ
 },
 [0x0717]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0717, -- ܗ
 },
 [0x0718]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER WAW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0718, -- ܘ
 },
 [0x0719]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER ZAIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0719, -- ܙ
 },
 [0x071A]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER HETH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x071A, -- ܚ
 },
 [0x071B]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER TETH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x071B, -- ܛ
 },
 [0x071C]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER TETH GARSHUNI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x071C, -- ܜ
 },
 [0x071D]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER YUDH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x071D, -- ܝ
 },
 [0x071E]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER YUDH HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x071E, -- ܞ
 },
 [0x071F]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER KAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x071F, -- ܟ
 },
 [0x0720]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER LAMADH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0720, -- ܠ
 },
 [0x0721]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER MIM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0721, -- ܡ
 },
 [0x0722]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0722, -- ܢ
 },
 [0x0723]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER SEMKATH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0723, -- ܣ
 },
 [0x0724]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER FINAL SEMKATH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0724, -- ܤ
 },
 [0x0725]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0725, -- ܥ
 },
 [0x0726]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0726, -- ܦ
 },
 [0x0727]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER REVERSED PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0727, -- ܧ
 },
 [0x0728]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER SADHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0728, -- ܨ
 },
 [0x0729]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER QAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0729, -- ܩ
 },
 [0x072A]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER RISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x072A, -- ܪ
 },
 [0x072B]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER SHIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x072B, -- ܫ
 },
 [0x072C]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER TAW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x072C, -- ܬ
 },
 [0x072D]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER PERSIAN BHETH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x072D, -- ܭ
 },
 [0x072E]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER PERSIAN GHAMAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x072E, -- ܮ
 },
 [0x072F]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER PERSIAN DHALATH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x072F, -- ܯ
 },
 [0x0730]={
  ["category"]="mn",
  ["description"]="SYRIAC PTHAHA ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0730, -- ܰ
 },
 [0x0731]={
  ["category"]="mn",
  ["description"]="SYRIAC PTHAHA BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0731, -- ܱ
 },
 [0x0732]={
  ["category"]="mn",
  ["description"]="SYRIAC PTHAHA DOTTED",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0732, -- ܲ
 },
 [0x0733]={
  ["category"]="mn",
  ["description"]="SYRIAC ZQAPHA ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0733, -- ܳ
 },
 [0x0734]={
  ["category"]="mn",
  ["description"]="SYRIAC ZQAPHA BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0734, -- ܴ
 },
 [0x0735]={
  ["category"]="mn",
  ["description"]="SYRIAC ZQAPHA DOTTED",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0735, -- ܵ
 },
 [0x0736]={
  ["category"]="mn",
  ["description"]="SYRIAC RBASA ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0736, -- ܶ
 },
 [0x0737]={
  ["category"]="mn",
  ["description"]="SYRIAC RBASA BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0737, -- ܷ
 },
 [0x0738]={
  ["category"]="mn",
  ["description"]="SYRIAC DOTTED ZLAMA HORIZONTAL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0738, -- ܸ
 },
 [0x0739]={
  ["category"]="mn",
  ["description"]="SYRIAC DOTTED ZLAMA ANGULAR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0739, -- ܹ
 },
 [0x073A]={
  ["category"]="mn",
  ["description"]="SYRIAC HBASA ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x073A, -- ܺ
 },
 [0x073B]={
  ["category"]="mn",
  ["description"]="SYRIAC HBASA BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x073B, -- ܻ
 },
 [0x073C]={
  ["category"]="mn",
  ["description"]="SYRIAC HBASA-ESASA DOTTED",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x073C, -- ܼ
 },
 [0x073D]={
  ["category"]="mn",
  ["description"]="SYRIAC ESASA ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x073D, -- ܽ
 },
 [0x073E]={
  ["category"]="mn",
  ["description"]="SYRIAC ESASA BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x073E, -- ܾ
 },
 [0x073F]={
  ["category"]="mn",
  ["description"]="SYRIAC RWAHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x073F, -- ܿ
 },
 [0x0740]={
  ["category"]="mn",
  ["description"]="SYRIAC FEMININE DOT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0740, -- ݀
 },
 [0x0741]={
  ["category"]="mn",
  ["description"]="SYRIAC QUSHSHAYA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0741, -- ݁
 },
 [0x0742]={
  ["category"]="mn",
  ["description"]="SYRIAC RUKKAKHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0742, -- ݂
 },
 [0x0743]={
  ["category"]="mn",
  ["description"]="SYRIAC TWO VERTICAL DOTS ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0743, -- ݃
 },
 [0x0744]={
  ["category"]="mn",
  ["description"]="SYRIAC TWO VERTICAL DOTS BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0744, -- ݄
 },
 [0x0745]={
  ["category"]="mn",
  ["description"]="SYRIAC THREE DOTS ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0745, -- ݅
 },
 [0x0746]={
  ["category"]="mn",
  ["description"]="SYRIAC THREE DOTS BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0746, -- ݆
 },
 [0x0747]={
  ["category"]="mn",
  ["description"]="SYRIAC OBLIQUE LINE ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0747, -- ݇
 },
 [0x0748]={
  ["category"]="mn",
  ["description"]="SYRIAC OBLIQUE LINE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0748, -- ݈
 },
 [0x0749]={
  ["category"]="mn",
  ["description"]="SYRIAC MUSIC",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0749, -- ݉
 },
 [0x074A]={
  ["category"]="mn",
  ["description"]="SYRIAC BARREKH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x074A, -- ݊
 },
 [0x074D]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER SOGDIAN ZHAIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x074D, -- ݍ
 },
 [0x074E]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER SOGDIAN KHAPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x074E, -- ݎ
 },
 [0x074F]={
  ["category"]="lo",
  ["description"]="SYRIAC LETTER SOGDIAN FE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x074F, -- ݏ
 },
 [0x0750]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH WITH THREE DOTS HORIZONTALLY BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0628,
  ["unicodeslot"]=0x0750, -- ݐ
 },
 [0x0751]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH WITH DOT BELOW AND THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0628,
  ["unicodeslot"]=0x0751, -- ݑ
 },
 [0x0752]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0628,
  ["unicodeslot"]=0x0752, -- ݒ
 },
 [0x0753]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW AND TWO DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0628,
  ["unicodeslot"]=0x0753, -- ݓ
 },
 [0x0754]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH WITH TWO DOTS BELOW AND DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0628,
  ["unicodeslot"]=0x0754, -- ݔ
 },
 [0x0755]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH WITH INVERTED SMALL V BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0628,
  ["unicodeslot"]=0x0755, -- ݕ
 },
 [0x0756]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH WITH SMALL V",
  ["linebreak"]="al",
  ["shcode"]=0x0628,
  ["unicodeslot"]=0x0756, -- ݖ
 },
 [0x0757]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH WITH TWO DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x062D,
  ["unicodeslot"]=0x0757, -- ݗ
 },
 [0x0758]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH WITH THREE DOTS POINTING UPWARDS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x062D,
  ["unicodeslot"]=0x0758, -- ݘ
 },
 [0x0759]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL WITH TWO DOTS VERTICALLY BELOW AND SMALL TAH",
  ["linebreak"]="al",
  ["shcode"]=0x062F,
  ["unicodeslot"]=0x0759, -- ݙ
 },
 [0x075A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL WITH INVERTED SMALL V BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x062F,
  ["unicodeslot"]=0x075A, -- ݚ
 },
 [0x075B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x075B, -- ݛ
 },
 [0x075C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN WITH FOUR DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0633,
  ["unicodeslot"]=0x075C, -- ݜ
 },
 [0x075D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER AIN WITH TWO DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0639,
  ["unicodeslot"]=0x075D, -- ݝ
 },
 [0x075E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER AIN WITH THREE DOTS POINTING DOWNWARDS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0639,
  ["unicodeslot"]=0x075E, -- ݞ
 },
 [0x075F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER AIN WITH TWO DOTS VERTICALLY ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0639,
  ["unicodeslot"]=0x075F, -- ݟ
 },
 [0x0760]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH WITH TWO DOTS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0641,
  ["unicodeslot"]=0x0760, -- ݠ
 },
 [0x0761]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH WITH THREE DOTS POINTING UPWARDS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0641,
  ["unicodeslot"]=0x0761, -- ݡ
 },
 [0x0762]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KEHEH WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x06A9,
  ["unicodeslot"]=0x0762, -- ݢ
 },
 [0x0763]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KEHEH WITH THREE DOTS ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x06A9,
  ["unicodeslot"]=0x0763, -- ݣ
 },
 [0x0764]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KEHEH WITH THREE DOTS POINTING UPWARDS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x06A9,
  ["unicodeslot"]=0x0764, -- ݤ
 },
 [0x0765]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER MEEM WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0645,
  ["unicodeslot"]=0x0765, -- ݥ
 },
 [0x0766]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER MEEM WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0645,
  ["unicodeslot"]=0x0766, -- ݦ
 },
 [0x0767]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON WITH TWO DOTS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0646,
  ["unicodeslot"]=0x0767, -- ݧ
 },
 [0x0768]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON WITH SMALL TAH",
  ["linebreak"]="al",
  ["shcode"]=0x0646,
  ["unicodeslot"]=0x0768, -- ݨ
 },
 [0x0769]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON WITH SMALL V",
  ["linebreak"]="al",
  ["shcode"]=0x0646,
  ["unicodeslot"]=0x0769, -- ݩ
 },
 [0x076A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM WITH BAR",
  ["linebreak"]="al",
  ["shcode"]=0x0644,
  ["unicodeslot"]=0x076A, -- ݪ
 },
 [0x076B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH TWO DOTS VERTICALLY ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x076B, -- ݫ
 },
 [0x076C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH WITH HAMZA ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0631,
  ["unicodeslot"]=0x076C, -- ݬ
 },
 [0x076D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN WITH TWO DOTS VERTICALLY ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0633,
  ["unicodeslot"]=0x076D, -- ݭ
 },
 [0x0780]={
  ["category"]="lo",
  ["description"]="THAANA LETTER HAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0780, -- ހ
 },
 [0x0781]={
  ["category"]="lo",
  ["description"]="THAANA LETTER SHAVIYANI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0781, -- ށ
 },
 [0x0782]={
  ["category"]="lo",
  ["description"]="THAANA LETTER NOONU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0782, -- ނ
 },
 [0x0783]={
  ["category"]="lo",
  ["description"]="THAANA LETTER RAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0783, -- ރ
 },
 [0x0784]={
  ["category"]="lo",
  ["description"]="THAANA LETTER BAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0784, -- ބ
 },
 [0x0785]={
  ["category"]="lo",
  ["description"]="THAANA LETTER LHAVIYANI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0785, -- ޅ
 },
 [0x0786]={
  ["category"]="lo",
  ["description"]="THAANA LETTER KAAFU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0786, -- ކ
 },
 [0x0787]={
  ["category"]="lo",
  ["description"]="THAANA LETTER ALIFU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0787, -- އ
 },
 [0x0788]={
  ["category"]="lo",
  ["description"]="THAANA LETTER VAAVU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0788, -- ވ
 },
 [0x0789]={
  ["category"]="lo",
  ["description"]="THAANA LETTER MEEMU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0789, -- މ
 },
 [0x078A]={
  ["category"]="lo",
  ["description"]="THAANA LETTER FAAFU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x078A, -- ފ
 },
 [0x078B]={
  ["category"]="lo",
  ["description"]="THAANA LETTER DHAALU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x078B, -- ދ
 },
 [0x078C]={
  ["category"]="lo",
  ["description"]="THAANA LETTER THAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x078C, -- ތ
 },
 [0x078D]={
  ["category"]="lo",
  ["description"]="THAANA LETTER LAAMU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x078D, -- ލ
 },
 [0x078E]={
  ["category"]="lo",
  ["description"]="THAANA LETTER GAAFU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x078E, -- ގ
 },
 [0x078F]={
  ["category"]="lo",
  ["description"]="THAANA LETTER GNAVIYANI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x078F, -- ޏ
 },
 [0x0790]={
  ["category"]="lo",
  ["description"]="THAANA LETTER SEENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0790, -- ސ
 },
 [0x0791]={
  ["category"]="lo",
  ["description"]="THAANA LETTER DAVIYANI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0791, -- ޑ
 },
 [0x0792]={
  ["category"]="lo",
  ["description"]="THAANA LETTER ZAVIYANI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0792, -- ޒ
 },
 [0x0793]={
  ["category"]="lo",
  ["description"]="THAANA LETTER TAVIYANI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0793, -- ޓ
 },
 [0x0794]={
  ["category"]="lo",
  ["description"]="THAANA LETTER YAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0794, -- ޔ
 },
 [0x0795]={
  ["category"]="lo",
  ["description"]="THAANA LETTER PAVIYANI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0795, -- ޕ
 },
 [0x0796]={
  ["category"]="lo",
  ["description"]="THAANA LETTER JAVIYANI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0796, -- ޖ
 },
 [0x0797]={
  ["category"]="lo",
  ["description"]="THAANA LETTER CHAVIYANI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0797, -- ޗ
 },
 [0x0798]={
  ["category"]="lo",
  ["description"]="THAANA LETTER TTAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0798, -- ޘ
 },
 [0x0799]={
  ["category"]="lo",
  ["description"]="THAANA LETTER HHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0799, -- ޙ
 },
 [0x079A]={
  ["category"]="lo",
  ["description"]="THAANA LETTER KHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x079A, -- ޚ
 },
 [0x079B]={
  ["category"]="lo",
  ["description"]="THAANA LETTER THAALU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x079B, -- ޛ
 },
 [0x079C]={
  ["category"]="lo",
  ["description"]="THAANA LETTER ZAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x079C, -- ޜ
 },
 [0x079D]={
  ["category"]="lo",
  ["description"]="THAANA LETTER SHEENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x079D, -- ޝ
 },
 [0x079E]={
  ["category"]="lo",
  ["description"]="THAANA LETTER SAADHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x079E, -- ޞ
 },
 [0x079F]={
  ["category"]="lo",
  ["description"]="THAANA LETTER DAADHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x079F, -- ޟ
 },
 [0x07A0]={
  ["category"]="lo",
  ["description"]="THAANA LETTER TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07A0, -- ޠ
 },
 [0x07A1]={
  ["category"]="lo",
  ["description"]="THAANA LETTER ZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07A1, -- ޡ
 },
 [0x07A2]={
  ["category"]="lo",
  ["description"]="THAANA LETTER AINU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07A2, -- ޢ
 },
 [0x07A3]={
  ["category"]="lo",
  ["description"]="THAANA LETTER GHAINU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07A3, -- ޣ
 },
 [0x07A4]={
  ["category"]="lo",
  ["description"]="THAANA LETTER QAAFU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07A4, -- ޤ
 },
 [0x07A5]={
  ["category"]="lo",
  ["description"]="THAANA LETTER WAAVU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07A5, -- ޥ
 },
 [0x07A6]={
  ["category"]="mn",
  ["description"]="THAANA ABAFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07A6, -- ަ
 },
 [0x07A7]={
  ["category"]="mn",
  ["description"]="THAANA AABAAFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07A7, -- ާ
 },
 [0x07A8]={
  ["category"]="mn",
  ["description"]="THAANA IBIFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07A8, -- ި
 },
 [0x07A9]={
  ["category"]="mn",
  ["description"]="THAANA EEBEEFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07A9, -- ީ
 },
 [0x07AA]={
  ["category"]="mn",
  ["description"]="THAANA UBUFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07AA, -- ު
 },
 [0x07AB]={
  ["category"]="mn",
  ["description"]="THAANA OOBOOFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07AB, -- ޫ
 },
 [0x07AC]={
  ["category"]="mn",
  ["description"]="THAANA EBEFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07AC, -- ެ
 },
 [0x07AD]={
  ["category"]="mn",
  ["description"]="THAANA EYBEYFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07AD, -- ޭ
 },
 [0x07AE]={
  ["category"]="mn",
  ["description"]="THAANA OBOFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07AE, -- ޮ
 },
 [0x07AF]={
  ["category"]="mn",
  ["description"]="THAANA OABOAFILI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07AF, -- ޯ
 },
 [0x07B0]={
  ["category"]="mn",
  ["description"]="THAANA SUKUN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07B0, -- ް
 },
 [0x07B1]={
  ["category"]="lo",
  ["description"]="THAANA LETTER NAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07B1, -- ޱ
 },
 [0x07C0]={
  ["category"]="nd",
  ["description"]="NKO DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C0, -- ߀
 },
 [0x07C1]={
  ["category"]="nd",
  ["description"]="NKO DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C1, -- ߁
 },
 [0x07C2]={
  ["category"]="nd",
  ["description"]="NKO DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C2, -- ߂
 },
 [0x07C3]={
  ["category"]="nd",
  ["description"]="NKO DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C3, -- ߃
 },
 [0x07C4]={
  ["category"]="nd",
  ["description"]="NKO DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C4, -- ߄
 },
 [0x07C5]={
  ["category"]="nd",
  ["description"]="NKO DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C5, -- ߅
 },
 [0x07C6]={
  ["category"]="nd",
  ["description"]="NKO DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C6, -- ߆
 },
 [0x07C7]={
  ["category"]="nd",
  ["description"]="NKO DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C7, -- ߇
 },
 [0x07C8]={
  ["category"]="nd",
  ["description"]="NKO DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C8, -- ߈
 },
 [0x07C9]={
  ["category"]="nd",
  ["description"]="NKO DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x07C9, -- ߉
 },
 [0x07CA]={
  ["category"]="lo",
  ["description"]="NKO LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07CA, -- ߊ
 },
 [0x07CB]={
  ["category"]="lo",
  ["description"]="NKO LETTER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07CB, -- ߋ
 },
 [0x07CC]={
  ["category"]="lo",
  ["description"]="NKO LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07CC, -- ߌ
 },
 [0x07CD]={
  ["category"]="lo",
  ["description"]="NKO LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07CD, -- ߍ
 },
 [0x07CE]={
  ["category"]="lo",
  ["description"]="NKO LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07CE, -- ߎ
 },
 [0x07CF]={
  ["category"]="lo",
  ["description"]="NKO LETTER OO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07CF, -- ߏ
 },
 [0x07D0]={
  ["category"]="lo",
  ["description"]="NKO LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D0, -- ߐ
 },
 [0x07D1]={
  ["category"]="lo",
  ["description"]="NKO LETTER DAGBASINNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D1, -- ߑ
 },
 [0x07D2]={
  ["category"]="lo",
  ["description"]="NKO LETTER N",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D2, -- ߒ
 },
 [0x07D3]={
  ["category"]="lo",
  ["description"]="NKO LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D3, -- ߓ
 },
 [0x07D4]={
  ["category"]="lo",
  ["description"]="NKO LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D4, -- ߔ
 },
 [0x07D5]={
  ["category"]="lo",
  ["description"]="NKO LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D5, -- ߕ
 },
 [0x07D6]={
  ["category"]="lo",
  ["description"]="NKO LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D6, -- ߖ
 },
 [0x07D7]={
  ["category"]="lo",
  ["description"]="NKO LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D7, -- ߗ
 },
 [0x07D8]={
  ["category"]="lo",
  ["description"]="NKO LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D8, -- ߘ
 },
 [0x07D9]={
  ["category"]="lo",
  ["description"]="NKO LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07D9, -- ߙ
 },
 [0x07DA]={
  ["category"]="lo",
  ["description"]="NKO LETTER RRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07DA, -- ߚ
 },
 [0x07DB]={
  ["category"]="lo",
  ["description"]="NKO LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07DB, -- ߛ
 },
 [0x07DC]={
  ["category"]="lo",
  ["description"]="NKO LETTER GBA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07DC, -- ߜ
 },
 [0x07DD]={
  ["category"]="lo",
  ["description"]="NKO LETTER FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07DD, -- ߝ
 },
 [0x07DE]={
  ["category"]="lo",
  ["description"]="NKO LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07DE, -- ߞ
 },
 [0x07DF]={
  ["category"]="lo",
  ["description"]="NKO LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07DF, -- ߟ
 },
 [0x07E0]={
  ["category"]="lo",
  ["description"]="NKO LETTER NA WOLOSO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E0, -- ߠ
 },
 [0x07E1]={
  ["category"]="lo",
  ["description"]="NKO LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E1, -- ߡ
 },
 [0x07E2]={
  ["category"]="lo",
  ["description"]="NKO LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E2, -- ߢ
 },
 [0x07E3]={
  ["category"]="lo",
  ["description"]="NKO LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E3, -- ߣ
 },
 [0x07E4]={
  ["category"]="lo",
  ["description"]="NKO LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E4, -- ߤ
 },
 [0x07E5]={
  ["category"]="lo",
  ["description"]="NKO LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E5, -- ߥ
 },
 [0x07E6]={
  ["category"]="lo",
  ["description"]="NKO LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E6, -- ߦ
 },
 [0x07E7]={
  ["category"]="lo",
  ["description"]="NKO LETTER NYA WOLOSO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E7, -- ߧ
 },
 [0x07E8]={
  ["category"]="lo",
  ["description"]="NKO LETTER JONA JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E8, -- ߨ
 },
 [0x07E9]={
  ["category"]="lo",
  ["description"]="NKO LETTER JONA CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07E9, -- ߩ
 },
 [0x07EA]={
  ["category"]="lo",
  ["description"]="NKO LETTER JONA RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07EA, -- ߪ
 },
 [0x07EB]={
  ["category"]="mn",
  ["description"]="NKO COMBINING SHORT HIGH TONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07EB, -- ߫
 },
 [0x07EC]={
  ["category"]="mn",
  ["description"]="NKO COMBINING SHORT LOW TONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07EC, -- ߬
 },
 [0x07ED]={
  ["category"]="mn",
  ["description"]="NKO COMBINING SHORT RISING TONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07ED, -- ߭
 },
 [0x07EE]={
  ["category"]="mn",
  ["description"]="NKO COMBINING LONG DESCENDING TONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07EE, -- ߮
 },
 [0x07EF]={
  ["category"]="mn",
  ["description"]="NKO COMBINING LONG HIGH TONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07EF, -- ߯
 },
 [0x07F0]={
  ["category"]="mn",
  ["description"]="NKO COMBINING LONG LOW TONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07F0, -- ߰
 },
 [0x07F1]={
  ["category"]="mn",
  ["description"]="NKO COMBINING LONG RISING TONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07F1, -- ߱
 },
 [0x07F2]={
  ["category"]="mn",
  ["description"]="NKO COMBINING NASALIZATION MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07F2, -- ߲
 },
 [0x07F3]={
  ["category"]="mn",
  ["description"]="NKO COMBINING DOUBLE DOT ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x07F3, -- ߳
 },
 [0x07F4]={
  ["category"]="lm",
  ["description"]="NKO HIGH TONE APOSTROPHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07F4, -- ߴ
 },
 [0x07F5]={
  ["category"]="lm",
  ["description"]="NKO LOW TONE APOSTROPHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07F5, -- ߵ
 },
 [0x07F6]={
  ["category"]="so",
  ["description"]="NKO SYMBOL OO DENNEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07F6, -- ߶
 },
 [0x07F7]={
  ["category"]="po",
  ["description"]="NKO SYMBOL GBAKURUNEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07F7, -- ߷
 },
 [0x07F8]={
  ["category"]="po",
  ["description"]="NKO COMMA",
  ["linebreak"]="is",
  ["unicodeslot"]=0x07F8, -- ߸
 },
 [0x07F9]={
  ["category"]="po",
  ["description"]="NKO EXCLAMATION MARK",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x07F9, -- ߹
 },
 [0x07FA]={
  ["category"]="lm",
  ["description"]="NKO LAJANYALAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x07FA, -- ߺ
 },
 [0x0901]={
  ["category"]="mn",
  ["description"]="DEVANAGARI SIGN CANDRABINDU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0901, -- ँ
 },
 [0x0902]={
  ["category"]="mn",
  ["description"]="DEVANAGARI SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0902, -- ं
 },
 [0x0903]={
  ["category"]="mc",
  ["description"]="DEVANAGARI SIGN VISARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0903, -- ः
 },
 [0x0904]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER SHORT A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0904, -- ऄ
 },
 [0x0905]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0905, -- अ
 },
 [0x0906]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0906, -- आ
 },
 [0x0907]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0907, -- इ
 },
 [0x0908]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0908, -- ई
 },
 [0x0909]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0909, -- उ
 },
 [0x090A]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x090A, -- ऊ
 },
 [0x090B]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER VOCALIC R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x090B, -- ऋ
 },
 [0x090C]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER VOCALIC L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x090C, -- ऌ
 },
 [0x090D]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER CANDRA E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x090D, -- ऍ
 },
 [0x090E]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER SHORT E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x090E, -- ऎ
 },
 [0x090F]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x090F, -- ए
 },
 [0x0910]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0910, -- ऐ
 },
 [0x0911]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER CANDRA O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0911, -- ऑ
 },
 [0x0912]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER SHORT O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0912, -- ऒ
 },
 [0x0913]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0913, -- ओ
 },
 [0x0914]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER AU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0914, -- औ
 },
 [0x0915]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0915, -- क
 },
 [0x0916]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0916, -- ख
 },
 [0x0917]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0917, -- ग
 },
 [0x0918]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0918, -- घ
 },
 [0x0919]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0919, -- ङ
 },
 [0x091A]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x091A, -- च
 },
 [0x091B]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x091B, -- छ
 },
 [0x091C]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x091C, -- ज
 },
 [0x091D]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x091D, -- झ
 },
 [0x091E]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x091E, -- ञ
 },
 [0x091F]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x091F, -- ट
 },
 [0x0920]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0920, -- ठ
 },
 [0x0921]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0921, -- ड
 },
 [0x0922]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0922, -- ढ
 },
 [0x0923]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0923, -- ण
 },
 [0x0924]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0924, -- त
 },
 [0x0925]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0925, -- थ
 },
 [0x0926]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0926, -- द
 },
 [0x0927]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0927, -- ध
 },
 [0x0928]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0928, -- न
 },
 [0x0929]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER NNNA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0928, 0x093C },
  ["unicodeslot"]=0x0929, -- ऩ
 },
 [0x092A]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x092A, -- प
 },
 [0x092B]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x092B, -- फ
 },
 [0x092C]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x092C, -- ब
 },
 [0x092D]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x092D, -- भ
 },
 [0x092E]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x092E, -- म
 },
 [0x092F]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x092F, -- य
 },
 [0x0930]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0930, -- र
 },
 [0x0931]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER RRA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0930, 0x093C },
  ["unicodeslot"]=0x0931, -- ऱ
 },
 [0x0932]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0932, -- ल
 },
 [0x0933]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER LLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0933, -- ळ
 },
 [0x0934]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER LLLA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0933, 0x093C },
  ["unicodeslot"]=0x0934, -- ऴ
 },
 [0x0935]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0935, -- व
 },
 [0x0936]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0936, -- श
 },
 [0x0937]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0937, -- ष
 },
 [0x0938]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0938, -- स
 },
 [0x0939]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0939, -- ह
 },
 [0x093C]={
  ["category"]="mn",
  ["description"]="DEVANAGARI SIGN NUKTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x093C, -- ़
 },
 [0x093D]={
  ["category"]="lo",
  ["description"]="DEVANAGARI SIGN AVAGRAHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x093D, -- ऽ
 },
 [0x093E]={
  ["category"]="mc",
  ["description"]="DEVANAGARI VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x093E, -- ा
 },
 [0x093F]={
  ["category"]="mc",
  ["description"]="DEVANAGARI VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x093F, -- ि
 },
 [0x0940]={
  ["category"]="mc",
  ["description"]="DEVANAGARI VOWEL SIGN II",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0940, -- ी
 },
 [0x0941]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0941, -- ु
 },
 [0x0942]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0942, -- ू
 },
 [0x0943]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN VOCALIC R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0943, -- ृ
 },
 [0x0944]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN VOCALIC RR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0944, -- ॄ
 },
 [0x0945]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN CANDRA E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0945, -- ॅ
 },
 [0x0946]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN SHORT E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0946, -- ॆ
 },
 [0x0947]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0947, -- े
 },
 [0x0948]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0948, -- ै
 },
 [0x0949]={
  ["category"]="mc",
  ["description"]="DEVANAGARI VOWEL SIGN CANDRA O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0949, -- ॉ
 },
 [0x094A]={
  ["category"]="mc",
  ["description"]="DEVANAGARI VOWEL SIGN SHORT O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x094A, -- ॊ
 },
 [0x094B]={
  ["category"]="mc",
  ["description"]="DEVANAGARI VOWEL SIGN O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x094B, -- ो
 },
 [0x094C]={
  ["category"]="mc",
  ["description"]="DEVANAGARI VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x094C, -- ौ
 },
 [0x094D]={
  ["category"]="mn",
  ["description"]="DEVANAGARI SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x094D, -- ्
 },
 [0x0950]={
  ["category"]="lo",
  ["description"]="DEVANAGARI OM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0950, -- ॐ
 },
 [0x0951]={
  ["category"]="mn",
  ["description"]="DEVANAGARI STRESS SIGN UDATTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0951, -- ॑
 },
 [0x0952]={
  ["category"]="mn",
  ["description"]="DEVANAGARI STRESS SIGN ANUDATTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0952, -- ॒
 },
 [0x0953]={
  ["category"]="mn",
  ["description"]="DEVANAGARI GRAVE ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0953, -- ॓
 },
 [0x0954]={
  ["category"]="mn",
  ["description"]="DEVANAGARI ACUTE ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0954, -- ॔
 },
 [0x0958]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER QA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0915, 0x093C },
  ["unicodeslot"]=0x0958, -- क़
 },
 [0x0959]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER KHHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0916, 0x093C },
  ["unicodeslot"]=0x0959, -- ख़
 },
 [0x095A]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER GHHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0917, 0x093C },
  ["unicodeslot"]=0x095A, -- ग़
 },
 [0x095B]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER ZA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x091C, 0x093C },
  ["unicodeslot"]=0x095B, -- ज़
 },
 [0x095C]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER DDDHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0921, 0x093C },
  ["unicodeslot"]=0x095C, -- ड़
 },
 [0x095D]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER RHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0922, 0x093C },
  ["unicodeslot"]=0x095D, -- ढ़
 },
 [0x095E]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER FA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x092B, 0x093C },
  ["unicodeslot"]=0x095E, -- फ़
 },
 [0x095F]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER YYA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x092F, 0x093C },
  ["unicodeslot"]=0x095F, -- य़
 },
 [0x0960]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER VOCALIC RR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0960, -- ॠ
 },
 [0x0961]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER VOCALIC LL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0961, -- ॡ
 },
 [0x0962]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN VOCALIC L",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0962, -- ॢ
 },
 [0x0963]={
  ["category"]="mn",
  ["description"]="DEVANAGARI VOWEL SIGN VOCALIC LL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0963, -- ॣ
 },
 [0x0964]={
  ["category"]="po",
  ["description"]="DEVANAGARI DANDA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0964, -- ।
 },
 [0x0965]={
  ["category"]="po",
  ["description"]="DEVANAGARI DOUBLE DANDA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0965, -- ॥
 },
 [0x0966]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0966, -- ०
 },
 [0x0967]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0967, -- १
 },
 [0x0968]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0968, -- २
 },
 [0x0969]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0969, -- ३
 },
 [0x096A]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x096A, -- ४
 },
 [0x096B]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x096B, -- ५
 },
 [0x096C]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x096C, -- ६
 },
 [0x096D]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x096D, -- ७
 },
 [0x096E]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x096E, -- ८
 },
 [0x096F]={
  ["category"]="nd",
  ["description"]="DEVANAGARI DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x096F, -- ९
 },
 [0x0970]={
  ["category"]="po",
  ["description"]="DEVANAGARI ABBREVIATION SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0970, -- ॰
 },
 [0x097B]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER GGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x097B, -- ॻ
 },
 [0x097C]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER JJA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x097C, -- ॼ
 },
 [0x097D]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER GLOTTAL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x097D, -- ॽ
 },
 [0x097E]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER DDDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x097E, -- ॾ
 },
 [0x097F]={
  ["category"]="lo",
  ["description"]="DEVANAGARI LETTER BBA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x097F, -- ॿ
 },
 [0x0981]={
  ["category"]="mn",
  ["description"]="BENGALI SIGN CANDRABINDU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0981, -- ঁ
 },
 [0x0982]={
  ["category"]="mc",
  ["description"]="BENGALI SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0982, -- ং
 },
 [0x0983]={
  ["category"]="mc",
  ["description"]="BENGALI SIGN VISARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0983, -- ঃ
 },
 [0x0985]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0985, -- অ
 },
 [0x0986]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0986, -- আ
 },
 [0x0987]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0987, -- ই
 },
 [0x0988]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0988, -- ঈ
 },
 [0x0989]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0989, -- উ
 },
 [0x098A]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x098A, -- ঊ
 },
 [0x098B]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER VOCALIC R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x098B, -- ঋ
 },
 [0x098C]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER VOCALIC L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x098C, -- ঌ
 },
 [0x098F]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x098F, -- এ
 },
 [0x0990]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0990, -- ঐ
 },
 [0x0993]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0993, -- ও
 },
 [0x0994]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER AU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0994, -- ঔ
 },
 [0x0995]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0995, -- ক
 },
 [0x0996]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0996, -- খ
 },
 [0x0997]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0997, -- গ
 },
 [0x0998]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0998, -- ঘ
 },
 [0x0999]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0999, -- ঙ
 },
 [0x099A]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x099A, -- চ
 },
 [0x099B]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x099B, -- ছ
 },
 [0x099C]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x099C, -- জ
 },
 [0x099D]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x099D, -- ঝ
 },
 [0x099E]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x099E, -- ঞ
 },
 [0x099F]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x099F, -- ট
 },
 [0x09A0]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09A0, -- ঠ
 },
 [0x09A1]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09A1, -- ড
 },
 [0x09A2]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09A2, -- ঢ
 },
 [0x09A3]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09A3, -- ণ
 },
 [0x09A4]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09A4, -- ত
 },
 [0x09A5]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09A5, -- থ
 },
 [0x09A6]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09A6, -- দ
 },
 [0x09A7]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09A7, -- ধ
 },
 [0x09A8]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09A8, -- ন
 },
 [0x09AA]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09AA, -- প
 },
 [0x09AB]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09AB, -- ফ
 },
 [0x09AC]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09AC, -- ব
 },
 [0x09AD]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09AD, -- ভ
 },
 [0x09AE]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09AE, -- ম
 },
 [0x09AF]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09AF, -- য
 },
 [0x09B0]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09B0, -- র
 },
 [0x09B2]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09B2, -- ল
 },
 [0x09B6]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09B6, -- শ
 },
 [0x09B7]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09B7, -- ষ
 },
 [0x09B8]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09B8, -- স
 },
 [0x09B9]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09B9, -- হ
 },
 [0x09BC]={
  ["category"]="mn",
  ["description"]="BENGALI SIGN NUKTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09BC, -- ়
 },
 [0x09BD]={
  ["category"]="lo",
  ["description"]="BENGALI SIGN AVAGRAHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09BD, -- ঽ
 },
 [0x09BE]={
  ["category"]="mc",
  ["description"]="BENGALI VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09BE, -- া
 },
 [0x09BF]={
  ["category"]="mc",
  ["description"]="BENGALI VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09BF, -- ি
 },
 [0x09C0]={
  ["category"]="mc",
  ["description"]="BENGALI VOWEL SIGN II",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09C0, -- ী
 },
 [0x09C1]={
  ["category"]="mn",
  ["description"]="BENGALI VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09C1, -- ু
 },
 [0x09C2]={
  ["category"]="mn",
  ["description"]="BENGALI VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09C2, -- ূ
 },
 [0x09C3]={
  ["category"]="mn",
  ["description"]="BENGALI VOWEL SIGN VOCALIC R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09C3, -- ৃ
 },
 [0x09C4]={
  ["category"]="mn",
  ["description"]="BENGALI VOWEL SIGN VOCALIC RR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09C4, -- ৄ
 },
 [0x09C7]={
  ["category"]="mc",
  ["description"]="BENGALI VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09C7, -- ে
 },
 [0x09C8]={
  ["category"]="mc",
  ["description"]="BENGALI VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09C8, -- ৈ
 },
 [0x09CB]={
  ["category"]="mc",
  ["description"]="BENGALI VOWEL SIGN O",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x09C7, 0x09BE },
  ["unicodeslot"]=0x09CB, -- ো
 },
 [0x09CC]={
  ["category"]="mc",
  ["description"]="BENGALI VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x09C7, 0x09D7 },
  ["unicodeslot"]=0x09CC, -- ৌ
 },
 [0x09CD]={
  ["category"]="mn",
  ["description"]="BENGALI SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09CD, -- ্
 },
 [0x09CE]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER KHANDA TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09CE, -- ৎ
 },
 [0x09D7]={
  ["category"]="mc",
  ["description"]="BENGALI AU LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09D7, -- ৗ
 },
 [0x09DC]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER RRA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x09A1, 0x09BC },
  ["unicodeslot"]=0x09DC, -- ড়
 },
 [0x09DD]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER RHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x09A2, 0x09BC },
  ["unicodeslot"]=0x09DD, -- ঢ়
 },
 [0x09DF]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER YYA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x09AF, 0x09BC },
  ["unicodeslot"]=0x09DF, -- য়
 },
 [0x09E0]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER VOCALIC RR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09E0, -- ৠ
 },
 [0x09E1]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER VOCALIC LL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09E1, -- ৡ
 },
 [0x09E2]={
  ["category"]="mn",
  ["description"]="BENGALI VOWEL SIGN VOCALIC L",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09E2, -- ৢ
 },
 [0x09E3]={
  ["category"]="mn",
  ["description"]="BENGALI VOWEL SIGN VOCALIC LL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x09E3, -- ৣ
 },
 [0x09E6]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09E6, -- ০
 },
 [0x09E7]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09E7, -- ১
 },
 [0x09E8]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09E8, -- ২
 },
 [0x09E9]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09E9, -- ৩
 },
 [0x09EA]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09EA, -- ৪
 },
 [0x09EB]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09EB, -- ৫
 },
 [0x09EC]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09EC, -- ৬
 },
 [0x09ED]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09ED, -- ৭
 },
 [0x09EE]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09EE, -- ৮
 },
 [0x09EF]={
  ["category"]="nd",
  ["description"]="BENGALI DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x09EF, -- ৯
 },
 [0x09F0]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER RA WITH MIDDLE DIAGONAL",
  ["linebreak"]="al",
  ["shcode"]=0x09B0,
  ["unicodeslot"]=0x09F0, -- ৰ
 },
 [0x09F1]={
  ["category"]="lo",
  ["description"]="BENGALI LETTER RA WITH LOWER DIAGONAL",
  ["linebreak"]="al",
  ["shcode"]=0x09B0,
  ["unicodeslot"]=0x09F1, -- ৱ
 },
 [0x09F2]={
  ["category"]="sc",
  ["description"]="BENGALI RUPEE MARK",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x09F2, -- ৲
 },
 [0x09F3]={
  ["category"]="sc",
  ["description"]="BENGALI RUPEE SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x09F3, -- ৳
 },
 [0x09F4]={
  ["category"]="no",
  ["description"]="BENGALI CURRENCY NUMERATOR ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09F4, -- ৴
 },
 [0x09F5]={
  ["category"]="no",
  ["description"]="BENGALI CURRENCY NUMERATOR TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09F5, -- ৵
 },
 [0x09F6]={
  ["category"]="no",
  ["description"]="BENGALI CURRENCY NUMERATOR THREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09F6, -- ৶
 },
 [0x09F7]={
  ["category"]="no",
  ["description"]="BENGALI CURRENCY NUMERATOR FOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09F7, -- ৷
 },
 [0x09F8]={
  ["category"]="no",
  ["description"]="BENGALI CURRENCY NUMERATOR ONE LESS THAN THE DENOMINATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09F8, -- ৸
 },
 [0x09F9]={
  ["category"]="no",
  ["description"]="BENGALI CURRENCY DENOMINATOR SIXTEEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09F9, -- ৹
 },
 [0x09FA]={
  ["category"]="so",
  ["description"]="BENGALI ISSHAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x09FA, -- ৺
 },
 [0x0A01]={
  ["category"]="mn",
  ["description"]="GURMUKHI SIGN ADAK BINDI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A01, -- ਁ
 },
 [0x0A02]={
  ["category"]="mn",
  ["description"]="GURMUKHI SIGN BINDI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A02, -- ਂ
 },
 [0x0A03]={
  ["category"]="mc",
  ["description"]="GURMUKHI SIGN VISARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A03, -- ਃ
 },
 [0x0A05]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A05, -- ਅ
 },
 [0x0A06]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A06, -- ਆ
 },
 [0x0A07]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A07, -- ਇ
 },
 [0x0A08]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A08, -- ਈ
 },
 [0x0A09]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A09, -- ਉ
 },
 [0x0A0A]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A0A, -- ਊ
 },
 [0x0A0F]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A0F, -- ਏ
 },
 [0x0A10]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A10, -- ਐ
 },
 [0x0A13]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER OO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A13, -- ਓ
 },
 [0x0A14]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER AU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A14, -- ਔ
 },
 [0x0A15]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A15, -- ਕ
 },
 [0x0A16]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A16, -- ਖ
 },
 [0x0A17]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A17, -- ਗ
 },
 [0x0A18]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A18, -- ਘ
 },
 [0x0A19]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A19, -- ਙ
 },
 [0x0A1A]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A1A, -- ਚ
 },
 [0x0A1B]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A1B, -- ਛ
 },
 [0x0A1C]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A1C, -- ਜ
 },
 [0x0A1D]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A1D, -- ਝ
 },
 [0x0A1E]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A1E, -- ਞ
 },
 [0x0A1F]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A1F, -- ਟ
 },
 [0x0A20]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A20, -- ਠ
 },
 [0x0A21]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A21, -- ਡ
 },
 [0x0A22]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A22, -- ਢ
 },
 [0x0A23]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A23, -- ਣ
 },
 [0x0A24]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A24, -- ਤ
 },
 [0x0A25]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A25, -- ਥ
 },
 [0x0A26]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A26, -- ਦ
 },
 [0x0A27]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A27, -- ਧ
 },
 [0x0A28]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A28, -- ਨ
 },
 [0x0A2A]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A2A, -- ਪ
 },
 [0x0A2B]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A2B, -- ਫ
 },
 [0x0A2C]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A2C, -- ਬ
 },
 [0x0A2D]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A2D, -- ਭ
 },
 [0x0A2E]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A2E, -- ਮ
 },
 [0x0A2F]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A2F, -- ਯ
 },
 [0x0A30]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A30, -- ਰ
 },
 [0x0A32]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A32, -- ਲ
 },
 [0x0A33]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER LLA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0A32, 0x0A3C },
  ["unicodeslot"]=0x0A33, -- ਲ਼
 },
 [0x0A35]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A35, -- ਵ
 },
 [0x0A36]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER SHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0A38, 0x0A3C },
  ["unicodeslot"]=0x0A36, -- ਸ਼
 },
 [0x0A38]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A38, -- ਸ
 },
 [0x0A39]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A39, -- ਹ
 },
 [0x0A3C]={
  ["category"]="mn",
  ["description"]="GURMUKHI SIGN NUKTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A3C, -- ਼
 },
 [0x0A3E]={
  ["category"]="mc",
  ["description"]="GURMUKHI VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A3E, -- ਾ
 },
 [0x0A3F]={
  ["category"]="mc",
  ["description"]="GURMUKHI VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A3F, -- ਿ
 },
 [0x0A40]={
  ["category"]="mc",
  ["description"]="GURMUKHI VOWEL SIGN II",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A40, -- ੀ
 },
 [0x0A41]={
  ["category"]="mn",
  ["description"]="GURMUKHI VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A41, -- ੁ
 },
 [0x0A42]={
  ["category"]="mn",
  ["description"]="GURMUKHI VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A42, -- ੂ
 },
 [0x0A47]={
  ["category"]="mn",
  ["description"]="GURMUKHI VOWEL SIGN EE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A47, -- ੇ
 },
 [0x0A48]={
  ["category"]="mn",
  ["description"]="GURMUKHI VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A48, -- ੈ
 },
 [0x0A4B]={
  ["category"]="mn",
  ["description"]="GURMUKHI VOWEL SIGN OO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A4B, -- ੋ
 },
 [0x0A4C]={
  ["category"]="mn",
  ["description"]="GURMUKHI VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A4C, -- ੌ
 },
 [0x0A4D]={
  ["category"]="mn",
  ["description"]="GURMUKHI SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A4D, -- ੍
 },
 [0x0A59]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER KHHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0A16, 0x0A3C },
  ["unicodeslot"]=0x0A59, -- ਖ਼
 },
 [0x0A5A]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER GHHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0A17, 0x0A3C },
  ["unicodeslot"]=0x0A5A, -- ਗ਼
 },
 [0x0A5B]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER ZA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0A1C, 0x0A3C },
  ["unicodeslot"]=0x0A5B, -- ਜ਼
 },
 [0x0A5C]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER RRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A5C, -- ੜ
 },
 [0x0A5E]={
  ["category"]="lo",
  ["description"]="GURMUKHI LETTER FA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0A2B, 0x0A3C },
  ["unicodeslot"]=0x0A5E, -- ਫ਼
 },
 [0x0A66]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A66, -- ੦
 },
 [0x0A67]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A67, -- ੧
 },
 [0x0A68]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A68, -- ੨
 },
 [0x0A69]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A69, -- ੩
 },
 [0x0A6A]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A6A, -- ੪
 },
 [0x0A6B]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A6B, -- ੫
 },
 [0x0A6C]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A6C, -- ੬
 },
 [0x0A6D]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A6D, -- ੭
 },
 [0x0A6E]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A6E, -- ੮
 },
 [0x0A6F]={
  ["category"]="nd",
  ["description"]="GURMUKHI DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0A6F, -- ੯
 },
 [0x0A70]={
  ["category"]="mn",
  ["description"]="GURMUKHI TIPPI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A70, -- ੰ
 },
 [0x0A71]={
  ["category"]="mn",
  ["description"]="GURMUKHI ADDAK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A71, -- ੱ
 },
 [0x0A72]={
  ["category"]="lo",
  ["description"]="GURMUKHI IRI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A72, -- ੲ
 },
 [0x0A73]={
  ["category"]="lo",
  ["description"]="GURMUKHI URA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A73, -- ੳ
 },
 [0x0A74]={
  ["category"]="lo",
  ["description"]="GURMUKHI EK ONKAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A74, -- ੴ
 },
 [0x0A81]={
  ["category"]="mn",
  ["description"]="GUJARATI SIGN CANDRABINDU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A81, -- ઁ
 },
 [0x0A82]={
  ["category"]="mn",
  ["description"]="GUJARATI SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A82, -- ં
 },
 [0x0A83]={
  ["category"]="mc",
  ["description"]="GUJARATI SIGN VISARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0A83, -- ઃ
 },
 [0x0A85]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A85, -- અ
 },
 [0x0A86]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A86, -- આ
 },
 [0x0A87]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A87, -- ઇ
 },
 [0x0A88]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A88, -- ઈ
 },
 [0x0A89]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A89, -- ઉ
 },
 [0x0A8A]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A8A, -- ઊ
 },
 [0x0A8B]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER VOCALIC R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A8B, -- ઋ
 },
 [0x0A8C]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER VOCALIC L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A8C, -- ઌ
 },
 [0x0A8D]={
  ["category"]="lo",
  ["description"]="GUJARATI VOWEL CANDRA E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A8D, -- ઍ
 },
 [0x0A8F]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A8F, -- એ
 },
 [0x0A90]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A90, -- ઐ
 },
 [0x0A91]={
  ["category"]="lo",
  ["description"]="GUJARATI VOWEL CANDRA O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A91, -- ઑ
 },
 [0x0A93]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A93, -- ઓ
 },
 [0x0A94]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER AU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A94, -- ઔ
 },
 [0x0A95]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A95, -- ક
 },
 [0x0A96]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A96, -- ખ
 },
 [0x0A97]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A97, -- ગ
 },
 [0x0A98]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A98, -- ઘ
 },
 [0x0A99]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A99, -- ઙ
 },
 [0x0A9A]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A9A, -- ચ
 },
 [0x0A9B]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A9B, -- છ
 },
 [0x0A9C]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A9C, -- જ
 },
 [0x0A9D]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A9D, -- ઝ
 },
 [0x0A9E]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A9E, -- ઞ
 },
 [0x0A9F]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0A9F, -- ટ
 },
 [0x0AA0]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AA0, -- ઠ
 },
 [0x0AA1]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AA1, -- ડ
 },
 [0x0AA2]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AA2, -- ઢ
 },
 [0x0AA3]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AA3, -- ણ
 },
 [0x0AA4]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AA4, -- ત
 },
 [0x0AA5]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AA5, -- થ
 },
 [0x0AA6]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AA6, -- દ
 },
 [0x0AA7]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AA7, -- ધ
 },
 [0x0AA8]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AA8, -- ન
 },
 [0x0AAA]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AAA, -- પ
 },
 [0x0AAB]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AAB, -- ફ
 },
 [0x0AAC]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AAC, -- બ
 },
 [0x0AAD]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AAD, -- ભ
 },
 [0x0AAE]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AAE, -- મ
 },
 [0x0AAF]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AAF, -- ય
 },
 [0x0AB0]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AB0, -- ર
 },
 [0x0AB2]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AB2, -- લ
 },
 [0x0AB3]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER LLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AB3, -- ળ
 },
 [0x0AB5]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AB5, -- વ
 },
 [0x0AB6]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AB6, -- શ
 },
 [0x0AB7]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AB7, -- ષ
 },
 [0x0AB8]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AB8, -- સ
 },
 [0x0AB9]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AB9, -- હ
 },
 [0x0ABC]={
  ["category"]="mn",
  ["description"]="GUJARATI SIGN NUKTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0ABC, -- ઼
 },
 [0x0ABD]={
  ["category"]="lo",
  ["description"]="GUJARATI SIGN AVAGRAHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0ABD, -- ઽ
 },
 [0x0ABE]={
  ["category"]="mc",
  ["description"]="GUJARATI VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0ABE, -- ા
 },
 [0x0ABF]={
  ["category"]="mc",
  ["description"]="GUJARATI VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0ABF, -- િ
 },
 [0x0AC0]={
  ["category"]="mc",
  ["description"]="GUJARATI VOWEL SIGN II",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AC0, -- ી
 },
 [0x0AC1]={
  ["category"]="mn",
  ["description"]="GUJARATI VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AC1, -- ુ
 },
 [0x0AC2]={
  ["category"]="mn",
  ["description"]="GUJARATI VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AC2, -- ૂ
 },
 [0x0AC3]={
  ["category"]="mn",
  ["description"]="GUJARATI VOWEL SIGN VOCALIC R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AC3, -- ૃ
 },
 [0x0AC4]={
  ["category"]="mn",
  ["description"]="GUJARATI VOWEL SIGN VOCALIC RR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AC4, -- ૄ
 },
 [0x0AC5]={
  ["category"]="mn",
  ["description"]="GUJARATI VOWEL SIGN CANDRA E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AC5, -- ૅ
 },
 [0x0AC7]={
  ["category"]="mn",
  ["description"]="GUJARATI VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AC7, -- ે
 },
 [0x0AC8]={
  ["category"]="mn",
  ["description"]="GUJARATI VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AC8, -- ૈ
 },
 [0x0AC9]={
  ["category"]="mc",
  ["description"]="GUJARATI VOWEL SIGN CANDRA O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AC9, -- ૉ
 },
 [0x0ACB]={
  ["category"]="mc",
  ["description"]="GUJARATI VOWEL SIGN O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0ACB, -- ો
 },
 [0x0ACC]={
  ["category"]="mc",
  ["description"]="GUJARATI VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0ACC, -- ૌ
 },
 [0x0ACD]={
  ["category"]="mn",
  ["description"]="GUJARATI SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0ACD, -- ્
 },
 [0x0AD0]={
  ["category"]="lo",
  ["description"]="GUJARATI OM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AD0, -- ૐ
 },
 [0x0AE0]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER VOCALIC RR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AE0, -- ૠ
 },
 [0x0AE1]={
  ["category"]="lo",
  ["description"]="GUJARATI LETTER VOCALIC LL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0AE1, -- ૡ
 },
 [0x0AE2]={
  ["category"]="mn",
  ["description"]="GUJARATI VOWEL SIGN VOCALIC L",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AE2, -- ૢ
 },
 [0x0AE3]={
  ["category"]="mn",
  ["description"]="GUJARATI VOWEL SIGN VOCALIC LL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0AE3, -- ૣ
 },
 [0x0AE6]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AE6, -- ૦
 },
 [0x0AE7]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AE7, -- ૧
 },
 [0x0AE8]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AE8, -- ૨
 },
 [0x0AE9]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AE9, -- ૩
 },
 [0x0AEA]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AEA, -- ૪
 },
 [0x0AEB]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AEB, -- ૫
 },
 [0x0AEC]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AEC, -- ૬
 },
 [0x0AED]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AED, -- ૭
 },
 [0x0AEE]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AEE, -- ૮
 },
 [0x0AEF]={
  ["category"]="nd",
  ["description"]="GUJARATI DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0AEF, -- ૯
 },
 [0x0AF1]={
  ["category"]="sc",
  ["description"]="GUJARATI RUPEE SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x0AF1, -- ૱
 },
 [0x0B01]={
  ["category"]="mn",
  ["description"]="ORIYA SIGN CANDRABINDU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B01, -- ଁ
 },
 [0x0B02]={
  ["category"]="mc",
  ["description"]="ORIYA SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B02, -- ଂ
 },
 [0x0B03]={
  ["category"]="mc",
  ["description"]="ORIYA SIGN VISARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B03, -- ଃ
 },
 [0x0B05]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B05, -- ଅ
 },
 [0x0B06]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B06, -- ଆ
 },
 [0x0B07]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B07, -- ଇ
 },
 [0x0B08]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B08, -- ଈ
 },
 [0x0B09]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B09, -- ଉ
 },
 [0x0B0A]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B0A, -- ଊ
 },
 [0x0B0B]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER VOCALIC R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B0B, -- ଋ
 },
 [0x0B0C]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER VOCALIC L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B0C, -- ଌ
 },
 [0x0B0F]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B0F, -- ଏ
 },
 [0x0B10]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B10, -- ଐ
 },
 [0x0B13]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B13, -- ଓ
 },
 [0x0B14]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER AU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B14, -- ଔ
 },
 [0x0B15]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B15, -- କ
 },
 [0x0B16]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B16, -- ଖ
 },
 [0x0B17]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B17, -- ଗ
 },
 [0x0B18]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B18, -- ଘ
 },
 [0x0B19]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B19, -- ଙ
 },
 [0x0B1A]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B1A, -- ଚ
 },
 [0x0B1B]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B1B, -- ଛ
 },
 [0x0B1C]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B1C, -- ଜ
 },
 [0x0B1D]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B1D, -- ଝ
 },
 [0x0B1E]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B1E, -- ଞ
 },
 [0x0B1F]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B1F, -- ଟ
 },
 [0x0B20]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B20, -- ଠ
 },
 [0x0B21]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B21, -- ଡ
 },
 [0x0B22]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B22, -- ଢ
 },
 [0x0B23]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B23, -- ଣ
 },
 [0x0B24]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B24, -- ତ
 },
 [0x0B25]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B25, -- ଥ
 },
 [0x0B26]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B26, -- ଦ
 },
 [0x0B27]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B27, -- ଧ
 },
 [0x0B28]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B28, -- ନ
 },
 [0x0B2A]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B2A, -- ପ
 },
 [0x0B2B]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B2B, -- ଫ
 },
 [0x0B2C]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B2C, -- ବ
 },
 [0x0B2D]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B2D, -- ଭ
 },
 [0x0B2E]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B2E, -- ମ
 },
 [0x0B2F]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B2F, -- ଯ
 },
 [0x0B30]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B30, -- ର
 },
 [0x0B32]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B32, -- ଲ
 },
 [0x0B33]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER LLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B33, -- ଳ
 },
 [0x0B35]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B35, -- ଵ
 },
 [0x0B36]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B36, -- ଶ
 },
 [0x0B37]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B37, -- ଷ
 },
 [0x0B38]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B38, -- ସ
 },
 [0x0B39]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B39, -- ହ
 },
 [0x0B3C]={
  ["category"]="mn",
  ["description"]="ORIYA SIGN NUKTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B3C, -- ଼
 },
 [0x0B3D]={
  ["category"]="lo",
  ["description"]="ORIYA SIGN AVAGRAHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B3D, -- ଽ
 },
 [0x0B3E]={
  ["category"]="mc",
  ["description"]="ORIYA VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B3E, -- ା
 },
 [0x0B3F]={
  ["category"]="mn",
  ["description"]="ORIYA VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B3F, -- ି
 },
 [0x0B40]={
  ["category"]="mc",
  ["description"]="ORIYA VOWEL SIGN II",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B40, -- ୀ
 },
 [0x0B41]={
  ["category"]="mn",
  ["description"]="ORIYA VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B41, -- ୁ
 },
 [0x0B42]={
  ["category"]="mn",
  ["description"]="ORIYA VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B42, -- ୂ
 },
 [0x0B43]={
  ["category"]="mn",
  ["description"]="ORIYA VOWEL SIGN VOCALIC R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B43, -- ୃ
 },
 [0x0B47]={
  ["category"]="mc",
  ["description"]="ORIYA VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B47, -- େ
 },
 [0x0B48]={
  ["category"]="mc",
  ["description"]="ORIYA VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0B47, 0x0B56 },
  ["unicodeslot"]=0x0B48, -- ୈ
 },
 [0x0B4B]={
  ["category"]="mc",
  ["description"]="ORIYA VOWEL SIGN O",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0B47, 0x0B3E },
  ["unicodeslot"]=0x0B4B, -- ୋ
 },
 [0x0B4C]={
  ["category"]="mc",
  ["description"]="ORIYA VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0B47, 0x0B57 },
  ["unicodeslot"]=0x0B4C, -- ୌ
 },
 [0x0B4D]={
  ["category"]="mn",
  ["description"]="ORIYA SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B4D, -- ୍
 },
 [0x0B56]={
  ["category"]="mn",
  ["description"]="ORIYA AI LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B56, -- ୖ
 },
 [0x0B57]={
  ["category"]="mc",
  ["description"]="ORIYA AU LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B57, -- ୗ
 },
 [0x0B5C]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER RRA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0B21, 0x0B3C },
  ["unicodeslot"]=0x0B5C, -- ଡ଼
 },
 [0x0B5D]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER RHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0B22, 0x0B3C },
  ["unicodeslot"]=0x0B5D, -- ଢ଼
 },
 [0x0B5F]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER YYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B5F, -- ୟ
 },
 [0x0B60]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER VOCALIC RR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B60, -- ୠ
 },
 [0x0B61]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER VOCALIC LL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B61, -- ୡ
 },
 [0x0B66]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B66, -- ୦
 },
 [0x0B67]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B67, -- ୧
 },
 [0x0B68]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B68, -- ୨
 },
 [0x0B69]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B69, -- ୩
 },
 [0x0B6A]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B6A, -- ୪
 },
 [0x0B6B]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B6B, -- ୫
 },
 [0x0B6C]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B6C, -- ୬
 },
 [0x0B6D]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B6D, -- ୭
 },
 [0x0B6E]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B6E, -- ୮
 },
 [0x0B6F]={
  ["category"]="nd",
  ["description"]="ORIYA DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0B6F, -- ୯
 },
 [0x0B70]={
  ["category"]="so",
  ["description"]="ORIYA ISSHAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B70, -- ୰
 },
 [0x0B71]={
  ["category"]="lo",
  ["description"]="ORIYA LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B71, -- ୱ
 },
 [0x0B82]={
  ["category"]="mn",
  ["description"]="TAMIL SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0B82, -- ஂ
 },
 [0x0B83]={
  ["category"]="lo",
  ["description"]="TAMIL SIGN VISARGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B83, -- ஃ
 },
 [0x0B85]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B85, -- அ
 },
 [0x0B86]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B86, -- ஆ
 },
 [0x0B87]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B87, -- இ
 },
 [0x0B88]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B88, -- ஈ
 },
 [0x0B89]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B89, -- உ
 },
 [0x0B8A]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B8A, -- ஊ
 },
 [0x0B8E]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B8E, -- எ
 },
 [0x0B8F]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B8F, -- ஏ
 },
 [0x0B90]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B90, -- ஐ
 },
 [0x0B92]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B92, -- ஒ
 },
 [0x0B93]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER OO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B93, -- ஓ
 },
 [0x0B94]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER AU",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0B92, 0x0BD7 },
  ["unicodeslot"]=0x0B94, -- ஔ
 },
 [0x0B95]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B95, -- க
 },
 [0x0B99]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B99, -- ங
 },
 [0x0B9A]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B9A, -- ச
 },
 [0x0B9C]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B9C, -- ஜ
 },
 [0x0B9E]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B9E, -- ஞ
 },
 [0x0B9F]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0B9F, -- ட
 },
 [0x0BA3]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BA3, -- ண
 },
 [0x0BA4]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BA4, -- த
 },
 [0x0BA8]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BA8, -- ந
 },
 [0x0BA9]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER NNNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BA9, -- ன
 },
 [0x0BAA]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BAA, -- ப
 },
 [0x0BAE]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BAE, -- ம
 },
 [0x0BAF]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BAF, -- ய
 },
 [0x0BB0]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB0, -- ர
 },
 [0x0BB1]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER RRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB1, -- ற
 },
 [0x0BB2]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB2, -- ல
 },
 [0x0BB3]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER LLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB3, -- ள
 },
 [0x0BB4]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER LLLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB4, -- ழ
 },
 [0x0BB5]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB5, -- வ
 },
 [0x0BB6]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB6, -- ஶ
 },
 [0x0BB7]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB7, -- ஷ
 },
 [0x0BB8]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB8, -- ஸ
 },
 [0x0BB9]={
  ["category"]="lo",
  ["description"]="TAMIL LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BB9, -- ஹ
 },
 [0x0BBE]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BBE, -- ா
 },
 [0x0BBF]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BBF, -- ி
 },
 [0x0BC0]={
  ["category"]="mn",
  ["description"]="TAMIL VOWEL SIGN II",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BC0, -- ீ
 },
 [0x0BC1]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BC1, -- ு
 },
 [0x0BC2]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BC2, -- ூ
 },
 [0x0BC6]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BC6, -- ெ
 },
 [0x0BC7]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN EE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BC7, -- ே
 },
 [0x0BC8]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BC8, -- ை
 },
 [0x0BCA]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN O",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0BC6, 0x0BBE },
  ["unicodeslot"]=0x0BCA, -- ொ
 },
 [0x0BCB]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN OO",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0BC7, 0x0BBE },
  ["unicodeslot"]=0x0BCB, -- ோ
 },
 [0x0BCC]={
  ["category"]="mc",
  ["description"]="TAMIL VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0BC6, 0x0BD7 },
  ["unicodeslot"]=0x0BCC, -- ௌ
 },
 [0x0BCD]={
  ["category"]="mn",
  ["description"]="TAMIL SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BCD, -- ்
 },
 [0x0BD7]={
  ["category"]="mc",
  ["description"]="TAMIL AU LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0BD7, -- ௗ
 },
 [0x0BE6]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BE6, -- ௦
 },
 [0x0BE7]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BE7, -- ௧
 },
 [0x0BE8]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BE8, -- ௨
 },
 [0x0BE9]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BE9, -- ௩
 },
 [0x0BEA]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BEA, -- ௪
 },
 [0x0BEB]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BEB, -- ௫
 },
 [0x0BEC]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BEC, -- ௬
 },
 [0x0BED]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BED, -- ௭
 },
 [0x0BEE]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BEE, -- ௮
 },
 [0x0BEF]={
  ["category"]="nd",
  ["description"]="TAMIL DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0BEF, -- ௯
 },
 [0x0BF0]={
  ["category"]="no",
  ["description"]="TAMIL NUMBER TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BF0, -- ௰
 },
 [0x0BF1]={
  ["category"]="no",
  ["description"]="TAMIL NUMBER ONE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BF1, -- ௱
 },
 [0x0BF2]={
  ["category"]="no",
  ["description"]="TAMIL NUMBER ONE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BF2, -- ௲
 },
 [0x0BF3]={
  ["category"]="so",
  ["description"]="TAMIL DAY SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BF3, -- ௳
 },
 [0x0BF4]={
  ["category"]="so",
  ["description"]="TAMIL MONTH SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BF4, -- ௴
 },
 [0x0BF5]={
  ["category"]="so",
  ["description"]="TAMIL YEAR SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BF5, -- ௵
 },
 [0x0BF6]={
  ["category"]="so",
  ["description"]="TAMIL DEBIT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BF6, -- ௶
 },
 [0x0BF7]={
  ["category"]="so",
  ["description"]="TAMIL CREDIT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BF7, -- ௷
 },
 [0x0BF8]={
  ["category"]="so",
  ["description"]="TAMIL AS ABOVE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BF8, -- ௸
 },
 [0x0BF9]={
  ["category"]="sc",
  ["description"]="TAMIL RUPEE SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x0BF9, -- ௹
 },
 [0x0BFA]={
  ["category"]="so",
  ["description"]="TAMIL NUMBER SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0BFA, -- ௺
 },
 [0x0C01]={
  ["category"]="mc",
  ["description"]="TELUGU SIGN CANDRABINDU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C01, -- ఁ
 },
 [0x0C02]={
  ["category"]="mc",
  ["description"]="TELUGU SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C02, -- ం
 },
 [0x0C03]={
  ["category"]="mc",
  ["description"]="TELUGU SIGN VISARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C03, -- ః
 },
 [0x0C05]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C05, -- అ
 },
 [0x0C06]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C06, -- ఆ
 },
 [0x0C07]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C07, -- ఇ
 },
 [0x0C08]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C08, -- ఈ
 },
 [0x0C09]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C09, -- ఉ
 },
 [0x0C0A]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C0A, -- ఊ
 },
 [0x0C0B]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER VOCALIC R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C0B, -- ఋ
 },
 [0x0C0C]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER VOCALIC L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C0C, -- ఌ
 },
 [0x0C0E]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C0E, -- ఎ
 },
 [0x0C0F]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C0F, -- ఏ
 },
 [0x0C10]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C10, -- ఐ
 },
 [0x0C12]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C12, -- ఒ
 },
 [0x0C13]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER OO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C13, -- ఓ
 },
 [0x0C14]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER AU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C14, -- ఔ
 },
 [0x0C15]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C15, -- క
 },
 [0x0C16]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C16, -- ఖ
 },
 [0x0C17]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C17, -- గ
 },
 [0x0C18]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C18, -- ఘ
 },
 [0x0C19]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C19, -- ఙ
 },
 [0x0C1A]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C1A, -- చ
 },
 [0x0C1B]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C1B, -- ఛ
 },
 [0x0C1C]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C1C, -- జ
 },
 [0x0C1D]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C1D, -- ఝ
 },
 [0x0C1E]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C1E, -- ఞ
 },
 [0x0C1F]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C1F, -- ట
 },
 [0x0C20]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C20, -- ఠ
 },
 [0x0C21]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C21, -- డ
 },
 [0x0C22]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C22, -- ఢ
 },
 [0x0C23]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C23, -- ణ
 },
 [0x0C24]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C24, -- త
 },
 [0x0C25]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C25, -- థ
 },
 [0x0C26]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C26, -- ద
 },
 [0x0C27]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C27, -- ధ
 },
 [0x0C28]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C28, -- న
 },
 [0x0C2A]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C2A, -- ప
 },
 [0x0C2B]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C2B, -- ఫ
 },
 [0x0C2C]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C2C, -- బ
 },
 [0x0C2D]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C2D, -- భ
 },
 [0x0C2E]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C2E, -- మ
 },
 [0x0C2F]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C2F, -- య
 },
 [0x0C30]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C30, -- ర
 },
 [0x0C31]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER RRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C31, -- ఱ
 },
 [0x0C32]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C32, -- ల
 },
 [0x0C33]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER LLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C33, -- ళ
 },
 [0x0C35]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C35, -- వ
 },
 [0x0C36]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C36, -- శ
 },
 [0x0C37]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C37, -- ష
 },
 [0x0C38]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C38, -- స
 },
 [0x0C39]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C39, -- హ
 },
 [0x0C3E]={
  ["category"]="mn",
  ["description"]="TELUGU VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C3E, -- ా
 },
 [0x0C3F]={
  ["category"]="mn",
  ["description"]="TELUGU VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C3F, -- ి
 },
 [0x0C40]={
  ["category"]="mn",
  ["description"]="TELUGU VOWEL SIGN II",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C40, -- ీ
 },
 [0x0C41]={
  ["category"]="mc",
  ["description"]="TELUGU VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C41, -- ు
 },
 [0x0C42]={
  ["category"]="mc",
  ["description"]="TELUGU VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C42, -- ూ
 },
 [0x0C43]={
  ["category"]="mc",
  ["description"]="TELUGU VOWEL SIGN VOCALIC R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C43, -- ృ
 },
 [0x0C44]={
  ["category"]="mc",
  ["description"]="TELUGU VOWEL SIGN VOCALIC RR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C44, -- ౄ
 },
 [0x0C46]={
  ["category"]="mn",
  ["description"]="TELUGU VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C46, -- ె
 },
 [0x0C47]={
  ["category"]="mn",
  ["description"]="TELUGU VOWEL SIGN EE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C47, -- ే
 },
 [0x0C48]={
  ["category"]="mn",
  ["description"]="TELUGU VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0C46, 0x0C56 },
  ["unicodeslot"]=0x0C48, -- ై
 },
 [0x0C4A]={
  ["category"]="mn",
  ["description"]="TELUGU VOWEL SIGN O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C4A, -- ొ
 },
 [0x0C4B]={
  ["category"]="mn",
  ["description"]="TELUGU VOWEL SIGN OO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C4B, -- ో
 },
 [0x0C4C]={
  ["category"]="mn",
  ["description"]="TELUGU VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C4C, -- ౌ
 },
 [0x0C4D]={
  ["category"]="mn",
  ["description"]="TELUGU SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C4D, -- ్
 },
 [0x0C55]={
  ["category"]="mn",
  ["description"]="TELUGU LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C55, -- ౕ
 },
 [0x0C56]={
  ["category"]="mn",
  ["description"]="TELUGU AI LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C56, -- ౖ
 },
 [0x0C60]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER VOCALIC RR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C60, -- ౠ
 },
 [0x0C61]={
  ["category"]="lo",
  ["description"]="TELUGU LETTER VOCALIC LL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C61, -- ౡ
 },
 [0x0C66]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C66, -- ౦
 },
 [0x0C67]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C67, -- ౧
 },
 [0x0C68]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C68, -- ౨
 },
 [0x0C69]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C69, -- ౩
 },
 [0x0C6A]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C6A, -- ౪
 },
 [0x0C6B]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C6B, -- ౫
 },
 [0x0C6C]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C6C, -- ౬
 },
 [0x0C6D]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C6D, -- ౭
 },
 [0x0C6E]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C6E, -- ౮
 },
 [0x0C6F]={
  ["category"]="nd",
  ["description"]="TELUGU DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0C6F, -- ౯
 },
 [0x0C82]={
  ["category"]="mc",
  ["description"]="KANNADA SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C82, -- ಂ
 },
 [0x0C83]={
  ["category"]="mc",
  ["description"]="KANNADA SIGN VISARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0C83, -- ಃ
 },
 [0x0C85]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C85, -- ಅ
 },
 [0x0C86]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C86, -- ಆ
 },
 [0x0C87]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C87, -- ಇ
 },
 [0x0C88]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C88, -- ಈ
 },
 [0x0C89]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C89, -- ಉ
 },
 [0x0C8A]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C8A, -- ಊ
 },
 [0x0C8B]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER VOCALIC R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C8B, -- ಋ
 },
 [0x0C8C]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER VOCALIC L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C8C, -- ಌ
 },
 [0x0C8E]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C8E, -- ಎ
 },
 [0x0C8F]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C8F, -- ಏ
 },
 [0x0C90]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C90, -- ಐ
 },
 [0x0C92]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C92, -- ಒ
 },
 [0x0C93]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER OO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C93, -- ಓ
 },
 [0x0C94]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER AU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C94, -- ಔ
 },
 [0x0C95]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C95, -- ಕ
 },
 [0x0C96]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C96, -- ಖ
 },
 [0x0C97]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C97, -- ಗ
 },
 [0x0C98]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C98, -- ಘ
 },
 [0x0C99]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C99, -- ಙ
 },
 [0x0C9A]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C9A, -- ಚ
 },
 [0x0C9B]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C9B, -- ಛ
 },
 [0x0C9C]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C9C, -- ಜ
 },
 [0x0C9D]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C9D, -- ಝ
 },
 [0x0C9E]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C9E, -- ಞ
 },
 [0x0C9F]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0C9F, -- ಟ
 },
 [0x0CA0]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CA0, -- ಠ
 },
 [0x0CA1]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CA1, -- ಡ
 },
 [0x0CA2]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CA2, -- ಢ
 },
 [0x0CA3]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CA3, -- ಣ
 },
 [0x0CA4]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CA4, -- ತ
 },
 [0x0CA5]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CA5, -- ಥ
 },
 [0x0CA6]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CA6, -- ದ
 },
 [0x0CA7]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CA7, -- ಧ
 },
 [0x0CA8]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CA8, -- ನ
 },
 [0x0CAA]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CAA, -- ಪ
 },
 [0x0CAB]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CAB, -- ಫ
 },
 [0x0CAC]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CAC, -- ಬ
 },
 [0x0CAD]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CAD, -- ಭ
 },
 [0x0CAE]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CAE, -- ಮ
 },
 [0x0CAF]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CAF, -- ಯ
 },
 [0x0CB0]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CB0, -- ರ
 },
 [0x0CB1]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER RRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CB1, -- ಱ
 },
 [0x0CB2]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CB2, -- ಲ
 },
 [0x0CB3]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER LLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CB3, -- ಳ
 },
 [0x0CB5]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CB5, -- ವ
 },
 [0x0CB6]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CB6, -- ಶ
 },
 [0x0CB7]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CB7, -- ಷ
 },
 [0x0CB8]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CB8, -- ಸ
 },
 [0x0CB9]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CB9, -- ಹ
 },
 [0x0CBC]={
  ["category"]="mn",
  ["description"]="KANNADA SIGN NUKTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CBC, -- ಼
 },
 [0x0CBD]={
  ["category"]="lo",
  ["description"]="KANNADA SIGN AVAGRAHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CBD, -- ಽ
 },
 [0x0CBE]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CBE, -- ಾ
 },
 [0x0CBF]={
  ["category"]="mn",
  ["description"]="KANNADA VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CBF, -- ಿ
 },
 [0x0CC0]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN II",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0CBF, 0x0CD5 },
  ["unicodeslot"]=0x0CC0, -- ೀ
 },
 [0x0CC1]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CC1, -- ು
 },
 [0x0CC2]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CC2, -- ೂ
 },
 [0x0CC3]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN VOCALIC R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CC3, -- ೃ
 },
 [0x0CC4]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN VOCALIC RR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CC4, -- ೄ
 },
 [0x0CC6]={
  ["category"]="mn",
  ["description"]="KANNADA VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CC6, -- ೆ
 },
 [0x0CC7]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN EE",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0CC6, 0x0CD5 },
  ["unicodeslot"]=0x0CC7, -- ೇ
 },
 [0x0CC8]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0CC6, 0x0CD6 },
  ["unicodeslot"]=0x0CC8, -- ೈ
 },
 [0x0CCA]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN O",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0CC6, 0x0CC2 },
  ["unicodeslot"]=0x0CCA, -- ೊ
 },
 [0x0CCB]={
  ["category"]="mc",
  ["description"]="KANNADA VOWEL SIGN OO",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0CCA, 0x0CD5 },
  ["unicodeslot"]=0x0CCB, -- ೋ
 },
 [0x0CCC]={
  ["category"]="mn",
  ["description"]="KANNADA VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CCC, -- ೌ
 },
 [0x0CCD]={
  ["category"]="mn",
  ["description"]="KANNADA SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CCD, -- ್
 },
 [0x0CD5]={
  ["category"]="mc",
  ["description"]="KANNADA LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CD5, -- ೕ
 },
 [0x0CD6]={
  ["category"]="mc",
  ["description"]="KANNADA AI LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CD6, -- ೖ
 },
 [0x0CDE]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CDE, -- ೞ
 },
 [0x0CE0]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER VOCALIC RR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CE0, -- ೠ
 },
 [0x0CE1]={
  ["category"]="lo",
  ["description"]="KANNADA LETTER VOCALIC LL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CE1, -- ೡ
 },
 [0x0CE2]={
  ["category"]="mn",
  ["description"]="KANNADA VOWEL SIGN VOCALIC L",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CE2, -- ೢ
 },
 [0x0CE3]={
  ["category"]="mn",
  ["description"]="KANNADA VOWEL SIGN VOCALIC LL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0CE3, -- ೣ
 },
 [0x0CE6]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CE6, -- ೦
 },
 [0x0CE7]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CE7, -- ೧
 },
 [0x0CE8]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CE8, -- ೨
 },
 [0x0CE9]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CE9, -- ೩
 },
 [0x0CEA]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CEA, -- ೪
 },
 [0x0CEB]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CEB, -- ೫
 },
 [0x0CEC]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CEC, -- ೬
 },
 [0x0CED]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CED, -- ೭
 },
 [0x0CEE]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CEE, -- ೮
 },
 [0x0CEF]={
  ["category"]="nd",
  ["description"]="KANNADA DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0CEF, -- ೯
 },
 [0x0CF1]={
  ["category"]="so",
  ["description"]="KANNADA SIGN JIHVAMULIYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CF1, -- ೱ
 },
 [0x0CF2]={
  ["category"]="so",
  ["description"]="KANNADA SIGN UPADHMANIYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0CF2, -- ೲ
 },
 [0x0D02]={
  ["category"]="mc",
  ["description"]="MALAYALAM SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D02, -- ം
 },
 [0x0D03]={
  ["category"]="mc",
  ["description"]="MALAYALAM SIGN VISARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D03, -- ഃ
 },
 [0x0D05]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D05, -- അ
 },
 [0x0D06]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D06, -- ആ
 },
 [0x0D07]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D07, -- ഇ
 },
 [0x0D08]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D08, -- ഈ
 },
 [0x0D09]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D09, -- ഉ
 },
 [0x0D0A]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D0A, -- ഊ
 },
 [0x0D0B]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER VOCALIC R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D0B, -- ഋ
 },
 [0x0D0C]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER VOCALIC L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D0C, -- ഌ
 },
 [0x0D0E]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D0E, -- എ
 },
 [0x0D0F]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D0F, -- ഏ
 },
 [0x0D10]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D10, -- ഐ
 },
 [0x0D12]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D12, -- ഒ
 },
 [0x0D13]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER OO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D13, -- ഓ
 },
 [0x0D14]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER AU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D14, -- ഔ
 },
 [0x0D15]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D15, -- ക
 },
 [0x0D16]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D16, -- ഖ
 },
 [0x0D17]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D17, -- ഗ
 },
 [0x0D18]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D18, -- ഘ
 },
 [0x0D19]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D19, -- ങ
 },
 [0x0D1A]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D1A, -- ച
 },
 [0x0D1B]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D1B, -- ഛ
 },
 [0x0D1C]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D1C, -- ജ
 },
 [0x0D1D]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D1D, -- ഝ
 },
 [0x0D1E]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D1E, -- ഞ
 },
 [0x0D1F]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D1F, -- ട
 },
 [0x0D20]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D20, -- ഠ
 },
 [0x0D21]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D21, -- ഡ
 },
 [0x0D22]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D22, -- ഢ
 },
 [0x0D23]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D23, -- ണ
 },
 [0x0D24]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D24, -- ത
 },
 [0x0D25]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D25, -- ഥ
 },
 [0x0D26]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D26, -- ദ
 },
 [0x0D27]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D27, -- ധ
 },
 [0x0D28]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D28, -- ന
 },
 [0x0D2A]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D2A, -- പ
 },
 [0x0D2B]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D2B, -- ഫ
 },
 [0x0D2C]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D2C, -- ബ
 },
 [0x0D2D]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D2D, -- ഭ
 },
 [0x0D2E]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D2E, -- മ
 },
 [0x0D2F]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D2F, -- യ
 },
 [0x0D30]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D30, -- ര
 },
 [0x0D31]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER RRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D31, -- റ
 },
 [0x0D32]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D32, -- ല
 },
 [0x0D33]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER LLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D33, -- ള
 },
 [0x0D34]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER LLLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D34, -- ഴ
 },
 [0x0D35]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D35, -- വ
 },
 [0x0D36]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D36, -- ശ
 },
 [0x0D37]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D37, -- ഷ
 },
 [0x0D38]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D38, -- സ
 },
 [0x0D39]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D39, -- ഹ
 },
 [0x0D3E]={
  ["category"]="mc",
  ["description"]="MALAYALAM VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D3E, -- ാ
 },
 [0x0D3F]={
  ["category"]="mc",
  ["description"]="MALAYALAM VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D3F, -- ി
 },
 [0x0D40]={
  ["category"]="mc",
  ["description"]="MALAYALAM VOWEL SIGN II",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D40, -- ീ
 },
 [0x0D41]={
  ["category"]="mn",
  ["description"]="MALAYALAM VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D41, -- ു
 },
 [0x0D42]={
  ["category"]="mn",
  ["description"]="MALAYALAM VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D42, -- ൂ
 },
 [0x0D43]={
  ["category"]="mn",
  ["description"]="MALAYALAM VOWEL SIGN VOCALIC R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D43, -- ൃ
 },
 [0x0D46]={
  ["category"]="mc",
  ["description"]="MALAYALAM VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D46, -- െ
 },
 [0x0D47]={
  ["category"]="mc",
  ["description"]="MALAYALAM VOWEL SIGN EE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D47, -- േ
 },
 [0x0D48]={
  ["category"]="mc",
  ["description"]="MALAYALAM VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D48, -- ൈ
 },
 [0x0D4A]={
  ["category"]="mc",
  ["description"]="MALAYALAM VOWEL SIGN O",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0D46, 0x0D3E },
  ["unicodeslot"]=0x0D4A, -- ൊ
 },
 [0x0D4B]={
  ["category"]="mc",
  ["description"]="MALAYALAM VOWEL SIGN OO",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0D47, 0x0D3E },
  ["unicodeslot"]=0x0D4B, -- ോ
 },
 [0x0D4C]={
  ["category"]="mc",
  ["description"]="MALAYALAM VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0D46, 0x0D57 },
  ["unicodeslot"]=0x0D4C, -- ൌ
 },
 [0x0D4D]={
  ["category"]="mn",
  ["description"]="MALAYALAM SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D4D, -- ്
 },
 [0x0D57]={
  ["category"]="mc",
  ["description"]="MALAYALAM AU LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D57, -- ൗ
 },
 [0x0D60]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER VOCALIC RR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D60, -- ൠ
 },
 [0x0D61]={
  ["category"]="lo",
  ["description"]="MALAYALAM LETTER VOCALIC LL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D61, -- ൡ
 },
 [0x0D66]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D66, -- ൦
 },
 [0x0D67]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D67, -- ൧
 },
 [0x0D68]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D68, -- ൨
 },
 [0x0D69]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D69, -- ൩
 },
 [0x0D6A]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D6A, -- ൪
 },
 [0x0D6B]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D6B, -- ൫
 },
 [0x0D6C]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D6C, -- ൬
 },
 [0x0D6D]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D6D, -- ൭
 },
 [0x0D6E]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D6E, -- ൮
 },
 [0x0D6F]={
  ["category"]="nd",
  ["description"]="MALAYALAM DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0D6F, -- ൯
 },
 [0x0D82]={
  ["category"]="mc",
  ["description"]="SINHALA SIGN ANUSVARAYA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D82, -- ං
 },
 [0x0D83]={
  ["category"]="mc",
  ["description"]="SINHALA SIGN VISARGAYA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0D83, -- ඃ
 },
 [0x0D85]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER AYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D85, -- අ
 },
 [0x0D86]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER AAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D86, -- ආ
 },
 [0x0D87]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER AEYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D87, -- ඇ
 },
 [0x0D88]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER AEEYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D88, -- ඈ
 },
 [0x0D89]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER IYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D89, -- ඉ
 },
 [0x0D8A]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER IIYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D8A, -- ඊ
 },
 [0x0D8B]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER UYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D8B, -- උ
 },
 [0x0D8C]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER UUYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D8C, -- ඌ
 },
 [0x0D8D]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER IRUYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D8D, -- ඍ
 },
 [0x0D8E]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER IRUUYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D8E, -- ඎ
 },
 [0x0D8F]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ILUYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D8F, -- ඏ
 },
 [0x0D90]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ILUUYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D90, -- ඐ
 },
 [0x0D91]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER EYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D91, -- එ
 },
 [0x0D92]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER EEYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D92, -- ඒ
 },
 [0x0D93]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER AIYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D93, -- ඓ
 },
 [0x0D94]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER OYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D94, -- ඔ
 },
 [0x0D95]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER OOYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D95, -- ඕ
 },
 [0x0D96]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER AUYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D96, -- ඖ
 },
 [0x0D9A]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA KAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D9A, -- ක
 },
 [0x0D9B]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA KAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D9B, -- ඛ
 },
 [0x0D9C]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA GAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D9C, -- ග
 },
 [0x0D9D]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA GAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D9D, -- ඝ
 },
 [0x0D9E]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER KANTAJA NAASIKYAYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D9E, -- ඞ
 },
 [0x0D9F]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER SANYAKA GAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0D9F, -- ඟ
 },
 [0x0DA0]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA CAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA0, -- ච
 },
 [0x0DA1]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA CAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA1, -- ඡ
 },
 [0x0DA2]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA JAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA2, -- ජ
 },
 [0x0DA3]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA JAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA3, -- ඣ
 },
 [0x0DA4]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER TAALUJA NAASIKYAYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA4, -- ඤ
 },
 [0x0DA5]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER TAALUJA SANYOOGA NAAKSIKYAYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA5, -- ඥ
 },
 [0x0DA6]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER SANYAKA JAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA6, -- ඦ
 },
 [0x0DA7]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA TTAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA7, -- ට
 },
 [0x0DA8]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA TTAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA8, -- ඨ
 },
 [0x0DA9]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA DDAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DA9, -- ඩ
 },
 [0x0DAA]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA DDAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DAA, -- ඪ
 },
 [0x0DAB]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MUURDHAJA NAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DAB, -- ණ
 },
 [0x0DAC]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER SANYAKA DDAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DAC, -- ඬ
 },
 [0x0DAD]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA TAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DAD, -- ත
 },
 [0x0DAE]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA TAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DAE, -- ථ
 },
 [0x0DAF]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA DAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DAF, -- ද
 },
 [0x0DB0]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA DAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DB0, -- ධ
 },
 [0x0DB1]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER DANTAJA NAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DB1, -- න
 },
 [0x0DB3]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER SANYAKA DAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DB3, -- ඳ
 },
 [0x0DB4]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA PAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DB4, -- ප
 },
 [0x0DB5]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA PAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DB5, -- ඵ
 },
 [0x0DB6]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER ALPAPRAANA BAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DB6, -- බ
 },
 [0x0DB7]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAHAAPRAANA BAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DB7, -- භ
 },
 [0x0DB8]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DB8, -- ම
 },
 [0x0DB9]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER AMBA BAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DB9, -- ඹ
 },
 [0x0DBA]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER YAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DBA, -- ය
 },
 [0x0DBB]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER RAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DBB, -- ර
 },
 [0x0DBD]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER DANTAJA LAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DBD, -- ල
 },
 [0x0DC0]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER VAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DC0, -- ව
 },
 [0x0DC1]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER TAALUJA SAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DC1, -- ශ
 },
 [0x0DC2]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MUURDHAJA SAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DC2, -- ෂ
 },
 [0x0DC3]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER DANTAJA SAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DC3, -- ස
 },
 [0x0DC4]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER HAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DC4, -- හ
 },
 [0x0DC5]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER MUURDHAJA LAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DC5, -- ළ
 },
 [0x0DC6]={
  ["category"]="lo",
  ["description"]="SINHALA LETTER FAYANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DC6, -- ෆ
 },
 [0x0DCA]={
  ["category"]="mn",
  ["description"]="SINHALA SIGN AL-LAKUNA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DCA, -- ්
 },
 [0x0DCF]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN AELA-PILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DCF, -- ා
 },
 [0x0DD0]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN KETTI AEDA-PILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DD0, -- ැ
 },
 [0x0DD1]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN DIGA AEDA-PILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DD1, -- ෑ
 },
 [0x0DD2]={
  ["category"]="mn",
  ["description"]="SINHALA VOWEL SIGN KETTI IS-PILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DD2, -- ි
 },
 [0x0DD3]={
  ["category"]="mn",
  ["description"]="SINHALA VOWEL SIGN DIGA IS-PILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DD3, -- ී
 },
 [0x0DD4]={
  ["category"]="mn",
  ["description"]="SINHALA VOWEL SIGN KETTI PAA-PILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DD4, -- ු
 },
 [0x0DD6]={
  ["category"]="mn",
  ["description"]="SINHALA VOWEL SIGN DIGA PAA-PILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DD6, -- ූ
 },
 [0x0DD8]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN GAETTA-PILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DD8, -- ෘ
 },
 [0x0DD9]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN KOMBUVA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DD9, -- ෙ
 },
 [0x0DDA]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN DIGA KOMBUVA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0DD9, 0x0DCA },
  ["unicodeslot"]=0x0DDA, -- ේ
 },
 [0x0DDB]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN KOMBU DEKA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DDB, -- ෛ
 },
 [0x0DDC]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN KOMBUVA HAA AELA-PILLA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0DD9, 0x0DCF },
  ["unicodeslot"]=0x0DDC, -- ො
 },
 [0x0DDD]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN KOMBUVA HAA DIGA AELA-PILLA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0DDC, 0x0DCA },
  ["unicodeslot"]=0x0DDD, -- ෝ
 },
 [0x0DDE]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN KOMBUVA HAA GAYANUKITTA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0DD9, 0x0DDF },
  ["unicodeslot"]=0x0DDE, -- ෞ
 },
 [0x0DDF]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN GAYANUKITTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DDF, -- ෟ
 },
 [0x0DF2]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN DIGA GAETTA-PILLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DF2, -- ෲ
 },
 [0x0DF3]={
  ["category"]="mc",
  ["description"]="SINHALA VOWEL SIGN DIGA GAYANUKITTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0DF3, -- ෳ
 },
 [0x0DF4]={
  ["category"]="po",
  ["description"]="SINHALA PUNCTUATION KUNDDALIYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0DF4, -- ෴
 },
 [0x0E01]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER KO KAI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E01, -- ก
 },
 [0x0E02]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER KHO KHAI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E02, -- ข
 },
 [0x0E03]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER KHO KHUAT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E03, -- ฃ
 },
 [0x0E04]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER KHO KHWAI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E04, -- ค
 },
 [0x0E05]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER KHO KHON",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E05, -- ฅ
 },
 [0x0E06]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER KHO RAKHANG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E06, -- ฆ
 },
 [0x0E07]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER NGO NGU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E07, -- ง
 },
 [0x0E08]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER CHO CHAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E08, -- จ
 },
 [0x0E09]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER CHO CHING",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E09, -- ฉ
 },
 [0x0E0A]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER CHO CHANG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E0A, -- ช
 },
 [0x0E0B]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SO SO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E0B, -- ซ
 },
 [0x0E0C]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER CHO CHOE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E0C, -- ฌ
 },
 [0x0E0D]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER YO YING",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E0D, -- ญ
 },
 [0x0E0E]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER DO CHADA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E0E, -- ฎ
 },
 [0x0E0F]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER TO PATAK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E0F, -- ฏ
 },
 [0x0E10]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER THO THAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E10, -- ฐ
 },
 [0x0E11]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER THO NANGMONTHO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E11, -- ฑ
 },
 [0x0E12]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER THO PHUTHAO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E12, -- ฒ
 },
 [0x0E13]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER NO NEN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E13, -- ณ
 },
 [0x0E14]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER DO DEK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E14, -- ด
 },
 [0x0E15]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER TO TAO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E15, -- ต
 },
 [0x0E16]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER THO THUNG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E16, -- ถ
 },
 [0x0E17]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER THO THAHAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E17, -- ท
 },
 [0x0E18]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER THO THONG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E18, -- ธ
 },
 [0x0E19]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER NO NU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E19, -- น
 },
 [0x0E1A]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER BO BAIMAI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E1A, -- บ
 },
 [0x0E1B]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER PO PLA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E1B, -- ป
 },
 [0x0E1C]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER PHO PHUNG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E1C, -- ผ
 },
 [0x0E1D]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER FO FA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E1D, -- ฝ
 },
 [0x0E1E]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER PHO PHAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E1E, -- พ
 },
 [0x0E1F]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER FO FAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E1F, -- ฟ
 },
 [0x0E20]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER PHO SAMPHAO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E20, -- ภ
 },
 [0x0E21]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER MO MA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E21, -- ม
 },
 [0x0E22]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER YO YAK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E22, -- ย
 },
 [0x0E23]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER RO RUA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E23, -- ร
 },
 [0x0E24]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER RU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E24, -- ฤ
 },
 [0x0E25]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER LO LING",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E25, -- ล
 },
 [0x0E26]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER LU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E26, -- ฦ
 },
 [0x0E27]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER WO WAEN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E27, -- ว
 },
 [0x0E28]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SO SALA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E28, -- ศ
 },
 [0x0E29]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SO RUSI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E29, -- ษ
 },
 [0x0E2A]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SO SUA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E2A, -- ส
 },
 [0x0E2B]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER HO HIP",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E2B, -- ห
 },
 [0x0E2C]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER LO CHULA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E2C, -- ฬ
 },
 [0x0E2D]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER O ANG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E2D, -- อ
 },
 [0x0E2E]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER HO NOKHUK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E2E, -- ฮ
 },
 [0x0E2F]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER PAIYANNOI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E2F, -- ฯ
 },
 [0x0E30]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SARA A",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E30, -- ะ
 },
 [0x0E31]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER MAI HAN-AKAT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E31, -- ั
 },
 [0x0E32]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SARA AA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E32, -- า
 },
 [0x0E33]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SARA AM",
  ["linebreak"]="sa",
  ["specials"]={ "compat", 0x0E4D, 0x0E32 },
  ["unicodeslot"]=0x0E33, -- ำ
 },
 [0x0E34]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER SARA I",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E34, -- ิ
 },
 [0x0E35]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER SARA II",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E35, -- ี
 },
 [0x0E36]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER SARA UE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E36, -- ึ
 },
 [0x0E37]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER SARA UEE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E37, -- ื
 },
 [0x0E38]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER SARA U",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E38, -- ุ
 },
 [0x0E39]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER SARA UU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E39, -- ู
 },
 [0x0E3A]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER PHINTHU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E3A, -- ฺ
 },
 [0x0E3F]={
  ["category"]="sc",
  ["description"]="THAI CURRENCY SYMBOL BAHT",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x0E3F, -- ฿
 },
 [0x0E40]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SARA E",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E40, -- เ
 },
 [0x0E41]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SARA AE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E41, -- แ
 },
 [0x0E42]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SARA O",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E42, -- โ
 },
 [0x0E43]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SARA AI MAIMUAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E43, -- ใ
 },
 [0x0E44]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER SARA AI MAIMALAI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E44, -- ไ
 },
 [0x0E45]={
  ["category"]="lo",
  ["description"]="THAI CHARACTER LAKKHANGYAO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E45, -- ๅ
 },
 [0x0E46]={
  ["category"]="lm",
  ["description"]="THAI CHARACTER MAIYAMOK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E46, -- ๆ
 },
 [0x0E47]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER MAITAIKHU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E47, -- ็
 },
 [0x0E48]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER MAI EK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E48, -- ่
 },
 [0x0E49]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER MAI THO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E49, -- ้
 },
 [0x0E4A]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER MAI TRI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E4A, -- ๊
 },
 [0x0E4B]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER MAI CHATTAWA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E4B, -- ๋
 },
 [0x0E4C]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER THANTHAKHAT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E4C, -- ์
 },
 [0x0E4D]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER NIKHAHIT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E4D, -- ํ
 },
 [0x0E4E]={
  ["category"]="mn",
  ["description"]="THAI CHARACTER YAMAKKAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E4E, -- ๎
 },
 [0x0E4F]={
  ["category"]="po",
  ["description"]="THAI CHARACTER FONGMAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0E4F, -- ๏
 },
 [0x0E50]={
  ["category"]="nd",
  ["description"]="THAI DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E50, -- ๐
 },
 [0x0E51]={
  ["category"]="nd",
  ["description"]="THAI DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E51, -- ๑
 },
 [0x0E52]={
  ["category"]="nd",
  ["description"]="THAI DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E52, -- ๒
 },
 [0x0E53]={
  ["category"]="nd",
  ["description"]="THAI DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E53, -- ๓
 },
 [0x0E54]={
  ["category"]="nd",
  ["description"]="THAI DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E54, -- ๔
 },
 [0x0E55]={
  ["category"]="nd",
  ["description"]="THAI DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E55, -- ๕
 },
 [0x0E56]={
  ["category"]="nd",
  ["description"]="THAI DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E56, -- ๖
 },
 [0x0E57]={
  ["category"]="nd",
  ["description"]="THAI DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E57, -- ๗
 },
 [0x0E58]={
  ["category"]="nd",
  ["description"]="THAI DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E58, -- ๘
 },
 [0x0E59]={
  ["category"]="nd",
  ["description"]="THAI DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0E59, -- ๙
 },
 [0x0E5A]={
  ["category"]="po",
  ["description"]="THAI CHARACTER ANGKHANKHU",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0E5A, -- ๚
 },
 [0x0E5B]={
  ["category"]="po",
  ["description"]="THAI CHARACTER KHOMUT",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0E5B, -- ๛
 },
 [0x0E81]={
  ["category"]="lo",
  ["description"]="LAO LETTER KO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E81, -- ກ
 },
 [0x0E82]={
  ["category"]="lo",
  ["description"]="LAO LETTER KHO SUNG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E82, -- ຂ
 },
 [0x0E84]={
  ["category"]="lo",
  ["description"]="LAO LETTER KHO TAM",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E84, -- ຄ
 },
 [0x0E87]={
  ["category"]="lo",
  ["description"]="LAO LETTER NGO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E87, -- ງ
 },
 [0x0E88]={
  ["category"]="lo",
  ["description"]="LAO LETTER CO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E88, -- ຈ
 },
 [0x0E8A]={
  ["category"]="lo",
  ["description"]="LAO LETTER SO TAM",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E8A, -- ຊ
 },
 [0x0E8D]={
  ["category"]="lo",
  ["description"]="LAO LETTER NYO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E8D, -- ຍ
 },
 [0x0E94]={
  ["category"]="lo",
  ["description"]="LAO LETTER DO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E94, -- ດ
 },
 [0x0E95]={
  ["category"]="lo",
  ["description"]="LAO LETTER TO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E95, -- ຕ
 },
 [0x0E96]={
  ["category"]="lo",
  ["description"]="LAO LETTER THO SUNG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E96, -- ຖ
 },
 [0x0E97]={
  ["category"]="lo",
  ["description"]="LAO LETTER THO TAM",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E97, -- ທ
 },
 [0x0E99]={
  ["category"]="lo",
  ["description"]="LAO LETTER NO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E99, -- ນ
 },
 [0x0E9A]={
  ["category"]="lo",
  ["description"]="LAO LETTER BO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E9A, -- ບ
 },
 [0x0E9B]={
  ["category"]="lo",
  ["description"]="LAO LETTER PO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E9B, -- ປ
 },
 [0x0E9C]={
  ["category"]="lo",
  ["description"]="LAO LETTER PHO SUNG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E9C, -- ຜ
 },
 [0x0E9D]={
  ["category"]="lo",
  ["description"]="LAO LETTER FO TAM",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E9D, -- ຝ
 },
 [0x0E9E]={
  ["category"]="lo",
  ["description"]="LAO LETTER PHO TAM",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E9E, -- ພ
 },
 [0x0E9F]={
  ["category"]="lo",
  ["description"]="LAO LETTER FO SUNG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0E9F, -- ຟ
 },
 [0x0EA1]={
  ["category"]="lo",
  ["description"]="LAO LETTER MO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EA1, -- ມ
 },
 [0x0EA2]={
  ["category"]="lo",
  ["description"]="LAO LETTER YO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EA2, -- ຢ
 },
 [0x0EA3]={
  ["category"]="lo",
  ["description"]="LAO LETTER LO LING",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EA3, -- ຣ
 },
 [0x0EA5]={
  ["category"]="lo",
  ["description"]="LAO LETTER LO LOOT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EA5, -- ລ
 },
 [0x0EA7]={
  ["category"]="lo",
  ["description"]="LAO LETTER WO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EA7, -- ວ
 },
 [0x0EAA]={
  ["category"]="lo",
  ["description"]="LAO LETTER SO SUNG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EAA, -- ສ
 },
 [0x0EAB]={
  ["category"]="lo",
  ["description"]="LAO LETTER HO SUNG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EAB, -- ຫ
 },
 [0x0EAD]={
  ["category"]="lo",
  ["description"]="LAO LETTER O",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EAD, -- ອ
 },
 [0x0EAE]={
  ["category"]="lo",
  ["description"]="LAO LETTER HO TAM",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EAE, -- ຮ
 },
 [0x0EAF]={
  ["category"]="lo",
  ["description"]="LAO ELLIPSIS",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EAF, -- ຯ
 },
 [0x0EB0]={
  ["category"]="lo",
  ["description"]="LAO VOWEL SIGN A",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EB0, -- ະ
 },
 [0x0EB1]={
  ["category"]="mn",
  ["description"]="LAO VOWEL SIGN MAI KAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EB1, -- ັ
 },
 [0x0EB2]={
  ["category"]="lo",
  ["description"]="LAO VOWEL SIGN AA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EB2, -- າ
 },
 [0x0EB3]={
  ["category"]="lo",
  ["description"]="LAO VOWEL SIGN AM",
  ["linebreak"]="sa",
  ["specials"]={ "compat", 0x0ECD, 0x0EB2 },
  ["unicodeslot"]=0x0EB3, -- ຳ
 },
 [0x0EB4]={
  ["category"]="mn",
  ["description"]="LAO VOWEL SIGN I",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EB4, -- ິ
 },
 [0x0EB5]={
  ["category"]="mn",
  ["description"]="LAO VOWEL SIGN II",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EB5, -- ີ
 },
 [0x0EB6]={
  ["category"]="mn",
  ["description"]="LAO VOWEL SIGN Y",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EB6, -- ຶ
 },
 [0x0EB7]={
  ["category"]="mn",
  ["description"]="LAO VOWEL SIGN YY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EB7, -- ື
 },
 [0x0EB8]={
  ["category"]="mn",
  ["description"]="LAO VOWEL SIGN U",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EB8, -- ຸ
 },
 [0x0EB9]={
  ["category"]="mn",
  ["description"]="LAO VOWEL SIGN UU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EB9, -- ູ
 },
 [0x0EBB]={
  ["category"]="mn",
  ["description"]="LAO VOWEL SIGN MAI KON",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EBB, -- ົ
 },
 [0x0EBC]={
  ["category"]="mn",
  ["description"]="LAO SEMIVOWEL SIGN LO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EBC, -- ຼ
 },
 [0x0EBD]={
  ["category"]="lo",
  ["description"]="LAO SEMIVOWEL SIGN NYO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EBD, -- ຽ
 },
 [0x0EC0]={
  ["category"]="lo",
  ["description"]="LAO VOWEL SIGN E",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EC0, -- ເ
 },
 [0x0EC1]={
  ["category"]="lo",
  ["description"]="LAO VOWEL SIGN EI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EC1, -- ແ
 },
 [0x0EC2]={
  ["category"]="lo",
  ["description"]="LAO VOWEL SIGN O",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EC2, -- ໂ
 },
 [0x0EC3]={
  ["category"]="lo",
  ["description"]="LAO VOWEL SIGN AY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EC3, -- ໃ
 },
 [0x0EC4]={
  ["category"]="lo",
  ["description"]="LAO VOWEL SIGN AI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EC4, -- ໄ
 },
 [0x0EC6]={
  ["category"]="lm",
  ["description"]="LAO KO LA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EC6, -- ໆ
 },
 [0x0EC8]={
  ["category"]="mn",
  ["description"]="LAO TONE MAI EK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EC8, -- ່
 },
 [0x0EC9]={
  ["category"]="mn",
  ["description"]="LAO TONE MAI THO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0EC9, -- ້
 },
 [0x0ECA]={
  ["category"]="mn",
  ["description"]="LAO TONE MAI TI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0ECA, -- ໊
 },
 [0x0ECB]={
  ["category"]="mn",
  ["description"]="LAO TONE MAI CATAWA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0ECB, -- ໋
 },
 [0x0ECC]={
  ["category"]="mn",
  ["description"]="LAO CANCELLATION MARK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0ECC, -- ໌
 },
 [0x0ECD]={
  ["category"]="mn",
  ["description"]="LAO NIGGAHITA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x0ECD, -- ໍ
 },
 [0x0ED0]={
  ["category"]="nd",
  ["description"]="LAO DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED0, -- ໐
 },
 [0x0ED1]={
  ["category"]="nd",
  ["description"]="LAO DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED1, -- ໑
 },
 [0x0ED2]={
  ["category"]="nd",
  ["description"]="LAO DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED2, -- ໒
 },
 [0x0ED3]={
  ["category"]="nd",
  ["description"]="LAO DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED3, -- ໓
 },
 [0x0ED4]={
  ["category"]="nd",
  ["description"]="LAO DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED4, -- ໔
 },
 [0x0ED5]={
  ["category"]="nd",
  ["description"]="LAO DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED5, -- ໕
 },
 [0x0ED6]={
  ["category"]="nd",
  ["description"]="LAO DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED6, -- ໖
 },
 [0x0ED7]={
  ["category"]="nd",
  ["description"]="LAO DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED7, -- ໗
 },
 [0x0ED8]={
  ["category"]="nd",
  ["description"]="LAO DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED8, -- ໘
 },
 [0x0ED9]={
  ["category"]="nd",
  ["description"]="LAO DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0ED9, -- ໙
 },
 [0x0EDC]={
  ["category"]="lo",
  ["description"]="LAO HO NO",
  ["linebreak"]="sa",
  ["specials"]={ "compat", 0x0EAB, 0x0E99 },
  ["unicodeslot"]=0x0EDC, -- ໜ
 },
 [0x0EDD]={
  ["category"]="lo",
  ["description"]="LAO HO MO",
  ["linebreak"]="sa",
  ["specials"]={ "compat", 0x0EAB, 0x0EA1 },
  ["unicodeslot"]=0x0EDD, -- ໝ
 },
 [0x0F00]={
  ["category"]="lo",
  ["description"]="TIBETAN SYLLABLE OM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F00, -- ༀ
 },
 [0x0F01]={
  ["category"]="so",
  ["description"]="TIBETAN MARK GTER YIG MGO TRUNCATED A",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0F01, -- ༁
 },
 [0x0F02]={
  ["category"]="so",
  ["description"]="TIBETAN MARK GTER YIG MGO -UM RNAM BCAD MA",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0F02, -- ༂
 },
 [0x0F03]={
  ["category"]="so",
  ["description"]="TIBETAN MARK GTER YIG MGO -UM GTER TSHEG MA",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0F03, -- ༃
 },
 [0x0F04]={
  ["category"]="po",
  ["description"]="TIBETAN MARK INITIAL YIG MGO MDUN MA",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0F04, -- ༄
 },
 [0x0F05]={
  ["category"]="po",
  ["description"]="TIBETAN MARK CLOSING YIG MGO SGAB MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F05, -- ༅
 },
 [0x0F06]={
  ["category"]="po",
  ["description"]="TIBETAN MARK CARET YIG MGO PHUR SHAD MA",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0F06, -- ༆
 },
 [0x0F07]={
  ["category"]="po",
  ["description"]="TIBETAN MARK YIG MGO TSHEG SHAD MA",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0F07, -- ༇
 },
 [0x0F08]={
  ["category"]="po",
  ["description"]="TIBETAN MARK SBRUL SHAD",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x0F08, -- ༈
 },
 [0x0F09]={
  ["category"]="po",
  ["description"]="TIBETAN MARK BSKUR YIG MGO",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0F09, -- ༉
 },
 [0x0F0A]={
  ["category"]="po",
  ["description"]="TIBETAN MARK BKA- SHOG YIG MGO",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0F0A, -- ༊
 },
 [0x0F0B]={
  ["category"]="po",
  ["description"]="TIBETAN MARK INTERSYLLABIC TSHEG",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0F0B, -- ་
 },
 [0x0F0C]={
  ["category"]="po",
  ["description"]="TIBETAN MARK DELIMITER TSHEG BSTAR",
  ["linebreak"]="gl",
  ["specials"]={ "nobreak", 0x0F0B },
  ["unicodeslot"]=0x0F0C, -- ༌
 },
 [0x0F0D]={
  ["category"]="po",
  ["description"]="TIBETAN MARK SHAD",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x0F0D, -- །
 },
 [0x0F0E]={
  ["category"]="po",
  ["description"]="TIBETAN MARK NYIS SHAD",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x0F0E, -- ༎
 },
 [0x0F0F]={
  ["category"]="po",
  ["description"]="TIBETAN MARK TSHEG SHAD",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x0F0F, -- ༏
 },
 [0x0F10]={
  ["category"]="po",
  ["description"]="TIBETAN MARK NYIS TSHEG SHAD",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x0F10, -- ༐
 },
 [0x0F11]={
  ["category"]="po",
  ["description"]="TIBETAN MARK RIN CHEN SPUNGS SHAD",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x0F11, -- ༑
 },
 [0x0F12]={
  ["category"]="po",
  ["description"]="TIBETAN MARK RGYA GRAM SHAD",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x0F12, -- ༒
 },
 [0x0F13]={
  ["category"]="so",
  ["description"]="TIBETAN MARK CARET -DZUD RTAGS ME LONG CAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F13, -- ༓
 },
 [0x0F14]={
  ["category"]="so",
  ["description"]="TIBETAN MARK GTER TSHEG",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x0F14, -- ༔
 },
 [0x0F15]={
  ["category"]="so",
  ["description"]="TIBETAN LOGOTYPE SIGN CHAD RTAGS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F15, -- ༕
 },
 [0x0F16]={
  ["category"]="so",
  ["description"]="TIBETAN LOGOTYPE SIGN LHAG RTAGS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F16, -- ༖
 },
 [0x0F17]={
  ["category"]="so",
  ["description"]="TIBETAN ASTROLOGICAL SIGN SGRA GCAN -CHAR RTAGS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F17, -- ༗
 },
 [0x0F18]={
  ["category"]="mn",
  ["description"]="TIBETAN ASTROLOGICAL SIGN -KHYUD PA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F18, -- ༘
 },
 [0x0F19]={
  ["category"]="mn",
  ["description"]="TIBETAN ASTROLOGICAL SIGN SDONG TSHUGS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F19, -- ༙
 },
 [0x0F1A]={
  ["category"]="so",
  ["description"]="TIBETAN SIGN RDEL DKAR GCIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F1A, -- ༚
 },
 [0x0F1B]={
  ["category"]="so",
  ["description"]="TIBETAN SIGN RDEL DKAR GNYIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F1B, -- ༛
 },
 [0x0F1C]={
  ["category"]="so",
  ["description"]="TIBETAN SIGN RDEL DKAR GSUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F1C, -- ༜
 },
 [0x0F1D]={
  ["category"]="so",
  ["description"]="TIBETAN SIGN RDEL NAG GCIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F1D, -- ༝
 },
 [0x0F1E]={
  ["category"]="so",
  ["description"]="TIBETAN SIGN RDEL NAG GNYIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F1E, -- ༞
 },
 [0x0F1F]={
  ["category"]="so",
  ["description"]="TIBETAN SIGN RDEL DKAR RDEL NAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F1F, -- ༟
 },
 [0x0F20]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F20, -- ༠
 },
 [0x0F21]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F21, -- ༡
 },
 [0x0F22]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F22, -- ༢
 },
 [0x0F23]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F23, -- ༣
 },
 [0x0F24]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F24, -- ༤
 },
 [0x0F25]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F25, -- ༥
 },
 [0x0F26]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F26, -- ༦
 },
 [0x0F27]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F27, -- ༧
 },
 [0x0F28]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F28, -- ༨
 },
 [0x0F29]={
  ["category"]="nd",
  ["description"]="TIBETAN DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x0F29, -- ༩
 },
 [0x0F2A]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F2A, -- ༪
 },
 [0x0F2B]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F2B, -- ༫
 },
 [0x0F2C]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF THREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F2C, -- ༬
 },
 [0x0F2D]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF FOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F2D, -- ༭
 },
 [0x0F2E]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF FIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F2E, -- ༮
 },
 [0x0F2F]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF SIX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F2F, -- ༯
 },
 [0x0F30]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF SEVEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F30, -- ༰
 },
 [0x0F31]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF EIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F31, -- ༱
 },
 [0x0F32]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF NINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F32, -- ༲
 },
 [0x0F33]={
  ["category"]="no",
  ["description"]="TIBETAN DIGIT HALF ZERO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F33, -- ༳
 },
 [0x0F34]={
  ["category"]="so",
  ["description"]="TIBETAN MARK BSDUS RTAGS",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0F34, -- ༴
 },
 [0x0F35]={
  ["category"]="mn",
  ["description"]="TIBETAN MARK NGAS BZUNG NYI ZLA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F35, -- ༵
 },
 [0x0F36]={
  ["category"]="so",
  ["description"]="TIBETAN MARK CARET -DZUD RTAGS BZHI MIG CAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F36, -- ༶
 },
 [0x0F37]={
  ["category"]="mn",
  ["description"]="TIBETAN MARK NGAS BZUNG SGOR RTAGS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F37, -- ༷
 },
 [0x0F38]={
  ["category"]="so",
  ["description"]="TIBETAN MARK CHE MGO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F38, -- ༸
 },
 [0x0F39]={
  ["category"]="mn",
  ["description"]="TIBETAN MARK TSA -PHRU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F39, -- ༹
 },
 [0x0F3A]={
  ["category"]="ps",
  ["description"]="TIBETAN MARK GUG RTAGS GYON",
  ["linebreak"]="op",
  ["unicodeslot"]=0x0F3A, -- ༺
 },
 [0x0F3B]={
  ["category"]="pe",
  ["description"]="TIBETAN MARK GUG RTAGS GYAS",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x0F3B, -- ༻
 },
 [0x0F3C]={
  ["category"]="ps",
  ["description"]="TIBETAN MARK ANG KHANG GYON",
  ["linebreak"]="op",
  ["unicodeslot"]=0x0F3C, -- ༼
 },
 [0x0F3D]={
  ["category"]="pe",
  ["description"]="TIBETAN MARK ANG KHANG GYAS",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x0F3D, -- ༽
 },
 [0x0F3E]={
  ["category"]="mc",
  ["description"]="TIBETAN SIGN YAR TSHES",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F3E, -- ༾
 },
 [0x0F3F]={
  ["category"]="mc",
  ["description"]="TIBETAN SIGN MAR TSHES",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F3F, -- ༿
 },
 [0x0F40]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F40, -- ཀ
 },
 [0x0F41]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F41, -- ཁ
 },
 [0x0F42]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F42, -- ག
 },
 [0x0F43]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER GHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0F42, 0x0FB7 },
  ["unicodeslot"]=0x0F43, -- གྷ
 },
 [0x0F44]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F44, -- ང
 },
 [0x0F45]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F45, -- ཅ
 },
 [0x0F46]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F46, -- ཆ
 },
 [0x0F47]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F47, -- ཇ
 },
 [0x0F49]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F49, -- ཉ
 },
 [0x0F4A]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F4A, -- ཊ
 },
 [0x0F4B]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F4B, -- ཋ
 },
 [0x0F4C]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F4C, -- ཌ
 },
 [0x0F4D]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER DDHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0F4C, 0x0FB7 },
  ["unicodeslot"]=0x0F4D, -- ཌྷ
 },
 [0x0F4E]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F4E, -- ཎ
 },
 [0x0F4F]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F4F, -- ཏ
 },
 [0x0F50]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F50, -- ཐ
 },
 [0x0F51]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F51, -- ད
 },
 [0x0F52]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER DHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0F51, 0x0FB7 },
  ["unicodeslot"]=0x0F52, -- དྷ
 },
 [0x0F53]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F53, -- ན
 },
 [0x0F54]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F54, -- པ
 },
 [0x0F55]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F55, -- ཕ
 },
 [0x0F56]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F56, -- བ
 },
 [0x0F57]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER BHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0F56, 0x0FB7 },
  ["unicodeslot"]=0x0F57, -- བྷ
 },
 [0x0F58]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F58, -- མ
 },
 [0x0F59]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER TSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F59, -- ཙ
 },
 [0x0F5A]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER TSHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F5A, -- ཚ
 },
 [0x0F5B]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER DZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F5B, -- ཛ
 },
 [0x0F5C]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER DZHA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0F5B, 0x0FB7 },
  ["unicodeslot"]=0x0F5C, -- ཛྷ
 },
 [0x0F5D]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F5D, -- ཝ
 },
 [0x0F5E]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER ZHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F5E, -- ཞ
 },
 [0x0F5F]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F5F, -- ཟ
 },
 [0x0F60]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER -A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F60, -- འ
 },
 [0x0F61]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F61, -- ཡ
 },
 [0x0F62]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F62, -- ར
 },
 [0x0F63]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F63, -- ལ
 },
 [0x0F64]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F64, -- ཤ
 },
 [0x0F65]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F65, -- ཥ
 },
 [0x0F66]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F66, -- ས
 },
 [0x0F67]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F67, -- ཧ
 },
 [0x0F68]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F68, -- ཨ
 },
 [0x0F69]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER KSSA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0F40, 0x0FB5 },
  ["unicodeslot"]=0x0F69, -- ཀྵ
 },
 [0x0F6A]={
  ["category"]="lo",
  ["description"]="TIBETAN LETTER FIXED-FORM RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F6A, -- ཪ
 },
 [0x0F71]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F71, -- ཱ
 },
 [0x0F72]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F72, -- ི
 },
 [0x0F73]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN II",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0F71, 0x0F72 },
  ["unicodeslot"]=0x0F73, -- ཱི
 },
 [0x0F74]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F74, -- ུ
 },
 [0x0F75]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN UU",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0F71, 0x0F74 },
  ["unicodeslot"]=0x0F75, -- ཱུ
 },
 [0x0F76]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN VOCALIC R",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0FB2, 0x0F80 },
  ["unicodeslot"]=0x0F76, -- ྲྀ
 },
 [0x0F77]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN VOCALIC RR",
  ["linebreak"]="cm",
  ["specials"]={ "compat", 0x0FB2, 0x0F81 },
  ["unicodeslot"]=0x0F77, -- ཷ
 },
 [0x0F78]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN VOCALIC L",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0FB3, 0x0F80 },
  ["unicodeslot"]=0x0F78, -- ླྀ
 },
 [0x0F79]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN VOCALIC LL",
  ["linebreak"]="cm",
  ["specials"]={ "compat", 0x0FB3, 0x0F81 },
  ["unicodeslot"]=0x0F79, -- ཹ
 },
 [0x0F7A]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F7A, -- ེ
 },
 [0x0F7B]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN EE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F7B, -- ཻ
 },
 [0x0F7C]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F7C, -- ོ
 },
 [0x0F7D]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN OO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F7D, -- ཽ
 },
 [0x0F7E]={
  ["category"]="mn",
  ["description"]="TIBETAN SIGN RJES SU NGA RO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F7E, -- ཾ
 },
 [0x0F7F]={
  ["category"]="mc",
  ["description"]="TIBETAN SIGN RNAM BCAD",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0F7F, -- ཿ
 },
 [0x0F80]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN REVERSED I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F80, -- ྀ
 },
 [0x0F81]={
  ["category"]="mn",
  ["description"]="TIBETAN VOWEL SIGN REVERSED II",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0F71, 0x0F80 },
  ["unicodeslot"]=0x0F81, -- ཱྀ
 },
 [0x0F82]={
  ["category"]="mn",
  ["description"]="TIBETAN SIGN NYI ZLA NAA DA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F82, -- ྂ
 },
 [0x0F83]={
  ["category"]="mn",
  ["description"]="TIBETAN SIGN SNA LDAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F83, -- ྃ
 },
 [0x0F84]={
  ["category"]="mn",
  ["description"]="TIBETAN MARK HALANTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F84, -- ྄
 },
 [0x0F85]={
  ["category"]="po",
  ["description"]="TIBETAN MARK PALUTA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0F85, -- ྅
 },
 [0x0F86]={
  ["category"]="mn",
  ["description"]="TIBETAN SIGN LCI RTAGS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F86, -- ྆
 },
 [0x0F87]={
  ["category"]="mn",
  ["description"]="TIBETAN SIGN YANG RTAGS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F87, -- ྇
 },
 [0x0F88]={
  ["category"]="lo",
  ["description"]="TIBETAN SIGN LCE TSA CAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F88, -- ྈ
 },
 [0x0F89]={
  ["category"]="lo",
  ["description"]="TIBETAN SIGN MCHU CAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F89, -- ྉ
 },
 [0x0F8A]={
  ["category"]="lo",
  ["description"]="TIBETAN SIGN GRU CAN RGYINGS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F8A, -- ྊ
 },
 [0x0F8B]={
  ["category"]="lo",
  ["description"]="TIBETAN SIGN GRU MED RGYINGS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0F8B, -- ྋ
 },
 [0x0F90]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER KA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F90, -- ྐ
 },
 [0x0F91]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER KHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F91, -- ྑ
 },
 [0x0F92]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER GA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F92, -- ྒ
 },
 [0x0F93]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER GHA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0F92, 0x0FB7 },
  ["unicodeslot"]=0x0F93, -- ྒྷ
 },
 [0x0F94]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER NGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F94, -- ྔ
 },
 [0x0F95]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER CA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F95, -- ྕ
 },
 [0x0F96]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER CHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F96, -- ྖ
 },
 [0x0F97]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER JA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F97, -- ྗ
 },
 [0x0F99]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER NYA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F99, -- ྙ
 },
 [0x0F9A]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER TTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F9A, -- ྚ
 },
 [0x0F9B]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER TTHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F9B, -- ྛ
 },
 [0x0F9C]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER DDA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F9C, -- ྜ
 },
 [0x0F9D]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER DDHA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0F9C, 0x0FB7 },
  ["unicodeslot"]=0x0F9D, -- ྜྷ
 },
 [0x0F9E]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER NNA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F9E, -- ྞ
 },
 [0x0F9F]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER TA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0F9F, -- ྟ
 },
 [0x0FA0]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER THA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FA0, -- ྠ
 },
 [0x0FA1]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER DA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FA1, -- ྡ
 },
 [0x0FA2]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER DHA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0FA1, 0x0FB7 },
  ["unicodeslot"]=0x0FA2, -- ྡྷ
 },
 [0x0FA3]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER NA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FA3, -- ྣ
 },
 [0x0FA4]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER PA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FA4, -- ྤ
 },
 [0x0FA5]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER PHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FA5, -- ྥ
 },
 [0x0FA6]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER BA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FA6, -- ྦ
 },
 [0x0FA7]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER BHA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0FA6, 0x0FB7 },
  ["unicodeslot"]=0x0FA7, -- ྦྷ
 },
 [0x0FA8]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER MA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FA8, -- ྨ
 },
 [0x0FA9]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER TSA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FA9, -- ྩ
 },
 [0x0FAA]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER TSHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FAA, -- ྪ
 },
 [0x0FAB]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER DZA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FAB, -- ྫ
 },
 [0x0FAC]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER DZHA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0FAB, 0x0FB7 },
  ["unicodeslot"]=0x0FAC, -- ྫྷ
 },
 [0x0FAD]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER WA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FAD, -- ྭ
 },
 [0x0FAE]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER ZHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FAE, -- ྮ
 },
 [0x0FAF]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER ZA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FAF, -- ྯ
 },
 [0x0FB0]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER -A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FB0, -- ྰ
 },
 [0x0FB1]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER YA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FB1, -- ྱ
 },
 [0x0FB2]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER RA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FB2, -- ྲ
 },
 [0x0FB3]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER LA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FB3, -- ླ
 },
 [0x0FB4]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER SHA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FB4, -- ྴ
 },
 [0x0FB5]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER SSA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FB5, -- ྵ
 },
 [0x0FB6]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER SA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FB6, -- ྶ
 },
 [0x0FB7]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER HA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FB7, -- ྷ
 },
 [0x0FB8]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FB8, -- ྸ
 },
 [0x0FB9]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER KSSA",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x0F90, 0x0FB5 },
  ["unicodeslot"]=0x0FB9, -- ྐྵ
 },
 [0x0FBA]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER FIXED-FORM WA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FBA, -- ྺ
 },
 [0x0FBB]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER FIXED-FORM YA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FBB, -- ྻ
 },
 [0x0FBC]={
  ["category"]="mn",
  ["description"]="TIBETAN SUBJOINED LETTER FIXED-FORM RA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FBC, -- ྼ
 },
 [0x0FBE]={
  ["category"]="so",
  ["description"]="TIBETAN KU RU KHA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0FBE, -- ྾
 },
 [0x0FBF]={
  ["category"]="so",
  ["description"]="TIBETAN KU RU KHA BZHI MIG CAN",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x0FBF, -- ྿
 },
 [0x0FC0]={
  ["category"]="so",
  ["description"]="TIBETAN CANTILLATION SIGN HEAVY BEAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FC0, -- ࿀
 },
 [0x0FC1]={
  ["category"]="so",
  ["description"]="TIBETAN CANTILLATION SIGN LIGHT BEAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FC1, -- ࿁
 },
 [0x0FC2]={
  ["category"]="so",
  ["description"]="TIBETAN CANTILLATION SIGN CANG TE-U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FC2, -- ࿂
 },
 [0x0FC3]={
  ["category"]="so",
  ["description"]="TIBETAN CANTILLATION SIGN SBUB -CHAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FC3, -- ࿃
 },
 [0x0FC4]={
  ["category"]="so",
  ["description"]="TIBETAN SYMBOL DRIL BU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FC4, -- ࿄
 },
 [0x0FC5]={
  ["category"]="so",
  ["description"]="TIBETAN SYMBOL RDO RJE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FC5, -- ࿅
 },
 [0x0FC6]={
  ["category"]="mn",
  ["description"]="TIBETAN SYMBOL PADMA GDAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x0FC6, -- ࿆
 },
 [0x0FC7]={
  ["category"]="so",
  ["description"]="TIBETAN SYMBOL RDO RJE RGYA GRAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FC7, -- ࿇
 },
 [0x0FC8]={
  ["category"]="so",
  ["description"]="TIBETAN SYMBOL PHUR PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FC8, -- ࿈
 },
 [0x0FC9]={
  ["category"]="so",
  ["description"]="TIBETAN SYMBOL NOR BU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FC9, -- ࿉
 },
 [0x0FCA]={
  ["category"]="so",
  ["description"]="TIBETAN SYMBOL NOR BU NYIS -KHYIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FCA, -- ࿊
 },
 [0x0FCB]={
  ["category"]="so",
  ["description"]="TIBETAN SYMBOL NOR BU GSUM -KHYIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FCB, -- ࿋
 },
 [0x0FCC]={
  ["category"]="so",
  ["description"]="TIBETAN SYMBOL NOR BU BZHI -KHYIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FCC, -- ࿌
 },
 [0x0FCF]={
  ["category"]="so",
  ["description"]="TIBETAN SIGN RDEL NAG GSUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x0FCF, -- ࿏
 },
 [0x0FD0]={
  ["category"]="po",
  ["description"]="TIBETAN MARK BSKA- SHOG GI MGO RGYAN",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0FD0, -- ࿐
 },
 [0x0FD1]={
  ["category"]="po",
  ["description"]="TIBETAN MARK MNYAM YIG GI MGO RGYAN",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x0FD1, -- ࿑
 },
 [0x1000]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER KA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1000, -- က
 },
 [0x1001]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER KHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1001, -- ခ
 },
 [0x1002]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER GA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1002, -- ဂ
 },
 [0x1003]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER GHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1003, -- ဃ
 },
 [0x1004]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER NGA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1004, -- င
 },
 [0x1005]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER CA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1005, -- စ
 },
 [0x1006]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER CHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1006, -- ဆ
 },
 [0x1007]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER JA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1007, -- ဇ
 },
 [0x1008]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER JHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1008, -- ဈ
 },
 [0x1009]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER NYA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1009, -- ဉ
 },
 [0x100A]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER NNYA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x100A, -- ည
 },
 [0x100B]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER TTA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x100B, -- ဋ
 },
 [0x100C]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER TTHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x100C, -- ဌ
 },
 [0x100D]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER DDA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x100D, -- ဍ
 },
 [0x100E]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER DDHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x100E, -- ဎ
 },
 [0x100F]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER NNA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x100F, -- ဏ
 },
 [0x1010]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER TA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1010, -- တ
 },
 [0x1011]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER THA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1011, -- ထ
 },
 [0x1012]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER DA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1012, -- ဒ
 },
 [0x1013]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER DHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1013, -- ဓ
 },
 [0x1014]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER NA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1014, -- န
 },
 [0x1015]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER PA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1015, -- ပ
 },
 [0x1016]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER PHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1016, -- ဖ
 },
 [0x1017]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER BA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1017, -- ဗ
 },
 [0x1018]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER BHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1018, -- ဘ
 },
 [0x1019]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER MA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1019, -- မ
 },
 [0x101A]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER YA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x101A, -- ယ
 },
 [0x101B]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER RA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x101B, -- ရ
 },
 [0x101C]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER LA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x101C, -- လ
 },
 [0x101D]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER WA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x101D, -- ဝ
 },
 [0x101E]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER SA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x101E, -- သ
 },
 [0x101F]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER HA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x101F, -- ဟ
 },
 [0x1020]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER LLA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1020, -- ဠ
 },
 [0x1021]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER A",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1021, -- အ
 },
 [0x1023]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER I",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1023, -- ဣ
 },
 [0x1024]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER II",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1024, -- ဤ
 },
 [0x1025]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER U",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1025, -- ဥ
 },
 [0x1026]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER UU",
  ["linebreak"]="sa",
  ["specials"]={ "char", 0x1025, 0x102E },
  ["unicodeslot"]=0x1026, -- ဦ
 },
 [0x1027]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER E",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1027, -- ဧ
 },
 [0x1029]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER O",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1029, -- ဩ
 },
 [0x102A]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER AU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x102A, -- ဪ
 },
 [0x102C]={
  ["category"]="mc",
  ["description"]="MYANMAR VOWEL SIGN AA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x102C, -- ာ
 },
 [0x102D]={
  ["category"]="mn",
  ["description"]="MYANMAR VOWEL SIGN I",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x102D, -- ိ
 },
 [0x102E]={
  ["category"]="mn",
  ["description"]="MYANMAR VOWEL SIGN II",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x102E, -- ီ
 },
 [0x102F]={
  ["category"]="mn",
  ["description"]="MYANMAR VOWEL SIGN U",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x102F, -- ု
 },
 [0x1030]={
  ["category"]="mn",
  ["description"]="MYANMAR VOWEL SIGN UU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1030, -- ူ
 },
 [0x1031]={
  ["category"]="mc",
  ["description"]="MYANMAR VOWEL SIGN E",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1031, -- ေ
 },
 [0x1032]={
  ["category"]="mn",
  ["description"]="MYANMAR VOWEL SIGN AI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1032, -- ဲ
 },
 [0x1036]={
  ["category"]="mn",
  ["description"]="MYANMAR SIGN ANUSVARA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1036, -- ံ
 },
 [0x1037]={
  ["category"]="mn",
  ["description"]="MYANMAR SIGN DOT BELOW",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1037, -- ့
 },
 [0x1038]={
  ["category"]="mc",
  ["description"]="MYANMAR SIGN VISARGA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1038, -- း
 },
 [0x1039]={
  ["category"]="mn",
  ["description"]="MYANMAR SIGN VIRAMA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1039, -- ္
 },
 [0x1040]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1040, -- ၀
 },
 [0x1041]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1041, -- ၁
 },
 [0x1042]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1042, -- ၂
 },
 [0x1043]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1043, -- ၃
 },
 [0x1044]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1044, -- ၄
 },
 [0x1045]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1045, -- ၅
 },
 [0x1046]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1046, -- ၆
 },
 [0x1047]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1047, -- ၇
 },
 [0x1048]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1048, -- ၈
 },
 [0x1049]={
  ["category"]="nd",
  ["description"]="MYANMAR DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1049, -- ၉
 },
 [0x104A]={
  ["category"]="po",
  ["description"]="MYANMAR SIGN LITTLE SECTION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x104A, -- ၊
 },
 [0x104B]={
  ["category"]="po",
  ["description"]="MYANMAR SIGN SECTION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x104B, -- ။
 },
 [0x104C]={
  ["category"]="po",
  ["description"]="MYANMAR SYMBOL LOCATIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x104C, -- ၌
 },
 [0x104D]={
  ["category"]="po",
  ["description"]="MYANMAR SYMBOL COMPLETED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x104D, -- ၍
 },
 [0x104E]={
  ["category"]="po",
  ["description"]="MYANMAR SYMBOL AFOREMENTIONED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x104E, -- ၎
 },
 [0x104F]={
  ["category"]="po",
  ["description"]="MYANMAR SYMBOL GENITIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x104F, -- ၏
 },
 [0x1050]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER SHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1050, -- ၐ
 },
 [0x1051]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER SSA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1051, -- ၑ
 },
 [0x1052]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER VOCALIC R",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1052, -- ၒ
 },
 [0x1053]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER VOCALIC RR",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1053, -- ၓ
 },
 [0x1054]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER VOCALIC L",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1054, -- ၔ
 },
 [0x1055]={
  ["category"]="lo",
  ["description"]="MYANMAR LETTER VOCALIC LL",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1055, -- ၕ
 },
 [0x1056]={
  ["category"]="mc",
  ["description"]="MYANMAR VOWEL SIGN VOCALIC R",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1056, -- ၖ
 },
 [0x1057]={
  ["category"]="mc",
  ["description"]="MYANMAR VOWEL SIGN VOCALIC RR",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1057, -- ၗ
 },
 [0x1058]={
  ["category"]="mn",
  ["description"]="MYANMAR VOWEL SIGN VOCALIC L",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1058, -- ၘ
 },
 [0x1059]={
  ["category"]="mn",
  ["description"]="MYANMAR VOWEL SIGN VOCALIC LL",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1059, -- ၙ
 },
 [0x10A0]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER AN",
  ["lccode"]=0x2D00,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A0, -- Ⴀ
 },
 [0x10A1]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER BAN",
  ["lccode"]=0x2D01,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A1, -- Ⴁ
 },
 [0x10A2]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER GAN",
  ["lccode"]=0x2D02,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A2, -- Ⴂ
 },
 [0x10A3]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER DON",
  ["lccode"]=0x2D03,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A3, -- Ⴃ
 },
 [0x10A4]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER EN",
  ["lccode"]=0x2D04,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A4, -- Ⴄ
 },
 [0x10A5]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER VIN",
  ["lccode"]=0x2D05,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A5, -- Ⴅ
 },
 [0x10A6]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER ZEN",
  ["lccode"]=0x2D06,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A6, -- Ⴆ
 },
 [0x10A7]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER TAN",
  ["lccode"]=0x2D07,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A7, -- Ⴇ
 },
 [0x10A8]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER IN",
  ["lccode"]=0x2D08,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A8, -- Ⴈ
 },
 [0x10A9]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER KAN",
  ["lccode"]=0x2D09,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A9, -- Ⴉ
 },
 [0x10AA]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER LAS",
  ["lccode"]=0x2D0A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10AA, -- Ⴊ
 },
 [0x10AB]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER MAN",
  ["lccode"]=0x2D0B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10AB, -- Ⴋ
 },
 [0x10AC]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER NAR",
  ["lccode"]=0x2D0C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10AC, -- Ⴌ
 },
 [0x10AD]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER ON",
  ["lccode"]=0x2D0D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10AD, -- Ⴍ
 },
 [0x10AE]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER PAR",
  ["lccode"]=0x2D0E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10AE, -- Ⴎ
 },
 [0x10AF]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER ZHAR",
  ["lccode"]=0x2D0F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10AF, -- Ⴏ
 },
 [0x10B0]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER RAE",
  ["lccode"]=0x2D10,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B0, -- Ⴐ
 },
 [0x10B1]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER SAN",
  ["lccode"]=0x2D11,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B1, -- Ⴑ
 },
 [0x10B2]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER TAR",
  ["lccode"]=0x2D12,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B2, -- Ⴒ
 },
 [0x10B3]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER UN",
  ["lccode"]=0x2D13,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B3, -- Ⴓ
 },
 [0x10B4]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER PHAR",
  ["lccode"]=0x2D14,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B4, -- Ⴔ
 },
 [0x10B5]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER KHAR",
  ["lccode"]=0x2D15,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B5, -- Ⴕ
 },
 [0x10B6]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER GHAN",
  ["lccode"]=0x2D16,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B6, -- Ⴖ
 },
 [0x10B7]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER QAR",
  ["lccode"]=0x2D17,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B7, -- Ⴗ
 },
 [0x10B8]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER SHIN",
  ["lccode"]=0x2D18,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B8, -- Ⴘ
 },
 [0x10B9]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER CHIN",
  ["lccode"]=0x2D19,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10B9, -- Ⴙ
 },
 [0x10BA]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER CAN",
  ["lccode"]=0x2D1A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10BA, -- Ⴚ
 },
 [0x10BB]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER JIL",
  ["lccode"]=0x2D1B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10BB, -- Ⴛ
 },
 [0x10BC]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER CIL",
  ["lccode"]=0x2D1C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10BC, -- Ⴜ
 },
 [0x10BD]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER CHAR",
  ["lccode"]=0x2D1D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10BD, -- Ⴝ
 },
 [0x10BE]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER XAN",
  ["lccode"]=0x2D1E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10BE, -- Ⴞ
 },
 [0x10BF]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER JHAN",
  ["lccode"]=0x2D1F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10BF, -- Ⴟ
 },
 [0x10C0]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER HAE",
  ["lccode"]=0x2D20,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10C0, -- Ⴠ
 },
 [0x10C1]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER HE",
  ["lccode"]=0x2D21,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10C1, -- Ⴡ
 },
 [0x10C2]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER HIE",
  ["lccode"]=0x2D22,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10C2, -- Ⴢ
 },
 [0x10C3]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER WE",
  ["lccode"]=0x2D23,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10C3, -- Ⴣ
 },
 [0x10C4]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER HAR",
  ["lccode"]=0x2D24,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10C4, -- Ⴤ
 },
 [0x10C5]={
  ["category"]="lu",
  ["description"]="GEORGIAN CAPITAL LETTER HOE",
  ["lccode"]=0x2D25,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10C5, -- Ⴥ
 },
 [0x10D0]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D0, -- ა
 },
 [0x10D1]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER BAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D1, -- ბ
 },
 [0x10D2]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER GAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D2, -- გ
 },
 [0x10D3]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER DON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D3, -- დ
 },
 [0x10D4]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D4, -- ე
 },
 [0x10D5]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER VIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D5, -- ვ
 },
 [0x10D6]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER ZEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D6, -- ზ
 },
 [0x10D7]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER TAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D7, -- თ
 },
 [0x10D8]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER IN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D8, -- ი
 },
 [0x10D9]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER KAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10D9, -- კ
 },
 [0x10DA]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER LAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10DA, -- ლ
 },
 [0x10DB]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER MAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10DB, -- მ
 },
 [0x10DC]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER NAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10DC, -- ნ
 },
 [0x10DD]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER ON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10DD, -- ო
 },
 [0x10DE]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER PAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10DE, -- პ
 },
 [0x10DF]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER ZHAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10DF, -- ჟ
 },
 [0x10E0]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER RAE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E0, -- რ
 },
 [0x10E1]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER SAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E1, -- ს
 },
 [0x10E2]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER TAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E2, -- ტ
 },
 [0x10E3]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER UN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E3, -- უ
 },
 [0x10E4]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER PHAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E4, -- ფ
 },
 [0x10E5]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER KHAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E5, -- ქ
 },
 [0x10E6]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER GHAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E6, -- ღ
 },
 [0x10E7]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER QAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E7, -- ყ
 },
 [0x10E8]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER SHIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E8, -- შ
 },
 [0x10E9]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER CHIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10E9, -- ჩ
 },
 [0x10EA]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER CAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10EA, -- ც
 },
 [0x10EB]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER JIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10EB, -- ძ
 },
 [0x10EC]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER CIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10EC, -- წ
 },
 [0x10ED]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER CHAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10ED, -- ჭ
 },
 [0x10EE]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER XAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10EE, -- ხ
 },
 [0x10EF]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER JHAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10EF, -- ჯ
 },
 [0x10F0]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER HAE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F0, -- ჰ
 },
 [0x10F1]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F1, -- ჱ
 },
 [0x10F2]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER HIE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F2, -- ჲ
 },
 [0x10F3]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER WE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F3, -- ჳ
 },
 [0x10F4]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER HAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F4, -- ჴ
 },
 [0x10F5]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER HOE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F5, -- ჵ
 },
 [0x10F6]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER FI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F6, -- ჶ
 },
 [0x10F7]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER YN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F7, -- ჷ
 },
 [0x10F8]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER ELIFI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F8, -- ჸ
 },
 [0x10F9]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER TURNED GAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10F9, -- ჹ
 },
 [0x10FA]={
  ["category"]="lo",
  ["description"]="GEORGIAN LETTER AIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10FA, -- ჺ
 },
 [0x10FB]={
  ["category"]="po",
  ["description"]="GEORGIAN PARAGRAPH SEPARATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10FB, -- ჻
 },
 [0x10FC]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER GEORGIAN NAR",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x10DC },
  ["unicodeslot"]=0x10FC, -- ჼ
 },
 [0x1100]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG KIYEOK",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1100, -- ᄀ
 },
 [0x1101]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SSANGKIYEOK",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1101, -- ᄁ
 },
 [0x1102]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG NIEUN",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1102, -- ᄂ
 },
 [0x1103]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG TIKEUT",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1103, -- ᄃ
 },
 [0x1104]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SSANGTIKEUT",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1104, -- ᄄ
 },
 [0x1105]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG RIEUL",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1105, -- ᄅ
 },
 [0x1106]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG MIEUM",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1106, -- ᄆ
 },
 [0x1107]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1107, -- ᄇ
 },
 [0x1108]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SSANGPIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1108, -- ᄈ
 },
 [0x1109]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1109, -- ᄉ
 },
 [0x110A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SSANGSIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x110A, -- ᄊ
 },
 [0x110B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x110B, -- ᄋ
 },
 [0x110C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x110C, -- ᄌ
 },
 [0x110D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SSANGCIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x110D, -- ᄍ
 },
 [0x110E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CHIEUCH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x110E, -- ᄎ
 },
 [0x110F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG KHIEUKH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x110F, -- ᄏ
 },
 [0x1110]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG THIEUTH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1110, -- ᄐ
 },
 [0x1111]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PHIEUPH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1111, -- ᄑ
 },
 [0x1112]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG HIEUH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1112, -- ᄒ
 },
 [0x1113]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG NIEUN-KIYEOK",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1113, -- ᄓ
 },
 [0x1114]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SSANGNIEUN",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1114, -- ᄔ
 },
 [0x1115]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG NIEUN-TIKEUT",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1115, -- ᄕ
 },
 [0x1116]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG NIEUN-PIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1116, -- ᄖ
 },
 [0x1117]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG TIKEUT-KIYEOK",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1117, -- ᄗ
 },
 [0x1118]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG RIEUL-NIEUN",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1118, -- ᄘ
 },
 [0x1119]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SSANGRIEUL",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1119, -- ᄙ
 },
 [0x111A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG RIEUL-HIEUH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x111A, -- ᄚ
 },
 [0x111B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG KAPYEOUNRIEUL",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x111B, -- ᄛ
 },
 [0x111C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG MIEUM-PIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x111C, -- ᄜ
 },
 [0x111D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG KAPYEOUNMIEUM",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x111D, -- ᄝ
 },
 [0x111E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-KIYEOK",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x111E, -- ᄞ
 },
 [0x111F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-NIEUN",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x111F, -- ᄟ
 },
 [0x1120]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-TIKEUT",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1120, -- ᄠ
 },
 [0x1121]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-SIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1121, -- ᄡ
 },
 [0x1122]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-SIOS-KIYEOK",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1122, -- ᄢ
 },
 [0x1123]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-SIOS-TIKEUT",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1123, -- ᄣ
 },
 [0x1124]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-SIOS-PIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1124, -- ᄤ
 },
 [0x1125]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-SSANGSIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1125, -- ᄥ
 },
 [0x1126]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-SIOS-CIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1126, -- ᄦ
 },
 [0x1127]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-CIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1127, -- ᄧ
 },
 [0x1128]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-CHIEUCH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1128, -- ᄨ
 },
 [0x1129]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-THIEUTH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1129, -- ᄩ
 },
 [0x112A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PIEUP-PHIEUPH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x112A, -- ᄪ
 },
 [0x112B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG KAPYEOUNPIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x112B, -- ᄫ
 },
 [0x112C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG KAPYEOUNSSANGPIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x112C, -- ᄬ
 },
 [0x112D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-KIYEOK",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x112D, -- ᄭ
 },
 [0x112E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-NIEUN",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x112E, -- ᄮ
 },
 [0x112F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-TIKEUT",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x112F, -- ᄯ
 },
 [0x1130]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-RIEUL",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1130, -- ᄰ
 },
 [0x1131]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-MIEUM",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1131, -- ᄱ
 },
 [0x1132]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-PIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1132, -- ᄲ
 },
 [0x1133]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-PIEUP-KIYEOK",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1133, -- ᄳ
 },
 [0x1134]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-SSANGSIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1134, -- ᄴ
 },
 [0x1135]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-IEUNG",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1135, -- ᄵ
 },
 [0x1136]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-CIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1136, -- ᄶ
 },
 [0x1137]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-CHIEUCH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1137, -- ᄷ
 },
 [0x1138]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-KHIEUKH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1138, -- ᄸ
 },
 [0x1139]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-THIEUTH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1139, -- ᄹ
 },
 [0x113A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-PHIEUPH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x113A, -- ᄺ
 },
 [0x113B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SIOS-HIEUH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x113B, -- ᄻ
 },
 [0x113C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CHITUEUMSIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x113C, -- ᄼ
 },
 [0x113D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CHITUEUMSSANGSIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x113D, -- ᄽ
 },
 [0x113E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CEONGCHIEUMSIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x113E, -- ᄾ
 },
 [0x113F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CEONGCHIEUMSSANGSIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x113F, -- ᄿ
 },
 [0x1140]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PANSIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1140, -- ᅀ
 },
 [0x1141]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-KIYEOK",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1141, -- ᅁ
 },
 [0x1142]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-TIKEUT",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1142, -- ᅂ
 },
 [0x1143]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-MIEUM",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1143, -- ᅃ
 },
 [0x1144]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-PIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1144, -- ᅄ
 },
 [0x1145]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-SIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1145, -- ᅅ
 },
 [0x1146]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-PANSIOS",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1146, -- ᅆ
 },
 [0x1147]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SSANGIEUNG",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1147, -- ᅇ
 },
 [0x1148]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-CIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1148, -- ᅈ
 },
 [0x1149]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-CHIEUCH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1149, -- ᅉ
 },
 [0x114A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-THIEUTH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x114A, -- ᅊ
 },
 [0x114B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG IEUNG-PHIEUPH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x114B, -- ᅋ
 },
 [0x114C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG YESIEUNG",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x114C, -- ᅌ
 },
 [0x114D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CIEUC-IEUNG",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x114D, -- ᅍ
 },
 [0x114E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CHITUEUMCIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x114E, -- ᅎ
 },
 [0x114F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CHITUEUMSSANGCIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x114F, -- ᅏ
 },
 [0x1150]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CEONGCHIEUMCIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1150, -- ᅐ
 },
 [0x1151]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CEONGCHIEUMSSANGCIEUC",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1151, -- ᅑ
 },
 [0x1152]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CHIEUCH-KHIEUKH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1152, -- ᅒ
 },
 [0x1153]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CHIEUCH-HIEUH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1153, -- ᅓ
 },
 [0x1154]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CHITUEUMCHIEUCH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1154, -- ᅔ
 },
 [0x1155]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG CEONGCHIEUMCHIEUCH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1155, -- ᅕ
 },
 [0x1156]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG PHIEUPH-PIEUP",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1156, -- ᅖ
 },
 [0x1157]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG KAPYEOUNPHIEUPH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1157, -- ᅗ
 },
 [0x1158]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG SSANGHIEUH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1158, -- ᅘ
 },
 [0x1159]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG YEORINHIEUH",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x1159, -- ᅙ
 },
 [0x115F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL CHOSEONG FILLER",
  ["linebreak"]="jl",
  ["unicodeslot"]=0x115F, -- ᅟ
 },
 [0x1160]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG FILLER",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1160, -- ᅠ
 },
 [0x1161]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG A",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1161, -- ᅡ
 },
 [0x1162]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG AE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1162, -- ᅢ
 },
 [0x1163]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YA",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1163, -- ᅣ
 },
 [0x1164]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YAE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1164, -- ᅤ
 },
 [0x1165]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG EO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1165, -- ᅥ
 },
 [0x1166]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG E",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1166, -- ᅦ
 },
 [0x1167]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YEO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1167, -- ᅧ
 },
 [0x1168]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1168, -- ᅨ
 },
 [0x1169]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG O",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1169, -- ᅩ
 },
 [0x116A]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG WA",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x116A, -- ᅪ
 },
 [0x116B]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG WAE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x116B, -- ᅫ
 },
 [0x116C]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG OE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x116C, -- ᅬ
 },
 [0x116D]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x116D, -- ᅭ
 },
 [0x116E]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x116E, -- ᅮ
 },
 [0x116F]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG WEO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x116F, -- ᅯ
 },
 [0x1170]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG WE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1170, -- ᅰ
 },
 [0x1171]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG WI",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1171, -- ᅱ
 },
 [0x1172]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YU",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1172, -- ᅲ
 },
 [0x1173]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG EU",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1173, -- ᅳ
 },
 [0x1174]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YI",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1174, -- ᅴ
 },
 [0x1175]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG I",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1175, -- ᅵ
 },
 [0x1176]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG A-O",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1176, -- ᅶ
 },
 [0x1177]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG A-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1177, -- ᅷ
 },
 [0x1178]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YA-O",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1178, -- ᅸ
 },
 [0x1179]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YA-YO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1179, -- ᅹ
 },
 [0x117A]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG EO-O",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x117A, -- ᅺ
 },
 [0x117B]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG EO-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x117B, -- ᅻ
 },
 [0x117C]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG EO-EU",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x117C, -- ᅼ
 },
 [0x117D]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YEO-O",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x117D, -- ᅽ
 },
 [0x117E]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YEO-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x117E, -- ᅾ
 },
 [0x117F]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG O-EO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x117F, -- ᅿ
 },
 [0x1180]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG O-E",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1180, -- ᆀ
 },
 [0x1181]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG O-YE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1181, -- ᆁ
 },
 [0x1182]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG O-O",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1182, -- ᆂ
 },
 [0x1183]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG O-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1183, -- ᆃ
 },
 [0x1184]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YO-YA",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1184, -- ᆄ
 },
 [0x1185]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YO-YAE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1185, -- ᆅ
 },
 [0x1186]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YO-YEO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1186, -- ᆆ
 },
 [0x1187]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YO-O",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1187, -- ᆇ
 },
 [0x1188]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YO-I",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1188, -- ᆈ
 },
 [0x1189]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG U-A",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1189, -- ᆉ
 },
 [0x118A]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG U-AE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x118A, -- ᆊ
 },
 [0x118B]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG U-EO-EU",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x118B, -- ᆋ
 },
 [0x118C]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG U-YE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x118C, -- ᆌ
 },
 [0x118D]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG U-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x118D, -- ᆍ
 },
 [0x118E]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YU-A",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x118E, -- ᆎ
 },
 [0x118F]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YU-EO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x118F, -- ᆏ
 },
 [0x1190]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YU-E",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1190, -- ᆐ
 },
 [0x1191]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YU-YEO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1191, -- ᆑ
 },
 [0x1192]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YU-YE",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1192, -- ᆒ
 },
 [0x1193]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YU-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1193, -- ᆓ
 },
 [0x1194]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YU-I",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1194, -- ᆔ
 },
 [0x1195]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG EU-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1195, -- ᆕ
 },
 [0x1196]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG EU-EU",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1196, -- ᆖ
 },
 [0x1197]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG YI-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1197, -- ᆗ
 },
 [0x1198]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG I-A",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1198, -- ᆘ
 },
 [0x1199]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG I-YA",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x1199, -- ᆙ
 },
 [0x119A]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG I-O",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x119A, -- ᆚ
 },
 [0x119B]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG I-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x119B, -- ᆛ
 },
 [0x119C]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG I-EU",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x119C, -- ᆜ
 },
 [0x119D]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG I-ARAEA",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x119D, -- ᆝ
 },
 [0x119E]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG ARAEA",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x119E, -- ᆞ
 },
 [0x119F]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG ARAEA-EO",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x119F, -- ᆟ
 },
 [0x11A0]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG ARAEA-U",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x11A0, -- ᆠ
 },
 [0x11A1]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG ARAEA-I",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x11A1, -- ᆡ
 },
 [0x11A2]={
  ["category"]="lo",
  ["description"]="HANGUL JUNGSEONG SSANGARAEA",
  ["linebreak"]="jv",
  ["unicodeslot"]=0x11A2, -- ᆢ
 },
 [0x11A8]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG KIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11A8, -- ᆨ
 },
 [0x11A9]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG SSANGKIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11A9, -- ᆩ
 },
 [0x11AA]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG KIYEOK-SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11AA, -- ᆪ
 },
 [0x11AB]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG NIEUN",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11AB, -- ᆫ
 },
 [0x11AC]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG NIEUN-CIEUC",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11AC, -- ᆬ
 },
 [0x11AD]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG NIEUN-HIEUH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11AD, -- ᆭ
 },
 [0x11AE]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG TIKEUT",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11AE, -- ᆮ
 },
 [0x11AF]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11AF, -- ᆯ
 },
 [0x11B0]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-KIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B0, -- ᆰ
 },
 [0x11B1]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-MIEUM",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B1, -- ᆱ
 },
 [0x11B2]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-PIEUP",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B2, -- ᆲ
 },
 [0x11B3]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B3, -- ᆳ
 },
 [0x11B4]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-THIEUTH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B4, -- ᆴ
 },
 [0x11B5]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-PHIEUPH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B5, -- ᆵ
 },
 [0x11B6]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-HIEUH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B6, -- ᆶ
 },
 [0x11B7]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG MIEUM",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B7, -- ᆷ
 },
 [0x11B8]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG PIEUP",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B8, -- ᆸ
 },
 [0x11B9]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG PIEUP-SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11B9, -- ᆹ
 },
 [0x11BA]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11BA, -- ᆺ
 },
 [0x11BB]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG SSANGSIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11BB, -- ᆻ
 },
 [0x11BC]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG IEUNG",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11BC, -- ᆼ
 },
 [0x11BD]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG CIEUC",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11BD, -- ᆽ
 },
 [0x11BE]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG CHIEUCH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11BE, -- ᆾ
 },
 [0x11BF]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG KHIEUKH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11BF, -- ᆿ
 },
 [0x11C0]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG THIEUTH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C0, -- ᇀ
 },
 [0x11C1]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG PHIEUPH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C1, -- ᇁ
 },
 [0x11C2]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG HIEUH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C2, -- ᇂ
 },
 [0x11C3]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG KIYEOK-RIEUL",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C3, -- ᇃ
 },
 [0x11C4]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG KIYEOK-SIOS-KIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C4, -- ᇄ
 },
 [0x11C5]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG NIEUN-KIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C5, -- ᇅ
 },
 [0x11C6]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG NIEUN-TIKEUT",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C6, -- ᇆ
 },
 [0x11C7]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG NIEUN-SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C7, -- ᇇ
 },
 [0x11C8]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG NIEUN-PANSIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C8, -- ᇈ
 },
 [0x11C9]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG NIEUN-THIEUTH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11C9, -- ᇉ
 },
 [0x11CA]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG TIKEUT-KIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11CA, -- ᇊ
 },
 [0x11CB]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG TIKEUT-RIEUL",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11CB, -- ᇋ
 },
 [0x11CC]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-KIYEOK-SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11CC, -- ᇌ
 },
 [0x11CD]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-NIEUN",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11CD, -- ᇍ
 },
 [0x11CE]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-TIKEUT",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11CE, -- ᇎ
 },
 [0x11CF]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-TIKEUT-HIEUH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11CF, -- ᇏ
 },
 [0x11D0]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG SSANGRIEUL",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D0, -- ᇐ
 },
 [0x11D1]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-MIEUM-KIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D1, -- ᇑ
 },
 [0x11D2]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-MIEUM-SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D2, -- ᇒ
 },
 [0x11D3]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-PIEUP-SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D3, -- ᇓ
 },
 [0x11D4]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-PIEUP-HIEUH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D4, -- ᇔ
 },
 [0x11D5]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-KAPYEOUNPIEUP",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D5, -- ᇕ
 },
 [0x11D6]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-SSANGSIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D6, -- ᇖ
 },
 [0x11D7]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-PANSIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D7, -- ᇗ
 },
 [0x11D8]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-KHIEUKH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D8, -- ᇘ
 },
 [0x11D9]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG RIEUL-YEORINHIEUH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11D9, -- ᇙ
 },
 [0x11DA]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG MIEUM-KIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11DA, -- ᇚ
 },
 [0x11DB]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG MIEUM-RIEUL",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11DB, -- ᇛ
 },
 [0x11DC]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG MIEUM-PIEUP",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11DC, -- ᇜ
 },
 [0x11DD]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG MIEUM-SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11DD, -- ᇝ
 },
 [0x11DE]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG MIEUM-SSANGSIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11DE, -- ᇞ
 },
 [0x11DF]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG MIEUM-PANSIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11DF, -- ᇟ
 },
 [0x11E0]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG MIEUM-CHIEUCH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E0, -- ᇠ
 },
 [0x11E1]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG MIEUM-HIEUH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E1, -- ᇡ
 },
 [0x11E2]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG KAPYEOUNMIEUM",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E2, -- ᇢ
 },
 [0x11E3]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG PIEUP-RIEUL",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E3, -- ᇣ
 },
 [0x11E4]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG PIEUP-PHIEUPH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E4, -- ᇤ
 },
 [0x11E5]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG PIEUP-HIEUH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E5, -- ᇥ
 },
 [0x11E6]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG KAPYEOUNPIEUP",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E6, -- ᇦ
 },
 [0x11E7]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG SIOS-KIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E7, -- ᇧ
 },
 [0x11E8]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG SIOS-TIKEUT",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E8, -- ᇨ
 },
 [0x11E9]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG SIOS-RIEUL",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11E9, -- ᇩ
 },
 [0x11EA]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG SIOS-PIEUP",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11EA, -- ᇪ
 },
 [0x11EB]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG PANSIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11EB, -- ᇫ
 },
 [0x11EC]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG IEUNG-KIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11EC, -- ᇬ
 },
 [0x11ED]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG IEUNG-SSANGKIYEOK",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11ED, -- ᇭ
 },
 [0x11EE]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG SSANGIEUNG",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11EE, -- ᇮ
 },
 [0x11EF]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG IEUNG-KHIEUKH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11EF, -- ᇯ
 },
 [0x11F0]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG YESIEUNG",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F0, -- ᇰ
 },
 [0x11F1]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG YESIEUNG-SIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F1, -- ᇱ
 },
 [0x11F2]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG YESIEUNG-PANSIOS",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F2, -- ᇲ
 },
 [0x11F3]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG PHIEUPH-PIEUP",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F3, -- ᇳ
 },
 [0x11F4]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG KAPYEOUNPHIEUPH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F4, -- ᇴ
 },
 [0x11F5]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG HIEUH-NIEUN",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F5, -- ᇵ
 },
 [0x11F6]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG HIEUH-RIEUL",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F6, -- ᇶ
 },
 [0x11F7]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG HIEUH-MIEUM",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F7, -- ᇷ
 },
 [0x11F8]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG HIEUH-PIEUP",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F8, -- ᇸ
 },
 [0x11F9]={
  ["category"]="lo",
  ["description"]="HANGUL JONGSEONG YEORINHIEUH",
  ["linebreak"]="jt",
  ["unicodeslot"]=0x11F9, -- ᇹ
 },
 [0x1200]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1200, -- ሀ
 },
 [0x1201]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1201, -- ሁ
 },
 [0x1202]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1202, -- ሂ
 },
 [0x1203]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1203, -- ሃ
 },
 [0x1204]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1204, -- ሄ
 },
 [0x1205]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1205, -- ህ
 },
 [0x1206]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1206, -- ሆ
 },
 [0x1207]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1207, -- ሇ
 },
 [0x1208]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1208, -- ለ
 },
 [0x1209]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1209, -- ሉ
 },
 [0x120A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE LI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A, -- ሊ
 },
 [0x120B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE LAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B, -- ላ
 },
 [0x120C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE LEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C, -- ሌ
 },
 [0x120D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE LE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D, -- ል
 },
 [0x120E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE LO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E, -- ሎ
 },
 [0x120F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE LWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F, -- ሏ
 },
 [0x1210]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1210, -- ሐ
 },
 [0x1211]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1211, -- ሑ
 },
 [0x1212]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1212, -- ሒ
 },
 [0x1213]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1213, -- ሓ
 },
 [0x1214]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1214, -- ሔ
 },
 [0x1215]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1215, -- ሕ
 },
 [0x1216]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1216, -- ሖ
 },
 [0x1217]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE HHWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1217, -- ሗ
 },
 [0x1218]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1218, -- መ
 },
 [0x1219]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1219, -- ሙ
 },
 [0x121A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A, -- ሚ
 },
 [0x121B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B, -- ማ
 },
 [0x121C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C, -- ሜ
 },
 [0x121D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D, -- ም
 },
 [0x121E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E, -- ሞ
 },
 [0x121F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F, -- ሟ
 },
 [0x1220]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1220, -- ሠ
 },
 [0x1221]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SZU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1221, -- ሡ
 },
 [0x1222]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SZI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1222, -- ሢ
 },
 [0x1223]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SZAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1223, -- ሣ
 },
 [0x1224]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SZEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1224, -- ሤ
 },
 [0x1225]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1225, -- ሥ
 },
 [0x1226]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1226, -- ሦ
 },
 [0x1227]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SZWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1227, -- ሧ
 },
 [0x1228]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1228, -- ረ
 },
 [0x1229]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1229, -- ሩ
 },
 [0x122A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE RI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A, -- ሪ
 },
 [0x122B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE RAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B, -- ራ
 },
 [0x122C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE REE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C, -- ሬ
 },
 [0x122D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE RE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D, -- ር
 },
 [0x122E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E, -- ሮ
 },
 [0x122F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE RWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F, -- ሯ
 },
 [0x1230]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1230, -- ሰ
 },
 [0x1231]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1231, -- ሱ
 },
 [0x1232]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1232, -- ሲ
 },
 [0x1233]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1233, -- ሳ
 },
 [0x1234]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1234, -- ሴ
 },
 [0x1235]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1235, -- ስ
 },
 [0x1236]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1236, -- ሶ
 },
 [0x1237]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1237, -- ሷ
 },
 [0x1238]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1238, -- ሸ
 },
 [0x1239]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1239, -- ሹ
 },
 [0x123A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x123A, -- ሺ
 },
 [0x123B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x123B, -- ሻ
 },
 [0x123C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x123C, -- ሼ
 },
 [0x123D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x123D, -- ሽ
 },
 [0x123E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x123E, -- ሾ
 },
 [0x123F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SHWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x123F, -- ሿ
 },
 [0x1240]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1240, -- ቀ
 },
 [0x1241]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1241, -- ቁ
 },
 [0x1242]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1242, -- ቂ
 },
 [0x1243]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1243, -- ቃ
 },
 [0x1244]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1244, -- ቄ
 },
 [0x1245]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1245, -- ቅ
 },
 [0x1246]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1246, -- ቆ
 },
 [0x1247]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1247, -- ቇ
 },
 [0x1248]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1248, -- ቈ
 },
 [0x124A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x124A, -- ቊ
 },
 [0x124B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x124B, -- ቋ
 },
 [0x124C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x124C, -- ቌ
 },
 [0x124D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x124D, -- ቍ
 },
 [0x1250]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1250, -- ቐ
 },
 [0x1251]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1251, -- ቑ
 },
 [0x1252]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1252, -- ቒ
 },
 [0x1253]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1253, -- ቓ
 },
 [0x1254]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1254, -- ቔ
 },
 [0x1255]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1255, -- ቕ
 },
 [0x1256]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1256, -- ቖ
 },
 [0x1258]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1258, -- ቘ
 },
 [0x125A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x125A, -- ቚ
 },
 [0x125B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x125B, -- ቛ
 },
 [0x125C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x125C, -- ቜ
 },
 [0x125D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QHWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x125D, -- ቝ
 },
 [0x1260]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1260, -- በ
 },
 [0x1261]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1261, -- ቡ
 },
 [0x1262]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1262, -- ቢ
 },
 [0x1263]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1263, -- ባ
 },
 [0x1264]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1264, -- ቤ
 },
 [0x1265]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1265, -- ብ
 },
 [0x1266]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1266, -- ቦ
 },
 [0x1267]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1267, -- ቧ
 },
 [0x1268]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1268, -- ቨ
 },
 [0x1269]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE VU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1269, -- ቩ
 },
 [0x126A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE VI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x126A, -- ቪ
 },
 [0x126B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE VAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x126B, -- ቫ
 },
 [0x126C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE VEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x126C, -- ቬ
 },
 [0x126D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE VE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x126D, -- ቭ
 },
 [0x126E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE VO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x126E, -- ቮ
 },
 [0x126F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE VWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x126F, -- ቯ
 },
 [0x1270]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1270, -- ተ
 },
 [0x1271]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1271, -- ቱ
 },
 [0x1272]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1272, -- ቲ
 },
 [0x1273]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1273, -- ታ
 },
 [0x1274]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1274, -- ቴ
 },
 [0x1275]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1275, -- ት
 },
 [0x1276]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1276, -- ቶ
 },
 [0x1277]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1277, -- ቷ
 },
 [0x1278]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1278, -- ቸ
 },
 [0x1279]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1279, -- ቹ
 },
 [0x127A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x127A, -- ቺ
 },
 [0x127B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x127B, -- ቻ
 },
 [0x127C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x127C, -- ቼ
 },
 [0x127D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x127D, -- ች
 },
 [0x127E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x127E, -- ቾ
 },
 [0x127F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x127F, -- ቿ
 },
 [0x1280]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1280, -- ኀ
 },
 [0x1281]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1281, -- ኁ
 },
 [0x1282]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1282, -- ኂ
 },
 [0x1283]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1283, -- ኃ
 },
 [0x1284]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1284, -- ኄ
 },
 [0x1285]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1285, -- ኅ
 },
 [0x1286]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1286, -- ኆ
 },
 [0x1287]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1287, -- ኇ
 },
 [0x1288]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1288, -- ኈ
 },
 [0x128A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x128A, -- ኊ
 },
 [0x128B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x128B, -- ኋ
 },
 [0x128C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x128C, -- ኌ
 },
 [0x128D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x128D, -- ኍ
 },
 [0x1290]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1290, -- ነ
 },
 [0x1291]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1291, -- ኑ
 },
 [0x1292]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1292, -- ኒ
 },
 [0x1293]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1293, -- ና
 },
 [0x1294]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1294, -- ኔ
 },
 [0x1295]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1295, -- ን
 },
 [0x1296]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1296, -- ኖ
 },
 [0x1297]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1297, -- ኗ
 },
 [0x1298]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1298, -- ኘ
 },
 [0x1299]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NYU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1299, -- ኙ
 },
 [0x129A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NYI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x129A, -- ኚ
 },
 [0x129B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NYAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x129B, -- ኛ
 },
 [0x129C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NYEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x129C, -- ኜ
 },
 [0x129D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NYE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x129D, -- ኝ
 },
 [0x129E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NYO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x129E, -- ኞ
 },
 [0x129F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NYWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x129F, -- ኟ
 },
 [0x12A0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GLOTTAL A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A0, -- አ
 },
 [0x12A1]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GLOTTAL U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A1, -- ኡ
 },
 [0x12A2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GLOTTAL I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A2, -- ኢ
 },
 [0x12A3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GLOTTAL AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A3, -- ኣ
 },
 [0x12A4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GLOTTAL EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A4, -- ኤ
 },
 [0x12A5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GLOTTAL E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A5, -- እ
 },
 [0x12A6]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GLOTTAL O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A6, -- ኦ
 },
 [0x12A7]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GLOTTAL WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A7, -- ኧ
 },
 [0x12A8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A8, -- ከ
 },
 [0x12A9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12A9, -- ኩ
 },
 [0x12AA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12AA, -- ኪ
 },
 [0x12AB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12AB, -- ካ
 },
 [0x12AC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12AC, -- ኬ
 },
 [0x12AD]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12AD, -- ክ
 },
 [0x12AE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12AE, -- ኮ
 },
 [0x12AF]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12AF, -- ኯ
 },
 [0x12B0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12B0, -- ኰ
 },
 [0x12B2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12B2, -- ኲ
 },
 [0x12B3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12B3, -- ኳ
 },
 [0x12B4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12B4, -- ኴ
 },
 [0x12B5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12B5, -- ኵ
 },
 [0x12B8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12B8, -- ኸ
 },
 [0x12B9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12B9, -- ኹ
 },
 [0x12BA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12BA, -- ኺ
 },
 [0x12BB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12BB, -- ኻ
 },
 [0x12BC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12BC, -- ኼ
 },
 [0x12BD]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12BD, -- ኽ
 },
 [0x12BE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12BE, -- ኾ
 },
 [0x12C0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12C0, -- ዀ
 },
 [0x12C2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12C2, -- ዂ
 },
 [0x12C3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12C3, -- ዃ
 },
 [0x12C4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12C4, -- ዄ
 },
 [0x12C5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KXWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12C5, -- ዅ
 },
 [0x12C8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12C8, -- ወ
 },
 [0x12C9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE WU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12C9, -- ዉ
 },
 [0x12CA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE WI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12CA, -- ዊ
 },
 [0x12CB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE WAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12CB, -- ዋ
 },
 [0x12CC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE WEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12CC, -- ዌ
 },
 [0x12CD]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE WE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12CD, -- ው
 },
 [0x12CE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE WO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12CE, -- ዎ
 },
 [0x12CF]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE WOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12CF, -- ዏ
 },
 [0x12D0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHARYNGEAL A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12D0, -- ዐ
 },
 [0x12D1]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHARYNGEAL U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12D1, -- ዑ
 },
 [0x12D2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHARYNGEAL I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12D2, -- ዒ
 },
 [0x12D3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHARYNGEAL AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12D3, -- ዓ
 },
 [0x12D4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHARYNGEAL EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12D4, -- ዔ
 },
 [0x12D5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHARYNGEAL E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12D5, -- ዕ
 },
 [0x12D6]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHARYNGEAL O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12D6, -- ዖ
 },
 [0x12D8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12D8, -- ዘ
 },
 [0x12D9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12D9, -- ዙ
 },
 [0x12DA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12DA, -- ዚ
 },
 [0x12DB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12DB, -- ዛ
 },
 [0x12DC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12DC, -- ዜ
 },
 [0x12DD]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12DD, -- ዝ
 },
 [0x12DE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12DE, -- ዞ
 },
 [0x12DF]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12DF, -- ዟ
 },
 [0x12E0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E0, -- ዠ
 },
 [0x12E1]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E1, -- ዡ
 },
 [0x12E2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E2, -- ዢ
 },
 [0x12E3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E3, -- ዣ
 },
 [0x12E4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E4, -- ዤ
 },
 [0x12E5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E5, -- ዥ
 },
 [0x12E6]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E6, -- ዦ
 },
 [0x12E7]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZHWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E7, -- ዧ
 },
 [0x12E8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E8, -- የ
 },
 [0x12E9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE YU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12E9, -- ዩ
 },
 [0x12EA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE YI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12EA, -- ዪ
 },
 [0x12EB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE YAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12EB, -- ያ
 },
 [0x12EC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE YEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12EC, -- ዬ
 },
 [0x12ED]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE YE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12ED, -- ይ
 },
 [0x12EE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE YO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12EE, -- ዮ
 },
 [0x12EF]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE YOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12EF, -- ዯ
 },
 [0x12F0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F0, -- ደ
 },
 [0x12F1]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F1, -- ዱ
 },
 [0x12F2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F2, -- ዲ
 },
 [0x12F3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F3, -- ዳ
 },
 [0x12F4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F4, -- ዴ
 },
 [0x12F5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F5, -- ድ
 },
 [0x12F6]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F6, -- ዶ
 },
 [0x12F7]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F7, -- ዷ
 },
 [0x12F8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F8, -- ዸ
 },
 [0x12F9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DDU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12F9, -- ዹ
 },
 [0x12FA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DDI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12FA, -- ዺ
 },
 [0x12FB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DDAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12FB, -- ዻ
 },
 [0x12FC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DDEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12FC, -- ዼ
 },
 [0x12FD]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12FD, -- ዽ
 },
 [0x12FE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DDO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12FE, -- ዾ
 },
 [0x12FF]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DDWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12FF, -- ዿ
 },
 [0x1300]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1300, -- ጀ
 },
 [0x1301]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE JU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1301, -- ጁ
 },
 [0x1302]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE JI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1302, -- ጂ
 },
 [0x1303]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE JAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1303, -- ጃ
 },
 [0x1304]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE JEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1304, -- ጄ
 },
 [0x1305]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE JE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1305, -- ጅ
 },
 [0x1306]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE JO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1306, -- ጆ
 },
 [0x1307]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE JWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1307, -- ጇ
 },
 [0x1308]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1308, -- ገ
 },
 [0x1309]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1309, -- ጉ
 },
 [0x130A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x130A, -- ጊ
 },
 [0x130B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x130B, -- ጋ
 },
 [0x130C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x130C, -- ጌ
 },
 [0x130D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x130D, -- ግ
 },
 [0x130E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x130E, -- ጎ
 },
 [0x130F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x130F, -- ጏ
 },
 [0x1310]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1310, -- ጐ
 },
 [0x1312]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1312, -- ጒ
 },
 [0x1313]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1313, -- ጓ
 },
 [0x1314]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1314, -- ጔ
 },
 [0x1315]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1315, -- ጕ
 },
 [0x1318]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1318, -- ጘ
 },
 [0x1319]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1319, -- ጙ
 },
 [0x131A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x131A, -- ጚ
 },
 [0x131B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x131B, -- ጛ
 },
 [0x131C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x131C, -- ጜ
 },
 [0x131D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x131D, -- ጝ
 },
 [0x131E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x131E, -- ጞ
 },
 [0x131F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x131F, -- ጟ
 },
 [0x1320]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1320, -- ጠ
 },
 [0x1321]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE THU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1321, -- ጡ
 },
 [0x1322]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE THI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1322, -- ጢ
 },
 [0x1323]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE THAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1323, -- ጣ
 },
 [0x1324]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE THEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1324, -- ጤ
 },
 [0x1325]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE THE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1325, -- ጥ
 },
 [0x1326]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE THO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1326, -- ጦ
 },
 [0x1327]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE THWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1327, -- ጧ
 },
 [0x1328]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1328, -- ጨ
 },
 [0x1329]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1329, -- ጩ
 },
 [0x132A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x132A, -- ጪ
 },
 [0x132B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x132B, -- ጫ
 },
 [0x132C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x132C, -- ጬ
 },
 [0x132D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x132D, -- ጭ
 },
 [0x132E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x132E, -- ጮ
 },
 [0x132F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CHWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x132F, -- ጯ
 },
 [0x1330]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1330, -- ጰ
 },
 [0x1331]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1331, -- ጱ
 },
 [0x1332]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1332, -- ጲ
 },
 [0x1333]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1333, -- ጳ
 },
 [0x1334]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1334, -- ጴ
 },
 [0x1335]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1335, -- ጵ
 },
 [0x1336]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1336, -- ጶ
 },
 [0x1337]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1337, -- ጷ
 },
 [0x1338]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1338, -- ጸ
 },
 [0x1339]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TSU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1339, -- ጹ
 },
 [0x133A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TSI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x133A, -- ጺ
 },
 [0x133B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TSAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x133B, -- ጻ
 },
 [0x133C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TSEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x133C, -- ጼ
 },
 [0x133D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TSE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x133D, -- ጽ
 },
 [0x133E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TSO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x133E, -- ጾ
 },
 [0x133F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TSWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x133F, -- ጿ
 },
 [0x1340]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1340, -- ፀ
 },
 [0x1341]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TZU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1341, -- ፁ
 },
 [0x1342]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TZI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1342, -- ፂ
 },
 [0x1343]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TZAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1343, -- ፃ
 },
 [0x1344]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TZEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1344, -- ፄ
 },
 [0x1345]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1345, -- ፅ
 },
 [0x1346]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1346, -- ፆ
 },
 [0x1347]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TZOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1347, -- ፇ
 },
 [0x1348]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1348, -- ፈ
 },
 [0x1349]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1349, -- ፉ
 },
 [0x134A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x134A, -- ፊ
 },
 [0x134B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x134B, -- ፋ
 },
 [0x134C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x134C, -- ፌ
 },
 [0x134D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x134D, -- ፍ
 },
 [0x134E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x134E, -- ፎ
 },
 [0x134F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x134F, -- ፏ
 },
 [0x1350]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1350, -- ፐ
 },
 [0x1351]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1351, -- ፑ
 },
 [0x1352]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1352, -- ፒ
 },
 [0x1353]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1353, -- ፓ
 },
 [0x1354]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1354, -- ፔ
 },
 [0x1355]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1355, -- ፕ
 },
 [0x1356]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1356, -- ፖ
 },
 [0x1357]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1357, -- ፗ
 },
 [0x1358]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE RYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1358, -- ፘ
 },
 [0x1359]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1359, -- ፙ
 },
 [0x135A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x135A, -- ፚ
 },
 [0x135F]={
  ["category"]="mn",
  ["description"]="ETHIOPIC COMBINING GEMINATION MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x135F, -- ፟
 },
 [0x1360]={
  ["category"]="so",
  ["description"]="ETHIOPIC SECTION MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1360, -- ፠
 },
 [0x1361]={
  ["category"]="po",
  ["description"]="ETHIOPIC WORDSPACE",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1361, -- ፡
 },
 [0x1362]={
  ["category"]="po",
  ["description"]="ETHIOPIC FULL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1362, -- ።
 },
 [0x1363]={
  ["category"]="po",
  ["description"]="ETHIOPIC COMMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1363, -- ፣
 },
 [0x1364]={
  ["category"]="po",
  ["description"]="ETHIOPIC SEMICOLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1364, -- ፤
 },
 [0x1365]={
  ["category"]="po",
  ["description"]="ETHIOPIC COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1365, -- ፥
 },
 [0x1366]={
  ["category"]="po",
  ["description"]="ETHIOPIC PREFACE COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1366, -- ፦
 },
 [0x1367]={
  ["category"]="po",
  ["description"]="ETHIOPIC QUESTION MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1367, -- ፧
 },
 [0x1368]={
  ["category"]="po",
  ["description"]="ETHIOPIC PARAGRAPH SEPARATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1368, -- ፨
 },
 [0x1369]={
  ["category"]="no",
  ["description"]="ETHIOPIC DIGIT ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1369, -- ፩
 },
 [0x136A]={
  ["category"]="no",
  ["description"]="ETHIOPIC DIGIT TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x136A, -- ፪
 },
 [0x136B]={
  ["category"]="no",
  ["description"]="ETHIOPIC DIGIT THREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x136B, -- ፫
 },
 [0x136C]={
  ["category"]="no",
  ["description"]="ETHIOPIC DIGIT FOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x136C, -- ፬
 },
 [0x136D]={
  ["category"]="no",
  ["description"]="ETHIOPIC DIGIT FIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x136D, -- ፭
 },
 [0x136E]={
  ["category"]="no",
  ["description"]="ETHIOPIC DIGIT SIX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x136E, -- ፮
 },
 [0x136F]={
  ["category"]="no",
  ["description"]="ETHIOPIC DIGIT SEVEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x136F, -- ፯
 },
 [0x1370]={
  ["category"]="no",
  ["description"]="ETHIOPIC DIGIT EIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1370, -- ፰
 },
 [0x1371]={
  ["category"]="no",
  ["description"]="ETHIOPIC DIGIT NINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1371, -- ፱
 },
 [0x1372]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1372, -- ፲
 },
 [0x1373]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER TWENTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1373, -- ፳
 },
 [0x1374]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER THIRTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1374, -- ፴
 },
 [0x1375]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER FORTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1375, -- ፵
 },
 [0x1376]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER FIFTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1376, -- ፶
 },
 [0x1377]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER SIXTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1377, -- ፷
 },
 [0x1378]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER SEVENTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1378, -- ፸
 },
 [0x1379]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER EIGHTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1379, -- ፹
 },
 [0x137A]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER NINETY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x137A, -- ፺
 },
 [0x137B]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x137B, -- ፻
 },
 [0x137C]={
  ["category"]="no",
  ["description"]="ETHIOPIC NUMBER TEN THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x137C, -- ፼
 },
 [0x1380]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SEBATBEIT MWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1380, -- ᎀ
 },
 [0x1381]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1381, -- ᎁ
 },
 [0x1382]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1382, -- ᎂ
 },
 [0x1383]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1383, -- ᎃ
 },
 [0x1384]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SEBATBEIT BWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1384, -- ᎄ
 },
 [0x1385]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1385, -- ᎅ
 },
 [0x1386]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1386, -- ᎆ
 },
 [0x1387]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1387, -- ᎇ
 },
 [0x1388]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SEBATBEIT FWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1388, -- ᎈ
 },
 [0x1389]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1389, -- ᎉ
 },
 [0x138A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x138A, -- ᎊ
 },
 [0x138B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE FWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x138B, -- ᎋ
 },
 [0x138C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SEBATBEIT PWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x138C, -- ᎌ
 },
 [0x138D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x138D, -- ᎍ
 },
 [0x138E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x138E, -- ᎎ
 },
 [0x138F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x138F, -- ᎏ
 },
 [0x1390]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK YIZET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1390, -- ᎐
 },
 [0x1391]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK DERET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1391, -- ᎑
 },
 [0x1392]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK RIKRIK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1392, -- ᎒
 },
 [0x1393]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK SHORT RIKRIK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1393, -- ᎓
 },
 [0x1394]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK DIFAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1394, -- ᎔
 },
 [0x1395]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK KENAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1395, -- ᎕
 },
 [0x1396]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK CHIRET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1396, -- ᎖
 },
 [0x1397]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK HIDET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1397, -- ᎗
 },
 [0x1398]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK DERET-HIDET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1398, -- ᎘
 },
 [0x1399]={
  ["category"]="so",
  ["description"]="ETHIOPIC TONAL MARK KURT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1399, -- ᎙
 },
 [0x13A0]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A0, -- Ꭰ
 },
 [0x13A1]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A1, -- Ꭱ
 },
 [0x13A2]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A2, -- Ꭲ
 },
 [0x13A3]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A3, -- Ꭳ
 },
 [0x13A4]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A4, -- Ꭴ
 },
 [0x13A5]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER V",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A5, -- Ꭵ
 },
 [0x13A6]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A6, -- Ꭶ
 },
 [0x13A7]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A7, -- Ꭷ
 },
 [0x13A8]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER GE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A8, -- Ꭸ
 },
 [0x13A9]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER GI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13A9, -- Ꭹ
 },
 [0x13AA]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER GO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13AA, -- Ꭺ
 },
 [0x13AB]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER GU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13AB, -- Ꭻ
 },
 [0x13AC]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER GV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13AC, -- Ꭼ
 },
 [0x13AD]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13AD, -- Ꭽ
 },
 [0x13AE]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13AE, -- Ꭾ
 },
 [0x13AF]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER HI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13AF, -- Ꭿ
 },
 [0x13B0]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER HO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B0, -- Ꮀ
 },
 [0x13B1]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER HU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B1, -- Ꮁ
 },
 [0x13B2]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER HV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B2, -- Ꮂ
 },
 [0x13B3]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B3, -- Ꮃ
 },
 [0x13B4]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER LE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B4, -- Ꮄ
 },
 [0x13B5]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER LI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B5, -- Ꮅ
 },
 [0x13B6]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER LO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B6, -- Ꮆ
 },
 [0x13B7]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B7, -- Ꮇ
 },
 [0x13B8]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER LV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B8, -- Ꮈ
 },
 [0x13B9]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13B9, -- Ꮉ
 },
 [0x13BA]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13BA, -- Ꮊ
 },
 [0x13BB]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13BB, -- Ꮋ
 },
 [0x13BC]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER MO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13BC, -- Ꮌ
 },
 [0x13BD]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER MU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13BD, -- Ꮍ
 },
 [0x13BE]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13BE, -- Ꮎ
 },
 [0x13BF]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER HNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13BF, -- Ꮏ
 },
 [0x13C0]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER NAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C0, -- Ꮐ
 },
 [0x13C1]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C1, -- Ꮑ
 },
 [0x13C2]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER NI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C2, -- Ꮒ
 },
 [0x13C3]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER NO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C3, -- Ꮓ
 },
 [0x13C4]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER NU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C4, -- Ꮔ
 },
 [0x13C5]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER NV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C5, -- Ꮕ
 },
 [0x13C6]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER QUA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C6, -- Ꮖ
 },
 [0x13C7]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER QUE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C7, -- Ꮗ
 },
 [0x13C8]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER QUI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C8, -- Ꮘ
 },
 [0x13C9]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER QUO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13C9, -- Ꮙ
 },
 [0x13CA]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER QUU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13CA, -- Ꮚ
 },
 [0x13CB]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER QUV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13CB, -- Ꮛ
 },
 [0x13CC]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13CC, -- Ꮜ
 },
 [0x13CD]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13CD, -- Ꮝ
 },
 [0x13CE]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER SE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13CE, -- Ꮞ
 },
 [0x13CF]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER SI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13CF, -- Ꮟ
 },
 [0x13D0]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER SO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D0, -- Ꮠ
 },
 [0x13D1]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER SU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D1, -- Ꮡ
 },
 [0x13D2]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER SV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D2, -- Ꮢ
 },
 [0x13D3]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D3, -- Ꮣ
 },
 [0x13D4]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D4, -- Ꮤ
 },
 [0x13D5]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER DE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D5, -- Ꮥ
 },
 [0x13D6]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D6, -- Ꮦ
 },
 [0x13D7]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D7, -- Ꮧ
 },
 [0x13D8]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D8, -- Ꮨ
 },
 [0x13D9]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER DO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13D9, -- Ꮩ
 },
 [0x13DA]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER DU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13DA, -- Ꮪ
 },
 [0x13DB]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER DV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13DB, -- Ꮫ
 },
 [0x13DC]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER DLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13DC, -- Ꮬ
 },
 [0x13DD]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13DD, -- Ꮭ
 },
 [0x13DE]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13DE, -- Ꮮ
 },
 [0x13DF]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13DF, -- Ꮯ
 },
 [0x13E0]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TLO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E0, -- Ꮰ
 },
 [0x13E1]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TLU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E1, -- Ꮱ
 },
 [0x13E2]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TLV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E2, -- Ꮲ
 },
 [0x13E3]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E3, -- Ꮳ
 },
 [0x13E4]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TSE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E4, -- Ꮴ
 },
 [0x13E5]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TSI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E5, -- Ꮵ
 },
 [0x13E6]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TSO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E6, -- Ꮶ
 },
 [0x13E7]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TSU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E7, -- Ꮷ
 },
 [0x13E8]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER TSV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E8, -- Ꮸ
 },
 [0x13E9]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13E9, -- Ꮹ
 },
 [0x13EA]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER WE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13EA, -- Ꮺ
 },
 [0x13EB]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER WI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13EB, -- Ꮻ
 },
 [0x13EC]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER WO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13EC, -- Ꮼ
 },
 [0x13ED]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER WU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13ED, -- Ꮽ
 },
 [0x13EE]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER WV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13EE, -- Ꮾ
 },
 [0x13EF]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13EF, -- Ꮿ
 },
 [0x13F0]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER YE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13F0, -- Ᏸ
 },
 [0x13F1]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER YI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13F1, -- Ᏹ
 },
 [0x13F2]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER YO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13F2, -- Ᏺ
 },
 [0x13F3]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER YU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13F3, -- Ᏻ
 },
 [0x13F4]={
  ["category"]="lo",
  ["description"]="CHEROKEE LETTER YV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x13F4, -- Ᏼ
 },
 [0x1401]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1401, -- ᐁ
 },
 [0x1402]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS AAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1402, -- ᐂ
 },
 [0x1403]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1403, -- ᐃ
 },
 [0x1404]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1404, -- ᐄ
 },
 [0x1405]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1405, -- ᐅ
 },
 [0x1406]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS OO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1406, -- ᐆ
 },
 [0x1407]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE OO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1407, -- ᐇ
 },
 [0x1408]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1408, -- ᐈ
 },
 [0x1409]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1409, -- ᐉ
 },
 [0x140A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x140A, -- ᐊ
 },
 [0x140B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x140B, -- ᐋ
 },
 [0x140C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x140C, -- ᐌ
 },
 [0x140D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE WE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x140D, -- ᐍ
 },
 [0x140E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x140E, -- ᐎ
 },
 [0x140F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE WI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x140F, -- ᐏ
 },
 [0x1410]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1410, -- ᐐ
 },
 [0x1411]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE WII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1411, -- ᐑ
 },
 [0x1412]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1412, -- ᐒ
 },
 [0x1413]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE WO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1413, -- ᐓ
 },
 [0x1414]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1414, -- ᐔ
 },
 [0x1415]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE WOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1415, -- ᐕ
 },
 [0x1416]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI WOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1416, -- ᐖ
 },
 [0x1417]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1417, -- ᐗ
 },
 [0x1418]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1418, -- ᐘ
 },
 [0x1419]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1419, -- ᐙ
 },
 [0x141A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE WAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x141A, -- ᐚ
 },
 [0x141B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI WAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x141B, -- ᐛ
 },
 [0x141C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS AI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x141C, -- ᐜ
 },
 [0x141D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE W",
  ["linebreak"]="al",
  ["unicodeslot"]=0x141D, -- ᐝ
 },
 [0x141E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS GLOTTAL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x141E, -- ᐞ
 },
 [0x141F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL ACUTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x141F, -- ᐟ
 },
 [0x1420]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL GRAVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1420, -- ᐠ
 },
 [0x1421]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL BOTTOM HALF RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1421, -- ᐡ
 },
 [0x1422]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL TOP HALF RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1422, -- ᐢ
 },
 [0x1423]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL RIGHT HALF RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1423, -- ᐣ
 },
 [0x1424]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1424, -- ᐤ
 },
 [0x1425]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL DOUBLE ACUTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1425, -- ᐥ
 },
 [0x1426]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL DOUBLE SHORT VERTICAL STROKES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1426, -- ᐦ
 },
 [0x1427]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL MIDDLE DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1427, -- ᐧ
 },
 [0x1428]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL SHORT HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1428, -- ᐨ
 },
 [0x1429]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL PLUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1429, -- ᐩ
 },
 [0x142A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FINAL DOWN TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x142A, -- ᐪ
 },
 [0x142B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x142B, -- ᐫ
 },
 [0x142C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS IN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x142C, -- ᐬ
 },
 [0x142D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS ON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x142D, -- ᐭ
 },
 [0x142E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x142E, -- ᐮ
 },
 [0x142F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x142F, -- ᐯ
 },
 [0x1430]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1430, -- ᐰ
 },
 [0x1431]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1431, -- ᐱ
 },
 [0x1432]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1432, -- ᐲ
 },
 [0x1433]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1433, -- ᐳ
 },
 [0x1434]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS POO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1434, -- ᐴ
 },
 [0x1435]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE POO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1435, -- ᐵ
 },
 [0x1436]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER HEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1436, -- ᐶ
 },
 [0x1437]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER HI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1437, -- ᐷ
 },
 [0x1438]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1438, -- ᐸ
 },
 [0x1439]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1439, -- ᐹ
 },
 [0x143A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x143A, -- ᐺ
 },
 [0x143B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE PWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x143B, -- ᐻ
 },
 [0x143C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x143C, -- ᐼ
 },
 [0x143D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE PWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x143D, -- ᐽ
 },
 [0x143E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x143E, -- ᐾ
 },
 [0x143F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE PWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x143F, -- ᐿ
 },
 [0x1440]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1440, -- ᑀ
 },
 [0x1441]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE PWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1441, -- ᑁ
 },
 [0x1442]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1442, -- ᑂ
 },
 [0x1443]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE PWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1443, -- ᑃ
 },
 [0x1444]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1444, -- ᑄ
 },
 [0x1445]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE PWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1445, -- ᑅ
 },
 [0x1446]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS PWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1446, -- ᑆ
 },
 [0x1447]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE PWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1447, -- ᑇ
 },
 [0x1448]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE PWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1448, -- ᑈ
 },
 [0x1449]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS P",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1449, -- ᑉ
 },
 [0x144A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE P",
  ["linebreak"]="al",
  ["unicodeslot"]=0x144A, -- ᑊ
 },
 [0x144B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER H",
  ["linebreak"]="al",
  ["unicodeslot"]=0x144B, -- ᑋ
 },
 [0x144C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x144C, -- ᑌ
 },
 [0x144D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x144D, -- ᑍ
 },
 [0x144E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x144E, -- ᑎ
 },
 [0x144F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x144F, -- ᑏ
 },
 [0x1450]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1450, -- ᑐ
 },
 [0x1451]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1451, -- ᑑ
 },
 [0x1452]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE TOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1452, -- ᑒ
 },
 [0x1453]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1453, -- ᑓ
 },
 [0x1454]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1454, -- ᑔ
 },
 [0x1455]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1455, -- ᑕ
 },
 [0x1456]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1456, -- ᑖ
 },
 [0x1457]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1457, -- ᑗ
 },
 [0x1458]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE TWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1458, -- ᑘ
 },
 [0x1459]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1459, -- ᑙ
 },
 [0x145A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE TWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x145A, -- ᑚ
 },
 [0x145B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x145B, -- ᑛ
 },
 [0x145C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE TWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x145C, -- ᑜ
 },
 [0x145D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x145D, -- ᑝ
 },
 [0x145E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x145E, -- ᑞ
 },
 [0x145F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x145F, -- ᑟ
 },
 [0x1460]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE TWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1460, -- ᑠ
 },
 [0x1461]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1461, -- ᑡ
 },
 [0x1462]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE TWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1462, -- ᑢ
 },
 [0x1463]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1463, -- ᑣ
 },
 [0x1464]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE TWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1464, -- ᑤ
 },
 [0x1465]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI TWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1465, -- ᑥ
 },
 [0x1466]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS T",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1466, -- ᑦ
 },
 [0x1467]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1467, -- ᑧ
 },
 [0x1468]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TTI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1468, -- ᑨ
 },
 [0x1469]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TTO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1469, -- ᑩ
 },
 [0x146A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x146A, -- ᑪ
 },
 [0x146B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x146B, -- ᑫ
 },
 [0x146C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x146C, -- ᑬ
 },
 [0x146D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x146D, -- ᑭ
 },
 [0x146E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x146E, -- ᑮ
 },
 [0x146F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x146F, -- ᑯ
 },
 [0x1470]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1470, -- ᑰ
 },
 [0x1471]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE KOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1471, -- ᑱ
 },
 [0x1472]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1472, -- ᑲ
 },
 [0x1473]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1473, -- ᑳ
 },
 [0x1474]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1474, -- ᑴ
 },
 [0x1475]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE KWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1475, -- ᑵ
 },
 [0x1476]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1476, -- ᑶ
 },
 [0x1477]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE KWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1477, -- ᑷ
 },
 [0x1478]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1478, -- ᑸ
 },
 [0x1479]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE KWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1479, -- ᑹ
 },
 [0x147A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x147A, -- ᑺ
 },
 [0x147B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE KWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x147B, -- ᑻ
 },
 [0x147C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x147C, -- ᑼ
 },
 [0x147D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE KWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x147D, -- ᑽ
 },
 [0x147E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x147E, -- ᑾ
 },
 [0x147F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE KWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x147F, -- ᑿ
 },
 [0x1480]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1480, -- ᒀ
 },
 [0x1481]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE KWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1481, -- ᒁ
 },
 [0x1482]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI KWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1482, -- ᒂ
 },
 [0x1483]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS K",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1483, -- ᒃ
 },
 [0x1484]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS KW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1484, -- ᒄ
 },
 [0x1485]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SOUTH-SLAVEY KEH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1485, -- ᒅ
 },
 [0x1486]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SOUTH-SLAVEY KIH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1486, -- ᒆ
 },
 [0x1487]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SOUTH-SLAVEY KOH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1487, -- ᒇ
 },
 [0x1488]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SOUTH-SLAVEY KAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1488, -- ᒈ
 },
 [0x1489]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1489, -- ᒉ
 },
 [0x148A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x148A, -- ᒊ
 },
 [0x148B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x148B, -- ᒋ
 },
 [0x148C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x148C, -- ᒌ
 },
 [0x148D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x148D, -- ᒍ
 },
 [0x148E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS COO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x148E, -- ᒎ
 },
 [0x148F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE COO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x148F, -- ᒏ
 },
 [0x1490]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1490, -- ᒐ
 },
 [0x1491]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1491, -- ᒑ
 },
 [0x1492]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1492, -- ᒒ
 },
 [0x1493]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE CWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1493, -- ᒓ
 },
 [0x1494]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1494, -- ᒔ
 },
 [0x1495]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE CWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1495, -- ᒕ
 },
 [0x1496]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1496, -- ᒖ
 },
 [0x1497]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE CWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1497, -- ᒗ
 },
 [0x1498]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1498, -- ᒘ
 },
 [0x1499]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE CWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1499, -- ᒙ
 },
 [0x149A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x149A, -- ᒚ
 },
 [0x149B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE CWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x149B, -- ᒛ
 },
 [0x149C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x149C, -- ᒜ
 },
 [0x149D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE CWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x149D, -- ᒝ
 },
 [0x149E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x149E, -- ᒞ
 },
 [0x149F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE CWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x149F, -- ᒟ
 },
 [0x14A0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI CWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A0, -- ᒠ
 },
 [0x14A1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A1, -- ᒡ
 },
 [0x14A2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI TH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A2, -- ᒢ
 },
 [0x14A3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A3, -- ᒣ
 },
 [0x14A4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A4, -- ᒤ
 },
 [0x14A5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A5, -- ᒥ
 },
 [0x14A6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A6, -- ᒦ
 },
 [0x14A7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A7, -- ᒧ
 },
 [0x14A8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A8, -- ᒨ
 },
 [0x14A9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE MOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14A9, -- ᒩ
 },
 [0x14AA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14AA, -- ᒪ
 },
 [0x14AB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14AB, -- ᒫ
 },
 [0x14AC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14AC, -- ᒬ
 },
 [0x14AD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE MWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14AD, -- ᒭ
 },
 [0x14AE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14AE, -- ᒮ
 },
 [0x14AF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE MWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14AF, -- ᒯ
 },
 [0x14B0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B0, -- ᒰ
 },
 [0x14B1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE MWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B1, -- ᒱ
 },
 [0x14B2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B2, -- ᒲ
 },
 [0x14B3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE MWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B3, -- ᒳ
 },
 [0x14B4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B4, -- ᒴ
 },
 [0x14B5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE MWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B5, -- ᒵ
 },
 [0x14B6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B6, -- ᒶ
 },
 [0x14B7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE MWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B7, -- ᒷ
 },
 [0x14B8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B8, -- ᒸ
 },
 [0x14B9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE MWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14B9, -- ᒹ
 },
 [0x14BA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI MWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14BA, -- ᒺ
 },
 [0x14BB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS M",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14BB, -- ᒻ
 },
 [0x14BC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE M",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14BC, -- ᒼ
 },
 [0x14BD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14BD, -- ᒽ
 },
 [0x14BE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS ATHAPASCAN M",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14BE, -- ᒾ
 },
 [0x14BF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI M",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14BF, -- ᒿ
 },
 [0x14C0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C0, -- ᓀ
 },
 [0x14C1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C1, -- ᓁ
 },
 [0x14C2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C2, -- ᓂ
 },
 [0x14C3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C3, -- ᓃ
 },
 [0x14C4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C4, -- ᓄ
 },
 [0x14C5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C5, -- ᓅ
 },
 [0x14C6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE NOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C6, -- ᓆ
 },
 [0x14C7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C7, -- ᓇ
 },
 [0x14C8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C8, -- ᓈ
 },
 [0x14C9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14C9, -- ᓉ
 },
 [0x14CA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE NWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14CA, -- ᓊ
 },
 [0x14CB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14CB, -- ᓋ
 },
 [0x14CC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE NWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14CC, -- ᓌ
 },
 [0x14CD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14CD, -- ᓍ
 },
 [0x14CE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE NWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14CE, -- ᓎ
 },
 [0x14CF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI NWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14CF, -- ᓏ
 },
 [0x14D0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS N",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D0, -- ᓐ
 },
 [0x14D1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER NG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D1, -- ᓑ
 },
 [0x14D2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D2, -- ᓒ
 },
 [0x14D3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D3, -- ᓓ
 },
 [0x14D4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D4, -- ᓔ
 },
 [0x14D5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D5, -- ᓕ
 },
 [0x14D6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D6, -- ᓖ
 },
 [0x14D7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D7, -- ᓗ
 },
 [0x14D8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D8, -- ᓘ
 },
 [0x14D9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE LOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14D9, -- ᓙ
 },
 [0x14DA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14DA, -- ᓚ
 },
 [0x14DB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14DB, -- ᓛ
 },
 [0x14DC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14DC, -- ᓜ
 },
 [0x14DD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14DD, -- ᓝ
 },
 [0x14DE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14DE, -- ᓞ
 },
 [0x14DF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14DF, -- ᓟ
 },
 [0x14E0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E0, -- ᓠ
 },
 [0x14E1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E1, -- ᓡ
 },
 [0x14E2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E2, -- ᓢ
 },
 [0x14E3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E3, -- ᓣ
 },
 [0x14E4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E4, -- ᓤ
 },
 [0x14E5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E5, -- ᓥ
 },
 [0x14E6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E6, -- ᓦ
 },
 [0x14E7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E7, -- ᓧ
 },
 [0x14E8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E8, -- ᓨ
 },
 [0x14E9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14E9, -- ᓩ
 },
 [0x14EA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14EA, -- ᓪ
 },
 [0x14EB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14EB, -- ᓫ
 },
 [0x14EC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MEDIAL L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14EC, -- ᓬ
 },
 [0x14ED]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14ED, -- ᓭ
 },
 [0x14EE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14EE, -- ᓮ
 },
 [0x14EF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14EF, -- ᓯ
 },
 [0x14F0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F0, -- ᓰ
 },
 [0x14F1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F1, -- ᓱ
 },
 [0x14F2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F2, -- ᓲ
 },
 [0x14F3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE SOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F3, -- ᓳ
 },
 [0x14F4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F4, -- ᓴ
 },
 [0x14F5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F5, -- ᓵ
 },
 [0x14F6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F6, -- ᓶ
 },
 [0x14F7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F7, -- ᓷ
 },
 [0x14F8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F8, -- ᓸ
 },
 [0x14F9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14F9, -- ᓹ
 },
 [0x14FA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14FA, -- ᓺ
 },
 [0x14FB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14FB, -- ᓻ
 },
 [0x14FC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14FC, -- ᓼ
 },
 [0x14FD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14FD, -- ᓽ
 },
 [0x14FE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14FE, -- ᓾ
 },
 [0x14FF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x14FF, -- ᓿ
 },
 [0x1500]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1500, -- ᔀ
 },
 [0x1501]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1501, -- ᔁ
 },
 [0x1502]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1502, -- ᔂ
 },
 [0x1503]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1503, -- ᔃ
 },
 [0x1504]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI SWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1504, -- ᔄ
 },
 [0x1505]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1505, -- ᔅ
 },
 [0x1506]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS ATHAPASCAN S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1506, -- ᔆ
 },
 [0x1507]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1507, -- ᔇ
 },
 [0x1508]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1508, -- ᔈ
 },
 [0x1509]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MOOSE-CREE SK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1509, -- ᔉ
 },
 [0x150A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI SKW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x150A, -- ᔊ
 },
 [0x150B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI S-W",
  ["linebreak"]="al",
  ["unicodeslot"]=0x150B, -- ᔋ
 },
 [0x150C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI SPWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x150C, -- ᔌ
 },
 [0x150D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI STWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x150D, -- ᔍ
 },
 [0x150E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI SKWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x150E, -- ᔎ
 },
 [0x150F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI SCWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x150F, -- ᔏ
 },
 [0x1510]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1510, -- ᔐ
 },
 [0x1511]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1511, -- ᔑ
 },
 [0x1512]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1512, -- ᔒ
 },
 [0x1513]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1513, -- ᔓ
 },
 [0x1514]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1514, -- ᔔ
 },
 [0x1515]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1515, -- ᔕ
 },
 [0x1516]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1516, -- ᔖ
 },
 [0x1517]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1517, -- ᔗ
 },
 [0x1518]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SHWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1518, -- ᔘ
 },
 [0x1519]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1519, -- ᔙ
 },
 [0x151A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SHWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x151A, -- ᔚ
 },
 [0x151B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x151B, -- ᔛ
 },
 [0x151C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SHWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x151C, -- ᔜ
 },
 [0x151D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x151D, -- ᔝ
 },
 [0x151E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SHWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x151E, -- ᔞ
 },
 [0x151F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x151F, -- ᔟ
 },
 [0x1520]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SHWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1520, -- ᔠ
 },
 [0x1521]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1521, -- ᔡ
 },
 [0x1522]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SHWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1522, -- ᔢ
 },
 [0x1523]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SHWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1523, -- ᔣ
 },
 [0x1524]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE SHWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1524, -- ᔤ
 },
 [0x1525]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1525, -- ᔥ
 },
 [0x1526]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1526, -- ᔦ
 },
 [0x1527]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1527, -- ᔧ
 },
 [0x1528]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1528, -- ᔨ
 },
 [0x1529]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1529, -- ᔩ
 },
 [0x152A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x152A, -- ᔪ
 },
 [0x152B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x152B, -- ᔫ
 },
 [0x152C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y-CREE YOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x152C, -- ᔬ
 },
 [0x152D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x152D, -- ᔭ
 },
 [0x152E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x152E, -- ᔮ
 },
 [0x152F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x152F, -- ᔯ
 },
 [0x1530]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE YWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1530, -- ᔰ
 },
 [0x1531]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1531, -- ᔱ
 },
 [0x1532]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE YWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1532, -- ᔲ
 },
 [0x1533]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1533, -- ᔳ
 },
 [0x1534]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE YWII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1534, -- ᔴ
 },
 [0x1535]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1535, -- ᔵ
 },
 [0x1536]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE YWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1536, -- ᔶ
 },
 [0x1537]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1537, -- ᔷ
 },
 [0x1538]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE YWOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1538, -- ᔸ
 },
 [0x1539]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1539, -- ᔹ
 },
 [0x153A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE YWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x153A, -- ᔺ
 },
 [0x153B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS YWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x153B, -- ᔻ
 },
 [0x153C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE YWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x153C, -- ᔼ
 },
 [0x153D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NASKAPI YWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x153D, -- ᔽ
 },
 [0x153E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Y",
  ["linebreak"]="al",
  ["unicodeslot"]=0x153E, -- ᔾ
 },
 [0x153F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BIBLE-CREE Y",
  ["linebreak"]="al",
  ["unicodeslot"]=0x153F, -- ᔿ
 },
 [0x1540]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE Y",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1540, -- ᕀ
 },
 [0x1541]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI YI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1541, -- ᕁ
 },
 [0x1542]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS RE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1542, -- ᕂ
 },
 [0x1543]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS R-CREE RE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1543, -- ᕃ
 },
 [0x1544]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1544, -- ᕄ
 },
 [0x1545]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS RAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1545, -- ᕅ
 },
 [0x1546]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS RI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1546, -- ᕆ
 },
 [0x1547]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS RII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1547, -- ᕇ
 },
 [0x1548]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1548, -- ᕈ
 },
 [0x1549]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS ROO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1549, -- ᕉ
 },
 [0x154A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x154A, -- ᕊ
 },
 [0x154B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x154B, -- ᕋ
 },
 [0x154C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS RAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x154C, -- ᕌ
 },
 [0x154D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x154D, -- ᕍ
 },
 [0x154E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS RWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x154E, -- ᕎ
 },
 [0x154F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE RWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x154F, -- ᕏ
 },
 [0x1550]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1550, -- ᕐ
 },
 [0x1551]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1551, -- ᕑ
 },
 [0x1552]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS MEDIAL R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1552, -- ᕒ
 },
 [0x1553]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1553, -- ᕓ
 },
 [0x1554]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1554, -- ᕔ
 },
 [0x1555]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1555, -- ᕕ
 },
 [0x1556]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1556, -- ᕖ
 },
 [0x1557]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1557, -- ᕗ
 },
 [0x1558]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1558, -- ᕘ
 },
 [0x1559]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1559, -- ᕙ
 },
 [0x155A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x155A, -- ᕚ
 },
 [0x155B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS FWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x155B, -- ᕛ
 },
 [0x155C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE FWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x155C, -- ᕜ
 },
 [0x155D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x155D, -- ᕝ
 },
 [0x155E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS THE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x155E, -- ᕞ
 },
 [0x155F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS N-CREE THE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x155F, -- ᕟ
 },
 [0x1560]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS THI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1560, -- ᕠ
 },
 [0x1561]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS N-CREE THI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1561, -- ᕡ
 },
 [0x1562]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS THII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1562, -- ᕢ
 },
 [0x1563]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS N-CREE THII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1563, -- ᕣ
 },
 [0x1564]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS THO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1564, -- ᕤ
 },
 [0x1565]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS THOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1565, -- ᕥ
 },
 [0x1566]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1566, -- ᕦ
 },
 [0x1567]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS THAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1567, -- ᕧ
 },
 [0x1568]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS THWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1568, -- ᕨ
 },
 [0x1569]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE THWAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1569, -- ᕩ
 },
 [0x156A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x156A, -- ᕪ
 },
 [0x156B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TTHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x156B, -- ᕫ
 },
 [0x156C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TTHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x156C, -- ᕬ
 },
 [0x156D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TTHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x156D, -- ᕭ
 },
 [0x156E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x156E, -- ᕮ
 },
 [0x156F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x156F, -- ᕯ
 },
 [0x1570]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TYE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1570, -- ᕰ
 },
 [0x1571]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TYI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1571, -- ᕱ
 },
 [0x1572]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TYO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1572, -- ᕲ
 },
 [0x1573]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1573, -- ᕳ
 },
 [0x1574]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NUNAVIK HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1574, -- ᕴ
 },
 [0x1575]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NUNAVIK HI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1575, -- ᕵ
 },
 [0x1576]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NUNAVIK HII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1576, -- ᕶ
 },
 [0x1577]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NUNAVIK HO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1577, -- ᕷ
 },
 [0x1578]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NUNAVIK HOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1578, -- ᕸ
 },
 [0x1579]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NUNAVIK HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1579, -- ᕹ
 },
 [0x157A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NUNAVIK HAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x157A, -- ᕺ
 },
 [0x157B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NUNAVIK H",
  ["linebreak"]="al",
  ["unicodeslot"]=0x157B, -- ᕻ
 },
 [0x157C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NUNAVUT H",
  ["linebreak"]="al",
  ["unicodeslot"]=0x157C, -- ᕼ
 },
 [0x157D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS HK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x157D, -- ᕽ
 },
 [0x157E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS QAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x157E, -- ᕾ
 },
 [0x157F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS QI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x157F, -- ᕿ
 },
 [0x1580]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS QII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1580, -- ᖀ
 },
 [0x1581]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS QO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1581, -- ᖁ
 },
 [0x1582]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS QOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1582, -- ᖂ
 },
 [0x1583]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS QA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1583, -- ᖃ
 },
 [0x1584]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS QAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1584, -- ᖄ
 },
 [0x1585]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS Q",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1585, -- ᖅ
 },
 [0x1586]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TLHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1586, -- ᖆ
 },
 [0x1587]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TLHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1587, -- ᖇ
 },
 [0x1588]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TLHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1588, -- ᖈ
 },
 [0x1589]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TLHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1589, -- ᖉ
 },
 [0x158A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE RE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x158A, -- ᖊ
 },
 [0x158B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE RI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x158B, -- ᖋ
 },
 [0x158C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x158C, -- ᖌ
 },
 [0x158D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WEST-CREE RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x158D, -- ᖍ
 },
 [0x158E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NGAAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x158E, -- ᖎ
 },
 [0x158F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x158F, -- ᖏ
 },
 [0x1590]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NGII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1590, -- ᖐ
 },
 [0x1591]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NGO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1591, -- ᖑ
 },
 [0x1592]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NGOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1592, -- ᖒ
 },
 [0x1593]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1593, -- ᖓ
 },
 [0x1594]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NGAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1594, -- ᖔ
 },
 [0x1595]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1595, -- ᖕ
 },
 [0x1596]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NNG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1596, -- ᖖ
 },
 [0x1597]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1597, -- ᖗ
 },
 [0x1598]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI SHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1598, -- ᖘ
 },
 [0x1599]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI SHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1599, -- ᖙ
 },
 [0x159A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x159A, -- ᖚ
 },
 [0x159B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WOODS-CREE THE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x159B, -- ᖛ
 },
 [0x159C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WOODS-CREE THI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x159C, -- ᖜ
 },
 [0x159D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WOODS-CREE THO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x159D, -- ᖝ
 },
 [0x159E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WOODS-CREE THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x159E, -- ᖞ
 },
 [0x159F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS WOODS-CREE TH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x159F, -- ᖟ
 },
 [0x15A0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A0, -- ᖠ
 },
 [0x15A1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LHII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A1, -- ᖡ
 },
 [0x15A2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A2, -- ᖢ
 },
 [0x15A3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LHOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A3, -- ᖣ
 },
 [0x15A4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A4, -- ᖤ
 },
 [0x15A5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A5, -- ᖥ
 },
 [0x15A6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS LH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A6, -- ᖦ
 },
 [0x15A7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TH-CREE THE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A7, -- ᖧ
 },
 [0x15A8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TH-CREE THI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A8, -- ᖨ
 },
 [0x15A9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TH-CREE THII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15A9, -- ᖩ
 },
 [0x15AA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TH-CREE THO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15AA, -- ᖪ
 },
 [0x15AB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TH-CREE THOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15AB, -- ᖫ
 },
 [0x15AC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TH-CREE THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15AC, -- ᖬ
 },
 [0x15AD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TH-CREE THAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15AD, -- ᖭ
 },
 [0x15AE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS TH-CREE TH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15AE, -- ᖮ
 },
 [0x15AF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS AIVILIK B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15AF, -- ᖯ
 },
 [0x15B0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B0, -- ᖰ
 },
 [0x15B1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B1, -- ᖱ
 },
 [0x15B2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B2, -- ᖲ
 },
 [0x15B3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B3, -- ᖳ
 },
 [0x15B4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT WE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B4, -- ᖴ
 },
 [0x15B5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT WI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B5, -- ᖵ
 },
 [0x15B6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT WO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B6, -- ᖶ
 },
 [0x15B7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B7, -- ᖷ
 },
 [0x15B8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B8, -- ᖸ
 },
 [0x15B9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT NI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15B9, -- ᖹ
 },
 [0x15BA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT NO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15BA, -- ᖺ
 },
 [0x15BB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15BB, -- ᖻ
 },
 [0x15BC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT KE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15BC, -- ᖼ
 },
 [0x15BD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15BD, -- ᖽ
 },
 [0x15BE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT KO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15BE, -- ᖾ
 },
 [0x15BF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS BLACKFOOT KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15BF, -- ᖿ
 },
 [0x15C0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C0, -- ᗀ
 },
 [0x15C1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI HI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C1, -- ᗁ
 },
 [0x15C2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI HO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C2, -- ᗂ
 },
 [0x15C3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C3, -- ᗃ
 },
 [0x15C4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C4, -- ᗄ
 },
 [0x15C5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C5, -- ᗅ
 },
 [0x15C6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C6, -- ᗆ
 },
 [0x15C7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C7, -- ᗇ
 },
 [0x15C8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C8, -- ᗈ
 },
 [0x15C9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15C9, -- ᗉ
 },
 [0x15CA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15CA, -- ᗊ
 },
 [0x15CB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15CB, -- ᗋ
 },
 [0x15CC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER RE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15CC, -- ᗌ
 },
 [0x15CD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER REE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15CD, -- ᗍ
 },
 [0x15CE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER RI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15CE, -- ᗎ
 },
 [0x15CF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15CF, -- ᗏ
 },
 [0x15D0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER WU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D0, -- ᗐ
 },
 [0x15D1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER WO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D1, -- ᗑ
 },
 [0x15D2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER WE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D2, -- ᗒ
 },
 [0x15D3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER WEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D3, -- ᗓ
 },
 [0x15D4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER WI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D4, -- ᗔ
 },
 [0x15D5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D5, -- ᗕ
 },
 [0x15D6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER HWU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D6, -- ᗖ
 },
 [0x15D7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER HWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D7, -- ᗗ
 },
 [0x15D8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER HWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D8, -- ᗘ
 },
 [0x15D9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER HWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15D9, -- ᗙ
 },
 [0x15DA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER HWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15DA, -- ᗚ
 },
 [0x15DB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER HWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15DB, -- ᗛ
 },
 [0x15DC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER THU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15DC, -- ᗜ
 },
 [0x15DD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER THO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15DD, -- ᗝ
 },
 [0x15DE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER THE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15DE, -- ᗞ
 },
 [0x15DF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER THEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15DF, -- ᗟ
 },
 [0x15E0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER THI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E0, -- ᗠ
 },
 [0x15E1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E1, -- ᗡ
 },
 [0x15E2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E2, -- ᗢ
 },
 [0x15E3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E3, -- ᗣ
 },
 [0x15E4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E4, -- ᗤ
 },
 [0x15E5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E5, -- ᗥ
 },
 [0x15E6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E6, -- ᗦ
 },
 [0x15E7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E7, -- ᗧ
 },
 [0x15E8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER PU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E8, -- ᗨ
 },
 [0x15E9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER PO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15E9, -- ᗩ
 },
 [0x15EA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15EA, -- ᗪ
 },
 [0x15EB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER PEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15EB, -- ᗫ
 },
 [0x15EC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER PI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15EC, -- ᗬ
 },
 [0x15ED]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15ED, -- ᗭ
 },
 [0x15EE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER P",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15EE, -- ᗮ
 },
 [0x15EF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15EF, -- ᗯ
 },
 [0x15F0]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F0, -- ᗰ
 },
 [0x15F1]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F1, -- ᗱ
 },
 [0x15F2]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F2, -- ᗲ
 },
 [0x15F3]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F3, -- ᗳ
 },
 [0x15F4]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F4, -- ᗴ
 },
 [0x15F5]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F5, -- ᗵ
 },
 [0x15F6]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F6, -- ᗶ
 },
 [0x15F7]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F7, -- ᗷ
 },
 [0x15F8]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F8, -- ᗸ
 },
 [0x15F9]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15F9, -- ᗹ
 },
 [0x15FA]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15FA, -- ᗺ
 },
 [0x15FB]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KKU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15FB, -- ᗻ
 },
 [0x15FC]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KKO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15FC, -- ᗼ
 },
 [0x15FD]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15FD, -- ᗽ
 },
 [0x15FE]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KKEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15FE, -- ᗾ
 },
 [0x15FF]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KKI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x15FF, -- ᗿ
 },
 [0x1600]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KKA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1600, -- ᘀ
 },
 [0x1601]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER KK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1601, -- ᘁ
 },
 [0x1602]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER NU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1602, -- ᘂ
 },
 [0x1603]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER NO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1603, -- ᘃ
 },
 [0x1604]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1604, -- ᘄ
 },
 [0x1605]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER NEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1605, -- ᘅ
 },
 [0x1606]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER NI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1606, -- ᘆ
 },
 [0x1607]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1607, -- ᘇ
 },
 [0x1608]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER MU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1608, -- ᘈ
 },
 [0x1609]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER MO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1609, -- ᘉ
 },
 [0x160A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x160A, -- ᘊ
 },
 [0x160B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER MEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x160B, -- ᘋ
 },
 [0x160C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x160C, -- ᘌ
 },
 [0x160D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x160D, -- ᘍ
 },
 [0x160E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER YU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x160E, -- ᘎ
 },
 [0x160F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER YO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x160F, -- ᘏ
 },
 [0x1610]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER YE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1610, -- ᘐ
 },
 [0x1611]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER YEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1611, -- ᘑ
 },
 [0x1612]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER YI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1612, -- ᘒ
 },
 [0x1613]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1613, -- ᘓ
 },
 [0x1614]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1614, -- ᘔ
 },
 [0x1615]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI JU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1615, -- ᘕ
 },
 [0x1616]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1616, -- ᘖ
 },
 [0x1617]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1617, -- ᘗ
 },
 [0x1618]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1618, -- ᘘ
 },
 [0x1619]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1619, -- ᘙ
 },
 [0x161A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS SAYISI JI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x161A, -- ᘚ
 },
 [0x161B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x161B, -- ᘛ
 },
 [0x161C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JJU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x161C, -- ᘜ
 },
 [0x161D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JJO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x161D, -- ᘝ
 },
 [0x161E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JJE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x161E, -- ᘞ
 },
 [0x161F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JJEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x161F, -- ᘟ
 },
 [0x1620]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JJI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1620, -- ᘠ
 },
 [0x1621]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER JJA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1621, -- ᘡ
 },
 [0x1622]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1622, -- ᘢ
 },
 [0x1623]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1623, -- ᘣ
 },
 [0x1624]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1624, -- ᘤ
 },
 [0x1625]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1625, -- ᘥ
 },
 [0x1626]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1626, -- ᘦ
 },
 [0x1627]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1627, -- ᘧ
 },
 [0x1628]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DLU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1628, -- ᘨ
 },
 [0x1629]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DLO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1629, -- ᘩ
 },
 [0x162A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x162A, -- ᘪ
 },
 [0x162B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DLEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x162B, -- ᘫ
 },
 [0x162C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x162C, -- ᘬ
 },
 [0x162D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x162D, -- ᘭ
 },
 [0x162E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x162E, -- ᘮ
 },
 [0x162F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x162F, -- ᘯ
 },
 [0x1630]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1630, -- ᘰ
 },
 [0x1631]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1631, -- ᘱ
 },
 [0x1632]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1632, -- ᘲ
 },
 [0x1633]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER LHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1633, -- ᘳ
 },
 [0x1634]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1634, -- ᘴ
 },
 [0x1635]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1635, -- ᘵ
 },
 [0x1636]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1636, -- ᘶ
 },
 [0x1637]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1637, -- ᘷ
 },
 [0x1638]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1638, -- ᘸ
 },
 [0x1639]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1639, -- ᘹ
 },
 [0x163A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x163A, -- ᘺ
 },
 [0x163B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x163B, -- ᘻ
 },
 [0x163C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x163C, -- ᘼ
 },
 [0x163D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x163D, -- ᘽ
 },
 [0x163E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x163E, -- ᘾ
 },
 [0x163F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x163F, -- ᘿ
 },
 [0x1640]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER ZU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1640, -- ᙀ
 },
 [0x1641]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER ZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1641, -- ᙁ
 },
 [0x1642]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER ZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1642, -- ᙂ
 },
 [0x1643]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER ZEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1643, -- ᙃ
 },
 [0x1644]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER ZI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1644, -- ᙄ
 },
 [0x1645]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1645, -- ᙅ
 },
 [0x1646]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER Z",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1646, -- ᙆ
 },
 [0x1647]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER INITIAL Z",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1647, -- ᙇ
 },
 [0x1648]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DZU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1648, -- ᙈ
 },
 [0x1649]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1649, -- ᙉ
 },
 [0x164A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x164A, -- ᙊ
 },
 [0x164B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DZEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x164B, -- ᙋ
 },
 [0x164C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DZI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x164C, -- ᙌ
 },
 [0x164D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER DZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x164D, -- ᙍ
 },
 [0x164E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x164E, -- ᙎ
 },
 [0x164F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x164F, -- ᙏ
 },
 [0x1650]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1650, -- ᙐ
 },
 [0x1651]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1651, -- ᙑ
 },
 [0x1652]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1652, -- ᙒ
 },
 [0x1653]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1653, -- ᙓ
 },
 [0x1654]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1654, -- ᙔ
 },
 [0x1655]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1655, -- ᙕ
 },
 [0x1656]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1656, -- ᙖ
 },
 [0x1657]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1657, -- ᙗ
 },
 [0x1658]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1658, -- ᙘ
 },
 [0x1659]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1659, -- ᙙ
 },
 [0x165A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER SH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x165A, -- ᙚ
 },
 [0x165B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TSU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x165B, -- ᙛ
 },
 [0x165C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TSO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x165C, -- ᙜ
 },
 [0x165D]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TSE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x165D, -- ᙝ
 },
 [0x165E]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TSEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x165E, -- ᙞ
 },
 [0x165F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TSI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x165F, -- ᙟ
 },
 [0x1660]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1660, -- ᙠ
 },
 [0x1661]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER CHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1661, -- ᙡ
 },
 [0x1662]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER CHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1662, -- ᙢ
 },
 [0x1663]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER CHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1663, -- ᙣ
 },
 [0x1664]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER CHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1664, -- ᙤ
 },
 [0x1665]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER CHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1665, -- ᙥ
 },
 [0x1666]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1666, -- ᙦ
 },
 [0x1667]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTSU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1667, -- ᙧ
 },
 [0x1668]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTSO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1668, -- ᙨ
 },
 [0x1669]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTSE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1669, -- ᙩ
 },
 [0x166A]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTSEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x166A, -- ᙪ
 },
 [0x166B]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTSI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x166B, -- ᙫ
 },
 [0x166C]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS CARRIER TTSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x166C, -- ᙬ
 },
 [0x166D]={
  ["category"]="po",
  ["description"]="CANADIAN SYLLABICS CHI SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x166D, -- ᙭
 },
 [0x166E]={
  ["category"]="po",
  ["description"]="CANADIAN SYLLABICS FULL STOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x166E, -- ᙮
 },
 [0x166F]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS QAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x166F, -- ᙯ
 },
 [0x1670]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NGAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1670, -- ᙰ
 },
 [0x1671]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NNGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1671, -- ᙱ
 },
 [0x1672]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NNGII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1672, -- ᙲ
 },
 [0x1673]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NNGO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1673, -- ᙳ
 },
 [0x1674]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NNGOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1674, -- ᙴ
 },
 [0x1675]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NNGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1675, -- ᙵ
 },
 [0x1676]={
  ["category"]="lo",
  ["description"]="CANADIAN SYLLABICS NNGAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1676, -- ᙶ
 },
 [0x1680]={
  ["category"]="zs",
  ["description"]="OGHAM SPACE MARK",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1680, --  
 },
 [0x1681]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER BEITH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1681, -- ᚁ
 },
 [0x1682]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER LUIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1682, -- ᚂ
 },
 [0x1683]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER FEARN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1683, -- ᚃ
 },
 [0x1684]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER SAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1684, -- ᚄ
 },
 [0x1685]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER NION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1685, -- ᚅ
 },
 [0x1686]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER UATH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1686, -- ᚆ
 },
 [0x1687]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER DAIR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1687, -- ᚇ
 },
 [0x1688]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER TINNE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1688, -- ᚈ
 },
 [0x1689]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER COLL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1689, -- ᚉ
 },
 [0x168A]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER CEIRT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x168A, -- ᚊ
 },
 [0x168B]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER MUIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x168B, -- ᚋ
 },
 [0x168C]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER GORT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x168C, -- ᚌ
 },
 [0x168D]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER NGEADAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x168D, -- ᚍ
 },
 [0x168E]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER STRAIF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x168E, -- ᚎ
 },
 [0x168F]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER RUIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x168F, -- ᚏ
 },
 [0x1690]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER AILM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1690, -- ᚐ
 },
 [0x1691]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER ONN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1691, -- ᚑ
 },
 [0x1692]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER UR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1692, -- ᚒ
 },
 [0x1693]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER EADHADH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1693, -- ᚓ
 },
 [0x1694]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER IODHADH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1694, -- ᚔ
 },
 [0x1695]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER EABHADH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1695, -- ᚕ
 },
 [0x1696]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER OR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1696, -- ᚖ
 },
 [0x1697]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER UILLEANN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1697, -- ᚗ
 },
 [0x1698]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER IFIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1698, -- ᚘ
 },
 [0x1699]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER EAMHANCHOLL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1699, -- ᚙ
 },
 [0x169A]={
  ["category"]="lo",
  ["description"]="OGHAM LETTER PEITH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x169A, -- ᚚ
 },
 [0x169B]={
  ["category"]="ps",
  ["description"]="OGHAM FEATHER MARK",
  ["linebreak"]="op",
  ["unicodeslot"]=0x169B, -- ᚛
 },
 [0x169C]={
  ["category"]="pe",
  ["description"]="OGHAM REVERSED FEATHER MARK",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x169C, -- ᚜
 },
 [0x16A0]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER FEHU FEOH FE F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A0, -- ᚠ
 },
 [0x16A1]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER V",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A1, -- ᚡ
 },
 [0x16A2]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER URUZ UR U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A2, -- ᚢ
 },
 [0x16A3]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER YR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A3, -- ᚣ
 },
 [0x16A4]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER Y",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A4, -- ᚤ
 },
 [0x16A5]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER W",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A5, -- ᚥ
 },
 [0x16A6]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER THURISAZ THURS THORN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A6, -- ᚦ
 },
 [0x16A7]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER ETH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A7, -- ᚧ
 },
 [0x16A8]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER ANSUZ A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A8, -- ᚨ
 },
 [0x16A9]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER OS O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16A9, -- ᚩ
 },
 [0x16AA]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER AC A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16AA, -- ᚪ
 },
 [0x16AB]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER AESC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16AB, -- ᚫ
 },
 [0x16AC]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER LONG-BRANCH-OSS O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16AC, -- ᚬ
 },
 [0x16AD]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SHORT-TWIG-OSS O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16AD, -- ᚭ
 },
 [0x16AE]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16AE, -- ᚮ
 },
 [0x16AF]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER OE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16AF, -- ᚯ
 },
 [0x16B0]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER ON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B0, -- ᚰ
 },
 [0x16B1]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER RAIDO RAD REID R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B1, -- ᚱ
 },
 [0x16B2]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER KAUNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B2, -- ᚲ
 },
 [0x16B3]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER CEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B3, -- ᚳ
 },
 [0x16B4]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER KAUN K",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B4, -- ᚴ
 },
 [0x16B5]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER G",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B5, -- ᚵ
 },
 [0x16B6]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER ENG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B6, -- ᚶ
 },
 [0x16B7]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER GEBO GYFU G",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B7, -- ᚷ
 },
 [0x16B8]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B8, -- ᚸ
 },
 [0x16B9]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER WUNJO WYNN W",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16B9, -- ᚹ
 },
 [0x16BA]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER HAGLAZ H",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16BA, -- ᚺ
 },
 [0x16BB]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER HAEGL H",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16BB, -- ᚻ
 },
 [0x16BC]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER LONG-BRANCH-HAGALL H",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16BC, -- ᚼ
 },
 [0x16BD]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SHORT-TWIG-HAGALL H",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16BD, -- ᚽ
 },
 [0x16BE]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER NAUDIZ NYD NAUD N",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16BE, -- ᚾ
 },
 [0x16BF]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SHORT-TWIG-NAUD N",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16BF, -- ᚿ
 },
 [0x16C0]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER DOTTED-N",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C0, -- ᛀ
 },
 [0x16C1]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER ISAZ IS ISS I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C1, -- ᛁ
 },
 [0x16C2]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C2, -- ᛂ
 },
 [0x16C3]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER JERAN J",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C3, -- ᛃ
 },
 [0x16C4]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER GER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C4, -- ᛄ
 },
 [0x16C5]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER LONG-BRANCH-AR AE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C5, -- ᛅ
 },
 [0x16C6]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SHORT-TWIG-AR A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C6, -- ᛆ
 },
 [0x16C7]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER IWAZ EOH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C7, -- ᛇ
 },
 [0x16C8]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER PERTHO PEORTH P",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C8, -- ᛈ
 },
 [0x16C9]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER ALGIZ EOLHX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16C9, -- ᛉ
 },
 [0x16CA]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SOWILO S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16CA, -- ᛊ
 },
 [0x16CB]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SIGEL LONG-BRANCH-SOL S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16CB, -- ᛋ
 },
 [0x16CC]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SHORT-TWIG-SOL S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16CC, -- ᛌ
 },
 [0x16CD]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16CD, -- ᛍ
 },
 [0x16CE]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER Z",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16CE, -- ᛎ
 },
 [0x16CF]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER TIWAZ TIR TYR T",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16CF, -- ᛏ
 },
 [0x16D0]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SHORT-TWIG-TYR T",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D0, -- ᛐ
 },
 [0x16D1]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D1, -- ᛑ
 },
 [0x16D2]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER BERKANAN BEORC BJARKAN B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D2, -- ᛒ
 },
 [0x16D3]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SHORT-TWIG-BJARKAN B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D3, -- ᛓ
 },
 [0x16D4]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER DOTTED-P",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D4, -- ᛔ
 },
 [0x16D5]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER OPEN-P",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D5, -- ᛕ
 },
 [0x16D6]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER EHWAZ EH E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D6, -- ᛖ
 },
 [0x16D7]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER MANNAZ MAN M",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D7, -- ᛗ
 },
 [0x16D8]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER LONG-BRANCH-MADR M",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D8, -- ᛘ
 },
 [0x16D9]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SHORT-TWIG-MADR M",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16D9, -- ᛙ
 },
 [0x16DA]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER LAUKAZ LAGU LOGR L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16DA, -- ᛚ
 },
 [0x16DB]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER DOTTED-L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16DB, -- ᛛ
 },
 [0x16DC]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER INGWAZ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16DC, -- ᛜ
 },
 [0x16DD]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER ING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16DD, -- ᛝ
 },
 [0x16DE]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER DAGAZ DAEG D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16DE, -- ᛞ
 },
 [0x16DF]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER OTHALAN ETHEL O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16DF, -- ᛟ
 },
 [0x16E0]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER EAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E0, -- ᛠ
 },
 [0x16E1]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER IOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E1, -- ᛡ
 },
 [0x16E2]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER CWEORTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E2, -- ᛢ
 },
 [0x16E3]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER CALC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E3, -- ᛣ
 },
 [0x16E4]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER CEALC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E4, -- ᛤ
 },
 [0x16E5]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER STAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E5, -- ᛥ
 },
 [0x16E6]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER LONG-BRANCH-YR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E6, -- ᛦ
 },
 [0x16E7]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER SHORT-TWIG-YR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E7, -- ᛧ
 },
 [0x16E8]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER ICELANDIC-YR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E8, -- ᛨ
 },
 [0x16E9]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER Q",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16E9, -- ᛩ
 },
 [0x16EA]={
  ["category"]="lo",
  ["description"]="RUNIC LETTER X",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16EA, -- ᛪ
 },
 [0x16EB]={
  ["category"]="po",
  ["description"]="RUNIC SINGLE PUNCTUATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x16EB, -- ᛫
 },
 [0x16EC]={
  ["category"]="po",
  ["description"]="RUNIC MULTIPLE PUNCTUATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x16EC, -- ᛬
 },
 [0x16ED]={
  ["category"]="po",
  ["description"]="RUNIC CROSS PUNCTUATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x16ED, -- ᛭
 },
 [0x16EE]={
  ["category"]="nl",
  ["description"]="RUNIC ARLAUG SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16EE, -- ᛮ
 },
 [0x16EF]={
  ["category"]="nl",
  ["description"]="RUNIC TVIMADUR SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16EF, -- ᛯ
 },
 [0x16F0]={
  ["category"]="nl",
  ["description"]="RUNIC BELGTHOR SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x16F0, -- ᛰ
 },
 [0x1700]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1700, -- ᜀ
 },
 [0x1701]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1701, -- ᜁ
 },
 [0x1702]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1702, -- ᜂ
 },
 [0x1703]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1703, -- ᜃ
 },
 [0x1704]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1704, -- ᜄ
 },
 [0x1705]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1705, -- ᜅ
 },
 [0x1706]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1706, -- ᜆ
 },
 [0x1707]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1707, -- ᜇ
 },
 [0x1708]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1708, -- ᜈ
 },
 [0x1709]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1709, -- ᜉ
 },
 [0x170A]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x170A, -- ᜊ
 },
 [0x170B]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x170B, -- ᜋ
 },
 [0x170C]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x170C, -- ᜌ
 },
 [0x170E]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x170E, -- ᜎ
 },
 [0x170F]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x170F, -- ᜏ
 },
 [0x1710]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1710, -- ᜐ
 },
 [0x1711]={
  ["category"]="lo",
  ["description"]="TAGALOG LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1711, -- ᜑ
 },
 [0x1712]={
  ["category"]="mn",
  ["description"]="TAGALOG VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1712, -- ᜒ
 },
 [0x1713]={
  ["category"]="mn",
  ["description"]="TAGALOG VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1713, -- ᜓ
 },
 [0x1714]={
  ["category"]="mn",
  ["description"]="TAGALOG SIGN VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1714, -- ᜔
 },
 [0x1720]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1720, -- ᜠ
 },
 [0x1721]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1721, -- ᜡ
 },
 [0x1722]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1722, -- ᜢ
 },
 [0x1723]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1723, -- ᜣ
 },
 [0x1724]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1724, -- ᜤ
 },
 [0x1725]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1725, -- ᜥ
 },
 [0x1726]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1726, -- ᜦ
 },
 [0x1727]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1727, -- ᜧ
 },
 [0x1728]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1728, -- ᜨ
 },
 [0x1729]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1729, -- ᜩ
 },
 [0x172A]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x172A, -- ᜪ
 },
 [0x172B]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x172B, -- ᜫ
 },
 [0x172C]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x172C, -- ᜬ
 },
 [0x172D]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x172D, -- ᜭ
 },
 [0x172E]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x172E, -- ᜮ
 },
 [0x172F]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x172F, -- ᜯ
 },
 [0x1730]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1730, -- ᜰ
 },
 [0x1731]={
  ["category"]="lo",
  ["description"]="HANUNOO LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1731, -- ᜱ
 },
 [0x1732]={
  ["category"]="mn",
  ["description"]="HANUNOO VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1732, -- ᜲ
 },
 [0x1733]={
  ["category"]="mn",
  ["description"]="HANUNOO VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1733, -- ᜳ
 },
 [0x1734]={
  ["category"]="mn",
  ["description"]="HANUNOO SIGN PAMUDPOD",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1734, -- ᜴
 },
 [0x1735]={
  ["category"]="po",
  ["description"]="PHILIPPINE SINGLE PUNCTUATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1735, -- ᜵
 },
 [0x1736]={
  ["category"]="po",
  ["description"]="PHILIPPINE DOUBLE PUNCTUATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1736, -- ᜶
 },
 [0x1740]={
  ["category"]="lo",
  ["description"]="BUHID LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1740, -- ᝀ
 },
 [0x1741]={
  ["category"]="lo",
  ["description"]="BUHID LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1741, -- ᝁ
 },
 [0x1742]={
  ["category"]="lo",
  ["description"]="BUHID LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1742, -- ᝂ
 },
 [0x1743]={
  ["category"]="lo",
  ["description"]="BUHID LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1743, -- ᝃ
 },
 [0x1744]={
  ["category"]="lo",
  ["description"]="BUHID LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1744, -- ᝄ
 },
 [0x1745]={
  ["category"]="lo",
  ["description"]="BUHID LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1745, -- ᝅ
 },
 [0x1746]={
  ["category"]="lo",
  ["description"]="BUHID LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1746, -- ᝆ
 },
 [0x1747]={
  ["category"]="lo",
  ["description"]="BUHID LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1747, -- ᝇ
 },
 [0x1748]={
  ["category"]="lo",
  ["description"]="BUHID LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1748, -- ᝈ
 },
 [0x1749]={
  ["category"]="lo",
  ["description"]="BUHID LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1749, -- ᝉ
 },
 [0x174A]={
  ["category"]="lo",
  ["description"]="BUHID LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x174A, -- ᝊ
 },
 [0x174B]={
  ["category"]="lo",
  ["description"]="BUHID LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x174B, -- ᝋ
 },
 [0x174C]={
  ["category"]="lo",
  ["description"]="BUHID LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x174C, -- ᝌ
 },
 [0x174D]={
  ["category"]="lo",
  ["description"]="BUHID LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x174D, -- ᝍ
 },
 [0x174E]={
  ["category"]="lo",
  ["description"]="BUHID LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x174E, -- ᝎ
 },
 [0x174F]={
  ["category"]="lo",
  ["description"]="BUHID LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x174F, -- ᝏ
 },
 [0x1750]={
  ["category"]="lo",
  ["description"]="BUHID LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1750, -- ᝐ
 },
 [0x1751]={
  ["category"]="lo",
  ["description"]="BUHID LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1751, -- ᝑ
 },
 [0x1752]={
  ["category"]="mn",
  ["description"]="BUHID VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1752, -- ᝒ
 },
 [0x1753]={
  ["category"]="mn",
  ["description"]="BUHID VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1753, -- ᝓ
 },
 [0x1760]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1760, -- ᝠ
 },
 [0x1761]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1761, -- ᝡ
 },
 [0x1762]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1762, -- ᝢ
 },
 [0x1763]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1763, -- ᝣ
 },
 [0x1764]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1764, -- ᝤ
 },
 [0x1765]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1765, -- ᝥ
 },
 [0x1766]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1766, -- ᝦ
 },
 [0x1767]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1767, -- ᝧ
 },
 [0x1768]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1768, -- ᝨ
 },
 [0x1769]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1769, -- ᝩ
 },
 [0x176A]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x176A, -- ᝪ
 },
 [0x176B]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x176B, -- ᝫ
 },
 [0x176C]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x176C, -- ᝬ
 },
 [0x176E]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x176E, -- ᝮ
 },
 [0x176F]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x176F, -- ᝯ
 },
 [0x1770]={
  ["category"]="lo",
  ["description"]="TAGBANWA LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1770, -- ᝰ
 },
 [0x1772]={
  ["category"]="mn",
  ["description"]="TAGBANWA VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1772, -- ᝲ
 },
 [0x1773]={
  ["category"]="mn",
  ["description"]="TAGBANWA VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1773, -- ᝳ
 },
 [0x1780]={
  ["category"]="lo",
  ["description"]="KHMER LETTER KA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1780, -- ក
 },
 [0x1781]={
  ["category"]="lo",
  ["description"]="KHMER LETTER KHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1781, -- ខ
 },
 [0x1782]={
  ["category"]="lo",
  ["description"]="KHMER LETTER KO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1782, -- គ
 },
 [0x1783]={
  ["category"]="lo",
  ["description"]="KHMER LETTER KHO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1783, -- ឃ
 },
 [0x1784]={
  ["category"]="lo",
  ["description"]="KHMER LETTER NGO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1784, -- ង
 },
 [0x1785]={
  ["category"]="lo",
  ["description"]="KHMER LETTER CA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1785, -- ច
 },
 [0x1786]={
  ["category"]="lo",
  ["description"]="KHMER LETTER CHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1786, -- ឆ
 },
 [0x1787]={
  ["category"]="lo",
  ["description"]="KHMER LETTER CO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1787, -- ជ
 },
 [0x1788]={
  ["category"]="lo",
  ["description"]="KHMER LETTER CHO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1788, -- ឈ
 },
 [0x1789]={
  ["category"]="lo",
  ["description"]="KHMER LETTER NYO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1789, -- ញ
 },
 [0x178A]={
  ["category"]="lo",
  ["description"]="KHMER LETTER DA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x178A, -- ដ
 },
 [0x178B]={
  ["category"]="lo",
  ["description"]="KHMER LETTER TTHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x178B, -- ឋ
 },
 [0x178C]={
  ["category"]="lo",
  ["description"]="KHMER LETTER DO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x178C, -- ឌ
 },
 [0x178D]={
  ["category"]="lo",
  ["description"]="KHMER LETTER TTHO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x178D, -- ឍ
 },
 [0x178E]={
  ["category"]="lo",
  ["description"]="KHMER LETTER NNO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x178E, -- ណ
 },
 [0x178F]={
  ["category"]="lo",
  ["description"]="KHMER LETTER TA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x178F, -- ត
 },
 [0x1790]={
  ["category"]="lo",
  ["description"]="KHMER LETTER THA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1790, -- ថ
 },
 [0x1791]={
  ["category"]="lo",
  ["description"]="KHMER LETTER TO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1791, -- ទ
 },
 [0x1792]={
  ["category"]="lo",
  ["description"]="KHMER LETTER THO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1792, -- ធ
 },
 [0x1793]={
  ["category"]="lo",
  ["description"]="KHMER LETTER NO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1793, -- ន
 },
 [0x1794]={
  ["category"]="lo",
  ["description"]="KHMER LETTER BA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1794, -- ប
 },
 [0x1795]={
  ["category"]="lo",
  ["description"]="KHMER LETTER PHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1795, -- ផ
 },
 [0x1796]={
  ["category"]="lo",
  ["description"]="KHMER LETTER PO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1796, -- ព
 },
 [0x1797]={
  ["category"]="lo",
  ["description"]="KHMER LETTER PHO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1797, -- ភ
 },
 [0x1798]={
  ["category"]="lo",
  ["description"]="KHMER LETTER MO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1798, -- ម
 },
 [0x1799]={
  ["category"]="lo",
  ["description"]="KHMER LETTER YO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1799, -- យ
 },
 [0x179A]={
  ["category"]="lo",
  ["description"]="KHMER LETTER RO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x179A, -- រ
 },
 [0x179B]={
  ["category"]="lo",
  ["description"]="KHMER LETTER LO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x179B, -- ល
 },
 [0x179C]={
  ["category"]="lo",
  ["description"]="KHMER LETTER VO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x179C, -- វ
 },
 [0x179D]={
  ["category"]="lo",
  ["description"]="KHMER LETTER SHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x179D, -- ឝ
 },
 [0x179E]={
  ["category"]="lo",
  ["description"]="KHMER LETTER SSO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x179E, -- ឞ
 },
 [0x179F]={
  ["category"]="lo",
  ["description"]="KHMER LETTER SA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x179F, -- ស
 },
 [0x17A0]={
  ["category"]="lo",
  ["description"]="KHMER LETTER HA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A0, -- ហ
 },
 [0x17A1]={
  ["category"]="lo",
  ["description"]="KHMER LETTER LA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A1, -- ឡ
 },
 [0x17A2]={
  ["category"]="lo",
  ["description"]="KHMER LETTER QA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A2, -- អ
 },
 [0x17A3]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QAQ",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A3, -- ឣ
 },
 [0x17A4]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QAA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A4, -- ឤ
 },
 [0x17A5]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A5, -- ឥ
 },
 [0x17A6]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QII",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A6, -- ឦ
 },
 [0x17A7]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A7, -- ឧ
 },
 [0x17A8]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QUK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A8, -- ឨ
 },
 [0x17A9]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QUU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17A9, -- ឩ
 },
 [0x17AA]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QUUV",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17AA, -- ឪ
 },
 [0x17AB]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL RY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17AB, -- ឫ
 },
 [0x17AC]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL RYY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17AC, -- ឬ
 },
 [0x17AD]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL LY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17AD, -- ឭ
 },
 [0x17AE]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL LYY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17AE, -- ឮ
 },
 [0x17AF]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17AF, -- ឯ
 },
 [0x17B0]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QAI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B0, -- ឰ
 },
 [0x17B1]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QOO TYPE ONE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B1, -- ឱ
 },
 [0x17B2]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QOO TYPE TWO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B2, -- ឲ
 },
 [0x17B3]={
  ["category"]="lo",
  ["description"]="KHMER INDEPENDENT VOWEL QAU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B3, -- ឳ
 },
 [0x17B4]={
  ["category"]="cf",
  ["description"]="KHMER VOWEL INHERENT AQ",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B4, -- ឴
 },
 [0x17B5]={
  ["category"]="cf",
  ["description"]="KHMER VOWEL INHERENT AA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B5, -- ឵
 },
 [0x17B6]={
  ["category"]="mc",
  ["description"]="KHMER VOWEL SIGN AA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B6, -- ា
 },
 [0x17B7]={
  ["category"]="mn",
  ["description"]="KHMER VOWEL SIGN I",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B7, -- ិ
 },
 [0x17B8]={
  ["category"]="mn",
  ["description"]="KHMER VOWEL SIGN II",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B8, -- ី
 },
 [0x17B9]={
  ["category"]="mn",
  ["description"]="KHMER VOWEL SIGN Y",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17B9, -- ឹ
 },
 [0x17BA]={
  ["category"]="mn",
  ["description"]="KHMER VOWEL SIGN YY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17BA, -- ឺ
 },
 [0x17BB]={
  ["category"]="mn",
  ["description"]="KHMER VOWEL SIGN U",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17BB, -- ុ
 },
 [0x17BC]={
  ["category"]="mn",
  ["description"]="KHMER VOWEL SIGN UU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17BC, -- ូ
 },
 [0x17BD]={
  ["category"]="mn",
  ["description"]="KHMER VOWEL SIGN UA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17BD, -- ួ
 },
 [0x17BE]={
  ["category"]="mc",
  ["description"]="KHMER VOWEL SIGN OE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17BE, -- ើ
 },
 [0x17BF]={
  ["category"]="mc",
  ["description"]="KHMER VOWEL SIGN YA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17BF, -- ឿ
 },
 [0x17C0]={
  ["category"]="mc",
  ["description"]="KHMER VOWEL SIGN IE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C0, -- ៀ
 },
 [0x17C1]={
  ["category"]="mc",
  ["description"]="KHMER VOWEL SIGN E",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C1, -- េ
 },
 [0x17C2]={
  ["category"]="mc",
  ["description"]="KHMER VOWEL SIGN AE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C2, -- ែ
 },
 [0x17C3]={
  ["category"]="mc",
  ["description"]="KHMER VOWEL SIGN AI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C3, -- ៃ
 },
 [0x17C4]={
  ["category"]="mc",
  ["description"]="KHMER VOWEL SIGN OO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C4, -- ោ
 },
 [0x17C5]={
  ["category"]="mc",
  ["description"]="KHMER VOWEL SIGN AU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C5, -- ៅ
 },
 [0x17C6]={
  ["category"]="mn",
  ["description"]="KHMER SIGN NIKAHIT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C6, -- ំ
 },
 [0x17C7]={
  ["category"]="mc",
  ["description"]="KHMER SIGN REAHMUK",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C7, -- ះ
 },
 [0x17C8]={
  ["category"]="mc",
  ["description"]="KHMER SIGN YUUKALEAPINTU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C8, -- ៈ
 },
 [0x17C9]={
  ["category"]="mn",
  ["description"]="KHMER SIGN MUUSIKATOAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17C9, -- ៉
 },
 [0x17CA]={
  ["category"]="mn",
  ["description"]="KHMER SIGN TRIISAP",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17CA, -- ៊
 },
 [0x17CB]={
  ["category"]="mn",
  ["description"]="KHMER SIGN BANTOC",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17CB, -- ់
 },
 [0x17CC]={
  ["category"]="mn",
  ["description"]="KHMER SIGN ROBAT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17CC, -- ៌
 },
 [0x17CD]={
  ["category"]="mn",
  ["description"]="KHMER SIGN TOANDAKHIAT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17CD, -- ៍
 },
 [0x17CE]={
  ["category"]="mn",
  ["description"]="KHMER SIGN KAKABAT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17CE, -- ៎
 },
 [0x17CF]={
  ["category"]="mn",
  ["description"]="KHMER SIGN AHSDA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17CF, -- ៏
 },
 [0x17D0]={
  ["category"]="mn",
  ["description"]="KHMER SIGN SAMYOK SANNYA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17D0, -- ័
 },
 [0x17D1]={
  ["category"]="mn",
  ["description"]="KHMER SIGN VIRIAM",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17D1, -- ៑
 },
 [0x17D2]={
  ["category"]="mn",
  ["description"]="KHMER SIGN COENG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17D2, -- ្
 },
 [0x17D3]={
  ["category"]="mn",
  ["description"]="KHMER SIGN BATHAMASAT",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17D3, -- ៓
 },
 [0x17D4]={
  ["category"]="po",
  ["description"]="KHMER SIGN KHAN",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x17D4, -- ។
 },
 [0x17D5]={
  ["category"]="po",
  ["description"]="KHMER SIGN BARIYOOSAN",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x17D5, -- ៕
 },
 [0x17D6]={
  ["category"]="po",
  ["description"]="KHMER SIGN CAMNUC PII KUUH",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x17D6, -- ៖
 },
 [0x17D7]={
  ["category"]="lm",
  ["description"]="KHMER SIGN LEK TOO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17D7, -- ៗ
 },
 [0x17D8]={
  ["category"]="po",
  ["description"]="KHMER SIGN BEYYAL",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x17D8, -- ៘
 },
 [0x17D9]={
  ["category"]="po",
  ["description"]="KHMER SIGN PHNAEK MUAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17D9, -- ៙
 },
 [0x17DA]={
  ["category"]="po",
  ["description"]="KHMER SIGN KOOMUUT",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x17DA, -- ៚
 },
 [0x17DB]={
  ["category"]="sc",
  ["description"]="KHMER CURRENCY SYMBOL RIEL",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x17DB, -- ៛
 },
 [0x17DC]={
  ["category"]="lo",
  ["description"]="KHMER SIGN AVAKRAHASANYA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17DC, -- ៜ
 },
 [0x17DD]={
  ["category"]="mn",
  ["description"]="KHMER SIGN ATTHACAN",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x17DD, -- ៝
 },
 [0x17E0]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E0, -- ០
 },
 [0x17E1]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E1, -- ១
 },
 [0x17E2]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E2, -- ២
 },
 [0x17E3]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E3, -- ៣
 },
 [0x17E4]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E4, -- ៤
 },
 [0x17E5]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E5, -- ៥
 },
 [0x17E6]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E6, -- ៦
 },
 [0x17E7]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E7, -- ៧
 },
 [0x17E8]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E8, -- ៨
 },
 [0x17E9]={
  ["category"]="nd",
  ["description"]="KHMER DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x17E9, -- ៩
 },
 [0x17F0]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK SON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F0, -- ៰
 },
 [0x17F1]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK MUOY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F1, -- ៱
 },
 [0x17F2]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK PII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F2, -- ៲
 },
 [0x17F3]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK BEI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F3, -- ៳
 },
 [0x17F4]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK BUON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F4, -- ៴
 },
 [0x17F5]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK PRAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F5, -- ៵
 },
 [0x17F6]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK PRAM-MUOY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F6, -- ៶
 },
 [0x17F7]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK PRAM-PII",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F7, -- ៷
 },
 [0x17F8]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK PRAM-BEI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F8, -- ៸
 },
 [0x17F9]={
  ["category"]="no",
  ["description"]="KHMER SYMBOL LEK ATTAK PRAM-BUON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x17F9, -- ៹
 },
 [0x1800]={
  ["category"]="po",
  ["description"]="MONGOLIAN BIRGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1800, -- ᠀
 },
 [0x1801]={
  ["category"]="po",
  ["description"]="MONGOLIAN ELLIPSIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1801, -- ᠁
 },
 [0x1802]={
  ["category"]="po",
  ["description"]="MONGOLIAN COMMA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1802, -- ᠂
 },
 [0x1803]={
  ["category"]="po",
  ["description"]="MONGOLIAN FULL STOP",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1803, -- ᠃
 },
 [0x1804]={
  ["category"]="po",
  ["description"]="MONGOLIAN COLON",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1804, -- ᠄
 },
 [0x1805]={
  ["category"]="po",
  ["description"]="MONGOLIAN FOUR DOTS",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1805, -- ᠅
 },
 [0x1806]={
  ["category"]="pd",
  ["description"]="MONGOLIAN TODO SOFT HYPHEN",
  ["linebreak"]="bb",
  ["unicodeslot"]=0x1806, -- ᠆
 },
 [0x1807]={
  ["category"]="po",
  ["description"]="MONGOLIAN SIBE SYLLABLE BOUNDARY MARKER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1807, -- ᠇
 },
 [0x1808]={
  ["category"]="po",
  ["description"]="MONGOLIAN MANCHU COMMA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1808, -- ᠈
 },
 [0x1809]={
  ["category"]="po",
  ["description"]="MONGOLIAN MANCHU FULL STOP",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1809, -- ᠉
 },
 [0x180A]={
  ["category"]="po",
  ["description"]="MONGOLIAN NIRUGU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x180A, -- ᠊
 },
 [0x180B]={
  ["category"]="mn",
  ["description"]="MONGOLIAN FREE VARIATION SELECTOR ONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x180B, -- ᠋
 },
 [0x180C]={
  ["category"]="mn",
  ["description"]="MONGOLIAN FREE VARIATION SELECTOR TWO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x180C, -- ᠌
 },
 [0x180D]={
  ["category"]="mn",
  ["description"]="MONGOLIAN FREE VARIATION SELECTOR THREE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x180D, -- ᠍
 },
 [0x180E]={
  ["category"]="zs",
  ["description"]="MONGOLIAN VOWEL SEPARATOR",
  ["linebreak"]="gl",
  ["unicodeslot"]=0x180E, -- ᠎
 },
 [0x1810]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1810, -- ᠐
 },
 [0x1811]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1811, -- ᠑
 },
 [0x1812]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1812, -- ᠒
 },
 [0x1813]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1813, -- ᠓
 },
 [0x1814]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1814, -- ᠔
 },
 [0x1815]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1815, -- ᠕
 },
 [0x1816]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1816, -- ᠖
 },
 [0x1817]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1817, -- ᠗
 },
 [0x1818]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1818, -- ᠘
 },
 [0x1819]={
  ["category"]="nd",
  ["description"]="MONGOLIAN DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1819, -- ᠙
 },
 [0x1820]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1820, -- ᠠ
 },
 [0x1821]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1821, -- ᠡ
 },
 [0x1822]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1822, -- ᠢ
 },
 [0x1823]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1823, -- ᠣ
 },
 [0x1824]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1824, -- ᠤ
 },
 [0x1825]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER OE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1825, -- ᠥ
 },
 [0x1826]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER UE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1826, -- ᠦ
 },
 [0x1827]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1827, -- ᠧ
 },
 [0x1828]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1828, -- ᠨ
 },
 [0x1829]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1829, -- ᠩ
 },
 [0x182A]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x182A, -- ᠪ
 },
 [0x182B]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x182B, -- ᠫ
 },
 [0x182C]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER QA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x182C, -- ᠬ
 },
 [0x182D]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x182D, -- ᠭ
 },
 [0x182E]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x182E, -- ᠮ
 },
 [0x182F]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x182F, -- ᠯ
 },
 [0x1830]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1830, -- ᠰ
 },
 [0x1831]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1831, -- ᠱ
 },
 [0x1832]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1832, -- ᠲ
 },
 [0x1833]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1833, -- ᠳ
 },
 [0x1834]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1834, -- ᠴ
 },
 [0x1835]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1835, -- ᠵ
 },
 [0x1836]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1836, -- ᠶ
 },
 [0x1837]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1837, -- ᠷ
 },
 [0x1838]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1838, -- ᠸ
 },
 [0x1839]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1839, -- ᠹ
 },
 [0x183A]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x183A, -- ᠺ
 },
 [0x183B]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x183B, -- ᠻ
 },
 [0x183C]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x183C, -- ᠼ
 },
 [0x183D]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x183D, -- ᠽ
 },
 [0x183E]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER HAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x183E, -- ᠾ
 },
 [0x183F]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ZRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x183F, -- ᠿ
 },
 [0x1840]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER LHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1840, -- ᡀ
 },
 [0x1841]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ZHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1841, -- ᡁ
 },
 [0x1842]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER CHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1842, -- ᡂ
 },
 [0x1843]={
  ["category"]="lm",
  ["description"]="MONGOLIAN LETTER TODO LONG VOWEL SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1843, -- ᡃ
 },
 [0x1844]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1844, -- ᡄ
 },
 [0x1845]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1845, -- ᡅ
 },
 [0x1846]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1846, -- ᡆ
 },
 [0x1847]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1847, -- ᡇ
 },
 [0x1848]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO OE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1848, -- ᡈ
 },
 [0x1849]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO UE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1849, -- ᡉ
 },
 [0x184A]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO ANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x184A, -- ᡊ
 },
 [0x184B]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x184B, -- ᡋ
 },
 [0x184C]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x184C, -- ᡌ
 },
 [0x184D]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO QA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x184D, -- ᡍ
 },
 [0x184E]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x184E, -- ᡎ
 },
 [0x184F]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x184F, -- ᡏ
 },
 [0x1850]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1850, -- ᡐ
 },
 [0x1851]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1851, -- ᡑ
 },
 [0x1852]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1852, -- ᡒ
 },
 [0x1853]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1853, -- ᡓ
 },
 [0x1854]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO TSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1854, -- ᡔ
 },
 [0x1855]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1855, -- ᡕ
 },
 [0x1856]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1856, -- ᡖ
 },
 [0x1857]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1857, -- ᡗ
 },
 [0x1858]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO GAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1858, -- ᡘ
 },
 [0x1859]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO HAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1859, -- ᡙ
 },
 [0x185A]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO JIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x185A, -- ᡚ
 },
 [0x185B]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO NIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x185B, -- ᡛ
 },
 [0x185C]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO DZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x185C, -- ᡜ
 },
 [0x185D]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x185D, -- ᡝ
 },
 [0x185E]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x185E, -- ᡞ
 },
 [0x185F]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE IY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x185F, -- ᡟ
 },
 [0x1860]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE UE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1860, -- ᡠ
 },
 [0x1861]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1861, -- ᡡ
 },
 [0x1862]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE ANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1862, -- ᡢ
 },
 [0x1863]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1863, -- ᡣ
 },
 [0x1864]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1864, -- ᡤ
 },
 [0x1865]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1865, -- ᡥ
 },
 [0x1866]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1866, -- ᡦ
 },
 [0x1867]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1867, -- ᡧ
 },
 [0x1868]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1868, -- ᡨ
 },
 [0x1869]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1869, -- ᡩ
 },
 [0x186A]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x186A, -- ᡪ
 },
 [0x186B]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x186B, -- ᡫ
 },
 [0x186C]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE GAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x186C, -- ᡬ
 },
 [0x186D]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE HAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x186D, -- ᡭ
 },
 [0x186E]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE TSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x186E, -- ᡮ
 },
 [0x186F]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x186F, -- ᡯ
 },
 [0x1870]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE RAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1870, -- ᡰ
 },
 [0x1871]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1871, -- ᡱ
 },
 [0x1872]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER SIBE ZHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1872, -- ᡲ
 },
 [0x1873]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1873, -- ᡳ
 },
 [0x1874]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1874, -- ᡴ
 },
 [0x1875]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1875, -- ᡵ
 },
 [0x1876]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1876, -- ᡶ
 },
 [0x1877]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ZHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1877, -- ᡷ
 },
 [0x1880]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI ANUSVARA ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1880, -- ᢀ
 },
 [0x1881]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI VISARGA ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1881, -- ᢁ
 },
 [0x1882]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI DAMARU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1882, -- ᢂ
 },
 [0x1883]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI UBADAMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1883, -- ᢃ
 },
 [0x1884]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI INVERTED UBADAMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1884, -- ᢄ
 },
 [0x1885]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI BALUDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1885, -- ᢅ
 },
 [0x1886]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI THREE BALUDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1886, -- ᢆ
 },
 [0x1887]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1887, -- ᢇ
 },
 [0x1888]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1888, -- ᢈ
 },
 [0x1889]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1889, -- ᢉ
 },
 [0x188A]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x188A, -- ᢊ
 },
 [0x188B]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x188B, -- ᢋ
 },
 [0x188C]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x188C, -- ᢌ
 },
 [0x188D]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x188D, -- ᢍ
 },
 [0x188E]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x188E, -- ᢎ
 },
 [0x188F]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x188F, -- ᢏ
 },
 [0x1890]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1890, -- ᢐ
 },
 [0x1891]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1891, -- ᢑ
 },
 [0x1892]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1892, -- ᢒ
 },
 [0x1893]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1893, -- ᢓ
 },
 [0x1894]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1894, -- ᢔ
 },
 [0x1895]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI ZHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1895, -- ᢕ
 },
 [0x1896]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1896, -- ᢖ
 },
 [0x1897]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI AH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1897, -- ᢗ
 },
 [0x1898]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO ALI GALI TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1898, -- ᢘ
 },
 [0x1899]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER TODO ALI GALI ZHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1899, -- ᢙ
 },
 [0x189A]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x189A, -- ᢚ
 },
 [0x189B]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x189B, -- ᢛ
 },
 [0x189C]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x189C, -- ᢜ
 },
 [0x189D]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x189D, -- ᢝ
 },
 [0x189E]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x189E, -- ᢞ
 },
 [0x189F]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x189F, -- ᢟ
 },
 [0x18A0]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x18A0, -- ᢠ
 },
 [0x18A1]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x18A1, -- ᢡ
 },
 [0x18A2]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x18A2, -- ᢢ
 },
 [0x18A3]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI CYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x18A3, -- ᢣ
 },
 [0x18A4]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI ZHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x18A4, -- ᢤ
 },
 [0x18A5]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x18A5, -- ᢥ
 },
 [0x18A6]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI HALF U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x18A6, -- ᢦ
 },
 [0x18A7]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER ALI GALI HALF YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x18A7, -- ᢧ
 },
 [0x18A8]={
  ["category"]="lo",
  ["description"]="MONGOLIAN LETTER MANCHU ALI GALI BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x18A8, -- ᢨ
 },
 [0x18A9]={
  ["category"]="mn",
  ["description"]="MONGOLIAN LETTER ALI GALI DAGALGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x18A9, -- ᢩ
 },
 [0x1900]={
  ["category"]="lo",
  ["description"]="LIMBU VOWEL-CARRIER LETTER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1900, -- ᤀ
 },
 [0x1901]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1901, -- ᤁ
 },
 [0x1902]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1902, -- ᤂ
 },
 [0x1903]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1903, -- ᤃ
 },
 [0x1904]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1904, -- ᤄ
 },
 [0x1905]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1905, -- ᤅ
 },
 [0x1906]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1906, -- ᤆ
 },
 [0x1907]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1907, -- ᤇ
 },
 [0x1908]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1908, -- ᤈ
 },
 [0x1909]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER JHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1909, -- ᤉ
 },
 [0x190A]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER YAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x190A, -- ᤊ
 },
 [0x190B]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x190B, -- ᤋ
 },
 [0x190C]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x190C, -- ᤌ
 },
 [0x190D]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x190D, -- ᤍ
 },
 [0x190E]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x190E, -- ᤎ
 },
 [0x190F]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x190F, -- ᤏ
 },
 [0x1910]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1910, -- ᤐ
 },
 [0x1911]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1911, -- ᤑ
 },
 [0x1912]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1912, -- ᤒ
 },
 [0x1913]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1913, -- ᤓ
 },
 [0x1914]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1914, -- ᤔ
 },
 [0x1915]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1915, -- ᤕ
 },
 [0x1916]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1916, -- ᤖ
 },
 [0x1917]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1917, -- ᤗ
 },
 [0x1918]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1918, -- ᤘ
 },
 [0x1919]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1919, -- ᤙ
 },
 [0x191A]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x191A, -- ᤚ
 },
 [0x191B]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x191B, -- ᤛ
 },
 [0x191C]={
  ["category"]="lo",
  ["description"]="LIMBU LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x191C, -- ᤜ
 },
 [0x1920]={
  ["category"]="mn",
  ["description"]="LIMBU VOWEL SIGN A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1920, -- ᤠ
 },
 [0x1921]={
  ["category"]="mn",
  ["description"]="LIMBU VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1921, -- ᤡ
 },
 [0x1922]={
  ["category"]="mn",
  ["description"]="LIMBU VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1922, -- ᤢ
 },
 [0x1923]={
  ["category"]="mc",
  ["description"]="LIMBU VOWEL SIGN EE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1923, -- ᤣ
 },
 [0x1924]={
  ["category"]="mc",
  ["description"]="LIMBU VOWEL SIGN AI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1924, -- ᤤ
 },
 [0x1925]={
  ["category"]="mc",
  ["description"]="LIMBU VOWEL SIGN OO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1925, -- ᤥ
 },
 [0x1926]={
  ["category"]="mc",
  ["description"]="LIMBU VOWEL SIGN AU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1926, -- ᤦ
 },
 [0x1927]={
  ["category"]="mn",
  ["description"]="LIMBU VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1927, -- ᤧ
 },
 [0x1928]={
  ["category"]="mn",
  ["description"]="LIMBU VOWEL SIGN O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1928, -- ᤨ
 },
 [0x1929]={
  ["category"]="mc",
  ["description"]="LIMBU SUBJOINED LETTER YA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1929, -- ᤩ
 },
 [0x192A]={
  ["category"]="mc",
  ["description"]="LIMBU SUBJOINED LETTER RA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x192A, -- ᤪ
 },
 [0x192B]={
  ["category"]="mc",
  ["description"]="LIMBU SUBJOINED LETTER WA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x192B, -- ᤫ
 },
 [0x1930]={
  ["category"]="mc",
  ["description"]="LIMBU SMALL LETTER KA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1930, -- ᤰ
 },
 [0x1931]={
  ["category"]="mc",
  ["description"]="LIMBU SMALL LETTER NGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1931, -- ᤱ
 },
 [0x1932]={
  ["category"]="mn",
  ["description"]="LIMBU SMALL LETTER ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1932, -- ᤲ
 },
 [0x1933]={
  ["category"]="mc",
  ["description"]="LIMBU SMALL LETTER TA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1933, -- ᤳ
 },
 [0x1934]={
  ["category"]="mc",
  ["description"]="LIMBU SMALL LETTER NA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1934, -- ᤴ
 },
 [0x1935]={
  ["category"]="mc",
  ["description"]="LIMBU SMALL LETTER PA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1935, -- ᤵ
 },
 [0x1936]={
  ["category"]="mc",
  ["description"]="LIMBU SMALL LETTER MA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1936, -- ᤶ
 },
 [0x1937]={
  ["category"]="mc",
  ["description"]="LIMBU SMALL LETTER RA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1937, -- ᤷ
 },
 [0x1938]={
  ["category"]="mc",
  ["description"]="LIMBU SMALL LETTER LA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1938, -- ᤸ
 },
 [0x1939]={
  ["category"]="mn",
  ["description"]="LIMBU SIGN MUKPHRENG",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1939, -- ᤹
 },
 [0x193A]={
  ["category"]="mn",
  ["description"]="LIMBU SIGN KEMPHRENG",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x193A, -- ᤺
 },
 [0x193B]={
  ["category"]="mn",
  ["description"]="LIMBU SIGN SA-I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x193B, -- ᤻
 },
 [0x1940]={
  ["category"]="so",
  ["description"]="LIMBU SIGN LOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1940, -- ᥀
 },
 [0x1944]={
  ["category"]="po",
  ["description"]="LIMBU EXCLAMATION MARK",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x1944, -- ᥄
 },
 [0x1945]={
  ["category"]="po",
  ["description"]="LIMBU QUESTION MARK",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x1945, -- ᥅
 },
 [0x1946]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1946, -- ᥆
 },
 [0x1947]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1947, -- ᥇
 },
 [0x1948]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1948, -- ᥈
 },
 [0x1949]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1949, -- ᥉
 },
 [0x194A]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x194A, -- ᥊
 },
 [0x194B]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x194B, -- ᥋
 },
 [0x194C]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x194C, -- ᥌
 },
 [0x194D]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x194D, -- ᥍
 },
 [0x194E]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x194E, -- ᥎
 },
 [0x194F]={
  ["category"]="nd",
  ["description"]="LIMBU DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x194F, -- ᥏
 },
 [0x1950]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER KA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1950, -- ᥐ
 },
 [0x1951]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER XA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1951, -- ᥑ
 },
 [0x1952]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER NGA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1952, -- ᥒ
 },
 [0x1953]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER TSA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1953, -- ᥓ
 },
 [0x1954]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER SA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1954, -- ᥔ
 },
 [0x1955]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER YA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1955, -- ᥕ
 },
 [0x1956]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER TA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1956, -- ᥖ
 },
 [0x1957]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER THA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1957, -- ᥗ
 },
 [0x1958]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER LA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1958, -- ᥘ
 },
 [0x1959]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER PA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1959, -- ᥙ
 },
 [0x195A]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER PHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x195A, -- ᥚ
 },
 [0x195B]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER MA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x195B, -- ᥛ
 },
 [0x195C]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER FA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x195C, -- ᥜ
 },
 [0x195D]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER VA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x195D, -- ᥝ
 },
 [0x195E]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER HA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x195E, -- ᥞ
 },
 [0x195F]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER QA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x195F, -- ᥟ
 },
 [0x1960]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER KHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1960, -- ᥠ
 },
 [0x1961]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER TSHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1961, -- ᥡ
 },
 [0x1962]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER NA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1962, -- ᥢ
 },
 [0x1963]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER A",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1963, -- ᥣ
 },
 [0x1964]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER I",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1964, -- ᥤ
 },
 [0x1965]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER EE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1965, -- ᥥ
 },
 [0x1966]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER EH",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1966, -- ᥦ
 },
 [0x1967]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER U",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1967, -- ᥧ
 },
 [0x1968]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER OO",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1968, -- ᥨ
 },
 [0x1969]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER O",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1969, -- ᥩ
 },
 [0x196A]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER UE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x196A, -- ᥪ
 },
 [0x196B]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER E",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x196B, -- ᥫ
 },
 [0x196C]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER AUE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x196C, -- ᥬ
 },
 [0x196D]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER AI",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x196D, -- ᥭ
 },
 [0x1970]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER TONE-0x0002",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1970, -- ᥰ
 },
 [0x1971]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER TONE-0x0003",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1971, -- ᥱ
 },
 [0x1972]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER TONE-0x0004",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1972, -- ᥲ
 },
 [0x1973]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER TONE-0x0005",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1973, -- ᥳ
 },
 [0x1974]={
  ["category"]="lo",
  ["description"]="TAI LE LETTER TONE-0x0006",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1974, -- ᥴ
 },
 [0x1980]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH QA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1980, -- ᦀ
 },
 [0x1981]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW QA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1981, -- ᦁ
 },
 [0x1982]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH KA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1982, -- ᦂ
 },
 [0x1983]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH XA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1983, -- ᦃ
 },
 [0x1984]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH NGA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1984, -- ᦄ
 },
 [0x1985]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW KA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1985, -- ᦅ
 },
 [0x1986]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW XA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1986, -- ᦆ
 },
 [0x1987]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW NGA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1987, -- ᦇ
 },
 [0x1988]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH TSA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1988, -- ᦈ
 },
 [0x1989]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH SA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1989, -- ᦉ
 },
 [0x198A]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH YA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x198A, -- ᦊ
 },
 [0x198B]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW TSA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x198B, -- ᦋ
 },
 [0x198C]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW SA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x198C, -- ᦌ
 },
 [0x198D]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW YA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x198D, -- ᦍ
 },
 [0x198E]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH TA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x198E, -- ᦎ
 },
 [0x198F]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH THA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x198F, -- ᦏ
 },
 [0x1990]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH NA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1990, -- ᦐ
 },
 [0x1991]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW TA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1991, -- ᦑ
 },
 [0x1992]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW THA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1992, -- ᦒ
 },
 [0x1993]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW NA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1993, -- ᦓ
 },
 [0x1994]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH PA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1994, -- ᦔ
 },
 [0x1995]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH PHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1995, -- ᦕ
 },
 [0x1996]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH MA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1996, -- ᦖ
 },
 [0x1997]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW PA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1997, -- ᦗ
 },
 [0x1998]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW PHA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1998, -- ᦘ
 },
 [0x1999]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW MA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x1999, -- ᦙ
 },
 [0x199A]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH FA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x199A, -- ᦚ
 },
 [0x199B]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH VA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x199B, -- ᦛ
 },
 [0x199C]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH LA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x199C, -- ᦜ
 },
 [0x199D]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW FA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x199D, -- ᦝ
 },
 [0x199E]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW VA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x199E, -- ᦞ
 },
 [0x199F]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW LA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x199F, -- ᦟ
 },
 [0x19A0]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH HA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A0, -- ᦠ
 },
 [0x19A1]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH DA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A1, -- ᦡ
 },
 [0x19A2]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH BA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A2, -- ᦢ
 },
 [0x19A3]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW HA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A3, -- ᦣ
 },
 [0x19A4]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW DA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A4, -- ᦤ
 },
 [0x19A5]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW BA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A5, -- ᦥ
 },
 [0x19A6]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH KVA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A6, -- ᦦ
 },
 [0x19A7]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER HIGH XVA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A7, -- ᦧ
 },
 [0x19A8]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW KVA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A8, -- ᦨ
 },
 [0x19A9]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER LOW XVA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19A9, -- ᦩ
 },
 [0x19B0]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN VOWEL SHORTENER",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B0, -- ᦰ
 },
 [0x19B1]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN AA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B1, -- ᦱ
 },
 [0x19B2]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN II",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B2, -- ᦲ
 },
 [0x19B3]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN U",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B3, -- ᦳ
 },
 [0x19B4]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN UU",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B4, -- ᦴ
 },
 [0x19B5]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN E",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B5, -- ᦵ
 },
 [0x19B6]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN AE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B6, -- ᦶ
 },
 [0x19B7]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN O",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B7, -- ᦷ
 },
 [0x19B8]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN OA",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B8, -- ᦸ
 },
 [0x19B9]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN UE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19B9, -- ᦹ
 },
 [0x19BA]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN AY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19BA, -- ᦺ
 },
 [0x19BB]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN AAY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19BB, -- ᦻ
 },
 [0x19BC]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN UY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19BC, -- ᦼ
 },
 [0x19BD]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN OY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19BD, -- ᦽ
 },
 [0x19BE]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN OAY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19BE, -- ᦾ
 },
 [0x19BF]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN UEY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19BF, -- ᦿ
 },
 [0x19C0]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE VOWEL SIGN IY",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C0, -- ᧀ
 },
 [0x19C1]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER FINAL V",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C1, -- ᧁ
 },
 [0x19C2]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER FINAL NG",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C2, -- ᧂ
 },
 [0x19C3]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER FINAL N",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C3, -- ᧃ
 },
 [0x19C4]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER FINAL M",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C4, -- ᧄ
 },
 [0x19C5]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER FINAL K",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C5, -- ᧅ
 },
 [0x19C6]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER FINAL D",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C6, -- ᧆ
 },
 [0x19C7]={
  ["category"]="lo",
  ["description"]="NEW TAI LUE LETTER FINAL B",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C7, -- ᧇ
 },
 [0x19C8]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE TONE MARK-0x0001",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C8, -- ᧈ
 },
 [0x19C9]={
  ["category"]="mc",
  ["description"]="NEW TAI LUE TONE MARK-0x0002",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19C9, -- ᧉ
 },
 [0x19D0]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D0, -- ᧐
 },
 [0x19D1]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D1, -- ᧑
 },
 [0x19D2]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D2, -- ᧒
 },
 [0x19D3]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D3, -- ᧓
 },
 [0x19D4]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D4, -- ᧔
 },
 [0x19D5]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D5, -- ᧕
 },
 [0x19D6]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D6, -- ᧖
 },
 [0x19D7]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D7, -- ᧗
 },
 [0x19D8]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D8, -- ᧘
 },
 [0x19D9]={
  ["category"]="nd",
  ["description"]="NEW TAI LUE DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x19D9, -- ᧙
 },
 [0x19DE]={
  ["category"]="po",
  ["description"]="NEW TAI LUE SIGN LAE",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19DE, -- ᧞
 },
 [0x19DF]={
  ["category"]="po",
  ["description"]="NEW TAI LUE SIGN LAEV",
  ["linebreak"]="sa",
  ["unicodeslot"]=0x19DF, -- ᧟
 },
 [0x19E0]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PATHAMASAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E0, -- ᧠
 },
 [0x19E1]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL MUOY KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E1, -- ᧡
 },
 [0x19E2]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PII KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E2, -- ᧢
 },
 [0x19E3]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL BEI KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E3, -- ᧣
 },
 [0x19E4]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL BUON KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E4, -- ᧤
 },
 [0x19E5]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E5, -- ᧥
 },
 [0x19E6]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM-MUOY KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E6, -- ᧦
 },
 [0x19E7]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM-PII KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E7, -- ᧧
 },
 [0x19E8]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM-BEI KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E8, -- ᧨
 },
 [0x19E9]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM-BUON KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19E9, -- ᧩
 },
 [0x19EA]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19EA, -- ᧪
 },
 [0x19EB]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-MUOY KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19EB, -- ᧫
 },
 [0x19EC]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-PII KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19EC, -- ᧬
 },
 [0x19ED]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-BEI KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19ED, -- ᧭
 },
 [0x19EE]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-BUON KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19EE, -- ᧮
 },
 [0x19EF]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-PRAM KOET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19EF, -- ᧯
 },
 [0x19F0]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL TUTEYASAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F0, -- ᧰
 },
 [0x19F1]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL MUOY ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F1, -- ᧱
 },
 [0x19F2]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PII ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F2, -- ᧲
 },
 [0x19F3]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL BEI ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F3, -- ᧳
 },
 [0x19F4]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL BUON ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F4, -- ᧴
 },
 [0x19F5]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F5, -- ᧵
 },
 [0x19F6]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM-MUOY ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F6, -- ᧶
 },
 [0x19F7]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM-PII ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F7, -- ᧷
 },
 [0x19F8]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM-BEI ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F8, -- ᧸
 },
 [0x19F9]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL PRAM-BUON ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19F9, -- ᧹
 },
 [0x19FA]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19FA, -- ᧺
 },
 [0x19FB]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-MUOY ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19FB, -- ᧻
 },
 [0x19FC]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-PII ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19FC, -- ᧼
 },
 [0x19FD]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-BEI ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19FD, -- ᧽
 },
 [0x19FE]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-BUON ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19FE, -- ᧾
 },
 [0x19FF]={
  ["category"]="so",
  ["description"]="KHMER SYMBOL DAP-PRAM ROC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x19FF, -- ᧿
 },
 [0x1A00]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A00, -- ᨀ
 },
 [0x1A01]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A01, -- ᨁ
 },
 [0x1A02]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A02, -- ᨂ
 },
 [0x1A03]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER NGKA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A03, -- ᨃ
 },
 [0x1A04]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A04, -- ᨄ
 },
 [0x1A05]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A05, -- ᨅ
 },
 [0x1A06]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A06, -- ᨆ
 },
 [0x1A07]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER MPA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A07, -- ᨇ
 },
 [0x1A08]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A08, -- ᨈ
 },
 [0x1A09]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A09, -- ᨉ
 },
 [0x1A0A]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A0A, -- ᨊ
 },
 [0x1A0B]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER NRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A0B, -- ᨋ
 },
 [0x1A0C]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A0C, -- ᨌ
 },
 [0x1A0D]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A0D, -- ᨍ
 },
 [0x1A0E]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A0E, -- ᨎ
 },
 [0x1A0F]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER NYCA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A0F, -- ᨏ
 },
 [0x1A10]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A10, -- ᨐ
 },
 [0x1A11]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A11, -- ᨑ
 },
 [0x1A12]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A12, -- ᨒ
 },
 [0x1A13]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A13, -- ᨓ
 },
 [0x1A14]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A14, -- ᨔ
 },
 [0x1A15]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A15, -- ᨕ
 },
 [0x1A16]={
  ["category"]="lo",
  ["description"]="BUGINESE LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A16, -- ᨖ
 },
 [0x1A17]={
  ["category"]="mn",
  ["description"]="BUGINESE VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1A17, -- ᨗ
 },
 [0x1A18]={
  ["category"]="mn",
  ["description"]="BUGINESE VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1A18, -- ᨘ
 },
 [0x1A19]={
  ["category"]="mc",
  ["description"]="BUGINESE VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1A19, -- ᨙ
 },
 [0x1A1A]={
  ["category"]="mc",
  ["description"]="BUGINESE VOWEL SIGN O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1A1A, -- ᨚ
 },
 [0x1A1B]={
  ["category"]="mc",
  ["description"]="BUGINESE VOWEL SIGN AE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1A1B, -- ᨛ
 },
 [0x1A1E]={
  ["category"]="po",
  ["description"]="BUGINESE PALLAWA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1A1E, -- ᨞
 },
 [0x1A1F]={
  ["category"]="po",
  ["description"]="BUGINESE END OF SECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1A1F, -- ᨟
 },
 [0x1B00]={
  ["category"]="mn",
  ["description"]="BALINESE SIGN ULU RICEM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B00, -- ᬀ
 },
 [0x1B01]={
  ["category"]="mn",
  ["description"]="BALINESE SIGN ULU CANDRA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B01, -- ᬁ
 },
 [0x1B02]={
  ["category"]="mn",
  ["description"]="BALINESE SIGN CECEK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B02, -- ᬂ
 },
 [0x1B03]={
  ["category"]="mn",
  ["description"]="BALINESE SIGN SURANG",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B03, -- ᬃ
 },
 [0x1B04]={
  ["category"]="mc",
  ["description"]="BALINESE SIGN BISAH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B04, -- ᬄ
 },
 [0x1B05]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER AKARA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B05, -- ᬅ
 },
 [0x1B06]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER AKARA TEDUNG",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1B05, 0x1B35 },
  ["unicodeslot"]=0x1B06, -- ᬆ
 },
 [0x1B07]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER IKARA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B07, -- ᬇ
 },
 [0x1B08]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER IKARA TEDUNG",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1B07, 0x1B35 },
  ["unicodeslot"]=0x1B08, -- ᬈ
 },
 [0x1B09]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER UKARA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B09, -- ᬉ
 },
 [0x1B0A]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER UKARA TEDUNG",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1B09, 0x1B35 },
  ["unicodeslot"]=0x1B0A, -- ᬊ
 },
 [0x1B0B]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER RA REPA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B0B, -- ᬋ
 },
 [0x1B0C]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER RA REPA TEDUNG",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1B0B, 0x1B35 },
  ["unicodeslot"]=0x1B0C, -- ᬌ
 },
 [0x1B0D]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER LA LENGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B0D, -- ᬍ
 },
 [0x1B0E]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER LA LENGA TEDUNG",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1B0D, 0x1B35 },
  ["unicodeslot"]=0x1B0E, -- ᬎ
 },
 [0x1B0F]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER EKARA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B0F, -- ᬏ
 },
 [0x1B10]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER AIKARA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B10, -- ᬐ
 },
 [0x1B11]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER OKARA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B11, -- ᬑ
 },
 [0x1B12]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER OKARA TEDUNG",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1B11, 0x1B35 },
  ["unicodeslot"]=0x1B12, -- ᬒ
 },
 [0x1B13]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B13, -- ᬓ
 },
 [0x1B14]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER KA MAHAPRANA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B14, -- ᬔ
 },
 [0x1B15]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B15, -- ᬕ
 },
 [0x1B16]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER GA GORA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B16, -- ᬖ
 },
 [0x1B17]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B17, -- ᬗ
 },
 [0x1B18]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B18, -- ᬘ
 },
 [0x1B19]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER CA LACA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B19, -- ᬙ
 },
 [0x1B1A]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B1A, -- ᬚ
 },
 [0x1B1B]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER JA JERA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B1B, -- ᬛ
 },
 [0x1B1C]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B1C, -- ᬜ
 },
 [0x1B1D]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER TA LATIK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B1D, -- ᬝ
 },
 [0x1B1E]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER TA MURDA MAHAPRANA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B1E, -- ᬞ
 },
 [0x1B1F]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER DA MURDA ALPAPRANA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B1F, -- ᬟ
 },
 [0x1B20]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER DA MURDA MAHAPRANA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B20, -- ᬠ
 },
 [0x1B21]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER NA RAMBAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B21, -- ᬡ
 },
 [0x1B22]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B22, -- ᬢ
 },
 [0x1B23]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER TA TAWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B23, -- ᬣ
 },
 [0x1B24]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B24, -- ᬤ
 },
 [0x1B25]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER DA MADU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B25, -- ᬥ
 },
 [0x1B26]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B26, -- ᬦ
 },
 [0x1B27]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B27, -- ᬧ
 },
 [0x1B28]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER PA KAPAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B28, -- ᬨ
 },
 [0x1B29]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B29, -- ᬩ
 },
 [0x1B2A]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER BA KEMBANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B2A, -- ᬪ
 },
 [0x1B2B]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B2B, -- ᬫ
 },
 [0x1B2C]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B2C, -- ᬬ
 },
 [0x1B2D]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B2D, -- ᬭ
 },
 [0x1B2E]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B2E, -- ᬮ
 },
 [0x1B2F]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B2F, -- ᬯ
 },
 [0x1B30]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER SA SAGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B30, -- ᬰ
 },
 [0x1B31]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER SA SAPA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B31, -- ᬱ
 },
 [0x1B32]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B32, -- ᬲ
 },
 [0x1B33]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B33, -- ᬳ
 },
 [0x1B34]={
  ["category"]="mn",
  ["description"]="BALINESE SIGN REREKAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B34, -- ᬴
 },
 [0x1B35]={
  ["category"]="mc",
  ["description"]="BALINESE VOWEL SIGN TEDUNG",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B35, -- ᬵ
 },
 [0x1B36]={
  ["category"]="mn",
  ["description"]="BALINESE VOWEL SIGN ULU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B36, -- ᬶ
 },
 [0x1B37]={
  ["category"]="mn",
  ["description"]="BALINESE VOWEL SIGN ULU SARI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B37, -- ᬷ
 },
 [0x1B38]={
  ["category"]="mn",
  ["description"]="BALINESE VOWEL SIGN SUKU",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B38, -- ᬸ
 },
 [0x1B39]={
  ["category"]="mn",
  ["description"]="BALINESE VOWEL SIGN SUKU ILUT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B39, -- ᬹ
 },
 [0x1B3A]={
  ["category"]="mn",
  ["description"]="BALINESE VOWEL SIGN RA REPA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B3A, -- ᬺ
 },
 [0x1B3B]={
  ["category"]="mc",
  ["description"]="BALINESE VOWEL SIGN RA REPA TEDUNG",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x1B3A, 0x1B35 },
  ["unicodeslot"]=0x1B3B, -- ᬻ
 },
 [0x1B3C]={
  ["category"]="mn",
  ["description"]="BALINESE VOWEL SIGN LA LENGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B3C, -- ᬼ
 },
 [0x1B3D]={
  ["category"]="mc",
  ["description"]="BALINESE VOWEL SIGN LA LENGA TEDUNG",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x1B3C, 0x1B35 },
  ["unicodeslot"]=0x1B3D, -- ᬽ
 },
 [0x1B3E]={
  ["category"]="mc",
  ["description"]="BALINESE VOWEL SIGN TALING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B3E, -- ᬾ
 },
 [0x1B3F]={
  ["category"]="mc",
  ["description"]="BALINESE VOWEL SIGN TALING REPA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B3F, -- ᬿ
 },
 [0x1B40]={
  ["category"]="mc",
  ["description"]="BALINESE VOWEL SIGN TALING TEDUNG",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x1B3E, 0x1B35 },
  ["unicodeslot"]=0x1B40, -- ᭀ
 },
 [0x1B41]={
  ["category"]="mc",
  ["description"]="BALINESE VOWEL SIGN TALING REPA TEDUNG",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x1B3F, 0x1B35 },
  ["unicodeslot"]=0x1B41, -- ᭁ
 },
 [0x1B42]={
  ["category"]="mn",
  ["description"]="BALINESE VOWEL SIGN PEPET",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B42, -- ᭂ
 },
 [0x1B43]={
  ["category"]="mc",
  ["description"]="BALINESE VOWEL SIGN PEPET TEDUNG",
  ["linebreak"]="cm",
  ["specials"]={ "char", 0x1B42, 0x1B35 },
  ["unicodeslot"]=0x1B43, -- ᭃ
 },
 [0x1B44]={
  ["category"]="mc",
  ["description"]="BALINESE ADEG ADEG",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B44, -- ᭄
 },
 [0x1B45]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER KAF SASAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B45, -- ᭅ
 },
 [0x1B46]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER KHOT SASAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B46, -- ᭆ
 },
 [0x1B47]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER TZIR SASAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B47, -- ᭇ
 },
 [0x1B48]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER EF SASAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B48, -- ᭈ
 },
 [0x1B49]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER VE SASAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B49, -- ᭉ
 },
 [0x1B4A]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER ZAL SASAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B4A, -- ᭊ
 },
 [0x1B4B]={
  ["category"]="lo",
  ["description"]="BALINESE LETTER ASYURA SASAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B4B, -- ᭋ
 },
 [0x1B50]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B50, -- ᭐
 },
 [0x1B51]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B51, -- ᭑
 },
 [0x1B52]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B52, -- ᭒
 },
 [0x1B53]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B53, -- ᭓
 },
 [0x1B54]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B54, -- ᭔
 },
 [0x1B55]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B55, -- ᭕
 },
 [0x1B56]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B56, -- ᭖
 },
 [0x1B57]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B57, -- ᭗
 },
 [0x1B58]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B58, -- ᭘
 },
 [0x1B59]={
  ["category"]="nd",
  ["description"]="BALINESE DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x1B59, -- ᭙
 },
 [0x1B5A]={
  ["category"]="po",
  ["description"]="BALINESE PANTI",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1B5A, -- ᭚
 },
 [0x1B5B]={
  ["category"]="po",
  ["description"]="BALINESE PAMADA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1B5B, -- ᭛
 },
 [0x1B5C]={
  ["category"]="po",
  ["description"]="BALINESE WINDU",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1B5C, -- ᭜
 },
 [0x1B5D]={
  ["category"]="po",
  ["description"]="BALINESE CARIK PAMUNGKAH",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1B5D, -- ᭝
 },
 [0x1B5E]={
  ["category"]="po",
  ["description"]="BALINESE CARIK SIKI",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1B5E, -- ᭞
 },
 [0x1B5F]={
  ["category"]="po",
  ["description"]="BALINESE CARIK PAREREN",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1B5F, -- ᭟
 },
 [0x1B60]={
  ["category"]="po",
  ["description"]="BALINESE PAMENENG",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1B60, -- ᭠
 },
 [0x1B61]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DONG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B61, -- ᭡
 },
 [0x1B62]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DENG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B62, -- ᭢
 },
 [0x1B63]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DUNG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B63, -- ᭣
 },
 [0x1B64]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B64, -- ᭤
 },
 [0x1B65]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DANG SURANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B65, -- ᭥
 },
 [0x1B66]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B66, -- ᭦
 },
 [0x1B67]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DAENG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B67, -- ᭧
 },
 [0x1B68]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DEUNG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B68, -- ᭨
 },
 [0x1B69]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DAING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B69, -- ᭩
 },
 [0x1B6A]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL DANG GEDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B6A, -- ᭪
 },
 [0x1B6B]={
  ["category"]="mn",
  ["description"]="BALINESE MUSICAL SYMBOL COMBINING TEGEH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B6B, -- ᭫
 },
 [0x1B6C]={
  ["category"]="mn",
  ["description"]="BALINESE MUSICAL SYMBOL COMBINING ENDEP",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B6C, -- ᭬
 },
 [0x1B6D]={
  ["category"]="mn",
  ["description"]="BALINESE MUSICAL SYMBOL COMBINING KEMPUL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B6D, -- ᭭
 },
 [0x1B6E]={
  ["category"]="mn",
  ["description"]="BALINESE MUSICAL SYMBOL COMBINING KEMPLI",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B6E, -- ᭮
 },
 [0x1B6F]={
  ["category"]="mn",
  ["description"]="BALINESE MUSICAL SYMBOL COMBINING JEGOGAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B6F, -- ᭯
 },
 [0x1B70]={
  ["category"]="mn",
  ["description"]="BALINESE MUSICAL SYMBOL COMBINING KEMPUL WITH JEGOGAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B70, -- ᭰
 },
 [0x1B71]={
  ["category"]="mn",
  ["description"]="BALINESE MUSICAL SYMBOL COMBINING KEMPLI WITH JEGOGAN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B71, -- ᭱
 },
 [0x1B72]={
  ["category"]="mn",
  ["description"]="BALINESE MUSICAL SYMBOL COMBINING BENDE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B72, -- ᭲
 },
 [0x1B73]={
  ["category"]="mn",
  ["description"]="BALINESE MUSICAL SYMBOL COMBINING GONG",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1B73, -- ᭳
 },
 [0x1B74]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DUG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B74, -- ᭴
 },
 [0x1B75]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B75, -- ᭵
 },
 [0x1B76]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TUK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B76, -- ᭶
 },
 [0x1B77]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B77, -- ᭷
 },
 [0x1B78]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B78, -- ᭸
 },
 [0x1B79]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PUNG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B79, -- ᭹
 },
 [0x1B7A]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B7A, -- ᭺
 },
 [0x1B7B]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLUK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B7B, -- ᭻
 },
 [0x1B7C]={
  ["category"]="so",
  ["description"]="BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1B7C, -- ᭼
 },
 [0x1D00]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D00, -- ᴀ
 },
 [0x1D01]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL AE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D01, -- ᴁ
 },
 [0x1D02]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED AE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D02, -- ᴂ
 },
 [0x1D03]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL BARRED B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D03, -- ᴃ
 },
 [0x1D04]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D04, -- ᴄ
 },
 [0x1D05]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D05, -- ᴅ
 },
 [0x1D06]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL ETH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D06, -- ᴆ
 },
 [0x1D07]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D07, -- ᴇ
 },
 [0x1D08]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED OPEN E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D08, -- ᴈ
 },
 [0x1D09]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D09, -- ᴉ
 },
 [0x1D0A]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL J",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A, -- ᴊ
 },
 [0x1D0B]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL K",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B, -- ᴋ
 },
 [0x1D0C]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL L WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C, -- ᴌ
 },
 [0x1D0D]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL M",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D, -- ᴍ
 },
 [0x1D0E]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL REVERSED N",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E, -- ᴎ
 },
 [0x1D0F]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0F, -- ᴏ
 },
 [0x1D10]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL OPEN O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D10, -- ᴐ
 },
 [0x1D11]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER SIDEWAYS O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D11, -- ᴑ
 },
 [0x1D12]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER SIDEWAYS OPEN O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D12, -- ᴒ
 },
 [0x1D13]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER SIDEWAYS O WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D13, -- ᴓ
 },
 [0x1D14]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED OE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D14, -- ᴔ
 },
 [0x1D15]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL OU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D15, -- ᴕ
 },
 [0x1D16]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TOP HALF O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D16, -- ᴖ
 },
 [0x1D17]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER BOTTOM HALF O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D17, -- ᴗ
 },
 [0x1D18]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL P",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D18, -- ᴘ
 },
 [0x1D19]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL REVERSED R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D19, -- ᴙ
 },
 [0x1D1A]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL TURNED R",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A, -- ᴚ
 },
 [0x1D1B]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL T",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B, -- ᴛ
 },
 [0x1D1C]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C, -- ᴜ
 },
 [0x1D1D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER SIDEWAYS U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D, -- ᴝ
 },
 [0x1D1E]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER SIDEWAYS DIAERESIZED U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1E, -- ᴞ
 },
 [0x1D1F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER SIDEWAYS TURNED M",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1F, -- ᴟ
 },
 [0x1D20]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL V",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D20, -- ᴠ
 },
 [0x1D21]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL W",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D21, -- ᴡ
 },
 [0x1D22]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL Z",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D22, -- ᴢ
 },
 [0x1D23]={
  ["category"]="ll",
  ["description"]="LATIN LETTER SMALL CAPITAL EZH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D23, -- ᴣ
 },
 [0x1D24]={
  ["category"]="ll",
  ["description"]="LATIN LETTER VOICED LARYNGEAL SPIRANT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D24, -- ᴤ
 },
 [0x1D25]={
  ["category"]="ll",
  ["description"]="LATIN LETTER AIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D25, -- ᴥ
 },
 [0x1D26]={
  ["category"]="ll",
  ["description"]="GREEK LETTER SMALL CAPITAL GAMMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D26, -- ᴦ
 },
 [0x1D27]={
  ["category"]="ll",
  ["description"]="GREEK LETTER SMALL CAPITAL LAMDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D27, -- ᴧ
 },
 [0x1D28]={
  ["category"]="ll",
  ["description"]="GREEK LETTER SMALL CAPITAL PI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D28, -- ᴨ
 },
 [0x1D29]={
  ["category"]="ll",
  ["description"]="GREEK LETTER SMALL CAPITAL RHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D29, -- ᴩ
 },
 [0x1D2A]={
  ["category"]="ll",
  ["description"]="GREEK LETTER SMALL CAPITAL PSI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D2A, -- ᴪ
 },
 [0x1D2B]={
  ["category"]="ll",
  ["description"]="CYRILLIC LETTER SMALL CAPITAL EL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D2B, -- ᴫ
 },
 [0x1D2C]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0041 },
  ["unicodeslot"]=0x1D2C, -- ᴬ
 },
 [0x1D2D]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL AE",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x00C6 },
  ["unicodeslot"]=0x1D2D, -- ᴭ
 },
 [0x1D2E]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0042 },
  ["unicodeslot"]=0x1D2E, -- ᴮ
 },
 [0x1D2F]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL BARRED B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D2F, -- ᴯ
 },
 [0x1D30]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0044 },
  ["unicodeslot"]=0x1D30, -- ᴰ
 },
 [0x1D31]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0045 },
  ["unicodeslot"]=0x1D31, -- ᴱ
 },
 [0x1D32]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL REVERSED E",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x018E },
  ["unicodeslot"]=0x1D32, -- ᴲ
 },
 [0x1D33]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0047 },
  ["unicodeslot"]=0x1D33, -- ᴳ
 },
 [0x1D34]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0048 },
  ["unicodeslot"]=0x1D34, -- ᴴ
 },
 [0x1D35]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0049 },
  ["unicodeslot"]=0x1D35, -- ᴵ
 },
 [0x1D36]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x004A },
  ["unicodeslot"]=0x1D36, -- ᴶ
 },
 [0x1D37]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x004B },
  ["unicodeslot"]=0x1D37, -- ᴷ
 },
 [0x1D38]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x004C },
  ["unicodeslot"]=0x1D38, -- ᴸ
 },
 [0x1D39]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x004D },
  ["unicodeslot"]=0x1D39, -- ᴹ
 },
 [0x1D3A]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x004E },
  ["unicodeslot"]=0x1D3A, -- ᴺ
 },
 [0x1D3B]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL REVERSED N",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D3B, -- ᴻ
 },
 [0x1D3C]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x004F },
  ["unicodeslot"]=0x1D3C, -- ᴼ
 },
 [0x1D3D]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL OU",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0222 },
  ["unicodeslot"]=0x1D3D, -- ᴽ
 },
 [0x1D3E]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0050 },
  ["unicodeslot"]=0x1D3E, -- ᴾ
 },
 [0x1D3F]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0052 },
  ["unicodeslot"]=0x1D3F, -- ᴿ
 },
 [0x1D40]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0054 },
  ["unicodeslot"]=0x1D40, -- ᵀ
 },
 [0x1D41]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0055 },
  ["unicodeslot"]=0x1D41, -- ᵁ
 },
 [0x1D42]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0057 },
  ["unicodeslot"]=0x1D42, -- ᵂ
 },
 [0x1D43]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0061 },
  ["unicodeslot"]=0x1D43, -- ᵃ
 },
 [0x1D44]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED A",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0250 },
  ["unicodeslot"]=0x1D44, -- ᵄ
 },
 [0x1D45]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0251 },
  ["unicodeslot"]=0x1D45, -- ᵅ
 },
 [0x1D46]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED AE",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x1D02 },
  ["unicodeslot"]=0x1D46, -- ᵆ
 },
 [0x1D47]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0062 },
  ["unicodeslot"]=0x1D47, -- ᵇ
 },
 [0x1D48]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0064 },
  ["unicodeslot"]=0x1D48, -- ᵈ
 },
 [0x1D49]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0065 },
  ["unicodeslot"]=0x1D49, -- ᵉ
 },
 [0x1D4A]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL SCHWA",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0259 },
  ["unicodeslot"]=0x1D4A, -- ᵊ
 },
 [0x1D4B]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL OPEN E",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x025B },
  ["unicodeslot"]=0x1D4B, -- ᵋ
 },
 [0x1D4C]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED OPEN E",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x025C },
  ["unicodeslot"]=0x1D4C, -- ᵌ
 },
 [0x1D4D]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0067 },
  ["unicodeslot"]=0x1D4D, -- ᵍ
 },
 [0x1D4E]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D4E, -- ᵎ
 },
 [0x1D4F]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x006B },
  ["unicodeslot"]=0x1D4F, -- ᵏ
 },
 [0x1D50]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x006D },
  ["unicodeslot"]=0x1D50, -- ᵐ
 },
 [0x1D51]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL ENG",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x014B },
  ["unicodeslot"]=0x1D51, -- ᵑ
 },
 [0x1D52]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x006F },
  ["unicodeslot"]=0x1D52, -- ᵒ
 },
 [0x1D53]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL OPEN O",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0254 },
  ["unicodeslot"]=0x1D53, -- ᵓ
 },
 [0x1D54]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TOP HALF O",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x1D16 },
  ["unicodeslot"]=0x1D54, -- ᵔ
 },
 [0x1D55]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL BOTTOM HALF O",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x1D17 },
  ["unicodeslot"]=0x1D55, -- ᵕ
 },
 [0x1D56]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0070 },
  ["unicodeslot"]=0x1D56, -- ᵖ
 },
 [0x1D57]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0074 },
  ["unicodeslot"]=0x1D57, -- ᵗ
 },
 [0x1D58]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0075 },
  ["unicodeslot"]=0x1D58, -- ᵘ
 },
 [0x1D59]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL SIDEWAYS U",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x1D1D },
  ["unicodeslot"]=0x1D59, -- ᵙ
 },
 [0x1D5A]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED M",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x026F },
  ["unicodeslot"]=0x1D5A, -- ᵚ
 },
 [0x1D5B]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0076 },
  ["unicodeslot"]=0x1D5B, -- ᵛ
 },
 [0x1D5C]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL AIN",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x1D25 },
  ["unicodeslot"]=0x1D5C, -- ᵜ
 },
 [0x1D5D]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL BETA",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x03B2 },
  ["unicodeslot"]=0x1D5D, -- ᵝ
 },
 [0x1D5E]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL GREEK GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x03B3 },
  ["unicodeslot"]=0x1D5E, -- ᵞ
 },
 [0x1D5F]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x03B4 },
  ["unicodeslot"]=0x1D5F, -- ᵟ
 },
 [0x1D60]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL GREEK PHI",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x03C6 },
  ["unicodeslot"]=0x1D60, -- ᵠ
 },
 [0x1D61]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL CHI",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x03C7 },
  ["unicodeslot"]=0x1D61, -- ᵡ
 },
 [0x1D62]={
  ["category"]="ll",
  ["description"]="LATIN SUBSCRIPT SMALL LETTER I",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0069 },
  ["unicodeslot"]=0x1D62, -- ᵢ
 },
 [0x1D63]={
  ["category"]="ll",
  ["description"]="LATIN SUBSCRIPT SMALL LETTER R",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0072 },
  ["unicodeslot"]=0x1D63, -- ᵣ
 },
 [0x1D64]={
  ["category"]="ll",
  ["description"]="LATIN SUBSCRIPT SMALL LETTER U",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0075 },
  ["unicodeslot"]=0x1D64, -- ᵤ
 },
 [0x1D65]={
  ["category"]="ll",
  ["description"]="LATIN SUBSCRIPT SMALL LETTER V",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0076 },
  ["unicodeslot"]=0x1D65, -- ᵥ
 },
 [0x1D66]={
  ["category"]="ll",
  ["description"]="GREEK SUBSCRIPT SMALL LETTER BETA",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x03B2 },
  ["unicodeslot"]=0x1D66, -- ᵦ
 },
 [0x1D67]={
  ["category"]="ll",
  ["description"]="GREEK SUBSCRIPT SMALL LETTER GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x03B3 },
  ["unicodeslot"]=0x1D67, -- ᵧ
 },
 [0x1D68]={
  ["category"]="ll",
  ["description"]="GREEK SUBSCRIPT SMALL LETTER RHO",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x03C1 },
  ["unicodeslot"]=0x1D68, -- ᵨ
 },
 [0x1D69]={
  ["category"]="ll",
  ["description"]="GREEK SUBSCRIPT SMALL LETTER PHI",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x03C6 },
  ["unicodeslot"]=0x1D69, -- ᵩ
 },
 [0x1D6A]={
  ["category"]="ll",
  ["description"]="GREEK SUBSCRIPT SMALL LETTER CHI",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x03C7 },
  ["unicodeslot"]=0x1D6A, -- ᵪ
 },
 [0x1D6B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER UE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D6B, -- ᵫ
 },
 [0x1D6C]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER B WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0062,
  ["unicodeslot"]=0x1D6C, -- ᵬ
 },
 [0x1D6D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER D WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["unicodeslot"]=0x1D6D, -- ᵭ
 },
 [0x1D6E]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER F WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0066,
  ["unicodeslot"]=0x1D6E, -- ᵮ
 },
 [0x1D6F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER M WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x006D,
  ["unicodeslot"]=0x1D6F, -- ᵯ
 },
 [0x1D70]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER N WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["unicodeslot"]=0x1D70, -- ᵰ
 },
 [0x1D71]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER P WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0070,
  ["unicodeslot"]=0x1D71, -- ᵱ
 },
 [0x1D72]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["unicodeslot"]=0x1D72, -- ᵲ
 },
 [0x1D73]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH FISHHOOK AND MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["unicodeslot"]=0x1D73, -- ᵳ
 },
 [0x1D74]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER S WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["unicodeslot"]=0x1D74, -- ᵴ
 },
 [0x1D75]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER T WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["unicodeslot"]=0x1D75, -- ᵵ
 },
 [0x1D76]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Z WITH MIDDLE TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["unicodeslot"]=0x1D76, -- ᵶ
 },
 [0x1D77]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TURNED G",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D77, -- ᵷ
 },
 [0x1D78]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER CYRILLIC EN",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x043D },
  ["unicodeslot"]=0x1D78, -- ᵸ
 },
 [0x1D79]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER INSULAR G",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D79, -- ᵹ
 },
 [0x1D7A]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TH WITH STRIKETHROUGH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D7A, -- ᵺ
 },
 [0x1D7B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL CAPITAL LETTER I WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D7B, -- ᵻ
 },
 [0x1D7C]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER IOTA WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0269,
  ["unicodeslot"]=0x1D7C, -- ᵼ
 },
 [0x1D7D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER P WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0070,
  ["uccode"]=0x2C63,
  ["unicodeslot"]=0x1D7D, -- ᵽ
 },
 [0x1D7E]={
  ["category"]="ll",
  ["description"]="LATIN SMALL CAPITAL LETTER U WITH STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D7E, -- ᵾ
 },
 [0x1D7F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER UPSILON WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x028A,
  ["unicodeslot"]=0x1D7F, -- ᵿ
 },
 [0x1D80]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER B WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0062,
  ["unicodeslot"]=0x1D80, -- ᶀ
 },
 [0x1D81]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER D WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["unicodeslot"]=0x1D81, -- ᶁ
 },
 [0x1D82]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER F WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0066,
  ["unicodeslot"]=0x1D82, -- ᶂ
 },
 [0x1D83]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER G WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["unicodeslot"]=0x1D83, -- ᶃ
 },
 [0x1D84]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER K WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x006B,
  ["unicodeslot"]=0x1D84, -- ᶄ
 },
 [0x1D85]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER L WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["unicodeslot"]=0x1D85, -- ᶅ
 },
 [0x1D86]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER M WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x006D,
  ["unicodeslot"]=0x1D86, -- ᶆ
 },
 [0x1D87]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER N WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["unicodeslot"]=0x1D87, -- ᶇ
 },
 [0x1D88]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER P WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0070,
  ["unicodeslot"]=0x1D88, -- ᶈ
 },
 [0x1D89]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["unicodeslot"]=0x1D89, -- ᶉ
 },
 [0x1D8A]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER S WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["unicodeslot"]=0x1D8A, -- ᶊ
 },
 [0x1D8B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER ESH WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0283,
  ["unicodeslot"]=0x1D8B, -- ᶋ
 },
 [0x1D8C]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER V WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0076,
  ["unicodeslot"]=0x1D8C, -- ᶌ
 },
 [0x1D8D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER X WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0078,
  ["unicodeslot"]=0x1D8D, -- ᶍ
 },
 [0x1D8E]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Z WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["unicodeslot"]=0x1D8E, -- ᶎ
 },
 [0x1D8F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER A WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["unicodeslot"]=0x1D8F, -- ᶏ
 },
 [0x1D90]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER ALPHA WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0251,
  ["unicodeslot"]=0x1D90, -- ᶐ
 },
 [0x1D91]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER D WITH HOOK AND TAIL",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["unicodeslot"]=0x1D91, -- ᶑ
 },
 [0x1D92]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER E WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["unicodeslot"]=0x1D92, -- ᶒ
 },
 [0x1D93]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER OPEN E WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D93, -- ᶓ
 },
 [0x1D94]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER REVERSED OPEN E WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D94, -- ᶔ
 },
 [0x1D95]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER SCHWA WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0259,
  ["unicodeslot"]=0x1D95, -- ᶕ
 },
 [0x1D96]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER I WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["unicodeslot"]=0x1D96, -- ᶖ
 },
 [0x1D97]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER OPEN O WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D97, -- ᶗ
 },
 [0x1D98]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER ESH WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0283,
  ["unicodeslot"]=0x1D98, -- ᶘ
 },
 [0x1D99]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER U WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["unicodeslot"]=0x1D99, -- ᶙ
 },
 [0x1D9A]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER EZH WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["shcode"]=0x0292,
  ["unicodeslot"]=0x1D9A, -- ᶚ
 },
 [0x1D9B]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0252 },
  ["unicodeslot"]=0x1D9B, -- ᶛ
 },
 [0x1D9C]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0063 },
  ["unicodeslot"]=0x1D9C, -- ᶜ
 },
 [0x1D9D]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL C WITH CURL",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0255 },
  ["unicodeslot"]=0x1D9D, -- ᶝ
 },
 [0x1D9E]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL ETH",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x00F0 },
  ["unicodeslot"]=0x1D9E, -- ᶞ
 },
 [0x1D9F]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL REVERSED OPEN E",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x025C },
  ["unicodeslot"]=0x1D9F, -- ᶟ
 },
 [0x1DA0]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0066 },
  ["unicodeslot"]=0x1DA0, -- ᶠ
 },
 [0x1DA1]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL DOTLESS J WITH STROKE",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x025F },
  ["unicodeslot"]=0x1DA1, -- ᶡ
 },
 [0x1DA2]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL SCRIPT G",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0261 },
  ["unicodeslot"]=0x1DA2, -- ᶢ
 },
 [0x1DA3]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED H",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0265 },
  ["unicodeslot"]=0x1DA3, -- ᶣ
 },
 [0x1DA4]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL I WITH STROKE",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0268 },
  ["unicodeslot"]=0x1DA4, -- ᶤ
 },
 [0x1DA5]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0269 },
  ["unicodeslot"]=0x1DA5, -- ᶥ
 },
 [0x1DA6]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x026A },
  ["unicodeslot"]=0x1DA6, -- ᶦ
 },
 [0x1DA7]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL CAPITAL I WITH STROKE",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x1D7B },
  ["unicodeslot"]=0x1DA7, -- ᶧ
 },
 [0x1DA8]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL J WITH CROSSED-TAIL",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x029D },
  ["unicodeslot"]=0x1DA8, -- ᶨ
 },
 [0x1DA9]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL L WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x026D },
  ["unicodeslot"]=0x1DA9, -- ᶩ
 },
 [0x1DAA]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL L WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x1D85 },
  ["unicodeslot"]=0x1DAA, -- ᶪ
 },
 [0x1DAB]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x029F },
  ["unicodeslot"]=0x1DAB, -- ᶫ
 },
 [0x1DAC]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL M WITH HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0271 },
  ["unicodeslot"]=0x1DAC, -- ᶬ
 },
 [0x1DAD]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED M WITH LONG LEG",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0270 },
  ["unicodeslot"]=0x1DAD, -- ᶭ
 },
 [0x1DAE]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL N WITH LEFT HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0272 },
  ["unicodeslot"]=0x1DAE, -- ᶮ
 },
 [0x1DAF]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL N WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0273 },
  ["unicodeslot"]=0x1DAF, -- ᶯ
 },
 [0x1DB0]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0274 },
  ["unicodeslot"]=0x1DB0, -- ᶰ
 },
 [0x1DB1]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL BARRED O",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0275 },
  ["unicodeslot"]=0x1DB1, -- ᶱ
 },
 [0x1DB2]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL PHI",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0278 },
  ["unicodeslot"]=0x1DB2, -- ᶲ
 },
 [0x1DB3]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL S WITH HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0282 },
  ["unicodeslot"]=0x1DB3, -- ᶳ
 },
 [0x1DB4]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL ESH",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0283 },
  ["unicodeslot"]=0x1DB4, -- ᶴ
 },
 [0x1DB5]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL T WITH PALATAL HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x01AB },
  ["unicodeslot"]=0x1DB5, -- ᶵ
 },
 [0x1DB6]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL U BAR",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0289 },
  ["unicodeslot"]=0x1DB6, -- ᶶ
 },
 [0x1DB7]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x028A },
  ["unicodeslot"]=0x1DB7, -- ᶷ
 },
 [0x1DB8]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x1D1C },
  ["unicodeslot"]=0x1DB8, -- ᶸ
 },
 [0x1DB9]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL V WITH HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x028B },
  ["unicodeslot"]=0x1DB9, -- ᶹ
 },
 [0x1DBA]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL TURNED V",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x028C },
  ["unicodeslot"]=0x1DBA, -- ᶺ
 },
 [0x1DBB]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x007A },
  ["unicodeslot"]=0x1DBB, -- ᶻ
 },
 [0x1DBC]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL Z WITH RETROFLEX HOOK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0290 },
  ["unicodeslot"]=0x1DBC, -- ᶼ
 },
 [0x1DBD]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL Z WITH CURL",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0291 },
  ["unicodeslot"]=0x1DBD, -- ᶽ
 },
 [0x1DBE]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL EZH",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0292 },
  ["unicodeslot"]=0x1DBE, -- ᶾ
 },
 [0x1DBF]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER SMALL THETA",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x03B8 },
  ["unicodeslot"]=0x1DBF, -- ᶿ
 },
 [0x1DC0]={
  ["category"]="mn",
  ["description"]="COMBINING DOTTED GRAVE ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC0, -- ᷀
 },
 [0x1DC1]={
  ["category"]="mn",
  ["description"]="COMBINING DOTTED ACUTE ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC1, -- ᷁
 },
 [0x1DC2]={
  ["category"]="mn",
  ["description"]="COMBINING SNAKE BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC2, -- ᷂
 },
 [0x1DC3]={
  ["category"]="mn",
  ["description"]="COMBINING SUSPENSION MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC3, -- ᷃
 },
 [0x1DC4]={
  ["category"]="mn",
  ["description"]="COMBINING MACRON-ACUTE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC4, -- ᷄
 },
 [0x1DC5]={
  ["category"]="mn",
  ["description"]="COMBINING GRAVE-MACRON",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC5, -- ᷅
 },
 [0x1DC6]={
  ["category"]="mn",
  ["description"]="COMBINING MACRON-GRAVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC6, -- ᷆
 },
 [0x1DC7]={
  ["category"]="mn",
  ["description"]="COMBINING ACUTE-MACRON",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC7, -- ᷇
 },
 [0x1DC8]={
  ["category"]="mn",
  ["description"]="COMBINING GRAVE-ACUTE-GRAVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC8, -- ᷈
 },
 [0x1DC9]={
  ["category"]="mn",
  ["description"]="COMBINING ACUTE-GRAVE-ACUTE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DC9, -- ᷉
 },
 [0x1DCA]={
  ["category"]="mn",
  ["description"]="COMBINING LATIN SMALL LETTER R BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DCA, -- ᷊
 },
 [0x1DFE]={
  ["category"]="mn",
  ["description"]="COMBINING LEFT ARROWHEAD ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DFE, -- ᷾
 },
 [0x1DFF]={
  ["category"]="mn",
  ["description"]="COMBINING RIGHT ARROWHEAD AND DOWN ARROWHEAD BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1DFF, -- ᷿
 },
 [0x1E00]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER A WITH RING BELOW",
  ["lccode"]=0x1E01,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0325 },
  ["unicodeslot"]=0x1E00, -- Ḁ
 },
 [0x1E01]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER A WITH RING BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0325 },
  ["uccode"]=0x1E00,
  ["unicodeslot"]=0x1E01, -- ḁ
 },
 [0x1E02]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER B WITH DOT ABOVE",
  ["lccode"]=0x1E03,
  ["linebreak"]="al",
  ["shcode"]=0x0042,
  ["specials"]={ "char", 0x0042, 0x0307 },
  ["unicodeslot"]=0x1E02, -- Ḃ
 },
 [0x1E03]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER B WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0062,
  ["specials"]={ "char", 0x0062, 0x0307 },
  ["uccode"]=0x1E02,
  ["unicodeslot"]=0x1E03, -- ḃ
 },
 [0x1E04]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER B WITH DOT BELOW",
  ["lccode"]=0x1E05,
  ["linebreak"]="al",
  ["shcode"]=0x0042,
  ["specials"]={ "char", 0x0042, 0x0323 },
  ["unicodeslot"]=0x1E04, -- Ḅ
 },
 [0x1E05]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER B WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0062,
  ["specials"]={ "char", 0x0062, 0x0323 },
  ["uccode"]=0x1E04,
  ["unicodeslot"]=0x1E05, -- ḅ
 },
 [0x1E06]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER B WITH LINE BELOW",
  ["lccode"]=0x1E07,
  ["linebreak"]="al",
  ["shcode"]=0x0042,
  ["specials"]={ "char", 0x0042, 0x0331 },
  ["unicodeslot"]=0x1E06, -- Ḇ
 },
 [0x1E07]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER B WITH LINE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0062,
  ["specials"]={ "char", 0x0062, 0x0331 },
  ["uccode"]=0x1E06,
  ["unicodeslot"]=0x1E07, -- ḇ
 },
 [0x1E08]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER C WITH CEDILLA AND ACUTE",
  ["lccode"]=0x1E09,
  ["linebreak"]="al",
  ["shcode"]=0x0043,
  ["specials"]={ "char", 0x00C7, 0x0301 },
  ["unicodeslot"]=0x1E08, -- Ḉ
 },
 [0x1E09]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER C WITH CEDILLA AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0063,
  ["specials"]={ "char", 0x00E7, 0x0301 },
  ["uccode"]=0x1E08,
  ["unicodeslot"]=0x1E09, -- ḉ
 },
 [0x1E0A]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER D WITH DOT ABOVE",
  ["lccode"]=0x1E0B,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["specials"]={ "char", 0x0044, 0x0307 },
  ["unicodeslot"]=0x1E0A, -- Ḋ
 },
 [0x1E0B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER D WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["specials"]={ "char", 0x0064, 0x0307 },
  ["uccode"]=0x1E0A,
  ["unicodeslot"]=0x1E0B, -- ḋ
 },
 [0x1E0C]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER D WITH DOT BELOW",
  ["lccode"]=0x1E0D,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["specials"]={ "char", 0x0044, 0x0323 },
  ["unicodeslot"]=0x1E0C, -- Ḍ
 },
 [0x1E0D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER D WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["specials"]={ "char", 0x0064, 0x0323 },
  ["uccode"]=0x1E0C,
  ["unicodeslot"]=0x1E0D, -- ḍ
 },
 [0x1E0E]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER D WITH LINE BELOW",
  ["lccode"]=0x1E0F,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["specials"]={ "char", 0x0044, 0x0331 },
  ["unicodeslot"]=0x1E0E, -- Ḏ
 },
 [0x1E0F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER D WITH LINE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["specials"]={ "char", 0x0064, 0x0331 },
  ["uccode"]=0x1E0E,
  ["unicodeslot"]=0x1E0F, -- ḏ
 },
 [0x1E10]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER D WITH CEDILLA",
  ["lccode"]=0x1E11,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["specials"]={ "char", 0x0044, 0x0327 },
  ["unicodeslot"]=0x1E10, -- Ḑ
 },
 [0x1E11]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER D WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["specials"]={ "char", 0x0064, 0x0327 },
  ["uccode"]=0x1E10,
  ["unicodeslot"]=0x1E11, -- ḑ
 },
 [0x1E12]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER D WITH CIRCUMFLEX BELOW",
  ["lccode"]=0x1E13,
  ["linebreak"]="al",
  ["shcode"]=0x0044,
  ["specials"]={ "char", 0x0044, 0x032D },
  ["unicodeslot"]=0x1E12, -- Ḓ
 },
 [0x1E13]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER D WITH CIRCUMFLEX BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0064,
  ["specials"]={ "char", 0x0064, 0x032D },
  ["uccode"]=0x1E12,
  ["unicodeslot"]=0x1E13, -- ḓ
 },
 [0x1E14]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER E WITH MACRON AND GRAVE",
  ["lccode"]=0x1E15,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0112, 0x0300 },
  ["unicodeslot"]=0x1E14, -- Ḕ
 },
 [0x1E15]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER E WITH MACRON AND GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0113, 0x0300 },
  ["uccode"]=0x1E14,
  ["unicodeslot"]=0x1E15, -- ḕ
 },
 [0x1E16]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER E WITH MACRON AND ACUTE",
  ["lccode"]=0x1E17,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0112, 0x0301 },
  ["unicodeslot"]=0x1E16, -- Ḗ
 },
 [0x1E17]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER E WITH MACRON AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0113, 0x0301 },
  ["uccode"]=0x1E16,
  ["unicodeslot"]=0x1E17, -- ḗ
 },
 [0x1E18]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER E WITH CIRCUMFLEX BELOW",
  ["lccode"]=0x1E19,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x032D },
  ["unicodeslot"]=0x1E18, -- Ḙ
 },
 [0x1E19]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER E WITH CIRCUMFLEX BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x032D },
  ["uccode"]=0x1E18,
  ["unicodeslot"]=0x1E19, -- ḙ
 },
 [0x1E1A]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER E WITH TILDE BELOW",
  ["lccode"]=0x1E1B,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0330 },
  ["unicodeslot"]=0x1E1A, -- Ḛ
 },
 [0x1E1B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER E WITH TILDE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0330 },
  ["uccode"]=0x1E1A,
  ["unicodeslot"]=0x1E1B, -- ḛ
 },
 [0x1E1C]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER E WITH CEDILLA AND BREVE",
  ["lccode"]=0x1E1D,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0228, 0x0306 },
  ["unicodeslot"]=0x1E1C, -- Ḝ
 },
 [0x1E1D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER E WITH CEDILLA AND BREVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0229, 0x0306 },
  ["uccode"]=0x1E1C,
  ["unicodeslot"]=0x1E1D, -- ḝ
 },
 [0x1E1E]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER F WITH DOT ABOVE",
  ["lccode"]=0x1E1F,
  ["linebreak"]="al",
  ["shcode"]=0x0046,
  ["specials"]={ "char", 0x0046, 0x0307 },
  ["unicodeslot"]=0x1E1E, -- Ḟ
 },
 [0x1E1F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER F WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0066,
  ["specials"]={ "char", 0x0066, 0x0307 },
  ["uccode"]=0x1E1E,
  ["unicodeslot"]=0x1E1F, -- ḟ
 },
 [0x1E20]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER G WITH MACRON",
  ["lccode"]=0x1E21,
  ["linebreak"]="al",
  ["shcode"]=0x0047,
  ["specials"]={ "char", 0x0047, 0x0304 },
  ["unicodeslot"]=0x1E20, -- Ḡ
 },
 [0x1E21]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER G WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0067,
  ["specials"]={ "char", 0x0067, 0x0304 },
  ["uccode"]=0x1E20,
  ["unicodeslot"]=0x1E21, -- ḡ
 },
 [0x1E22]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER H WITH DOT ABOVE",
  ["lccode"]=0x1E23,
  ["linebreak"]="al",
  ["shcode"]=0x0048,
  ["specials"]={ "char", 0x0048, 0x0307 },
  ["unicodeslot"]=0x1E22, -- Ḣ
 },
 [0x1E23]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER H WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["specials"]={ "char", 0x0068, 0x0307 },
  ["uccode"]=0x1E22,
  ["unicodeslot"]=0x1E23, -- ḣ
 },
 [0x1E24]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER H WITH DOT BELOW",
  ["lccode"]=0x1E25,
  ["linebreak"]="al",
  ["shcode"]=0x0048,
  ["specials"]={ "char", 0x0048, 0x0323 },
  ["unicodeslot"]=0x1E24, -- Ḥ
 },
 [0x1E25]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER H WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["specials"]={ "char", 0x0068, 0x0323 },
  ["uccode"]=0x1E24,
  ["unicodeslot"]=0x1E25, -- ḥ
 },
 [0x1E26]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER H WITH DIAERESIS",
  ["lccode"]=0x1E27,
  ["linebreak"]="al",
  ["shcode"]=0x0048,
  ["specials"]={ "char", 0x0048, 0x0308 },
  ["unicodeslot"]=0x1E26, -- Ḧ
 },
 [0x1E27]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER H WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["specials"]={ "char", 0x0068, 0x0308 },
  ["uccode"]=0x1E26,
  ["unicodeslot"]=0x1E27, -- ḧ
 },
 [0x1E28]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER H WITH CEDILLA",
  ["lccode"]=0x1E29,
  ["linebreak"]="al",
  ["shcode"]=0x0048,
  ["specials"]={ "char", 0x0048, 0x0327 },
  ["unicodeslot"]=0x1E28, -- Ḩ
 },
 [0x1E29]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER H WITH CEDILLA",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["specials"]={ "char", 0x0068, 0x0327 },
  ["uccode"]=0x1E28,
  ["unicodeslot"]=0x1E29, -- ḩ
 },
 [0x1E2A]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER H WITH BREVE BELOW",
  ["lccode"]=0x1E2B,
  ["linebreak"]="al",
  ["shcode"]=0x0048,
  ["specials"]={ "char", 0x0048, 0x032E },
  ["unicodeslot"]=0x1E2A, -- Ḫ
 },
 [0x1E2B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER H WITH BREVE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["specials"]={ "char", 0x0068, 0x032E },
  ["uccode"]=0x1E2A,
  ["unicodeslot"]=0x1E2B, -- ḫ
 },
 [0x1E2C]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER I WITH TILDE BELOW",
  ["lccode"]=0x1E2D,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0330 },
  ["unicodeslot"]=0x1E2C, -- Ḭ
 },
 [0x1E2D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER I WITH TILDE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0330 },
  ["uccode"]=0x1E2C,
  ["unicodeslot"]=0x1E2D, -- ḭ
 },
 [0x1E2E]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER I WITH DIAERESIS AND ACUTE",
  ["lccode"]=0x1E2F,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x00CF, 0x0301 },
  ["unicodeslot"]=0x1E2E, -- Ḯ
 },
 [0x1E2F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER I WITH DIAERESIS AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x00EF, 0x0301 },
  ["uccode"]=0x1E2E,
  ["unicodeslot"]=0x1E2F, -- ḯ
 },
 [0x1E30]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER K WITH ACUTE",
  ["lccode"]=0x1E31,
  ["linebreak"]="al",
  ["shcode"]=0x004B,
  ["specials"]={ "char", 0x004B, 0x0301 },
  ["unicodeslot"]=0x1E30, -- Ḱ
 },
 [0x1E31]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER K WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006B,
  ["specials"]={ "char", 0x006B, 0x0301 },
  ["uccode"]=0x1E30,
  ["unicodeslot"]=0x1E31, -- ḱ
 },
 [0x1E32]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER K WITH DOT BELOW",
  ["lccode"]=0x1E33,
  ["linebreak"]="al",
  ["shcode"]=0x004B,
  ["specials"]={ "char", 0x004B, 0x0323 },
  ["unicodeslot"]=0x1E32, -- Ḳ
 },
 [0x1E33]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER K WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006B,
  ["specials"]={ "char", 0x006B, 0x0323 },
  ["uccode"]=0x1E32,
  ["unicodeslot"]=0x1E33, -- ḳ
 },
 [0x1E34]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER K WITH LINE BELOW",
  ["lccode"]=0x1E35,
  ["linebreak"]="al",
  ["shcode"]=0x004B,
  ["specials"]={ "char", 0x004B, 0x0331 },
  ["unicodeslot"]=0x1E34, -- Ḵ
 },
 [0x1E35]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER K WITH LINE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006B,
  ["specials"]={ "char", 0x006B, 0x0331 },
  ["uccode"]=0x1E34,
  ["unicodeslot"]=0x1E35, -- ḵ
 },
 [0x1E36]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER L WITH DOT BELOW",
  ["lccode"]=0x1E37,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["specials"]={ "char", 0x004C, 0x0323 },
  ["unicodeslot"]=0x1E36, -- Ḷ
 },
 [0x1E37]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER L WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["specials"]={ "char", 0x006C, 0x0323 },
  ["uccode"]=0x1E36,
  ["unicodeslot"]=0x1E37, -- ḷ
 },
 [0x1E38]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER L WITH DOT BELOW AND MACRON",
  ["lccode"]=0x1E39,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["specials"]={ "char", 0x1E36, 0x0304 },
  ["unicodeslot"]=0x1E38, -- Ḹ
 },
 [0x1E39]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER L WITH DOT BELOW AND MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["specials"]={ "char", 0x1E37, 0x0304 },
  ["uccode"]=0x1E38,
  ["unicodeslot"]=0x1E39, -- ḹ
 },
 [0x1E3A]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER L WITH LINE BELOW",
  ["lccode"]=0x1E3B,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["specials"]={ "char", 0x004C, 0x0331 },
  ["unicodeslot"]=0x1E3A, -- Ḻ
 },
 [0x1E3B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER L WITH LINE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["specials"]={ "char", 0x006C, 0x0331 },
  ["uccode"]=0x1E3A,
  ["unicodeslot"]=0x1E3B, -- ḻ
 },
 [0x1E3C]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER L WITH CIRCUMFLEX BELOW",
  ["lccode"]=0x1E3D,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["specials"]={ "char", 0x004C, 0x032D },
  ["unicodeslot"]=0x1E3C, -- Ḽ
 },
 [0x1E3D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER L WITH CIRCUMFLEX BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["specials"]={ "char", 0x006C, 0x032D },
  ["uccode"]=0x1E3C,
  ["unicodeslot"]=0x1E3D, -- ḽ
 },
 [0x1E3E]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER M WITH ACUTE",
  ["lccode"]=0x1E3F,
  ["linebreak"]="al",
  ["shcode"]=0x004D,
  ["specials"]={ "char", 0x004D, 0x0301 },
  ["unicodeslot"]=0x1E3E, -- Ḿ
 },
 [0x1E3F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER M WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006D,
  ["specials"]={ "char", 0x006D, 0x0301 },
  ["uccode"]=0x1E3E,
  ["unicodeslot"]=0x1E3F, -- ḿ
 },
 [0x1E40]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER M WITH DOT ABOVE",
  ["lccode"]=0x1E41,
  ["linebreak"]="al",
  ["shcode"]=0x004D,
  ["specials"]={ "char", 0x004D, 0x0307 },
  ["unicodeslot"]=0x1E40, -- Ṁ
 },
 [0x1E41]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER M WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x006D,
  ["specials"]={ "char", 0x006D, 0x0307 },
  ["uccode"]=0x1E40,
  ["unicodeslot"]=0x1E41, -- ṁ
 },
 [0x1E42]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER M WITH DOT BELOW",
  ["lccode"]=0x1E43,
  ["linebreak"]="al",
  ["shcode"]=0x004D,
  ["specials"]={ "char", 0x004D, 0x0323 },
  ["unicodeslot"]=0x1E42, -- Ṃ
 },
 [0x1E43]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER M WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006D,
  ["specials"]={ "char", 0x006D, 0x0323 },
  ["uccode"]=0x1E42,
  ["unicodeslot"]=0x1E43, -- ṃ
 },
 [0x1E44]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER N WITH DOT ABOVE",
  ["lccode"]=0x1E45,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["specials"]={ "char", 0x004E, 0x0307 },
  ["unicodeslot"]=0x1E44, -- Ṅ
 },
 [0x1E45]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER N WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["specials"]={ "char", 0x006E, 0x0307 },
  ["uccode"]=0x1E44,
  ["unicodeslot"]=0x1E45, -- ṅ
 },
 [0x1E46]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER N WITH DOT BELOW",
  ["lccode"]=0x1E47,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["specials"]={ "char", 0x004E, 0x0323 },
  ["unicodeslot"]=0x1E46, -- Ṇ
 },
 [0x1E47]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER N WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["specials"]={ "char", 0x006E, 0x0323 },
  ["uccode"]=0x1E46,
  ["unicodeslot"]=0x1E47, -- ṇ
 },
 [0x1E48]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER N WITH LINE BELOW",
  ["lccode"]=0x1E49,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["specials"]={ "char", 0x004E, 0x0331 },
  ["unicodeslot"]=0x1E48, -- Ṉ
 },
 [0x1E49]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER N WITH LINE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["specials"]={ "char", 0x006E, 0x0331 },
  ["uccode"]=0x1E48,
  ["unicodeslot"]=0x1E49, -- ṉ
 },
 [0x1E4A]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER N WITH CIRCUMFLEX BELOW",
  ["lccode"]=0x1E4B,
  ["linebreak"]="al",
  ["shcode"]=0x004E,
  ["specials"]={ "char", 0x004E, 0x032D },
  ["unicodeslot"]=0x1E4A, -- Ṋ
 },
 [0x1E4B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER N WITH CIRCUMFLEX BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006E,
  ["specials"]={ "char", 0x006E, 0x032D },
  ["uccode"]=0x1E4A,
  ["unicodeslot"]=0x1E4B, -- ṋ
 },
 [0x1E4C]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER O WITH TILDE AND ACUTE",
  ["lccode"]=0x1E4D,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x00D5, 0x0301 },
  ["unicodeslot"]=0x1E4C, -- Ṍ
 },
 [0x1E4D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER O WITH TILDE AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x00F5, 0x0301 },
  ["uccode"]=0x1E4C,
  ["unicodeslot"]=0x1E4D, -- ṍ
 },
 [0x1E4E]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER O WITH TILDE AND DIAERESIS",
  ["lccode"]=0x1E4F,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x00D5, 0x0308 },
  ["unicodeslot"]=0x1E4E, -- Ṏ
 },
 [0x1E4F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER O WITH TILDE AND DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x00F5, 0x0308 },
  ["uccode"]=0x1E4E,
  ["unicodeslot"]=0x1E4F, -- ṏ
 },
 [0x1E50]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER O WITH MACRON AND GRAVE",
  ["lccode"]=0x1E51,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x014C, 0x0300 },
  ["unicodeslot"]=0x1E50, -- Ṑ
 },
 [0x1E51]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER O WITH MACRON AND GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x014D, 0x0300 },
  ["uccode"]=0x1E50,
  ["unicodeslot"]=0x1E51, -- ṑ
 },
 [0x1E52]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER O WITH MACRON AND ACUTE",
  ["lccode"]=0x1E53,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x014C, 0x0301 },
  ["unicodeslot"]=0x1E52, -- Ṓ
 },
 [0x1E53]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER O WITH MACRON AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x014D, 0x0301 },
  ["uccode"]=0x1E52,
  ["unicodeslot"]=0x1E53, -- ṓ
 },
 [0x1E54]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER P WITH ACUTE",
  ["lccode"]=0x1E55,
  ["linebreak"]="al",
  ["shcode"]=0x0050,
  ["specials"]={ "char", 0x0050, 0x0301 },
  ["unicodeslot"]=0x1E54, -- Ṕ
 },
 [0x1E55]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER P WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0070,
  ["specials"]={ "char", 0x0070, 0x0301 },
  ["uccode"]=0x1E54,
  ["unicodeslot"]=0x1E55, -- ṕ
 },
 [0x1E56]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER P WITH DOT ABOVE",
  ["lccode"]=0x1E57,
  ["linebreak"]="al",
  ["shcode"]=0x0050,
  ["specials"]={ "char", 0x0050, 0x0307 },
  ["unicodeslot"]=0x1E56, -- Ṗ
 },
 [0x1E57]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER P WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0070,
  ["specials"]={ "char", 0x0070, 0x0307 },
  ["uccode"]=0x1E56,
  ["unicodeslot"]=0x1E57, -- ṗ
 },
 [0x1E58]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER R WITH DOT ABOVE",
  ["lccode"]=0x1E59,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["specials"]={ "char", 0x0052, 0x0307 },
  ["unicodeslot"]=0x1E58, -- Ṙ
 },
 [0x1E59]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["specials"]={ "char", 0x0072, 0x0307 },
  ["uccode"]=0x1E58,
  ["unicodeslot"]=0x1E59, -- ṙ
 },
 [0x1E5A]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER R WITH DOT BELOW",
  ["lccode"]=0x1E5B,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["specials"]={ "char", 0x0052, 0x0323 },
  ["unicodeslot"]=0x1E5A, -- Ṛ
 },
 [0x1E5B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["specials"]={ "char", 0x0072, 0x0323 },
  ["uccode"]=0x1E5A,
  ["unicodeslot"]=0x1E5B, -- ṛ
 },
 [0x1E5C]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER R WITH DOT BELOW AND MACRON",
  ["lccode"]=0x1E5D,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["specials"]={ "char", 0x1E5A, 0x0304 },
  ["unicodeslot"]=0x1E5C, -- Ṝ
 },
 [0x1E5D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH DOT BELOW AND MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["specials"]={ "char", 0x1E5B, 0x0304 },
  ["uccode"]=0x1E5C,
  ["unicodeslot"]=0x1E5D, -- ṝ
 },
 [0x1E5E]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER R WITH LINE BELOW",
  ["lccode"]=0x1E5F,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["specials"]={ "char", 0x0052, 0x0331 },
  ["unicodeslot"]=0x1E5E, -- Ṟ
 },
 [0x1E5F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER R WITH LINE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0072,
  ["specials"]={ "char", 0x0072, 0x0331 },
  ["uccode"]=0x1E5E,
  ["unicodeslot"]=0x1E5F, -- ṟ
 },
 [0x1E60]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER S WITH DOT ABOVE",
  ["lccode"]=0x1E61,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x0053, 0x0307 },
  ["unicodeslot"]=0x1E60, -- Ṡ
 },
 [0x1E61]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER S WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x0073, 0x0307 },
  ["uccode"]=0x1E60,
  ["unicodeslot"]=0x1E61, -- ṡ
 },
 [0x1E62]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER S WITH DOT BELOW",
  ["lccode"]=0x1E63,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x0053, 0x0323 },
  ["unicodeslot"]=0x1E62, -- Ṣ
 },
 [0x1E63]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER S WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x0073, 0x0323 },
  ["uccode"]=0x1E62,
  ["unicodeslot"]=0x1E63, -- ṣ
 },
 [0x1E64]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER S WITH ACUTE AND DOT ABOVE",
  ["lccode"]=0x1E65,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x015A, 0x0307 },
  ["unicodeslot"]=0x1E64, -- Ṥ
 },
 [0x1E65]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER S WITH ACUTE AND DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x015B, 0x0307 },
  ["uccode"]=0x1E64,
  ["unicodeslot"]=0x1E65, -- ṥ
 },
 [0x1E66]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER S WITH CARON AND DOT ABOVE",
  ["lccode"]=0x1E67,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x0160, 0x0307 },
  ["unicodeslot"]=0x1E66, -- Ṧ
 },
 [0x1E67]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER S WITH CARON AND DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x0161, 0x0307 },
  ["uccode"]=0x1E66,
  ["unicodeslot"]=0x1E67, -- ṧ
 },
 [0x1E68]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER S WITH DOT BELOW AND DOT ABOVE",
  ["lccode"]=0x1E69,
  ["linebreak"]="al",
  ["shcode"]=0x0053,
  ["specials"]={ "char", 0x1E62, 0x0307 },
  ["unicodeslot"]=0x1E68, -- Ṩ
 },
 [0x1E69]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER S WITH DOT BELOW AND DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0073,
  ["specials"]={ "char", 0x1E63, 0x0307 },
  ["uccode"]=0x1E68,
  ["unicodeslot"]=0x1E69, -- ṩ
 },
 [0x1E6A]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER T WITH DOT ABOVE",
  ["lccode"]=0x1E6B,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["specials"]={ "char", 0x0054, 0x0307 },
  ["unicodeslot"]=0x1E6A, -- Ṫ
 },
 [0x1E6B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER T WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["specials"]={ "char", 0x0074, 0x0307 },
  ["uccode"]=0x1E6A,
  ["unicodeslot"]=0x1E6B, -- ṫ
 },
 [0x1E6C]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER T WITH DOT BELOW",
  ["lccode"]=0x1E6D,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["specials"]={ "char", 0x0054, 0x0323 },
  ["unicodeslot"]=0x1E6C, -- Ṭ
 },
 [0x1E6D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER T WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["specials"]={ "char", 0x0074, 0x0323 },
  ["uccode"]=0x1E6C,
  ["unicodeslot"]=0x1E6D, -- ṭ
 },
 [0x1E6E]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER T WITH LINE BELOW",
  ["lccode"]=0x1E6F,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["specials"]={ "char", 0x0054, 0x0331 },
  ["unicodeslot"]=0x1E6E, -- Ṯ
 },
 [0x1E6F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER T WITH LINE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["specials"]={ "char", 0x0074, 0x0331 },
  ["uccode"]=0x1E6E,
  ["unicodeslot"]=0x1E6F, -- ṯ
 },
 [0x1E70]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER T WITH CIRCUMFLEX BELOW",
  ["lccode"]=0x1E71,
  ["linebreak"]="al",
  ["shcode"]=0x0054,
  ["specials"]={ "char", 0x0054, 0x032D },
  ["unicodeslot"]=0x1E70, -- Ṱ
 },
 [0x1E71]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER T WITH CIRCUMFLEX BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["specials"]={ "char", 0x0074, 0x032D },
  ["uccode"]=0x1E70,
  ["unicodeslot"]=0x1E71, -- ṱ
 },
 [0x1E72]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER U WITH DIAERESIS BELOW",
  ["lccode"]=0x1E73,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0324 },
  ["unicodeslot"]=0x1E72, -- Ṳ
 },
 [0x1E73]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER U WITH DIAERESIS BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0324 },
  ["uccode"]=0x1E72,
  ["unicodeslot"]=0x1E73, -- ṳ
 },
 [0x1E74]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER U WITH TILDE BELOW",
  ["lccode"]=0x1E75,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0330 },
  ["unicodeslot"]=0x1E74, -- Ṵ
 },
 [0x1E75]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER U WITH TILDE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0330 },
  ["uccode"]=0x1E74,
  ["unicodeslot"]=0x1E75, -- ṵ
 },
 [0x1E76]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER U WITH CIRCUMFLEX BELOW",
  ["lccode"]=0x1E77,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x032D },
  ["unicodeslot"]=0x1E76, -- Ṷ
 },
 [0x1E77]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x032D },
  ["uccode"]=0x1E76,
  ["unicodeslot"]=0x1E77, -- ṷ
 },
 [0x1E78]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER U WITH TILDE AND ACUTE",
  ["lccode"]=0x1E79,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0168, 0x0301 },
  ["unicodeslot"]=0x1E78, -- Ṹ
 },
 [0x1E79]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER U WITH TILDE AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0169, 0x0301 },
  ["uccode"]=0x1E78,
  ["unicodeslot"]=0x1E79, -- ṹ
 },
 [0x1E7A]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER U WITH MACRON AND DIAERESIS",
  ["lccode"]=0x1E7B,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x016A, 0x0308 },
  ["unicodeslot"]=0x1E7A, -- Ṻ
 },
 [0x1E7B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER U WITH MACRON AND DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x016B, 0x0308 },
  ["uccode"]=0x1E7A,
  ["unicodeslot"]=0x1E7B, -- ṻ
 },
 [0x1E7C]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER V WITH TILDE",
  ["lccode"]=0x1E7D,
  ["linebreak"]="al",
  ["shcode"]=0x0056,
  ["specials"]={ "char", 0x0056, 0x0303 },
  ["unicodeslot"]=0x1E7C, -- Ṽ
 },
 [0x1E7D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER V WITH TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0076,
  ["specials"]={ "char", 0x0076, 0x0303 },
  ["uccode"]=0x1E7C,
  ["unicodeslot"]=0x1E7D, -- ṽ
 },
 [0x1E7E]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER V WITH DOT BELOW",
  ["lccode"]=0x1E7F,
  ["linebreak"]="al",
  ["shcode"]=0x0056,
  ["specials"]={ "char", 0x0056, 0x0323 },
  ["unicodeslot"]=0x1E7E, -- Ṿ
 },
 [0x1E7F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER V WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0076,
  ["specials"]={ "char", 0x0076, 0x0323 },
  ["uccode"]=0x1E7E,
  ["unicodeslot"]=0x1E7F, -- ṿ
 },
 [0x1E80]={
  ["adobename"]="Wgrave",
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER W WITH GRAVE",
  ["lccode"]=0x1E81,
  ["linebreak"]="al",
  ["shcode"]=0x0057,
  ["specials"]={ "char", 0x0057, 0x0300 },
  ["unicodeslot"]=0x1E80, -- Ẁ
 },
 [0x1E81]={
  ["adobename"]="wgrave",
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER W WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0077,
  ["specials"]={ "char", 0x0077, 0x0300 },
  ["uccode"]=0x1E80,
  ["unicodeslot"]=0x1E81, -- ẁ
 },
 [0x1E82]={
  ["adobename"]="Wacute",
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER W WITH ACUTE",
  ["lccode"]=0x1E83,
  ["linebreak"]="al",
  ["shcode"]=0x0057,
  ["specials"]={ "char", 0x0057, 0x0301 },
  ["unicodeslot"]=0x1E82, -- Ẃ
 },
 [0x1E83]={
  ["adobename"]="wacute",
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER W WITH ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0077,
  ["specials"]={ "char", 0x0077, 0x0301 },
  ["uccode"]=0x1E82,
  ["unicodeslot"]=0x1E83, -- ẃ
 },
 [0x1E84]={
  ["adobename"]="Wdieresis",
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER W WITH DIAERESIS",
  ["lccode"]=0x1E85,
  ["linebreak"]="al",
  ["shcode"]=0x0057,
  ["specials"]={ "char", 0x0057, 0x0308 },
  ["unicodeslot"]=0x1E84, -- Ẅ
 },
 [0x1E85]={
  ["adobename"]="wdieresis",
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER W WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0077,
  ["specials"]={ "char", 0x0077, 0x0308 },
  ["uccode"]=0x1E84,
  ["unicodeslot"]=0x1E85, -- ẅ
 },
 [0x1E86]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER W WITH DOT ABOVE",
  ["lccode"]=0x1E87,
  ["linebreak"]="al",
  ["shcode"]=0x0057,
  ["specials"]={ "char", 0x0057, 0x0307 },
  ["unicodeslot"]=0x1E86, -- Ẇ
 },
 [0x1E87]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER W WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0077,
  ["specials"]={ "char", 0x0077, 0x0307 },
  ["uccode"]=0x1E86,
  ["unicodeslot"]=0x1E87, -- ẇ
 },
 [0x1E88]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER W WITH DOT BELOW",
  ["lccode"]=0x1E89,
  ["linebreak"]="al",
  ["shcode"]=0x0057,
  ["specials"]={ "char", 0x0057, 0x0323 },
  ["unicodeslot"]=0x1E88, -- Ẉ
 },
 [0x1E89]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER W WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0077,
  ["specials"]={ "char", 0x0077, 0x0323 },
  ["uccode"]=0x1E88,
  ["unicodeslot"]=0x1E89, -- ẉ
 },
 [0x1E8A]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER X WITH DOT ABOVE",
  ["lccode"]=0x1E8B,
  ["linebreak"]="al",
  ["shcode"]=0x0058,
  ["specials"]={ "char", 0x0058, 0x0307 },
  ["unicodeslot"]=0x1E8A, -- Ẋ
 },
 [0x1E8B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER X WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0078,
  ["specials"]={ "char", 0x0078, 0x0307 },
  ["uccode"]=0x1E8A,
  ["unicodeslot"]=0x1E8B, -- ẋ
 },
 [0x1E8C]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER X WITH DIAERESIS",
  ["lccode"]=0x1E8D,
  ["linebreak"]="al",
  ["shcode"]=0x0058,
  ["specials"]={ "char", 0x0058, 0x0308 },
  ["unicodeslot"]=0x1E8C, -- Ẍ
 },
 [0x1E8D]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER X WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0078,
  ["specials"]={ "char", 0x0078, 0x0308 },
  ["uccode"]=0x1E8C,
  ["unicodeslot"]=0x1E8D, -- ẍ
 },
 [0x1E8E]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER Y WITH DOT ABOVE",
  ["lccode"]=0x1E8F,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["specials"]={ "char", 0x0059, 0x0307 },
  ["unicodeslot"]=0x1E8E, -- Ẏ
 },
 [0x1E8F]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Y WITH DOT ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x0307 },
  ["uccode"]=0x1E8E,
  ["unicodeslot"]=0x1E8F, -- ẏ
 },
 [0x1E90]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER Z WITH CIRCUMFLEX",
  ["lccode"]=0x1E91,
  ["linebreak"]="al",
  ["shcode"]=0x005A,
  ["specials"]={ "char", 0x005A, 0x0302 },
  ["unicodeslot"]=0x1E90, -- Ẑ
 },
 [0x1E91]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Z WITH CIRCUMFLEX",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["specials"]={ "char", 0x007A, 0x0302 },
  ["uccode"]=0x1E90,
  ["unicodeslot"]=0x1E91, -- ẑ
 },
 [0x1E92]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER Z WITH DOT BELOW",
  ["lccode"]=0x1E93,
  ["linebreak"]="al",
  ["shcode"]=0x005A,
  ["specials"]={ "char", 0x005A, 0x0323 },
  ["unicodeslot"]=0x1E92, -- Ẓ
 },
 [0x1E93]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Z WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["specials"]={ "char", 0x007A, 0x0323 },
  ["uccode"]=0x1E92,
  ["unicodeslot"]=0x1E93, -- ẓ
 },
 [0x1E94]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER Z WITH LINE BELOW",
  ["lccode"]=0x1E95,
  ["linebreak"]="al",
  ["shcode"]=0x005A,
  ["specials"]={ "char", 0x005A, 0x0331 },
  ["unicodeslot"]=0x1E94, -- Ẕ
 },
 [0x1E95]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Z WITH LINE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["specials"]={ "char", 0x007A, 0x0331 },
  ["uccode"]=0x1E94,
  ["unicodeslot"]=0x1E95, -- ẕ
 },
 [0x1E96]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER H WITH LINE BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["specials"]={ "char", 0x0068, 0x0331 },
  ["unicodeslot"]=0x1E96, -- ẖ
 },
 [0x1E97]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER T WITH DIAERESIS",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["specials"]={ "char", 0x0074, 0x0308 },
  ["unicodeslot"]=0x1E97, -- ẗ
 },
 [0x1E98]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER W WITH RING ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0077,
  ["specials"]={ "char", 0x0077, 0x030A },
  ["unicodeslot"]=0x1E98, -- ẘ
 },
 [0x1E99]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Y WITH RING ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x030A },
  ["unicodeslot"]=0x1E99, -- ẙ
 },
 [0x1E9A]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER A WITH RIGHT HALF RING",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "compat", 0x0061, 0x02BE },
  ["unicodeslot"]=0x1E9A, -- ẚ
 },
 [0x1E9B]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER LONG S WITH DOT ABOVE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x017F, 0x0307 },
  ["uccode"]=0x1E60,
  ["unicodeslot"]=0x1E9B, -- ẛ
 },
 [0x1EA0]={
  ["category"]="lu",
  ["contextname"]="Adotbelow",
  ["description"]="LATIN CAPITAL LETTER A WITH DOT BELOW",
  ["lccode"]=0x1EA1,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0323 },
  ["unicodeslot"]=0x1EA0, -- Ạ
 },
 [0x1EA1]={
  ["category"]="ll",
  ["contextname"]="adotbelow",
  ["description"]="LATIN SMALL LETTER A WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0323 },
  ["uccode"]=0x1EA0,
  ["unicodeslot"]=0x1EA1, -- ạ
 },
 [0x1EA2]={
  ["category"]="lu",
  ["contextname"]="Ahook",
  ["description"]="LATIN CAPITAL LETTER A WITH HOOK ABOVE",
  ["lccode"]=0x1EA3,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0041, 0x0309 },
  ["unicodeslot"]=0x1EA2, -- Ả
 },
 [0x1EA3]={
  ["category"]="ll",
  ["contextname"]="ahook",
  ["description"]="LATIN SMALL LETTER A WITH HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0061, 0x0309 },
  ["uccode"]=0x1EA2,
  ["unicodeslot"]=0x1EA3, -- ả
 },
 [0x1EA4]={
  ["category"]="lu",
  ["contextname"]="Acircumflexacute",
  ["description"]="LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND ACUTE",
  ["lccode"]=0x1EA5,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x00C2, 0x0301 },
  ["unicodeslot"]=0x1EA4, -- Ấ
 },
 [0x1EA5]={
  ["category"]="ll",
  ["contextname"]="acircumflexacute",
  ["description"]="LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x00E2, 0x0301 },
  ["uccode"]=0x1EA4,
  ["unicodeslot"]=0x1EA5, -- ấ
 },
 [0x1EA6]={
  ["category"]="lu",
  ["contextname"]="Acircumflexgrave",
  ["description"]="LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND GRAVE",
  ["lccode"]=0x1EA7,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x00C2, 0x0300 },
  ["unicodeslot"]=0x1EA6, -- Ầ
 },
 [0x1EA7]={
  ["category"]="ll",
  ["contextname"]="acircumflexgrave",
  ["description"]="LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x00E2, 0x0300 },
  ["uccode"]=0x1EA6,
  ["unicodeslot"]=0x1EA7, -- ầ
 },
 [0x1EA8]={
  ["category"]="lu",
  ["contextname"]="Acircumflexhook",
  ["description"]="LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE",
  ["lccode"]=0x1EA9,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x00C2, 0x0309 },
  ["unicodeslot"]=0x1EA8, -- Ẩ
 },
 [0x1EA9]={
  ["category"]="ll",
  ["contextname"]="acircumflexhook",
  ["description"]="LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x00E2, 0x0309 },
  ["uccode"]=0x1EA8,
  ["unicodeslot"]=0x1EA9, -- ẩ
 },
 [0x1EAA]={
  ["category"]="lu",
  ["contextname"]="Acircumflextilde",
  ["description"]="LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND TILDE",
  ["lccode"]=0x1EAB,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x00C2, 0x0303 },
  ["unicodeslot"]=0x1EAA, -- Ẫ
 },
 [0x1EAB]={
  ["category"]="ll",
  ["contextname"]="acircumflextilde",
  ["description"]="LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x00E2, 0x0303 },
  ["uccode"]=0x1EAA,
  ["unicodeslot"]=0x1EAB, -- ẫ
 },
 [0x1EAC]={
  ["category"]="lu",
  ["contextname"]="Acircumflexdotbelow",
  ["description"]="LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND DOT BELOW",
  ["lccode"]=0x1EAD,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x1EA0, 0x0302 },
  ["unicodeslot"]=0x1EAC, -- Ậ
 },
 [0x1EAD]={
  ["category"]="ll",
  ["contextname"]="acircumflexdotbelow",
  ["description"]="LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x1EA1, 0x0302 },
  ["uccode"]=0x1EAC,
  ["unicodeslot"]=0x1EAD, -- ậ
 },
 [0x1EAE]={
  ["category"]="lu",
  ["contextname"]="Abreveacute",
  ["description"]="LATIN CAPITAL LETTER A WITH BREVE AND ACUTE",
  ["lccode"]=0x1EAF,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0102, 0x0301 },
  ["unicodeslot"]=0x1EAE, -- Ắ
 },
 [0x1EAF]={
  ["category"]="ll",
  ["contextname"]="abreveacute",
  ["description"]="LATIN SMALL LETTER A WITH BREVE AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0103, 0x0301 },
  ["uccode"]=0x1EAE,
  ["unicodeslot"]=0x1EAF, -- ắ
 },
 [0x1EB0]={
  ["category"]="lu",
  ["contextname"]="Abrevegrave",
  ["description"]="LATIN CAPITAL LETTER A WITH BREVE AND GRAVE",
  ["lccode"]=0x1EB1,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0102, 0x0300 },
  ["unicodeslot"]=0x1EB0, -- Ằ
 },
 [0x1EB1]={
  ["category"]="ll",
  ["contextname"]="abrevegrave",
  ["description"]="LATIN SMALL LETTER A WITH BREVE AND GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0103, 0x0300 },
  ["uccode"]=0x1EB0,
  ["unicodeslot"]=0x1EB1, -- ằ
 },
 [0x1EB2]={
  ["category"]="lu",
  ["contextname"]="Abrevehook",
  ["description"]="LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE",
  ["lccode"]=0x1EB3,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0102, 0x0309 },
  ["unicodeslot"]=0x1EB2, -- Ẳ
 },
 [0x1EB3]={
  ["category"]="ll",
  ["contextname"]="abrevehook",
  ["description"]="LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0103, 0x0309 },
  ["uccode"]=0x1EB2,
  ["unicodeslot"]=0x1EB3, -- ẳ
 },
 [0x1EB4]={
  ["category"]="lu",
  ["contextname"]="Abrevetilde",
  ["description"]="LATIN CAPITAL LETTER A WITH BREVE AND TILDE",
  ["lccode"]=0x1EB5,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x0102, 0x0303 },
  ["unicodeslot"]=0x1EB4, -- Ẵ
 },
 [0x1EB5]={
  ["category"]="ll",
  ["contextname"]="abrevetilde",
  ["description"]="LATIN SMALL LETTER A WITH BREVE AND TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x0103, 0x0303 },
  ["uccode"]=0x1EB4,
  ["unicodeslot"]=0x1EB5, -- ẵ
 },
 [0x1EB6]={
  ["category"]="lu",
  ["contextname"]="Abrevedotbelow",
  ["description"]="LATIN CAPITAL LETTER A WITH BREVE AND DOT BELOW",
  ["lccode"]=0x1EB7,
  ["linebreak"]="al",
  ["shcode"]=0x0041,
  ["specials"]={ "char", 0x1EA0, 0x0306 },
  ["unicodeslot"]=0x1EB6, -- Ặ
 },
 [0x1EB7]={
  ["category"]="ll",
  ["contextname"]="abrevedotbelow",
  ["description"]="LATIN SMALL LETTER A WITH BREVE AND DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["specials"]={ "char", 0x1EA1, 0x0306 },
  ["uccode"]=0x1EB6,
  ["unicodeslot"]=0x1EB7, -- ặ
 },
 [0x1EB8]={
  ["category"]="lu",
  ["contextname"]="Edotbelow",
  ["description"]="LATIN CAPITAL LETTER E WITH DOT BELOW",
  ["lccode"]=0x1EB9,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0323 },
  ["unicodeslot"]=0x1EB8, -- Ẹ
 },
 [0x1EB9]={
  ["category"]="ll",
  ["contextname"]="edotbelow",
  ["description"]="LATIN SMALL LETTER E WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0323 },
  ["uccode"]=0x1EB8,
  ["unicodeslot"]=0x1EB9, -- ẹ
 },
 [0x1EBA]={
  ["category"]="lu",
  ["contextname"]="Ehook",
  ["description"]="LATIN CAPITAL LETTER E WITH HOOK ABOVE",
  ["lccode"]=0x1EBB,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0309 },
  ["unicodeslot"]=0x1EBA, -- Ẻ
 },
 [0x1EBB]={
  ["category"]="ll",
  ["contextname"]="ehook",
  ["description"]="LATIN SMALL LETTER E WITH HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0309 },
  ["uccode"]=0x1EBA,
  ["unicodeslot"]=0x1EBB, -- ẻ
 },
 [0x1EBC]={
  ["category"]="lu",
  ["contextname"]="Etilde",
  ["description"]="LATIN CAPITAL LETTER E WITH TILDE",
  ["lccode"]=0x1EBD,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x0045, 0x0303 },
  ["unicodeslot"]=0x1EBC, -- Ẽ
 },
 [0x1EBD]={
  ["category"]="ll",
  ["contextname"]="etilde",
  ["description"]="LATIN SMALL LETTER E WITH TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x0065, 0x0303 },
  ["uccode"]=0x1EBC,
  ["unicodeslot"]=0x1EBD, -- ẽ
 },
 [0x1EBE]={
  ["category"]="lu",
  ["contextname"]="Ecircumflexacute",
  ["description"]="LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND ACUTE",
  ["lccode"]=0x1EBF,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x00CA, 0x0301 },
  ["unicodeslot"]=0x1EBE, -- Ế
 },
 [0x1EBF]={
  ["category"]="ll",
  ["contextname"]="ecircumflexacute",
  ["description"]="LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x00EA, 0x0301 },
  ["uccode"]=0x1EBE,
  ["unicodeslot"]=0x1EBF, -- ế
 },
 [0x1EC0]={
  ["category"]="lu",
  ["contextname"]="Ecircumflexgrave",
  ["description"]="LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE",
  ["lccode"]=0x1EC1,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x00CA, 0x0300 },
  ["unicodeslot"]=0x1EC0, -- Ề
 },
 [0x1EC1]={
  ["category"]="ll",
  ["contextname"]="ecircumflexgrave",
  ["description"]="LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x00EA, 0x0300 },
  ["uccode"]=0x1EC0,
  ["unicodeslot"]=0x1EC1, -- ề
 },
 [0x1EC2]={
  ["category"]="lu",
  ["contextname"]="Ecircumflexhook",
  ["description"]="LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE",
  ["lccode"]=0x1EC3,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x00CA, 0x0309 },
  ["unicodeslot"]=0x1EC2, -- Ể
 },
 [0x1EC3]={
  ["category"]="ll",
  ["contextname"]="ecircumflexhook",
  ["description"]="LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x00EA, 0x0309 },
  ["uccode"]=0x1EC2,
  ["unicodeslot"]=0x1EC3, -- ể
 },
 [0x1EC4]={
  ["category"]="lu",
  ["contextname"]="Ecircumflextilde",
  ["description"]="LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND TILDE",
  ["lccode"]=0x1EC5,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x00CA, 0x0303 },
  ["unicodeslot"]=0x1EC4, -- Ễ
 },
 [0x1EC5]={
  ["category"]="ll",
  ["contextname"]="ecircumflextilde",
  ["description"]="LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x00EA, 0x0303 },
  ["uccode"]=0x1EC4,
  ["unicodeslot"]=0x1EC5, -- ễ
 },
 [0x1EC6]={
  ["category"]="lu",
  ["contextname"]="Ecircumflexdotbelow",
  ["description"]="LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND DOT BELOW",
  ["lccode"]=0x1EC7,
  ["linebreak"]="al",
  ["shcode"]=0x0045,
  ["specials"]={ "char", 0x1EB8, 0x0302 },
  ["unicodeslot"]=0x1EC6, -- Ệ
 },
 [0x1EC7]={
  ["category"]="ll",
  ["contextname"]="ecircumflexdotbelow",
  ["description"]="LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0065,
  ["specials"]={ "char", 0x1EB9, 0x0302 },
  ["uccode"]=0x1EC6,
  ["unicodeslot"]=0x1EC7, -- ệ
 },
 [0x1EC8]={
  ["category"]="lu",
  ["contextname"]="Ihook",
  ["description"]="LATIN CAPITAL LETTER I WITH HOOK ABOVE",
  ["lccode"]=0x1EC9,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0309 },
  ["unicodeslot"]=0x1EC8, -- Ỉ
 },
 [0x1EC9]={
  ["category"]="ll",
  ["contextname"]="ihook",
  ["description"]="LATIN SMALL LETTER I WITH HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0309 },
  ["uccode"]=0x1EC8,
  ["unicodeslot"]=0x1EC9, -- ỉ
 },
 [0x1ECA]={
  ["category"]="lu",
  ["contextname"]="Idotbelow",
  ["description"]="LATIN CAPITAL LETTER I WITH DOT BELOW",
  ["lccode"]=0x1ECB,
  ["linebreak"]="al",
  ["shcode"]=0x0049,
  ["specials"]={ "char", 0x0049, 0x0323 },
  ["unicodeslot"]=0x1ECA, -- Ị
 },
 [0x1ECB]={
  ["category"]="ll",
  ["contextname"]="idotbelow",
  ["description"]="LATIN SMALL LETTER I WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0069,
  ["specials"]={ "char", 0x0069, 0x0323 },
  ["uccode"]=0x1ECA,
  ["unicodeslot"]=0x1ECB, -- ị
 },
 [0x1ECC]={
  ["category"]="lu",
  ["contextname"]="Odotbelow",
  ["description"]="LATIN CAPITAL LETTER O WITH DOT BELOW",
  ["lccode"]=0x1ECD,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0323 },
  ["unicodeslot"]=0x1ECC, -- Ọ
 },
 [0x1ECD]={
  ["category"]="ll",
  ["contextname"]="odotbelow",
  ["description"]="LATIN SMALL LETTER O WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0323 },
  ["uccode"]=0x1ECC,
  ["unicodeslot"]=0x1ECD, -- ọ
 },
 [0x1ECE]={
  ["category"]="lu",
  ["contextname"]="Ohook",
  ["description"]="LATIN CAPITAL LETTER O WITH HOOK ABOVE",
  ["lccode"]=0x1ECF,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x004F, 0x0309 },
  ["unicodeslot"]=0x1ECE, -- Ỏ
 },
 [0x1ECF]={
  ["category"]="ll",
  ["contextname"]="ohook",
  ["description"]="LATIN SMALL LETTER O WITH HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x006F, 0x0309 },
  ["uccode"]=0x1ECE,
  ["unicodeslot"]=0x1ECF, -- ỏ
 },
 [0x1ED0]={
  ["category"]="lu",
  ["contextname"]="Ocircumflexacute",
  ["description"]="LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE",
  ["lccode"]=0x1ED1,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x00D4, 0x0301 },
  ["unicodeslot"]=0x1ED0, -- Ố
 },
 [0x1ED1]={
  ["category"]="ll",
  ["contextname"]="ocircumflexacute",
  ["description"]="LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x00F4, 0x0301 },
  ["uccode"]=0x1ED0,
  ["unicodeslot"]=0x1ED1, -- ố
 },
 [0x1ED2]={
  ["category"]="lu",
  ["contextname"]="Ocircumflexgrave",
  ["description"]="LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND GRAVE",
  ["lccode"]=0x1ED3,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x00D4, 0x0300 },
  ["unicodeslot"]=0x1ED2, -- Ồ
 },
 [0x1ED3]={
  ["category"]="ll",
  ["contextname"]="ocircumflexgrave",
  ["description"]="LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x00F4, 0x0300 },
  ["uccode"]=0x1ED2,
  ["unicodeslot"]=0x1ED3, -- ồ
 },
 [0x1ED4]={
  ["category"]="lu",
  ["contextname"]="Ocircumflexhook",
  ["description"]="LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE",
  ["lccode"]=0x1ED5,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x00D4, 0x0309 },
  ["unicodeslot"]=0x1ED4, -- Ổ
 },
 [0x1ED5]={
  ["category"]="ll",
  ["contextname"]="ocircumflexhook",
  ["description"]="LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x00F4, 0x0309 },
  ["uccode"]=0x1ED4,
  ["unicodeslot"]=0x1ED5, -- ổ
 },
 [0x1ED6]={
  ["category"]="lu",
  ["contextname"]="Ocircumflextilde",
  ["description"]="LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE",
  ["lccode"]=0x1ED7,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x00D4, 0x0303 },
  ["unicodeslot"]=0x1ED6, -- Ỗ
 },
 [0x1ED7]={
  ["category"]="ll",
  ["contextname"]="ocircumflextilde",
  ["description"]="LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x00F4, 0x0303 },
  ["uccode"]=0x1ED6,
  ["unicodeslot"]=0x1ED7, -- ỗ
 },
 [0x1ED8]={
  ["category"]="lu",
  ["contextname"]="Ocircumflexdotbelow",
  ["description"]="LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND DOT BELOW",
  ["lccode"]=0x1ED9,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x1ECC, 0x0302 },
  ["unicodeslot"]=0x1ED8, -- Ộ
 },
 [0x1ED9]={
  ["category"]="ll",
  ["contextname"]="ocircumflexdotbelow",
  ["description"]="LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x1ECD, 0x0302 },
  ["uccode"]=0x1ED8,
  ["unicodeslot"]=0x1ED9, -- ộ
 },
 [0x1EDA]={
  ["category"]="lu",
  ["contextname"]="Ohornacute",
  ["description"]="LATIN CAPITAL LETTER O WITH HORN AND ACUTE",
  ["lccode"]=0x1EDB,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x01A0, 0x0301 },
  ["unicodeslot"]=0x1EDA, -- Ớ
 },
 [0x1EDB]={
  ["category"]="ll",
  ["contextname"]="ohornacute",
  ["description"]="LATIN SMALL LETTER O WITH HORN AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x01A1, 0x0301 },
  ["uccode"]=0x1EDA,
  ["unicodeslot"]=0x1EDB, -- ớ
 },
 [0x1EDC]={
  ["category"]="lu",
  ["contextname"]="Ohorngrave",
  ["description"]="LATIN CAPITAL LETTER O WITH HORN AND GRAVE",
  ["lccode"]=0x1EDD,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x01A0, 0x0300 },
  ["unicodeslot"]=0x1EDC, -- Ờ
 },
 [0x1EDD]={
  ["category"]="ll",
  ["contextname"]="ohorngrave",
  ["description"]="LATIN SMALL LETTER O WITH HORN AND GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x01A1, 0x0300 },
  ["uccode"]=0x1EDC,
  ["unicodeslot"]=0x1EDD, -- ờ
 },
 [0x1EDE]={
  ["category"]="lu",
  ["contextname"]="Ohornhook",
  ["description"]="LATIN CAPITAL LETTER O WITH HORN AND HOOK ABOVE",
  ["lccode"]=0x1EDF,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x01A0, 0x0309 },
  ["unicodeslot"]=0x1EDE, -- Ở
 },
 [0x1EDF]={
  ["category"]="ll",
  ["contextname"]="ohornhook",
  ["description"]="LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x01A1, 0x0309 },
  ["uccode"]=0x1EDE,
  ["unicodeslot"]=0x1EDF, -- ở
 },
 [0x1EE0]={
  ["category"]="lu",
  ["contextname"]="Ohorntilde",
  ["description"]="LATIN CAPITAL LETTER O WITH HORN AND TILDE",
  ["lccode"]=0x1EE1,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x01A0, 0x0303 },
  ["unicodeslot"]=0x1EE0, -- Ỡ
 },
 [0x1EE1]={
  ["category"]="ll",
  ["contextname"]="ohorntilde",
  ["description"]="LATIN SMALL LETTER O WITH HORN AND TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x01A1, 0x0303 },
  ["uccode"]=0x1EE0,
  ["unicodeslot"]=0x1EE1, -- ỡ
 },
 [0x1EE2]={
  ["category"]="lu",
  ["contextname"]="Ohorndotbelow",
  ["description"]="LATIN CAPITAL LETTER O WITH HORN AND DOT BELOW",
  ["lccode"]=0x1EE3,
  ["linebreak"]="al",
  ["shcode"]=0x004F,
  ["specials"]={ "char", 0x01A0, 0x0323 },
  ["unicodeslot"]=0x1EE2, -- Ợ
 },
 [0x1EE3]={
  ["category"]="ll",
  ["contextname"]="ohorndotbelow",
  ["description"]="LATIN SMALL LETTER O WITH HORN AND DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x006F,
  ["specials"]={ "char", 0x01A1, 0x0323 },
  ["uccode"]=0x1EE2,
  ["unicodeslot"]=0x1EE3, -- ợ
 },
 [0x1EE4]={
  ["category"]="lu",
  ["contextname"]="Udotbelow",
  ["description"]="LATIN CAPITAL LETTER U WITH DOT BELOW",
  ["lccode"]=0x1EE5,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0323 },
  ["unicodeslot"]=0x1EE4, -- Ụ
 },
 [0x1EE5]={
  ["category"]="ll",
  ["contextname"]="udotbelow",
  ["description"]="LATIN SMALL LETTER U WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0323 },
  ["uccode"]=0x1EE4,
  ["unicodeslot"]=0x1EE5, -- ụ
 },
 [0x1EE6]={
  ["category"]="lu",
  ["contextname"]="Uhook",
  ["description"]="LATIN CAPITAL LETTER U WITH HOOK ABOVE",
  ["lccode"]=0x1EE7,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x0055, 0x0309 },
  ["unicodeslot"]=0x1EE6, -- Ủ
 },
 [0x1EE7]={
  ["category"]="ll",
  ["contextname"]="uhook",
  ["description"]="LATIN SMALL LETTER U WITH HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x0075, 0x0309 },
  ["uccode"]=0x1EE6,
  ["unicodeslot"]=0x1EE7, -- ủ
 },
 [0x1EE8]={
  ["category"]="lu",
  ["contextname"]="Uhornacute",
  ["description"]="LATIN CAPITAL LETTER U WITH HORN AND ACUTE",
  ["lccode"]=0x1EE9,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x01AF, 0x0301 },
  ["unicodeslot"]=0x1EE8, -- Ứ
 },
 [0x1EE9]={
  ["category"]="ll",
  ["contextname"]="uhornacute",
  ["description"]="LATIN SMALL LETTER U WITH HORN AND ACUTE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x01B0, 0x0301 },
  ["uccode"]=0x1EE8,
  ["unicodeslot"]=0x1EE9, -- ứ
 },
 [0x1EEA]={
  ["category"]="lu",
  ["contextname"]="Uhorngrave",
  ["description"]="LATIN CAPITAL LETTER U WITH HORN AND GRAVE",
  ["lccode"]=0x1EEB,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x01AF, 0x0300 },
  ["unicodeslot"]=0x1EEA, -- Ừ
 },
 [0x1EEB]={
  ["category"]="ll",
  ["contextname"]="uhorngrave",
  ["description"]="LATIN SMALL LETTER U WITH HORN AND GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x01B0, 0x0300 },
  ["uccode"]=0x1EEA,
  ["unicodeslot"]=0x1EEB, -- ừ
 },
 [0x1EEC]={
  ["category"]="lu",
  ["contextname"]="Uhornhook",
  ["description"]="LATIN CAPITAL LETTER U WITH HORN AND HOOK ABOVE",
  ["lccode"]=0x1EED,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x01AF, 0x0309 },
  ["unicodeslot"]=0x1EEC, -- Ử
 },
 [0x1EED]={
  ["category"]="ll",
  ["contextname"]="uhornhook",
  ["description"]="LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x01B0, 0x0309 },
  ["uccode"]=0x1EEC,
  ["unicodeslot"]=0x1EED, -- ử
 },
 [0x1EEE]={
  ["category"]="lu",
  ["contextname"]="Uhorntilde",
  ["description"]="LATIN CAPITAL LETTER U WITH HORN AND TILDE",
  ["lccode"]=0x1EEF,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x01AF, 0x0303 },
  ["unicodeslot"]=0x1EEE, -- Ữ
 },
 [0x1EEF]={
  ["category"]="ll",
  ["contextname"]="uhorntilde",
  ["description"]="LATIN SMALL LETTER U WITH HORN AND TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x01B0, 0x0303 },
  ["uccode"]=0x1EEE,
  ["unicodeslot"]=0x1EEF, -- ữ
 },
 [0x1EF0]={
  ["category"]="lu",
  ["contextname"]="Uhorndotbelow",
  ["description"]="LATIN CAPITAL LETTER U WITH HORN AND DOT BELOW",
  ["lccode"]=0x1EF1,
  ["linebreak"]="al",
  ["shcode"]=0x0055,
  ["specials"]={ "char", 0x01AF, 0x0323 },
  ["unicodeslot"]=0x1EF0, -- Ự
 },
 [0x1EF1]={
  ["category"]="ll",
  ["contextname"]="uhorndotbelow",
  ["description"]="LATIN SMALL LETTER U WITH HORN AND DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0075,
  ["specials"]={ "char", 0x01B0, 0x0323 },
  ["uccode"]=0x1EF0,
  ["unicodeslot"]=0x1EF1, -- ự
 },
 [0x1EF2]={
  ["adobename"]="Ygrave",
  ["category"]="lu",
  ["contextname"]="Ygrave",
  ["description"]="LATIN CAPITAL LETTER Y WITH GRAVE",
  ["lccode"]=0x1EF3,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["specials"]={ "char", 0x0059, 0x0300 },
  ["unicodeslot"]=0x1EF2, -- Ỳ
 },
 [0x1EF3]={
  ["adobename"]="ygrave",
  ["category"]="ll",
  ["contextname"]="ygrave",
  ["description"]="LATIN SMALL LETTER Y WITH GRAVE",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x0300 },
  ["uccode"]=0x1EF2,
  ["unicodeslot"]=0x1EF3, -- ỳ
 },
 [0x1EF4]={
  ["category"]="lu",
  ["contextname"]="Ydotbelow",
  ["description"]="LATIN CAPITAL LETTER Y WITH DOT BELOW",
  ["lccode"]=0x1EF5,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["specials"]={ "char", 0x0059, 0x0323 },
  ["unicodeslot"]=0x1EF4, -- Ỵ
 },
 [0x1EF5]={
  ["category"]="ll",
  ["contextname"]="ydotbelow",
  ["description"]="LATIN SMALL LETTER Y WITH DOT BELOW",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x0323 },
  ["uccode"]=0x1EF4,
  ["unicodeslot"]=0x1EF5, -- ỵ
 },
 [0x1EF6]={
  ["category"]="lu",
  ["contextname"]="Yhook",
  ["description"]="LATIN CAPITAL LETTER Y WITH HOOK ABOVE",
  ["lccode"]=0x1EF7,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["specials"]={ "char", 0x0059, 0x0309 },
  ["unicodeslot"]=0x1EF6, -- Ỷ
 },
 [0x1EF7]={
  ["category"]="ll",
  ["contextname"]="yhook",
  ["description"]="LATIN SMALL LETTER Y WITH HOOK ABOVE",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x0309 },
  ["uccode"]=0x1EF6,
  ["unicodeslot"]=0x1EF7, -- ỷ
 },
 [0x1EF8]={
  ["category"]="lu",
  ["contextname"]="Ytilde",
  ["description"]="LATIN CAPITAL LETTER Y WITH TILDE",
  ["lccode"]=0x1EF9,
  ["linebreak"]="al",
  ["shcode"]=0x0059,
  ["specials"]={ "char", 0x0059, 0x0303 },
  ["unicodeslot"]=0x1EF8, -- Ỹ
 },
 [0x1EF9]={
  ["category"]="ll",
  ["contextname"]="ytilde",
  ["description"]="LATIN SMALL LETTER Y WITH TILDE",
  ["linebreak"]="al",
  ["shcode"]=0x0079,
  ["specials"]={ "char", 0x0079, 0x0303 },
  ["uccode"]=0x1EF8,
  ["unicodeslot"]=0x1EF9, -- ỹ
 },
 [0x1F00]={
  ["category"]="ll",
  ["contextname"]="greekalphapsili",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PSILI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03B1, 0x0313 },
  ["uccode"]=0x1F08,
  ["unicodeslot"]=0x1F00, -- ἀ
 },
 [0x1F01]={
  ["category"]="ll",
  ["contextname"]="greekalphadasia",
  ["description"]="GREEK SMALL LETTER ALPHA WITH DASIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03B1, 0x0314 },
  ["uccode"]=0x1F09,
  ["unicodeslot"]=0x1F01, -- ἁ
 },
 [0x1F02]={
  ["category"]="ll",
  ["contextname"]="greekalphapsilivaria",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F00, 0x0300 },
  ["uccode"]=0x1F0A,
  ["unicodeslot"]=0x1F02, -- ἂ
 },
 [0x1F03]={
  ["category"]="ll",
  ["contextname"]="greekalphadasiavaria",
  ["description"]="GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F01, 0x0300 },
  ["uccode"]=0x1F0B,
  ["unicodeslot"]=0x1F03, -- ἃ
 },
 [0x1F04]={
  ["category"]="ll",
  ["contextname"]="greekalphapsilitonos",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F00, 0x0301 },
  ["uccode"]=0x1F0C,
  ["unicodeslot"]=0x1F04, -- ἄ
 },
 [0x1F05]={
  ["category"]="ll",
  ["contextname"]="greekalphadasiatonos",
  ["description"]="GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F01, 0x0301 },
  ["uccode"]=0x1F0D,
  ["unicodeslot"]=0x1F05, -- ἅ
 },
 [0x1F06]={
  ["category"]="ll",
  ["contextname"]="greekalphapsiliperispomeni",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F00, 0x0342 },
  ["uccode"]=0x1F0E,
  ["unicodeslot"]=0x1F06, -- ἆ
 },
 [0x1F07]={
  ["category"]="ll",
  ["contextname"]="greekalphadasiaperispomeni",
  ["description"]="GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F01, 0x0342 },
  ["uccode"]=0x1F0F,
  ["unicodeslot"]=0x1F07, -- ἇ
 },
 [0x1F08]={
  ["category"]="lu",
  ["contextname"]="greekAlphapsili",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH PSILI",
  ["lccode"]=0x1F00,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x0391, 0x0313 },
  ["unicodeslot"]=0x1F08, -- Ἀ
 },
 [0x1F09]={
  ["category"]="lu",
  ["contextname"]="greekAlphadasia",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH DASIA",
  ["lccode"]=0x1F01,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x0391, 0x0314 },
  ["unicodeslot"]=0x1F09, -- Ἁ
 },
 [0x1F0A]={
  ["category"]="lu",
  ["contextname"]="greekAlphapsilivaria",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA",
  ["lccode"]=0x1F02,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F08, 0x0300 },
  ["unicodeslot"]=0x1F0A, -- Ἂ
 },
 [0x1F0B]={
  ["category"]="lu",
  ["contextname"]="greekAlphadasiavaria",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA",
  ["lccode"]=0x1F03,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F09, 0x0300 },
  ["unicodeslot"]=0x1F0B, -- Ἃ
 },
 [0x1F0C]={
  ["category"]="lu",
  ["contextname"]="greekAlphapsilitonos",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA",
  ["lccode"]=0x1F04,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F08, 0x0301 },
  ["unicodeslot"]=0x1F0C, -- Ἄ
 },
 [0x1F0D]={
  ["category"]="lu",
  ["contextname"]="greekAlphadasiatonos",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA",
  ["lccode"]=0x1F05,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F09, 0x0301 },
  ["unicodeslot"]=0x1F0D, -- Ἅ
 },
 [0x1F0E]={
  ["category"]="lu",
  ["contextname"]="greekAlphapsiliperispomeni",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI",
  ["lccode"]=0x1F06,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F08, 0x0342 },
  ["unicodeslot"]=0x1F0E, -- Ἆ
 },
 [0x1F0F]={
  ["category"]="lu",
  ["contextname"]="greekAlphadasiaperispomeni",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI",
  ["lccode"]=0x1F07,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F09, 0x0342 },
  ["unicodeslot"]=0x1F0F, -- Ἇ
 },
 [0x1F10]={
  ["category"]="ll",
  ["contextname"]="greekepsilonpsili",
  ["description"]="GREEK SMALL LETTER EPSILON WITH PSILI",
  ["linebreak"]="al",
  ["shcode"]=0x03B5,
  ["specials"]={ "char", 0x03B5, 0x0313 },
  ["uccode"]=0x1F18,
  ["unicodeslot"]=0x1F10, -- ἐ
 },
 [0x1F11]={
  ["category"]="ll",
  ["contextname"]="greekepsilondasia",
  ["description"]="GREEK SMALL LETTER EPSILON WITH DASIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B5,
  ["specials"]={ "char", 0x03B5, 0x0314 },
  ["uccode"]=0x1F19,
  ["unicodeslot"]=0x1F11, -- ἑ
 },
 [0x1F12]={
  ["category"]="ll",
  ["contextname"]="greekepsilonpsilivaria",
  ["description"]="GREEK SMALL LETTER EPSILON WITH PSILI AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B5,
  ["specials"]={ "char", 0x1F10, 0x0300 },
  ["uccode"]=0x1F1A,
  ["unicodeslot"]=0x1F12, -- ἒ
 },
 [0x1F13]={
  ["category"]="ll",
  ["contextname"]="greekepsilondasiavaria",
  ["description"]="GREEK SMALL LETTER EPSILON WITH DASIA AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B5,
  ["specials"]={ "char", 0x1F11, 0x0300 },
  ["uccode"]=0x1F1B,
  ["unicodeslot"]=0x1F13, -- ἓ
 },
 [0x1F14]={
  ["category"]="ll",
  ["contextname"]="greekepsilonpsilitonos",
  ["description"]="GREEK SMALL LETTER EPSILON WITH PSILI AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B5,
  ["specials"]={ "char", 0x1F10, 0x0301 },
  ["uccode"]=0x1F1C,
  ["unicodeslot"]=0x1F14, -- ἔ
 },
 [0x1F15]={
  ["category"]="ll",
  ["contextname"]="greekepsilondasiatonos",
  ["description"]="GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B5,
  ["specials"]={ "char", 0x1F11, 0x0301 },
  ["uccode"]=0x1F1D,
  ["unicodeslot"]=0x1F15, -- ἕ
 },
 [0x1F18]={
  ["category"]="lu",
  ["contextname"]="greekEpsilonpsili",
  ["description"]="GREEK CAPITAL LETTER EPSILON WITH PSILI",
  ["lccode"]=0x1F10,
  ["linebreak"]="al",
  ["shcode"]=0x0395,
  ["specials"]={ "char", 0x0395, 0x0313 },
  ["unicodeslot"]=0x1F18, -- Ἐ
 },
 [0x1F19]={
  ["category"]="lu",
  ["contextname"]="greekEpsilondasia",
  ["description"]="GREEK CAPITAL LETTER EPSILON WITH DASIA",
  ["lccode"]=0x1F11,
  ["linebreak"]="al",
  ["shcode"]=0x0395,
  ["specials"]={ "char", 0x0395, 0x0314 },
  ["unicodeslot"]=0x1F19, -- Ἑ
 },
 [0x1F1A]={
  ["category"]="lu",
  ["contextname"]="greekEpsilonpsilivaria",
  ["description"]="GREEK CAPITAL LETTER EPSILON WITH PSILI AND VARIA",
  ["lccode"]=0x1F12,
  ["linebreak"]="al",
  ["shcode"]=0x0395,
  ["specials"]={ "char", 0x1F18, 0x0300 },
  ["unicodeslot"]=0x1F1A, -- Ἒ
 },
 [0x1F1B]={
  ["category"]="lu",
  ["contextname"]="greekEpsilondasiavaria",
  ["description"]="GREEK CAPITAL LETTER EPSILON WITH DASIA AND VARIA",
  ["lccode"]=0x1F13,
  ["linebreak"]="al",
  ["shcode"]=0x0395,
  ["specials"]={ "char", 0x1F19, 0x0300 },
  ["unicodeslot"]=0x1F1B, -- Ἓ
 },
 [0x1F1C]={
  ["category"]="lu",
  ["contextname"]="greekEpsilonpsilitonos",
  ["description"]="GREEK CAPITAL LETTER EPSILON WITH PSILI AND OXIA",
  ["lccode"]=0x1F14,
  ["linebreak"]="al",
  ["shcode"]=0x0395,
  ["specials"]={ "char", 0x1F18, 0x0301 },
  ["unicodeslot"]=0x1F1C, -- Ἔ
 },
 [0x1F1D]={
  ["category"]="lu",
  ["contextname"]="greekEpsilondasiatonos",
  ["description"]="GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA",
  ["lccode"]=0x1F15,
  ["linebreak"]="al",
  ["shcode"]=0x0395,
  ["specials"]={ "char", 0x1F19, 0x0301 },
  ["unicodeslot"]=0x1F1D, -- Ἕ
 },
 [0x1F20]={
  ["category"]="ll",
  ["contextname"]="greeketapsili",
  ["description"]="GREEK SMALL LETTER ETA WITH PSILI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x03B7, 0x0313 },
  ["uccode"]=0x1F28,
  ["unicodeslot"]=0x1F20, -- ἠ
 },
 [0x1F21]={
  ["category"]="ll",
  ["contextname"]="greeketadasia",
  ["description"]="GREEK SMALL LETTER ETA WITH DASIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x03B7, 0x0314 },
  ["uccode"]=0x1F29,
  ["unicodeslot"]=0x1F21, -- ἡ
 },
 [0x1F22]={
  ["category"]="ll",
  ["contextname"]="greeketapsilivaria",
  ["description"]="GREEK SMALL LETTER ETA WITH PSILI AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F20, 0x0300 },
  ["uccode"]=0x1F2A,
  ["unicodeslot"]=0x1F22, -- ἢ
 },
 [0x1F23]={
  ["category"]="ll",
  ["contextname"]="greeketadasiavaria",
  ["description"]="GREEK SMALL LETTER ETA WITH DASIA AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F21, 0x0300 },
  ["uccode"]=0x1F2B,
  ["unicodeslot"]=0x1F23, -- ἣ
 },
 [0x1F24]={
  ["category"]="ll",
  ["contextname"]="greeketapsilitonos",
  ["description"]="GREEK SMALL LETTER ETA WITH PSILI AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F20, 0x0301 },
  ["uccode"]=0x1F2C,
  ["unicodeslot"]=0x1F24, -- ἤ
 },
 [0x1F25]={
  ["category"]="ll",
  ["contextname"]="greeketadasiatonos",
  ["description"]="GREEK SMALL LETTER ETA WITH DASIA AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F21, 0x0301 },
  ["uccode"]=0x1F2D,
  ["unicodeslot"]=0x1F25, -- ἥ
 },
 [0x1F26]={
  ["category"]="ll",
  ["contextname"]="greeketapsiliperispomeni",
  ["description"]="GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F20, 0x0342 },
  ["uccode"]=0x1F2E,
  ["unicodeslot"]=0x1F26, -- ἦ
 },
 [0x1F27]={
  ["category"]="ll",
  ["contextname"]="greeketadasiaperispomeni",
  ["description"]="GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F21, 0x0342 },
  ["uccode"]=0x1F2F,
  ["unicodeslot"]=0x1F27, -- ἧ
 },
 [0x1F28]={
  ["category"]="lu",
  ["contextname"]="greekEtapsili",
  ["description"]="GREEK CAPITAL LETTER ETA WITH PSILI",
  ["lccode"]=0x1F20,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x0397, 0x0313 },
  ["unicodeslot"]=0x1F28, -- Ἠ
 },
 [0x1F29]={
  ["category"]="lu",
  ["contextname"]="greekEtadasia",
  ["description"]="GREEK CAPITAL LETTER ETA WITH DASIA",
  ["lccode"]=0x1F21,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x0397, 0x0314 },
  ["unicodeslot"]=0x1F29, -- Ἡ
 },
 [0x1F2A]={
  ["category"]="lu",
  ["contextname"]="greekEtapsilivaria",
  ["description"]="GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA",
  ["lccode"]=0x1F22,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F28, 0x0300 },
  ["unicodeslot"]=0x1F2A, -- Ἢ
 },
 [0x1F2B]={
  ["category"]="lu",
  ["contextname"]="greekEtadasiavaria",
  ["description"]="GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA",
  ["lccode"]=0x1F23,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F29, 0x0300 },
  ["unicodeslot"]=0x1F2B, -- Ἣ
 },
 [0x1F2C]={
  ["category"]="lu",
  ["contextname"]="greekEtapsilitonos",
  ["description"]="GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA",
  ["lccode"]=0x1F24,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F28, 0x0301 },
  ["unicodeslot"]=0x1F2C, -- Ἤ
 },
 [0x1F2D]={
  ["category"]="lu",
  ["contextname"]="greekEtadasiatonos",
  ["description"]="GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA",
  ["lccode"]=0x1F25,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F29, 0x0301 },
  ["unicodeslot"]=0x1F2D, -- Ἥ
 },
 [0x1F2E]={
  ["category"]="lu",
  ["contextname"]="greekEtapsiliperispomeni",
  ["description"]="GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI",
  ["lccode"]=0x1F26,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F28, 0x0342 },
  ["unicodeslot"]=0x1F2E, -- Ἦ
 },
 [0x1F2F]={
  ["category"]="lu",
  ["contextname"]="greekEtadasiaperispomeni",
  ["description"]="GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI",
  ["lccode"]=0x1F27,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F29, 0x0342 },
  ["unicodeslot"]=0x1F2F, -- Ἧ
 },
 [0x1F30]={
  ["category"]="ll",
  ["contextname"]="greekiotapsili",
  ["description"]="GREEK SMALL LETTER IOTA WITH PSILI",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03B9, 0x0313 },
  ["uccode"]=0x1F38,
  ["unicodeslot"]=0x1F30, -- ἰ
 },
 [0x1F31]={
  ["category"]="ll",
  ["contextname"]="greekiotadasia",
  ["description"]="GREEK SMALL LETTER IOTA WITH DASIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03B9, 0x0314 },
  ["uccode"]=0x1F39,
  ["unicodeslot"]=0x1F31, -- ἱ
 },
 [0x1F32]={
  ["category"]="ll",
  ["contextname"]="greekiotapsilivaria",
  ["description"]="GREEK SMALL LETTER IOTA WITH PSILI AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x1F30, 0x0300 },
  ["uccode"]=0x1F3A,
  ["unicodeslot"]=0x1F32, -- ἲ
 },
 [0x1F33]={
  ["category"]="ll",
  ["contextname"]="greekiotadasiavaria",
  ["description"]="GREEK SMALL LETTER IOTA WITH DASIA AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x1F31, 0x0300 },
  ["uccode"]=0x1F3B,
  ["unicodeslot"]=0x1F33, -- ἳ
 },
 [0x1F34]={
  ["category"]="ll",
  ["contextname"]="greekiotapsilitonos",
  ["description"]="GREEK SMALL LETTER IOTA WITH PSILI AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x1F30, 0x0301 },
  ["uccode"]=0x1F3C,
  ["unicodeslot"]=0x1F34, -- ἴ
 },
 [0x1F35]={
  ["category"]="ll",
  ["contextname"]="greekiotadasiatonos",
  ["description"]="GREEK SMALL LETTER IOTA WITH DASIA AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x1F31, 0x0301 },
  ["uccode"]=0x1F3D,
  ["unicodeslot"]=0x1F35, -- ἵ
 },
 [0x1F36]={
  ["category"]="ll",
  ["contextname"]="greekiotapsiliperispomeni",
  ["description"]="GREEK SMALL LETTER IOTA WITH PSILI AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x1F30, 0x0342 },
  ["uccode"]=0x1F3E,
  ["unicodeslot"]=0x1F36, -- ἶ
 },
 [0x1F37]={
  ["category"]="ll",
  ["contextname"]="greekiotadasiaperispomeni",
  ["description"]="GREEK SMALL LETTER IOTA WITH DASIA AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x1F31, 0x0342 },
  ["uccode"]=0x1F3F,
  ["unicodeslot"]=0x1F37, -- ἷ
 },
 [0x1F38]={
  ["category"]="lu",
  ["contextname"]="greekIotapsili",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH PSILI",
  ["lccode"]=0x1F30,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x0399, 0x0313 },
  ["unicodeslot"]=0x1F38, -- Ἰ
 },
 [0x1F39]={
  ["category"]="lu",
  ["contextname"]="greekIotadasia",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH DASIA",
  ["lccode"]=0x1F31,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x0399, 0x0314 },
  ["unicodeslot"]=0x1F39, -- Ἱ
 },
 [0x1F3A]={
  ["category"]="lu",
  ["contextname"]="greekIotapsilivaria",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH PSILI AND VARIA",
  ["lccode"]=0x1F32,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x1F38, 0x0300 },
  ["unicodeslot"]=0x1F3A, -- Ἲ
 },
 [0x1F3B]={
  ["category"]="lu",
  ["contextname"]="greekIotadasiavaria",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH DASIA AND VARIA",
  ["lccode"]=0x1F33,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x1F39, 0x0300 },
  ["unicodeslot"]=0x1F3B, -- Ἳ
 },
 [0x1F3C]={
  ["category"]="lu",
  ["contextname"]="greekIotapsilitonos",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH PSILI AND OXIA",
  ["lccode"]=0x1F34,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x1F38, 0x0301 },
  ["unicodeslot"]=0x1F3C, -- Ἴ
 },
 [0x1F3D]={
  ["category"]="lu",
  ["contextname"]="greekIotadasiatonos",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH DASIA AND OXIA",
  ["lccode"]=0x1F35,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x1F39, 0x0301 },
  ["unicodeslot"]=0x1F3D, -- Ἵ
 },
 [0x1F3E]={
  ["category"]="lu",
  ["contextname"]="greekIotapsiliperispomeni",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH PSILI AND PERISPOMENI",
  ["lccode"]=0x1F36,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x1F38, 0x0342 },
  ["unicodeslot"]=0x1F3E, -- Ἶ
 },
 [0x1F3F]={
  ["category"]="lu",
  ["contextname"]="greekIotadasiaperispomeni",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH DASIA AND PERISPOMENI",
  ["lccode"]=0x1F37,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x1F39, 0x0342 },
  ["unicodeslot"]=0x1F3F, -- Ἷ
 },
 [0x1F40]={
  ["category"]="ll",
  ["contextname"]="greekomicronpsili",
  ["description"]="GREEK SMALL LETTER OMICRON WITH PSILI",
  ["linebreak"]="al",
  ["shcode"]=0x03BF,
  ["specials"]={ "char", 0x03BF, 0x0313 },
  ["uccode"]=0x1F48,
  ["unicodeslot"]=0x1F40, -- ὀ
 },
 [0x1F41]={
  ["category"]="ll",
  ["contextname"]="greekomicrondasia",
  ["description"]="GREEK SMALL LETTER OMICRON WITH DASIA",
  ["linebreak"]="al",
  ["shcode"]=0x03BF,
  ["specials"]={ "char", 0x03BF, 0x0314 },
  ["uccode"]=0x1F49,
  ["unicodeslot"]=0x1F41, -- ὁ
 },
 [0x1F42]={
  ["category"]="ll",
  ["contextname"]="greekomicronpsilivaria",
  ["description"]="GREEK SMALL LETTER OMICRON WITH PSILI AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03BF,
  ["specials"]={ "char", 0x1F40, 0x0300 },
  ["uccode"]=0x1F4A,
  ["unicodeslot"]=0x1F42, -- ὂ
 },
 [0x1F43]={
  ["category"]="ll",
  ["contextname"]="greekomicrondasiavaria",
  ["description"]="GREEK SMALL LETTER OMICRON WITH DASIA AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03BF,
  ["specials"]={ "char", 0x1F41, 0x0300 },
  ["uccode"]=0x1F4B,
  ["unicodeslot"]=0x1F43, -- ὃ
 },
 [0x1F44]={
  ["category"]="ll",
  ["contextname"]="greekomicronpsilitonos",
  ["description"]="GREEK SMALL LETTER OMICRON WITH PSILI AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03BF,
  ["specials"]={ "char", 0x1F40, 0x0301 },
  ["uccode"]=0x1F4C,
  ["unicodeslot"]=0x1F44, -- ὄ
 },
 [0x1F45]={
  ["category"]="ll",
  ["contextname"]="greekomicrondasiatonos",
  ["description"]="GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03BF,
  ["specials"]={ "char", 0x1F41, 0x0301 },
  ["uccode"]=0x1F4D,
  ["unicodeslot"]=0x1F45, -- ὅ
 },
 [0x1F48]={
  ["category"]="lu",
  ["contextname"]="greekOmicronpsili",
  ["description"]="GREEK CAPITAL LETTER OMICRON WITH PSILI",
  ["lccode"]=0x1F40,
  ["linebreak"]="al",
  ["shcode"]=0x039F,
  ["specials"]={ "char", 0x039F, 0x0313 },
  ["unicodeslot"]=0x1F48, -- Ὀ
 },
 [0x1F49]={
  ["category"]="lu",
  ["contextname"]="greekOmicrondasia",
  ["description"]="GREEK CAPITAL LETTER OMICRON WITH DASIA",
  ["lccode"]=0x1F41,
  ["linebreak"]="al",
  ["shcode"]=0x039F,
  ["specials"]={ "char", 0x039F, 0x0314 },
  ["unicodeslot"]=0x1F49, -- Ὁ
 },
 [0x1F4A]={
  ["category"]="lu",
  ["contextname"]="greekOmicronpsilivaria",
  ["description"]="GREEK CAPITAL LETTER OMICRON WITH PSILI AND VARIA",
  ["lccode"]=0x1F42,
  ["linebreak"]="al",
  ["shcode"]=0x039F,
  ["specials"]={ "char", 0x1F48, 0x0300 },
  ["unicodeslot"]=0x1F4A, -- Ὂ
 },
 [0x1F4B]={
  ["category"]="lu",
  ["contextname"]="greekOmicrondasiavaria",
  ["description"]="GREEK CAPITAL LETTER OMICRON WITH DASIA AND VARIA",
  ["lccode"]=0x1F43,
  ["linebreak"]="al",
  ["shcode"]=0x039F,
  ["specials"]={ "char", 0x1F49, 0x0300 },
  ["unicodeslot"]=0x1F4B, -- Ὃ
 },
 [0x1F4C]={
  ["category"]="lu",
  ["contextname"]="greekOmicronpsilitonos",
  ["description"]="GREEK CAPITAL LETTER OMICRON WITH PSILI AND OXIA",
  ["lccode"]=0x1F44,
  ["linebreak"]="al",
  ["shcode"]=0x039F,
  ["specials"]={ "char", 0x1F48, 0x0301 },
  ["unicodeslot"]=0x1F4C, -- Ὄ
 },
 [0x1F4D]={
  ["category"]="lu",
  ["contextname"]="greekOmicrondasiatonos",
  ["description"]="GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA",
  ["lccode"]=0x1F45,
  ["linebreak"]="al",
  ["shcode"]=0x039F,
  ["specials"]={ "char", 0x1F49, 0x0301 },
  ["unicodeslot"]=0x1F4D, -- Ὅ
 },
 [0x1F50]={
  ["category"]="ll",
  ["contextname"]="greekupsilonpsili",
  ["description"]="GREEK SMALL LETTER UPSILON WITH PSILI",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03C5, 0x0313 },
  ["unicodeslot"]=0x1F50, -- ὐ
 },
 [0x1F51]={
  ["category"]="ll",
  ["contextname"]="greekupsilondasia",
  ["description"]="GREEK SMALL LETTER UPSILON WITH DASIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03C5, 0x0314 },
  ["uccode"]=0x1F59,
  ["unicodeslot"]=0x1F51, -- ὑ
 },
 [0x1F52]={
  ["category"]="ll",
  ["contextname"]="greekupsilonpsilivaria",
  ["description"]="GREEK SMALL LETTER UPSILON WITH PSILI AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x1F50, 0x0300 },
  ["unicodeslot"]=0x1F52, -- ὒ
 },
 [0x1F53]={
  ["category"]="ll",
  ["contextname"]="greekupsilondasiavaria",
  ["description"]="GREEK SMALL LETTER UPSILON WITH DASIA AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x1F51, 0x0300 },
  ["uccode"]=0x1F5B,
  ["unicodeslot"]=0x1F53, -- ὓ
 },
 [0x1F54]={
  ["category"]="ll",
  ["contextname"]="greekupsilonpsilitonos",
  ["description"]="GREEK SMALL LETTER UPSILON WITH PSILI AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x1F50, 0x0301 },
  ["unicodeslot"]=0x1F54, -- ὔ
 },
 [0x1F55]={
  ["category"]="ll",
  ["contextname"]="greekupsilondasiatonos",
  ["description"]="GREEK SMALL LETTER UPSILON WITH DASIA AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x1F51, 0x0301 },
  ["uccode"]=0x1F5D,
  ["unicodeslot"]=0x1F55, -- ὕ
 },
 [0x1F56]={
  ["category"]="ll",
  ["contextname"]="greekupsilonpsiliperispomeni",
  ["description"]="GREEK SMALL LETTER UPSILON WITH PSILI AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x1F50, 0x0342 },
  ["unicodeslot"]=0x1F56, -- ὖ
 },
 [0x1F57]={
  ["category"]="ll",
  ["contextname"]="greekupsilondasiaperispomeni",
  ["description"]="GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x1F51, 0x0342 },
  ["uccode"]=0x1F5F,
  ["unicodeslot"]=0x1F57, -- ὗ
 },
 [0x1F59]={
  ["category"]="lu",
  ["contextname"]="greekUpsilondasia",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH DASIA",
  ["lccode"]=0x1F51,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x03A5, 0x0314 },
  ["unicodeslot"]=0x1F59, -- Ὑ
 },
 [0x1F5B]={
  ["category"]="lu",
  ["contextname"]="greekUpsilondasiavaria",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA",
  ["lccode"]=0x1F53,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x1F59, 0x0300 },
  ["unicodeslot"]=0x1F5B, -- Ὓ
 },
 [0x1F5D]={
  ["category"]="lu",
  ["contextname"]="greekUpsilondasiatonos",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA",
  ["lccode"]=0x1F55,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x1F59, 0x0301 },
  ["unicodeslot"]=0x1F5D, -- Ὕ
 },
 [0x1F5F]={
  ["category"]="lu",
  ["contextname"]="greekUpsilondasiaperispomeni",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI",
  ["lccode"]=0x1F57,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x1F59, 0x0342 },
  ["unicodeslot"]=0x1F5F, -- Ὗ
 },
 [0x1F60]={
  ["category"]="ll",
  ["contextname"]="greekomegapsili",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PSILI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x03C9, 0x0313 },
  ["uccode"]=0x1F68,
  ["unicodeslot"]=0x1F60, -- ὠ
 },
 [0x1F61]={
  ["category"]="ll",
  ["contextname"]="greekomegadasia",
  ["description"]="GREEK SMALL LETTER OMEGA WITH DASIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x03C9, 0x0314 },
  ["uccode"]=0x1F69,
  ["unicodeslot"]=0x1F61, -- ὡ
 },
 [0x1F62]={
  ["category"]="ll",
  ["contextname"]="greekomegapsilivaria",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F60, 0x0300 },
  ["uccode"]=0x1F6A,
  ["unicodeslot"]=0x1F62, -- ὢ
 },
 [0x1F63]={
  ["category"]="ll",
  ["contextname"]="greekomegadasiavaria",
  ["description"]="GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F61, 0x0300 },
  ["uccode"]=0x1F6B,
  ["unicodeslot"]=0x1F63, -- ὣ
 },
 [0x1F64]={
  ["category"]="ll",
  ["contextname"]="greekomegapsilitonos",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F60, 0x0301 },
  ["uccode"]=0x1F6C,
  ["unicodeslot"]=0x1F64, -- ὤ
 },
 [0x1F65]={
  ["category"]="ll",
  ["contextname"]="greekomegadasiatonos",
  ["description"]="GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F61, 0x0301 },
  ["uccode"]=0x1F6D,
  ["unicodeslot"]=0x1F65, -- ὥ
 },
 [0x1F66]={
  ["category"]="ll",
  ["contextname"]="greekomegapsiliperispomeni",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F60, 0x0342 },
  ["uccode"]=0x1F6E,
  ["unicodeslot"]=0x1F66, -- ὦ
 },
 [0x1F67]={
  ["category"]="ll",
  ["contextname"]="greekomegadasiaperispomeni",
  ["description"]="GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F61, 0x0342 },
  ["uccode"]=0x1F6F,
  ["unicodeslot"]=0x1F67, -- ὧ
 },
 [0x1F68]={
  ["category"]="lu",
  ["contextname"]="greekOmegapsili",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH PSILI",
  ["lccode"]=0x1F60,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x03A9, 0x0313 },
  ["unicodeslot"]=0x1F68, -- Ὠ
 },
 [0x1F69]={
  ["category"]="lu",
  ["contextname"]="greekOmegadasia",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH DASIA",
  ["lccode"]=0x1F61,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x03A9, 0x0314 },
  ["unicodeslot"]=0x1F69, -- Ὡ
 },
 [0x1F6A]={
  ["category"]="lu",
  ["contextname"]="greekOmegapsilivaria",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA",
  ["lccode"]=0x1F62,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F68, 0x0300 },
  ["unicodeslot"]=0x1F6A, -- Ὢ
 },
 [0x1F6B]={
  ["category"]="lu",
  ["contextname"]="greekOmegadasiavaria",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA",
  ["lccode"]=0x1F63,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F69, 0x0300 },
  ["unicodeslot"]=0x1F6B, -- Ὣ
 },
 [0x1F6C]={
  ["category"]="lu",
  ["contextname"]="greekOmegapsilitonos",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA",
  ["lccode"]=0x1F64,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F68, 0x0301 },
  ["unicodeslot"]=0x1F6C, -- Ὤ
 },
 [0x1F6D]={
  ["category"]="lu",
  ["contextname"]="greekOmegadasiatonos",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA",
  ["lccode"]=0x1F65,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F69, 0x0301 },
  ["unicodeslot"]=0x1F6D, -- Ὥ
 },
 [0x1F6E]={
  ["category"]="lu",
  ["contextname"]="greekOmegapsiliperispomeni",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI",
  ["lccode"]=0x1F66,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F68, 0x0342 },
  ["unicodeslot"]=0x1F6E, -- Ὦ
 },
 [0x1F6F]={
  ["category"]="lu",
  ["contextname"]="greekOmegadasiaperispomeni",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI",
  ["lccode"]=0x1F67,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F69, 0x0342 },
  ["unicodeslot"]=0x1F6F, -- Ὧ
 },
 [0x1F70]={
  ["category"]="ll",
  ["contextname"]="greekalphavaria",
  ["description"]="GREEK SMALL LETTER ALPHA WITH VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03B1, 0x0300 },
  ["uccode"]=0x1FBA,
  ["unicodeslot"]=0x1F70, -- ὰ
 },
 [0x1F71]={
  ["category"]="ll",
  ["contextname"]="greekalphaoxia",
  ["description"]="GREEK SMALL LETTER ALPHA WITH OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03AC },
  ["uccode"]=0x1FBB,
  ["unicodeslot"]=0x1F71, -- ά
 },
 [0x1F72]={
  ["category"]="ll",
  ["contextname"]="greekepsilonvaria",
  ["description"]="GREEK SMALL LETTER EPSILON WITH VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B5,
  ["specials"]={ "char", 0x03B5, 0x0300 },
  ["uccode"]=0x1FC8,
  ["unicodeslot"]=0x1F72, -- ὲ
 },
 [0x1F73]={
  ["category"]="ll",
  ["contextname"]="greekepsilonoxia",
  ["description"]="GREEK SMALL LETTER EPSILON WITH OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B5,
  ["specials"]={ "char", 0x03AD },
  ["uccode"]=0x1FC9,
  ["unicodeslot"]=0x1F73, -- έ
 },
 [0x1F74]={
  ["category"]="ll",
  ["contextname"]="greeketavaria",
  ["description"]="GREEK SMALL LETTER ETA WITH VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x03B7, 0x0300 },
  ["uccode"]=0x1FCA,
  ["unicodeslot"]=0x1F74, -- ὴ
 },
 [0x1F75]={
  ["category"]="ll",
  ["contextname"]="greeketaoxia",
  ["description"]="GREEK SMALL LETTER ETA WITH OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x03AE },
  ["uccode"]=0x1FCB,
  ["unicodeslot"]=0x1F75, -- ή
 },
 [0x1F76]={
  ["category"]="ll",
  ["contextname"]="greekiotavaria",
  ["description"]="GREEK SMALL LETTER IOTA WITH VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03B9, 0x0300 },
  ["uccode"]=0x1FDA,
  ["unicodeslot"]=0x1F76, -- ὶ
 },
 [0x1F77]={
  ["category"]="ll",
  ["contextname"]="greekiotaoxia",
  ["description"]="GREEK SMALL LETTER IOTA WITH OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03AF },
  ["uccode"]=0x1FDB,
  ["unicodeslot"]=0x1F77, -- ί
 },
 [0x1F78]={
  ["category"]="ll",
  ["contextname"]="greekomicronvaria",
  ["description"]="GREEK SMALL LETTER OMICRON WITH VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03BF,
  ["specials"]={ "char", 0x03BF, 0x0300 },
  ["uccode"]=0x1FF8,
  ["unicodeslot"]=0x1F78, -- ὸ
 },
 [0x1F79]={
  ["category"]="ll",
  ["contextname"]="greekomicronoxia",
  ["description"]="GREEK SMALL LETTER OMICRON WITH OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03BF,
  ["specials"]={ "char", 0x03CC },
  ["uccode"]=0x1FF9,
  ["unicodeslot"]=0x1F79, -- ό
 },
 [0x1F7A]={
  ["category"]="ll",
  ["contextname"]="greekupsilonvaria",
  ["description"]="GREEK SMALL LETTER UPSILON WITH VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03C5, 0x0300 },
  ["uccode"]=0x1FEA,
  ["unicodeslot"]=0x1F7A, -- ὺ
 },
 [0x1F7B]={
  ["category"]="ll",
  ["contextname"]="greekupsilonoxia",
  ["description"]="GREEK SMALL LETTER UPSILON WITH OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03CD },
  ["uccode"]=0x1FEB,
  ["unicodeslot"]=0x1F7B, -- ύ
 },
 [0x1F7C]={
  ["category"]="ll",
  ["contextname"]="greekomegavaria",
  ["description"]="GREEK SMALL LETTER OMEGA WITH VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x03C9, 0x0300 },
  ["uccode"]=0x1FFA,
  ["unicodeslot"]=0x1F7C, -- ὼ
 },
 [0x1F7D]={
  ["category"]="ll",
  ["contextname"]="greekomegaoxia",
  ["description"]="GREEK SMALL LETTER OMEGA WITH OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x03CE },
  ["uccode"]=0x1FFB,
  ["unicodeslot"]=0x1F7D, -- ώ
 },
 [0x1F80]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubpsili",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F00, 0x0345 },
  ["uccode"]=0x1F88,
  ["unicodeslot"]=0x1F80, -- ᾀ
 },
 [0x1F81]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubdasia",
  ["description"]="GREEK SMALL LETTER ALPHA WITH DASIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F01, 0x0345 },
  ["uccode"]=0x1F89,
  ["unicodeslot"]=0x1F81, -- ᾁ
 },
 [0x1F82]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubpsilivaria",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F02, 0x0345 },
  ["uccode"]=0x1F8A,
  ["unicodeslot"]=0x1F82, -- ᾂ
 },
 [0x1F83]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubdasiavaria",
  ["description"]="GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F03, 0x0345 },
  ["uccode"]=0x1F8B,
  ["unicodeslot"]=0x1F83, -- ᾃ
 },
 [0x1F84]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubpsilitonos",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F04, 0x0345 },
  ["uccode"]=0x1F8C,
  ["unicodeslot"]=0x1F84, -- ᾄ
 },
 [0x1F85]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubdasiatonos",
  ["description"]="GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F05, 0x0345 },
  ["uccode"]=0x1F8D,
  ["unicodeslot"]=0x1F85, -- ᾅ
 },
 [0x1F86]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubpsiliperispomeni",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F06, 0x0345 },
  ["uccode"]=0x1F8E,
  ["unicodeslot"]=0x1F86, -- ᾆ
 },
 [0x1F87]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubdasiaperispomeni",
  ["description"]="GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F07, 0x0345 },
  ["uccode"]=0x1F8F,
  ["unicodeslot"]=0x1F87, -- ᾇ
 },
 [0x1F88]={
  ["category"]="lt",
  ["contextname"]="greekAlphaiotasubpsili",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH PSILI AND PROSGEGRAMMENI",
  ["lccode"]=0x1F80,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F08, 0x0345 },
  ["unicodeslot"]=0x1F88, -- ᾈ
 },
 [0x1F89]={
  ["category"]="lt",
  ["contextname"]="greekAlphaiotasubdasia",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH DASIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F81,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F09, 0x0345 },
  ["unicodeslot"]=0x1F89, -- ᾉ
 },
 [0x1F8A]={
  ["category"]="lt",
  ["contextname"]="greekAlphaiotasubpsilivaria",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F82,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F0A, 0x0345 },
  ["unicodeslot"]=0x1F8A, -- ᾊ
 },
 [0x1F8B]={
  ["category"]="lt",
  ["contextname"]="greekAlphaiotasubdasiavaria",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F83,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F0B, 0x0345 },
  ["unicodeslot"]=0x1F8B, -- ᾋ
 },
 [0x1F8C]={
  ["category"]="lt",
  ["contextname"]="greekAlphaiotasubpsilitonos",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F84,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F0C, 0x0345 },
  ["unicodeslot"]=0x1F8C, -- ᾌ
 },
 [0x1F8D]={
  ["category"]="lt",
  ["contextname"]="greekAlphaiotasubdasiatonos",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F85,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F0D, 0x0345 },
  ["unicodeslot"]=0x1F8D, -- ᾍ
 },
 [0x1F8E]={
  ["category"]="lt",
  ["contextname"]="greekAlphaiotasubpsiliperispomeni",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI",
  ["lccode"]=0x1F86,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F0E, 0x0345 },
  ["unicodeslot"]=0x1F8E, -- ᾎ
 },
 [0x1F8F]={
  ["category"]="lt",
  ["contextname"]="greekAlphaiotasubdasiaperispomeni",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI",
  ["lccode"]=0x1F87,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x1F0F, 0x0345 },
  ["unicodeslot"]=0x1F8F, -- ᾏ
 },
 [0x1F90]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubpsili",
  ["description"]="GREEK SMALL LETTER ETA WITH PSILI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F20, 0x0345 },
  ["uccode"]=0x1F98,
  ["unicodeslot"]=0x1F90, -- ᾐ
 },
 [0x1F91]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubdasia",
  ["description"]="GREEK SMALL LETTER ETA WITH DASIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F21, 0x0345 },
  ["uccode"]=0x1F99,
  ["unicodeslot"]=0x1F91, -- ᾑ
 },
 [0x1F92]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubpsilivaria",
  ["description"]="GREEK SMALL LETTER ETA WITH PSILI AND VARIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F22, 0x0345 },
  ["uccode"]=0x1F9A,
  ["unicodeslot"]=0x1F92, -- ᾒ
 },
 [0x1F93]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubdasiavaria",
  ["description"]="GREEK SMALL LETTER ETA WITH DASIA AND VARIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F23, 0x0345 },
  ["uccode"]=0x1F9B,
  ["unicodeslot"]=0x1F93, -- ᾓ
 },
 [0x1F94]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubpsilitonos",
  ["description"]="GREEK SMALL LETTER ETA WITH PSILI AND OXIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F24, 0x0345 },
  ["uccode"]=0x1F9C,
  ["unicodeslot"]=0x1F94, -- ᾔ
 },
 [0x1F95]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubdasiatonos",
  ["description"]="GREEK SMALL LETTER ETA WITH DASIA AND OXIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F25, 0x0345 },
  ["uccode"]=0x1F9D,
  ["unicodeslot"]=0x1F95, -- ᾕ
 },
 [0x1F96]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubpsiliperispomeni",
  ["description"]="GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F26, 0x0345 },
  ["uccode"]=0x1F9E,
  ["unicodeslot"]=0x1F96, -- ᾖ
 },
 [0x1F97]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubdasiaperispomeni",
  ["description"]="GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F27, 0x0345 },
  ["uccode"]=0x1F9F,
  ["unicodeslot"]=0x1F97, -- ᾗ
 },
 [0x1F98]={
  ["category"]="lt",
  ["contextname"]="greekEtaiotasubpsili",
  ["description"]="GREEK CAPITAL LETTER ETA WITH PSILI AND PROSGEGRAMMENI",
  ["lccode"]=0x1F90,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F28, 0x0345 },
  ["unicodeslot"]=0x1F98, -- ᾘ
 },
 [0x1F99]={
  ["category"]="lt",
  ["contextname"]="greekEtaiotasubdasia",
  ["description"]="GREEK CAPITAL LETTER ETA WITH DASIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F91,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F29, 0x0345 },
  ["unicodeslot"]=0x1F99, -- ᾙ
 },
 [0x1F9A]={
  ["category"]="lt",
  ["contextname"]="greekEtaiotasubpsilivaria",
  ["description"]="GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F92,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F2A, 0x0345 },
  ["unicodeslot"]=0x1F9A, -- ᾚ
 },
 [0x1F9B]={
  ["category"]="lt",
  ["contextname"]="greekEtaiotasubdasiavaria",
  ["description"]="GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F93,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F2B, 0x0345 },
  ["unicodeslot"]=0x1F9B, -- ᾛ
 },
 [0x1F9C]={
  ["category"]="lt",
  ["contextname"]="greekEtaiotasubpsilitonos",
  ["description"]="GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F94,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F2C, 0x0345 },
  ["unicodeslot"]=0x1F9C, -- ᾜ
 },
 [0x1F9D]={
  ["category"]="lt",
  ["contextname"]="greekEtaiotasubdasiatonos",
  ["description"]="GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1F95,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F2D, 0x0345 },
  ["unicodeslot"]=0x1F9D, -- ᾝ
 },
 [0x1F9E]={
  ["category"]="lt",
  ["contextname"]="greekEtaiotasubpsiliperispomeni",
  ["description"]="GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI",
  ["lccode"]=0x1F96,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F2E, 0x0345 },
  ["unicodeslot"]=0x1F9E, -- ᾞ
 },
 [0x1F9F]={
  ["category"]="lt",
  ["contextname"]="greekEtaiotasubdasiaperispomeni",
  ["description"]="GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI",
  ["lccode"]=0x1F97,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x1F2F, 0x0345 },
  ["unicodeslot"]=0x1F9F, -- ᾟ
 },
 [0x1FA0]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubpsili",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PSILI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F60, 0x0345 },
  ["uccode"]=0x1FA8,
  ["unicodeslot"]=0x1FA0, -- ᾠ
 },
 [0x1FA1]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubdasia",
  ["description"]="GREEK SMALL LETTER OMEGA WITH DASIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F61, 0x0345 },
  ["uccode"]=0x1FA9,
  ["unicodeslot"]=0x1FA1, -- ᾡ
 },
 [0x1FA2]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubpsilivaria",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F62, 0x0345 },
  ["uccode"]=0x1FAA,
  ["unicodeslot"]=0x1FA2, -- ᾢ
 },
 [0x1FA3]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubdasiavaria",
  ["description"]="GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F63, 0x0345 },
  ["uccode"]=0x1FAB,
  ["unicodeslot"]=0x1FA3, -- ᾣ
 },
 [0x1FA4]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubpsilitonos",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F64, 0x0345 },
  ["uccode"]=0x1FAC,
  ["unicodeslot"]=0x1FA4, -- ᾤ
 },
 [0x1FA5]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubdasiatonos",
  ["description"]="GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F65, 0x0345 },
  ["uccode"]=0x1FAD,
  ["unicodeslot"]=0x1FA5, -- ᾥ
 },
 [0x1FA6]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubpsiliperispomeni",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F66, 0x0345 },
  ["uccode"]=0x1FAE,
  ["unicodeslot"]=0x1FA6, -- ᾦ
 },
 [0x1FA7]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubdasiaperispomeni",
  ["description"]="GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F67, 0x0345 },
  ["uccode"]=0x1FAF,
  ["unicodeslot"]=0x1FA7, -- ᾧ
 },
 [0x1FA8]={
  ["category"]="lt",
  ["contextname"]="greekOmegaiotasubpsili",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH PSILI AND PROSGEGRAMMENI",
  ["lccode"]=0x1FA0,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F68, 0x0345 },
  ["unicodeslot"]=0x1FA8, -- ᾨ
 },
 [0x1FA9]={
  ["category"]="lt",
  ["contextname"]="greekOmegaiotasubdasia",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH DASIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1FA1,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F69, 0x0345 },
  ["unicodeslot"]=0x1FA9, -- ᾩ
 },
 [0x1FAA]={
  ["category"]="lt",
  ["contextname"]="greekOmegaiotasubpsilivaria",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1FA2,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F6A, 0x0345 },
  ["unicodeslot"]=0x1FAA, -- ᾪ
 },
 [0x1FAB]={
  ["category"]="lt",
  ["contextname"]="greekOmegaiotasubdasiavaria",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1FA3,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F6B, 0x0345 },
  ["unicodeslot"]=0x1FAB, -- ᾫ
 },
 [0x1FAC]={
  ["category"]="lt",
  ["contextname"]="greekOmegaiotasubpsilitonos",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1FA4,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F6C, 0x0345 },
  ["unicodeslot"]=0x1FAC, -- ᾬ
 },
 [0x1FAD]={
  ["category"]="lt",
  ["contextname"]="greekOmegaiotasubdasiatonos",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA AND PROSGEGRAMMENI",
  ["lccode"]=0x1FA5,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F6D, 0x0345 },
  ["unicodeslot"]=0x1FAD, -- ᾭ
 },
 [0x1FAE]={
  ["category"]="lt",
  ["contextname"]="greekOmegaiotasubpsiliperispomeni",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI",
  ["lccode"]=0x1FA6,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F6E, 0x0345 },
  ["unicodeslot"]=0x1FAE, -- ᾮ
 },
 [0x1FAF]={
  ["category"]="lt",
  ["contextname"]="greekOmegaiotasubdasiaperispomeni",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI",
  ["lccode"]=0x1FA7,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x1F6F, 0x0345 },
  ["unicodeslot"]=0x1FAF, -- ᾯ
 },
 [0x1FB0]={
  ["category"]="ll",
  ["contextname"]="greekalphavrachy",
  ["description"]="GREEK SMALL LETTER ALPHA WITH VRACHY",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03B1, 0x0306 },
  ["uccode"]=0x1FB8,
  ["unicodeslot"]=0x1FB0, -- ᾰ
 },
 [0x1FB1]={
  ["category"]="ll",
  ["contextname"]="greekalphamacron",
  ["description"]="GREEK SMALL LETTER ALPHA WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03B1, 0x0304 },
  ["uccode"]=0x1FB9,
  ["unicodeslot"]=0x1FB1, -- ᾱ
 },
 [0x1FB2]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubvaria",
  ["description"]="GREEK SMALL LETTER ALPHA WITH VARIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1F70, 0x0345 },
  ["unicodeslot"]=0x1FB2, -- ᾲ
 },
 [0x1FB3]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasub",
  ["description"]="GREEK SMALL LETTER ALPHA WITH YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03B1, 0x0345 },
  ["uccode"]=0x1FBC,
  ["unicodeslot"]=0x1FB3, -- ᾳ
 },
 [0x1FB4]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubtonos",
  ["description"]="GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03AC, 0x0345 },
  ["unicodeslot"]=0x1FB4, -- ᾴ
 },
 [0x1FB6]={
  ["category"]="ll",
  ["contextname"]="greekalphaperispomeni",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x03B1, 0x0342 },
  ["unicodeslot"]=0x1FB6, -- ᾶ
 },
 [0x1FB7]={
  ["category"]="ll",
  ["contextname"]="greekalphaiotasubperispomeni",
  ["description"]="GREEK SMALL LETTER ALPHA WITH PERISPOMENI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B1,
  ["specials"]={ "char", 0x1FB6, 0x0345 },
  ["unicodeslot"]=0x1FB7, -- ᾷ
 },
 [0x1FB8]={
  ["category"]="lu",
  ["contextname"]="greekAlphavrachy",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH VRACHY",
  ["lccode"]=0x1FB0,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x0391, 0x0306 },
  ["unicodeslot"]=0x1FB8, -- Ᾰ
 },
 [0x1FB9]={
  ["category"]="lu",
  ["contextname"]="greekAlphamacron",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH MACRON",
  ["lccode"]=0x1FB1,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x0391, 0x0304 },
  ["unicodeslot"]=0x1FB9, -- Ᾱ
 },
 [0x1FBA]={
  ["category"]="lu",
  ["contextname"]="greekAlphavaria",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH VARIA",
  ["lccode"]=0x1F70,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x0391, 0x0300 },
  ["unicodeslot"]=0x1FBA, -- Ὰ
 },
 [0x1FBB]={
  ["category"]="lu",
  ["contextname"]="greekAlphatonos",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH OXIA",
  ["lccode"]=0x1F71,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x0386 },
  ["unicodeslot"]=0x1FBB, -- Ά
 },
 [0x1FBC]={
  ["category"]="lt",
  ["contextname"]="greekAlphaiotasub",
  ["description"]="GREEK CAPITAL LETTER ALPHA WITH PROSGEGRAMMENI",
  ["lccode"]=0x1FB3,
  ["linebreak"]="al",
  ["shcode"]=0x0391,
  ["specials"]={ "char", 0x0391, 0x0345 },
  ["unicodeslot"]=0x1FBC, -- ᾼ
 },
 [0x1FBD]={
  ["category"]="sk",
  ["contextname"]="greekCoronis",
  ["description"]="GREEK KORONIS",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0313 },
  ["unicodeslot"]=0x1FBD, -- ᾽
 },
 [0x1FBE]={
  ["category"]="ll",
  ["contextname"]="greekprosgegrammeni",
  ["description"]="GREEK PROSGEGRAMMENI",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x03B9 },
  ["uccode"]=0x0399,
  ["unicodeslot"]=0x1FBE, -- ι
 },
 [0x1FBF]={
  ["category"]="sk",
  ["contextname"]="greekpsili",
  ["description"]="GREEK PSILI",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0313 },
  ["unicodeslot"]=0x1FBF, -- ᾿
 },
 [0x1FC0]={
  ["category"]="sk",
  ["contextname"]="greekperispomeni",
  ["description"]="GREEK PERISPOMENI",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0342 },
  ["unicodeslot"]=0x1FC0, -- ῀
 },
 [0x1FC1]={
  ["category"]="sk",
  ["contextname"]="greekdialytikaperispomeni",
  ["description"]="GREEK DIALYTIKA AND PERISPOMENI",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x00A8, 0x0342 },
  ["unicodeslot"]=0x1FC1, -- ῁
 },
 [0x1FC2]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubvaria",
  ["description"]="GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1F74, 0x0345 },
  ["unicodeslot"]=0x1FC2, -- ῂ
 },
 [0x1FC3]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasub",
  ["description"]="GREEK SMALL LETTER ETA WITH YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x03B7, 0x0345 },
  ["uccode"]=0x1FCC,
  ["unicodeslot"]=0x1FC3, -- ῃ
 },
 [0x1FC4]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubtonos",
  ["description"]="GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x03AE, 0x0345 },
  ["unicodeslot"]=0x1FC4, -- ῄ
 },
 [0x1FC6]={
  ["category"]="ll",
  ["contextname"]="greeketaperispomeni",
  ["description"]="GREEK SMALL LETTER ETA WITH PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x03B7, 0x0342 },
  ["unicodeslot"]=0x1FC6, -- ῆ
 },
 [0x1FC7]={
  ["category"]="ll",
  ["contextname"]="greeketaiotasubperispomeni",
  ["description"]="GREEK SMALL LETTER ETA WITH PERISPOMENI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B7,
  ["specials"]={ "char", 0x1FC6, 0x0345 },
  ["unicodeslot"]=0x1FC7, -- ῇ
 },
 [0x1FC8]={
  ["category"]="lu",
  ["contextname"]="greekEpsilonvaria",
  ["description"]="GREEK CAPITAL LETTER EPSILON WITH VARIA",
  ["lccode"]=0x1F72,
  ["linebreak"]="al",
  ["shcode"]=0x0395,
  ["specials"]={ "char", 0x0395, 0x0300 },
  ["unicodeslot"]=0x1FC8, -- Ὲ
 },
 [0x1FC9]={
  ["category"]="lu",
  ["contextname"]="greekEpsilontonos",
  ["description"]="GREEK CAPITAL LETTER EPSILON WITH OXIA",
  ["lccode"]=0x1F73,
  ["linebreak"]="al",
  ["shcode"]=0x0395,
  ["specials"]={ "char", 0x0388 },
  ["unicodeslot"]=0x1FC9, -- Έ
 },
 [0x1FCA]={
  ["category"]="lu",
  ["contextname"]="greekEtavaria",
  ["description"]="GREEK CAPITAL LETTER ETA WITH VARIA",
  ["lccode"]=0x1F74,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x0397, 0x0300 },
  ["unicodeslot"]=0x1FCA, -- Ὴ
 },
 [0x1FCB]={
  ["category"]="lu",
  ["contextname"]="greekEtatonos",
  ["description"]="GREEK CAPITAL LETTER ETA WITH OXIA",
  ["lccode"]=0x1F75,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x0389 },
  ["unicodeslot"]=0x1FCB, -- Ή
 },
 [0x1FCC]={
  ["category"]="lt",
  ["contextname"]="greekEtaiotasub",
  ["description"]="GREEK CAPITAL LETTER ETA WITH PROSGEGRAMMENI",
  ["lccode"]=0x1FC3,
  ["linebreak"]="al",
  ["shcode"]=0x0397,
  ["specials"]={ "char", 0x0397, 0x0345 },
  ["unicodeslot"]=0x1FCC, -- ῌ
 },
 [0x1FCD]={
  ["category"]="sk",
  ["contextname"]="greekpsilivaria",
  ["description"]="GREEK PSILI AND VARIA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1FBF, 0x0300 },
  ["unicodeslot"]=0x1FCD, -- ῍
 },
 [0x1FCE]={
  ["category"]="sk",
  ["contextname"]="greekpsilitonos",
  ["description"]="GREEK PSILI AND OXIA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1FBF, 0x0301 },
  ["unicodeslot"]=0x1FCE, -- ῎
 },
 [0x1FCF]={
  ["category"]="sk",
  ["contextname"]="greekpsiliperispomeni",
  ["description"]="GREEK PSILI AND PERISPOMENI",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1FBF, 0x0342 },
  ["unicodeslot"]=0x1FCF, -- ῏
 },
 [0x1FD0]={
  ["category"]="ll",
  ["contextname"]="greekiotavrachy",
  ["description"]="GREEK SMALL LETTER IOTA WITH VRACHY",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03B9, 0x0306 },
  ["uccode"]=0x1FD8,
  ["unicodeslot"]=0x1FD0, -- ῐ
 },
 [0x1FD1]={
  ["category"]="ll",
  ["contextname"]="greekiotamacron",
  ["description"]="GREEK SMALL LETTER IOTA WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03B9, 0x0304 },
  ["uccode"]=0x1FD9,
  ["unicodeslot"]=0x1FD1, -- ῑ
 },
 [0x1FD2]={
  ["category"]="ll",
  ["contextname"]="greekiotadialytikavaria",
  ["description"]="GREEK SMALL LETTER IOTA WITH DIALYTIKA AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03CA, 0x0300 },
  ["unicodeslot"]=0x1FD2, -- ῒ
 },
 [0x1FD3]={
  ["category"]="ll",
  ["contextname"]="greekiotadialytikatonos",
  ["description"]="GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x0390 },
  ["unicodeslot"]=0x1FD3, -- ΐ
 },
 [0x1FD6]={
  ["category"]="ll",
  ["contextname"]="greekiotaperispomeni",
  ["description"]="GREEK SMALL LETTER IOTA WITH PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03B9, 0x0342 },
  ["unicodeslot"]=0x1FD6, -- ῖ
 },
 [0x1FD7]={
  ["category"]="ll",
  ["contextname"]="greekiotadialytikaperispomeni",
  ["description"]="GREEK SMALL LETTER IOTA WITH DIALYTIKA AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03B9,
  ["specials"]={ "char", 0x03CA, 0x0342 },
  ["unicodeslot"]=0x1FD7, -- ῗ
 },
 [0x1FD8]={
  ["category"]="lu",
  ["contextname"]="greekIotavrachy",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH VRACHY",
  ["lccode"]=0x1FD0,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x0399, 0x0306 },
  ["unicodeslot"]=0x1FD8, -- Ῐ
 },
 [0x1FD9]={
  ["category"]="lu",
  ["contextname"]="greekIotamacron",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH MACRON",
  ["lccode"]=0x1FD1,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x0399, 0x0304 },
  ["unicodeslot"]=0x1FD9, -- Ῑ
 },
 [0x1FDA]={
  ["category"]="lu",
  ["contextname"]="greekIotavaria",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH VARIA",
  ["lccode"]=0x1F76,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x0399, 0x0300 },
  ["unicodeslot"]=0x1FDA, -- Ὶ
 },
 [0x1FDB]={
  ["category"]="lu",
  ["contextname"]="greekIotatonos",
  ["description"]="GREEK CAPITAL LETTER IOTA WITH OXIA",
  ["lccode"]=0x1F77,
  ["linebreak"]="al",
  ["shcode"]=0x0399,
  ["specials"]={ "char", 0x038A },
  ["unicodeslot"]=0x1FDB, -- Ί
 },
 [0x1FDD]={
  ["category"]="sk",
  ["contextname"]="greekdasiavaria",
  ["description"]="GREEK DASIA AND VARIA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1FFE, 0x0300 },
  ["unicodeslot"]=0x1FDD, -- ῝
 },
 [0x1FDE]={
  ["category"]="sk",
  ["contextname"]="greekdasiatonos",
  ["description"]="GREEK DASIA AND OXIA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1FFE, 0x0301 },
  ["unicodeslot"]=0x1FDE, -- ῞
 },
 [0x1FDF]={
  ["category"]="sk",
  ["contextname"]="greekdasiaperispomeni",
  ["description"]="GREEK DASIA AND PERISPOMENI",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1FFE, 0x0342 },
  ["unicodeslot"]=0x1FDF, -- ῟
 },
 [0x1FE0]={
  ["category"]="ll",
  ["contextname"]="greekupsilonvrachy",
  ["description"]="GREEK SMALL LETTER UPSILON WITH VRACHY",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03C5, 0x0306 },
  ["uccode"]=0x1FE8,
  ["unicodeslot"]=0x1FE0, -- ῠ
 },
 [0x1FE1]={
  ["category"]="ll",
  ["contextname"]="greekupsilonmacron",
  ["description"]="GREEK SMALL LETTER UPSILON WITH MACRON",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03C5, 0x0304 },
  ["uccode"]=0x1FE9,
  ["unicodeslot"]=0x1FE1, -- ῡ
 },
 [0x1FE2]={
  ["category"]="ll",
  ["contextname"]="greekupsilondialytikavaria",
  ["description"]="GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND VARIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03CB, 0x0300 },
  ["unicodeslot"]=0x1FE2, -- ῢ
 },
 [0x1FE3]={
  ["category"]="ll",
  ["contextname"]="greekupsilondialytikatonos",
  ["description"]="GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND OXIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03B0 },
  ["unicodeslot"]=0x1FE3, -- ΰ
 },
 [0x1FE4]={
  ["category"]="ll",
  ["contextname"]="greekrhopsili",
  ["description"]="GREEK SMALL LETTER RHO WITH PSILI",
  ["linebreak"]="al",
  ["shcode"]=0x03C1,
  ["specials"]={ "char", 0x03C1, 0x0313 },
  ["unicodeslot"]=0x1FE4, -- ῤ
 },
 [0x1FE5]={
  ["category"]="ll",
  ["contextname"]="greekrhodasia",
  ["description"]="GREEK SMALL LETTER RHO WITH DASIA",
  ["linebreak"]="al",
  ["shcode"]=0x03C1,
  ["specials"]={ "char", 0x03C1, 0x0314 },
  ["uccode"]=0x1FEC,
  ["unicodeslot"]=0x1FE5, -- ῥ
 },
 [0x1FE6]={
  ["category"]="ll",
  ["contextname"]="greekupsilonperispomeni",
  ["description"]="GREEK SMALL LETTER UPSILON WITH PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03C5, 0x0342 },
  ["unicodeslot"]=0x1FE6, -- ῦ
 },
 [0x1FE7]={
  ["category"]="ll",
  ["contextname"]="greekupsilondialytikaperispomeni",
  ["description"]="GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C5,
  ["specials"]={ "char", 0x03CB, 0x0342 },
  ["unicodeslot"]=0x1FE7, -- ῧ
 },
 [0x1FE8]={
  ["category"]="lu",
  ["contextname"]="greekUpsilonvrachy",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH VRACHY",
  ["lccode"]=0x1FE0,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x03A5, 0x0306 },
  ["unicodeslot"]=0x1FE8, -- Ῠ
 },
 [0x1FE9]={
  ["category"]="lu",
  ["contextname"]="greekUpsilonmacron",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH MACRON",
  ["lccode"]=0x1FE1,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x03A5, 0x0304 },
  ["unicodeslot"]=0x1FE9, -- Ῡ
 },
 [0x1FEA]={
  ["category"]="lu",
  ["contextname"]="greekUpsilonvaria",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH VARIA",
  ["lccode"]=0x1F7A,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x03A5, 0x0300 },
  ["unicodeslot"]=0x1FEA, -- Ὺ
 },
 [0x1FEB]={
  ["category"]="lu",
  ["contextname"]="greekUpsilontonos",
  ["description"]="GREEK CAPITAL LETTER UPSILON WITH OXIA",
  ["lccode"]=0x1F7B,
  ["linebreak"]="al",
  ["shcode"]=0x03A5,
  ["specials"]={ "char", 0x038E },
  ["unicodeslot"]=0x1FEB, -- Ύ
 },
 [0x1FEC]={
  ["category"]="lu",
  ["contextname"]="greekRhodasia",
  ["description"]="GREEK CAPITAL LETTER RHO WITH DASIA",
  ["lccode"]=0x1FE5,
  ["linebreak"]="al",
  ["shcode"]=0x03A1,
  ["specials"]={ "char", 0x03A1, 0x0314 },
  ["unicodeslot"]=0x1FEC, -- Ῥ
 },
 [0x1FED]={
  ["category"]="sk",
  ["contextname"]="greekdialytikavaria",
  ["description"]="GREEK DIALYTIKA AND VARIA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x00A8, 0x0300 },
  ["unicodeslot"]=0x1FED, -- ῭
 },
 [0x1FEE]={
  ["category"]="sk",
  ["contextname"]="greekdialytikatonos",
  ["description"]="GREEK DIALYTIKA AND OXIA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0385 },
  ["unicodeslot"]=0x1FEE, -- ΅
 },
 [0x1FEF]={
  ["category"]="sk",
  ["contextname"]="greekvaria",
  ["description"]="GREEK VARIA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x0060 },
  ["unicodeslot"]=0x1FEF, -- `
 },
 [0x1FF2]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubvaria",
  ["description"]="GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1F7C, 0x0345 },
  ["unicodeslot"]=0x1FF2, -- ῲ
 },
 [0x1FF3]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasub",
  ["description"]="GREEK SMALL LETTER OMEGA WITH YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x03C9, 0x0345 },
  ["uccode"]=0x1FFC,
  ["unicodeslot"]=0x1FF3, -- ῳ
 },
 [0x1FF4]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubtonos",
  ["description"]="GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x03CE, 0x0345 },
  ["unicodeslot"]=0x1FF4, -- ῴ
 },
 [0x1FF6]={
  ["category"]="ll",
  ["contextname"]="greekomegaperispomeni",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PERISPOMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x03C9, 0x0342 },
  ["unicodeslot"]=0x1FF6, -- ῶ
 },
 [0x1FF7]={
  ["category"]="ll",
  ["contextname"]="greekomegaiotasubperispomeni",
  ["description"]="GREEK SMALL LETTER OMEGA WITH PERISPOMENI AND YPOGEGRAMMENI",
  ["linebreak"]="al",
  ["shcode"]=0x03C9,
  ["specials"]={ "char", 0x1FF6, 0x0345 },
  ["unicodeslot"]=0x1FF7, -- ῷ
 },
 [0x1FF8]={
  ["category"]="lu",
  ["contextname"]="greekOmicronvaria",
  ["description"]="GREEK CAPITAL LETTER OMICRON WITH VARIA",
  ["lccode"]=0x1F78,
  ["linebreak"]="al",
  ["shcode"]=0x039F,
  ["specials"]={ "char", 0x039F, 0x0300 },
  ["unicodeslot"]=0x1FF8, -- Ὸ
 },
 [0x1FF9]={
  ["category"]="lu",
  ["contextname"]="greekOmicrontonos",
  ["description"]="GREEK CAPITAL LETTER OMICRON WITH OXIA",
  ["lccode"]=0x1F79,
  ["linebreak"]="al",
  ["shcode"]=0x039F,
  ["specials"]={ "char", 0x038C },
  ["unicodeslot"]=0x1FF9, -- Ό
 },
 [0x1FFA]={
  ["category"]="lu",
  ["contextname"]="greekOmegavaria",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH VARIA",
  ["lccode"]=0x1F7C,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x03A9, 0x0300 },
  ["unicodeslot"]=0x1FFA, -- Ὼ
 },
 [0x1FFB]={
  ["category"]="lu",
  ["contextname"]="greekOmegatonos",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH OXIA",
  ["lccode"]=0x1F7D,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x038F },
  ["unicodeslot"]=0x1FFB, -- Ώ
 },
 [0x1FFC]={
  ["category"]="lt",
  ["contextname"]="greekOmegaiotasub",
  ["description"]="GREEK CAPITAL LETTER OMEGA WITH PROSGEGRAMMENI",
  ["lccode"]=0x1FF3,
  ["linebreak"]="al",
  ["shcode"]=0x03A9,
  ["specials"]={ "char", 0x03A9, 0x0345 },
  ["unicodeslot"]=0x1FFC, -- ῼ
 },
 [0x1FFD]={
  ["category"]="sk",
  ["contextname"]="greekoxia",
  ["description"]="GREEK OXIA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x00B4 },
  ["unicodeslot"]=0x1FFD, -- ´
 },
 [0x1FFE]={
  ["category"]="sk",
  ["contextname"]="greekdasia",
  ["description"]="GREEK DASIA",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0314 },
  ["unicodeslot"]=0x1FFE, -- ῾
 },
 [0x2000]={
  ["category"]="zs",
  ["description"]="EN QUAD",
  ["linebreak"]="ba",
  ["specials"]={ "char", 0x2002 },
  ["unicodeslot"]=0x2000, --  
 },
 [0x2001]={
  ["category"]="zs",
  ["description"]="EM QUAD",
  ["linebreak"]="ba",
  ["specials"]={ "char", 0x2003 },
  ["unicodeslot"]=0x2001, --  
 },
 [0x2002]={
  ["category"]="zs",
  ["contextname"]="enspace",
  ["description"]="EN SPACE",
  ["linebreak"]="ba",
  ["specials"]={ "compat", 0x0020 },
  ["unicodeslot"]=0x2002, --  
 },
 [0x2003]={
  ["category"]="zs",
  ["contextname"]="emspace",
  ["description"]="EM SPACE",
  ["linebreak"]="ba",
  ["specials"]={ "compat", 0x0020 },
  ["unicodeslot"]=0x2003, --  
 },
 [0x2004]={
  ["category"]="zs",
  ["description"]="THREE-PER-EM SPACE",
  ["linebreak"]="ba",
  ["specials"]={ "compat", 0x0020 },
  ["unicodeslot"]=0x2004, --  
 },
 [0x2005]={
  ["category"]="zs",
  ["description"]="FOUR-PER-EM SPACE",
  ["linebreak"]="ba",
  ["specials"]={ "compat", 0x0020 },
  ["unicodeslot"]=0x2005, --  
 },
 [0x2006]={
  ["category"]="zs",
  ["description"]="SIX-PER-EM SPACE",
  ["linebreak"]="ba",
  ["specials"]={ "compat", 0x0020 },
  ["unicodeslot"]=0x2006, --  
 },
 [0x2007]={
  ["category"]="zs",
  ["description"]="FIGURE SPACE",
  ["linebreak"]="gl",
  ["specials"]={ "nobreak", 0x0020 },
  ["unicodeslot"]=0x2007, --  
 },
 [0x2008]={
  ["category"]="zs",
  ["description"]="PUNCTUATION SPACE",
  ["linebreak"]="ba",
  ["specials"]={ "compat", 0x0020 },
  ["unicodeslot"]=0x2008, --  
 },
 [0x2009]={
  ["category"]="zs",
  ["contextname"]="thinspace",
  ["description"]="THIN SPACE",
  ["linebreak"]="ba",
  ["specials"]={ "compat", 0x0020 },
  ["unicodeslot"]=0x2009, --  
 },
 [0x200A]={
  ["category"]="zs",
  ["contextname"]="hairspace",
  ["description"]="HAIR SPACE",
  ["linebreak"]="ba",
  ["specials"]={ "compat", 0x0020 },
  ["unicodeslot"]=0x200A, --  
 },
 [0x200B]={
  ["category"]="cf",
  ["description"]="ZERO WIDTH SPACE",
  ["linebreak"]="zw",
  ["unicodeslot"]=0x200B, -- ​
 },
 [0x200C]={
  ["adobename"]="afii61664",
  ["category"]="cf",
  ["description"]="ZERO WIDTH NON-JOINER",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x200C, -- ‌
 },
 [0x200D]={
  ["adobename"]="afii301",
  ["category"]="cf",
  ["description"]="ZERO WIDTH JOINER",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x200D, -- ‍
 },
 [0x200E]={
  ["adobename"]="afii299",
  ["category"]="cf",
  ["description"]="LEFT-TO-RIGHT MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x200E, -- ‎
 },
 [0x200F]={
  ["adobename"]="afii300",
  ["category"]="cf",
  ["description"]="RIGHT-TO-LEFT MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x200F, -- ‏
 },
 [0x2010]={
  ["category"]="pd",
  ["cjkwd"]="a",
  ["description"]="HYPHEN",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2010, -- ‐
 },
 [0x2011]={
  ["category"]="pd",
  ["description"]="NON-BREAKING HYPHEN",
  ["linebreak"]="gl",
  ["specials"]={ "nobreak", 0x2010 },
  ["unicodeslot"]=0x2011, -- ‑
 },
 [0x2012]={
  ["adobename"]="figuredash",
  ["category"]="pd",
  ["contextname"]="textminus",
  ["description"]="FIGURE DASH",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2012, -- ‒
 },
 [0x2013]={
  ["adobename"]="endash",
  ["category"]="pd",
  ["cjkwd"]="a",
  ["contextname"]="endash",
  ["description"]="EN DASH",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2013, -- –
 },
 [0x2014]={
  ["adobename"]="emdash",
  ["category"]="pd",
  ["cjkwd"]="a",
  ["contextname"]="emdash",
  ["description"]="EM DASH",
  ["linebreak"]="b2",
  ["unicodeslot"]=0x2014, -- —
 },
 [0x2015]={
  ["adobename"]="afii208",
  ["category"]="pd",
  ["cjkwd"]="a",
  ["contextname"]="texthorizontalbar",
  ["description"]="HORIZONTAL BAR",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2015, -- ―
 },
 [0x2016]={
  ["category"]="po",
  ["cjkwd"]="a",
  ["description"]="DOUBLE VERTICAL LINE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2016, -- ‖
 },
 [0x2017]={
  ["adobename"]="underscoredbl",
  ["category"]="po",
  ["description"]="DOUBLE LOW LINE",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0333 },
  ["unicodeslot"]=0x2017, -- ‗
 },
 [0x2018]={
  ["adobename"]="quoteleft",
  ["category"]="pi",
  ["cjkwd"]="a",
  ["contextname"]="quoteleft",
  ["description"]="LEFT SINGLE QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2018, -- ‘
 },
 [0x2019]={
  ["adobename"]="quoteright",
  ["category"]="pf",
  ["cjkwd"]="a",
  ["contextname"]="quoteright",
  ["description"]="RIGHT SINGLE QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2019, -- ’
 },
 [0x201A]={
  ["adobename"]="quotesinglbase",
  ["category"]="ps",
  ["contextname"]="quotesinglebase",
  ["description"]="SINGLE LOW-0x0009 QUOTATION MARK",
  ["linebreak"]="op",
  ["unicodeslot"]=0x201A, -- ‚
 },
 [0x201B]={
  ["adobename"]="quotereversed",
  ["category"]="pi",
  ["description"]="SINGLE HIGH-REVERSED-0x0009 QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x201B, -- ‛
 },
 [0x201C]={
  ["adobename"]="quotedblleft",
  ["category"]="pi",
  ["cjkwd"]="a",
  ["contextname"]="quotedblleft",
  ["description"]="LEFT DOUBLE QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x201C, -- “
 },
 [0x201D]={
  ["adobename"]="quotedblright",
  ["category"]="pf",
  ["cjkwd"]="a",
  ["contextname"]="quotedblright",
  ["description"]="RIGHT DOUBLE QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x201D, -- ”
 },
 [0x201E]={
  ["adobename"]="quotedblbase",
  ["category"]="ps",
  ["contextname"]="quotedblbase",
  ["description"]="DOUBLE LOW-0x0009 QUOTATION MARK",
  ["linebreak"]="op",
  ["unicodeslot"]=0x201E, -- „
 },
 [0x201F]={
  ["category"]="pi",
  ["description"]="DOUBLE HIGH-REVERSED-0x0009 QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x201F, -- ‟
 },
 [0x2020]={
  ["adobename"]="dagger",
  ["category"]="po",
  ["cjkwd"]="a",
  ["contextname"]="textdag",
  ["description"]="DAGGER",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2020, -- †
 },
 [0x2021]={
  ["adobename"]="daggerdbl",
  ["category"]="po",
  ["cjkwd"]="a",
  ["contextname"]="textddag",
  ["description"]="DOUBLE DAGGER",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2021, -- ‡
 },
 [0x2022]={
  ["adobename"]="bullet",
  ["category"]="po",
  ["cjkwd"]="a",
  ["contextname"]="textbullet",
  ["mathclass"]="binary", -- ok? AM: yes
  ["mathname"] = "bullet",
  ["description"]="BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2022, -- •
 },
 [0x2023]={
  ["category"]="po",
  ["description"]="TRIANGULAR BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2023, -- ‣
 },
 [0x2024]={
  ["adobename"]="onedotenleader",
  ["category"]="po",
  ["cjkwd"]="a",
  ["description"]="ONE DOT LEADER",
  ["linebreak"]="in",
  ["specials"]={ "compat", 0x002E },
  ["unicodeslot"]=0x2024, -- ․
 },
 [0x2025]={
  ["adobename"]="twodotenleader",
  ["category"]="po",
  ["cjkwd"]="a",
  ["description"]="TWO DOT LEADER",
  ["linebreak"]="in",
  ["specials"]={ "compat", 0x002E, 0x002E },
  ["unicodeslot"]=0x2025, -- ‥
 },
 [0x2026]={
  ["adobename"]="ellipsis",
  ["category"]="po",
  ["cjkwd"]="a",
  ["contextname"]="textellipsis",
  ["description"]="HORIZONTAL ELLIPSIS",
  ["linebreak"]="in",
  ["specials"]={ "compat", 0x002E, 0x002E, 0x002E },
  ["unicodeslot"]=0x2026, -- …
 },
 [0x2027]={
  ["category"]="po",
  ["cjkwd"]="a",
  ["description"]="HYPHENATION POINT",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2027, -- ‧
 },
 [0x2028]={
  ["category"]="zl",
  ["description"]="LINE SEPARATOR",
  ["linebreak"]="bk",
  ["unicodeslot"]=0x2028, --  
 },
 [0x2029]={
  ["category"]="zp",
  ["description"]="PARAGRAPH SEPARATOR",
  ["linebreak"]="bk",
  ["unicodeslot"]=0x2029, --  
 },
 [0x202A]={
  ["category"]="cf",
  ["description"]="LEFT-TO-RIGHT EMBEDDING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x202A, -- ‪
 },
 [0x202B]={
  ["category"]="cf",
  ["description"]="RIGHT-TO-LEFT EMBEDDING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x202B, -- ‫
 },
 [0x202C]={
  ["adobename"]="afii61573",
  ["category"]="cf",
  ["description"]="POP DIRECTIONAL FORMATTING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x202C, -- ‬
 },
 [0x202D]={
  ["adobename"]="afii61574",
  ["category"]="cf",
  ["description"]="LEFT-TO-RIGHT OVERRIDE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x202D, -- ‭
 },
 [0x202E]={
  ["adobename"]="afii61575",
  ["category"]="cf",
  ["description"]="RIGHT-TO-LEFT OVERRIDE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x202E, -- ‮
 },
 [0x202F]={
  ["category"]="zs",
  ["description"]="NARROW NO-BREAK SPACE",
  ["linebreak"]="gl",
  ["specials"]={ "nobreak", 0x0020 },
  ["unicodeslot"]=0x202F, --  
 },
 [0x2030]={
  ["adobename"]="perthousand",
  ["category"]="po",
  ["cjkwd"]="a",
  ["contextname"]="perthousand",
  ["description"]="PER MILLE SIGN",
  ["linebreak"]="po",
  ["unicodeslot"]=0x2030, -- ‰
 },
 [0x2031]={
  ["category"]="po",
  ["description"]="PER TEN THOUSAND SIGN",
  ["linebreak"]="po",
  ["unicodeslot"]=0x2031, -- ‱
 },
 [0x2032]={
  ["adobename"]="minute",
  ["category"]="po",
  ["cjkwd"]="a",
  ["description"]="PRIME",
  ["linebreak"]="po",
  ["unicodeslot"]=0x2032, -- ′
 },
 [0x2033]={
  ["adobename"]="second",
  ["category"]="po",
  ["cjkwd"]="a",
  ["description"]="DOUBLE PRIME",
  ["linebreak"]="po",
  ["specials"]={ "compat", 0x2032, 0x2032 },
  ["unicodeslot"]=0x2033, -- ″
 },
 [0x2034]={
  ["category"]="po",
  ["description"]="TRIPLE PRIME",
  ["linebreak"]="po",
  ["specials"]={ "compat", 0x2032, 0x2032, 0x2032 },
  ["unicodeslot"]=0x2034, -- ‴
 },
 [0x2035]={
  ["category"]="po",
  ["cjkwd"]="a",
  ["description"]="REVERSED PRIME",
  ["linebreak"]="po",
  ["unicodeslot"]=0x2035, -- ‵
 },
 [0x2036]={
  ["category"]="po",
  ["description"]="REVERSED DOUBLE PRIME",
  ["linebreak"]="po",
  ["specials"]={ "compat", 0x2035, 0x2035 },
  ["unicodeslot"]=0x2036, -- ‶
 },
 [0x2037]={
  ["category"]="po",
  ["description"]="REVERSED TRIPLE PRIME",
  ["linebreak"]="po",
  ["specials"]={ "compat", 0x2035, 0x2035, 0x2035 },
  ["unicodeslot"]=0x2037, -- ‷
 },
 [0x2038]={
  ["category"]="po",
  ["description"]="CARET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2038, -- ‸
 },
 [0x2039]={
  ["adobename"]="guilsinglleft",
  ["category"]="pi",
  ["contextname"]="guilsingleleft",
  ["description"]="SINGLE LEFT-POINTING ANGLE QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2039, -- ‹
 },
 [0x203A]={
  ["adobename"]="guilsinglright",
  ["category"]="pf",
  ["contextname"]="guilsingleright",
  ["description"]="SINGLE RIGHT-POINTING ANGLE QUOTATION MARK",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x203A, -- ›
 },
 [0x203B]={
  ["category"]="po",
  ["cjkwd"]="a",
  ["description"]="REFERENCE MARK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x203B, -- ※
 },
 [0x203C]={
  ["adobename"]="exclamdbl",
  ["category"]="po",
  ["description"]="DOUBLE EXCLAMATION MARK",
  ["linebreak"]="ns",
  ["specials"]={ "compat", 0x0021, 0x0021 },
  ["unicodeslot"]=0x203C, -- ‼
 },
 [0x203D]={
  ["category"]="po",
  ["description"]="INTERROBANG",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x203D, -- ‽
 },
 [0x203E]={
  ["category"]="po",
  ["cjkwd"]="a",
  ["description"]="OVERLINE",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0020, 0x0305 },
  ["unicodeslot"]=0x203E, -- ‾
 },
 [0x203F]={
  ["category"]="pc",
  ["description"]="UNDERTIE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x203F, -- ‿
 },
 [0x2040]={
  ["category"]="pc",
  ["description"]="CHARACTER TIE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2040, -- ⁀
 },
 [0x2041]={
  ["category"]="po",
  ["description"]="CARET INSERTION POINT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2041, -- ⁁
 },
 [0x2042]={
  ["category"]="po",
  ["description"]="ASTERISM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2042, -- ⁂
 },
 [0x2043]={
  ["category"]="po",
  ["description"]="HYPHEN BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2043, -- ⁃
 },
 [0x2044]={
  ["adobename"]="fraction",
  ["category"]="sm",
  ["description"]="FRACTION SLASH",
  ["linebreak"]="is",
  ["unicodeslot"]=0x2044, -- ⁄
 },
 [0x2045]={
  ["category"]="ps",
  ["description"]="LEFT SQUARE BRACKET WITH QUILL",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2045, -- ⁅
 },
 [0x2046]={
  ["category"]="pe",
  ["description"]="RIGHT SQUARE BRACKET WITH QUILL",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2046, -- ⁆
 },
 [0x2047]={
  ["category"]="po",
  ["description"]="DOUBLE QUESTION MARK",
  ["linebreak"]="ns",
  ["specials"]={ "compat", 0x003F, 0x003F },
  ["unicodeslot"]=0x2047, -- ⁇
 },
 [0x2048]={
  ["category"]="po",
  ["description"]="QUESTION EXCLAMATION MARK",
  ["linebreak"]="ns",
  ["specials"]={ "compat", 0x003F, 0x0021 },
  ["unicodeslot"]=0x2048, -- ⁈
 },
 [0x2049]={
  ["category"]="po",
  ["description"]="EXCLAMATION QUESTION MARK",
  ["linebreak"]="ns",
  ["specials"]={ "compat", 0x0021, 0x003F },
  ["unicodeslot"]=0x2049, -- ⁉
 },
 [0x204A]={
  ["category"]="po",
  ["description"]="TIRONIAN SIGN ET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x204A, -- ⁊
 },
 [0x204B]={
  ["category"]="po",
  ["description"]="REVERSED PILCROW SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x204B, -- ⁋
 },
 [0x204C]={
  ["category"]="po",
  ["description"]="BLACK LEFTWARDS BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x204C, -- ⁌
 },
 [0x204D]={
  ["category"]="po",
  ["description"]="BLACK RIGHTWARDS BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x204D, -- ⁍
 },
 [0x204E]={
  ["category"]="po",
  ["description"]="LOW ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x204E, -- ⁎
 },
 [0x204F]={
  ["category"]="po",
  ["description"]="REVERSED SEMICOLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x204F, -- ⁏
 },
 [0x2050]={
  ["category"]="po",
  ["description"]="CLOSE UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2050, -- ⁐
 },
 [0x2051]={
  ["category"]="po",
  ["description"]="TWO ASTERISKS ALIGNED VERTICALLY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2051, -- ⁑
 },
 [0x2052]={
  ["category"]="sm",
  ["description"]="COMMERCIAL MINUS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2052, -- ⁒
 },
 [0x2053]={
  ["category"]="po",
  ["description"]="SWUNG DASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2053, -- ⁓
 },
 [0x2054]={
  ["category"]="pc",
  ["description"]="INVERTED UNDERTIE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2054, -- ⁔
 },
 [0x2055]={
  ["category"]="po",
  ["description"]="FLOWER PUNCTUATION MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2055, -- ⁕
 },
 [0x2056]={
  ["category"]="po",
  ["description"]="THREE DOT PUNCTUATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2056, -- ⁖
 },
 [0x2057]={
  ["category"]="po",
  ["description"]="QUADRUPLE PRIME",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x2032, 0x2032, 0x2032, 0x2032 },
  ["unicodeslot"]=0x2057, -- ⁗
 },
 [0x2058]={
  ["category"]="po",
  ["description"]="FOUR DOT PUNCTUATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2058, -- ⁘
 },
 [0x2059]={
  ["category"]="po",
  ["description"]="FIVE DOT PUNCTUATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2059, -- ⁙
 },
 [0x205A]={
  ["category"]="po",
  ["description"]="TWO DOT PUNCTUATION",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x205A, -- ⁚
 },
 [0x205B]={
  ["category"]="po",
  ["description"]="FOUR DOT MARK",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x205B, -- ⁛
 },
 [0x205C]={
  ["category"]="po",
  ["description"]="DOTTED CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x205C, -- ⁜
 },
 [0x205D]={
  ["category"]="po",
  ["description"]="TRICOLON",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x205D, -- ⁝
 },
 [0x205E]={
  ["category"]="po",
  ["description"]="VERTICAL FOUR DOTS",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x205E, -- ⁞
 },
 [0x205F]={
  ["category"]="zs",
  ["description"]="MEDIUM MATHEMATICAL SPACE",
  ["linebreak"]="ba",
  ["specials"]={ "compat", 0x0020 },
  ["unicodeslot"]=0x205F, --  
 },
 [0x2060]={
  ["category"]="cf",
  ["description"]="WORD JOINER",
  ["linebreak"]="wj",
  ["unicodeslot"]=0x2060, -- ⁠
 },
 [0x2061]={
  ["category"]="cf",
  ["contextcommand"]="relax",
  ["comment"]="maybe: nulloperator",
  ["description"]="FUNCTION APPLICATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2061, -- ⁡
 },
 [0x2062]={
  ["category"]="cf",
  ["description"]="INVISIBLE TIMES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2062, -- ⁢
 },
 [0x2063]={
  ["category"]="cf",
  ["description"]="INVISIBLE SEPARATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2063, -- ⁣
 },
 [0x206A]={
  ["category"]="cf",
  ["description"]="INHIBIT SYMMETRIC SWAPPING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x206A, -- ⁪
 },
 [0x206B]={
  ["category"]="cf",
  ["description"]="ACTIVATE SYMMETRIC SWAPPING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x206B, -- ⁫
 },
 [0x206C]={
  ["category"]="cf",
  ["description"]="INHIBIT ARABIC FORM SHAPING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x206C, -- ⁬
 },
 [0x206D]={
  ["category"]="cf",
  ["description"]="ACTIVATE ARABIC FORM SHAPING",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x206D, -- ⁭
 },
 [0x206E]={
  ["category"]="cf",
  ["description"]="NATIONAL DIGIT SHAPES",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x206E, -- ⁮
 },
 [0x206F]={
  ["category"]="cf",
  ["description"]="NOMINAL DIGIT SHAPES",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x206F, -- ⁯
 },
 [0x2070]={
  ["category"]="no",
  ["description"]="SUPERSCRIPT ZERO",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0030 },
  ["unicodeslot"]=0x2070, -- ⁰
 },
 [0x2071]={
  ["category"]="ll",
  ["description"]="SUPERSCRIPT LATIN SMALL LETTER I",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0069 },
  ["unicodeslot"]=0x2071, -- ⁱ
 },
 [0x2074]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="SUPERSCRIPT FOUR",
  ["linebreak"]="ai",
  ["specials"]={ "super", 0x0034 },
  ["unicodeslot"]=0x2074, -- ⁴
 },
 [0x2075]={
  ["category"]="no",
  ["description"]="SUPERSCRIPT FIVE",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0035 },
  ["unicodeslot"]=0x2075, -- ⁵
 },
 [0x2076]={
  ["category"]="no",
  ["description"]="SUPERSCRIPT SIX",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0036 },
  ["unicodeslot"]=0x2076, -- ⁶
 },
 [0x2077]={
  ["category"]="no",
  ["description"]="SUPERSCRIPT SEVEN",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0037 },
  ["unicodeslot"]=0x2077, -- ⁷
 },
 [0x2078]={
  ["category"]="no",
  ["description"]="SUPERSCRIPT EIGHT",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0038 },
  ["unicodeslot"]=0x2078, -- ⁸
 },
 [0x2079]={
  ["category"]="no",
  ["description"]="SUPERSCRIPT NINE",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0039 },
  ["unicodeslot"]=0x2079, -- ⁹
 },
 [0x207A]={
  ["category"]="sm",
  ["description"]="SUPERSCRIPT PLUS SIGN",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x002B },
  ["unicodeslot"]=0x207A, -- ⁺
 },
 [0x207B]={
  ["category"]="sm",
  ["description"]="SUPERSCRIPT MINUS",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x2212 },
  ["unicodeslot"]=0x207B, -- ⁻
 },
 [0x207C]={
  ["category"]="sm",
  ["description"]="SUPERSCRIPT EQUALS SIGN",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x003D },
  ["unicodeslot"]=0x207C, -- ⁼
 },
 [0x207D]={
  ["category"]="ps",
  ["description"]="SUPERSCRIPT LEFT PARENTHESIS",
  ["linebreak"]="op",
  ["specials"]={ "super", 0x0028 },
  ["unicodeslot"]=0x207D, -- ⁽
 },
 [0x207E]={
  ["category"]="pe",
  ["description"]="SUPERSCRIPT RIGHT PARENTHESIS",
  ["linebreak"]="cl",
  ["specials"]={ "super", 0x0029 },
  ["unicodeslot"]=0x207E, -- ⁾
 },
 [0x207F]={
  ["category"]="ll",
  ["cjkwd"]="a",
  ["description"]="SUPERSCRIPT LATIN SMALL LETTER N",
  ["linebreak"]="ai",
  ["specials"]={ "super", 0x006E },
  ["unicodeslot"]=0x207F, -- ⁿ
 },
 [0x2080]={
  ["category"]="no",
  ["description"]="SUBSCRIPT ZERO",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0030 },
  ["unicodeslot"]=0x2080, -- ₀
 },
 [0x2081]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="SUBSCRIPT ONE",
  ["linebreak"]="ai",
  ["specials"]={ "sub", 0x0031 },
  ["unicodeslot"]=0x2081, -- ₁
 },
 [0x2082]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="SUBSCRIPT TWO",
  ["linebreak"]="ai",
  ["specials"]={ "sub", 0x0032 },
  ["unicodeslot"]=0x2082, -- ₂
 },
 [0x2083]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="SUBSCRIPT THREE",
  ["linebreak"]="ai",
  ["specials"]={ "sub", 0x0033 },
  ["unicodeslot"]=0x2083, -- ₃
 },
 [0x2084]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="SUBSCRIPT FOUR",
  ["linebreak"]="ai",
  ["specials"]={ "sub", 0x0034 },
  ["unicodeslot"]=0x2084, -- ₄
 },
 [0x2085]={
  ["category"]="no",
  ["description"]="SUBSCRIPT FIVE",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0035 },
  ["unicodeslot"]=0x2085, -- ₅
 },
 [0x2086]={
  ["category"]="no",
  ["description"]="SUBSCRIPT SIX",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0036 },
  ["unicodeslot"]=0x2086, -- ₆
 },
 [0x2087]={
  ["category"]="no",
  ["description"]="SUBSCRIPT SEVEN",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0037 },
  ["unicodeslot"]=0x2087, -- ₇
 },
 [0x2088]={
  ["category"]="no",
  ["description"]="SUBSCRIPT EIGHT",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0038 },
  ["unicodeslot"]=0x2088, -- ₈
 },
 [0x2089]={
  ["category"]="no",
  ["description"]="SUBSCRIPT NINE",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0039 },
  ["unicodeslot"]=0x2089, -- ₉
 },
 [0x208A]={
  ["category"]="sm",
  ["description"]="SUBSCRIPT PLUS SIGN",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x002B },
  ["unicodeslot"]=0x208A, -- ₊
 },
 [0x208B]={
  ["category"]="sm",
  ["description"]="SUBSCRIPT MINUS",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x2212 },
  ["unicodeslot"]=0x208B, -- ₋
 },
 [0x208C]={
  ["category"]="sm",
  ["description"]="SUBSCRIPT EQUALS SIGN",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x003D },
  ["unicodeslot"]=0x208C, -- ₌
 },
 [0x208D]={
  ["category"]="ps",
  ["description"]="SUBSCRIPT LEFT PARENTHESIS",
  ["linebreak"]="op",
  ["specials"]={ "sub", 0x0028 },
  ["unicodeslot"]=0x208D, -- ₍
 },
 [0x208E]={
  ["category"]="pe",
  ["description"]="SUBSCRIPT RIGHT PARENTHESIS",
  ["linebreak"]="cl",
  ["specials"]={ "sub", 0x0029 },
  ["unicodeslot"]=0x208E, -- ₎
 },
 [0x2090]={
  ["category"]="lm",
  ["description"]="LATIN SUBSCRIPT SMALL LETTER A",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0061 },
  ["unicodeslot"]=0x2090, -- ₐ
 },
 [0x2091]={
  ["category"]="lm",
  ["description"]="LATIN SUBSCRIPT SMALL LETTER E",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0065 },
  ["unicodeslot"]=0x2091, -- ₑ
 },
 [0x2092]={
  ["category"]="lm",
  ["description"]="LATIN SUBSCRIPT SMALL LETTER O",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x006F },
  ["unicodeslot"]=0x2092, -- ₒ
 },
 [0x2093]={
  ["category"]="lm",
  ["description"]="LATIN SUBSCRIPT SMALL LETTER X",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0078 },
  ["unicodeslot"]=0x2093, -- ₓ
 },
 [0x2094]={
  ["category"]="lm",
  ["description"]="LATIN SUBSCRIPT SMALL LETTER SCHWA",
  ["linebreak"]="al",
  ["specials"]={ "sub", 0x0259 },
  ["unicodeslot"]=0x2094, -- ₔ
 },
 [0x20A0]={
  ["category"]="sc",
  ["description"]="EURO-CURRENCY SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20A0, -- ₠
 },
 [0x20A1]={
  ["adobename"]="colonmonetary",
  ["category"]="sc",
  ["description"]="COLON SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20A1, -- ₡
 },
 [0x20A2]={
  ["category"]="sc",
  ["description"]="CRUZEIRO SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20A2, -- ₢
 },
 [0x20A3]={
  ["adobename"]="franc",
  ["category"]="sc",
  ["description"]="FRENCH FRANC SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20A3, -- ₣
 },
 [0x20A4]={
  ["adobename"]="lira",
  ["category"]="sc",
  ["description"]="LIRA SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20A4, -- ₤
 },
 [0x20A5]={
  ["category"]="sc",
  ["description"]="MILL SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20A5, -- ₥
 },
 [0x20A6]={
  ["category"]="sc",
  ["description"]="NAIRA SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20A6, -- ₦
 },
 [0x20A7]={
  ["adobename"]="peseta",
  ["category"]="sc",
  ["description"]="PESETA SIGN",
  ["linebreak"]="po",
  ["unicodeslot"]=0x20A7, -- ₧
 },
 [0x20A8]={
  ["category"]="sc",
  ["description"]="RUPEE SIGN",
  ["linebreak"]="pr",
  ["specials"]={ "compat", 0x0052, 0x0073 },
  ["unicodeslot"]=0x20A8, -- ₨
 },
 [0x20A9]={
  ["category"]="sc",
  ["cjkwd"]="h",
  ["description"]="WON SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20A9, -- ₩
 },
 [0x20AA]={
  ["adobename"]="afii57636",
  ["category"]="sc",
  ["description"]="NEW SHEQEL SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20AA, -- ₪
 },
 [0x20AB]={
  ["adobename"]="dong",
  ["category"]="sc",
  ["contextname"]="textdong",
  ["description"]="DONG SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20AB, -- ₫
 },
 [0x20AC]={
  ["adobename"]="Euro",
  ["category"]="sc",
  ["cjkwd"]="a",
  ["contextname"]="texteuro",
  ["description"]="EURO SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20AC, -- €
 },
 [0x20AD]={
  ["category"]="sc",
  ["description"]="KIP SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20AD, -- ₭
 },
 [0x20AE]={
  ["category"]="sc",
  ["description"]="TUGRIK SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20AE, -- ₮
 },
 [0x20AF]={
  ["category"]="sc",
  ["description"]="DRACHMA SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20AF, -- ₯
 },
 [0x20B0]={
  ["category"]="sc",
  ["description"]="GERMAN PENNY SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20B0, -- ₰
 },
 [0x20B1]={
  ["category"]="sc",
  ["description"]="PESO SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20B1, -- ₱
 },
 [0x20B2]={
  ["category"]="sc",
  ["description"]="GUARANI SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20B2, -- ₲
 },
 [0x20B3]={
  ["category"]="sc",
  ["description"]="AUSTRAL SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20B3, -- ₳
 },
 [0x20B4]={
  ["category"]="sc",
  ["description"]="HRYVNIA SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20B4, -- ₴
 },
 [0x20B5]={
  ["category"]="sc",
  ["description"]="CEDI SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x20B5, -- ₵
 },
 [0x20D0]={
  ["category"]="mn",
  ["description"]="COMBINING LEFT HARPOON ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D0, -- ⃐
 },
 [0x20D1]={
  ["category"]="mn",
  ["description"]="COMBINING RIGHT HARPOON ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D1, -- ⃑
 },
 [0x20D2]={
  ["category"]="mn",
  ["description"]="COMBINING LONG VERTICAL LINE OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D2, -- ⃒
 },
 [0x20D3]={
  ["category"]="mn",
  ["description"]="COMBINING SHORT VERTICAL LINE OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D3, -- ⃓
 },
 [0x20D4]={
  ["category"]="mn",
  ["description"]="COMBINING ANTICLOCKWISE ARROW ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D4, -- ⃔
 },
 [0x20D5]={
  ["category"]="mn",
  ["description"]="COMBINING CLOCKWISE ARROW ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D5, -- ⃕
 },
 [0x20D6]={
  ["category"]="mn",
  ["description"]="COMBINING LEFT ARROW ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D6, -- ⃖
 },
 [0x20D7]={
  ["category"]="mn",
  ["description"]="COMBINING RIGHT ARROW ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D7, -- ⃗
 },
 [0x20D8]={
  ["category"]="mn",
  ["description"]="COMBINING RING OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D8, -- ⃘
 },
 [0x20D9]={
  ["category"]="mn",
  ["description"]="COMBINING CLOCKWISE RING OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20D9, -- ⃙
 },
 [0x20DA]={
  ["category"]="mn",
  ["description"]="COMBINING ANTICLOCKWISE RING OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20DA, -- ⃚
 },
 [0x20DB]={
  ["category"]="mn",
  ["description"]="COMBINING THREE DOTS ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20DB, -- ⃛
 },
 [0x20DC]={
  ["category"]="mn",
  ["description"]="COMBINING FOUR DOTS ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20DC, -- ⃜
 },
 [0x20DD]={
  ["category"]="me",
  ["description"]="COMBINING ENCLOSING CIRCLE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20DD, -- ⃝
 },
 [0x20DE]={
  ["category"]="me",
  ["description"]="COMBINING ENCLOSING SQUARE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20DE, -- ⃞
 },
 [0x20DF]={
  ["category"]="me",
  ["description"]="COMBINING ENCLOSING DIAMOND",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20DF, -- ⃟
 },
 [0x20E0]={
  ["category"]="me",
  ["description"]="COMBINING ENCLOSING CIRCLE BACKSLASH",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E0, -- ⃠
 },
 [0x20E1]={
  ["category"]="mn",
  ["description"]="COMBINING LEFT RIGHT ARROW ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E1, -- ⃡
 },
 [0x20E2]={
  ["category"]="me",
  ["description"]="COMBINING ENCLOSING SCREEN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E2, -- ⃢
 },
 [0x20E3]={
  ["category"]="me",
  ["description"]="COMBINING ENCLOSING KEYCAP",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E3, -- ⃣
 },
 [0x20E4]={
  ["category"]="me",
  ["description"]="COMBINING ENCLOSING UPWARD POINTING TRIANGLE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E4, -- ⃤
 },
 [0x20E5]={
  ["category"]="mn",
  ["description"]="COMBINING REVERSE SOLIDUS OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E5, -- ⃥
 },
 [0x20E6]={
  ["category"]="mn",
  ["description"]="COMBINING DOUBLE VERTICAL STROKE OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E6, -- ⃦
 },
 [0x20E7]={
  ["category"]="mn",
  ["description"]="COMBINING ANNUITY SYMBOL",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E7, -- ⃧
 },
 [0x20E8]={
  ["category"]="mn",
  ["description"]="COMBINING TRIPLE UNDERDOT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E8, -- ⃨
 },
 [0x20E9]={
  ["category"]="mn",
  ["description"]="COMBINING WIDE BRIDGE ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20E9, -- ⃩
 },
 [0x20EA]={
  ["category"]="mn",
  ["description"]="COMBINING LEFTWARDS ARROW OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20EA, -- ⃪
 },
 [0x20EB]={
  ["category"]="mn",
  ["description"]="COMBINING LONG DOUBLE SOLIDUS OVERLAY",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20EB, -- ⃫
 },
 [0x20EC]={
  ["category"]="mn",
  ["description"]="COMBINING RIGHTWARDS HARPOON WITH BARB DOWNWARDS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20EC, -- ⃬
 },
 [0x20ED]={
  ["category"]="mn",
  ["description"]="COMBINING LEFTWARDS HARPOON WITH BARB DOWNWARDS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20ED, -- ⃭
 },
 [0x20EE]={
  ["category"]="mn",
  ["description"]="COMBINING LEFT ARROW BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20EE, -- ⃮
 },
 [0x20EF]={
  ["category"]="mn",
  ["description"]="COMBINING RIGHT ARROW BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x20EF, -- ⃯
 },
 [0x2100]={
  ["category"]="so",
  ["description"]="ACCOUNT OF",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0061, 0x002F, 0x0063 },
  ["unicodeslot"]=0x2100, -- ℀
 },
 [0x2101]={
  ["category"]="so",
  ["description"]="ADDRESSED TO THE SUBJECT",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0061, 0x002F, 0x0073 },
  ["unicodeslot"]=0x2101, -- ℁
 },
 [0x2102]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x2102, -- ℂ
 },
 [0x2103]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="DEGREE CELSIUS",
  ["linebreak"]="po",
  ["specials"]={ "compat", 0x00B0, 0x0043 },
  ["unicodeslot"]=0x2103, -- ℃
 },
 [0x2104]={
  ["category"]="so",
  ["description"]="CENTRE LINE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2104, -- ℄
 },
 [0x2105]={
  ["adobename"]="afii61248",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CARE OF",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0063, 0x002F, 0x006F },
  ["unicodeslot"]=0x2105, -- ℅
 },
 [0x2106]={
  ["category"]="so",
  ["description"]="CADA UNA",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0063, 0x002F, 0x0075 },
  ["unicodeslot"]=0x2106, -- ℆
 },
 [0x2107]={
  ["category"]="lu",
  ["description"]="EULER CONSTANT",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0190 },
  ["unicodeslot"]=0x2107, -- ℇ
 },
 [0x2108]={
  ["category"]="so",
  ["description"]="SCRUPLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2108, -- ℈
 },
 [0x2109]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="DEGREE FAHRENHEIT",
  ["linebreak"]="po",
  ["specials"]={ "compat", 0x00B0, 0x0046 },
  ["unicodeslot"]=0x2109, -- ℉
 },
 [0x210A]={
  ["category"]="ll",
  ["description"]="SCRIPT SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x210A, -- ℊ
 },
 [0x210B]={
  ["category"]="lu",
  ["description"]="SCRIPT CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x210B, -- ℋ
 },
 [0x210C]={
  ["category"]="lu",
  ["description"]="BLACK-LETTER CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x210C, -- ℌ
 },
 [0x210D]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x210D, -- ℍ
 },
 [0x210E]={
  ["category"]="ll",
  ["description"]="PLANCK CONSTANT",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x210E, -- ℎ
 },
 [0x210F]={
  ["category"]="ll",
  ["description"]="PLANCK CONSTANT OVER TWO PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0127 },
  ["unicodeslot"]=0x210F, -- ℏ
 },
 [0x2110]={
  ["category"]="lu",
  ["description"]="SCRIPT CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x2110, -- ℐ
 },
 [0x2111]={
  ["adobename"]="Ifraktur",
  ["category"]="lu",
  ["description"]="BLACK-LETTER CAPITAL I",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Im",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x2111, -- ℑ
 },
 [0x2112]={
  ["category"]="lu",
  ["description"]="SCRIPT CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x2112, -- ℒ
 },
 [0x2113]={
  ["adobename"]="afii61289",
  ["category"]="ll",
  ["cjkwd"]="a",
  ["description"]="SCRIPT SMALL L",
  ["linebreak"]="ai",
  ["mathclass"]="variable",
  ["mathname"]="ell",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x2113, -- ℓ
 },
 [0x2114]={
  ["category"]="so",
  ["description"]="L B BAR SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2114, -- ℔
 },
 [0x2115]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x2115, -- ℕ
 },
 [0x2116]={
  ["adobename"]="afii61352",
  ["category"]="so",
  ["cjkwd"]="a",
  ["contextname"]="textnumero",
  ["description"]="NUMERO SIGN",
  ["linebreak"]="pr",
  ["specials"]={ "compat", 0x004E, 0x006F },
  ["unicodeslot"]=0x2116, -- №
 },
 [0x2117]={
  ["category"]="so",
  ["description"]="SOUND RECORDING COPYRIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2117, -- ℗
 },
 [0x2118]={
  ["adobename"]="weierstrass",
  ["category"]="so",
  ["description"]="SCRIPT CAPITAL P",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="wp",
  ["unicodeslot"]=0x2118, -- ℘
 },
 [0x2119]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x2119, -- ℙ
 },
 [0x211A]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x211A, -- ℚ
 },
 [0x211B]={
  ["category"]="lu",
  ["description"]="SCRIPT CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x211B, -- ℛ
 },
 [0x211C]={
  ["adobename"]="Rfraktur",
  ["category"]="lu",
  ["description"]="BLACK-LETTER CAPITAL R",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="Re",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x211C, -- ℜ
 },
 [0x211D]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x211D, -- ℝ
 },
 [0x211E]={
  ["adobename"]="prescription",
  ["category"]="so",
  ["description"]="PRESCRIPTION TAKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x211E, -- ℞
 },
 [0x211F]={
  ["category"]="so",
  ["description"]="RESPONSE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x211F, -- ℟
 },
 [0x2120]={
  ["category"]="so",
  ["description"]="SERVICE MARK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x0053, 0x004D },
  ["unicodeslot"]=0x2120, -- ℠
 },
 [0x2121]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="TELEPHONE SIGN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0054, 0x0045, 0x004C },
  ["unicodeslot"]=0x2121, -- ℡
 },
 [0x2122]={
  ["adobename"]="trademark",
  ["category"]="so",
  ["cjkwd"]="a",
  ["contextname"]="trademark",
  ["description"]="TRADE MARK SIGN",
  ["linebreak"]="ai",
  ["specials"]={ "super", 0x0054, 0x004D },
  ["unicodeslot"]=0x2122, -- ™
 },
 [0x2123]={
  ["category"]="so",
  ["description"]="VERSICLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2123, -- ℣
 },
 [0x2124]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x2124, -- ℤ
 },
 [0x2125]={
  ["category"]="so",
  ["description"]="OUNCE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2125, -- ℥
 },
 [0x2126]={
  ["adobename"]="Omega",
  ["category"]="lu",
  ["cjkwd"]="a",
  ["description"]="OHM SIGN",
  ["lccode"]=0x03C9,
  ["linebreak"]="al",
  ["specials"]={ "char", 0x03A9 },
  ["unicodeslot"]=0x2126, -- Ω
 },
 [0x2127]={
  ["category"]="so",
  ["description"]="INVERTED OHM SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2127, -- ℧
 },
 [0x2128]={
  ["category"]="lu",
  ["description"]="BLACK-LETTER CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x2128, -- ℨ
 },
 [0x2129]={
  ["category"]="so",
  ["description"]="TURNED GREEK SMALL LETTER IOTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2129, -- ℩
 },
 [0x212A]={
  ["category"]="lu",
  ["description"]="KELVIN SIGN",
  ["lccode"]=0x006B,
  ["linebreak"]="al",
  ["specials"]={ "char", 0x004B },
  ["unicodeslot"]=0x212A, -- K
 },
 [0x212B]={
  ["category"]="lu",
  ["cjkwd"]="a",
  ["description"]="ANGSTROM SIGN",
  ["lccode"]=0x00E5,
  ["linebreak"]="ai",
  ["specials"]={ "char", 0x00C5 },
  ["unicodeslot"]=0x212B, -- Å
 },
 [0x212C]={
  ["category"]="lu",
  ["description"]="SCRIPT CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x212C, -- ℬ
 },
 [0x212D]={
  ["category"]="lu",
  ["description"]="BLACK-LETTER CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x212D, -- ℭ
 },
 [0x212E]={
  ["adobename"]="estimated",
  ["category"]="so",
  ["description"]="ESTIMATED SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x212E, -- ℮
 },
 [0x212F]={
  ["category"]="ll",
  ["description"]="SCRIPT SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x212F, -- ℯ
 },
 [0x2130]={
  ["category"]="lu",
  ["description"]="SCRIPT CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x2130, -- ℰ
 },
 [0x2131]={
  ["category"]="lu",
  ["description"]="SCRIPT CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x2131, -- ℱ
 },
 [0x2132]={
  ["category"]="lu",
  ["description"]="TURNED CAPITAL F",
  ["lccode"]=0x214E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2132, -- Ⅎ
 },
 [0x2133]={
  ["category"]="lu",
  ["description"]="SCRIPT CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x2133, -- ℳ
 },
 [0x2134]={
  ["category"]="ll",
  ["description"]="SCRIPT SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x2134, -- ℴ
 },
 [0x2135]={
  ["adobename"]="aleph",
  ["category"]="lo",
  ["description"]="ALEF SYMBOL",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="aleph",
  ["specials"]={ "compat", 0x05D0 },
  ["unicodeslot"]=0x2135, -- ℵ
 },
 [0x2136]={
  ["category"]="lo",
  ["description"]="BET SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x05D1 },
  ["unicodeslot"]=0x2136, -- ℶ
 },
 [0x2137]={
  ["category"]="lo",
  ["description"]="GIMEL SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x05D2 },
  ["unicodeslot"]=0x2137, -- ℷ
 },
 [0x2138]={
  ["category"]="lo",
  ["description"]="DALET SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x05D3 },
  ["unicodeslot"]=0x2138, -- ℸ
 },
 [0x2139]={
  ["category"]="ll",
  ["description"]="INFORMATION SOURCE",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x2139, -- ℹ
 },
 [0x213A]={
  ["category"]="so",
  ["description"]="ROTATED CAPITAL Q",
  ["linebreak"]="al",
  ["unicodeslot"]=0x213A, -- ℺
 },
 [0x213B]={
  ["category"]="so",
  ["description"]="FACSIMILE SIGN",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0046, 0x0041, 0x0058 },
  ["unicodeslot"]=0x213B, -- ℻
 },
 [0x213C]={
  ["category"]="ll",
  ["description"]="DOUBLE-STRUCK SMALL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C0 },
  ["unicodeslot"]=0x213C, -- ℼ
 },
 [0x213D]={
  ["category"]="ll",
  ["description"]="DOUBLE-STRUCK SMALL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B3 },
  ["unicodeslot"]=0x213D, -- ℽ
 },
 [0x213E]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK CAPITAL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0393 },
  ["unicodeslot"]=0x213E, -- ℾ
 },
 [0x213F]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK CAPITAL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A0 },
  ["unicodeslot"]=0x213F, -- ℿ
 },
 [0x2140]={
  ["category"]="sm",
  ["description"]="DOUBLE-STRUCK N-ARY SUMMATION",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2211 },
  ["unicodeslot"]=0x2140, -- ⅀
 },
 [0x2141]={
  ["category"]="sm",
  ["description"]="TURNED SANS-SERIF CAPITAL G",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2141, -- ⅁
 },
 [0x2142]={
  ["category"]="sm",
  ["description"]="TURNED SANS-SERIF CAPITAL L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2142, -- ⅂
 },
 [0x2143]={
  ["category"]="sm",
  ["description"]="REVERSED SANS-SERIF CAPITAL L",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2143, -- ⅃
 },
 [0x2144]={
  ["category"]="sm",
  ["description"]="TURNED SANS-SERIF CAPITAL Y",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2144, -- ⅄
 },
 [0x2145]={
  ["category"]="lu",
  ["description"]="DOUBLE-STRUCK ITALIC CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x2145, -- ⅅ
 },
 [0x2146]={
  ["category"]="ll",
  ["description"]="DOUBLE-STRUCK ITALIC SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x2146, -- ⅆ
 },
 [0x2147]={
  ["category"]="ll",
  ["description"]="DOUBLE-STRUCK ITALIC SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x2147, -- ⅇ
 },
 [0x2148]={
  ["category"]="ll",
  ["description"]="DOUBLE-STRUCK ITALIC SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x2148, -- ⅈ
 },
 [0x2149]={
  ["category"]="ll",
  ["description"]="DOUBLE-STRUCK ITALIC SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x2149, -- ⅉ
 },
 [0x214A]={
  ["category"]="so",
  ["description"]="PROPERTY LINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x214A, -- ⅊
 },
 [0x214B]={
  ["category"]="sm",
  ["description"]="TURNED AMPERSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x214B, -- ⅋
 },
 [0x214C]={
  ["category"]="so",
  ["description"]="PER SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x214C, -- ⅌
 },
 [0x214D]={
  ["category"]="so",
  ["description"]="AKTIESELSKAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x214D, -- ⅍
 },
 [0x214E]={
  ["category"]="ll",
  ["description"]="TURNED SMALL F",
  ["linebreak"]="al",
  ["uccode"]=0x2132,
  ["unicodeslot"]=0x214E, -- ⅎ
 },
 [0x2153]={
  ["adobename"]="onethird",
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="onethird",
  ["description"]="VULGAR FRACTION ONE THIRD",
  ["linebreak"]="al",
  ["specials"]={ "fraction", 0x0031, 0x2044, 0x0033 },
  ["unicodeslot"]=0x2153, -- ⅓
 },
 [0x2154]={
  ["adobename"]="twothirds",
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="twothirds",
  ["description"]="VULGAR FRACTION TWO THIRDS",
  ["linebreak"]="ai",
  ["specials"]={ "fraction", 0x0032, 0x2044, 0x0033 },
  ["unicodeslot"]=0x2154, -- ⅔
 },
 [0x2155]={
  ["category"]="no",
  ["contextname"]="onefifth",
  ["description"]="VULGAR FRACTION ONE FIFTH",
  ["linebreak"]="ai",
  ["specials"]={ "fraction", 0x0031, 0x2044, 0x0035 },
  ["unicodeslot"]=0x2155, -- ⅕
 },
 [0x2156]={
  ["category"]="no",
  ["contextname"]="twofifths",
  ["description"]="VULGAR FRACTION TWO FIFTHS",
  ["linebreak"]="al",
  ["specials"]={ "fraction", 0x0032, 0x2044, 0x0035 },
  ["unicodeslot"]=0x2156, -- ⅖
 },
 [0x2157]={
  ["category"]="no",
  ["contextname"]="threefifths",
  ["description"]="VULGAR FRACTION THREE FIFTHS",
  ["linebreak"]="al",
  ["specials"]={ "fraction", 0x0033, 0x2044, 0x0035 },
  ["unicodeslot"]=0x2157, -- ⅗
 },
 [0x2158]={
  ["category"]="no",
  ["contextname"]="fourfifths",
  ["description"]="VULGAR FRACTION FOUR FIFTHS",
  ["linebreak"]="al",
  ["specials"]={ "fraction", 0x0034, 0x2044, 0x0035 },
  ["unicodeslot"]=0x2158, -- ⅘
 },
 [0x2159]={
  ["category"]="no",
  ["contextname"]="onesixth",
  ["description"]="VULGAR FRACTION ONE SIXTH",
  ["linebreak"]="al",
  ["specials"]={ "fraction", 0x0031, 0x2044, 0x0036 },
  ["unicodeslot"]=0x2159, -- ⅙
 },
 [0x215A]={
  ["category"]="no",
  ["contextname"]="fivesixths",
  ["description"]="VULGAR FRACTION FIVE SIXTHS",
  ["linebreak"]="al",
  ["specials"]={ "fraction", 0x0035, 0x2044, 0x0036 },
  ["unicodeslot"]=0x215A, -- ⅚
 },
 [0x215B]={
  ["adobename"]="oneeighth",
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="oneeighth",
  ["description"]="VULGAR FRACTION ONE EIGHTH",
  ["linebreak"]="ai",
  ["specials"]={ "fraction", 0x0031, 0x2044, 0x0038 },
  ["unicodeslot"]=0x215B, -- ⅛
 },
 [0x215C]={
  ["adobename"]="threeeighths",
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="threeeighths",
  ["description"]="VULGAR FRACTION THREE EIGHTHS",
  ["linebreak"]="al",
  ["specials"]={ "fraction", 0x0033, 0x2044, 0x0038 },
  ["unicodeslot"]=0x215C, -- ⅜
 },
 [0x215D]={
  ["adobename"]="fiveeighths",
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="fiveeighths",
  ["description"]="VULGAR FRACTION FIVE EIGHTHS",
  ["linebreak"]="al",
  ["specials"]={ "fraction", 0x0035, 0x2044, 0x0038 },
  ["unicodeslot"]=0x215D, -- ⅝
 },
 [0x215E]={
  ["adobename"]="seveneighths",
  ["category"]="no",
  ["cjkwd"]="a",
  ["contextname"]="seveneighths",
  ["description"]="VULGAR FRACTION SEVEN EIGHTHS",
  ["linebreak"]="ai",
  ["specials"]={ "fraction", 0x0037, 0x2044, 0x0038 },
  ["unicodeslot"]=0x215E, -- ⅞
 },
 [0x215F]={
  ["category"]="no",
  ["description"]="FRACTION NUMERATOR ONE",
  ["linebreak"]="al",
  ["specials"]={ "fraction", 0x0031, 0x2044 },
  ["unicodeslot"]=0x215F, -- ⅟
 },
 [0x2160]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanI",
  ["description"]="ROMAN NUMERAL ONE",
  ["lccode"]=0x2170,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0049 },
  ["unicodeslot"]=0x2160, -- Ⅰ
 },
 [0x2161]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanII",
  ["description"]="ROMAN NUMERAL TWO",
  ["lccode"]=0x2171,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0049, 0x0049 },
  ["unicodeslot"]=0x2161, -- Ⅱ
 },
 [0x2162]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanIII",
  ["description"]="ROMAN NUMERAL THREE",
  ["lccode"]=0x2172,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0049, 0x0049, 0x0049 },
  ["unicodeslot"]=0x2162, -- Ⅲ
 },
 [0x2163]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanIV",
  ["description"]="ROMAN NUMERAL FOUR",
  ["lccode"]=0x2173,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0049, 0x0056 },
  ["unicodeslot"]=0x2163, -- Ⅳ
 },
 [0x2164]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanV",
  ["description"]="ROMAN NUMERAL FIVE",
  ["lccode"]=0x2174,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0056 },
  ["unicodeslot"]=0x2164, -- Ⅴ
 },
 [0x2165]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanVI",
  ["description"]="ROMAN NUMERAL SIX",
  ["lccode"]=0x2175,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0056, 0x0049 },
  ["unicodeslot"]=0x2165, -- Ⅵ
 },
 [0x2166]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanVII",
  ["description"]="ROMAN NUMERAL SEVEN",
  ["lccode"]=0x2176,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0056, 0x0049, 0x0049 },
  ["unicodeslot"]=0x2166, -- Ⅶ
 },
 [0x2167]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanVIII",
  ["description"]="ROMAN NUMERAL EIGHT",
  ["lccode"]=0x2177,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0056, 0x0049, 0x0049, 0x0049 },
  ["unicodeslot"]=0x2167, -- Ⅷ
 },
 [0x2168]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanIX",
  ["description"]="ROMAN NUMERAL NINE",
  ["lccode"]=0x2178,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0049, 0x0058 },
  ["unicodeslot"]=0x2168, -- Ⅸ
 },
 [0x2169]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanX",
  ["description"]="ROMAN NUMERAL TEN",
  ["lccode"]=0x2179,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0058 },
  ["unicodeslot"]=0x2169, -- Ⅹ
 },
 [0x216A]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanXI",
  ["description"]="ROMAN NUMERAL ELEVEN",
  ["lccode"]=0x217A,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0058, 0x0049 },
  ["unicodeslot"]=0x216A, -- Ⅺ
 },
 [0x216B]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanXII",
  ["description"]="ROMAN NUMERAL TWELVE",
  ["lccode"]=0x217B,
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0058, 0x0049, 0x0049 },
  ["unicodeslot"]=0x216B, -- Ⅻ
 },
 [0x216C]={
  ["category"]="nl",
  ["contextname"]="romanL",
  ["description"]="ROMAN NUMERAL FIFTY",
  ["lccode"]=0x217C,
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x004C },
  ["unicodeslot"]=0x216C, -- Ⅼ
 },
 [0x216D]={
  ["category"]="nl",
  ["contextname"]="romanC",
  ["description"]="ROMAN NUMERAL ONE HUNDRED",
  ["lccode"]=0x217D,
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0043 },
  ["unicodeslot"]=0x216D, -- Ⅽ
 },
 [0x216E]={
  ["category"]="nl",
  ["contextname"]="romanD",
  ["description"]="ROMAN NUMERAL FIVE HUNDRED",
  ["lccode"]=0x217E,
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0044 },
  ["unicodeslot"]=0x216E, -- Ⅾ
 },
 [0x216F]={
  ["category"]="nl",
  ["contextname"]="romanM",
  ["description"]="ROMAN NUMERAL ONE THOUSAND",
  ["lccode"]=0x217F,
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x004D },
  ["unicodeslot"]=0x216F, -- Ⅿ
 },
 [0x2170]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romani",
  ["description"]="SMALL ROMAN NUMERAL ONE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0069 },
  ["uccode"]=0x2160,
  ["unicodeslot"]=0x2170, -- ⅰ
 },
 [0x2171]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanii",
  ["description"]="SMALL ROMAN NUMERAL TWO",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0069, 0x0069 },
  ["uccode"]=0x2161,
  ["unicodeslot"]=0x2171, -- ⅱ
 },
 [0x2172]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romaniii",
  ["description"]="SMALL ROMAN NUMERAL THREE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0069, 0x0069, 0x0069 },
  ["uccode"]=0x2162,
  ["unicodeslot"]=0x2172, -- ⅲ
 },
 [0x2173]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romaniv",
  ["description"]="SMALL ROMAN NUMERAL FOUR",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0069, 0x0076 },
  ["uccode"]=0x2163,
  ["unicodeslot"]=0x2173, -- ⅳ
 },
 [0x2174]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanv",
  ["description"]="SMALL ROMAN NUMERAL FIVE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0076 },
  ["uccode"]=0x2164,
  ["unicodeslot"]=0x2174, -- ⅴ
 },
 [0x2175]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanvi",
  ["description"]="SMALL ROMAN NUMERAL SIX",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0076, 0x0069 },
  ["uccode"]=0x2165,
  ["unicodeslot"]=0x2175, -- ⅵ
 },
 [0x2176]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanvii",
  ["description"]="SMALL ROMAN NUMERAL SEVEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0076, 0x0069, 0x0069 },
  ["uccode"]=0x2166,
  ["unicodeslot"]=0x2176, -- ⅶ
 },
 [0x2177]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanviii",
  ["description"]="SMALL ROMAN NUMERAL EIGHT",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0076, 0x0069, 0x0069, 0x0069 },
  ["uccode"]=0x2167,
  ["unicodeslot"]=0x2177, -- ⅷ
 },
 [0x2178]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanix",
  ["description"]="SMALL ROMAN NUMERAL NINE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0069, 0x0078 },
  ["uccode"]=0x2168,
  ["unicodeslot"]=0x2178, -- ⅸ
 },
 [0x2179]={
  ["category"]="nl",
  ["cjkwd"]="a",
  ["contextname"]="romanx",
  ["description"]="SMALL ROMAN NUMERAL TEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0078 },
  ["uccode"]=0x2169,
  ["unicodeslot"]=0x2179, -- ⅹ
 },
 [0x217A]={
  ["category"]="nl",
  ["contextname"]="romanxi",
  ["description"]="SMALL ROMAN NUMERAL ELEVEN",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0078, 0x0069 },
  ["uccode"]=0x216A,
  ["unicodeslot"]=0x217A, -- ⅺ
 },
 [0x217B]={
  ["category"]="nl",
  ["contextname"]="romanxii",
  ["description"]="SMALL ROMAN NUMERAL TWELVE",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0078, 0x0069, 0x0069 },
  ["uccode"]=0x216B,
  ["unicodeslot"]=0x217B, -- ⅻ
 },
 [0x217C]={
  ["category"]="nl",
  ["contextname"]="romanl",
  ["description"]="SMALL ROMAN NUMERAL FIFTY",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x006C },
  ["uccode"]=0x216C,
  ["unicodeslot"]=0x217C, -- ⅼ
 },
 [0x217D]={
  ["category"]="nl",
  ["contextname"]="romanc",
  ["description"]="SMALL ROMAN NUMERAL ONE HUNDRED",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0063 },
  ["uccode"]=0x216D,
  ["unicodeslot"]=0x217D, -- ⅽ
 },
 [0x217E]={
  ["category"]="nl",
  ["contextname"]="romand",
  ["description"]="SMALL ROMAN NUMERAL FIVE HUNDRED",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0064 },
  ["uccode"]=0x216E,
  ["unicodeslot"]=0x217E, -- ⅾ
 },
 [0x217F]={
  ["category"]="nl",
  ["contextname"]="romanm",
  ["description"]="SMALL ROMAN NUMERAL ONE THOUSAND",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x006D },
  ["uccode"]=0x216F,
  ["unicodeslot"]=0x217F, -- ⅿ
 },
 [0x2180]={
  ["category"]="nl",
  ["description"]="ROMAN NUMERAL ONE THOUSAND C D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2180, -- ↀ
 },
 [0x2181]={
  ["category"]="nl",
  ["description"]="ROMAN NUMERAL FIVE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2181, -- ↁ
 },
 [0x2182]={
  ["category"]="nl",
  ["description"]="ROMAN NUMERAL TEN THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2182, -- ↂ
 },
 [0x2183]={
  ["category"]="lu",
  ["description"]="ROMAN NUMERAL REVERSED ONE HUNDRED",
  ["lccode"]=0x2184,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2183, -- Ↄ
 },
 [0x2184]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER REVERSED C",
  ["linebreak"]="al",
  ["uccode"]=0x2183,
  ["unicodeslot"]=0x2184, -- ↄ
 },
 [0x2190]={
  ["adobename"]="arrowleft",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="LEFTWARDS ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="leftarrow",
  ["unicodeslot"]=0x2190, -- ←
 },
 [0x2191]={
  ["adobename"]="arrowup",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="UPWARDS ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="uparraow",
  ["unicodeslot"]=0x2191, -- ↑
 },
 [0x2192]={
  ["adobename"]="arrowright",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="RIGHTWARDS ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="rightarrow",
  ["unicodeslot"]=0x2192, -- →
 },
 [0x2193]={
  ["adobename"]="arrowdown",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="DOWNWARDS ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="downarrow",
  ["unicodeslot"]=0x2193, -- ↓
 },
 [0x2194]={
  ["adobename"]="arrowboth",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="LEFT RIGHT ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="leftrightarrow",
  ["unicodeslot"]=0x2194, -- ↔
 },
 [0x2195]={
  ["adobename"]="arrowupdn",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="UP DOWN ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="updownarrow",
  ["unicodeslot"]=0x2195, -- ↕
 },
 [0x2196]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="NORTH WEST ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="nwarrow",
  ["unicodeslot"]=0x2196, -- ↖
 },
 [0x2197]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="NORTH EAST ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="nearrow",
  ["unicodeslot"]=0x2197, -- ↗
 },
 [0x2198]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="SOUTH EAST ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="searrow",
  ["unicodeslot"]=0x2198, -- ↘
 },
 [0x2199]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="SOUTH WEST ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="swarrow",
  ["unicodeslot"]=0x2199, -- ↙
 },
 [0x219A]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW WITH STROKE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2190, 0x0338 },
  ["unicodeslot"]=0x219A, -- ↚
 },
 [0x219B]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW WITH STROKE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2192, 0x0338 },
  ["unicodeslot"]=0x219B, -- ↛
 },
 [0x219C]={
  ["category"]="so",
  ["description"]="LEFTWARDS WAVE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x219C, -- ↜
 },
 [0x219D]={
  ["category"]="so",
  ["description"]="RIGHTWARDS WAVE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x219D, -- ↝
 },
 [0x219E]={
  ["category"]="so",
  ["description"]="LEFTWARDS TWO HEADED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x219E, -- ↞
 },
 [0x219F]={
  ["category"]="so",
  ["description"]="UPWARDS TWO HEADED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x219F, -- ↟
 },
 [0x21A0]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS TWO HEADED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A0, -- ↠
 },
 [0x21A1]={
  ["category"]="so",
  ["description"]="DOWNWARDS TWO HEADED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A1, -- ↡
 },
 [0x21A2]={
  ["category"]="so",
  ["description"]="LEFTWARDS ARROW WITH TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A2, -- ↢
 },
 [0x21A3]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW WITH TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A3, -- ↣
 },
 [0x21A4]={
  ["category"]="so",
  ["description"]="LEFTWARDS ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A4, -- ↤
 },
 [0x21A5]={
  ["category"]="so",
  ["description"]="UPWARDS ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A5, -- ↥
 },
 [0x21A6]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A6, -- ↦
 },
 [0x21A7]={
  ["category"]="so",
  ["description"]="DOWNWARDS ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A7, -- ↧
 },
 [0x21A8]={
  ["adobename"]="arrowupdnbse",
  ["category"]="so",
  ["description"]="UP DOWN ARROW WITH BASE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A8, -- ↨
 },
 [0x21A9]={
  ["category"]="so",
  ["description"]="LEFTWARDS ARROW WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21A9, -- ↩
 },
 [0x21AA]={
  ["category"]="so",
  ["description"]="RIGHTWARDS ARROW WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21AA, -- ↪
 },
 [0x21AB]={
  ["category"]="so",
  ["description"]="LEFTWARDS ARROW WITH LOOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21AB, -- ↫
 },
 [0x21AC]={
  ["category"]="so",
  ["description"]="RIGHTWARDS ARROW WITH LOOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21AC, -- ↬
 },
 [0x21AD]={
  ["category"]="so",
  ["description"]="LEFT RIGHT WAVE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21AD, -- ↭
 },
 [0x21AE]={
  ["category"]="sm",
  ["description"]="LEFT RIGHT ARROW WITH STROKE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2194, 0x0338 },
  ["unicodeslot"]=0x21AE, -- ↮
 },
 [0x21AF]={
  ["category"]="so",
  ["description"]="DOWNWARDS ZIGZAG ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21AF, -- ↯
 },
 [0x21B0]={
  ["category"]="so",
  ["description"]="UPWARDS ARROW WITH TIP LEFTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B0, -- ↰
 },
 [0x21B1]={
  ["category"]="so",
  ["description"]="UPWARDS ARROW WITH TIP RIGHTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B1, -- ↱
 },
 [0x21B2]={
  ["category"]="so",
  ["description"]="DOWNWARDS ARROW WITH TIP LEFTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B2, -- ↲
 },
 [0x21B3]={
  ["category"]="so",
  ["description"]="DOWNWARDS ARROW WITH TIP RIGHTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B3, -- ↳
 },
 [0x21B4]={
  ["category"]="so",
  ["description"]="RIGHTWARDS ARROW WITH CORNER DOWNWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B4, -- ↴
 },
 [0x21B5]={
  ["adobename"]="carriagereturn",
  ["category"]="so",
  ["description"]="DOWNWARDS ARROW WITH CORNER LEFTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B5, -- ↵
 },
 [0x21B6]={
  ["category"]="so",
  ["description"]="ANTICLOCKWISE TOP SEMICIRCLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B6, -- ↶
 },
 [0x21B7]={
  ["category"]="so",
  ["description"]="CLOCKWISE TOP SEMICIRCLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B7, -- ↷
 },
 [0x21B8]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="NORTH WEST ARROW TO LONG BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B8, -- ↸
 },
 [0x21B9]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LEFTWARDS ARROW TO BAR OVER RIGHTWARDS ARROW TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21B9, -- ↹
 },
 [0x21BA]={
  ["category"]="so",
  ["description"]="ANTICLOCKWISE OPEN CIRCLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21BA, -- ↺
 },
 [0x21BB]={
  ["category"]="so",
  ["description"]="CLOCKWISE OPEN CIRCLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21BB, -- ↻
 },
 [0x21BC]={
  ["category"]="so",
  ["description"]="LEFTWARDS HARPOON WITH BARB UPWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21BC, -- ↼
 },
 [0x21BD]={
  ["category"]="so",
  ["description"]="LEFTWARDS HARPOON WITH BARB DOWNWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21BD, -- ↽
 },
 [0x21BE]={
  ["category"]="so",
  ["description"]="UPWARDS HARPOON WITH BARB RIGHTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21BE, -- ↾
 },
 [0x21BF]={
  ["category"]="so",
  ["description"]="UPWARDS HARPOON WITH BARB LEFTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21BF, -- ↿
 },
 [0x21C0]={
  ["category"]="so",
  ["description"]="RIGHTWARDS HARPOON WITH BARB UPWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C0, -- ⇀
 },
 [0x21C1]={
  ["category"]="so",
  ["description"]="RIGHTWARDS HARPOON WITH BARB DOWNWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C1, -- ⇁
 },
 [0x21C2]={
  ["category"]="so",
  ["description"]="DOWNWARDS HARPOON WITH BARB RIGHTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C2, -- ⇂
 },
 [0x21C3]={
  ["category"]="so",
  ["description"]="DOWNWARDS HARPOON WITH BARB LEFTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C3, -- ⇃
 },
 [0x21C4]={
  ["category"]="so",
  ["description"]="RIGHTWARDS ARROW OVER LEFTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C4, -- ⇄
 },
 [0x21C5]={
  ["category"]="so",
  ["description"]="UPWARDS ARROW LEFTWARDS OF DOWNWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C5, -- ⇅
 },
 [0x21C6]={
  ["category"]="so",
  ["description"]="LEFTWARDS ARROW OVER RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C6, -- ⇆
 },
 [0x21C7]={
  ["category"]="so",
  ["description"]="LEFTWARDS PAIRED ARROWS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C7, -- ⇇
 },
 [0x21C8]={
  ["category"]="so",
  ["description"]="UPWARDS PAIRED ARROWS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C8, -- ⇈
 },
 [0x21C9]={
  ["category"]="so",
  ["description"]="RIGHTWARDS PAIRED ARROWS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21C9, -- ⇉
 },
 [0x21CA]={
  ["category"]="so",
  ["description"]="DOWNWARDS PAIRED ARROWS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21CA, -- ⇊
 },
 [0x21CB]={
  ["category"]="so",
  ["description"]="LEFTWARDS HARPOON OVER RIGHTWARDS HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21CB, -- ⇋
 },
 [0x21CC]={
  ["category"]="so",
  ["description"]="RIGHTWARDS HARPOON OVER LEFTWARDS HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21CC, -- ⇌
 },
 [0x21CD]={
  ["category"]="so",
  ["description"]="LEFTWARDS DOUBLE ARROW WITH STROKE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x21D0, 0x0338 },
  ["unicodeslot"]=0x21CD, -- ⇍
 },
 [0x21CE]={
  ["category"]="sm",
  ["description"]="LEFT RIGHT DOUBLE ARROW WITH STROKE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x21D4, 0x0338 },
  ["unicodeslot"]=0x21CE, -- ⇎
 },
 [0x21CF]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS DOUBLE ARROW WITH STROKE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x21D2, 0x0338 },
  ["unicodeslot"]=0x21CF, -- ⇏
 },
 [0x21D0]={
  ["adobename"]="arrowdblleft",
  ["category"]="so",
  ["description"]="LEFTWARDS DOUBLE ARROW",
  ["linebreak"]="al",
  ["mathclass"]="relation",
  ["mathname"]="Leftarrow",
  ["unicodeslot"]=0x21D0, -- ⇐
 },
 [0x21D1]={
  ["adobename"]="arrowdblup",
  ["category"]="so",
  ["description"]="UPWARDS DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21D1, -- ⇑
 },
 [0x21D2]={
  ["adobename"]="arrowdblright",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="RIGHTWARDS DOUBLE ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="Rightarrow",
  ["unicodeslot"]=0x21D2, -- ⇒
 },
 [0x21D3]={
  ["adobename"]="arrowdbldown",
  ["category"]="so",
  ["description"]="DOWNWARDS DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21D3, -- ⇓
 },
 [0x21D4]={
  ["adobename"]="arrowdblboth",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="LEFT RIGHT DOUBLE ARROW",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="Leftrightarrow",
  ["unicodeslot"]=0x21D4, -- ⇔
 },
 [0x21D5]={
  ["category"]="so",
  ["description"]="UP DOWN DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21D5, -- ⇕
 },
 [0x21D6]={
  ["category"]="so",
  ["description"]="NORTH WEST DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21D6, -- ⇖
 },
 [0x21D7]={
  ["category"]="so",
  ["description"]="NORTH EAST DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21D7, -- ⇗
 },
 [0x21D8]={
  ["category"]="so",
  ["description"]="SOUTH EAST DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21D8, -- ⇘
 },
 [0x21D9]={
  ["category"]="so",
  ["description"]="SOUTH WEST DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21D9, -- ⇙
 },
 [0x21DA]={
  ["category"]="so",
  ["description"]="LEFTWARDS TRIPLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21DA, -- ⇚
 },
 [0x21DB]={
  ["category"]="so",
  ["description"]="RIGHTWARDS TRIPLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21DB, -- ⇛
 },
 [0x21DC]={
  ["category"]="so",
  ["description"]="LEFTWARDS SQUIGGLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21DC, -- ⇜
 },
 [0x21DD]={
  ["category"]="so",
  ["description"]="RIGHTWARDS SQUIGGLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21DD, -- ⇝
 },
 [0x21DE]={
  ["category"]="so",
  ["description"]="UPWARDS ARROW WITH DOUBLE STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21DE, -- ⇞
 },
 [0x21DF]={
  ["category"]="so",
  ["description"]="DOWNWARDS ARROW WITH DOUBLE STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21DF, -- ⇟
 },
 [0x21E0]={
  ["category"]="so",
  ["description"]="LEFTWARDS DASHED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E0, -- ⇠
 },
 [0x21E1]={
  ["category"]="so",
  ["description"]="UPWARDS DASHED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E1, -- ⇡
 },
 [0x21E2]={
  ["category"]="so",
  ["description"]="RIGHTWARDS DASHED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E2, -- ⇢
 },
 [0x21E3]={
  ["category"]="so",
  ["description"]="DOWNWARDS DASHED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E3, -- ⇣
 },
 [0x21E4]={
  ["category"]="so",
  ["description"]="LEFTWARDS ARROW TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E4, -- ⇤
 },
 [0x21E5]={
  ["category"]="so",
  ["description"]="RIGHTWARDS ARROW TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E5, -- ⇥
 },
 [0x21E6]={
  ["category"]="so",
  ["description"]="LEFTWARDS WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E6, -- ⇦
 },
 [0x21E7]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="UPWARDS WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E7, -- ⇧
 },
 [0x21E8]={
  ["category"]="so",
  ["description"]="RIGHTWARDS WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E8, -- ⇨
 },
 [0x21E9]={
  ["category"]="so",
  ["description"]="DOWNWARDS WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21E9, -- ⇩
 },
 [0x21EA]={
  ["category"]="so",
  ["description"]="UPWARDS WHITE ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21EA, -- ⇪
 },
 [0x21EB]={
  ["category"]="so",
  ["description"]="UPWARDS WHITE ARROW ON PEDESTAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21EB, -- ⇫
 },
 [0x21EC]={
  ["category"]="so",
  ["description"]="UPWARDS WHITE ARROW ON PEDESTAL WITH HORIZONTAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21EC, -- ⇬
 },
 [0x21ED]={
  ["category"]="so",
  ["description"]="UPWARDS WHITE ARROW ON PEDESTAL WITH VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21ED, -- ⇭
 },
 [0x21EE]={
  ["category"]="so",
  ["description"]="UPWARDS WHITE DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21EE, -- ⇮
 },
 [0x21EF]={
  ["category"]="so",
  ["description"]="UPWARDS WHITE DOUBLE ARROW ON PEDESTAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21EF, -- ⇯
 },
 [0x21F0]={
  ["category"]="so",
  ["description"]="RIGHTWARDS WHITE ARROW FROM WALL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F0, -- ⇰
 },
 [0x21F1]={
  ["category"]="so",
  ["description"]="NORTH WEST ARROW TO CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F1, -- ⇱
 },
 [0x21F2]={
  ["category"]="so",
  ["description"]="SOUTH EAST ARROW TO CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F2, -- ⇲
 },
 [0x21F3]={
  ["category"]="so",
  ["description"]="UP DOWN WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F3, -- ⇳
 },
 [0x21F4]={
  ["category"]="sm",
  ["description"]="RIGHT ARROW WITH SMALL CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F4, -- ⇴
 },
 [0x21F5]={
  ["category"]="sm",
  ["description"]="DOWNWARDS ARROW LEFTWARDS OF UPWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F5, -- ⇵
 },
 [0x21F6]={
  ["category"]="sm",
  ["description"]="THREE RIGHTWARDS ARROWS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F6, -- ⇶
 },
 [0x21F7]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F7, -- ⇷
 },
 [0x21F8]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F8, -- ⇸
 },
 [0x21F9]={
  ["category"]="sm",
  ["description"]="LEFT RIGHT ARROW WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21F9, -- ⇹
 },
 [0x21FA]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW WITH DOUBLE VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21FA, -- ⇺
 },
 [0x21FB]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW WITH DOUBLE VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21FB, -- ⇻
 },
 [0x21FC]={
  ["category"]="sm",
  ["description"]="LEFT RIGHT ARROW WITH DOUBLE VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21FC, -- ⇼
 },
 [0x21FD]={
  ["category"]="sm",
  ["description"]="LEFTWARDS OPEN-HEADED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21FD, -- ⇽
 },
 [0x21FE]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS OPEN-HEADED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21FE, -- ⇾
 },
 [0x21FF]={
  ["category"]="sm",
  ["description"]="LEFT RIGHT OPEN-HEADED ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x21FF, -- ⇿
 },
 [0x2200]={
  ["adobename"]="universal",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="FOR ALL",
  ["mathclass"]="ord",
  ["mathname"]="forall",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2200, -- ∀
 },
 [0x2201]={
  ["category"]="sm",
  ["description"]="COMPLEMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2201, -- ∁
 },
 [0x2202]={
  ["adobename"]="partialdiff",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="PARTIAL DIFFERENTIAL",
  ["linebreak"]="ai",
  ["mathclass"]="variable",
  ["mathname"]="partial",
  ["unicodeslot"]=0x2202, -- ∂
 },
 [0x2203]={
  ["adobename"]="existential",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="THERE EXISTS",
  ["linebreak"]="ai",
  ["mathclass"]="ord",
  ["mathname"]="exists",
  ["unicodeslot"]=0x2203, -- ∃
 },
 [0x2204]={
  ["category"]="sm",
  ["description"]="THERE DOES NOT EXIST",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2203, 0x0338 },
  ["unicodeslot"]=0x2204, -- ∄
 },
 [0x2205]={
  ["adobename"]="emptyset",
  ["category"]="sm",
  ["description"]="EMPTY SET",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="emptyset",
  ["unicodeslot"]=0x2205, -- ∅
 },
 [0x2206]={
  ["adobename"]="Delta",
  ["category"]="sm",
  ["description"]="INCREMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2206, -- ∆
 },
 [0x2207]={
  ["adobename"]="gradient",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="NABLA",
  ["mathclass"]="variable",
  ["mathname"]="nabla",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2207, -- ∇
 },
 [0x2208]={
  ["adobename"]="element",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="ELEMENT OF",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]=false, -- "in"
  ["unicodeslot"]=0x2208, -- ∈
 },
 [0x2209]={
  ["adobename"]="notelement",
  ["category"]="sm",
  ["description"]="NOT AN ELEMENT OF",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2208, 0x0338 },
  ["mathclass"]="relation",
  ["mathname"]="ni",
  ["unicodeslot"]=0x2209, -- ∉
 },
 [0x220A]={
  ["category"]="sm",
  ["description"]="SMALL ELEMENT OF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x220A, -- ∊
 },
 [0x220B]={
  ["adobename"]="suchthat",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="CONTAINS AS MEMBER",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x220B, -- ∋
 },
 [0x220C]={
  ["category"]="sm",
  ["description"]="DOES NOT CONTAIN AS MEMBER",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x220B, 0x0338 },
  ["unicodeslot"]=0x220C, -- ∌
 },
 [0x220D]={
  ["category"]="sm",
  ["description"]="SMALL CONTAINS AS MEMBER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x220D, -- ∍
 },
 [0x220E]={
  ["category"]="sm",
  ["description"]="END OF PROOF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x220E, -- ∎
 },
 [0x220F]={
  ["adobename"]="product",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="N-ARY PRODUCT",
  ["linebreak"]="ai",
  ["mathclass"]="limop",
  ["mathname"]="prod",
  ["unicodeslot"]=0x220F, -- ∏
 },
 [0x2210]={
  ["category"]="sm",
  ["description"]="N-ARY COPRODUCT",
  ["linebreak"]="al",
  ["mathclass"]="relation",
  ["mathname"]="coprod",
  ["unicodeslot"]=0x2210, -- ∐
 },
 [0x2211]={
  ["adobename"]="summation",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="N-ARY SUMMATION",
  ["linebreak"]="ai",
  ["mathclass"]="limop",
  ["mathname"]="sum",
  ["unicodeslot"]=0x2211, -- ∑
 },
 [0x2212]={
  ["adobename"]="minus",
  ["category"]="sm",
  ["description"]="MINUS SIGN",
  ["linebreak"]="pr",
  ["unicodeslot"]=0x2212, -- −
  ["mathclass"]="binary",
 },
 [0x2213]={
  ["category"]="sm",
  ["description"]="MINUS-OR-PLUS SIGN",
  ["linebreak"]="pr",
  ["mathclass"]="binary",
  ["mathname"]="mp",
  ["unicodeslot"]=0x2213, -- ∓
 },
 [0x2214]={
  ["category"]="sm",
  ["description"]="DOT PLUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2214, -- ∔
 },
 [0x2215]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="DIVISION SLASH",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2215, -- ∕
 },
 [0x2216]={
  ["category"]="sm",
  ["description"]="SET MINUS",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="setminus",
  ["unicodeslot"]=0x2216, -- ∖
 },
 [0x2217]={
  ["adobename"]="asteriskmath",
  ["category"]="sm",
  ["description"]="ASTERISK OPERATOR",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="ast",
  ["unicodeslot"]=0x2217, -- ∗
 },
 [0x2218]={
  ["category"]="sm",
  ["description"]="RING OPERATOR",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="circ",
  ["unicodeslot"]=0x2218, -- ∘
 },
 [0x2219]={
  ["category"]="sm",
  ["description"]="BULLET OPERATOR",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="bullet",
  ["unicodeslot"]=0x2219, -- ∙
 },
 [0x221A]={
  ["adobename"]="radical",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="SQUARE ROOT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x221A, -- √
 },
 [0x221B]={
  ["category"]="sm",
  ["description"]="CUBE ROOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x221B, -- ∛
 },
 [0x221C]={
  ["category"]="sm",
  ["description"]="FOURTH ROOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x221C, -- ∜
 },
 [0x221D]={
  ["adobename"]="proportional",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="PROPORTIONAL TO",
  ["mathclass"]="relation",
  ["mathname"]="propto",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x221D, -- ∝
 },
 [0x221E]={
  ["adobename"]="infinity",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="INFINITY",
  ["linebreak"]="ai",
  ["mathclass"]="variable",
  ["mathname"]="infty",
  ["unicodeslot"]=0x221E, -- ∞
 },
 [0x221F]={
  ["adobename"]="orthogonal",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="RIGHT ANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x221F, -- ∟
 },
 [0x2220]={
  ["adobename"]="angle",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="ANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2220, -- ∠
 },
 [0x2221]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2221, -- ∡
 },
 [0x2222]={
  ["category"]="sm",
  ["description"]="SPHERICAL ANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2222, -- ∢
 },
 [0x2223]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="DIVIDES",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2223, -- ∣
 },
 [0x2224]={
  ["category"]="sm",
  ["description"]="DOES NOT DIVIDE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2223, 0x0338 },
  ["unicodeslot"]=0x2224, -- ∤
 },
 [0x2225]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="PARALLEL TO",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="parallel",
  ["unicodeslot"]=0x2225, -- ∥
 },
 [0x2226]={
  ["category"]="sm",
  ["description"]="NOT PARALLEL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2225, 0x0338 },
  ["unicodeslot"]=0x2226, -- ∦
 },
 [0x2227]={
  ["adobename"]="logicaland",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="LOGICAL AND",
  ["linebreak"]="ai",
  ["mathclass"]="limop",
  ["mathname"]="wedge",
  ["unicodeslot"]=0x2227, -- ∧
 },
 [0x2228]={
  ["adobename"]="logicalor",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="LOGICAL OR",
  ["linebreak"]="ai",
  ["mathclass"]="limop",
  ["mathname"]="vee",
  ["unicodeslot"]=0x2228, -- ∨
 },
 [0x2229]={
  ["adobename"]="intersection",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="INTERSECTION",
  ["linebreak"]="ai",
  ["mathclass"]="limop",
  ["mathname"]="cap",
  ["unicodeslot"]=0x2229, -- ∩
 },
 [0x222A]={
  ["adobename"]="union",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="UNION",
  ["linebreak"]="ai",
  ["mathclass"]="limop",
  ["mathname"]="cup",
  ["unicodeslot"]=0x222A, -- ∪
 },
 [0x222B]={
  ["adobename"]="integral",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="INTEGRAL",
  ["linebreak"]="ai",
  ["mathclass"]="limop",
  ["mathname"]="intop",
  ["unicodeslot"]=0x222B, -- ∫
 },
 [0x222C]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="DOUBLE INTEGRAL",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x222B, 0x222B },
  ["unicodeslot"]=0x222C, -- ∬
 },
 [0x222D]={
  ["category"]="sm",
  ["description"]="TRIPLE INTEGRAL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x222B, 0x222B, 0x222B },
  ["unicodeslot"]=0x222D, -- ∭
 },
 [0x222E]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="CONTOUR INTEGRAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x222E, -- ∮
 },
 [0x222F]={
  ["category"]="sm",
  ["description"]="SURFACE INTEGRAL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x222E, 0x222E },
  ["unicodeslot"]=0x222F, -- ∯
 },
 [0x2230]={
  ["category"]="sm",
  ["description"]="VOLUME INTEGRAL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x222E, 0x222E, 0x222E },
  ["unicodeslot"]=0x2230, -- ∰
 },
 [0x2231]={
  ["category"]="sm",
  ["description"]="CLOCKWISE INTEGRAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2231, -- ∱
 },
 [0x2232]={
  ["category"]="sm",
  ["description"]="CLOCKWISE CONTOUR INTEGRAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2232, -- ∲
 },
 [0x2233]={
  ["category"]="sm",
  ["description"]="ANTICLOCKWISE CONTOUR INTEGRAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2233, -- ∳
 },
 [0x2234]={
  ["adobename"]="therefore",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="THEREFORE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2234, -- ∴
 },
 [0x2235]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="BECAUSE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2235, -- ∵
 },
 [0x2236]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="RATIO",
  ["linebreak"]="ai",
  ["mathclass"]="punctuation", -- AM: Not sure
  ["mathname"]="colon",
  ["unicodeslot"]=0x2236, -- ∶
 },
 [0x2237]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="PROPORTION",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2237, -- ∷
 },
 [0x2238]={
  ["category"]="sm",
  ["description"]="DOT MINUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2238, -- ∸
 },
 [0x2239]={
  ["category"]="sm",
  ["description"]="EXCESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2239, -- ∹
 },
 [0x223A]={
  ["category"]="sm",
  ["description"]="GEOMETRIC PROPORTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x223A, -- ∺
 },
 [0x223B]={
  ["category"]="sm",
  ["description"]="HOMOTHETIC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x223B, -- ∻
 },
 [0x223C]={
  ["adobename"]="similar",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="TILDE OPERATOR",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="sim",
  ["unicodeslot"]=0x223C, -- ∼
 },
 [0x223D]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="REVERSED TILDE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x223D, -- ∽
 },
 [0x223E]={
  ["category"]="sm",
  ["description"]="INVERTED LAZY S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x223E, -- ∾
 },
 [0x223F]={
  ["category"]="sm",
  ["description"]="SINE WAVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x223F, -- ∿
 },
 [0x2240]={
  ["category"]="sm",
  ["description"]="WREATH PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2240, -- ≀
 },
 [0x2241]={
  ["category"]="sm",
  ["description"]="NOT TILDE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x223C, 0x0338 },
  ["unicodeslot"]=0x2241, -- ≁
 },
 [0x2242]={
  ["category"]="sm",
  ["description"]="MINUS TILDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2242, -- ≂
 },
 [0x2243]={
  ["category"]="sm",
  ["description"]="ASYMPTOTICALLY EQUAL TO",
  ["linebreak"]="al",
  ["mathclass"]="relation",
  ["mathname"]="simeq",
  ["unicodeslot"]=0x2243, -- ≃
 },
 [0x2244]={
  ["category"]="sm",
  ["description"]="NOT ASYMPTOTICALLY EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2243, 0x0338 },
  ["unicodeslot"]=0x2244, -- ≄
 },
 [0x2245]={
  ["adobename"]="congruent",
  ["category"]="sm",
  ["description"]="APPROXIMATELY EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2245, -- ≅
 },
 [0x2246]={
  ["category"]="sm",
  ["description"]="APPROXIMATELY BUT NOT ACTUALLY EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2246, -- ≆
 },
 [0x2247]={
  ["category"]="sm",
  ["description"]="NEITHER APPROXIMATELY NOR ACTUALLY EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2245, 0x0338 },
  ["unicodeslot"]=0x2247, -- ≇
 },
 [0x2248]={
  ["adobename"]="approxequal",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="ALMOST EQUAL TO",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="approx",
  ["unicodeslot"]=0x2248, -- ≈
 },
 [0x2249]={
  ["category"]="sm",
  ["description"]="NOT ALMOST EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2248, 0x0338 },
  ["unicodeslot"]=0x2249, -- ≉
 },
 [0x224A]={
  ["category"]="sm",
  ["description"]="ALMOST EQUAL OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x224A, -- ≊
 },
 [0x224B]={
  ["category"]="sm",
  ["description"]="TRIPLE TILDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x224B, -- ≋
 },
 [0x224C]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="ALL EQUAL TO",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="equiv",
  ["unicodeslot"]=0x224C, -- ≌
 },
 [0x224D]={
  ["category"]="sm",
  ["description"]="EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x224D, -- ≍
 },
 [0x224E]={
  ["category"]="sm",
  ["description"]="GEOMETRICALLY EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x224E, -- ≎
 },
 [0x224F]={
  ["category"]="sm",
  ["description"]="DIFFERENCE BETWEEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x224F, -- ≏
 },
 [0x2250]={
  ["category"]="sm",
  ["description"]="APPROACHES THE LIMIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2250, -- ≐
 },
 [0x2251]={
  ["category"]="sm",
  ["description"]="GEOMETRICALLY EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2251, -- ≑
 },
 [0x2252]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="APPROXIMATELY EQUAL TO OR THE IMAGE OF",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2252, -- ≒
 },
 [0x2253]={
  ["category"]="sm",
  ["description"]="IMAGE OF OR APPROXIMATELY EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2253, -- ≓
 },
 [0x2254]={
  ["category"]="sm",
  ["description"]="COLON EQUALS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2254, -- ≔
 },
 [0x2255]={
  ["category"]="sm",
  ["description"]="EQUALS COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2255, -- ≕
 },
 [0x2256]={
  ["category"]="sm",
  ["description"]="RING IN EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2256, -- ≖
 },
 [0x2257]={
  ["category"]="sm",
  ["description"]="RING EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2257, -- ≗
 },
 [0x2258]={
  ["category"]="sm",
  ["description"]="CORRESPONDS TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2258, -- ≘
 },
 [0x2259]={
  ["category"]="sm",
  ["description"]="ESTIMATES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2259, -- ≙
 },
 [0x225A]={
  ["category"]="sm",
  ["description"]="EQUIANGULAR TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x225A, -- ≚
 },
 [0x225B]={
  ["category"]="sm",
  ["description"]="STAR EQUALS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x225B, -- ≛
 },
 [0x225C]={
  ["category"]="sm",
  ["description"]="DELTA EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x225C, -- ≜
 },
 [0x225D]={
  ["category"]="sm",
  ["description"]="EQUAL TO BY DEFINITION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x225D, -- ≝
 },
 [0x225E]={
  ["category"]="sm",
  ["description"]="MEASURED BY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x225E, -- ≞
 },
 [0x225F]={
  ["category"]="sm",
  ["description"]="QUESTIONED EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x225F, -- ≟
 },
 [0x2260]={
  ["adobename"]="notequal",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="NOT EQUAL TO",
  ["linebreak"]="ai",
  ["specials"]={ "char", 0x003D, 0x0338 },
  ["unicodeslot"]=0x2260, -- ≠
 },
 [0x2261]={
  ["adobename"]="equivalence",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="IDENTICAL TO",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="equiv",
  ["unicodeslot"]=0x2261, -- ≡
 },
 [0x2262]={
  ["category"]="sm",
  ["description"]="NOT IDENTICAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2261, 0x0338 },
  ["unicodeslot"]=0x2262, -- ≢
 },
 [0x2263]={
  ["category"]="sm",
  ["description"]="STRICTLY EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2263, -- ≣
 },
 [0x2264]={
  ["adobename"]="lessequal",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="LESS-THAN OR EQUAL TO",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="leq",
  ["unicodeslot"]=0x2264, -- ≤
 },
 [0x2265]={
  ["adobename"]="greaterequal",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="GREATER-THAN OR EQUAL TO",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="geq",
  ["unicodeslot"]=0x2265, -- ≥
 },
 [0x2266]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="LESS-THAN OVER EQUAL TO",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2266, -- ≦
 },
 [0x2267]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="GREATER-THAN OVER EQUAL TO",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2267, -- ≧
 },
 [0x2268]={
  ["category"]="sm",
  ["description"]="LESS-THAN BUT NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2268, -- ≨
 },
 [0x2269]={
  ["category"]="sm",
  ["description"]="GREATER-THAN BUT NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2269, -- ≩
 },
 [0x226A]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="MUCH LESS-THAN",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="ll",
  ["unicodeslot"]=0x226A, -- ≪
 },
 [0x226B]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="MUCH GREATER-THAN",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="gg",
  ["unicodeslot"]=0x226B, -- ≫
 },
 [0x226C]={
  ["category"]="sm",
  ["description"]="BETWEEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x226C, -- ≬
 },
 [0x226D]={
  ["category"]="sm",
  ["description"]="NOT EQUIVALENT TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x224D, 0x0338 },
  ["unicodeslot"]=0x226D, -- ≭
 },
 [0x226E]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="NOT LESS-THAN",
  ["linebreak"]="ai",
  ["specials"]={ "char", 0x003C, 0x0338 },
  ["unicodeslot"]=0x226E, -- ≮
 },
 [0x226F]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="NOT GREATER-THAN",
  ["linebreak"]="ai",
  ["specials"]={ "char", 0x003E, 0x0338 },
  ["unicodeslot"]=0x226F, -- ≯
 },
 [0x2270]={
  ["category"]="sm",
  ["description"]="NEITHER LESS-THAN NOR EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2264, 0x0338 },
  ["unicodeslot"]=0x2270, -- ≰
 },
 [0x2271]={
  ["category"]="sm",
  ["description"]="NEITHER GREATER-THAN NOR EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2265, 0x0338 },
  ["unicodeslot"]=0x2271, -- ≱
 },
 [0x2272]={
  ["category"]="sm",
  ["description"]="LESS-THAN OR EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2272, -- ≲
 },
 [0x2273]={
  ["category"]="sm",
  ["description"]="GREATER-THAN OR EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2273, -- ≳
 },
 [0x2274]={
  ["category"]="sm",
  ["description"]="NEITHER LESS-THAN NOR EQUIVALENT TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2272, 0x0338 },
  ["unicodeslot"]=0x2274, -- ≴
 },
 [0x2275]={
  ["category"]="sm",
  ["description"]="NEITHER GREATER-THAN NOR EQUIVALENT TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2273, 0x0338 },
  ["unicodeslot"]=0x2275, -- ≵
 },
 [0x2276]={
  ["category"]="sm",
  ["description"]="LESS-THAN OR GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2276, -- ≶
 },
 [0x2277]={
  ["category"]="sm",
  ["description"]="GREATER-THAN OR LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2277, -- ≷
 },
 [0x2278]={
  ["category"]="sm",
  ["description"]="NEITHER LESS-THAN NOR GREATER-THAN",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2276, 0x0338 },
  ["unicodeslot"]=0x2278, -- ≸
 },
 [0x2279]={
  ["category"]="sm",
  ["description"]="NEITHER GREATER-THAN NOR LESS-THAN",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2277, 0x0338 },
  ["unicodeslot"]=0x2279, -- ≹
 },
 [0x227A]={
  ["category"]="sm",
  ["description"]="PRECEDES",
  ["mathclass"]="relation",
  ["mathname"]="prec",
  ["linebreak"]="al",
  ["mathclass"]="relation",
  ["mathname"]="prec",
  ["unicodeslot"]=0x227A, -- ≺
 },
 [0x227B]={
  ["category"]="sm",
  ["description"]="SUCCEEDS",
  ["mathclass"]="relation",
  ["mathname"]="succ",
  ["linebreak"]="al",
  ["mathclass"]="relation",
  ["mathname"]="succ",
  ["unicodeslot"]=0x227B, -- ≻
 },
 [0x227C]={
  ["category"]="sm",
  ["description"]="PRECEDES OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x227C, -- ≼
 },
 [0x227D]={
  ["category"]="sm",
  ["description"]="SUCCEEDS OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x227D, -- ≽
 },
 [0x227E]={
  ["category"]="sm",
  ["description"]="PRECEDES OR EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x227E, -- ≾
 },
 [0x227F]={
  ["category"]="sm",
  ["description"]="SUCCEEDS OR EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x227F, -- ≿
 },
 [0x2280]={
  ["category"]="sm",
  ["description"]="DOES NOT PRECEDE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x227A, 0x0338 },
  ["unicodeslot"]=0x2280, -- ⊀
 },
 [0x2281]={
  ["category"]="sm",
  ["description"]="DOES NOT SUCCEED",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x227B, 0x0338 },
  ["unicodeslot"]=0x2281, -- ⊁
 },
 [0x2282]={
  ["adobename"]="propersubset",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="SUBSET OF",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="subset",
  ["unicodeslot"]=0x2282, -- ⊂
 },
 [0x2283]={
  ["adobename"]="propersuperset",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="SUPERSET OF",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="supset",
  ["unicodeslot"]=0x2283, -- ⊃
 },
 [0x2284]={
  ["adobename"]="notsubset",
  ["category"]="sm",
  ["description"]="NOT A SUBSET OF",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2282, 0x0338 },
  ["unicodeslot"]=0x2284, -- ⊄
 },
 [0x2285]={
  ["category"]="sm",
  ["description"]="NOT A SUPERSET OF",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2283, 0x0338 },
  ["unicodeslot"]=0x2285, -- ⊅
 },
 [0x2286]={
  ["adobename"]="reflexsubset",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="SUBSET OF OR EQUAL TO",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="subseteq",
  ["unicodeslot"]=0x2286, -- ⊆
 },
 [0x2287]={
  ["adobename"]="reflexsuperset",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="SUPERSET OF OR EQUAL TO",
  ["linebreak"]="ai",
  ["mathclass"]="relation",
  ["mathname"]="supseteq",
  ["unicodeslot"]=0x2287, -- ⊇
 },
 [0x2288]={
  ["category"]="sm",
  ["description"]="NEITHER A SUBSET OF NOR EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2286, 0x0338 },
  ["unicodeslot"]=0x2288, -- ⊈
 },
 [0x2289]={
  ["category"]="sm",
  ["description"]="NEITHER A SUPERSET OF NOR EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2287, 0x0338 },
  ["unicodeslot"]=0x2289, -- ⊉
 },
 [0x228A]={
  ["category"]="sm",
  ["description"]="SUBSET OF WITH NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x228A, -- ⊊
 },
 [0x228B]={
  ["category"]="sm",
  ["description"]="SUPERSET OF WITH NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x228B, -- ⊋
 },
 [0x228C]={
  ["category"]="sm",
  ["description"]="MULTISET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x228C, -- ⊌
 },
 [0x228D]={
  ["category"]="sm",
  ["description"]="MULTISET MULTIPLICATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x228D, -- ⊍
 },
 [0x228E]={
  ["category"]="sm",
  ["description"]="MULTISET UNION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x228E, -- ⊎
 },
 [0x228F]={
  ["category"]="sm",
  ["description"]="SQUARE IMAGE OF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x228F, -- ⊏
 },
 [0x2290]={
  ["category"]="sm",
  ["description"]="SQUARE ORIGINAL OF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2290, -- ⊐
 },
 [0x2291]={
  ["category"]="sm",
  ["description"]="SQUARE IMAGE OF OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2291, -- ⊑
 },
 [0x2292]={
  ["category"]="sm",
  ["description"]="SQUARE ORIGINAL OF OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2292, -- ⊒
 },
 [0x2293]={
  ["category"]="sm",
  ["description"]="SQUARE CAP",
  ["linebreak"]="al",
  ["mathclass"]="relation",
  ["mathname"]="sqcap",
  ["unicodeslot"]=0x2293, -- ⊓
 },
 [0x2294]={
  ["category"]="sm",
  ["description"]="SQUARE CUP",
  ["linebreak"]="al",
  ["mathclass"]="relation",
  ["mathname"]="sqcup",
  ["unicodeslot"]=0x2294, -- ⊔
 },
 [0x2295]={
  ["adobename"]="circleplus",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="CIRCLED PLUS",
  ["linebreak"]="ai",
  ["mathclass"]="binary",
  ["mathname"]="oplus",
  ["unicodeslot"]=0x2295, -- ⊕
 },
 [0x2296]={
  ["category"]="sm",
  ["description"]="CIRCLED MINUS",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="ominus",
  ["unicodeslot"]=0x2296, -- ⊖
 },
 [0x2297]={
  ["adobename"]="circlemultiply",
  ["category"]="sm",
  ["description"]="CIRCLED TIMES",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="otimes",
  ["unicodeslot"]=0x2297, -- ⊗
 },
 [0x2298]={
  ["category"]="sm",
  ["description"]="CIRCLED DIVISION SLASH",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="oslash",
  ["unicodeslot"]=0x2298, -- ⊘
 },
 [0x2299]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DOT OPERATOR",
  ["linebreak"]="ai",
  ["mathclass"]="binary",
  ["mathname"]="odot",
  ["unicodeslot"]=0x2299, -- ⊙
 },
 [0x229A]={
  ["category"]="sm",
  ["description"]="CIRCLED RING OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x229A, -- ⊚
 },
 [0x229B]={
  ["category"]="sm",
  ["description"]="CIRCLED ASTERISK OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x229B, -- ⊛
 },
 [0x229C]={
  ["category"]="sm",
  ["description"]="CIRCLED EQUALS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x229C, -- ⊜
 },
 [0x229D]={
  ["category"]="sm",
  ["description"]="CIRCLED DASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x229D, -- ⊝
 },
 [0x229E]={
  ["category"]="sm",
  ["description"]="SQUARED PLUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x229E, -- ⊞
 },
 [0x229F]={
  ["category"]="sm",
  ["description"]="SQUARED MINUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x229F, -- ⊟
 },
 [0x22A0]={
  ["category"]="sm",
  ["description"]="SQUARED TIMES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22A0, -- ⊠
 },
 [0x22A1]={
  ["category"]="sm",
  ["description"]="SQUARED DOT OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22A1, -- ⊡
 },
 [0x22A2]={
  ["category"]="sm",
  ["description"]="RIGHT TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22A2, -- ⊢
 },
 [0x22A3]={
  ["category"]="sm",
  ["description"]="LEFT TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22A3, -- ⊣
 },
 [0x22A4]={
  ["category"]="sm",
  ["description"]="DOWN TACK",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="bot",
  ["unicodeslot"]=0x22A4, -- ⊤
 },
 [0x22A5]={
  ["adobename"]="perpendicular",
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="UP TACK",
  ["linebreak"]="ai",
  ["mathclass"]="variable",
  ["mathname"]="top",
  ["unicodeslot"]=0x22A5, -- ⊥
 },
 [0x22A6]={
  ["category"]="sm",
  ["description"]="ASSERTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22A6, -- ⊦
 },
 [0x22A7]={
  ["category"]="sm",
  ["description"]="MODELS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22A7, -- ⊧
 },
 [0x22A8]={
  ["category"]="sm",
  ["description"]="TRUE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22A8, -- ⊨
 },
 [0x22A9]={
  ["category"]="sm",
  ["description"]="FORCES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22A9, -- ⊩
 },
 [0x22AA]={
  ["category"]="sm",
  ["description"]="TRIPLE VERTICAL BAR RIGHT TURNSTILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22AA, -- ⊪
 },
 [0x22AB]={
  ["category"]="sm",
  ["description"]="DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22AB, -- ⊫
 },
 [0x22AC]={
  ["category"]="sm",
  ["description"]="DOES NOT PROVE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x22A2, 0x0338 },
  ["unicodeslot"]=0x22AC, -- ⊬
 },
 [0x22AD]={
  ["category"]="sm",
  ["description"]="NOT TRUE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x22A8, 0x0338 },
  ["unicodeslot"]=0x22AD, -- ⊭
 },
 [0x22AE]={
  ["category"]="sm",
  ["description"]="DOES NOT FORCE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x22A9, 0x0338 },
  ["unicodeslot"]=0x22AE, -- ⊮
 },
 [0x22AF]={
  ["category"]="sm",
  ["description"]="NEGATED DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x22AB, 0x0338 },
  ["unicodeslot"]=0x22AF, -- ⊯
 },
 [0x22B0]={
  ["category"]="sm",
  ["description"]="PRECEDES UNDER RELATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B0, -- ⊰
 },
 [0x22B1]={
  ["category"]="sm",
  ["description"]="SUCCEEDS UNDER RELATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B1, -- ⊱
 },
 [0x22B2]={
  ["category"]="sm",
  ["description"]="NORMAL SUBGROUP OF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B2, -- ⊲
 },
 [0x22B3]={
  ["category"]="sm",
  ["description"]="CONTAINS AS NORMAL SUBGROUP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B3, -- ⊳
 },
 [0x22B4]={
  ["category"]="sm",
  ["description"]="NORMAL SUBGROUP OF OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B4, -- ⊴
 },
 [0x22B5]={
  ["category"]="sm",
  ["description"]="CONTAINS AS NORMAL SUBGROUP OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B5, -- ⊵
 },
 [0x22B6]={
  ["category"]="sm",
  ["description"]="ORIGINAL OF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B6, -- ⊶
 },
 [0x22B7]={
  ["category"]="sm",
  ["description"]="IMAGE OF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B7, -- ⊷
 },
 [0x22B8]={
  ["category"]="sm",
  ["description"]="MULTIMAP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B8, -- ⊸
 },
 [0x22B9]={
  ["category"]="sm",
  ["description"]="HERMITIAN CONJUGATE MATRIX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22B9, -- ⊹
 },
 [0x22BA]={
  ["category"]="sm",
  ["description"]="INTERCALATE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22BA, -- ⊺
 },
 [0x22BB]={
  ["category"]="sm",
  ["description"]="XOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22BB, -- ⊻
 },
 [0x22BC]={
  ["category"]="sm",
  ["description"]="NAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22BC, -- ⊼
 },
 [0x22BD]={
  ["category"]="sm",
  ["description"]="NOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22BD, -- ⊽
 },
 [0x22BE]={
  ["category"]="sm",
  ["description"]="RIGHT ANGLE WITH ARC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22BE, -- ⊾
 },
 [0x22BF]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="RIGHT TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x22BF, -- ⊿
 },
 [0x22C0]={
  ["category"]="sm",
  ["description"]="N-ARY LOGICAL AND",
  ["linebreak"]="al",
  ["mathclass"]="limop",
  ["mathname"]="bigwedge",
  ["unicodeslot"]=0x22C0, -- ⋀
 },
 [0x22C1]={
  ["category"]="sm",
  ["description"]="N-ARY LOGICAL OR",
  ["linebreak"]="al",
  ["mathclass"]="limop",
  ["mathname"]="bigvee",
  ["unicodeslot"]=0x22C1, -- ⋁
 },
 [0x22C2]={
  ["category"]="sm",
  ["description"]="N-ARY INTERSECTION",
  ["linebreak"]="al",
  ["mathclass"]="limop",
  ["mathname"]="bigcap",
  ["unicodeslot"]=0x22C2, -- ⋂
 },
 [0x22C3]={
  ["category"]="sm",
  ["description"]="N-ARY UNION",
  ["linebreak"]="al",
  ["mathclass"]="limop",
  ["mathname"]="bigcup",
  ["unicodeslot"]=0x22C3, -- ⋃
 },
 [0x22C4]={
  ["category"]="sm",
  ["description"]="DIAMOND OPERATOR",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="diamond",
  ["unicodeslot"]=0x22C4, -- ⋄
 },
 [0x22C5]={
  ["adobename"]="dotmath",
  ["category"]="sm",
  ["description"]="DOT OPERATOR",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="cdot",
  ["unicodeslot"]=0x22C5, -- ⋅
 },
 [0x22C6]={
  ["category"]="sm",
  ["description"]="STAR OPERATOR",
  ["linebreak"]="al",
  ["mathclass"]="binary",
  ["mathname"]="star",
  ["unicodeslot"]=0x22C6, -- ⋆
 },
 [0x22C7]={
  ["category"]="sm",
  ["description"]="DIVISION TIMES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22C7, -- ⋇
 },
 [0x22C8]={
  ["category"]="sm",
  ["description"]="BOWTIE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22C8, -- ⋈
 },
 [0x22C9]={
  ["category"]="sm",
  ["description"]="LEFT NORMAL FACTOR SEMIDIRECT PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22C9, -- ⋉
 },
 [0x22CA]={
  ["category"]="sm",
  ["description"]="RIGHT NORMAL FACTOR SEMIDIRECT PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22CA, -- ⋊
 },
 [0x22CB]={
  ["category"]="sm",
  ["description"]="LEFT SEMIDIRECT PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22CB, -- ⋋
 },
 [0x22CC]={
  ["category"]="sm",
  ["description"]="RIGHT SEMIDIRECT PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22CC, -- ⋌
 },
 [0x22CD]={
  ["category"]="sm",
  ["description"]="REVERSED TILDE EQUALS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22CD, -- ⋍
 },
 [0x22CE]={
  ["category"]="sm",
  ["description"]="CURLY LOGICAL OR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22CE, -- ⋎
 },
 [0x22CF]={
  ["category"]="sm",
  ["description"]="CURLY LOGICAL AND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22CF, -- ⋏
 },
 [0x22D0]={
  ["category"]="sm",
  ["description"]="DOUBLE SUBSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D0, -- ⋐
 },
 [0x22D1]={
  ["category"]="sm",
  ["description"]="DOUBLE SUPERSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D1, -- ⋑
 },
 [0x22D2]={
  ["category"]="sm",
  ["description"]="DOUBLE INTERSECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D2, -- ⋒
 },
 [0x22D3]={
  ["category"]="sm",
  ["description"]="DOUBLE UNION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D3, -- ⋓
 },
 [0x22D4]={
  ["category"]="sm",
  ["description"]="PITCHFORK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D4, -- ⋔
 },
 [0x22D5]={
  ["category"]="sm",
  ["description"]="EQUAL AND PARALLEL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D5, -- ⋕
 },
 [0x22D6]={
  ["category"]="sm",
  ["description"]="LESS-THAN WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D6, -- ⋖
 },
 [0x22D7]={
  ["category"]="sm",
  ["description"]="GREATER-THAN WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D7, -- ⋗
 },
 [0x22D8]={
  ["category"]="sm",
  ["description"]="VERY MUCH LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D8, -- ⋘
 },
 [0x22D9]={
  ["category"]="sm",
  ["description"]="VERY MUCH GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22D9, -- ⋙
 },
 [0x22DA]={
  ["category"]="sm",
  ["description"]="LESS-THAN EQUAL TO OR GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22DA, -- ⋚
 },
 [0x22DB]={
  ["category"]="sm",
  ["description"]="GREATER-THAN EQUAL TO OR LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22DB, -- ⋛
 },
 [0x22DC]={
  ["category"]="sm",
  ["description"]="EQUAL TO OR LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22DC, -- ⋜
 },
 [0x22DD]={
  ["category"]="sm",
  ["description"]="EQUAL TO OR GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22DD, -- ⋝
 },
 [0x22DE]={
  ["category"]="sm",
  ["description"]="EQUAL TO OR PRECEDES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22DE, -- ⋞
 },
 [0x22DF]={
  ["category"]="sm",
  ["description"]="EQUAL TO OR SUCCEEDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22DF, -- ⋟
 },
 [0x22E0]={
  ["category"]="sm",
  ["description"]="DOES NOT PRECEDE OR EQUAL",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x227C, 0x0338 },
  ["unicodeslot"]=0x22E0, -- ⋠
 },
 [0x22E1]={
  ["category"]="sm",
  ["description"]="DOES NOT SUCCEED OR EQUAL",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x227D, 0x0338 },
  ["unicodeslot"]=0x22E1, -- ⋡
 },
 [0x22E2]={
  ["category"]="sm",
  ["description"]="NOT SQUARE IMAGE OF OR EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2291, 0x0338 },
  ["unicodeslot"]=0x22E2, -- ⋢
 },
 [0x22E3]={
  ["category"]="sm",
  ["description"]="NOT SQUARE ORIGINAL OF OR EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2292, 0x0338 },
  ["unicodeslot"]=0x22E3, -- ⋣
 },
 [0x22E4]={
  ["category"]="sm",
  ["description"]="SQUARE IMAGE OF OR NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22E4, -- ⋤
 },
 [0x22E5]={
  ["category"]="sm",
  ["description"]="SQUARE ORIGINAL OF OR NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22E5, -- ⋥
 },
 [0x22E6]={
  ["category"]="sm",
  ["description"]="LESS-THAN BUT NOT EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22E6, -- ⋦
 },
 [0x22E7]={
  ["category"]="sm",
  ["description"]="GREATER-THAN BUT NOT EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22E7, -- ⋧
 },
 [0x22E8]={
  ["category"]="sm",
  ["description"]="PRECEDES BUT NOT EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22E8, -- ⋨
 },
 [0x22E9]={
  ["category"]="sm",
  ["description"]="SUCCEEDS BUT NOT EQUIVALENT TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22E9, -- ⋩
 },
 [0x22EA]={
  ["category"]="sm",
  ["description"]="NOT NORMAL SUBGROUP OF",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x22B2, 0x0338 },
  ["unicodeslot"]=0x22EA, -- ⋪
 },
 [0x22EB]={
  ["category"]="sm",
  ["description"]="DOES NOT CONTAIN AS NORMAL SUBGROUP",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x22B3, 0x0338 },
  ["unicodeslot"]=0x22EB, -- ⋫
 },
 [0x22EC]={
  ["category"]="sm",
  ["description"]="NOT NORMAL SUBGROUP OF OR EQUAL TO",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x22B4, 0x0338 },
  ["unicodeslot"]=0x22EC, -- ⋬
 },
 [0x22ED]={
  ["category"]="sm",
  ["description"]="DOES NOT CONTAIN AS NORMAL SUBGROUP OR EQUAL",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x22B5, 0x0338 },
  ["unicodeslot"]=0x22ED, -- ⋭
 },
 [0x22EE]={
  ["category"]="sm",
  ["description"]="VERTICAL ELLIPSIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22EE, -- ⋮
 },
 [0x22EF]={
  ["category"]="sm",
  ["description"]="MIDLINE HORIZONTAL ELLIPSIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22EF, -- ⋯
 },
 [0x22F0]={
  ["category"]="sm",
  ["description"]="UP RIGHT DIAGONAL ELLIPSIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F0, -- ⋰
 },
 [0x22F1]={
  ["category"]="sm",
  ["description"]="DOWN RIGHT DIAGONAL ELLIPSIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F1, -- ⋱
 },
 [0x22F2]={
  ["category"]="sm",
  ["description"]="ELEMENT OF WITH LONG HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F2, -- ⋲
 },
 [0x22F3]={
  ["category"]="sm",
  ["description"]="ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F3, -- ⋳
 },
 [0x22F4]={
  ["category"]="sm",
  ["description"]="SMALL ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F4, -- ⋴
 },
 [0x22F5]={
  ["category"]="sm",
  ["description"]="ELEMENT OF WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F5, -- ⋵
 },
 [0x22F6]={
  ["category"]="sm",
  ["description"]="ELEMENT OF WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F6, -- ⋶
 },
 [0x22F7]={
  ["category"]="sm",
  ["description"]="SMALL ELEMENT OF WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F7, -- ⋷
 },
 [0x22F8]={
  ["category"]="sm",
  ["description"]="ELEMENT OF WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F8, -- ⋸
 },
 [0x22F9]={
  ["category"]="sm",
  ["description"]="ELEMENT OF WITH TWO HORIZONTAL STROKES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22F9, -- ⋹
 },
 [0x22FA]={
  ["category"]="sm",
  ["description"]="CONTAINS WITH LONG HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22FA, -- ⋺
 },
 [0x22FB]={
  ["category"]="sm",
  ["description"]="CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22FB, -- ⋻
 },
 [0x22FC]={
  ["category"]="sm",
  ["description"]="SMALL CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22FC, -- ⋼
 },
 [0x22FD]={
  ["category"]="sm",
  ["description"]="CONTAINS WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22FD, -- ⋽
 },
 [0x22FE]={
  ["category"]="sm",
  ["description"]="SMALL CONTAINS WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22FE, -- ⋾
 },
 [0x22FF]={
  ["category"]="sm",
  ["description"]="Z NOTATION BAG MEMBERSHIP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x22FF, -- ⋿
 },
 [0x2300]={
  ["category"]="so",
  ["description"]="DIAMETER SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2300, -- ⌀
 },
 [0x2301]={
  ["category"]="so",
  ["description"]="ELECTRIC ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2301, -- ⌁
 },
 [0x2302]={
  ["adobename"]="house",
  ["category"]="so",
  ["description"]="HOUSE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2302, -- ⌂
 },
 [0x2303]={
  ["category"]="so",
  ["description"]="UP ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2303, -- ⌃
 },
 [0x2304]={
  ["category"]="so",
  ["description"]="DOWN ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2304, -- ⌄
 },
 [0x2305]={
  ["category"]="so",
  ["description"]="PROJECTIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2305, -- ⌅
 },
 [0x2306]={
  ["category"]="so",
  ["description"]="PERSPECTIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2306, -- ⌆
 },
 [0x2307]={
  ["category"]="so",
  ["description"]="WAVY LINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2307, -- ⌇
 },
 [0x2308]={
  ["category"]="sm",
  ["description"]="LEFT CEILING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2308, -- ⌈
 },
 [0x2309]={
  ["category"]="sm",
  ["description"]="RIGHT CEILING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2309, -- ⌉
 },
 [0x230A]={
  ["category"]="sm",
  ["description"]="LEFT FLOOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x230A, -- ⌊
 },
 [0x230B]={
  ["category"]="sm",
  ["description"]="RIGHT FLOOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x230B, -- ⌋
 },
 [0x230C]={
  ["category"]="so",
  ["description"]="BOTTOM RIGHT CROP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x230C, -- ⌌
 },
 [0x230D]={
  ["category"]="so",
  ["description"]="BOTTOM LEFT CROP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x230D, -- ⌍
 },
 [0x230E]={
  ["category"]="so",
  ["description"]="TOP RIGHT CROP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x230E, -- ⌎
 },
 [0x230F]={
  ["category"]="so",
  ["description"]="TOP LEFT CROP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x230F, -- ⌏
 },
 [0x2310]={
  ["adobename"]="revlogicalnot",
  ["category"]="so",
  ["description"]="REVERSED NOT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2310, -- ⌐
 },
 [0x2311]={
  ["category"]="so",
  ["description"]="SQUARE LOZENGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2311, -- ⌑
 },
 [0x2312]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="ARC",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2312, -- ⌒
 },
 [0x2313]={
  ["category"]="so",
  ["description"]="SEGMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2313, -- ⌓
 },
 [0x2314]={
  ["category"]="so",
  ["description"]="SECTOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2314, -- ⌔
 },
 [0x2315]={
  ["category"]="so",
  ["description"]="TELEPHONE RECORDER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2315, -- ⌕
 },
 [0x2316]={
  ["category"]="so",
  ["description"]="POSITION INDICATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2316, -- ⌖
 },
 [0x2317]={
  ["category"]="so",
  ["description"]="VIEWDATA SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2317, -- ⌗
 },
 [0x2318]={
  ["category"]="so",
  ["description"]="PLACE OF INTEREST SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2318, -- ⌘
 },
 [0x2319]={
  ["category"]="so",
  ["description"]="TURNED NOT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2319, -- ⌙
 },
 [0x231A]={
  ["category"]="so",
  ["description"]="WATCH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x231A, -- ⌚
 },
 [0x231B]={
  ["category"]="so",
  ["description"]="HOURGLASS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x231B, -- ⌛
 },
 [0x231C]={
  ["category"]="so",
  ["description"]="TOP LEFT CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x231C, -- ⌜
 },
 [0x231D]={
  ["category"]="so",
  ["description"]="TOP RIGHT CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x231D, -- ⌝
 },
 [0x231E]={
  ["category"]="so",
  ["description"]="BOTTOM LEFT CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x231E, -- ⌞
 },
 [0x231F]={
  ["category"]="so",
  ["description"]="BOTTOM RIGHT CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x231F, -- ⌟
 },
 [0x2320]={
  ["adobename"]="integraltp",
  ["category"]="sm",
  ["description"]="TOP HALF INTEGRAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2320, -- ⌠
 },
 [0x2321]={
  ["adobename"]="integralbt",
  ["category"]="sm",
  ["description"]="BOTTOM HALF INTEGRAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2321, -- ⌡
 },
 [0x2322]={
  ["category"]="so",
  ["description"]="FROWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2322, -- ⌢
 },
 [0x2323]={
  ["category"]="so",
  ["description"]="SMILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2323, -- ⌣
 },
 [0x2324]={
  ["category"]="so",
  ["description"]="UP ARROWHEAD BETWEEN TWO HORIZONTAL BARS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2324, -- ⌤
 },
 [0x2325]={
  ["category"]="so",
  ["description"]="OPTION KEY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2325, -- ⌥
 },
 [0x2326]={
  ["category"]="so",
  ["description"]="ERASE TO THE RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2326, -- ⌦
 },
 [0x2327]={
  ["category"]="so",
  ["description"]="X IN A RECTANGLE BOX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2327, -- ⌧
 },
 [0x2328]={
  ["category"]="so",
  ["description"]="KEYBOARD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2328, -- ⌨
 },
 [0x2329]={
  ["adobename"]="angleleft",
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT-POINTING ANGLE BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "char", 0x3008 },
  ["unicodeslot"]=0x2329, -- 〈
 },
 [0x232A]={
  ["adobename"]="angleright",
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT-POINTING ANGLE BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "char", 0x3009 },
  ["unicodeslot"]=0x232A, -- 〉
 },
 [0x232B]={
  ["category"]="so",
  ["description"]="ERASE TO THE LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x232B, -- ⌫
 },
 [0x232C]={
  ["category"]="so",
  ["description"]="BENZENE RING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x232C, -- ⌬
 },
 [0x232D]={
  ["category"]="so",
  ["description"]="CYLINDRICITY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x232D, -- ⌭
 },
 [0x232E]={
  ["category"]="so",
  ["description"]="ALL AROUND-PROFILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x232E, -- ⌮
 },
 [0x232F]={
  ["category"]="so",
  ["description"]="SYMMETRY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x232F, -- ⌯
 },
 [0x2330]={
  ["category"]="so",
  ["description"]="TOTAL RUNOUT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2330, -- ⌰
 },
 [0x2331]={
  ["category"]="so",
  ["description"]="DIMENSION ORIGIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2331, -- ⌱
 },
 [0x2332]={
  ["category"]="so",
  ["description"]="CONICAL TAPER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2332, -- ⌲
 },
 [0x2333]={
  ["category"]="so",
  ["description"]="SLOPE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2333, -- ⌳
 },
 [0x2334]={
  ["category"]="so",
  ["description"]="COUNTERBORE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2334, -- ⌴
 },
 [0x2335]={
  ["category"]="so",
  ["description"]="COUNTERSINK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2335, -- ⌵
 },
 [0x2336]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL I-BEAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2336, -- ⌶
 },
 [0x2337]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL SQUISH QUAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2337, -- ⌷
 },
 [0x2338]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2338, -- ⌸
 },
 [0x2339]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD DIVIDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2339, -- ⌹
 },
 [0x233A]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD DIAMOND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x233A, -- ⌺
 },
 [0x233B]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD JOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x233B, -- ⌻
 },
 [0x233C]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x233C, -- ⌼
 },
 [0x233D]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL CIRCLE STILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x233D, -- ⌽
 },
 [0x233E]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL CIRCLE JOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x233E, -- ⌾
 },
 [0x233F]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL SLASH BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x233F, -- ⌿
 },
 [0x2340]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL BACKSLASH BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2340, -- ⍀
 },
 [0x2341]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2341, -- ⍁
 },
 [0x2342]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD BACKSLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2342, -- ⍂
 },
 [0x2343]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2343, -- ⍃
 },
 [0x2344]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2344, -- ⍄
 },
 [0x2345]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL LEFTWARDS VANE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2345, -- ⍅
 },
 [0x2346]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL RIGHTWARDS VANE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2346, -- ⍆
 },
 [0x2347]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD LEFTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2347, -- ⍇
 },
 [0x2348]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2348, -- ⍈
 },
 [0x2349]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL CIRCLE BACKSLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2349, -- ⍉
 },
 [0x234A]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DOWN TACK UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x234A, -- ⍊
 },
 [0x234B]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DELTA STILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x234B, -- ⍋
 },
 [0x234C]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD DOWN CARET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x234C, -- ⍌
 },
 [0x234D]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD DELTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x234D, -- ⍍
 },
 [0x234E]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DOWN TACK JOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x234E, -- ⍎
 },
 [0x234F]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL UPWARDS VANE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x234F, -- ⍏
 },
 [0x2350]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD UPWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2350, -- ⍐
 },
 [0x2351]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL UP TACK OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2351, -- ⍑
 },
 [0x2352]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DEL STILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2352, -- ⍒
 },
 [0x2353]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD UP CARET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2353, -- ⍓
 },
 [0x2354]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD DEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2354, -- ⍔
 },
 [0x2355]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL UP TACK JOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2355, -- ⍕
 },
 [0x2356]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DOWNWARDS VANE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2356, -- ⍖
 },
 [0x2357]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD DOWNWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2357, -- ⍗
 },
 [0x2358]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUOTE UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2358, -- ⍘
 },
 [0x2359]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DELTA UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2359, -- ⍙
 },
 [0x235A]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DIAMOND UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x235A, -- ⍚
 },
 [0x235B]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL JOT UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x235B, -- ⍛
 },
 [0x235C]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL CIRCLE UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x235C, -- ⍜
 },
 [0x235D]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL UP SHOE JOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x235D, -- ⍝
 },
 [0x235E]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUOTE QUAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x235E, -- ⍞
 },
 [0x235F]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL CIRCLE STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x235F, -- ⍟
 },
 [0x2360]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2360, -- ⍠
 },
 [0x2361]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL UP TACK DIAERESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2361, -- ⍡
 },
 [0x2362]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DEL DIAERESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2362, -- ⍢
 },
 [0x2363]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL STAR DIAERESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2363, -- ⍣
 },
 [0x2364]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL JOT DIAERESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2364, -- ⍤
 },
 [0x2365]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL CIRCLE DIAERESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2365, -- ⍥
 },
 [0x2366]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DOWN SHOE STILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2366, -- ⍦
 },
 [0x2367]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL LEFT SHOE STILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2367, -- ⍧
 },
 [0x2368]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL TILDE DIAERESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2368, -- ⍨
 },
 [0x2369]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL GREATER-THAN DIAERESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2369, -- ⍩
 },
 [0x236A]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL COMMA BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x236A, -- ⍪
 },
 [0x236B]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DEL TILDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x236B, -- ⍫
 },
 [0x236C]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL ZILDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x236C, -- ⍬
 },
 [0x236D]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL STILE TILDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x236D, -- ⍭
 },
 [0x236E]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL SEMICOLON UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x236E, -- ⍮
 },
 [0x236F]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD NOT EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x236F, -- ⍯
 },
 [0x2370]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD QUESTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2370, -- ⍰
 },
 [0x2371]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL DOWN CARET TILDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2371, -- ⍱
 },
 [0x2372]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL UP CARET TILDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2372, -- ⍲
 },
 [0x2373]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL IOTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2373, -- ⍳
 },
 [0x2374]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL RHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2374, -- ⍴
 },
 [0x2375]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL OMEGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2375, -- ⍵
 },
 [0x2376]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL ALPHA UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2376, -- ⍶
 },
 [0x2377]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL EPSILON UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2377, -- ⍷
 },
 [0x2378]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL IOTA UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2378, -- ⍸
 },
 [0x2379]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL OMEGA UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2379, -- ⍹
 },
 [0x237A]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL ALPHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x237A, -- ⍺
 },
 [0x237B]={
  ["category"]="so",
  ["description"]="NOT CHECK MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x237B, -- ⍻
 },
 [0x237C]={
  ["category"]="sm",
  ["description"]="RIGHT ANGLE WITH DOWNWARDS ZIGZAG ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x237C, -- ⍼
 },
 [0x237D]={
  ["category"]="so",
  ["description"]="SHOULDERED OPEN BOX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x237D, -- ⍽
 },
 [0x237E]={
  ["category"]="so",
  ["description"]="BELL SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x237E, -- ⍾
 },
 [0x237F]={
  ["category"]="so",
  ["description"]="VERTICAL LINE WITH MIDDLE DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x237F, -- ⍿
 },
 [0x2380]={
  ["category"]="so",
  ["description"]="INSERTION SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2380, -- ⎀
 },
 [0x2381]={
  ["category"]="so",
  ["description"]="CONTINUOUS UNDERLINE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2381, -- ⎁
 },
 [0x2382]={
  ["category"]="so",
  ["description"]="DISCONTINUOUS UNDERLINE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2382, -- ⎂
 },
 [0x2383]={
  ["category"]="so",
  ["description"]="EMPHASIS SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2383, -- ⎃
 },
 [0x2384]={
  ["category"]="so",
  ["description"]="COMPOSITION SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2384, -- ⎄
 },
 [0x2385]={
  ["category"]="so",
  ["description"]="WHITE SQUARE WITH CENTRE VERTICAL LINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2385, -- ⎅
 },
 [0x2386]={
  ["category"]="so",
  ["description"]="ENTER SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2386, -- ⎆
 },
 [0x2387]={
  ["category"]="so",
  ["description"]="ALTERNATIVE KEY SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2387, -- ⎇
 },
 [0x2388]={
  ["category"]="so",
  ["description"]="HELM SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2388, -- ⎈
 },
 [0x2389]={
  ["category"]="so",
  ["description"]="CIRCLED HORIZONTAL BAR WITH NOTCH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2389, -- ⎉
 },
 [0x238A]={
  ["category"]="so",
  ["description"]="CIRCLED TRIANGLE DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x238A, -- ⎊
 },
 [0x238B]={
  ["category"]="so",
  ["description"]="BROKEN CIRCLE WITH NORTHWEST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x238B, -- ⎋
 },
 [0x238C]={
  ["category"]="so",
  ["description"]="UNDO SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x238C, -- ⎌
 },
 [0x238D]={
  ["category"]="so",
  ["description"]="MONOSTABLE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x238D, -- ⎍
 },
 [0x238E]={
  ["category"]="so",
  ["description"]="HYSTERESIS SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x238E, -- ⎎
 },
 [0x238F]={
  ["category"]="so",
  ["description"]="OPEN-CIRCUIT-OUTPUT H-TYPE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x238F, -- ⎏
 },
 [0x2390]={
  ["category"]="so",
  ["description"]="OPEN-CIRCUIT-OUTPUT L-TYPE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2390, -- ⎐
 },
 [0x2391]={
  ["category"]="so",
  ["description"]="PASSIVE-PULL-DOWN-OUTPUT SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2391, -- ⎑
 },
 [0x2392]={
  ["category"]="so",
  ["description"]="PASSIVE-PULL-UP-OUTPUT SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2392, -- ⎒
 },
 [0x2393]={
  ["category"]="so",
  ["description"]="DIRECT CURRENT SYMBOL FORM TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2393, -- ⎓
 },
 [0x2394]={
  ["category"]="so",
  ["description"]="SOFTWARE-FUNCTION SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2394, -- ⎔
 },
 [0x2395]={
  ["category"]="so",
  ["description"]="APL FUNCTIONAL SYMBOL QUAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2395, -- ⎕
 },
 [0x2396]={
  ["category"]="so",
  ["description"]="DECIMAL SEPARATOR KEY SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2396, -- ⎖
 },
 [0x2397]={
  ["category"]="so",
  ["description"]="PREVIOUS PAGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2397, -- ⎗
 },
 [0x2398]={
  ["category"]="so",
  ["description"]="NEXT PAGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2398, -- ⎘
 },
 [0x2399]={
  ["category"]="so",
  ["description"]="PRINT SCREEN SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2399, -- ⎙
 },
 [0x239A]={
  ["category"]="so",
  ["description"]="CLEAR SCREEN SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x239A, -- ⎚
 },
 [0x239B]={
  ["category"]="sm",
  ["description"]="LEFT PARENTHESIS UPPER HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x239B, -- ⎛
 },
 [0x239C]={
  ["category"]="sm",
  ["description"]="LEFT PARENTHESIS EXTENSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x239C, -- ⎜
 },
 [0x239D]={
  ["category"]="sm",
  ["description"]="LEFT PARENTHESIS LOWER HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x239D, -- ⎝
 },
 [0x239E]={
  ["category"]="sm",
  ["description"]="RIGHT PARENTHESIS UPPER HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x239E, -- ⎞
 },
 [0x239F]={
  ["category"]="sm",
  ["description"]="RIGHT PARENTHESIS EXTENSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x239F, -- ⎟
 },
 [0x23A0]={
  ["category"]="sm",
  ["description"]="RIGHT PARENTHESIS LOWER HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A0, -- ⎠
 },
 [0x23A1]={
  ["category"]="sm",
  ["description"]="LEFT SQUARE BRACKET UPPER CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A1, -- ⎡
 },
 [0x23A2]={
  ["category"]="sm",
  ["description"]="LEFT SQUARE BRACKET EXTENSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A2, -- ⎢
 },
 [0x23A3]={
  ["category"]="sm",
  ["description"]="LEFT SQUARE BRACKET LOWER CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A3, -- ⎣
 },
 [0x23A4]={
  ["category"]="sm",
  ["description"]="RIGHT SQUARE BRACKET UPPER CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A4, -- ⎤
 },
 [0x23A5]={
  ["category"]="sm",
  ["description"]="RIGHT SQUARE BRACKET EXTENSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A5, -- ⎥
 },
 [0x23A6]={
  ["category"]="sm",
  ["description"]="RIGHT SQUARE BRACKET LOWER CORNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A6, -- ⎦
 },
 [0x23A7]={
  ["category"]="sm",
  ["description"]="LEFT CURLY BRACKET UPPER HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A7, -- ⎧
 },
 [0x23A8]={
  ["category"]="sm",
  ["description"]="LEFT CURLY BRACKET MIDDLE PIECE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A8, -- ⎨
 },
 [0x23A9]={
  ["category"]="sm",
  ["description"]="LEFT CURLY BRACKET LOWER HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23A9, -- ⎩
 },
 [0x23AA]={
  ["category"]="sm",
  ["description"]="CURLY BRACKET EXTENSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23AA, -- ⎪
 },
 [0x23AB]={
  ["category"]="sm",
  ["description"]="RIGHT CURLY BRACKET UPPER HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23AB, -- ⎫
 },
 [0x23AC]={
  ["category"]="sm",
  ["description"]="RIGHT CURLY BRACKET MIDDLE PIECE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23AC, -- ⎬
 },
 [0x23AD]={
  ["category"]="sm",
  ["description"]="RIGHT CURLY BRACKET LOWER HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23AD, -- ⎭
 },
 [0x23AE]={
  ["category"]="sm",
  ["description"]="INTEGRAL EXTENSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23AE, -- ⎮
 },
 [0x23AF]={
  ["category"]="sm",
  ["description"]="HORIZONTAL LINE EXTENSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23AF, -- ⎯
 },
 [0x23B0]={
  ["category"]="sm",
  ["description"]="UPPER LEFT OR LOWER RIGHT CURLY BRACKET SECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B0, -- ⎰
 },
 [0x23B1]={
  ["category"]="sm",
  ["description"]="UPPER RIGHT OR LOWER LEFT CURLY BRACKET SECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B1, -- ⎱
 },
 [0x23B2]={
  ["category"]="sm",
  ["description"]="SUMMATION TOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B2, -- ⎲
 },
 [0x23B3]={
  ["category"]="sm",
  ["description"]="SUMMATION BOTTOM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B3, -- ⎳
 },
 [0x23B4]={
  ["category"]="so",
  ["description"]="TOP SQUARE BRACKET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B4, -- ⎴
 },
 [0x23B5]={
  ["category"]="so",
  ["description"]="BOTTOM SQUARE BRACKET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B5, -- ⎵
 },
 [0x23B6]={
  ["category"]="so",
  ["description"]="BOTTOM SQUARE BRACKET OVER TOP SQUARE BRACKET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B6, -- ⎶
 },
 [0x23B7]={
  ["category"]="so",
  ["description"]="RADICAL SYMBOL BOTTOM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B7, -- ⎷
 },
 [0x23B8]={
  ["category"]="so",
  ["description"]="LEFT VERTICAL BOX LINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B8, -- ⎸
 },
 [0x23B9]={
  ["category"]="so",
  ["description"]="RIGHT VERTICAL BOX LINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23B9, -- ⎹
 },
 [0x23BA]={
  ["category"]="so",
  ["description"]="HORIZONTAL SCAN LINE-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23BA, -- ⎺
 },
 [0x23BB]={
  ["category"]="so",
  ["description"]="HORIZONTAL SCAN LINE-0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23BB, -- ⎻
 },
 [0x23BC]={
  ["category"]="so",
  ["description"]="HORIZONTAL SCAN LINE-0x0007",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23BC, -- ⎼
 },
 [0x23BD]={
  ["category"]="so",
  ["description"]="HORIZONTAL SCAN LINE-0x0009",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23BD, -- ⎽
 },
 [0x23BE]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT VERTICAL AND TOP RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23BE, -- ⎾
 },
 [0x23BF]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23BF, -- ⎿
 },
 [0x23C0]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT VERTICAL WITH CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C0, -- ⏀
 },
 [0x23C1]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C1, -- ⏁
 },
 [0x23C2]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C2, -- ⏂
 },
 [0x23C3]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT VERTICAL WITH TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C3, -- ⏃
 },
 [0x23C4]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C4, -- ⏄
 },
 [0x23C5]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C5, -- ⏅
 },
 [0x23C6]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT VERTICAL AND WAVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C6, -- ⏆
 },
 [0x23C7]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH WAVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C7, -- ⏇
 },
 [0x23C8]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH WAVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C8, -- ⏈
 },
 [0x23C9]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23C9, -- ⏉
 },
 [0x23CA]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23CA, -- ⏊
 },
 [0x23CB]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT VERTICAL AND TOP LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23CB, -- ⏋
 },
 [0x23CC]={
  ["category"]="so",
  ["description"]="DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23CC, -- ⏌
 },
 [0x23CD]={
  ["category"]="so",
  ["description"]="SQUARE FOOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23CD, -- ⏍
 },
 [0x23CE]={
  ["category"]="so",
  ["description"]="RETURN SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23CE, -- ⏎
 },
 [0x23CF]={
  ["category"]="so",
  ["description"]="EJECT SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23CF, -- ⏏
 },
 [0x23D0]={
  ["category"]="so",
  ["description"]="VERTICAL LINE EXTENSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D0, -- ⏐
 },
 [0x23D1]={
  ["category"]="so",
  ["description"]="METRICAL BREVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D1, -- ⏑
 },
 [0x23D2]={
  ["category"]="so",
  ["description"]="METRICAL LONG OVER SHORT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D2, -- ⏒
 },
 [0x23D3]={
  ["category"]="so",
  ["description"]="METRICAL SHORT OVER LONG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D3, -- ⏓
 },
 [0x23D4]={
  ["category"]="so",
  ["description"]="METRICAL LONG OVER TWO SHORTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D4, -- ⏔
 },
 [0x23D5]={
  ["category"]="so",
  ["description"]="METRICAL TWO SHORTS OVER LONG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D5, -- ⏕
 },
 [0x23D6]={
  ["category"]="so",
  ["description"]="METRICAL TWO SHORTS JOINED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D6, -- ⏖
 },
 [0x23D7]={
  ["category"]="so",
  ["description"]="METRICAL TRISEME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D7, -- ⏗
 },
 [0x23D8]={
  ["category"]="so",
  ["description"]="METRICAL TETRASEME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D8, -- ⏘
 },
 [0x23D9]={
  ["category"]="so",
  ["description"]="METRICAL PENTASEME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23D9, -- ⏙
 },
 [0x23DA]={
  ["category"]="so",
  ["description"]="EARTH GROUND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23DA, -- ⏚
 },
 [0x23DB]={
  ["category"]="so",
  ["description"]="FUSE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23DB, -- ⏛
 },
 [0x23DC]={
  ["category"]="sm",
  ["description"]="TOP PARENTHESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23DC, -- ⏜
 },
 [0x23DD]={
  ["category"]="sm",
  ["description"]="BOTTOM PARENTHESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23DD, -- ⏝
 },
 [0x23DE]={
  ["category"]="sm",
  ["description"]="TOP CURLY BRACKET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23DE, -- ⏞
 },
 [0x23DF]={
  ["category"]="sm",
  ["description"]="BOTTOM CURLY BRACKET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23DF, -- ⏟
 },
 [0x23E0]={
  ["category"]="sm",
  ["description"]="TOP TORTOISE SHELL BRACKET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23E0, -- ⏠
 },
 [0x23E1]={
  ["category"]="sm",
  ["description"]="BOTTOM TORTOISE SHELL BRACKET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23E1, -- ⏡
 },
 [0x23E2]={
  ["category"]="so",
  ["description"]="WHITE TRAPEZIUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23E2, -- ⏢
 },
 [0x23E3]={
  ["category"]="so",
  ["description"]="BENZENE RING WITH CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23E3, -- ⏣
 },
 [0x23E4]={
  ["category"]="so",
  ["description"]="STRAIGHTNESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23E4, -- ⏤
 },
 [0x23E5]={
  ["category"]="so",
  ["description"]="FLATNESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23E5, -- ⏥
 },
 [0x23E6]={
  ["category"]="so",
  ["description"]="AC CURRENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23E6, -- ⏦
 },
 [0x23E7]={
  ["category"]="so",
  ["description"]="ELECTRICAL INTERSECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x23E7, -- ⏧
 },
 [0x2400]={
  ["category"]="so",
  ["description"]="SYMBOL FOR NULL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2400, -- ␀
 },
 [0x2401]={
  ["category"]="so",
  ["description"]="SYMBOL FOR START OF HEADING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2401, -- ␁
 },
 [0x2402]={
  ["category"]="so",
  ["description"]="SYMBOL FOR START OF TEXT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2402, -- ␂
 },
 [0x2403]={
  ["category"]="so",
  ["description"]="SYMBOL FOR END OF TEXT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2403, -- ␃
 },
 [0x2404]={
  ["category"]="so",
  ["description"]="SYMBOL FOR END OF TRANSMISSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2404, -- ␄
 },
 [0x2405]={
  ["category"]="so",
  ["description"]="SYMBOL FOR ENQUIRY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2405, -- ␅
 },
 [0x2406]={
  ["category"]="so",
  ["description"]="SYMBOL FOR ACKNOWLEDGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2406, -- ␆
 },
 [0x2407]={
  ["category"]="so",
  ["description"]="SYMBOL FOR BELL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2407, -- ␇
 },
 [0x2408]={
  ["category"]="so",
  ["description"]="SYMBOL FOR BACKSPACE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2408, -- ␈
 },
 [0x2409]={
  ["category"]="so",
  ["description"]="SYMBOL FOR HORIZONTAL TABULATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2409, -- ␉
 },
 [0x240A]={
  ["category"]="so",
  ["description"]="SYMBOL FOR LINE FEED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x240A, -- ␊
 },
 [0x240B]={
  ["category"]="so",
  ["description"]="SYMBOL FOR VERTICAL TABULATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x240B, -- ␋
 },
 [0x240C]={
  ["category"]="so",
  ["description"]="SYMBOL FOR FORM FEED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x240C, -- ␌
 },
 [0x240D]={
  ["category"]="so",
  ["description"]="SYMBOL FOR CARRIAGE RETURN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x240D, -- ␍
 },
 [0x240E]={
  ["category"]="so",
  ["description"]="SYMBOL FOR SHIFT OUT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x240E, -- ␎
 },
 [0x240F]={
  ["category"]="so",
  ["description"]="SYMBOL FOR SHIFT IN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x240F, -- ␏
 },
 [0x2410]={
  ["category"]="so",
  ["description"]="SYMBOL FOR DATA LINK ESCAPE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2410, -- ␐
 },
 [0x2411]={
  ["category"]="so",
  ["description"]="SYMBOL FOR DEVICE CONTROL ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2411, -- ␑
 },
 [0x2412]={
  ["category"]="so",
  ["description"]="SYMBOL FOR DEVICE CONTROL TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2412, -- ␒
 },
 [0x2413]={
  ["category"]="so",
  ["description"]="SYMBOL FOR DEVICE CONTROL THREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2413, -- ␓
 },
 [0x2414]={
  ["category"]="so",
  ["description"]="SYMBOL FOR DEVICE CONTROL FOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2414, -- ␔
 },
 [0x2415]={
  ["category"]="so",
  ["description"]="SYMBOL FOR NEGATIVE ACKNOWLEDGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2415, -- ␕
 },
 [0x2416]={
  ["category"]="so",
  ["description"]="SYMBOL FOR SYNCHRONOUS IDLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2416, -- ␖
 },
 [0x2417]={
  ["category"]="so",
  ["description"]="SYMBOL FOR END OF TRANSMISSION BLOCK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2417, -- ␗
 },
 [0x2418]={
  ["category"]="so",
  ["description"]="SYMBOL FOR CANCEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2418, -- ␘
 },
 [0x2419]={
  ["category"]="so",
  ["description"]="SYMBOL FOR END OF MEDIUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2419, -- ␙
 },
 [0x241A]={
  ["category"]="so",
  ["description"]="SYMBOL FOR SUBSTITUTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x241A, -- ␚
 },
 [0x241B]={
  ["category"]="so",
  ["description"]="SYMBOL FOR ESCAPE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x241B, -- ␛
 },
 [0x241C]={
  ["category"]="so",
  ["description"]="SYMBOL FOR FILE SEPARATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x241C, -- ␜
 },
 [0x241D]={
  ["category"]="so",
  ["description"]="SYMBOL FOR GROUP SEPARATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x241D, -- ␝
 },
 [0x241E]={
  ["category"]="so",
  ["description"]="SYMBOL FOR RECORD SEPARATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x241E, -- ␞
 },
 [0x241F]={
  ["category"]="so",
  ["description"]="SYMBOL FOR UNIT SEPARATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x241F, -- ␟
 },
 [0x2420]={
  ["category"]="so",
  ["description"]="SYMBOL FOR SPACE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2420, -- ␠
 },
 [0x2421]={
  ["category"]="so",
  ["description"]="SYMBOL FOR DELETE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2421, -- ␡
 },
 [0x2422]={
  ["category"]="so",
  ["description"]="BLANK SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2422, -- ␢
 },
 [0x2423]={
  ["category"]="so",
  ["description"]="OPEN BOX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2423, -- ␣
 },
 [0x2424]={
  ["category"]="so",
  ["description"]="SYMBOL FOR NEWLINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2424, -- ␤
 },
 [0x2425]={
  ["category"]="so",
  ["description"]="SYMBOL FOR DELETE FORM TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2425, -- ␥
 },
 [0x2426]={
  ["category"]="so",
  ["description"]="SYMBOL FOR SUBSTITUTE FORM TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2426, -- ␦
 },
 [0x2440]={
  ["category"]="so",
  ["description"]="OCR HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2440, -- ⑀
 },
 [0x2441]={
  ["category"]="so",
  ["description"]="OCR CHAIR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2441, -- ⑁
 },
 [0x2442]={
  ["category"]="so",
  ["description"]="OCR FORK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2442, -- ⑂
 },
 [0x2443]={
  ["category"]="so",
  ["description"]="OCR INVERTED FORK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2443, -- ⑃
 },
 [0x2444]={
  ["category"]="so",
  ["description"]="OCR BELT BUCKLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2444, -- ⑄
 },
 [0x2445]={
  ["category"]="so",
  ["description"]="OCR BOW TIE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2445, -- ⑅
 },
 [0x2446]={
  ["category"]="so",
  ["description"]="OCR BRANCH BANK IDENTIFICATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2446, -- ⑆
 },
 [0x2447]={
  ["category"]="so",
  ["description"]="OCR AMOUNT OF CHECK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2447, -- ⑇
 },
 [0x2448]={
  ["category"]="so",
  ["description"]="OCR DASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2448, -- ⑈
 },
 [0x2449]={
  ["category"]="so",
  ["description"]="OCR CUSTOMER ACCOUNT NUMBER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2449, -- ⑉
 },
 [0x244A]={
  ["category"]="so",
  ["description"]="OCR DOUBLE BACKSLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x244A, -- ⑊
 },
 [0x2460]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DIGIT ONE",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031 },
  ["unicodeslot"]=0x2460, -- ①
 },
 [0x2461]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DIGIT TWO",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0032 },
  ["unicodeslot"]=0x2461, -- ②
 },
 [0x2462]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DIGIT THREE",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0033 },
  ["unicodeslot"]=0x2462, -- ③
 },
 [0x2463]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DIGIT FOUR",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0034 },
  ["unicodeslot"]=0x2463, -- ④
 },
 [0x2464]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DIGIT FIVE",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0035 },
  ["unicodeslot"]=0x2464, -- ⑤
 },
 [0x2465]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DIGIT SIX",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0036 },
  ["unicodeslot"]=0x2465, -- ⑥
 },
 [0x2466]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DIGIT SEVEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0037 },
  ["unicodeslot"]=0x2466, -- ⑦
 },
 [0x2467]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DIGIT EIGHT",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0038 },
  ["unicodeslot"]=0x2467, -- ⑧
 },
 [0x2468]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED DIGIT NINE",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0039 },
  ["unicodeslot"]=0x2468, -- ⑨
 },
 [0x2469]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER TEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0030 },
  ["unicodeslot"]=0x2469, -- ⑩
 },
 [0x246A]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER ELEVEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0031 },
  ["unicodeslot"]=0x246A, -- ⑪
 },
 [0x246B]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER TWELVE",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0032 },
  ["unicodeslot"]=0x246B, -- ⑫
 },
 [0x246C]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER THIRTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0033 },
  ["unicodeslot"]=0x246C, -- ⑬
 },
 [0x246D]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER FOURTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0034 },
  ["unicodeslot"]=0x246D, -- ⑭
 },
 [0x246E]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER FIFTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0035 },
  ["unicodeslot"]=0x246E, -- ⑮
 },
 [0x246F]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER SIXTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0036 },
  ["unicodeslot"]=0x246F, -- ⑯
 },
 [0x2470]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER SEVENTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0037 },
  ["unicodeslot"]=0x2470, -- ⑰
 },
 [0x2471]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER EIGHTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0038 },
  ["unicodeslot"]=0x2471, -- ⑱
 },
 [0x2472]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER NINETEEN",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0031, 0x0039 },
  ["unicodeslot"]=0x2472, -- ⑲
 },
 [0x2473]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="CIRCLED NUMBER TWENTY",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0032, 0x0030 },
  ["unicodeslot"]=0x2473, -- ⑳
 },
 [0x2474]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED DIGIT ONE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0029 },
  ["unicodeslot"]=0x2474, -- ⑴
 },
 [0x2475]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED DIGIT TWO",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0032, 0x0029 },
  ["unicodeslot"]=0x2475, -- ⑵
 },
 [0x2476]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED DIGIT THREE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0033, 0x0029 },
  ["unicodeslot"]=0x2476, -- ⑶
 },
 [0x2477]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED DIGIT FOUR",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0034, 0x0029 },
  ["unicodeslot"]=0x2477, -- ⑷
 },
 [0x2478]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED DIGIT FIVE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0035, 0x0029 },
  ["unicodeslot"]=0x2478, -- ⑸
 },
 [0x2479]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED DIGIT SIX",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0036, 0x0029 },
  ["unicodeslot"]=0x2479, -- ⑹
 },
 [0x247A]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED DIGIT SEVEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0037, 0x0029 },
  ["unicodeslot"]=0x247A, -- ⑺
 },
 [0x247B]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED DIGIT EIGHT",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0038, 0x0029 },
  ["unicodeslot"]=0x247B, -- ⑻
 },
 [0x247C]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED DIGIT NINE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0039, 0x0029 },
  ["unicodeslot"]=0x247C, -- ⑼
 },
 [0x247D]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER TEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0030, 0x0029 },
  ["unicodeslot"]=0x247D, -- ⑽
 },
 [0x247E]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER ELEVEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0031, 0x0029 },
  ["unicodeslot"]=0x247E, -- ⑾
 },
 [0x247F]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER TWELVE",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0032, 0x0029 },
  ["unicodeslot"]=0x247F, -- ⑿
 },
 [0x2480]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER THIRTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0033, 0x0029 },
  ["unicodeslot"]=0x2480, -- ⒀
 },
 [0x2481]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER FOURTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0034, 0x0029 },
  ["unicodeslot"]=0x2481, -- ⒁
 },
 [0x2482]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER FIFTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0035, 0x0029 },
  ["unicodeslot"]=0x2482, -- ⒂
 },
 [0x2483]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER SIXTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0036, 0x0029 },
  ["unicodeslot"]=0x2483, -- ⒃
 },
 [0x2484]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER SEVENTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0037, 0x0029 },
  ["unicodeslot"]=0x2484, -- ⒄
 },
 [0x2485]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER EIGHTEEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0038, 0x0029 },
  ["unicodeslot"]=0x2485, -- ⒅
 },
 [0x2486]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER NINETEEN",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0031, 0x0039, 0x0029 },
  ["unicodeslot"]=0x2486, -- ⒆
 },
 [0x2487]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED NUMBER TWENTY",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0032, 0x0030, 0x0029 },
  ["unicodeslot"]=0x2487, -- ⒇
 },
 [0x2488]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DIGIT ONE FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x002E },
  ["unicodeslot"]=0x2488, -- ⒈
 },
 [0x2489]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DIGIT TWO FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0032, 0x002E },
  ["unicodeslot"]=0x2489, -- ⒉
 },
 [0x248A]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DIGIT THREE FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0033, 0x002E },
  ["unicodeslot"]=0x248A, -- ⒊
 },
 [0x248B]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DIGIT FOUR FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0034, 0x002E },
  ["unicodeslot"]=0x248B, -- ⒋
 },
 [0x248C]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DIGIT FIVE FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0035, 0x002E },
  ["unicodeslot"]=0x248C, -- ⒌
 },
 [0x248D]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DIGIT SIX FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0036, 0x002E },
  ["unicodeslot"]=0x248D, -- ⒍
 },
 [0x248E]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DIGIT SEVEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0037, 0x002E },
  ["unicodeslot"]=0x248E, -- ⒎
 },
 [0x248F]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DIGIT EIGHT FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0038, 0x002E },
  ["unicodeslot"]=0x248F, -- ⒏
 },
 [0x2490]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DIGIT NINE FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0039, 0x002E },
  ["unicodeslot"]=0x2490, -- ⒐
 },
 [0x2491]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER TEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0030, 0x002E },
  ["unicodeslot"]=0x2491, -- ⒑
 },
 [0x2492]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER ELEVEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0031, 0x002E },
  ["unicodeslot"]=0x2492, -- ⒒
 },
 [0x2493]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER TWELVE FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0032, 0x002E },
  ["unicodeslot"]=0x2493, -- ⒓
 },
 [0x2494]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER THIRTEEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0033, 0x002E },
  ["unicodeslot"]=0x2494, -- ⒔
 },
 [0x2495]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER FOURTEEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0034, 0x002E },
  ["unicodeslot"]=0x2495, -- ⒕
 },
 [0x2496]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER FIFTEEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0035, 0x002E },
  ["unicodeslot"]=0x2496, -- ⒖
 },
 [0x2497]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER SIXTEEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0036, 0x002E },
  ["unicodeslot"]=0x2497, -- ⒗
 },
 [0x2498]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER SEVENTEEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0037, 0x002E },
  ["unicodeslot"]=0x2498, -- ⒘
 },
 [0x2499]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER EIGHTEEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0038, 0x002E },
  ["unicodeslot"]=0x2499, -- ⒙
 },
 [0x249A]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER NINETEEN FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0031, 0x0039, 0x002E },
  ["unicodeslot"]=0x249A, -- ⒚
 },
 [0x249B]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NUMBER TWENTY FULL STOP",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0032, 0x0030, 0x002E },
  ["unicodeslot"]=0x249B, -- ⒛
 },
 [0x249C]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER A",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0061, 0x0029 },
  ["unicodeslot"]=0x249C, -- ⒜
 },
 [0x249D]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER B",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0062, 0x0029 },
  ["unicodeslot"]=0x249D, -- ⒝
 },
 [0x249E]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER C",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0063, 0x0029 },
  ["unicodeslot"]=0x249E, -- ⒞
 },
 [0x249F]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER D",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0064, 0x0029 },
  ["unicodeslot"]=0x249F, -- ⒟
 },
 [0x24A0]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER E",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0065, 0x0029 },
  ["unicodeslot"]=0x24A0, -- ⒠
 },
 [0x24A1]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER F",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0066, 0x0029 },
  ["unicodeslot"]=0x24A1, -- ⒡
 },
 [0x24A2]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER G",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0067, 0x0029 },
  ["unicodeslot"]=0x24A2, -- ⒢
 },
 [0x24A3]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER H",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0068, 0x0029 },
  ["unicodeslot"]=0x24A3, -- ⒣
 },
 [0x24A4]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER I",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0069, 0x0029 },
  ["unicodeslot"]=0x24A4, -- ⒤
 },
 [0x24A5]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER J",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x006A, 0x0029 },
  ["unicodeslot"]=0x24A5, -- ⒥
 },
 [0x24A6]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER K",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x006B, 0x0029 },
  ["unicodeslot"]=0x24A6, -- ⒦
 },
 [0x24A7]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER L",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x006C, 0x0029 },
  ["unicodeslot"]=0x24A7, -- ⒧
 },
 [0x24A8]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER M",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x006D, 0x0029 },
  ["unicodeslot"]=0x24A8, -- ⒨
 },
 [0x24A9]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER N",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x006E, 0x0029 },
  ["unicodeslot"]=0x24A9, -- ⒩
 },
 [0x24AA]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER O",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x006F, 0x0029 },
  ["unicodeslot"]=0x24AA, -- ⒪
 },
 [0x24AB]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER P",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0070, 0x0029 },
  ["unicodeslot"]=0x24AB, -- ⒫
 },
 [0x24AC]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER Q",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0071, 0x0029 },
  ["unicodeslot"]=0x24AC, -- ⒬
 },
 [0x24AD]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER R",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0072, 0x0029 },
  ["unicodeslot"]=0x24AD, -- ⒭
 },
 [0x24AE]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER S",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0073, 0x0029 },
  ["unicodeslot"]=0x24AE, -- ⒮
 },
 [0x24AF]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER T",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0074, 0x0029 },
  ["unicodeslot"]=0x24AF, -- ⒯
 },
 [0x24B0]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER U",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0075, 0x0029 },
  ["unicodeslot"]=0x24B0, -- ⒰
 },
 [0x24B1]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER V",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0076, 0x0029 },
  ["unicodeslot"]=0x24B1, -- ⒱
 },
 [0x24B2]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER W",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0077, 0x0029 },
  ["unicodeslot"]=0x24B2, -- ⒲
 },
 [0x24B3]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER X",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0078, 0x0029 },
  ["unicodeslot"]=0x24B3, -- ⒳
 },
 [0x24B4]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER Y",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x0079, 0x0029 },
  ["unicodeslot"]=0x24B4, -- ⒴
 },
 [0x24B5]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="PARENTHESIZED LATIN SMALL LETTER Z",
  ["linebreak"]="ai",
  ["specials"]={ "compat", 0x0028, 0x007A, 0x0029 },
  ["unicodeslot"]=0x24B5, -- ⒵
 },
 [0x24B6]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER A",
  ["lccode"]=0x24D0,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0041 },
  ["unicodeslot"]=0x24B6, -- Ⓐ
 },
 [0x24B7]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER B",
  ["lccode"]=0x24D1,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0042 },
  ["unicodeslot"]=0x24B7, -- Ⓑ
 },
 [0x24B8]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER C",
  ["lccode"]=0x24D2,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0043 },
  ["unicodeslot"]=0x24B8, -- Ⓒ
 },
 [0x24B9]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER D",
  ["lccode"]=0x24D3,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0044 },
  ["unicodeslot"]=0x24B9, -- Ⓓ
 },
 [0x24BA]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER E",
  ["lccode"]=0x24D4,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0045 },
  ["unicodeslot"]=0x24BA, -- Ⓔ
 },
 [0x24BB]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER F",
  ["lccode"]=0x24D5,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0046 },
  ["unicodeslot"]=0x24BB, -- Ⓕ
 },
 [0x24BC]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER G",
  ["lccode"]=0x24D6,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0047 },
  ["unicodeslot"]=0x24BC, -- Ⓖ
 },
 [0x24BD]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER H",
  ["lccode"]=0x24D7,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0048 },
  ["unicodeslot"]=0x24BD, -- Ⓗ
 },
 [0x24BE]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER I",
  ["lccode"]=0x24D8,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0049 },
  ["unicodeslot"]=0x24BE, -- Ⓘ
 },
 [0x24BF]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER J",
  ["lccode"]=0x24D9,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x004A },
  ["unicodeslot"]=0x24BF, -- Ⓙ
 },
 [0x24C0]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER K",
  ["lccode"]=0x24DA,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x004B },
  ["unicodeslot"]=0x24C0, -- Ⓚ
 },
 [0x24C1]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER L",
  ["lccode"]=0x24DB,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x004C },
  ["unicodeslot"]=0x24C1, -- Ⓛ
 },
 [0x24C2]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER M",
  ["lccode"]=0x24DC,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x004D },
  ["unicodeslot"]=0x24C2, -- Ⓜ
 },
 [0x24C3]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER N",
  ["lccode"]=0x24DD,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x004E },
  ["unicodeslot"]=0x24C3, -- Ⓝ
 },
 [0x24C4]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER O",
  ["lccode"]=0x24DE,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x004F },
  ["unicodeslot"]=0x24C4, -- Ⓞ
 },
 [0x24C5]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER P",
  ["lccode"]=0x24DF,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0050 },
  ["unicodeslot"]=0x24C5, -- Ⓟ
 },
 [0x24C6]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER Q",
  ["lccode"]=0x24E0,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0051 },
  ["unicodeslot"]=0x24C6, -- Ⓠ
 },
 [0x24C7]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER R",
  ["lccode"]=0x24E1,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0052 },
  ["unicodeslot"]=0x24C7, -- Ⓡ
 },
 [0x24C8]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER S",
  ["lccode"]=0x24E2,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0053 },
  ["unicodeslot"]=0x24C8, -- Ⓢ
 },
 [0x24C9]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER T",
  ["lccode"]=0x24E3,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0054 },
  ["unicodeslot"]=0x24C9, -- Ⓣ
 },
 [0x24CA]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER U",
  ["lccode"]=0x24E4,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0055 },
  ["unicodeslot"]=0x24CA, -- Ⓤ
 },
 [0x24CB]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER V",
  ["lccode"]=0x24E5,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0056 },
  ["unicodeslot"]=0x24CB, -- Ⓥ
 },
 [0x24CC]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER W",
  ["lccode"]=0x24E6,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0057 },
  ["unicodeslot"]=0x24CC, -- Ⓦ
 },
 [0x24CD]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER X",
  ["lccode"]=0x24E7,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0058 },
  ["unicodeslot"]=0x24CD, -- Ⓧ
 },
 [0x24CE]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER Y",
  ["lccode"]=0x24E8,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0059 },
  ["unicodeslot"]=0x24CE, -- Ⓨ
 },
 [0x24CF]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN CAPITAL LETTER Z",
  ["lccode"]=0x24E9,
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x005A },
  ["unicodeslot"]=0x24CF, -- Ⓩ
 },
 [0x24D0]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER A",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0061 },
  ["uccode"]=0x24B6,
  ["unicodeslot"]=0x24D0, -- ⓐ
 },
 [0x24D1]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER B",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0062 },
  ["uccode"]=0x24B7,
  ["unicodeslot"]=0x24D1, -- ⓑ
 },
 [0x24D2]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER C",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0063 },
  ["uccode"]=0x24B8,
  ["unicodeslot"]=0x24D2, -- ⓒ
 },
 [0x24D3]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER D",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0064 },
  ["uccode"]=0x24B9,
  ["unicodeslot"]=0x24D3, -- ⓓ
 },
 [0x24D4]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER E",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0065 },
  ["uccode"]=0x24BA,
  ["unicodeslot"]=0x24D4, -- ⓔ
 },
 [0x24D5]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER F",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0066 },
  ["uccode"]=0x24BB,
  ["unicodeslot"]=0x24D5, -- ⓕ
 },
 [0x24D6]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER G",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0067 },
  ["uccode"]=0x24BC,
  ["unicodeslot"]=0x24D6, -- ⓖ
 },
 [0x24D7]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER H",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0068 },
  ["uccode"]=0x24BD,
  ["unicodeslot"]=0x24D7, -- ⓗ
 },
 [0x24D8]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER I",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0069 },
  ["uccode"]=0x24BE,
  ["unicodeslot"]=0x24D8, -- ⓘ
 },
 [0x24D9]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER J",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x006A },
  ["uccode"]=0x24BF,
  ["unicodeslot"]=0x24D9, -- ⓙ
 },
 [0x24DA]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER K",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x006B },
  ["uccode"]=0x24C0,
  ["unicodeslot"]=0x24DA, -- ⓚ
 },
 [0x24DB]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER L",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x006C },
  ["uccode"]=0x24C1,
  ["unicodeslot"]=0x24DB, -- ⓛ
 },
 [0x24DC]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER M",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x006D },
  ["uccode"]=0x24C2,
  ["unicodeslot"]=0x24DC, -- ⓜ
 },
 [0x24DD]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER N",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x006E },
  ["uccode"]=0x24C3,
  ["unicodeslot"]=0x24DD, -- ⓝ
 },
 [0x24DE]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER O",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x006F },
  ["uccode"]=0x24C4,
  ["unicodeslot"]=0x24DE, -- ⓞ
 },
 [0x24DF]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER P",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0070 },
  ["uccode"]=0x24C5,
  ["unicodeslot"]=0x24DF, -- ⓟ
 },
 [0x24E0]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER Q",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0071 },
  ["uccode"]=0x24C6,
  ["unicodeslot"]=0x24E0, -- ⓠ
 },
 [0x24E1]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER R",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0072 },
  ["uccode"]=0x24C7,
  ["unicodeslot"]=0x24E1, -- ⓡ
 },
 [0x24E2]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER S",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0073 },
  ["uccode"]=0x24C8,
  ["unicodeslot"]=0x24E2, -- ⓢ
 },
 [0x24E3]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER T",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0074 },
  ["uccode"]=0x24C9,
  ["unicodeslot"]=0x24E3, -- ⓣ
 },
 [0x24E4]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER U",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0075 },
  ["uccode"]=0x24CA,
  ["unicodeslot"]=0x24E4, -- ⓤ
 },
 [0x24E5]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER V",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0076 },
  ["uccode"]=0x24CB,
  ["unicodeslot"]=0x24E5, -- ⓥ
 },
 [0x24E6]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER W",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0077 },
  ["uccode"]=0x24CC,
  ["unicodeslot"]=0x24E6, -- ⓦ
 },
 [0x24E7]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER X",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0078 },
  ["uccode"]=0x24CD,
  ["unicodeslot"]=0x24E7, -- ⓧ
 },
 [0x24E8]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER Y",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0079 },
  ["uccode"]=0x24CE,
  ["unicodeslot"]=0x24E8, -- ⓨ
 },
 [0x24E9]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLED LATIN SMALL LETTER Z",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x007A },
  ["uccode"]=0x24CF,
  ["unicodeslot"]=0x24E9, -- ⓩ
 },
 [0x24EA]={
  ["category"]="no",
  ["description"]="CIRCLED DIGIT ZERO",
  ["linebreak"]="ai",
  ["specials"]={ "circle", 0x0030 },
  ["unicodeslot"]=0x24EA, -- ⓪
 },
 [0x24EB]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER ELEVEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24EB, -- ⓫
 },
 [0x24EC]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER TWELVE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24EC, -- ⓬
 },
 [0x24ED]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER THIRTEEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24ED, -- ⓭
 },
 [0x24EE]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER FOURTEEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24EE, -- ⓮
 },
 [0x24EF]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER FIFTEEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24EF, -- ⓯
 },
 [0x24F0]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER SIXTEEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F0, -- ⓰
 },
 [0x24F1]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER SEVENTEEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F1, -- ⓱
 },
 [0x24F2]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER EIGHTEEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F2, -- ⓲
 },
 [0x24F3]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER NINETEEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F3, -- ⓳
 },
 [0x24F4]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED NUMBER TWENTY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F4, -- ⓴
 },
 [0x24F5]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED DIGIT ONE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F5, -- ⓵
 },
 [0x24F6]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED DIGIT TWO",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F6, -- ⓶
 },
 [0x24F7]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED DIGIT THREE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F7, -- ⓷
 },
 [0x24F8]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED DIGIT FOUR",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F8, -- ⓸
 },
 [0x24F9]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED DIGIT FIVE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24F9, -- ⓹
 },
 [0x24FA]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED DIGIT SIX",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24FA, -- ⓺
 },
 [0x24FB]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED DIGIT SEVEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24FB, -- ⓻
 },
 [0x24FC]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED DIGIT EIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24FC, -- ⓼
 },
 [0x24FD]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED DIGIT NINE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24FD, -- ⓽
 },
 [0x24FE]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DOUBLE CIRCLED NUMBER TEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x24FE, -- ⓾
 },
 [0x24FF]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="NEGATIVE CIRCLED DIGIT ZERO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x24FF, -- ⓿
 },
 [0x2500]={
  ["adobename"]="SF100000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2500, -- ─
 },
 [0x2501]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2501, -- ━
 },
 [0x2502]={
  ["adobename"]="SF110000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT VERTICAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2502, -- │
 },
 [0x2503]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY VERTICAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2503, -- ┃
 },
 [0x2504]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT TRIPLE DASH HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2504, -- ┄
 },
 [0x2505]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY TRIPLE DASH HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2505, -- ┅
 },
 [0x2506]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT TRIPLE DASH VERTICAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2506, -- ┆
 },
 [0x2507]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY TRIPLE DASH VERTICAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2507, -- ┇
 },
 [0x2508]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT QUADRUPLE DASH HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2508, -- ┈
 },
 [0x2509]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY QUADRUPLE DASH HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2509, -- ┉
 },
 [0x250A]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT QUADRUPLE DASH VERTICAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x250A, -- ┊
 },
 [0x250B]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY QUADRUPLE DASH VERTICAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x250B, -- ┋
 },
 [0x250C]={
  ["adobename"]="SF10000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT DOWN AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x250C, -- ┌
 },
 [0x250D]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN LIGHT AND RIGHT HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x250D, -- ┍
 },
 [0x250E]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN HEAVY AND RIGHT LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x250E, -- ┎
 },
 [0x250F]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY DOWN AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x250F, -- ┏
 },
 [0x2510]={
  ["adobename"]="SF30000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT DOWN AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2510, -- ┐
 },
 [0x2511]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN LIGHT AND LEFT HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2511, -- ┑
 },
 [0x2512]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN HEAVY AND LEFT LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2512, -- ┒
 },
 [0x2513]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY DOWN AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2513, -- ┓
 },
 [0x2514]={
  ["adobename"]="SF20000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT UP AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2514, -- └
 },
 [0x2515]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP LIGHT AND RIGHT HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2515, -- ┕
 },
 [0x2516]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP HEAVY AND RIGHT LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2516, -- ┖
 },
 [0x2517]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY UP AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2517, -- ┗
 },
 [0x2518]={
  ["adobename"]="SF40000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT UP AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2518, -- ┘
 },
 [0x2519]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP LIGHT AND LEFT HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2519, -- ┙
 },
 [0x251A]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP HEAVY AND LEFT LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x251A, -- ┚
 },
 [0x251B]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY UP AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x251B, -- ┛
 },
 [0x251C]={
  ["adobename"]="SF80000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT VERTICAL AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x251C, -- ├
 },
 [0x251D]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL LIGHT AND RIGHT HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x251D, -- ┝
 },
 [0x251E]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP HEAVY AND RIGHT DOWN LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x251E, -- ┞
 },
 [0x251F]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN HEAVY AND RIGHT UP LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x251F, -- ┟
 },
 [0x2520]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL HEAVY AND RIGHT LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2520, -- ┠
 },
 [0x2521]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN LIGHT AND RIGHT UP HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2521, -- ┡
 },
 [0x2522]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP LIGHT AND RIGHT DOWN HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2522, -- ┢
 },
 [0x2523]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY VERTICAL AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2523, -- ┣
 },
 [0x2524]={
  ["adobename"]="SF90000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT VERTICAL AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2524, -- ┤
 },
 [0x2525]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL LIGHT AND LEFT HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2525, -- ┥
 },
 [0x2526]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP HEAVY AND LEFT DOWN LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2526, -- ┦
 },
 [0x2527]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN HEAVY AND LEFT UP LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2527, -- ┧
 },
 [0x2528]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL HEAVY AND LEFT LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2528, -- ┨
 },
 [0x2529]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN LIGHT AND LEFT UP HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2529, -- ┩
 },
 [0x252A]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP LIGHT AND LEFT DOWN HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x252A, -- ┪
 },
 [0x252B]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY VERTICAL AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x252B, -- ┫
 },
 [0x252C]={
  ["adobename"]="SF60000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT DOWN AND HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x252C, -- ┬
 },
 [0x252D]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LEFT HEAVY AND RIGHT DOWN LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x252D, -- ┭
 },
 [0x252E]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS RIGHT HEAVY AND LEFT DOWN LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x252E, -- ┮
 },
 [0x252F]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN LIGHT AND HORIZONTAL HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x252F, -- ┯
 },
 [0x2530]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN HEAVY AND HORIZONTAL LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2530, -- ┰
 },
 [0x2531]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS RIGHT LIGHT AND LEFT DOWN HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2531, -- ┱
 },
 [0x2532]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LEFT LIGHT AND RIGHT DOWN HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2532, -- ┲
 },
 [0x2533]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY DOWN AND HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2533, -- ┳
 },
 [0x2534]={
  ["adobename"]="SF70000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT UP AND HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2534, -- ┴
 },
 [0x2535]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LEFT HEAVY AND RIGHT UP LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2535, -- ┵
 },
 [0x2536]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS RIGHT HEAVY AND LEFT UP LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2536, -- ┶
 },
 [0x2537]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP LIGHT AND HORIZONTAL HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2537, -- ┷
 },
 [0x2538]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP HEAVY AND HORIZONTAL LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2538, -- ┸
 },
 [0x2539]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS RIGHT LIGHT AND LEFT UP HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2539, -- ┹
 },
 [0x253A]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LEFT LIGHT AND RIGHT UP HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x253A, -- ┺
 },
 [0x253B]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY UP AND HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x253B, -- ┻
 },
 [0x253C]={
  ["adobename"]="SF50000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x253C, -- ┼
 },
 [0x253D]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LEFT HEAVY AND RIGHT VERTICAL LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x253D, -- ┽
 },
 [0x253E]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS RIGHT HEAVY AND LEFT VERTICAL LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x253E, -- ┾
 },
 [0x253F]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL LIGHT AND HORIZONTAL HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x253F, -- ┿
 },
 [0x2540]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP HEAVY AND DOWN HORIZONTAL LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2540, -- ╀
 },
 [0x2541]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN HEAVY AND UP HORIZONTAL LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2541, -- ╁
 },
 [0x2542]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL HEAVY AND HORIZONTAL LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2542, -- ╂
 },
 [0x2543]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LEFT UP HEAVY AND RIGHT DOWN LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2543, -- ╃
 },
 [0x2544]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS RIGHT UP HEAVY AND LEFT DOWN LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2544, -- ╄
 },
 [0x2545]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LEFT DOWN HEAVY AND RIGHT UP LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2545, -- ╅
 },
 [0x2546]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS RIGHT DOWN HEAVY AND LEFT UP LIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2546, -- ╆
 },
 [0x2547]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN LIGHT AND UP HORIZONTAL HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2547, -- ╇
 },
 [0x2548]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP LIGHT AND DOWN HORIZONTAL HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2548, -- ╈
 },
 [0x2549]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS RIGHT LIGHT AND LEFT VERTICAL HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2549, -- ╉
 },
 [0x254A]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LEFT LIGHT AND RIGHT VERTICAL HEAVY",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x254A, -- ╊
 },
 [0x254B]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS HEAVY VERTICAL AND HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x254B, -- ╋
 },
 [0x254C]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS LIGHT DOUBLE DASH HORIZONTAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x254C, -- ╌
 },
 [0x254D]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS HEAVY DOUBLE DASH HORIZONTAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x254D, -- ╍
 },
 [0x254E]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS LIGHT DOUBLE DASH VERTICAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x254E, -- ╎
 },
 [0x254F]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS HEAVY DOUBLE DASH VERTICAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x254F, -- ╏
 },
 [0x2550]={
  ["adobename"]="SF430000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2550, -- ═
 },
 [0x2551]={
  ["adobename"]="SF240000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE VERTICAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2551, -- ║
 },
 [0x2552]={
  ["adobename"]="SF510000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2552, -- ╒
 },
 [0x2553]={
  ["adobename"]="SF520000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2553, -- ╓
 },
 [0x2554]={
  ["adobename"]="SF390000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE DOWN AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2554, -- ╔
 },
 [0x2555]={
  ["adobename"]="SF220000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2555, -- ╕
 },
 [0x2556]={
  ["adobename"]="SF210000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2556, -- ╖
 },
 [0x2557]={
  ["adobename"]="SF250000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE DOWN AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2557, -- ╗
 },
 [0x2558]={
  ["adobename"]="SF500000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2558, -- ╘
 },
 [0x2559]={
  ["adobename"]="SF490000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2559, -- ╙
 },
 [0x255A]={
  ["adobename"]="SF380000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE UP AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x255A, -- ╚
 },
 [0x255B]={
  ["adobename"]="SF280000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP SINGLE AND LEFT DOUBLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x255B, -- ╛
 },
 [0x255C]={
  ["adobename"]="SF270000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP DOUBLE AND LEFT SINGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x255C, -- ╜
 },
 [0x255D]={
  ["adobename"]="SF260000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE UP AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x255D, -- ╝
 },
 [0x255E]={
  ["adobename"]="SF360000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x255E, -- ╞
 },
 [0x255F]={
  ["adobename"]="SF370000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x255F, -- ╟
 },
 [0x2560]={
  ["adobename"]="SF420000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE VERTICAL AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2560, -- ╠
 },
 [0x2561]={
  ["adobename"]="SF190000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2561, -- ╡
 },
 [0x2562]={
  ["adobename"]="SF200000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2562, -- ╢
 },
 [0x2563]={
  ["adobename"]="SF230000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE VERTICAL AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2563, -- ╣
 },
 [0x2564]={
  ["adobename"]="SF470000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2564, -- ╤
 },
 [0x2565]={
  ["adobename"]="SF480000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2565, -- ╥
 },
 [0x2566]={
  ["adobename"]="SF410000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2566, -- ╦
 },
 [0x2567]={
  ["adobename"]="SF450000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2567, -- ╧
 },
 [0x2568]={
  ["adobename"]="SF460000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2568, -- ╨
 },
 [0x2569]={
  ["adobename"]="SF400000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE UP AND HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2569, -- ╩
 },
 [0x256A]={
  ["adobename"]="SF540000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x256A, -- ╪
 },
 [0x256B]={
  ["adobename"]="SF530000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x256B, -- ╫
 },
 [0x256C]={
  ["adobename"]="SF440000",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x256C, -- ╬
 },
 [0x256D]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT ARC DOWN AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x256D, -- ╭
 },
 [0x256E]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT ARC DOWN AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x256E, -- ╮
 },
 [0x256F]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT ARC UP AND LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x256F, -- ╯
 },
 [0x2570]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT ARC UP AND RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2570, -- ╰
 },
 [0x2571]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT DIAGONAL UPPER RIGHT TO LOWER LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2571, -- ╱
 },
 [0x2572]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT DIAGONAL UPPER LEFT TO LOWER RIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2572, -- ╲
 },
 [0x2573]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BOX DRAWINGS LIGHT DIAGONAL CROSS",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2573, -- ╳
 },
 [0x2574]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS LIGHT LEFT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2574, -- ╴
 },
 [0x2575]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS LIGHT UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2575, -- ╵
 },
 [0x2576]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS LIGHT RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2576, -- ╶
 },
 [0x2577]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS LIGHT DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2577, -- ╷
 },
 [0x2578]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS HEAVY LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2578, -- ╸
 },
 [0x2579]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS HEAVY UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2579, -- ╹
 },
 [0x257A]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS HEAVY RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x257A, -- ╺
 },
 [0x257B]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS HEAVY DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x257B, -- ╻
 },
 [0x257C]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS LIGHT LEFT AND HEAVY RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x257C, -- ╼
 },
 [0x257D]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS LIGHT UP AND HEAVY DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x257D, -- ╽
 },
 [0x257E]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS HEAVY LEFT AND LIGHT RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x257E, -- ╾
 },
 [0x257F]={
  ["category"]="so",
  ["description"]="BOX DRAWINGS HEAVY UP AND LIGHT DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x257F, -- ╿
 },
 [0x2580]={
  ["adobename"]="upblock",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="UPPER HALF BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2580, -- ▀
 },
 [0x2581]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LOWER ONE EIGHTH BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2581, -- ▁
 },
 [0x2582]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LOWER ONE QUARTER BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2582, -- ▂
 },
 [0x2583]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LOWER THREE EIGHTHS BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2583, -- ▃
 },
 [0x2584]={
  ["adobename"]="dnblock",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LOWER HALF BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2584, -- ▄
 },
 [0x2585]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LOWER FIVE EIGHTHS BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2585, -- ▅
 },
 [0x2586]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LOWER THREE QUARTERS BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2586, -- ▆
 },
 [0x2587]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LOWER SEVEN EIGHTHS BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2587, -- ▇
 },
 [0x2588]={
  ["adobename"]="block",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="FULL BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2588, -- █
 },
 [0x2589]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LEFT SEVEN EIGHTHS BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2589, -- ▉
 },
 [0x258A]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LEFT THREE QUARTERS BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x258A, -- ▊
 },
 [0x258B]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LEFT FIVE EIGHTHS BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x258B, -- ▋
 },
 [0x258C]={
  ["adobename"]="lfblock",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LEFT HALF BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x258C, -- ▌
 },
 [0x258D]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LEFT THREE EIGHTHS BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x258D, -- ▍
 },
 [0x258E]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LEFT ONE QUARTER BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x258E, -- ▎
 },
 [0x258F]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LEFT ONE EIGHTH BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x258F, -- ▏
 },
 [0x2590]={
  ["adobename"]="rtblock",
  ["category"]="so",
  ["description"]="RIGHT HALF BLOCK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2590, -- ▐
 },
 [0x2591]={
  ["adobename"]="ltshade",
  ["category"]="so",
  ["description"]="LIGHT SHADE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2591, -- ░
 },
 [0x2592]={
  ["adobename"]="shade",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="MEDIUM SHADE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2592, -- ▒
 },
 [0x2593]={
  ["adobename"]="dkshade",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="DARK SHADE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2593, -- ▓
 },
 [0x2594]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="UPPER ONE EIGHTH BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2594, -- ▔
 },
 [0x2595]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="RIGHT ONE EIGHTH BLOCK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2595, -- ▕
 },
 [0x2596]={
  ["category"]="so",
  ["description"]="QUADRANT LOWER LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2596, -- ▖
 },
 [0x2597]={
  ["category"]="so",
  ["description"]="QUADRANT LOWER RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2597, -- ▗
 },
 [0x2598]={
  ["category"]="so",
  ["description"]="QUADRANT UPPER LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2598, -- ▘
 },
 [0x2599]={
  ["category"]="so",
  ["description"]="QUADRANT UPPER LEFT AND LOWER LEFT AND LOWER RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2599, -- ▙
 },
 [0x259A]={
  ["category"]="so",
  ["description"]="QUADRANT UPPER LEFT AND LOWER RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x259A, -- ▚
 },
 [0x259B]={
  ["category"]="so",
  ["description"]="QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x259B, -- ▛
 },
 [0x259C]={
  ["category"]="so",
  ["description"]="QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x259C, -- ▜
 },
 [0x259D]={
  ["category"]="so",
  ["description"]="QUADRANT UPPER RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x259D, -- ▝
 },
 [0x259E]={
  ["category"]="so",
  ["description"]="QUADRANT UPPER RIGHT AND LOWER LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x259E, -- ▞
 },
 [0x259F]={
  ["category"]="so",
  ["description"]="QUADRANT UPPER RIGHT AND LOWER LEFT AND LOWER RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x259F, -- ▟
 },
 [0x25A0]={
  ["adobename"]="filledbox",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK SQUARE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25A0, -- ■
 },
 [0x25A1]={
  ["adobename"]="H22073",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE SQUARE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25A1, -- □
 },
 [0x25A2]={
  ["category"]="so",
  ["description"]="WHITE SQUARE WITH ROUNDED CORNERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25A2, -- ▢
 },
 [0x25A3]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE SQUARE CONTAINING BLACK SMALL SQUARE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25A3, -- ▣
 },
 [0x25A4]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="SQUARE WITH HORIZONTAL FILL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25A4, -- ▤
 },
 [0x25A5]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="SQUARE WITH VERTICAL FILL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25A5, -- ▥
 },
 [0x25A6]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="SQUARE WITH ORTHOGONAL CROSSHATCH FILL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25A6, -- ▦
 },
 [0x25A7]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="SQUARE WITH UPPER LEFT TO LOWER RIGHT FILL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25A7, -- ▧
 },
 [0x25A8]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="SQUARE WITH UPPER RIGHT TO LOWER LEFT FILL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25A8, -- ▨
 },
 [0x25A9]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="SQUARE WITH DIAGONAL CROSSHATCH FILL",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25A9, -- ▩
 },
 [0x25AA]={
  ["adobename"]="H18543",
  ["category"]="so",
  ["description"]="BLACK SMALL SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25AA, -- ▪
 },
 [0x25AB]={
  ["adobename"]="H18551",
  ["category"]="so",
  ["description"]="WHITE SMALL SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25AB, -- ▫
 },
 [0x25AC]={
  ["adobename"]="filledrect",
  ["category"]="so",
  ["description"]="BLACK RECTANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25AC, -- ▬
 },
 [0x25AD]={
  ["category"]="so",
  ["description"]="WHITE RECTANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25AD, -- ▭
 },
 [0x25AE]={
  ["category"]="so",
  ["description"]="BLACK VERTICAL RECTANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25AE, -- ▮
 },
 [0x25AF]={
  ["category"]="so",
  ["description"]="WHITE VERTICAL RECTANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25AF, -- ▯
 },
 [0x25B0]={
  ["category"]="so",
  ["description"]="BLACK PARALLELOGRAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25B0, -- ▰
 },
 [0x25B1]={
  ["category"]="so",
  ["description"]="WHITE PARALLELOGRAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25B1, -- ▱
 },
 [0x25B2]={
  ["adobename"]="triagup",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK UP-POINTING TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25B2, -- ▲
 },
 [0x25B3]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE UP-POINTING TRIANGLE",
  ["linebreak"]="ai",
  ["mathclass"]="ord",
  ["mathname"]="triangle",
  ["unicodeslot"]=0x25B3, -- △
 },
 [0x25B4]={
  ["category"]="so",
  ["description"]="BLACK UP-POINTING SMALL TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25B4, -- ▴
 },
 [0x25B5]={
  ["category"]="so",
  ["description"]="WHITE UP-POINTING SMALL TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25B5, -- ▵
 },
 [0x25B6]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK RIGHT-POINTING TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25B6, -- ▶
 },
 [0x25B7]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="WHITE RIGHT-POINTING TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25B7, -- ▷
 },
 [0x25B8]={
  ["category"]="so",
  ["description"]="BLACK RIGHT-POINTING SMALL TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25B8, -- ▸
 },
 [0x25B9]={
  ["category"]="so",
  ["description"]="WHITE RIGHT-POINTING SMALL TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25B9, -- ▹
 },
 [0x25BA]={
  ["adobename"]="triagrt",
  ["category"]="so",
  ["description"]="BLACK RIGHT-POINTING POINTER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25BA, -- ►
 },
 [0x25BB]={
  ["category"]="so",
  ["description"]="WHITE RIGHT-POINTING POINTER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25BB, -- ▻
 },
 [0x25BC]={
  ["adobename"]="triagdn",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK DOWN-POINTING TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25BC, -- ▼
 },
 [0x25BD]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE DOWN-POINTING TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25BD, -- ▽
 },
 [0x25BE]={
  ["category"]="so",
  ["description"]="BLACK DOWN-POINTING SMALL TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25BE, -- ▾
 },
 [0x25BF]={
  ["category"]="so",
  ["description"]="WHITE DOWN-POINTING SMALL TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25BF, -- ▿
 },
 [0x25C0]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK LEFT-POINTING TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25C0, -- ◀
 },
 [0x25C1]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="WHITE LEFT-POINTING TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25C1, -- ◁
 },
 [0x25C2]={
  ["category"]="so",
  ["description"]="BLACK LEFT-POINTING SMALL TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25C2, -- ◂
 },
 [0x25C3]={
  ["category"]="so",
  ["description"]="WHITE LEFT-POINTING SMALL TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25C3, -- ◃
 },
 [0x25C4]={
  ["adobename"]="triaglf",
  ["category"]="so",
  ["description"]="BLACK LEFT-POINTING POINTER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25C4, -- ◄
 },
 [0x25C5]={
  ["category"]="so",
  ["description"]="WHITE LEFT-POINTING POINTER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25C5, -- ◅
 },
 [0x25C6]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK DIAMOND",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25C6, -- ◆
 },
 [0x25C7]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE DIAMOND",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25C7, -- ◇
 },
 [0x25C8]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE DIAMOND CONTAINING BLACK SMALL DIAMOND",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25C8, -- ◈
 },
 [0x25C9]={
  ["category"]="so",
  ["description"]="FISHEYE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25C9, -- ◉
 },
 [0x25CA]={
  ["adobename"]="lozenge",
  ["category"]="so",
  ["description"]="LOZENGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25CA, -- ◊
 },
 [0x25CB]={
  ["adobename"]="circle",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE CIRCLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25CB, -- ○
 },
 [0x25CC]={
  ["category"]="so",
  ["description"]="DOTTED CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25CC, -- ◌
 },
 [0x25CD]={
  ["category"]="so",
  ["description"]="CIRCLE WITH VERTICAL FILL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25CD, -- ◍
 },
 [0x25CE]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BULLSEYE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25CE, -- ◎
 },
 [0x25CF]={
  ["adobename"]="H18533",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK CIRCLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25CF, -- ●
 },
 [0x25D0]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLE WITH LEFT HALF BLACK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25D0, -- ◐
 },
 [0x25D1]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="CIRCLE WITH RIGHT HALF BLACK",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25D1, -- ◑
 },
 [0x25D2]={
  ["category"]="so",
  ["description"]="CIRCLE WITH LOWER HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25D2, -- ◒
 },
 [0x25D3]={
  ["category"]="so",
  ["description"]="CIRCLE WITH UPPER HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25D3, -- ◓
 },
 [0x25D4]={
  ["category"]="so",
  ["description"]="CIRCLE WITH UPPER RIGHT QUADRANT BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25D4, -- ◔
 },
 [0x25D5]={
  ["category"]="so",
  ["description"]="CIRCLE WITH ALL BUT UPPER LEFT QUADRANT BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25D5, -- ◕
 },
 [0x25D6]={
  ["category"]="so",
  ["description"]="LEFT HALF BLACK CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25D6, -- ◖
 },
 [0x25D7]={
  ["category"]="so",
  ["description"]="RIGHT HALF BLACK CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25D7, -- ◗
 },
 [0x25D8]={
  ["adobename"]="invbullet",
  ["category"]="so",
  ["description"]="INVERSE BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25D8, -- ◘
 },
 [0x25D9]={
  ["adobename"]="invcircle",
  ["category"]="so",
  ["description"]="INVERSE WHITE CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25D9, -- ◙
 },
 [0x25DA]={
  ["category"]="so",
  ["description"]="UPPER HALF INVERSE WHITE CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25DA, -- ◚
 },
 [0x25DB]={
  ["category"]="so",
  ["description"]="LOWER HALF INVERSE WHITE CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25DB, -- ◛
 },
 [0x25DC]={
  ["category"]="so",
  ["description"]="UPPER LEFT QUADRANT CIRCULAR ARC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25DC, -- ◜
 },
 [0x25DD]={
  ["category"]="so",
  ["description"]="UPPER RIGHT QUADRANT CIRCULAR ARC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25DD, -- ◝
 },
 [0x25DE]={
  ["category"]="so",
  ["description"]="LOWER RIGHT QUADRANT CIRCULAR ARC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25DE, -- ◞
 },
 [0x25DF]={
  ["category"]="so",
  ["description"]="LOWER LEFT QUADRANT CIRCULAR ARC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25DF, -- ◟
 },
 [0x25E0]={
  ["category"]="so",
  ["description"]="UPPER HALF CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25E0, -- ◠
 },
 [0x25E1]={
  ["category"]="so",
  ["description"]="LOWER HALF CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25E1, -- ◡
 },
 [0x25E2]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK LOWER RIGHT TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25E2, -- ◢
 },
 [0x25E3]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK LOWER LEFT TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25E3, -- ◣
 },
 [0x25E4]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK UPPER LEFT TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25E4, -- ◤
 },
 [0x25E5]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK UPPER RIGHT TRIANGLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25E5, -- ◥
 },
 [0x25E6]={
  ["adobename"]="openbullet",
  ["category"]="so",
  ["description"]="WHITE BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25E6, -- ◦
 },
 [0x25E7]={
  ["category"]="so",
  ["description"]="SQUARE WITH LEFT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25E7, -- ◧
 },
 [0x25E8]={
  ["category"]="so",
  ["description"]="SQUARE WITH RIGHT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25E8, -- ◨
 },
 [0x25E9]={
  ["category"]="so",
  ["description"]="SQUARE WITH UPPER LEFT DIAGONAL HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25E9, -- ◩
 },
 [0x25EA]={
  ["category"]="so",
  ["description"]="SQUARE WITH LOWER RIGHT DIAGONAL HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25EA, -- ◪
 },
 [0x25EB]={
  ["category"]="so",
  ["description"]="WHITE SQUARE WITH VERTICAL BISECTING LINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25EB, -- ◫
 },
 [0x25EC]={
  ["category"]="so",
  ["description"]="WHITE UP-POINTING TRIANGLE WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25EC, -- ◬
 },
 [0x25ED]={
  ["category"]="so",
  ["description"]="UP-POINTING TRIANGLE WITH LEFT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25ED, -- ◭
 },
 [0x25EE]={
  ["category"]="so",
  ["description"]="UP-POINTING TRIANGLE WITH RIGHT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25EE, -- ◮
 },
 [0x25EF]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="LARGE CIRCLE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x25EF, -- ◯
 },
 [0x25F0]={
  ["category"]="so",
  ["description"]="WHITE SQUARE WITH UPPER LEFT QUADRANT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F0, -- ◰
 },
 [0x25F1]={
  ["category"]="so",
  ["description"]="WHITE SQUARE WITH LOWER LEFT QUADRANT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F1, -- ◱
 },
 [0x25F2]={
  ["category"]="so",
  ["description"]="WHITE SQUARE WITH LOWER RIGHT QUADRANT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F2, -- ◲
 },
 [0x25F3]={
  ["category"]="so",
  ["description"]="WHITE SQUARE WITH UPPER RIGHT QUADRANT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F3, -- ◳
 },
 [0x25F4]={
  ["category"]="so",
  ["description"]="WHITE CIRCLE WITH UPPER LEFT QUADRANT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F4, -- ◴
 },
 [0x25F5]={
  ["category"]="so",
  ["description"]="WHITE CIRCLE WITH LOWER LEFT QUADRANT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F5, -- ◵
 },
 [0x25F6]={
  ["category"]="so",
  ["description"]="WHITE CIRCLE WITH LOWER RIGHT QUADRANT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F6, -- ◶
 },
 [0x25F7]={
  ["category"]="so",
  ["description"]="WHITE CIRCLE WITH UPPER RIGHT QUADRANT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F7, -- ◷
 },
 [0x25F8]={
  ["category"]="sm",
  ["description"]="UPPER LEFT TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F8, -- ◸
 },
 [0x25F9]={
  ["category"]="sm",
  ["description"]="UPPER RIGHT TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25F9, -- ◹
 },
 [0x25FA]={
  ["category"]="sm",
  ["description"]="LOWER LEFT TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25FA, -- ◺
 },
 [0x25FB]={
  ["category"]="sm",
  ["description"]="WHITE MEDIUM SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25FB, -- ◻
 },
 [0x25FC]={
  ["category"]="sm",
  ["description"]="BLACK MEDIUM SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25FC, -- ◼
 },
 [0x25FD]={
  ["category"]="sm",
  ["description"]="WHITE MEDIUM SMALL SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25FD, -- ◽
 },
 [0x25FE]={
  ["category"]="sm",
  ["description"]="BLACK MEDIUM SMALL SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25FE, -- ◾
 },
 [0x25FF]={
  ["category"]="sm",
  ["description"]="LOWER RIGHT TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x25FF, -- ◿
 },
 [0x2600]={
  ["category"]="so",
  ["description"]="BLACK SUN WITH RAYS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2600, -- ☀
 },
 [0x2601]={
  ["category"]="so",
  ["description"]="CLOUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2601, -- ☁
 },
 [0x2602]={
  ["category"]="so",
  ["description"]="UMBRELLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2602, -- ☂
 },
 [0x2603]={
  ["category"]="so",
  ["description"]="SNOWMAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2603, -- ☃
 },
 [0x2604]={
  ["category"]="so",
  ["description"]="COMET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2604, -- ☄
 },
 [0x2605]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK STAR",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2605, -- ★
 },
 [0x2606]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE STAR",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2606, -- ☆
 },
 [0x2607]={
  ["category"]="so",
  ["description"]="LIGHTNING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2607, -- ☇
 },
 [0x2608]={
  ["category"]="so",
  ["description"]="THUNDERSTORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2608, -- ☈
 },
 [0x2609]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="SUN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2609, -- ☉
 },
 [0x260A]={
  ["category"]="so",
  ["description"]="ASCENDING NODE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x260A, -- ☊
 },
 [0x260B]={
  ["category"]="so",
  ["description"]="DESCENDING NODE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x260B, -- ☋
 },
 [0x260C]={
  ["category"]="so",
  ["description"]="CONJUNCTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x260C, -- ☌
 },
 [0x260D]={
  ["category"]="so",
  ["description"]="OPPOSITION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x260D, -- ☍
 },
 [0x260E]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK TELEPHONE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x260E, -- ☎
 },
 [0x260F]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE TELEPHONE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x260F, -- ☏
 },
 [0x2610]={
  ["category"]="so",
  ["description"]="BALLOT BOX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2610, -- ☐
 },
 [0x2611]={
  ["category"]="so",
  ["description"]="BALLOT BOX WITH CHECK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2611, -- ☑
 },
 [0x2612]={
  ["category"]="so",
  ["description"]="BALLOT BOX WITH X",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2612, -- ☒
 },
 [0x2613]={
  ["category"]="so",
  ["description"]="SALTIRE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2613, -- ☓
 },
 [0x2614]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="UMBRELLA WITH RAIN DROPS",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2614, -- ☔
 },
 [0x2615]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="HOT BEVERAGE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2615, -- ☕
 },
 [0x2616]={
  ["category"]="so",
  ["description"]="WHITE SHOGI PIECE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2616, -- ☖
 },
 [0x2617]={
  ["category"]="so",
  ["description"]="BLACK SHOGI PIECE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2617, -- ☗
 },
 [0x2618]={
  ["category"]="so",
  ["description"]="SHAMROCK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2618, -- ☘
 },
 [0x2619]={
  ["category"]="so",
  ["description"]="REVERSED ROTATED FLORAL HEART BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2619, -- ☙
 },
 [0x261A]={
  ["category"]="so",
  ["description"]="BLACK LEFT POINTING INDEX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x261A, -- ☚
 },
 [0x261B]={
  ["category"]="so",
  ["description"]="BLACK RIGHT POINTING INDEX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x261B, -- ☛
 },
 [0x261C]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE LEFT POINTING INDEX",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x261C, -- ☜
 },
 [0x261D]={
  ["category"]="so",
  ["description"]="WHITE UP POINTING INDEX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x261D, -- ☝
 },
 [0x261E]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE RIGHT POINTING INDEX",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x261E, -- ☞
 },
 [0x261F]={
  ["category"]="so",
  ["description"]="WHITE DOWN POINTING INDEX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x261F, -- ☟
 },
 [0x2620]={
  ["category"]="so",
  ["description"]="SKULL AND CROSSBONES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2620, -- ☠
 },
 [0x2621]={
  ["category"]="so",
  ["description"]="CAUTION SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2621, -- ☡
 },
 [0x2622]={
  ["category"]="so",
  ["description"]="RADIOACTIVE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2622, -- ☢
 },
 [0x2623]={
  ["category"]="so",
  ["description"]="BIOHAZARD SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2623, -- ☣
 },
 [0x2624]={
  ["category"]="so",
  ["description"]="CADUCEUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2624, -- ☤
 },
 [0x2625]={
  ["category"]="so",
  ["description"]="ANKH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2625, -- ☥
 },
 [0x2626]={
  ["category"]="so",
  ["description"]="ORTHODOX CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2626, -- ☦
 },
 [0x2627]={
  ["category"]="so",
  ["description"]="CHI RHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2627, -- ☧
 },
 [0x2628]={
  ["category"]="so",
  ["description"]="CROSS OF LORRAINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2628, -- ☨
 },
 [0x2629]={
  ["category"]="so",
  ["description"]="CROSS OF JERUSALEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2629, -- ☩
 },
 [0x262A]={
  ["category"]="so",
  ["description"]="STAR AND CRESCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x262A, -- ☪
 },
 [0x262B]={
  ["category"]="so",
  ["description"]="FARSI SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x262B, -- ☫
 },
 [0x262C]={
  ["category"]="so",
  ["description"]="ADI SHAKTI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x262C, -- ☬
 },
 [0x262D]={
  ["category"]="so",
  ["description"]="HAMMER AND SICKLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x262D, -- ☭
 },
 [0x262E]={
  ["category"]="so",
  ["description"]="PEACE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x262E, -- ☮
 },
 [0x262F]={
  ["category"]="so",
  ["description"]="YIN YANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x262F, -- ☯
 },
 [0x2630]={
  ["category"]="so",
  ["description"]="TRIGRAM FOR HEAVEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2630, -- ☰
 },
 [0x2631]={
  ["category"]="so",
  ["description"]="TRIGRAM FOR LAKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2631, -- ☱
 },
 [0x2632]={
  ["category"]="so",
  ["description"]="TRIGRAM FOR FIRE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2632, -- ☲
 },
 [0x2633]={
  ["category"]="so",
  ["description"]="TRIGRAM FOR THUNDER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2633, -- ☳
 },
 [0x2634]={
  ["category"]="so",
  ["description"]="TRIGRAM FOR WIND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2634, -- ☴
 },
 [0x2635]={
  ["category"]="so",
  ["description"]="TRIGRAM FOR WATER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2635, -- ☵
 },
 [0x2636]={
  ["category"]="so",
  ["description"]="TRIGRAM FOR MOUNTAIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2636, -- ☶
 },
 [0x2637]={
  ["category"]="so",
  ["description"]="TRIGRAM FOR EARTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2637, -- ☷
 },
 [0x2638]={
  ["category"]="so",
  ["description"]="WHEEL OF DHARMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2638, -- ☸
 },
 [0x2639]={
  ["category"]="so",
  ["description"]="WHITE FROWNING FACE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2639, -- ☹
 },
 [0x263A]={
  ["adobename"]="smileface",
  ["category"]="so",
  ["description"]="WHITE SMILING FACE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x263A, -- ☺
 },
 [0x263B]={
  ["adobename"]="invsmileface",
  ["category"]="so",
  ["description"]="BLACK SMILING FACE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x263B, -- ☻
 },
 [0x263C]={
  ["adobename"]="sun",
  ["category"]="so",
  ["description"]="WHITE SUN WITH RAYS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x263C, -- ☼
 },
 [0x263D]={
  ["category"]="so",
  ["description"]="FIRST QUARTER MOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x263D, -- ☽
 },
 [0x263E]={
  ["category"]="so",
  ["description"]="LAST QUARTER MOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x263E, -- ☾
 },
 [0x263F]={
  ["category"]="so",
  ["description"]="MERCURY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x263F, -- ☿
 },
 [0x2640]={
  ["adobename"]="female",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="FEMALE SIGN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2640, -- ♀
 },
 [0x2641]={
  ["category"]="so",
  ["description"]="EARTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2641, -- ♁
 },
 [0x2642]={
  ["adobename"]="male",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="MALE SIGN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2642, -- ♂
 },
 [0x2643]={
  ["category"]="so",
  ["description"]="JUPITER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2643, -- ♃
 },
 [0x2644]={
  ["category"]="so",
  ["description"]="SATURN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2644, -- ♄
 },
 [0x2645]={
  ["category"]="so",
  ["description"]="URANUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2645, -- ♅
 },
 [0x2646]={
  ["category"]="so",
  ["description"]="NEPTUNE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2646, -- ♆
 },
 [0x2647]={
  ["category"]="so",
  ["description"]="PLUTO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2647, -- ♇
 },
 [0x2648]={
  ["category"]="so",
  ["description"]="ARIES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2648, -- ♈
 },
 [0x2649]={
  ["category"]="so",
  ["description"]="TAURUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2649, -- ♉
 },
 [0x264A]={
  ["category"]="so",
  ["description"]="GEMINI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x264A, -- ♊
 },
 [0x264B]={
  ["category"]="so",
  ["description"]="CANCER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x264B, -- ♋
 },
 [0x264C]={
  ["category"]="so",
  ["description"]="LEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x264C, -- ♌
 },
 [0x264D]={
  ["category"]="so",
  ["description"]="VIRGO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x264D, -- ♍
 },
 [0x264E]={
  ["category"]="so",
  ["description"]="LIBRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x264E, -- ♎
 },
 [0x264F]={
  ["category"]="so",
  ["description"]="SCORPIUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x264F, -- ♏
 },
 [0x2650]={
  ["category"]="so",
  ["description"]="SAGITTARIUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2650, -- ♐
 },
 [0x2651]={
  ["category"]="so",
  ["description"]="CAPRICORN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2651, -- ♑
 },
 [0x2652]={
  ["category"]="so",
  ["description"]="AQUARIUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2652, -- ♒
 },
 [0x2653]={
  ["category"]="so",
  ["description"]="PISCES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2653, -- ♓
 },
 [0x2654]={
  ["category"]="so",
  ["description"]="WHITE CHESS KING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2654, -- ♔
 },
 [0x2655]={
  ["category"]="so",
  ["description"]="WHITE CHESS QUEEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2655, -- ♕
 },
 [0x2656]={
  ["category"]="so",
  ["description"]="WHITE CHESS ROOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2656, -- ♖
 },
 [0x2657]={
  ["category"]="so",
  ["description"]="WHITE CHESS BISHOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2657, -- ♗
 },
 [0x2658]={
  ["category"]="so",
  ["description"]="WHITE CHESS KNIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2658, -- ♘
 },
 [0x2659]={
  ["category"]="so",
  ["description"]="WHITE CHESS PAWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2659, -- ♙
 },
 [0x265A]={
  ["category"]="so",
  ["description"]="BLACK CHESS KING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x265A, -- ♚
 },
 [0x265B]={
  ["category"]="so",
  ["description"]="BLACK CHESS QUEEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x265B, -- ♛
 },
 [0x265C]={
  ["category"]="so",
  ["description"]="BLACK CHESS ROOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x265C, -- ♜
 },
 [0x265D]={
  ["category"]="so",
  ["description"]="BLACK CHESS BISHOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x265D, -- ♝
 },
 [0x265E]={
  ["category"]="so",
  ["description"]="BLACK CHESS KNIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x265E, -- ♞
 },
 [0x265F]={
  ["category"]="so",
  ["description"]="BLACK CHESS PAWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x265F, -- ♟
 },
 [0x2660]={
  ["adobename"]="spade",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK SPADE SUIT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2660, -- ♠
 },
 [0x2661]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE HEART SUIT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2661, -- ♡
 },
 [0x2662]={
  ["category"]="so",
  ["description"]="WHITE DIAMOND SUIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2662, -- ♢
 },
 [0x2663]={
  ["adobename"]="club",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK CLUB SUIT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2663, -- ♣
 },
 [0x2664]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE SPADE SUIT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2664, -- ♤
 },
 [0x2665]={
  ["adobename"]="heart",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BLACK HEART SUIT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2665, -- ♥
 },
 [0x2666]={
  ["adobename"]="diamond",
  ["category"]="so",
  ["description"]="BLACK DIAMOND SUIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2666, -- ♦
 },
 [0x2667]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="WHITE CLUB SUIT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2667, -- ♧
 },
 [0x2668]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="HOT SPRINGS",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2668, -- ♨
 },
 [0x2669]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="QUARTER NOTE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2669, -- ♩
 },
 [0x266A]={
  ["adobename"]="musicalnote",
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="EIGHTH NOTE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x266A, -- ♪
 },
 [0x266B]={
  ["adobename"]="musicalnotedbl",
  ["category"]="so",
  ["description"]="BEAMED EIGHTH NOTES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x266B, -- ♫
 },
 [0x266C]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="BEAMED SIXTEENTH NOTES",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x266C, -- ♬
 },
 [0x266D]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="MUSIC FLAT SIGN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x266D, -- ♭
 },
 [0x266E]={
  ["category"]="so",
  ["description"]="MUSIC NATURAL SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x266E, -- ♮
 },
 [0x266F]={
  ["category"]="sm",
  ["cjkwd"]="a",
  ["description"]="MUSIC SHARP SIGN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x266F, -- ♯
 },
 [0x2670]={
  ["category"]="so",
  ["description"]="WEST SYRIAC CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2670, -- ♰
 },
 [0x2671]={
  ["category"]="so",
  ["description"]="EAST SYRIAC CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2671, -- ♱
 },
 [0x2672]={
  ["category"]="so",
  ["description"]="UNIVERSAL RECYCLING SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2672, -- ♲
 },
 [0x2673]={
  ["category"]="so",
  ["description"]="RECYCLING SYMBOL FOR TYPE-0x0001 PLASTICS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2673, -- ♳
 },
 [0x2674]={
  ["category"]="so",
  ["description"]="RECYCLING SYMBOL FOR TYPE-0x0002 PLASTICS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2674, -- ♴
 },
 [0x2675]={
  ["category"]="so",
  ["description"]="RECYCLING SYMBOL FOR TYPE-0x0003 PLASTICS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2675, -- ♵
 },
 [0x2676]={
  ["category"]="so",
  ["description"]="RECYCLING SYMBOL FOR TYPE-0x0004 PLASTICS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2676, -- ♶
 },
 [0x2677]={
  ["category"]="so",
  ["description"]="RECYCLING SYMBOL FOR TYPE-0x0005 PLASTICS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2677, -- ♷
 },
 [0x2678]={
  ["category"]="so",
  ["description"]="RECYCLING SYMBOL FOR TYPE-0x0006 PLASTICS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2678, -- ♸
 },
 [0x2679]={
  ["category"]="so",
  ["description"]="RECYCLING SYMBOL FOR TYPE-0x0007 PLASTICS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2679, -- ♹
 },
 [0x267A]={
  ["category"]="so",
  ["description"]="RECYCLING SYMBOL FOR GENERIC MATERIALS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x267A, -- ♺
 },
 [0x267B]={
  ["category"]="so",
  ["description"]="BLACK UNIVERSAL RECYCLING SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x267B, -- ♻
 },
 [0x267C]={
  ["category"]="so",
  ["description"]="RECYCLED PAPER SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x267C, -- ♼
 },
 [0x267D]={
  ["category"]="so",
  ["description"]="PARTIALLY-RECYCLED PAPER SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x267D, -- ♽
 },
 [0x267E]={
  ["category"]="so",
  ["description"]="PERMANENT PAPER SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x267E, -- ♾
 },
 [0x267F]={
  ["category"]="so",
  ["description"]="WHEELCHAIR SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x267F, -- ♿
 },
 [0x2680]={
  ["category"]="so",
  ["description"]="DIE FACE-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2680, -- ⚀
 },
 [0x2681]={
  ["category"]="so",
  ["description"]="DIE FACE-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2681, -- ⚁
 },
 [0x2682]={
  ["category"]="so",
  ["description"]="DIE FACE-0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2682, -- ⚂
 },
 [0x2683]={
  ["category"]="so",
  ["description"]="DIE FACE-0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2683, -- ⚃
 },
 [0x2684]={
  ["category"]="so",
  ["description"]="DIE FACE-0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2684, -- ⚄
 },
 [0x2685]={
  ["category"]="so",
  ["description"]="DIE FACE-0x0006",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2685, -- ⚅
 },
 [0x2686]={
  ["category"]="so",
  ["description"]="WHITE CIRCLE WITH DOT RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2686, -- ⚆
 },
 [0x2687]={
  ["category"]="so",
  ["description"]="WHITE CIRCLE WITH TWO DOTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2687, -- ⚇
 },
 [0x2688]={
  ["category"]="so",
  ["description"]="BLACK CIRCLE WITH WHITE DOT RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2688, -- ⚈
 },
 [0x2689]={
  ["category"]="so",
  ["description"]="BLACK CIRCLE WITH TWO WHITE DOTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2689, -- ⚉
 },
 [0x268A]={
  ["category"]="so",
  ["description"]="MONOGRAM FOR YANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x268A, -- ⚊
 },
 [0x268B]={
  ["category"]="so",
  ["description"]="MONOGRAM FOR YIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x268B, -- ⚋
 },
 [0x268C]={
  ["category"]="so",
  ["description"]="DIGRAM FOR GREATER YANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x268C, -- ⚌
 },
 [0x268D]={
  ["category"]="so",
  ["description"]="DIGRAM FOR LESSER YIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x268D, -- ⚍
 },
 [0x268E]={
  ["category"]="so",
  ["description"]="DIGRAM FOR LESSER YANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x268E, -- ⚎
 },
 [0x268F]={
  ["category"]="so",
  ["description"]="DIGRAM FOR GREATER YIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x268F, -- ⚏
 },
 [0x2690]={
  ["category"]="so",
  ["description"]="WHITE FLAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2690, -- ⚐
 },
 [0x2691]={
  ["category"]="so",
  ["description"]="BLACK FLAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2691, -- ⚑
 },
 [0x2692]={
  ["category"]="so",
  ["description"]="HAMMER AND PICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2692, -- ⚒
 },
 [0x2693]={
  ["category"]="so",
  ["description"]="ANCHOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2693, -- ⚓
 },
 [0x2694]={
  ["category"]="so",
  ["description"]="CROSSED SWORDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2694, -- ⚔
 },
 [0x2695]={
  ["category"]="so",
  ["description"]="STAFF OF AESCULAPIUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2695, -- ⚕
 },
 [0x2696]={
  ["category"]="so",
  ["description"]="SCALES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2696, -- ⚖
 },
 [0x2697]={
  ["category"]="so",
  ["description"]="ALEMBIC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2697, -- ⚗
 },
 [0x2698]={
  ["category"]="so",
  ["description"]="FLOWER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2698, -- ⚘
 },
 [0x2699]={
  ["category"]="so",
  ["description"]="GEAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2699, -- ⚙
 },
 [0x269A]={
  ["category"]="so",
  ["description"]="STAFF OF HERMES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x269A, -- ⚚
 },
 [0x269B]={
  ["category"]="so",
  ["description"]="ATOM SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x269B, -- ⚛
 },
 [0x269C]={
  ["category"]="so",
  ["description"]="FLEUR-DE-LIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x269C, -- ⚜
 },
 [0x26A0]={
  ["category"]="so",
  ["description"]="WARNING SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A0, -- ⚠
 },
 [0x26A1]={
  ["category"]="so",
  ["description"]="HIGH VOLTAGE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A1, -- ⚡
 },
 [0x26A2]={
  ["category"]="so",
  ["description"]="DOUBLED FEMALE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A2, -- ⚢
 },
 [0x26A3]={
  ["category"]="so",
  ["description"]="DOUBLED MALE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A3, -- ⚣
 },
 [0x26A4]={
  ["category"]="so",
  ["description"]="INTERLOCKED FEMALE AND MALE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A4, -- ⚤
 },
 [0x26A5]={
  ["category"]="so",
  ["description"]="MALE AND FEMALE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A5, -- ⚥
 },
 [0x26A6]={
  ["category"]="so",
  ["description"]="MALE WITH STROKE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A6, -- ⚦
 },
 [0x26A7]={
  ["category"]="so",
  ["description"]="MALE WITH STROKE AND MALE AND FEMALE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A7, -- ⚧
 },
 [0x26A8]={
  ["category"]="so",
  ["description"]="VERTICAL MALE WITH STROKE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A8, -- ⚨
 },
 [0x26A9]={
  ["category"]="so",
  ["description"]="HORIZONTAL MALE WITH STROKE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26A9, -- ⚩
 },
 [0x26AA]={
  ["category"]="so",
  ["description"]="MEDIUM WHITE CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26AA, -- ⚪
 },
 [0x26AB]={
  ["category"]="so",
  ["description"]="MEDIUM BLACK CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26AB, -- ⚫
 },
 [0x26AC]={
  ["category"]="so",
  ["description"]="MEDIUM SMALL WHITE CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26AC, -- ⚬
 },
 [0x26AD]={
  ["category"]="so",
  ["description"]="MARRIAGE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26AD, -- ⚭
 },
 [0x26AE]={
  ["category"]="so",
  ["description"]="DIVORCE SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26AE, -- ⚮
 },
 [0x26AF]={
  ["category"]="so",
  ["description"]="UNMARRIED PARTNERSHIP SYMBOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26AF, -- ⚯
 },
 [0x26B0]={
  ["category"]="so",
  ["description"]="COFFIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26B0, -- ⚰
 },
 [0x26B1]={
  ["category"]="so",
  ["description"]="FUNERAL URN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26B1, -- ⚱
 },
 [0x26B2]={
  ["category"]="so",
  ["description"]="NEUTER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x26B2, -- ⚲
 },
 [0x2701]={
  ["category"]="so",
  ["description"]="UPPER BLADE SCISSORS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2701, -- ✁
 },
 [0x2702]={
  ["category"]="so",
  ["description"]="BLACK SCISSORS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2702, -- ✂
 },
 [0x2703]={
  ["category"]="so",
  ["description"]="LOWER BLADE SCISSORS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2703, -- ✃
 },
 [0x2704]={
  ["category"]="so",
  ["description"]="WHITE SCISSORS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2704, -- ✄
 },
 [0x2706]={
  ["category"]="so",
  ["description"]="TELEPHONE LOCATION SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2706, -- ✆
 },
 [0x2707]={
  ["category"]="so",
  ["description"]="TAPE DRIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2707, -- ✇
 },
 [0x2708]={
  ["category"]="so",
  ["description"]="AIRPLANE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2708, -- ✈
 },
 [0x2709]={
  ["category"]="so",
  ["description"]="ENVELOPE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2709, -- ✉
 },
 [0x270C]={
  ["category"]="so",
  ["description"]="VICTORY HAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x270C, -- ✌
 },
 [0x270D]={
  ["category"]="so",
  ["description"]="WRITING HAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x270D, -- ✍
 },
 [0x270E]={
  ["category"]="so",
  ["description"]="LOWER RIGHT PENCIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x270E, -- ✎
 },
 [0x270F]={
  ["category"]="so",
  ["description"]="PENCIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x270F, -- ✏
 },
 [0x2710]={
  ["category"]="so",
  ["description"]="UPPER RIGHT PENCIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2710, -- ✐
 },
 [0x2711]={
  ["category"]="so",
  ["description"]="WHITE NIB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2711, -- ✑
 },
 [0x2712]={
  ["category"]="so",
  ["description"]="BLACK NIB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2712, -- ✒
 },
 [0x2713]={
  ["category"]="so",
  ["description"]="CHECK MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2713, -- ✓
 },
 [0x2714]={
  ["category"]="so",
  ["description"]="HEAVY CHECK MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2714, -- ✔
 },
 [0x2715]={
  ["category"]="so",
  ["description"]="MULTIPLICATION X",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2715, -- ✕
 },
 [0x2716]={
  ["category"]="so",
  ["description"]="HEAVY MULTIPLICATION X",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2716, -- ✖
 },
 [0x2717]={
  ["category"]="so",
  ["description"]="BALLOT X",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2717, -- ✗
 },
 [0x2718]={
  ["category"]="so",
  ["description"]="HEAVY BALLOT X",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2718, -- ✘
 },
 [0x2719]={
  ["category"]="so",
  ["description"]="OUTLINED GREEK CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2719, -- ✙
 },
 [0x271A]={
  ["category"]="so",
  ["description"]="HEAVY GREEK CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x271A, -- ✚
 },
 [0x271B]={
  ["category"]="so",
  ["description"]="OPEN CENTRE CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x271B, -- ✛
 },
 [0x271C]={
  ["category"]="so",
  ["description"]="HEAVY OPEN CENTRE CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x271C, -- ✜
 },
 [0x271D]={
  ["category"]="so",
  ["description"]="LATIN CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x271D, -- ✝
 },
 [0x271E]={
  ["category"]="so",
  ["description"]="SHADOWED WHITE LATIN CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x271E, -- ✞
 },
 [0x271F]={
  ["category"]="so",
  ["description"]="OUTLINED LATIN CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x271F, -- ✟
 },
 [0x2720]={
  ["category"]="so",
  ["description"]="MALTESE CROSS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2720, -- ✠
 },
 [0x2721]={
  ["category"]="so",
  ["description"]="STAR OF DAVID",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2721, -- ✡
 },
 [0x2722]={
  ["category"]="so",
  ["description"]="FOUR TEARDROP-SPOKED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2722, -- ✢
 },
 [0x2723]={
  ["category"]="so",
  ["description"]="FOUR BALLOON-SPOKED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2723, -- ✣
 },
 [0x2724]={
  ["category"]="so",
  ["description"]="HEAVY FOUR BALLOON-SPOKED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2724, -- ✤
 },
 [0x2725]={
  ["category"]="so",
  ["description"]="FOUR CLUB-SPOKED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2725, -- ✥
 },
 [0x2726]={
  ["category"]="so",
  ["description"]="BLACK FOUR POINTED STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2726, -- ✦
 },
 [0x2727]={
  ["category"]="so",
  ["description"]="WHITE FOUR POINTED STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2727, -- ✧
 },
 [0x2729]={
  ["category"]="so",
  ["description"]="STRESS OUTLINED WHITE STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2729, -- ✩
 },
 [0x272A]={
  ["category"]="so",
  ["description"]="CIRCLED WHITE STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x272A, -- ✪
 },
 [0x272B]={
  ["category"]="so",
  ["description"]="OPEN CENTRE BLACK STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x272B, -- ✫
 },
 [0x272C]={
  ["category"]="so",
  ["description"]="BLACK CENTRE WHITE STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x272C, -- ✬
 },
 [0x272D]={
  ["category"]="so",
  ["description"]="OUTLINED BLACK STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x272D, -- ✭
 },
 [0x272E]={
  ["category"]="so",
  ["description"]="HEAVY OUTLINED BLACK STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x272E, -- ✮
 },
 [0x272F]={
  ["category"]="so",
  ["description"]="PINWHEEL STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x272F, -- ✯
 },
 [0x2730]={
  ["category"]="so",
  ["description"]="SHADOWED WHITE STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2730, -- ✰
 },
 [0x2731]={
  ["category"]="so",
  ["description"]="HEAVY ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2731, -- ✱
 },
 [0x2732]={
  ["category"]="so",
  ["description"]="OPEN CENTRE ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2732, -- ✲
 },
 [0x2733]={
  ["category"]="so",
  ["description"]="EIGHT SPOKED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2733, -- ✳
 },
 [0x2734]={
  ["category"]="so",
  ["description"]="EIGHT POINTED BLACK STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2734, -- ✴
 },
 [0x2735]={
  ["category"]="so",
  ["description"]="EIGHT POINTED PINWHEEL STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2735, -- ✵
 },
 [0x2736]={
  ["category"]="so",
  ["description"]="SIX POINTED BLACK STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2736, -- ✶
 },
 [0x2737]={
  ["category"]="so",
  ["description"]="EIGHT POINTED RECTILINEAR BLACK STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2737, -- ✷
 },
 [0x2738]={
  ["category"]="so",
  ["description"]="HEAVY EIGHT POINTED RECTILINEAR BLACK STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2738, -- ✸
 },
 [0x2739]={
  ["category"]="so",
  ["description"]="TWELVE POINTED BLACK STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2739, -- ✹
 },
 [0x273A]={
  ["category"]="so",
  ["description"]="SIXTEEN POINTED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x273A, -- ✺
 },
 [0x273B]={
  ["category"]="so",
  ["description"]="TEARDROP-SPOKED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x273B, -- ✻
 },
 [0x273C]={
  ["category"]="so",
  ["description"]="OPEN CENTRE TEARDROP-SPOKED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x273C, -- ✼
 },
 [0x273D]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="HEAVY TEARDROP-SPOKED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x273D, -- ✽
 },
 [0x273E]={
  ["category"]="so",
  ["description"]="SIX PETALLED BLACK AND WHITE FLORETTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x273E, -- ✾
 },
 [0x273F]={
  ["category"]="so",
  ["description"]="BLACK FLORETTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x273F, -- ✿
 },
 [0x2740]={
  ["category"]="so",
  ["description"]="WHITE FLORETTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2740, -- ❀
 },
 [0x2741]={
  ["category"]="so",
  ["description"]="EIGHT PETALLED OUTLINED BLACK FLORETTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2741, -- ❁
 },
 [0x2742]={
  ["category"]="so",
  ["description"]="CIRCLED OPEN CENTRE EIGHT POINTED STAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2742, -- ❂
 },
 [0x2743]={
  ["category"]="so",
  ["description"]="HEAVY TEARDROP-SPOKED PINWHEEL ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2743, -- ❃
 },
 [0x2744]={
  ["category"]="so",
  ["description"]="SNOWFLAKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2744, -- ❄
 },
 [0x2745]={
  ["category"]="so",
  ["description"]="TIGHT TRIFOLIATE SNOWFLAKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2745, -- ❅
 },
 [0x2746]={
  ["category"]="so",
  ["description"]="HEAVY CHEVRON SNOWFLAKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2746, -- ❆
 },
 [0x2747]={
  ["category"]="so",
  ["description"]="SPARKLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2747, -- ❇
 },
 [0x2748]={
  ["category"]="so",
  ["description"]="HEAVY SPARKLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2748, -- ❈
 },
 [0x2749]={
  ["category"]="so",
  ["description"]="BALLOON-SPOKED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2749, -- ❉
 },
 [0x274A]={
  ["category"]="so",
  ["description"]="EIGHT TEARDROP-SPOKED PROPELLER ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x274A, -- ❊
 },
 [0x274B]={
  ["category"]="so",
  ["description"]="HEAVY EIGHT TEARDROP-SPOKED PROPELLER ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x274B, -- ❋
 },
 [0x274D]={
  ["category"]="so",
  ["description"]="SHADOWED WHITE CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x274D, -- ❍
 },
 [0x274F]={
  ["category"]="so",
  ["description"]="LOWER RIGHT DROP-SHADOWED WHITE SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x274F, -- ❏
 },
 [0x2750]={
  ["category"]="so",
  ["description"]="UPPER RIGHT DROP-SHADOWED WHITE SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2750, -- ❐
 },
 [0x2751]={
  ["category"]="so",
  ["description"]="LOWER RIGHT SHADOWED WHITE SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2751, -- ❑
 },
 [0x2752]={
  ["category"]="so",
  ["description"]="UPPER RIGHT SHADOWED WHITE SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2752, -- ❒
 },
 [0x2756]={
  ["category"]="so",
  ["description"]="BLACK DIAMOND MINUS WHITE X",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2756, -- ❖
 },
 [0x2758]={
  ["category"]="so",
  ["description"]="LIGHT VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2758, -- ❘
 },
 [0x2759]={
  ["category"]="so",
  ["description"]="MEDIUM VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2759, -- ❙
 },
 [0x275A]={
  ["category"]="so",
  ["description"]="HEAVY VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x275A, -- ❚
 },
 [0x275B]={
  ["category"]="so",
  ["description"]="HEAVY SINGLE TURNED COMMA QUOTATION MARK ORNAMENT",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x275B, -- ❛
 },
 [0x275C]={
  ["category"]="so",
  ["description"]="HEAVY SINGLE COMMA QUOTATION MARK ORNAMENT",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x275C, -- ❜
 },
 [0x275D]={
  ["category"]="so",
  ["description"]="HEAVY DOUBLE TURNED COMMA QUOTATION MARK ORNAMENT",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x275D, -- ❝
 },
 [0x275E]={
  ["category"]="so",
  ["description"]="HEAVY DOUBLE COMMA QUOTATION MARK ORNAMENT",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x275E, -- ❞
 },
 [0x2761]={
  ["category"]="so",
  ["description"]="CURVED STEM PARAGRAPH SIGN ORNAMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2761, -- ❡
 },
 [0x2762]={
  ["category"]="so",
  ["description"]="HEAVY EXCLAMATION MARK ORNAMENT",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x2762, -- ❢
 },
 [0x2763]={
  ["category"]="so",
  ["description"]="HEAVY HEART EXCLAMATION MARK ORNAMENT",
  ["linebreak"]="ex",
  ["unicodeslot"]=0x2763, -- ❣
 },
 [0x2764]={
  ["category"]="so",
  ["description"]="HEAVY BLACK HEART",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2764, -- ❤
 },
 [0x2765]={
  ["category"]="so",
  ["description"]="ROTATED HEAVY BLACK HEART BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2765, -- ❥
 },
 [0x2766]={
  ["category"]="so",
  ["description"]="FLORAL HEART",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2766, -- ❦
 },
 [0x2767]={
  ["category"]="so",
  ["description"]="ROTATED FLORAL HEART BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2767, -- ❧
 },
 [0x2768]={
  ["category"]="ps",
  ["description"]="MEDIUM LEFT PARENTHESIS ORNAMENT",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2768, -- ❨
 },
 [0x2769]={
  ["category"]="pe",
  ["description"]="MEDIUM RIGHT PARENTHESIS ORNAMENT",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2769, -- ❩
 },
 [0x276A]={
  ["category"]="ps",
  ["description"]="MEDIUM FLATTENED LEFT PARENTHESIS ORNAMENT",
  ["linebreak"]="op",
  ["unicodeslot"]=0x276A, -- ❪
 },
 [0x276B]={
  ["category"]="pe",
  ["description"]="MEDIUM FLATTENED RIGHT PARENTHESIS ORNAMENT",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x276B, -- ❫
 },
 [0x276C]={
  ["category"]="ps",
  ["description"]="MEDIUM LEFT-POINTING ANGLE BRACKET ORNAMENT",
  ["linebreak"]="op",
  ["unicodeslot"]=0x276C, -- ❬
 },
 [0x276D]={
  ["category"]="pe",
  ["description"]="MEDIUM RIGHT-POINTING ANGLE BRACKET ORNAMENT",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x276D, -- ❭
 },
 [0x276E]={
  ["category"]="ps",
  ["description"]="HEAVY LEFT-POINTING ANGLE QUOTATION MARK ORNAMENT",
  ["linebreak"]="op",
  ["unicodeslot"]=0x276E, -- ❮
 },
 [0x276F]={
  ["category"]="pe",
  ["description"]="HEAVY RIGHT-POINTING ANGLE QUOTATION MARK ORNAMENT",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x276F, -- ❯
 },
 [0x2770]={
  ["category"]="ps",
  ["description"]="HEAVY LEFT-POINTING ANGLE BRACKET ORNAMENT",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2770, -- ❰
 },
 [0x2771]={
  ["category"]="pe",
  ["description"]="HEAVY RIGHT-POINTING ANGLE BRACKET ORNAMENT",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2771, -- ❱
 },
 [0x2772]={
  ["category"]="ps",
  ["description"]="LIGHT LEFT TORTOISE SHELL BRACKET ORNAMENT",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2772, -- ❲
 },
 [0x2773]={
  ["category"]="pe",
  ["description"]="LIGHT RIGHT TORTOISE SHELL BRACKET ORNAMENT",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2773, -- ❳
 },
 [0x2774]={
  ["category"]="ps",
  ["description"]="MEDIUM LEFT CURLY BRACKET ORNAMENT",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2774, -- ❴
 },
 [0x2775]={
  ["category"]="pe",
  ["description"]="MEDIUM RIGHT CURLY BRACKET ORNAMENT",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2775, -- ❵
 },
 [0x2776]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED DIGIT ONE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2776, -- ❶
 },
 [0x2777]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED DIGIT TWO",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2777, -- ❷
 },
 [0x2778]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED DIGIT THREE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2778, -- ❸
 },
 [0x2779]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED DIGIT FOUR",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2779, -- ❹
 },
 [0x277A]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED DIGIT FIVE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x277A, -- ❺
 },
 [0x277B]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED DIGIT SIX",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x277B, -- ❻
 },
 [0x277C]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED DIGIT SEVEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x277C, -- ❼
 },
 [0x277D]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED DIGIT EIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x277D, -- ❽
 },
 [0x277E]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED DIGIT NINE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x277E, -- ❾
 },
 [0x277F]={
  ["category"]="no",
  ["cjkwd"]="a",
  ["description"]="DINGBAT NEGATIVE CIRCLED NUMBER TEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x277F, -- ❿
 },
 [0x2780]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF DIGIT ONE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2780, -- ➀
 },
 [0x2781]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF DIGIT TWO",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2781, -- ➁
 },
 [0x2782]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF DIGIT THREE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2782, -- ➂
 },
 [0x2783]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF DIGIT FOUR",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2783, -- ➃
 },
 [0x2784]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF DIGIT FIVE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2784, -- ➄
 },
 [0x2785]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF DIGIT SIX",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2785, -- ➅
 },
 [0x2786]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF DIGIT SEVEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2786, -- ➆
 },
 [0x2787]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF DIGIT EIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2787, -- ➇
 },
 [0x2788]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF DIGIT NINE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2788, -- ➈
 },
 [0x2789]={
  ["category"]="no",
  ["description"]="DINGBAT CIRCLED SANS-SERIF NUMBER TEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2789, -- ➉
 },
 [0x278A]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT ONE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x278A, -- ➊
 },
 [0x278B]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT TWO",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x278B, -- ➋
 },
 [0x278C]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT THREE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x278C, -- ➌
 },
 [0x278D]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FOUR",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x278D, -- ➍
 },
 [0x278E]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FIVE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x278E, -- ➎
 },
 [0x278F]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SIX",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x278F, -- ➏
 },
 [0x2790]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SEVEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2790, -- ➐
 },
 [0x2791]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT EIGHT",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2791, -- ➑
 },
 [0x2792]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT NINE",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2792, -- ➒
 },
 [0x2793]={
  ["category"]="no",
  ["description"]="DINGBAT NEGATIVE CIRCLED SANS-SERIF NUMBER TEN",
  ["linebreak"]="ai",
  ["unicodeslot"]=0x2793, -- ➓
 },
 [0x2794]={
  ["category"]="so",
  ["description"]="HEAVY WIDE-HEADED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2794, -- ➔
 },
 [0x2798]={
  ["category"]="so",
  ["description"]="HEAVY SOUTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2798, -- ➘
 },
 [0x2799]={
  ["category"]="so",
  ["description"]="HEAVY RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2799, -- ➙
 },
 [0x279A]={
  ["category"]="so",
  ["description"]="HEAVY NORTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x279A, -- ➚
 },
 [0x279B]={
  ["category"]="so",
  ["description"]="DRAFTING POINT RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x279B, -- ➛
 },
 [0x279C]={
  ["category"]="so",
  ["description"]="HEAVY ROUND-TIPPED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x279C, -- ➜
 },
 [0x279D]={
  ["category"]="so",
  ["description"]="TRIANGLE-HEADED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x279D, -- ➝
 },
 [0x279E]={
  ["category"]="so",
  ["description"]="HEAVY TRIANGLE-HEADED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x279E, -- ➞
 },
 [0x279F]={
  ["category"]="so",
  ["description"]="DASHED TRIANGLE-HEADED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x279F, -- ➟
 },
 [0x27A0]={
  ["category"]="so",
  ["description"]="HEAVY DASHED TRIANGLE-HEADED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A0, -- ➠
 },
 [0x27A1]={
  ["category"]="so",
  ["description"]="BLACK RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A1, -- ➡
 },
 [0x27A2]={
  ["category"]="so",
  ["description"]="THREE-D TOP-LIGHTED RIGHTWARDS ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A2, -- ➢
 },
 [0x27A3]={
  ["category"]="so",
  ["description"]="THREE-D BOTTOM-LIGHTED RIGHTWARDS ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A3, -- ➣
 },
 [0x27A4]={
  ["category"]="so",
  ["description"]="BLACK RIGHTWARDS ARROWHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A4, -- ➤
 },
 [0x27A5]={
  ["category"]="so",
  ["description"]="HEAVY BLACK CURVED DOWNWARDS AND RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A5, -- ➥
 },
 [0x27A6]={
  ["category"]="so",
  ["description"]="HEAVY BLACK CURVED UPWARDS AND RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A6, -- ➦
 },
 [0x27A7]={
  ["category"]="so",
  ["description"]="SQUAT BLACK RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A7, -- ➧
 },
 [0x27A8]={
  ["category"]="so",
  ["description"]="HEAVY CONCAVE-POINTED BLACK RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A8, -- ➨
 },
 [0x27A9]={
  ["category"]="so",
  ["description"]="RIGHT-SHADED WHITE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27A9, -- ➩
 },
 [0x27AA]={
  ["category"]="so",
  ["description"]="LEFT-SHADED WHITE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27AA, -- ➪
 },
 [0x27AB]={
  ["category"]="so",
  ["description"]="BACK-TILTED SHADOWED WHITE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27AB, -- ➫
 },
 [0x27AC]={
  ["category"]="so",
  ["description"]="FRONT-TILTED SHADOWED WHITE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27AC, -- ➬
 },
 [0x27AD]={
  ["category"]="so",
  ["description"]="HEAVY LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27AD, -- ➭
 },
 [0x27AE]={
  ["category"]="so",
  ["description"]="HEAVY UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27AE, -- ➮
 },
 [0x27AF]={
  ["category"]="so",
  ["description"]="NOTCHED LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27AF, -- ➯
 },
 [0x27B1]={
  ["category"]="so",
  ["description"]="NOTCHED UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27B1, -- ➱
 },
 [0x27B2]={
  ["category"]="so",
  ["description"]="CIRCLED HEAVY WHITE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27B2, -- ➲
 },
 [0x27B3]={
  ["category"]="so",
  ["description"]="WHITE-FEATHERED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27B3, -- ➳
 },
 [0x27B4]={
  ["category"]="so",
  ["description"]="BLACK-FEATHERED SOUTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27B4, -- ➴
 },
 [0x27B5]={
  ["category"]="so",
  ["description"]="BLACK-FEATHERED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27B5, -- ➵
 },
 [0x27B6]={
  ["category"]="so",
  ["description"]="BLACK-FEATHERED NORTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27B6, -- ➶
 },
 [0x27B7]={
  ["category"]="so",
  ["description"]="HEAVY BLACK-FEATHERED SOUTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27B7, -- ➷
 },
 [0x27B8]={
  ["category"]="so",
  ["description"]="HEAVY BLACK-FEATHERED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27B8, -- ➸
 },
 [0x27B9]={
  ["category"]="so",
  ["description"]="HEAVY BLACK-FEATHERED NORTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27B9, -- ➹
 },
 [0x27BA]={
  ["category"]="so",
  ["description"]="TEARDROP-BARBED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27BA, -- ➺
 },
 [0x27BB]={
  ["category"]="so",
  ["description"]="HEAVY TEARDROP-SHANKED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27BB, -- ➻
 },
 [0x27BC]={
  ["category"]="so",
  ["description"]="WEDGE-TAILED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27BC, -- ➼
 },
 [0x27BD]={
  ["category"]="so",
  ["description"]="HEAVY WEDGE-TAILED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27BD, -- ➽
 },
 [0x27BE]={
  ["category"]="so",
  ["description"]="OPEN-OUTLINED RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27BE, -- ➾
 },
 [0x27C0]={
  ["category"]="sm",
  ["description"]="THREE DIMENSIONAL ANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27C0, -- ⟀
 },
 [0x27C1]={
  ["category"]="sm",
  ["description"]="WHITE TRIANGLE CONTAINING SMALL WHITE TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27C1, -- ⟁
 },
 [0x27C2]={
  ["category"]="sm",
  ["description"]="PERPENDICULAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27C2, -- ⟂
 },
 [0x27C3]={
  ["category"]="sm",
  ["description"]="OPEN SUBSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27C3, -- ⟃
 },
 [0x27C4]={
  ["category"]="sm",
  ["description"]="OPEN SUPERSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27C4, -- ⟄
 },
 [0x27C5]={
  ["category"]="ps",
  ["description"]="LEFT S-SHAPED BAG DELIMITER",
  ["linebreak"]="op",
  ["unicodeslot"]=0x27C5, -- ⟅
 },
 [0x27C6]={
  ["category"]="pe",
  ["description"]="RIGHT S-SHAPED BAG DELIMITER",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x27C6, -- ⟆
 },
 [0x27C7]={
  ["category"]="sm",
  ["description"]="OR WITH DOT INSIDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27C7, -- ⟇
 },
 [0x27C8]={
  ["category"]="sm",
  ["description"]="REVERSE SOLIDUS PRECEDING SUBSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27C8, -- ⟈
 },
 [0x27C9]={
  ["category"]="sm",
  ["description"]="SUPERSET PRECEDING SOLIDUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27C9, -- ⟉
 },
 [0x27CA]={
  ["category"]="sm",
  ["description"]="VERTICAL BAR WITH HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27CA, -- ⟊
 },
 [0x27D0]={
  ["category"]="sm",
  ["description"]="WHITE DIAMOND WITH CENTRED DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D0, -- ⟐
 },
 [0x27D1]={
  ["category"]="sm",
  ["description"]="AND WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D1, -- ⟑
 },
 [0x27D2]={
  ["category"]="sm",
  ["description"]="ELEMENT OF OPENING UPWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D2, -- ⟒
 },
 [0x27D3]={
  ["category"]="sm",
  ["description"]="LOWER RIGHT CORNER WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D3, -- ⟓
 },
 [0x27D4]={
  ["category"]="sm",
  ["description"]="UPPER LEFT CORNER WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D4, -- ⟔
 },
 [0x27D5]={
  ["category"]="sm",
  ["description"]="LEFT OUTER JOIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D5, -- ⟕
 },
 [0x27D6]={
  ["category"]="sm",
  ["description"]="RIGHT OUTER JOIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D6, -- ⟖
 },
 [0x27D7]={
  ["category"]="sm",
  ["description"]="FULL OUTER JOIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D7, -- ⟗
 },
 [0x27D8]={
  ["category"]="sm",
  ["description"]="LARGE UP TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D8, -- ⟘
 },
 [0x27D9]={
  ["category"]="sm",
  ["description"]="LARGE DOWN TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27D9, -- ⟙
 },
 [0x27DA]={
  ["category"]="sm",
  ["description"]="LEFT AND RIGHT DOUBLE TURNSTILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27DA, -- ⟚
 },
 [0x27DB]={
  ["category"]="sm",
  ["description"]="LEFT AND RIGHT TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27DB, -- ⟛
 },
 [0x27DC]={
  ["category"]="sm",
  ["description"]="LEFT MULTIMAP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27DC, -- ⟜
 },
 [0x27DD]={
  ["category"]="sm",
  ["description"]="LONG RIGHT TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27DD, -- ⟝
 },
 [0x27DE]={
  ["category"]="sm",
  ["description"]="LONG LEFT TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27DE, -- ⟞
 },
 [0x27DF]={
  ["category"]="sm",
  ["description"]="UP TACK WITH CIRCLE ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27DF, -- ⟟
 },
 [0x27E0]={
  ["category"]="sm",
  ["description"]="LOZENGE DIVIDED BY HORIZONTAL RULE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27E0, -- ⟠
 },
 [0x27E1]={
  ["category"]="sm",
  ["description"]="WHITE CONCAVE-SIDED DIAMOND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27E1, -- ⟡
 },
 [0x27E2]={
  ["category"]="sm",
  ["description"]="WHITE CONCAVE-SIDED DIAMOND WITH LEFTWARDS TICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27E2, -- ⟢
 },
 [0x27E3]={
  ["category"]="sm",
  ["description"]="WHITE CONCAVE-SIDED DIAMOND WITH RIGHTWARDS TICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27E3, -- ⟣
 },
 [0x27E4]={
  ["category"]="sm",
  ["description"]="WHITE SQUARE WITH LEFTWARDS TICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27E4, -- ⟤
 },
 [0x27E5]={
  ["category"]="sm",
  ["description"]="WHITE SQUARE WITH RIGHTWARDS TICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27E5, -- ⟥
 },
 [0x27E6]={
  ["category"]="ps",
  ["cjkwd"]="na",
  ["description"]="MATHEMATICAL LEFT WHITE SQUARE BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x27E6, -- ⟦
 },
 [0x27E7]={
  ["category"]="pe",
  ["cjkwd"]="na",
  ["description"]="MATHEMATICAL RIGHT WHITE SQUARE BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x27E7, -- ⟧
 },
 [0x27E8]={
  ["category"]="ps",
  ["cjkwd"]="na",
  ["description"]="MATHEMATICAL LEFT ANGLE BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x27E8, -- ⟨
 },
 [0x27E9]={
  ["category"]="pe",
  ["cjkwd"]="na",
  ["description"]="MATHEMATICAL RIGHT ANGLE BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x27E9, -- ⟩
 },
 [0x27EA]={
  ["category"]="ps",
  ["cjkwd"]="na",
  ["description"]="MATHEMATICAL LEFT DOUBLE ANGLE BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x27EA, -- ⟪
 },
 [0x27EB]={
  ["category"]="pe",
  ["cjkwd"]="na",
  ["description"]="MATHEMATICAL RIGHT DOUBLE ANGLE BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x27EB, -- ⟫
 },
 [0x27F0]={
  ["category"]="sm",
  ["description"]="UPWARDS QUADRUPLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F0, -- ⟰
 },
 [0x27F1]={
  ["category"]="sm",
  ["description"]="DOWNWARDS QUADRUPLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F1, -- ⟱
 },
 [0x27F2]={
  ["category"]="sm",
  ["description"]="ANTICLOCKWISE GAPPED CIRCLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F2, -- ⟲
 },
 [0x27F3]={
  ["category"]="sm",
  ["description"]="CLOCKWISE GAPPED CIRCLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F3, -- ⟳
 },
 [0x27F4]={
  ["category"]="sm",
  ["description"]="RIGHT ARROW WITH CIRCLED PLUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F4, -- ⟴
 },
 [0x27F5]={
  ["category"]="sm",
  ["description"]="LONG LEFTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F5, -- ⟵
 },
 [0x27F6]={
  ["category"]="sm",
  ["description"]="LONG RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F6, -- ⟶
 },
 [0x27F7]={
  ["category"]="sm",
  ["description"]="LONG LEFT RIGHT ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F7, -- ⟷
 },
 [0x27F8]={
  ["category"]="sm",
  ["description"]="LONG LEFTWARDS DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F8, -- ⟸
 },
 [0x27F9]={
  ["category"]="sm",
  ["description"]="LONG RIGHTWARDS DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27F9, -- ⟹
 },
 [0x27FA]={
  ["category"]="sm",
  ["description"]="LONG LEFT RIGHT DOUBLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27FA, -- ⟺
 },
 [0x27FB]={
  ["category"]="sm",
  ["description"]="LONG LEFTWARDS ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27FB, -- ⟻
 },
 [0x27FC]={
  ["category"]="sm",
  ["description"]="LONG RIGHTWARDS ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27FC, -- ⟼
 },
 [0x27FD]={
  ["category"]="sm",
  ["description"]="LONG LEFTWARDS DOUBLE ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27FD, -- ⟽
 },
 [0x27FE]={
  ["category"]="sm",
  ["description"]="LONG RIGHTWARDS DOUBLE ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27FE, -- ⟾
 },
 [0x27FF]={
  ["category"]="sm",
  ["description"]="LONG RIGHTWARDS SQUIGGLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x27FF, -- ⟿
 },
 [0x2800]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN BLANK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2800, -- ⠀
 },
 [0x2801]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2801, -- ⠁
 },
 [0x2802]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2802, -- ⠂
 },
 [0x2803]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x000C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2803, -- ⠃
 },
 [0x2804]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2804, -- ⠄
 },
 [0x2805]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x000D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2805, -- ⠅
 },
 [0x2806]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0017",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2806, -- ⠆
 },
 [0x2807]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x007B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2807, -- ⠇
 },
 [0x2808]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2808, -- ⠈
 },
 [0x2809]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x000E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2809, -- ⠉
 },
 [0x280A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0018",
  ["linebreak"]="al",
  ["unicodeslot"]=0x280A, -- ⠊
 },
 [0x280B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x007C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x280B, -- ⠋
 },
 [0x280C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0022",
  ["linebreak"]="al",
  ["unicodeslot"]=0x280C, -- ⠌
 },
 [0x280D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0086",
  ["linebreak"]="al",
  ["unicodeslot"]=0x280D, -- ⠍
 },
 [0x280E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00EA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x280E, -- ⠎
 },
 [0x280F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04D2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x280F, -- ⠏
 },
 [0x2810]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2810, -- ⠐
 },
 [0x2811]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x000F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2811, -- ⠑
 },
 [0x2812]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0019",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2812, -- ⠒
 },
 [0x2813]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x007D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2813, -- ⠓
 },
 [0x2814]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0023",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2814, -- ⠔
 },
 [0x2815]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0087",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2815, -- ⠕
 },
 [0x2816]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00EB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2816, -- ⠖
 },
 [0x2817]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04D3",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2817, -- ⠗
 },
 [0x2818]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x002D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2818, -- ⠘
 },
 [0x2819]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0091",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2819, -- ⠙
 },
 [0x281A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00F5",
  ["linebreak"]="al",
  ["unicodeslot"]=0x281A, -- ⠚
 },
 [0x281B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04DD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x281B, -- ⠛
 },
 [0x281C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0159",
  ["linebreak"]="al",
  ["unicodeslot"]=0x281C, -- ⠜
 },
 [0x281D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0541",
  ["linebreak"]="al",
  ["unicodeslot"]=0x281D, -- ⠝
 },
 [0x281E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0929",
  ["linebreak"]="al",
  ["unicodeslot"]=0x281E, -- ⠞
 },
 [0x281F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3039",
  ["linebreak"]="al",
  ["unicodeslot"]=0x281F, -- ⠟
 },
 [0x2820]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0006",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2820, -- ⠠
 },
 [0x2821]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0010",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2821, -- ⠡
 },
 [0x2822]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x001A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2822, -- ⠢
 },
 [0x2823]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x007E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2823, -- ⠣
 },
 [0x2824]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0024",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2824, -- ⠤
 },
 [0x2825]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0088",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2825, -- ⠥
 },
 [0x2826]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00EC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2826, -- ⠦
 },
 [0x2827]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04D4",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2827, -- ⠧
 },
 [0x2828]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x002E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2828, -- ⠨
 },
 [0x2829]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0092",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2829, -- ⠩
 },
 [0x282A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00F6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x282A, -- ⠪
 },
 [0x282B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04DE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x282B, -- ⠫
 },
 [0x282C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x015A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x282C, -- ⠬
 },
 [0x282D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0542",
  ["linebreak"]="al",
  ["unicodeslot"]=0x282D, -- ⠭
 },
 [0x282E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x092A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x282E, -- ⠮
 },
 [0x282F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x303A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x282F, -- ⠯
 },
 [0x2830]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0038",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2830, -- ⠰
 },
 [0x2831]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x009C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2831, -- ⠱
 },
 [0x2832]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0100",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2832, -- ⠲
 },
 [0x2833]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04E8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2833, -- ⠳
 },
 [0x2834]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0164",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2834, -- ⠴
 },
 [0x2835]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x054C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2835, -- ⠵
 },
 [0x2836]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0934",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2836, -- ⠶
 },
 [0x2837]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3044",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2837, -- ⠷
 },
 [0x2838]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x01C8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2838, -- ⠸
 },
 [0x2839]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x05B0",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2839, -- ⠹
 },
 [0x283A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0998",
  ["linebreak"]="al",
  ["unicodeslot"]=0x283A, -- ⠺
 },
 [0x283B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x30A8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x283B, -- ⠻
 },
 [0x283C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0D80",
  ["linebreak"]="al",
  ["unicodeslot"]=0x283C, -- ⠼
 },
 [0x283D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3490",
  ["linebreak"]="al",
  ["unicodeslot"]=0x283D, -- ⠽
 },
 [0x283E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5BA0",
  ["linebreak"]="al",
  ["unicodeslot"]=0x283E, -- ⠾
 },
 [0x283F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E240",
  ["linebreak"]="al",
  ["unicodeslot"]=0x283F, -- ⠿
 },
 [0x2840]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0007",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2840, -- ⡀
 },
 [0x2841]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0011",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2841, -- ⡁
 },
 [0x2842]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x001B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2842, -- ⡂
 },
 [0x2843]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x007F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2843, -- ⡃
 },
 [0x2844]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0025",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2844, -- ⡄
 },
 [0x2845]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0089",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2845, -- ⡅
 },
 [0x2846]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00ED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2846, -- ⡆
 },
 [0x2847]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04D5",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2847, -- ⡇
 },
 [0x2848]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x002F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2848, -- ⡈
 },
 [0x2849]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0093",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2849, -- ⡉
 },
 [0x284A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00F7",
  ["linebreak"]="al",
  ["unicodeslot"]=0x284A, -- ⡊
 },
 [0x284B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04DF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x284B, -- ⡋
 },
 [0x284C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x015B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x284C, -- ⡌
 },
 [0x284D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0543",
  ["linebreak"]="al",
  ["unicodeslot"]=0x284D, -- ⡍
 },
 [0x284E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x092B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x284E, -- ⡎
 },
 [0x284F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x303B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x284F, -- ⡏
 },
 [0x2850]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0039",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2850, -- ⡐
 },
 [0x2851]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x009D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2851, -- ⡑
 },
 [0x2852]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0101",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2852, -- ⡒
 },
 [0x2853]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04E9",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2853, -- ⡓
 },
 [0x2854]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0165",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2854, -- ⡔
 },
 [0x2855]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x054D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2855, -- ⡕
 },
 [0x2856]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0935",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2856, -- ⡖
 },
 [0x2857]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3045",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2857, -- ⡗
 },
 [0x2858]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x01C9",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2858, -- ⡘
 },
 [0x2859]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x05B1",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2859, -- ⡙
 },
 [0x285A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0999",
  ["linebreak"]="al",
  ["unicodeslot"]=0x285A, -- ⡚
 },
 [0x285B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x30A9",
  ["linebreak"]="al",
  ["unicodeslot"]=0x285B, -- ⡛
 },
 [0x285C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0D81",
  ["linebreak"]="al",
  ["unicodeslot"]=0x285C, -- ⡜
 },
 [0x285D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3491",
  ["linebreak"]="al",
  ["unicodeslot"]=0x285D, -- ⡝
 },
 [0x285E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5BA1",
  ["linebreak"]="al",
  ["unicodeslot"]=0x285E, -- ⡞
 },
 [0x285F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E241",
  ["linebreak"]="al",
  ["unicodeslot"]=0x285F, -- ⡟
 },
 [0x2860]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0043",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2860, -- ⡠
 },
 [0x2861]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00A7",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2861, -- ⡡
 },
 [0x2862]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x010B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2862, -- ⡢
 },
 [0x2863]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04F3",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2863, -- ⡣
 },
 [0x2864]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x016F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2864, -- ⡤
 },
 [0x2865]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0557",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2865, -- ⡥
 },
 [0x2866]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x093F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2866, -- ⡦
 },
 [0x2867]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x304F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2867, -- ⡧
 },
 [0x2868]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x01D3",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2868, -- ⡨
 },
 [0x2869]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x05BB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2869, -- ⡩
 },
 [0x286A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x09A3",
  ["linebreak"]="al",
  ["unicodeslot"]=0x286A, -- ⡪
 },
 [0x286B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x30B3",
  ["linebreak"]="al",
  ["unicodeslot"]=0x286B, -- ⡫
 },
 [0x286C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0D8B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x286C, -- ⡬
 },
 [0x286D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x349B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x286D, -- ⡭
 },
 [0x286E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5BAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x286E, -- ⡮
 },
 [0x286F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E24B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x286F, -- ⡯
 },
 [0x2870]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0237",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2870, -- ⡰
 },
 [0x2871]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x061F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2871, -- ⡱
 },
 [0x2872]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0A07",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2872, -- ⡲
 },
 [0x2873]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3117",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2873, -- ⡳
 },
 [0x2874]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0DEF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2874, -- ⡴
 },
 [0x2875]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x34FF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2875, -- ⡵
 },
 [0x2876]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5C0F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2876, -- ⡶
 },
 [0x2877]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E2AF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2877, -- ⡷
 },
 [0x2878]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x11D7",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2878, -- ⡸
 },
 [0x2879]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x38E7",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2879, -- ⡹
 },
 [0x287A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5FF7",
  ["linebreak"]="al",
  ["unicodeslot"]=0x287A, -- ⡺
 },
 [0x287B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E697",
  ["linebreak"]="al",
  ["unicodeslot"]=0x287B, -- ⡻
 },
 [0x287C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x8707",
  ["linebreak"]="al",
  ["unicodeslot"]=0x287C, -- ⡼
 },
 [0x287D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x20DA7",
  ["linebreak"]="al",
  ["unicodeslot"]=0x287D, -- ⡽
 },
 [0x287E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x39447",
  ["linebreak"]="al",
  ["unicodeslot"]=0x287E, -- ⡾
 },
 [0x287F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x12D687",
  ["linebreak"]="al",
  ["unicodeslot"]=0x287F, -- ⡿
 },
 [0x2880]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0008",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2880, -- ⢀
 },
 [0x2881]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0012",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2881, -- ⢁
 },
 [0x2882]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x001C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2882, -- ⢂
 },
 [0x2883]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0080",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2883, -- ⢃
 },
 [0x2884]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0026",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2884, -- ⢄
 },
 [0x2885]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x008A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2885, -- ⢅
 },
 [0x2886]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2886, -- ⢆
 },
 [0x2887]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04D6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2887, -- ⢇
 },
 [0x2888]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0030",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2888, -- ⢈
 },
 [0x2889]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0094",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2889, -- ⢉
 },
 [0x288A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00F8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x288A, -- ⢊
 },
 [0x288B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04E0",
  ["linebreak"]="al",
  ["unicodeslot"]=0x288B, -- ⢋
 },
 [0x288C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x015C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x288C, -- ⢌
 },
 [0x288D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0544",
  ["linebreak"]="al",
  ["unicodeslot"]=0x288D, -- ⢍
 },
 [0x288E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x092C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x288E, -- ⢎
 },
 [0x288F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x303C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x288F, -- ⢏
 },
 [0x2890]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x003A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2890, -- ⢐
 },
 [0x2891]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x009E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2891, -- ⢑
 },
 [0x2892]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0102",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2892, -- ⢒
 },
 [0x2893]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04EA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2893, -- ⢓
 },
 [0x2894]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0166",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2894, -- ⢔
 },
 [0x2895]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x054E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2895, -- ⢕
 },
 [0x2896]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0936",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2896, -- ⢖
 },
 [0x2897]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3046",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2897, -- ⢗
 },
 [0x2898]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x01CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2898, -- ⢘
 },
 [0x2899]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x05B2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2899, -- ⢙
 },
 [0x289A]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x099A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x289A, -- ⢚
 },
 [0x289B]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x30AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x289B, -- ⢛
 },
 [0x289C]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0D82",
  ["linebreak"]="al",
  ["unicodeslot"]=0x289C, -- ⢜
 },
 [0x289D]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3492",
  ["linebreak"]="al",
  ["unicodeslot"]=0x289D, -- ⢝
 },
 [0x289E]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5BA2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x289E, -- ⢞
 },
 [0x289F]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E242",
  ["linebreak"]="al",
  ["unicodeslot"]=0x289F, -- ⢟
 },
 [0x28A0]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0044",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A0, -- ⢠
 },
 [0x28A1]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00A8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A1, -- ⢡
 },
 [0x28A2]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x010C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A2, -- ⢢
 },
 [0x28A3]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04F4",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A3, -- ⢣
 },
 [0x28A4]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0170",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A4, -- ⢤
 },
 [0x28A5]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0558",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A5, -- ⢥
 },
 [0x28A6]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0940",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A6, -- ⢦
 },
 [0x28A7]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3050",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A7, -- ⢧
 },
 [0x28A8]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x01D4",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A8, -- ⢨
 },
 [0x28A9]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x05BC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28A9, -- ⢩
 },
 [0x28AA]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x09A4",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28AA, -- ⢪
 },
 [0x28AB]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x30B4",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28AB, -- ⢫
 },
 [0x28AC]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0D8C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28AC, -- ⢬
 },
 [0x28AD]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x349C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28AD, -- ⢭
 },
 [0x28AE]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5BAC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28AE, -- ⢮
 },
 [0x28AF]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E24C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28AF, -- ⢯
 },
 [0x28B0]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0238",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B0, -- ⢰
 },
 [0x28B1]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0620",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B1, -- ⢱
 },
 [0x28B2]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0A08",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B2, -- ⢲
 },
 [0x28B3]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3118",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B3, -- ⢳
 },
 [0x28B4]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0DF0",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B4, -- ⢴
 },
 [0x28B5]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3500",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B5, -- ⢵
 },
 [0x28B6]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5C10",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B6, -- ⢶
 },
 [0x28B7]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E2B0",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B7, -- ⢷
 },
 [0x28B8]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x11D8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B8, -- ⢸
 },
 [0x28B9]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x38E8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28B9, -- ⢹
 },
 [0x28BA]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5FF8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28BA, -- ⢺
 },
 [0x28BB]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E698",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28BB, -- ⢻
 },
 [0x28BC]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x8708",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28BC, -- ⢼
 },
 [0x28BD]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x20DA8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28BD, -- ⢽
 },
 [0x28BE]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x39448",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28BE, -- ⢾
 },
 [0x28BF]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x12D688",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28BF, -- ⢿
 },
 [0x28C0]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x004E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C0, -- ⣀
 },
 [0x28C1]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x00B2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C1, -- ⣁
 },
 [0x28C2]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0116",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C2, -- ⣂
 },
 [0x28C3]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x04FE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C3, -- ⣃
 },
 [0x28C4]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x017A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C4, -- ⣄
 },
 [0x28C5]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0562",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C5, -- ⣅
 },
 [0x28C6]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x094A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C6, -- ⣆
 },
 [0x28C7]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x305A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C7, -- ⣇
 },
 [0x28C8]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x01DE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C8, -- ⣈
 },
 [0x28C9]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x05C6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28C9, -- ⣉
 },
 [0x28CA]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x09AE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28CA, -- ⣊
 },
 [0x28CB]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x30BE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28CB, -- ⣋
 },
 [0x28CC]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0D96",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28CC, -- ⣌
 },
 [0x28CD]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x34A6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28CD, -- ⣍
 },
 [0x28CE]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5BB6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28CE, -- ⣎
 },
 [0x28CF]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E256",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28CF, -- ⣏
 },
 [0x28D0]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0242",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D0, -- ⣐
 },
 [0x28D1]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x062A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D1, -- ⣑
 },
 [0x28D2]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0A12",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D2, -- ⣒
 },
 [0x28D3]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3122",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D3, -- ⣓
 },
 [0x28D4]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0DFA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D4, -- ⣔
 },
 [0x28D5]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x350A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D5, -- ⣕
 },
 [0x28D6]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5C1A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D6, -- ⣖
 },
 [0x28D7]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E2BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D7, -- ⣗
 },
 [0x28D8]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x11E2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D8, -- ⣘
 },
 [0x28D9]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x38F2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28D9, -- ⣙
 },
 [0x28DA]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x6002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28DA, -- ⣚
 },
 [0x28DB]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E6A2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28DB, -- ⣛
 },
 [0x28DC]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x8712",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28DC, -- ⣜
 },
 [0x28DD]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x20DB2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28DD, -- ⣝
 },
 [0x28DE]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x39452",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28DE, -- ⣞
 },
 [0x28DF]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x12D692",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28DF, -- ⣟
 },
 [0x28E0]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x02A6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E0, -- ⣠
 },
 [0x28E1]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x068E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E1, -- ⣡
 },
 [0x28E2]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0A76",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E2, -- ⣢
 },
 [0x28E3]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3186",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E3, -- ⣣
 },
 [0x28E4]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x0E5E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E4, -- ⣤
 },
 [0x28E5]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x356E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E5, -- ⣥
 },
 [0x28E6]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5C7E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E6, -- ⣦
 },
 [0x28E7]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E31E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E7, -- ⣧
 },
 [0x28E8]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1246",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E8, -- ⣨
 },
 [0x28E9]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3956",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28E9, -- ⣩
 },
 [0x28EA]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x6066",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28EA, -- ⣪
 },
 [0x28EB]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1E706",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28EB, -- ⣫
 },
 [0x28EC]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x8776",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28EC, -- ⣬
 },
 [0x28ED]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x20E16",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28ED, -- ⣭
 },
 [0x28EE]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x394B6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28EE, -- ⣮
 },
 [0x28EF]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x12D6F6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28EF, -- ⣯
 },
 [0x28F0]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x162E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F0, -- ⣰
 },
 [0x28F1]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3D3E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F1, -- ⣱
 },
 [0x28F2]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x644E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F2, -- ⣲
 },
 [0x28F3]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1EAEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F3, -- ⣳
 },
 [0x28F4]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x8B5E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F4, -- ⣴
 },
 [0x28F5]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x211FE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F5, -- ⣵
 },
 [0x28F6]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3989E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F6, -- ⣶
 },
 [0x28F7]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x12DADE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F7, -- ⣷
 },
 [0x28F8]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0xB26E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F8, -- ⣸
 },
 [0x28F9]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x2390E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28F9, -- ⣹
 },
 [0x28FA]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x3BFAE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28FA, -- ⣺
 },
 [0x28FB]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x1301EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28FB, -- ⣻
 },
 [0x28FC]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x5464E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28FC, -- ⣼
 },
 [0x28FD]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x14888E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28FD, -- ⣽
 },
 [0x28FE]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0x23CACE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28FE, -- ⣾
 },
 [0x28FF]={
  ["category"]="so",
  ["description"]="BRAILLE PATTERN DOTS-0xBC614E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x28FF, -- ⣿
 },
 [0x2900]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2900, -- ⤀
 },
 [0x2901]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2901, -- ⤁
 },
 [0x2902]={
  ["category"]="sm",
  ["description"]="LEFTWARDS DOUBLE ARROW WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2902, -- ⤂
 },
 [0x2903]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS DOUBLE ARROW WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2903, -- ⤃
 },
 [0x2904]={
  ["category"]="sm",
  ["description"]="LEFT RIGHT DOUBLE ARROW WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2904, -- ⤄
 },
 [0x2905]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS TWO-HEADED ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2905, -- ⤅
 },
 [0x2906]={
  ["category"]="sm",
  ["description"]="LEFTWARDS DOUBLE ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2906, -- ⤆
 },
 [0x2907]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS DOUBLE ARROW FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2907, -- ⤇
 },
 [0x2908]={
  ["category"]="sm",
  ["description"]="DOWNWARDS ARROW WITH HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2908, -- ⤈
 },
 [0x2909]={
  ["category"]="sm",
  ["description"]="UPWARDS ARROW WITH HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2909, -- ⤉
 },
 [0x290A]={
  ["category"]="sm",
  ["description"]="UPWARDS TRIPLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x290A, -- ⤊
 },
 [0x290B]={
  ["category"]="sm",
  ["description"]="DOWNWARDS TRIPLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x290B, -- ⤋
 },
 [0x290C]={
  ["category"]="sm",
  ["description"]="LEFTWARDS DOUBLE DASH ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x290C, -- ⤌
 },
 [0x290D]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS DOUBLE DASH ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x290D, -- ⤍
 },
 [0x290E]={
  ["category"]="sm",
  ["description"]="LEFTWARDS TRIPLE DASH ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x290E, -- ⤎
 },
 [0x290F]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS TRIPLE DASH ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x290F, -- ⤏
 },
 [0x2910]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS TWO-HEADED TRIPLE DASH ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2910, -- ⤐
 },
 [0x2911]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW WITH DOTTED STEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2911, -- ⤑
 },
 [0x2912]={
  ["category"]="sm",
  ["description"]="UPWARDS ARROW TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2912, -- ⤒
 },
 [0x2913]={
  ["category"]="sm",
  ["description"]="DOWNWARDS ARROW TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2913, -- ⤓
 },
 [0x2914]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW WITH TAIL WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2914, -- ⤔
 },
 [0x2915]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2915, -- ⤕
 },
 [0x2916]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS TWO-HEADED ARROW WITH TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2916, -- ⤖
 },
 [0x2917]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2917, -- ⤗
 },
 [0x2918]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2918, -- ⤘
 },
 [0x2919]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW-TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2919, -- ⤙
 },
 [0x291A]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW-TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x291A, -- ⤚
 },
 [0x291B]={
  ["category"]="sm",
  ["description"]="LEFTWARDS DOUBLE ARROW-TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x291B, -- ⤛
 },
 [0x291C]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS DOUBLE ARROW-TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x291C, -- ⤜
 },
 [0x291D]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW TO BLACK DIAMOND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x291D, -- ⤝
 },
 [0x291E]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW TO BLACK DIAMOND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x291E, -- ⤞
 },
 [0x291F]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW FROM BAR TO BLACK DIAMOND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x291F, -- ⤟
 },
 [0x2920]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW FROM BAR TO BLACK DIAMOND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2920, -- ⤠
 },
 [0x2921]={
  ["category"]="sm",
  ["description"]="NORTH WEST AND SOUTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2921, -- ⤡
 },
 [0x2922]={
  ["category"]="sm",
  ["description"]="NORTH EAST AND SOUTH WEST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2922, -- ⤢
 },
 [0x2923]={
  ["category"]="sm",
  ["description"]="NORTH WEST ARROW WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2923, -- ⤣
 },
 [0x2924]={
  ["category"]="sm",
  ["description"]="NORTH EAST ARROW WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2924, -- ⤤
 },
 [0x2925]={
  ["category"]="sm",
  ["description"]="SOUTH EAST ARROW WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2925, -- ⤥
 },
 [0x2926]={
  ["category"]="sm",
  ["description"]="SOUTH WEST ARROW WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2926, -- ⤦
 },
 [0x2927]={
  ["category"]="sm",
  ["description"]="NORTH WEST ARROW AND NORTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2927, -- ⤧
 },
 [0x2928]={
  ["category"]="sm",
  ["description"]="NORTH EAST ARROW AND SOUTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2928, -- ⤨
 },
 [0x2929]={
  ["category"]="sm",
  ["description"]="SOUTH EAST ARROW AND SOUTH WEST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2929, -- ⤩
 },
 [0x292A]={
  ["category"]="sm",
  ["description"]="SOUTH WEST ARROW AND NORTH WEST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x292A, -- ⤪
 },
 [0x292B]={
  ["category"]="sm",
  ["description"]="RISING DIAGONAL CROSSING FALLING DIAGONAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x292B, -- ⤫
 },
 [0x292C]={
  ["category"]="sm",
  ["description"]="FALLING DIAGONAL CROSSING RISING DIAGONAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x292C, -- ⤬
 },
 [0x292D]={
  ["category"]="sm",
  ["description"]="SOUTH EAST ARROW CROSSING NORTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x292D, -- ⤭
 },
 [0x292E]={
  ["category"]="sm",
  ["description"]="NORTH EAST ARROW CROSSING SOUTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x292E, -- ⤮
 },
 [0x292F]={
  ["category"]="sm",
  ["description"]="FALLING DIAGONAL CROSSING NORTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x292F, -- ⤯
 },
 [0x2930]={
  ["category"]="sm",
  ["description"]="RISING DIAGONAL CROSSING SOUTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2930, -- ⤰
 },
 [0x2931]={
  ["category"]="sm",
  ["description"]="NORTH EAST ARROW CROSSING NORTH WEST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2931, -- ⤱
 },
 [0x2932]={
  ["category"]="sm",
  ["description"]="NORTH WEST ARROW CROSSING NORTH EAST ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2932, -- ⤲
 },
 [0x2933]={
  ["category"]="sm",
  ["description"]="WAVE ARROW POINTING DIRECTLY RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2933, -- ⤳
 },
 [0x2934]={
  ["category"]="sm",
  ["description"]="ARROW POINTING RIGHTWARDS THEN CURVING UPWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2934, -- ⤴
 },
 [0x2935]={
  ["category"]="sm",
  ["description"]="ARROW POINTING RIGHTWARDS THEN CURVING DOWNWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2935, -- ⤵
 },
 [0x2936]={
  ["category"]="sm",
  ["description"]="ARROW POINTING DOWNWARDS THEN CURVING LEFTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2936, -- ⤶
 },
 [0x2937]={
  ["category"]="sm",
  ["description"]="ARROW POINTING DOWNWARDS THEN CURVING RIGHTWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2937, -- ⤷
 },
 [0x2938]={
  ["category"]="sm",
  ["description"]="RIGHT-SIDE ARC CLOCKWISE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2938, -- ⤸
 },
 [0x2939]={
  ["category"]="sm",
  ["description"]="LEFT-SIDE ARC ANTICLOCKWISE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2939, -- ⤹
 },
 [0x293A]={
  ["category"]="sm",
  ["description"]="TOP ARC ANTICLOCKWISE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x293A, -- ⤺
 },
 [0x293B]={
  ["category"]="sm",
  ["description"]="BOTTOM ARC ANTICLOCKWISE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x293B, -- ⤻
 },
 [0x293C]={
  ["category"]="sm",
  ["description"]="TOP ARC CLOCKWISE ARROW WITH MINUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x293C, -- ⤼
 },
 [0x293D]={
  ["category"]="sm",
  ["description"]="TOP ARC ANTICLOCKWISE ARROW WITH PLUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x293D, -- ⤽
 },
 [0x293E]={
  ["category"]="sm",
  ["description"]="LOWER RIGHT SEMICIRCULAR CLOCKWISE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x293E, -- ⤾
 },
 [0x293F]={
  ["category"]="sm",
  ["description"]="LOWER LEFT SEMICIRCULAR ANTICLOCKWISE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x293F, -- ⤿
 },
 [0x2940]={
  ["category"]="sm",
  ["description"]="ANTICLOCKWISE CLOSED CIRCLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2940, -- ⥀
 },
 [0x2941]={
  ["category"]="sm",
  ["description"]="CLOCKWISE CLOSED CIRCLE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2941, -- ⥁
 },
 [0x2942]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW ABOVE SHORT LEFTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2942, -- ⥂
 },
 [0x2943]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW ABOVE SHORT RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2943, -- ⥃
 },
 [0x2944]={
  ["category"]="sm",
  ["description"]="SHORT RIGHTWARDS ARROW ABOVE LEFTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2944, -- ⥄
 },
 [0x2945]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW WITH PLUS BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2945, -- ⥅
 },
 [0x2946]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW WITH PLUS BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2946, -- ⥆
 },
 [0x2947]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW THROUGH X",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2947, -- ⥇
 },
 [0x2948]={
  ["category"]="sm",
  ["description"]="LEFT RIGHT ARROW THROUGH SMALL CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2948, -- ⥈
 },
 [0x2949]={
  ["category"]="sm",
  ["description"]="UPWARDS TWO-HEADED ARROW FROM SMALL CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2949, -- ⥉
 },
 [0x294A]={
  ["category"]="sm",
  ["description"]="LEFT BARB UP RIGHT BARB DOWN HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x294A, -- ⥊
 },
 [0x294B]={
  ["category"]="sm",
  ["description"]="LEFT BARB DOWN RIGHT BARB UP HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x294B, -- ⥋
 },
 [0x294C]={
  ["category"]="sm",
  ["description"]="UP BARB RIGHT DOWN BARB LEFT HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x294C, -- ⥌
 },
 [0x294D]={
  ["category"]="sm",
  ["description"]="UP BARB LEFT DOWN BARB RIGHT HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x294D, -- ⥍
 },
 [0x294E]={
  ["category"]="sm",
  ["description"]="LEFT BARB UP RIGHT BARB UP HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x294E, -- ⥎
 },
 [0x294F]={
  ["category"]="sm",
  ["description"]="UP BARB RIGHT DOWN BARB RIGHT HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x294F, -- ⥏
 },
 [0x2950]={
  ["category"]="sm",
  ["description"]="LEFT BARB DOWN RIGHT BARB DOWN HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2950, -- ⥐
 },
 [0x2951]={
  ["category"]="sm",
  ["description"]="UP BARB LEFT DOWN BARB LEFT HARPOON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2951, -- ⥑
 },
 [0x2952]={
  ["category"]="sm",
  ["description"]="LEFTWARDS HARPOON WITH BARB UP TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2952, -- ⥒
 },
 [0x2953]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS HARPOON WITH BARB UP TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2953, -- ⥓
 },
 [0x2954]={
  ["category"]="sm",
  ["description"]="UPWARDS HARPOON WITH BARB RIGHT TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2954, -- ⥔
 },
 [0x2955]={
  ["category"]="sm",
  ["description"]="DOWNWARDS HARPOON WITH BARB RIGHT TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2955, -- ⥕
 },
 [0x2956]={
  ["category"]="sm",
  ["description"]="LEFTWARDS HARPOON WITH BARB DOWN TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2956, -- ⥖
 },
 [0x2957]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS HARPOON WITH BARB DOWN TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2957, -- ⥗
 },
 [0x2958]={
  ["category"]="sm",
  ["description"]="UPWARDS HARPOON WITH BARB LEFT TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2958, -- ⥘
 },
 [0x2959]={
  ["category"]="sm",
  ["description"]="DOWNWARDS HARPOON WITH BARB LEFT TO BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2959, -- ⥙
 },
 [0x295A]={
  ["category"]="sm",
  ["description"]="LEFTWARDS HARPOON WITH BARB UP FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x295A, -- ⥚
 },
 [0x295B]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS HARPOON WITH BARB UP FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x295B, -- ⥛
 },
 [0x295C]={
  ["category"]="sm",
  ["description"]="UPWARDS HARPOON WITH BARB RIGHT FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x295C, -- ⥜
 },
 [0x295D]={
  ["category"]="sm",
  ["description"]="DOWNWARDS HARPOON WITH BARB RIGHT FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x295D, -- ⥝
 },
 [0x295E]={
  ["category"]="sm",
  ["description"]="LEFTWARDS HARPOON WITH BARB DOWN FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x295E, -- ⥞
 },
 [0x295F]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS HARPOON WITH BARB DOWN FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x295F, -- ⥟
 },
 [0x2960]={
  ["category"]="sm",
  ["description"]="UPWARDS HARPOON WITH BARB LEFT FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2960, -- ⥠
 },
 [0x2961]={
  ["category"]="sm",
  ["description"]="DOWNWARDS HARPOON WITH BARB LEFT FROM BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2961, -- ⥡
 },
 [0x2962]={
  ["category"]="sm",
  ["description"]="LEFTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2962, -- ⥢
 },
 [0x2963]={
  ["category"]="sm",
  ["description"]="UPWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2963, -- ⥣
 },
 [0x2964]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2964, -- ⥤
 },
 [0x2965]={
  ["category"]="sm",
  ["description"]="DOWNWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2965, -- ⥥
 },
 [0x2966]={
  ["category"]="sm",
  ["description"]="LEFTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2966, -- ⥦
 },
 [0x2967]={
  ["category"]="sm",
  ["description"]="LEFTWARDS HARPOON WITH BARB DOWN ABOVE RIGHTWARDS HARPOON WITH BARB DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2967, -- ⥧
 },
 [0x2968]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2968, -- ⥨
 },
 [0x2969]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS HARPOON WITH BARB DOWN ABOVE LEFTWARDS HARPOON WITH BARB DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2969, -- ⥩
 },
 [0x296A]={
  ["category"]="sm",
  ["description"]="LEFTWARDS HARPOON WITH BARB UP ABOVE LONG DASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x296A, -- ⥪
 },
 [0x296B]={
  ["category"]="sm",
  ["description"]="LEFTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x296B, -- ⥫
 },
 [0x296C]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS HARPOON WITH BARB UP ABOVE LONG DASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x296C, -- ⥬
 },
 [0x296D]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x296D, -- ⥭
 },
 [0x296E]={
  ["category"]="sm",
  ["description"]="UPWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x296E, -- ⥮
 },
 [0x296F]={
  ["category"]="sm",
  ["description"]="DOWNWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x296F, -- ⥯
 },
 [0x2970]={
  ["category"]="sm",
  ["description"]="RIGHT DOUBLE ARROW WITH ROUNDED HEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2970, -- ⥰
 },
 [0x2971]={
  ["category"]="sm",
  ["description"]="EQUALS SIGN ABOVE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2971, -- ⥱
 },
 [0x2972]={
  ["category"]="sm",
  ["description"]="TILDE OPERATOR ABOVE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2972, -- ⥲
 },
 [0x2973]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW ABOVE TILDE OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2973, -- ⥳
 },
 [0x2974]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW ABOVE TILDE OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2974, -- ⥴
 },
 [0x2975]={
  ["category"]="sm",
  ["description"]="RIGHTWARDS ARROW ABOVE ALMOST EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2975, -- ⥵
 },
 [0x2976]={
  ["category"]="sm",
  ["description"]="LESS-THAN ABOVE LEFTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2976, -- ⥶
 },
 [0x2977]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW THROUGH LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2977, -- ⥷
 },
 [0x2978]={
  ["category"]="sm",
  ["description"]="GREATER-THAN ABOVE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2978, -- ⥸
 },
 [0x2979]={
  ["category"]="sm",
  ["description"]="SUBSET ABOVE RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2979, -- ⥹
 },
 [0x297A]={
  ["category"]="sm",
  ["description"]="LEFTWARDS ARROW THROUGH SUBSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x297A, -- ⥺
 },
 [0x297B]={
  ["category"]="sm",
  ["description"]="SUPERSET ABOVE LEFTWARDS ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x297B, -- ⥻
 },
 [0x297C]={
  ["category"]="sm",
  ["description"]="LEFT FISH TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x297C, -- ⥼
 },
 [0x297D]={
  ["category"]="sm",
  ["description"]="RIGHT FISH TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x297D, -- ⥽
 },
 [0x297E]={
  ["category"]="sm",
  ["description"]="UP FISH TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x297E, -- ⥾
 },
 [0x297F]={
  ["category"]="sm",
  ["description"]="DOWN FISH TAIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x297F, -- ⥿
 },
 [0x2980]={
  ["category"]="sm",
  ["description"]="TRIPLE VERTICAL BAR DELIMITER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2980, -- ⦀
 },
 [0x2981]={
  ["category"]="sm",
  ["description"]="Z NOTATION SPOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2981, -- ⦁
 },
 [0x2982]={
  ["category"]="sm",
  ["description"]="Z NOTATION TYPE COLON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2982, -- ⦂
 },
 [0x2983]={
  ["category"]="ps",
  ["description"]="LEFT WHITE CURLY BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2983, -- ⦃
 },
 [0x2984]={
  ["category"]="pe",
  ["description"]="RIGHT WHITE CURLY BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2984, -- ⦄
 },
 [0x2985]={
  ["category"]="ps",
  ["cjkwd"]="na",
  ["description"]="LEFT WHITE PARENTHESIS",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2985, -- ⦅
 },
 [0x2986]={
  ["category"]="pe",
  ["cjkwd"]="na",
  ["description"]="RIGHT WHITE PARENTHESIS",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2986, -- ⦆
 },
 [0x2987]={
  ["category"]="ps",
  ["description"]="Z NOTATION LEFT IMAGE BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2987, -- ⦇
 },
 [0x2988]={
  ["category"]="pe",
  ["description"]="Z NOTATION RIGHT IMAGE BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2988, -- ⦈
 },
 [0x2989]={
  ["category"]="ps",
  ["description"]="Z NOTATION LEFT BINDING BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2989, -- ⦉
 },
 [0x298A]={
  ["category"]="pe",
  ["description"]="Z NOTATION RIGHT BINDING BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x298A, -- ⦊
 },
 [0x298B]={
  ["category"]="ps",
  ["description"]="LEFT SQUARE BRACKET WITH UNDERBAR",
  ["linebreak"]="op",
  ["unicodeslot"]=0x298B, -- ⦋
 },
 [0x298C]={
  ["category"]="pe",
  ["description"]="RIGHT SQUARE BRACKET WITH UNDERBAR",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x298C, -- ⦌
 },
 [0x298D]={
  ["category"]="ps",
  ["description"]="LEFT SQUARE BRACKET WITH TICK IN TOP CORNER",
  ["linebreak"]="op",
  ["unicodeslot"]=0x298D, -- ⦍
 },
 [0x298E]={
  ["category"]="pe",
  ["description"]="RIGHT SQUARE BRACKET WITH TICK IN BOTTOM CORNER",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x298E, -- ⦎
 },
 [0x298F]={
  ["category"]="ps",
  ["description"]="LEFT SQUARE BRACKET WITH TICK IN BOTTOM CORNER",
  ["linebreak"]="op",
  ["unicodeslot"]=0x298F, -- ⦏
 },
 [0x2990]={
  ["category"]="pe",
  ["description"]="RIGHT SQUARE BRACKET WITH TICK IN TOP CORNER",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2990, -- ⦐
 },
 [0x2991]={
  ["category"]="ps",
  ["description"]="LEFT ANGLE BRACKET WITH DOT",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2991, -- ⦑
 },
 [0x2992]={
  ["category"]="pe",
  ["description"]="RIGHT ANGLE BRACKET WITH DOT",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2992, -- ⦒
 },
 [0x2993]={
  ["category"]="ps",
  ["description"]="LEFT ARC LESS-THAN BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2993, -- ⦓
 },
 [0x2994]={
  ["category"]="pe",
  ["description"]="RIGHT ARC GREATER-THAN BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2994, -- ⦔
 },
 [0x2995]={
  ["category"]="ps",
  ["description"]="DOUBLE LEFT ARC GREATER-THAN BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2995, -- ⦕
 },
 [0x2996]={
  ["category"]="pe",
  ["description"]="DOUBLE RIGHT ARC LESS-THAN BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2996, -- ⦖
 },
 [0x2997]={
  ["category"]="ps",
  ["description"]="LEFT BLACK TORTOISE SHELL BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x2997, -- ⦗
 },
 [0x2998]={
  ["category"]="pe",
  ["description"]="RIGHT BLACK TORTOISE SHELL BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x2998, -- ⦘
 },
 [0x2999]={
  ["category"]="sm",
  ["description"]="DOTTED FENCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2999, -- ⦙
 },
 [0x299A]={
  ["category"]="sm",
  ["description"]="VERTICAL ZIGZAG LINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x299A, -- ⦚
 },
 [0x299B]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE OPENING LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x299B, -- ⦛
 },
 [0x299C]={
  ["category"]="sm",
  ["description"]="RIGHT ANGLE VARIANT WITH SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x299C, -- ⦜
 },
 [0x299D]={
  ["category"]="sm",
  ["description"]="MEASURED RIGHT ANGLE WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x299D, -- ⦝
 },
 [0x299E]={
  ["category"]="sm",
  ["description"]="ANGLE WITH S INSIDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x299E, -- ⦞
 },
 [0x299F]={
  ["category"]="sm",
  ["description"]="ACUTE ANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x299F, -- ⦟
 },
 [0x29A0]={
  ["category"]="sm",
  ["description"]="SPHERICAL ANGLE OPENING LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A0, -- ⦠
 },
 [0x29A1]={
  ["category"]="sm",
  ["description"]="SPHERICAL ANGLE OPENING UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A1, -- ⦡
 },
 [0x29A2]={
  ["category"]="sm",
  ["description"]="TURNED ANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A2, -- ⦢
 },
 [0x29A3]={
  ["category"]="sm",
  ["description"]="REVERSED ANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A3, -- ⦣
 },
 [0x29A4]={
  ["category"]="sm",
  ["description"]="ANGLE WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A4, -- ⦤
 },
 [0x29A5]={
  ["category"]="sm",
  ["description"]="REVERSED ANGLE WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A5, -- ⦥
 },
 [0x29A6]={
  ["category"]="sm",
  ["description"]="OBLIQUE ANGLE OPENING UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A6, -- ⦦
 },
 [0x29A7]={
  ["category"]="sm",
  ["description"]="OBLIQUE ANGLE OPENING DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A7, -- ⦧
 },
 [0x29A8]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A8, -- ⦨
 },
 [0x29A9]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29A9, -- ⦩
 },
 [0x29AA]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29AA, -- ⦪
 },
 [0x29AB]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29AB, -- ⦫
 },
 [0x29AC]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29AC, -- ⦬
 },
 [0x29AD]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29AD, -- ⦭
 },
 [0x29AE]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29AE, -- ⦮
 },
 [0x29AF]={
  ["category"]="sm",
  ["description"]="MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29AF, -- ⦯
 },
 [0x29B0]={
  ["category"]="sm",
  ["description"]="REVERSED EMPTY SET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B0, -- ⦰
 },
 [0x29B1]={
  ["category"]="sm",
  ["description"]="EMPTY SET WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B1, -- ⦱
 },
 [0x29B2]={
  ["category"]="sm",
  ["description"]="EMPTY SET WITH SMALL CIRCLE ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B2, -- ⦲
 },
 [0x29B3]={
  ["category"]="sm",
  ["description"]="EMPTY SET WITH RIGHT ARROW ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B3, -- ⦳
 },
 [0x29B4]={
  ["category"]="sm",
  ["description"]="EMPTY SET WITH LEFT ARROW ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B4, -- ⦴
 },
 [0x29B5]={
  ["category"]="sm",
  ["description"]="CIRCLE WITH HORIZONTAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B5, -- ⦵
 },
 [0x29B6]={
  ["category"]="sm",
  ["description"]="CIRCLED VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B6, -- ⦶
 },
 [0x29B7]={
  ["category"]="sm",
  ["description"]="CIRCLED PARALLEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B7, -- ⦷
 },
 [0x29B8]={
  ["category"]="sm",
  ["description"]="CIRCLED REVERSE SOLIDUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B8, -- ⦸
 },
 [0x29B9]={
  ["category"]="sm",
  ["description"]="CIRCLED PERPENDICULAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29B9, -- ⦹
 },
 [0x29BA]={
  ["category"]="sm",
  ["description"]="CIRCLE DIVIDED BY HORIZONTAL BAR AND TOP HALF DIVIDED BY VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29BA, -- ⦺
 },
 [0x29BB]={
  ["category"]="sm",
  ["description"]="CIRCLE WITH SUPERIMPOSED X",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29BB, -- ⦻
 },
 [0x29BC]={
  ["category"]="sm",
  ["description"]="CIRCLED ANTICLOCKWISE-ROTATED DIVISION SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29BC, -- ⦼
 },
 [0x29BD]={
  ["category"]="sm",
  ["description"]="UP ARROW THROUGH CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29BD, -- ⦽
 },
 [0x29BE]={
  ["category"]="sm",
  ["description"]="CIRCLED WHITE BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29BE, -- ⦾
 },
 [0x29BF]={
  ["category"]="sm",
  ["description"]="CIRCLED BULLET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29BF, -- ⦿
 },
 [0x29C0]={
  ["category"]="sm",
  ["description"]="CIRCLED LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C0, -- ⧀
 },
 [0x29C1]={
  ["category"]="sm",
  ["description"]="CIRCLED GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C1, -- ⧁
 },
 [0x29C2]={
  ["category"]="sm",
  ["description"]="CIRCLE WITH SMALL CIRCLE TO THE RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C2, -- ⧂
 },
 [0x29C3]={
  ["category"]="sm",
  ["description"]="CIRCLE WITH TWO HORIZONTAL STROKES TO THE RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C3, -- ⧃
 },
 [0x29C4]={
  ["category"]="sm",
  ["description"]="SQUARED RISING DIAGONAL SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C4, -- ⧄
 },
 [0x29C5]={
  ["category"]="sm",
  ["description"]="SQUARED FALLING DIAGONAL SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C5, -- ⧅
 },
 [0x29C6]={
  ["category"]="sm",
  ["description"]="SQUARED ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C6, -- ⧆
 },
 [0x29C7]={
  ["category"]="sm",
  ["description"]="SQUARED SMALL CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C7, -- ⧇
 },
 [0x29C8]={
  ["category"]="sm",
  ["description"]="SQUARED SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C8, -- ⧈
 },
 [0x29C9]={
  ["category"]="sm",
  ["description"]="TWO JOINED SQUARES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29C9, -- ⧉
 },
 [0x29CA]={
  ["category"]="sm",
  ["description"]="TRIANGLE WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29CA, -- ⧊
 },
 [0x29CB]={
  ["category"]="sm",
  ["description"]="TRIANGLE WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29CB, -- ⧋
 },
 [0x29CC]={
  ["category"]="sm",
  ["description"]="S IN TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29CC, -- ⧌
 },
 [0x29CD]={
  ["category"]="sm",
  ["description"]="TRIANGLE WITH SERIFS AT BOTTOM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29CD, -- ⧍
 },
 [0x29CE]={
  ["category"]="sm",
  ["description"]="RIGHT TRIANGLE ABOVE LEFT TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29CE, -- ⧎
 },
 [0x29CF]={
  ["category"]="sm",
  ["description"]="LEFT TRIANGLE BESIDE VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29CF, -- ⧏
 },
 [0x29D0]={
  ["category"]="sm",
  ["description"]="VERTICAL BAR BESIDE RIGHT TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29D0, -- ⧐
 },
 [0x29D1]={
  ["category"]="sm",
  ["description"]="BOWTIE WITH LEFT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29D1, -- ⧑
 },
 [0x29D2]={
  ["category"]="sm",
  ["description"]="BOWTIE WITH RIGHT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29D2, -- ⧒
 },
 [0x29D3]={
  ["category"]="sm",
  ["description"]="BLACK BOWTIE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29D3, -- ⧓
 },
 [0x29D4]={
  ["category"]="sm",
  ["description"]="TIMES WITH LEFT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29D4, -- ⧔
 },
 [0x29D5]={
  ["category"]="sm",
  ["description"]="TIMES WITH RIGHT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29D5, -- ⧕
 },
 [0x29D6]={
  ["category"]="sm",
  ["description"]="WHITE HOURGLASS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29D6, -- ⧖
 },
 [0x29D7]={
  ["category"]="sm",
  ["description"]="BLACK HOURGLASS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29D7, -- ⧗
 },
 [0x29D8]={
  ["category"]="ps",
  ["description"]="LEFT WIGGLY FENCE",
  ["linebreak"]="op",
  ["unicodeslot"]=0x29D8, -- ⧘
 },
 [0x29D9]={
  ["category"]="pe",
  ["description"]="RIGHT WIGGLY FENCE",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x29D9, -- ⧙
 },
 [0x29DA]={
  ["category"]="ps",
  ["description"]="LEFT DOUBLE WIGGLY FENCE",
  ["linebreak"]="op",
  ["unicodeslot"]=0x29DA, -- ⧚
 },
 [0x29DB]={
  ["category"]="pe",
  ["description"]="RIGHT DOUBLE WIGGLY FENCE",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x29DB, -- ⧛
 },
 [0x29DC]={
  ["category"]="sm",
  ["description"]="INCOMPLETE INFINITY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29DC, -- ⧜
 },
 [0x29DD]={
  ["category"]="sm",
  ["description"]="TIE OVER INFINITY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29DD, -- ⧝
 },
 [0x29DE]={
  ["category"]="sm",
  ["description"]="INFINITY NEGATED WITH VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29DE, -- ⧞
 },
 [0x29DF]={
  ["category"]="sm",
  ["description"]="DOUBLE-ENDED MULTIMAP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29DF, -- ⧟
 },
 [0x29E0]={
  ["category"]="sm",
  ["description"]="SQUARE WITH CONTOURED OUTLINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E0, -- ⧠
 },
 [0x29E1]={
  ["category"]="sm",
  ["description"]="INCREASES AS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E1, -- ⧡
 },
 [0x29E2]={
  ["category"]="sm",
  ["description"]="SHUFFLE PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E2, -- ⧢
 },
 [0x29E3]={
  ["category"]="sm",
  ["description"]="EQUALS SIGN AND SLANTED PARALLEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E3, -- ⧣
 },
 [0x29E4]={
  ["category"]="sm",
  ["description"]="EQUALS SIGN AND SLANTED PARALLEL WITH TILDE ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E4, -- ⧤
 },
 [0x29E5]={
  ["category"]="sm",
  ["description"]="IDENTICAL TO AND SLANTED PARALLEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E5, -- ⧥
 },
 [0x29E6]={
  ["category"]="sm",
  ["description"]="GLEICH STARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E6, -- ⧦
 },
 [0x29E7]={
  ["category"]="sm",
  ["description"]="THERMODYNAMIC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E7, -- ⧧
 },
 [0x29E8]={
  ["category"]="sm",
  ["description"]="DOWN-POINTING TRIANGLE WITH LEFT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E8, -- ⧨
 },
 [0x29E9]={
  ["category"]="sm",
  ["description"]="DOWN-POINTING TRIANGLE WITH RIGHT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29E9, -- ⧩
 },
 [0x29EA]={
  ["category"]="sm",
  ["description"]="BLACK DIAMOND WITH DOWN ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29EA, -- ⧪
 },
 [0x29EB]={
  ["category"]="sm",
  ["description"]="BLACK LOZENGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29EB, -- ⧫
 },
 [0x29EC]={
  ["category"]="sm",
  ["description"]="WHITE CIRCLE WITH DOWN ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29EC, -- ⧬
 },
 [0x29ED]={
  ["category"]="sm",
  ["description"]="BLACK CIRCLE WITH DOWN ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29ED, -- ⧭
 },
 [0x29EE]={
  ["category"]="sm",
  ["description"]="ERROR-BARRED WHITE SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29EE, -- ⧮
 },
 [0x29EF]={
  ["category"]="sm",
  ["description"]="ERROR-BARRED BLACK SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29EF, -- ⧯
 },
 [0x29F0]={
  ["category"]="sm",
  ["description"]="ERROR-BARRED WHITE DIAMOND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F0, -- ⧰
 },
 [0x29F1]={
  ["category"]="sm",
  ["description"]="ERROR-BARRED BLACK DIAMOND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F1, -- ⧱
 },
 [0x29F2]={
  ["category"]="sm",
  ["description"]="ERROR-BARRED WHITE CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F2, -- ⧲
 },
 [0x29F3]={
  ["category"]="sm",
  ["description"]="ERROR-BARRED BLACK CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F3, -- ⧳
 },
 [0x29F4]={
  ["category"]="sm",
  ["description"]="RULE-DELAYED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F4, -- ⧴
 },
 [0x29F5]={
  ["category"]="sm",
  ["description"]="REVERSE SOLIDUS OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F5, -- ⧵
 },
 [0x29F6]={
  ["category"]="sm",
  ["description"]="SOLIDUS WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F6, -- ⧶
 },
 [0x29F7]={
  ["category"]="sm",
  ["description"]="REVERSE SOLIDUS WITH HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F7, -- ⧷
 },
 [0x29F8]={
  ["category"]="sm",
  ["description"]="BIG SOLIDUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F8, -- ⧸
 },
 [0x29F9]={
  ["category"]="sm",
  ["description"]="BIG REVERSE SOLIDUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29F9, -- ⧹
 },
 [0x29FA]={
  ["category"]="sm",
  ["description"]="DOUBLE PLUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29FA, -- ⧺
 },
 [0x29FB]={
  ["category"]="sm",
  ["description"]="TRIPLE PLUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29FB, -- ⧻
 },
 [0x29FC]={
  ["category"]="ps",
  ["description"]="LEFT-POINTING CURVED ANGLE BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x29FC, -- ⧼
 },
 [0x29FD]={
  ["category"]="pe",
  ["description"]="RIGHT-POINTING CURVED ANGLE BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x29FD, -- ⧽
 },
 [0x29FE]={
  ["category"]="sm",
  ["description"]="TINY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29FE, -- ⧾
 },
 [0x29FF]={
  ["category"]="sm",
  ["description"]="MINY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x29FF, -- ⧿
 },
 [0x2A00]={
  ["category"]="sm",
  ["description"]="N-ARY CIRCLED DOT OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A00, -- ⨀
 },
 [0x2A01]={
  ["category"]="sm",
  ["description"]="N-ARY CIRCLED PLUS OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A01, -- ⨁
 },
 [0x2A02]={
  ["category"]="sm",
  ["description"]="N-ARY CIRCLED TIMES OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A02, -- ⨂
 },
 [0x2A03]={
  ["category"]="sm",
  ["description"]="N-ARY UNION OPERATOR WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A03, -- ⨃
 },
 [0x2A04]={
  ["category"]="sm",
  ["description"]="N-ARY UNION OPERATOR WITH PLUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A04, -- ⨄
 },
 [0x2A05]={
  ["category"]="sm",
  ["description"]="N-ARY SQUARE INTERSECTION OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A05, -- ⨅
 },
 [0x2A06]={
  ["category"]="sm",
  ["description"]="N-ARY SQUARE UNION OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A06, -- ⨆
 },
 [0x2A07]={
  ["category"]="sm",
  ["description"]="TWO LOGICAL AND OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A07, -- ⨇
 },
 [0x2A08]={
  ["category"]="sm",
  ["description"]="TWO LOGICAL OR OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A08, -- ⨈
 },
 [0x2A09]={
  ["category"]="sm",
  ["description"]="N-ARY TIMES OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A09, -- ⨉
 },
 [0x2A0A]={
  ["category"]="sm",
  ["description"]="MODULO TWO SUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A0A, -- ⨊
 },
 [0x2A0B]={
  ["category"]="sm",
  ["description"]="SUMMATION WITH INTEGRAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A0B, -- ⨋
 },
 [0x2A0C]={
  ["category"]="sm",
  ["description"]="QUADRUPLE INTEGRAL OPERATOR",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x222B, 0x222B, 0x222B, 0x222B },
  ["unicodeslot"]=0x2A0C, -- ⨌
 },
 [0x2A0D]={
  ["category"]="sm",
  ["description"]="FINITE PART INTEGRAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A0D, -- ⨍
 },
 [0x2A0E]={
  ["category"]="sm",
  ["description"]="INTEGRAL WITH DOUBLE STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A0E, -- ⨎
 },
 [0x2A0F]={
  ["category"]="sm",
  ["description"]="INTEGRAL AVERAGE WITH SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A0F, -- ⨏
 },
 [0x2A10]={
  ["category"]="sm",
  ["description"]="CIRCULATION FUNCTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A10, -- ⨐
 },
 [0x2A11]={
  ["category"]="sm",
  ["description"]="ANTICLOCKWISE INTEGRATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A11, -- ⨑
 },
 [0x2A12]={
  ["category"]="sm",
  ["description"]="LINE INTEGRATION WITH RECTANGULAR PATH AROUND POLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A12, -- ⨒
 },
 [0x2A13]={
  ["category"]="sm",
  ["description"]="LINE INTEGRATION WITH SEMICIRCULAR PATH AROUND POLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A13, -- ⨓
 },
 [0x2A14]={
  ["category"]="sm",
  ["description"]="LINE INTEGRATION NOT INCLUDING THE POLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A14, -- ⨔
 },
 [0x2A15]={
  ["category"]="sm",
  ["description"]="INTEGRAL AROUND A POINT OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A15, -- ⨕
 },
 [0x2A16]={
  ["category"]="sm",
  ["description"]="QUATERNION INTEGRAL OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A16, -- ⨖
 },
 [0x2A17]={
  ["category"]="sm",
  ["description"]="INTEGRAL WITH LEFTWARDS ARROW WITH HOOK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A17, -- ⨗
 },
 [0x2A18]={
  ["category"]="sm",
  ["description"]="INTEGRAL WITH TIMES SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A18, -- ⨘
 },
 [0x2A19]={
  ["category"]="sm",
  ["description"]="INTEGRAL WITH INTERSECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A19, -- ⨙
 },
 [0x2A1A]={
  ["category"]="sm",
  ["description"]="INTEGRAL WITH UNION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A1A, -- ⨚
 },
 [0x2A1B]={
  ["category"]="sm",
  ["description"]="INTEGRAL WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A1B, -- ⨛
 },
 [0x2A1C]={
  ["category"]="sm",
  ["description"]="INTEGRAL WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A1C, -- ⨜
 },
 [0x2A1D]={
  ["category"]="sm",
  ["description"]="JOIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A1D, -- ⨝
 },
 [0x2A1E]={
  ["category"]="sm",
  ["description"]="LARGE LEFT TRIANGLE OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A1E, -- ⨞
 },
 [0x2A1F]={
  ["category"]="sm",
  ["description"]="Z NOTATION SCHEMA COMPOSITION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A1F, -- ⨟
 },
 [0x2A20]={
  ["category"]="sm",
  ["description"]="Z NOTATION SCHEMA PIPING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A20, -- ⨠
 },
 [0x2A21]={
  ["category"]="sm",
  ["description"]="Z NOTATION SCHEMA PROJECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A21, -- ⨡
 },
 [0x2A22]={
  ["category"]="sm",
  ["description"]="PLUS SIGN WITH SMALL CIRCLE ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A22, -- ⨢
 },
 [0x2A23]={
  ["category"]="sm",
  ["description"]="PLUS SIGN WITH CIRCUMFLEX ACCENT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A23, -- ⨣
 },
 [0x2A24]={
  ["category"]="sm",
  ["description"]="PLUS SIGN WITH TILDE ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A24, -- ⨤
 },
 [0x2A25]={
  ["category"]="sm",
  ["description"]="PLUS SIGN WITH DOT BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A25, -- ⨥
 },
 [0x2A26]={
  ["category"]="sm",
  ["description"]="PLUS SIGN WITH TILDE BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A26, -- ⨦
 },
 [0x2A27]={
  ["category"]="sm",
  ["description"]="PLUS SIGN WITH SUBSCRIPT TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A27, -- ⨧
 },
 [0x2A28]={
  ["category"]="sm",
  ["description"]="PLUS SIGN WITH BLACK TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A28, -- ⨨
 },
 [0x2A29]={
  ["category"]="sm",
  ["description"]="MINUS SIGN WITH COMMA ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A29, -- ⨩
 },
 [0x2A2A]={
  ["category"]="sm",
  ["description"]="MINUS SIGN WITH DOT BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A2A, -- ⨪
 },
 [0x2A2B]={
  ["category"]="sm",
  ["description"]="MINUS SIGN WITH FALLING DOTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A2B, -- ⨫
 },
 [0x2A2C]={
  ["category"]="sm",
  ["description"]="MINUS SIGN WITH RISING DOTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A2C, -- ⨬
 },
 [0x2A2D]={
  ["category"]="sm",
  ["description"]="PLUS SIGN IN LEFT HALF CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A2D, -- ⨭
 },
 [0x2A2E]={
  ["category"]="sm",
  ["description"]="PLUS SIGN IN RIGHT HALF CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A2E, -- ⨮
 },
 [0x2A2F]={
  ["category"]="sm",
  ["description"]="VECTOR OR CROSS PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A2F, -- ⨯
 },
 [0x2A30]={
  ["category"]="sm",
  ["description"]="MULTIPLICATION SIGN WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A30, -- ⨰
 },
 [0x2A31]={
  ["category"]="sm",
  ["description"]="MULTIPLICATION SIGN WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A31, -- ⨱
 },
 [0x2A32]={
  ["category"]="sm",
  ["description"]="SEMIDIRECT PRODUCT WITH BOTTOM CLOSED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A32, -- ⨲
 },
 [0x2A33]={
  ["category"]="sm",
  ["description"]="SMASH PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A33, -- ⨳
 },
 [0x2A34]={
  ["category"]="sm",
  ["description"]="MULTIPLICATION SIGN IN LEFT HALF CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A34, -- ⨴
 },
 [0x2A35]={
  ["category"]="sm",
  ["description"]="MULTIPLICATION SIGN IN RIGHT HALF CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A35, -- ⨵
 },
 [0x2A36]={
  ["category"]="sm",
  ["description"]="CIRCLED MULTIPLICATION SIGN WITH CIRCUMFLEX ACCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A36, -- ⨶
 },
 [0x2A37]={
  ["category"]="sm",
  ["description"]="MULTIPLICATION SIGN IN DOUBLE CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A37, -- ⨷
 },
 [0x2A38]={
  ["category"]="sm",
  ["description"]="CIRCLED DIVISION SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A38, -- ⨸
 },
 [0x2A39]={
  ["category"]="sm",
  ["description"]="PLUS SIGN IN TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A39, -- ⨹
 },
 [0x2A3A]={
  ["category"]="sm",
  ["description"]="MINUS SIGN IN TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A3A, -- ⨺
 },
 [0x2A3B]={
  ["category"]="sm",
  ["description"]="MULTIPLICATION SIGN IN TRIANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A3B, -- ⨻
 },
 [0x2A3C]={
  ["category"]="sm",
  ["description"]="INTERIOR PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A3C, -- ⨼
 },
 [0x2A3D]={
  ["category"]="sm",
  ["description"]="RIGHTHAND INTERIOR PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A3D, -- ⨽
 },
 [0x2A3E]={
  ["category"]="sm",
  ["description"]="Z NOTATION RELATIONAL COMPOSITION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A3E, -- ⨾
 },
 [0x2A3F]={
  ["category"]="sm",
  ["description"]="AMALGAMATION OR COPRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A3F, -- ⨿
 },
 [0x2A40]={
  ["category"]="sm",
  ["description"]="INTERSECTION WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A40, -- ⩀
 },
 [0x2A41]={
  ["category"]="sm",
  ["description"]="UNION WITH MINUS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A41, -- ⩁
 },
 [0x2A42]={
  ["category"]="sm",
  ["description"]="UNION WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A42, -- ⩂
 },
 [0x2A43]={
  ["category"]="sm",
  ["description"]="INTERSECTION WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A43, -- ⩃
 },
 [0x2A44]={
  ["category"]="sm",
  ["description"]="INTERSECTION WITH LOGICAL AND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A44, -- ⩄
 },
 [0x2A45]={
  ["category"]="sm",
  ["description"]="UNION WITH LOGICAL OR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A45, -- ⩅
 },
 [0x2A46]={
  ["category"]="sm",
  ["description"]="UNION ABOVE INTERSECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A46, -- ⩆
 },
 [0x2A47]={
  ["category"]="sm",
  ["description"]="INTERSECTION ABOVE UNION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A47, -- ⩇
 },
 [0x2A48]={
  ["category"]="sm",
  ["description"]="UNION ABOVE BAR ABOVE INTERSECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A48, -- ⩈
 },
 [0x2A49]={
  ["category"]="sm",
  ["description"]="INTERSECTION ABOVE BAR ABOVE UNION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A49, -- ⩉
 },
 [0x2A4A]={
  ["category"]="sm",
  ["description"]="UNION BESIDE AND JOINED WITH UNION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A4A, -- ⩊
 },
 [0x2A4B]={
  ["category"]="sm",
  ["description"]="INTERSECTION BESIDE AND JOINED WITH INTERSECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A4B, -- ⩋
 },
 [0x2A4C]={
  ["category"]="sm",
  ["description"]="CLOSED UNION WITH SERIFS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A4C, -- ⩌
 },
 [0x2A4D]={
  ["category"]="sm",
  ["description"]="CLOSED INTERSECTION WITH SERIFS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A4D, -- ⩍
 },
 [0x2A4E]={
  ["category"]="sm",
  ["description"]="DOUBLE SQUARE INTERSECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A4E, -- ⩎
 },
 [0x2A4F]={
  ["category"]="sm",
  ["description"]="DOUBLE SQUARE UNION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A4F, -- ⩏
 },
 [0x2A50]={
  ["category"]="sm",
  ["description"]="CLOSED UNION WITH SERIFS AND SMASH PRODUCT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A50, -- ⩐
 },
 [0x2A51]={
  ["category"]="sm",
  ["description"]="LOGICAL AND WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A51, -- ⩑
 },
 [0x2A52]={
  ["category"]="sm",
  ["description"]="LOGICAL OR WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A52, -- ⩒
 },
 [0x2A53]={
  ["category"]="sm",
  ["description"]="DOUBLE LOGICAL AND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A53, -- ⩓
 },
 [0x2A54]={
  ["category"]="sm",
  ["description"]="DOUBLE LOGICAL OR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A54, -- ⩔
 },
 [0x2A55]={
  ["category"]="sm",
  ["description"]="TWO INTERSECTING LOGICAL AND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A55, -- ⩕
 },
 [0x2A56]={
  ["category"]="sm",
  ["description"]="TWO INTERSECTING LOGICAL OR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A56, -- ⩖
 },
 [0x2A57]={
  ["category"]="sm",
  ["description"]="SLOPING LARGE OR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A57, -- ⩗
 },
 [0x2A58]={
  ["category"]="sm",
  ["description"]="SLOPING LARGE AND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A58, -- ⩘
 },
 [0x2A59]={
  ["category"]="sm",
  ["description"]="LOGICAL OR OVERLAPPING LOGICAL AND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A59, -- ⩙
 },
 [0x2A5A]={
  ["category"]="sm",
  ["description"]="LOGICAL AND WITH MIDDLE STEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A5A, -- ⩚
 },
 [0x2A5B]={
  ["category"]="sm",
  ["description"]="LOGICAL OR WITH MIDDLE STEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A5B, -- ⩛
 },
 [0x2A5C]={
  ["category"]="sm",
  ["description"]="LOGICAL AND WITH HORIZONTAL DASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A5C, -- ⩜
 },
 [0x2A5D]={
  ["category"]="sm",
  ["description"]="LOGICAL OR WITH HORIZONTAL DASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A5D, -- ⩝
 },
 [0x2A5E]={
  ["category"]="sm",
  ["description"]="LOGICAL AND WITH DOUBLE OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A5E, -- ⩞
 },
 [0x2A5F]={
  ["category"]="sm",
  ["description"]="LOGICAL AND WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A5F, -- ⩟
 },
 [0x2A60]={
  ["category"]="sm",
  ["description"]="LOGICAL AND WITH DOUBLE UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A60, -- ⩠
 },
 [0x2A61]={
  ["category"]="sm",
  ["description"]="SMALL VEE WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A61, -- ⩡
 },
 [0x2A62]={
  ["category"]="sm",
  ["description"]="LOGICAL OR WITH DOUBLE OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A62, -- ⩢
 },
 [0x2A63]={
  ["category"]="sm",
  ["description"]="LOGICAL OR WITH DOUBLE UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A63, -- ⩣
 },
 [0x2A64]={
  ["category"]="sm",
  ["description"]="Z NOTATION DOMAIN ANTIRESTRICTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A64, -- ⩤
 },
 [0x2A65]={
  ["category"]="sm",
  ["description"]="Z NOTATION RANGE ANTIRESTRICTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A65, -- ⩥
 },
 [0x2A66]={
  ["category"]="sm",
  ["description"]="EQUALS SIGN WITH DOT BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A66, -- ⩦
 },
 [0x2A67]={
  ["category"]="sm",
  ["description"]="IDENTICAL WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A67, -- ⩧
 },
 [0x2A68]={
  ["category"]="sm",
  ["description"]="TRIPLE HORIZONTAL BAR WITH DOUBLE VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A68, -- ⩨
 },
 [0x2A69]={
  ["category"]="sm",
  ["description"]="TRIPLE HORIZONTAL BAR WITH TRIPLE VERTICAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A69, -- ⩩
 },
 [0x2A6A]={
  ["category"]="sm",
  ["description"]="TILDE OPERATOR WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A6A, -- ⩪
 },
 [0x2A6B]={
  ["category"]="sm",
  ["description"]="TILDE OPERATOR WITH RISING DOTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A6B, -- ⩫
 },
 [0x2A6C]={
  ["category"]="sm",
  ["description"]="SIMILAR MINUS SIMILAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A6C, -- ⩬
 },
 [0x2A6D]={
  ["category"]="sm",
  ["description"]="CONGRUENT WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A6D, -- ⩭
 },
 [0x2A6E]={
  ["category"]="sm",
  ["description"]="EQUALS WITH ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A6E, -- ⩮
 },
 [0x2A6F]={
  ["category"]="sm",
  ["description"]="ALMOST EQUAL TO WITH CIRCUMFLEX ACCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A6F, -- ⩯
 },
 [0x2A70]={
  ["category"]="sm",
  ["description"]="APPROXIMATELY EQUAL OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A70, -- ⩰
 },
 [0x2A71]={
  ["category"]="sm",
  ["description"]="EQUALS SIGN ABOVE PLUS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A71, -- ⩱
 },
 [0x2A72]={
  ["category"]="sm",
  ["description"]="PLUS SIGN ABOVE EQUALS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A72, -- ⩲
 },
 [0x2A73]={
  ["category"]="sm",
  ["description"]="EQUALS SIGN ABOVE TILDE OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A73, -- ⩳
 },
 [0x2A74]={
  ["category"]="sm",
  ["description"]="DOUBLE COLON EQUAL",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x003A, 0x003A, 0x003D },
  ["unicodeslot"]=0x2A74, -- ⩴
 },
 [0x2A75]={
  ["category"]="sm",
  ["description"]="TWO CONSECUTIVE EQUALS SIGNS",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x003D, 0x003D },
  ["unicodeslot"]=0x2A75, -- ⩵
 },
 [0x2A76]={
  ["category"]="sm",
  ["description"]="THREE CONSECUTIVE EQUALS SIGNS",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x003D, 0x003D, 0x003D },
  ["unicodeslot"]=0x2A76, -- ⩶
 },
 [0x2A77]={
  ["category"]="sm",
  ["description"]="EQUALS SIGN WITH TWO DOTS ABOVE AND TWO DOTS BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A77, -- ⩷
 },
 [0x2A78]={
  ["category"]="sm",
  ["description"]="EQUIVALENT WITH FOUR DOTS ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A78, -- ⩸
 },
 [0x2A79]={
  ["category"]="sm",
  ["description"]="LESS-THAN WITH CIRCLE INSIDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A79, -- ⩹
 },
 [0x2A7A]={
  ["category"]="sm",
  ["description"]="GREATER-THAN WITH CIRCLE INSIDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A7A, -- ⩺
 },
 [0x2A7B]={
  ["category"]="sm",
  ["description"]="LESS-THAN WITH QUESTION MARK ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A7B, -- ⩻
 },
 [0x2A7C]={
  ["category"]="sm",
  ["description"]="GREATER-THAN WITH QUESTION MARK ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A7C, -- ⩼
 },
 [0x2A7D]={
  ["category"]="sm",
  ["description"]="LESS-THAN OR SLANTED EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A7D, -- ⩽
 },
 [0x2A7E]={
  ["category"]="sm",
  ["description"]="GREATER-THAN OR SLANTED EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A7E, -- ⩾
 },
 [0x2A7F]={
  ["category"]="sm",
  ["description"]="LESS-THAN OR SLANTED EQUAL TO WITH DOT INSIDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A7F, -- ⩿
 },
 [0x2A80]={
  ["category"]="sm",
  ["description"]="GREATER-THAN OR SLANTED EQUAL TO WITH DOT INSIDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A80, -- ⪀
 },
 [0x2A81]={
  ["category"]="sm",
  ["description"]="LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A81, -- ⪁
 },
 [0x2A82]={
  ["category"]="sm",
  ["description"]="GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A82, -- ⪂
 },
 [0x2A83]={
  ["category"]="sm",
  ["description"]="LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE RIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A83, -- ⪃
 },
 [0x2A84]={
  ["category"]="sm",
  ["description"]="GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE LEFT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A84, -- ⪄
 },
 [0x2A85]={
  ["category"]="sm",
  ["description"]="LESS-THAN OR APPROXIMATE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A85, -- ⪅
 },
 [0x2A86]={
  ["category"]="sm",
  ["description"]="GREATER-THAN OR APPROXIMATE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A86, -- ⪆
 },
 [0x2A87]={
  ["category"]="sm",
  ["description"]="LESS-THAN AND SINGLE-LINE NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A87, -- ⪇
 },
 [0x2A88]={
  ["category"]="sm",
  ["description"]="GREATER-THAN AND SINGLE-LINE NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A88, -- ⪈
 },
 [0x2A89]={
  ["category"]="sm",
  ["description"]="LESS-THAN AND NOT APPROXIMATE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A89, -- ⪉
 },
 [0x2A8A]={
  ["category"]="sm",
  ["description"]="GREATER-THAN AND NOT APPROXIMATE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A8A, -- ⪊
 },
 [0x2A8B]={
  ["category"]="sm",
  ["description"]="LESS-THAN ABOVE DOUBLE-LINE EQUAL ABOVE GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A8B, -- ⪋
 },
 [0x2A8C]={
  ["category"]="sm",
  ["description"]="GREATER-THAN ABOVE DOUBLE-LINE EQUAL ABOVE LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A8C, -- ⪌
 },
 [0x2A8D]={
  ["category"]="sm",
  ["description"]="LESS-THAN ABOVE SIMILAR OR EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A8D, -- ⪍
 },
 [0x2A8E]={
  ["category"]="sm",
  ["description"]="GREATER-THAN ABOVE SIMILAR OR EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A8E, -- ⪎
 },
 [0x2A8F]={
  ["category"]="sm",
  ["description"]="LESS-THAN ABOVE SIMILAR ABOVE GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A8F, -- ⪏
 },
 [0x2A90]={
  ["category"]="sm",
  ["description"]="GREATER-THAN ABOVE SIMILAR ABOVE LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A90, -- ⪐
 },
 [0x2A91]={
  ["category"]="sm",
  ["description"]="LESS-THAN ABOVE GREATER-THAN ABOVE DOUBLE-LINE EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A91, -- ⪑
 },
 [0x2A92]={
  ["category"]="sm",
  ["description"]="GREATER-THAN ABOVE LESS-THAN ABOVE DOUBLE-LINE EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A92, -- ⪒
 },
 [0x2A93]={
  ["category"]="sm",
  ["description"]="LESS-THAN ABOVE SLANTED EQUAL ABOVE GREATER-THAN ABOVE SLANTED EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A93, -- ⪓
 },
 [0x2A94]={
  ["category"]="sm",
  ["description"]="GREATER-THAN ABOVE SLANTED EQUAL ABOVE LESS-THAN ABOVE SLANTED EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A94, -- ⪔
 },
 [0x2A95]={
  ["category"]="sm",
  ["description"]="SLANTED EQUAL TO OR LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A95, -- ⪕
 },
 [0x2A96]={
  ["category"]="sm",
  ["description"]="SLANTED EQUAL TO OR GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A96, -- ⪖
 },
 [0x2A97]={
  ["category"]="sm",
  ["description"]="SLANTED EQUAL TO OR LESS-THAN WITH DOT INSIDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A97, -- ⪗
 },
 [0x2A98]={
  ["category"]="sm",
  ["description"]="SLANTED EQUAL TO OR GREATER-THAN WITH DOT INSIDE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A98, -- ⪘
 },
 [0x2A99]={
  ["category"]="sm",
  ["description"]="DOUBLE-LINE EQUAL TO OR LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A99, -- ⪙
 },
 [0x2A9A]={
  ["category"]="sm",
  ["description"]="DOUBLE-LINE EQUAL TO OR GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A9A, -- ⪚
 },
 [0x2A9B]={
  ["category"]="sm",
  ["description"]="DOUBLE-LINE SLANTED EQUAL TO OR LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A9B, -- ⪛
 },
 [0x2A9C]={
  ["category"]="sm",
  ["description"]="DOUBLE-LINE SLANTED EQUAL TO OR GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A9C, -- ⪜
 },
 [0x2A9D]={
  ["category"]="sm",
  ["description"]="SIMILAR OR LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A9D, -- ⪝
 },
 [0x2A9E]={
  ["category"]="sm",
  ["description"]="SIMILAR OR GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A9E, -- ⪞
 },
 [0x2A9F]={
  ["category"]="sm",
  ["description"]="SIMILAR ABOVE LESS-THAN ABOVE EQUALS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2A9F, -- ⪟
 },
 [0x2AA0]={
  ["category"]="sm",
  ["description"]="SIMILAR ABOVE GREATER-THAN ABOVE EQUALS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA0, -- ⪠
 },
 [0x2AA1]={
  ["category"]="sm",
  ["description"]="DOUBLE NESTED LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA1, -- ⪡
 },
 [0x2AA2]={
  ["category"]="sm",
  ["description"]="DOUBLE NESTED GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA2, -- ⪢
 },
 [0x2AA3]={
  ["category"]="sm",
  ["description"]="DOUBLE NESTED LESS-THAN WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA3, -- ⪣
 },
 [0x2AA4]={
  ["category"]="sm",
  ["description"]="GREATER-THAN OVERLAPPING LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA4, -- ⪤
 },
 [0x2AA5]={
  ["category"]="sm",
  ["description"]="GREATER-THAN BESIDE LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA5, -- ⪥
 },
 [0x2AA6]={
  ["category"]="sm",
  ["description"]="LESS-THAN CLOSED BY CURVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA6, -- ⪦
 },
 [0x2AA7]={
  ["category"]="sm",
  ["description"]="GREATER-THAN CLOSED BY CURVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA7, -- ⪧
 },
 [0x2AA8]={
  ["category"]="sm",
  ["description"]="LESS-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA8, -- ⪨
 },
 [0x2AA9]={
  ["category"]="sm",
  ["description"]="GREATER-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AA9, -- ⪩
 },
 [0x2AAA]={
  ["category"]="sm",
  ["description"]="SMALLER THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AAA, -- ⪪
 },
 [0x2AAB]={
  ["category"]="sm",
  ["description"]="LARGER THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AAB, -- ⪫
 },
 [0x2AAC]={
  ["category"]="sm",
  ["description"]="SMALLER THAN OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AAC, -- ⪬
 },
 [0x2AAD]={
  ["category"]="sm",
  ["description"]="LARGER THAN OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AAD, -- ⪭
 },
 [0x2AAE]={
  ["category"]="sm",
  ["description"]="EQUALS SIGN WITH BUMPY ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AAE, -- ⪮
 },
 [0x2AAF]={
  ["category"]="sm",
  ["description"]="PRECEDES ABOVE SINGLE-LINE EQUALS SIGN",
  ["mathclass"]="relation",
  ["mathname"]="preceq",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AAF, -- ⪯
 },
 [0x2AB0]={
  ["category"]="sm",
  ["description"]="SUCCEEDS ABOVE SINGLE-LINE EQUALS SIGN",
  ["mathclass"]="relation",
  ["mathname"]="succeq",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB0, -- ⪰
 },
 [0x2AB1]={
  ["category"]="sm",
  ["description"]="PRECEDES ABOVE SINGLE-LINE NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB1, -- ⪱
 },
 [0x2AB2]={
  ["category"]="sm",
  ["description"]="SUCCEEDS ABOVE SINGLE-LINE NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB2, -- ⪲
 },
 [0x2AB3]={
  ["category"]="sm",
  ["description"]="PRECEDES ABOVE EQUALS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB3, -- ⪳
 },
 [0x2AB4]={
  ["category"]="sm",
  ["description"]="SUCCEEDS ABOVE EQUALS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB4, -- ⪴
 },
 [0x2AB5]={
  ["category"]="sm",
  ["description"]="PRECEDES ABOVE NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB5, -- ⪵
 },
 [0x2AB6]={
  ["category"]="sm",
  ["description"]="SUCCEEDS ABOVE NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB6, -- ⪶
 },
 [0x2AB7]={
  ["category"]="sm",
  ["description"]="PRECEDES ABOVE ALMOST EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB7, -- ⪷
 },
 [0x2AB8]={
  ["category"]="sm",
  ["description"]="SUCCEEDS ABOVE ALMOST EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB8, -- ⪸
 },
 [0x2AB9]={
  ["category"]="sm",
  ["description"]="PRECEDES ABOVE NOT ALMOST EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AB9, -- ⪹
 },
 [0x2ABA]={
  ["category"]="sm",
  ["description"]="SUCCEEDS ABOVE NOT ALMOST EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ABA, -- ⪺
 },
 [0x2ABB]={
  ["category"]="sm",
  ["description"]="DOUBLE PRECEDES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ABB, -- ⪻
 },
 [0x2ABC]={
  ["category"]="sm",
  ["description"]="DOUBLE SUCCEEDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ABC, -- ⪼
 },
 [0x2ABD]={
  ["category"]="sm",
  ["description"]="SUBSET WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ABD, -- ⪽
 },
 [0x2ABE]={
  ["category"]="sm",
  ["description"]="SUPERSET WITH DOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ABE, -- ⪾
 },
 [0x2ABF]={
  ["category"]="sm",
  ["description"]="SUBSET WITH PLUS SIGN BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ABF, -- ⪿
 },
 [0x2AC0]={
  ["category"]="sm",
  ["description"]="SUPERSET WITH PLUS SIGN BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC0, -- ⫀
 },
 [0x2AC1]={
  ["category"]="sm",
  ["description"]="SUBSET WITH MULTIPLICATION SIGN BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC1, -- ⫁
 },
 [0x2AC2]={
  ["category"]="sm",
  ["description"]="SUPERSET WITH MULTIPLICATION SIGN BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC2, -- ⫂
 },
 [0x2AC3]={
  ["category"]="sm",
  ["description"]="SUBSET OF OR EQUAL TO WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC3, -- ⫃
 },
 [0x2AC4]={
  ["category"]="sm",
  ["description"]="SUPERSET OF OR EQUAL TO WITH DOT ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC4, -- ⫄
 },
 [0x2AC5]={
  ["category"]="sm",
  ["description"]="SUBSET OF ABOVE EQUALS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC5, -- ⫅
 },
 [0x2AC6]={
  ["category"]="sm",
  ["description"]="SUPERSET OF ABOVE EQUALS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC6, -- ⫆
 },
 [0x2AC7]={
  ["category"]="sm",
  ["description"]="SUBSET OF ABOVE TILDE OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC7, -- ⫇
 },
 [0x2AC8]={
  ["category"]="sm",
  ["description"]="SUPERSET OF ABOVE TILDE OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC8, -- ⫈
 },
 [0x2AC9]={
  ["category"]="sm",
  ["description"]="SUBSET OF ABOVE ALMOST EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AC9, -- ⫉
 },
 [0x2ACA]={
  ["category"]="sm",
  ["description"]="SUPERSET OF ABOVE ALMOST EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ACA, -- ⫊
 },
 [0x2ACB]={
  ["category"]="sm",
  ["description"]="SUBSET OF ABOVE NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ACB, -- ⫋
 },
 [0x2ACC]={
  ["category"]="sm",
  ["description"]="SUPERSET OF ABOVE NOT EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ACC, -- ⫌
 },
 [0x2ACD]={
  ["category"]="sm",
  ["description"]="SQUARE LEFT OPEN BOX OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ACD, -- ⫍
 },
 [0x2ACE]={
  ["category"]="sm",
  ["description"]="SQUARE RIGHT OPEN BOX OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ACE, -- ⫎
 },
 [0x2ACF]={
  ["category"]="sm",
  ["description"]="CLOSED SUBSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ACF, -- ⫏
 },
 [0x2AD0]={
  ["category"]="sm",
  ["description"]="CLOSED SUPERSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD0, -- ⫐
 },
 [0x2AD1]={
  ["category"]="sm",
  ["description"]="CLOSED SUBSET OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD1, -- ⫑
 },
 [0x2AD2]={
  ["category"]="sm",
  ["description"]="CLOSED SUPERSET OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD2, -- ⫒
 },
 [0x2AD3]={
  ["category"]="sm",
  ["description"]="SUBSET ABOVE SUPERSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD3, -- ⫓
 },
 [0x2AD4]={
  ["category"]="sm",
  ["description"]="SUPERSET ABOVE SUBSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD4, -- ⫔
 },
 [0x2AD5]={
  ["category"]="sm",
  ["description"]="SUBSET ABOVE SUBSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD5, -- ⫕
 },
 [0x2AD6]={
  ["category"]="sm",
  ["description"]="SUPERSET ABOVE SUPERSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD6, -- ⫖
 },
 [0x2AD7]={
  ["category"]="sm",
  ["description"]="SUPERSET BESIDE SUBSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD7, -- ⫗
 },
 [0x2AD8]={
  ["category"]="sm",
  ["description"]="SUPERSET BESIDE AND JOINED BY DASH WITH SUBSET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD8, -- ⫘
 },
 [0x2AD9]={
  ["category"]="sm",
  ["description"]="ELEMENT OF OPENING DOWNWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AD9, -- ⫙
 },
 [0x2ADA]={
  ["category"]="sm",
  ["description"]="PITCHFORK WITH TEE TOP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ADA, -- ⫚
 },
 [0x2ADB]={
  ["category"]="sm",
  ["description"]="TRANSVERSAL INTERSECTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ADB, -- ⫛
 },
 [0x2ADC]={
  ["category"]="sm",
  ["description"]="FORKING",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x2ADD, 0x0338 },
  ["unicodeslot"]=0x2ADC, -- ⫝̸
 },
 [0x2ADD]={
  ["category"]="sm",
  ["description"]="NONFORKING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ADD, -- ⫝
 },
 [0x2ADE]={
  ["category"]="sm",
  ["description"]="SHORT LEFT TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ADE, -- ⫞
 },
 [0x2ADF]={
  ["category"]="sm",
  ["description"]="SHORT DOWN TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2ADF, -- ⫟
 },
 [0x2AE0]={
  ["category"]="sm",
  ["description"]="SHORT UP TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE0, -- ⫠
 },
 [0x2AE1]={
  ["category"]="sm",
  ["description"]="PERPENDICULAR WITH S",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE1, -- ⫡
 },
 [0x2AE2]={
  ["category"]="sm",
  ["description"]="VERTICAL BAR TRIPLE RIGHT TURNSTILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE2, -- ⫢
 },
 [0x2AE3]={
  ["category"]="sm",
  ["description"]="DOUBLE VERTICAL BAR LEFT TURNSTILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE3, -- ⫣
 },
 [0x2AE4]={
  ["category"]="sm",
  ["description"]="VERTICAL BAR DOUBLE LEFT TURNSTILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE4, -- ⫤
 },
 [0x2AE5]={
  ["category"]="sm",
  ["description"]="DOUBLE VERTICAL BAR DOUBLE LEFT TURNSTILE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE5, -- ⫥
 },
 [0x2AE6]={
  ["category"]="sm",
  ["description"]="LONG DASH FROM LEFT MEMBER OF DOUBLE VERTICAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE6, -- ⫦
 },
 [0x2AE7]={
  ["category"]="sm",
  ["description"]="SHORT DOWN TACK WITH OVERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE7, -- ⫧
 },
 [0x2AE8]={
  ["category"]="sm",
  ["description"]="SHORT UP TACK WITH UNDERBAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE8, -- ⫨
 },
 [0x2AE9]={
  ["category"]="sm",
  ["description"]="SHORT UP TACK ABOVE SHORT DOWN TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AE9, -- ⫩
 },
 [0x2AEA]={
  ["category"]="sm",
  ["description"]="DOUBLE DOWN TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AEA, -- ⫪
 },
 [0x2AEB]={
  ["category"]="sm",
  ["description"]="DOUBLE UP TACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AEB, -- ⫫
 },
 [0x2AEC]={
  ["category"]="sm",
  ["description"]="DOUBLE STROKE NOT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AEC, -- ⫬
 },
 [0x2AED]={
  ["category"]="sm",
  ["description"]="REVERSED DOUBLE STROKE NOT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AED, -- ⫭
 },
 [0x2AEE]={
  ["category"]="sm",
  ["description"]="DOES NOT DIVIDE WITH REVERSED NEGATION SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AEE, -- ⫮
 },
 [0x2AEF]={
  ["category"]="sm",
  ["description"]="VERTICAL LINE WITH CIRCLE ABOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AEF, -- ⫯
 },
 [0x2AF0]={
  ["category"]="sm",
  ["description"]="VERTICAL LINE WITH CIRCLE BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF0, -- ⫰
 },
 [0x2AF1]={
  ["category"]="sm",
  ["description"]="DOWN TACK WITH CIRCLE BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF1, -- ⫱
 },
 [0x2AF2]={
  ["category"]="sm",
  ["description"]="PARALLEL WITH HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF2, -- ⫲
 },
 [0x2AF3]={
  ["category"]="sm",
  ["description"]="PARALLEL WITH TILDE OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF3, -- ⫳
 },
 [0x2AF4]={
  ["category"]="sm",
  ["description"]="TRIPLE VERTICAL BAR BINARY RELATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF4, -- ⫴
 },
 [0x2AF5]={
  ["category"]="sm",
  ["description"]="TRIPLE VERTICAL BAR WITH HORIZONTAL STROKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF5, -- ⫵
 },
 [0x2AF6]={
  ["category"]="sm",
  ["description"]="TRIPLE COLON OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF6, -- ⫶
 },
 [0x2AF7]={
  ["category"]="sm",
  ["description"]="TRIPLE NESTED LESS-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF7, -- ⫷
 },
 [0x2AF8]={
  ["category"]="sm",
  ["description"]="TRIPLE NESTED GREATER-THAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF8, -- ⫸
 },
 [0x2AF9]={
  ["category"]="sm",
  ["description"]="DOUBLE-LINE SLANTED LESS-THAN OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AF9, -- ⫹
 },
 [0x2AFA]={
  ["category"]="sm",
  ["description"]="DOUBLE-LINE SLANTED GREATER-THAN OR EQUAL TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AFA, -- ⫺
 },
 [0x2AFB]={
  ["category"]="sm",
  ["description"]="TRIPLE SOLIDUS BINARY RELATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AFB, -- ⫻
 },
 [0x2AFC]={
  ["category"]="sm",
  ["description"]="LARGE TRIPLE VERTICAL BAR OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AFC, -- ⫼
 },
 [0x2AFD]={
  ["category"]="sm",
  ["description"]="DOUBLE SOLIDUS OPERATOR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AFD, -- ⫽
 },
 [0x2AFE]={
  ["category"]="sm",
  ["description"]="WHITE VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AFE, -- ⫾
 },
 [0x2AFF]={
  ["category"]="sm",
  ["description"]="N-ARY WHITE VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2AFF, -- ⫿
 },
 [0x2B00]={
  ["category"]="so",
  ["description"]="NORTH EAST WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B00, -- ⬀
 },
 [0x2B01]={
  ["category"]="so",
  ["description"]="NORTH WEST WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B01, -- ⬁
 },
 [0x2B02]={
  ["category"]="so",
  ["description"]="SOUTH EAST WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B02, -- ⬂
 },
 [0x2B03]={
  ["category"]="so",
  ["description"]="SOUTH WEST WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B03, -- ⬃
 },
 [0x2B04]={
  ["category"]="so",
  ["description"]="LEFT RIGHT WHITE ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B04, -- ⬄
 },
 [0x2B05]={
  ["category"]="so",
  ["description"]="LEFTWARDS BLACK ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B05, -- ⬅
 },
 [0x2B06]={
  ["category"]="so",
  ["description"]="UPWARDS BLACK ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B06, -- ⬆
 },
 [0x2B07]={
  ["category"]="so",
  ["description"]="DOWNWARDS BLACK ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B07, -- ⬇
 },
 [0x2B08]={
  ["category"]="so",
  ["description"]="NORTH EAST BLACK ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B08, -- ⬈
 },
 [0x2B09]={
  ["category"]="so",
  ["description"]="NORTH WEST BLACK ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B09, -- ⬉
 },
 [0x2B0A]={
  ["category"]="so",
  ["description"]="SOUTH EAST BLACK ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B0A, -- ⬊
 },
 [0x2B0B]={
  ["category"]="so",
  ["description"]="SOUTH WEST BLACK ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B0B, -- ⬋
 },
 [0x2B0C]={
  ["category"]="so",
  ["description"]="LEFT RIGHT BLACK ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B0C, -- ⬌
 },
 [0x2B0D]={
  ["category"]="so",
  ["description"]="UP DOWN BLACK ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B0D, -- ⬍
 },
 [0x2B0E]={
  ["category"]="so",
  ["description"]="RIGHTWARDS ARROW WITH TIP DOWNWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B0E, -- ⬎
 },
 [0x2B0F]={
  ["category"]="so",
  ["description"]="RIGHTWARDS ARROW WITH TIP UPWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B0F, -- ⬏
 },
 [0x2B10]={
  ["category"]="so",
  ["description"]="LEFTWARDS ARROW WITH TIP DOWNWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B10, -- ⬐
 },
 [0x2B11]={
  ["category"]="so",
  ["description"]="LEFTWARDS ARROW WITH TIP UPWARDS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B11, -- ⬑
 },
 [0x2B12]={
  ["category"]="so",
  ["description"]="SQUARE WITH TOP HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B12, -- ⬒
 },
 [0x2B13]={
  ["category"]="so",
  ["description"]="SQUARE WITH BOTTOM HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B13, -- ⬓
 },
 [0x2B14]={
  ["category"]="so",
  ["description"]="SQUARE WITH UPPER RIGHT DIAGONAL HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B14, -- ⬔
 },
 [0x2B15]={
  ["category"]="so",
  ["description"]="SQUARE WITH LOWER LEFT DIAGONAL HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B15, -- ⬕
 },
 [0x2B16]={
  ["category"]="so",
  ["description"]="DIAMOND WITH LEFT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B16, -- ⬖
 },
 [0x2B17]={
  ["category"]="so",
  ["description"]="DIAMOND WITH RIGHT HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B17, -- ⬗
 },
 [0x2B18]={
  ["category"]="so",
  ["description"]="DIAMOND WITH TOP HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B18, -- ⬘
 },
 [0x2B19]={
  ["category"]="so",
  ["description"]="DIAMOND WITH BOTTOM HALF BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B19, -- ⬙
 },
 [0x2B1A]={
  ["category"]="so",
  ["description"]="DOTTED SQUARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B1A, -- ⬚
 },
 [0x2B20]={
  ["category"]="so",
  ["description"]="WHITE PENTAGON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B20, -- ⬠
 },
 [0x2B21]={
  ["category"]="so",
  ["description"]="WHITE HEXAGON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B21, -- ⬡
 },
 [0x2B22]={
  ["category"]="so",
  ["description"]="BLACK HEXAGON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B22, -- ⬢
 },
 [0x2B23]={
  ["category"]="so",
  ["description"]="HORIZONTAL BLACK HEXAGON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2B23, -- ⬣
 },
 [0x2C00]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER AZU",
  ["lccode"]=0x2C30,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C00, -- Ⰰ
 },
 [0x2C01]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER BUKY",
  ["lccode"]=0x2C31,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C01, -- Ⰱ
 },
 [0x2C02]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER VEDE",
  ["lccode"]=0x2C32,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C02, -- Ⰲ
 },
 [0x2C03]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER GLAGOLI",
  ["lccode"]=0x2C33,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C03, -- Ⰳ
 },
 [0x2C04]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER DOBRO",
  ["lccode"]=0x2C34,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C04, -- Ⰴ
 },
 [0x2C05]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER YESTU",
  ["lccode"]=0x2C35,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C05, -- Ⰵ
 },
 [0x2C06]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER ZHIVETE",
  ["lccode"]=0x2C36,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C06, -- Ⰶ
 },
 [0x2C07]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER DZELO",
  ["lccode"]=0x2C37,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C07, -- Ⰷ
 },
 [0x2C08]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER ZEMLJA",
  ["lccode"]=0x2C38,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C08, -- Ⰸ
 },
 [0x2C09]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER IZHE",
  ["lccode"]=0x2C39,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C09, -- Ⰹ
 },
 [0x2C0A]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER INITIAL IZHE",
  ["lccode"]=0x2C3A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C0A, -- Ⰺ
 },
 [0x2C0B]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER I",
  ["lccode"]=0x2C3B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C0B, -- Ⰻ
 },
 [0x2C0C]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER DJERVI",
  ["lccode"]=0x2C3C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C0C, -- Ⰼ
 },
 [0x2C0D]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER KAKO",
  ["lccode"]=0x2C3D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C0D, -- Ⰽ
 },
 [0x2C0E]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER LJUDIJE",
  ["lccode"]=0x2C3E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C0E, -- Ⰾ
 },
 [0x2C0F]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER MYSLITE",
  ["lccode"]=0x2C3F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C0F, -- Ⰿ
 },
 [0x2C10]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER NASHI",
  ["lccode"]=0x2C40,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C10, -- Ⱀ
 },
 [0x2C11]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER ONU",
  ["lccode"]=0x2C41,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C11, -- Ⱁ
 },
 [0x2C12]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER POKOJI",
  ["lccode"]=0x2C42,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C12, -- Ⱂ
 },
 [0x2C13]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER RITSI",
  ["lccode"]=0x2C43,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C13, -- Ⱃ
 },
 [0x2C14]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER SLOVO",
  ["lccode"]=0x2C44,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C14, -- Ⱄ
 },
 [0x2C15]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER TVRIDO",
  ["lccode"]=0x2C45,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C15, -- Ⱅ
 },
 [0x2C16]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER UKU",
  ["lccode"]=0x2C46,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C16, -- Ⱆ
 },
 [0x2C17]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER FRITU",
  ["lccode"]=0x2C47,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C17, -- Ⱇ
 },
 [0x2C18]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER HERU",
  ["lccode"]=0x2C48,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C18, -- Ⱈ
 },
 [0x2C19]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER OTU",
  ["lccode"]=0x2C49,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C19, -- Ⱉ
 },
 [0x2C1A]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER PE",
  ["lccode"]=0x2C4A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C1A, -- Ⱊ
 },
 [0x2C1B]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER SHTA",
  ["lccode"]=0x2C4B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C1B, -- Ⱋ
 },
 [0x2C1C]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER TSI",
  ["lccode"]=0x2C4C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C1C, -- Ⱌ
 },
 [0x2C1D]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER CHRIVI",
  ["lccode"]=0x2C4D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C1D, -- Ⱍ
 },
 [0x2C1E]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER SHA",
  ["lccode"]=0x2C4E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C1E, -- Ⱎ
 },
 [0x2C1F]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER YERU",
  ["lccode"]=0x2C4F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C1F, -- Ⱏ
 },
 [0x2C20]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER YERI",
  ["lccode"]=0x2C50,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C20, -- Ⱐ
 },
 [0x2C21]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER YATI",
  ["lccode"]=0x2C51,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C21, -- Ⱑ
 },
 [0x2C22]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER SPIDERY HA",
  ["lccode"]=0x2C52,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C22, -- Ⱒ
 },
 [0x2C23]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER YU",
  ["lccode"]=0x2C53,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C23, -- Ⱓ
 },
 [0x2C24]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER SMALL YUS",
  ["lccode"]=0x2C54,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C24, -- Ⱔ
 },
 [0x2C25]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER SMALL YUS WITH TAIL",
  ["lccode"]=0x2C55,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C25, -- Ⱕ
 },
 [0x2C26]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER YO",
  ["lccode"]=0x2C56,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C26, -- Ⱖ
 },
 [0x2C27]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER IOTATED SMALL YUS",
  ["lccode"]=0x2C57,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C27, -- Ⱗ
 },
 [0x2C28]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER BIG YUS",
  ["lccode"]=0x2C58,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C28, -- Ⱘ
 },
 [0x2C29]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER IOTATED BIG YUS",
  ["lccode"]=0x2C59,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C29, -- Ⱙ
 },
 [0x2C2A]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER FITA",
  ["lccode"]=0x2C5A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C2A, -- Ⱚ
 },
 [0x2C2B]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER IZHITSA",
  ["lccode"]=0x2C5B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C2B, -- Ⱛ
 },
 [0x2C2C]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER SHTAPIC",
  ["lccode"]=0x2C5C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C2C, -- Ⱜ
 },
 [0x2C2D]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER TROKUTASTI A",
  ["lccode"]=0x2C5D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C2D, -- Ⱝ
 },
 [0x2C2E]={
  ["category"]="lu",
  ["description"]="GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE",
  ["lccode"]=0x2C5E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C2E, -- Ⱞ
 },
 [0x2C30]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER AZU",
  ["linebreak"]="al",
  ["uccode"]=0x2C00,
  ["unicodeslot"]=0x2C30, -- ⰰ
 },
 [0x2C31]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER BUKY",
  ["linebreak"]="al",
  ["uccode"]=0x2C01,
  ["unicodeslot"]=0x2C31, -- ⰱ
 },
 [0x2C32]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER VEDE",
  ["linebreak"]="al",
  ["uccode"]=0x2C02,
  ["unicodeslot"]=0x2C32, -- ⰲ
 },
 [0x2C33]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER GLAGOLI",
  ["linebreak"]="al",
  ["uccode"]=0x2C03,
  ["unicodeslot"]=0x2C33, -- ⰳ
 },
 [0x2C34]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER DOBRO",
  ["linebreak"]="al",
  ["uccode"]=0x2C04,
  ["unicodeslot"]=0x2C34, -- ⰴ
 },
 [0x2C35]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER YESTU",
  ["linebreak"]="al",
  ["uccode"]=0x2C05,
  ["unicodeslot"]=0x2C35, -- ⰵ
 },
 [0x2C36]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER ZHIVETE",
  ["linebreak"]="al",
  ["uccode"]=0x2C06,
  ["unicodeslot"]=0x2C36, -- ⰶ
 },
 [0x2C37]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER DZELO",
  ["linebreak"]="al",
  ["uccode"]=0x2C07,
  ["unicodeslot"]=0x2C37, -- ⰷ
 },
 [0x2C38]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER ZEMLJA",
  ["linebreak"]="al",
  ["uccode"]=0x2C08,
  ["unicodeslot"]=0x2C38, -- ⰸ
 },
 [0x2C39]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER IZHE",
  ["linebreak"]="al",
  ["uccode"]=0x2C09,
  ["unicodeslot"]=0x2C39, -- ⰹ
 },
 [0x2C3A]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER INITIAL IZHE",
  ["linebreak"]="al",
  ["uccode"]=0x2C0A,
  ["unicodeslot"]=0x2C3A, -- ⰺ
 },
 [0x2C3B]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER I",
  ["linebreak"]="al",
  ["uccode"]=0x2C0B,
  ["unicodeslot"]=0x2C3B, -- ⰻ
 },
 [0x2C3C]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER DJERVI",
  ["linebreak"]="al",
  ["uccode"]=0x2C0C,
  ["unicodeslot"]=0x2C3C, -- ⰼ
 },
 [0x2C3D]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER KAKO",
  ["linebreak"]="al",
  ["uccode"]=0x2C0D,
  ["unicodeslot"]=0x2C3D, -- ⰽ
 },
 [0x2C3E]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER LJUDIJE",
  ["linebreak"]="al",
  ["uccode"]=0x2C0E,
  ["unicodeslot"]=0x2C3E, -- ⰾ
 },
 [0x2C3F]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER MYSLITE",
  ["linebreak"]="al",
  ["uccode"]=0x2C0F,
  ["unicodeslot"]=0x2C3F, -- ⰿ
 },
 [0x2C40]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER NASHI",
  ["linebreak"]="al",
  ["uccode"]=0x2C10,
  ["unicodeslot"]=0x2C40, -- ⱀ
 },
 [0x2C41]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER ONU",
  ["linebreak"]="al",
  ["uccode"]=0x2C11,
  ["unicodeslot"]=0x2C41, -- ⱁ
 },
 [0x2C42]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER POKOJI",
  ["linebreak"]="al",
  ["uccode"]=0x2C12,
  ["unicodeslot"]=0x2C42, -- ⱂ
 },
 [0x2C43]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER RITSI",
  ["linebreak"]="al",
  ["uccode"]=0x2C13,
  ["unicodeslot"]=0x2C43, -- ⱃ
 },
 [0x2C44]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER SLOVO",
  ["linebreak"]="al",
  ["uccode"]=0x2C14,
  ["unicodeslot"]=0x2C44, -- ⱄ
 },
 [0x2C45]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER TVRIDO",
  ["linebreak"]="al",
  ["uccode"]=0x2C15,
  ["unicodeslot"]=0x2C45, -- ⱅ
 },
 [0x2C46]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER UKU",
  ["linebreak"]="al",
  ["uccode"]=0x2C16,
  ["unicodeslot"]=0x2C46, -- ⱆ
 },
 [0x2C47]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER FRITU",
  ["linebreak"]="al",
  ["uccode"]=0x2C17,
  ["unicodeslot"]=0x2C47, -- ⱇ
 },
 [0x2C48]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER HERU",
  ["linebreak"]="al",
  ["uccode"]=0x2C18,
  ["unicodeslot"]=0x2C48, -- ⱈ
 },
 [0x2C49]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER OTU",
  ["linebreak"]="al",
  ["uccode"]=0x2C19,
  ["unicodeslot"]=0x2C49, -- ⱉ
 },
 [0x2C4A]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER PE",
  ["linebreak"]="al",
  ["uccode"]=0x2C1A,
  ["unicodeslot"]=0x2C4A, -- ⱊ
 },
 [0x2C4B]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER SHTA",
  ["linebreak"]="al",
  ["uccode"]=0x2C1B,
  ["unicodeslot"]=0x2C4B, -- ⱋ
 },
 [0x2C4C]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER TSI",
  ["linebreak"]="al",
  ["uccode"]=0x2C1C,
  ["unicodeslot"]=0x2C4C, -- ⱌ
 },
 [0x2C4D]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER CHRIVI",
  ["linebreak"]="al",
  ["uccode"]=0x2C1D,
  ["unicodeslot"]=0x2C4D, -- ⱍ
 },
 [0x2C4E]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER SHA",
  ["linebreak"]="al",
  ["uccode"]=0x2C1E,
  ["unicodeslot"]=0x2C4E, -- ⱎ
 },
 [0x2C4F]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER YERU",
  ["linebreak"]="al",
  ["uccode"]=0x2C1F,
  ["unicodeslot"]=0x2C4F, -- ⱏ
 },
 [0x2C50]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER YERI",
  ["linebreak"]="al",
  ["uccode"]=0x2C20,
  ["unicodeslot"]=0x2C50, -- ⱐ
 },
 [0x2C51]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER YATI",
  ["linebreak"]="al",
  ["uccode"]=0x2C21,
  ["unicodeslot"]=0x2C51, -- ⱑ
 },
 [0x2C52]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER SPIDERY HA",
  ["linebreak"]="al",
  ["uccode"]=0x2C22,
  ["unicodeslot"]=0x2C52, -- ⱒ
 },
 [0x2C53]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER YU",
  ["linebreak"]="al",
  ["uccode"]=0x2C23,
  ["unicodeslot"]=0x2C53, -- ⱓ
 },
 [0x2C54]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER SMALL YUS",
  ["linebreak"]="al",
  ["uccode"]=0x2C24,
  ["unicodeslot"]=0x2C54, -- ⱔ
 },
 [0x2C55]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER SMALL YUS WITH TAIL",
  ["linebreak"]="al",
  ["uccode"]=0x2C25,
  ["unicodeslot"]=0x2C55, -- ⱕ
 },
 [0x2C56]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER YO",
  ["linebreak"]="al",
  ["uccode"]=0x2C26,
  ["unicodeslot"]=0x2C56, -- ⱖ
 },
 [0x2C57]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER IOTATED SMALL YUS",
  ["linebreak"]="al",
  ["uccode"]=0x2C27,
  ["unicodeslot"]=0x2C57, -- ⱗ
 },
 [0x2C58]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER BIG YUS",
  ["linebreak"]="al",
  ["uccode"]=0x2C28,
  ["unicodeslot"]=0x2C58, -- ⱘ
 },
 [0x2C59]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER IOTATED BIG YUS",
  ["linebreak"]="al",
  ["uccode"]=0x2C29,
  ["unicodeslot"]=0x2C59, -- ⱙ
 },
 [0x2C5A]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER FITA",
  ["linebreak"]="al",
  ["uccode"]=0x2C2A,
  ["unicodeslot"]=0x2C5A, -- ⱚ
 },
 [0x2C5B]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER IZHITSA",
  ["linebreak"]="al",
  ["uccode"]=0x2C2B,
  ["unicodeslot"]=0x2C5B, -- ⱛ
 },
 [0x2C5C]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER SHTAPIC",
  ["linebreak"]="al",
  ["uccode"]=0x2C2C,
  ["unicodeslot"]=0x2C5C, -- ⱜ
 },
 [0x2C5D]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER TROKUTASTI A",
  ["linebreak"]="al",
  ["uccode"]=0x2C2D,
  ["unicodeslot"]=0x2C5D, -- ⱝ
 },
 [0x2C5E]={
  ["category"]="ll",
  ["description"]="GLAGOLITIC SMALL LETTER LATINATE MYSLITE",
  ["linebreak"]="al",
  ["uccode"]=0x2C2E,
  ["unicodeslot"]=0x2C5E, -- ⱞ
 },
 [0x2C60]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER L WITH DOUBLE BAR",
  ["lccode"]=0x2C61,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["unicodeslot"]=0x2C60, -- Ⱡ
 },
 [0x2C61]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER L WITH DOUBLE BAR",
  ["linebreak"]="al",
  ["shcode"]=0x006C,
  ["uccode"]=0x2C60,
  ["unicodeslot"]=0x2C61, -- ⱡ
 },
 [0x2C62]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER L WITH MIDDLE TILDE",
  ["lccode"]=0x026B,
  ["linebreak"]="al",
  ["shcode"]=0x004C,
  ["unicodeslot"]=0x2C62, -- Ɫ
 },
 [0x2C63]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER P WITH STROKE",
  ["lccode"]=0x1D7D,
  ["linebreak"]="al",
  ["shcode"]=0x0050,
  ["unicodeslot"]=0x2C63, -- Ᵽ
 },
 [0x2C64]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER R WITH TAIL",
  ["lccode"]=0x027D,
  ["linebreak"]="al",
  ["shcode"]=0x0052,
  ["unicodeslot"]=0x2C64, -- Ɽ
 },
 [0x2C65]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER A WITH STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0061,
  ["uccode"]=0x023A,
  ["unicodeslot"]=0x2C65, -- ⱥ
 },
 [0x2C66]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER T WITH DIAGONAL STROKE",
  ["linebreak"]="al",
  ["shcode"]=0x0074,
  ["uccode"]=0x023E,
  ["unicodeslot"]=0x2C66, -- ⱦ
 },
 [0x2C67]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER H WITH DESCENDER",
  ["lccode"]=0x2C68,
  ["linebreak"]="al",
  ["shcode"]=0x0048,
  ["unicodeslot"]=0x2C67, -- Ⱨ
 },
 [0x2C68]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER H WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x0068,
  ["uccode"]=0x2C67,
  ["unicodeslot"]=0x2C68, -- ⱨ
 },
 [0x2C69]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER K WITH DESCENDER",
  ["lccode"]=0x2C6A,
  ["linebreak"]="al",
  ["shcode"]=0x004B,
  ["unicodeslot"]=0x2C69, -- Ⱪ
 },
 [0x2C6A]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER K WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x006B,
  ["uccode"]=0x2C69,
  ["unicodeslot"]=0x2C6A, -- ⱪ
 },
 [0x2C6B]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER Z WITH DESCENDER",
  ["lccode"]=0x2C6C,
  ["linebreak"]="al",
  ["shcode"]=0x005A,
  ["unicodeslot"]=0x2C6B, -- Ⱬ
 },
 [0x2C6C]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER Z WITH DESCENDER",
  ["linebreak"]="al",
  ["shcode"]=0x007A,
  ["uccode"]=0x2C6B,
  ["unicodeslot"]=0x2C6C, -- ⱬ
 },
 [0x2C74]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER V WITH CURL",
  ["linebreak"]="al",
  ["shcode"]=0x0076,
  ["unicodeslot"]=0x2C74, -- ⱴ
 },
 [0x2C75]={
  ["category"]="lu",
  ["description"]="LATIN CAPITAL LETTER HALF H",
  ["lccode"]=0x2C76,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C75, -- Ⱶ
 },
 [0x2C76]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER HALF H",
  ["linebreak"]="al",
  ["uccode"]=0x2C75,
  ["unicodeslot"]=0x2C76, -- ⱶ
 },
 [0x2C77]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LETTER TAILLESS PHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C77, -- ⱷ
 },
 [0x2C80]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER ALFA",
  ["lccode"]=0x2C81,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C80, -- Ⲁ
 },
 [0x2C81]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER ALFA",
  ["linebreak"]="al",
  ["uccode"]=0x2C80,
  ["unicodeslot"]=0x2C81, -- ⲁ
 },
 [0x2C82]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER VIDA",
  ["lccode"]=0x2C83,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C82, -- Ⲃ
 },
 [0x2C83]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER VIDA",
  ["linebreak"]="al",
  ["uccode"]=0x2C82,
  ["unicodeslot"]=0x2C83, -- ⲃ
 },
 [0x2C84]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER GAMMA",
  ["lccode"]=0x2C85,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C84, -- Ⲅ
 },
 [0x2C85]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER GAMMA",
  ["linebreak"]="al",
  ["uccode"]=0x2C84,
  ["unicodeslot"]=0x2C85, -- ⲅ
 },
 [0x2C86]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER DALDA",
  ["lccode"]=0x2C87,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C86, -- Ⲇ
 },
 [0x2C87]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER DALDA",
  ["linebreak"]="al",
  ["uccode"]=0x2C86,
  ["unicodeslot"]=0x2C87, -- ⲇ
 },
 [0x2C88]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER EIE",
  ["lccode"]=0x2C89,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C88, -- Ⲉ
 },
 [0x2C89]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER EIE",
  ["linebreak"]="al",
  ["uccode"]=0x2C88,
  ["unicodeslot"]=0x2C89, -- ⲉ
 },
 [0x2C8A]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER SOU",
  ["lccode"]=0x2C8B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C8A, -- Ⲋ
 },
 [0x2C8B]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER SOU",
  ["linebreak"]="al",
  ["uccode"]=0x2C8A,
  ["unicodeslot"]=0x2C8B, -- ⲋ
 },
 [0x2C8C]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER ZATA",
  ["lccode"]=0x2C8D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C8C, -- Ⲍ
 },
 [0x2C8D]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER ZATA",
  ["linebreak"]="al",
  ["uccode"]=0x2C8C,
  ["unicodeslot"]=0x2C8D, -- ⲍ
 },
 [0x2C8E]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER HATE",
  ["lccode"]=0x2C8F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C8E, -- Ⲏ
 },
 [0x2C8F]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER HATE",
  ["linebreak"]="al",
  ["uccode"]=0x2C8E,
  ["unicodeslot"]=0x2C8F, -- ⲏ
 },
 [0x2C90]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER THETHE",
  ["lccode"]=0x2C91,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C90, -- Ⲑ
 },
 [0x2C91]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER THETHE",
  ["linebreak"]="al",
  ["uccode"]=0x2C90,
  ["unicodeslot"]=0x2C91, -- ⲑ
 },
 [0x2C92]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER IAUDA",
  ["lccode"]=0x2C93,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C92, -- Ⲓ
 },
 [0x2C93]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER IAUDA",
  ["linebreak"]="al",
  ["uccode"]=0x2C92,
  ["unicodeslot"]=0x2C93, -- ⲓ
 },
 [0x2C94]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER KAPA",
  ["lccode"]=0x2C95,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C94, -- Ⲕ
 },
 [0x2C95]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER KAPA",
  ["linebreak"]="al",
  ["uccode"]=0x2C94,
  ["unicodeslot"]=0x2C95, -- ⲕ
 },
 [0x2C96]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER LAULA",
  ["lccode"]=0x2C97,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C96, -- Ⲗ
 },
 [0x2C97]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER LAULA",
  ["linebreak"]="al",
  ["uccode"]=0x2C96,
  ["unicodeslot"]=0x2C97, -- ⲗ
 },
 [0x2C98]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER MI",
  ["lccode"]=0x2C99,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C98, -- Ⲙ
 },
 [0x2C99]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER MI",
  ["linebreak"]="al",
  ["uccode"]=0x2C98,
  ["unicodeslot"]=0x2C99, -- ⲙ
 },
 [0x2C9A]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER NI",
  ["lccode"]=0x2C9B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C9A, -- Ⲛ
 },
 [0x2C9B]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER NI",
  ["linebreak"]="al",
  ["uccode"]=0x2C9A,
  ["unicodeslot"]=0x2C9B, -- ⲛ
 },
 [0x2C9C]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER KSI",
  ["lccode"]=0x2C9D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C9C, -- Ⲝ
 },
 [0x2C9D]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER KSI",
  ["linebreak"]="al",
  ["uccode"]=0x2C9C,
  ["unicodeslot"]=0x2C9D, -- ⲝ
 },
 [0x2C9E]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER O",
  ["lccode"]=0x2C9F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2C9E, -- Ⲟ
 },
 [0x2C9F]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER O",
  ["linebreak"]="al",
  ["uccode"]=0x2C9E,
  ["unicodeslot"]=0x2C9F, -- ⲟ
 },
 [0x2CA0]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER PI",
  ["lccode"]=0x2CA1,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CA0, -- Ⲡ
 },
 [0x2CA1]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER PI",
  ["linebreak"]="al",
  ["uccode"]=0x2CA0,
  ["unicodeslot"]=0x2CA1, -- ⲡ
 },
 [0x2CA2]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER RO",
  ["lccode"]=0x2CA3,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CA2, -- Ⲣ
 },
 [0x2CA3]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER RO",
  ["linebreak"]="al",
  ["uccode"]=0x2CA2,
  ["unicodeslot"]=0x2CA3, -- ⲣ
 },
 [0x2CA4]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER SIMA",
  ["lccode"]=0x2CA5,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CA4, -- Ⲥ
 },
 [0x2CA5]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER SIMA",
  ["linebreak"]="al",
  ["uccode"]=0x2CA4,
  ["unicodeslot"]=0x2CA5, -- ⲥ
 },
 [0x2CA6]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER TAU",
  ["lccode"]=0x2CA7,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CA6, -- Ⲧ
 },
 [0x2CA7]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER TAU",
  ["linebreak"]="al",
  ["uccode"]=0x2CA6,
  ["unicodeslot"]=0x2CA7, -- ⲧ
 },
 [0x2CA8]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER UA",
  ["lccode"]=0x2CA9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CA8, -- Ⲩ
 },
 [0x2CA9]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER UA",
  ["linebreak"]="al",
  ["uccode"]=0x2CA8,
  ["unicodeslot"]=0x2CA9, -- ⲩ
 },
 [0x2CAA]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER FI",
  ["lccode"]=0x2CAB,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CAA, -- Ⲫ
 },
 [0x2CAB]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER FI",
  ["linebreak"]="al",
  ["uccode"]=0x2CAA,
  ["unicodeslot"]=0x2CAB, -- ⲫ
 },
 [0x2CAC]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER KHI",
  ["lccode"]=0x2CAD,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CAC, -- Ⲭ
 },
 [0x2CAD]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER KHI",
  ["linebreak"]="al",
  ["uccode"]=0x2CAC,
  ["unicodeslot"]=0x2CAD, -- ⲭ
 },
 [0x2CAE]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER PSI",
  ["lccode"]=0x2CAF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CAE, -- Ⲯ
 },
 [0x2CAF]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER PSI",
  ["linebreak"]="al",
  ["uccode"]=0x2CAE,
  ["unicodeslot"]=0x2CAF, -- ⲯ
 },
 [0x2CB0]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OOU",
  ["lccode"]=0x2CB1,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CB0, -- Ⲱ
 },
 [0x2CB1]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OOU",
  ["linebreak"]="al",
  ["uccode"]=0x2CB0,
  ["unicodeslot"]=0x2CB1, -- ⲱ
 },
 [0x2CB2]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER DIALECT-P ALEF",
  ["lccode"]=0x2CB3,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CB2, -- Ⲳ
 },
 [0x2CB3]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER DIALECT-P ALEF",
  ["linebreak"]="al",
  ["uccode"]=0x2CB2,
  ["unicodeslot"]=0x2CB3, -- ⲳ
 },
 [0x2CB4]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC AIN",
  ["lccode"]=0x2CB5,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CB4, -- Ⲵ
 },
 [0x2CB5]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC AIN",
  ["linebreak"]="al",
  ["uccode"]=0x2CB4,
  ["unicodeslot"]=0x2CB5, -- ⲵ
 },
 [0x2CB6]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER CRYPTOGRAMMIC EIE",
  ["lccode"]=0x2CB7,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CB6, -- Ⲷ
 },
 [0x2CB7]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER CRYPTOGRAMMIC EIE",
  ["linebreak"]="al",
  ["uccode"]=0x2CB6,
  ["unicodeslot"]=0x2CB7, -- ⲷ
 },
 [0x2CB8]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER DIALECT-P KAPA",
  ["lccode"]=0x2CB9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CB8, -- Ⲹ
 },
 [0x2CB9]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER DIALECT-P KAPA",
  ["linebreak"]="al",
  ["uccode"]=0x2CB8,
  ["unicodeslot"]=0x2CB9, -- ⲹ
 },
 [0x2CBA]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER DIALECT-P NI",
  ["lccode"]=0x2CBB,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CBA, -- Ⲻ
 },
 [0x2CBB]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER DIALECT-P NI",
  ["linebreak"]="al",
  ["uccode"]=0x2CBA,
  ["unicodeslot"]=0x2CBB, -- ⲻ
 },
 [0x2CBC]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER CRYPTOGRAMMIC NI",
  ["lccode"]=0x2CBD,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CBC, -- Ⲽ
 },
 [0x2CBD]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER CRYPTOGRAMMIC NI",
  ["linebreak"]="al",
  ["uccode"]=0x2CBC,
  ["unicodeslot"]=0x2CBD, -- ⲽ
 },
 [0x2CBE]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC OOU",
  ["lccode"]=0x2CBF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CBE, -- Ⲿ
 },
 [0x2CBF]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC OOU",
  ["linebreak"]="al",
  ["uccode"]=0x2CBE,
  ["unicodeslot"]=0x2CBF, -- ⲿ
 },
 [0x2CC0]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER SAMPI",
  ["lccode"]=0x2CC1,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CC0, -- Ⳁ
 },
 [0x2CC1]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER SAMPI",
  ["linebreak"]="al",
  ["uccode"]=0x2CC0,
  ["unicodeslot"]=0x2CC1, -- ⳁ
 },
 [0x2CC2]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER CROSSED SHEI",
  ["lccode"]=0x2CC3,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CC2, -- Ⳃ
 },
 [0x2CC3]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER CROSSED SHEI",
  ["linebreak"]="al",
  ["uccode"]=0x2CC2,
  ["unicodeslot"]=0x2CC3, -- ⳃ
 },
 [0x2CC4]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC SHEI",
  ["lccode"]=0x2CC5,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CC4, -- Ⳅ
 },
 [0x2CC5]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC SHEI",
  ["linebreak"]="al",
  ["uccode"]=0x2CC4,
  ["unicodeslot"]=0x2CC5, -- ⳅ
 },
 [0x2CC6]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC ESH",
  ["lccode"]=0x2CC7,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CC6, -- Ⳇ
 },
 [0x2CC7]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC ESH",
  ["linebreak"]="al",
  ["uccode"]=0x2CC6,
  ["unicodeslot"]=0x2CC7, -- ⳇ
 },
 [0x2CC8]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER AKHMIMIC KHEI",
  ["lccode"]=0x2CC9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CC8, -- Ⳉ
 },
 [0x2CC9]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER AKHMIMIC KHEI",
  ["linebreak"]="al",
  ["uccode"]=0x2CC8,
  ["unicodeslot"]=0x2CC9, -- ⳉ
 },
 [0x2CCA]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER DIALECT-P HORI",
  ["lccode"]=0x2CCB,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CCA, -- Ⳋ
 },
 [0x2CCB]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER DIALECT-P HORI",
  ["linebreak"]="al",
  ["uccode"]=0x2CCA,
  ["unicodeslot"]=0x2CCB, -- ⳋ
 },
 [0x2CCC]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC HORI",
  ["lccode"]=0x2CCD,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CCC, -- Ⳍ
 },
 [0x2CCD]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC HORI",
  ["linebreak"]="al",
  ["uccode"]=0x2CCC,
  ["unicodeslot"]=0x2CCD, -- ⳍ
 },
 [0x2CCE]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC HA",
  ["lccode"]=0x2CCF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CCE, -- Ⳏ
 },
 [0x2CCF]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC HA",
  ["linebreak"]="al",
  ["uccode"]=0x2CCE,
  ["unicodeslot"]=0x2CCF, -- ⳏ
 },
 [0x2CD0]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER L-SHAPED HA",
  ["lccode"]=0x2CD1,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CD0, -- Ⳑ
 },
 [0x2CD1]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER L-SHAPED HA",
  ["linebreak"]="al",
  ["uccode"]=0x2CD0,
  ["unicodeslot"]=0x2CD1, -- ⳑ
 },
 [0x2CD2]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC HEI",
  ["lccode"]=0x2CD3,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CD2, -- Ⳓ
 },
 [0x2CD3]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC HEI",
  ["linebreak"]="al",
  ["uccode"]=0x2CD2,
  ["unicodeslot"]=0x2CD3, -- ⳓ
 },
 [0x2CD4]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC HAT",
  ["lccode"]=0x2CD5,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CD4, -- Ⳕ
 },
 [0x2CD5]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC HAT",
  ["linebreak"]="al",
  ["uccode"]=0x2CD4,
  ["unicodeslot"]=0x2CD5, -- ⳕ
 },
 [0x2CD6]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC GANGIA",
  ["lccode"]=0x2CD7,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CD6, -- Ⳗ
 },
 [0x2CD7]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC GANGIA",
  ["linebreak"]="al",
  ["uccode"]=0x2CD6,
  ["unicodeslot"]=0x2CD7, -- ⳗ
 },
 [0x2CD8]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC DJA",
  ["lccode"]=0x2CD9,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CD8, -- Ⳙ
 },
 [0x2CD9]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC DJA",
  ["linebreak"]="al",
  ["uccode"]=0x2CD8,
  ["unicodeslot"]=0x2CD9, -- ⳙ
 },
 [0x2CDA]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD COPTIC SHIMA",
  ["lccode"]=0x2CDB,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CDA, -- Ⳛ
 },
 [0x2CDB]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD COPTIC SHIMA",
  ["linebreak"]="al",
  ["uccode"]=0x2CDA,
  ["unicodeslot"]=0x2CDB, -- ⳛ
 },
 [0x2CDC]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD NUBIAN SHIMA",
  ["lccode"]=0x2CDD,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CDC, -- Ⳝ
 },
 [0x2CDD]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD NUBIAN SHIMA",
  ["linebreak"]="al",
  ["uccode"]=0x2CDC,
  ["unicodeslot"]=0x2CDD, -- ⳝ
 },
 [0x2CDE]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD NUBIAN NGI",
  ["lccode"]=0x2CDF,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CDE, -- Ⳟ
 },
 [0x2CDF]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD NUBIAN NGI",
  ["linebreak"]="al",
  ["uccode"]=0x2CDE,
  ["unicodeslot"]=0x2CDF, -- ⳟ
 },
 [0x2CE0]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD NUBIAN NYI",
  ["lccode"]=0x2CE1,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CE0, -- Ⳡ
 },
 [0x2CE1]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD NUBIAN NYI",
  ["linebreak"]="al",
  ["uccode"]=0x2CE0,
  ["unicodeslot"]=0x2CE1, -- ⳡ
 },
 [0x2CE2]={
  ["category"]="lu",
  ["description"]="COPTIC CAPITAL LETTER OLD NUBIAN WAU",
  ["lccode"]=0x2CE3,
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CE2, -- Ⳣ
 },
 [0x2CE3]={
  ["category"]="ll",
  ["description"]="COPTIC SMALL LETTER OLD NUBIAN WAU",
  ["linebreak"]="al",
  ["uccode"]=0x2CE2,
  ["unicodeslot"]=0x2CE3, -- ⳣ
 },
 [0x2CE4]={
  ["category"]="ll",
  ["description"]="COPTIC SYMBOL KAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CE4, -- ⳤ
 },
 [0x2CE5]={
  ["category"]="so",
  ["description"]="COPTIC SYMBOL MI RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CE5, -- ⳥
 },
 [0x2CE6]={
  ["category"]="so",
  ["description"]="COPTIC SYMBOL PI RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CE6, -- ⳦
 },
 [0x2CE7]={
  ["category"]="so",
  ["description"]="COPTIC SYMBOL STAUROS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CE7, -- ⳧
 },
 [0x2CE8]={
  ["category"]="so",
  ["description"]="COPTIC SYMBOL TAU RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CE8, -- ⳨
 },
 [0x2CE9]={
  ["category"]="so",
  ["description"]="COPTIC SYMBOL KHI RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CE9, -- ⳩
 },
 [0x2CEA]={
  ["category"]="so",
  ["description"]="COPTIC SYMBOL SHIMA SIMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CEA, -- ⳪
 },
 [0x2CF9]={
  ["category"]="po",
  ["description"]="COPTIC OLD NUBIAN FULL STOP",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2CF9, -- ⳹
 },
 [0x2CFA]={
  ["category"]="po",
  ["description"]="COPTIC OLD NUBIAN DIRECT QUESTION MARK",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2CFA, -- ⳺
 },
 [0x2CFB]={
  ["category"]="po",
  ["description"]="COPTIC OLD NUBIAN INDIRECT QUESTION MARK",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2CFB, -- ⳻
 },
 [0x2CFC]={
  ["category"]="po",
  ["description"]="COPTIC OLD NUBIAN VERSE DIVIDER",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2CFC, -- ⳼
 },
 [0x2CFD]={
  ["category"]="no",
  ["description"]="COPTIC FRACTION ONE HALF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2CFD, -- ⳽
 },
 [0x2CFE]={
  ["category"]="po",
  ["description"]="COPTIC FULL STOP",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2CFE, -- ⳾
 },
 [0x2CFF]={
  ["category"]="po",
  ["description"]="COPTIC MORPHOLOGICAL DIVIDER",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2CFF, -- ⳿
 },
 [0x2D00]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER AN",
  ["linebreak"]="al",
  ["uccode"]=0x10A0,
  ["unicodeslot"]=0x2D00, -- ⴀ
 },
 [0x2D01]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER BAN",
  ["linebreak"]="al",
  ["uccode"]=0x10A1,
  ["unicodeslot"]=0x2D01, -- ⴁ
 },
 [0x2D02]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER GAN",
  ["linebreak"]="al",
  ["uccode"]=0x10A2,
  ["unicodeslot"]=0x2D02, -- ⴂ
 },
 [0x2D03]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER DON",
  ["linebreak"]="al",
  ["uccode"]=0x10A3,
  ["unicodeslot"]=0x2D03, -- ⴃ
 },
 [0x2D04]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER EN",
  ["linebreak"]="al",
  ["uccode"]=0x10A4,
  ["unicodeslot"]=0x2D04, -- ⴄ
 },
 [0x2D05]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER VIN",
  ["linebreak"]="al",
  ["uccode"]=0x10A5,
  ["unicodeslot"]=0x2D05, -- ⴅ
 },
 [0x2D06]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER ZEN",
  ["linebreak"]="al",
  ["uccode"]=0x10A6,
  ["unicodeslot"]=0x2D06, -- ⴆ
 },
 [0x2D07]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER TAN",
  ["linebreak"]="al",
  ["uccode"]=0x10A7,
  ["unicodeslot"]=0x2D07, -- ⴇ
 },
 [0x2D08]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER IN",
  ["linebreak"]="al",
  ["uccode"]=0x10A8,
  ["unicodeslot"]=0x2D08, -- ⴈ
 },
 [0x2D09]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER KAN",
  ["linebreak"]="al",
  ["uccode"]=0x10A9,
  ["unicodeslot"]=0x2D09, -- ⴉ
 },
 [0x2D0A]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER LAS",
  ["linebreak"]="al",
  ["uccode"]=0x10AA,
  ["unicodeslot"]=0x2D0A, -- ⴊ
 },
 [0x2D0B]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER MAN",
  ["linebreak"]="al",
  ["uccode"]=0x10AB,
  ["unicodeslot"]=0x2D0B, -- ⴋ
 },
 [0x2D0C]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER NAR",
  ["linebreak"]="al",
  ["uccode"]=0x10AC,
  ["unicodeslot"]=0x2D0C, -- ⴌ
 },
 [0x2D0D]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER ON",
  ["linebreak"]="al",
  ["uccode"]=0x10AD,
  ["unicodeslot"]=0x2D0D, -- ⴍ
 },
 [0x2D0E]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER PAR",
  ["linebreak"]="al",
  ["uccode"]=0x10AE,
  ["unicodeslot"]=0x2D0E, -- ⴎ
 },
 [0x2D0F]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER ZHAR",
  ["linebreak"]="al",
  ["uccode"]=0x10AF,
  ["unicodeslot"]=0x2D0F, -- ⴏ
 },
 [0x2D10]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER RAE",
  ["linebreak"]="al",
  ["uccode"]=0x10B0,
  ["unicodeslot"]=0x2D10, -- ⴐ
 },
 [0x2D11]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER SAN",
  ["linebreak"]="al",
  ["uccode"]=0x10B1,
  ["unicodeslot"]=0x2D11, -- ⴑ
 },
 [0x2D12]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER TAR",
  ["linebreak"]="al",
  ["uccode"]=0x10B2,
  ["unicodeslot"]=0x2D12, -- ⴒ
 },
 [0x2D13]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER UN",
  ["linebreak"]="al",
  ["uccode"]=0x10B3,
  ["unicodeslot"]=0x2D13, -- ⴓ
 },
 [0x2D14]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER PHAR",
  ["linebreak"]="al",
  ["uccode"]=0x10B4,
  ["unicodeslot"]=0x2D14, -- ⴔ
 },
 [0x2D15]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER KHAR",
  ["linebreak"]="al",
  ["uccode"]=0x10B5,
  ["unicodeslot"]=0x2D15, -- ⴕ
 },
 [0x2D16]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER GHAN",
  ["linebreak"]="al",
  ["uccode"]=0x10B6,
  ["unicodeslot"]=0x2D16, -- ⴖ
 },
 [0x2D17]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER QAR",
  ["linebreak"]="al",
  ["uccode"]=0x10B7,
  ["unicodeslot"]=0x2D17, -- ⴗ
 },
 [0x2D18]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER SHIN",
  ["linebreak"]="al",
  ["uccode"]=0x10B8,
  ["unicodeslot"]=0x2D18, -- ⴘ
 },
 [0x2D19]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER CHIN",
  ["linebreak"]="al",
  ["uccode"]=0x10B9,
  ["unicodeslot"]=0x2D19, -- ⴙ
 },
 [0x2D1A]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER CAN",
  ["linebreak"]="al",
  ["uccode"]=0x10BA,
  ["unicodeslot"]=0x2D1A, -- ⴚ
 },
 [0x2D1B]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER JIL",
  ["linebreak"]="al",
  ["uccode"]=0x10BB,
  ["unicodeslot"]=0x2D1B, -- ⴛ
 },
 [0x2D1C]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER CIL",
  ["linebreak"]="al",
  ["uccode"]=0x10BC,
  ["unicodeslot"]=0x2D1C, -- ⴜ
 },
 [0x2D1D]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER CHAR",
  ["linebreak"]="al",
  ["uccode"]=0x10BD,
  ["unicodeslot"]=0x2D1D, -- ⴝ
 },
 [0x2D1E]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER XAN",
  ["linebreak"]="al",
  ["uccode"]=0x10BE,
  ["unicodeslot"]=0x2D1E, -- ⴞ
 },
 [0x2D1F]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER JHAN",
  ["linebreak"]="al",
  ["uccode"]=0x10BF,
  ["unicodeslot"]=0x2D1F, -- ⴟ
 },
 [0x2D20]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER HAE",
  ["linebreak"]="al",
  ["uccode"]=0x10C0,
  ["unicodeslot"]=0x2D20, -- ⴠ
 },
 [0x2D21]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER HE",
  ["linebreak"]="al",
  ["uccode"]=0x10C1,
  ["unicodeslot"]=0x2D21, -- ⴡ
 },
 [0x2D22]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER HIE",
  ["linebreak"]="al",
  ["uccode"]=0x10C2,
  ["unicodeslot"]=0x2D22, -- ⴢ
 },
 [0x2D23]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER WE",
  ["linebreak"]="al",
  ["uccode"]=0x10C3,
  ["unicodeslot"]=0x2D23, -- ⴣ
 },
 [0x2D24]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER HAR",
  ["linebreak"]="al",
  ["uccode"]=0x10C4,
  ["unicodeslot"]=0x2D24, -- ⴤ
 },
 [0x2D25]={
  ["category"]="ll",
  ["description"]="GEORGIAN SMALL LETTER HOE",
  ["linebreak"]="al",
  ["uccode"]=0x10C5,
  ["unicodeslot"]=0x2D25, -- ⴥ
 },
 [0x2D30]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D30, -- ⴰ
 },
 [0x2D31]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D31, -- ⴱ
 },
 [0x2D32]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YABH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D32, -- ⴲ
 },
 [0x2D33]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D33, -- ⴳ
 },
 [0x2D34]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAGHH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D34, -- ⴴ
 },
 [0x2D35]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER BERBER ACADEMY YAJ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D35, -- ⴵ
 },
 [0x2D36]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAJ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D36, -- ⴶ
 },
 [0x2D37]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D37, -- ⴷ
 },
 [0x2D38]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YADH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D38, -- ⴸ
 },
 [0x2D39]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YADD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D39, -- ⴹ
 },
 [0x2D3A]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YADDH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D3A, -- ⴺ
 },
 [0x2D3B]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YEY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D3B, -- ⴻ
 },
 [0x2D3C]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D3C, -- ⴼ
 },
 [0x2D3D]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D3D, -- ⴽ
 },
 [0x2D3E]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER TUAREG YAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D3E, -- ⴾ
 },
 [0x2D3F]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAKHH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D3F, -- ⴿ
 },
 [0x2D40]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D40, -- ⵀ
 },
 [0x2D41]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER BERBER ACADEMY YAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D41, -- ⵁ
 },
 [0x2D42]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER TUAREG YAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D42, -- ⵂ
 },
 [0x2D43]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAHH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D43, -- ⵃ
 },
 [0x2D44]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D44, -- ⵄ
 },
 [0x2D45]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAKH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D45, -- ⵅ
 },
 [0x2D46]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER TUAREG YAKH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D46, -- ⵆ
 },
 [0x2D47]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAQ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D47, -- ⵇ
 },
 [0x2D48]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER TUAREG YAQ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D48, -- ⵈ
 },
 [0x2D49]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D49, -- ⵉ
 },
 [0x2D4A]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAZH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D4A, -- ⵊ
 },
 [0x2D4B]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER AHAGGAR YAZH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D4B, -- ⵋ
 },
 [0x2D4C]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER TUAREG YAZH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D4C, -- ⵌ
 },
 [0x2D4D]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D4D, -- ⵍ
 },
 [0x2D4E]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D4E, -- ⵎ
 },
 [0x2D4F]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D4F, -- ⵏ
 },
 [0x2D50]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER TUAREG YAGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D50, -- ⵐ
 },
 [0x2D51]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER TUAREG YANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D51, -- ⵑ
 },
 [0x2D52]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D52, -- ⵒ
 },
 [0x2D53]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D53, -- ⵓ
 },
 [0x2D54]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D54, -- ⵔ
 },
 [0x2D55]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YARR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D55, -- ⵕ
 },
 [0x2D56]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAGH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D56, -- ⵖ
 },
 [0x2D57]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER TUAREG YAGH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D57, -- ⵗ
 },
 [0x2D58]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER AYER YAGH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D58, -- ⵘ
 },
 [0x2D59]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D59, -- ⵙ
 },
 [0x2D5A]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YASS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D5A, -- ⵚ
 },
 [0x2D5B]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D5B, -- ⵛ
 },
 [0x2D5C]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D5C, -- ⵜ
 },
 [0x2D5D]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YATH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D5D, -- ⵝ
 },
 [0x2D5E]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YACH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D5E, -- ⵞ
 },
 [0x2D5F]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YATT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D5F, -- ⵟ
 },
 [0x2D60]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAV",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D60, -- ⵠ
 },
 [0x2D61]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D61, -- ⵡ
 },
 [0x2D62]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D62, -- ⵢ
 },
 [0x2D63]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAZ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D63, -- ⵣ
 },
 [0x2D64]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER TAWELLEMET YAZ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D64, -- ⵤ
 },
 [0x2D65]={
  ["category"]="lo",
  ["description"]="TIFINAGH LETTER YAZZ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D65, -- ⵥ
 },
 [0x2D6F]={
  ["category"]="lm",
  ["description"]="TIFINAGH MODIFIER LETTER LABIALIZATION MARK",
  ["linebreak"]="al",
  ["specials"]={ "super", 0x2D61 },
  ["unicodeslot"]=0x2D6F, -- ⵯ
 },
 [0x2D80]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE LOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D80, -- ⶀ
 },
 [0x2D81]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE MOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D81, -- ⶁ
 },
 [0x2D82]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ROA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D82, -- ⶂ
 },
 [0x2D83]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D83, -- ⶃ
 },
 [0x2D84]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SHOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D84, -- ⶄ
 },
 [0x2D85]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE BOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D85, -- ⶅ
 },
 [0x2D86]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE TOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D86, -- ⶆ
 },
 [0x2D87]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE COA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D87, -- ⶇ
 },
 [0x2D88]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D88, -- ⶈ
 },
 [0x2D89]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE NYOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D89, -- ⶉ
 },
 [0x2D8A]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GLOTTAL OA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D8A, -- ⶊ
 },
 [0x2D8B]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D8B, -- ⶋ
 },
 [0x2D8C]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D8C, -- ⶌ
 },
 [0x2D8D]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE DDOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D8D, -- ⶍ
 },
 [0x2D8E]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE JOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D8E, -- ⶎ
 },
 [0x2D8F]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE THOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D8F, -- ⶏ
 },
 [0x2D90]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CHOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D90, -- ⶐ
 },
 [0x2D91]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE PHOA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D91, -- ⶑ
 },
 [0x2D92]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE POA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D92, -- ⶒ
 },
 [0x2D93]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D93, -- ⶓ
 },
 [0x2D94]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGWI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D94, -- ⶔ
 },
 [0x2D95]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGWEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D95, -- ⶕ
 },
 [0x2D96]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GGWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2D96, -- ⶖ
 },
 [0x2DA0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DA0, -- ⶠ
 },
 [0x2DA1]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SSU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DA1, -- ⶡ
 },
 [0x2DA2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SSI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DA2, -- ⶢ
 },
 [0x2DA3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SSAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DA3, -- ⶣ
 },
 [0x2DA4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SSEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DA4, -- ⶤ
 },
 [0x2DA5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SSE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DA5, -- ⶥ
 },
 [0x2DA6]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE SSO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DA6, -- ⶦ
 },
 [0x2DA8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DA8, -- ⶨ
 },
 [0x2DA9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DA9, -- ⶩ
 },
 [0x2DAA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DAA, -- ⶪ
 },
 [0x2DAB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DAB, -- ⶫ
 },
 [0x2DAC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DAC, -- ⶬ
 },
 [0x2DAD]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DAD, -- ⶭ
 },
 [0x2DAE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DAE, -- ⶮ
 },
 [0x2DB0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DB0, -- ⶰ
 },
 [0x2DB1]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZZU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DB1, -- ⶱ
 },
 [0x2DB2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZZI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DB2, -- ⶲ
 },
 [0x2DB3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZZAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DB3, -- ⶳ
 },
 [0x2DB4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZZEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DB4, -- ⶴ
 },
 [0x2DB5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DB5, -- ⶵ
 },
 [0x2DB6]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE ZZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DB6, -- ⶶ
 },
 [0x2DB8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DB8, -- ⶸ
 },
 [0x2DB9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DB9, -- ⶹ
 },
 [0x2DBA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DBA, -- ⶺ
 },
 [0x2DBB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCHAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DBB, -- ⶻ
 },
 [0x2DBC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCHEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DBC, -- ⶼ
 },
 [0x2DBD]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DBD, -- ⶽ
 },
 [0x2DBE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE CCHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DBE, -- ⶾ
 },
 [0x2DC0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DC0, -- ⷀ
 },
 [0x2DC1]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QYU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DC1, -- ⷁ
 },
 [0x2DC2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QYI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DC2, -- ⷂ
 },
 [0x2DC3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QYAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DC3, -- ⷃ
 },
 [0x2DC4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QYEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DC4, -- ⷄ
 },
 [0x2DC5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QYE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DC5, -- ⷅ
 },
 [0x2DC6]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE QYO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DC6, -- ⷆ
 },
 [0x2DC8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DC8, -- ⷈ
 },
 [0x2DC9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KYU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DC9, -- ⷉ
 },
 [0x2DCA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KYI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DCA, -- ⷊ
 },
 [0x2DCB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KYAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DCB, -- ⷋ
 },
 [0x2DCC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KYEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DCC, -- ⷌ
 },
 [0x2DCD]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KYE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DCD, -- ⷍ
 },
 [0x2DCE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE KYO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DCE, -- ⷎ
 },
 [0x2DD0]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DD0, -- ⷐ
 },
 [0x2DD1]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XYU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DD1, -- ⷑ
 },
 [0x2DD2]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XYI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DD2, -- ⷒ
 },
 [0x2DD3]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XYAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DD3, -- ⷓ
 },
 [0x2DD4]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XYEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DD4, -- ⷔ
 },
 [0x2DD5]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XYE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DD5, -- ⷕ
 },
 [0x2DD6]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE XYO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DD6, -- ⷖ
 },
 [0x2DD8]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DD8, -- ⷘ
 },
 [0x2DD9]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GYU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DD9, -- ⷙ
 },
 [0x2DDA]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GYI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DDA, -- ⷚ
 },
 [0x2DDB]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GYAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DDB, -- ⷛ
 },
 [0x2DDC]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GYEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DDC, -- ⷜ
 },
 [0x2DDD]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GYE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DDD, -- ⷝ
 },
 [0x2DDE]={
  ["category"]="lo",
  ["description"]="ETHIOPIC SYLLABLE GYO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2DDE, -- ⷞ
 },
 [0x2E00]={
  ["category"]="po",
  ["description"]="RIGHT ANGLE SUBSTITUTION MARKER",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E00, -- ⸀
 },
 [0x2E01]={
  ["category"]="po",
  ["description"]="RIGHT ANGLE DOTTED SUBSTITUTION MARKER",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E01, -- ⸁
 },
 [0x2E02]={
  ["category"]="pi",
  ["description"]="LEFT SUBSTITUTION BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E02, -- ⸂
 },
 [0x2E03]={
  ["category"]="pf",
  ["description"]="RIGHT SUBSTITUTION BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E03, -- ⸃
 },
 [0x2E04]={
  ["category"]="pi",
  ["description"]="LEFT DOTTED SUBSTITUTION BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E04, -- ⸄
 },
 [0x2E05]={
  ["category"]="pf",
  ["description"]="RIGHT DOTTED SUBSTITUTION BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E05, -- ⸅
 },
 [0x2E06]={
  ["category"]="po",
  ["description"]="RAISED INTERPOLATION MARKER",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E06, -- ⸆
 },
 [0x2E07]={
  ["category"]="po",
  ["description"]="RAISED DOTTED INTERPOLATION MARKER",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E07, -- ⸇
 },
 [0x2E08]={
  ["category"]="po",
  ["description"]="DOTTED TRANSPOSITION MARKER",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E08, -- ⸈
 },
 [0x2E09]={
  ["category"]="pi",
  ["description"]="LEFT TRANSPOSITION BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E09, -- ⸉
 },
 [0x2E0A]={
  ["category"]="pf",
  ["description"]="RIGHT TRANSPOSITION BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E0A, -- ⸊
 },
 [0x2E0B]={
  ["category"]="po",
  ["description"]="RAISED SQUARE",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E0B, -- ⸋
 },
 [0x2E0C]={
  ["category"]="pi",
  ["description"]="LEFT RAISED OMISSION BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E0C, -- ⸌
 },
 [0x2E0D]={
  ["category"]="pf",
  ["description"]="RIGHT RAISED OMISSION BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E0D, -- ⸍
 },
 [0x2E0E]={
  ["category"]="po",
  ["description"]="EDITORIAL CORONIS",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2E0E, -- ⸎
 },
 [0x2E0F]={
  ["category"]="po",
  ["description"]="PARAGRAPHOS",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2E0F, -- ⸏
 },
 [0x2E10]={
  ["category"]="po",
  ["description"]="FORKED PARAGRAPHOS",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2E10, -- ⸐
 },
 [0x2E11]={
  ["category"]="po",
  ["description"]="REVERSED FORKED PARAGRAPHOS",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2E11, -- ⸑
 },
 [0x2E12]={
  ["category"]="po",
  ["description"]="HYPODIASTOLE",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2E12, -- ⸒
 },
 [0x2E13]={
  ["category"]="po",
  ["description"]="DOTTED OBELOS",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2E13, -- ⸓
 },
 [0x2E14]={
  ["category"]="po",
  ["description"]="DOWNWARDS ANCORA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2E14, -- ⸔
 },
 [0x2E15]={
  ["category"]="po",
  ["description"]="UPWARDS ANCORA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2E15, -- ⸕
 },
 [0x2E16]={
  ["category"]="po",
  ["description"]="DOTTED RIGHT-POINTING ANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x2E16, -- ⸖
 },
 [0x2E17]={
  ["category"]="pd",
  ["description"]="DOUBLE OBLIQUE HYPHEN",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x2E17, -- ⸗
 },
 [0x2E1C]={
  ["category"]="pi",
  ["description"]="LEFT LOW PARAPHRASE BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E1C, -- ⸜
 },
 [0x2E1D]={
  ["category"]="pf",
  ["description"]="RIGHT LOW PARAPHRASE BRACKET",
  ["linebreak"]="qu",
  ["unicodeslot"]=0x2E1D, -- ⸝
 },
 [0x2E80]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL REPEAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E80, -- ⺀
 },
 [0x2E81]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL CLIFF",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E81, -- ⺁
 },
 [0x2E82]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SECOND ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E82, -- ⺂
 },
 [0x2E83]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SECOND TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E83, -- ⺃
 },
 [0x2E84]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SECOND THREE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E84, -- ⺄
 },
 [0x2E85]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL PERSON",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E85, -- ⺅
 },
 [0x2E86]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL BOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E86, -- ⺆
 },
 [0x2E87]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL TABLE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E87, -- ⺇
 },
 [0x2E88]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL KNIFE ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E88, -- ⺈
 },
 [0x2E89]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL KNIFE TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E89, -- ⺉
 },
 [0x2E8A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL DIVINATION",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E8A, -- ⺊
 },
 [0x2E8B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SEAL",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E8B, -- ⺋
 },
 [0x2E8C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SMALL ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E8C, -- ⺌
 },
 [0x2E8D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SMALL TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E8D, -- ⺍
 },
 [0x2E8E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL LAME ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E8E, -- ⺎
 },
 [0x2E8F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL LAME TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E8F, -- ⺏
 },
 [0x2E90]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL LAME THREE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E90, -- ⺐
 },
 [0x2E91]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL LAME FOUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E91, -- ⺑
 },
 [0x2E92]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SNAKE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E92, -- ⺒
 },
 [0x2E93]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL THREAD",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E93, -- ⺓
 },
 [0x2E94]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SNOUT ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E94, -- ⺔
 },
 [0x2E95]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SNOUT TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E95, -- ⺕
 },
 [0x2E96]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL HEART ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E96, -- ⺖
 },
 [0x2E97]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL HEART TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E97, -- ⺗
 },
 [0x2E98]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL HAND",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E98, -- ⺘
 },
 [0x2E99]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL RAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E99, -- ⺙
 },
 [0x2E9B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL CHOKE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E9B, -- ⺛
 },
 [0x2E9C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SUN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E9C, -- ⺜
 },
 [0x2E9D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL MOON",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E9D, -- ⺝
 },
 [0x2E9E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL DEATH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2E9E, -- ⺞
 },
 [0x2E9F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL MOTHER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6BCD },
  ["unicodeslot"]=0x2E9F, -- ⺟
 },
 [0x2EA0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL CIVILIAN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA0, -- ⺠
 },
 [0x2EA1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL WATER ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA1, -- ⺡
 },
 [0x2EA2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL WATER TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA2, -- ⺢
 },
 [0x2EA3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL FIRE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA3, -- ⺣
 },
 [0x2EA4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL PAW ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA4, -- ⺤
 },
 [0x2EA5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL PAW TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA5, -- ⺥
 },
 [0x2EA6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SIMPLIFIED HALF TREE TRUNK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA6, -- ⺦
 },
 [0x2EA7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL COW",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA7, -- ⺧
 },
 [0x2EA8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL DOG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA8, -- ⺨
 },
 [0x2EA9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL JADE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EA9, -- ⺩
 },
 [0x2EAA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL BOLT OF CLOTH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EAA, -- ⺪
 },
 [0x2EAB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL EYE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EAB, -- ⺫
 },
 [0x2EAC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SPIRIT ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EAC, -- ⺬
 },
 [0x2EAD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SPIRIT TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EAD, -- ⺭
 },
 [0x2EAE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL BAMBOO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EAE, -- ⺮
 },
 [0x2EAF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SILK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EAF, -- ⺯
 },
 [0x2EB0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED SILK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB0, -- ⺰
 },
 [0x2EB1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL NET ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB1, -- ⺱
 },
 [0x2EB2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL NET TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB2, -- ⺲
 },
 [0x2EB3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL NET THREE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB3, -- ⺳
 },
 [0x2EB4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL NET FOUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB4, -- ⺴
 },
 [0x2EB5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL MESH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB5, -- ⺵
 },
 [0x2EB6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SHEEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB6, -- ⺶
 },
 [0x2EB7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL RAM",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB7, -- ⺷
 },
 [0x2EB8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL EWE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB8, -- ⺸
 },
 [0x2EB9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL OLD",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EB9, -- ⺹
 },
 [0x2EBA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL BRUSH ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EBA, -- ⺺
 },
 [0x2EBB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL BRUSH TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EBB, -- ⺻
 },
 [0x2EBC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL MEAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EBC, -- ⺼
 },
 [0x2EBD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL MORTAR",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EBD, -- ⺽
 },
 [0x2EBE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL GRASS ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EBE, -- ⺾
 },
 [0x2EBF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL GRASS TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EBF, -- ⺿
 },
 [0x2EC0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL GRASS THREE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC0, -- ⻀
 },
 [0x2EC1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL TIGER",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC1, -- ⻁
 },
 [0x2EC2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL CLOTHES",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC2, -- ⻂
 },
 [0x2EC3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL WEST ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC3, -- ⻃
 },
 [0x2EC4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL WEST TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC4, -- ⻄
 },
 [0x2EC5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED SEE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC5, -- ⻅
 },
 [0x2EC6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SIMPLIFIED HORN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC6, -- ⻆
 },
 [0x2EC7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL HORN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC7, -- ⻇
 },
 [0x2EC8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED SPEECH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC8, -- ⻈
 },
 [0x2EC9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED SHELL",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EC9, -- ⻉
 },
 [0x2ECA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL FOOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ECA, -- ⻊
 },
 [0x2ECB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED CART",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ECB, -- ⻋
 },
 [0x2ECC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SIMPLIFIED WALK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ECC, -- ⻌
 },
 [0x2ECD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL WALK ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ECD, -- ⻍
 },
 [0x2ECE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL WALK TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ECE, -- ⻎
 },
 [0x2ECF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL CITY",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ECF, -- ⻏
 },
 [0x2ED0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED GOLD",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED0, -- ⻐
 },
 [0x2ED1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL LONG ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED1, -- ⻑
 },
 [0x2ED2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL LONG TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED2, -- ⻒
 },
 [0x2ED3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED LONG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED3, -- ⻓
 },
 [0x2ED4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED GATE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED4, -- ⻔
 },
 [0x2ED5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL MOUND ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED5, -- ⻕
 },
 [0x2ED6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL MOUND TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED6, -- ⻖
 },
 [0x2ED7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL RAIN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED7, -- ⻗
 },
 [0x2ED8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL BLUE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED8, -- ⻘
 },
 [0x2ED9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED TANNED LEATHER",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2ED9, -- ⻙
 },
 [0x2EDA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED LEAF",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EDA, -- ⻚
 },
 [0x2EDB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED WIND",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EDB, -- ⻛
 },
 [0x2EDC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED FLY",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EDC, -- ⻜
 },
 [0x2EDD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL EAT ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EDD, -- ⻝
 },
 [0x2EDE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL EAT TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EDE, -- ⻞
 },
 [0x2EDF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL EAT THREE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EDF, -- ⻟
 },
 [0x2EE0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED EAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE0, -- ⻠
 },
 [0x2EE1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL HEAD",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE1, -- ⻡
 },
 [0x2EE2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED HORSE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE2, -- ⻢
 },
 [0x2EE3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL BONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE3, -- ⻣
 },
 [0x2EE4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL GHOST",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE4, -- ⻤
 },
 [0x2EE5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED FISH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE5, -- ⻥
 },
 [0x2EE6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED BIRD",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE6, -- ⻦
 },
 [0x2EE7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED SALT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE7, -- ⻧
 },
 [0x2EE8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SIMPLIFIED WHEAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE8, -- ⻨
 },
 [0x2EE9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL SIMPLIFIED YELLOW",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EE9, -- ⻩
 },
 [0x2EEA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED FROG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EEA, -- ⻪
 },
 [0x2EEB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL J-SIMPLIFIED EVEN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EEB, -- ⻫
 },
 [0x2EEC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED EVEN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EEC, -- ⻬
 },
 [0x2EED]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL J-SIMPLIFIED TOOTH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EED, -- ⻭
 },
 [0x2EEE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED TOOTH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EEE, -- ⻮
 },
 [0x2EEF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL J-SIMPLIFIED DRAGON",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EEF, -- ⻯
 },
 [0x2EF0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED DRAGON",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EF0, -- ⻰
 },
 [0x2EF1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL TURTLE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EF1, -- ⻱
 },
 [0x2EF2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL J-SIMPLIFIED TURTLE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2EF2, -- ⻲
 },
 [0x2EF3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK RADICAL C-SIMPLIFIED TURTLE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9F9F },
  ["unicodeslot"]=0x2EF3, -- ⻳
 },
 [0x2F00]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL ONE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x4E00 },
  ["unicodeslot"]=0x2F00, -- ⼀
 },
 [0x2F01]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x4E28 },
  ["unicodeslot"]=0x2F01, -- ⼁
 },
 [0x2F02]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DOT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x4E36 },
  ["unicodeslot"]=0x2F02, -- ⼂
 },
 [0x2F03]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SLASH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x4E3F },
  ["unicodeslot"]=0x2F03, -- ⼃
 },
 [0x2F04]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SECOND",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x4E59 },
  ["unicodeslot"]=0x2F04, -- ⼄
 },
 [0x2F05]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HOOK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x4E85 },
  ["unicodeslot"]=0x2F05, -- ⼅
 },
 [0x2F06]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TWO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x4E8C },
  ["unicodeslot"]=0x2F06, -- ⼆
 },
 [0x2F07]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LID",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x4EA0 },
  ["unicodeslot"]=0x2F07, -- ⼇
 },
 [0x2F08]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MAN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x4EBA },
  ["unicodeslot"]=0x2F08, -- ⼈
 },
 [0x2F09]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LEGS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x513F },
  ["unicodeslot"]=0x2F09, -- ⼉
 },
 [0x2F0A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL ENTER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5165 },
  ["unicodeslot"]=0x2F0A, -- ⼊
 },
 [0x2F0B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x516B },
  ["unicodeslot"]=0x2F0B, -- ⼋
 },
 [0x2F0C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DOWN BOX",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5182 },
  ["unicodeslot"]=0x2F0C, -- ⼌
 },
 [0x2F0D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL COVER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5196 },
  ["unicodeslot"]=0x2F0D, -- ⼍
 },
 [0x2F0E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL ICE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x51AB },
  ["unicodeslot"]=0x2F0E, -- ⼎
 },
 [0x2F0F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TABLE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x51E0 },
  ["unicodeslot"]=0x2F0F, -- ⼏
 },
 [0x2F10]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL OPEN BOX",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x51F5 },
  ["unicodeslot"]=0x2F10, -- ⼐
 },
 [0x2F11]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL KNIFE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5200 },
  ["unicodeslot"]=0x2F11, -- ⼑
 },
 [0x2F12]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL POWER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x529B },
  ["unicodeslot"]=0x2F12, -- ⼒
 },
 [0x2F13]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WRAP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x52F9 },
  ["unicodeslot"]=0x2F13, -- ⼓
 },
 [0x2F14]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SPOON",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5315 },
  ["unicodeslot"]=0x2F14, -- ⼔
 },
 [0x2F15]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL RIGHT OPEN BOX",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x531A },
  ["unicodeslot"]=0x2F15, -- ⼕
 },
 [0x2F16]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HIDING ENCLOSURE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5338 },
  ["unicodeslot"]=0x2F16, -- ⼖
 },
 [0x2F17]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5341 },
  ["unicodeslot"]=0x2F17, -- ⼗
 },
 [0x2F18]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DIVINATION",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x535C },
  ["unicodeslot"]=0x2F18, -- ⼘
 },
 [0x2F19]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SEAL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5369 },
  ["unicodeslot"]=0x2F19, -- ⼙
 },
 [0x2F1A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CLIFF",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5382 },
  ["unicodeslot"]=0x2F1A, -- ⼚
 },
 [0x2F1B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL PRIVATE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x53B6 },
  ["unicodeslot"]=0x2F1B, -- ⼛
 },
 [0x2F1C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL AGAIN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x53C8 },
  ["unicodeslot"]=0x2F1C, -- ⼜
 },
 [0x2F1D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MOUTH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x53E3 },
  ["unicodeslot"]=0x2F1D, -- ⼝
 },
 [0x2F1E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL ENCLOSURE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x56D7 },
  ["unicodeslot"]=0x2F1E, -- ⼞
 },
 [0x2F1F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL EARTH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x571F },
  ["unicodeslot"]=0x2F1F, -- ⼟
 },
 [0x2F20]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SCHOLAR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x58EB },
  ["unicodeslot"]=0x2F20, -- ⼠
 },
 [0x2F21]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL GO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5902 },
  ["unicodeslot"]=0x2F21, -- ⼡
 },
 [0x2F22]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL GO SLOWLY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x590A },
  ["unicodeslot"]=0x2F22, -- ⼢
 },
 [0x2F23]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL EVENING",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5915 },
  ["unicodeslot"]=0x2F23, -- ⼣
 },
 [0x2F24]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BIG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5927 },
  ["unicodeslot"]=0x2F24, -- ⼤
 },
 [0x2F25]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WOMAN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5973 },
  ["unicodeslot"]=0x2F25, -- ⼥
 },
 [0x2F26]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CHILD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5B50 },
  ["unicodeslot"]=0x2F26, -- ⼦
 },
 [0x2F27]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL ROOF",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5B80 },
  ["unicodeslot"]=0x2F27, -- ⼧
 },
 [0x2F28]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL INCH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5BF8 },
  ["unicodeslot"]=0x2F28, -- ⼨
 },
 [0x2F29]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SMALL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5C0F },
  ["unicodeslot"]=0x2F29, -- ⼩
 },
 [0x2F2A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LAME",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5C22 },
  ["unicodeslot"]=0x2F2A, -- ⼪
 },
 [0x2F2B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CORPSE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5C38 },
  ["unicodeslot"]=0x2F2B, -- ⼫
 },
 [0x2F2C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SPROUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5C6E },
  ["unicodeslot"]=0x2F2C, -- ⼬
 },
 [0x2F2D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MOUNTAIN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5C71 },
  ["unicodeslot"]=0x2F2D, -- ⼭
 },
 [0x2F2E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL RIVER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5DDB },
  ["unicodeslot"]=0x2F2E, -- ⼮
 },
 [0x2F2F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WORK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5DE5 },
  ["unicodeslot"]=0x2F2F, -- ⼯
 },
 [0x2F30]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL ONESELF",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5DF1 },
  ["unicodeslot"]=0x2F30, -- ⼰
 },
 [0x2F31]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TURBAN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5DFE },
  ["unicodeslot"]=0x2F31, -- ⼱
 },
 [0x2F32]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DRY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5E72 },
  ["unicodeslot"]=0x2F32, -- ⼲
 },
 [0x2F33]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SHORT THREAD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5E7A },
  ["unicodeslot"]=0x2F33, -- ⼳
 },
 [0x2F34]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DOTTED CLIFF",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5E7F },
  ["unicodeslot"]=0x2F34, -- ⼴
 },
 [0x2F35]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LONG STRIDE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5EF4 },
  ["unicodeslot"]=0x2F35, -- ⼵
 },
 [0x2F36]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TWO HANDS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5EFE },
  ["unicodeslot"]=0x2F36, -- ⼶
 },
 [0x2F37]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SHOOT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5F0B },
  ["unicodeslot"]=0x2F37, -- ⼷
 },
 [0x2F38]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BOW",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5F13 },
  ["unicodeslot"]=0x2F38, -- ⼸
 },
 [0x2F39]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SNOUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5F50 },
  ["unicodeslot"]=0x2F39, -- ⼹
 },
 [0x2F3A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BRISTLE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5F61 },
  ["unicodeslot"]=0x2F3A, -- ⼺
 },
 [0x2F3B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL STEP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5F73 },
  ["unicodeslot"]=0x2F3B, -- ⼻
 },
 [0x2F3C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HEART",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5FC3 },
  ["unicodeslot"]=0x2F3C, -- ⼼
 },
 [0x2F3D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HALBERD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6208 },
  ["unicodeslot"]=0x2F3D, -- ⼽
 },
 [0x2F3E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DOOR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6236 },
  ["unicodeslot"]=0x2F3E, -- ⼾
 },
 [0x2F3F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HAND",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x624B },
  ["unicodeslot"]=0x2F3F, -- ⼿
 },
 [0x2F40]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BRANCH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x652F },
  ["unicodeslot"]=0x2F40, -- ⽀
 },
 [0x2F41]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL RAP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6534 },
  ["unicodeslot"]=0x2F41, -- ⽁
 },
 [0x2F42]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SCRIPT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6587 },
  ["unicodeslot"]=0x2F42, -- ⽂
 },
 [0x2F43]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DIPPER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6597 },
  ["unicodeslot"]=0x2F43, -- ⽃
 },
 [0x2F44]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL AXE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x65A4 },
  ["unicodeslot"]=0x2F44, -- ⽄
 },
 [0x2F45]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SQUARE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x65B9 },
  ["unicodeslot"]=0x2F45, -- ⽅
 },
 [0x2F46]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL NOT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x65E0 },
  ["unicodeslot"]=0x2F46, -- ⽆
 },
 [0x2F47]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SUN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x65E5 },
  ["unicodeslot"]=0x2F47, -- ⽇
 },
 [0x2F48]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SAY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x66F0 },
  ["unicodeslot"]=0x2F48, -- ⽈
 },
 [0x2F49]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MOON",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6708 },
  ["unicodeslot"]=0x2F49, -- ⽉
 },
 [0x2F4A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TREE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6728 },
  ["unicodeslot"]=0x2F4A, -- ⽊
 },
 [0x2F4B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LACK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6B20 },
  ["unicodeslot"]=0x2F4B, -- ⽋
 },
 [0x2F4C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL STOP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6B62 },
  ["unicodeslot"]=0x2F4C, -- ⽌
 },
 [0x2F4D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DEATH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6B79 },
  ["unicodeslot"]=0x2F4D, -- ⽍
 },
 [0x2F4E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WEAPON",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6BB3 },
  ["unicodeslot"]=0x2F4E, -- ⽎
 },
 [0x2F4F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DO NOT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6BCB },
  ["unicodeslot"]=0x2F4F, -- ⽏
 },
 [0x2F50]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL COMPARE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6BD4 },
  ["unicodeslot"]=0x2F50, -- ⽐
 },
 [0x2F51]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FUR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6BDB },
  ["unicodeslot"]=0x2F51, -- ⽑
 },
 [0x2F52]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CLAN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6C0F },
  ["unicodeslot"]=0x2F52, -- ⽒
 },
 [0x2F53]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL STEAM",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6C14 },
  ["unicodeslot"]=0x2F53, -- ⽓
 },
 [0x2F54]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WATER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x6C34 },
  ["unicodeslot"]=0x2F54, -- ⽔
 },
 [0x2F55]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FIRE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x706B },
  ["unicodeslot"]=0x2F55, -- ⽕
 },
 [0x2F56]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CLAW",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x722A },
  ["unicodeslot"]=0x2F56, -- ⽖
 },
 [0x2F57]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FATHER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7236 },
  ["unicodeslot"]=0x2F57, -- ⽗
 },
 [0x2F58]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DOUBLE X",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x723B },
  ["unicodeslot"]=0x2F58, -- ⽘
 },
 [0x2F59]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HALF TREE TRUNK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x723F },
  ["unicodeslot"]=0x2F59, -- ⽙
 },
 [0x2F5A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SLICE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7247 },
  ["unicodeslot"]=0x2F5A, -- ⽚
 },
 [0x2F5B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FANG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7259 },
  ["unicodeslot"]=0x2F5B, -- ⽛
 },
 [0x2F5C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL COW",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x725B },
  ["unicodeslot"]=0x2F5C, -- ⽜
 },
 [0x2F5D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DOG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x72AC },
  ["unicodeslot"]=0x2F5D, -- ⽝
 },
 [0x2F5E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL PROFOUND",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7384 },
  ["unicodeslot"]=0x2F5E, -- ⽞
 },
 [0x2F5F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL JADE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7389 },
  ["unicodeslot"]=0x2F5F, -- ⽟
 },
 [0x2F60]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MELON",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x74DC },
  ["unicodeslot"]=0x2F60, -- ⽠
 },
 [0x2F61]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TILE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x74E6 },
  ["unicodeslot"]=0x2F61, -- ⽡
 },
 [0x2F62]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SWEET",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7518 },
  ["unicodeslot"]=0x2F62, -- ⽢
 },
 [0x2F63]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LIFE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x751F },
  ["unicodeslot"]=0x2F63, -- ⽣
 },
 [0x2F64]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL USE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7528 },
  ["unicodeslot"]=0x2F64, -- ⽤
 },
 [0x2F65]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FIELD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7530 },
  ["unicodeslot"]=0x2F65, -- ⽥
 },
 [0x2F66]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BOLT OF CLOTH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x758B },
  ["unicodeslot"]=0x2F66, -- ⽦
 },
 [0x2F67]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SICKNESS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7592 },
  ["unicodeslot"]=0x2F67, -- ⽧
 },
 [0x2F68]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DOTTED TENT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7676 },
  ["unicodeslot"]=0x2F68, -- ⽨
 },
 [0x2F69]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WHITE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x767D },
  ["unicodeslot"]=0x2F69, -- ⽩
 },
 [0x2F6A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SKIN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x76AE },
  ["unicodeslot"]=0x2F6A, -- ⽪
 },
 [0x2F6B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DISH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x76BF },
  ["unicodeslot"]=0x2F6B, -- ⽫
 },
 [0x2F6C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL EYE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x76EE },
  ["unicodeslot"]=0x2F6C, -- ⽬
 },
 [0x2F6D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SPEAR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x77DB },
  ["unicodeslot"]=0x2F6D, -- ⽭
 },
 [0x2F6E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL ARROW",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x77E2 },
  ["unicodeslot"]=0x2F6E, -- ⽮
 },
 [0x2F6F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL STONE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x77F3 },
  ["unicodeslot"]=0x2F6F, -- ⽯
 },
 [0x2F70]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SPIRIT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x793A },
  ["unicodeslot"]=0x2F70, -- ⽰
 },
 [0x2F71]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TRACK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x79B8 },
  ["unicodeslot"]=0x2F71, -- ⽱
 },
 [0x2F72]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL GRAIN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x79BE },
  ["unicodeslot"]=0x2F72, -- ⽲
 },
 [0x2F73]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CAVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7A74 },
  ["unicodeslot"]=0x2F73, -- ⽳
 },
 [0x2F74]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL STAND",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7ACB },
  ["unicodeslot"]=0x2F74, -- ⽴
 },
 [0x2F75]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BAMBOO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7AF9 },
  ["unicodeslot"]=0x2F75, -- ⽵
 },
 [0x2F76]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL RICE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7C73 },
  ["unicodeslot"]=0x2F76, -- ⽶
 },
 [0x2F77]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SILK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7CF8 },
  ["unicodeslot"]=0x2F77, -- ⽷
 },
 [0x2F78]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL JAR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7F36 },
  ["unicodeslot"]=0x2F78, -- ⽸
 },
 [0x2F79]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL NET",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7F51 },
  ["unicodeslot"]=0x2F79, -- ⽹
 },
 [0x2F7A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SHEEP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7F8A },
  ["unicodeslot"]=0x2F7A, -- ⽺
 },
 [0x2F7B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FEATHER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x7FBD },
  ["unicodeslot"]=0x2F7B, -- ⽻
 },
 [0x2F7C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL OLD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8001 },
  ["unicodeslot"]=0x2F7C, -- ⽼
 },
 [0x2F7D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL AND",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x800C },
  ["unicodeslot"]=0x2F7D, -- ⽽
 },
 [0x2F7E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL PLOW",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8012 },
  ["unicodeslot"]=0x2F7E, -- ⽾
 },
 [0x2F7F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL EAR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8033 },
  ["unicodeslot"]=0x2F7F, -- ⽿
 },
 [0x2F80]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BRUSH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x807F },
  ["unicodeslot"]=0x2F80, -- ⾀
 },
 [0x2F81]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MEAT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8089 },
  ["unicodeslot"]=0x2F81, -- ⾁
 },
 [0x2F82]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MINISTER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x81E3 },
  ["unicodeslot"]=0x2F82, -- ⾂
 },
 [0x2F83]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SELF",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x81EA },
  ["unicodeslot"]=0x2F83, -- ⾃
 },
 [0x2F84]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL ARRIVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x81F3 },
  ["unicodeslot"]=0x2F84, -- ⾄
 },
 [0x2F85]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MORTAR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x81FC },
  ["unicodeslot"]=0x2F85, -- ⾅
 },
 [0x2F86]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TONGUE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x820C },
  ["unicodeslot"]=0x2F86, -- ⾆
 },
 [0x2F87]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL OPPOSE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x821B },
  ["unicodeslot"]=0x2F87, -- ⾇
 },
 [0x2F88]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BOAT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x821F },
  ["unicodeslot"]=0x2F88, -- ⾈
 },
 [0x2F89]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL STOPPING",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x826E },
  ["unicodeslot"]=0x2F89, -- ⾉
 },
 [0x2F8A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL COLOR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8272 },
  ["unicodeslot"]=0x2F8A, -- ⾊
 },
 [0x2F8B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL GRASS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8278 },
  ["unicodeslot"]=0x2F8B, -- ⾋
 },
 [0x2F8C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TIGER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x864D },
  ["unicodeslot"]=0x2F8C, -- ⾌
 },
 [0x2F8D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL INSECT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x866B },
  ["unicodeslot"]=0x2F8D, -- ⾍
 },
 [0x2F8E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BLOOD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8840 },
  ["unicodeslot"]=0x2F8E, -- ⾎
 },
 [0x2F8F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WALK ENCLOSURE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x884C },
  ["unicodeslot"]=0x2F8F, -- ⾏
 },
 [0x2F90]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CLOTHES",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8863 },
  ["unicodeslot"]=0x2F90, -- ⾐
 },
 [0x2F91]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WEST",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x897E },
  ["unicodeslot"]=0x2F91, -- ⾑
 },
 [0x2F92]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SEE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x898B },
  ["unicodeslot"]=0x2F92, -- ⾒
 },
 [0x2F93]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HORN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x89D2 },
  ["unicodeslot"]=0x2F93, -- ⾓
 },
 [0x2F94]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SPEECH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8A00 },
  ["unicodeslot"]=0x2F94, -- ⾔
 },
 [0x2F95]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL VALLEY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8C37 },
  ["unicodeslot"]=0x2F95, -- ⾕
 },
 [0x2F96]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BEAN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8C46 },
  ["unicodeslot"]=0x2F96, -- ⾖
 },
 [0x2F97]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL PIG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8C55 },
  ["unicodeslot"]=0x2F97, -- ⾗
 },
 [0x2F98]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BADGER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8C78 },
  ["unicodeslot"]=0x2F98, -- ⾘
 },
 [0x2F99]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SHELL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8C9D },
  ["unicodeslot"]=0x2F99, -- ⾙
 },
 [0x2F9A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL RED",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8D64 },
  ["unicodeslot"]=0x2F9A, -- ⾚
 },
 [0x2F9B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL RUN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8D70 },
  ["unicodeslot"]=0x2F9B, -- ⾛
 },
 [0x2F9C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FOOT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8DB3 },
  ["unicodeslot"]=0x2F9C, -- ⾜
 },
 [0x2F9D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BODY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8EAB },
  ["unicodeslot"]=0x2F9D, -- ⾝
 },
 [0x2F9E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CART",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8ECA },
  ["unicodeslot"]=0x2F9E, -- ⾞
 },
 [0x2F9F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BITTER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8F9B },
  ["unicodeslot"]=0x2F9F, -- ⾟
 },
 [0x2FA0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MORNING",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8FB0 },
  ["unicodeslot"]=0x2FA0, -- ⾠
 },
 [0x2FA1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WALK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x8FB5 },
  ["unicodeslot"]=0x2FA1, -- ⾡
 },
 [0x2FA2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CITY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9091 },
  ["unicodeslot"]=0x2FA2, -- ⾢
 },
 [0x2FA3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9149 },
  ["unicodeslot"]=0x2FA3, -- ⾣
 },
 [0x2FA4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DISTINGUISH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x91C6 },
  ["unicodeslot"]=0x2FA4, -- ⾤
 },
 [0x2FA5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL VILLAGE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x91CC },
  ["unicodeslot"]=0x2FA5, -- ⾥
 },
 [0x2FA6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL GOLD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x91D1 },
  ["unicodeslot"]=0x2FA6, -- ⾦
 },
 [0x2FA7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LONG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9577 },
  ["unicodeslot"]=0x2FA7, -- ⾧
 },
 [0x2FA8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL GATE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9580 },
  ["unicodeslot"]=0x2FA8, -- ⾨
 },
 [0x2FA9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MOUND",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x961C },
  ["unicodeslot"]=0x2FA9, -- ⾩
 },
 [0x2FAA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SLAVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x96B6 },
  ["unicodeslot"]=0x2FAA, -- ⾪
 },
 [0x2FAB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SHORT TAILED BIRD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x96B9 },
  ["unicodeslot"]=0x2FAB, -- ⾫
 },
 [0x2FAC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL RAIN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x96E8 },
  ["unicodeslot"]=0x2FAC, -- ⾬
 },
 [0x2FAD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BLUE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9751 },
  ["unicodeslot"]=0x2FAD, -- ⾭
 },
 [0x2FAE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WRONG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x975E },
  ["unicodeslot"]=0x2FAE, -- ⾮
 },
 [0x2FAF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FACE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9762 },
  ["unicodeslot"]=0x2FAF, -- ⾯
 },
 [0x2FB0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LEATHER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9769 },
  ["unicodeslot"]=0x2FB0, -- ⾰
 },
 [0x2FB1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TANNED LEATHER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x97CB },
  ["unicodeslot"]=0x2FB1, -- ⾱
 },
 [0x2FB2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LEEK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x97ED },
  ["unicodeslot"]=0x2FB2, -- ⾲
 },
 [0x2FB3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SOUND",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x97F3 },
  ["unicodeslot"]=0x2FB3, -- ⾳
 },
 [0x2FB4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL LEAF",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9801 },
  ["unicodeslot"]=0x2FB4, -- ⾴
 },
 [0x2FB5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WIND",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x98A8 },
  ["unicodeslot"]=0x2FB5, -- ⾵
 },
 [0x2FB6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FLY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x98DB },
  ["unicodeslot"]=0x2FB6, -- ⾶
 },
 [0x2FB7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL EAT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x98DF },
  ["unicodeslot"]=0x2FB7, -- ⾷
 },
 [0x2FB8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HEAD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9996 },
  ["unicodeslot"]=0x2FB8, -- ⾸
 },
 [0x2FB9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FRAGRANT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9999 },
  ["unicodeslot"]=0x2FB9, -- ⾹
 },
 [0x2FBA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HORSE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x99AC },
  ["unicodeslot"]=0x2FBA, -- ⾺
 },
 [0x2FBB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BONE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9AA8 },
  ["unicodeslot"]=0x2FBB, -- ⾻
 },
 [0x2FBC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TALL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9AD8 },
  ["unicodeslot"]=0x2FBC, -- ⾼
 },
 [0x2FBD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HAIR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9ADF },
  ["unicodeslot"]=0x2FBD, -- ⾽
 },
 [0x2FBE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FIGHT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9B25 },
  ["unicodeslot"]=0x2FBE, -- ⾾
 },
 [0x2FBF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SACRIFICIAL WINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9B2F },
  ["unicodeslot"]=0x2FBF, -- ⾿
 },
 [0x2FC0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL CAULDRON",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9B32 },
  ["unicodeslot"]=0x2FC0, -- ⿀
 },
 [0x2FC1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL GHOST",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9B3C },
  ["unicodeslot"]=0x2FC1, -- ⿁
 },
 [0x2FC2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FISH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9B5A },
  ["unicodeslot"]=0x2FC2, -- ⿂
 },
 [0x2FC3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BIRD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9CE5 },
  ["unicodeslot"]=0x2FC3, -- ⿃
 },
 [0x2FC4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL SALT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9E75 },
  ["unicodeslot"]=0x2FC4, -- ⿄
 },
 [0x2FC5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DEER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9E7F },
  ["unicodeslot"]=0x2FC5, -- ⿅
 },
 [0x2FC6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL WHEAT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9EA5 },
  ["unicodeslot"]=0x2FC6, -- ⿆
 },
 [0x2FC7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL HEMP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9EBB },
  ["unicodeslot"]=0x2FC7, -- ⿇
 },
 [0x2FC8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL YELLOW",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9EC3 },
  ["unicodeslot"]=0x2FC8, -- ⿈
 },
 [0x2FC9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL MILLET",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9ECD },
  ["unicodeslot"]=0x2FC9, -- ⿉
 },
 [0x2FCA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL BLACK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9ED1 },
  ["unicodeslot"]=0x2FCA, -- ⿊
 },
 [0x2FCB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL EMBROIDERY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9EF9 },
  ["unicodeslot"]=0x2FCB, -- ⿋
 },
 [0x2FCC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FROG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9EFD },
  ["unicodeslot"]=0x2FCC, -- ⿌
 },
 [0x2FCD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TRIPOD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9F0E },
  ["unicodeslot"]=0x2FCD, -- ⿍
 },
 [0x2FCE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DRUM",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9F13 },
  ["unicodeslot"]=0x2FCE, -- ⿎
 },
 [0x2FCF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL RAT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9F20 },
  ["unicodeslot"]=0x2FCF, -- ⿏
 },
 [0x2FD0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL NOSE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9F3B },
  ["unicodeslot"]=0x2FD0, -- ⿐
 },
 [0x2FD1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL EVEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9F4A },
  ["unicodeslot"]=0x2FD1, -- ⿑
 },
 [0x2FD2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TOOTH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9F52 },
  ["unicodeslot"]=0x2FD2, -- ⿒
 },
 [0x2FD3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL DRAGON",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9F8D },
  ["unicodeslot"]=0x2FD3, -- ⿓
 },
 [0x2FD4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL TURTLE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9F9C },
  ["unicodeslot"]=0x2FD4, -- ⿔
 },
 [0x2FD5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KANGXI RADICAL FLUTE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x9FA0 },
  ["unicodeslot"]=0x2FD5, -- ⿕
 },
 [0x2FF0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO RIGHT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF0, -- ⿰
 },
 [0x2FF1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO BELOW",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF1, -- ⿱
 },
 [0x2FF2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO MIDDLE AND RIGHT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF2, -- ⿲
 },
 [0x2FF3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO MIDDLE AND BELOW",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF3, -- ⿳
 },
 [0x2FF4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER FULL SURROUND",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF4, -- ⿴
 },
 [0x2FF5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM ABOVE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF5, -- ⿵
 },
 [0x2FF6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM BELOW",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF6, -- ⿶
 },
 [0x2FF7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LEFT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF7, -- ⿷
 },
 [0x2FF8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER LEFT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF8, -- ⿸
 },
 [0x2FF9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER RIGHT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FF9, -- ⿹
 },
 [0x2FFA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LOWER LEFT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FFA, -- ⿺
 },
 [0x2FFB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DESCRIPTION CHARACTER OVERLAID",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2FFB, -- ⿻
 },
 [0x3000]={
  ["category"]="zs",
  ["cjkwd"]="f",
  ["description"]="IDEOGRAPHIC SPACE",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0020 },
  ["unicodeslot"]=0x3000, -- 　
 },
 [0x3001]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC COMMA",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x3001, -- 、
 },
 [0x3002]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC FULL STOP",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x3002, -- 。
 },
 [0x3003]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="DITTO MARK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3003, -- 〃
 },
 [0x3004]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="JAPANESE INDUSTRIAL STANDARD SYMBOL",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3004, -- 〄
 },
 [0x3005]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ITERATION MARK",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3005, -- 々
 },
 [0x3006]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC CLOSING MARK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3006, -- 〆
 },
 [0x3007]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC NUMBER ZERO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3007, -- 〇
 },
 [0x3008]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT ANGLE BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x3008, -- 〈
 },
 [0x3009]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT ANGLE BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x3009, -- 〉
 },
 [0x300A]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT DOUBLE ANGLE BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x300A, -- 《
 },
 [0x300B]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT DOUBLE ANGLE BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x300B, -- 》
 },
 [0x300C]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT CORNER BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x300C, -- 「
 },
 [0x300D]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT CORNER BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x300D, -- 」
 },
 [0x300E]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT WHITE CORNER BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x300E, -- 『
 },
 [0x300F]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT WHITE CORNER BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x300F, -- 』
 },
 [0x3010]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT BLACK LENTICULAR BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x3010, -- 【
 },
 [0x3011]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT BLACK LENTICULAR BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x3011, -- 】
 },
 [0x3012]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="POSTAL MARK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3012, -- 〒
 },
 [0x3013]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="GETA MARK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3013, -- 〓
 },
 [0x3014]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT TORTOISE SHELL BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x3014, -- 〔
 },
 [0x3015]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT TORTOISE SHELL BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x3015, -- 〕
 },
 [0x3016]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT WHITE LENTICULAR BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x3016, -- 〖
 },
 [0x3017]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT WHITE LENTICULAR BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x3017, -- 〗
 },
 [0x3018]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT WHITE TORTOISE SHELL BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x3018, -- 〘
 },
 [0x3019]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT WHITE TORTOISE SHELL BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x3019, -- 〙
 },
 [0x301A]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="LEFT WHITE SQUARE BRACKET",
  ["linebreak"]="op",
  ["unicodeslot"]=0x301A, -- 〚
 },
 [0x301B]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="RIGHT WHITE SQUARE BRACKET",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x301B, -- 〛
 },
 [0x301C]={
  ["category"]="pd",
  ["cjkwd"]="w",
  ["description"]="WAVE DASH",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x301C, -- 〜
 },
 [0x301D]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="REVERSED DOUBLE PRIME QUOTATION MARK",
  ["linebreak"]="op",
  ["unicodeslot"]=0x301D, -- 〝
 },
 [0x301E]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="DOUBLE PRIME QUOTATION MARK",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x301E, -- 〞
 },
 [0x301F]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="LOW DOUBLE PRIME QUOTATION MARK",
  ["linebreak"]="cl",
  ["unicodeslot"]=0x301F, -- 〟
 },
 [0x3020]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="POSTAL MARK FACE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3020, -- 〠
 },
 [0x3021]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL ONE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3021, -- 〡
 },
 [0x3022]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL TWO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3022, -- 〢
 },
 [0x3023]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL THREE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3023, -- 〣
 },
 [0x3024]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL FOUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3024, -- 〤
 },
 [0x3025]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL FIVE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3025, -- 〥
 },
 [0x3026]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL SIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3026, -- 〦
 },
 [0x3027]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL SEVEN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3027, -- 〧
 },
 [0x3028]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL EIGHT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3028, -- 〨
 },
 [0x3029]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL NINE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3029, -- 〩
 },
 [0x302A]={
  ["category"]="mn",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC LEVEL TONE MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x302A, -- 〪
 },
 [0x302B]={
  ["category"]="mn",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC RISING TONE MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x302B, -- 〫
 },
 [0x302C]={
  ["category"]="mn",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC DEPARTING TONE MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x302C, -- 〬
 },
 [0x302D]={
  ["category"]="mn",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ENTERING TONE MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x302D, -- 〭
 },
 [0x302E]={
  ["category"]="mn",
  ["cjkwd"]="w",
  ["description"]="HANGUL SINGLE DOT TONE MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x302E, -- 〮
 },
 [0x302F]={
  ["category"]="mn",
  ["cjkwd"]="w",
  ["description"]="HANGUL DOUBLE DOT TONE MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x302F, -- 〯
 },
 [0x3030]={
  ["category"]="pd",
  ["cjkwd"]="w",
  ["description"]="WAVY DASH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3030, -- 〰
 },
 [0x3031]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="VERTICAL KANA REPEAT MARK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3031, -- 〱
 },
 [0x3032]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="VERTICAL KANA REPEAT WITH VOICED SOUND MARK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3032, -- 〲
 },
 [0x3033]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="VERTICAL KANA REPEAT MARK UPPER HALF",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3033, -- 〳
 },
 [0x3034]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="VERTICAL KANA REPEAT WITH VOICED SOUND MARK UPPER HALF",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3034, -- 〴
 },
 [0x3035]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="VERTICAL KANA REPEAT MARK LOWER HALF",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3035, -- 〵
 },
 [0x3036]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED POSTAL MARK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x3012 },
  ["unicodeslot"]=0x3036, -- 〶
 },
 [0x3037]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH LINE FEED SEPARATOR SYMBOL",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3037, -- 〷
 },
 [0x3038]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL TEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5341 },
  ["unicodeslot"]=0x3038, -- 〸
 },
 [0x3039]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL TWENTY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5344 },
  ["unicodeslot"]=0x3039, -- 〹
 },
 [0x303A]={
  ["category"]="nl",
  ["cjkwd"]="w",
  ["description"]="HANGZHOU NUMERAL THIRTY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x5345 },
  ["unicodeslot"]=0x303A, -- 〺
 },
 [0x303B]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="VERTICAL IDEOGRAPHIC ITERATION MARK",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x303B, -- 〻
 },
 [0x303C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="MASU MARK",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x303C, -- 〼
 },
 [0x303D]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PART ALTERNATION MARK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x303D, -- 〽
 },
 [0x303E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC VARIATION INDICATOR",
  ["linebreak"]="id",
  ["unicodeslot"]=0x303E, -- 〾
 },
 [0x303F]={
  ["category"]="so",
  ["description"]="IDEOGRAPHIC HALF FILL SPACE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x303F, -- 〿
 },
 [0x3041]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL A",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3041, -- ぁ
 },
 [0x3042]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER A",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3042, -- あ
 },
 [0x3043]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL I",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3043, -- ぃ
 },
 [0x3044]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER I",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3044, -- い
 },
 [0x3045]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL U",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3045, -- ぅ
 },
 [0x3046]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER U",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3046, -- う
 },
 [0x3047]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL E",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3047, -- ぇ
 },
 [0x3048]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER E",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3048, -- え
 },
 [0x3049]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL O",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3049, -- ぉ
 },
 [0x304A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER O",
  ["linebreak"]="id",
  ["unicodeslot"]=0x304A, -- お
 },
 [0x304B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER KA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x304B, -- か
 },
 [0x304C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER GA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x304B, 0x3099 },
  ["unicodeslot"]=0x304C, -- が
 },
 [0x304D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER KI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x304D, -- き
 },
 [0x304E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER GI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x304D, 0x3099 },
  ["unicodeslot"]=0x304E, -- ぎ
 },
 [0x304F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER KU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x304F, -- く
 },
 [0x3050]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER GU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x304F, 0x3099 },
  ["unicodeslot"]=0x3050, -- ぐ
 },
 [0x3051]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER KE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3051, -- け
 },
 [0x3052]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER GE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3051, 0x3099 },
  ["unicodeslot"]=0x3052, -- げ
 },
 [0x3053]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER KO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3053, -- こ
 },
 [0x3054]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER GO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3053, 0x3099 },
  ["unicodeslot"]=0x3054, -- ご
 },
 [0x3055]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3055, -- さ
 },
 [0x3056]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER ZA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3055, 0x3099 },
  ["unicodeslot"]=0x3056, -- ざ
 },
 [0x3057]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3057, -- し
 },
 [0x3058]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER ZI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3057, 0x3099 },
  ["unicodeslot"]=0x3058, -- じ
 },
 [0x3059]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3059, -- す
 },
 [0x305A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER ZU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3059, 0x3099 },
  ["unicodeslot"]=0x305A, -- ず
 },
 [0x305B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x305B, -- せ
 },
 [0x305C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER ZE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x305B, 0x3099 },
  ["unicodeslot"]=0x305C, -- ぜ
 },
 [0x305D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x305D, -- そ
 },
 [0x305E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER ZO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x305D, 0x3099 },
  ["unicodeslot"]=0x305E, -- ぞ
 },
 [0x305F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER TA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x305F, -- た
 },
 [0x3060]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER DA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x305F, 0x3099 },
  ["unicodeslot"]=0x3060, -- だ
 },
 [0x3061]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER TI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3061, -- ち
 },
 [0x3062]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER DI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3061, 0x3099 },
  ["unicodeslot"]=0x3062, -- ぢ
 },
 [0x3063]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL TU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3063, -- っ
 },
 [0x3064]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER TU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3064, -- つ
 },
 [0x3065]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER DU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3064, 0x3099 },
  ["unicodeslot"]=0x3065, -- づ
 },
 [0x3066]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER TE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3066, -- て
 },
 [0x3067]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER DE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3066, 0x3099 },
  ["unicodeslot"]=0x3067, -- で
 },
 [0x3068]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER TO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3068, -- と
 },
 [0x3069]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER DO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3068, 0x3099 },
  ["unicodeslot"]=0x3069, -- ど
 },
 [0x306A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER NA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x306A, -- な
 },
 [0x306B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER NI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x306B, -- に
 },
 [0x306C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER NU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x306C, -- ぬ
 },
 [0x306D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER NE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x306D, -- ね
 },
 [0x306E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER NO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x306E, -- の
 },
 [0x306F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER HA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x306F, -- は
 },
 [0x3070]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER BA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x306F, 0x3099 },
  ["unicodeslot"]=0x3070, -- ば
 },
 [0x3071]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER PA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x306F, 0x309A },
  ["unicodeslot"]=0x3071, -- ぱ
 },
 [0x3072]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER HI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3072, -- ひ
 },
 [0x3073]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER BI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3072, 0x3099 },
  ["unicodeslot"]=0x3073, -- び
 },
 [0x3074]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER PI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3072, 0x309A },
  ["unicodeslot"]=0x3074, -- ぴ
 },
 [0x3075]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER HU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3075, -- ふ
 },
 [0x3076]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER BU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3075, 0x3099 },
  ["unicodeslot"]=0x3076, -- ぶ
 },
 [0x3077]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER PU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3075, 0x309A },
  ["unicodeslot"]=0x3077, -- ぷ
 },
 [0x3078]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER HE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3078, -- へ
 },
 [0x3079]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER BE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3078, 0x3099 },
  ["unicodeslot"]=0x3079, -- べ
 },
 [0x307A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER PE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3078, 0x309A },
  ["unicodeslot"]=0x307A, -- ぺ
 },
 [0x307B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER HO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x307B, -- ほ
 },
 [0x307C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER BO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x307B, 0x3099 },
  ["unicodeslot"]=0x307C, -- ぼ
 },
 [0x307D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER PO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x307B, 0x309A },
  ["unicodeslot"]=0x307D, -- ぽ
 },
 [0x307E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER MA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x307E, -- ま
 },
 [0x307F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER MI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x307F, -- み
 },
 [0x3080]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER MU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3080, -- む
 },
 [0x3081]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER ME",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3081, -- め
 },
 [0x3082]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER MO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3082, -- も
 },
 [0x3083]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL YA",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3083, -- ゃ
 },
 [0x3084]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER YA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3084, -- や
 },
 [0x3085]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL YU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3085, -- ゅ
 },
 [0x3086]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER YU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3086, -- ゆ
 },
 [0x3087]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL YO",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3087, -- ょ
 },
 [0x3088]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER YO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3088, -- よ
 },
 [0x3089]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER RA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3089, -- ら
 },
 [0x308A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER RI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x308A, -- り
 },
 [0x308B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER RU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x308B, -- る
 },
 [0x308C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER RE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x308C, -- れ
 },
 [0x308D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER RO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x308D, -- ろ
 },
 [0x308E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL WA",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x308E, -- ゎ
 },
 [0x308F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER WA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x308F, -- わ
 },
 [0x3090]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER WI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3090, -- ゐ
 },
 [0x3091]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER WE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3091, -- ゑ
 },
 [0x3092]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER WO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3092, -- を
 },
 [0x3093]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER N",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3093, -- ん
 },
 [0x3094]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER VU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3046, 0x3099 },
  ["unicodeslot"]=0x3094, -- ゔ
 },
 [0x3095]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL KA",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3095, -- ゕ
 },
 [0x3096]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA LETTER SMALL KE",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x3096, -- ゖ
 },
 [0x3099]={
  ["category"]="mn",
  ["cjkwd"]="w",
  ["description"]="COMBINING KATAKANA-HIRAGANA VOICED SOUND MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x3099, -- ゙
 },
 [0x309A]={
  ["category"]="mn",
  ["cjkwd"]="w",
  ["description"]="COMBINING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x309A, -- ゚
 },
 [0x309B]={
  ["category"]="sk",
  ["cjkwd"]="w",
  ["description"]="KATAKANA-HIRAGANA VOICED SOUND MARK",
  ["linebreak"]="ns",
  ["specials"]={ "compat", 0x0020, 0x3099 },
  ["unicodeslot"]=0x309B, -- ゛
 },
 [0x309C]={
  ["category"]="sk",
  ["cjkwd"]="w",
  ["description"]="KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK",
  ["linebreak"]="ns",
  ["specials"]={ "compat", 0x0020, 0x309A },
  ["unicodeslot"]=0x309C, -- ゜
 },
 [0x309D]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA ITERATION MARK",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x309D, -- ゝ
 },
 [0x309E]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA VOICED ITERATION MARK",
  ["linebreak"]="ns",
  ["specials"]={ "char", 0x309D, 0x3099 },
  ["unicodeslot"]=0x309E, -- ゞ
 },
 [0x309F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HIRAGANA DIGRAPH YORI",
  ["linebreak"]="id",
  ["specials"]={ "vertical", 0x3088, 0x308A },
  ["unicodeslot"]=0x309F, -- ゟ
 },
 [0x30A0]={
  ["category"]="pd",
  ["cjkwd"]="w",
  ["description"]="KATAKANA-HIRAGANA DOUBLE HYPHEN",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30A0, -- ゠
 },
 [0x30A1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL A",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30A1, -- ァ
 },
 [0x30A2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER A",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30A2, -- ア
 },
 [0x30A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL I",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30A3, -- ィ
 },
 [0x30A4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER I",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30A4, -- イ
 },
 [0x30A5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL U",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30A5, -- ゥ
 },
 [0x30A6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER U",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30A6, -- ウ
 },
 [0x30A7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL E",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30A7, -- ェ
 },
 [0x30A8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER E",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30A8, -- エ
 },
 [0x30A9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL O",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30A9, -- ォ
 },
 [0x30AA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER O",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30AA, -- オ
 },
 [0x30AB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER KA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30AB, -- カ
 },
 [0x30AC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER GA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30AB, 0x3099 },
  ["unicodeslot"]=0x30AC, -- ガ
 },
 [0x30AD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER KI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30AD, -- キ
 },
 [0x30AE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER GI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30AD, 0x3099 },
  ["unicodeslot"]=0x30AE, -- ギ
 },
 [0x30AF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER KU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30AF, -- ク
 },
 [0x30B0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER GU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30AF, 0x3099 },
  ["unicodeslot"]=0x30B0, -- グ
 },
 [0x30B1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER KE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30B1, -- ケ
 },
 [0x30B2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER GE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30B1, 0x3099 },
  ["unicodeslot"]=0x30B2, -- ゲ
 },
 [0x30B3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER KO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30B3, -- コ
 },
 [0x30B4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER GO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30B3, 0x3099 },
  ["unicodeslot"]=0x30B4, -- ゴ
 },
 [0x30B5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30B5, -- サ
 },
 [0x30B6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER ZA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30B5, 0x3099 },
  ["unicodeslot"]=0x30B6, -- ザ
 },
 [0x30B7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30B7, -- シ
 },
 [0x30B8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER ZI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30B7, 0x3099 },
  ["unicodeslot"]=0x30B8, -- ジ
 },
 [0x30B9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30B9, -- ス
 },
 [0x30BA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER ZU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30B9, 0x3099 },
  ["unicodeslot"]=0x30BA, -- ズ
 },
 [0x30BB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30BB, -- セ
 },
 [0x30BC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER ZE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30BB, 0x3099 },
  ["unicodeslot"]=0x30BC, -- ゼ
 },
 [0x30BD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30BD, -- ソ
 },
 [0x30BE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER ZO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30BD, 0x3099 },
  ["unicodeslot"]=0x30BE, -- ゾ
 },
 [0x30BF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER TA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30BF, -- タ
 },
 [0x30C0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER DA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30BF, 0x3099 },
  ["unicodeslot"]=0x30C0, -- ダ
 },
 [0x30C1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER TI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30C1, -- チ
 },
 [0x30C2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER DI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30C1, 0x3099 },
  ["unicodeslot"]=0x30C2, -- ヂ
 },
 [0x30C3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL TU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30C3, -- ッ
 },
 [0x30C4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER TU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30C4, -- ツ
 },
 [0x30C5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER DU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30C4, 0x3099 },
  ["unicodeslot"]=0x30C5, -- ヅ
 },
 [0x30C6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER TE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30C6, -- テ
 },
 [0x30C7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER DE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30C6, 0x3099 },
  ["unicodeslot"]=0x30C7, -- デ
 },
 [0x30C8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER TO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30C8, -- ト
 },
 [0x30C9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER DO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30C8, 0x3099 },
  ["unicodeslot"]=0x30C9, -- ド
 },
 [0x30CA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER NA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30CA, -- ナ
 },
 [0x30CB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER NI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30CB, -- ニ
 },
 [0x30CC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER NU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30CC, -- ヌ
 },
 [0x30CD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER NE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30CD, -- ネ
 },
 [0x30CE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER NO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30CE, -- ノ
 },
 [0x30CF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER HA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30CF, -- ハ
 },
 [0x30D0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER BA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30CF, 0x3099 },
  ["unicodeslot"]=0x30D0, -- バ
 },
 [0x30D1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER PA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30CF, 0x309A },
  ["unicodeslot"]=0x30D1, -- パ
 },
 [0x30D2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER HI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30D2, -- ヒ
 },
 [0x30D3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER BI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30D2, 0x3099 },
  ["unicodeslot"]=0x30D3, -- ビ
 },
 [0x30D4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER PI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30D2, 0x309A },
  ["unicodeslot"]=0x30D4, -- ピ
 },
 [0x30D5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER HU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30D5, -- フ
 },
 [0x30D6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER BU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30D5, 0x3099 },
  ["unicodeslot"]=0x30D6, -- ブ
 },
 [0x30D7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER PU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30D5, 0x309A },
  ["unicodeslot"]=0x30D7, -- プ
 },
 [0x30D8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER HE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30D8, -- ヘ
 },
 [0x30D9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER BE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30D8, 0x3099 },
  ["unicodeslot"]=0x30D9, -- ベ
 },
 [0x30DA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER PE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30D8, 0x309A },
  ["unicodeslot"]=0x30DA, -- ペ
 },
 [0x30DB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER HO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30DB, -- ホ
 },
 [0x30DC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER BO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30DB, 0x3099 },
  ["unicodeslot"]=0x30DC, -- ボ
 },
 [0x30DD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER PO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30DB, 0x309A },
  ["unicodeslot"]=0x30DD, -- ポ
 },
 [0x30DE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER MA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30DE, -- マ
 },
 [0x30DF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER MI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30DF, -- ミ
 },
 [0x30E0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER MU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30E0, -- ム
 },
 [0x30E1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER ME",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30E1, -- メ
 },
 [0x30E2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER MO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30E2, -- モ
 },
 [0x30E3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL YA",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30E3, -- ャ
 },
 [0x30E4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER YA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30E4, -- ヤ
 },
 [0x30E5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL YU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30E5, -- ュ
 },
 [0x30E6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER YU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30E6, -- ユ
 },
 [0x30E7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL YO",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30E7, -- ョ
 },
 [0x30E8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER YO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30E8, -- ヨ
 },
 [0x30E9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER RA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30E9, -- ラ
 },
 [0x30EA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER RI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30EA, -- リ
 },
 [0x30EB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER RU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30EB, -- ル
 },
 [0x30EC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER RE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30EC, -- レ
 },
 [0x30ED]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER RO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30ED, -- ロ
 },
 [0x30EE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL WA",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30EE, -- ヮ
 },
 [0x30EF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER WA",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30EF, -- ワ
 },
 [0x30F0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER WI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30F0, -- ヰ
 },
 [0x30F1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER WE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30F1, -- ヱ
 },
 [0x30F2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER WO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30F2, -- ヲ
 },
 [0x30F3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER N",
  ["linebreak"]="id",
  ["unicodeslot"]=0x30F3, -- ン
 },
 [0x30F4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER VU",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30A6, 0x3099 },
  ["unicodeslot"]=0x30F4, -- ヴ
 },
 [0x30F5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL KA",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30F5, -- ヵ
 },
 [0x30F6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL KE",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30F6, -- ヶ
 },
 [0x30F7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER VA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30EF, 0x3099 },
  ["unicodeslot"]=0x30F7, -- ヷ
 },
 [0x30F8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER VI",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30F0, 0x3099 },
  ["unicodeslot"]=0x30F8, -- ヸ
 },
 [0x30F9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER VE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30F1, 0x3099 },
  ["unicodeslot"]=0x30F9, -- ヹ
 },
 [0x30FA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER VO",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x30F2, 0x3099 },
  ["unicodeslot"]=0x30FA, -- ヺ
 },
 [0x30FB]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="KATAKANA MIDDLE DOT",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30FB, -- ・
 },
 [0x30FC]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="KATAKANA-HIRAGANA PROLONGED SOUND MARK",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30FC, -- ー
 },
 [0x30FD]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="KATAKANA ITERATION MARK",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x30FD, -- ヽ
 },
 [0x30FE]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="KATAKANA VOICED ITERATION MARK",
  ["linebreak"]="ns",
  ["specials"]={ "char", 0x30FD, 0x3099 },
  ["unicodeslot"]=0x30FE, -- ヾ
 },
 [0x30FF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA DIGRAPH KOTO",
  ["linebreak"]="id",
  ["specials"]={ "vertical", 0x30B3, 0x30C8 },
  ["unicodeslot"]=0x30FF, -- ヿ
 },
 [0x3105]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER B",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3105, -- ㄅ
 },
 [0x3106]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER P",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3106, -- ㄆ
 },
 [0x3107]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER M",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3107, -- ㄇ
 },
 [0x3108]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER F",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3108, -- ㄈ
 },
 [0x3109]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER D",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3109, -- ㄉ
 },
 [0x310A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER T",
  ["linebreak"]="id",
  ["unicodeslot"]=0x310A, -- ㄊ
 },
 [0x310B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER N",
  ["linebreak"]="id",
  ["unicodeslot"]=0x310B, -- ㄋ
 },
 [0x310C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER L",
  ["linebreak"]="id",
  ["unicodeslot"]=0x310C, -- ㄌ
 },
 [0x310D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER G",
  ["linebreak"]="id",
  ["unicodeslot"]=0x310D, -- ㄍ
 },
 [0x310E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER K",
  ["linebreak"]="id",
  ["unicodeslot"]=0x310E, -- ㄎ
 },
 [0x310F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER H",
  ["linebreak"]="id",
  ["unicodeslot"]=0x310F, -- ㄏ
 },
 [0x3110]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER J",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3110, -- ㄐ
 },
 [0x3111]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER Q",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3111, -- ㄑ
 },
 [0x3112]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER X",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3112, -- ㄒ
 },
 [0x3113]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER ZH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3113, -- ㄓ
 },
 [0x3114]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER CH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3114, -- ㄔ
 },
 [0x3115]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER SH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3115, -- ㄕ
 },
 [0x3116]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER R",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3116, -- ㄖ
 },
 [0x3117]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER Z",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3117, -- ㄗ
 },
 [0x3118]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER C",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3118, -- ㄘ
 },
 [0x3119]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER S",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3119, -- ㄙ
 },
 [0x311A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER A",
  ["linebreak"]="id",
  ["unicodeslot"]=0x311A, -- ㄚ
 },
 [0x311B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER O",
  ["linebreak"]="id",
  ["unicodeslot"]=0x311B, -- ㄛ
 },
 [0x311C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER E",
  ["linebreak"]="id",
  ["unicodeslot"]=0x311C, -- ㄜ
 },
 [0x311D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER EH",
  ["linebreak"]="id",
  ["unicodeslot"]=0x311D, -- ㄝ
 },
 [0x311E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER AI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x311E, -- ㄞ
 },
 [0x311F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER EI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x311F, -- ㄟ
 },
 [0x3120]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER AU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3120, -- ㄠ
 },
 [0x3121]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER OU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3121, -- ㄡ
 },
 [0x3122]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER AN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3122, -- ㄢ
 },
 [0x3123]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER EN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3123, -- ㄣ
 },
 [0x3124]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER ANG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3124, -- ㄤ
 },
 [0x3125]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER ENG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3125, -- ㄥ
 },
 [0x3126]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER ER",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3126, -- ㄦ
 },
 [0x3127]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER I",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3127, -- ㄧ
 },
 [0x3128]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER U",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3128, -- ㄨ
 },
 [0x3129]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER IU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3129, -- ㄩ
 },
 [0x312A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER V",
  ["linebreak"]="id",
  ["unicodeslot"]=0x312A, -- ㄪ
 },
 [0x312B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER NG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x312B, -- ㄫ
 },
 [0x312C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER GN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x312C, -- ㄬ
 },
 [0x3131]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER KIYEOK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1100 },
  ["unicodeslot"]=0x3131, -- ㄱ
 },
 [0x3132]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SSANGKIYEOK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1101 },
  ["unicodeslot"]=0x3132, -- ㄲ
 },
 [0x3133]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER KIYEOK-SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11AA },
  ["unicodeslot"]=0x3133, -- ㄳ
 },
 [0x3134]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER NIEUN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1102 },
  ["unicodeslot"]=0x3134, -- ㄴ
 },
 [0x3135]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER NIEUN-CIEUC",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11AC },
  ["unicodeslot"]=0x3135, -- ㄵ
 },
 [0x3136]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER NIEUN-HIEUH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11AD },
  ["unicodeslot"]=0x3136, -- ㄶ
 },
 [0x3137]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER TIKEUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1103 },
  ["unicodeslot"]=0x3137, -- ㄷ
 },
 [0x3138]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SSANGTIKEUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1104 },
  ["unicodeslot"]=0x3138, -- ㄸ
 },
 [0x3139]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1105 },
  ["unicodeslot"]=0x3139, -- ㄹ
 },
 [0x313A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-KIYEOK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11B0 },
  ["unicodeslot"]=0x313A, -- ㄺ
 },
 [0x313B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-MIEUM",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11B1 },
  ["unicodeslot"]=0x313B, -- ㄻ
 },
 [0x313C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-PIEUP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11B2 },
  ["unicodeslot"]=0x313C, -- ㄼ
 },
 [0x313D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11B3 },
  ["unicodeslot"]=0x313D, -- ㄽ
 },
 [0x313E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-THIEUTH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11B4 },
  ["unicodeslot"]=0x313E, -- ㄾ
 },
 [0x313F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-PHIEUPH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11B5 },
  ["unicodeslot"]=0x313F, -- ㄿ
 },
 [0x3140]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-HIEUH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x111A },
  ["unicodeslot"]=0x3140, -- ㅀ
 },
 [0x3141]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER MIEUM",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1106 },
  ["unicodeslot"]=0x3141, -- ㅁ
 },
 [0x3142]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PIEUP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1107 },
  ["unicodeslot"]=0x3142, -- ㅂ
 },
 [0x3143]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SSANGPIEUP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1108 },
  ["unicodeslot"]=0x3143, -- ㅃ
 },
 [0x3144]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PIEUP-SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1121 },
  ["unicodeslot"]=0x3144, -- ㅄ
 },
 [0x3145]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1109 },
  ["unicodeslot"]=0x3145, -- ㅅ
 },
 [0x3146]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SSANGSIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x110A },
  ["unicodeslot"]=0x3146, -- ㅆ
 },
 [0x3147]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER IEUNG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x110B },
  ["unicodeslot"]=0x3147, -- ㅇ
 },
 [0x3148]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER CIEUC",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x110C },
  ["unicodeslot"]=0x3148, -- ㅈ
 },
 [0x3149]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SSANGCIEUC",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x110D },
  ["unicodeslot"]=0x3149, -- ㅉ
 },
 [0x314A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER CHIEUCH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x110E },
  ["unicodeslot"]=0x314A, -- ㅊ
 },
 [0x314B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER KHIEUKH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x110F },
  ["unicodeslot"]=0x314B, -- ㅋ
 },
 [0x314C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER THIEUTH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1110 },
  ["unicodeslot"]=0x314C, -- ㅌ
 },
 [0x314D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PHIEUPH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1111 },
  ["unicodeslot"]=0x314D, -- ㅍ
 },
 [0x314E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER HIEUH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1112 },
  ["unicodeslot"]=0x314E, -- ㅎ
 },
 [0x314F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1161 },
  ["unicodeslot"]=0x314F, -- ㅏ
 },
 [0x3150]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER AE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1162 },
  ["unicodeslot"]=0x3150, -- ㅐ
 },
 [0x3151]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YA",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1163 },
  ["unicodeslot"]=0x3151, -- ㅑ
 },
 [0x3152]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YAE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1164 },
  ["unicodeslot"]=0x3152, -- ㅒ
 },
 [0x3153]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER EO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1165 },
  ["unicodeslot"]=0x3153, -- ㅓ
 },
 [0x3154]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER E",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1166 },
  ["unicodeslot"]=0x3154, -- ㅔ
 },
 [0x3155]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YEO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1167 },
  ["unicodeslot"]=0x3155, -- ㅕ
 },
 [0x3156]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1168 },
  ["unicodeslot"]=0x3156, -- ㅖ
 },
 [0x3157]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER O",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1169 },
  ["unicodeslot"]=0x3157, -- ㅗ
 },
 [0x3158]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER WA",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x116A },
  ["unicodeslot"]=0x3158, -- ㅘ
 },
 [0x3159]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER WAE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x116B },
  ["unicodeslot"]=0x3159, -- ㅙ
 },
 [0x315A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER OE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x116C },
  ["unicodeslot"]=0x315A, -- ㅚ
 },
 [0x315B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x116D },
  ["unicodeslot"]=0x315B, -- ㅛ
 },
 [0x315C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER U",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x116E },
  ["unicodeslot"]=0x315C, -- ㅜ
 },
 [0x315D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER WEO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x116F },
  ["unicodeslot"]=0x315D, -- ㅝ
 },
 [0x315E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER WE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1170 },
  ["unicodeslot"]=0x315E, -- ㅞ
 },
 [0x315F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER WI",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1171 },
  ["unicodeslot"]=0x315F, -- ㅟ
 },
 [0x3160]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YU",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1172 },
  ["unicodeslot"]=0x3160, -- ㅠ
 },
 [0x3161]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER EU",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1173 },
  ["unicodeslot"]=0x3161, -- ㅡ
 },
 [0x3162]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YI",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1174 },
  ["unicodeslot"]=0x3162, -- ㅢ
 },
 [0x3163]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER I",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1175 },
  ["unicodeslot"]=0x3163, -- ㅣ
 },
 [0x3164]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL FILLER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1160 },
  ["unicodeslot"]=0x3164, -- ㅤ
 },
 [0x3165]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SSANGNIEUN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1114 },
  ["unicodeslot"]=0x3165, -- ㅥ
 },
 [0x3166]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER NIEUN-TIKEUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1115 },
  ["unicodeslot"]=0x3166, -- ㅦ
 },
 [0x3167]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER NIEUN-SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11C7 },
  ["unicodeslot"]=0x3167, -- ㅧ
 },
 [0x3168]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER NIEUN-PANSIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11C8 },
  ["unicodeslot"]=0x3168, -- ㅨ
 },
 [0x3169]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-KIYEOK-SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11CC },
  ["unicodeslot"]=0x3169, -- ㅩ
 },
 [0x316A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-TIKEUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11CE },
  ["unicodeslot"]=0x316A, -- ㅪ
 },
 [0x316B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-PIEUP-SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11D3 },
  ["unicodeslot"]=0x316B, -- ㅫ
 },
 [0x316C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-PANSIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11D7 },
  ["unicodeslot"]=0x316C, -- ㅬ
 },
 [0x316D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER RIEUL-YEORINHIEUH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11D9 },
  ["unicodeslot"]=0x316D, -- ㅭ
 },
 [0x316E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER MIEUM-PIEUP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x111C },
  ["unicodeslot"]=0x316E, -- ㅮ
 },
 [0x316F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER MIEUM-SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11DD },
  ["unicodeslot"]=0x316F, -- ㅯ
 },
 [0x3170]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER MIEUM-PANSIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11DF },
  ["unicodeslot"]=0x3170, -- ㅰ
 },
 [0x3171]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER KAPYEOUNMIEUM",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x111D },
  ["unicodeslot"]=0x3171, -- ㅱ
 },
 [0x3172]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PIEUP-KIYEOK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x111E },
  ["unicodeslot"]=0x3172, -- ㅲ
 },
 [0x3173]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PIEUP-TIKEUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1120 },
  ["unicodeslot"]=0x3173, -- ㅳ
 },
 [0x3174]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PIEUP-SIOS-KIYEOK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1122 },
  ["unicodeslot"]=0x3174, -- ㅴ
 },
 [0x3175]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PIEUP-SIOS-TIKEUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1123 },
  ["unicodeslot"]=0x3175, -- ㅵ
 },
 [0x3176]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PIEUP-CIEUC",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1127 },
  ["unicodeslot"]=0x3176, -- ㅶ
 },
 [0x3177]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PIEUP-THIEUTH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1129 },
  ["unicodeslot"]=0x3177, -- ㅷ
 },
 [0x3178]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER KAPYEOUNPIEUP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x112B },
  ["unicodeslot"]=0x3178, -- ㅸ
 },
 [0x3179]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER KAPYEOUNSSANGPIEUP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x112C },
  ["unicodeslot"]=0x3179, -- ㅹ
 },
 [0x317A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SIOS-KIYEOK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x112D },
  ["unicodeslot"]=0x317A, -- ㅺ
 },
 [0x317B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SIOS-NIEUN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x112E },
  ["unicodeslot"]=0x317B, -- ㅻ
 },
 [0x317C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SIOS-TIKEUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x112F },
  ["unicodeslot"]=0x317C, -- ㅼ
 },
 [0x317D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SIOS-PIEUP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1132 },
  ["unicodeslot"]=0x317D, -- ㅽ
 },
 [0x317E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SIOS-CIEUC",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1136 },
  ["unicodeslot"]=0x317E, -- ㅾ
 },
 [0x317F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER PANSIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1140 },
  ["unicodeslot"]=0x317F, -- ㅿ
 },
 [0x3180]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SSANGIEUNG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1147 },
  ["unicodeslot"]=0x3180, -- ㆀ
 },
 [0x3181]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YESIEUNG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x114C },
  ["unicodeslot"]=0x3181, -- ㆁ
 },
 [0x3182]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YESIEUNG-SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11F1 },
  ["unicodeslot"]=0x3182, -- ㆂ
 },
 [0x3183]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YESIEUNG-PANSIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11F2 },
  ["unicodeslot"]=0x3183, -- ㆃ
 },
 [0x3184]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER KAPYEOUNPHIEUPH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1157 },
  ["unicodeslot"]=0x3184, -- ㆄ
 },
 [0x3185]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER SSANGHIEUH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1158 },
  ["unicodeslot"]=0x3185, -- ㆅ
 },
 [0x3186]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YEORINHIEUH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1159 },
  ["unicodeslot"]=0x3186, -- ㆆ
 },
 [0x3187]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YO-YA",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1184 },
  ["unicodeslot"]=0x3187, -- ㆇ
 },
 [0x3188]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YO-YAE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1185 },
  ["unicodeslot"]=0x3188, -- ㆈ
 },
 [0x3189]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YO-I",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1188 },
  ["unicodeslot"]=0x3189, -- ㆉ
 },
 [0x318A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YU-YEO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1191 },
  ["unicodeslot"]=0x318A, -- ㆊ
 },
 [0x318B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YU-YE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1192 },
  ["unicodeslot"]=0x318B, -- ㆋ
 },
 [0x318C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER YU-I",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x1194 },
  ["unicodeslot"]=0x318C, -- ㆌ
 },
 [0x318D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER ARAEA",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x119E },
  ["unicodeslot"]=0x318D, -- ㆍ
 },
 [0x318E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="HANGUL LETTER ARAEAE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x11A1 },
  ["unicodeslot"]=0x318E, -- ㆎ
 },
 [0x3190]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION LINKING MARK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3190, -- ㆐
 },
 [0x3191]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION REVERSE MARK",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3191, -- ㆑
 },
 [0x3192]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION ONE MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4E00 },
  ["unicodeslot"]=0x3192, -- ㆒
 },
 [0x3193]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION TWO MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4E8C },
  ["unicodeslot"]=0x3193, -- ㆓
 },
 [0x3194]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION THREE MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4E09 },
  ["unicodeslot"]=0x3194, -- ㆔
 },
 [0x3195]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION FOUR MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x56DB },
  ["unicodeslot"]=0x3195, -- ㆕
 },
 [0x3196]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION TOP MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4E0A },
  ["unicodeslot"]=0x3196, -- ㆖
 },
 [0x3197]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION MIDDLE MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4E2D },
  ["unicodeslot"]=0x3197, -- ㆗
 },
 [0x3198]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION BOTTOM MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4E0B },
  ["unicodeslot"]=0x3198, -- ㆘
 },
 [0x3199]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION FIRST MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x7532 },
  ["unicodeslot"]=0x3199, -- ㆙
 },
 [0x319A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION SECOND MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4E59 },
  ["unicodeslot"]=0x319A, -- ㆚
 },
 [0x319B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION THIRD MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4E19 },
  ["unicodeslot"]=0x319B, -- ㆛
 },
 [0x319C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION FOURTH MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4E01 },
  ["unicodeslot"]=0x319C, -- ㆜
 },
 [0x319D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION HEAVEN MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x5929 },
  ["unicodeslot"]=0x319D, -- ㆝
 },
 [0x319E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION EARTH MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x5730 },
  ["unicodeslot"]=0x319E, -- ㆞
 },
 [0x319F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC ANNOTATION MAN MARK",
  ["linebreak"]="id",
  ["specials"]={ "super", 0x4EBA },
  ["unicodeslot"]=0x319F, -- ㆟
 },
 [0x31A0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER BU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A0, -- ㆠ
 },
 [0x31A1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER ZI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A1, -- ㆡ
 },
 [0x31A2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER JI",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A2, -- ㆢ
 },
 [0x31A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER GU",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A3, -- ㆣ
 },
 [0x31A4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER EE",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A4, -- ㆤ
 },
 [0x31A5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER ENN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A5, -- ㆥ
 },
 [0x31A6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER OO",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A6, -- ㆦ
 },
 [0x31A7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER ONN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A7, -- ㆧ
 },
 [0x31A8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER IR",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A8, -- ㆨ
 },
 [0x31A9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER ANN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31A9, -- ㆩ
 },
 [0x31AA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER INN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31AA, -- ㆪ
 },
 [0x31AB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER UNN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31AB, -- ㆫ
 },
 [0x31AC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER IM",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31AC, -- ㆬ
 },
 [0x31AD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER NGG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31AD, -- ㆭ
 },
 [0x31AE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER AINN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31AE, -- ㆮ
 },
 [0x31AF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER AUNN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31AF, -- ㆯ
 },
 [0x31B0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER AM",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31B0, -- ㆰ
 },
 [0x31B1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER OM",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31B1, -- ㆱ
 },
 [0x31B2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER ONG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31B2, -- ㆲ
 },
 [0x31B3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO LETTER INNN",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31B3, -- ㆳ
 },
 [0x31B4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO FINAL LETTER P",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31B4, -- ㆴ
 },
 [0x31B5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO FINAL LETTER T",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31B5, -- ㆵ
 },
 [0x31B6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO FINAL LETTER K",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31B6, -- ㆶ
 },
 [0x31B7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="BOPOMOFO FINAL LETTER H",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31B7, -- ㆷ
 },
 [0x31C0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE T",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C0, -- ㇀
 },
 [0x31C1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE WG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C1, -- ㇁
 },
 [0x31C2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE XG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C2, -- ㇂
 },
 [0x31C3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE BXG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C3, -- ㇃
 },
 [0x31C4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE SW",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C4, -- ㇄
 },
 [0x31C5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE HZZ",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C5, -- ㇅
 },
 [0x31C6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE HZG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C6, -- ㇆
 },
 [0x31C7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE HP",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C7, -- ㇇
 },
 [0x31C8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE HZWG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C8, -- ㇈
 },
 [0x31C9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE SZWG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31C9, -- ㇉
 },
 [0x31CA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE HZT",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31CA, -- ㇊
 },
 [0x31CB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE HZZP",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31CB, -- ㇋
 },
 [0x31CC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE HPWG",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31CC, -- ㇌
 },
 [0x31CD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE HZW",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31CD, -- ㇍
 },
 [0x31CE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE HZZZ",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31CE, -- ㇎
 },
 [0x31CF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CJK STROKE N",
  ["linebreak"]="id",
  ["unicodeslot"]=0x31CF, -- ㇏
 },
 [0x31F0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL KU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F0, -- ㇰ
 },
 [0x31F1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL SI",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F1, -- ㇱ
 },
 [0x31F2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL SU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F2, -- ㇲ
 },
 [0x31F3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL TO",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F3, -- ㇳ
 },
 [0x31F4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL NU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F4, -- ㇴ
 },
 [0x31F5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL HA",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F5, -- ㇵ
 },
 [0x31F6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL HI",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F6, -- ㇶ
 },
 [0x31F7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL HU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F7, -- ㇷ
 },
 [0x31F8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL HE",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F8, -- ㇸ
 },
 [0x31F9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL HO",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31F9, -- ㇹ
 },
 [0x31FA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL MU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31FA, -- ㇺ
 },
 [0x31FB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL RA",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31FB, -- ㇻ
 },
 [0x31FC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL RI",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31FC, -- ㇼ
 },
 [0x31FD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL RU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31FD, -- ㇽ
 },
 [0x31FE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL RE",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31FE, -- ㇾ
 },
 [0x31FF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="KATAKANA LETTER SMALL RO",
  ["linebreak"]="ns",
  ["unicodeslot"]=0x31FF, -- ㇿ
 },
 [0x3200]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL KIYEOK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1100, 0x0029 },
  ["unicodeslot"]=0x3200, -- ㈀
 },
 [0x3201]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL NIEUN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1102, 0x0029 },
  ["unicodeslot"]=0x3201, -- ㈁
 },
 [0x3202]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL TIKEUT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1103, 0x0029 },
  ["unicodeslot"]=0x3202, -- ㈂
 },
 [0x3203]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL RIEUL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1105, 0x0029 },
  ["unicodeslot"]=0x3203, -- ㈃
 },
 [0x3204]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL MIEUM",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1106, 0x0029 },
  ["unicodeslot"]=0x3204, -- ㈄
 },
 [0x3205]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL PIEUP",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1107, 0x0029 },
  ["unicodeslot"]=0x3205, -- ㈅
 },
 [0x3206]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL SIOS",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1109, 0x0029 },
  ["unicodeslot"]=0x3206, -- ㈆
 },
 [0x3207]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL IEUNG",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110B, 0x0029 },
  ["unicodeslot"]=0x3207, -- ㈇
 },
 [0x3208]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL CIEUC",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110C, 0x0029 },
  ["unicodeslot"]=0x3208, -- ㈈
 },
 [0x3209]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL CHIEUCH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110E, 0x0029 },
  ["unicodeslot"]=0x3209, -- ㈉
 },
 [0x320A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL KHIEUKH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110F, 0x0029 },
  ["unicodeslot"]=0x320A, -- ㈊
 },
 [0x320B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL THIEUTH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1110, 0x0029 },
  ["unicodeslot"]=0x320B, -- ㈋
 },
 [0x320C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL PHIEUPH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1111, 0x0029 },
  ["unicodeslot"]=0x320C, -- ㈌
 },
 [0x320D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL HIEUH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1112, 0x0029 },
  ["unicodeslot"]=0x320D, -- ㈍
 },
 [0x320E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL KIYEOK A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1100, 0x1161, 0x0029 },
  ["unicodeslot"]=0x320E, -- ㈎
 },
 [0x320F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL NIEUN A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1102, 0x1161, 0x0029 },
  ["unicodeslot"]=0x320F, -- ㈏
 },
 [0x3210]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL TIKEUT A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1103, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3210, -- ㈐
 },
 [0x3211]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL RIEUL A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1105, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3211, -- ㈑
 },
 [0x3212]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL MIEUM A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1106, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3212, -- ㈒
 },
 [0x3213]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL PIEUP A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1107, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3213, -- ㈓
 },
 [0x3214]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL SIOS A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1109, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3214, -- ㈔
 },
 [0x3215]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL IEUNG A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110B, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3215, -- ㈕
 },
 [0x3216]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL CIEUC A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110C, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3216, -- ㈖
 },
 [0x3217]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL CHIEUCH A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110E, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3217, -- ㈗
 },
 [0x3218]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL KHIEUKH A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110F, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3218, -- ㈘
 },
 [0x3219]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL THIEUTH A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1110, 0x1161, 0x0029 },
  ["unicodeslot"]=0x3219, -- ㈙
 },
 [0x321A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL PHIEUPH A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1111, 0x1161, 0x0029 },
  ["unicodeslot"]=0x321A, -- ㈚
 },
 [0x321B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL HIEUH A",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x1112, 0x1161, 0x0029 },
  ["unicodeslot"]=0x321B, -- ㈛
 },
 [0x321C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED HANGUL CIEUC U",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110C, 0x116E, 0x0029 },
  ["unicodeslot"]=0x321C, -- ㈜
 },
 [0x321D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED KOREAN CHARACTER OJEON",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110B, 0x1169, 0x110C, 0x1165, 0x11AB, 0x0029 },
  ["unicodeslot"]=0x321D, -- ㈝
 },
 [0x321E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED KOREAN CHARACTER O HU",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x110B, 0x1169, 0x1112, 0x116E, 0x0029 },
  ["unicodeslot"]=0x321E, -- ㈞
 },
 [0x3220]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH ONE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x4E00, 0x0029 },
  ["unicodeslot"]=0x3220, -- ㈠
 },
 [0x3221]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH TWO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x4E8C, 0x0029 },
  ["unicodeslot"]=0x3221, -- ㈡
 },
 [0x3222]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH THREE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x4E09, 0x0029 },
  ["unicodeslot"]=0x3222, -- ㈢
 },
 [0x3223]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH FOUR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x56DB, 0x0029 },
  ["unicodeslot"]=0x3223, -- ㈣
 },
 [0x3224]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH FIVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x4E94, 0x0029 },
  ["unicodeslot"]=0x3224, -- ㈤
 },
 [0x3225]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH SIX",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x516D, 0x0029 },
  ["unicodeslot"]=0x3225, -- ㈥
 },
 [0x3226]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH SEVEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x4E03, 0x0029 },
  ["unicodeslot"]=0x3226, -- ㈦
 },
 [0x3227]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x516B, 0x0029 },
  ["unicodeslot"]=0x3227, -- ㈧
 },
 [0x3228]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH NINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x4E5D, 0x0029 },
  ["unicodeslot"]=0x3228, -- ㈨
 },
 [0x3229]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH TEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x5341, 0x0029 },
  ["unicodeslot"]=0x3229, -- ㈩
 },
 [0x322A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH MOON",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x6708, 0x0029 },
  ["unicodeslot"]=0x322A, -- ㈪
 },
 [0x322B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH FIRE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x706B, 0x0029 },
  ["unicodeslot"]=0x322B, -- ㈫
 },
 [0x322C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH WATER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x6C34, 0x0029 },
  ["unicodeslot"]=0x322C, -- ㈬
 },
 [0x322D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH WOOD",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x6728, 0x0029 },
  ["unicodeslot"]=0x322D, -- ㈭
 },
 [0x322E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH METAL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x91D1, 0x0029 },
  ["unicodeslot"]=0x322E, -- ㈮
 },
 [0x322F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH EARTH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x571F, 0x0029 },
  ["unicodeslot"]=0x322F, -- ㈯
 },
 [0x3230]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH SUN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x65E5, 0x0029 },
  ["unicodeslot"]=0x3230, -- ㈰
 },
 [0x3231]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH STOCK",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x682A, 0x0029 },
  ["unicodeslot"]=0x3231, -- ㈱
 },
 [0x3232]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH HAVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x6709, 0x0029 },
  ["unicodeslot"]=0x3232, -- ㈲
 },
 [0x3233]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH SOCIETY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x793E, 0x0029 },
  ["unicodeslot"]=0x3233, -- ㈳
 },
 [0x3234]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH NAME",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x540D, 0x0029 },
  ["unicodeslot"]=0x3234, -- ㈴
 },
 [0x3235]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH SPECIAL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x7279, 0x0029 },
  ["unicodeslot"]=0x3235, -- ㈵
 },
 [0x3236]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH FINANCIAL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x8CA1, 0x0029 },
  ["unicodeslot"]=0x3236, -- ㈶
 },
 [0x3237]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH CONGRATULATION",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x795D, 0x0029 },
  ["unicodeslot"]=0x3237, -- ㈷
 },
 [0x3238]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH LABOR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x52B4, 0x0029 },
  ["unicodeslot"]=0x3238, -- ㈸
 },
 [0x3239]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH REPRESENT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x4EE3, 0x0029 },
  ["unicodeslot"]=0x3239, -- ㈹
 },
 [0x323A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH CALL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x547C, 0x0029 },
  ["unicodeslot"]=0x323A, -- ㈺
 },
 [0x323B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH STUDY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x5B66, 0x0029 },
  ["unicodeslot"]=0x323B, -- ㈻
 },
 [0x323C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH SUPERVISE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x76E3, 0x0029 },
  ["unicodeslot"]=0x323C, -- ㈼
 },
 [0x323D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH ENTERPRISE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x4F01, 0x0029 },
  ["unicodeslot"]=0x323D, -- ㈽
 },
 [0x323E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH RESOURCE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x8CC7, 0x0029 },
  ["unicodeslot"]=0x323E, -- ㈾
 },
 [0x323F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH ALLIANCE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x5354, 0x0029 },
  ["unicodeslot"]=0x323F, -- ㈿
 },
 [0x3240]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH FESTIVAL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x796D, 0x0029 },
  ["unicodeslot"]=0x3240, -- ㉀
 },
 [0x3241]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH REST",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x4F11, 0x0029 },
  ["unicodeslot"]=0x3241, -- ㉁
 },
 [0x3242]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH SELF",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x81EA, 0x0029 },
  ["unicodeslot"]=0x3242, -- ㉂
 },
 [0x3243]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARENTHESIZED IDEOGRAPH REACH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0028, 0x81F3, 0x0029 },
  ["unicodeslot"]=0x3243, -- ㉃
 },
 [0x3250]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="PARTNERSHIP SIGN",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0050, 0x0054, 0x0045 },
  ["unicodeslot"]=0x3250, -- ㉐
 },
 [0x3251]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER TWENTY ONE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0032, 0x0031 },
  ["unicodeslot"]=0x3251, -- ㉑
 },
 [0x3252]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER TWENTY TWO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0032, 0x0032 },
  ["unicodeslot"]=0x3252, -- ㉒
 },
 [0x3253]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER TWENTY THREE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0032, 0x0033 },
  ["unicodeslot"]=0x3253, -- ㉓
 },
 [0x3254]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER TWENTY FOUR",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0032, 0x0034 },
  ["unicodeslot"]=0x3254, -- ㉔
 },
 [0x3255]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER TWENTY FIVE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0032, 0x0035 },
  ["unicodeslot"]=0x3255, -- ㉕
 },
 [0x3256]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER TWENTY SIX",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0032, 0x0036 },
  ["unicodeslot"]=0x3256, -- ㉖
 },
 [0x3257]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER TWENTY SEVEN",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0032, 0x0037 },
  ["unicodeslot"]=0x3257, -- ㉗
 },
 [0x3258]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER TWENTY EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0032, 0x0038 },
  ["unicodeslot"]=0x3258, -- ㉘
 },
 [0x3259]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER TWENTY NINE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0032, 0x0039 },
  ["unicodeslot"]=0x3259, -- ㉙
 },
 [0x325A]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0030 },
  ["unicodeslot"]=0x325A, -- ㉚
 },
 [0x325B]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY ONE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0031 },
  ["unicodeslot"]=0x325B, -- ㉛
 },
 [0x325C]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY TWO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0032 },
  ["unicodeslot"]=0x325C, -- ㉜
 },
 [0x325D]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY THREE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0033 },
  ["unicodeslot"]=0x325D, -- ㉝
 },
 [0x325E]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY FOUR",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0034 },
  ["unicodeslot"]=0x325E, -- ㉞
 },
 [0x325F]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY FIVE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0035 },
  ["unicodeslot"]=0x325F, -- ㉟
 },
 [0x3260]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL KIYEOK",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1100 },
  ["unicodeslot"]=0x3260, -- ㉠
 },
 [0x3261]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL NIEUN",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1102 },
  ["unicodeslot"]=0x3261, -- ㉡
 },
 [0x3262]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL TIKEUT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1103 },
  ["unicodeslot"]=0x3262, -- ㉢
 },
 [0x3263]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL RIEUL",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1105 },
  ["unicodeslot"]=0x3263, -- ㉣
 },
 [0x3264]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL MIEUM",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1106 },
  ["unicodeslot"]=0x3264, -- ㉤
 },
 [0x3265]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL PIEUP",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1107 },
  ["unicodeslot"]=0x3265, -- ㉥
 },
 [0x3266]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL SIOS",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1109 },
  ["unicodeslot"]=0x3266, -- ㉦
 },
 [0x3267]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL IEUNG",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110B },
  ["unicodeslot"]=0x3267, -- ㉧
 },
 [0x3268]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL CIEUC",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110C },
  ["unicodeslot"]=0x3268, -- ㉨
 },
 [0x3269]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL CHIEUCH",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110E },
  ["unicodeslot"]=0x3269, -- ㉩
 },
 [0x326A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL KHIEUKH",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110F },
  ["unicodeslot"]=0x326A, -- ㉪
 },
 [0x326B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL THIEUTH",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1110 },
  ["unicodeslot"]=0x326B, -- ㉫
 },
 [0x326C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL PHIEUPH",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1111 },
  ["unicodeslot"]=0x326C, -- ㉬
 },
 [0x326D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL HIEUH",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1112 },
  ["unicodeslot"]=0x326D, -- ㉭
 },
 [0x326E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL KIYEOK A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1100, 0x1161 },
  ["unicodeslot"]=0x326E, -- ㉮
 },
 [0x326F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL NIEUN A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1102, 0x1161 },
  ["unicodeslot"]=0x326F, -- ㉯
 },
 [0x3270]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL TIKEUT A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1103, 0x1161 },
  ["unicodeslot"]=0x3270, -- ㉰
 },
 [0x3271]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL RIEUL A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1105, 0x1161 },
  ["unicodeslot"]=0x3271, -- ㉱
 },
 [0x3272]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL MIEUM A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1106, 0x1161 },
  ["unicodeslot"]=0x3272, -- ㉲
 },
 [0x3273]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL PIEUP A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1107, 0x1161 },
  ["unicodeslot"]=0x3273, -- ㉳
 },
 [0x3274]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL SIOS A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1109, 0x1161 },
  ["unicodeslot"]=0x3274, -- ㉴
 },
 [0x3275]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL IEUNG A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110B, 0x1161 },
  ["unicodeslot"]=0x3275, -- ㉵
 },
 [0x3276]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL CIEUC A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110C, 0x1161 },
  ["unicodeslot"]=0x3276, -- ㉶
 },
 [0x3277]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL CHIEUCH A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110E, 0x1161 },
  ["unicodeslot"]=0x3277, -- ㉷
 },
 [0x3278]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL KHIEUKH A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110F, 0x1161 },
  ["unicodeslot"]=0x3278, -- ㉸
 },
 [0x3279]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL THIEUTH A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1110, 0x1161 },
  ["unicodeslot"]=0x3279, -- ㉹
 },
 [0x327A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL PHIEUPH A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1111, 0x1161 },
  ["unicodeslot"]=0x327A, -- ㉺
 },
 [0x327B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL HIEUH A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x1112, 0x1161 },
  ["unicodeslot"]=0x327B, -- ㉻
 },
 [0x327C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KOREAN CHARACTER CHAMKO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110E, 0x1161, 0x11B7, 0x1100, 0x1169 },
  ["unicodeslot"]=0x327C, -- ㉼
 },
 [0x327D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KOREAN CHARACTER JUEUI",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110C, 0x116E, 0x110B, 0x1174 },
  ["unicodeslot"]=0x327D, -- ㉽
 },
 [0x327E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED HANGUL IEUNG U",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x110B, 0x116E },
  ["unicodeslot"]=0x327E, -- ㉾
 },
 [0x327F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="KOREAN STANDARD SYMBOL",
  ["linebreak"]="id",
  ["unicodeslot"]=0x327F, -- ㉿
 },
 [0x3280]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH ONE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4E00 },
  ["unicodeslot"]=0x3280, -- ㊀
 },
 [0x3281]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH TWO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4E8C },
  ["unicodeslot"]=0x3281, -- ㊁
 },
 [0x3282]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH THREE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4E09 },
  ["unicodeslot"]=0x3282, -- ㊂
 },
 [0x3283]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH FOUR",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x56DB },
  ["unicodeslot"]=0x3283, -- ㊃
 },
 [0x3284]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH FIVE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4E94 },
  ["unicodeslot"]=0x3284, -- ㊄
 },
 [0x3285]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH SIX",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x516D },
  ["unicodeslot"]=0x3285, -- ㊅
 },
 [0x3286]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH SEVEN",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4E03 },
  ["unicodeslot"]=0x3286, -- ㊆
 },
 [0x3287]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x516B },
  ["unicodeslot"]=0x3287, -- ㊇
 },
 [0x3288]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH NINE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4E5D },
  ["unicodeslot"]=0x3288, -- ㊈
 },
 [0x3289]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH TEN",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x5341 },
  ["unicodeslot"]=0x3289, -- ㊉
 },
 [0x328A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH MOON",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x6708 },
  ["unicodeslot"]=0x328A, -- ㊊
 },
 [0x328B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH FIRE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x706B },
  ["unicodeslot"]=0x328B, -- ㊋
 },
 [0x328C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH WATER",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x6C34 },
  ["unicodeslot"]=0x328C, -- ㊌
 },
 [0x328D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH WOOD",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x6728 },
  ["unicodeslot"]=0x328D, -- ㊍
 },
 [0x328E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH METAL",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x91D1 },
  ["unicodeslot"]=0x328E, -- ㊎
 },
 [0x328F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH EARTH",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x571F },
  ["unicodeslot"]=0x328F, -- ㊏
 },
 [0x3290]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH SUN",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x65E5 },
  ["unicodeslot"]=0x3290, -- ㊐
 },
 [0x3291]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH STOCK",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x682A },
  ["unicodeslot"]=0x3291, -- ㊑
 },
 [0x3292]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH HAVE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x6709 },
  ["unicodeslot"]=0x3292, -- ㊒
 },
 [0x3293]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH SOCIETY",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x793E },
  ["unicodeslot"]=0x3293, -- ㊓
 },
 [0x3294]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH NAME",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x540D },
  ["unicodeslot"]=0x3294, -- ㊔
 },
 [0x3295]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH SPECIAL",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x7279 },
  ["unicodeslot"]=0x3295, -- ㊕
 },
 [0x3296]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH FINANCIAL",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x8CA1 },
  ["unicodeslot"]=0x3296, -- ㊖
 },
 [0x3297]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH CONGRATULATION",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x795D },
  ["unicodeslot"]=0x3297, -- ㊗
 },
 [0x3298]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH LABOR",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x52B4 },
  ["unicodeslot"]=0x3298, -- ㊘
 },
 [0x3299]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH SECRET",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x79D8 },
  ["unicodeslot"]=0x3299, -- ㊙
 },
 [0x329A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH MALE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x7537 },
  ["unicodeslot"]=0x329A, -- ㊚
 },
 [0x329B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH FEMALE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x5973 },
  ["unicodeslot"]=0x329B, -- ㊛
 },
 [0x329C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH SUITABLE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x9069 },
  ["unicodeslot"]=0x329C, -- ㊜
 },
 [0x329D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH EXCELLENT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x512A },
  ["unicodeslot"]=0x329D, -- ㊝
 },
 [0x329E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH PRINT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x5370 },
  ["unicodeslot"]=0x329E, -- ㊞
 },
 [0x329F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH ATTENTION",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x6CE8 },
  ["unicodeslot"]=0x329F, -- ㊟
 },
 [0x32A0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH ITEM",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x9805 },
  ["unicodeslot"]=0x32A0, -- ㊠
 },
 [0x32A1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH REST",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4F11 },
  ["unicodeslot"]=0x32A1, -- ㊡
 },
 [0x32A2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH COPY",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x5199 },
  ["unicodeslot"]=0x32A2, -- ㊢
 },
 [0x32A3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH CORRECT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x6B63 },
  ["unicodeslot"]=0x32A3, -- ㊣
 },
 [0x32A4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH HIGH",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4E0A },
  ["unicodeslot"]=0x32A4, -- ㊤
 },
 [0x32A5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH CENTRE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4E2D },
  ["unicodeslot"]=0x32A5, -- ㊥
 },
 [0x32A6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH LOW",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4E0B },
  ["unicodeslot"]=0x32A6, -- ㊦
 },
 [0x32A7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH LEFT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x5DE6 },
  ["unicodeslot"]=0x32A7, -- ㊧
 },
 [0x32A8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH RIGHT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x53F3 },
  ["unicodeslot"]=0x32A8, -- ㊨
 },
 [0x32A9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH MEDICINE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x533B },
  ["unicodeslot"]=0x32A9, -- ㊩
 },
 [0x32AA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH RELIGION",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x5B97 },
  ["unicodeslot"]=0x32AA, -- ㊪
 },
 [0x32AB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH STUDY",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x5B66 },
  ["unicodeslot"]=0x32AB, -- ㊫
 },
 [0x32AC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH SUPERVISE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x76E3 },
  ["unicodeslot"]=0x32AC, -- ㊬
 },
 [0x32AD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH ENTERPRISE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x4F01 },
  ["unicodeslot"]=0x32AD, -- ㊭
 },
 [0x32AE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH RESOURCE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x8CC7 },
  ["unicodeslot"]=0x32AE, -- ㊮
 },
 [0x32AF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH ALLIANCE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x5354 },
  ["unicodeslot"]=0x32AF, -- ㊯
 },
 [0x32B0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED IDEOGRAPH NIGHT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x591C },
  ["unicodeslot"]=0x32B0, -- ㊰
 },
 [0x32B1]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY SIX",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0036 },
  ["unicodeslot"]=0x32B1, -- ㊱
 },
 [0x32B2]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY SEVEN",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0037 },
  ["unicodeslot"]=0x32B2, -- ㊲
 },
 [0x32B3]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0038 },
  ["unicodeslot"]=0x32B3, -- ㊳
 },
 [0x32B4]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER THIRTY NINE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0033, 0x0039 },
  ["unicodeslot"]=0x32B4, -- ㊴
 },
 [0x32B5]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0030 },
  ["unicodeslot"]=0x32B5, -- ㊵
 },
 [0x32B6]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY ONE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0031 },
  ["unicodeslot"]=0x32B6, -- ㊶
 },
 [0x32B7]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY TWO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0032 },
  ["unicodeslot"]=0x32B7, -- ㊷
 },
 [0x32B8]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY THREE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0033 },
  ["unicodeslot"]=0x32B8, -- ㊸
 },
 [0x32B9]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY FOUR",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0034 },
  ["unicodeslot"]=0x32B9, -- ㊹
 },
 [0x32BA]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY FIVE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0035 },
  ["unicodeslot"]=0x32BA, -- ㊺
 },
 [0x32BB]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY SIX",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0036 },
  ["unicodeslot"]=0x32BB, -- ㊻
 },
 [0x32BC]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY SEVEN",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0037 },
  ["unicodeslot"]=0x32BC, -- ㊼
 },
 [0x32BD]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0038 },
  ["unicodeslot"]=0x32BD, -- ㊽
 },
 [0x32BE]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FORTY NINE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0034, 0x0039 },
  ["unicodeslot"]=0x32BE, -- ㊾
 },
 [0x32BF]={
  ["category"]="no",
  ["cjkwd"]="w",
  ["description"]="CIRCLED NUMBER FIFTY",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x0035, 0x0030 },
  ["unicodeslot"]=0x32BF, -- ㊿
 },
 [0x32C0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR JANUARY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x6708 },
  ["unicodeslot"]=0x32C0, -- ㋀
 },
 [0x32C1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR FEBRUARY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x6708 },
  ["unicodeslot"]=0x32C1, -- ㋁
 },
 [0x32C2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR MARCH",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0033, 0x6708 },
  ["unicodeslot"]=0x32C2, -- ㋂
 },
 [0x32C3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR APRIL",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0034, 0x6708 },
  ["unicodeslot"]=0x32C3, -- ㋃
 },
 [0x32C4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR MAY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0035, 0x6708 },
  ["unicodeslot"]=0x32C4, -- ㋄
 },
 [0x32C5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR JUNE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0036, 0x6708 },
  ["unicodeslot"]=0x32C5, -- ㋅
 },
 [0x32C6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR JULY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0037, 0x6708 },
  ["unicodeslot"]=0x32C6, -- ㋆
 },
 [0x32C7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR AUGUST",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0038, 0x6708 },
  ["unicodeslot"]=0x32C7, -- ㋇
 },
 [0x32C8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR SEPTEMBER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0039, 0x6708 },
  ["unicodeslot"]=0x32C8, -- ㋈
 },
 [0x32C9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR OCTOBER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0030, 0x6708 },
  ["unicodeslot"]=0x32C9, -- ㋉
 },
 [0x32CA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR NOVEMBER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0031, 0x6708 },
  ["unicodeslot"]=0x32CA, -- ㋊
 },
 [0x32CB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DECEMBER",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0032, 0x6708 },
  ["unicodeslot"]=0x32CB, -- ㋋
 },
 [0x32CC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HG",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0048, 0x0067 },
  ["unicodeslot"]=0x32CC, -- ㋌
 },
 [0x32CD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ERG",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0065, 0x0072, 0x0067 },
  ["unicodeslot"]=0x32CD, -- ㋍
 },
 [0x32CE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE EV",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0065, 0x0056 },
  ["unicodeslot"]=0x32CE, -- ㋎
 },
 [0x32CF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="LIMITED LIABILITY SIGN",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004C, 0x0054, 0x0044 },
  ["unicodeslot"]=0x32CF, -- ㋏
 },
 [0x32D0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA A",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30A2 },
  ["unicodeslot"]=0x32D0, -- ㋐
 },
 [0x32D1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA I",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30A4 },
  ["unicodeslot"]=0x32D1, -- ㋑
 },
 [0x32D2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA U",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30A6 },
  ["unicodeslot"]=0x32D2, -- ㋒
 },
 [0x32D3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA E",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30A8 },
  ["unicodeslot"]=0x32D3, -- ㋓
 },
 [0x32D4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA O",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30AA },
  ["unicodeslot"]=0x32D4, -- ㋔
 },
 [0x32D5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA KA",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30AB },
  ["unicodeslot"]=0x32D5, -- ㋕
 },
 [0x32D6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA KI",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30AD },
  ["unicodeslot"]=0x32D6, -- ㋖
 },
 [0x32D7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA KU",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30AF },
  ["unicodeslot"]=0x32D7, -- ㋗
 },
 [0x32D8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA KE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30B1 },
  ["unicodeslot"]=0x32D8, -- ㋘
 },
 [0x32D9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA KO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30B3 },
  ["unicodeslot"]=0x32D9, -- ㋙
 },
 [0x32DA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA SA",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30B5 },
  ["unicodeslot"]=0x32DA, -- ㋚
 },
 [0x32DB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA SI",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30B7 },
  ["unicodeslot"]=0x32DB, -- ㋛
 },
 [0x32DC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA SU",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30B9 },
  ["unicodeslot"]=0x32DC, -- ㋜
 },
 [0x32DD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA SE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30BB },
  ["unicodeslot"]=0x32DD, -- ㋝
 },
 [0x32DE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA SO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30BD },
  ["unicodeslot"]=0x32DE, -- ㋞
 },
 [0x32DF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA TA",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30BF },
  ["unicodeslot"]=0x32DF, -- ㋟
 },
 [0x32E0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA TI",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30C1 },
  ["unicodeslot"]=0x32E0, -- ㋠
 },
 [0x32E1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA TU",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30C4 },
  ["unicodeslot"]=0x32E1, -- ㋡
 },
 [0x32E2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA TE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30C6 },
  ["unicodeslot"]=0x32E2, -- ㋢
 },
 [0x32E3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA TO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30C8 },
  ["unicodeslot"]=0x32E3, -- ㋣
 },
 [0x32E4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA NA",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30CA },
  ["unicodeslot"]=0x32E4, -- ㋤
 },
 [0x32E5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA NI",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30CB },
  ["unicodeslot"]=0x32E5, -- ㋥
 },
 [0x32E6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA NU",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30CC },
  ["unicodeslot"]=0x32E6, -- ㋦
 },
 [0x32E7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA NE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30CD },
  ["unicodeslot"]=0x32E7, -- ㋧
 },
 [0x32E8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA NO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30CE },
  ["unicodeslot"]=0x32E8, -- ㋨
 },
 [0x32E9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA HA",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30CF },
  ["unicodeslot"]=0x32E9, -- ㋩
 },
 [0x32EA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA HI",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30D2 },
  ["unicodeslot"]=0x32EA, -- ㋪
 },
 [0x32EB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA HU",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30D5 },
  ["unicodeslot"]=0x32EB, -- ㋫
 },
 [0x32EC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA HE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30D8 },
  ["unicodeslot"]=0x32EC, -- ㋬
 },
 [0x32ED]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA HO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30DB },
  ["unicodeslot"]=0x32ED, -- ㋭
 },
 [0x32EE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA MA",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30DE },
  ["unicodeslot"]=0x32EE, -- ㋮
 },
 [0x32EF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA MI",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30DF },
  ["unicodeslot"]=0x32EF, -- ㋯
 },
 [0x32F0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA MU",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30E0 },
  ["unicodeslot"]=0x32F0, -- ㋰
 },
 [0x32F1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA ME",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30E1 },
  ["unicodeslot"]=0x32F1, -- ㋱
 },
 [0x32F2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA MO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30E2 },
  ["unicodeslot"]=0x32F2, -- ㋲
 },
 [0x32F3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA YA",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30E4 },
  ["unicodeslot"]=0x32F3, -- ㋳
 },
 [0x32F4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA YU",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30E6 },
  ["unicodeslot"]=0x32F4, -- ㋴
 },
 [0x32F5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA YO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30E8 },
  ["unicodeslot"]=0x32F5, -- ㋵
 },
 [0x32F6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA RA",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30E9 },
  ["unicodeslot"]=0x32F6, -- ㋶
 },
 [0x32F7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA RI",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30EA },
  ["unicodeslot"]=0x32F7, -- ㋷
 },
 [0x32F8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA RU",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30EB },
  ["unicodeslot"]=0x32F8, -- ㋸
 },
 [0x32F9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA RE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30EC },
  ["unicodeslot"]=0x32F9, -- ㋹
 },
 [0x32FA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA RO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30ED },
  ["unicodeslot"]=0x32FA, -- ㋺
 },
 [0x32FB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA WA",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30EF },
  ["unicodeslot"]=0x32FB, -- ㋻
 },
 [0x32FC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA WI",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30F0 },
  ["unicodeslot"]=0x32FC, -- ㋼
 },
 [0x32FD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA WE",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30F1 },
  ["unicodeslot"]=0x32FD, -- ㋽
 },
 [0x32FE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="CIRCLED KATAKANA WO",
  ["linebreak"]="id",
  ["specials"]={ "circle", 0x30F2 },
  ["unicodeslot"]=0x32FE, -- ㋾
 },
 [0x3300]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE APAATO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30A2, 0x30D1, 0x30FC, 0x30C8 },
  ["unicodeslot"]=0x3300, -- ㌀
 },
 [0x3301]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ARUHUA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30A2, 0x30EB, 0x30D5, 0x30A1 },
  ["unicodeslot"]=0x3301, -- ㌁
 },
 [0x3302]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ANPEA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30A2, 0x30F3, 0x30DA, 0x30A2 },
  ["unicodeslot"]=0x3302, -- ㌂
 },
 [0x3303]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE AARU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30A2, 0x30FC, 0x30EB },
  ["unicodeslot"]=0x3303, -- ㌃
 },
 [0x3304]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ININGU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30A4, 0x30CB, 0x30F3, 0x30B0 },
  ["unicodeslot"]=0x3304, -- ㌄
 },
 [0x3305]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE INTI",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30A4, 0x30F3, 0x30C1 },
  ["unicodeslot"]=0x3305, -- ㌅
 },
 [0x3306]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE UON",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30A6, 0x30A9, 0x30F3 },
  ["unicodeslot"]=0x3306, -- ㌆
 },
 [0x3307]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ESUKUUDO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30A8, 0x30B9, 0x30AF, 0x30FC, 0x30C9 },
  ["unicodeslot"]=0x3307, -- ㌇
 },
 [0x3308]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE EEKAA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30A8, 0x30FC, 0x30AB, 0x30FC },
  ["unicodeslot"]=0x3308, -- ㌈
 },
 [0x3309]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ONSU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AA, 0x30F3, 0x30B9 },
  ["unicodeslot"]=0x3309, -- ㌉
 },
 [0x330A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE OOMU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AA, 0x30FC, 0x30E0 },
  ["unicodeslot"]=0x330A, -- ㌊
 },
 [0x330B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KAIRI",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AB, 0x30A4, 0x30EA },
  ["unicodeslot"]=0x330B, -- ㌋
 },
 [0x330C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KARATTO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AB, 0x30E9, 0x30C3, 0x30C8 },
  ["unicodeslot"]=0x330C, -- ㌌
 },
 [0x330D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KARORII",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AB, 0x30ED, 0x30EA, 0x30FC },
  ["unicodeslot"]=0x330D, -- ㌍
 },
 [0x330E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GARON",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AC, 0x30ED, 0x30F3 },
  ["unicodeslot"]=0x330E, -- ㌎
 },
 [0x330F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GANMA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AC, 0x30F3, 0x30DE },
  ["unicodeslot"]=0x330F, -- ㌏
 },
 [0x3310]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GIGA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AE, 0x30AC },
  ["unicodeslot"]=0x3310, -- ㌐
 },
 [0x3311]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GINII",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AE, 0x30CB, 0x30FC },
  ["unicodeslot"]=0x3311, -- ㌑
 },
 [0x3312]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KYURII",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AD, 0x30E5, 0x30EA, 0x30FC },
  ["unicodeslot"]=0x3312, -- ㌒
 },
 [0x3313]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GIRUDAA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AE, 0x30EB, 0x30C0, 0x30FC },
  ["unicodeslot"]=0x3313, -- ㌓
 },
 [0x3314]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KIRO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AD, 0x30ED },
  ["unicodeslot"]=0x3314, -- ㌔
 },
 [0x3315]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KIROGURAMU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AD, 0x30ED, 0x30B0, 0x30E9, 0x30E0 },
  ["unicodeslot"]=0x3315, -- ㌕
 },
 [0x3316]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KIROMEETORU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AD, 0x30ED, 0x30E1, 0x30FC, 0x30C8, 0x30EB },
  ["unicodeslot"]=0x3316, -- ㌖
 },
 [0x3317]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KIROWATTO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AD, 0x30ED, 0x30EF, 0x30C3, 0x30C8 },
  ["unicodeslot"]=0x3317, -- ㌗
 },
 [0x3318]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GURAMU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30B0, 0x30E9, 0x30E0 },
  ["unicodeslot"]=0x3318, -- ㌘
 },
 [0x3319]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GURAMUTON",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30B0, 0x30E9, 0x30E0, 0x30C8, 0x30F3 },
  ["unicodeslot"]=0x3319, -- ㌙
 },
 [0x331A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KURUZEIRO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AF, 0x30EB, 0x30BC, 0x30A4, 0x30ED },
  ["unicodeslot"]=0x331A, -- ㌚
 },
 [0x331B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KUROONE",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30AF, 0x30ED, 0x30FC, 0x30CD },
  ["unicodeslot"]=0x331B, -- ㌛
 },
 [0x331C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KEESU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30B1, 0x30FC, 0x30B9 },
  ["unicodeslot"]=0x331C, -- ㌜
 },
 [0x331D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KORUNA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30B3, 0x30EB, 0x30CA },
  ["unicodeslot"]=0x331D, -- ㌝
 },
 [0x331E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KOOPO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30B3, 0x30FC, 0x30DD },
  ["unicodeslot"]=0x331E, -- ㌞
 },
 [0x331F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE SAIKURU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30B5, 0x30A4, 0x30AF, 0x30EB },
  ["unicodeslot"]=0x331F, -- ㌟
 },
 [0x3320]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE SANTIIMU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30B5, 0x30F3, 0x30C1, 0x30FC, 0x30E0 },
  ["unicodeslot"]=0x3320, -- ㌠
 },
 [0x3321]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE SIRINGU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30B7, 0x30EA, 0x30F3, 0x30B0 },
  ["unicodeslot"]=0x3321, -- ㌡
 },
 [0x3322]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE SENTI",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30BB, 0x30F3, 0x30C1 },
  ["unicodeslot"]=0x3322, -- ㌢
 },
 [0x3323]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE SENTO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30BB, 0x30F3, 0x30C8 },
  ["unicodeslot"]=0x3323, -- ㌣
 },
 [0x3324]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE DAASU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30C0, 0x30FC, 0x30B9 },
  ["unicodeslot"]=0x3324, -- ㌤
 },
 [0x3325]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE DESI",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30C7, 0x30B7 },
  ["unicodeslot"]=0x3325, -- ㌥
 },
 [0x3326]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE DORU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30C9, 0x30EB },
  ["unicodeslot"]=0x3326, -- ㌦
 },
 [0x3327]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE TON",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30C8, 0x30F3 },
  ["unicodeslot"]=0x3327, -- ㌧
 },
 [0x3328]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE NANO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30CA, 0x30CE },
  ["unicodeslot"]=0x3328, -- ㌨
 },
 [0x3329]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE NOTTO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30CE, 0x30C3, 0x30C8 },
  ["unicodeslot"]=0x3329, -- ㌩
 },
 [0x332A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HAITU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30CF, 0x30A4, 0x30C4 },
  ["unicodeslot"]=0x332A, -- ㌪
 },
 [0x332B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PAASENTO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D1, 0x30FC, 0x30BB, 0x30F3, 0x30C8 },
  ["unicodeslot"]=0x332B, -- ㌫
 },
 [0x332C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PAATU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D1, 0x30FC, 0x30C4 },
  ["unicodeslot"]=0x332C, -- ㌬
 },
 [0x332D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE BAARERU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D0, 0x30FC, 0x30EC, 0x30EB },
  ["unicodeslot"]=0x332D, -- ㌭
 },
 [0x332E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PIASUTORU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D4, 0x30A2, 0x30B9, 0x30C8, 0x30EB },
  ["unicodeslot"]=0x332E, -- ㌮
 },
 [0x332F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PIKURU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D4, 0x30AF, 0x30EB },
  ["unicodeslot"]=0x332F, -- ㌯
 },
 [0x3330]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PIKO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D4, 0x30B3 },
  ["unicodeslot"]=0x3330, -- ㌰
 },
 [0x3331]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE BIRU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D3, 0x30EB },
  ["unicodeslot"]=0x3331, -- ㌱
 },
 [0x3332]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HUARADDO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D5, 0x30A1, 0x30E9, 0x30C3, 0x30C9 },
  ["unicodeslot"]=0x3332, -- ㌲
 },
 [0x3333]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HUIITO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D5, 0x30A3, 0x30FC, 0x30C8 },
  ["unicodeslot"]=0x3333, -- ㌳
 },
 [0x3334]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE BUSSYERU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D6, 0x30C3, 0x30B7, 0x30A7, 0x30EB },
  ["unicodeslot"]=0x3334, -- ㌴
 },
 [0x3335]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HURAN",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D5, 0x30E9, 0x30F3 },
  ["unicodeslot"]=0x3335, -- ㌵
 },
 [0x3336]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HEKUTAARU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D8, 0x30AF, 0x30BF, 0x30FC, 0x30EB },
  ["unicodeslot"]=0x3336, -- ㌶
 },
 [0x3337]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PESO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DA, 0x30BD },
  ["unicodeslot"]=0x3337, -- ㌷
 },
 [0x3338]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PENIHI",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DA, 0x30CB, 0x30D2 },
  ["unicodeslot"]=0x3338, -- ㌸
 },
 [0x3339]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HERUTU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D8, 0x30EB, 0x30C4 },
  ["unicodeslot"]=0x3339, -- ㌹
 },
 [0x333A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PENSU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DA, 0x30F3, 0x30B9 },
  ["unicodeslot"]=0x333A, -- ㌺
 },
 [0x333B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PEEZI",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DA, 0x30FC, 0x30B8 },
  ["unicodeslot"]=0x333B, -- ㌻
 },
 [0x333C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE BEETA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30D9, 0x30FC, 0x30BF },
  ["unicodeslot"]=0x333C, -- ㌼
 },
 [0x333D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE POINTO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DD, 0x30A4, 0x30F3, 0x30C8 },
  ["unicodeslot"]=0x333D, -- ㌽
 },
 [0x333E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE BORUTO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DC, 0x30EB, 0x30C8 },
  ["unicodeslot"]=0x333E, -- ㌾
 },
 [0x333F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HON",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DB, 0x30F3 },
  ["unicodeslot"]=0x333F, -- ㌿
 },
 [0x3340]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PONDO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DD, 0x30F3, 0x30C9 },
  ["unicodeslot"]=0x3340, -- ㍀
 },
 [0x3341]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HOORU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DB, 0x30FC, 0x30EB },
  ["unicodeslot"]=0x3341, -- ㍁
 },
 [0x3342]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HOON",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DB, 0x30FC, 0x30F3 },
  ["unicodeslot"]=0x3342, -- ㍂
 },
 [0x3343]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MAIKURO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DE, 0x30A4, 0x30AF, 0x30ED },
  ["unicodeslot"]=0x3343, -- ㍃
 },
 [0x3344]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MAIRU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DE, 0x30A4, 0x30EB },
  ["unicodeslot"]=0x3344, -- ㍄
 },
 [0x3345]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MAHHA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DE, 0x30C3, 0x30CF },
  ["unicodeslot"]=0x3345, -- ㍅
 },
 [0x3346]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MARUKU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DE, 0x30EB, 0x30AF },
  ["unicodeslot"]=0x3346, -- ㍆
 },
 [0x3347]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MANSYON",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DE, 0x30F3, 0x30B7, 0x30E7, 0x30F3 },
  ["unicodeslot"]=0x3347, -- ㍇
 },
 [0x3348]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MIKURON",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DF, 0x30AF, 0x30ED, 0x30F3 },
  ["unicodeslot"]=0x3348, -- ㍈
 },
 [0x3349]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MIRI",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DF, 0x30EA },
  ["unicodeslot"]=0x3349, -- ㍉
 },
 [0x334A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MIRIBAARU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30DF, 0x30EA, 0x30D0, 0x30FC, 0x30EB },
  ["unicodeslot"]=0x334A, -- ㍊
 },
 [0x334B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MEGA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30E1, 0x30AC },
  ["unicodeslot"]=0x334B, -- ㍋
 },
 [0x334C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MEGATON",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30E1, 0x30AC, 0x30C8, 0x30F3 },
  ["unicodeslot"]=0x334C, -- ㍌
 },
 [0x334D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MEETORU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30E1, 0x30FC, 0x30C8, 0x30EB },
  ["unicodeslot"]=0x334D, -- ㍍
 },
 [0x334E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE YAADO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30E4, 0x30FC, 0x30C9 },
  ["unicodeslot"]=0x334E, -- ㍎
 },
 [0x334F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE YAARU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30E4, 0x30FC, 0x30EB },
  ["unicodeslot"]=0x334F, -- ㍏
 },
 [0x3350]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE YUAN",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30E6, 0x30A2, 0x30F3 },
  ["unicodeslot"]=0x3350, -- ㍐
 },
 [0x3351]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE RITTORU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30EA, 0x30C3, 0x30C8, 0x30EB },
  ["unicodeslot"]=0x3351, -- ㍑
 },
 [0x3352]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE RIRA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30EA, 0x30E9 },
  ["unicodeslot"]=0x3352, -- ㍒
 },
 [0x3353]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE RUPII",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30EB, 0x30D4, 0x30FC },
  ["unicodeslot"]=0x3353, -- ㍓
 },
 [0x3354]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE RUUBURU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30EB, 0x30FC, 0x30D6, 0x30EB },
  ["unicodeslot"]=0x3354, -- ㍔
 },
 [0x3355]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE REMU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30EC, 0x30E0 },
  ["unicodeslot"]=0x3355, -- ㍕
 },
 [0x3356]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE RENTOGEN",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30EC, 0x30F3, 0x30C8, 0x30B2, 0x30F3 },
  ["unicodeslot"]=0x3356, -- ㍖
 },
 [0x3357]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE WATTO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x30EF, 0x30C3, 0x30C8 },
  ["unicodeslot"]=0x3357, -- ㍗
 },
 [0x3358]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ZERO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0030, 0x70B9 },
  ["unicodeslot"]=0x3358, -- ㍘
 },
 [0x3359]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ONE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x70B9 },
  ["unicodeslot"]=0x3359, -- ㍙
 },
 [0x335A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x70B9 },
  ["unicodeslot"]=0x335A, -- ㍚
 },
 [0x335B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THREE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0033, 0x70B9 },
  ["unicodeslot"]=0x335B, -- ㍛
 },
 [0x335C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOUR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0034, 0x70B9 },
  ["unicodeslot"]=0x335C, -- ㍜
 },
 [0x335D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0035, 0x70B9 },
  ["unicodeslot"]=0x335D, -- ㍝
 },
 [0x335E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIX",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0036, 0x70B9 },
  ["unicodeslot"]=0x335E, -- ㍞
 },
 [0x335F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0037, 0x70B9 },
  ["unicodeslot"]=0x335F, -- ㍟
 },
 [0x3360]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0038, 0x70B9 },
  ["unicodeslot"]=0x3360, -- ㍠
 },
 [0x3361]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0039, 0x70B9 },
  ["unicodeslot"]=0x3361, -- ㍡
 },
 [0x3362]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0030, 0x70B9 },
  ["unicodeslot"]=0x3362, -- ㍢
 },
 [0x3363]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ELEVEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0031, 0x70B9 },
  ["unicodeslot"]=0x3363, -- ㍣
 },
 [0x3364]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWELVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0032, 0x70B9 },
  ["unicodeslot"]=0x3364, -- ㍤
 },
 [0x3365]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THIRTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0033, 0x70B9 },
  ["unicodeslot"]=0x3365, -- ㍥
 },
 [0x3366]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOURTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0034, 0x70B9 },
  ["unicodeslot"]=0x3366, -- ㍦
 },
 [0x3367]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIFTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0035, 0x70B9 },
  ["unicodeslot"]=0x3367, -- ㍧
 },
 [0x3368]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIXTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0036, 0x70B9 },
  ["unicodeslot"]=0x3368, -- ㍨
 },
 [0x3369]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVENTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0037, 0x70B9 },
  ["unicodeslot"]=0x3369, -- ㍩
 },
 [0x336A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0038, 0x70B9 },
  ["unicodeslot"]=0x336A, -- ㍪
 },
 [0x336B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINETEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0039, 0x70B9 },
  ["unicodeslot"]=0x336B, -- ㍫
 },
 [0x336C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0030, 0x70B9 },
  ["unicodeslot"]=0x336C, -- ㍬
 },
 [0x336D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-ONE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0031, 0x70B9 },
  ["unicodeslot"]=0x336D, -- ㍭
 },
 [0x336E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-TWO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0032, 0x70B9 },
  ["unicodeslot"]=0x336E, -- ㍮
 },
 [0x336F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-THREE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0033, 0x70B9 },
  ["unicodeslot"]=0x336F, -- ㍯
 },
 [0x3370]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-FOUR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0034, 0x70B9 },
  ["unicodeslot"]=0x3370, -- ㍰
 },
 [0x3371]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HPA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0068, 0x0050, 0x0061 },
  ["unicodeslot"]=0x3371, -- ㍱
 },
 [0x3372]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE DA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0064, 0x0061 },
  ["unicodeslot"]=0x3372, -- ㍲
 },
 [0x3373]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE AU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0041, 0x0055 },
  ["unicodeslot"]=0x3373, -- ㍳
 },
 [0x3374]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE BAR",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0062, 0x0061, 0x0072 },
  ["unicodeslot"]=0x3374, -- ㍴
 },
 [0x3375]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE OV",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006F, 0x0056 },
  ["unicodeslot"]=0x3375, -- ㍵
 },
 [0x3376]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PC",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0070, 0x0063 },
  ["unicodeslot"]=0x3376, -- ㍶
 },
 [0x3377]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE DM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0064, 0x006D },
  ["unicodeslot"]=0x3377, -- ㍷
 },
 [0x3378]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE DM SQUARED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0064, 0x006D, 0x00B2 },
  ["unicodeslot"]=0x3378, -- ㍸
 },
 [0x3379]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE DM CUBED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0064, 0x006D, 0x00B3 },
  ["unicodeslot"]=0x3379, -- ㍹
 },
 [0x337A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE IU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0049, 0x0055 },
  ["unicodeslot"]=0x337A, -- ㍺
 },
 [0x337B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ERA NAME HEISEI",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x5E73, 0x6210 },
  ["unicodeslot"]=0x337B, -- ㍻
 },
 [0x337C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ERA NAME SYOUWA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x662D, 0x548C },
  ["unicodeslot"]=0x337C, -- ㍼
 },
 [0x337D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ERA NAME TAISYOU",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x5927, 0x6B63 },
  ["unicodeslot"]=0x337D, -- ㍽
 },
 [0x337E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ERA NAME MEIZI",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x660E, 0x6CBB },
  ["unicodeslot"]=0x337E, -- ㍾
 },
 [0x337F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE CORPORATION",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x682A, 0x5F0F, 0x4F1A, 0x793E },
  ["unicodeslot"]=0x337F, -- ㍿
 },
 [0x3380]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PA AMPS",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0070, 0x0041 },
  ["unicodeslot"]=0x3380, -- ㎀
 },
 [0x3381]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE NA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006E, 0x0041 },
  ["unicodeslot"]=0x3381, -- ㎁
 },
 [0x3382]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MU A",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x03BC, 0x0041 },
  ["unicodeslot"]=0x3382, -- ㎂
 },
 [0x3383]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x0041 },
  ["unicodeslot"]=0x3383, -- ㎃
 },
 [0x3384]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x0041 },
  ["unicodeslot"]=0x3384, -- ㎄
 },
 [0x3385]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KB",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004B, 0x0042 },
  ["unicodeslot"]=0x3385, -- ㎅
 },
 [0x3386]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MB",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004D, 0x0042 },
  ["unicodeslot"]=0x3386, -- ㎆
 },
 [0x3387]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GB",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0047, 0x0042 },
  ["unicodeslot"]=0x3387, -- ㎇
 },
 [0x3388]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE CAL",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0063, 0x0061, 0x006C },
  ["unicodeslot"]=0x3388, -- ㎈
 },
 [0x3389]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KCAL",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x0063, 0x0061, 0x006C },
  ["unicodeslot"]=0x3389, -- ㎉
 },
 [0x338A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PF",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0070, 0x0046 },
  ["unicodeslot"]=0x338A, -- ㎊
 },
 [0x338B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE NF",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006E, 0x0046 },
  ["unicodeslot"]=0x338B, -- ㎋
 },
 [0x338C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MU F",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x03BC, 0x0046 },
  ["unicodeslot"]=0x338C, -- ㎌
 },
 [0x338D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MU G",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x03BC, 0x0067 },
  ["unicodeslot"]=0x338D, -- ㎍
 },
 [0x338E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MG",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x0067 },
  ["unicodeslot"]=0x338E, -- ㎎
 },
 [0x338F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KG",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x0067 },
  ["unicodeslot"]=0x338F, -- ㎏
 },
 [0x3390]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HZ",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0048, 0x007A },
  ["unicodeslot"]=0x3390, -- ㎐
 },
 [0x3391]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KHZ",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x0048, 0x007A },
  ["unicodeslot"]=0x3391, -- ㎑
 },
 [0x3392]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MHZ",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004D, 0x0048, 0x007A },
  ["unicodeslot"]=0x3392, -- ㎒
 },
 [0x3393]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GHZ",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0047, 0x0048, 0x007A },
  ["unicodeslot"]=0x3393, -- ㎓
 },
 [0x3394]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE THZ",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0054, 0x0048, 0x007A },
  ["unicodeslot"]=0x3394, -- ㎔
 },
 [0x3395]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MU L",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x03BC, 0x2113 },
  ["unicodeslot"]=0x3395, -- ㎕
 },
 [0x3396]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE ML",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x2113 },
  ["unicodeslot"]=0x3396, -- ㎖
 },
 [0x3397]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE DL",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0064, 0x2113 },
  ["unicodeslot"]=0x3397, -- ㎗
 },
 [0x3398]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KL",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x2113 },
  ["unicodeslot"]=0x3398, -- ㎘
 },
 [0x3399]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE FM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0066, 0x006D },
  ["unicodeslot"]=0x3399, -- ㎙
 },
 [0x339A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE NM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006E, 0x006D },
  ["unicodeslot"]=0x339A, -- ㎚
 },
 [0x339B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MU M",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x03BC, 0x006D },
  ["unicodeslot"]=0x339B, -- ㎛
 },
 [0x339C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x006D },
  ["unicodeslot"]=0x339C, -- ㎜
 },
 [0x339D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE CM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0063, 0x006D },
  ["unicodeslot"]=0x339D, -- ㎝
 },
 [0x339E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x006D },
  ["unicodeslot"]=0x339E, -- ㎞
 },
 [0x339F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MM SQUARED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x006D, 0x00B2 },
  ["unicodeslot"]=0x339F, -- ㎟
 },
 [0x33A0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE CM SQUARED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0063, 0x006D, 0x00B2 },
  ["unicodeslot"]=0x33A0, -- ㎠
 },
 [0x33A1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE M SQUARED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x00B2 },
  ["unicodeslot"]=0x33A1, -- ㎡
 },
 [0x33A2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KM SQUARED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x006D, 0x00B2 },
  ["unicodeslot"]=0x33A2, -- ㎢
 },
 [0x33A3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MM CUBED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x006D, 0x00B3 },
  ["unicodeslot"]=0x33A3, -- ㎣
 },
 [0x33A4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE CM CUBED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0063, 0x006D, 0x00B3 },
  ["unicodeslot"]=0x33A4, -- ㎤
 },
 [0x33A5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE M CUBED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x00B3 },
  ["unicodeslot"]=0x33A5, -- ㎥
 },
 [0x33A6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KM CUBED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x006D, 0x00B3 },
  ["unicodeslot"]=0x33A6, -- ㎦
 },
 [0x33A7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE M OVER S",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x2215, 0x0073 },
  ["unicodeslot"]=0x33A7, -- ㎧
 },
 [0x33A8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE M OVER S SQUARED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x2215, 0x0073, 0x00B2 },
  ["unicodeslot"]=0x33A8, -- ㎨
 },
 [0x33A9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0050, 0x0061 },
  ["unicodeslot"]=0x33A9, -- ㎩
 },
 [0x33AA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KPA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x0050, 0x0061 },
  ["unicodeslot"]=0x33AA, -- ㎪
 },
 [0x33AB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MPA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004D, 0x0050, 0x0061 },
  ["unicodeslot"]=0x33AB, -- ㎫
 },
 [0x33AC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GPA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0047, 0x0050, 0x0061 },
  ["unicodeslot"]=0x33AC, -- ㎬
 },
 [0x33AD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE RAD",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0072, 0x0061, 0x0064 },
  ["unicodeslot"]=0x33AD, -- ㎭
 },
 [0x33AE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE RAD OVER S",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0072, 0x0061, 0x0064, 0x2215, 0x0073 },
  ["unicodeslot"]=0x33AE, -- ㎮
 },
 [0x33AF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE RAD OVER S SQUARED",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0072, 0x0061, 0x0064, 0x2215, 0x0073, 0x00B2 },
  ["unicodeslot"]=0x33AF, -- ㎯
 },
 [0x33B0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PS",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0070, 0x0073 },
  ["unicodeslot"]=0x33B0, -- ㎰
 },
 [0x33B1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE NS",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006E, 0x0073 },
  ["unicodeslot"]=0x33B1, -- ㎱
 },
 [0x33B2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MU S",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x03BC, 0x0073 },
  ["unicodeslot"]=0x33B2, -- ㎲
 },
 [0x33B3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MS",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x0073 },
  ["unicodeslot"]=0x33B3, -- ㎳
 },
 [0x33B4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PV",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0070, 0x0056 },
  ["unicodeslot"]=0x33B4, -- ㎴
 },
 [0x33B5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE NV",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006E, 0x0056 },
  ["unicodeslot"]=0x33B5, -- ㎵
 },
 [0x33B6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MU V",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x03BC, 0x0056 },
  ["unicodeslot"]=0x33B6, -- ㎶
 },
 [0x33B7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MV",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x0056 },
  ["unicodeslot"]=0x33B7, -- ㎷
 },
 [0x33B8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KV",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x0056 },
  ["unicodeslot"]=0x33B8, -- ㎸
 },
 [0x33B9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MV MEGA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004D, 0x0056 },
  ["unicodeslot"]=0x33B9, -- ㎹
 },
 [0x33BA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PW",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0070, 0x0057 },
  ["unicodeslot"]=0x33BA, -- ㎺
 },
 [0x33BB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE NW",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006E, 0x0057 },
  ["unicodeslot"]=0x33BB, -- ㎻
 },
 [0x33BC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MU W",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x03BC, 0x0057 },
  ["unicodeslot"]=0x33BC, -- ㎼
 },
 [0x33BD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MW",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x0057 },
  ["unicodeslot"]=0x33BD, -- ㎽
 },
 [0x33BE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KW",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x0057 },
  ["unicodeslot"]=0x33BE, -- ㎾
 },
 [0x33BF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MW MEGA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004D, 0x0057 },
  ["unicodeslot"]=0x33BF, -- ㎿
 },
 [0x33C0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE K OHM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x03A9 },
  ["unicodeslot"]=0x33C0, -- ㏀
 },
 [0x33C1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE M OHM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004D, 0x03A9 },
  ["unicodeslot"]=0x33C1, -- ㏁
 },
 [0x33C2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE AM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0061, 0x002E, 0x006D, 0x002E },
  ["unicodeslot"]=0x33C2, -- ㏂
 },
 [0x33C3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE BQ",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0042, 0x0071 },
  ["unicodeslot"]=0x33C3, -- ㏃
 },
 [0x33C4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE CC",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0063, 0x0063 },
  ["unicodeslot"]=0x33C4, -- ㏄
 },
 [0x33C5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE CD",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0063, 0x0064 },
  ["unicodeslot"]=0x33C5, -- ㏅
 },
 [0x33C6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE C OVER KG",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0043, 0x2215, 0x006B, 0x0067 },
  ["unicodeslot"]=0x33C6, -- ㏆
 },
 [0x33C7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE CO",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0043, 0x006F, 0x002E },
  ["unicodeslot"]=0x33C7, -- ㏇
 },
 [0x33C8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE DB",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0064, 0x0042 },
  ["unicodeslot"]=0x33C8, -- ㏈
 },
 [0x33C9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GY",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0047, 0x0079 },
  ["unicodeslot"]=0x33C9, -- ㏉
 },
 [0x33CA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HA",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0068, 0x0061 },
  ["unicodeslot"]=0x33CA, -- ㏊
 },
 [0x33CB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE HP",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0048, 0x0050 },
  ["unicodeslot"]=0x33CB, -- ㏋
 },
 [0x33CC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE IN",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0069, 0x006E },
  ["unicodeslot"]=0x33CC, -- ㏌
 },
 [0x33CD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KK",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004B, 0x004B },
  ["unicodeslot"]=0x33CD, -- ㏍
 },
 [0x33CE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KM CAPITAL",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x004B, 0x004D },
  ["unicodeslot"]=0x33CE, -- ㏎
 },
 [0x33CF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE KT",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006B, 0x0074 },
  ["unicodeslot"]=0x33CF, -- ㏏
 },
 [0x33D0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE LM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006C, 0x006D },
  ["unicodeslot"]=0x33D0, -- ㏐
 },
 [0x33D1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE LN",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006C, 0x006E },
  ["unicodeslot"]=0x33D1, -- ㏑
 },
 [0x33D2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE LOG",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006C, 0x006F, 0x0067 },
  ["unicodeslot"]=0x33D2, -- ㏒
 },
 [0x33D3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE LX",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006C, 0x0078 },
  ["unicodeslot"]=0x33D3, -- ㏓
 },
 [0x33D4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MB SMALL",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x0062 },
  ["unicodeslot"]=0x33D4, -- ㏔
 },
 [0x33D5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MIL",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x0069, 0x006C },
  ["unicodeslot"]=0x33D5, -- ㏕
 },
 [0x33D6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE MOL",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x006D, 0x006F, 0x006C },
  ["unicodeslot"]=0x33D6, -- ㏖
 },
 [0x33D7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PH",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0050, 0x0048 },
  ["unicodeslot"]=0x33D7, -- ㏗
 },
 [0x33D8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0070, 0x002E, 0x006D, 0x002E },
  ["unicodeslot"]=0x33D8, -- ㏘
 },
 [0x33D9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PPM",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0050, 0x0050, 0x004D },
  ["unicodeslot"]=0x33D9, -- ㏙
 },
 [0x33DA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE PR",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0050, 0x0052 },
  ["unicodeslot"]=0x33DA, -- ㏚
 },
 [0x33DB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE SR",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0073, 0x0072 },
  ["unicodeslot"]=0x33DB, -- ㏛
 },
 [0x33DC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE SV",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0053, 0x0076 },
  ["unicodeslot"]=0x33DC, -- ㏜
 },
 [0x33DD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE WB",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0057, 0x0062 },
  ["unicodeslot"]=0x33DD, -- ㏝
 },
 [0x33DE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE V OVER M",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0056, 0x2215, 0x006D },
  ["unicodeslot"]=0x33DE, -- ㏞
 },
 [0x33DF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE A OVER M",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0041, 0x2215, 0x006D },
  ["unicodeslot"]=0x33DF, -- ㏟
 },
 [0x33E0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ONE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x65E5 },
  ["unicodeslot"]=0x33E0, -- ㏠
 },
 [0x33E1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x65E5 },
  ["unicodeslot"]=0x33E1, -- ㏡
 },
 [0x33E2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THREE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0033, 0x65E5 },
  ["unicodeslot"]=0x33E2, -- ㏢
 },
 [0x33E3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOUR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0034, 0x65E5 },
  ["unicodeslot"]=0x33E3, -- ㏣
 },
 [0x33E4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0035, 0x65E5 },
  ["unicodeslot"]=0x33E4, -- ㏤
 },
 [0x33E5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIX",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0036, 0x65E5 },
  ["unicodeslot"]=0x33E5, -- ㏥
 },
 [0x33E6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0037, 0x65E5 },
  ["unicodeslot"]=0x33E6, -- ㏦
 },
 [0x33E7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0038, 0x65E5 },
  ["unicodeslot"]=0x33E7, -- ㏧
 },
 [0x33E8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0039, 0x65E5 },
  ["unicodeslot"]=0x33E8, -- ㏨
 },
 [0x33E9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0030, 0x65E5 },
  ["unicodeslot"]=0x33E9, -- ㏩
 },
 [0x33EA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ELEVEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0031, 0x65E5 },
  ["unicodeslot"]=0x33EA, -- ㏪
 },
 [0x33EB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWELVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0032, 0x65E5 },
  ["unicodeslot"]=0x33EB, -- ㏫
 },
 [0x33EC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0033, 0x65E5 },
  ["unicodeslot"]=0x33EC, -- ㏬
 },
 [0x33ED]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOURTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0034, 0x65E5 },
  ["unicodeslot"]=0x33ED, -- ㏭
 },
 [0x33EE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIFTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0035, 0x65E5 },
  ["unicodeslot"]=0x33EE, -- ㏮
 },
 [0x33EF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIXTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0036, 0x65E5 },
  ["unicodeslot"]=0x33EF, -- ㏯
 },
 [0x33F0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVENTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0037, 0x65E5 },
  ["unicodeslot"]=0x33F0, -- ㏰
 },
 [0x33F1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHTEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0038, 0x65E5 },
  ["unicodeslot"]=0x33F1, -- ㏱
 },
 [0x33F2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINETEEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0031, 0x0039, 0x65E5 },
  ["unicodeslot"]=0x33F2, -- ㏲
 },
 [0x33F3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0030, 0x65E5 },
  ["unicodeslot"]=0x33F3, -- ㏳
 },
 [0x33F4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-ONE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0031, 0x65E5 },
  ["unicodeslot"]=0x33F4, -- ㏴
 },
 [0x33F5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-TWO",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0032, 0x65E5 },
  ["unicodeslot"]=0x33F5, -- ㏵
 },
 [0x33F6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-THREE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0033, 0x65E5 },
  ["unicodeslot"]=0x33F6, -- ㏶
 },
 [0x33F7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FOUR",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0034, 0x65E5 },
  ["unicodeslot"]=0x33F7, -- ㏷
 },
 [0x33F8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FIVE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0035, 0x65E5 },
  ["unicodeslot"]=0x33F8, -- ㏸
 },
 [0x33F9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SIX",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0036, 0x65E5 },
  ["unicodeslot"]=0x33F9, -- ㏹
 },
 [0x33FA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SEVEN",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0037, 0x65E5 },
  ["unicodeslot"]=0x33FA, -- ㏺
 },
 [0x33FB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0038, 0x65E5 },
  ["unicodeslot"]=0x33FB, -- ㏻
 },
 [0x33FC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-NINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0032, 0x0039, 0x65E5 },
  ["unicodeslot"]=0x33FC, -- ㏼
 },
 [0x33FD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0033, 0x0030, 0x65E5 },
  ["unicodeslot"]=0x33FD, -- ㏽
 },
 [0x33FE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY-ONE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x0033, 0x0031, 0x65E5 },
  ["unicodeslot"]=0x33FE, -- ㏾
 },
 [0x33FF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="SQUARE GAL",
  ["linebreak"]="id",
  ["specials"]={ "square", 0x0067, 0x0061, 0x006C },
  ["unicodeslot"]=0x33FF, -- ㏿
 },
 [0x3400]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="<CJK Ideograph Extension A, First>",
  ["linebreak"]="id",
  ["unicodeslot"]=0x3400, -- 㐀
 },
 [0x4DB5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="<CJK Ideograph Extension A, Last>",
  ["linebreak"]="id",
  ["unicodeslot"]=0x4DB5, -- 䶵
 },
 [0x4DC0]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE CREATIVE HEAVEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC0, -- ䷀
 },
 [0x4DC1]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE RECEPTIVE EARTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC1, -- ䷁
 },
 [0x4DC2]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR DIFFICULTY AT THE BEGINNING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC2, -- ䷂
 },
 [0x4DC3]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR YOUTHFUL FOLLY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC3, -- ䷃
 },
 [0x4DC4]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR WAITING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC4, -- ䷄
 },
 [0x4DC5]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR CONFLICT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC5, -- ䷅
 },
 [0x4DC6]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE ARMY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC6, -- ䷆
 },
 [0x4DC7]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR HOLDING TOGETHER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC7, -- ䷇
 },
 [0x4DC8]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR SMALL TAMING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC8, -- ䷈
 },
 [0x4DC9]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR TREADING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DC9, -- ䷉
 },
 [0x4DCA]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR PEACE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DCA, -- ䷊
 },
 [0x4DCB]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR STANDSTILL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DCB, -- ䷋
 },
 [0x4DCC]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR FELLOWSHIP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DCC, -- ䷌
 },
 [0x4DCD]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR GREAT POSSESSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DCD, -- ䷍
 },
 [0x4DCE]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR MODESTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DCE, -- ䷎
 },
 [0x4DCF]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR ENTHUSIASM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DCF, -- ䷏
 },
 [0x4DD0]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR FOLLOWING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD0, -- ䷐
 },
 [0x4DD1]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR WORK ON THE DECAYED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD1, -- ䷑
 },
 [0x4DD2]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR APPROACH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD2, -- ䷒
 },
 [0x4DD3]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR CONTEMPLATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD3, -- ䷓
 },
 [0x4DD4]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR BITING THROUGH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD4, -- ䷔
 },
 [0x4DD5]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR GRACE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD5, -- ䷕
 },
 [0x4DD6]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR SPLITTING APART",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD6, -- ䷖
 },
 [0x4DD7]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR RETURN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD7, -- ䷗
 },
 [0x4DD8]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR INNOCENCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD8, -- ䷘
 },
 [0x4DD9]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR GREAT TAMING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DD9, -- ䷙
 },
 [0x4DDA]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR MOUTH CORNERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DDA, -- ䷚
 },
 [0x4DDB]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR GREAT PREPONDERANCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DDB, -- ䷛
 },
 [0x4DDC]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE ABYSMAL WATER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DDC, -- ䷜
 },
 [0x4DDD]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE CLINGING FIRE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DDD, -- ䷝
 },
 [0x4DDE]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR INFLUENCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DDE, -- ䷞
 },
 [0x4DDF]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR DURATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DDF, -- ䷟
 },
 [0x4DE0]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR RETREAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE0, -- ䷠
 },
 [0x4DE1]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR GREAT POWER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE1, -- ䷡
 },
 [0x4DE2]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR PROGRESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE2, -- ䷢
 },
 [0x4DE3]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR DARKENING OF THE LIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE3, -- ䷣
 },
 [0x4DE4]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE FAMILY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE4, -- ䷤
 },
 [0x4DE5]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR OPPOSITION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE5, -- ䷥
 },
 [0x4DE6]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR OBSTRUCTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE6, -- ䷦
 },
 [0x4DE7]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR DELIVERANCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE7, -- ䷧
 },
 [0x4DE8]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR DECREASE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE8, -- ䷨
 },
 [0x4DE9]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR INCREASE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DE9, -- ䷩
 },
 [0x4DEA]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR BREAKTHROUGH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DEA, -- ䷪
 },
 [0x4DEB]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR COMING TO MEET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DEB, -- ䷫
 },
 [0x4DEC]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR GATHERING TOGETHER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DEC, -- ䷬
 },
 [0x4DED]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR PUSHING UPWARD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DED, -- ䷭
 },
 [0x4DEE]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR OPPRESSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DEE, -- ䷮
 },
 [0x4DEF]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE WELL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DEF, -- ䷯
 },
 [0x4DF0]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR REVOLUTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF0, -- ䷰
 },
 [0x4DF1]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE CAULDRON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF1, -- ䷱
 },
 [0x4DF2]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE AROUSING THUNDER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF2, -- ䷲
 },
 [0x4DF3]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE KEEPING STILL MOUNTAIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF3, -- ䷳
 },
 [0x4DF4]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR DEVELOPMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF4, -- ䷴
 },
 [0x4DF5]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE MARRYING MAIDEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF5, -- ䷵
 },
 [0x4DF6]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR ABUNDANCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF6, -- ䷶
 },
 [0x4DF7]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE WANDERER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF7, -- ䷷
 },
 [0x4DF8]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE GENTLE WIND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF8, -- ䷸
 },
 [0x4DF9]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR THE JOYOUS LAKE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DF9, -- ䷹
 },
 [0x4DFA]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR DISPERSION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DFA, -- ䷺
 },
 [0x4DFB]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR LIMITATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DFB, -- ䷻
 },
 [0x4DFC]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR INNER TRUTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DFC, -- ䷼
 },
 [0x4DFD]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR SMALL PREPONDERANCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DFD, -- ䷽
 },
 [0x4DFE]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR AFTER COMPLETION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DFE, -- ䷾
 },
 [0x4DFF]={
  ["category"]="so",
  ["description"]="HEXAGRAM FOR BEFORE COMPLETION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x4DFF, -- ䷿
 },
 [0x4E00]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="<CJK Ideograph, First>",
  ["linebreak"]="id",
  ["unicodeslot"]=0x4E00, -- 一
 },
 [0x9FBB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="<CJK Ideograph, Last>",
  ["linebreak"]="id",
  ["unicodeslot"]=0x9FBB, -- 龻
 },
 [0xA000]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE IT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA000, -- ꀀ
 },
 [0xA001]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE IX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA001, -- ꀁ
 },
 [0xA002]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE I",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA002, -- ꀂ
 },
 [0xA003]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE IP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA003, -- ꀃ
 },
 [0xA004]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE IET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA004, -- ꀄ
 },
 [0xA005]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE IEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA005, -- ꀅ
 },
 [0xA006]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE IE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA006, -- ꀆ
 },
 [0xA007]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE IEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA007, -- ꀇ
 },
 [0xA008]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE AT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA008, -- ꀈ
 },
 [0xA009]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE AX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA009, -- ꀉ
 },
 [0xA00A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE A",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA00A, -- ꀊ
 },
 [0xA00B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE AP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA00B, -- ꀋ
 },
 [0xA00C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE UOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA00C, -- ꀌ
 },
 [0xA00D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE UO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA00D, -- ꀍ
 },
 [0xA00E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE UOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA00E, -- ꀎ
 },
 [0xA00F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE OT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA00F, -- ꀏ
 },
 [0xA010]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE OX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA010, -- ꀐ
 },
 [0xA011]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE O",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA011, -- ꀑ
 },
 [0xA012]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE OP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA012, -- ꀒ
 },
 [0xA013]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE EX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA013, -- ꀓ
 },
 [0xA014]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE E",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA014, -- ꀔ
 },
 [0xA015]={
  ["category"]="lm",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WU",
  ["linebreak"]="ns",
  ["unicodeslot"]=0xA015, -- ꀕ
 },
 [0xA016]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA016, -- ꀖ
 },
 [0xA017]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA017, -- ꀗ
 },
 [0xA018]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA018, -- ꀘ
 },
 [0xA019]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA019, -- ꀙ
 },
 [0xA01A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA01A, -- ꀚ
 },
 [0xA01B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA01B, -- ꀛ
 },
 [0xA01C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA01C, -- ꀜ
 },
 [0xA01D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA01D, -- ꀝ
 },
 [0xA01E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA01E, -- ꀞ
 },
 [0xA01F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA01F, -- ꀟ
 },
 [0xA020]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA020, -- ꀠ
 },
 [0xA021]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA021, -- ꀡ
 },
 [0xA022]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA022, -- ꀢ
 },
 [0xA023]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA023, -- ꀣ
 },
 [0xA024]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA024, -- ꀤ
 },
 [0xA025]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA025, -- ꀥ
 },
 [0xA026]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA026, -- ꀦ
 },
 [0xA027]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA027, -- ꀧ
 },
 [0xA028]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA028, -- ꀨ
 },
 [0xA029]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA029, -- ꀩ
 },
 [0xA02A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA02A, -- ꀪ
 },
 [0xA02B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA02B, -- ꀫ
 },
 [0xA02C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA02C, -- ꀬ
 },
 [0xA02D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA02D, -- ꀭ
 },
 [0xA02E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA02E, -- ꀮ
 },
 [0xA02F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA02F, -- ꀯ
 },
 [0xA030]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA030, -- ꀰ
 },
 [0xA031]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA031, -- ꀱ
 },
 [0xA032]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA032, -- ꀲ
 },
 [0xA033]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA033, -- ꀳ
 },
 [0xA034]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA034, -- ꀴ
 },
 [0xA035]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA035, -- ꀵ
 },
 [0xA036]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA036, -- ꀶ
 },
 [0xA037]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA037, -- ꀷ
 },
 [0xA038]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA038, -- ꀸ
 },
 [0xA039]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA039, -- ꀹ
 },
 [0xA03A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA03A, -- ꀺ
 },
 [0xA03B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA03B, -- ꀻ
 },
 [0xA03C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA03C, -- ꀼ
 },
 [0xA03D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA03D, -- ꀽ
 },
 [0xA03E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA03E, -- ꀾ
 },
 [0xA03F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA03F, -- ꀿ
 },
 [0xA040]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA040, -- ꁀ
 },
 [0xA041]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA041, -- ꁁ
 },
 [0xA042]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA042, -- ꁂ
 },
 [0xA043]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA043, -- ꁃ
 },
 [0xA044]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA044, -- ꁄ
 },
 [0xA045]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA045, -- ꁅ
 },
 [0xA046]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE POT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA046, -- ꁆ
 },
 [0xA047]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE POX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA047, -- ꁇ
 },
 [0xA048]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA048, -- ꁈ
 },
 [0xA049]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE POP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA049, -- ꁉ
 },
 [0xA04A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA04A, -- ꁊ
 },
 [0xA04B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA04B, -- ꁋ
 },
 [0xA04C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA04C, -- ꁌ
 },
 [0xA04D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA04D, -- ꁍ
 },
 [0xA04E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA04E, -- ꁎ
 },
 [0xA04F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA04F, -- ꁏ
 },
 [0xA050]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA050, -- ꁐ
 },
 [0xA051]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA051, -- ꁑ
 },
 [0xA052]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA052, -- ꁒ
 },
 [0xA053]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA053, -- ꁓ
 },
 [0xA054]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA054, -- ꁔ
 },
 [0xA055]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE PYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA055, -- ꁕ
 },
 [0xA056]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA056, -- ꁖ
 },
 [0xA057]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA057, -- ꁗ
 },
 [0xA058]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA058, -- ꁘ
 },
 [0xA059]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA059, -- ꁙ
 },
 [0xA05A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA05A, -- ꁚ
 },
 [0xA05B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA05B, -- ꁛ
 },
 [0xA05C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA05C, -- ꁜ
 },
 [0xA05D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA05D, -- ꁝ
 },
 [0xA05E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA05E, -- ꁞ
 },
 [0xA05F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA05F, -- ꁟ
 },
 [0xA060]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA060, -- ꁠ
 },
 [0xA061]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA061, -- ꁡ
 },
 [0xA062]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA062, -- ꁢ
 },
 [0xA063]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA063, -- ꁣ
 },
 [0xA064]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA064, -- ꁤ
 },
 [0xA065]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA065, -- ꁥ
 },
 [0xA066]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA066, -- ꁦ
 },
 [0xA067]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA067, -- ꁧ
 },
 [0xA068]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA068, -- ꁨ
 },
 [0xA069]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA069, -- ꁩ
 },
 [0xA06A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA06A, -- ꁪ
 },
 [0xA06B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA06B, -- ꁫ
 },
 [0xA06C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA06C, -- ꁬ
 },
 [0xA06D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA06D, -- ꁭ
 },
 [0xA06E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA06E, -- ꁮ
 },
 [0xA06F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA06F, -- ꁯ
 },
 [0xA070]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA070, -- ꁰ
 },
 [0xA071]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA071, -- ꁱ
 },
 [0xA072]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA072, -- ꁲ
 },
 [0xA073]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA073, -- ꁳ
 },
 [0xA074]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA074, -- ꁴ
 },
 [0xA075]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE BBYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA075, -- ꁵ
 },
 [0xA076]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA076, -- ꁶ
 },
 [0xA077]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA077, -- ꁷ
 },
 [0xA078]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA078, -- ꁸ
 },
 [0xA079]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA079, -- ꁹ
 },
 [0xA07A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA07A, -- ꁺ
 },
 [0xA07B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA07B, -- ꁻ
 },
 [0xA07C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA07C, -- ꁼ
 },
 [0xA07D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA07D, -- ꁽ
 },
 [0xA07E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA07E, -- ꁾ
 },
 [0xA07F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA07F, -- ꁿ
 },
 [0xA080]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA080, -- ꂀ
 },
 [0xA081]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA081, -- ꂁ
 },
 [0xA082]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA082, -- ꂂ
 },
 [0xA083]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA083, -- ꂃ
 },
 [0xA084]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA084, -- ꂄ
 },
 [0xA085]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA085, -- ꂅ
 },
 [0xA086]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA086, -- ꂆ
 },
 [0xA087]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA087, -- ꂇ
 },
 [0xA088]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA088, -- ꂈ
 },
 [0xA089]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA089, -- ꂉ
 },
 [0xA08A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA08A, -- ꂊ
 },
 [0xA08B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA08B, -- ꂋ
 },
 [0xA08C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA08C, -- ꂌ
 },
 [0xA08D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA08D, -- ꂍ
 },
 [0xA08E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA08E, -- ꂎ
 },
 [0xA08F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA08F, -- ꂏ
 },
 [0xA090]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NBYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA090, -- ꂐ
 },
 [0xA091]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA091, -- ꂑ
 },
 [0xA092]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA092, -- ꂒ
 },
 [0xA093]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA093, -- ꂓ
 },
 [0xA094]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA094, -- ꂔ
 },
 [0xA095]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA095, -- ꂕ
 },
 [0xA096]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA096, -- ꂖ
 },
 [0xA097]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA097, -- ꂗ
 },
 [0xA098]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA098, -- ꂘ
 },
 [0xA099]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA099, -- ꂙ
 },
 [0xA09A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA09A, -- ꂚ
 },
 [0xA09B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA09B, -- ꂛ
 },
 [0xA09C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA09C, -- ꂜ
 },
 [0xA09D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA09D, -- ꂝ
 },
 [0xA09E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA09E, -- ꂞ
 },
 [0xA09F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA09F, -- ꂟ
 },
 [0xA0A0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A0, -- ꂠ
 },
 [0xA0A1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A1, -- ꂡ
 },
 [0xA0A2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A2, -- ꂢ
 },
 [0xA0A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A3, -- ꂣ
 },
 [0xA0A4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A4, -- ꂤ
 },
 [0xA0A5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A5, -- ꂥ
 },
 [0xA0A6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A6, -- ꂦ
 },
 [0xA0A7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A7, -- ꂧ
 },
 [0xA0A8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A8, -- ꂨ
 },
 [0xA0A9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0A9, -- ꂩ
 },
 [0xA0AA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0AA, -- ꂪ
 },
 [0xA0AB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0AB, -- ꂫ
 },
 [0xA0AC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0AC, -- ꂬ
 },
 [0xA0AD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HMYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0AD, -- ꂭ
 },
 [0xA0AE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0AE, -- ꂮ
 },
 [0xA0AF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0AF, -- ꂯ
 },
 [0xA0B0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B0, -- ꂰ
 },
 [0xA0B1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B1, -- ꂱ
 },
 [0xA0B2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B2, -- ꂲ
 },
 [0xA0B3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B3, -- ꂳ
 },
 [0xA0B4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B4, -- ꂴ
 },
 [0xA0B5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B5, -- ꂵ
 },
 [0xA0B6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B6, -- ꂶ
 },
 [0xA0B7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B7, -- ꂷ
 },
 [0xA0B8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B8, -- ꂸ
 },
 [0xA0B9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0B9, -- ꂹ
 },
 [0xA0BA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0BA, -- ꂺ
 },
 [0xA0BB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0BB, -- ꂻ
 },
 [0xA0BC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0BC, -- ꂼ
 },
 [0xA0BD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0BD, -- ꂽ
 },
 [0xA0BE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0BE, -- ꂾ
 },
 [0xA0BF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0BF, -- ꂿ
 },
 [0xA0C0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C0, -- ꃀ
 },
 [0xA0C1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C1, -- ꃁ
 },
 [0xA0C2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ME",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C2, -- ꃂ
 },
 [0xA0C3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C3, -- ꃃ
 },
 [0xA0C4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C4, -- ꃄ
 },
 [0xA0C5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C5, -- ꃅ
 },
 [0xA0C6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C6, -- ꃆ
 },
 [0xA0C7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C7, -- ꃇ
 },
 [0xA0C8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C8, -- ꃈ
 },
 [0xA0C9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0C9, -- ꃉ
 },
 [0xA0CA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0CA, -- ꃊ
 },
 [0xA0CB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0CB, -- ꃋ
 },
 [0xA0CC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0CC, -- ꃌ
 },
 [0xA0CD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0CD, -- ꃍ
 },
 [0xA0CE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0CE, -- ꃎ
 },
 [0xA0CF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0CF, -- ꃏ
 },
 [0xA0D0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D0, -- ꃐ
 },
 [0xA0D1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D1, -- ꃑ
 },
 [0xA0D2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D2, -- ꃒ
 },
 [0xA0D3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D3, -- ꃓ
 },
 [0xA0D4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D4, -- ꃔ
 },
 [0xA0D5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D5, -- ꃕ
 },
 [0xA0D6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D6, -- ꃖ
 },
 [0xA0D7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D7, -- ꃗ
 },
 [0xA0D8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D8, -- ꃘ
 },
 [0xA0D9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0D9, -- ꃙ
 },
 [0xA0DA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0DA, -- ꃚ
 },
 [0xA0DB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0DB, -- ꃛ
 },
 [0xA0DC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0DC, -- ꃜ
 },
 [0xA0DD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0DD, -- ꃝ
 },
 [0xA0DE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0DE, -- ꃞ
 },
 [0xA0DF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0DF, -- ꃟ
 },
 [0xA0E0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E0, -- ꃠ
 },
 [0xA0E1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE FYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E1, -- ꃡ
 },
 [0xA0E2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E2, -- ꃢ
 },
 [0xA0E3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E3, -- ꃣ
 },
 [0xA0E4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E4, -- ꃤ
 },
 [0xA0E5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E5, -- ꃥ
 },
 [0xA0E6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E6, -- ꃦ
 },
 [0xA0E7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E7, -- ꃧ
 },
 [0xA0E8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E8, -- ꃨ
 },
 [0xA0E9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0E9, -- ꃩ
 },
 [0xA0EA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0EA, -- ꃪ
 },
 [0xA0EB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0EB, -- ꃫ
 },
 [0xA0EC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0EC, -- ꃬ
 },
 [0xA0ED]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0ED, -- ꃭ
 },
 [0xA0EE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0EE, -- ꃮ
 },
 [0xA0EF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0EF, -- ꃯ
 },
 [0xA0F0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F0, -- ꃰ
 },
 [0xA0F1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F1, -- ꃱ
 },
 [0xA0F2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F2, -- ꃲ
 },
 [0xA0F3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F3, -- ꃳ
 },
 [0xA0F4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F4, -- ꃴ
 },
 [0xA0F5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F5, -- ꃵ
 },
 [0xA0F6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F6, -- ꃶ
 },
 [0xA0F7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F7, -- ꃷ
 },
 [0xA0F8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F8, -- ꃸ
 },
 [0xA0F9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0F9, -- ꃹ
 },
 [0xA0FA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0FA, -- ꃺ
 },
 [0xA0FB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0FB, -- ꃻ
 },
 [0xA0FC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0FC, -- ꃼ
 },
 [0xA0FD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0FD, -- ꃽ
 },
 [0xA0FE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0FE, -- ꃾ
 },
 [0xA0FF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE VYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA0FF, -- ꃿ
 },
 [0xA100]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA100, -- ꄀ
 },
 [0xA101]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA101, -- ꄁ
 },
 [0xA102]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA102, -- ꄂ
 },
 [0xA103]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA103, -- ꄃ
 },
 [0xA104]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA104, -- ꄄ
 },
 [0xA105]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA105, -- ꄅ
 },
 [0xA106]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA106, -- ꄆ
 },
 [0xA107]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA107, -- ꄇ
 },
 [0xA108]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA108, -- ꄈ
 },
 [0xA109]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA109, -- ꄉ
 },
 [0xA10A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA10A, -- ꄊ
 },
 [0xA10B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA10B, -- ꄋ
 },
 [0xA10C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA10C, -- ꄌ
 },
 [0xA10D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA10D, -- ꄍ
 },
 [0xA10E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA10E, -- ꄎ
 },
 [0xA10F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA10F, -- ꄏ
 },
 [0xA110]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA110, -- ꄐ
 },
 [0xA111]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA111, -- ꄑ
 },
 [0xA112]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA112, -- ꄒ
 },
 [0xA113]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA113, -- ꄓ
 },
 [0xA114]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA114, -- ꄔ
 },
 [0xA115]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA115, -- ꄕ
 },
 [0xA116]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA116, -- ꄖ
 },
 [0xA117]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA117, -- ꄗ
 },
 [0xA118]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA118, -- ꄘ
 },
 [0xA119]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA119, -- ꄙ
 },
 [0xA11A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA11A, -- ꄚ
 },
 [0xA11B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA11B, -- ꄛ
 },
 [0xA11C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA11C, -- ꄜ
 },
 [0xA11D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA11D, -- ꄝ
 },
 [0xA11E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA11E, -- ꄞ
 },
 [0xA11F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA11F, -- ꄟ
 },
 [0xA120]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA120, -- ꄠ
 },
 [0xA121]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA121, -- ꄡ
 },
 [0xA122]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA122, -- ꄢ
 },
 [0xA123]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA123, -- ꄣ
 },
 [0xA124]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA124, -- ꄤ
 },
 [0xA125]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA125, -- ꄥ
 },
 [0xA126]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA126, -- ꄦ
 },
 [0xA127]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA127, -- ꄧ
 },
 [0xA128]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA128, -- ꄨ
 },
 [0xA129]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA129, -- ꄩ
 },
 [0xA12A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA12A, -- ꄪ
 },
 [0xA12B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA12B, -- ꄫ
 },
 [0xA12C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA12C, -- ꄬ
 },
 [0xA12D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA12D, -- ꄭ
 },
 [0xA12E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA12E, -- ꄮ
 },
 [0xA12F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA12F, -- ꄯ
 },
 [0xA130]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA130, -- ꄰ
 },
 [0xA131]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA131, -- ꄱ
 },
 [0xA132]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA132, -- ꄲ
 },
 [0xA133]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA133, -- ꄳ
 },
 [0xA134]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA134, -- ꄴ
 },
 [0xA135]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE TUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA135, -- ꄵ
 },
 [0xA136]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA136, -- ꄶ
 },
 [0xA137]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA137, -- ꄷ
 },
 [0xA138]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA138, -- ꄸ
 },
 [0xA139]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA139, -- ꄹ
 },
 [0xA13A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA13A, -- ꄺ
 },
 [0xA13B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA13B, -- ꄻ
 },
 [0xA13C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA13C, -- ꄼ
 },
 [0xA13D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA13D, -- ꄽ
 },
 [0xA13E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA13E, -- ꄾ
 },
 [0xA13F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA13F, -- ꄿ
 },
 [0xA140]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA140, -- ꅀ
 },
 [0xA141]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA141, -- ꅁ
 },
 [0xA142]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA142, -- ꅂ
 },
 [0xA143]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA143, -- ꅃ
 },
 [0xA144]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA144, -- ꅄ
 },
 [0xA145]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA145, -- ꅅ
 },
 [0xA146]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA146, -- ꅆ
 },
 [0xA147]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA147, -- ꅇ
 },
 [0xA148]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA148, -- ꅈ
 },
 [0xA149]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA149, -- ꅉ
 },
 [0xA14A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA14A, -- ꅊ
 },
 [0xA14B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA14B, -- ꅋ
 },
 [0xA14C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA14C, -- ꅌ
 },
 [0xA14D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA14D, -- ꅍ
 },
 [0xA14E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA14E, -- ꅎ
 },
 [0xA14F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA14F, -- ꅏ
 },
 [0xA150]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE DDUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA150, -- ꅐ
 },
 [0xA151]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA151, -- ꅑ
 },
 [0xA152]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA152, -- ꅒ
 },
 [0xA153]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA153, -- ꅓ
 },
 [0xA154]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA154, -- ꅔ
 },
 [0xA155]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA155, -- ꅕ
 },
 [0xA156]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA156, -- ꅖ
 },
 [0xA157]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA157, -- ꅗ
 },
 [0xA158]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA158, -- ꅘ
 },
 [0xA159]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA159, -- ꅙ
 },
 [0xA15A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA15A, -- ꅚ
 },
 [0xA15B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA15B, -- ꅛ
 },
 [0xA15C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA15C, -- ꅜ
 },
 [0xA15D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA15D, -- ꅝ
 },
 [0xA15E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA15E, -- ꅞ
 },
 [0xA15F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA15F, -- ꅟ
 },
 [0xA160]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA160, -- ꅠ
 },
 [0xA161]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA161, -- ꅡ
 },
 [0xA162]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA162, -- ꅢ
 },
 [0xA163]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA163, -- ꅣ
 },
 [0xA164]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA164, -- ꅤ
 },
 [0xA165]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA165, -- ꅥ
 },
 [0xA166]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA166, -- ꅦ
 },
 [0xA167]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NDUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA167, -- ꅧ
 },
 [0xA168]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA168, -- ꅨ
 },
 [0xA169]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA169, -- ꅩ
 },
 [0xA16A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA16A, -- ꅪ
 },
 [0xA16B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA16B, -- ꅫ
 },
 [0xA16C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA16C, -- ꅬ
 },
 [0xA16D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA16D, -- ꅭ
 },
 [0xA16E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA16E, -- ꅮ
 },
 [0xA16F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA16F, -- ꅯ
 },
 [0xA170]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA170, -- ꅰ
 },
 [0xA171]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA171, -- ꅱ
 },
 [0xA172]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA172, -- ꅲ
 },
 [0xA173]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA173, -- ꅳ
 },
 [0xA174]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA174, -- ꅴ
 },
 [0xA175]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA175, -- ꅵ
 },
 [0xA176]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA176, -- ꅶ
 },
 [0xA177]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA177, -- ꅷ
 },
 [0xA178]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA178, -- ꅸ
 },
 [0xA179]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA179, -- ꅹ
 },
 [0xA17A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA17A, -- ꅺ
 },
 [0xA17B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA17B, -- ꅻ
 },
 [0xA17C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HNUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA17C, -- ꅼ
 },
 [0xA17D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA17D, -- ꅽ
 },
 [0xA17E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA17E, -- ꅾ
 },
 [0xA17F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA17F, -- ꅿ
 },
 [0xA180]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA180, -- ꆀ
 },
 [0xA181]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA181, -- ꆁ
 },
 [0xA182]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA182, -- ꆂ
 },
 [0xA183]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA183, -- ꆃ
 },
 [0xA184]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA184, -- ꆄ
 },
 [0xA185]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA185, -- ꆅ
 },
 [0xA186]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA186, -- ꆆ
 },
 [0xA187]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA187, -- ꆇ
 },
 [0xA188]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA188, -- ꆈ
 },
 [0xA189]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA189, -- ꆉ
 },
 [0xA18A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA18A, -- ꆊ
 },
 [0xA18B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA18B, -- ꆋ
 },
 [0xA18C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA18C, -- ꆌ
 },
 [0xA18D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA18D, -- ꆍ
 },
 [0xA18E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA18E, -- ꆎ
 },
 [0xA18F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA18F, -- ꆏ
 },
 [0xA190]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA190, -- ꆐ
 },
 [0xA191]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA191, -- ꆑ
 },
 [0xA192]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA192, -- ꆒ
 },
 [0xA193]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA193, -- ꆓ
 },
 [0xA194]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA194, -- ꆔ
 },
 [0xA195]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA195, -- ꆕ
 },
 [0xA196]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA196, -- ꆖ
 },
 [0xA197]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA197, -- ꆗ
 },
 [0xA198]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA198, -- ꆘ
 },
 [0xA199]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA199, -- ꆙ
 },
 [0xA19A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA19A, -- ꆚ
 },
 [0xA19B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA19B, -- ꆛ
 },
 [0xA19C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA19C, -- ꆜ
 },
 [0xA19D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA19D, -- ꆝ
 },
 [0xA19E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA19E, -- ꆞ
 },
 [0xA19F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA19F, -- ꆟ
 },
 [0xA1A0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A0, -- ꆠ
 },
 [0xA1A1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A1, -- ꆡ
 },
 [0xA1A2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A2, -- ꆢ
 },
 [0xA1A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A3, -- ꆣ
 },
 [0xA1A4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A4, -- ꆤ
 },
 [0xA1A5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A5, -- ꆥ
 },
 [0xA1A6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A6, -- ꆦ
 },
 [0xA1A7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A7, -- ꆧ
 },
 [0xA1A8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A8, -- ꆨ
 },
 [0xA1A9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1A9, -- ꆩ
 },
 [0xA1AA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1AA, -- ꆪ
 },
 [0xA1AB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1AB, -- ꆫ
 },
 [0xA1AC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1AC, -- ꆬ
 },
 [0xA1AD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1AD, -- ꆭ
 },
 [0xA1AE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1AE, -- ꆮ
 },
 [0xA1AF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1AF, -- ꆯ
 },
 [0xA1B0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B0, -- ꆰ
 },
 [0xA1B1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B1, -- ꆱ
 },
 [0xA1B2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B2, -- ꆲ
 },
 [0xA1B3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B3, -- ꆳ
 },
 [0xA1B4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B4, -- ꆴ
 },
 [0xA1B5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B5, -- ꆵ
 },
 [0xA1B6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HLYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B6, -- ꆶ
 },
 [0xA1B7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B7, -- ꆷ
 },
 [0xA1B8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B8, -- ꆸ
 },
 [0xA1B9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1B9, -- ꆹ
 },
 [0xA1BA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1BA, -- ꆺ
 },
 [0xA1BB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1BB, -- ꆻ
 },
 [0xA1BC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1BC, -- ꆼ
 },
 [0xA1BD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1BD, -- ꆽ
 },
 [0xA1BE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1BE, -- ꆾ
 },
 [0xA1BF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1BF, -- ꆿ
 },
 [0xA1C0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C0, -- ꇀ
 },
 [0xA1C1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C1, -- ꇁ
 },
 [0xA1C2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C2, -- ꇂ
 },
 [0xA1C3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C3, -- ꇃ
 },
 [0xA1C4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C4, -- ꇄ
 },
 [0xA1C5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C5, -- ꇅ
 },
 [0xA1C6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C6, -- ꇆ
 },
 [0xA1C7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C7, -- ꇇ
 },
 [0xA1C8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C8, -- ꇈ
 },
 [0xA1C9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1C9, -- ꇉ
 },
 [0xA1CA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1CA, -- ꇊ
 },
 [0xA1CB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1CB, -- ꇋ
 },
 [0xA1CC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1CC, -- ꇌ
 },
 [0xA1CD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1CD, -- ꇍ
 },
 [0xA1CE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1CE, -- ꇎ
 },
 [0xA1CF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1CF, -- ꇏ
 },
 [0xA1D0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D0, -- ꇐ
 },
 [0xA1D1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D1, -- ꇑ
 },
 [0xA1D2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D2, -- ꇒ
 },
 [0xA1D3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D3, -- ꇓ
 },
 [0xA1D4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D4, -- ꇔ
 },
 [0xA1D5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D5, -- ꇕ
 },
 [0xA1D6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D6, -- ꇖ
 },
 [0xA1D7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D7, -- ꇗ
 },
 [0xA1D8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D8, -- ꇘ
 },
 [0xA1D9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE LYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1D9, -- ꇙ
 },
 [0xA1DA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1DA, -- ꇚ
 },
 [0xA1DB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1DB, -- ꇛ
 },
 [0xA1DC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1DC, -- ꇜ
 },
 [0xA1DD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1DD, -- ꇝ
 },
 [0xA1DE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1DE, -- ꇞ
 },
 [0xA1DF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1DF, -- ꇟ
 },
 [0xA1E0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E0, -- ꇠ
 },
 [0xA1E1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E1, -- ꇡ
 },
 [0xA1E2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E2, -- ꇢ
 },
 [0xA1E3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E3, -- ꇣ
 },
 [0xA1E4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E4, -- ꇤ
 },
 [0xA1E5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E5, -- ꇥ
 },
 [0xA1E6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E6, -- ꇦ
 },
 [0xA1E7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E7, -- ꇧ
 },
 [0xA1E8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E8, -- ꇨ
 },
 [0xA1E9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1E9, -- ꇩ
 },
 [0xA1EA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1EA, -- ꇪ
 },
 [0xA1EB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1EB, -- ꇫ
 },
 [0xA1EC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1EC, -- ꇬ
 },
 [0xA1ED]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1ED, -- ꇭ
 },
 [0xA1EE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1EE, -- ꇮ
 },
 [0xA1EF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1EF, -- ꇯ
 },
 [0xA1F0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F0, -- ꇰ
 },
 [0xA1F1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F1, -- ꇱ
 },
 [0xA1F2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F2, -- ꇲ
 },
 [0xA1F3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F3, -- ꇳ
 },
 [0xA1F4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F4, -- ꇴ
 },
 [0xA1F5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F5, -- ꇵ
 },
 [0xA1F6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F6, -- ꇶ
 },
 [0xA1F7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F7, -- ꇷ
 },
 [0xA1F8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F8, -- ꇸ
 },
 [0xA1F9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1F9, -- ꇹ
 },
 [0xA1FA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1FA, -- ꇺ
 },
 [0xA1FB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1FB, -- ꇻ
 },
 [0xA1FC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1FC, -- ꇼ
 },
 [0xA1FD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1FD, -- ꇽ
 },
 [0xA1FE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1FE, -- ꇾ
 },
 [0xA1FF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA1FF, -- ꇿ
 },
 [0xA200]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA200, -- ꈀ
 },
 [0xA201]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA201, -- ꈁ
 },
 [0xA202]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA202, -- ꈂ
 },
 [0xA203]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA203, -- ꈃ
 },
 [0xA204]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA204, -- ꈄ
 },
 [0xA205]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA205, -- ꈅ
 },
 [0xA206]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA206, -- ꈆ
 },
 [0xA207]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA207, -- ꈇ
 },
 [0xA208]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA208, -- ꈈ
 },
 [0xA209]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA209, -- ꈉ
 },
 [0xA20A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA20A, -- ꈊ
 },
 [0xA20B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA20B, -- ꈋ
 },
 [0xA20C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA20C, -- ꈌ
 },
 [0xA20D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA20D, -- ꈍ
 },
 [0xA20E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA20E, -- ꈎ
 },
 [0xA20F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA20F, -- ꈏ
 },
 [0xA210]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA210, -- ꈐ
 },
 [0xA211]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA211, -- ꈑ
 },
 [0xA212]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA212, -- ꈒ
 },
 [0xA213]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE KUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA213, -- ꈓ
 },
 [0xA214]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA214, -- ꈔ
 },
 [0xA215]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA215, -- ꈕ
 },
 [0xA216]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA216, -- ꈖ
 },
 [0xA217]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA217, -- ꈗ
 },
 [0xA218]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA218, -- ꈘ
 },
 [0xA219]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA219, -- ꈙ
 },
 [0xA21A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA21A, -- ꈚ
 },
 [0xA21B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA21B, -- ꈛ
 },
 [0xA21C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA21C, -- ꈜ
 },
 [0xA21D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA21D, -- ꈝ
 },
 [0xA21E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA21E, -- ꈞ
 },
 [0xA21F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA21F, -- ꈟ
 },
 [0xA220]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA220, -- ꈠ
 },
 [0xA221]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA221, -- ꈡ
 },
 [0xA222]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA222, -- ꈢ
 },
 [0xA223]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA223, -- ꈣ
 },
 [0xA224]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA224, -- ꈤ
 },
 [0xA225]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA225, -- ꈥ
 },
 [0xA226]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA226, -- ꈦ
 },
 [0xA227]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA227, -- ꈧ
 },
 [0xA228]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA228, -- ꈨ
 },
 [0xA229]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA229, -- ꈩ
 },
 [0xA22A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA22A, -- ꈪ
 },
 [0xA22B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA22B, -- ꈫ
 },
 [0xA22C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA22C, -- ꈬ
 },
 [0xA22D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA22D, -- ꈭ
 },
 [0xA22E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA22E, -- ꈮ
 },
 [0xA22F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE GGUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA22F, -- ꈯ
 },
 [0xA230]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA230, -- ꈰ
 },
 [0xA231]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA231, -- ꈱ
 },
 [0xA232]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA232, -- ꈲ
 },
 [0xA233]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA233, -- ꈳ
 },
 [0xA234]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA234, -- ꈴ
 },
 [0xA235]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA235, -- ꈵ
 },
 [0xA236]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA236, -- ꈶ
 },
 [0xA237]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA237, -- ꈷ
 },
 [0xA238]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA238, -- ꈸ
 },
 [0xA239]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA239, -- ꈹ
 },
 [0xA23A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA23A, -- ꈺ
 },
 [0xA23B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA23B, -- ꈻ
 },
 [0xA23C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA23C, -- ꈼ
 },
 [0xA23D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA23D, -- ꈽ
 },
 [0xA23E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA23E, -- ꈾ
 },
 [0xA23F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA23F, -- ꈿ
 },
 [0xA240]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA240, -- ꉀ
 },
 [0xA241]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA241, -- ꉁ
 },
 [0xA242]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA242, -- ꉂ
 },
 [0xA243]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA243, -- ꉃ
 },
 [0xA244]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA244, -- ꉄ
 },
 [0xA245]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE MGUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA245, -- ꉅ
 },
 [0xA246]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA246, -- ꉆ
 },
 [0xA247]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA247, -- ꉇ
 },
 [0xA248]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA248, -- ꉈ
 },
 [0xA249]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA249, -- ꉉ
 },
 [0xA24A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA24A, -- ꉊ
 },
 [0xA24B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA24B, -- ꉋ
 },
 [0xA24C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA24C, -- ꉌ
 },
 [0xA24D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA24D, -- ꉍ
 },
 [0xA24E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA24E, -- ꉎ
 },
 [0xA24F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA24F, -- ꉏ
 },
 [0xA250]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA250, -- ꉐ
 },
 [0xA251]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA251, -- ꉑ
 },
 [0xA252]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA252, -- ꉒ
 },
 [0xA253]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA253, -- ꉓ
 },
 [0xA254]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA254, -- ꉔ
 },
 [0xA255]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA255, -- ꉕ
 },
 [0xA256]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA256, -- ꉖ
 },
 [0xA257]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA257, -- ꉗ
 },
 [0xA258]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA258, -- ꉘ
 },
 [0xA259]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA259, -- ꉙ
 },
 [0xA25A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA25A, -- ꉚ
 },
 [0xA25B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA25B, -- ꉛ
 },
 [0xA25C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HXEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA25C, -- ꉜ
 },
 [0xA25D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA25D, -- ꉝ
 },
 [0xA25E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA25E, -- ꉞ
 },
 [0xA25F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA25F, -- ꉟ
 },
 [0xA260]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA260, -- ꉠ
 },
 [0xA261]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA261, -- ꉡ
 },
 [0xA262]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA262, -- ꉢ
 },
 [0xA263]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA263, -- ꉣ
 },
 [0xA264]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA264, -- ꉤ
 },
 [0xA265]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA265, -- ꉥ
 },
 [0xA266]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA266, -- ꉦ
 },
 [0xA267]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA267, -- ꉧ
 },
 [0xA268]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA268, -- ꉨ
 },
 [0xA269]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA269, -- ꉩ
 },
 [0xA26A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA26A, -- ꉪ
 },
 [0xA26B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA26B, -- ꉫ
 },
 [0xA26C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA26C, -- ꉬ
 },
 [0xA26D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NGEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA26D, -- ꉭ
 },
 [0xA26E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA26E, -- ꉮ
 },
 [0xA26F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA26F, -- ꉯ
 },
 [0xA270]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA270, -- ꉰ
 },
 [0xA271]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA271, -- ꉱ
 },
 [0xA272]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA272, -- ꉲ
 },
 [0xA273]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA273, -- ꉳ
 },
 [0xA274]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA274, -- ꉴ
 },
 [0xA275]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA275, -- ꉵ
 },
 [0xA276]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA276, -- ꉶ
 },
 [0xA277]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA277, -- ꉷ
 },
 [0xA278]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA278, -- ꉸ
 },
 [0xA279]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA279, -- ꉹ
 },
 [0xA27A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA27A, -- ꉺ
 },
 [0xA27B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA27B, -- ꉻ
 },
 [0xA27C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA27C, -- ꉼ
 },
 [0xA27D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA27D, -- ꉽ
 },
 [0xA27E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA27E, -- ꉾ
 },
 [0xA27F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE HEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA27F, -- ꉿ
 },
 [0xA280]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA280, -- ꊀ
 },
 [0xA281]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA281, -- ꊁ
 },
 [0xA282]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA282, -- ꊂ
 },
 [0xA283]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA283, -- ꊃ
 },
 [0xA284]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA284, -- ꊄ
 },
 [0xA285]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA285, -- ꊅ
 },
 [0xA286]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA286, -- ꊆ
 },
 [0xA287]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA287, -- ꊇ
 },
 [0xA288]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA288, -- ꊈ
 },
 [0xA289]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA289, -- ꊉ
 },
 [0xA28A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA28A, -- ꊊ
 },
 [0xA28B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA28B, -- ꊋ
 },
 [0xA28C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE WEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA28C, -- ꊌ
 },
 [0xA28D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA28D, -- ꊍ
 },
 [0xA28E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA28E, -- ꊎ
 },
 [0xA28F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA28F, -- ꊏ
 },
 [0xA290]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA290, -- ꊐ
 },
 [0xA291]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA291, -- ꊑ
 },
 [0xA292]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA292, -- ꊒ
 },
 [0xA293]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA293, -- ꊓ
 },
 [0xA294]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA294, -- ꊔ
 },
 [0xA295]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA295, -- ꊕ
 },
 [0xA296]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA296, -- ꊖ
 },
 [0xA297]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA297, -- ꊗ
 },
 [0xA298]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA298, -- ꊘ
 },
 [0xA299]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA299, -- ꊙ
 },
 [0xA29A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA29A, -- ꊚ
 },
 [0xA29B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA29B, -- ꊛ
 },
 [0xA29C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA29C, -- ꊜ
 },
 [0xA29D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA29D, -- ꊝ
 },
 [0xA29E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA29E, -- ꊞ
 },
 [0xA29F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA29F, -- ꊟ
 },
 [0xA2A0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A0, -- ꊠ
 },
 [0xA2A1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A1, -- ꊡ
 },
 [0xA2A2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A2, -- ꊢ
 },
 [0xA2A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A3, -- ꊣ
 },
 [0xA2A4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A4, -- ꊤ
 },
 [0xA2A5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A5, -- ꊥ
 },
 [0xA2A6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A6, -- ꊦ
 },
 [0xA2A7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A7, -- ꊧ
 },
 [0xA2A8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A8, -- ꊨ
 },
 [0xA2A9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2A9, -- ꊩ
 },
 [0xA2AA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2AA, -- ꊪ
 },
 [0xA2AB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2AB, -- ꊫ
 },
 [0xA2AC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2AC, -- ꊬ
 },
 [0xA2AD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2AD, -- ꊭ
 },
 [0xA2AE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2AE, -- ꊮ
 },
 [0xA2AF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2AF, -- ꊯ
 },
 [0xA2B0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B0, -- ꊰ
 },
 [0xA2B1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B1, -- ꊱ
 },
 [0xA2B2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B2, -- ꊲ
 },
 [0xA2B3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B3, -- ꊳ
 },
 [0xA2B4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B4, -- ꊴ
 },
 [0xA2B5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B5, -- ꊵ
 },
 [0xA2B6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B6, -- ꊶ
 },
 [0xA2B7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B7, -- ꊷ
 },
 [0xA2B8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B8, -- ꊸ
 },
 [0xA2B9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2B9, -- ꊹ
 },
 [0xA2BA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2BA, -- ꊺ
 },
 [0xA2BB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2BB, -- ꊻ
 },
 [0xA2BC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2BC, -- ꊼ
 },
 [0xA2BD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE COT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2BD, -- ꊽ
 },
 [0xA2BE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE COX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2BE, -- ꊾ
 },
 [0xA2BF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2BF, -- ꊿ
 },
 [0xA2C0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE COP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C0, -- ꋀ
 },
 [0xA2C1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C1, -- ꋁ
 },
 [0xA2C2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C2, -- ꋂ
 },
 [0xA2C3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C3, -- ꋃ
 },
 [0xA2C4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C4, -- ꋄ
 },
 [0xA2C5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C5, -- ꋅ
 },
 [0xA2C6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C6, -- ꋆ
 },
 [0xA2C7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C7, -- ꋇ
 },
 [0xA2C8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C8, -- ꋈ
 },
 [0xA2C9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2C9, -- ꋉ
 },
 [0xA2CA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2CA, -- ꋊ
 },
 [0xA2CB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2CB, -- ꋋ
 },
 [0xA2CC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2CC, -- ꋌ
 },
 [0xA2CD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2CD, -- ꋍ
 },
 [0xA2CE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2CE, -- ꋎ
 },
 [0xA2CF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2CF, -- ꋏ
 },
 [0xA2D0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D0, -- ꋐ
 },
 [0xA2D1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D1, -- ꋑ
 },
 [0xA2D2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D2, -- ꋒ
 },
 [0xA2D3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D3, -- ꋓ
 },
 [0xA2D4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D4, -- ꋔ
 },
 [0xA2D5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D5, -- ꋕ
 },
 [0xA2D6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D6, -- ꋖ
 },
 [0xA2D7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D7, -- ꋗ
 },
 [0xA2D8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D8, -- ꋘ
 },
 [0xA2D9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2D9, -- ꋙ
 },
 [0xA2DA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2DA, -- ꋚ
 },
 [0xA2DB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2DB, -- ꋛ
 },
 [0xA2DC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2DC, -- ꋜ
 },
 [0xA2DD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2DD, -- ꋝ
 },
 [0xA2DE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2DE, -- ꋞ
 },
 [0xA2DF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2DF, -- ꋟ
 },
 [0xA2E0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E0, -- ꋠ
 },
 [0xA2E1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E1, -- ꋡ
 },
 [0xA2E2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E2, -- ꋢ
 },
 [0xA2E3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E3, -- ꋣ
 },
 [0xA2E4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E4, -- ꋤ
 },
 [0xA2E5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E5, -- ꋥ
 },
 [0xA2E6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E6, -- ꋦ
 },
 [0xA2E7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E7, -- ꋧ
 },
 [0xA2E8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E8, -- ꋨ
 },
 [0xA2E9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2E9, -- ꋩ
 },
 [0xA2EA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2EA, -- ꋪ
 },
 [0xA2EB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2EB, -- ꋫ
 },
 [0xA2EC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZZYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2EC, -- ꋬ
 },
 [0xA2ED]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2ED, -- ꋭ
 },
 [0xA2EE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2EE, -- ꋮ
 },
 [0xA2EF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2EF, -- ꋯ
 },
 [0xA2F0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F0, -- ꋰ
 },
 [0xA2F1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F1, -- ꋱ
 },
 [0xA2F2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F2, -- ꋲ
 },
 [0xA2F3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F3, -- ꋳ
 },
 [0xA2F4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F4, -- ꋴ
 },
 [0xA2F5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F5, -- ꋵ
 },
 [0xA2F6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F6, -- ꋶ
 },
 [0xA2F7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F7, -- ꋷ
 },
 [0xA2F8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F8, -- ꋸ
 },
 [0xA2F9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2F9, -- ꋹ
 },
 [0xA2FA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2FA, -- ꋺ
 },
 [0xA2FB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2FB, -- ꋻ
 },
 [0xA2FC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2FC, -- ꋼ
 },
 [0xA2FD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2FD, -- ꋽ
 },
 [0xA2FE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2FE, -- ꋾ
 },
 [0xA2FF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA2FF, -- ꋿ
 },
 [0xA300]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA300, -- ꌀ
 },
 [0xA301]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA301, -- ꌁ
 },
 [0xA302]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA302, -- ꌂ
 },
 [0xA303]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA303, -- ꌃ
 },
 [0xA304]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA304, -- ꌄ
 },
 [0xA305]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA305, -- ꌅ
 },
 [0xA306]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA306, -- ꌆ
 },
 [0xA307]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA307, -- ꌇ
 },
 [0xA308]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NZYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA308, -- ꌈ
 },
 [0xA309]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA309, -- ꌉ
 },
 [0xA30A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA30A, -- ꌊ
 },
 [0xA30B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA30B, -- ꌋ
 },
 [0xA30C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA30C, -- ꌌ
 },
 [0xA30D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA30D, -- ꌍ
 },
 [0xA30E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA30E, -- ꌎ
 },
 [0xA30F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA30F, -- ꌏ
 },
 [0xA310]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA310, -- ꌐ
 },
 [0xA311]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA311, -- ꌑ
 },
 [0xA312]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA312, -- ꌒ
 },
 [0xA313]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA313, -- ꌓ
 },
 [0xA314]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA314, -- ꌔ
 },
 [0xA315]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA315, -- ꌕ
 },
 [0xA316]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA316, -- ꌖ
 },
 [0xA317]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA317, -- ꌗ
 },
 [0xA318]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA318, -- ꌘ
 },
 [0xA319]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA319, -- ꌙ
 },
 [0xA31A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA31A, -- ꌚ
 },
 [0xA31B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA31B, -- ꌛ
 },
 [0xA31C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA31C, -- ꌜ
 },
 [0xA31D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA31D, -- ꌝ
 },
 [0xA31E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA31E, -- ꌞ
 },
 [0xA31F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA31F, -- ꌟ
 },
 [0xA320]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA320, -- ꌠ
 },
 [0xA321]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA321, -- ꌡ
 },
 [0xA322]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA322, -- ꌢ
 },
 [0xA323]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA323, -- ꌣ
 },
 [0xA324]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA324, -- ꌤ
 },
 [0xA325]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA325, -- ꌥ
 },
 [0xA326]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA326, -- ꌦ
 },
 [0xA327]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA327, -- ꌧ
 },
 [0xA328]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA328, -- ꌨ
 },
 [0xA329]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA329, -- ꌩ
 },
 [0xA32A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA32A, -- ꌪ
 },
 [0xA32B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA32B, -- ꌫ
 },
 [0xA32C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA32C, -- ꌬ
 },
 [0xA32D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA32D, -- ꌭ
 },
 [0xA32E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA32E, -- ꌮ
 },
 [0xA32F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA32F, -- ꌯ
 },
 [0xA330]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA330, -- ꌰ
 },
 [0xA331]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA331, -- ꌱ
 },
 [0xA332]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA332, -- ꌲ
 },
 [0xA333]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA333, -- ꌳ
 },
 [0xA334]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA334, -- ꌴ
 },
 [0xA335]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA335, -- ꌵ
 },
 [0xA336]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA336, -- ꌶ
 },
 [0xA337]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA337, -- ꌷ
 },
 [0xA338]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA338, -- ꌸ
 },
 [0xA339]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA339, -- ꌹ
 },
 [0xA33A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA33A, -- ꌺ
 },
 [0xA33B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA33B, -- ꌻ
 },
 [0xA33C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA33C, -- ꌼ
 },
 [0xA33D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA33D, -- ꌽ
 },
 [0xA33E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA33E, -- ꌾ
 },
 [0xA33F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA33F, -- ꌿ
 },
 [0xA340]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA340, -- ꍀ
 },
 [0xA341]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA341, -- ꍁ
 },
 [0xA342]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA342, -- ꍂ
 },
 [0xA343]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA343, -- ꍃ
 },
 [0xA344]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA344, -- ꍄ
 },
 [0xA345]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SSYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA345, -- ꍅ
 },
 [0xA346]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA346, -- ꍆ
 },
 [0xA347]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA347, -- ꍇ
 },
 [0xA348]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA348, -- ꍈ
 },
 [0xA349]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA349, -- ꍉ
 },
 [0xA34A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA34A, -- ꍊ
 },
 [0xA34B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA34B, -- ꍋ
 },
 [0xA34C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA34C, -- ꍌ
 },
 [0xA34D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA34D, -- ꍍ
 },
 [0xA34E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA34E, -- ꍎ
 },
 [0xA34F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA34F, -- ꍏ
 },
 [0xA350]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA350, -- ꍐ
 },
 [0xA351]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA351, -- ꍑ
 },
 [0xA352]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA352, -- ꍒ
 },
 [0xA353]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA353, -- ꍓ
 },
 [0xA354]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA354, -- ꍔ
 },
 [0xA355]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA355, -- ꍕ
 },
 [0xA356]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA356, -- ꍖ
 },
 [0xA357]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA357, -- ꍗ
 },
 [0xA358]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA358, -- ꍘ
 },
 [0xA359]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA359, -- ꍙ
 },
 [0xA35A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA35A, -- ꍚ
 },
 [0xA35B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA35B, -- ꍛ
 },
 [0xA35C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA35C, -- ꍜ
 },
 [0xA35D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA35D, -- ꍝ
 },
 [0xA35E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA35E, -- ꍞ
 },
 [0xA35F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA35F, -- ꍟ
 },
 [0xA360]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ZHYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA360, -- ꍠ
 },
 [0xA361]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA361, -- ꍡ
 },
 [0xA362]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA362, -- ꍢ
 },
 [0xA363]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA363, -- ꍣ
 },
 [0xA364]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA364, -- ꍤ
 },
 [0xA365]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA365, -- ꍥ
 },
 [0xA366]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA366, -- ꍦ
 },
 [0xA367]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA367, -- ꍧ
 },
 [0xA368]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA368, -- ꍨ
 },
 [0xA369]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA369, -- ꍩ
 },
 [0xA36A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA36A, -- ꍪ
 },
 [0xA36B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA36B, -- ꍫ
 },
 [0xA36C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA36C, -- ꍬ
 },
 [0xA36D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA36D, -- ꍭ
 },
 [0xA36E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA36E, -- ꍮ
 },
 [0xA36F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA36F, -- ꍯ
 },
 [0xA370]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA370, -- ꍰ
 },
 [0xA371]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA371, -- ꍱ
 },
 [0xA372]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA372, -- ꍲ
 },
 [0xA373]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA373, -- ꍳ
 },
 [0xA374]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA374, -- ꍴ
 },
 [0xA375]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA375, -- ꍵ
 },
 [0xA376]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA376, -- ꍶ
 },
 [0xA377]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA377, -- ꍷ
 },
 [0xA378]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA378, -- ꍸ
 },
 [0xA379]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA379, -- ꍹ
 },
 [0xA37A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA37A, -- ꍺ
 },
 [0xA37B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE CHYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA37B, -- ꍻ
 },
 [0xA37C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA37C, -- ꍼ
 },
 [0xA37D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA37D, -- ꍽ
 },
 [0xA37E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA37E, -- ꍾ
 },
 [0xA37F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA37F, -- ꍿ
 },
 [0xA380]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RROT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA380, -- ꎀ
 },
 [0xA381]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RROX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA381, -- ꎁ
 },
 [0xA382]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA382, -- ꎂ
 },
 [0xA383]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RROP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA383, -- ꎃ
 },
 [0xA384]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA384, -- ꎄ
 },
 [0xA385]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RREX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA385, -- ꎅ
 },
 [0xA386]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA386, -- ꎆ
 },
 [0xA387]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RREP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA387, -- ꎇ
 },
 [0xA388]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA388, -- ꎈ
 },
 [0xA389]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA389, -- ꎉ
 },
 [0xA38A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA38A, -- ꎊ
 },
 [0xA38B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA38B, -- ꎋ
 },
 [0xA38C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA38C, -- ꎌ
 },
 [0xA38D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA38D, -- ꎍ
 },
 [0xA38E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA38E, -- ꎎ
 },
 [0xA38F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA38F, -- ꎏ
 },
 [0xA390]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA390, -- ꎐ
 },
 [0xA391]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA391, -- ꎑ
 },
 [0xA392]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA392, -- ꎒ
 },
 [0xA393]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RRYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA393, -- ꎓ
 },
 [0xA394]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA394, -- ꎔ
 },
 [0xA395]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA395, -- ꎕ
 },
 [0xA396]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA396, -- ꎖ
 },
 [0xA397]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA397, -- ꎗ
 },
 [0xA398]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NROX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA398, -- ꎘ
 },
 [0xA399]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA399, -- ꎙ
 },
 [0xA39A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NROP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA39A, -- ꎚ
 },
 [0xA39B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA39B, -- ꎛ
 },
 [0xA39C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NREX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA39C, -- ꎜ
 },
 [0xA39D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA39D, -- ꎝ
 },
 [0xA39E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NREP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA39E, -- ꎞ
 },
 [0xA39F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA39F, -- ꎟ
 },
 [0xA3A0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A0, -- ꎠ
 },
 [0xA3A1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A1, -- ꎡ
 },
 [0xA3A2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A2, -- ꎢ
 },
 [0xA3A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A3, -- ꎣ
 },
 [0xA3A4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A4, -- ꎤ
 },
 [0xA3A5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A5, -- ꎥ
 },
 [0xA3A6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A6, -- ꎦ
 },
 [0xA3A7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A7, -- ꎧ
 },
 [0xA3A8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A8, -- ꎨ
 },
 [0xA3A9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3A9, -- ꎩ
 },
 [0xA3AA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NRYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3AA, -- ꎪ
 },
 [0xA3AB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3AB, -- ꎫ
 },
 [0xA3AC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3AC, -- ꎬ
 },
 [0xA3AD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3AD, -- ꎭ
 },
 [0xA3AE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3AE, -- ꎮ
 },
 [0xA3AF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3AF, -- ꎯ
 },
 [0xA3B0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B0, -- ꎰ
 },
 [0xA3B1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B1, -- ꎱ
 },
 [0xA3B2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B2, -- ꎲ
 },
 [0xA3B3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B3, -- ꎳ
 },
 [0xA3B4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B4, -- ꎴ
 },
 [0xA3B5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B5, -- ꎵ
 },
 [0xA3B6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B6, -- ꎶ
 },
 [0xA3B7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B7, -- ꎷ
 },
 [0xA3B8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B8, -- ꎸ
 },
 [0xA3B9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3B9, -- ꎹ
 },
 [0xA3BA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3BA, -- ꎺ
 },
 [0xA3BB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3BB, -- ꎻ
 },
 [0xA3BC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3BC, -- ꎼ
 },
 [0xA3BD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3BD, -- ꎽ
 },
 [0xA3BE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3BE, -- ꎾ
 },
 [0xA3BF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3BF, -- ꎿ
 },
 [0xA3C0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C0, -- ꏀ
 },
 [0xA3C1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C1, -- ꏁ
 },
 [0xA3C2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C2, -- ꏂ
 },
 [0xA3C3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C3, -- ꏃ
 },
 [0xA3C4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C4, -- ꏄ
 },
 [0xA3C5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE SHYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C5, -- ꏅ
 },
 [0xA3C6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C6, -- ꏆ
 },
 [0xA3C7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RAX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C7, -- ꏇ
 },
 [0xA3C8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C8, -- ꏈ
 },
 [0xA3C9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RAP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3C9, -- ꏉ
 },
 [0xA3CA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3CA, -- ꏊ
 },
 [0xA3CB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3CB, -- ꏋ
 },
 [0xA3CC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3CC, -- ꏌ
 },
 [0xA3CD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ROT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3CD, -- ꏍ
 },
 [0xA3CE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ROX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3CE, -- ꏎ
 },
 [0xA3CF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3CF, -- ꏏ
 },
 [0xA3D0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE ROP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D0, -- ꏐ
 },
 [0xA3D1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE REX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D1, -- ꏑ
 },
 [0xA3D2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D2, -- ꏒ
 },
 [0xA3D3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE REP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D3, -- ꏓ
 },
 [0xA3D4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D4, -- ꏔ
 },
 [0xA3D5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D5, -- ꏕ
 },
 [0xA3D6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D6, -- ꏖ
 },
 [0xA3D7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D7, -- ꏗ
 },
 [0xA3D8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D8, -- ꏘ
 },
 [0xA3D9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3D9, -- ꏙ
 },
 [0xA3DA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3DA, -- ꏚ
 },
 [0xA3DB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3DB, -- ꏛ
 },
 [0xA3DC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3DC, -- ꏜ
 },
 [0xA3DD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3DD, -- ꏝ
 },
 [0xA3DE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3DE, -- ꏞ
 },
 [0xA3DF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE RYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3DF, -- ꏟ
 },
 [0xA3E0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E0, -- ꏠ
 },
 [0xA3E1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E1, -- ꏡ
 },
 [0xA3E2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E2, -- ꏢ
 },
 [0xA3E3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E3, -- ꏣ
 },
 [0xA3E4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E4, -- ꏤ
 },
 [0xA3E5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E5, -- ꏥ
 },
 [0xA3E6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E6, -- ꏦ
 },
 [0xA3E7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E7, -- ꏧ
 },
 [0xA3E8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E8, -- ꏨ
 },
 [0xA3E9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3E9, -- ꏩ
 },
 [0xA3EA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3EA, -- ꏪ
 },
 [0xA3EB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3EB, -- ꏫ
 },
 [0xA3EC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3EC, -- ꏬ
 },
 [0xA3ED]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3ED, -- ꏭ
 },
 [0xA3EE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3EE, -- ꏮ
 },
 [0xA3EF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3EF, -- ꏯ
 },
 [0xA3F0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F0, -- ꏰ
 },
 [0xA3F1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F1, -- ꏱ
 },
 [0xA3F2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F2, -- ꏲ
 },
 [0xA3F3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F3, -- ꏳ
 },
 [0xA3F4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F4, -- ꏴ
 },
 [0xA3F5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F5, -- ꏵ
 },
 [0xA3F6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F6, -- ꏶ
 },
 [0xA3F7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F7, -- ꏷ
 },
 [0xA3F8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F8, -- ꏸ
 },
 [0xA3F9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3F9, -- ꏹ
 },
 [0xA3FA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3FA, -- ꏺ
 },
 [0xA3FB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3FB, -- ꏻ
 },
 [0xA3FC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3FC, -- ꏼ
 },
 [0xA3FD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3FD, -- ꏽ
 },
 [0xA3FE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3FE, -- ꏾ
 },
 [0xA3FF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA3FF, -- ꏿ
 },
 [0xA400]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA400, -- ꐀ
 },
 [0xA401]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA401, -- ꐁ
 },
 [0xA402]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA402, -- ꐂ
 },
 [0xA403]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA403, -- ꐃ
 },
 [0xA404]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA404, -- ꐄ
 },
 [0xA405]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA405, -- ꐅ
 },
 [0xA406]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA406, -- ꐆ
 },
 [0xA407]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA407, -- ꐇ
 },
 [0xA408]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA408, -- ꐈ
 },
 [0xA409]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA409, -- ꐉ
 },
 [0xA40A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA40A, -- ꐊ
 },
 [0xA40B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA40B, -- ꐋ
 },
 [0xA40C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA40C, -- ꐌ
 },
 [0xA40D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA40D, -- ꐍ
 },
 [0xA40E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA40E, -- ꐎ
 },
 [0xA40F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA40F, -- ꐏ
 },
 [0xA410]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA410, -- ꐐ
 },
 [0xA411]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA411, -- ꐑ
 },
 [0xA412]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA412, -- ꐒ
 },
 [0xA413]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA413, -- ꐓ
 },
 [0xA414]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA414, -- ꐔ
 },
 [0xA415]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA415, -- ꐕ
 },
 [0xA416]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA416, -- ꐖ
 },
 [0xA417]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE QYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA417, -- ꐗ
 },
 [0xA418]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA418, -- ꐘ
 },
 [0xA419]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA419, -- ꐙ
 },
 [0xA41A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA41A, -- ꐚ
 },
 [0xA41B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA41B, -- ꐛ
 },
 [0xA41C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA41C, -- ꐜ
 },
 [0xA41D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA41D, -- ꐝ
 },
 [0xA41E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA41E, -- ꐞ
 },
 [0xA41F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA41F, -- ꐟ
 },
 [0xA420]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA420, -- ꐠ
 },
 [0xA421]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA421, -- ꐡ
 },
 [0xA422]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA422, -- ꐢ
 },
 [0xA423]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA423, -- ꐣ
 },
 [0xA424]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA424, -- ꐤ
 },
 [0xA425]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA425, -- ꐥ
 },
 [0xA426]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA426, -- ꐦ
 },
 [0xA427]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA427, -- ꐧ
 },
 [0xA428]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA428, -- ꐨ
 },
 [0xA429]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA429, -- ꐩ
 },
 [0xA42A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA42A, -- ꐪ
 },
 [0xA42B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA42B, -- ꐫ
 },
 [0xA42C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA42C, -- ꐬ
 },
 [0xA42D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA42D, -- ꐭ
 },
 [0xA42E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA42E, -- ꐮ
 },
 [0xA42F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA42F, -- ꐯ
 },
 [0xA430]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE JJYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA430, -- ꐰ
 },
 [0xA431]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA431, -- ꐱ
 },
 [0xA432]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA432, -- ꐲ
 },
 [0xA433]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA433, -- ꐳ
 },
 [0xA434]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA434, -- ꐴ
 },
 [0xA435]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA435, -- ꐵ
 },
 [0xA436]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA436, -- ꐶ
 },
 [0xA437]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA437, -- ꐷ
 },
 [0xA438]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA438, -- ꐸ
 },
 [0xA439]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA439, -- ꐹ
 },
 [0xA43A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA43A, -- ꐺ
 },
 [0xA43B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA43B, -- ꐻ
 },
 [0xA43C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA43C, -- ꐼ
 },
 [0xA43D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA43D, -- ꐽ
 },
 [0xA43E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA43E, -- ꐾ
 },
 [0xA43F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA43F, -- ꐿ
 },
 [0xA440]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA440, -- ꑀ
 },
 [0xA441]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA441, -- ꑁ
 },
 [0xA442]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA442, -- ꑂ
 },
 [0xA443]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA443, -- ꑃ
 },
 [0xA444]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA444, -- ꑄ
 },
 [0xA445]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA445, -- ꑅ
 },
 [0xA446]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA446, -- ꑆ
 },
 [0xA447]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA447, -- ꑇ
 },
 [0xA448]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA448, -- ꑈ
 },
 [0xA449]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NJYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA449, -- ꑉ
 },
 [0xA44A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA44A, -- ꑊ
 },
 [0xA44B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA44B, -- ꑋ
 },
 [0xA44C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA44C, -- ꑌ
 },
 [0xA44D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA44D, -- ꑍ
 },
 [0xA44E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA44E, -- ꑎ
 },
 [0xA44F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA44F, -- ꑏ
 },
 [0xA450]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA450, -- ꑐ
 },
 [0xA451]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA451, -- ꑑ
 },
 [0xA452]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA452, -- ꑒ
 },
 [0xA453]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA453, -- ꑓ
 },
 [0xA454]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA454, -- ꑔ
 },
 [0xA455]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA455, -- ꑕ
 },
 [0xA456]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA456, -- ꑖ
 },
 [0xA457]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA457, -- ꑗ
 },
 [0xA458]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA458, -- ꑘ
 },
 [0xA459]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA459, -- ꑙ
 },
 [0xA45A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA45A, -- ꑚ
 },
 [0xA45B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA45B, -- ꑛ
 },
 [0xA45C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE NYUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA45C, -- ꑜ
 },
 [0xA45D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA45D, -- ꑝ
 },
 [0xA45E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA45E, -- ꑞ
 },
 [0xA45F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA45F, -- ꑟ
 },
 [0xA460]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA460, -- ꑠ
 },
 [0xA461]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA461, -- ꑡ
 },
 [0xA462]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA462, -- ꑢ
 },
 [0xA463]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA463, -- ꑣ
 },
 [0xA464]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA464, -- ꑤ
 },
 [0xA465]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA465, -- ꑥ
 },
 [0xA466]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA466, -- ꑦ
 },
 [0xA467]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA467, -- ꑧ
 },
 [0xA468]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA468, -- ꑨ
 },
 [0xA469]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA469, -- ꑩ
 },
 [0xA46A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA46A, -- ꑪ
 },
 [0xA46B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA46B, -- ꑫ
 },
 [0xA46C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA46C, -- ꑬ
 },
 [0xA46D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA46D, -- ꑭ
 },
 [0xA46E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA46E, -- ꑮ
 },
 [0xA46F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA46F, -- ꑯ
 },
 [0xA470]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE XYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA470, -- ꑰ
 },
 [0xA471]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA471, -- ꑱ
 },
 [0xA472]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YIX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA472, -- ꑲ
 },
 [0xA473]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA473, -- ꑳ
 },
 [0xA474]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA474, -- ꑴ
 },
 [0xA475]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA475, -- ꑵ
 },
 [0xA476]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YIEX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA476, -- ꑶ
 },
 [0xA477]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA477, -- ꑷ
 },
 [0xA478]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YIEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA478, -- ꑸ
 },
 [0xA479]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YUOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA479, -- ꑹ
 },
 [0xA47A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YUOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA47A, -- ꑺ
 },
 [0xA47B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA47B, -- ꑻ
 },
 [0xA47C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA47C, -- ꑼ
 },
 [0xA47D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA47D, -- ꑽ
 },
 [0xA47E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YOX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA47E, -- ꑾ
 },
 [0xA47F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA47F, -- ꑿ
 },
 [0xA480]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA480, -- ꒀ
 },
 [0xA481]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA481, -- ꒁ
 },
 [0xA482]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YUX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA482, -- ꒂ
 },
 [0xA483]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA483, -- ꒃ
 },
 [0xA484]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA484, -- ꒄ
 },
 [0xA485]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YURX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA485, -- ꒅ
 },
 [0xA486]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA486, -- ꒆ
 },
 [0xA487]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA487, -- ꒇ
 },
 [0xA488]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YYX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA488, -- ꒈ
 },
 [0xA489]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA489, -- ꒉ
 },
 [0xA48A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA48A, -- ꒊ
 },
 [0xA48B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YYRX",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA48B, -- ꒋ
 },
 [0xA48C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="YI SYLLABLE YYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA48C, -- ꒌ
 },
 [0xA490]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL QOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA490, -- ꒐
 },
 [0xA491]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL LI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA491, -- ꒑
 },
 [0xA492]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL KIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA492, -- ꒒
 },
 [0xA493]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL NYIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA493, -- ꒓
 },
 [0xA494]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL CYP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA494, -- ꒔
 },
 [0xA495]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL SSI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA495, -- ꒕
 },
 [0xA496]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL GGOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA496, -- ꒖
 },
 [0xA497]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL GEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA497, -- ꒗
 },
 [0xA498]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL MI",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA498, -- ꒘
 },
 [0xA499]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL HXIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA499, -- ꒙
 },
 [0xA49A]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL LYR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA49A, -- ꒚
 },
 [0xA49B]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL BBUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA49B, -- ꒛
 },
 [0xA49C]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL MOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA49C, -- ꒜
 },
 [0xA49D]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL YO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA49D, -- ꒝
 },
 [0xA49E]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL PUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA49E, -- ꒞
 },
 [0xA49F]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL HXUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA49F, -- ꒟
 },
 [0xA4A0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL TAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A0, -- ꒠
 },
 [0xA4A1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL GA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A1, -- ꒡
 },
 [0xA4A2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL ZUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A2, -- ꒢
 },
 [0xA4A3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL CYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A3, -- ꒣
 },
 [0xA4A4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL DDUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A4, -- ꒤
 },
 [0xA4A5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL BUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A5, -- ꒥
 },
 [0xA4A6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL GGUO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A6, -- ꒦
 },
 [0xA4A7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL NYOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A7, -- ꒧
 },
 [0xA4A8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL TU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A8, -- ꒨
 },
 [0xA4A9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL OP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4A9, -- ꒩
 },
 [0xA4AA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL JJUT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4AA, -- ꒪
 },
 [0xA4AB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL ZOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4AB, -- ꒫
 },
 [0xA4AC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL PYT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4AC, -- ꒬
 },
 [0xA4AD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL HMO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4AD, -- ꒭
 },
 [0xA4AE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL YIT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4AE, -- ꒮
 },
 [0xA4AF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL VUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4AF, -- ꒯
 },
 [0xA4B0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL SHY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B0, -- ꒰
 },
 [0xA4B1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL VEP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B1, -- ꒱
 },
 [0xA4B2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL ZA",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B2, -- ꒲
 },
 [0xA4B3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL JO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B3, -- ꒳
 },
 [0xA4B4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL NZUP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B4, -- ꒴
 },
 [0xA4B5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL JJY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B5, -- ꒵
 },
 [0xA4B6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL GOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B6, -- ꒶
 },
 [0xA4B7]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL JJIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B7, -- ꒷
 },
 [0xA4B8]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL WO",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B8, -- ꒸
 },
 [0xA4B9]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL DU",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4B9, -- ꒹
 },
 [0xA4BA]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL SHUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4BA, -- ꒺
 },
 [0xA4BB]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL LIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4BB, -- ꒻
 },
 [0xA4BC]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL CY",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4BC, -- ꒼
 },
 [0xA4BD]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL CUOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4BD, -- ꒽
 },
 [0xA4BE]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL CIP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4BE, -- ꒾
 },
 [0xA4BF]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL HXOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4BF, -- ꒿
 },
 [0xA4C0]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL SHAT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4C0, -- ꓀
 },
 [0xA4C1]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL ZUR",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4C1, -- ꓁
 },
 [0xA4C2]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL SHOP",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4C2, -- ꓂
 },
 [0xA4C3]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL CHE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4C3, -- ꓃
 },
 [0xA4C4]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL ZZIET",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4C4, -- ꓄
 },
 [0xA4C5]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL NBIE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4C5, -- ꓅
 },
 [0xA4C6]={
  ["category"]="so",
  ["cjkwd"]="w",
  ["description"]="YI RADICAL KE",
  ["linebreak"]="id",
  ["unicodeslot"]=0xA4C6, -- ꓆
 },
 [0xA700]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CHINESE TONE YIN PING",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA700, -- ꜀
 },
 [0xA701]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CHINESE TONE YANG PING",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA701, -- ꜁
 },
 [0xA702]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CHINESE TONE YIN SHANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA702, -- ꜂
 },
 [0xA703]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CHINESE TONE YANG SHANG",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA703, -- ꜃
 },
 [0xA704]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CHINESE TONE YIN QU",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA704, -- ꜄
 },
 [0xA705]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CHINESE TONE YANG QU",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA705, -- ꜅
 },
 [0xA706]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CHINESE TONE YIN RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA706, -- ꜆
 },
 [0xA707]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER CHINESE TONE YANG RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA707, -- ꜇
 },
 [0xA708]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER EXTRA-HIGH DOTTED TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA708, -- ꜈
 },
 [0xA709]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER HIGH DOTTED TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA709, -- ꜉
 },
 [0xA70A]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER MID DOTTED TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA70A, -- ꜊
 },
 [0xA70B]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW DOTTED TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA70B, -- ꜋
 },
 [0xA70C]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER EXTRA-LOW DOTTED TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA70C, -- ꜌
 },
 [0xA70D]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER EXTRA-HIGH DOTTED LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA70D, -- ꜍
 },
 [0xA70E]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER HIGH DOTTED LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA70E, -- ꜎
 },
 [0xA70F]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER MID DOTTED LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA70F, -- ꜏
 },
 [0xA710]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW DOTTED LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA710, -- ꜐
 },
 [0xA711]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER EXTRA-LOW DOTTED LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA711, -- ꜑
 },
 [0xA712]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER EXTRA-HIGH LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA712, -- ꜒
 },
 [0xA713]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER HIGH LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA713, -- ꜓
 },
 [0xA714]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER MID LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA714, -- ꜔
 },
 [0xA715]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER LOW LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA715, -- ꜕
 },
 [0xA716]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER EXTRA-LOW LEFT-STEM TONE BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA716, -- ꜖
 },
 [0xA717]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER DOT VERTICAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA717, -- ꜗ
 },
 [0xA718]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER DOT SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA718, -- ꜘ
 },
 [0xA719]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER DOT HORIZONTAL BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA719, -- ꜙ
 },
 [0xA71A]={
  ["category"]="lm",
  ["description"]="MODIFIER LETTER LOWER RIGHT CORNER ANGLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA71A, -- ꜚ
 },
 [0xA720]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER STRESS AND HIGH TONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA720, -- ꜠
 },
 [0xA721]={
  ["category"]="sk",
  ["description"]="MODIFIER LETTER STRESS AND LOW TONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA721, -- ꜡
 },
 [0xA800]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA800, -- ꠀ
 },
 [0xA801]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA801, -- ꠁ
 },
 [0xA802]={
  ["category"]="mc",
  ["description"]="SYLOTI NAGRI SIGN DVISVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xA802, -- ꠂ
 },
 [0xA803]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA803, -- ꠃ
 },
 [0xA804]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA804, -- ꠄ
 },
 [0xA805]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA805, -- ꠅ
 },
 [0xA806]={
  ["category"]="mn",
  ["description"]="SYLOTI NAGRI SIGN HASANTA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xA806, -- ꠆
 },
 [0xA807]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER KO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA807, -- ꠇ
 },
 [0xA808]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER KHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA808, -- ꠈ
 },
 [0xA809]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER GO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA809, -- ꠉ
 },
 [0xA80A]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER GHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA80A, -- ꠊ
 },
 [0xA80B]={
  ["category"]="mn",
  ["description"]="SYLOTI NAGRI SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xA80B, -- ꠋ
 },
 [0xA80C]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER CO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA80C, -- ꠌ
 },
 [0xA80D]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER CHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA80D, -- ꠍ
 },
 [0xA80E]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER JO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA80E, -- ꠎ
 },
 [0xA80F]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER JHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA80F, -- ꠏ
 },
 [0xA810]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER TTO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA810, -- ꠐ
 },
 [0xA811]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER TTHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA811, -- ꠑ
 },
 [0xA812]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER DDO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA812, -- ꠒ
 },
 [0xA813]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER DDHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA813, -- ꠓ
 },
 [0xA814]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA814, -- ꠔ
 },
 [0xA815]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER THO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA815, -- ꠕ
 },
 [0xA816]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER DO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA816, -- ꠖ
 },
 [0xA817]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER DHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA817, -- ꠗ
 },
 [0xA818]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER NO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA818, -- ꠘ
 },
 [0xA819]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER PO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA819, -- ꠙ
 },
 [0xA81A]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER PHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA81A, -- ꠚ
 },
 [0xA81B]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER BO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA81B, -- ꠛ
 },
 [0xA81C]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER BHO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA81C, -- ꠜ
 },
 [0xA81D]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER MO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA81D, -- ꠝ
 },
 [0xA81E]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA81E, -- ꠞ
 },
 [0xA81F]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER LO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA81F, -- ꠟ
 },
 [0xA820]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER RRO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA820, -- ꠠ
 },
 [0xA821]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER SO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA821, -- ꠡ
 },
 [0xA822]={
  ["category"]="lo",
  ["description"]="SYLOTI NAGRI LETTER HO",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA822, -- ꠢ
 },
 [0xA823]={
  ["category"]="mc",
  ["description"]="SYLOTI NAGRI VOWEL SIGN A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xA823, -- ꠣ
 },
 [0xA824]={
  ["category"]="mc",
  ["description"]="SYLOTI NAGRI VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xA824, -- ꠤ
 },
 [0xA825]={
  ["category"]="mn",
  ["description"]="SYLOTI NAGRI VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xA825, -- ꠥ
 },
 [0xA826]={
  ["category"]="mn",
  ["description"]="SYLOTI NAGRI VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xA826, -- ꠦ
 },
 [0xA827]={
  ["category"]="mc",
  ["description"]="SYLOTI NAGRI VOWEL SIGN OO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xA827, -- ꠧ
 },
 [0xA828]={
  ["category"]="so",
  ["description"]="SYLOTI NAGRI POETRY MARK-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA828, -- ꠨
 },
 [0xA829]={
  ["category"]="so",
  ["description"]="SYLOTI NAGRI POETRY MARK-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA829, -- ꠩
 },
 [0xA82A]={
  ["category"]="so",
  ["description"]="SYLOTI NAGRI POETRY MARK-0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA82A, -- ꠪
 },
 [0xA82B]={
  ["category"]="so",
  ["description"]="SYLOTI NAGRI POETRY MARK-0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA82B, -- ꠫
 },
 [0xA840]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA840, -- ꡀ
 },
 [0xA841]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA841, -- ꡁ
 },
 [0xA842]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA842, -- ꡂ
 },
 [0xA843]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER NGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA843, -- ꡃ
 },
 [0xA844]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA844, -- ꡄ
 },
 [0xA845]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA845, -- ꡅ
 },
 [0xA846]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA846, -- ꡆ
 },
 [0xA847]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA847, -- ꡇ
 },
 [0xA848]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA848, -- ꡈ
 },
 [0xA849]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA849, -- ꡉ
 },
 [0xA84A]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA84A, -- ꡊ
 },
 [0xA84B]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA84B, -- ꡋ
 },
 [0xA84C]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA84C, -- ꡌ
 },
 [0xA84D]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA84D, -- ꡍ
 },
 [0xA84E]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA84E, -- ꡎ
 },
 [0xA84F]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA84F, -- ꡏ
 },
 [0xA850]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER TSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA850, -- ꡐ
 },
 [0xA851]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER TSHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA851, -- ꡑ
 },
 [0xA852]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER DZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA852, -- ꡒ
 },
 [0xA853]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA853, -- ꡓ
 },
 [0xA854]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER ZHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA854, -- ꡔ
 },
 [0xA855]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA855, -- ꡕ
 },
 [0xA856]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER SMALL A",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA856, -- ꡖ
 },
 [0xA857]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA857, -- ꡗ
 },
 [0xA858]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA858, -- ꡘ
 },
 [0xA859]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA859, -- ꡙ
 },
 [0xA85A]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA85A, -- ꡚ
 },
 [0xA85B]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA85B, -- ꡛ
 },
 [0xA85C]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA85C, -- ꡜ
 },
 [0xA85D]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA85D, -- ꡝ
 },
 [0xA85E]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA85E, -- ꡞ
 },
 [0xA85F]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA85F, -- ꡟ
 },
 [0xA860]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA860, -- ꡠ
 },
 [0xA861]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA861, -- ꡡ
 },
 [0xA862]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER QA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA862, -- ꡢ
 },
 [0xA863]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER XA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA863, -- ꡣ
 },
 [0xA864]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA864, -- ꡤ
 },
 [0xA865]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER GGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA865, -- ꡥ
 },
 [0xA866]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA866, -- ꡦ
 },
 [0xA867]={
  ["category"]="lo",
  ["description"]="PHAGS-PA SUBJOINED LETTER WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA867, -- ꡧ
 },
 [0xA868]={
  ["category"]="lo",
  ["description"]="PHAGS-PA SUBJOINED LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA868, -- ꡨ
 },
 [0xA869]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA869, -- ꡩ
 },
 [0xA86A]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA86A, -- ꡪ
 },
 [0xA86B]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA86B, -- ꡫ
 },
 [0xA86C]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA86C, -- ꡬ
 },
 [0xA86D]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER ALTERNATE YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA86D, -- ꡭ
 },
 [0xA86E]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER VOICELESS SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA86E, -- ꡮ
 },
 [0xA86F]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER VOICED HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA86F, -- ꡯ
 },
 [0xA870]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER ASPIRATED FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA870, -- ꡰ
 },
 [0xA871]={
  ["category"]="lo",
  ["description"]="PHAGS-PA SUBJOINED LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA871, -- ꡱ
 },
 [0xA872]={
  ["category"]="lo",
  ["description"]="PHAGS-PA SUPERFIXED LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA872, -- ꡲ
 },
 [0xA873]={
  ["category"]="lo",
  ["description"]="PHAGS-PA LETTER CANDRABINDU",
  ["linebreak"]="al",
  ["unicodeslot"]=0xA873, -- ꡳ
 },
 [0xA874]={
  ["category"]="po",
  ["description"]="PHAGS-PA SINGLE HEAD MARK",
  ["linebreak"]="bb",
  ["unicodeslot"]=0xA874, -- ꡴
 },
 [0xA875]={
  ["category"]="po",
  ["description"]="PHAGS-PA DOUBLE HEAD MARK",
  ["linebreak"]="bb",
  ["unicodeslot"]=0xA875, -- ꡵
 },
 [0xA876]={
  ["category"]="po",
  ["description"]="PHAGS-PA MARK SHAD",
  ["linebreak"]="ex",
  ["unicodeslot"]=0xA876, -- ꡶
 },
 [0xA877]={
  ["category"]="po",
  ["description"]="PHAGS-PA MARK DOUBLE SHAD",
  ["linebreak"]="ex",
  ["unicodeslot"]=0xA877, -- ꡷
 },
 [0xAC00]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="<Hangul Syllable, First>",
  ["linebreak"]="h2",
  ["unicodeslot"]=0xAC00, -- 가
 },
 [0xD7A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="<Hangul Syllable, Last>",
  ["linebreak"]="h3",
  ["unicodeslot"]=0xD7A3, -- 힣
 },
 [0xD800]={
  ["category"]="cs",
  ["description"]="<Non Private Use High Surrogate, First>",
  ["linebreak"]="sg",
  ["unicodeslot"]=0xD800, -- 
 },
 [0xDB7F]={
  ["category"]="cs",
  ["description"]="<Non Private Use High Surrogate, Last>",
  ["linebreak"]="sg",
  ["unicodeslot"]=0xDB7F, -- 
 },
 [0xDB80]={
  ["category"]="cs",
  ["description"]="<Private Use High Surrogate, First>",
  ["linebreak"]="sg",
  ["unicodeslot"]=0xDB80, -- 
 },
 [0xDBFF]={
  ["category"]="cs",
  ["description"]="<Private Use High Surrogate, Last>",
  ["linebreak"]="sg",
  ["unicodeslot"]=0xDBFF, -- 
 },
 [0xDC00]={
  ["category"]="cs",
  ["description"]="<Low Surrogate, First>",
  ["linebreak"]="sg",
  ["unicodeslot"]=0xDC00, -- 
 },
 [0xDFFF]={
  ["category"]="cs",
  ["description"]="<Low Surrogate, Last>",
  ["linebreak"]="sg",
  ["unicodeslot"]=0xDFFF, -- 
 },
 [0xE000]={
  ["category"]="co",
  ["cjkwd"]="a",
  ["description"]="<Private Use, First>",
  ["unicodeslot"]=0xE000, -- 
 },
 [0xF8FF]={
  ["category"]="co",
  ["cjkwd"]="a",
  ["description"]="<Private Use, Last>",
  ["unicodeslot"]=0xF8FF, -- 
 },
 [0xF900]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0384",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8C48 },
  ["unicodeslot"]=0xF900, -- 豈
 },
 [0xF901]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0385",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x66F4 },
  ["unicodeslot"]=0xF901, -- 更
 },
 [0xF902]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0386",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8ECA },
  ["unicodeslot"]=0xF902, -- 車
 },
 [0xF903]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0387",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8CC8 },
  ["unicodeslot"]=0xF903, -- 賈
 },
 [0xF904]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0388",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6ED1 },
  ["unicodeslot"]=0xF904, -- 滑
 },
 [0xF905]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0389",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4E32 },
  ["unicodeslot"]=0xF905, -- 串
 },
 [0xF906]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x038A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x53E5 },
  ["unicodeslot"]=0xF906, -- 句
 },
 [0xF907]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x038B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F9C },
  ["unicodeslot"]=0xF907, -- 龜
 },
 [0xF908]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x038C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F9C },
  ["unicodeslot"]=0xF908, -- 龜
 },
 [0xF909]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x038D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5951 },
  ["unicodeslot"]=0xF909, -- 契
 },
 [0xF90A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005AA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x91D1 },
  ["unicodeslot"]=0xF90A, -- 金
 },
 [0xF90B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005AB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5587 },
  ["unicodeslot"]=0xF90B, -- 喇
 },
 [0xF90C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005AC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5948 },
  ["unicodeslot"]=0xF90C, -- 奈
 },
 [0xF90D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005AD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x61F6 },
  ["unicodeslot"]=0xF90D, -- 懶
 },
 [0xF90E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005AE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7669 },
  ["unicodeslot"]=0xF90E, -- 癩
 },
 [0xF90F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005AF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7F85 },
  ["unicodeslot"]=0xF90F, -- 羅
 },
 [0xF910]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x038E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x863F },
  ["unicodeslot"]=0xF910, -- 蘿
 },
 [0xF911]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x038F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x87BA },
  ["unicodeslot"]=0xF911, -- 螺
 },
 [0xF912]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0390",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x88F8 },
  ["unicodeslot"]=0xF912, -- 裸
 },
 [0xF913]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0391",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x908F },
  ["unicodeslot"]=0xF913, -- 邏
 },
 [0xF914]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0392",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6A02 },
  ["unicodeslot"]=0xF914, -- 樂
 },
 [0xF915]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0393",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D1B },
  ["unicodeslot"]=0xF915, -- 洛
 },
 [0xF916]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0394",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x70D9 },
  ["unicodeslot"]=0xF916, -- 烙
 },
 [0xF917]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0395",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x73DE },
  ["unicodeslot"]=0xF917, -- 珞
 },
 [0xF918]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0396",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x843D },
  ["unicodeslot"]=0xF918, -- 落
 },
 [0xF919]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0397",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x916A },
  ["unicodeslot"]=0xF919, -- 酪
 },
 [0xF91A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005BA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x99F1 },
  ["unicodeslot"]=0xF91A, -- 駱
 },
 [0xF91B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005BB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4E82 },
  ["unicodeslot"]=0xF91B, -- 亂
 },
 [0xF91C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005BC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5375 },
  ["unicodeslot"]=0xF91C, -- 卵
 },
 [0xF91D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005BD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6B04 },
  ["unicodeslot"]=0xF91D, -- 欄
 },
 [0xF91E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005BE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x721B },
  ["unicodeslot"]=0xF91E, -- 爛
 },
 [0xF91F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005BF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x862D },
  ["unicodeslot"]=0xF91F, -- 蘭
 },
 [0xF920]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0398",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9E1E },
  ["unicodeslot"]=0xF920, -- 鸞
 },
 [0xF921]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0399",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5D50 },
  ["unicodeslot"]=0xF921, -- 嵐
 },
 [0xF922]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x039A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6FEB },
  ["unicodeslot"]=0xF922, -- 濫
 },
 [0xF923]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x039B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x85CD },
  ["unicodeslot"]=0xF923, -- 藍
 },
 [0xF924]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x039C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8964 },
  ["unicodeslot"]=0xF924, -- 襤
 },
 [0xF925]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x039D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x62C9 },
  ["unicodeslot"]=0xF925, -- 拉
 },
 [0xF926]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x039E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x81D8 },
  ["unicodeslot"]=0xF926, -- 臘
 },
 [0xF927]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x039F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x881F },
  ["unicodeslot"]=0xF927, -- 蠟
 },
 [0xF928]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5ECA },
  ["unicodeslot"]=0xF928, -- 廊
 },
 [0xF929]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6717 },
  ["unicodeslot"]=0xF929, -- 朗
 },
 [0xF92A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005CA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D6A },
  ["unicodeslot"]=0xF92A, -- 浪
 },
 [0xF92B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005CB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x72FC },
  ["unicodeslot"]=0xF92B, -- 狼
 },
 [0xF92C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005CC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x90CE },
  ["unicodeslot"]=0xF92C, -- 郎
 },
 [0xF92D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005CD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4F86 },
  ["unicodeslot"]=0xF92D, -- 來
 },
 [0xF92E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005CE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51B7 },
  ["unicodeslot"]=0xF92E, -- 冷
 },
 [0xF92F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005CF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52DE },
  ["unicodeslot"]=0xF92F, -- 勞
 },
 [0xF930]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x64C4 },
  ["unicodeslot"]=0xF930, -- 擄
 },
 [0xF931]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6AD3 },
  ["unicodeslot"]=0xF931, -- 櫓
 },
 [0xF932]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7210 },
  ["unicodeslot"]=0xF932, -- 爐
 },
 [0xF933]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x76E7 },
  ["unicodeslot"]=0xF933, -- 盧
 },
 [0xF934]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8001 },
  ["unicodeslot"]=0xF934, -- 老
 },
 [0xF935]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8606 },
  ["unicodeslot"]=0xF935, -- 蘆
 },
 [0xF936]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A8",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x865C },
  ["unicodeslot"]=0xF936, -- 虜
 },
 [0xF937]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03A9",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8DEF },
  ["unicodeslot"]=0xF937, -- 路
 },
 [0xF938]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03AA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9732 },
  ["unicodeslot"]=0xF938, -- 露
 },
 [0xF939]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03AB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9B6F },
  ["unicodeslot"]=0xF939, -- 魯
 },
 [0xF93A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005DA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9DFA },
  ["unicodeslot"]=0xF93A, -- 鷺
 },
 [0xF93B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005DB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x788C },
  ["unicodeslot"]=0xF93B, -- 碌
 },
 [0xF93C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005DC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x797F },
  ["unicodeslot"]=0xF93C, -- 祿
 },
 [0xF93D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005DD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7DA0 },
  ["unicodeslot"]=0xF93D, -- 綠
 },
 [0xF93E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005DE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x83C9 },
  ["unicodeslot"]=0xF93E, -- 菉
 },
 [0xF93F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005DF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9304 },
  ["unicodeslot"]=0xF93F, -- 錄
 },
 [0xF940]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03AC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9E7F },
  ["unicodeslot"]=0xF940, -- 鹿
 },
 [0xF941]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03AD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AD6 },
  ["unicodeslot"]=0xF941, -- 論
 },
 [0xF942]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03AE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x58DF },
  ["unicodeslot"]=0xF942, -- 壟
 },
 [0xF943]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03AF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5F04 },
  ["unicodeslot"]=0xF943, -- 弄
 },
 [0xF944]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7C60 },
  ["unicodeslot"]=0xF944, -- 籠
 },
 [0xF945]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x807E },
  ["unicodeslot"]=0xF945, -- 聾
 },
 [0xF946]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7262 },
  ["unicodeslot"]=0xF946, -- 牢
 },
 [0xF947]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x78CA },
  ["unicodeslot"]=0xF947, -- 磊
 },
 [0xF948]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8CC2 },
  ["unicodeslot"]=0xF948, -- 賂
 },
 [0xF949]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x96F7 },
  ["unicodeslot"]=0xF949, -- 雷
 },
 [0xF94A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005EA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x58D8 },
  ["unicodeslot"]=0xF94A, -- 壘
 },
 [0xF94B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005EB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C62 },
  ["unicodeslot"]=0xF94B, -- 屢
 },
 [0xF94C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005EC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6A13 },
  ["unicodeslot"]=0xF94C, -- 樓
 },
 [0xF94D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005ED",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6DDA },
  ["unicodeslot"]=0xF94D, -- 淚
 },
 [0xF94E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005EE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6F0F },
  ["unicodeslot"]=0xF94E, -- 漏
 },
 [0xF94F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005EF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7D2F },
  ["unicodeslot"]=0xF94F, -- 累
 },
 [0xF950]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7E37 },
  ["unicodeslot"]=0xF950, -- 縷
 },
 [0xF951]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x964B },
  ["unicodeslot"]=0xF951, -- 陋
 },
 [0xF952]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B8",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52D2 },
  ["unicodeslot"]=0xF952, -- 勒
 },
 [0xF953]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03B9",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x808B },
  ["unicodeslot"]=0xF953, -- 肋
 },
 [0xF954]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03BA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51DC },
  ["unicodeslot"]=0xF954, -- 凜
 },
 [0xF955]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03BB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51CC },
  ["unicodeslot"]=0xF955, -- 凌
 },
 [0xF956]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03BC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7A1C },
  ["unicodeslot"]=0xF956, -- 稜
 },
 [0xF957]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03BD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7DBE },
  ["unicodeslot"]=0xF957, -- 綾
 },
 [0xF958]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03BE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x83F1 },
  ["unicodeslot"]=0xF958, -- 菱
 },
 [0xF959]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03BF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9675 },
  ["unicodeslot"]=0xF959, -- 陵
 },
 [0xF95A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005FA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8B80 },
  ["unicodeslot"]=0xF95A, -- 讀
 },
 [0xF95B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005FB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x62CF },
  ["unicodeslot"]=0xF95B, -- 拏
 },
 [0xF95C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005FC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6A02 },
  ["unicodeslot"]=0xF95C, -- 樂
 },
 [0xF95D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005FD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AFE },
  ["unicodeslot"]=0xF95D, -- 諾
 },
 [0xF95E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005FE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4E39 },
  ["unicodeslot"]=0xF95E, -- 丹
 },
 [0xF95F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x005FF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5BE7 },
  ["unicodeslot"]=0xF95F, -- 寧
 },
 [0xF960]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6012 },
  ["unicodeslot"]=0xF960, -- 怒
 },
 [0xF961]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7387 },
  ["unicodeslot"]=0xF961, -- 率
 },
 [0xF962]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7570 },
  ["unicodeslot"]=0xF962, -- 異
 },
 [0xF963]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5317 },
  ["unicodeslot"]=0xF963, -- 北
 },
 [0xF964]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x78FB },
  ["unicodeslot"]=0xF964, -- 磻
 },
 [0xF965]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4FBF },
  ["unicodeslot"]=0xF965, -- 便
 },
 [0xF966]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5FA9 },
  ["unicodeslot"]=0xF966, -- 復
 },
 [0xF967]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4E0D },
  ["unicodeslot"]=0xF967, -- 不
 },
 [0xF968]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C8",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6CCC },
  ["unicodeslot"]=0xF968, -- 泌
 },
 [0xF969]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03C9",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6578 },
  ["unicodeslot"]=0xF969, -- 數
 },
 [0xF96A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0060A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7D22 },
  ["unicodeslot"]=0xF96A, -- 索
 },
 [0xF96B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0060B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x53C3 },
  ["unicodeslot"]=0xF96B, -- 參
 },
 [0xF96C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0060C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x585E },
  ["unicodeslot"]=0xF96C, -- 塞
 },
 [0xF96D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0060D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7701 },
  ["unicodeslot"]=0xF96D, -- 省
 },
 [0xF96E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0060E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8449 },
  ["unicodeslot"]=0xF96E, -- 葉
 },
 [0xF96F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0060F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AAA },
  ["unicodeslot"]=0xF96F, -- 說
 },
 [0xF970]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03CA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6BBA },
  ["unicodeslot"]=0xF970, -- 殺
 },
 [0xF971]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03CB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8FB0 },
  ["unicodeslot"]=0xF971, -- 辰
 },
 [0xF972]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03CC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6C88 },
  ["unicodeslot"]=0xF972, -- 沈
 },
 [0xF973]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03CD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x62FE },
  ["unicodeslot"]=0xF973, -- 拾
 },
 [0xF974]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03CE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x82E5 },
  ["unicodeslot"]=0xF974, -- 若
 },
 [0xF975]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03CF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x63A0 },
  ["unicodeslot"]=0xF975, -- 掠
 },
 [0xF976]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7565 },
  ["unicodeslot"]=0xF976, -- 略
 },
 [0xF977]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4EAE },
  ["unicodeslot"]=0xF977, -- 亮
 },
 [0xF978]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5169 },
  ["unicodeslot"]=0xF978, -- 兩
 },
 [0xF979]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51C9 },
  ["unicodeslot"]=0xF979, -- 凉
 },
 [0xF97A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0061A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6881 },
  ["unicodeslot"]=0xF97A, -- 梁
 },
 [0xF97B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0061B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7CE7 },
  ["unicodeslot"]=0xF97B, -- 糧
 },
 [0xF97C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0061C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x826F },
  ["unicodeslot"]=0xF97C, -- 良
 },
 [0xF97D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0061D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AD2 },
  ["unicodeslot"]=0xF97D, -- 諒
 },
 [0xF97E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0061E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x91CF },
  ["unicodeslot"]=0xF97E, -- 量
 },
 [0xF97F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0061F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52F5 },
  ["unicodeslot"]=0xF97F, -- 勵
 },
 [0xF980]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5442 },
  ["unicodeslot"]=0xF980, -- 呂
 },
 [0xF981]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5973 },
  ["unicodeslot"]=0xF981, -- 女
 },
 [0xF982]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5EEC },
  ["unicodeslot"]=0xF982, -- 廬
 },
 [0xF983]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x65C5 },
  ["unicodeslot"]=0xF983, -- 旅
 },
 [0xF984]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D8",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6FFE },
  ["unicodeslot"]=0xF984, -- 濾
 },
 [0xF985]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03D9",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x792A },
  ["unicodeslot"]=0xF985, -- 礪
 },
 [0xF986]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03DA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x95AD },
  ["unicodeslot"]=0xF986, -- 閭
 },
 [0xF987]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03DB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9A6A },
  ["unicodeslot"]=0xF987, -- 驪
 },
 [0xF988]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03DC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9E97 },
  ["unicodeslot"]=0xF988, -- 麗
 },
 [0xF989]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03DD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9ECE },
  ["unicodeslot"]=0xF989, -- 黎
 },
 [0xF98A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0062A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x529B },
  ["unicodeslot"]=0xF98A, -- 力
 },
 [0xF98B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0062B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x66C6 },
  ["unicodeslot"]=0xF98B, -- 曆
 },
 [0xF98C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0062C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6B77 },
  ["unicodeslot"]=0xF98C, -- 歷
 },
 [0xF98D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0062D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8F62 },
  ["unicodeslot"]=0xF98D, -- 轢
 },
 [0xF98E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0062E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5E74 },
  ["unicodeslot"]=0xF98E, -- 年
 },
 [0xF98F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0062F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6190 },
  ["unicodeslot"]=0xF98F, -- 憐
 },
 [0xF990]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03DE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6200 },
  ["unicodeslot"]=0xF990, -- 戀
 },
 [0xF991]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03DF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x649A },
  ["unicodeslot"]=0xF991, -- 撚
 },
 [0xF992]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03E0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6F23 },
  ["unicodeslot"]=0xF992, -- 漣
 },
 [0xF993]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03E1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7149 },
  ["unicodeslot"]=0xF993, -- 煉
 },
 [0xF994]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03E2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7489 },
  ["unicodeslot"]=0xF994, -- 璉
 },
 [0xF995]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03E3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x79CA },
  ["unicodeslot"]=0xF995, -- 秊
 },
 [0xF996]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03E4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7DF4 },
  ["unicodeslot"]=0xF996, -- 練
 },
 [0xF997]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03E5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x806F },
  ["unicodeslot"]=0xF997, -- 聯
 },
 [0xF998]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03E6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8F26 },
  ["unicodeslot"]=0xF998, -- 輦
 },
 [0xF999]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x03E7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x84EE },
  ["unicodeslot"]=0xF999, -- 蓮
 },
 [0xF99A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0063A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9023 },
  ["unicodeslot"]=0xF99A, -- 連
 },
 [0xF99B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0063B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x934A },
  ["unicodeslot"]=0xF99B, -- 鍊
 },
 [0xF99C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0063C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5217 },
  ["unicodeslot"]=0xF99C, -- 列
 },
 [0xF99D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0063D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52A3 },
  ["unicodeslot"]=0xF99D, -- 劣
 },
 [0xF99E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0063E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x54BD },
  ["unicodeslot"]=0xF99E, -- 咽
 },
 [0xF99F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0063F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x70C8 },
  ["unicodeslot"]=0xF99F, -- 烈
 },
 [0xF9A0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x88C2 },
  ["unicodeslot"]=0xF9A0, -- 裂
 },
 [0xF9A1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AAA },
  ["unicodeslot"]=0xF9A1, -- 說
 },
 [0xF9A2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5EC9 },
  ["unicodeslot"]=0xF9A2, -- 廉
 },
 [0xF9A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5FF5 },
  ["unicodeslot"]=0xF9A3, -- 念
 },
 [0xF9A4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x637B },
  ["unicodeslot"]=0xF9A4, -- 捻
 },
 [0xF9A5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6BAE },
  ["unicodeslot"]=0xF9A5, -- 殮
 },
 [0xF9A6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7C3E },
  ["unicodeslot"]=0xF9A6, -- 簾
 },
 [0xF9A7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7375 },
  ["unicodeslot"]=0xF9A7, -- 獵
 },
 [0xF9A8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4EE4 },
  ["unicodeslot"]=0xF9A8, -- 令
 },
 [0xF9A9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009A0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x56F9 },
  ["unicodeslot"]=0xF9A9, -- 囹
 },
 [0xF9AA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009AA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5BE7 },
  ["unicodeslot"]=0xF9AA, -- 寧
 },
 [0xF9AB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009AB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5DBA },
  ["unicodeslot"]=0xF9AB, -- 嶺
 },
 [0xF9AC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009AC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x601C },
  ["unicodeslot"]=0xF9AC, -- 怜
 },
 [0xF9AD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009AD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x73B2 },
  ["unicodeslot"]=0xF9AD, -- 玲
 },
 [0xF9AE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009AE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7469 },
  ["unicodeslot"]=0xF9AE, -- 瑩
 },
 [0xF9AF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009AF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7F9A },
  ["unicodeslot"]=0xF9AF, -- 羚
 },
 [0xF9B0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8046 },
  ["unicodeslot"]=0xF9B0, -- 聆
 },
 [0xF9B1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9234 },
  ["unicodeslot"]=0xF9B1, -- 鈴
 },
 [0xF9B2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x96F6 },
  ["unicodeslot"]=0xF9B2, -- 零
 },
 [0xF9B3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9748 },
  ["unicodeslot"]=0xF9B3, -- 靈
 },
 [0xF9B4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9818 },
  ["unicodeslot"]=0xF9B4, -- 領
 },
 [0xF9B5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4F8B },
  ["unicodeslot"]=0xF9B5, -- 例
 },
 [0xF9B6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x79AE },
  ["unicodeslot"]=0xF9B6, -- 禮
 },
 [0xF9B7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x91B4 },
  ["unicodeslot"]=0xF9B7, -- 醴
 },
 [0xF9B8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x96B8 },
  ["unicodeslot"]=0xF9B8, -- 隸
 },
 [0xF9B9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009B0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x60E1 },
  ["unicodeslot"]=0xF9B9, -- 惡
 },
 [0xF9BA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009BA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4E86 },
  ["unicodeslot"]=0xF9BA, -- 了
 },
 [0xF9BB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009BB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x50DA },
  ["unicodeslot"]=0xF9BB, -- 僚
 },
 [0xF9BC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009BC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5BEE },
  ["unicodeslot"]=0xF9BC, -- 寮
 },
 [0xF9BD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009BD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C3F },
  ["unicodeslot"]=0xF9BD, -- 尿
 },
 [0xF9BE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009BE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6599 },
  ["unicodeslot"]=0xF9BE, -- 料
 },
 [0xF9BF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009BF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6A02 },
  ["unicodeslot"]=0xF9BF, -- 樂
 },
 [0xF9C0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x71CE },
  ["unicodeslot"]=0xF9C0, -- 燎
 },
 [0xF9C1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7642 },
  ["unicodeslot"]=0xF9C1, -- 療
 },
 [0xF9C2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x84FC },
  ["unicodeslot"]=0xF9C2, -- 蓼
 },
 [0xF9C3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x907C },
  ["unicodeslot"]=0xF9C3, -- 遼
 },
 [0xF9C4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F8D },
  ["unicodeslot"]=0xF9C4, -- 龍
 },
 [0xF9C5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6688 },
  ["unicodeslot"]=0xF9C5, -- 暈
 },
 [0xF9C6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x962E },
  ["unicodeslot"]=0xF9C6, -- 阮
 },
 [0xF9C7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5289 },
  ["unicodeslot"]=0xF9C7, -- 劉
 },
 [0xF9C8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x677B },
  ["unicodeslot"]=0xF9C8, -- 杻
 },
 [0xF9C9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009C0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x67F3 },
  ["unicodeslot"]=0xF9C9, -- 柳
 },
 [0xF9CA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009CA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D41 },
  ["unicodeslot"]=0xF9CA, -- 流
 },
 [0xF9CB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009CB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6E9C },
  ["unicodeslot"]=0xF9CB, -- 溜
 },
 [0xF9CC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009CC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7409 },
  ["unicodeslot"]=0xF9CC, -- 琉
 },
 [0xF9CD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009CD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7559 },
  ["unicodeslot"]=0xF9CD, -- 留
 },
 [0xF9CE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009CE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x786B },
  ["unicodeslot"]=0xF9CE, -- 硫
 },
 [0xF9CF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009CF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7D10 },
  ["unicodeslot"]=0xF9CF, -- 紐
 },
 [0xF9D0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x985E },
  ["unicodeslot"]=0xF9D0, -- 類
 },
 [0xF9D1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x516D },
  ["unicodeslot"]=0xF9D1, -- 六
 },
 [0xF9D2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x622E },
  ["unicodeslot"]=0xF9D2, -- 戮
 },
 [0xF9D3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9678 },
  ["unicodeslot"]=0xF9D3, -- 陸
 },
 [0xF9D4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x502B },
  ["unicodeslot"]=0xF9D4, -- 倫
 },
 [0xF9D5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5D19 },
  ["unicodeslot"]=0xF9D5, -- 崙
 },
 [0xF9D6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6DEA },
  ["unicodeslot"]=0xF9D6, -- 淪
 },
 [0xF9D7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8F2A },
  ["unicodeslot"]=0xF9D7, -- 輪
 },
 [0xF9D8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5F8B },
  ["unicodeslot"]=0xF9D8, -- 律
 },
 [0xF9D9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009D0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6144 },
  ["unicodeslot"]=0xF9D9, -- 慄
 },
 [0xF9DA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009DA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6817 },
  ["unicodeslot"]=0xF9DA, -- 栗
 },
 [0xF9DB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009DB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7387 },
  ["unicodeslot"]=0xF9DB, -- 率
 },
 [0xF9DC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009DC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9686 },
  ["unicodeslot"]=0xF9DC, -- 隆
 },
 [0xF9DD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009DD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5229 },
  ["unicodeslot"]=0xF9DD, -- 利
 },
 [0xF9DE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009DE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x540F },
  ["unicodeslot"]=0xF9DE, -- 吏
 },
 [0xF9DF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009DF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C65 },
  ["unicodeslot"]=0xF9DF, -- 履
 },
 [0xF9E0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6613 },
  ["unicodeslot"]=0xF9E0, -- 易
 },
 [0xF9E1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x674E },
  ["unicodeslot"]=0xF9E1, -- 李
 },
 [0xF9E2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x68A8 },
  ["unicodeslot"]=0xF9E2, -- 梨
 },
 [0xF9E3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6CE5 },
  ["unicodeslot"]=0xF9E3, -- 泥
 },
 [0xF9E4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7406 },
  ["unicodeslot"]=0xF9E4, -- 理
 },
 [0xF9E5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x75E2 },
  ["unicodeslot"]=0xF9E5, -- 痢
 },
 [0xF9E6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7F79 },
  ["unicodeslot"]=0xF9E6, -- 罹
 },
 [0xF9E7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x88CF },
  ["unicodeslot"]=0xF9E7, -- 裏
 },
 [0xF9E8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x88E1 },
  ["unicodeslot"]=0xF9E8, -- 裡
 },
 [0xF9E9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009E0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x91CC },
  ["unicodeslot"]=0xF9E9, -- 里
 },
 [0xF9EA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009EA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x96E2 },
  ["unicodeslot"]=0xF9EA, -- 離
 },
 [0xF9EB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009EB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x533F },
  ["unicodeslot"]=0xF9EB, -- 匿
 },
 [0xF9EC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009EC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6EBA },
  ["unicodeslot"]=0xF9EC, -- 溺
 },
 [0xF9ED]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009ED",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x541D },
  ["unicodeslot"]=0xF9ED, -- 吝
 },
 [0xF9EE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009EE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x71D0 },
  ["unicodeslot"]=0xF9EE, -- 燐
 },
 [0xF9EF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009EF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7498 },
  ["unicodeslot"]=0xF9EF, -- 璘
 },
 [0xF9F0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x85FA },
  ["unicodeslot"]=0xF9F0, -- 藺
 },
 [0xF9F1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x96A3 },
  ["unicodeslot"]=0xF9F1, -- 隣
 },
 [0xF9F2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9C57 },
  ["unicodeslot"]=0xF9F2, -- 鱗
 },
 [0xF9F3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9E9F },
  ["unicodeslot"]=0xF9F3, -- 麟
 },
 [0xF9F4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6797 },
  ["unicodeslot"]=0xF9F4, -- 林
 },
 [0xF9F5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6DCB },
  ["unicodeslot"]=0xF9F5, -- 淋
 },
 [0xF9F6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x81E8 },
  ["unicodeslot"]=0xF9F6, -- 臨
 },
 [0xF9F7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7ACB },
  ["unicodeslot"]=0xF9F7, -- 立
 },
 [0xF9F8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7B20 },
  ["unicodeslot"]=0xF9F8, -- 笠
 },
 [0xF9F9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009F0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7C92 },
  ["unicodeslot"]=0xF9F9, -- 粒
 },
 [0xF9FA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009FA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x72C0 },
  ["unicodeslot"]=0xF9FA, -- 狀
 },
 [0xF9FB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009FB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7099 },
  ["unicodeslot"]=0xF9FB, -- 炙
 },
 [0xF9FC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009FC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8B58 },
  ["unicodeslot"]=0xF9FC, -- 識
 },
 [0xF9FD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009FD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4EC0 },
  ["unicodeslot"]=0xF9FD, -- 什
 },
 [0xF9FE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009FE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8336 },
  ["unicodeslot"]=0xF9FE, -- 茶
 },
 [0xF9FF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-F0x0009FF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x523A },
  ["unicodeslot"]=0xF9FF, -- 刺
 },
 [0xFA00]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5207 },
  ["unicodeslot"]=0xFA00, -- 切
 },
 [0xFA01]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5EA6 },
  ["unicodeslot"]=0xFA01, -- 度
 },
 [0xFA02]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x62D3 },
  ["unicodeslot"]=0xFA02, -- 拓
 },
 [0xFA03]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7CD6 },
  ["unicodeslot"]=0xFA03, -- 糖
 },
 [0xFA04]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5B85 },
  ["unicodeslot"]=0xFA04, -- 宅
 },
 [0xFA05]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D1E },
  ["unicodeslot"]=0xFA05, -- 洞
 },
 [0xFA06]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x66B4 },
  ["unicodeslot"]=0xFA06, -- 暴
 },
 [0xFA07]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8F3B },
  ["unicodeslot"]=0xFA07, -- 輻
 },
 [0xFA08]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x884C },
  ["unicodeslot"]=0xFA08, -- 行
 },
 [0xFA09]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x964D },
  ["unicodeslot"]=0xFA09, -- 降
 },
 [0xFA0A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0000A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x898B },
  ["unicodeslot"]=0xFA0A, -- 見
 },
 [0xFA0B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0000B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5ED3 },
  ["unicodeslot"]=0xFA0B, -- 廓
 },
 [0xFA0C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0000C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5140 },
  ["unicodeslot"]=0xFA0C, -- 兀
 },
 [0xFA0D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0000D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x55C0 },
  ["unicodeslot"]=0xFA0D, -- 嗀
 },
 [0xFA0E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0000E",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA0E, -- 﨎
 },
 [0xFA0F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0000F",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA0F, -- 﨏
 },
 [0xFA10]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x000A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x585A },
  ["unicodeslot"]=0xFA10, -- 塚
 },
 [0xFA11]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x000B",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA11, -- 﨑
 },
 [0xFA12]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x000C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6674 },
  ["unicodeslot"]=0xFA12, -- 晴
 },
 [0xFA13]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x000D",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA13, -- 﨓
 },
 [0xFA14]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x000E",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA14, -- 﨔
 },
 [0xFA15]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x000F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51DE },
  ["unicodeslot"]=0xFA15, -- 凞
 },
 [0xFA16]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0010",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x732A },
  ["unicodeslot"]=0xFA16, -- 猪
 },
 [0xFA17]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0011",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x76CA },
  ["unicodeslot"]=0xFA17, -- 益
 },
 [0xFA18]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0012",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x793C },
  ["unicodeslot"]=0xFA18, -- 礼
 },
 [0xFA19]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0013",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x795E },
  ["unicodeslot"]=0xFA19, -- 神
 },
 [0xFA1A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0001A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7965 },
  ["unicodeslot"]=0xFA1A, -- 祥
 },
 [0xFA1B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0001B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x798F },
  ["unicodeslot"]=0xFA1B, -- 福
 },
 [0xFA1C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0001C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9756 },
  ["unicodeslot"]=0xFA1C, -- 靖
 },
 [0xFA1D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0001D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7CBE },
  ["unicodeslot"]=0xFA1D, -- 精
 },
 [0xFA1E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0001E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7FBD },
  ["unicodeslot"]=0xFA1E, -- 羽
 },
 [0xFA1F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0001F",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA1F, -- 﨟
 },
 [0xFA20]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0014",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8612 },
  ["unicodeslot"]=0xFA20, -- 蘒
 },
 [0xFA21]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0015",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA21, -- 﨡
 },
 [0xFA22]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0016",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AF8 },
  ["unicodeslot"]=0xFA22, -- 諸
 },
 [0xFA23]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0017",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA23, -- 﨣
 },
 [0xFA24]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0018",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA24, -- 﨤
 },
 [0xFA25]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0019",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9038 },
  ["unicodeslot"]=0xFA25, -- 逸
 },
 [0xFA26]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x001A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x90FD },
  ["unicodeslot"]=0xFA26, -- 都
 },
 [0xFA27]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x001B",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA27, -- 﨧
 },
 [0xFA28]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x001C",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA28, -- 﨨
 },
 [0xFA29]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x001D",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFA29, -- 﨩
 },
 [0xFA2A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0002A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x98EF },
  ["unicodeslot"]=0xFA2A, -- 飯
 },
 [0xFA2B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0002B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x98FC },
  ["unicodeslot"]=0xFA2B, -- 飼
 },
 [0xFA2C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0002C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9928 },
  ["unicodeslot"]=0xFA2C, -- 館
 },
 [0xFA2D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0002D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9DB4 },
  ["unicodeslot"]=0xFA2D, -- 鶴
 },
 [0xFA30]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x001E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4FAE },
  ["unicodeslot"]=0xFA30, -- 侮
 },
 [0xFA31]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x001F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x50E7 },
  ["unicodeslot"]=0xFA31, -- 僧
 },
 [0xFA32]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0020",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x514D },
  ["unicodeslot"]=0xFA32, -- 免
 },
 [0xFA33]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0021",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52C9 },
  ["unicodeslot"]=0xFA33, -- 勉
 },
 [0xFA34]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0022",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52E4 },
  ["unicodeslot"]=0xFA34, -- 勤
 },
 [0xFA35]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0023",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5351 },
  ["unicodeslot"]=0xFA35, -- 卑
 },
 [0xFA36]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0024",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x559D },
  ["unicodeslot"]=0xFA36, -- 喝
 },
 [0xFA37]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0025",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5606 },
  ["unicodeslot"]=0xFA37, -- 嘆
 },
 [0xFA38]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0026",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5668 },
  ["unicodeslot"]=0xFA38, -- 器
 },
 [0xFA39]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0027",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5840 },
  ["unicodeslot"]=0xFA39, -- 塀
 },
 [0xFA3A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0003A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x58A8 },
  ["unicodeslot"]=0xFA3A, -- 墨
 },
 [0xFA3B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0003B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C64 },
  ["unicodeslot"]=0xFA3B, -- 層
 },
 [0xFA3C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0003C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C6E },
  ["unicodeslot"]=0xFA3C, -- 屮
 },
 [0xFA3D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0003D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6094 },
  ["unicodeslot"]=0xFA3D, -- 悔
 },
 [0xFA3E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0003E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6168 },
  ["unicodeslot"]=0xFA3E, -- 慨
 },
 [0xFA3F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0003F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x618E },
  ["unicodeslot"]=0xFA3F, -- 憎
 },
 [0xFA40]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0028",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x61F2 },
  ["unicodeslot"]=0xFA40, -- 懲
 },
 [0xFA41]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0029",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x654F },
  ["unicodeslot"]=0xFA41, -- 敏
 },
 [0xFA42]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x002A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x65E2 },
  ["unicodeslot"]=0xFA42, -- 既
 },
 [0xFA43]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x002B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6691 },
  ["unicodeslot"]=0xFA43, -- 暑
 },
 [0xFA44]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x002C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6885 },
  ["unicodeslot"]=0xFA44, -- 梅
 },
 [0xFA45]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x002D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D77 },
  ["unicodeslot"]=0xFA45, -- 海
 },
 [0xFA46]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x002E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6E1A },
  ["unicodeslot"]=0xFA46, -- 渚
 },
 [0xFA47]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x002F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6F22 },
  ["unicodeslot"]=0xFA47, -- 漢
 },
 [0xFA48]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0030",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x716E },
  ["unicodeslot"]=0xFA48, -- 煮
 },
 [0xFA49]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0031",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x722B },
  ["unicodeslot"]=0xFA49, -- 爫
 },
 [0xFA4A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0004A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7422 },
  ["unicodeslot"]=0xFA4A, -- 琢
 },
 [0xFA4B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0004B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7891 },
  ["unicodeslot"]=0xFA4B, -- 碑
 },
 [0xFA4C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0004C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x793E },
  ["unicodeslot"]=0xFA4C, -- 社
 },
 [0xFA4D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0004D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7949 },
  ["unicodeslot"]=0xFA4D, -- 祉
 },
 [0xFA4E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0004E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7948 },
  ["unicodeslot"]=0xFA4E, -- 祈
 },
 [0xFA4F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0004F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7950 },
  ["unicodeslot"]=0xFA4F, -- 祐
 },
 [0xFA50]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0032",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7956 },
  ["unicodeslot"]=0xFA50, -- 祖
 },
 [0xFA51]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0033",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x795D },
  ["unicodeslot"]=0xFA51, -- 祝
 },
 [0xFA52]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0034",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x798D },
  ["unicodeslot"]=0xFA52, -- 禍
 },
 [0xFA53]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0035",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x798E },
  ["unicodeslot"]=0xFA53, -- 禎
 },
 [0xFA54]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0036",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7A40 },
  ["unicodeslot"]=0xFA54, -- 穀
 },
 [0xFA55]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0037",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7A81 },
  ["unicodeslot"]=0xFA55, -- 突
 },
 [0xFA56]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0038",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7BC0 },
  ["unicodeslot"]=0xFA56, -- 節
 },
 [0xFA57]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0039",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7DF4 },
  ["unicodeslot"]=0xFA57, -- 練
 },
 [0xFA58]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x003A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7E09 },
  ["unicodeslot"]=0xFA58, -- 縉
 },
 [0xFA59]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x003B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7E41 },
  ["unicodeslot"]=0xFA59, -- 繁
 },
 [0xFA5A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0005A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7F72 },
  ["unicodeslot"]=0xFA5A, -- 署
 },
 [0xFA5B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0005B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8005 },
  ["unicodeslot"]=0xFA5B, -- 者
 },
 [0xFA5C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0005C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x81ED },
  ["unicodeslot"]=0xFA5C, -- 臭
 },
 [0xFA5D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0005D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8279 },
  ["unicodeslot"]=0xFA5D, -- 艹
 },
 [0xFA5E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0005E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8279 },
  ["unicodeslot"]=0xFA5E, -- 艹
 },
 [0xFA5F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0005F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8457 },
  ["unicodeslot"]=0xFA5F, -- 著
 },
 [0xFA60]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x003C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8910 },
  ["unicodeslot"]=0xFA60, -- 褐
 },
 [0xFA61]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x003D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8996 },
  ["unicodeslot"]=0xFA61, -- 視
 },
 [0xFA62]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x003E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8B01 },
  ["unicodeslot"]=0xFA62, -- 謁
 },
 [0xFA63]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x003F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8B39 },
  ["unicodeslot"]=0xFA63, -- 謹
 },
 [0xFA64]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0040",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8CD3 },
  ["unicodeslot"]=0xFA64, -- 賓
 },
 [0xFA65]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0041",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8D08 },
  ["unicodeslot"]=0xFA65, -- 贈
 },
 [0xFA66]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0042",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8FB6 },
  ["unicodeslot"]=0xFA66, -- 辶
 },
 [0xFA67]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0043",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9038 },
  ["unicodeslot"]=0xFA67, -- 逸
 },
 [0xFA68]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0044",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x96E3 },
  ["unicodeslot"]=0xFA68, -- 難
 },
 [0xFA69]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0045",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x97FF },
  ["unicodeslot"]=0xFA69, -- 響
 },
 [0xFA6A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0006A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x983B },
  ["unicodeslot"]=0xFA6A, -- 頻
 },
 [0xFA70]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0046",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4E26 },
  ["unicodeslot"]=0xFA70, -- 並
 },
 [0xFA71]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0047",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51B5 },
  ["unicodeslot"]=0xFA71, -- 况
 },
 [0xFA72]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0048",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5168 },
  ["unicodeslot"]=0xFA72, -- 全
 },
 [0xFA73]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0049",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4F80 },
  ["unicodeslot"]=0xFA73, -- 侀
 },
 [0xFA74]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x004A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5145 },
  ["unicodeslot"]=0xFA74, -- 充
 },
 [0xFA75]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x004B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5180 },
  ["unicodeslot"]=0xFA75, -- 冀
 },
 [0xFA76]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x004C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52C7 },
  ["unicodeslot"]=0xFA76, -- 勇
 },
 [0xFA77]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x004D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52FA },
  ["unicodeslot"]=0xFA77, -- 勺
 },
 [0xFA78]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x004E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x559D },
  ["unicodeslot"]=0xFA78, -- 喝
 },
 [0xFA79]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x004F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5555 },
  ["unicodeslot"]=0xFA79, -- 啕
 },
 [0xFA7A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0007A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5599 },
  ["unicodeslot"]=0xFA7A, -- 喙
 },
 [0xFA7B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0007B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x55E2 },
  ["unicodeslot"]=0xFA7B, -- 嗢
 },
 [0xFA7C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0007C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x585A },
  ["unicodeslot"]=0xFA7C, -- 塚
 },
 [0xFA7D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0007D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x58B3 },
  ["unicodeslot"]=0xFA7D, -- 墳
 },
 [0xFA7E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0007E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5944 },
  ["unicodeslot"]=0xFA7E, -- 奄
 },
 [0xFA7F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0007F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5954 },
  ["unicodeslot"]=0xFA7F, -- 奔
 },
 [0xFA80]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0050",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5A62 },
  ["unicodeslot"]=0xFA80, -- 婢
 },
 [0xFA81]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0051",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5B28 },
  ["unicodeslot"]=0xFA81, -- 嬨
 },
 [0xFA82]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0052",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5ED2 },
  ["unicodeslot"]=0xFA82, -- 廒
 },
 [0xFA83]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0053",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5ED9 },
  ["unicodeslot"]=0xFA83, -- 廙
 },
 [0xFA84]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0054",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5F69 },
  ["unicodeslot"]=0xFA84, -- 彩
 },
 [0xFA85]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0055",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5FAD },
  ["unicodeslot"]=0xFA85, -- 徭
 },
 [0xFA86]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0056",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x60D8 },
  ["unicodeslot"]=0xFA86, -- 惘
 },
 [0xFA87]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0057",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x614E },
  ["unicodeslot"]=0xFA87, -- 慎
 },
 [0xFA88]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0058",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6108 },
  ["unicodeslot"]=0xFA88, -- 愈
 },
 [0xFA89]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0059",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x618E },
  ["unicodeslot"]=0xFA89, -- 憎
 },
 [0xFA8A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0008A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6160 },
  ["unicodeslot"]=0xFA8A, -- 慠
 },
 [0xFA8B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0008B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x61F2 },
  ["unicodeslot"]=0xFA8B, -- 懲
 },
 [0xFA8C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0008C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6234 },
  ["unicodeslot"]=0xFA8C, -- 戴
 },
 [0xFA8D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0008D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x63C4 },
  ["unicodeslot"]=0xFA8D, -- 揄
 },
 [0xFA8E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0008E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x641C },
  ["unicodeslot"]=0xFA8E, -- 搜
 },
 [0xFA8F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0008F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6452 },
  ["unicodeslot"]=0xFA8F, -- 摒
 },
 [0xFA90]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x005A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6556 },
  ["unicodeslot"]=0xFA90, -- 敖
 },
 [0xFA91]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x005B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6674 },
  ["unicodeslot"]=0xFA91, -- 晴
 },
 [0xFA92]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x005C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6717 },
  ["unicodeslot"]=0xFA92, -- 朗
 },
 [0xFA93]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x005D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x671B },
  ["unicodeslot"]=0xFA93, -- 望
 },
 [0xFA94]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x005E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6756 },
  ["unicodeslot"]=0xFA94, -- 杖
 },
 [0xFA95]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x005F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6B79 },
  ["unicodeslot"]=0xFA95, -- 歹
 },
 [0xFA96]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0060",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6BBA },
  ["unicodeslot"]=0xFA96, -- 殺
 },
 [0xFA97]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0061",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D41 },
  ["unicodeslot"]=0xFA97, -- 流
 },
 [0xFA98]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0062",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6EDB },
  ["unicodeslot"]=0xFA98, -- 滛
 },
 [0xFA99]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0063",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6ECB },
  ["unicodeslot"]=0xFA99, -- 滋
 },
 [0xFA9A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0009A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6F22 },
  ["unicodeslot"]=0xFA9A, -- 漢
 },
 [0xFA9B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0009B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x701E },
  ["unicodeslot"]=0xFA9B, -- 瀞
 },
 [0xFA9C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0009C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x716E },
  ["unicodeslot"]=0xFA9C, -- 煮
 },
 [0xFA9D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0009D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x77A7 },
  ["unicodeslot"]=0xFA9D, -- 瞧
 },
 [0xFA9E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0009E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7235 },
  ["unicodeslot"]=0xFA9E, -- 爵
 },
 [0xFA9F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FA0x0009F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x72AF },
  ["unicodeslot"]=0xFA9F, -- 犯
 },
 [0xFAA0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x732A },
  ["unicodeslot"]=0xFAA0, -- 猪
 },
 [0xFAA1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7471 },
  ["unicodeslot"]=0xFAA1, -- 瑱
 },
 [0xFAA2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7506 },
  ["unicodeslot"]=0xFAA2, -- 甆
 },
 [0xFAA3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x753B },
  ["unicodeslot"]=0xFAA3, -- 画
 },
 [0xFAA4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x761D },
  ["unicodeslot"]=0xFAA4, -- 瘝
 },
 [0xFAA5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x761F },
  ["unicodeslot"]=0xFAA5, -- 瘟
 },
 [0xFAA6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x76CA },
  ["unicodeslot"]=0xFAA6, -- 益
 },
 [0xFAA7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x76DB },
  ["unicodeslot"]=0xFAA7, -- 盛
 },
 [0xFAA8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x76F4 },
  ["unicodeslot"]=0xFAA8, -- 直
 },
 [0xFAA9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAA0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x774A },
  ["unicodeslot"]=0xFAA9, -- 睊
 },
 [0xFAAA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAAA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7740 },
  ["unicodeslot"]=0xFAAA, -- 着
 },
 [0xFAAB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAAB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x78CC },
  ["unicodeslot"]=0xFAAB, -- 磌
 },
 [0xFAAC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAAC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7AB1 },
  ["unicodeslot"]=0xFAAC, -- 窱
 },
 [0xFAAD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAAD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7BC0 },
  ["unicodeslot"]=0xFAAD, -- 節
 },
 [0xFAAE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAAE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7C7B },
  ["unicodeslot"]=0xFAAE, -- 类
 },
 [0xFAAF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAAF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7D5B },
  ["unicodeslot"]=0xFAAF, -- 絛
 },
 [0xFAB0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7DF4 },
  ["unicodeslot"]=0xFAB0, -- 練
 },
 [0xFAB1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7F3E },
  ["unicodeslot"]=0xFAB1, -- 缾
 },
 [0xFAB2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8005 },
  ["unicodeslot"]=0xFAB2, -- 者
 },
 [0xFAB3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8352 },
  ["unicodeslot"]=0xFAB3, -- 荒
 },
 [0xFAB4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x83EF },
  ["unicodeslot"]=0xFAB4, -- 華
 },
 [0xFAB5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8779 },
  ["unicodeslot"]=0xFAB5, -- 蝹
 },
 [0xFAB6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8941 },
  ["unicodeslot"]=0xFAB6, -- 襁
 },
 [0xFAB7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8986 },
  ["unicodeslot"]=0xFAB7, -- 覆
 },
 [0xFAB8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8996 },
  ["unicodeslot"]=0xFAB8, -- 視
 },
 [0xFAB9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAB0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8ABF },
  ["unicodeslot"]=0xFAB9, -- 調
 },
 [0xFABA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FABA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AF8 },
  ["unicodeslot"]=0xFABA, -- 諸
 },
 [0xFABB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FABB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8ACB },
  ["unicodeslot"]=0xFABB, -- 請
 },
 [0xFABC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FABC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8B01 },
  ["unicodeslot"]=0xFABC, -- 謁
 },
 [0xFABD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FABD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AFE },
  ["unicodeslot"]=0xFABD, -- 諾
 },
 [0xFABE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FABE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AED },
  ["unicodeslot"]=0xFABE, -- 諭
 },
 [0xFABF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FABF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8B39 },
  ["unicodeslot"]=0xFABF, -- 謹
 },
 [0xFAC0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8B8A },
  ["unicodeslot"]=0xFAC0, -- 變
 },
 [0xFAC1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8D08 },
  ["unicodeslot"]=0xFAC1, -- 贈
 },
 [0xFAC2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8F38 },
  ["unicodeslot"]=0xFAC2, -- 輸
 },
 [0xFAC3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9072 },
  ["unicodeslot"]=0xFAC3, -- 遲
 },
 [0xFAC4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9199 },
  ["unicodeslot"]=0xFAC4, -- 醙
 },
 [0xFAC5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9276 },
  ["unicodeslot"]=0xFAC5, -- 鉶
 },
 [0xFAC6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x967C },
  ["unicodeslot"]=0xFAC6, -- 陼
 },
 [0xFAC7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x96E3 },
  ["unicodeslot"]=0xFAC7, -- 難
 },
 [0xFAC8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9756 },
  ["unicodeslot"]=0xFAC8, -- 靖
 },
 [0xFAC9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAC0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x97DB },
  ["unicodeslot"]=0xFAC9, -- 韛
 },
 [0xFACA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FACA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x97FF },
  ["unicodeslot"]=0xFACA, -- 響
 },
 [0xFACB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FACB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x980B },
  ["unicodeslot"]=0xFACB, -- 頋
 },
 [0xFACC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FACC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x983B },
  ["unicodeslot"]=0xFACC, -- 頻
 },
 [0xFACD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FACD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9B12 },
  ["unicodeslot"]=0xFACD, -- 鬒
 },
 [0xFACE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FACE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F9C },
  ["unicodeslot"]=0xFACE, -- 龜
 },
 [0xFACF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FACF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2284A },
  ["unicodeslot"]=0xFACF, -- 𢡊
 },
 [0xFAD0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x22844 },
  ["unicodeslot"]=0xFAD0, -- 𢡄
 },
 [0xFAD1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x233D5 },
  ["unicodeslot"]=0xFAD1, -- 𣏕
 },
 [0xFAD2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3B9D },
  ["unicodeslot"]=0xFAD2, -- 㮝
 },
 [0xFAD3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4018 },
  ["unicodeslot"]=0xFAD3, -- 䀘
 },
 [0xFAD4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4039 },
  ["unicodeslot"]=0xFAD4, -- 䀹
 },
 [0xFAD5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25249 },
  ["unicodeslot"]=0xFAD5, -- 𥉉
 },
 [0xFAD6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25CD0 },
  ["unicodeslot"]=0xFAD6, -- 𥳐
 },
 [0xFAD7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x27ED3 },
  ["unicodeslot"]=0xFAD7, -- 𧻓
 },
 [0xFAD8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F43 },
  ["unicodeslot"]=0xFAD8, -- 齃
 },
 [0xFAD9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-FAD0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F8E },
  ["unicodeslot"]=0xFAD9, -- 龎
 },
 [0xFB00]={
  ["category"]="ll",
  ["contextname"]="ffligature",
  ["description"]="LATIN SMALL LIGATURE FF",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0066, 0x0066 },
  ["unicodeslot"]=0xFB00, -- ﬀ
 },
 [0xFB01]={
  ["category"]="ll",
  ["contextname"]="filigature",
  ["description"]="LATIN SMALL LIGATURE FI",
  ["linebreak"]="al",
  ["shcode"]={ 0x0066, 0x0069 },
  ["specials"]={ "compat", 0x0066, 0x0069 },
  ["unicodeslot"]=0xFB01, -- ﬁ
 },
 [0xFB02]={
  ["category"]="ll",
  ["contextname"]="flligature",
  ["description"]="LATIN SMALL LIGATURE FL",
  ["linebreak"]="al",
  ["shcode"]={ 0x0066, 0x006C },
  ["specials"]={ "compat", 0x0066, 0x006C },
  ["unicodeslot"]=0xFB02, -- ﬂ
 },
 [0xFB03]={
  ["category"]="ll",
  ["contextname"]="ffiligature",
  ["description"]="LATIN SMALL LIGATURE FFI",
  ["linebreak"]="al",
  ["shcode"]={ 0x0066, 0x0069 },
  ["specials"]={ "compat", 0x0066, 0x0066, 0x0069 },
  ["unicodeslot"]=0xFB03, -- ﬃ
 },
 [0xFB04]={
  ["category"]="ll",
  ["contextname"]="fflligature",
  ["description"]="LATIN SMALL LIGATURE FFL",
  ["linebreak"]="al",
  ["shcode"]={ 0x0066, 0x006C },
  ["specials"]={ "compat", 0x0066, 0x0066, 0x006C },
  ["unicodeslot"]=0xFB04, -- ﬄ
 },
 [0xFB05]={
  ["category"]="ll",
  ["description"]="LATIN SMALL LIGATURE LONG S T",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x017F, 0x0074 },
  ["unicodeslot"]=0xFB05, -- ﬅ
 },
 [0xFB06]={
  ["category"]="ll",
  ["contextname"]="stligature",
  ["description"]="LATIN SMALL LIGATURE ST",
  ["linebreak"]="al",
  ["shcode"]={ 0x0073, 0x0074 },
  ["specials"]={ "compat", 0x0073, 0x0074 },
  ["unicodeslot"]=0xFB06, -- ﬆ
 },
 [0xFB13]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LIGATURE MEN NOW",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0574, 0x0576 },
  ["unicodeslot"]=0xFB13, -- ﬓ
 },
 [0xFB14]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LIGATURE MEN ECH",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0574, 0x0565 },
  ["unicodeslot"]=0xFB14, -- ﬔ
 },
 [0xFB15]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LIGATURE MEN INI",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0574, 0x056B },
  ["unicodeslot"]=0xFB15, -- ﬕ
 },
 [0xFB16]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LIGATURE VEW NOW",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x057E, 0x0576 },
  ["unicodeslot"]=0xFB16, -- ﬖ
 },
 [0xFB17]={
  ["category"]="ll",
  ["description"]="ARMENIAN SMALL LIGATURE MEN XEH",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x0574, 0x056D },
  ["unicodeslot"]=0xFB17, -- ﬗ
 },
 [0xFB1D]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER YOD WITH HIRIQ",
  ["linebreak"]="al",
  ["shcode"]=0x05D9,
  ["specials"]={ "char", 0x05D9, 0x05B4 },
  ["unicodeslot"]=0xFB1D, -- יִ
 },
 [0xFB1E]={
  ["category"]="mn",
  ["description"]="HEBREW POINT JUDEO-SPANISH VARIKA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFB1E, -- ﬞ
 },
 [0xFB1F]={
  ["category"]="lo",
  ["description"]="HEBREW LIGATURE YIDDISH YOD YOD PATAH",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x05F2, 0x05B7 },
  ["unicodeslot"]=0xFB1F, -- ײַ
 },
 [0xFB20]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER ALTERNATIVE AYIN",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x05E2 },
  ["unicodeslot"]=0xFB20, -- ﬠ
 },
 [0xFB21]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER WIDE ALEF",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x05D0 },
  ["unicodeslot"]=0xFB21, -- ﬡ
 },
 [0xFB22]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER WIDE DALET",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x05D3 },
  ["unicodeslot"]=0xFB22, -- ﬢ
 },
 [0xFB23]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER WIDE HE",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x05D4 },
  ["unicodeslot"]=0xFB23, -- ﬣ
 },
 [0xFB24]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER WIDE KAF",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x05DB },
  ["unicodeslot"]=0xFB24, -- ﬤ
 },
 [0xFB25]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER WIDE LAMED",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x05DC },
  ["unicodeslot"]=0xFB25, -- ﬥ
 },
 [0xFB26]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER WIDE FINAL MEM",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x05DD },
  ["unicodeslot"]=0xFB26, -- ﬦ
 },
 [0xFB27]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER WIDE RESH",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x05E8 },
  ["unicodeslot"]=0xFB27, -- ﬧ
 },
 [0xFB28]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER WIDE TAV",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x05EA },
  ["unicodeslot"]=0xFB28, -- ﬨ
 },
 [0xFB29]={
  ["category"]="sm",
  ["description"]="HEBREW LETTER ALTERNATIVE PLUS SIGN",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x002B },
  ["unicodeslot"]=0xFB29, -- ﬩
 },
 [0xFB2A]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER SHIN WITH SHIN DOT",
  ["linebreak"]="al",
  ["shcode"]=0x05E9,
  ["specials"]={ "char", 0x05E9, 0x05C1 },
  ["unicodeslot"]=0xFB2A, -- שׁ
 },
 [0xFB2B]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER SHIN WITH SIN DOT",
  ["linebreak"]="al",
  ["shcode"]=0x05E9,
  ["specials"]={ "char", 0x05E9, 0x05C2 },
  ["unicodeslot"]=0xFB2B, -- שׂ
 },
 [0xFB2C]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER SHIN WITH DAGESH AND SHIN DOT",
  ["linebreak"]="al",
  ["shcode"]=0x05E9,
  ["specials"]={ "char", 0xFB49, 0x05C1 },
  ["unicodeslot"]=0xFB2C, -- שּׁ
 },
 [0xFB2D]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER SHIN WITH DAGESH AND SIN DOT",
  ["linebreak"]="al",
  ["shcode"]=0x05E9,
  ["specials"]={ "char", 0xFB49, 0x05C2 },
  ["unicodeslot"]=0xFB2D, -- שּׂ
 },
 [0xFB2E]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER ALEF WITH PATAH",
  ["linebreak"]="al",
  ["shcode"]=0x05D0,
  ["specials"]={ "char", 0x05D0, 0x05B7 },
  ["unicodeslot"]=0xFB2E, -- אַ
 },
 [0xFB2F]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER ALEF WITH QAMATS",
  ["linebreak"]="al",
  ["shcode"]=0x05D0,
  ["specials"]={ "char", 0x05D0, 0x05B8 },
  ["unicodeslot"]=0xFB2F, -- אָ
 },
 [0xFB30]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER ALEF WITH MAPIQ",
  ["linebreak"]="al",
  ["shcode"]=0x05D0,
  ["specials"]={ "char", 0x05D0, 0x05BC },
  ["unicodeslot"]=0xFB30, -- אּ
 },
 [0xFB31]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER BET WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05D1,
  ["specials"]={ "char", 0x05D1, 0x05BC },
  ["unicodeslot"]=0xFB31, -- בּ
 },
 [0xFB32]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER GIMEL WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05D2,
  ["specials"]={ "char", 0x05D2, 0x05BC },
  ["unicodeslot"]=0xFB32, -- גּ
 },
 [0xFB33]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER DALET WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05D3,
  ["specials"]={ "char", 0x05D3, 0x05BC },
  ["unicodeslot"]=0xFB33, -- דּ
 },
 [0xFB34]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER HE WITH MAPIQ",
  ["linebreak"]="al",
  ["shcode"]=0x05D4,
  ["specials"]={ "char", 0x05D4, 0x05BC },
  ["unicodeslot"]=0xFB34, -- הּ
 },
 [0xFB35]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER VAV WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05D5,
  ["specials"]={ "char", 0x05D5, 0x05BC },
  ["unicodeslot"]=0xFB35, -- וּ
 },
 [0xFB36]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER ZAYIN WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05D6,
  ["specials"]={ "char", 0x05D6, 0x05BC },
  ["unicodeslot"]=0xFB36, -- זּ
 },
 [0xFB38]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER TET WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05D8,
  ["specials"]={ "char", 0x05D8, 0x05BC },
  ["unicodeslot"]=0xFB38, -- טּ
 },
 [0xFB39]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER YOD WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05D9,
  ["specials"]={ "char", 0x05D9, 0x05BC },
  ["unicodeslot"]=0xFB39, -- יּ
 },
 [0xFB3A]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER FINAL KAF WITH DAGESH",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x05DA, 0x05BC },
  ["unicodeslot"]=0xFB3A, -- ךּ
 },
 [0xFB3B]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER KAF WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05DB,
  ["specials"]={ "char", 0x05DB, 0x05BC },
  ["unicodeslot"]=0xFB3B, -- כּ
 },
 [0xFB3C]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER LAMED WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05DC,
  ["specials"]={ "char", 0x05DC, 0x05BC },
  ["unicodeslot"]=0xFB3C, -- לּ
 },
 [0xFB3E]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER MEM WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05DE,
  ["specials"]={ "char", 0x05DE, 0x05BC },
  ["unicodeslot"]=0xFB3E, -- מּ
 },
 [0xFB40]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER NUN WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05E0,
  ["specials"]={ "char", 0x05E0, 0x05BC },
  ["unicodeslot"]=0xFB40, -- נּ
 },
 [0xFB41]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER SAMEKH WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05E1,
  ["specials"]={ "char", 0x05E1, 0x05BC },
  ["unicodeslot"]=0xFB41, -- סּ
 },
 [0xFB43]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER FINAL PE WITH DAGESH",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x05E3, 0x05BC },
  ["unicodeslot"]=0xFB43, -- ףּ
 },
 [0xFB44]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER PE WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05E4,
  ["specials"]={ "char", 0x05E4, 0x05BC },
  ["unicodeslot"]=0xFB44, -- פּ
 },
 [0xFB46]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER TSADI WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05E6,
  ["specials"]={ "char", 0x05E6, 0x05BC },
  ["unicodeslot"]=0xFB46, -- צּ
 },
 [0xFB47]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER QOF WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05E7,
  ["specials"]={ "char", 0x05E7, 0x05BC },
  ["unicodeslot"]=0xFB47, -- קּ
 },
 [0xFB48]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER RESH WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05E8,
  ["specials"]={ "char", 0x05E8, 0x05BC },
  ["unicodeslot"]=0xFB48, -- רּ
 },
 [0xFB49]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER SHIN WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05E9,
  ["specials"]={ "char", 0x05E9, 0x05BC },
  ["unicodeslot"]=0xFB49, -- שּ
 },
 [0xFB4A]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER TAV WITH DAGESH",
  ["linebreak"]="al",
  ["shcode"]=0x05EA,
  ["specials"]={ "char", 0x05EA, 0x05BC },
  ["unicodeslot"]=0xFB4A, -- תּ
 },
 [0xFB4B]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER VAV WITH HOLAM",
  ["linebreak"]="al",
  ["shcode"]=0x05D5,
  ["specials"]={ "char", 0x05D5, 0x05B9 },
  ["unicodeslot"]=0xFB4B, -- וֹ
 },
 [0xFB4C]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER BET WITH RAFE",
  ["linebreak"]="al",
  ["shcode"]=0x05D1,
  ["specials"]={ "char", 0x05D1, 0x05BF },
  ["unicodeslot"]=0xFB4C, -- בֿ
 },
 [0xFB4D]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER KAF WITH RAFE",
  ["linebreak"]="al",
  ["shcode"]=0x05DB,
  ["specials"]={ "char", 0x05DB, 0x05BF },
  ["unicodeslot"]=0xFB4D, -- כֿ
 },
 [0xFB4E]={
  ["category"]="lo",
  ["description"]="HEBREW LETTER PE WITH RAFE",
  ["linebreak"]="al",
  ["shcode"]=0x05E4,
  ["specials"]={ "char", 0x05E4, 0x05BF },
  ["unicodeslot"]=0xFB4E, -- פֿ
 },
 [0xFB4F]={
  ["category"]="lo",
  ["description"]="HEBREW LIGATURE ALEF LAMED",
  ["linebreak"]="al",
  ["specials"]={ "compat", 0x05D0, 0x05DC },
  ["unicodeslot"]=0xFB4F, -- ﭏ
 },
 [0xFB50]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WASLA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0671 },
  ["unicodeslot"]=0xFB50, -- ﭐ
 },
 [0xFB51]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WASLA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0671 },
  ["unicodeslot"]=0xFB51, -- ﭑ
 },
 [0xFB52]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x067B },
  ["unicodeslot"]=0xFB52, -- ﭒ
 },
 [0xFB53]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x067B },
  ["unicodeslot"]=0xFB53, -- ﭓ
 },
 [0xFB54]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x067B },
  ["unicodeslot"]=0xFB54, -- ﭔ
 },
 [0xFB55]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x067B },
  ["unicodeslot"]=0xFB55, -- ﭕ
 },
 [0xFB56]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x067E },
  ["unicodeslot"]=0xFB56, -- ﭖ
 },
 [0xFB57]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x067E },
  ["unicodeslot"]=0xFB57, -- ﭗ
 },
 [0xFB58]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x067E },
  ["unicodeslot"]=0xFB58, -- ﭘ
 },
 [0xFB59]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x067E },
  ["unicodeslot"]=0xFB59, -- ﭙ
 },
 [0xFB5A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEHEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0680 },
  ["unicodeslot"]=0xFB5A, -- ﭚ
 },
 [0xFB5B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEHEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0680 },
  ["unicodeslot"]=0xFB5B, -- ﭛ
 },
 [0xFB5C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEHEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0680 },
  ["unicodeslot"]=0xFB5C, -- ﭜ
 },
 [0xFB5D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEHEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0680 },
  ["unicodeslot"]=0xFB5D, -- ﭝ
 },
 [0xFB5E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEHEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x067A },
  ["unicodeslot"]=0xFB5E, -- ﭞ
 },
 [0xFB5F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEHEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x067A },
  ["unicodeslot"]=0xFB5F, -- ﭟ
 },
 [0xFB60]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEHEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x067A },
  ["unicodeslot"]=0xFB60, -- ﭠ
 },
 [0xFB61]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEHEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x067A },
  ["unicodeslot"]=0xFB61, -- ﭡ
 },
 [0xFB62]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEHEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x067F },
  ["unicodeslot"]=0xFB62, -- ﭢ
 },
 [0xFB63]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEHEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x067F },
  ["unicodeslot"]=0xFB63, -- ﭣ
 },
 [0xFB64]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEHEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x067F },
  ["unicodeslot"]=0xFB64, -- ﭤ
 },
 [0xFB65]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEHEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x067F },
  ["unicodeslot"]=0xFB65, -- ﭥ
 },
 [0xFB66]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0679 },
  ["unicodeslot"]=0xFB66, -- ﭦ
 },
 [0xFB67]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0679 },
  ["unicodeslot"]=0xFB67, -- ﭧ
 },
 [0xFB68]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0679 },
  ["unicodeslot"]=0xFB68, -- ﭨ
 },
 [0xFB69]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TTEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0679 },
  ["unicodeslot"]=0xFB69, -- ﭩ
 },
 [0xFB6A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER VEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06A4 },
  ["unicodeslot"]=0xFB6A, -- ﭪ
 },
 [0xFB6B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER VEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06A4 },
  ["unicodeslot"]=0xFB6B, -- ﭫ
 },
 [0xFB6C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER VEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06A4 },
  ["unicodeslot"]=0xFB6C, -- ﭬ
 },
 [0xFB6D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER VEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06A4 },
  ["unicodeslot"]=0xFB6D, -- ﭭ
 },
 [0xFB6E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEHEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06A6 },
  ["unicodeslot"]=0xFB6E, -- ﭮ
 },
 [0xFB6F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEHEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06A6 },
  ["unicodeslot"]=0xFB6F, -- ﭯ
 },
 [0xFB70]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEHEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06A6 },
  ["unicodeslot"]=0xFB70, -- ﭰ
 },
 [0xFB71]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER PEHEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06A6 },
  ["unicodeslot"]=0xFB71, -- ﭱ
 },
 [0xFB72]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DYEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0684 },
  ["unicodeslot"]=0xFB72, -- ﭲ
 },
 [0xFB73]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DYEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0684 },
  ["unicodeslot"]=0xFB73, -- ﭳ
 },
 [0xFB74]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DYEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0684 },
  ["unicodeslot"]=0xFB74, -- ﭴ
 },
 [0xFB75]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DYEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0684 },
  ["unicodeslot"]=0xFB75, -- ﭵ
 },
 [0xFB76]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NYEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0683 },
  ["unicodeslot"]=0xFB76, -- ﭶ
 },
 [0xFB77]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NYEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0683 },
  ["unicodeslot"]=0xFB77, -- ﭷ
 },
 [0xFB78]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NYEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0683 },
  ["unicodeslot"]=0xFB78, -- ﭸ
 },
 [0xFB79]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NYEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0683 },
  ["unicodeslot"]=0xFB79, -- ﭹ
 },
 [0xFB7A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0686 },
  ["unicodeslot"]=0xFB7A, -- ﭺ
 },
 [0xFB7B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0686 },
  ["unicodeslot"]=0xFB7B, -- ﭻ
 },
 [0xFB7C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0686 },
  ["unicodeslot"]=0xFB7C, -- ﭼ
 },
 [0xFB7D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0686 },
  ["unicodeslot"]=0xFB7D, -- ﭽ
 },
 [0xFB7E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEHEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0687 },
  ["unicodeslot"]=0xFB7E, -- ﭾ
 },
 [0xFB7F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEHEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0687 },
  ["unicodeslot"]=0xFB7F, -- ﭿ
 },
 [0xFB80]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEHEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0687 },
  ["unicodeslot"]=0xFB80, -- ﮀ
 },
 [0xFB81]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TCHEHEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0687 },
  ["unicodeslot"]=0xFB81, -- ﮁ
 },
 [0xFB82]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DDAHAL ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x068D },
  ["unicodeslot"]=0xFB82, -- ﮂ
 },
 [0xFB83]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DDAHAL FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x068D },
  ["unicodeslot"]=0xFB83, -- ﮃ
 },
 [0xFB84]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAHAL ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x068C },
  ["unicodeslot"]=0xFB84, -- ﮄ
 },
 [0xFB85]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAHAL FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x068C },
  ["unicodeslot"]=0xFB85, -- ﮅ
 },
 [0xFB86]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DUL ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x068E },
  ["unicodeslot"]=0xFB86, -- ﮆ
 },
 [0xFB87]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DUL FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x068E },
  ["unicodeslot"]=0xFB87, -- ﮇ
 },
 [0xFB88]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DDAL ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0688 },
  ["unicodeslot"]=0xFB88, -- ﮈ
 },
 [0xFB89]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DDAL FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0688 },
  ["unicodeslot"]=0xFB89, -- ﮉ
 },
 [0xFB8A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER JEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0698 },
  ["unicodeslot"]=0xFB8A, -- ﮊ
 },
 [0xFB8B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER JEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0698 },
  ["unicodeslot"]=0xFB8B, -- ﮋ
 },
 [0xFB8C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER RREH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0691 },
  ["unicodeslot"]=0xFB8C, -- ﮌ
 },
 [0xFB8D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER RREH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0691 },
  ["unicodeslot"]=0xFB8D, -- ﮍ
 },
 [0xFB8E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KEHEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06A9 },
  ["unicodeslot"]=0xFB8E, -- ﮎ
 },
 [0xFB8F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KEHEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06A9 },
  ["unicodeslot"]=0xFB8F, -- ﮏ
 },
 [0xFB90]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KEHEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06A9 },
  ["unicodeslot"]=0xFB90, -- ﮐ
 },
 [0xFB91]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KEHEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06A9 },
  ["unicodeslot"]=0xFB91, -- ﮑ
 },
 [0xFB92]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GAF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06AF },
  ["unicodeslot"]=0xFB92, -- ﮒ
 },
 [0xFB93]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GAF FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06AF },
  ["unicodeslot"]=0xFB93, -- ﮓ
 },
 [0xFB94]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GAF INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06AF },
  ["unicodeslot"]=0xFB94, -- ﮔ
 },
 [0xFB95]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GAF MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06AF },
  ["unicodeslot"]=0xFB95, -- ﮕ
 },
 [0xFB96]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GUEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06B3 },
  ["unicodeslot"]=0xFB96, -- ﮖ
 },
 [0xFB97]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GUEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06B3 },
  ["unicodeslot"]=0xFB97, -- ﮗ
 },
 [0xFB98]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GUEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06B3 },
  ["unicodeslot"]=0xFB98, -- ﮘ
 },
 [0xFB99]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GUEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06B3 },
  ["unicodeslot"]=0xFB99, -- ﮙ
 },
 [0xFB9A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NGOEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06B1 },
  ["unicodeslot"]=0xFB9A, -- ﮚ
 },
 [0xFB9B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NGOEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06B1 },
  ["unicodeslot"]=0xFB9B, -- ﮛ
 },
 [0xFB9C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NGOEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06B1 },
  ["unicodeslot"]=0xFB9C, -- ﮜ
 },
 [0xFB9D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NGOEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06B1 },
  ["unicodeslot"]=0xFB9D, -- ﮝ
 },
 [0xFB9E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON GHUNNA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06BA },
  ["unicodeslot"]=0xFB9E, -- ﮞ
 },
 [0xFB9F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON GHUNNA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06BA },
  ["unicodeslot"]=0xFB9F, -- ﮟ
 },
 [0xFBA0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER RNOON ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06BB },
  ["unicodeslot"]=0xFBA0, -- ﮠ
 },
 [0xFBA1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER RNOON FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06BB },
  ["unicodeslot"]=0xFBA1, -- ﮡ
 },
 [0xFBA2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER RNOON INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06BB },
  ["unicodeslot"]=0xFBA2, -- ﮢ
 },
 [0xFBA3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER RNOON MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06BB },
  ["unicodeslot"]=0xFBA3, -- ﮣ
 },
 [0xFBA4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH WITH YEH ABOVE ISOLATED FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0647,
  ["specials"]={ "isolated", 0x06C0 },
  ["unicodeslot"]=0xFBA4, -- ﮤ
 },
 [0xFBA5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH WITH YEH ABOVE FINAL FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0647,
  ["specials"]={ "final", 0x06C0 },
  ["unicodeslot"]=0xFBA5, -- ﮥ
 },
 [0xFBA6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH GOAL ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06C1 },
  ["unicodeslot"]=0xFBA6, -- ﮦ
 },
 [0xFBA7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH GOAL FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06C1 },
  ["unicodeslot"]=0xFBA7, -- ﮧ
 },
 [0xFBA8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH GOAL INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06C1 },
  ["unicodeslot"]=0xFBA8, -- ﮨ
 },
 [0xFBA9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH GOAL MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06C1 },
  ["unicodeslot"]=0xFBA9, -- ﮩ
 },
 [0xFBAA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH DOACHASHMEE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06BE },
  ["unicodeslot"]=0xFBAA, -- ﮪ
 },
 [0xFBAB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH DOACHASHMEE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06BE },
  ["unicodeslot"]=0xFBAB, -- ﮫ
 },
 [0xFBAC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH DOACHASHMEE INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06BE },
  ["unicodeslot"]=0xFBAC, -- ﮬ
 },
 [0xFBAD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH DOACHASHMEE MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06BE },
  ["unicodeslot"]=0xFBAD, -- ﮭ
 },
 [0xFBAE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH BARREE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06D2 },
  ["unicodeslot"]=0xFBAE, -- ﮮ
 },
 [0xFBAF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH BARREE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06D2 },
  ["unicodeslot"]=0xFBAF, -- ﮯ
 },
 [0xFBB0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH BARREE WITH HAMZA ABOVE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06D3 },
  ["unicodeslot"]=0xFBB0, -- ﮰ
 },
 [0xFBB1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH BARREE WITH HAMZA ABOVE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06D3 },
  ["unicodeslot"]=0xFBB1, -- ﮱ
 },
 [0xFBD3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NG ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06AD },
  ["unicodeslot"]=0xFBD3, -- ﯓ
 },
 [0xFBD4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NG FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06AD },
  ["unicodeslot"]=0xFBD4, -- ﯔ
 },
 [0xFBD5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NG INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06AD },
  ["unicodeslot"]=0xFBD5, -- ﯕ
 },
 [0xFBD6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NG MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06AD },
  ["unicodeslot"]=0xFBD6, -- ﯖ
 },
 [0xFBD7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER U ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06C7 },
  ["unicodeslot"]=0xFBD7, -- ﯗ
 },
 [0xFBD8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER U FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06C7 },
  ["unicodeslot"]=0xFBD8, -- ﯘ
 },
 [0xFBD9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER OE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06C6 },
  ["unicodeslot"]=0xFBD9, -- ﯙ
 },
 [0xFBDA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER OE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06C6 },
  ["unicodeslot"]=0xFBDA, -- ﯚ
 },
 [0xFBDB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YU ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06C8 },
  ["unicodeslot"]=0xFBDB, -- ﯛ
 },
 [0xFBDC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YU FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06C8 },
  ["unicodeslot"]=0xFBDC, -- ﯜ
 },
 [0xFBDD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER U WITH HAMZA ABOVE ISOLATED FORM",
  ["linebreak"]="al",
  ["shcode"]=0x06C7,
  ["specials"]={ "isolated", 0x0677 },
  ["unicodeslot"]=0xFBDD, -- ﯝ
 },
 [0xFBDE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER VE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06CB },
  ["unicodeslot"]=0xFBDE, -- ﯞ
 },
 [0xFBDF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER VE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06CB },
  ["unicodeslot"]=0xFBDF, -- ﯟ
 },
 [0xFBE0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KIRGHIZ OE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06C5 },
  ["unicodeslot"]=0xFBE0, -- ﯠ
 },
 [0xFBE1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KIRGHIZ OE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06C5 },
  ["unicodeslot"]=0xFBE1, -- ﯡ
 },
 [0xFBE2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KIRGHIZ YU ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06C9 },
  ["unicodeslot"]=0xFBE2, -- ﯢ
 },
 [0xFBE3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KIRGHIZ YU FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06C9 },
  ["unicodeslot"]=0xFBE3, -- ﯣ
 },
 [0xFBE4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER E ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06D0 },
  ["unicodeslot"]=0xFBE4, -- ﯤ
 },
 [0xFBE5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER E FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06D0 },
  ["unicodeslot"]=0xFBE5, -- ﯥ
 },
 [0xFBE6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER E INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06D0 },
  ["unicodeslot"]=0xFBE6, -- ﯦ
 },
 [0xFBE7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER E MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06D0 },
  ["unicodeslot"]=0xFBE7, -- ﯧ
 },
 [0xFBE8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0649 },
  ["unicodeslot"]=0xFBE8, -- ﯨ
 },
 [0xFBE9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0649 },
  ["unicodeslot"]=0xFBE9, -- ﯩ
 },
 [0xFBEA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x0627 },
  ["unicodeslot"]=0xFBEA, -- ﯪ
 },
 [0xFBEB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x0627 },
  ["unicodeslot"]=0xFBEB, -- ﯫ
 },
 [0xFBEC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x06D5 },
  ["unicodeslot"]=0xFBEC, -- ﯬ
 },
 [0xFBED]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x06D5 },
  ["unicodeslot"]=0xFBED, -- ﯭ
 },
 [0xFBEE]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x0648 },
  ["unicodeslot"]=0xFBEE, -- ﯮ
 },
 [0xFBEF]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x0648 },
  ["unicodeslot"]=0xFBEF, -- ﯯ
 },
 [0xFBF0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x06C7 },
  ["unicodeslot"]=0xFBF0, -- ﯰ
 },
 [0xFBF1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x06C7 },
  ["unicodeslot"]=0xFBF1, -- ﯱ
 },
 [0xFBF2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x06C6 },
  ["unicodeslot"]=0xFBF2, -- ﯲ
 },
 [0xFBF3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x06C6 },
  ["unicodeslot"]=0xFBF3, -- ﯳ
 },
 [0xFBF4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x06C8 },
  ["unicodeslot"]=0xFBF4, -- ﯴ
 },
 [0xFBF5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x06C8 },
  ["unicodeslot"]=0xFBF5, -- ﯵ
 },
 [0xFBF6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x06D0 },
  ["unicodeslot"]=0xFBF6, -- ﯶ
 },
 [0xFBF7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x06D0 },
  ["unicodeslot"]=0xFBF7, -- ﯷ
 },
 [0xFBF8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0626, 0x06D0 },
  ["unicodeslot"]=0xFBF8, -- ﯸ
 },
 [0xFBF9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x0649 },
  ["unicodeslot"]=0xFBF9, -- ﯹ
 },
 [0xFBFA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x0649 },
  ["unicodeslot"]=0xFBFA, -- ﯺ
 },
 [0xFBFB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0626, 0x0649 },
  ["unicodeslot"]=0xFBFB, -- ﯻ
 },
 [0xFBFC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FARSI YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x06CC },
  ["unicodeslot"]=0xFBFC, -- ﯼ
 },
 [0xFBFD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FARSI YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x06CC },
  ["unicodeslot"]=0xFBFD, -- ﯽ
 },
 [0xFBFE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FARSI YEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x06CC },
  ["unicodeslot"]=0xFBFE, -- ﯾ
 },
 [0xFBFF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FARSI YEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x06CC },
  ["unicodeslot"]=0xFBFF, -- ﯿ
 },
 [0xFC00]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x062C },
  ["unicodeslot"]=0xFC00, -- ﰀ
 },
 [0xFC01]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x062D },
  ["unicodeslot"]=0xFC01, -- ﰁ
 },
 [0xFC02]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x0645 },
  ["unicodeslot"]=0xFC02, -- ﰂ
 },
 [0xFC03]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x0649 },
  ["unicodeslot"]=0xFC03, -- ﰃ
 },
 [0xFC04]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0626, 0x064A },
  ["unicodeslot"]=0xFC04, -- ﰄ
 },
 [0xFC05]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0628, 0x062C },
  ["unicodeslot"]=0xFC05, -- ﰅ
 },
 [0xFC06]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0628, 0x062D },
  ["unicodeslot"]=0xFC06, -- ﰆ
 },
 [0xFC07]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0628, 0x062E },
  ["unicodeslot"]=0xFC07, -- ﰇ
 },
 [0xFC08]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0628, 0x0645 },
  ["unicodeslot"]=0xFC08, -- ﰈ
 },
 [0xFC09]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0628, 0x0649 },
  ["unicodeslot"]=0xFC09, -- ﰉ
 },
 [0xFC0A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0628, 0x064A },
  ["unicodeslot"]=0xFC0A, -- ﰊ
 },
 [0xFC0B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062A, 0x062C },
  ["unicodeslot"]=0xFC0B, -- ﰋ
 },
 [0xFC0C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062A, 0x062D },
  ["unicodeslot"]=0xFC0C, -- ﰌ
 },
 [0xFC0D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062A, 0x062E },
  ["unicodeslot"]=0xFC0D, -- ﰍ
 },
 [0xFC0E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062A, 0x0645 },
  ["unicodeslot"]=0xFC0E, -- ﰎ
 },
 [0xFC0F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062A, 0x0649 },
  ["unicodeslot"]=0xFC0F, -- ﰏ
 },
 [0xFC10]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062A, 0x064A },
  ["unicodeslot"]=0xFC10, -- ﰐ
 },
 [0xFC11]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062B, 0x062C },
  ["unicodeslot"]=0xFC11, -- ﰑ
 },
 [0xFC12]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062B, 0x0645 },
  ["unicodeslot"]=0xFC12, -- ﰒ
 },
 [0xFC13]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062B, 0x0649 },
  ["unicodeslot"]=0xFC13, -- ﰓ
 },
 [0xFC14]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062B, 0x064A },
  ["unicodeslot"]=0xFC14, -- ﰔ
 },
 [0xFC15]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062C, 0x062D },
  ["unicodeslot"]=0xFC15, -- ﰕ
 },
 [0xFC16]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062C, 0x0645 },
  ["unicodeslot"]=0xFC16, -- ﰖ
 },
 [0xFC17]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062D, 0x062C },
  ["unicodeslot"]=0xFC17, -- ﰗ
 },
 [0xFC18]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062D, 0x0645 },
  ["unicodeslot"]=0xFC18, -- ﰘ
 },
 [0xFC19]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KHAH WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062E, 0x062C },
  ["unicodeslot"]=0xFC19, -- ﰙ
 },
 [0xFC1A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KHAH WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062E, 0x062D },
  ["unicodeslot"]=0xFC1A, -- ﰚ
 },
 [0xFC1B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KHAH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062E, 0x0645 },
  ["unicodeslot"]=0xFC1B, -- ﰛ
 },
 [0xFC1C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0633, 0x062C },
  ["unicodeslot"]=0xFC1C, -- ﰜ
 },
 [0xFC1D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0633, 0x062D },
  ["unicodeslot"]=0xFC1D, -- ﰝ
 },
 [0xFC1E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0633, 0x062E },
  ["unicodeslot"]=0xFC1E, -- ﰞ
 },
 [0xFC1F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0633, 0x0645 },
  ["unicodeslot"]=0xFC1F, -- ﰟ
 },
 [0xFC20]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635, 0x062D },
  ["unicodeslot"]=0xFC20, -- ﰠ
 },
 [0xFC21]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635, 0x0645 },
  ["unicodeslot"]=0xFC21, -- ﰡ
 },
 [0xFC22]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0636, 0x062C },
  ["unicodeslot"]=0xFC22, -- ﰢ
 },
 [0xFC23]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0636, 0x062D },
  ["unicodeslot"]=0xFC23, -- ﰣ
 },
 [0xFC24]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0636, 0x062E },
  ["unicodeslot"]=0xFC24, -- ﰤ
 },
 [0xFC25]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0636, 0x0645 },
  ["unicodeslot"]=0xFC25, -- ﰥ
 },
 [0xFC26]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0637, 0x062D },
  ["unicodeslot"]=0xFC26, -- ﰦ
 },
 [0xFC27]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0637, 0x0645 },
  ["unicodeslot"]=0xFC27, -- ﰧ
 },
 [0xFC28]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE ZAH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0638, 0x0645 },
  ["unicodeslot"]=0xFC28, -- ﰨ
 },
 [0xFC29]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0639, 0x062C },
  ["unicodeslot"]=0xFC29, -- ﰩ
 },
 [0xFC2A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0639, 0x0645 },
  ["unicodeslot"]=0xFC2A, -- ﰪ
 },
 [0xFC2B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x063A, 0x062C },
  ["unicodeslot"]=0xFC2B, -- ﰫ
 },
 [0xFC2C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x063A, 0x0645 },
  ["unicodeslot"]=0xFC2C, -- ﰬ
 },
 [0xFC2D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0641, 0x062C },
  ["unicodeslot"]=0xFC2D, -- ﰭ
 },
 [0xFC2E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0641, 0x062D },
  ["unicodeslot"]=0xFC2E, -- ﰮ
 },
 [0xFC2F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0641, 0x062E },
  ["unicodeslot"]=0xFC2F, -- ﰯ
 },
 [0xFC30]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0641, 0x0645 },
  ["unicodeslot"]=0xFC30, -- ﰰ
 },
 [0xFC31]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0641, 0x0649 },
  ["unicodeslot"]=0xFC31, -- ﰱ
 },
 [0xFC32]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0641, 0x064A },
  ["unicodeslot"]=0xFC32, -- ﰲ
 },
 [0xFC33]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0642, 0x062D },
  ["unicodeslot"]=0xFC33, -- ﰳ
 },
 [0xFC34]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0642, 0x0645 },
  ["unicodeslot"]=0xFC34, -- ﰴ
 },
 [0xFC35]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0642, 0x0649 },
  ["unicodeslot"]=0xFC35, -- ﰵ
 },
 [0xFC36]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0642, 0x064A },
  ["unicodeslot"]=0xFC36, -- ﰶ
 },
 [0xFC37]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH ALEF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0643, 0x0627 },
  ["unicodeslot"]=0xFC37, -- ﰷ
 },
 [0xFC38]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0643, 0x062C },
  ["unicodeslot"]=0xFC38, -- ﰸ
 },
 [0xFC39]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0643, 0x062D },
  ["unicodeslot"]=0xFC39, -- ﰹ
 },
 [0xFC3A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0643, 0x062E },
  ["unicodeslot"]=0xFC3A, -- ﰺ
 },
 [0xFC3B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH LAM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0643, 0x0644 },
  ["unicodeslot"]=0xFC3B, -- ﰻ
 },
 [0xFC3C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0643, 0x0645 },
  ["unicodeslot"]=0xFC3C, -- ﰼ
 },
 [0xFC3D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0643, 0x0649 },
  ["unicodeslot"]=0xFC3D, -- ﰽ
 },
 [0xFC3E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0643, 0x064A },
  ["unicodeslot"]=0xFC3E, -- ﰾ
 },
 [0xFC3F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x062C },
  ["unicodeslot"]=0xFC3F, -- ﰿ
 },
 [0xFC40]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x062D },
  ["unicodeslot"]=0xFC40, -- ﱀ
 },
 [0xFC41]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x062E },
  ["unicodeslot"]=0xFC41, -- ﱁ
 },
 [0xFC42]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x0645 },
  ["unicodeslot"]=0xFC42, -- ﱂ
 },
 [0xFC43]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x0649 },
  ["unicodeslot"]=0xFC43, -- ﱃ
 },
 [0xFC44]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x064A },
  ["unicodeslot"]=0xFC44, -- ﱄ
 },
 [0xFC45]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0645, 0x062C },
  ["unicodeslot"]=0xFC45, -- ﱅ
 },
 [0xFC46]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0645, 0x062D },
  ["unicodeslot"]=0xFC46, -- ﱆ
 },
 [0xFC47]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0645, 0x062E },
  ["unicodeslot"]=0xFC47, -- ﱇ
 },
 [0xFC48]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0645, 0x0645 },
  ["unicodeslot"]=0xFC48, -- ﱈ
 },
 [0xFC49]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0645, 0x0649 },
  ["unicodeslot"]=0xFC49, -- ﱉ
 },
 [0xFC4A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0645, 0x064A },
  ["unicodeslot"]=0xFC4A, -- ﱊ
 },
 [0xFC4B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0646, 0x062C },
  ["unicodeslot"]=0xFC4B, -- ﱋ
 },
 [0xFC4C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0646, 0x062D },
  ["unicodeslot"]=0xFC4C, -- ﱌ
 },
 [0xFC4D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0646, 0x062E },
  ["unicodeslot"]=0xFC4D, -- ﱍ
 },
 [0xFC4E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0646, 0x0645 },
  ["unicodeslot"]=0xFC4E, -- ﱎ
 },
 [0xFC4F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0646, 0x0649 },
  ["unicodeslot"]=0xFC4F, -- ﱏ
 },
 [0xFC50]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0646, 0x064A },
  ["unicodeslot"]=0xFC50, -- ﱐ
 },
 [0xFC51]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HEH WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0647, 0x062C },
  ["unicodeslot"]=0xFC51, -- ﱑ
 },
 [0xFC52]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HEH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0647, 0x0645 },
  ["unicodeslot"]=0xFC52, -- ﱒ
 },
 [0xFC53]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HEH WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0647, 0x0649 },
  ["unicodeslot"]=0xFC53, -- ﱓ
 },
 [0xFC54]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HEH WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0647, 0x064A },
  ["unicodeslot"]=0xFC54, -- ﱔ
 },
 [0xFC55]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x064A, 0x062C },
  ["unicodeslot"]=0xFC55, -- ﱕ
 },
 [0xFC56]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x064A, 0x062D },
  ["unicodeslot"]=0xFC56, -- ﱖ
 },
 [0xFC57]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x064A, 0x062E },
  ["unicodeslot"]=0xFC57, -- ﱗ
 },
 [0xFC58]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x064A, 0x0645 },
  ["unicodeslot"]=0xFC58, -- ﱘ
 },
 [0xFC59]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x064A, 0x0649 },
  ["unicodeslot"]=0xFC59, -- ﱙ
 },
 [0xFC5A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x064A, 0x064A },
  ["unicodeslot"]=0xFC5A, -- ﱚ
 },
 [0xFC5B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THAL WITH SUPERSCRIPT ALEF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0630, 0x0670 },
  ["unicodeslot"]=0xFC5B, -- ﱛ
 },
 [0xFC5C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE REH WITH SUPERSCRIPT ALEF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0631, 0x0670 },
  ["unicodeslot"]=0xFC5C, -- ﱜ
 },
 [0xFC5D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0649, 0x0670 },
  ["unicodeslot"]=0xFC5D, -- ﱝ
 },
 [0xFC5E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHADDA WITH DAMMATAN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x064C, 0x0651 },
  ["unicodeslot"]=0xFC5E, -- ﱞ
 },
 [0xFC5F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHADDA WITH KASRATAN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x064D, 0x0651 },
  ["unicodeslot"]=0xFC5F, -- ﱟ
 },
 [0xFC60]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHADDA WITH FATHA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x064E, 0x0651 },
  ["unicodeslot"]=0xFC60, -- ﱠ
 },
 [0xFC61]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHADDA WITH DAMMA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x064F, 0x0651 },
  ["unicodeslot"]=0xFC61, -- ﱡ
 },
 [0xFC62]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHADDA WITH KASRA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x0650, 0x0651 },
  ["unicodeslot"]=0xFC62, -- ﱢ
 },
 [0xFC63]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHADDA WITH SUPERSCRIPT ALEF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x0651, 0x0670 },
  ["unicodeslot"]=0xFC63, -- ﱣ
 },
 [0xFC64]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x0631 },
  ["unicodeslot"]=0xFC64, -- ﱤ
 },
 [0xFC65]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ZAIN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x0632 },
  ["unicodeslot"]=0xFC65, -- ﱥ
 },
 [0xFC66]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x0645 },
  ["unicodeslot"]=0xFC66, -- ﱦ
 },
 [0xFC67]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH NOON FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x0646 },
  ["unicodeslot"]=0xFC67, -- ﱧ
 },
 [0xFC68]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x0649 },
  ["unicodeslot"]=0xFC68, -- ﱨ
 },
 [0xFC69]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0626, 0x064A },
  ["unicodeslot"]=0xFC69, -- ﱩ
 },
 [0xFC6A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0628, 0x0631 },
  ["unicodeslot"]=0xFC6A, -- ﱪ
 },
 [0xFC6B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH ZAIN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0628, 0x0632 },
  ["unicodeslot"]=0xFC6B, -- ﱫ
 },
 [0xFC6C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0628, 0x0645 },
  ["unicodeslot"]=0xFC6C, -- ﱬ
 },
 [0xFC6D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH NOON FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0628, 0x0646 },
  ["unicodeslot"]=0xFC6D, -- ﱭ
 },
 [0xFC6E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0628, 0x0649 },
  ["unicodeslot"]=0xFC6E, -- ﱮ
 },
 [0xFC6F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0628, 0x064A },
  ["unicodeslot"]=0xFC6F, -- ﱯ
 },
 [0xFC70]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x0631 },
  ["unicodeslot"]=0xFC70, -- ﱰ
 },
 [0xFC71]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH ZAIN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x0632 },
  ["unicodeslot"]=0xFC71, -- ﱱ
 },
 [0xFC72]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x0645 },
  ["unicodeslot"]=0xFC72, -- ﱲ
 },
 [0xFC73]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH NOON FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x0646 },
  ["unicodeslot"]=0xFC73, -- ﱳ
 },
 [0xFC74]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x0649 },
  ["unicodeslot"]=0xFC74, -- ﱴ
 },
 [0xFC75]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x064A },
  ["unicodeslot"]=0xFC75, -- ﱵ
 },
 [0xFC76]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062B, 0x0631 },
  ["unicodeslot"]=0xFC76, -- ﱶ
 },
 [0xFC77]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH ZAIN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062B, 0x0632 },
  ["unicodeslot"]=0xFC77, -- ﱷ
 },
 [0xFC78]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062B, 0x0645 },
  ["unicodeslot"]=0xFC78, -- ﱸ
 },
 [0xFC79]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH NOON FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062B, 0x0646 },
  ["unicodeslot"]=0xFC79, -- ﱹ
 },
 [0xFC7A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062B, 0x0649 },
  ["unicodeslot"]=0xFC7A, -- ﱺ
 },
 [0xFC7B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062B, 0x064A },
  ["unicodeslot"]=0xFC7B, -- ﱻ
 },
 [0xFC7C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0641, 0x0649 },
  ["unicodeslot"]=0xFC7C, -- ﱼ
 },
 [0xFC7D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0641, 0x064A },
  ["unicodeslot"]=0xFC7D, -- ﱽ
 },
 [0xFC7E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0642, 0x0649 },
  ["unicodeslot"]=0xFC7E, -- ﱾ
 },
 [0xFC7F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0642, 0x064A },
  ["unicodeslot"]=0xFC7F, -- ﱿ
 },
 [0xFC80]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH ALEF FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0643, 0x0627 },
  ["unicodeslot"]=0xFC80, -- ﲀ
 },
 [0xFC81]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH LAM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0643, 0x0644 },
  ["unicodeslot"]=0xFC81, -- ﲁ
 },
 [0xFC82]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0643, 0x0645 },
  ["unicodeslot"]=0xFC82, -- ﲂ
 },
 [0xFC83]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0643, 0x0649 },
  ["unicodeslot"]=0xFC83, -- ﲃ
 },
 [0xFC84]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0643, 0x064A },
  ["unicodeslot"]=0xFC84, -- ﲄ
 },
 [0xFC85]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x0645 },
  ["unicodeslot"]=0xFC85, -- ﲅ
 },
 [0xFC86]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x0649 },
  ["unicodeslot"]=0xFC86, -- ﲆ
 },
 [0xFC87]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x064A },
  ["unicodeslot"]=0xFC87, -- ﲇ
 },
 [0xFC88]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH ALEF FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0645, 0x0627 },
  ["unicodeslot"]=0xFC88, -- ﲈ
 },
 [0xFC89]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0645, 0x0645 },
  ["unicodeslot"]=0xFC89, -- ﲉ
 },
 [0xFC8A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x0631 },
  ["unicodeslot"]=0xFC8A, -- ﲊ
 },
 [0xFC8B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH ZAIN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x0632 },
  ["unicodeslot"]=0xFC8B, -- ﲋ
 },
 [0xFC8C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x0645 },
  ["unicodeslot"]=0xFC8C, -- ﲌ
 },
 [0xFC8D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH NOON FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x0646 },
  ["unicodeslot"]=0xFC8D, -- ﲍ
 },
 [0xFC8E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x0649 },
  ["unicodeslot"]=0xFC8E, -- ﲎ
 },
 [0xFC8F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x064A },
  ["unicodeslot"]=0xFC8F, -- ﲏ
 },
 [0xFC90]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0649, 0x0670 },
  ["unicodeslot"]=0xFC90, -- ﲐ
 },
 [0xFC91]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x0631 },
  ["unicodeslot"]=0xFC91, -- ﲑ
 },
 [0xFC92]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH ZAIN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x0632 },
  ["unicodeslot"]=0xFC92, -- ﲒ
 },
 [0xFC93]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x0645 },
  ["unicodeslot"]=0xFC93, -- ﲓ
 },
 [0xFC94]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH NOON FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x0646 },
  ["unicodeslot"]=0xFC94, -- ﲔ
 },
 [0xFC95]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x0649 },
  ["unicodeslot"]=0xFC95, -- ﲕ
 },
 [0xFC96]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x064A },
  ["unicodeslot"]=0xFC96, -- ﲖ
 },
 [0xFC97]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0626, 0x062C },
  ["unicodeslot"]=0xFC97, -- ﲗ
 },
 [0xFC98]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0626, 0x062D },
  ["unicodeslot"]=0xFC98, -- ﲘ
 },
 [0xFC99]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0626, 0x062E },
  ["unicodeslot"]=0xFC99, -- ﲙ
 },
 [0xFC9A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0626, 0x0645 },
  ["unicodeslot"]=0xFC9A, -- ﲚ
 },
 [0xFC9B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0626, 0x0647 },
  ["unicodeslot"]=0xFC9B, -- ﲛ
 },
 [0xFC9C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0628, 0x062C },
  ["unicodeslot"]=0xFC9C, -- ﲜ
 },
 [0xFC9D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0628, 0x062D },
  ["unicodeslot"]=0xFC9D, -- ﲝ
 },
 [0xFC9E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0628, 0x062E },
  ["unicodeslot"]=0xFC9E, -- ﲞ
 },
 [0xFC9F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0628, 0x0645 },
  ["unicodeslot"]=0xFC9F, -- ﲟ
 },
 [0xFCA0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH HEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0628, 0x0647 },
  ["unicodeslot"]=0xFCA0, -- ﲠ
 },
 [0xFCA1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x062C },
  ["unicodeslot"]=0xFCA1, -- ﲡ
 },
 [0xFCA2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x062D },
  ["unicodeslot"]=0xFCA2, -- ﲢ
 },
 [0xFCA3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x062E },
  ["unicodeslot"]=0xFCA3, -- ﲣ
 },
 [0xFCA4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x0645 },
  ["unicodeslot"]=0xFCA4, -- ﲤ
 },
 [0xFCA5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH HEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x0647 },
  ["unicodeslot"]=0xFCA5, -- ﲥ
 },
 [0xFCA6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062B, 0x0645 },
  ["unicodeslot"]=0xFCA6, -- ﲦ
 },
 [0xFCA7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062C, 0x062D },
  ["unicodeslot"]=0xFCA7, -- ﲧ
 },
 [0xFCA8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062C, 0x0645 },
  ["unicodeslot"]=0xFCA8, -- ﲨ
 },
 [0xFCA9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062D, 0x062C },
  ["unicodeslot"]=0xFCA9, -- ﲩ
 },
 [0xFCAA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062D, 0x0645 },
  ["unicodeslot"]=0xFCAA, -- ﲪ
 },
 [0xFCAB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KHAH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062E, 0x062C },
  ["unicodeslot"]=0xFCAB, -- ﲫ
 },
 [0xFCAC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KHAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062E, 0x0645 },
  ["unicodeslot"]=0xFCAC, -- ﲬ
 },
 [0xFCAD]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x062C },
  ["unicodeslot"]=0xFCAD, -- ﲭ
 },
 [0xFCAE]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x062D },
  ["unicodeslot"]=0xFCAE, -- ﲮ
 },
 [0xFCAF]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x062E },
  ["unicodeslot"]=0xFCAF, -- ﲯ
 },
 [0xFCB0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x0645 },
  ["unicodeslot"]=0xFCB0, -- ﲰ
 },
 [0xFCB1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0635, 0x062D },
  ["unicodeslot"]=0xFCB1, -- ﲱ
 },
 [0xFCB2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0635, 0x062E },
  ["unicodeslot"]=0xFCB2, -- ﲲ
 },
 [0xFCB3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0635, 0x0645 },
  ["unicodeslot"]=0xFCB3, -- ﲳ
 },
 [0xFCB4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0636, 0x062C },
  ["unicodeslot"]=0xFCB4, -- ﲴ
 },
 [0xFCB5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0636, 0x062D },
  ["unicodeslot"]=0xFCB5, -- ﲵ
 },
 [0xFCB6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0636, 0x062E },
  ["unicodeslot"]=0xFCB6, -- ﲶ
 },
 [0xFCB7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0636, 0x0645 },
  ["unicodeslot"]=0xFCB7, -- ﲷ
 },
 [0xFCB8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0637, 0x062D },
  ["unicodeslot"]=0xFCB8, -- ﲸ
 },
 [0xFCB9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE ZAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0638, 0x0645 },
  ["unicodeslot"]=0xFCB9, -- ﲹ
 },
 [0xFCBA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0639, 0x062C },
  ["unicodeslot"]=0xFCBA, -- ﲺ
 },
 [0xFCBB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0639, 0x0645 },
  ["unicodeslot"]=0xFCBB, -- ﲻ
 },
 [0xFCBC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x063A, 0x062C },
  ["unicodeslot"]=0xFCBC, -- ﲼ
 },
 [0xFCBD]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x063A, 0x0645 },
  ["unicodeslot"]=0xFCBD, -- ﲽ
 },
 [0xFCBE]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0641, 0x062C },
  ["unicodeslot"]=0xFCBE, -- ﲾ
 },
 [0xFCBF]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0641, 0x062D },
  ["unicodeslot"]=0xFCBF, -- ﲿ
 },
 [0xFCC0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0641, 0x062E },
  ["unicodeslot"]=0xFCC0, -- ﳀ
 },
 [0xFCC1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0641, 0x0645 },
  ["unicodeslot"]=0xFCC1, -- ﳁ
 },
 [0xFCC2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0642, 0x062D },
  ["unicodeslot"]=0xFCC2, -- ﳂ
 },
 [0xFCC3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0642, 0x0645 },
  ["unicodeslot"]=0xFCC3, -- ﳃ
 },
 [0xFCC4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0643, 0x062C },
  ["unicodeslot"]=0xFCC4, -- ﳄ
 },
 [0xFCC5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0643, 0x062D },
  ["unicodeslot"]=0xFCC5, -- ﳅ
 },
 [0xFCC6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0643, 0x062E },
  ["unicodeslot"]=0xFCC6, -- ﳆ
 },
 [0xFCC7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH LAM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0643, 0x0644 },
  ["unicodeslot"]=0xFCC7, -- ﳇ
 },
 [0xFCC8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0643, 0x0645 },
  ["unicodeslot"]=0xFCC8, -- ﳈ
 },
 [0xFCC9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x062C },
  ["unicodeslot"]=0xFCC9, -- ﳉ
 },
 [0xFCCA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x062D },
  ["unicodeslot"]=0xFCCA, -- ﳊ
 },
 [0xFCCB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x062E },
  ["unicodeslot"]=0xFCCB, -- ﳋ
 },
 [0xFCCC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x0645 },
  ["unicodeslot"]=0xFCCC, -- ﳌ
 },
 [0xFCCD]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH HEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x0647 },
  ["unicodeslot"]=0xFCCD, -- ﳍ
 },
 [0xFCCE]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062C },
  ["unicodeslot"]=0xFCCE, -- ﳎ
 },
 [0xFCCF]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062D },
  ["unicodeslot"]=0xFCCF, -- ﳏ
 },
 [0xFCD0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062E },
  ["unicodeslot"]=0xFCD0, -- ﳐ
 },
 [0xFCD1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x0645 },
  ["unicodeslot"]=0xFCD1, -- ﳑ
 },
 [0xFCD2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0646, 0x062C },
  ["unicodeslot"]=0xFCD2, -- ﳒ
 },
 [0xFCD3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0646, 0x062D },
  ["unicodeslot"]=0xFCD3, -- ﳓ
 },
 [0xFCD4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0646, 0x062E },
  ["unicodeslot"]=0xFCD4, -- ﳔ
 },
 [0xFCD5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0646, 0x0645 },
  ["unicodeslot"]=0xFCD5, -- ﳕ
 },
 [0xFCD6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH HEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0646, 0x0647 },
  ["unicodeslot"]=0xFCD6, -- ﳖ
 },
 [0xFCD7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HEH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0647, 0x062C },
  ["unicodeslot"]=0xFCD7, -- ﳗ
 },
 [0xFCD8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HEH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0647, 0x0645 },
  ["unicodeslot"]=0xFCD8, -- ﳘ
 },
 [0xFCD9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HEH WITH SUPERSCRIPT ALEF INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0647, 0x0670 },
  ["unicodeslot"]=0xFCD9, -- ﳙ
 },
 [0xFCDA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x064A, 0x062C },
  ["unicodeslot"]=0xFCDA, -- ﳚ
 },
 [0xFCDB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x064A, 0x062D },
  ["unicodeslot"]=0xFCDB, -- ﳛ
 },
 [0xFCDC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x064A, 0x062E },
  ["unicodeslot"]=0xFCDC, -- ﳜ
 },
 [0xFCDD]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x064A, 0x0645 },
  ["unicodeslot"]=0xFCDD, -- ﳝ
 },
 [0xFCDE]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x064A, 0x0647 },
  ["unicodeslot"]=0xFCDE, -- ﳞ
 },
 [0xFCDF]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0626, 0x0645 },
  ["unicodeslot"]=0xFCDF, -- ﳟ
 },
 [0xFCE0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0626, 0x0647 },
  ["unicodeslot"]=0xFCE0, -- ﳠ
 },
 [0xFCE1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0628, 0x0645 },
  ["unicodeslot"]=0xFCE1, -- ﳡ
 },
 [0xFCE2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH HEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0628, 0x0647 },
  ["unicodeslot"]=0xFCE2, -- ﳢ
 },
 [0xFCE3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x062A, 0x0645 },
  ["unicodeslot"]=0xFCE3, -- ﳣ
 },
 [0xFCE4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH HEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x062A, 0x0647 },
  ["unicodeslot"]=0xFCE4, -- ﳤ
 },
 [0xFCE5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x062B, 0x0645 },
  ["unicodeslot"]=0xFCE5, -- ﳥ
 },
 [0xFCE6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE THEH WITH HEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x062B, 0x0647 },
  ["unicodeslot"]=0xFCE6, -- ﳦ
 },
 [0xFCE7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0633, 0x0645 },
  ["unicodeslot"]=0xFCE7, -- ﳧ
 },
 [0xFCE8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH HEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0633, 0x0647 },
  ["unicodeslot"]=0xFCE8, -- ﳨ
 },
 [0xFCE9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0634, 0x0645 },
  ["unicodeslot"]=0xFCE9, -- ﳩ
 },
 [0xFCEA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH HEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0634, 0x0647 },
  ["unicodeslot"]=0xFCEA, -- ﳪ
 },
 [0xFCEB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH LAM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0643, 0x0644 },
  ["unicodeslot"]=0xFCEB, -- ﳫ
 },
 [0xFCEC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0643, 0x0645 },
  ["unicodeslot"]=0xFCEC, -- ﳬ
 },
 [0xFCED]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0644, 0x0645 },
  ["unicodeslot"]=0xFCED, -- ﳭ
 },
 [0xFCEE]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0646, 0x0645 },
  ["unicodeslot"]=0xFCEE, -- ﳮ
 },
 [0xFCEF]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH HEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0646, 0x0647 },
  ["unicodeslot"]=0xFCEF, -- ﳯ
 },
 [0xFCF0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x064A, 0x0645 },
  ["unicodeslot"]=0xFCF0, -- ﳰ
 },
 [0xFCF1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x064A, 0x0647 },
  ["unicodeslot"]=0xFCF1, -- ﳱ
 },
 [0xFCF2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHADDA WITH FATHA MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0640, 0x064E, 0x0651 },
  ["unicodeslot"]=0xFCF2, -- ﳲ
 },
 [0xFCF3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHADDA WITH DAMMA MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0640, 0x064F, 0x0651 },
  ["unicodeslot"]=0xFCF3, -- ﳳ
 },
 [0xFCF4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHADDA WITH KASRA MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0640, 0x0650, 0x0651 },
  ["unicodeslot"]=0xFCF4, -- ﳴ
 },
 [0xFCF5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0637, 0x0649 },
  ["unicodeslot"]=0xFCF5, -- ﳵ
 },
 [0xFCF6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0637, 0x064A },
  ["unicodeslot"]=0xFCF6, -- ﳶ
 },
 [0xFCF7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0639, 0x0649 },
  ["unicodeslot"]=0xFCF7, -- ﳷ
 },
 [0xFCF8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0639, 0x064A },
  ["unicodeslot"]=0xFCF8, -- ﳸ
 },
 [0xFCF9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x063A, 0x0649 },
  ["unicodeslot"]=0xFCF9, -- ﳹ
 },
 [0xFCFA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x063A, 0x064A },
  ["unicodeslot"]=0xFCFA, -- ﳺ
 },
 [0xFCFB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0633, 0x0649 },
  ["unicodeslot"]=0xFCFB, -- ﳻ
 },
 [0xFCFC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0633, 0x064A },
  ["unicodeslot"]=0xFCFC, -- ﳼ
 },
 [0xFCFD]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0634, 0x0649 },
  ["unicodeslot"]=0xFCFD, -- ﳽ
 },
 [0xFCFE]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0634, 0x064A },
  ["unicodeslot"]=0xFCFE, -- ﳾ
 },
 [0xFCFF]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062D, 0x0649 },
  ["unicodeslot"]=0xFCFF, -- ﳿ
 },
 [0xFD00]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062D, 0x064A },
  ["unicodeslot"]=0xFD00, -- ﴀ
 },
 [0xFD01]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062C, 0x0649 },
  ["unicodeslot"]=0xFD01, -- ﴁ
 },
 [0xFD02]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062C, 0x064A },
  ["unicodeslot"]=0xFD02, -- ﴂ
 },
 [0xFD03]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KHAH WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062E, 0x0649 },
  ["unicodeslot"]=0xFD03, -- ﴃ
 },
 [0xFD04]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KHAH WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062E, 0x064A },
  ["unicodeslot"]=0xFD04, -- ﴄ
 },
 [0xFD05]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635, 0x0649 },
  ["unicodeslot"]=0xFD05, -- ﴅ
 },
 [0xFD06]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635, 0x064A },
  ["unicodeslot"]=0xFD06, -- ﴆ
 },
 [0xFD07]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0636, 0x0649 },
  ["unicodeslot"]=0xFD07, -- ﴇ
 },
 [0xFD08]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0636, 0x064A },
  ["unicodeslot"]=0xFD08, -- ﴈ
 },
 [0xFD09]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0634, 0x062C },
  ["unicodeslot"]=0xFD09, -- ﴉ
 },
 [0xFD0A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0634, 0x062D },
  ["unicodeslot"]=0xFD0A, -- ﴊ
 },
 [0xFD0B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0634, 0x062E },
  ["unicodeslot"]=0xFD0B, -- ﴋ
 },
 [0xFD0C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0634, 0x0645 },
  ["unicodeslot"]=0xFD0C, -- ﴌ
 },
 [0xFD0D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH REH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0634, 0x0631 },
  ["unicodeslot"]=0xFD0D, -- ﴍ
 },
 [0xFD0E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH REH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0633, 0x0631 },
  ["unicodeslot"]=0xFD0E, -- ﴎ
 },
 [0xFD0F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH REH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635, 0x0631 },
  ["unicodeslot"]=0xFD0F, -- ﴏ
 },
 [0xFD10]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH REH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0636, 0x0631 },
  ["unicodeslot"]=0xFD10, -- ﴐ
 },
 [0xFD11]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0637, 0x0649 },
  ["unicodeslot"]=0xFD11, -- ﴑ
 },
 [0xFD12]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0637, 0x064A },
  ["unicodeslot"]=0xFD12, -- ﴒ
 },
 [0xFD13]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0639, 0x0649 },
  ["unicodeslot"]=0xFD13, -- ﴓ
 },
 [0xFD14]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0639, 0x064A },
  ["unicodeslot"]=0xFD14, -- ﴔ
 },
 [0xFD15]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x063A, 0x0649 },
  ["unicodeslot"]=0xFD15, -- ﴕ
 },
 [0xFD16]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x063A, 0x064A },
  ["unicodeslot"]=0xFD16, -- ﴖ
 },
 [0xFD17]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0633, 0x0649 },
  ["unicodeslot"]=0xFD17, -- ﴗ
 },
 [0xFD18]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0633, 0x064A },
  ["unicodeslot"]=0xFD18, -- ﴘ
 },
 [0xFD19]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x0649 },
  ["unicodeslot"]=0xFD19, -- ﴙ
 },
 [0xFD1A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x064A },
  ["unicodeslot"]=0xFD1A, -- ﴚ
 },
 [0xFD1B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062D, 0x0649 },
  ["unicodeslot"]=0xFD1B, -- ﴛ
 },
 [0xFD1C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062D, 0x064A },
  ["unicodeslot"]=0xFD1C, -- ﴜ
 },
 [0xFD1D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062C, 0x0649 },
  ["unicodeslot"]=0xFD1D, -- ﴝ
 },
 [0xFD1E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062C, 0x064A },
  ["unicodeslot"]=0xFD1E, -- ﴞ
 },
 [0xFD1F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KHAH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062E, 0x0649 },
  ["unicodeslot"]=0xFD1F, -- ﴟ
 },
 [0xFD20]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KHAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062E, 0x064A },
  ["unicodeslot"]=0xFD20, -- ﴠ
 },
 [0xFD21]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0635, 0x0649 },
  ["unicodeslot"]=0xFD21, -- ﴡ
 },
 [0xFD22]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0635, 0x064A },
  ["unicodeslot"]=0xFD22, -- ﴢ
 },
 [0xFD23]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0636, 0x0649 },
  ["unicodeslot"]=0xFD23, -- ﴣ
 },
 [0xFD24]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0636, 0x064A },
  ["unicodeslot"]=0xFD24, -- ﴤ
 },
 [0xFD25]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH JEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x062C },
  ["unicodeslot"]=0xFD25, -- ﴥ
 },
 [0xFD26]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH HAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x062D },
  ["unicodeslot"]=0xFD26, -- ﴦ
 },
 [0xFD27]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH KHAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x062E },
  ["unicodeslot"]=0xFD27, -- ﴧ
 },
 [0xFD28]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x0645 },
  ["unicodeslot"]=0xFD28, -- ﴨ
 },
 [0xFD29]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x0631 },
  ["unicodeslot"]=0xFD29, -- ﴩ
 },
 [0xFD2A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0633, 0x0631 },
  ["unicodeslot"]=0xFD2A, -- ﴪ
 },
 [0xFD2B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0635, 0x0631 },
  ["unicodeslot"]=0xFD2B, -- ﴫ
 },
 [0xFD2C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0636, 0x0631 },
  ["unicodeslot"]=0xFD2C, -- ﴬ
 },
 [0xFD2D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0634, 0x062C },
  ["unicodeslot"]=0xFD2D, -- ﴭ
 },
 [0xFD2E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0634, 0x062D },
  ["unicodeslot"]=0xFD2E, -- ﴮ
 },
 [0xFD2F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0634, 0x062E },
  ["unicodeslot"]=0xFD2F, -- ﴯ
 },
 [0xFD30]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0634, 0x0645 },
  ["unicodeslot"]=0xFD30, -- ﴰ
 },
 [0xFD31]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH HEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x0647 },
  ["unicodeslot"]=0xFD31, -- ﴱ
 },
 [0xFD32]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH HEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0634, 0x0647 },
  ["unicodeslot"]=0xFD32, -- ﴲ
 },
 [0xFD33]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0637, 0x0645 },
  ["unicodeslot"]=0xFD33, -- ﴳ
 },
 [0xFD34]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH JEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0633, 0x062C },
  ["unicodeslot"]=0xFD34, -- ﴴ
 },
 [0xFD35]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH HAH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0633, 0x062D },
  ["unicodeslot"]=0xFD35, -- ﴵ
 },
 [0xFD36]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH KHAH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0633, 0x062E },
  ["unicodeslot"]=0xFD36, -- ﴶ
 },
 [0xFD37]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH JEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0634, 0x062C },
  ["unicodeslot"]=0xFD37, -- ﴷ
 },
 [0xFD38]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH HAH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0634, 0x062D },
  ["unicodeslot"]=0xFD38, -- ﴸ
 },
 [0xFD39]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH KHAH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0634, 0x062E },
  ["unicodeslot"]=0xFD39, -- ﴹ
 },
 [0xFD3A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0637, 0x0645 },
  ["unicodeslot"]=0xFD3A, -- ﴺ
 },
 [0xFD3B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE ZAH WITH MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0638, 0x0645 },
  ["unicodeslot"]=0xFD3B, -- ﴻ
 },
 [0xFD3C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE ALEF WITH FATHATAN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0627, 0x064B },
  ["unicodeslot"]=0xFD3C, -- ﴼ
 },
 [0xFD3D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE ALEF WITH FATHATAN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0627, 0x064B },
  ["unicodeslot"]=0xFD3D, -- ﴽ
 },
 [0xFD3E]={
  ["category"]="ps",
  ["description"]="ORNATE LEFT PARENTHESIS",
  ["linebreak"]="op",
  ["unicodeslot"]=0xFD3E, -- ﴾
 },
 [0xFD3F]={
  ["category"]="pe",
  ["description"]="ORNATE RIGHT PARENTHESIS",
  ["linebreak"]="cl",
  ["unicodeslot"]=0xFD3F, -- ﴿
 },
 [0xFD50]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH JEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x062C, 0x0645 },
  ["unicodeslot"]=0xFD50, -- ﵐ
 },
 [0xFD51]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH HAH WITH JEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x062D, 0x062C },
  ["unicodeslot"]=0xFD51, -- ﵑ
 },
 [0xFD52]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH HAH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x062D, 0x062C },
  ["unicodeslot"]=0xFD52, -- ﵒ
 },
 [0xFD53]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH HAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x062D, 0x0645 },
  ["unicodeslot"]=0xFD53, -- ﵓ
 },
 [0xFD54]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH KHAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x062E, 0x0645 },
  ["unicodeslot"]=0xFD54, -- ﵔ
 },
 [0xFD55]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH MEEM WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x0645, 0x062C },
  ["unicodeslot"]=0xFD55, -- ﵕ
 },
 [0xFD56]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH MEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD56, -- ﵖ
 },
 [0xFD57]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH MEEM WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A, 0x0645, 0x062E },
  ["unicodeslot"]=0xFD57, -- ﵗ
 },
 [0xFD58]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH MEEM WITH HAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062C, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD58, -- ﵘ
 },
 [0xFD59]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH MEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062C, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD59, -- ﵙ
 },
 [0xFD5A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062D, 0x0645, 0x064A },
  ["unicodeslot"]=0xFD5A, -- ﵚ
 },
 [0xFD5B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH MEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062D, 0x0645, 0x0649 },
  ["unicodeslot"]=0xFD5B, -- ﵛ
 },
 [0xFD5C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH HAH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x062D, 0x062C },
  ["unicodeslot"]=0xFD5C, -- ﵜ
 },
 [0xFD5D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH JEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x062C, 0x062D },
  ["unicodeslot"]=0xFD5D, -- ﵝ
 },
 [0xFD5E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH JEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0633, 0x062C, 0x0649 },
  ["unicodeslot"]=0xFD5E, -- ﵞ
 },
 [0xFD5F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH MEEM WITH HAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0633, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD5F, -- ﵟ
 },
 [0xFD60]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH MEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD60, -- ﵠ
 },
 [0xFD61]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH MEEM WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x0645, 0x062C },
  ["unicodeslot"]=0xFD61, -- ﵡ
 },
 [0xFD62]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH MEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0633, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD62, -- ﵢ
 },
 [0xFD63]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH MEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD63, -- ﵣ
 },
 [0xFD64]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH HAH WITH HAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0635, 0x062D, 0x062D },
  ["unicodeslot"]=0xFD64, -- ﵤ
 },
 [0xFD65]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH HAH WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0635, 0x062D, 0x062D },
  ["unicodeslot"]=0xFD65, -- ﵥ
 },
 [0xFD66]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH MEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0635, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD66, -- ﵦ
 },
 [0xFD67]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH HAH WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x062D, 0x0645 },
  ["unicodeslot"]=0xFD67, -- ﵧ
 },
 [0xFD68]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH HAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0634, 0x062D, 0x0645 },
  ["unicodeslot"]=0xFD68, -- ﵨ
 },
 [0xFD69]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH JEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x062C, 0x064A },
  ["unicodeslot"]=0xFD69, -- ﵩ
 },
 [0xFD6A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x0645, 0x062E },
  ["unicodeslot"]=0xFD6A, -- ﵪ
 },
 [0xFD6B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0634, 0x0645, 0x062E },
  ["unicodeslot"]=0xFD6B, -- ﵫ
 },
 [0xFD6C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD6C, -- ﵬ
 },
 [0xFD6D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0634, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD6D, -- ﵭ
 },
 [0xFD6E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH HAH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0636, 0x062D, 0x0649 },
  ["unicodeslot"]=0xFD6E, -- ﵮ
 },
 [0xFD6F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH KHAH WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0636, 0x062E, 0x0645 },
  ["unicodeslot"]=0xFD6F, -- ﵯ
 },
 [0xFD70]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH KHAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0636, 0x062E, 0x0645 },
  ["unicodeslot"]=0xFD70, -- ﵰ
 },
 [0xFD71]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH MEEM WITH HAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0637, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD71, -- ﵱ
 },
 [0xFD72]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH MEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0637, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD72, -- ﵲ
 },
 [0xFD73]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH MEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0637, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD73, -- ﵳ
 },
 [0xFD74]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TAH WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0637, 0x0645, 0x064A },
  ["unicodeslot"]=0xFD74, -- ﵴ
 },
 [0xFD75]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH JEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0639, 0x062C, 0x0645 },
  ["unicodeslot"]=0xFD75, -- ﵵ
 },
 [0xFD76]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH MEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0639, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD76, -- ﵶ
 },
 [0xFD77]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH MEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0639, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD77, -- ﵷ
 },
 [0xFD78]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH MEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0639, 0x0645, 0x0649 },
  ["unicodeslot"]=0xFD78, -- ﵸ
 },
 [0xFD79]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH MEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x063A, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD79, -- ﵹ
 },
 [0xFD7A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x063A, 0x0645, 0x064A },
  ["unicodeslot"]=0xFD7A, -- ﵺ
 },
 [0xFD7B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE GHAIN WITH MEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x063A, 0x0645, 0x0649 },
  ["unicodeslot"]=0xFD7B, -- ﵻ
 },
 [0xFD7C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH KHAH WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0641, 0x062E, 0x0645 },
  ["unicodeslot"]=0xFD7C, -- ﵼ
 },
 [0xFD7D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH KHAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0641, 0x062E, 0x0645 },
  ["unicodeslot"]=0xFD7D, -- ﵽ
 },
 [0xFD7E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH MEEM WITH HAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0642, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD7E, -- ﵾ
 },
 [0xFD7F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH MEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0642, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD7F, -- ﵿ
 },
 [0xFD80]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH HAH WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x062D, 0x0645 },
  ["unicodeslot"]=0xFD80, -- ﶀ
 },
 [0xFD81]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x062D, 0x064A },
  ["unicodeslot"]=0xFD81, -- ﶁ
 },
 [0xFD82]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH HAH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x062D, 0x0649 },
  ["unicodeslot"]=0xFD82, -- ﶂ
 },
 [0xFD83]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH JEEM WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x062C, 0x062C },
  ["unicodeslot"]=0xFD83, -- ﶃ
 },
 [0xFD84]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH JEEM WITH JEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x062C, 0x062C },
  ["unicodeslot"]=0xFD84, -- ﶄ
 },
 [0xFD85]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH KHAH WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x062E, 0x0645 },
  ["unicodeslot"]=0xFD85, -- ﶅ
 },
 [0xFD86]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH KHAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x062E, 0x0645 },
  ["unicodeslot"]=0xFD86, -- ﶆ
 },
 [0xFD87]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH MEEM WITH HAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD87, -- ﶇ
 },
 [0xFD88]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH MEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x0645, 0x062D },
  ["unicodeslot"]=0xFD88, -- ﶈ
 },
 [0xFD89]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH HAH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062D, 0x062C },
  ["unicodeslot"]=0xFD89, -- ﶉ
 },
 [0xFD8A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH HAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062D, 0x0645 },
  ["unicodeslot"]=0xFD8A, -- ﶊ
 },
 [0xFD8B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0645, 0x062D, 0x064A },
  ["unicodeslot"]=0xFD8B, -- ﶋ
 },
 [0xFD8C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH JEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062C, 0x062D },
  ["unicodeslot"]=0xFD8C, -- ﶌ
 },
 [0xFD8D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH JEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062C, 0x0645 },
  ["unicodeslot"]=0xFD8D, -- ﶍ
 },
 [0xFD8E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH KHAH WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062E, 0x062C },
  ["unicodeslot"]=0xFD8E, -- ﶎ
 },
 [0xFD8F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH KHAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062E, 0x0645 },
  ["unicodeslot"]=0xFD8F, -- ﶏ
 },
 [0xFD92]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH JEEM WITH KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645, 0x062C, 0x062E },
  ["unicodeslot"]=0xFD92, -- ﶒ
 },
 [0xFD93]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HEH WITH MEEM WITH JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0647, 0x0645, 0x062C },
  ["unicodeslot"]=0xFD93, -- ﶓ
 },
 [0xFD94]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HEH WITH MEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0647, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD94, -- ﶔ
 },
 [0xFD95]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH HAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0646, 0x062D, 0x0645 },
  ["unicodeslot"]=0xFD95, -- ﶕ
 },
 [0xFD96]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH HAH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x062D, 0x0649 },
  ["unicodeslot"]=0xFD96, -- ﶖ
 },
 [0xFD97]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH JEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x062C, 0x0645 },
  ["unicodeslot"]=0xFD97, -- ﶗ
 },
 [0xFD98]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH JEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0646, 0x062C, 0x0645 },
  ["unicodeslot"]=0xFD98, -- ﶘ
 },
 [0xFD99]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH JEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x062C, 0x0649 },
  ["unicodeslot"]=0xFD99, -- ﶙ
 },
 [0xFD9A]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x0645, 0x064A },
  ["unicodeslot"]=0xFD9A, -- ﶚ
 },
 [0xFD9B]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH MEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x0645, 0x0649 },
  ["unicodeslot"]=0xFD9B, -- ﶛ
 },
 [0xFD9C]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH MEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD9C, -- ﶜ
 },
 [0xFD9D]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH MEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x064A, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFD9D, -- ﶝ
 },
 [0xFD9E]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH KHAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0628, 0x062E, 0x064A },
  ["unicodeslot"]=0xFD9E, -- ﶞ
 },
 [0xFD9F]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH JEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x062C, 0x064A },
  ["unicodeslot"]=0xFD9F, -- ﶟ
 },
 [0xFDA0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH JEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x062C, 0x0649 },
  ["unicodeslot"]=0xFDA0, -- ﶠ
 },
 [0xFDA1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH KHAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x062E, 0x064A },
  ["unicodeslot"]=0xFDA1, -- ﶡ
 },
 [0xFDA2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH KHAH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x062E, 0x0649 },
  ["unicodeslot"]=0xFDA2, -- ﶢ
 },
 [0xFDA3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x0645, 0x064A },
  ["unicodeslot"]=0xFDA3, -- ﶣ
 },
 [0xFDA4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE TEH WITH MEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A, 0x0645, 0x0649 },
  ["unicodeslot"]=0xFDA4, -- ﶤ
 },
 [0xFDA5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062C, 0x0645, 0x064A },
  ["unicodeslot"]=0xFDA5, -- ﶥ
 },
 [0xFDA6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH HAH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062C, 0x062D, 0x0649 },
  ["unicodeslot"]=0xFDA6, -- ﶦ
 },
 [0xFDA7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH MEEM WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062C, 0x0645, 0x0649 },
  ["unicodeslot"]=0xFDA7, -- ﶧ
 },
 [0xFDA8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH KHAH WITH ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0633, 0x062E, 0x0649 },
  ["unicodeslot"]=0xFDA8, -- ﶨ
 },
 [0xFDA9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0635, 0x062D, 0x064A },
  ["unicodeslot"]=0xFDA9, -- ﶩ
 },
 [0xFDAA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SHEEN WITH HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634, 0x062D, 0x064A },
  ["unicodeslot"]=0xFDAA, -- ﶪ
 },
 [0xFDAB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE DAD WITH HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0636, 0x062D, 0x064A },
  ["unicodeslot"]=0xFDAB, -- ﶫ
 },
 [0xFDAC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH JEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x062C, 0x064A },
  ["unicodeslot"]=0xFDAC, -- ﶬ
 },
 [0xFDAD]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x0645, 0x064A },
  ["unicodeslot"]=0xFDAD, -- ﶭ
 },
 [0xFDAE]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x062D, 0x064A },
  ["unicodeslot"]=0xFDAE, -- ﶮ
 },
 [0xFDAF]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH JEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x062C, 0x064A },
  ["unicodeslot"]=0xFDAF, -- ﶯ
 },
 [0xFDB0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE YEH WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A, 0x0645, 0x064A },
  ["unicodeslot"]=0xFDB0, -- ﶰ
 },
 [0xFDB1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0645, 0x0645, 0x064A },
  ["unicodeslot"]=0xFDB1, -- ﶱ
 },
 [0xFDB2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0642, 0x0645, 0x064A },
  ["unicodeslot"]=0xFDB2, -- ﶲ
 },
 [0xFDB3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x062D, 0x064A },
  ["unicodeslot"]=0xFDB3, -- ﶳ
 },
 [0xFDB4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QAF WITH MEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0642, 0x0645, 0x062D },
  ["unicodeslot"]=0xFDB4, -- ﶴ
 },
 [0xFDB5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH HAH WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x062D, 0x0645 },
  ["unicodeslot"]=0xFDB5, -- ﶵ
 },
 [0xFDB6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0639, 0x0645, 0x064A },
  ["unicodeslot"]=0xFDB6, -- ﶶ
 },
 [0xFDB7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0643, 0x0645, 0x064A },
  ["unicodeslot"]=0xFDB7, -- ﶷ
 },
 [0xFDB8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH JEEM WITH HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0646, 0x062C, 0x062D },
  ["unicodeslot"]=0xFDB8, -- ﶸ
 },
 [0xFDB9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH KHAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0645, 0x062E, 0x064A },
  ["unicodeslot"]=0xFDB9, -- ﶹ
 },
 [0xFDBA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH JEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644, 0x062C, 0x0645 },
  ["unicodeslot"]=0xFDBA, -- ﶺ
 },
 [0xFDBB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH MEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0643, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFDBB, -- ﶻ
 },
 [0xFDBC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH JEEM WITH MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x062C, 0x0645 },
  ["unicodeslot"]=0xFDBC, -- ﶼ
 },
 [0xFDBD]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH JEEM WITH HAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x062C, 0x062D },
  ["unicodeslot"]=0xFDBD, -- ﶽ
 },
 [0xFDBE]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JEEM WITH HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062C, 0x062D, 0x064A },
  ["unicodeslot"]=0xFDBE, -- ﶾ
 },
 [0xFDBF]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE HAH WITH JEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062D, 0x062C, 0x064A },
  ["unicodeslot"]=0xFDBF, -- ﶿ
 },
 [0xFDC0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MEEM WITH JEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0645, 0x062C, 0x064A },
  ["unicodeslot"]=0xFDC0, -- ﷀ
 },
 [0xFDC1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE FEH WITH MEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0641, 0x0645, 0x064A },
  ["unicodeslot"]=0xFDC1, -- ﷁ
 },
 [0xFDC2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE BEH WITH HAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0628, 0x062D, 0x064A },
  ["unicodeslot"]=0xFDC2, -- ﷂ
 },
 [0xFDC3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE KAF WITH MEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0643, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFDC3, -- ﷃ
 },
 [0xFDC4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AIN WITH JEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0639, 0x062C, 0x0645 },
  ["unicodeslot"]=0xFDC4, -- ﷄ
 },
 [0xFDC5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SAD WITH MEEM WITH MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0635, 0x0645, 0x0645 },
  ["unicodeslot"]=0xFDC5, -- ﷅ
 },
 [0xFDC6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SEEN WITH KHAH WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0633, 0x062E, 0x064A },
  ["unicodeslot"]=0xFDC6, -- ﷆ
 },
 [0xFDC7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE NOON WITH JEEM WITH YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646, 0x062C, 0x064A },
  ["unicodeslot"]=0xFDC7, -- ﷇ
 },
 [0xFDF0]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SALLA USED AS KORANIC STOP SIGN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635, 0x0644, 0x06D2 },
  ["unicodeslot"]=0xFDF0, -- ﷰ
 },
 [0xFDF1]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE QALA USED AS KORANIC STOP SIGN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0642, 0x0644, 0x06D2 },
  ["unicodeslot"]=0xFDF1, -- ﷱ
 },
 [0xFDF2]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE ALLAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0627, 0x0644, 0x0644, 0x0647 },
  ["unicodeslot"]=0xFDF2, -- ﷲ
 },
 [0xFDF3]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE AKBAR ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0627, 0x0643, 0x0628, 0x0631 },
  ["unicodeslot"]=0xFDF3, -- ﷳ
 },
 [0xFDF4]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE MOHAMMAD ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0645, 0x062D, 0x0645, 0x062F },
  ["unicodeslot"]=0xFDF4, -- ﷴ
 },
 [0xFDF5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SALAM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635, 0x0644, 0x0639, 0x0645 },
  ["unicodeslot"]=0xFDF5, -- ﷵ
 },
 [0xFDF6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE RASOUL ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0631, 0x0633, 0x0648, 0x0644 },
  ["unicodeslot"]=0xFDF6, -- ﷶ
 },
 [0xFDF7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE ALAYHE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0639, 0x0644, 0x064A, 0x0647 },
  ["unicodeslot"]=0xFDF7, -- ﷷ
 },
 [0xFDF8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE WASALLAM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0648, 0x0633, 0x0644, 0x0645 },
  ["unicodeslot"]=0xFDF8, -- ﷸ
 },
 [0xFDF9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SALLA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635, 0x0644, 0x0649 },
  ["unicodeslot"]=0xFDF9, -- ﷹ
 },
 [0xFDFA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE SALLALLAHOU ALAYHE WASALLAM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635, 0x0644, 0x0649, 0x0020, 0x0627, 0x0644, 0x0644, 0x0647, 0x0020, 0x0639, 0x0644, 0x064A, 0x0647, 0x0020, 0x0648, 0x0633, 0x0644, 0x0645 },
  ["unicodeslot"]=0xFDFA, -- ﷺ
 },
 [0xFDFB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE JALLAJALALOUHOU",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062C, 0x0644, 0x0020, 0x062C, 0x0644, 0x0627, 0x0644, 0x0647 },
  ["unicodeslot"]=0xFDFB, -- ﷻ
 },
 [0xFDFC]={
  ["category"]="sc",
  ["description"]="RIAL SIGN",
  ["linebreak"]="po",
  ["specials"]={ "isolated", 0x0631, 0x06CC, 0x0627, 0x0644 },
  ["unicodeslot"]=0xFDFC, -- ﷼
 },
 [0xFDFD]={
  ["category"]="so",
  ["description"]="ARABIC LIGATURE BISMILLAH AR-RAHMAN AR-RAHEEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0xFDFD, -- ﷽
 },
 [0xFE00]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0001",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE00, -- ︀
 },
 [0xFE01]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0002",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE01, -- ︁
 },
 [0xFE02]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0003",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE02, -- ︂
 },
 [0xFE03]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0004",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE03, -- ︃
 },
 [0xFE04]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0005",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE04, -- ︄
 },
 [0xFE05]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0006",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE05, -- ︅
 },
 [0xFE06]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0007",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE06, -- ︆
 },
 [0xFE07]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0008",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE07, -- ︇
 },
 [0xFE08]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0009",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE08, -- ︈
 },
 [0xFE09]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x000A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE09, -- ︉
 },
 [0xFE0A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x000B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE0A, -- ︊
 },
 [0xFE0B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x000C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE0B, -- ︋
 },
 [0xFE0C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x000D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE0C, -- ︌
 },
 [0xFE0D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x000E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE0D, -- ︍
 },
 [0xFE0E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x000F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE0E, -- ︎
 },
 [0xFE0F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0010",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE0F, -- ️
 },
 [0xFE10]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL COMMA",
  ["linebreak"]="is",
  ["specials"]={ "vertical", 0x002C },
  ["unicodeslot"]=0xFE10, -- ︐
 },
 [0xFE11]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC COMMA",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x3001 },
  ["unicodeslot"]=0xFE11, -- ︑
 },
 [0xFE12]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC FULL STOP",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x3002 },
  ["unicodeslot"]=0xFE12, -- ︒
 },
 [0xFE13]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL COLON",
  ["linebreak"]="is",
  ["specials"]={ "vertical", 0x003A },
  ["unicodeslot"]=0xFE13, -- ︓
 },
 [0xFE14]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL SEMICOLON",
  ["linebreak"]="is",
  ["specials"]={ "vertical", 0x003B },
  ["unicodeslot"]=0xFE14, -- ︔
 },
 [0xFE15]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL EXCLAMATION MARK",
  ["linebreak"]="ex",
  ["specials"]={ "vertical", 0x0021 },
  ["unicodeslot"]=0xFE15, -- ︕
 },
 [0xFE16]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL QUESTION MARK",
  ["linebreak"]="ex",
  ["specials"]={ "vertical", 0x003F },
  ["unicodeslot"]=0xFE16, -- ︖
 },
 [0xFE17]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT WHITE LENTICULAR BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x3016 },
  ["unicodeslot"]=0xFE17, -- ︗
 },
 [0xFE18]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT WHITE LENTICULAR BRAKCET",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x3017 },
  ["unicodeslot"]=0xFE18, -- ︘
 },
 [0xFE19]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL HORIZONTAL ELLIPSIS",
  ["linebreak"]="in",
  ["specials"]={ "vertical", 0x2026 },
  ["unicodeslot"]=0xFE19, -- ︙
 },
 [0xFE20]={
  ["category"]="mn",
  ["description"]="COMBINING LIGATURE LEFT HALF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE20, -- ︠
 },
 [0xFE21]={
  ["category"]="mn",
  ["description"]="COMBINING LIGATURE RIGHT HALF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE21, -- ︡
 },
 [0xFE22]={
  ["category"]="mn",
  ["description"]="COMBINING DOUBLE TILDE LEFT HALF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE22, -- ︢
 },
 [0xFE23]={
  ["category"]="mn",
  ["description"]="COMBINING DOUBLE TILDE RIGHT HALF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFE23, -- ︣
 },
 [0xFE30]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL TWO DOT LEADER",
  ["linebreak"]="id",
  ["specials"]={ "vertical", 0x2025 },
  ["unicodeslot"]=0xFE30, -- ︰
 },
 [0xFE31]={
  ["category"]="pd",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL EM DASH",
  ["linebreak"]="id",
  ["specials"]={ "vertical", 0x2014 },
  ["unicodeslot"]=0xFE31, -- ︱
 },
 [0xFE32]={
  ["category"]="pd",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL EN DASH",
  ["linebreak"]="id",
  ["specials"]={ "vertical", 0x2013 },
  ["unicodeslot"]=0xFE32, -- ︲
 },
 [0xFE33]={
  ["category"]="pc",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LOW LINE",
  ["linebreak"]="id",
  ["specials"]={ "vertical", 0x005F },
  ["unicodeslot"]=0xFE33, -- ︳
 },
 [0xFE34]={
  ["category"]="pc",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL WAVY LOW LINE",
  ["linebreak"]="id",
  ["specials"]={ "vertical", 0x005F },
  ["unicodeslot"]=0xFE34, -- ︴
 },
 [0xFE35]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT PARENTHESIS",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x0028 },
  ["unicodeslot"]=0xFE35, -- ︵
 },
 [0xFE36]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT PARENTHESIS",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x0029 },
  ["unicodeslot"]=0xFE36, -- ︶
 },
 [0xFE37]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT CURLY BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x007B },
  ["unicodeslot"]=0xFE37, -- ︷
 },
 [0xFE38]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT CURLY BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x007D },
  ["unicodeslot"]=0xFE38, -- ︸
 },
 [0xFE39]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT TORTOISE SHELL BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x3014 },
  ["unicodeslot"]=0xFE39, -- ︹
 },
 [0xFE3A]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT TORTOISE SHELL BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x3015 },
  ["unicodeslot"]=0xFE3A, -- ︺
 },
 [0xFE3B]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT BLACK LENTICULAR BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x3010 },
  ["unicodeslot"]=0xFE3B, -- ︻
 },
 [0xFE3C]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT BLACK LENTICULAR BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x3011 },
  ["unicodeslot"]=0xFE3C, -- ︼
 },
 [0xFE3D]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT DOUBLE ANGLE BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x300A },
  ["unicodeslot"]=0xFE3D, -- ︽
 },
 [0xFE3E]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT DOUBLE ANGLE BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x300B },
  ["unicodeslot"]=0xFE3E, -- ︾
 },
 [0xFE3F]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT ANGLE BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x3008 },
  ["unicodeslot"]=0xFE3F, -- ︿
 },
 [0xFE40]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT ANGLE BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x3009 },
  ["unicodeslot"]=0xFE40, -- ﹀
 },
 [0xFE41]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT CORNER BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x300C },
  ["unicodeslot"]=0xFE41, -- ﹁
 },
 [0xFE42]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT CORNER BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x300D },
  ["unicodeslot"]=0xFE42, -- ﹂
 },
 [0xFE43]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT WHITE CORNER BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x300E },
  ["unicodeslot"]=0xFE43, -- ﹃
 },
 [0xFE44]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT WHITE CORNER BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x300F },
  ["unicodeslot"]=0xFE44, -- ﹄
 },
 [0xFE45]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SESAME DOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFE45, -- ﹅
 },
 [0xFE46]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="WHITE SESAME DOT",
  ["linebreak"]="id",
  ["unicodeslot"]=0xFE46, -- ﹆
 },
 [0xFE47]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL LEFT SQUARE BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "vertical", 0x005B },
  ["unicodeslot"]=0xFE47, -- ﹇
 },
 [0xFE48]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="PRESENTATION FORM FOR VERTICAL RIGHT SQUARE BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "vertical", 0x005D },
  ["unicodeslot"]=0xFE48, -- ﹈
 },
 [0xFE49]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="DASHED OVERLINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x203E },
  ["unicodeslot"]=0xFE49, -- ﹉
 },
 [0xFE4A]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="CENTRELINE OVERLINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x203E },
  ["unicodeslot"]=0xFE4A, -- ﹊
 },
 [0xFE4B]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="WAVY OVERLINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x203E },
  ["unicodeslot"]=0xFE4B, -- ﹋
 },
 [0xFE4C]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="DOUBLE WAVY OVERLINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x203E },
  ["unicodeslot"]=0xFE4C, -- ﹌
 },
 [0xFE4D]={
  ["category"]="pc",
  ["cjkwd"]="w",
  ["description"]="DASHED LOW LINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x005F },
  ["unicodeslot"]=0xFE4D, -- ﹍
 },
 [0xFE4E]={
  ["category"]="pc",
  ["cjkwd"]="w",
  ["description"]="CENTRELINE LOW LINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x005F },
  ["unicodeslot"]=0xFE4E, -- ﹎
 },
 [0xFE4F]={
  ["category"]="pc",
  ["cjkwd"]="w",
  ["description"]="WAVY LOW LINE",
  ["linebreak"]="id",
  ["specials"]={ "compat", 0x005F },
  ["unicodeslot"]=0xFE4F, -- ﹏
 },
 [0xFE50]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL COMMA",
  ["linebreak"]="cl",
  ["specials"]={ "small", 0x002C },
  ["unicodeslot"]=0xFE50, -- ﹐
 },
 [0xFE51]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL IDEOGRAPHIC COMMA",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x3001 },
  ["unicodeslot"]=0xFE51, -- ﹑
 },
 [0xFE52]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL FULL STOP",
  ["linebreak"]="cl",
  ["specials"]={ "small", 0x002E },
  ["unicodeslot"]=0xFE52, -- ﹒
 },
 [0xFE54]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL SEMICOLON",
  ["linebreak"]="ns",
  ["specials"]={ "small", 0x003B },
  ["unicodeslot"]=0xFE54, -- ﹔
 },
 [0xFE55]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL COLON",
  ["linebreak"]="ns",
  ["specials"]={ "small", 0x003A },
  ["unicodeslot"]=0xFE55, -- ﹕
 },
 [0xFE56]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL QUESTION MARK",
  ["linebreak"]="ex",
  ["specials"]={ "small", 0x003F },
  ["unicodeslot"]=0xFE56, -- ﹖
 },
 [0xFE57]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL EXCLAMATION MARK",
  ["linebreak"]="ex",
  ["specials"]={ "small", 0x0021 },
  ["unicodeslot"]=0xFE57, -- ﹗
 },
 [0xFE58]={
  ["category"]="pd",
  ["cjkwd"]="w",
  ["description"]="SMALL EM DASH",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x2014 },
  ["unicodeslot"]=0xFE58, -- ﹘
 },
 [0xFE59]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="SMALL LEFT PARENTHESIS",
  ["linebreak"]="op",
  ["specials"]={ "small", 0x0028 },
  ["unicodeslot"]=0xFE59, -- ﹙
 },
 [0xFE5A]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="SMALL RIGHT PARENTHESIS",
  ["linebreak"]="cl",
  ["specials"]={ "small", 0x0029 },
  ["unicodeslot"]=0xFE5A, -- ﹚
 },
 [0xFE5B]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="SMALL LEFT CURLY BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "small", 0x007B },
  ["unicodeslot"]=0xFE5B, -- ﹛
 },
 [0xFE5C]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="SMALL RIGHT CURLY BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "small", 0x007D },
  ["unicodeslot"]=0xFE5C, -- ﹜
 },
 [0xFE5D]={
  ["category"]="ps",
  ["cjkwd"]="w",
  ["description"]="SMALL LEFT TORTOISE SHELL BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "small", 0x3014 },
  ["unicodeslot"]=0xFE5D, -- ﹝
 },
 [0xFE5E]={
  ["category"]="pe",
  ["cjkwd"]="w",
  ["description"]="SMALL RIGHT TORTOISE SHELL BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "small", 0x3015 },
  ["unicodeslot"]=0xFE5E, -- ﹞
 },
 [0xFE5F]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL NUMBER SIGN",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x0023 },
  ["unicodeslot"]=0xFE5F, -- ﹟
 },
 [0xFE60]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL AMPERSAND",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x0026 },
  ["unicodeslot"]=0xFE60, -- ﹠
 },
 [0xFE61]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL ASTERISK",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x002A },
  ["unicodeslot"]=0xFE61, -- ﹡
 },
 [0xFE62]={
  ["category"]="sm",
  ["cjkwd"]="w",
  ["description"]="SMALL PLUS SIGN",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x002B },
  ["unicodeslot"]=0xFE62, -- ﹢
 },
 [0xFE63]={
  ["category"]="pd",
  ["cjkwd"]="w",
  ["description"]="SMALL HYPHEN-MINUS",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x002D },
  ["unicodeslot"]=0xFE63, -- ﹣
 },
 [0xFE64]={
  ["category"]="sm",
  ["cjkwd"]="w",
  ["description"]="SMALL LESS-THAN SIGN",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x003C },
  ["unicodeslot"]=0xFE64, -- ﹤
 },
 [0xFE65]={
  ["category"]="sm",
  ["cjkwd"]="w",
  ["description"]="SMALL GREATER-THAN SIGN",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x003E },
  ["unicodeslot"]=0xFE65, -- ﹥
 },
 [0xFE66]={
  ["category"]="sm",
  ["cjkwd"]="w",
  ["description"]="SMALL EQUALS SIGN",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x003D },
  ["unicodeslot"]=0xFE66, -- ﹦
 },
 [0xFE68]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL REVERSE SOLIDUS",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x005C },
  ["unicodeslot"]=0xFE68, -- ﹨
 },
 [0xFE69]={
  ["category"]="sc",
  ["cjkwd"]="w",
  ["description"]="SMALL DOLLAR SIGN",
  ["linebreak"]="pr",
  ["specials"]={ "small", 0x0024 },
  ["unicodeslot"]=0xFE69, -- ﹩
 },
 [0xFE6A]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL PERCENT SIGN",
  ["linebreak"]="po",
  ["specials"]={ "small", 0x0025 },
  ["unicodeslot"]=0xFE6A, -- ﹪
 },
 [0xFE6B]={
  ["category"]="po",
  ["cjkwd"]="w",
  ["description"]="SMALL COMMERCIAL AT",
  ["linebreak"]="id",
  ["specials"]={ "small", 0x0040 },
  ["unicodeslot"]=0xFE6B, -- ﹫
 },
 [0xFE70]={
  ["category"]="lo",
  ["description"]="ARABIC FATHATAN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x064B },
  ["unicodeslot"]=0xFE70, -- ﹰ
 },
 [0xFE71]={
  ["category"]="lo",
  ["description"]="ARABIC TATWEEL WITH FATHATAN ABOVE",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0640, 0x064B },
  ["unicodeslot"]=0xFE71, -- ﹱ
 },
 [0xFE72]={
  ["category"]="lo",
  ["description"]="ARABIC DAMMATAN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x064C },
  ["unicodeslot"]=0xFE72, -- ﹲ
 },
 [0xFE73]={
  ["category"]="lo",
  ["description"]="ARABIC TAIL FRAGMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0xFE73, -- ﹳ
 },
 [0xFE74]={
  ["category"]="lo",
  ["description"]="ARABIC KASRATAN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x064D },
  ["unicodeslot"]=0xFE74, -- ﹴ
 },
 [0xFE76]={
  ["category"]="lo",
  ["description"]="ARABIC FATHA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x064E },
  ["unicodeslot"]=0xFE76, -- ﹶ
 },
 [0xFE77]={
  ["category"]="lo",
  ["description"]="ARABIC FATHA MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0640, 0x064E },
  ["unicodeslot"]=0xFE77, -- ﹷ
 },
 [0xFE78]={
  ["category"]="lo",
  ["description"]="ARABIC DAMMA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x064F },
  ["unicodeslot"]=0xFE78, -- ﹸ
 },
 [0xFE79]={
  ["category"]="lo",
  ["description"]="ARABIC DAMMA MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0640, 0x064F },
  ["unicodeslot"]=0xFE79, -- ﹹ
 },
 [0xFE7A]={
  ["category"]="lo",
  ["description"]="ARABIC KASRA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x0650 },
  ["unicodeslot"]=0xFE7A, -- ﹺ
 },
 [0xFE7B]={
  ["category"]="lo",
  ["description"]="ARABIC KASRA MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0640, 0x0650 },
  ["unicodeslot"]=0xFE7B, -- ﹻ
 },
 [0xFE7C]={
  ["category"]="lo",
  ["description"]="ARABIC SHADDA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x0651 },
  ["unicodeslot"]=0xFE7C, -- ﹼ
 },
 [0xFE7D]={
  ["category"]="lo",
  ["description"]="ARABIC SHADDA MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0640, 0x0651 },
  ["unicodeslot"]=0xFE7D, -- ﹽ
 },
 [0xFE7E]={
  ["category"]="lo",
  ["description"]="ARABIC SUKUN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0020, 0x0652 },
  ["unicodeslot"]=0xFE7E, -- ﹾ
 },
 [0xFE7F]={
  ["category"]="lo",
  ["description"]="ARABIC SUKUN MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0640, 0x0652 },
  ["unicodeslot"]=0xFE7F, -- ﹿ
 },
 [0xFE80]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAMZA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0621 },
  ["unicodeslot"]=0xFE80, -- ﺀ
 },
 [0xFE81]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH MADDA ABOVE ISOLATED FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["specials"]={ "isolated", 0x0622 },
  ["unicodeslot"]=0xFE81, -- ﺁ
 },
 [0xFE82]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH MADDA ABOVE FINAL FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["specials"]={ "final", 0x0622 },
  ["unicodeslot"]=0xFE82, -- ﺂ
 },
 [0xFE83]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH HAMZA ABOVE ISOLATED FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["specials"]={ "isolated", 0x0623 },
  ["unicodeslot"]=0xFE83, -- ﺃ
 },
 [0xFE84]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH HAMZA ABOVE FINAL FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["specials"]={ "final", 0x0623 },
  ["unicodeslot"]=0xFE84, -- ﺄ
 },
 [0xFE85]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER WAW WITH HAMZA ABOVE ISOLATED FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0648,
  ["specials"]={ "isolated", 0x0624 },
  ["unicodeslot"]=0xFE85, -- ﺅ
 },
 [0xFE86]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER WAW WITH HAMZA ABOVE FINAL FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0648,
  ["specials"]={ "final", 0x0624 },
  ["unicodeslot"]=0xFE86, -- ﺆ
 },
 [0xFE87]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH HAMZA BELOW ISOLATED FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["specials"]={ "isolated", 0x0625 },
  ["unicodeslot"]=0xFE87, -- ﺇ
 },
 [0xFE88]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF WITH HAMZA BELOW FINAL FORM",
  ["linebreak"]="al",
  ["shcode"]=0x0627,
  ["specials"]={ "final", 0x0625 },
  ["unicodeslot"]=0xFE88, -- ﺈ
 },
 [0xFE89]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH WITH HAMZA ABOVE ISOLATED FORM",
  ["linebreak"]="al",
  ["shcode"]=0x064A,
  ["specials"]={ "isolated", 0x0626 },
  ["unicodeslot"]=0xFE89, -- ﺉ
 },
 [0xFE8A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH WITH HAMZA ABOVE FINAL FORM",
  ["linebreak"]="al",
  ["shcode"]=0x064A,
  ["specials"]={ "final", 0x0626 },
  ["unicodeslot"]=0xFE8A, -- ﺊ
 },
 [0xFE8B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH WITH HAMZA ABOVE INITIAL FORM",
  ["linebreak"]="al",
  ["shcode"]=0x064A,
  ["specials"]={ "initial", 0x0626 },
  ["unicodeslot"]=0xFE8B, -- ﺋ
 },
 [0xFE8C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH WITH HAMZA ABOVE MEDIAL FORM",
  ["linebreak"]="al",
  ["shcode"]=0x064A,
  ["specials"]={ "medial", 0x0626 },
  ["unicodeslot"]=0xFE8C, -- ﺌ
 },
 [0xFE8D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0627 },
  ["unicodeslot"]=0xFE8D, -- ﺍ
 },
 [0xFE8E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0627 },
  ["unicodeslot"]=0xFE8E, -- ﺎ
 },
 [0xFE8F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0628 },
  ["unicodeslot"]=0xFE8F, -- ﺏ
 },
 [0xFE90]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0628 },
  ["unicodeslot"]=0xFE90, -- ﺐ
 },
 [0xFE91]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0628 },
  ["unicodeslot"]=0xFE91, -- ﺑ
 },
 [0xFE92]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER BEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0628 },
  ["unicodeslot"]=0xFE92, -- ﺒ
 },
 [0xFE93]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH MARBUTA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0629 },
  ["unicodeslot"]=0xFE93, -- ﺓ
 },
 [0xFE94]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH MARBUTA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0629 },
  ["unicodeslot"]=0xFE94, -- ﺔ
 },
 [0xFE95]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062A },
  ["unicodeslot"]=0xFE95, -- ﺕ
 },
 [0xFE96]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062A },
  ["unicodeslot"]=0xFE96, -- ﺖ
 },
 [0xFE97]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062A },
  ["unicodeslot"]=0xFE97, -- ﺗ
 },
 [0xFE98]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x062A },
  ["unicodeslot"]=0xFE98, -- ﺘ
 },
 [0xFE99]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER THEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062B },
  ["unicodeslot"]=0xFE99, -- ﺙ
 },
 [0xFE9A]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER THEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062B },
  ["unicodeslot"]=0xFE9A, -- ﺚ
 },
 [0xFE9B]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER THEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062B },
  ["unicodeslot"]=0xFE9B, -- ﺛ
 },
 [0xFE9C]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER THEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x062B },
  ["unicodeslot"]=0xFE9C, -- ﺜ
 },
 [0xFE9D]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER JEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062C },
  ["unicodeslot"]=0xFE9D, -- ﺝ
 },
 [0xFE9E]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER JEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062C },
  ["unicodeslot"]=0xFE9E, -- ﺞ
 },
 [0xFE9F]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER JEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062C },
  ["unicodeslot"]=0xFE9F, -- ﺟ
 },
 [0xFEA0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER JEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x062C },
  ["unicodeslot"]=0xFEA0, -- ﺠ
 },
 [0xFEA1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062D },
  ["unicodeslot"]=0xFEA1, -- ﺡ
 },
 [0xFEA2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062D },
  ["unicodeslot"]=0xFEA2, -- ﺢ
 },
 [0xFEA3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062D },
  ["unicodeslot"]=0xFEA3, -- ﺣ
 },
 [0xFEA4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HAH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x062D },
  ["unicodeslot"]=0xFEA4, -- ﺤ
 },
 [0xFEA5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KHAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062E },
  ["unicodeslot"]=0xFEA5, -- ﺥ
 },
 [0xFEA6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KHAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062E },
  ["unicodeslot"]=0xFEA6, -- ﺦ
 },
 [0xFEA7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KHAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x062E },
  ["unicodeslot"]=0xFEA7, -- ﺧ
 },
 [0xFEA8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KHAH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x062E },
  ["unicodeslot"]=0xFEA8, -- ﺨ
 },
 [0xFEA9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x062F },
  ["unicodeslot"]=0xFEA9, -- ﺩ
 },
 [0xFEAA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAL FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x062F },
  ["unicodeslot"]=0xFEAA, -- ﺪ
 },
 [0xFEAB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER THAL ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0630 },
  ["unicodeslot"]=0xFEAB, -- ﺫ
 },
 [0xFEAC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER THAL FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0630 },
  ["unicodeslot"]=0xFEAC, -- ﺬ
 },
 [0xFEAD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0631 },
  ["unicodeslot"]=0xFEAD, -- ﺭ
 },
 [0xFEAE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER REH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0631 },
  ["unicodeslot"]=0xFEAE, -- ﺮ
 },
 [0xFEAF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ZAIN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0632 },
  ["unicodeslot"]=0xFEAF, -- ﺯ
 },
 [0xFEB0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ZAIN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0632 },
  ["unicodeslot"]=0xFEB0, -- ﺰ
 },
 [0xFEB1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0633 },
  ["unicodeslot"]=0xFEB1, -- ﺱ
 },
 [0xFEB2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0633 },
  ["unicodeslot"]=0xFEB2, -- ﺲ
 },
 [0xFEB3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0633 },
  ["unicodeslot"]=0xFEB3, -- ﺳ
 },
 [0xFEB4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SEEN MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0633 },
  ["unicodeslot"]=0xFEB4, -- ﺴ
 },
 [0xFEB5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SHEEN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0634 },
  ["unicodeslot"]=0xFEB5, -- ﺵ
 },
 [0xFEB6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SHEEN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0634 },
  ["unicodeslot"]=0xFEB6, -- ﺶ
 },
 [0xFEB7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SHEEN INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0634 },
  ["unicodeslot"]=0xFEB7, -- ﺷ
 },
 [0xFEB8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SHEEN MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0634 },
  ["unicodeslot"]=0xFEB8, -- ﺸ
 },
 [0xFEB9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SAD ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0635 },
  ["unicodeslot"]=0xFEB9, -- ﺹ
 },
 [0xFEBA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SAD FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0635 },
  ["unicodeslot"]=0xFEBA, -- ﺺ
 },
 [0xFEBB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SAD INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0635 },
  ["unicodeslot"]=0xFEBB, -- ﺻ
 },
 [0xFEBC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER SAD MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0635 },
  ["unicodeslot"]=0xFEBC, -- ﺼ
 },
 [0xFEBD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAD ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0636 },
  ["unicodeslot"]=0xFEBD, -- ﺽ
 },
 [0xFEBE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAD FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0636 },
  ["unicodeslot"]=0xFEBE, -- ﺾ
 },
 [0xFEBF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAD INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0636 },
  ["unicodeslot"]=0xFEBF, -- ﺿ
 },
 [0xFEC0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER DAD MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0636 },
  ["unicodeslot"]=0xFEC0, -- ﻀ
 },
 [0xFEC1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0637 },
  ["unicodeslot"]=0xFEC1, -- ﻁ
 },
 [0xFEC2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0637 },
  ["unicodeslot"]=0xFEC2, -- ﻂ
 },
 [0xFEC3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0637 },
  ["unicodeslot"]=0xFEC3, -- ﻃ
 },
 [0xFEC4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER TAH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0637 },
  ["unicodeslot"]=0xFEC4, -- ﻄ
 },
 [0xFEC5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ZAH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0638 },
  ["unicodeslot"]=0xFEC5, -- ﻅ
 },
 [0xFEC6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ZAH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0638 },
  ["unicodeslot"]=0xFEC6, -- ﻆ
 },
 [0xFEC7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ZAH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0638 },
  ["unicodeslot"]=0xFEC7, -- ﻇ
 },
 [0xFEC8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ZAH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0638 },
  ["unicodeslot"]=0xFEC8, -- ﻈ
 },
 [0xFEC9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER AIN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0639 },
  ["unicodeslot"]=0xFEC9, -- ﻉ
 },
 [0xFECA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER AIN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0639 },
  ["unicodeslot"]=0xFECA, -- ﻊ
 },
 [0xFECB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER AIN INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0639 },
  ["unicodeslot"]=0xFECB, -- ﻋ
 },
 [0xFECC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER AIN MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0639 },
  ["unicodeslot"]=0xFECC, -- ﻌ
 },
 [0xFECD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GHAIN ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x063A },
  ["unicodeslot"]=0xFECD, -- ﻍ
 },
 [0xFECE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GHAIN FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x063A },
  ["unicodeslot"]=0xFECE, -- ﻎ
 },
 [0xFECF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GHAIN INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x063A },
  ["unicodeslot"]=0xFECF, -- ﻏ
 },
 [0xFED0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER GHAIN MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x063A },
  ["unicodeslot"]=0xFED0, -- ﻐ
 },
 [0xFED1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0641 },
  ["unicodeslot"]=0xFED1, -- ﻑ
 },
 [0xFED2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0641 },
  ["unicodeslot"]=0xFED2, -- ﻒ
 },
 [0xFED3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0641 },
  ["unicodeslot"]=0xFED3, -- ﻓ
 },
 [0xFED4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER FEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0641 },
  ["unicodeslot"]=0xFED4, -- ﻔ
 },
 [0xFED5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER QAF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0642 },
  ["unicodeslot"]=0xFED5, -- ﻕ
 },
 [0xFED6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER QAF FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0642 },
  ["unicodeslot"]=0xFED6, -- ﻖ
 },
 [0xFED7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER QAF INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0642 },
  ["unicodeslot"]=0xFED7, -- ﻗ
 },
 [0xFED8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER QAF MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0642 },
  ["unicodeslot"]=0xFED8, -- ﻘ
 },
 [0xFED9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KAF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0643 },
  ["unicodeslot"]=0xFED9, -- ﻙ
 },
 [0xFEDA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KAF FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0643 },
  ["unicodeslot"]=0xFEDA, -- ﻚ
 },
 [0xFEDB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KAF INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0643 },
  ["unicodeslot"]=0xFEDB, -- ﻛ
 },
 [0xFEDC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER KAF MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0643 },
  ["unicodeslot"]=0xFEDC, -- ﻜ
 },
 [0xFEDD]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644 },
  ["unicodeslot"]=0xFEDD, -- ﻝ
 },
 [0xFEDE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644 },
  ["unicodeslot"]=0xFEDE, -- ﻞ
 },
 [0xFEDF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0644 },
  ["unicodeslot"]=0xFEDF, -- ﻟ
 },
 [0xFEE0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER LAM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0644 },
  ["unicodeslot"]=0xFEE0, -- ﻠ
 },
 [0xFEE1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER MEEM ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0645 },
  ["unicodeslot"]=0xFEE1, -- ﻡ
 },
 [0xFEE2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER MEEM FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0645 },
  ["unicodeslot"]=0xFEE2, -- ﻢ
 },
 [0xFEE3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER MEEM INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0645 },
  ["unicodeslot"]=0xFEE3, -- ﻣ
 },
 [0xFEE4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER MEEM MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0645 },
  ["unicodeslot"]=0xFEE4, -- ﻤ
 },
 [0xFEE5]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0646 },
  ["unicodeslot"]=0xFEE5, -- ﻥ
 },
 [0xFEE6]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0646 },
  ["unicodeslot"]=0xFEE6, -- ﻦ
 },
 [0xFEE7]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0646 },
  ["unicodeslot"]=0xFEE7, -- ﻧ
 },
 [0xFEE8]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER NOON MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0646 },
  ["unicodeslot"]=0xFEE8, -- ﻨ
 },
 [0xFEE9]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0647 },
  ["unicodeslot"]=0xFEE9, -- ﻩ
 },
 [0xFEEA]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0647 },
  ["unicodeslot"]=0xFEEA, -- ﻪ
 },
 [0xFEEB]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x0647 },
  ["unicodeslot"]=0xFEEB, -- ﻫ
 },
 [0xFEEC]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER HEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x0647 },
  ["unicodeslot"]=0xFEEC, -- ﻬ
 },
 [0xFEED]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER WAW ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0648 },
  ["unicodeslot"]=0xFEED, -- ﻭ
 },
 [0xFEEE]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER WAW FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0648 },
  ["unicodeslot"]=0xFEEE, -- ﻮ
 },
 [0xFEEF]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF MAKSURA ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0649 },
  ["unicodeslot"]=0xFEEF, -- ﻯ
 },
 [0xFEF0]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER ALEF MAKSURA FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0649 },
  ["unicodeslot"]=0xFEF0, -- ﻰ
 },
 [0xFEF1]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x064A },
  ["unicodeslot"]=0xFEF1, -- ﻱ
 },
 [0xFEF2]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x064A },
  ["unicodeslot"]=0xFEF2, -- ﻲ
 },
 [0xFEF3]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH INITIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "initial", 0x064A },
  ["unicodeslot"]=0xFEF3, -- ﻳ
 },
 [0xFEF4]={
  ["category"]="lo",
  ["description"]="ARABIC LETTER YEH MEDIAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "medial", 0x064A },
  ["unicodeslot"]=0xFEF4, -- ﻴ
 },
 [0xFEF5]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x0622 },
  ["unicodeslot"]=0xFEF5, -- ﻵ
 },
 [0xFEF6]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x0622 },
  ["unicodeslot"]=0xFEF6, -- ﻶ
 },
 [0xFEF7]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x0623 },
  ["unicodeslot"]=0xFEF7, -- ﻷ
 },
 [0xFEF8]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x0623 },
  ["unicodeslot"]=0xFEF8, -- ﻸ
 },
 [0xFEF9]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x0625 },
  ["unicodeslot"]=0xFEF9, -- ﻹ
 },
 [0xFEFA]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x0625 },
  ["unicodeslot"]=0xFEFA, -- ﻺ
 },
 [0xFEFB]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF ISOLATED FORM",
  ["linebreak"]="al",
  ["specials"]={ "isolated", 0x0644, 0x0627 },
  ["unicodeslot"]=0xFEFB, -- ﻻ
 },
 [0xFEFC]={
  ["category"]="lo",
  ["description"]="ARABIC LIGATURE LAM WITH ALEF FINAL FORM",
  ["linebreak"]="al",
  ["specials"]={ "final", 0x0644, 0x0627 },
  ["unicodeslot"]=0xFEFC, -- ﻼ
 },
 [0xFEFF]={
  ["category"]="cf",
  ["description"]="ZERO WIDTH NO-BREAK SPACE",
  ["linebreak"]="wj",
  ["unicodeslot"]=0xFEFF, -- ﻿
 },
 [0xFF01]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH EXCLAMATION MARK",
  ["linebreak"]="ex",
  ["specials"]={ "wide", 0x0021 },
  ["unicodeslot"]=0xFF01, -- ！
 },
 [0xFF02]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH QUOTATION MARK",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0022 },
  ["unicodeslot"]=0xFF02, -- ＂
 },
 [0xFF03]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH NUMBER SIGN",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0023 },
  ["unicodeslot"]=0xFF03, -- ＃
 },
 [0xFF04]={
  ["category"]="sc",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DOLLAR SIGN",
  ["linebreak"]="pr",
  ["specials"]={ "wide", 0x0024 },
  ["unicodeslot"]=0xFF04, -- ＄
 },
 [0xFF05]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH PERCENT SIGN",
  ["linebreak"]="po",
  ["specials"]={ "wide", 0x0025 },
  ["unicodeslot"]=0xFF05, -- ％
 },
 [0xFF06]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH AMPERSAND",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0026 },
  ["unicodeslot"]=0xFF06, -- ＆
 },
 [0xFF07]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH APOSTROPHE",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0027 },
  ["unicodeslot"]=0xFF07, -- ＇
 },
 [0xFF08]={
  ["category"]="ps",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LEFT PARENTHESIS",
  ["linebreak"]="op",
  ["specials"]={ "wide", 0x0028 },
  ["unicodeslot"]=0xFF08, -- （
 },
 [0xFF09]={
  ["category"]="pe",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH RIGHT PARENTHESIS",
  ["linebreak"]="cl",
  ["specials"]={ "wide", 0x0029 },
  ["unicodeslot"]=0xFF09, -- ）
 },
 [0xFF0A]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH ASTERISK",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x002A },
  ["unicodeslot"]=0xFF0A, -- ＊
 },
 [0xFF0B]={
  ["category"]="sm",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH PLUS SIGN",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x002B },
  ["unicodeslot"]=0xFF0B, -- ＋
 },
 [0xFF0C]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH COMMA",
  ["linebreak"]="cl",
  ["specials"]={ "wide", 0x002C },
  ["unicodeslot"]=0xFF0C, -- ，
 },
 [0xFF0D]={
  ["category"]="pd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH HYPHEN-MINUS",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x002D },
  ["unicodeslot"]=0xFF0D, -- －
 },
 [0xFF0E]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH FULL STOP",
  ["linebreak"]="cl",
  ["specials"]={ "wide", 0x002E },
  ["unicodeslot"]=0xFF0E, -- ．
 },
 [0xFF0F]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH SOLIDUS",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x002F },
  ["unicodeslot"]=0xFF0F, -- ／
 },
 [0xFF10]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT ZERO",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0030 },
  ["unicodeslot"]=0xFF10, -- ０
 },
 [0xFF11]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT ONE",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0031 },
  ["unicodeslot"]=0xFF11, -- １
 },
 [0xFF12]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT TWO",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0032 },
  ["unicodeslot"]=0xFF12, -- ２
 },
 [0xFF13]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT THREE",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0033 },
  ["unicodeslot"]=0xFF13, -- ３
 },
 [0xFF14]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT FOUR",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0034 },
  ["unicodeslot"]=0xFF14, -- ４
 },
 [0xFF15]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT FIVE",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0035 },
  ["unicodeslot"]=0xFF15, -- ５
 },
 [0xFF16]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT SIX",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0036 },
  ["unicodeslot"]=0xFF16, -- ６
 },
 [0xFF17]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT SEVEN",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0037 },
  ["unicodeslot"]=0xFF17, -- ７
 },
 [0xFF18]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT EIGHT",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0038 },
  ["unicodeslot"]=0xFF18, -- ８
 },
 [0xFF19]={
  ["category"]="nd",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH DIGIT NINE",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0039 },
  ["unicodeslot"]=0xFF19, -- ９
 },
 [0xFF1A]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH COLON",
  ["linebreak"]="ns",
  ["specials"]={ "wide", 0x003A },
  ["unicodeslot"]=0xFF1A, -- ：
 },
 [0xFF1B]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH SEMICOLON",
  ["linebreak"]="ns",
  ["specials"]={ "wide", 0x003B },
  ["unicodeslot"]=0xFF1B, -- ；
 },
 [0xFF1C]={
  ["category"]="sm",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LESS-THAN SIGN",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x003C },
  ["unicodeslot"]=0xFF1C, -- ＜
 },
 [0xFF1D]={
  ["category"]="sm",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH EQUALS SIGN",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x003D },
  ["unicodeslot"]=0xFF1D, -- ＝
 },
 [0xFF1E]={
  ["category"]="sm",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH GREATER-THAN SIGN",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x003E },
  ["unicodeslot"]=0xFF1E, -- ＞
 },
 [0xFF1F]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH QUESTION MARK",
  ["linebreak"]="ex",
  ["specials"]={ "wide", 0x003F },
  ["unicodeslot"]=0xFF1F, -- ？
 },
 [0xFF20]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH COMMERCIAL AT",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0040 },
  ["unicodeslot"]=0xFF20, -- ＠
 },
 [0xFF21]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER A",
  ["lccode"]=0xFF41,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0041 },
  ["unicodeslot"]=0xFF21, -- Ａ
 },
 [0xFF22]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER B",
  ["lccode"]=0xFF42,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0042 },
  ["unicodeslot"]=0xFF22, -- Ｂ
 },
 [0xFF23]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER C",
  ["lccode"]=0xFF43,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0043 },
  ["unicodeslot"]=0xFF23, -- Ｃ
 },
 [0xFF24]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER D",
  ["lccode"]=0xFF44,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0044 },
  ["unicodeslot"]=0xFF24, -- Ｄ
 },
 [0xFF25]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER E",
  ["lccode"]=0xFF45,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0045 },
  ["unicodeslot"]=0xFF25, -- Ｅ
 },
 [0xFF26]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER F",
  ["lccode"]=0xFF46,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0046 },
  ["unicodeslot"]=0xFF26, -- Ｆ
 },
 [0xFF27]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER G",
  ["lccode"]=0xFF47,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0047 },
  ["unicodeslot"]=0xFF27, -- Ｇ
 },
 [0xFF28]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER H",
  ["lccode"]=0xFF48,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0048 },
  ["unicodeslot"]=0xFF28, -- Ｈ
 },
 [0xFF29]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER I",
  ["lccode"]=0xFF49,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0049 },
  ["unicodeslot"]=0xFF29, -- Ｉ
 },
 [0xFF2A]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER J",
  ["lccode"]=0xFF4A,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x004A },
  ["unicodeslot"]=0xFF2A, -- Ｊ
 },
 [0xFF2B]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER K",
  ["lccode"]=0xFF4B,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x004B },
  ["unicodeslot"]=0xFF2B, -- Ｋ
 },
 [0xFF2C]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER L",
  ["lccode"]=0xFF4C,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x004C },
  ["unicodeslot"]=0xFF2C, -- Ｌ
 },
 [0xFF2D]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER M",
  ["lccode"]=0xFF4D,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x004D },
  ["unicodeslot"]=0xFF2D, -- Ｍ
 },
 [0xFF2E]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER N",
  ["lccode"]=0xFF4E,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x004E },
  ["unicodeslot"]=0xFF2E, -- Ｎ
 },
 [0xFF2F]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER O",
  ["lccode"]=0xFF4F,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x004F },
  ["unicodeslot"]=0xFF2F, -- Ｏ
 },
 [0xFF30]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER P",
  ["lccode"]=0xFF50,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0050 },
  ["unicodeslot"]=0xFF30, -- Ｐ
 },
 [0xFF31]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER Q",
  ["lccode"]=0xFF51,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0051 },
  ["unicodeslot"]=0xFF31, -- Ｑ
 },
 [0xFF32]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER R",
  ["lccode"]=0xFF52,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0052 },
  ["unicodeslot"]=0xFF32, -- Ｒ
 },
 [0xFF33]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER S",
  ["lccode"]=0xFF53,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0053 },
  ["unicodeslot"]=0xFF33, -- Ｓ
 },
 [0xFF34]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER T",
  ["lccode"]=0xFF54,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0054 },
  ["unicodeslot"]=0xFF34, -- Ｔ
 },
 [0xFF35]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER U",
  ["lccode"]=0xFF55,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0055 },
  ["unicodeslot"]=0xFF35, -- Ｕ
 },
 [0xFF36]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER V",
  ["lccode"]=0xFF56,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0056 },
  ["unicodeslot"]=0xFF36, -- Ｖ
 },
 [0xFF37]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER W",
  ["lccode"]=0xFF57,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0057 },
  ["unicodeslot"]=0xFF37, -- Ｗ
 },
 [0xFF38]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER X",
  ["lccode"]=0xFF58,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0058 },
  ["unicodeslot"]=0xFF38, -- Ｘ
 },
 [0xFF39]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER Y",
  ["lccode"]=0xFF59,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0059 },
  ["unicodeslot"]=0xFF39, -- Ｙ
 },
 [0xFF3A]={
  ["category"]="lu",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN CAPITAL LETTER Z",
  ["lccode"]=0xFF5A,
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x005A },
  ["unicodeslot"]=0xFF3A, -- Ｚ
 },
 [0xFF3B]={
  ["category"]="ps",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LEFT SQUARE BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "wide", 0x005B },
  ["unicodeslot"]=0xFF3B, -- ［
 },
 [0xFF3C]={
  ["category"]="po",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH REVERSE SOLIDUS",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x005C },
  ["unicodeslot"]=0xFF3C, -- ＼
 },
 [0xFF3D]={
  ["category"]="pe",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH RIGHT SQUARE BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "wide", 0x005D },
  ["unicodeslot"]=0xFF3D, -- ］
 },
 [0xFF3E]={
  ["category"]="sk",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH CIRCUMFLEX ACCENT",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x005E },
  ["unicodeslot"]=0xFF3E, -- ＾
 },
 [0xFF3F]={
  ["category"]="pc",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LOW LINE",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x005F },
  ["unicodeslot"]=0xFF3F, -- ＿
 },
 [0xFF40]={
  ["category"]="sk",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH GRAVE ACCENT",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0060 },
  ["unicodeslot"]=0xFF40, -- ｀
 },
 [0xFF41]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER A",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0061 },
  ["uccode"]=0xFF21,
  ["unicodeslot"]=0xFF41, -- ａ
 },
 [0xFF42]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER B",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0062 },
  ["uccode"]=0xFF22,
  ["unicodeslot"]=0xFF42, -- ｂ
 },
 [0xFF43]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER C",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0063 },
  ["uccode"]=0xFF23,
  ["unicodeslot"]=0xFF43, -- ｃ
 },
 [0xFF44]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER D",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0064 },
  ["uccode"]=0xFF24,
  ["unicodeslot"]=0xFF44, -- ｄ
 },
 [0xFF45]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER E",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0065 },
  ["uccode"]=0xFF25,
  ["unicodeslot"]=0xFF45, -- ｅ
 },
 [0xFF46]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER F",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0066 },
  ["uccode"]=0xFF26,
  ["unicodeslot"]=0xFF46, -- ｆ
 },
 [0xFF47]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER G",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0067 },
  ["uccode"]=0xFF27,
  ["unicodeslot"]=0xFF47, -- ｇ
 },
 [0xFF48]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER H",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0068 },
  ["uccode"]=0xFF28,
  ["unicodeslot"]=0xFF48, -- ｈ
 },
 [0xFF49]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER I",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0069 },
  ["uccode"]=0xFF29,
  ["unicodeslot"]=0xFF49, -- ｉ
 },
 [0xFF4A]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER J",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x006A },
  ["uccode"]=0xFF2A,
  ["unicodeslot"]=0xFF4A, -- ｊ
 },
 [0xFF4B]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER K",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x006B },
  ["uccode"]=0xFF2B,
  ["unicodeslot"]=0xFF4B, -- ｋ
 },
 [0xFF4C]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER L",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x006C },
  ["uccode"]=0xFF2C,
  ["unicodeslot"]=0xFF4C, -- ｌ
 },
 [0xFF4D]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER M",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x006D },
  ["uccode"]=0xFF2D,
  ["unicodeslot"]=0xFF4D, -- ｍ
 },
 [0xFF4E]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER N",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x006E },
  ["uccode"]=0xFF2E,
  ["unicodeslot"]=0xFF4E, -- ｎ
 },
 [0xFF4F]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER O",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x006F },
  ["uccode"]=0xFF2F,
  ["unicodeslot"]=0xFF4F, -- ｏ
 },
 [0xFF50]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER P",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0070 },
  ["uccode"]=0xFF30,
  ["unicodeslot"]=0xFF50, -- ｐ
 },
 [0xFF51]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER Q",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0071 },
  ["uccode"]=0xFF31,
  ["unicodeslot"]=0xFF51, -- ｑ
 },
 [0xFF52]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER R",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0072 },
  ["uccode"]=0xFF32,
  ["unicodeslot"]=0xFF52, -- ｒ
 },
 [0xFF53]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER S",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0073 },
  ["uccode"]=0xFF33,
  ["unicodeslot"]=0xFF53, -- ｓ
 },
 [0xFF54]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER T",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0074 },
  ["uccode"]=0xFF34,
  ["unicodeslot"]=0xFF54, -- ｔ
 },
 [0xFF55]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER U",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0075 },
  ["uccode"]=0xFF35,
  ["unicodeslot"]=0xFF55, -- ｕ
 },
 [0xFF56]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER V",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0076 },
  ["uccode"]=0xFF36,
  ["unicodeslot"]=0xFF56, -- ｖ
 },
 [0xFF57]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER W",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0077 },
  ["uccode"]=0xFF37,
  ["unicodeslot"]=0xFF57, -- ｗ
 },
 [0xFF58]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER X",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0078 },
  ["uccode"]=0xFF38,
  ["unicodeslot"]=0xFF58, -- ｘ
 },
 [0xFF59]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER Y",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x0079 },
  ["uccode"]=0xFF39,
  ["unicodeslot"]=0xFF59, -- ｙ
 },
 [0xFF5A]={
  ["category"]="ll",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LATIN SMALL LETTER Z",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x007A },
  ["uccode"]=0xFF3A,
  ["unicodeslot"]=0xFF5A, -- ｚ
 },
 [0xFF5B]={
  ["category"]="ps",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LEFT CURLY BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "wide", 0x007B },
  ["unicodeslot"]=0xFF5B, -- ｛
 },
 [0xFF5C]={
  ["category"]="sm",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH VERTICAL LINE",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x007C },
  ["unicodeslot"]=0xFF5C, -- ｜
 },
 [0xFF5D]={
  ["category"]="pe",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH RIGHT CURLY BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "wide", 0x007D },
  ["unicodeslot"]=0xFF5D, -- ｝
 },
 [0xFF5E]={
  ["category"]="sm",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH TILDE",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x007E },
  ["unicodeslot"]=0xFF5E, -- ～
 },
 [0xFF5F]={
  ["category"]="ps",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH LEFT WHITE PARENTHESIS",
  ["linebreak"]="op",
  ["specials"]={ "wide", 0x2985 },
  ["unicodeslot"]=0xFF5F, -- ｟
 },
 [0xFF60]={
  ["category"]="pe",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH RIGHT WHITE PARENTHESIS",
  ["linebreak"]="cl",
  ["specials"]={ "wide", 0x2986 },
  ["unicodeslot"]=0xFF60, -- ｠
 },
 [0xFF61]={
  ["category"]="po",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH IDEOGRAPHIC FULL STOP",
  ["linebreak"]="cl",
  ["specials"]={ "narrow", 0x3002 },
  ["unicodeslot"]=0xFF61, -- ｡
 },
 [0xFF62]={
  ["category"]="ps",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH LEFT CORNER BRACKET",
  ["linebreak"]="op",
  ["specials"]={ "narrow", 0x300C },
  ["unicodeslot"]=0xFF62, -- ｢
 },
 [0xFF63]={
  ["category"]="pe",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH RIGHT CORNER BRACKET",
  ["linebreak"]="cl",
  ["specials"]={ "narrow", 0x300D },
  ["unicodeslot"]=0xFF63, -- ｣
 },
 [0xFF64]={
  ["category"]="po",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH IDEOGRAPHIC COMMA",
  ["linebreak"]="cl",
  ["specials"]={ "narrow", 0x3001 },
  ["unicodeslot"]=0xFF64, -- ､
 },
 [0xFF65]={
  ["category"]="po",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA MIDDLE DOT",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30FB },
  ["unicodeslot"]=0xFF65, -- ･
 },
 [0xFF66]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER WO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30F2 },
  ["unicodeslot"]=0xFF66, -- ｦ
 },
 [0xFF67]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SMALL A",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30A1 },
  ["unicodeslot"]=0xFF67, -- ｧ
 },
 [0xFF68]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SMALL I",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30A3 },
  ["unicodeslot"]=0xFF68, -- ｨ
 },
 [0xFF69]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SMALL U",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30A5 },
  ["unicodeslot"]=0xFF69, -- ｩ
 },
 [0xFF6A]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SMALL E",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30A7 },
  ["unicodeslot"]=0xFF6A, -- ｪ
 },
 [0xFF6B]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SMALL O",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30A9 },
  ["unicodeslot"]=0xFF6B, -- ｫ
 },
 [0xFF6C]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SMALL YA",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30E3 },
  ["unicodeslot"]=0xFF6C, -- ｬ
 },
 [0xFF6D]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SMALL YU",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30E5 },
  ["unicodeslot"]=0xFF6D, -- ｭ
 },
 [0xFF6E]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SMALL YO",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30E7 },
  ["unicodeslot"]=0xFF6E, -- ｮ
 },
 [0xFF6F]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SMALL TU",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30C3 },
  ["unicodeslot"]=0xFF6F, -- ｯ
 },
 [0xFF70]={
  ["category"]="lm",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA-HIRAGANA PROLONGED SOUND MARK",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x30FC },
  ["unicodeslot"]=0xFF70, -- ｰ
 },
 [0xFF71]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER A",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30A2 },
  ["unicodeslot"]=0xFF71, -- ｱ
 },
 [0xFF72]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER I",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30A4 },
  ["unicodeslot"]=0xFF72, -- ｲ
 },
 [0xFF73]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER U",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30A6 },
  ["unicodeslot"]=0xFF73, -- ｳ
 },
 [0xFF74]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER E",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30A8 },
  ["unicodeslot"]=0xFF74, -- ｴ
 },
 [0xFF75]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER O",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30AA },
  ["unicodeslot"]=0xFF75, -- ｵ
 },
 [0xFF76]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER KA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30AB },
  ["unicodeslot"]=0xFF76, -- ｶ
 },
 [0xFF77]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER KI",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30AD },
  ["unicodeslot"]=0xFF77, -- ｷ
 },
 [0xFF78]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER KU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30AF },
  ["unicodeslot"]=0xFF78, -- ｸ
 },
 [0xFF79]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER KE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30B1 },
  ["unicodeslot"]=0xFF79, -- ｹ
 },
 [0xFF7A]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER KO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30B3 },
  ["unicodeslot"]=0xFF7A, -- ｺ
 },
 [0xFF7B]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30B5 },
  ["unicodeslot"]=0xFF7B, -- ｻ
 },
 [0xFF7C]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SI",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30B7 },
  ["unicodeslot"]=0xFF7C, -- ｼ
 },
 [0xFF7D]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30B9 },
  ["unicodeslot"]=0xFF7D, -- ｽ
 },
 [0xFF7E]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30BB },
  ["unicodeslot"]=0xFF7E, -- ｾ
 },
 [0xFF7F]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER SO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30BD },
  ["unicodeslot"]=0xFF7F, -- ｿ
 },
 [0xFF80]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER TA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30BF },
  ["unicodeslot"]=0xFF80, -- ﾀ
 },
 [0xFF81]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER TI",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30C1 },
  ["unicodeslot"]=0xFF81, -- ﾁ
 },
 [0xFF82]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER TU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30C4 },
  ["unicodeslot"]=0xFF82, -- ﾂ
 },
 [0xFF83]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER TE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30C6 },
  ["unicodeslot"]=0xFF83, -- ﾃ
 },
 [0xFF84]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER TO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30C8 },
  ["unicodeslot"]=0xFF84, -- ﾄ
 },
 [0xFF85]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER NA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30CA },
  ["unicodeslot"]=0xFF85, -- ﾅ
 },
 [0xFF86]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER NI",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30CB },
  ["unicodeslot"]=0xFF86, -- ﾆ
 },
 [0xFF87]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER NU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30CC },
  ["unicodeslot"]=0xFF87, -- ﾇ
 },
 [0xFF88]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER NE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30CD },
  ["unicodeslot"]=0xFF88, -- ﾈ
 },
 [0xFF89]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER NO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30CE },
  ["unicodeslot"]=0xFF89, -- ﾉ
 },
 [0xFF8A]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER HA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30CF },
  ["unicodeslot"]=0xFF8A, -- ﾊ
 },
 [0xFF8B]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER HI",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30D2 },
  ["unicodeslot"]=0xFF8B, -- ﾋ
 },
 [0xFF8C]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER HU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30D5 },
  ["unicodeslot"]=0xFF8C, -- ﾌ
 },
 [0xFF8D]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER HE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30D8 },
  ["unicodeslot"]=0xFF8D, -- ﾍ
 },
 [0xFF8E]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER HO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30DB },
  ["unicodeslot"]=0xFF8E, -- ﾎ
 },
 [0xFF8F]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER MA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30DE },
  ["unicodeslot"]=0xFF8F, -- ﾏ
 },
 [0xFF90]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER MI",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30DF },
  ["unicodeslot"]=0xFF90, -- ﾐ
 },
 [0xFF91]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER MU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30E0 },
  ["unicodeslot"]=0xFF91, -- ﾑ
 },
 [0xFF92]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER ME",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30E1 },
  ["unicodeslot"]=0xFF92, -- ﾒ
 },
 [0xFF93]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER MO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30E2 },
  ["unicodeslot"]=0xFF93, -- ﾓ
 },
 [0xFF94]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER YA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30E4 },
  ["unicodeslot"]=0xFF94, -- ﾔ
 },
 [0xFF95]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER YU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30E6 },
  ["unicodeslot"]=0xFF95, -- ﾕ
 },
 [0xFF96]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER YO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30E8 },
  ["unicodeslot"]=0xFF96, -- ﾖ
 },
 [0xFF97]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER RA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30E9 },
  ["unicodeslot"]=0xFF97, -- ﾗ
 },
 [0xFF98]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER RI",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30EA },
  ["unicodeslot"]=0xFF98, -- ﾘ
 },
 [0xFF99]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER RU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30EB },
  ["unicodeslot"]=0xFF99, -- ﾙ
 },
 [0xFF9A]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER RE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30EC },
  ["unicodeslot"]=0xFF9A, -- ﾚ
 },
 [0xFF9B]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER RO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30ED },
  ["unicodeslot"]=0xFF9B, -- ﾛ
 },
 [0xFF9C]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER WA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30EF },
  ["unicodeslot"]=0xFF9C, -- ﾜ
 },
 [0xFF9D]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA LETTER N",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x30F3 },
  ["unicodeslot"]=0xFF9D, -- ﾝ
 },
 [0xFF9E]={
  ["category"]="lm",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA VOICED SOUND MARK",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x3099 },
  ["unicodeslot"]=0xFF9E, -- ﾞ
 },
 [0xFF9F]={
  ["category"]="lm",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH KATAKANA SEMI-VOICED SOUND MARK",
  ["linebreak"]="ns",
  ["specials"]={ "narrow", 0x309A },
  ["unicodeslot"]=0xFF9F, -- ﾟ
 },
 [0xFFA0]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL FILLER",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3164 },
  ["unicodeslot"]=0xFFA0, -- ﾠ
 },
 [0xFFA1]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER KIYEOK",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3131 },
  ["unicodeslot"]=0xFFA1, -- ﾡ
 },
 [0xFFA2]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER SSANGKIYEOK",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3132 },
  ["unicodeslot"]=0xFFA2, -- ﾢ
 },
 [0xFFA3]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER KIYEOK-SIOS",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3133 },
  ["unicodeslot"]=0xFFA3, -- ﾣ
 },
 [0xFFA4]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER NIEUN",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3134 },
  ["unicodeslot"]=0xFFA4, -- ﾤ
 },
 [0xFFA5]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER NIEUN-CIEUC",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3135 },
  ["unicodeslot"]=0xFFA5, -- ﾥ
 },
 [0xFFA6]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER NIEUN-HIEUH",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3136 },
  ["unicodeslot"]=0xFFA6, -- ﾦ
 },
 [0xFFA7]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER TIKEUT",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3137 },
  ["unicodeslot"]=0xFFA7, -- ﾧ
 },
 [0xFFA8]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER SSANGTIKEUT",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3138 },
  ["unicodeslot"]=0xFFA8, -- ﾨ
 },
 [0xFFA9]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER RIEUL",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3139 },
  ["unicodeslot"]=0xFFA9, -- ﾩ
 },
 [0xFFAA]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER RIEUL-KIYEOK",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x313A },
  ["unicodeslot"]=0xFFAA, -- ﾪ
 },
 [0xFFAB]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER RIEUL-MIEUM",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x313B },
  ["unicodeslot"]=0xFFAB, -- ﾫ
 },
 [0xFFAC]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER RIEUL-PIEUP",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x313C },
  ["unicodeslot"]=0xFFAC, -- ﾬ
 },
 [0xFFAD]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER RIEUL-SIOS",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x313D },
  ["unicodeslot"]=0xFFAD, -- ﾭ
 },
 [0xFFAE]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER RIEUL-THIEUTH",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x313E },
  ["unicodeslot"]=0xFFAE, -- ﾮ
 },
 [0xFFAF]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER RIEUL-PHIEUPH",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x313F },
  ["unicodeslot"]=0xFFAF, -- ﾯ
 },
 [0xFFB0]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER RIEUL-HIEUH",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3140 },
  ["unicodeslot"]=0xFFB0, -- ﾰ
 },
 [0xFFB1]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER MIEUM",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3141 },
  ["unicodeslot"]=0xFFB1, -- ﾱ
 },
 [0xFFB2]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER PIEUP",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3142 },
  ["unicodeslot"]=0xFFB2, -- ﾲ
 },
 [0xFFB3]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER SSANGPIEUP",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3143 },
  ["unicodeslot"]=0xFFB3, -- ﾳ
 },
 [0xFFB4]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER PIEUP-SIOS",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3144 },
  ["unicodeslot"]=0xFFB4, -- ﾴ
 },
 [0xFFB5]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER SIOS",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3145 },
  ["unicodeslot"]=0xFFB5, -- ﾵ
 },
 [0xFFB6]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER SSANGSIOS",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3146 },
  ["unicodeslot"]=0xFFB6, -- ﾶ
 },
 [0xFFB7]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER IEUNG",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3147 },
  ["unicodeslot"]=0xFFB7, -- ﾷ
 },
 [0xFFB8]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER CIEUC",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3148 },
  ["unicodeslot"]=0xFFB8, -- ﾸ
 },
 [0xFFB9]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER SSANGCIEUC",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3149 },
  ["unicodeslot"]=0xFFB9, -- ﾹ
 },
 [0xFFBA]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER CHIEUCH",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x314A },
  ["unicodeslot"]=0xFFBA, -- ﾺ
 },
 [0xFFBB]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER KHIEUKH",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x314B },
  ["unicodeslot"]=0xFFBB, -- ﾻ
 },
 [0xFFBC]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER THIEUTH",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x314C },
  ["unicodeslot"]=0xFFBC, -- ﾼ
 },
 [0xFFBD]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER PHIEUPH",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x314D },
  ["unicodeslot"]=0xFFBD, -- ﾽ
 },
 [0xFFBE]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER HIEUH",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x314E },
  ["unicodeslot"]=0xFFBE, -- ﾾ
 },
 [0xFFC2]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER A",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x314F },
  ["unicodeslot"]=0xFFC2, -- ￂ
 },
 [0xFFC3]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER AE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3150 },
  ["unicodeslot"]=0xFFC3, -- ￃ
 },
 [0xFFC4]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER YA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3151 },
  ["unicodeslot"]=0xFFC4, -- ￄ
 },
 [0xFFC5]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER YAE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3152 },
  ["unicodeslot"]=0xFFC5, -- ￅ
 },
 [0xFFC6]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER EO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3153 },
  ["unicodeslot"]=0xFFC6, -- ￆ
 },
 [0xFFC7]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER E",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3154 },
  ["unicodeslot"]=0xFFC7, -- ￇ
 },
 [0xFFCA]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER YEO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3155 },
  ["unicodeslot"]=0xFFCA, -- ￊ
 },
 [0xFFCB]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER YE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3156 },
  ["unicodeslot"]=0xFFCB, -- ￋ
 },
 [0xFFCC]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER O",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3157 },
  ["unicodeslot"]=0xFFCC, -- ￌ
 },
 [0xFFCD]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER WA",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3158 },
  ["unicodeslot"]=0xFFCD, -- ￍ
 },
 [0xFFCE]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER WAE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3159 },
  ["unicodeslot"]=0xFFCE, -- ￎ
 },
 [0xFFCF]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER OE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x315A },
  ["unicodeslot"]=0xFFCF, -- ￏ
 },
 [0xFFD2]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER YO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x315B },
  ["unicodeslot"]=0xFFD2, -- ￒ
 },
 [0xFFD3]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER U",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x315C },
  ["unicodeslot"]=0xFFD3, -- ￓ
 },
 [0xFFD4]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER WEO",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x315D },
  ["unicodeslot"]=0xFFD4, -- ￔ
 },
 [0xFFD5]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER WE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x315E },
  ["unicodeslot"]=0xFFD5, -- ￕ
 },
 [0xFFD6]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER WI",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x315F },
  ["unicodeslot"]=0xFFD6, -- ￖ
 },
 [0xFFD7]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER YU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3160 },
  ["unicodeslot"]=0xFFD7, -- ￗ
 },
 [0xFFDA]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER EU",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3161 },
  ["unicodeslot"]=0xFFDA, -- ￚ
 },
 [0xFFDB]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER YI",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3162 },
  ["unicodeslot"]=0xFFDB, -- ￛ
 },
 [0xFFDC]={
  ["category"]="lo",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH HANGUL LETTER I",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x3163 },
  ["unicodeslot"]=0xFFDC, -- ￜ
 },
 [0xFFE0]={
  ["category"]="sc",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH CENT SIGN",
  ["linebreak"]="po",
  ["specials"]={ "wide", 0x00A2 },
  ["unicodeslot"]=0xFFE0, -- ￠
 },
 [0xFFE1]={
  ["category"]="sc",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH POUND SIGN",
  ["linebreak"]="pr",
  ["specials"]={ "wide", 0x00A3 },
  ["unicodeslot"]=0xFFE1, -- ￡
 },
 [0xFFE2]={
  ["category"]="sm",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH NOT SIGN",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x00AC },
  ["unicodeslot"]=0xFFE2, -- ￢
 },
 [0xFFE3]={
  ["category"]="sk",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH MACRON",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x00AF },
  ["unicodeslot"]=0xFFE3, -- ￣
 },
 [0xFFE4]={
  ["category"]="so",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH BROKEN BAR",
  ["linebreak"]="id",
  ["specials"]={ "wide", 0x00A6 },
  ["unicodeslot"]=0xFFE4, -- ￤
 },
 [0xFFE5]={
  ["category"]="sc",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH YEN SIGN",
  ["linebreak"]="pr",
  ["specials"]={ "wide", 0x00A5 },
  ["unicodeslot"]=0xFFE5, -- ￥
 },
 [0xFFE6]={
  ["category"]="sc",
  ["cjkwd"]="f",
  ["description"]="FULLWIDTH WON SIGN",
  ["linebreak"]="pr",
  ["specials"]={ "wide", 0x20A9 },
  ["unicodeslot"]=0xFFE6, -- ￦
 },
 [0xFFE8]={
  ["category"]="so",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH FORMS LIGHT VERTICAL",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x2502 },
  ["unicodeslot"]=0xFFE8, -- ￨
 },
 [0xFFE9]={
  ["category"]="sm",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH LEFTWARDS ARROW",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x2190 },
  ["unicodeslot"]=0xFFE9, -- ￩
 },
 [0xFFEA]={
  ["category"]="sm",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH UPWARDS ARROW",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x2191 },
  ["unicodeslot"]=0xFFEA, -- ￪
 },
 [0xFFEB]={
  ["category"]="sm",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH RIGHTWARDS ARROW",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x2192 },
  ["unicodeslot"]=0xFFEB, -- ￫
 },
 [0xFFEC]={
  ["category"]="sm",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH DOWNWARDS ARROW",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x2193 },
  ["unicodeslot"]=0xFFEC, -- ￬
 },
 [0xFFED]={
  ["category"]="so",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH BLACK SQUARE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x25A0 },
  ["unicodeslot"]=0xFFED, -- ￭
 },
 [0xFFEE]={
  ["category"]="so",
  ["cjkwd"]="h",
  ["description"]="HALFWIDTH WHITE CIRCLE",
  ["linebreak"]="al",
  ["specials"]={ "narrow", 0x25CB },
  ["unicodeslot"]=0xFFEE, -- ￮
 },
 [0xFFF9]={
  ["category"]="cf",
  ["description"]="INTERLINEAR ANNOTATION ANCHOR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFFF9, -- ￹
 },
 [0xFFFA]={
  ["category"]="cf",
  ["description"]="INTERLINEAR ANNOTATION SEPARATOR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFFFA, -- ￺
 },
 [0xFFFB]={
  ["category"]="cf",
  ["description"]="INTERLINEAR ANNOTATION TERMINATOR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xFFFB, -- ￻
 },
 [0xFFFC]={
  ["category"]="so",
  ["description"]="OBJECT REPLACEMENT CHARACTER",
  ["linebreak"]="cb",
  ["unicodeslot"]=0xFFFC, -- ￼
 },
 [0xFFFD]={
  ["category"]="so",
  ["cjkwd"]="a",
  ["description"]="REPLACEMENT CHARACTER",
  ["linebreak"]="ai",
  ["unicodeslot"]=0xFFFD, -- �
 },
 [0x10000]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0008 A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10000, -- 𐀀
 },
 [0x10001]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0026 E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10001, -- 𐀁
 },
 [0x10002]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x001C I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10002, -- 𐀂
 },
 [0x10003]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x003D O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10003, -- 𐀃
 },
 [0x10004]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x000A U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10004, -- 𐀄
 },
 [0x10005]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0001 DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10005, -- 𐀅
 },
 [0x10006]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x002D DE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10006, -- 𐀆
 },
 [0x10007]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0007 DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10007, -- 𐀇
 },
 [0x10008]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x000E DO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10008, -- 𐀈
 },
 [0x10009]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0033 DU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10009, -- 𐀉
 },
 [0x1000A]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0039 JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1000A, -- 𐀊
 },
 [0x1000B]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x002E JE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1000B, -- 𐀋
 },
 [0x1000D]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0024 JO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1000D, -- 𐀍
 },
 [0x1000E]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0041 JU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1000E, -- 𐀎
 },
 [0x1000F]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x004D KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1000F, -- 𐀏
 },
 [0x10010]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x002C KE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10010, -- 𐀐
 },
 [0x10011]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0043 KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10011, -- 𐀑
 },
 [0x10012]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0046 KO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10012, -- 𐀒
 },
 [0x10013]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0051 KU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10013, -- 𐀓
 },
 [0x10014]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0050 MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10014, -- 𐀔
 },
 [0x10015]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x000D ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10015, -- 𐀕
 },
 [0x10016]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0049 MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10016, -- 𐀖
 },
 [0x10017]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x000F MO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10017, -- 𐀗
 },
 [0x10018]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0017 MU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10018, -- 𐀘
 },
 [0x10019]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0006 NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10019, -- 𐀙
 },
 [0x1001A]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0018 NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1001A, -- 𐀚
 },
 [0x1001B]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x001E NI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1001B, -- 𐀛
 },
 [0x1001C]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0034 NO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1001C, -- 𐀜
 },
 [0x1001D]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0037 NU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1001D, -- 𐀝
 },
 [0x1001E]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0003 PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1001E, -- 𐀞
 },
 [0x1001F]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0048 PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1001F, -- 𐀟
 },
 [0x10020]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0027 PI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10020, -- 𐀠
 },
 [0x10021]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x000B PO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10021, -- 𐀡
 },
 [0x10022]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0032 PU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10022, -- 𐀢
 },
 [0x10023]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0010 QA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10023, -- 𐀣
 },
 [0x10024]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x004E QE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10024, -- 𐀤
 },
 [0x10025]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0015 QI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10025, -- 𐀥
 },
 [0x10026]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0020 QO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10026, -- 𐀦
 },
 [0x10028]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x003C RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10028, -- 𐀨
 },
 [0x10029]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x001B RE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10029, -- 𐀩
 },
 [0x1002A]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0035 RI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1002A, -- 𐀪
 },
 [0x1002B]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0002 RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1002B, -- 𐀫
 },
 [0x1002C]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x001A RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1002C, -- 𐀬
 },
 [0x1002D]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x001F SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1002D, -- 𐀭
 },
 [0x1002E]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0009 SE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1002E, -- 𐀮
 },
 [0x1002F]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0029 SI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1002F, -- 𐀯
 },
 [0x10030]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x000C SO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10030, -- 𐀰
 },
 [0x10031]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x003A SU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10031, -- 𐀱
 },
 [0x10032]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x003B TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10032, -- 𐀲
 },
 [0x10033]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0004 TE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10033, -- 𐀳
 },
 [0x10034]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0025 TI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10034, -- 𐀴
 },
 [0x10035]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0005 TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10035, -- 𐀵
 },
 [0x10036]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0045 TU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10036, -- 𐀶
 },
 [0x10037]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0036 WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10037, -- 𐀷
 },
 [0x10038]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x004B WE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10038, -- 𐀸
 },
 [0x10039]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0028 WI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10039, -- 𐀹
 },
 [0x1003A]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x002A WO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1003A, -- 𐀺
 },
 [0x1003C]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0011 ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1003C, -- 𐀼
 },
 [0x1003D]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x004A ZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1003D, -- 𐀽
 },
 [0x1003F]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0014 ZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1003F, -- 𐀿
 },
 [0x10040]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0019 A0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10040, -- 𐁀
 },
 [0x10041]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x002B A0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10041, -- 𐁁
 },
 [0x10042]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0055 AU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10042, -- 𐁂
 },
 [0x10043]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0047 DWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10043, -- 𐁃
 },
 [0x10044]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x005A DWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10044, -- 𐁄
 },
 [0x10045]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0030 NWA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10045, -- 𐁅
 },
 [0x10046]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x001D PU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10046, -- 𐁆
 },
 [0x10047]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x003E PTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10047, -- 𐁇
 },
 [0x10048]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x004C RA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10048, -- 𐁈
 },
 [0x10049]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0021 RA0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10049, -- 𐁉
 },
 [0x1004A]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0044 RO0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1004A, -- 𐁊
 },
 [0x1004B]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0042 TA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1004B, -- 𐁋
 },
 [0x1004C]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x0057 TWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1004C, -- 𐁌
 },
 [0x1004D]={
  ["category"]="lo",
  ["description"]="LINEAR B SYLLABLE B0x005B TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1004D, -- 𐁍
 },
 [0x10050]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0012",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10050, -- 𐁐
 },
 [0x10051]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0013",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10051, -- 𐁑
 },
 [0x10052]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0016",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10052, -- 𐁒
 },
 [0x10053]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0022",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10053, -- 𐁓
 },
 [0x10054]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x002F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10054, -- 𐁔
 },
 [0x10055]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0031",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10055, -- 𐁕
 },
 [0x10056]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0038",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10056, -- 𐁖
 },
 [0x10057]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x003F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10057, -- 𐁗
 },
 [0x10058]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0040",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10058, -- 𐁘
 },
 [0x10059]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x004F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10059, -- 𐁙
 },
 [0x1005A]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0052",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1005A, -- 𐁚
 },
 [0x1005B]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0053",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1005B, -- 𐁛
 },
 [0x1005C]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0056",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1005C, -- 𐁜
 },
 [0x1005D]={
  ["category"]="lo",
  ["description"]="LINEAR B SYMBOL B0x0059",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1005D, -- 𐁝
 },
 [0x10080]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0064 MAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10080, -- 𐂀
 },
 [0x10081]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0066 WOMAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10081, -- 𐂁
 },
 [0x10082]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0068 DEER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10082, -- 𐂂
 },
 [0x10083]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0069 EQUID",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10083, -- 𐂃
 },
 [0x10084]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0069F MARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10084, -- 𐂄
 },
 [0x10085]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0069M STALLION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10085, -- 𐂅
 },
 [0x10086]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x006AF EWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10086, -- 𐂆
 },
 [0x10087]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x006AM RAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10087, -- 𐂇
 },
 [0x10088]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x006BF SHE-GOAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10088, -- 𐂈
 },
 [0x10089]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x006BM HE-GOAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10089, -- 𐂉
 },
 [0x1008A]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x006CF SOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1008A, -- 𐂊
 },
 [0x1008B]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x006CM BOAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1008B, -- 𐂋
 },
 [0x1008C]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x006DF COW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1008C, -- 𐂌
 },
 [0x1008D]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x006DM BULL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1008D, -- 𐂍
 },
 [0x1008E]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0078 WHEAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1008E, -- 𐂎
 },
 [0x1008F]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0079 BARLEY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1008F, -- 𐂏
 },
 [0x10090]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x007A OLIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10090, -- 𐂐
 },
 [0x10091]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x007B SPICE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10091, -- 𐂑
 },
 [0x10092]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x007D CYPERUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10092, -- 𐂒
 },
 [0x10093]={
  ["category"]="lo",
  ["description"]="LINEAR B MONOGRAM B0x007F KAPO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10093, -- 𐂓
 },
 [0x10094]={
  ["category"]="lo",
  ["description"]="LINEAR B MONOGRAM B0x0080 KANAKO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10094, -- 𐂔
 },
 [0x10095]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0082 OIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10095, -- 𐂕
 },
 [0x10096]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0083 WINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10096, -- 𐂖
 },
 [0x10097]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0084",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10097, -- 𐂗
 },
 [0x10098]={
  ["category"]="lo",
  ["description"]="LINEAR B MONOGRAM B0x0085 AREPA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10098, -- 𐂘
 },
 [0x10099]={
  ["category"]="lo",
  ["description"]="LINEAR B MONOGRAM B0x0087 MERI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10099, -- 𐂙
 },
 [0x1009A]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x008C BRONZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1009A, -- 𐂚
 },
 [0x1009B]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x008D GOLD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1009B, -- 𐂛
 },
 [0x1009C]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x008E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1009C, -- 𐂜
 },
 [0x1009D]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0091 WOOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1009D, -- 𐂝
 },
 [0x1009E]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0092",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1009E, -- 𐂞
 },
 [0x1009F]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0096",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1009F, -- 𐂟
 },
 [0x100A0]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0097 HORN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A0, -- 𐂠
 },
 [0x100A1]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0098",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A1, -- 𐂡
 },
 [0x100A2]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0099",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A2, -- 𐂢
 },
 [0x100A3]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x009A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A3, -- 𐂣
 },
 [0x100A4]={
  ["category"]="lo",
  ["description"]="LINEAR B MONOGRAM B0x009C TURO0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A4, -- 𐂤
 },
 [0x100A5]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x009D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A5, -- 𐂥
 },
 [0x100A6]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x009E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A6, -- 𐂦
 },
 [0x100A7]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x009F CLOTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A7, -- 𐂧
 },
 [0x100A8]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A0",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A8, -- 𐂨
 },
 [0x100A9]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A1",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100A9, -- 𐂩
 },
 [0x100AA]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A2 GARMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100AA, -- 𐂪
 },
 [0x100AB]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A3 ARMOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100AB, -- 𐂫
 },
 [0x100AC]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A4",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100AC, -- 𐂬
 },
 [0x100AD]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A5",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100AD, -- 𐂭
 },
 [0x100AE]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100AE, -- 𐂮
 },
 [0x100AF]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A7",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100AF, -- 𐂯
 },
 [0x100B0]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B0, -- 𐂰
 },
 [0x100B1]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00A9",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B1, -- 𐂱
 },
 [0x100B2]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B2, -- 𐂲
 },
 [0x100B3]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00AB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B3, -- 𐂳
 },
 [0x100B4]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00AC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B4, -- 𐂴
 },
 [0x100B5]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00AD MONTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B5, -- 𐂵
 },
 [0x100B6]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00AE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B6, -- 𐂶
 },
 [0x100B7]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B0 TREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B7, -- 𐂷
 },
 [0x100B8]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B1",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B8, -- 𐂸
 },
 [0x100B9]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100B9, -- 𐂹
 },
 [0x100BA]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B3",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100BA, -- 𐂺
 },
 [0x100BB]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B4",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100BB, -- 𐂻
 },
 [0x100BC]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B5",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100BC, -- 𐂼
 },
 [0x100BD]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100BD, -- 𐂽
 },
 [0x100BE]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B7",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100BE, -- 𐂾
 },
 [0x100BF]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100BF, -- 𐂿
 },
 [0x100C0]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00B9",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C0, -- 𐃀
 },
 [0x100C1]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00BD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C1, -- 𐃁
 },
 [0x100C2]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00BE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C2, -- 𐃂
 },
 [0x100C3]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00BF HELMET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C3, -- 𐃃
 },
 [0x100C4]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00DC FOOTSTOOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C4, -- 𐃄
 },
 [0x100C5]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00E1 BATHTUB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C5, -- 𐃅
 },
 [0x100C6]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00E6 SPEAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C6, -- 𐃆
 },
 [0x100C7]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00E7 ARROW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C7, -- 𐃇
 },
 [0x100C8]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00E8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C8, -- 𐃈
 },
 [0x100C9]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00E9 SWORD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100C9, -- 𐃉
 },
 [0x100CA]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00EA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100CA, -- 𐃊
 },
 [0x100CB]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00EC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100CB, -- 𐃋
 },
 [0x100CC]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00F0 WHEELED CHARIOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100CC, -- 𐃌
 },
 [0x100CD]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00F1 CHARIOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100CD, -- 𐃍
 },
 [0x100CE]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00F2 CHARIOT FRAME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100CE, -- 𐃎
 },
 [0x100CF]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00F3 WHEEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100CF, -- 𐃏
 },
 [0x100D0]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00F5",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D0, -- 𐃐
 },
 [0x100D1]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00F6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D1, -- 𐃑
 },
 [0x100D2]={
  ["category"]="lo",
  ["description"]="LINEAR B MONOGRAM B0x00F7 DIPTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D2, -- 𐃒
 },
 [0x100D3]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00F8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D3, -- 𐃓
 },
 [0x100D4]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00F9",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D4, -- 𐃔
 },
 [0x100D5]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00FB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D5, -- 𐃕
 },
 [0x100D6]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00FC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D6, -- 𐃖
 },
 [0x100D7]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00FD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D7, -- 𐃗
 },
 [0x100D8]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00FE DART",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D8, -- 𐃘
 },
 [0x100D9]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x00FF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100D9, -- 𐃙
 },
 [0x100DA]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0100",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100DA, -- 𐃚
 },
 [0x100DB]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0101",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100DB, -- 𐃛
 },
 [0x100DC]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0102",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100DC, -- 𐃜
 },
 [0x100DD]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM B0x0103",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100DD, -- 𐃝
 },
 [0x100DE]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x009B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100DE, -- 𐃞
 },
 [0x100DF]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00C8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100DF, -- 𐃟
 },
 [0x100E0]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00C9",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E0, -- 𐃠
 },
 [0x100E1]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E1, -- 𐃡
 },
 [0x100E2]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00CB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E2, -- 𐃢
 },
 [0x100E3]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00CC",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E3, -- 𐃣
 },
 [0x100E4]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00CD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E4, -- 𐃤
 },
 [0x100E5]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00CE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E5, -- 𐃥
 },
 [0x100E6]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00CF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E6, -- 𐃦
 },
 [0x100E7]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D0",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E7, -- 𐃧
 },
 [0x100E8]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D1",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E8, -- 𐃨
 },
 [0x100E9]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100E9, -- 𐃩
 },
 [0x100EA]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D3",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100EA, -- 𐃪
 },
 [0x100EB]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D4",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100EB, -- 𐃫
 },
 [0x100EC]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D5",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100EC, -- 𐃬
 },
 [0x100ED]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D6",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100ED, -- 𐃭
 },
 [0x100EE]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D7",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100EE, -- 𐃮
 },
 [0x100EF]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D8",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100EF, -- 𐃯
 },
 [0x100F0]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00D9",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F0, -- 𐃰
 },
 [0x100F1]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F1, -- 𐃱
 },
 [0x100F2]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00DB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F2, -- 𐃲
 },
 [0x100F3]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00DD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F3, -- 𐃳
 },
 [0x100F4]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00DE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F4, -- 𐃴
 },
 [0x100F5]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00E2",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F5, -- 𐃵
 },
 [0x100F6]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00E3",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F6, -- 𐃶
 },
 [0x100F7]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00E4",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F7, -- 𐃷
 },
 [0x100F8]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00E5",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F8, -- 𐃸
 },
 [0x100F9]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x00FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100F9, -- 𐃹
 },
 [0x100FA]={
  ["category"]="lo",
  ["description"]="LINEAR B IDEOGRAM VESSEL B0x0131",
  ["linebreak"]="al",
  ["unicodeslot"]=0x100FA, -- 𐃺
 },
 [0x10100]={
  ["category"]="po",
  ["description"]="AEGEAN WORD SEPARATOR LINE",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10100, -- 𐄀
 },
 [0x10101]={
  ["category"]="po",
  ["description"]="AEGEAN WORD SEPARATOR DOT",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10101, -- 𐄁
 },
 [0x10102]={
  ["category"]="so",
  ["description"]="AEGEAN CHECK MARK",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10102, -- 𐄂
 },
 [0x10107]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10107, -- 𐄇
 },
 [0x10108]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10108, -- 𐄈
 },
 [0x10109]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER THREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10109, -- 𐄉
 },
 [0x1010A]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1010A, -- 𐄊
 },
 [0x1010B]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1010B, -- 𐄋
 },
 [0x1010C]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SIX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1010C, -- 𐄌
 },
 [0x1010D]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SEVEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1010D, -- 𐄍
 },
 [0x1010E]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER EIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1010E, -- 𐄎
 },
 [0x1010F]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER NINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1010F, -- 𐄏
 },
 [0x10110]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10110, -- 𐄐
 },
 [0x10111]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER TWENTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10111, -- 𐄑
 },
 [0x10112]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER THIRTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10112, -- 𐄒
 },
 [0x10113]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FORTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10113, -- 𐄓
 },
 [0x10114]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FIFTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10114, -- 𐄔
 },
 [0x10115]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SIXTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10115, -- 𐄕
 },
 [0x10116]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SEVENTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10116, -- 𐄖
 },
 [0x10117]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER EIGHTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10117, -- 𐄗
 },
 [0x10118]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER NINETY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10118, -- 𐄘
 },
 [0x10119]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER ONE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10119, -- 𐄙
 },
 [0x1011A]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER TWO HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1011A, -- 𐄚
 },
 [0x1011B]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER THREE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1011B, -- 𐄛
 },
 [0x1011C]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FOUR HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1011C, -- 𐄜
 },
 [0x1011D]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FIVE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1011D, -- 𐄝
 },
 [0x1011E]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SIX HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1011E, -- 𐄞
 },
 [0x1011F]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SEVEN HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1011F, -- 𐄟
 },
 [0x10120]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER EIGHT HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10120, -- 𐄠
 },
 [0x10121]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER NINE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10121, -- 𐄡
 },
 [0x10122]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER ONE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10122, -- 𐄢
 },
 [0x10123]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER TWO THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10123, -- 𐄣
 },
 [0x10124]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER THREE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10124, -- 𐄤
 },
 [0x10125]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FOUR THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10125, -- 𐄥
 },
 [0x10126]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FIVE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10126, -- 𐄦
 },
 [0x10127]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SIX THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10127, -- 𐄧
 },
 [0x10128]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SEVEN THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10128, -- 𐄨
 },
 [0x10129]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER EIGHT THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10129, -- 𐄩
 },
 [0x1012A]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER NINE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1012A, -- 𐄪
 },
 [0x1012B]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER TEN THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1012B, -- 𐄫
 },
 [0x1012C]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER TWENTY THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1012C, -- 𐄬
 },
 [0x1012D]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER THIRTY THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1012D, -- 𐄭
 },
 [0x1012E]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FORTY THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1012E, -- 𐄮
 },
 [0x1012F]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER FIFTY THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1012F, -- 𐄯
 },
 [0x10130]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SIXTY THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10130, -- 𐄰
 },
 [0x10131]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER SEVENTY THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10131, -- 𐄱
 },
 [0x10132]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER EIGHTY THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10132, -- 𐄲
 },
 [0x10133]={
  ["category"]="no",
  ["description"]="AEGEAN NUMBER NINETY THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10133, -- 𐄳
 },
 [0x10137]={
  ["category"]="so",
  ["description"]="AEGEAN WEIGHT BASE UNIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10137, -- 𐄷
 },
 [0x10138]={
  ["category"]="so",
  ["description"]="AEGEAN WEIGHT FIRST SUBUNIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10138, -- 𐄸
 },
 [0x10139]={
  ["category"]="so",
  ["description"]="AEGEAN WEIGHT SECOND SUBUNIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10139, -- 𐄹
 },
 [0x1013A]={
  ["category"]="so",
  ["description"]="AEGEAN WEIGHT THIRD SUBUNIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1013A, -- 𐄺
 },
 [0x1013B]={
  ["category"]="so",
  ["description"]="AEGEAN WEIGHT FOURTH SUBUNIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1013B, -- 𐄻
 },
 [0x1013C]={
  ["category"]="so",
  ["description"]="AEGEAN DRY MEASURE FIRST SUBUNIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1013C, -- 𐄼
 },
 [0x1013D]={
  ["category"]="so",
  ["description"]="AEGEAN LIQUID MEASURE FIRST SUBUNIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1013D, -- 𐄽
 },
 [0x1013E]={
  ["category"]="so",
  ["description"]="AEGEAN MEASURE SECOND SUBUNIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1013E, -- 𐄾
 },
 [0x1013F]={
  ["category"]="so",
  ["description"]="AEGEAN MEASURE THIRD SUBUNIT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1013F, -- 𐄿
 },
 [0x10140]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC ONE QUARTER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10140, -- 𐅀
 },
 [0x10141]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC ONE HALF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10141, -- 𐅁
 },
 [0x10142]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC ONE DRACHMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10142, -- 𐅂
 },
 [0x10143]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10143, -- 𐅃
 },
 [0x10144]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIFTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10144, -- 𐅄
 },
 [0x10145]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIVE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10145, -- 𐅅
 },
 [0x10146]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIVE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10146, -- 𐅆
 },
 [0x10147]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIFTY THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10147, -- 𐅇
 },
 [0x10148]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIVE TALENTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10148, -- 𐅈
 },
 [0x10149]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC TEN TALENTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10149, -- 𐅉
 },
 [0x1014A]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIFTY TALENTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1014A, -- 𐅊
 },
 [0x1014B]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC ONE HUNDRED TALENTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1014B, -- 𐅋
 },
 [0x1014C]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIVE HUNDRED TALENTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1014C, -- 𐅌
 },
 [0x1014D]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC ONE THOUSAND TALENTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1014D, -- 𐅍
 },
 [0x1014E]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIVE THOUSAND TALENTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1014E, -- 𐅎
 },
 [0x1014F]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIVE STATERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1014F, -- 𐅏
 },
 [0x10150]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC TEN STATERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10150, -- 𐅐
 },
 [0x10151]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIFTY STATERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10151, -- 𐅑
 },
 [0x10152]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC ONE HUNDRED STATERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10152, -- 𐅒
 },
 [0x10153]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIVE HUNDRED STATERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10153, -- 𐅓
 },
 [0x10154]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC ONE THOUSAND STATERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10154, -- 𐅔
 },
 [0x10155]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC TEN THOUSAND STATERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10155, -- 𐅕
 },
 [0x10156]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC FIFTY THOUSAND STATERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10156, -- 𐅖
 },
 [0x10157]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC ATTIC TEN MNAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10157, -- 𐅗
 },
 [0x10158]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC HERAEUM ONE PLETHRON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10158, -- 𐅘
 },
 [0x10159]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10159, -- 𐅙
 },
 [0x1015A]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC HERMIONIAN ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1015A, -- 𐅚
 },
 [0x1015B]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC EPIDAUREAN TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1015B, -- 𐅛
 },
 [0x1015C]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1015C, -- 𐅜
 },
 [0x1015D]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC CYRENAIC TWO DRACHMAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1015D, -- 𐅝
 },
 [0x1015E]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC EPIDAUREAN TWO DRACHMAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1015E, -- 𐅞
 },
 [0x1015F]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC TROEZENIAN FIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1015F, -- 𐅟
 },
 [0x10160]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC TROEZENIAN TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10160, -- 𐅠
 },
 [0x10161]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC TROEZENIAN TEN ALTERNATE FORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10161, -- 𐅡
 },
 [0x10162]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC HERMIONIAN TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10162, -- 𐅢
 },
 [0x10163]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC MESSENIAN TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10163, -- 𐅣
 },
 [0x10164]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10164, -- 𐅤
 },
 [0x10165]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN THIRTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10165, -- 𐅥
 },
 [0x10166]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC TROEZENIAN FIFTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10166, -- 𐅦
 },
 [0x10167]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC TROEZENIAN FIFTY ALTERNATE FORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10167, -- 𐅧
 },
 [0x10168]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC HERMIONIAN FIFTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10168, -- 𐅨
 },
 [0x10169]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN FIFTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10169, -- 𐅩
 },
 [0x1016A]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN ONE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1016A, -- 𐅪
 },
 [0x1016B]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN THREE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1016B, -- 𐅫
 },
 [0x1016C]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC EPIDAUREAN FIVE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1016C, -- 𐅬
 },
 [0x1016D]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC TROEZENIAN FIVE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1016D, -- 𐅭
 },
 [0x1016E]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN FIVE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1016E, -- 𐅮
 },
 [0x1016F]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC CARYSTIAN FIVE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1016F, -- 𐅯
 },
 [0x10170]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC NAXIAN FIVE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10170, -- 𐅰
 },
 [0x10171]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN ONE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10171, -- 𐅱
 },
 [0x10172]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC THESPIAN FIVE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10172, -- 𐅲
 },
 [0x10173]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC DELPHIC FIVE MNAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10173, -- 𐅳
 },
 [0x10174]={
  ["category"]="nl",
  ["description"]="GREEK ACROPHONIC STRATIAN FIFTY MNAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10174, -- 𐅴
 },
 [0x10175]={
  ["category"]="no",
  ["description"]="GREEK ONE HALF SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10175, -- 𐅵
 },
 [0x10176]={
  ["category"]="no",
  ["description"]="GREEK ONE HALF SIGN ALTERNATE FORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10176, -- 𐅶
 },
 [0x10177]={
  ["category"]="no",
  ["description"]="GREEK TWO THIRDS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10177, -- 𐅷
 },
 [0x10178]={
  ["category"]="no",
  ["description"]="GREEK THREE QUARTERS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10178, -- 𐅸
 },
 [0x10179]={
  ["category"]="so",
  ["description"]="GREEK YEAR SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10179, -- 𐅹
 },
 [0x1017A]={
  ["category"]="so",
  ["description"]="GREEK TALENT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1017A, -- 𐅺
 },
 [0x1017B]={
  ["category"]="so",
  ["description"]="GREEK DRACHMA SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1017B, -- 𐅻
 },
 [0x1017C]={
  ["category"]="so",
  ["description"]="GREEK OBOL SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1017C, -- 𐅼
 },
 [0x1017D]={
  ["category"]="so",
  ["description"]="GREEK TWO OBOLS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1017D, -- 𐅽
 },
 [0x1017E]={
  ["category"]="so",
  ["description"]="GREEK THREE OBOLS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1017E, -- 𐅾
 },
 [0x1017F]={
  ["category"]="so",
  ["description"]="GREEK FOUR OBOLS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1017F, -- 𐅿
 },
 [0x10180]={
  ["category"]="so",
  ["description"]="GREEK FIVE OBOLS SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10180, -- 𐆀
 },
 [0x10181]={
  ["category"]="so",
  ["description"]="GREEK METRETES SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10181, -- 𐆁
 },
 [0x10182]={
  ["category"]="so",
  ["description"]="GREEK KYATHOS BASE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10182, -- 𐆂
 },
 [0x10183]={
  ["category"]="so",
  ["description"]="GREEK LITRA SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10183, -- 𐆃
 },
 [0x10184]={
  ["category"]="so",
  ["description"]="GREEK OUNKIA SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10184, -- 𐆄
 },
 [0x10185]={
  ["category"]="so",
  ["description"]="GREEK XESTES SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10185, -- 𐆅
 },
 [0x10186]={
  ["category"]="so",
  ["description"]="GREEK ARTABE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10186, -- 𐆆
 },
 [0x10187]={
  ["category"]="so",
  ["description"]="GREEK AROURA SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10187, -- 𐆇
 },
 [0x10188]={
  ["category"]="so",
  ["description"]="GREEK GRAMMA SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10188, -- 𐆈
 },
 [0x10189]={
  ["category"]="so",
  ["description"]="GREEK TRYBLION BASE SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10189, -- 𐆉
 },
 [0x1018A]={
  ["category"]="no",
  ["description"]="GREEK ZERO SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1018A, -- 𐆊
 },
 [0x10300]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10300, -- 𐌀
 },
 [0x10301]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER BE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10301, -- 𐌁
 },
 [0x10302]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER KE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10302, -- 𐌂
 },
 [0x10303]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER DE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10303, -- 𐌃
 },
 [0x10304]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10304, -- 𐌄
 },
 [0x10305]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER VE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10305, -- 𐌅
 },
 [0x10306]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER ZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10306, -- 𐌆
 },
 [0x10307]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10307, -- 𐌇
 },
 [0x10308]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER THE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10308, -- 𐌈
 },
 [0x10309]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10309, -- 𐌉
 },
 [0x1030A]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1030A, -- 𐌊
 },
 [0x1030B]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER EL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1030B, -- 𐌋
 },
 [0x1030C]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER EM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1030C, -- 𐌌
 },
 [0x1030D]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1030D, -- 𐌍
 },
 [0x1030E]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER ESH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1030E, -- 𐌎
 },
 [0x1030F]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1030F, -- 𐌏
 },
 [0x10310]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10310, -- 𐌐
 },
 [0x10311]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10311, -- 𐌑
 },
 [0x10312]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER KU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10312, -- 𐌒
 },
 [0x10313]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER ER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10313, -- 𐌓
 },
 [0x10314]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER ES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10314, -- 𐌔
 },
 [0x10315]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER TE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10315, -- 𐌕
 },
 [0x10316]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10316, -- 𐌖
 },
 [0x10317]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER EKS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10317, -- 𐌗
 },
 [0x10318]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER PHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10318, -- 𐌘
 },
 [0x10319]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER KHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10319, -- 𐌙
 },
 [0x1031A]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER EF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1031A, -- 𐌚
 },
 [0x1031B]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER ERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1031B, -- 𐌛
 },
 [0x1031C]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER CHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1031C, -- 𐌜
 },
 [0x1031D]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER II",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1031D, -- 𐌝
 },
 [0x1031E]={
  ["category"]="lo",
  ["description"]="OLD ITALIC LETTER UU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1031E, -- 𐌞
 },
 [0x10320]={
  ["category"]="no",
  ["description"]="OLD ITALIC NUMERAL ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10320, -- 𐌠
 },
 [0x10321]={
  ["category"]="no",
  ["description"]="OLD ITALIC NUMERAL FIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10321, -- 𐌡
 },
 [0x10322]={
  ["category"]="no",
  ["description"]="OLD ITALIC NUMERAL TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10322, -- 𐌢
 },
 [0x10323]={
  ["category"]="no",
  ["description"]="OLD ITALIC NUMERAL FIFTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10323, -- 𐌣
 },
 [0x10330]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER AHSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10330, -- 𐌰
 },
 [0x10331]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER BAIRKAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10331, -- 𐌱
 },
 [0x10332]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER GIBA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10332, -- 𐌲
 },
 [0x10333]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER DAGS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10333, -- 𐌳
 },
 [0x10334]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER AIHVUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10334, -- 𐌴
 },
 [0x10335]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER QAIRTHRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10335, -- 𐌵
 },
 [0x10336]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER IUJA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10336, -- 𐌶
 },
 [0x10337]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER HAGL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10337, -- 𐌷
 },
 [0x10338]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER THIUTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10338, -- 𐌸
 },
 [0x10339]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER EIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10339, -- 𐌹
 },
 [0x1033A]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER KUSMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1033A, -- 𐌺
 },
 [0x1033B]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER LAGUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1033B, -- 𐌻
 },
 [0x1033C]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER MANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1033C, -- 𐌼
 },
 [0x1033D]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER NAUTHS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1033D, -- 𐌽
 },
 [0x1033E]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER JER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1033E, -- 𐌾
 },
 [0x1033F]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER URUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1033F, -- 𐌿
 },
 [0x10340]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER PAIRTHRA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10340, -- 𐍀
 },
 [0x10341]={
  ["category"]="nl",
  ["description"]="GOTHIC LETTER NINETY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10341, -- 𐍁
 },
 [0x10342]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER RAIDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10342, -- 𐍂
 },
 [0x10343]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER SAUIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10343, -- 𐍃
 },
 [0x10344]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER TEIWS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10344, -- 𐍄
 },
 [0x10345]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER WINJA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10345, -- 𐍅
 },
 [0x10346]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER FAIHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10346, -- 𐍆
 },
 [0x10347]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER IGGWS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10347, -- 𐍇
 },
 [0x10348]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER HWAIR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10348, -- 𐍈
 },
 [0x10349]={
  ["category"]="lo",
  ["description"]="GOTHIC LETTER OTHAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10349, -- 𐍉
 },
 [0x1034A]={
  ["category"]="nl",
  ["description"]="GOTHIC LETTER NINE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1034A, -- 𐍊
 },
 [0x10380]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER ALPA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10380, -- 𐎀
 },
 [0x10381]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER BETA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10381, -- 𐎁
 },
 [0x10382]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER GAMLA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10382, -- 𐎂
 },
 [0x10383]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10383, -- 𐎃
 },
 [0x10384]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER DELTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10384, -- 𐎄
 },
 [0x10385]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER HO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10385, -- 𐎅
 },
 [0x10386]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER WO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10386, -- 𐎆
 },
 [0x10387]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER ZETA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10387, -- 𐎇
 },
 [0x10388]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER HOTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10388, -- 𐎈
 },
 [0x10389]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER TET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10389, -- 𐎉
 },
 [0x1038A]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER YOD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1038A, -- 𐎊
 },
 [0x1038B]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER KAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1038B, -- 𐎋
 },
 [0x1038C]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER SHIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1038C, -- 𐎌
 },
 [0x1038D]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER LAMDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1038D, -- 𐎍
 },
 [0x1038E]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER MEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1038E, -- 𐎎
 },
 [0x1038F]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER DHAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1038F, -- 𐎏
 },
 [0x10390]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10390, -- 𐎐
 },
 [0x10391]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER ZU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10391, -- 𐎑
 },
 [0x10392]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER SAMKA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10392, -- 𐎒
 },
 [0x10393]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER AIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10393, -- 𐎓
 },
 [0x10394]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER PU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10394, -- 𐎔
 },
 [0x10395]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER SADE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10395, -- 𐎕
 },
 [0x10396]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER QOPA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10396, -- 𐎖
 },
 [0x10397]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER RASHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10397, -- 𐎗
 },
 [0x10398]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER THANNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10398, -- 𐎘
 },
 [0x10399]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER GHAIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10399, -- 𐎙
 },
 [0x1039A]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1039A, -- 𐎚
 },
 [0x1039B]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1039B, -- 𐎛
 },
 [0x1039C]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1039C, -- 𐎜
 },
 [0x1039D]={
  ["category"]="lo",
  ["description"]="UGARITIC LETTER SSU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1039D, -- 𐎝
 },
 [0x1039F]={
  ["category"]="po",
  ["description"]="UGARITIC WORD DIVIDER",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1039F, -- 𐎟
 },
 [0x103A0]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A0, -- 𐎠
 },
 [0x103A1]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A1, -- 𐎡
 },
 [0x103A2]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A2, -- 𐎢
 },
 [0x103A3]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A3, -- 𐎣
 },
 [0x103A4]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN KU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A4, -- 𐎤
 },
 [0x103A5]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A5, -- 𐎥
 },
 [0x103A6]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN GU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A6, -- 𐎦
 },
 [0x103A7]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN XA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A7, -- 𐎧
 },
 [0x103A8]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A8, -- 𐎨
 },
 [0x103A9]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103A9, -- 𐎩
 },
 [0x103AA]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN JI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103AA, -- 𐎪
 },
 [0x103AB]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103AB, -- 𐎫
 },
 [0x103AC]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN TU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103AC, -- 𐎬
 },
 [0x103AD]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103AD, -- 𐎭
 },
 [0x103AE]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103AE, -- 𐎮
 },
 [0x103AF]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN DU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103AF, -- 𐎯
 },
 [0x103B0]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B0, -- 𐎰
 },
 [0x103B1]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B1, -- 𐎱
 },
 [0x103B2]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B2, -- 𐎲
 },
 [0x103B3]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B3, -- 𐎳
 },
 [0x103B4]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B4, -- 𐎴
 },
 [0x103B5]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN NU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B5, -- 𐎵
 },
 [0x103B6]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B6, -- 𐎶
 },
 [0x103B7]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B7, -- 𐎷
 },
 [0x103B8]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN MU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B8, -- 𐎸
 },
 [0x103B9]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103B9, -- 𐎹
 },
 [0x103BA]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103BA, -- 𐎺
 },
 [0x103BB]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN VI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103BB, -- 𐎻
 },
 [0x103BC]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103BC, -- 𐎼
 },
 [0x103BD]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103BD, -- 𐎽
 },
 [0x103BE]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103BE, -- 𐎾
 },
 [0x103BF]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103BF, -- 𐎿
 },
 [0x103C0]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103C0, -- 𐏀
 },
 [0x103C1]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103C1, -- 𐏁
 },
 [0x103C2]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103C2, -- 𐏂
 },
 [0x103C3]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103C3, -- 𐏃
 },
 [0x103C8]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN AURAMAZDAA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103C8, -- 𐏈
 },
 [0x103C9]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN AURAMAZDAA-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103C9, -- 𐏉
 },
 [0x103CA]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN AURAMAZDAAHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103CA, -- 𐏊
 },
 [0x103CB]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN XSHAAYATHIYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103CB, -- 𐏋
 },
 [0x103CC]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN DAHYAAUSH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103CC, -- 𐏌
 },
 [0x103CD]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN DAHYAAUSH-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103CD, -- 𐏍
 },
 [0x103CE]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN BAGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103CE, -- 𐏎
 },
 [0x103CF]={
  ["category"]="lo",
  ["description"]="OLD PERSIAN SIGN BUUMISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103CF, -- 𐏏
 },
 [0x103D0]={
  ["category"]="po",
  ["description"]="OLD PERSIAN WORD DIVIDER",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x103D0, -- 𐏐
 },
 [0x103D1]={
  ["category"]="nl",
  ["description"]="OLD PERSIAN NUMBER ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103D1, -- 𐏑
 },
 [0x103D2]={
  ["category"]="nl",
  ["description"]="OLD PERSIAN NUMBER TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103D2, -- 𐏒
 },
 [0x103D3]={
  ["category"]="nl",
  ["description"]="OLD PERSIAN NUMBER TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103D3, -- 𐏓
 },
 [0x103D4]={
  ["category"]="nl",
  ["description"]="OLD PERSIAN NUMBER TWENTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103D4, -- 𐏔
 },
 [0x103D5]={
  ["category"]="nl",
  ["description"]="OLD PERSIAN NUMBER HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x103D5, -- 𐏕
 },
 [0x10400]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER LONG I",
  ["lccode"]=0x10428,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10400, -- 𐐀
 },
 [0x10401]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER LONG E",
  ["lccode"]=0x10429,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10401, -- 𐐁
 },
 [0x10402]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER LONG A",
  ["lccode"]=0x1042A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10402, -- 𐐂
 },
 [0x10403]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER LONG AH",
  ["lccode"]=0x1042B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10403, -- 𐐃
 },
 [0x10404]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER LONG O",
  ["lccode"]=0x1042C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10404, -- 𐐄
 },
 [0x10405]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER LONG OO",
  ["lccode"]=0x1042D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10405, -- 𐐅
 },
 [0x10406]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER SHORT I",
  ["lccode"]=0x1042E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10406, -- 𐐆
 },
 [0x10407]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER SHORT E",
  ["lccode"]=0x1042F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10407, -- 𐐇
 },
 [0x10408]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER SHORT A",
  ["lccode"]=0x10430,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10408, -- 𐐈
 },
 [0x10409]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER SHORT AH",
  ["lccode"]=0x10431,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10409, -- 𐐉
 },
 [0x1040A]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER SHORT O",
  ["lccode"]=0x10432,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1040A, -- 𐐊
 },
 [0x1040B]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER SHORT OO",
  ["lccode"]=0x10433,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1040B, -- 𐐋
 },
 [0x1040C]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER AY",
  ["lccode"]=0x10434,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1040C, -- 𐐌
 },
 [0x1040D]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER OW",
  ["lccode"]=0x10435,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1040D, -- 𐐍
 },
 [0x1040E]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER WU",
  ["lccode"]=0x10436,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1040E, -- 𐐎
 },
 [0x1040F]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER YEE",
  ["lccode"]=0x10437,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1040F, -- 𐐏
 },
 [0x10410]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER H",
  ["lccode"]=0x10438,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10410, -- 𐐐
 },
 [0x10411]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER PEE",
  ["lccode"]=0x10439,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10411, -- 𐐑
 },
 [0x10412]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER BEE",
  ["lccode"]=0x1043A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10412, -- 𐐒
 },
 [0x10413]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER TEE",
  ["lccode"]=0x1043B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10413, -- 𐐓
 },
 [0x10414]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER DEE",
  ["lccode"]=0x1043C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10414, -- 𐐔
 },
 [0x10415]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER CHEE",
  ["lccode"]=0x1043D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10415, -- 𐐕
 },
 [0x10416]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER JEE",
  ["lccode"]=0x1043E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10416, -- 𐐖
 },
 [0x10417]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER KAY",
  ["lccode"]=0x1043F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10417, -- 𐐗
 },
 [0x10418]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER GAY",
  ["lccode"]=0x10440,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10418, -- 𐐘
 },
 [0x10419]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER EF",
  ["lccode"]=0x10441,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10419, -- 𐐙
 },
 [0x1041A]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER VEE",
  ["lccode"]=0x10442,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1041A, -- 𐐚
 },
 [0x1041B]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER ETH",
  ["lccode"]=0x10443,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1041B, -- 𐐛
 },
 [0x1041C]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER THEE",
  ["lccode"]=0x10444,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1041C, -- 𐐜
 },
 [0x1041D]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER ES",
  ["lccode"]=0x10445,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1041D, -- 𐐝
 },
 [0x1041E]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER ZEE",
  ["lccode"]=0x10446,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1041E, -- 𐐞
 },
 [0x1041F]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER ESH",
  ["lccode"]=0x10447,
  ["linebreak"]="al",
  ["unicodeslot"]=0x1041F, -- 𐐟
 },
 [0x10420]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER ZHEE",
  ["lccode"]=0x10448,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10420, -- 𐐠
 },
 [0x10421]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER ER",
  ["lccode"]=0x10449,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10421, -- 𐐡
 },
 [0x10422]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER EL",
  ["lccode"]=0x1044A,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10422, -- 𐐢
 },
 [0x10423]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER EM",
  ["lccode"]=0x1044B,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10423, -- 𐐣
 },
 [0x10424]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER EN",
  ["lccode"]=0x1044C,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10424, -- 𐐤
 },
 [0x10425]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER ENG",
  ["lccode"]=0x1044D,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10425, -- 𐐥
 },
 [0x10426]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER OI",
  ["lccode"]=0x1044E,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10426, -- 𐐦
 },
 [0x10427]={
  ["category"]="lu",
  ["description"]="DESERET CAPITAL LETTER EW",
  ["lccode"]=0x1044F,
  ["linebreak"]="al",
  ["unicodeslot"]=0x10427, -- 𐐧
 },
 [0x10428]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER LONG I",
  ["linebreak"]="al",
  ["uccode"]=0x10400,
  ["unicodeslot"]=0x10428, -- 𐐨
 },
 [0x10429]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER LONG E",
  ["linebreak"]="al",
  ["uccode"]=0x10401,
  ["unicodeslot"]=0x10429, -- 𐐩
 },
 [0x1042A]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER LONG A",
  ["linebreak"]="al",
  ["uccode"]=0x10402,
  ["unicodeslot"]=0x1042A, -- 𐐪
 },
 [0x1042B]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER LONG AH",
  ["linebreak"]="al",
  ["uccode"]=0x10403,
  ["unicodeslot"]=0x1042B, -- 𐐫
 },
 [0x1042C]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER LONG O",
  ["linebreak"]="al",
  ["uccode"]=0x10404,
  ["unicodeslot"]=0x1042C, -- 𐐬
 },
 [0x1042D]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER LONG OO",
  ["linebreak"]="al",
  ["uccode"]=0x10405,
  ["unicodeslot"]=0x1042D, -- 𐐭
 },
 [0x1042E]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER SHORT I",
  ["linebreak"]="al",
  ["uccode"]=0x10406,
  ["unicodeslot"]=0x1042E, -- 𐐮
 },
 [0x1042F]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER SHORT E",
  ["linebreak"]="al",
  ["uccode"]=0x10407,
  ["unicodeslot"]=0x1042F, -- 𐐯
 },
 [0x10430]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER SHORT A",
  ["linebreak"]="al",
  ["uccode"]=0x10408,
  ["unicodeslot"]=0x10430, -- 𐐰
 },
 [0x10431]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER SHORT AH",
  ["linebreak"]="al",
  ["uccode"]=0x10409,
  ["unicodeslot"]=0x10431, -- 𐐱
 },
 [0x10432]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER SHORT O",
  ["linebreak"]="al",
  ["uccode"]=0x1040A,
  ["unicodeslot"]=0x10432, -- 𐐲
 },
 [0x10433]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER SHORT OO",
  ["linebreak"]="al",
  ["uccode"]=0x1040B,
  ["unicodeslot"]=0x10433, -- 𐐳
 },
 [0x10434]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER AY",
  ["linebreak"]="al",
  ["uccode"]=0x1040C,
  ["unicodeslot"]=0x10434, -- 𐐴
 },
 [0x10435]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER OW",
  ["linebreak"]="al",
  ["uccode"]=0x1040D,
  ["unicodeslot"]=0x10435, -- 𐐵
 },
 [0x10436]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER WU",
  ["linebreak"]="al",
  ["uccode"]=0x1040E,
  ["unicodeslot"]=0x10436, -- 𐐶
 },
 [0x10437]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER YEE",
  ["linebreak"]="al",
  ["uccode"]=0x1040F,
  ["unicodeslot"]=0x10437, -- 𐐷
 },
 [0x10438]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER H",
  ["linebreak"]="al",
  ["uccode"]=0x10410,
  ["unicodeslot"]=0x10438, -- 𐐸
 },
 [0x10439]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER PEE",
  ["linebreak"]="al",
  ["uccode"]=0x10411,
  ["unicodeslot"]=0x10439, -- 𐐹
 },
 [0x1043A]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER BEE",
  ["linebreak"]="al",
  ["uccode"]=0x10412,
  ["unicodeslot"]=0x1043A, -- 𐐺
 },
 [0x1043B]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER TEE",
  ["linebreak"]="al",
  ["uccode"]=0x10413,
  ["unicodeslot"]=0x1043B, -- 𐐻
 },
 [0x1043C]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER DEE",
  ["linebreak"]="al",
  ["uccode"]=0x10414,
  ["unicodeslot"]=0x1043C, -- 𐐼
 },
 [0x1043D]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER CHEE",
  ["linebreak"]="al",
  ["uccode"]=0x10415,
  ["unicodeslot"]=0x1043D, -- 𐐽
 },
 [0x1043E]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER JEE",
  ["linebreak"]="al",
  ["uccode"]=0x10416,
  ["unicodeslot"]=0x1043E, -- 𐐾
 },
 [0x1043F]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER KAY",
  ["linebreak"]="al",
  ["uccode"]=0x10417,
  ["unicodeslot"]=0x1043F, -- 𐐿
 },
 [0x10440]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER GAY",
  ["linebreak"]="al",
  ["uccode"]=0x10418,
  ["unicodeslot"]=0x10440, -- 𐑀
 },
 [0x10441]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER EF",
  ["linebreak"]="al",
  ["uccode"]=0x10419,
  ["unicodeslot"]=0x10441, -- 𐑁
 },
 [0x10442]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER VEE",
  ["linebreak"]="al",
  ["uccode"]=0x1041A,
  ["unicodeslot"]=0x10442, -- 𐑂
 },
 [0x10443]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER ETH",
  ["linebreak"]="al",
  ["uccode"]=0x1041B,
  ["unicodeslot"]=0x10443, -- 𐑃
 },
 [0x10444]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER THEE",
  ["linebreak"]="al",
  ["uccode"]=0x1041C,
  ["unicodeslot"]=0x10444, -- 𐑄
 },
 [0x10445]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER ES",
  ["linebreak"]="al",
  ["uccode"]=0x1041D,
  ["unicodeslot"]=0x10445, -- 𐑅
 },
 [0x10446]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER ZEE",
  ["linebreak"]="al",
  ["uccode"]=0x1041E,
  ["unicodeslot"]=0x10446, -- 𐑆
 },
 [0x10447]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER ESH",
  ["linebreak"]="al",
  ["uccode"]=0x1041F,
  ["unicodeslot"]=0x10447, -- 𐑇
 },
 [0x10448]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER ZHEE",
  ["linebreak"]="al",
  ["uccode"]=0x10420,
  ["unicodeslot"]=0x10448, -- 𐑈
 },
 [0x10449]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER ER",
  ["linebreak"]="al",
  ["uccode"]=0x10421,
  ["unicodeslot"]=0x10449, -- 𐑉
 },
 [0x1044A]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER EL",
  ["linebreak"]="al",
  ["uccode"]=0x10422,
  ["unicodeslot"]=0x1044A, -- 𐑊
 },
 [0x1044B]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER EM",
  ["linebreak"]="al",
  ["uccode"]=0x10423,
  ["unicodeslot"]=0x1044B, -- 𐑋
 },
 [0x1044C]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER EN",
  ["linebreak"]="al",
  ["uccode"]=0x10424,
  ["unicodeslot"]=0x1044C, -- 𐑌
 },
 [0x1044D]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER ENG",
  ["linebreak"]="al",
  ["uccode"]=0x10425,
  ["unicodeslot"]=0x1044D, -- 𐑍
 },
 [0x1044E]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER OI",
  ["linebreak"]="al",
  ["uccode"]=0x10426,
  ["unicodeslot"]=0x1044E, -- 𐑎
 },
 [0x1044F]={
  ["category"]="ll",
  ["description"]="DESERET SMALL LETTER EW",
  ["linebreak"]="al",
  ["uccode"]=0x10427,
  ["unicodeslot"]=0x1044F, -- 𐑏
 },
 [0x10450]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER PEEP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10450, -- 𐑐
 },
 [0x10451]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER TOT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10451, -- 𐑑
 },
 [0x10452]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER KICK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10452, -- 𐑒
 },
 [0x10453]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER FEE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10453, -- 𐑓
 },
 [0x10454]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER THIGH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10454, -- 𐑔
 },
 [0x10455]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER SO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10455, -- 𐑕
 },
 [0x10456]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER SURE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10456, -- 𐑖
 },
 [0x10457]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER CHURCH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10457, -- 𐑗
 },
 [0x10458]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER YEA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10458, -- 𐑘
 },
 [0x10459]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER HUNG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10459, -- 𐑙
 },
 [0x1045A]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER BIB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1045A, -- 𐑚
 },
 [0x1045B]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER DEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1045B, -- 𐑛
 },
 [0x1045C]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER GAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1045C, -- 𐑜
 },
 [0x1045D]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER VOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1045D, -- 𐑝
 },
 [0x1045E]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER THEY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1045E, -- 𐑞
 },
 [0x1045F]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER ZOO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1045F, -- 𐑟
 },
 [0x10460]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER MEASURE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10460, -- 𐑠
 },
 [0x10461]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER JUDGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10461, -- 𐑡
 },
 [0x10462]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER WOE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10462, -- 𐑢
 },
 [0x10463]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER HA-HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10463, -- 𐑣
 },
 [0x10464]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER LOLL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10464, -- 𐑤
 },
 [0x10465]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER MIME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10465, -- 𐑥
 },
 [0x10466]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER IF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10466, -- 𐑦
 },
 [0x10467]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER EGG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10467, -- 𐑧
 },
 [0x10468]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10468, -- 𐑨
 },
 [0x10469]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER ADO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10469, -- 𐑩
 },
 [0x1046A]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER ON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1046A, -- 𐑪
 },
 [0x1046B]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER WOOL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1046B, -- 𐑫
 },
 [0x1046C]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER OUT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1046C, -- 𐑬
 },
 [0x1046D]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER AH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1046D, -- 𐑭
 },
 [0x1046E]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER ROAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1046E, -- 𐑮
 },
 [0x1046F]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1046F, -- 𐑯
 },
 [0x10470]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER EAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10470, -- 𐑰
 },
 [0x10471]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER AGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10471, -- 𐑱
 },
 [0x10472]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER ICE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10472, -- 𐑲
 },
 [0x10473]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10473, -- 𐑳
 },
 [0x10474]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER OAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10474, -- 𐑴
 },
 [0x10475]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER OOZE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10475, -- 𐑵
 },
 [0x10476]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER OIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10476, -- 𐑶
 },
 [0x10477]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER AWE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10477, -- 𐑷
 },
 [0x10478]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER ARE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10478, -- 𐑸
 },
 [0x10479]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER OR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10479, -- 𐑹
 },
 [0x1047A]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER AIR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1047A, -- 𐑺
 },
 [0x1047B]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER ERR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1047B, -- 𐑻
 },
 [0x1047C]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER ARRAY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1047C, -- 𐑼
 },
 [0x1047D]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER EAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1047D, -- 𐑽
 },
 [0x1047E]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER IAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1047E, -- 𐑾
 },
 [0x1047F]={
  ["category"]="lo",
  ["description"]="SHAVIAN LETTER YEW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1047F, -- 𐑿
 },
 [0x10480]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER ALEF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10480, -- 𐒀
 },
 [0x10481]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10481, -- 𐒁
 },
 [0x10482]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10482, -- 𐒂
 },
 [0x10483]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10483, -- 𐒃
 },
 [0x10484]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER XA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10484, -- 𐒄
 },
 [0x10485]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10485, -- 𐒅
 },
 [0x10486]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER DEEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10486, -- 𐒆
 },
 [0x10487]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10487, -- 𐒇
 },
 [0x10488]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10488, -- 𐒈
 },
 [0x10489]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER SHIIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10489, -- 𐒉
 },
 [0x1048A]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1048A, -- 𐒊
 },
 [0x1048B]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER CAYN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1048B, -- 𐒋
 },
 [0x1048C]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1048C, -- 𐒌
 },
 [0x1048D]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER FA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1048D, -- 𐒍
 },
 [0x1048E]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER QAAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1048E, -- 𐒎
 },
 [0x1048F]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER KAAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1048F, -- 𐒏
 },
 [0x10490]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER LAAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10490, -- 𐒐
 },
 [0x10491]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER MIIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10491, -- 𐒑
 },
 [0x10492]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER NUUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10492, -- 𐒒
 },
 [0x10493]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER WAW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10493, -- 𐒓
 },
 [0x10494]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10494, -- 𐒔
 },
 [0x10495]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10495, -- 𐒕
 },
 [0x10496]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10496, -- 𐒖
 },
 [0x10497]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10497, -- 𐒗
 },
 [0x10498]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10498, -- 𐒘
 },
 [0x10499]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10499, -- 𐒙
 },
 [0x1049A]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1049A, -- 𐒚
 },
 [0x1049B]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER AA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1049B, -- 𐒛
 },
 [0x1049C]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER EE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1049C, -- 𐒜
 },
 [0x1049D]={
  ["category"]="lo",
  ["description"]="OSMANYA LETTER OO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1049D, -- 𐒝
 },
 [0x104A0]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT ZERO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A0, -- 𐒠
 },
 [0x104A1]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT ONE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A1, -- 𐒡
 },
 [0x104A2]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT TWO",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A2, -- 𐒢
 },
 [0x104A3]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT THREE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A3, -- 𐒣
 },
 [0x104A4]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT FOUR",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A4, -- 𐒤
 },
 [0x104A5]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT FIVE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A5, -- 𐒥
 },
 [0x104A6]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT SIX",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A6, -- 𐒦
 },
 [0x104A7]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT SEVEN",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A7, -- 𐒧
 },
 [0x104A8]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT EIGHT",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A8, -- 𐒨
 },
 [0x104A9]={
  ["category"]="nd",
  ["description"]="OSMANYA DIGIT NINE",
  ["linebreak"]="nu",
  ["unicodeslot"]=0x104A9, -- 𐒩
 },
 [0x10800]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10800, -- 𐠀
 },
 [0x10801]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10801, -- 𐠁
 },
 [0x10802]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10802, -- 𐠂
 },
 [0x10803]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE O",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10803, -- 𐠃
 },
 [0x10804]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10804, -- 𐠄
 },
 [0x10805]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10805, -- 𐠅
 },
 [0x10808]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE JO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10808, -- 𐠈
 },
 [0x1080A]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1080A, -- 𐠊
 },
 [0x1080B]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE KE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1080B, -- 𐠋
 },
 [0x1080C]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1080C, -- 𐠌
 },
 [0x1080D]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE KO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1080D, -- 𐠍
 },
 [0x1080E]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE KU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1080E, -- 𐠎
 },
 [0x1080F]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1080F, -- 𐠏
 },
 [0x10810]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE LE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10810, -- 𐠐
 },
 [0x10811]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE LI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10811, -- 𐠑
 },
 [0x10812]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE LO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10812, -- 𐠒
 },
 [0x10813]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10813, -- 𐠓
 },
 [0x10814]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10814, -- 𐠔
 },
 [0x10815]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10815, -- 𐠕
 },
 [0x10816]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10816, -- 𐠖
 },
 [0x10817]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE MO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10817, -- 𐠗
 },
 [0x10818]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE MU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10818, -- 𐠘
 },
 [0x10819]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10819, -- 𐠙
 },
 [0x1081A]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1081A, -- 𐠚
 },
 [0x1081B]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE NI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1081B, -- 𐠛
 },
 [0x1081C]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE NO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1081C, -- 𐠜
 },
 [0x1081D]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE NU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1081D, -- 𐠝
 },
 [0x1081E]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1081E, -- 𐠞
 },
 [0x1081F]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1081F, -- 𐠟
 },
 [0x10820]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE PI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10820, -- 𐠠
 },
 [0x10821]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE PO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10821, -- 𐠡
 },
 [0x10822]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE PU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10822, -- 𐠢
 },
 [0x10823]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10823, -- 𐠣
 },
 [0x10824]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE RE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10824, -- 𐠤
 },
 [0x10825]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE RI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10825, -- 𐠥
 },
 [0x10826]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE RO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10826, -- 𐠦
 },
 [0x10827]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10827, -- 𐠧
 },
 [0x10828]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10828, -- 𐠨
 },
 [0x10829]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE SE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10829, -- 𐠩
 },
 [0x1082A]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE SI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1082A, -- 𐠪
 },
 [0x1082B]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE SO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1082B, -- 𐠫
 },
 [0x1082C]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE SU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1082C, -- 𐠬
 },
 [0x1082D]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1082D, -- 𐠭
 },
 [0x1082E]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE TE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1082E, -- 𐠮
 },
 [0x1082F]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE TI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1082F, -- 𐠯
 },
 [0x10830]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE TO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10830, -- 𐠰
 },
 [0x10831]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE TU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10831, -- 𐠱
 },
 [0x10832]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE WA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10832, -- 𐠲
 },
 [0x10833]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE WE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10833, -- 𐠳
 },
 [0x10834]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE WI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10834, -- 𐠴
 },
 [0x10835]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE WO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10835, -- 𐠵
 },
 [0x10837]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE XA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10837, -- 𐠷
 },
 [0x10838]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE XE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10838, -- 𐠸
 },
 [0x1083C]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1083C, -- 𐠼
 },
 [0x1083F]={
  ["category"]="lo",
  ["description"]="CYPRIOT SYLLABLE ZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1083F, -- 𐠿
 },
 [0x10900]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER ALF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10900, -- 𐤀
 },
 [0x10901]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER BET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10901, -- 𐤁
 },
 [0x10902]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER GAML",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10902, -- 𐤂
 },
 [0x10903]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER DELT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10903, -- 𐤃
 },
 [0x10904]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER HE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10904, -- 𐤄
 },
 [0x10905]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER WAU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10905, -- 𐤅
 },
 [0x10906]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER ZAI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10906, -- 𐤆
 },
 [0x10907]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER HET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10907, -- 𐤇
 },
 [0x10908]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER TET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10908, -- 𐤈
 },
 [0x10909]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER YOD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10909, -- 𐤉
 },
 [0x1090A]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER KAF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1090A, -- 𐤊
 },
 [0x1090B]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER LAMD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1090B, -- 𐤋
 },
 [0x1090C]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER MEM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1090C, -- 𐤌
 },
 [0x1090D]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1090D, -- 𐤍
 },
 [0x1090E]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER SEMK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1090E, -- 𐤎
 },
 [0x1090F]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER AIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1090F, -- 𐤏
 },
 [0x10910]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER PE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10910, -- 𐤐
 },
 [0x10911]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER SADE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10911, -- 𐤑
 },
 [0x10912]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER QOF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10912, -- 𐤒
 },
 [0x10913]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER ROSH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10913, -- 𐤓
 },
 [0x10914]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER SHIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10914, -- 𐤔
 },
 [0x10915]={
  ["category"]="lo",
  ["description"]="PHOENICIAN LETTER TAU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10915, -- 𐤕
 },
 [0x10916]={
  ["category"]="no",
  ["description"]="PHOENICIAN NUMBER ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10916, -- 𐤖
 },
 [0x10917]={
  ["category"]="no",
  ["description"]="PHOENICIAN NUMBER TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10917, -- 𐤗
 },
 [0x10918]={
  ["category"]="no",
  ["description"]="PHOENICIAN NUMBER TWENTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10918, -- 𐤘
 },
 [0x10919]={
  ["category"]="no",
  ["description"]="PHOENICIAN NUMBER ONE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10919, -- 𐤙
 },
 [0x1091F]={
  ["category"]="po",
  ["description"]="PHOENICIAN WORD SEPARATOR",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x1091F, -- 𐤟
 },
 [0x10A00]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A00, -- 𐨀
 },
 [0x10A01]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI VOWEL SIGN I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A01, -- 𐨁
 },
 [0x10A02]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI VOWEL SIGN U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A02, -- 𐨂
 },
 [0x10A03]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI VOWEL SIGN VOCALIC R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A03, -- 𐨃
 },
 [0x10A05]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI VOWEL SIGN E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A05, -- 𐨅
 },
 [0x10A06]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI VOWEL SIGN O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A06, -- 𐨆
 },
 [0x10A0C]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI VOWEL LENGTH MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A0C, -- 𐨌
 },
 [0x10A0D]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI SIGN DOUBLE RING BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A0D, -- 𐨍
 },
 [0x10A0E]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI SIGN ANUSVARA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A0E, -- 𐨎
 },
 [0x10A0F]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI SIGN VISARGA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A0F, -- 𐨏
 },
 [0x10A10]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A10, -- 𐨐
 },
 [0x10A11]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER KHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A11, -- 𐨑
 },
 [0x10A12]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A12, -- 𐨒
 },
 [0x10A13]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER GHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A13, -- 𐨓
 },
 [0x10A15]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER CA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A15, -- 𐨕
 },
 [0x10A16]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER CHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A16, -- 𐨖
 },
 [0x10A17]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER JA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A17, -- 𐨗
 },
 [0x10A19]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER NYA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A19, -- 𐨙
 },
 [0x10A1A]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER TTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A1A, -- 𐨚
 },
 [0x10A1B]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER TTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A1B, -- 𐨛
 },
 [0x10A1C]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER DDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A1C, -- 𐨜
 },
 [0x10A1D]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER DDHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A1D, -- 𐨝
 },
 [0x10A1E]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER NNA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A1E, -- 𐨞
 },
 [0x10A1F]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A1F, -- 𐨟
 },
 [0x10A20]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER THA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A20, -- 𐨠
 },
 [0x10A21]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A21, -- 𐨡
 },
 [0x10A22]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER DHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A22, -- 𐨢
 },
 [0x10A23]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A23, -- 𐨣
 },
 [0x10A24]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A24, -- 𐨤
 },
 [0x10A25]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER PHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A25, -- 𐨥
 },
 [0x10A26]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A26, -- 𐨦
 },
 [0x10A27]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER BHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A27, -- 𐨧
 },
 [0x10A28]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A28, -- 𐨨
 },
 [0x10A29]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER YA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A29, -- 𐨩
 },
 [0x10A2A]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A2A, -- 𐨪
 },
 [0x10A2B]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A2B, -- 𐨫
 },
 [0x10A2C]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER VA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A2C, -- 𐨬
 },
 [0x10A2D]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A2D, -- 𐨭
 },
 [0x10A2E]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER SSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A2E, -- 𐨮
 },
 [0x10A2F]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A2F, -- 𐨯
 },
 [0x10A30]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A30, -- 𐨰
 },
 [0x10A31]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A31, -- 𐨱
 },
 [0x10A32]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER KKA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A32, -- 𐨲
 },
 [0x10A33]={
  ["category"]="lo",
  ["description"]="KHAROSHTHI LETTER TTTHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A33, -- 𐨳
 },
 [0x10A38]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI SIGN BAR ABOVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A38, -- 𐨸
 },
 [0x10A39]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI SIGN CAUDA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A39, -- 𐨹
 },
 [0x10A3A]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI SIGN DOT BELOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A3A, -- 𐨺
 },
 [0x10A3F]={
  ["category"]="mn",
  ["description"]="KHAROSHTHI VIRAMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x10A3F, -- 𐨿
 },
 [0x10A40]={
  ["category"]="no",
  ["description"]="KHAROSHTHI DIGIT ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A40, -- 𐩀
 },
 [0x10A41]={
  ["category"]="no",
  ["description"]="KHAROSHTHI DIGIT TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A41, -- 𐩁
 },
 [0x10A42]={
  ["category"]="no",
  ["description"]="KHAROSHTHI DIGIT THREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A42, -- 𐩂
 },
 [0x10A43]={
  ["category"]="no",
  ["description"]="KHAROSHTHI DIGIT FOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A43, -- 𐩃
 },
 [0x10A44]={
  ["category"]="no",
  ["description"]="KHAROSHTHI NUMBER TEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A44, -- 𐩄
 },
 [0x10A45]={
  ["category"]="no",
  ["description"]="KHAROSHTHI NUMBER TWENTY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A45, -- 𐩅
 },
 [0x10A46]={
  ["category"]="no",
  ["description"]="KHAROSHTHI NUMBER ONE HUNDRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A46, -- 𐩆
 },
 [0x10A47]={
  ["category"]="no",
  ["description"]="KHAROSHTHI NUMBER ONE THOUSAND",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A47, -- 𐩇
 },
 [0x10A50]={
  ["category"]="po",
  ["description"]="KHAROSHTHI PUNCTUATION DOT",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10A50, -- 𐩐
 },
 [0x10A51]={
  ["category"]="po",
  ["description"]="KHAROSHTHI PUNCTUATION SMALL CIRCLE",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10A51, -- 𐩑
 },
 [0x10A52]={
  ["category"]="po",
  ["description"]="KHAROSHTHI PUNCTUATION CIRCLE",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10A52, -- 𐩒
 },
 [0x10A53]={
  ["category"]="po",
  ["description"]="KHAROSHTHI PUNCTUATION CRESCENT BAR",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10A53, -- 𐩓
 },
 [0x10A54]={
  ["category"]="po",
  ["description"]="KHAROSHTHI PUNCTUATION MANGALAM",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10A54, -- 𐩔
 },
 [0x10A55]={
  ["category"]="po",
  ["description"]="KHAROSHTHI PUNCTUATION LOTUS",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10A55, -- 𐩕
 },
 [0x10A56]={
  ["category"]="po",
  ["description"]="KHAROSHTHI PUNCTUATION DANDA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10A56, -- 𐩖
 },
 [0x10A57]={
  ["category"]="po",
  ["description"]="KHAROSHTHI PUNCTUATION DOUBLE DANDA",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x10A57, -- 𐩗
 },
 [0x10A58]={
  ["category"]="po",
  ["description"]="KHAROSHTHI PUNCTUATION LINES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x10A58, -- 𐩘
 },
 [0x12000]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12000, -- 𒀀
 },
 [0x12001]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12001, -- 𒀁
 },
 [0x12002]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12002, -- 𒀂
 },
 [0x12003]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12003, -- 𒀃
 },
 [0x12004]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A TIMES HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12004, -- 𒀄
 },
 [0x12005]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A TIMES IGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12005, -- 𒀅
 },
 [0x12006]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A TIMES LAGAR GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12006, -- 𒀆
 },
 [0x12007]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A TIMES MUSH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12007, -- 𒀇
 },
 [0x12008]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A TIMES SAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12008, -- 𒀈
 },
 [0x12009]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN A0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12009, -- 𒀉
 },
 [0x1200A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1200A, -- 𒀊
 },
 [0x1200B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES ASH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1200B, -- 𒀋
 },
 [0x1200C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES DUN0x0003 GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1200C, -- 𒀌
 },
 [0x1200D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES GAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1200D, -- 𒀍
 },
 [0x1200E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1200E, -- 𒀎
 },
 [0x1200F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1200F, -- 𒀏
 },
 [0x12010]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12010, -- 𒀐
 },
 [0x12011]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES IMIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12011, -- 𒀑
 },
 [0x12012]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES LAGAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12012, -- 𒀒
 },
 [0x12013]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES SHESH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12013, -- 𒀓
 },
 [0x12014]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB TIMES U PLUS U PLUS U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12014, -- 𒀔
 },
 [0x12015]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12015, -- 𒀕
 },
 [0x12016]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12016, -- 𒀖
 },
 [0x12017]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB0x0002 TIMES BALAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12017, -- 𒀗
 },
 [0x12018]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB0x0002 TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12018, -- 𒀘
 },
 [0x12019]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB0x0002 TIMES ME PLUS EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12019, -- 𒀙
 },
 [0x1201A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB0x0002 TIMES SHA0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1201A, -- 𒀚
 },
 [0x1201B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AB0x0002 TIMES TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1201B, -- 𒀛
 },
 [0x1201C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1201C, -- 𒀜
 },
 [0x1201D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1201D, -- 𒀝
 },
 [0x1201E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AK TIMES ERIN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1201E, -- 𒀞
 },
 [0x1201F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AK TIMES SHITA PLUS GISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1201F, -- 𒀟
 },
 [0x12020]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12020, -- 𒀠
 },
 [0x12021]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AL TIMES AL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12021, -- 𒀡
 },
 [0x12022]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AL TIMES DIM0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12022, -- 𒀢
 },
 [0x12023]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AL TIMES GISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12023, -- 𒀣
 },
 [0x12024]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AL TIMES HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12024, -- 𒀤
 },
 [0x12025]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AL TIMES KAD0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12025, -- 𒀥
 },
 [0x12026]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AL TIMES KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12026, -- 𒀦
 },
 [0x12027]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AL TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12027, -- 𒀧
 },
 [0x12028]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AL TIMES USH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12028, -- 𒀨
 },
 [0x12029]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ALAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12029, -- 𒀩
 },
 [0x1202A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ALEPH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1202A, -- 𒀪
 },
 [0x1202B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AMAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1202B, -- 𒀫
 },
 [0x1202C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AMAR TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1202C, -- 𒀬
 },
 [0x1202D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1202D, -- 𒀭
 },
 [0x1202E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AN OVER AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1202E, -- 𒀮
 },
 [0x1202F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AN THREE TIMES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1202F, -- 𒀯
 },
 [0x12030]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AN PLUS NAGA OPPOSING AN PLUS NAGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12030, -- 𒀰
 },
 [0x12031]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN AN PLUS NAGA SQUARED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12031, -- 𒀱
 },
 [0x12032]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ANSHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12032, -- 𒀲
 },
 [0x12033]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN APIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12033, -- 𒀳
 },
 [0x12034]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ARAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12034, -- 𒀴
 },
 [0x12035]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ARAD TIMES KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12035, -- 𒀵
 },
 [0x12036]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ARKAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12036, -- 𒀶
 },
 [0x12037]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ASAL0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12037, -- 𒀷
 },
 [0x12038]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12038, -- 𒀸
 },
 [0x12039]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ASH ZIDA TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12039, -- 𒀹
 },
 [0x1203A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ASH KABA TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1203A, -- 𒀺
 },
 [0x1203B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ASH OVER ASH TUG0x0002 OVER TUG0x0002 TUG0x0002 OVER TUG0x0002 PAP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1203B, -- 𒀻
 },
 [0x1203C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ASH OVER ASH OVER ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1203C, -- 𒀼
 },
 [0x1203D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ASH OVER ASH OVER ASH CROSSING ASH OVER ASH OVER ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1203D, -- 𒀽
 },
 [0x1203E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ASH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1203E, -- 𒀾
 },
 [0x1203F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ASHGAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1203F, -- 𒀿
 },
 [0x12040]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12040, -- 𒁀
 },
 [0x12041]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12041, -- 𒁁
 },
 [0x12042]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BAG0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12042, -- 𒁂
 },
 [0x12043]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BAHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12043, -- 𒁃
 },
 [0x12044]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12044, -- 𒁄
 },
 [0x12045]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BAL OVER BAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12045, -- 𒁅
 },
 [0x12046]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BALAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12046, -- 𒁆
 },
 [0x12047]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12047, -- 𒁇
 },
 [0x12048]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BARA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12048, -- 𒁈
 },
 [0x12049]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12049, -- 𒁉
 },
 [0x1204A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BI TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1204A, -- 𒁊
 },
 [0x1204B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BI TIMES GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1204B, -- 𒁋
 },
 [0x1204C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BI TIMES IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1204C, -- 𒁌
 },
 [0x1204D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1204D, -- 𒁍
 },
 [0x1204E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BU OVER BU AB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1204E, -- 𒁎
 },
 [0x1204F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BU OVER BU UN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1204F, -- 𒁏
 },
 [0x12050]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BU CROSSING BU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12050, -- 𒁐
 },
 [0x12051]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BULUG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12051, -- 𒁑
 },
 [0x12052]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BULUG OVER BULUG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12052, -- 𒁒
 },
 [0x12053]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12053, -- 𒁓
 },
 [0x12054]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN BUR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12054, -- 𒁔
 },
 [0x12055]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12055, -- 𒁕
 },
 [0x12056]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12056, -- 𒁖
 },
 [0x12057]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES A PLUS MASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12057, -- 𒁗
 },
 [0x12058]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES AMAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12058, -- 𒁘
 },
 [0x12059]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES BALAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12059, -- 𒁙
 },
 [0x1205A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1205A, -- 𒁚
 },
 [0x1205B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1205B, -- 𒁛
 },
 [0x1205C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES GA PLUS MASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1205C, -- 𒁜
 },
 [0x1205D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES GI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1205D, -- 𒁝
 },
 [0x1205E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES GIR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1205E, -- 𒁞
 },
 [0x1205F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES GUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1205F, -- 𒁟
 },
 [0x12060]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12060, -- 𒁠
 },
 [0x12061]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES IR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12061, -- 𒁡
 },
 [0x12062]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES IR PLUS LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12062, -- 𒁢
 },
 [0x12063]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES KAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12063, -- 𒁣
 },
 [0x12064]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12064, -- 𒁤
 },
 [0x12065]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12065, -- 𒁥
 },
 [0x12066]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES LU PLUS MASH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12066, -- 𒁦
 },
 [0x12067]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES LUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12067, -- 𒁧
 },
 [0x12068]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12068, -- 𒁨
 },
 [0x12069]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES PAP PLUS PAP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12069, -- 𒁩
 },
 [0x1206A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES SI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1206A, -- 𒁪
 },
 [0x1206B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1206B, -- 𒁫
 },
 [0x1206C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES U0x0002 PLUS GIR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1206C, -- 𒁬
 },
 [0x1206D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAG KISIM0x0005 TIMES USH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1206D, -- 𒁭
 },
 [0x1206E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1206E, -- 𒁮
 },
 [0x1206F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1206F, -- 𒁯
 },
 [0x12070]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DARA0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12070, -- 𒁰
 },
 [0x12071]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DARA0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12071, -- 𒁱
 },
 [0x12072]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12072, -- 𒁲
 },
 [0x12073]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DIB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12073, -- 𒁳
 },
 [0x12074]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DIM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12074, -- 𒁴
 },
 [0x12075]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DIM TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12075, -- 𒁵
 },
 [0x12076]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DIM0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12076, -- 𒁶
 },
 [0x12077]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12077, -- 𒁷
 },
 [0x12078]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DIN KASKAL U GUNU DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12078, -- 𒁸
 },
 [0x12079]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12079, -- 𒁹
 },
 [0x1207A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1207A, -- 𒁺
 },
 [0x1207B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DU OVER DU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1207B, -- 𒁻
 },
 [0x1207C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DU GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1207C, -- 𒁼
 },
 [0x1207D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DU SHESHIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1207D, -- 𒁽
 },
 [0x1207E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1207E, -- 𒁾
 },
 [0x1207F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUB TIMES ESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1207F, -- 𒁿
 },
 [0x12080]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUB0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12080, -- 𒂀
 },
 [0x12081]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12081, -- 𒂁
 },
 [0x12082]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUGUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12082, -- 𒂂
 },
 [0x12083]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12083, -- 𒂃
 },
 [0x12084]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12084, -- 𒂄
 },
 [0x12085]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUN0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12085, -- 𒂅
 },
 [0x12086]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUN0x0003 GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12086, -- 𒂆
 },
 [0x12087]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUN0x0003 GUNU GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12087, -- 𒂇
 },
 [0x12088]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUN0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12088, -- 𒂈
 },
 [0x12089]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN DUR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12089, -- 𒂉
 },
 [0x1208A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1208A, -- 𒂊
 },
 [0x1208B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E TIMES PAP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1208B, -- 𒂋
 },
 [0x1208C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E OVER E NUN OVER NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1208C, -- 𒂌
 },
 [0x1208D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1208D, -- 𒂍
 },
 [0x1208E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E0x0002 TIMES A PLUS HA PLUS DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1208E, -- 𒂎
 },
 [0x1208F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E0x0002 TIMES GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1208F, -- 𒂏
 },
 [0x12090]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E0x0002 TIMES MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12090, -- 𒂐
 },
 [0x12091]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E0x0002 TIMES SAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12091, -- 𒂑
 },
 [0x12092]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E0x0002 TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12092, -- 𒂒
 },
 [0x12093]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN E0x0002 TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12093, -- 𒂓
 },
 [0x12094]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EDIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12094, -- 𒂔
 },
 [0x12095]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EGIR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12095, -- 𒂕
 },
 [0x12096]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12096, -- 𒂖
 },
 [0x12097]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12097, -- 𒂗
 },
 [0x12098]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EN TIMES GAN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12098, -- 𒂘
 },
 [0x12099]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EN TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12099, -- 𒂙
 },
 [0x1209A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EN TIMES ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1209A, -- 𒂚
 },
 [0x1209B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EN CROSSING EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1209B, -- 𒂛
 },
 [0x1209C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EN OPPOSING EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1209C, -- 𒂜
 },
 [0x1209D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EN SQUARED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1209D, -- 𒂝
 },
 [0x1209E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EREN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1209E, -- 𒂞
 },
 [0x1209F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ERIN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1209F, -- 𒂟
 },
 [0x120A0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A0, -- 𒂠
 },
 [0x120A1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A1, -- 𒂡
 },
 [0x120A2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A2, -- 𒂢
 },
 [0x120A3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES A PLUS LAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A3, -- 𒂣
 },
 [0x120A4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES A PLUS LAL TIMES LAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A4, -- 𒂤
 },
 [0x120A5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A5, -- 𒂥
 },
 [0x120A6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A6, -- 𒂦
 },
 [0x120A7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES DUN0x0003 GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A7, -- 𒂧
 },
 [0x120A8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES DUN0x0003 GUNU GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A8, -- 𒂨
 },
 [0x120A9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120A9, -- 𒂩
 },
 [0x120AA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES HA GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120AA, -- 𒂪
 },
 [0x120AB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120AB, -- 𒂫
 },
 [0x120AC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES KASKAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120AC, -- 𒂬
 },
 [0x120AD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES KASKAL SQUARED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120AD, -- 𒂭
 },
 [0x120AE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES KU0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120AE, -- 𒂮
 },
 [0x120AF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120AF, -- 𒂯
 },
 [0x120B0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES LAL TIMES LAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B0, -- 𒂰
 },
 [0x120B1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES LI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B1, -- 𒂱
 },
 [0x120B2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B2, -- 𒂲
 },
 [0x120B3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES U0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B3, -- 𒂳
 },
 [0x120B4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN EZEN TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B4, -- 𒂴
 },
 [0x120B5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B5, -- 𒂵
 },
 [0x120B6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B6, -- 𒂶
 },
 [0x120B7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B7, -- 𒂷
 },
 [0x120B8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES A PLUS DA PLUS HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B8, -- 𒂸
 },
 [0x120B9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES A PLUS HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120B9, -- 𒂹
 },
 [0x120BA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES A PLUS IGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120BA, -- 𒂺
 },
 [0x120BB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES AB0x0002 TENU PLUS TAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120BB, -- 𒂻
 },
 [0x120BC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120BC, -- 𒂼
 },
 [0x120BD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120BD, -- 𒂽
 },
 [0x120BE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES ASH0x0002 PLUS GAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120BE, -- 𒂾
 },
 [0x120BF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120BF, -- 𒂿
 },
 [0x120C0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES BAR PLUS RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C0, -- 𒃀
 },
 [0x120C1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES BUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C1, -- 𒃁
 },
 [0x120C2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES BUR PLUS RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C2, -- 𒃂
 },
 [0x120C3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C3, -- 𒃃
 },
 [0x120C4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C4, -- 𒃄
 },
 [0x120C5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES DIM TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C5, -- 𒃅
 },
 [0x120C6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES DUB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C6, -- 𒃆
 },
 [0x120C7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES EL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C7, -- 𒃇
 },
 [0x120C8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES EL PLUS LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C8, -- 𒃈
 },
 [0x120C9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120C9, -- 𒃉
 },
 [0x120CA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES EN TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120CA, -- 𒃊
 },
 [0x120CB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120CB, -- 𒃋
 },
 [0x120CC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120CC, -- 𒃌
 },
 [0x120CD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES GI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120CD, -- 𒃍
 },
 [0x120CE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES GI0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120CE, -- 𒃎
 },
 [0x120CF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES GI0x0004 PLUS A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120CF, -- 𒃏
 },
 [0x120D0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES GIR0x0002 PLUS SU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D0, -- 𒃐
 },
 [0x120D1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES HA PLUS LU PLUS ESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D1, -- 𒃑
 },
 [0x120D2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES HAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D2, -- 𒃒
 },
 [0x120D3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES HAL PLUS LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D3, -- 𒃓
 },
 [0x120D4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES HI PLUS LI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D4, -- 𒃔
 },
 [0x120D5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES HUB0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D5, -- 𒃕
 },
 [0x120D6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D6, -- 𒃖
 },
 [0x120D7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES ISH PLUS HU PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D7, -- 𒃗
 },
 [0x120D8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES KAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D8, -- 𒃘
 },
 [0x120D9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES KASKAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120D9, -- 𒃙
 },
 [0x120DA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES KID",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120DA, -- 𒃚
 },
 [0x120DB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES KID PLUS LAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120DB, -- 𒃛
 },
 [0x120DC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES KU0x0003 PLUS AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120DC, -- 𒃜
 },
 [0x120DD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120DD, -- 𒃝
 },
 [0x120DE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES ME PLUS EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120DE, -- 𒃞
 },
 [0x120DF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120DF, -- 𒃟
 },
 [0x120E0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E0, -- 𒃠
 },
 [0x120E1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES NUN OVER NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E1, -- 𒃡
 },
 [0x120E2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E2, -- 𒃢
 },
 [0x120E3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES SAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E3, -- 𒃣
 },
 [0x120E4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES SAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E4, -- 𒃤
 },
 [0x120E5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E5, -- 𒃥
 },
 [0x120E6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES SHE PLUS TUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E6, -- 𒃦
 },
 [0x120E7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES SHID",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E7, -- 𒃧
 },
 [0x120E8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES SUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E8, -- 𒃨
 },
 [0x120E9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120E9, -- 𒃩
 },
 [0x120EA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120EA, -- 𒃪
 },
 [0x120EB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120EB, -- 𒃫
 },
 [0x120EC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 TIMES UD PLUS DU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120EC, -- 𒃬
 },
 [0x120ED]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GA0x0002 OVER GA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120ED, -- 𒃭
 },
 [0x120EE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GABA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120EE, -- 𒃮
 },
 [0x120EF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GABA CROSSING GABA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120EF, -- 𒃯
 },
 [0x120F0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F0, -- 𒃰
 },
 [0x120F1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAD OVER GAD GAR OVER GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F1, -- 𒃱
 },
 [0x120F2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F2, -- 𒃲
 },
 [0x120F3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAL GAD OVER GAD GAR OVER GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F3, -- 𒃳
 },
 [0x120F4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GALAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F4, -- 𒃴
 },
 [0x120F5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F5, -- 𒃵
 },
 [0x120F6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F6, -- 𒃶
 },
 [0x120F7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F7, -- 𒃷
 },
 [0x120F8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F8, -- 𒃸
 },
 [0x120F9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAN0x0002 OVER GAN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120F9, -- 𒃹
 },
 [0x120FA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAN0x0002 CROSSING GAN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120FA, -- 𒃺
 },
 [0x120FB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120FB, -- 𒃻
 },
 [0x120FC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GAR0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120FC, -- 𒃼
 },
 [0x120FD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GASHAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120FD, -- 𒃽
 },
 [0x120FE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GESHTIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120FE, -- 𒃾
 },
 [0x120FF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GESHTIN TIMES KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x120FF, -- 𒃿
 },
 [0x12100]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12100, -- 𒄀
 },
 [0x12101]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GI TIMES E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12101, -- 𒄁
 },
 [0x12102]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GI TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12102, -- 𒄂
 },
 [0x12103]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GI CROSSING GI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12103, -- 𒄃
 },
 [0x12104]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GI0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12104, -- 𒄄
 },
 [0x12105]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GI0x0004 OVER GI0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12105, -- 𒄅
 },
 [0x12106]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GI0x0004 CROSSING GI0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12106, -- 𒄆
 },
 [0x12107]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GIDIM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12107, -- 𒄇
 },
 [0x12108]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GIR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12108, -- 𒄈
 },
 [0x12109]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GIR0x0002 GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12109, -- 𒄉
 },
 [0x1210A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GIR0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1210A, -- 𒄊
 },
 [0x1210B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GIR0x0003 TIMES A PLUS IGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1210B, -- 𒄋
 },
 [0x1210C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GIR0x0003 TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1210C, -- 𒄌
 },
 [0x1210D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GIR0x0003 TIMES IGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1210D, -- 𒄍
 },
 [0x1210E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GIR0x0003 TIMES LU PLUS IGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1210E, -- 𒄎
 },
 [0x1210F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GIR0x0003 TIMES PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1210F, -- 𒄏
 },
 [0x12110]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GISAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12110, -- 𒄐
 },
 [0x12111]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12111, -- 𒄑
 },
 [0x12112]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GISH CROSSING GISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12112, -- 𒄒
 },
 [0x12113]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GISH TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12113, -- 𒄓
 },
 [0x12114]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GISH TIMES TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12114, -- 𒄔
 },
 [0x12115]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GISH TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12115, -- 𒄕
 },
 [0x12116]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12116, -- 𒄖
 },
 [0x12117]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GU CROSSING GU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12117, -- 𒄗
 },
 [0x12118]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12118, -- 𒄘
 },
 [0x12119]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GU0x0002 TIMES KAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12119, -- 𒄙
 },
 [0x1211A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GU0x0002 TIMES KAK TIMES IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1211A, -- 𒄚
 },
 [0x1211B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GU0x0002 TIMES NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1211B, -- 𒄛
 },
 [0x1211C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GU0x0002 TIMES SAL PLUS TUG0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1211C, -- 𒄜
 },
 [0x1211D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GU0x0002 GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1211D, -- 𒄝
 },
 [0x1211E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1211E, -- 𒄞
 },
 [0x1211F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GUD TIMES A PLUS KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1211F, -- 𒄟
 },
 [0x12120]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GUD TIMES KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12120, -- 𒄠
 },
 [0x12121]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GUD OVER GUD LUGAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12121, -- 𒄡
 },
 [0x12122]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GUL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12122, -- 𒄢
 },
 [0x12123]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12123, -- 𒄣
 },
 [0x12124]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GUM TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12124, -- 𒄤
 },
 [0x12125]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12125, -- 𒄥
 },
 [0x12126]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GUR0x0007",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12126, -- 𒄦
 },
 [0x12127]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GURUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12127, -- 𒄧
 },
 [0x12128]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN GURUSH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12128, -- 𒄨
 },
 [0x12129]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12129, -- 𒄩
 },
 [0x1212A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HA TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1212A, -- 𒄪
 },
 [0x1212B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HA GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1212B, -- 𒄫
 },
 [0x1212C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1212C, -- 𒄬
 },
 [0x1212D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1212D, -- 𒄭
 },
 [0x1212E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI TIMES ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1212E, -- 𒄮
 },
 [0x1212F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI TIMES ASH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1212F, -- 𒄯
 },
 [0x12130]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12130, -- 𒄰
 },
 [0x12131]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI TIMES DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12131, -- 𒄱
 },
 [0x12132]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI TIMES GAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12132, -- 𒄲
 },
 [0x12133]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI TIMES KIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12133, -- 𒄳
 },
 [0x12134]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI TIMES NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12134, -- 𒄴
 },
 [0x12135]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12135, -- 𒄵
 },
 [0x12136]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HI TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12136, -- 𒄶
 },
 [0x12137]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12137, -- 𒄷
 },
 [0x12138]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HUB0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12138, -- 𒄸
 },
 [0x12139]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HUB0x0002 TIMES AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12139, -- 𒄹
 },
 [0x1213A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HUB0x0002 TIMES HAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1213A, -- 𒄺
 },
 [0x1213B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HUB0x0002 TIMES KASKAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1213B, -- 𒄻
 },
 [0x1213C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HUB0x0002 TIMES LISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1213C, -- 𒄼
 },
 [0x1213D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HUB0x0002 TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1213D, -- 𒄽
 },
 [0x1213E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN HUL0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1213E, -- 𒄾
 },
 [0x1213F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1213F, -- 𒄿
 },
 [0x12140]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN I A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12140, -- 𒅀
 },
 [0x12141]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12141, -- 𒅁
 },
 [0x12142]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IDIM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12142, -- 𒅂
 },
 [0x12143]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IDIM OVER IDIM BUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12143, -- 𒅃
 },
 [0x12144]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IDIM OVER IDIM SQUARED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12144, -- 𒅄
 },
 [0x12145]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12145, -- 𒅅
 },
 [0x12146]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12146, -- 𒅆
 },
 [0x12147]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IGI DIB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12147, -- 𒅇
 },
 [0x12148]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IGI RI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12148, -- 𒅈
 },
 [0x12149]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IGI OVER IGI SHIR OVER SHIR UD OVER UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12149, -- 𒅉
 },
 [0x1214A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1214A, -- 𒅊
 },
 [0x1214B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1214B, -- 𒅋
 },
 [0x1214C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IL TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1214C, -- 𒅌
 },
 [0x1214D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IL0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1214D, -- 𒅍
 },
 [0x1214E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1214E, -- 𒅎
 },
 [0x1214F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IM TIMES TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1214F, -- 𒅏
 },
 [0x12150]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IM CROSSING IM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12150, -- 𒅐
 },
 [0x12151]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IM OPPOSING IM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12151, -- 𒅑
 },
 [0x12152]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IM SQUARED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12152, -- 𒅒
 },
 [0x12153]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IMIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12153, -- 𒅓
 },
 [0x12154]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12154, -- 𒅔
 },
 [0x12155]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN IR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12155, -- 𒅕
 },
 [0x12156]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12156, -- 𒅖
 },
 [0x12157]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12157, -- 𒅗
 },
 [0x12158]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12158, -- 𒅘
 },
 [0x12159]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES AD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12159, -- 𒅙
 },
 [0x1215A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES AD PLUS KU0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1215A, -- 𒅚
 },
 [0x1215B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES ASH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1215B, -- 𒅛
 },
 [0x1215C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1215C, -- 𒅜
 },
 [0x1215D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES BALAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1215D, -- 𒅝
 },
 [0x1215E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1215E, -- 𒅞
 },
 [0x1215F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1215F, -- 𒅟
 },
 [0x12160]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES ERIN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12160, -- 𒅠
 },
 [0x12161]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES ESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12161, -- 𒅡
 },
 [0x12162]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12162, -- 𒅢
 },
 [0x12163]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12163, -- 𒅣
 },
 [0x12164]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12164, -- 𒅤
 },
 [0x12165]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12165, -- 𒅥
 },
 [0x12166]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GAR PLUS SHA0x0003 PLUS A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12166, -- 𒅦
 },
 [0x12167]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12167, -- 𒅧
 },
 [0x12168]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GIR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12168, -- 𒅨
 },
 [0x12169]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GISH PLUS SAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12169, -- 𒅩
 },
 [0x1216A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GISH CROSSING GISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1216A, -- 𒅪
 },
 [0x1216B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1216B, -- 𒅫
 },
 [0x1216C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES GUR0x0007",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1216C, -- 𒅬
 },
 [0x1216D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES IGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1216D, -- 𒅭
 },
 [0x1216E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES IM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1216E, -- 𒅮
 },
 [0x1216F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES KAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1216F, -- 𒅯
 },
 [0x12170]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12170, -- 𒅰
 },
 [0x12171]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES KID",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12171, -- 𒅱
 },
 [0x12172]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES LI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12172, -- 𒅲
 },
 [0x12173]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12173, -- 𒅳
 },
 [0x12174]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12174, -- 𒅴
 },
 [0x12175]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES ME PLUS DU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12175, -- 𒅵
 },
 [0x12176]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES ME PLUS GI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12176, -- 𒅶
 },
 [0x12177]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES ME PLUS TE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12177, -- 𒅷
 },
 [0x12178]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12178, -- 𒅸
 },
 [0x12179]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES MI PLUS NUNUZ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12179, -- 𒅹
 },
 [0x1217A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1217A, -- 𒅺
 },
 [0x1217B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1217B, -- 𒅻
 },
 [0x1217C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES PI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1217C, -- 𒅼
 },
 [0x1217D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1217D, -- 𒅽
 },
 [0x1217E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1217E, -- 𒅾
 },
 [0x1217F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES SAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1217F, -- 𒅿
 },
 [0x12180]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12180, -- 𒆀
 },
 [0x12181]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12181, -- 𒆁
 },
 [0x12182]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES SHID",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12182, -- 𒆂
 },
 [0x12183]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES SHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12183, -- 𒆃
 },
 [0x12184]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES SIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12184, -- 𒆄
 },
 [0x12185]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES SUHUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12185, -- 𒆅
 },
 [0x12186]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES TAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12186, -- 𒆆
 },
 [0x12187]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12187, -- 𒆇
 },
 [0x12188]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES U0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12188, -- 𒆈
 },
 [0x12189]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12189, -- 𒆉
 },
 [0x1218A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES UMUM TIMES PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1218A, -- 𒆊
 },
 [0x1218B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES USH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1218B, -- 𒆋
 },
 [0x1218C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA TIMES ZI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1218C, -- 𒆌
 },
 [0x1218D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1218D, -- 𒆍
 },
 [0x1218E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KA0x0002 CROSSING KA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1218E, -- 𒆎
 },
 [0x1218F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1218F, -- 𒆏
 },
 [0x12190]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAD0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12190, -- 𒆐
 },
 [0x12191]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAD0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12191, -- 𒆑
 },
 [0x12192]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAD0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12192, -- 𒆒
 },
 [0x12193]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAD0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12193, -- 𒆓
 },
 [0x12194]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAD0x0005 OVER KAD0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12194, -- 𒆔
 },
 [0x12195]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12195, -- 𒆕
 },
 [0x12196]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAK TIMES IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12196, -- 𒆖
 },
 [0x12197]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12197, -- 𒆗
 },
 [0x12198]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAL TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12198, -- 𒆘
 },
 [0x12199]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAL CROSSING KAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12199, -- 𒆙
 },
 [0x1219A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAM0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1219A, -- 𒆚
 },
 [0x1219B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KAM0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1219B, -- 𒆛
 },
 [0x1219C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KASKAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1219C, -- 𒆜
 },
 [0x1219D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KASKAL LAGAB TIMES U OVER LAGAB TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1219D, -- 𒆝
 },
 [0x1219E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KASKAL OVER KASKAL LAGAB TIMES U OVER LAGAB TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1219E, -- 𒆞
 },
 [0x1219F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1219F, -- 𒆟
 },
 [0x121A0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A0, -- 𒆠
 },
 [0x121A1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KI TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A1, -- 𒆡
 },
 [0x121A2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KI TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A2, -- 𒆢
 },
 [0x121A3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KI TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A3, -- 𒆣
 },
 [0x121A4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KID",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A4, -- 𒆤
 },
 [0x121A5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A5, -- 𒆥
 },
 [0x121A6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KISAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A6, -- 𒆦
 },
 [0x121A7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A7, -- 𒆧
 },
 [0x121A8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KISIM0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A8, -- 𒆨
 },
 [0x121A9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KISIM0x0005 OVER KISIM0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121A9, -- 𒆩
 },
 [0x121AA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121AA, -- 𒆪
 },
 [0x121AB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KU OVER HI TIMES ASH0x0002 KU OVER HI TIMES ASH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121AB, -- 𒆫
 },
 [0x121AC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KU0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121AC, -- 𒆬
 },
 [0x121AD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KU0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121AD, -- 𒆭
 },
 [0x121AE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KU0x0004 VARIANT FORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121AE, -- 𒆮
 },
 [0x121AF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KU0x0007",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121AF, -- 𒆯
 },
 [0x121B0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KUL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B0, -- 𒆰
 },
 [0x121B1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KUL GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B1, -- 𒆱
 },
 [0x121B2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B2, -- 𒆲
 },
 [0x121B3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B3, -- 𒆳
 },
 [0x121B4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KUR OPPOSING KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B4, -- 𒆴
 },
 [0x121B5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KUSHU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B5, -- 𒆵
 },
 [0x121B6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN KWU0x013E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B6, -- 𒆶
 },
 [0x121B7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B7, -- 𒆷
 },
 [0x121B8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B8, -- 𒆸
 },
 [0x121B9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121B9, -- 𒆹
 },
 [0x121BA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES A PLUS DA PLUS HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121BA, -- 𒆺
 },
 [0x121BB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES A PLUS GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121BB, -- 𒆻
 },
 [0x121BC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES A PLUS LAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121BC, -- 𒆼
 },
 [0x121BD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES AL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121BD, -- 𒆽
 },
 [0x121BE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121BE, -- 𒆾
 },
 [0x121BF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES ASH ZIDA TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121BF, -- 𒆿
 },
 [0x121C0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C0, -- 𒇀
 },
 [0x121C1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C1, -- 𒇁
 },
 [0x121C2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES DAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C2, -- 𒇂
 },
 [0x121C3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C3, -- 𒇃
 },
 [0x121C4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C4, -- 𒇄
 },
 [0x121C5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C5, -- 𒇅
 },
 [0x121C6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES GUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C6, -- 𒇆
 },
 [0x121C7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES GUD PLUS GUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C7, -- 𒇇
 },
 [0x121C8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C8, -- 𒇈
 },
 [0x121C9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES HAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121C9, -- 𒇉
 },
 [0x121CA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES HI TIMES NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121CA, -- 𒇊
 },
 [0x121CB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121CB, -- 𒇋
 },
 [0x121CC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES IM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121CC, -- 𒇌
 },
 [0x121CD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES IM PLUS HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121CD, -- 𒇍
 },
 [0x121CE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES IM PLUS LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121CE, -- 𒇎
 },
 [0x121CF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121CF, -- 𒇏
 },
 [0x121D0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES KIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D0, -- 𒇐
 },
 [0x121D1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES KU0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D1, -- 𒇑
 },
 [0x121D2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES KUL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D2, -- 𒇒
 },
 [0x121D3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES KUL PLUS HI PLUS A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D3, -- 𒇓
 },
 [0x121D4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES LAGAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D4, -- 𒇔
 },
 [0x121D5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES LISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D5, -- 𒇕
 },
 [0x121D6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D6, -- 𒇖
 },
 [0x121D7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES LUL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D7, -- 𒇗
 },
 [0x121D8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D8, -- 𒇘
 },
 [0x121D9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES ME PLUS EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121D9, -- 𒇙
 },
 [0x121DA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES MUSH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121DA, -- 𒇚
 },
 [0x121DB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121DB, -- 𒇛
 },
 [0x121DC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES SHE PLUS SUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121DC, -- 𒇜
 },
 [0x121DD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES SHITA PLUS GISH PLUS ERIN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121DD, -- 𒇝
 },
 [0x121DE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES SHITA PLUS GISH TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121DE, -- 𒇞
 },
 [0x121DF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES SHU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121DF, -- 𒇟
 },
 [0x121E0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES SHU0x0002 PLUS SHU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E0, -- 𒇠
 },
 [0x121E1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES SUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E1, -- 𒇡
 },
 [0x121E2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES TAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E2, -- 𒇢
 },
 [0x121E3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E3, -- 𒇣
 },
 [0x121E4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES TE PLUS A PLUS SU PLUS NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E4, -- 𒇤
 },
 [0x121E5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E5, -- 𒇥
 },
 [0x121E6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES U PLUS A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E6, -- 𒇦
 },
 [0x121E7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES U PLUS U PLUS U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E7, -- 𒇧
 },
 [0x121E8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES U0x0002 PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E8, -- 𒇨
 },
 [0x121E9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121E9, -- 𒇩
 },
 [0x121EA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB TIMES USH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121EA, -- 𒇪
 },
 [0x121EB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAB SQUARED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121EB, -- 𒇫
 },
 [0x121EC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121EC, -- 𒇬
 },
 [0x121ED]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAR TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121ED, -- 𒇭
 },
 [0x121EE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAR TIMES SHE PLUS SUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121EE, -- 𒇮
 },
 [0x121EF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAR GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121EF, -- 𒇯
 },
 [0x121F0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAGAR GUNU OVER LAGAR GUNU SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F0, -- 𒇰
 },
 [0x121F1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAHSHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F1, -- 𒇱
 },
 [0x121F2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F2, -- 𒇲
 },
 [0x121F3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAL TIMES LAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F3, -- 𒇳
 },
 [0x121F4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F4, -- 𒇴
 },
 [0x121F5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAM TIMES KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F5, -- 𒇵
 },
 [0x121F6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LAM TIMES KUR PLUS RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F6, -- 𒇶
 },
 [0x121F7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F7, -- 𒇷
 },
 [0x121F8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F8, -- 𒇸
 },
 [0x121F9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LIMMU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121F9, -- 𒇹
 },
 [0x121FA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121FA, -- 𒇺
 },
 [0x121FB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121FB, -- 𒇻
 },
 [0x121FC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121FC, -- 𒇼
 },
 [0x121FD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121FD, -- 𒇽
 },
 [0x121FE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES AL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121FE, -- 𒇾
 },
 [0x121FF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x121FF, -- 𒇿
 },
 [0x12200]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES ESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12200, -- 𒈀
 },
 [0x12201]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES ESH0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12201, -- 𒈁
 },
 [0x12202]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12202, -- 𒈂
 },
 [0x12203]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES HI TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12203, -- 𒈃
 },
 [0x12204]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES IM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12204, -- 𒈄
 },
 [0x12205]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES KAD0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12205, -- 𒈅
 },
 [0x12206]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES KAD0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12206, -- 𒈆
 },
 [0x12207]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES KAD0x0003 PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12207, -- 𒈇
 },
 [0x12208]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12208, -- 𒈈
 },
 [0x12209]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES LA PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12209, -- 𒈉
 },
 [0x1220A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES LAGAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1220A, -- 𒈊
 },
 [0x1220B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES ME PLUS EN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1220B, -- 𒈋
 },
 [0x1220C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1220C, -- 𒈌
 },
 [0x1220D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES NU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1220D, -- 𒈍
 },
 [0x1220E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES SI PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1220E, -- 𒈎
 },
 [0x1220F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES SIK0x0002 PLUS BU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1220F, -- 𒈏
 },
 [0x12210]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TIMES TUG0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12210, -- 𒈐
 },
 [0x12211]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12211, -- 𒈑
 },
 [0x12212]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 CROSSING LU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12212, -- 𒈒
 },
 [0x12213]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 OPPOSING LU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12213, -- 𒈓
 },
 [0x12214]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 SQUARED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12214, -- 𒈔
 },
 [0x12215]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0002 SHESHIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12215, -- 𒈕
 },
 [0x12216]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LU0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12216, -- 𒈖
 },
 [0x12217]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LUGAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12217, -- 𒈗
 },
 [0x12218]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LUGAL OVER LUGAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12218, -- 𒈘
 },
 [0x12219]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LUGAL OPPOSING LUGAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12219, -- 𒈙
 },
 [0x1221A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LUGAL SHESHIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1221A, -- 𒈚
 },
 [0x1221B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LUH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1221B, -- 𒈛
 },
 [0x1221C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LUL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1221C, -- 𒈜
 },
 [0x1221D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1221D, -- 𒈝
 },
 [0x1221E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LUM OVER LUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1221E, -- 𒈞
 },
 [0x1221F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN LUM OVER LUM GAR OVER GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1221F, -- 𒈟
 },
 [0x12220]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12220, -- 𒈠
 },
 [0x12221]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MA TIMES TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12221, -- 𒈡
 },
 [0x12222]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MA GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12222, -- 𒈢
 },
 [0x12223]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12223, -- 𒈣
 },
 [0x12224]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MAH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12224, -- 𒈤
 },
 [0x12225]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12225, -- 𒈥
 },
 [0x12226]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12226, -- 𒈦
 },
 [0x12227]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MASH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12227, -- 𒈧
 },
 [0x12228]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12228, -- 𒈨
 },
 [0x12229]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12229, -- 𒈩
 },
 [0x1222A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1222A, -- 𒈪
 },
 [0x1222B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1222B, -- 𒈫
 },
 [0x1222C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1222C, -- 𒈬
 },
 [0x1222D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MU OVER MU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1222D, -- 𒈭
 },
 [0x1222E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1222E, -- 𒈮
 },
 [0x1222F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUG GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1222F, -- 𒈯
 },
 [0x12230]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUNSUB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12230, -- 𒈰
 },
 [0x12231]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MURGU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12231, -- 𒈱
 },
 [0x12232]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12232, -- 𒈲
 },
 [0x12233]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12233, -- 𒈳
 },
 [0x12234]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH TIMES KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12234, -- 𒈴
 },
 [0x12235]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH TIMES ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12235, -- 𒈵
 },
 [0x12236]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH OVER MUSH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12236, -- 𒈶
 },
 [0x12237]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH OVER MUSH TIMES A PLUS NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12237, -- 𒈷
 },
 [0x12238]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH CROSSING MUSH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12238, -- 𒈸
 },
 [0x12239]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12239, -- 𒈹
 },
 [0x1223A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH0x0003 TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1223A, -- 𒈺
 },
 [0x1223B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH0x0003 TIMES A PLUS DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1223B, -- 𒈻
 },
 [0x1223C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH0x0003 TIMES DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1223C, -- 𒈼
 },
 [0x1223D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN MUSH0x0003 GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1223D, -- 𒈽
 },
 [0x1223E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1223E, -- 𒈾
 },
 [0x1223F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1223F, -- 𒈿
 },
 [0x12240]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NAGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12240, -- 𒉀
 },
 [0x12241]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NAGA INVERTED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12241, -- 𒉁
 },
 [0x12242]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NAGA TIMES SHU TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12242, -- 𒉂
 },
 [0x12243]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NAGA OPPOSING NAGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12243, -- 𒉃
 },
 [0x12244]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NAGAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12244, -- 𒉄
 },
 [0x12245]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NAM NUTILLU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12245, -- 𒉅
 },
 [0x12246]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12246, -- 𒉆
 },
 [0x12247]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NAM0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12247, -- 𒉇
 },
 [0x12248]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12248, -- 𒉈
 },
 [0x12249]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NE TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12249, -- 𒉉
 },
 [0x1224A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NE TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1224A, -- 𒉊
 },
 [0x1224B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NE SHESHIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1224B, -- 𒉋
 },
 [0x1224C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1224C, -- 𒉌
 },
 [0x1224D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NI TIMES E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1224D, -- 𒉍
 },
 [0x1224E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NI0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1224E, -- 𒉎
 },
 [0x1224F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NIM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1224F, -- 𒉏
 },
 [0x12250]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NIM TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12250, -- 𒉐
 },
 [0x12251]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NIM TIMES GAR PLUS GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12251, -- 𒉑
 },
 [0x12252]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12252, -- 𒉒
 },
 [0x12253]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12253, -- 𒉓
 },
 [0x12254]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12254, -- 𒉔
 },
 [0x12255]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES ASH PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12255, -- 𒉕
 },
 [0x12256]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES GUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12256, -- 𒉖
 },
 [0x12257]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES ME PLUS GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12257, -- 𒉗
 },
 [0x12258]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12258, -- 𒉘
 },
 [0x12259]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12259, -- 𒉙
 },
 [0x1225A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1225A, -- 𒉚
 },
 [0x1225B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES SHE PLUS A AN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1225B, -- 𒉛
 },
 [0x1225C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES SHE PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1225C, -- 𒉜
 },
 [0x1225D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES SHE PLUS ASH PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1225D, -- 𒉝
 },
 [0x1225E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES U0x0002 PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1225E, -- 𒉞
 },
 [0x1225F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NINDA0x0002 TIMES USH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1225F, -- 𒉟
 },
 [0x12260]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NISAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12260, -- 𒉠
 },
 [0x12261]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12261, -- 𒉡
 },
 [0x12262]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NU0x000B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12262, -- 𒉢
 },
 [0x12263]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12263, -- 𒉣
 },
 [0x12264]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN LAGAR TIMES GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12264, -- 𒉤
 },
 [0x12265]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN LAGAR TIMES MASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12265, -- 𒉥
 },
 [0x12266]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN LAGAR TIMES SAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12266, -- 𒉦
 },
 [0x12267]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN LAGAR TIMES SAL OVER NUN LAGAR TIMES SAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12267, -- 𒉧
 },
 [0x12268]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN LAGAR TIMES USH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12268, -- 𒉨
 },
 [0x12269]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12269, -- 𒉩
 },
 [0x1226A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN OVER NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1226A, -- 𒉪
 },
 [0x1226B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN CROSSING NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1226B, -- 𒉫
 },
 [0x1226C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUN CROSSING NUN LAGAR OVER LAGAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1226C, -- 𒉬
 },
 [0x1226D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1226D, -- 𒉭
 },
 [0x1226E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES ASHGAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1226E, -- 𒉮
 },
 [0x1226F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1226F, -- 𒉯
 },
 [0x12270]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES DUG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12270, -- 𒉰
 },
 [0x12271]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES GUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12271, -- 𒉱
 },
 [0x12272]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12272, -- 𒉲
 },
 [0x12273]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES KAD0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12273, -- 𒉳
 },
 [0x12274]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES LA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12274, -- 𒉴
 },
 [0x12275]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12275, -- 𒉵
 },
 [0x12276]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES SILA0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12276, -- 𒉶
 },
 [0x12277]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ AB0x0002 TIMES U0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12277, -- 𒉷
 },
 [0x12278]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ KISIM0x0005 TIMES BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12278, -- 𒉸
 },
 [0x12279]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN NUNUZ KISIM0x0005 TIMES BI U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12279, -- 𒉹
 },
 [0x1227A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1227A, -- 𒉺
 },
 [0x1227B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1227B, -- 𒉻
 },
 [0x1227C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1227C, -- 𒉼
 },
 [0x1227D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PAP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1227D, -- 𒉽
 },
 [0x1227E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1227E, -- 𒉾
 },
 [0x1227F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1227F, -- 𒉿
 },
 [0x12280]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12280, -- 𒊀
 },
 [0x12281]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI TIMES AB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12281, -- 𒊁
 },
 [0x12282]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI TIMES BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12282, -- 𒊂
 },
 [0x12283]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI TIMES BU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12283, -- 𒊃
 },
 [0x12284]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI TIMES E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12284, -- 𒊄
 },
 [0x12285]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI TIMES I",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12285, -- 𒊅
 },
 [0x12286]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI TIMES IB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12286, -- 𒊆
 },
 [0x12287]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12287, -- 𒊇
 },
 [0x12288]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI TIMES U0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12288, -- 𒊈
 },
 [0x12289]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PI CROSSING PI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12289, -- 𒊉
 },
 [0x1228A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PIRIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1228A, -- 𒊊
 },
 [0x1228B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PIRIG TIMES KAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1228B, -- 𒊋
 },
 [0x1228C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PIRIG TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1228C, -- 𒊌
 },
 [0x1228D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PIRIG TIMES ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1228D, -- 𒊍
 },
 [0x1228E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN PIRIG OPPOSING PIRIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1228E, -- 𒊎
 },
 [0x1228F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN RA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1228F, -- 𒊏
 },
 [0x12290]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN RAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12290, -- 𒊐
 },
 [0x12291]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN RI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12291, -- 𒊑
 },
 [0x12292]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN RU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12292, -- 𒊒
 },
 [0x12293]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12293, -- 𒊓
 },
 [0x12294]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG NUTILLU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12294, -- 𒊔
 },
 [0x12295]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12295, -- 𒊕
 },
 [0x12296]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12296, -- 𒊖
 },
 [0x12297]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES DU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12297, -- 𒊗
 },
 [0x12298]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES DUB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12298, -- 𒊘
 },
 [0x12299]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12299, -- 𒊙
 },
 [0x1229A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES KAK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1229A, -- 𒊚
 },
 [0x1229B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1229B, -- 𒊛
 },
 [0x1229C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES LUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1229C, -- 𒊜
 },
 [0x1229D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1229D, -- 𒊝
 },
 [0x1229E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1229E, -- 𒊞
 },
 [0x1229F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES SAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1229F, -- 𒊟
 },
 [0x122A0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES SHID",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A0, -- 𒊠
 },
 [0x122A1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES TAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A1, -- 𒊡
 },
 [0x122A2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES U0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A2, -- 𒊢
 },
 [0x122A3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES UB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A3, -- 𒊣
 },
 [0x122A4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES UM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A4, -- 𒊤
 },
 [0x122A5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES UR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A5, -- 𒊥
 },
 [0x122A6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG TIMES USH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A6, -- 𒊦
 },
 [0x122A7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG OVER SAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A7, -- 𒊧
 },
 [0x122A8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAG GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A8, -- 𒊨
 },
 [0x122A9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122A9, -- 𒊩
 },
 [0x122AA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAL LAGAB TIMES ASH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122AA, -- 𒊪
 },
 [0x122AB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SANGA0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122AB, -- 𒊫
 },
 [0x122AC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122AC, -- 𒊬
 },
 [0x122AD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122AD, -- 𒊭
 },
 [0x122AE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122AE, -- 𒊮
 },
 [0x122AF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0003 TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122AF, -- 𒊯
 },
 [0x122B0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0003 TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B0, -- 𒊰
 },
 [0x122B1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0003 TIMES GISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B1, -- 𒊱
 },
 [0x122B2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0003 TIMES NE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B2, -- 𒊲
 },
 [0x122B3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0003 TIMES SHU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B3, -- 𒊳
 },
 [0x122B4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0003 TIMES TUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B4, -- 𒊴
 },
 [0x122B5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0003 TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B5, -- 𒊵
 },
 [0x122B6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0003 TIMES U PLUS A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B6, -- 𒊶
 },
 [0x122B7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHA0x0006",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B7, -- 𒊷
 },
 [0x122B8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHAB0x0006",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B8, -- 𒊸
 },
 [0x122B9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122B9, -- 𒊹
 },
 [0x122BA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122BA, -- 𒊺
 },
 [0x122BB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHE HU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122BB, -- 𒊻
 },
 [0x122BC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHE OVER SHE GAD OVER GAD GAR OVER GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122BC, -- 𒊼
 },
 [0x122BD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHE OVER SHE TAB OVER TAB GAR OVER GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122BD, -- 𒊽
 },
 [0x122BE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHEG0x0009",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122BE, -- 𒊾
 },
 [0x122BF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122BF, -- 𒊿
 },
 [0x122C0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHESH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C0, -- 𒋀
 },
 [0x122C1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C1, -- 𒋁
 },
 [0x122C2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHESHLAM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C2, -- 𒋂
 },
 [0x122C3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHID",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C3, -- 𒋃
 },
 [0x122C4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHID TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C4, -- 𒋄
 },
 [0x122C5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHID TIMES IM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C5, -- 𒋅
 },
 [0x122C6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C6, -- 𒋆
 },
 [0x122C7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C7, -- 𒋇
 },
 [0x122C8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES BAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C8, -- 𒋈
 },
 [0x122C9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES BULUG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122C9, -- 𒋉
 },
 [0x122CA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES DIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122CA, -- 𒋊
 },
 [0x122CB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122CB, -- 𒋋
 },
 [0x122CC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES IGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122CC, -- 𒋌
 },
 [0x122CD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES IGI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122CD, -- 𒋍
 },
 [0x122CE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES KUSHU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122CE, -- 𒋎
 },
 [0x122CF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES LUL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122CF, -- 𒋏
 },
 [0x122D0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES MUG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D0, -- 𒋐
 },
 [0x122D1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIM TIMES SAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D1, -- 𒋑
 },
 [0x122D2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHINIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D2, -- 𒋒
 },
 [0x122D3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D3, -- 𒋓
 },
 [0x122D4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIR TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D4, -- 𒋔
 },
 [0x122D5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHIR OVER SHIR BUR OVER BUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D5, -- 𒋕
 },
 [0x122D6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHITA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D6, -- 𒋖
 },
 [0x122D7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D7, -- 𒋗
 },
 [0x122D8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHU OVER INVERTED SHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D8, -- 𒋘
 },
 [0x122D9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122D9, -- 𒋙
 },
 [0x122DA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SHUBUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122DA, -- 𒋚
 },
 [0x122DB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122DB, -- 𒋛
 },
 [0x122DC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SI GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122DC, -- 𒋜
 },
 [0x122DD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122DD, -- 𒋝
 },
 [0x122DE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SIG0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122DE, -- 𒋞
 },
 [0x122DF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SIG0x0004 OVER SIG0x0004 SHU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122DF, -- 𒋟
 },
 [0x122E0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SIK0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E0, -- 𒋠
 },
 [0x122E1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SILA0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E1, -- 𒋡
 },
 [0x122E2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E2, -- 𒋢
 },
 [0x122E3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SU OVER SU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E3, -- 𒋣
 },
 [0x122E4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E4, -- 𒋤
 },
 [0x122E5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SUD0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E5, -- 𒋥
 },
 [0x122E6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SUHUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E6, -- 𒋦
 },
 [0x122E7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E7, -- 𒋧
 },
 [0x122E8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SUMASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E8, -- 𒋨
 },
 [0x122E9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122E9, -- 𒋩
 },
 [0x122EA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN SUR0x0009",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122EA, -- 𒋪
 },
 [0x122EB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122EB, -- 𒋫
 },
 [0x122EC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TA ASTERISK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122EC, -- 𒋬
 },
 [0x122ED]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TA TIMES HI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122ED, -- 𒋭
 },
 [0x122EE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TA TIMES MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122EE, -- 𒋮
 },
 [0x122EF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TA GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122EF, -- 𒋯
 },
 [0x122F0]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F0, -- 𒋰
 },
 [0x122F1]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAB OVER TAB NI OVER NI DISH OVER DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F1, -- 𒋱
 },
 [0x122F2]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAB SQUARED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F2, -- 𒋲
 },
 [0x122F3]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F3, -- 𒋳
 },
 [0x122F4]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAG TIMES BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F4, -- 𒋴
 },
 [0x122F5]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAG TIMES GUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F5, -- 𒋵
 },
 [0x122F6]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAG TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F6, -- 𒋶
 },
 [0x122F7]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAG TIMES SHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F7, -- 𒋷
 },
 [0x122F8]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAG TIMES TUG0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F8, -- 𒋸
 },
 [0x122F9]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAG TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122F9, -- 𒋹
 },
 [0x122FA]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122FA, -- 𒋺
 },
 [0x122FB]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122FB, -- 𒋻
 },
 [0x122FC]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122FC, -- 𒋼
 },
 [0x122FD]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TE GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122FD, -- 𒋽
 },
 [0x122FE]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122FE, -- 𒋾
 },
 [0x122FF]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TI TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x122FF, -- 𒋿
 },
 [0x12300]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TIL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12300, -- 𒌀
 },
 [0x12301]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TIR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12301, -- 𒌁
 },
 [0x12302]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TIR TIMES TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12302, -- 𒌂
 },
 [0x12303]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TIR OVER TIR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12303, -- 𒌃
 },
 [0x12304]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TIR OVER TIR GAD OVER GAD GAR OVER GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12304, -- 𒌄
 },
 [0x12305]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12305, -- 𒌅
 },
 [0x12306]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TUG0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12306, -- 𒌆
 },
 [0x12307]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TUK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12307, -- 𒌇
 },
 [0x12308]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12308, -- 𒌈
 },
 [0x12309]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12309, -- 𒌉
 },
 [0x1230A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN TUR OVER TUR ZA OVER ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1230A, -- 𒌊
 },
 [0x1230B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1230B, -- 𒌋
 },
 [0x1230C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN U GUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1230C, -- 𒌌
 },
 [0x1230D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN U U U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1230D, -- 𒌍
 },
 [0x1230E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN U OVER U PA OVER PA GAR OVER GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1230E, -- 𒌎
 },
 [0x1230F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN U OVER U SUR OVER SUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1230F, -- 𒌏
 },
 [0x12310]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN U OVER U U REVERSED OVER U REVERSED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12310, -- 𒌐
 },
 [0x12311]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN U0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12311, -- 𒌑
 },
 [0x12312]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12312, -- 𒌒
 },
 [0x12313]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12313, -- 𒌓
 },
 [0x12314]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UD KUSHU0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12314, -- 𒌔
 },
 [0x12315]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UD TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12315, -- 𒌕
 },
 [0x12316]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UD TIMES MI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12316, -- 𒌖
 },
 [0x12317]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UD TIMES U PLUS U PLUS U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12317, -- 𒌗
 },
 [0x12318]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UD TIMES U PLUS U PLUS U GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12318, -- 𒌘
 },
 [0x12319]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UD GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12319, -- 𒌙
 },
 [0x1231A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UD SHESHIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1231A, -- 𒌚
 },
 [0x1231B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UD SHESHIG TIMES BAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1231B, -- 𒌛
 },
 [0x1231C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UDUG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1231C, -- 𒌜
 },
 [0x1231D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1231D, -- 𒌝
 },
 [0x1231E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UM TIMES LAGAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1231E, -- 𒌞
 },
 [0x1231F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UM TIMES ME PLUS DA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1231F, -- 𒌟
 },
 [0x12320]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UM TIMES SHA0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12320, -- 𒌠
 },
 [0x12321]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UM TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12321, -- 𒌡
 },
 [0x12322]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UMBIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12322, -- 𒌢
 },
 [0x12323]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UMUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12323, -- 𒌣
 },
 [0x12324]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UMUM TIMES KASKAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12324, -- 𒌤
 },
 [0x12325]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UMUM TIMES PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12325, -- 𒌥
 },
 [0x12326]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12326, -- 𒌦
 },
 [0x12327]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UN GUNU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12327, -- 𒌧
 },
 [0x12328]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12328, -- 𒌨
 },
 [0x12329]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR CROSSING UR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12329, -- 𒌩
 },
 [0x1232A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR SHESHIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1232A, -- 𒌪
 },
 [0x1232B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1232B, -- 𒌫
 },
 [0x1232C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0002 TIMES A PLUS HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1232C, -- 𒌬
 },
 [0x1232D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0002 TIMES A PLUS NA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1232D, -- 𒌭
 },
 [0x1232E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0002 TIMES AL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1232E, -- 𒌮
 },
 [0x1232F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0002 TIMES HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1232F, -- 𒌯
 },
 [0x12330]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0002 TIMES NUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12330, -- 𒌰
 },
 [0x12331]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0002 TIMES U0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12331, -- 𒌱
 },
 [0x12332]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0002 TIMES U0x0002 PLUS ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12332, -- 𒌲
 },
 [0x12333]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0002 TIMES U0x0002 PLUS BI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12333, -- 𒌳
 },
 [0x12334]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UR0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12334, -- 𒌴
 },
 [0x12335]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12335, -- 𒌵
 },
 [0x12336]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URI0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12336, -- 𒌶
 },
 [0x12337]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12337, -- 𒌷
 },
 [0x12338]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12338, -- 𒌸
 },
 [0x12339]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES ASHGAB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12339, -- 𒌹
 },
 [0x1233A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES BAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1233A, -- 𒌺
 },
 [0x1233B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES DUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1233B, -- 𒌻
 },
 [0x1233C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1233C, -- 𒌼
 },
 [0x1233D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES GAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1233D, -- 𒌽
 },
 [0x1233E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES GAN0x0002 TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1233E, -- 𒌾
 },
 [0x1233F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES GAR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1233F, -- 𒌿
 },
 [0x12340]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES GU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12340, -- 𒍀
 },
 [0x12341]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES HA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12341, -- 𒍁
 },
 [0x12342]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES IGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12342, -- 𒍂
 },
 [0x12343]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES IM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12343, -- 𒍃
 },
 [0x12344]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES ISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12344, -- 𒍄
 },
 [0x12345]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES KI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12345, -- 𒍅
 },
 [0x12346]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES LUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12346, -- 𒍆
 },
 [0x12347]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES MIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12347, -- 𒍇
 },
 [0x12348]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12348, -- 𒍈
 },
 [0x12349]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES SHE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12349, -- 𒍉
 },
 [0x1234A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES SIG0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1234A, -- 𒍊
 },
 [0x1234B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES TU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1234B, -- 𒍋
 },
 [0x1234C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES U PLUS GUD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1234C, -- 𒍌
 },
 [0x1234D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES UD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1234D, -- 𒍍
 },
 [0x1234E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URU TIMES URUDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1234E, -- 𒍎
 },
 [0x1234F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URUDA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1234F, -- 𒍏
 },
 [0x12350]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN URUDA TIMES U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12350, -- 𒍐
 },
 [0x12351]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN USH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12351, -- 𒍑
 },
 [0x12352]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN USH TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12352, -- 𒍒
 },
 [0x12353]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN USH TIMES KU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12353, -- 𒍓
 },
 [0x12354]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN USH TIMES KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12354, -- 𒍔
 },
 [0x12355]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN USH TIMES TAK0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12355, -- 𒍕
 },
 [0x12356]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN USHX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12356, -- 𒍖
 },
 [0x12357]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN USH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12357, -- 𒍗
 },
 [0x12358]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN USHUMX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12358, -- 𒍘
 },
 [0x12359]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UTUKI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12359, -- 𒍙
 },
 [0x1235A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UZ0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1235A, -- 𒍚
 },
 [0x1235B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UZ0x0003 TIMES KASKAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1235B, -- 𒍛
 },
 [0x1235C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN UZU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1235C, -- 𒍜
 },
 [0x1235D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1235D, -- 𒍝
 },
 [0x1235E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZA TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1235E, -- 𒍞
 },
 [0x1235F]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZA SQUARED TIMES KUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1235F, -- 𒍟
 },
 [0x12360]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZAG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12360, -- 𒍠
 },
 [0x12361]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZAMX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12361, -- 𒍡
 },
 [0x12362]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZE0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12362, -- 𒍢
 },
 [0x12363]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12363, -- 𒍣
 },
 [0x12364]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZI OVER ZI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12364, -- 𒍤
 },
 [0x12365]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZI0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12365, -- 𒍥
 },
 [0x12366]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZIB",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12366, -- 𒍦
 },
 [0x12367]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZIB KABA TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12367, -- 𒍧
 },
 [0x12368]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZIG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12368, -- 𒍨
 },
 [0x12369]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZIZ0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12369, -- 𒍩
 },
 [0x1236A]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1236A, -- 𒍪
 },
 [0x1236B]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZU0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1236B, -- 𒍫
 },
 [0x1236C]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZU0x0005 TIMES A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1236C, -- 𒍬
 },
 [0x1236D]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZUBUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1236D, -- 𒍭
 },
 [0x1236E]={
  ["category"]="lo",
  ["description"]="CUNEIFORM SIGN ZUM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1236E, -- 𒍮
 },
 [0x12400]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12400, -- 𒐀
 },
 [0x12401]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12401, -- 𒐁
 },
 [0x12402]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12402, -- 𒐂
 },
 [0x12403]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12403, -- 𒐃
 },
 [0x12404]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SIX ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12404, -- 𒐄
 },
 [0x12405]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SEVEN ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12405, -- 𒐅
 },
 [0x12406]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN EIGHT ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12406, -- 𒐆
 },
 [0x12407]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NINE ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12407, -- 𒐇
 },
 [0x12408]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12408, -- 𒐈
 },
 [0x12409]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12409, -- 𒐉
 },
 [0x1240A]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1240A, -- 𒐊
 },
 [0x1240B]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SIX DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1240B, -- 𒐋
 },
 [0x1240C]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SEVEN DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1240C, -- 𒐌
 },
 [0x1240D]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN EIGHT DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1240D, -- 𒐍
 },
 [0x1240E]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NINE DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1240E, -- 𒐎
 },
 [0x1240F]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1240F, -- 𒐏
 },
 [0x12410]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12410, -- 𒐐
 },
 [0x12411]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SIX U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12411, -- 𒐑
 },
 [0x12412]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SEVEN U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12412, -- 𒐒
 },
 [0x12413]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN EIGHT U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12413, -- 𒐓
 },
 [0x12414]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NINE U",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12414, -- 𒐔
 },
 [0x12415]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE GESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12415, -- 𒐕
 },
 [0x12416]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO GESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12416, -- 𒐖
 },
 [0x12417]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE GESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12417, -- 𒐗
 },
 [0x12418]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR GESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12418, -- 𒐘
 },
 [0x12419]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE GESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12419, -- 𒐙
 },
 [0x1241A]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SIX GESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1241A, -- 𒐚
 },
 [0x1241B]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SEVEN GESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1241B, -- 𒐛
 },
 [0x1241C]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN EIGHT GESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1241C, -- 𒐜
 },
 [0x1241D]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NINE GESH0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1241D, -- 𒐝
 },
 [0x1241E]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE GESHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1241E, -- 𒐞
 },
 [0x1241F]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO GESHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1241F, -- 𒐟
 },
 [0x12420]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE GESHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12420, -- 𒐠
 },
 [0x12421]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR GESHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12421, -- 𒐡
 },
 [0x12422]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE GESHU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12422, -- 𒐢
 },
 [0x12423]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO SHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12423, -- 𒐣
 },
 [0x12424]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE SHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12424, -- 𒐤
 },
 [0x12425]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE SHAR0x0002 VARIANT FORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12425, -- 𒐥
 },
 [0x12426]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR SHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12426, -- 𒐦
 },
 [0x12427]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE SHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12427, -- 𒐧
 },
 [0x12428]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SIX SHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12428, -- 𒐨
 },
 [0x12429]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SEVEN SHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12429, -- 𒐩
 },
 [0x1242A]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN EIGHT SHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1242A, -- 𒐪
 },
 [0x1242B]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NINE SHAR0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1242B, -- 𒐫
 },
 [0x1242C]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE SHARU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1242C, -- 𒐬
 },
 [0x1242D]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO SHARU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1242D, -- 𒐭
 },
 [0x1242E]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE SHARU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1242E, -- 𒐮
 },
 [0x1242F]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE SHARU VARIANT FORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1242F, -- 𒐯
 },
 [0x12430]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR SHARU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12430, -- 𒐰
 },
 [0x12431]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE SHARU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12431, -- 𒐱
 },
 [0x12432]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SHAR0x0002 TIMES GAL PLUS DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12432, -- 𒐲
 },
 [0x12433]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SHAR0x0002 TIMES GAL PLUS MIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12433, -- 𒐳
 },
 [0x12434]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE BURU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12434, -- 𒐴
 },
 [0x12435]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO BURU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12435, -- 𒐵
 },
 [0x12436]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE BURU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12436, -- 𒐶
 },
 [0x12437]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE BURU VARIANT FORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12437, -- 𒐷
 },
 [0x12438]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR BURU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12438, -- 𒐸
 },
 [0x12439]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE BURU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12439, -- 𒐹
 },
 [0x1243A]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE VARIANT FORM ESH0x0010",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1243A, -- 𒐺
 },
 [0x1243B]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE VARIANT FORM ESH0x0015",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1243B, -- 𒐻
 },
 [0x1243C]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1243C, -- 𒐼
 },
 [0x1243D]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1243D, -- 𒐽
 },
 [0x1243E]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1243E, -- 𒐾
 },
 [0x1243F]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1243F, -- 𒐿
 },
 [0x12440]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SIX VARIANT FORM ASH0x0009",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12440, -- 𒑀
 },
 [0x12441]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12441, -- 𒑁
 },
 [0x12442]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12442, -- 𒑂
 },
 [0x12443]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12443, -- 𒑃
 },
 [0x12444]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN EIGHT VARIANT FORM USSU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12444, -- 𒑄
 },
 [0x12445]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN EIGHT VARIANT FORM USSU0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12445, -- 𒑅
 },
 [0x12446]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12446, -- 𒑆
 },
 [0x12447]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12447, -- 𒑇
 },
 [0x12448]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12448, -- 𒑈
 },
 [0x12449]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12449, -- 𒑉
 },
 [0x1244A]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO ASH TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1244A, -- 𒑊
 },
 [0x1244B]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE ASH TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1244B, -- 𒑋
 },
 [0x1244C]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR ASH TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1244C, -- 𒑌
 },
 [0x1244D]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE ASH TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1244D, -- 𒑍
 },
 [0x1244E]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN SIX ASH TENU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1244E, -- 𒑎
 },
 [0x1244F]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE BAN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1244F, -- 𒑏
 },
 [0x12450]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO BAN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12450, -- 𒑐
 },
 [0x12451]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN THREE BAN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12451, -- 𒑑
 },
 [0x12452]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR BAN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12452, -- 𒑒
 },
 [0x12453]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FOUR BAN0x0002 VARIANT FORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12453, -- 𒑓
 },
 [0x12454]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE BAN0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12454, -- 𒑔
 },
 [0x12455]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE BAN0x0002 VARIANT FORM",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12455, -- 𒑕
 },
 [0x12456]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NIGIDAMIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12456, -- 𒑖
 },
 [0x12457]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN NIGIDAESH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12457, -- 𒑗
 },
 [0x12458]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE ESHE0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12458, -- 𒑘
 },
 [0x12459]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO ESHE0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12459, -- 𒑙
 },
 [0x1245A]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE THIRD DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1245A, -- 𒑚
 },
 [0x1245B]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO THIRDS DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1245B, -- 𒑛
 },
 [0x1245C]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN FIVE SIXTHS DISH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1245C, -- 𒑜
 },
 [0x1245D]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE THIRD VARIANT FORM A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1245D, -- 𒑝
 },
 [0x1245E]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN TWO THIRDS VARIANT FORM A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1245E, -- 𒑞
 },
 [0x1245F]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE EIGHTH ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1245F, -- 𒑟
 },
 [0x12460]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN ONE QUARTER ASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12460, -- 𒑠
 },
 [0x12461]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE SIXTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12461, -- 𒑡
 },
 [0x12462]={
  ["category"]="nl",
  ["description"]="CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE QUARTER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x12462, -- 𒑢
 },
 [0x12470]={
  ["category"]="po",
  ["description"]="CUNEIFORM PUNCTUATION SIGN OLD ASSYRIAN WORD DIVIDER",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x12470, -- 𒑰
 },
 [0x12471]={
  ["category"]="po",
  ["description"]="CUNEIFORM PUNCTUATION SIGN VERTICAL COLON",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x12471, -- 𒑱
 },
 [0x12472]={
  ["category"]="po",
  ["description"]="CUNEIFORM PUNCTUATION SIGN DIAGONAL COLON",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x12472, -- 𒑲
 },
 [0x12473]={
  ["category"]="po",
  ["description"]="CUNEIFORM PUNCTUATION SIGN DIAGONAL TRICOLON",
  ["linebreak"]="ba",
  ["unicodeslot"]=0x12473, -- 𒑳
 },
 [0x1D000]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PSILI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D000, -- 𝀀
 },
 [0x1D001]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DASEIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D001, -- 𝀁
 },
 [0x1D002]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PERISPOMENI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D002, -- 𝀂
 },
 [0x1D003]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL OXEIA EKFONITIKON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D003, -- 𝀃
 },
 [0x1D004]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL OXEIA DIPLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D004, -- 𝀄
 },
 [0x1D005]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL VAREIA EKFONITIKON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D005, -- 𝀅
 },
 [0x1D006]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL VAREIA DIPLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D006, -- 𝀆
 },
 [0x1D007]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KATHISTI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D007, -- 𝀇
 },
 [0x1D008]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SYRMATIKI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D008, -- 𝀈
 },
 [0x1D009]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PARAKLITIKI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D009, -- 𝀉
 },
 [0x1D00A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YPOKRISIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D00A, -- 𝀊
 },
 [0x1D00B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YPOKRISIS DIPLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D00B, -- 𝀋
 },
 [0x1D00C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KREMASTI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D00C, -- 𝀌
 },
 [0x1D00D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APESO EKFONITIKON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D00D, -- 𝀍
 },
 [0x1D00E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL EXO EKFONITIKON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D00E, -- 𝀎
 },
 [0x1D00F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TELEIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D00F, -- 𝀏
 },
 [0x1D010]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KENTIMATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D010, -- 𝀐
 },
 [0x1D011]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APOSTROFOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D011, -- 𝀑
 },
 [0x1D012]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APOSTROFOS DIPLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D012, -- 𝀒
 },
 [0x1D013]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SYNEVMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D013, -- 𝀓
 },
 [0x1D014]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL THITA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D014, -- 𝀔
 },
 [0x1D015]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL OLIGON ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D015, -- 𝀕
 },
 [0x1D016]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GORGON ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D016, -- 𝀖
 },
 [0x1D017]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PSILON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D017, -- 𝀗
 },
 [0x1D018]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL CHAMILON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D018, -- 𝀘
 },
 [0x1D019]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL VATHY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D019, -- 𝀙
 },
 [0x1D01A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ISON ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D01A, -- 𝀚
 },
 [0x1D01B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KENTIMA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D01B, -- 𝀛
 },
 [0x1D01C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KENTIMATA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D01C, -- 𝀜
 },
 [0x1D01D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SAXIMATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D01D, -- 𝀝
 },
 [0x1D01E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PARICHON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D01E, -- 𝀞
 },
 [0x1D01F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL STAVROS APODEXIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D01F, -- 𝀟
 },
 [0x1D020]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL OXEIAI ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D020, -- 𝀠
 },
 [0x1D021]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL VAREIAI ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D021, -- 𝀡
 },
 [0x1D022]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APODERMA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D022, -- 𝀢
 },
 [0x1D023]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APOTHEMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D023, -- 𝀣
 },
 [0x1D024]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KLASMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D024, -- 𝀤
 },
 [0x1D025]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL REVMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D025, -- 𝀥
 },
 [0x1D026]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PIASMA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D026, -- 𝀦
 },
 [0x1D027]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TINAGMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D027, -- 𝀧
 },
 [0x1D028]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ANATRICHISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D028, -- 𝀨
 },
 [0x1D029]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SEISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D029, -- 𝀩
 },
 [0x1D02A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SYNAGMA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D02A, -- 𝀪
 },
 [0x1D02B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SYNAGMA META STAVROU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D02B, -- 𝀫
 },
 [0x1D02C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL OYRANISMA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D02C, -- 𝀬
 },
 [0x1D02D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL THEMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D02D, -- 𝀭
 },
 [0x1D02E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL LEMOI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D02E, -- 𝀮
 },
 [0x1D02F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DYO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D02F, -- 𝀯
 },
 [0x1D030]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TRIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D030, -- 𝀰
 },
 [0x1D031]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TESSERA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D031, -- 𝀱
 },
 [0x1D032]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KRATIMATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D032, -- 𝀲
 },
 [0x1D033]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APESO EXO NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D033, -- 𝀳
 },
 [0x1D034]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D034, -- 𝀴
 },
 [0x1D035]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL IMIFTHORA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D035, -- 𝀵
 },
 [0x1D036]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TROMIKON ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D036, -- 𝀶
 },
 [0x1D037]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KATAVA TROMIKON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D037, -- 𝀷
 },
 [0x1D038]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PELASTON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D038, -- 𝀸
 },
 [0x1D039]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PSIFISTON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D039, -- 𝀹
 },
 [0x1D03A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KONTEVMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D03A, -- 𝀺
 },
 [0x1D03B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL CHOREVMA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D03B, -- 𝀻
 },
 [0x1D03C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL RAPISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D03C, -- 𝀼
 },
 [0x1D03D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PARAKALESMA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D03D, -- 𝀽
 },
 [0x1D03E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PARAKLITIKI ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D03E, -- 𝀾
 },
 [0x1D03F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ICHADIN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D03F, -- 𝀿
 },
 [0x1D040]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL NANA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D040, -- 𝁀
 },
 [0x1D041]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PETASMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D041, -- 𝁁
 },
 [0x1D042]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KONTEVMA ALLO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D042, -- 𝁂
 },
 [0x1D043]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TROMIKON ALLO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D043, -- 𝁃
 },
 [0x1D044]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL STRAGGISMATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D044, -- 𝁄
 },
 [0x1D045]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GRONTHISMATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D045, -- 𝁅
 },
 [0x1D046]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ISON NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D046, -- 𝁆
 },
 [0x1D047]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL OLIGON NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D047, -- 𝁇
 },
 [0x1D048]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL OXEIA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D048, -- 𝁈
 },
 [0x1D049]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PETASTI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D049, -- 𝁉
 },
 [0x1D04A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KOUFISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D04A, -- 𝁊
 },
 [0x1D04B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PETASTOKOUFISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D04B, -- 𝁋
 },
 [0x1D04C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KRATIMOKOUFISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D04C, -- 𝁌
 },
 [0x1D04D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PELASTON NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D04D, -- 𝁍
 },
 [0x1D04E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KENTIMATA NEO ANO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D04E, -- 𝁎
 },
 [0x1D04F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KENTIMA NEO ANO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D04F, -- 𝁏
 },
 [0x1D050]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YPSILI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D050, -- 𝁐
 },
 [0x1D051]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APOSTROFOS NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D051, -- 𝁑
 },
 [0x1D052]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APOSTROFOI SYNDESMOS NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D052, -- 𝁒
 },
 [0x1D053]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YPORROI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D053, -- 𝁓
 },
 [0x1D054]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KRATIMOYPORROON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D054, -- 𝁔
 },
 [0x1D055]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ELAFRON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D055, -- 𝁕
 },
 [0x1D056]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL CHAMILI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D056, -- 𝁖
 },
 [0x1D057]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MIKRON ISON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D057, -- 𝁗
 },
 [0x1D058]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL VAREIA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D058, -- 𝁘
 },
 [0x1D059]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PIASMA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D059, -- 𝁙
 },
 [0x1D05A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PSIFISTON NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D05A, -- 𝁚
 },
 [0x1D05B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL OMALON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D05B, -- 𝁛
 },
 [0x1D05C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ANTIKENOMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D05C, -- 𝁜
 },
 [0x1D05D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL LYGISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D05D, -- 𝁝
 },
 [0x1D05E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PARAKLITIKI NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D05E, -- 𝁞
 },
 [0x1D05F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PARAKALESMA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D05F, -- 𝁟
 },
 [0x1D060]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ETERON PARAKALESMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D060, -- 𝁠
 },
 [0x1D061]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KYLISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D061, -- 𝁡
 },
 [0x1D062]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ANTIKENOKYLISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D062, -- 𝁢
 },
 [0x1D063]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TROMIKON NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D063, -- 𝁣
 },
 [0x1D064]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL EKSTREPTON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D064, -- 𝁤
 },
 [0x1D065]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SYNAGMA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D065, -- 𝁥
 },
 [0x1D066]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SYRMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D066, -- 𝁦
 },
 [0x1D067]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL CHOREVMA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D067, -- 𝁧
 },
 [0x1D068]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL EPEGERMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D068, -- 𝁨
 },
 [0x1D069]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SEISMA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D069, -- 𝁩
 },
 [0x1D06A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL XIRON KLASMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D06A, -- 𝁪
 },
 [0x1D06B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TROMIKOPSIFISTON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D06B, -- 𝁫
 },
 [0x1D06C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PSIFISTOLYGISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D06C, -- 𝁬
 },
 [0x1D06D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TROMIKOLYGISMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D06D, -- 𝁭
 },
 [0x1D06E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TROMIKOPARAKALESMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D06E, -- 𝁮
 },
 [0x1D06F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PSIFISTOPARAKALESMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D06F, -- 𝁯
 },
 [0x1D070]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TROMIKOSYNAGMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D070, -- 𝁰
 },
 [0x1D071]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL PSIFISTOSYNAGMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D071, -- 𝁱
 },
 [0x1D072]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GORGOSYNTHETON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D072, -- 𝁲
 },
 [0x1D073]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ARGOSYNTHETON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D073, -- 𝁳
 },
 [0x1D074]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ETERON ARGOSYNTHETON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D074, -- 𝁴
 },
 [0x1D075]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL OYRANISMA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D075, -- 𝁵
 },
 [0x1D076]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL THEMATISMOS ESO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D076, -- 𝁶
 },
 [0x1D077]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL THEMATISMOS EXO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D077, -- 𝁷
 },
 [0x1D078]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL THEMA APLOUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D078, -- 𝁸
 },
 [0x1D079]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL THES KAI APOTHES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D079, -- 𝁹
 },
 [0x1D07A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KATAVASMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D07A, -- 𝁺
 },
 [0x1D07B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ENDOFONON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D07B, -- 𝁻
 },
 [0x1D07C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YFEN KATO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D07C, -- 𝁼
 },
 [0x1D07D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YFEN ANO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D07D, -- 𝁽
 },
 [0x1D07E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL STAVROS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D07E, -- 𝁾
 },
 [0x1D07F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KLASMA ANO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D07F, -- 𝁿
 },
 [0x1D080]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIPLI ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D080, -- 𝂀
 },
 [0x1D081]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KRATIMA ARCHAION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D081, -- 𝂁
 },
 [0x1D082]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KRATIMA ALLO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D082, -- 𝂂
 },
 [0x1D083]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KRATIMA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D083, -- 𝂃
 },
 [0x1D084]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APODERMA NEO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D084, -- 𝂄
 },
 [0x1D085]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D085, -- 𝂅
 },
 [0x1D086]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIPLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D086, -- 𝂆
 },
 [0x1D087]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TRIPLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D087, -- 𝂇
 },
 [0x1D088]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TETRAPLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D088, -- 𝂈
 },
 [0x1D089]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KORONIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D089, -- 𝂉
 },
 [0x1D08A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL LEIMMA ENOS CHRONOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D08A, -- 𝂊
 },
 [0x1D08B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL LEIMMA DYO CHRONON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D08B, -- 𝂋
 },
 [0x1D08C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL LEIMMA TRION CHRONON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D08C, -- 𝂌
 },
 [0x1D08D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL LEIMMA TESSARON CHRONON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D08D, -- 𝂍
 },
 [0x1D08E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL LEIMMA IMISEOS CHRONOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D08E, -- 𝂎
 },
 [0x1D08F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GORGON NEO ANO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D08F, -- 𝂏
 },
 [0x1D090]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON ARISTERA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D090, -- 𝂐
 },
 [0x1D091]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON DEXIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D091, -- 𝂑
 },
 [0x1D092]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIGORGON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D092, -- 𝂒
 },
 [0x1D093]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA KATO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D093, -- 𝂓
 },
 [0x1D094]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA ANO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D094, -- 𝂔
 },
 [0x1D095]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON DEXIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D095, -- 𝂕
 },
 [0x1D096]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL TRIGORGON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D096, -- 𝂖
 },
 [0x1D097]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ARGON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D097, -- 𝂗
 },
 [0x1D098]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL IMIDIARGON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D098, -- 𝂘
 },
 [0x1D099]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIARGON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D099, -- 𝂙
 },
 [0x1D09A]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL AGOGI POLI ARGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D09A, -- 𝂚
 },
 [0x1D09B]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL AGOGI ARGOTERI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D09B, -- 𝂛
 },
 [0x1D09C]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL AGOGI ARGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D09C, -- 𝂜
 },
 [0x1D09D]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL AGOGI METRIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D09D, -- 𝂝
 },
 [0x1D09E]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL AGOGI MESI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D09E, -- 𝂞
 },
 [0x1D09F]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL AGOGI GORGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D09F, -- 𝂟
 },
 [0x1D0A0]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL AGOGI GORGOTERI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A0, -- 𝂠
 },
 [0x1D0A1]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL AGOGI POLI GORGI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A1, -- 𝂡
 },
 [0x1D0A2]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A2, -- 𝂢
 },
 [0x1D0A3]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI PROTOS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A3, -- 𝂣
 },
 [0x1D0A4]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA DEYTEROS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A4, -- 𝂤
 },
 [0x1D0A5]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI DEYTEROS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A5, -- 𝂥
 },
 [0x1D0A6]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA TRITOS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A6, -- 𝂦
 },
 [0x1D0A7]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA TRIFONIAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A7, -- 𝂧
 },
 [0x1D0A8]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A8, -- 𝂨
 },
 [0x1D0A9]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS LEGETOS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0A9, -- 𝂩
 },
 [0x1D0AA]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA LEGETOS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0AA, -- 𝂪
 },
 [0x1D0AB]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0AB, -- 𝂫
 },
 [0x1D0AC]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ISAKIA TELOUS ICHIMATOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0AC, -- 𝂬
 },
 [0x1D0AD]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL APOSTROFOI TELOUS ICHIMATOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0AD, -- 𝂭
 },
 [0x1D0AE]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FANEROSIS TETRAFONIAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0AE, -- 𝂮
 },
 [0x1D0AF]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FANEROSIS MONOFONIAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0AF, -- 𝂯
 },
 [0x1D0B0]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FANEROSIS DIFONIAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B0, -- 𝂰
 },
 [0x1D0B1]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA VARYS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B1, -- 𝂱
 },
 [0x1D0B2]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOVARYS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B2, -- 𝂲
 },
 [0x1D0B3]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS TETARTOS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B3, -- 𝂳
 },
 [0x1D0B4]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GORTHMIKON N APLOUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B4, -- 𝂴
 },
 [0x1D0B5]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GORTHMIKON N DIPLOUN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B5, -- 𝂵
 },
 [0x1D0B6]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ENARXIS KAI FTHORA VOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B6, -- 𝂶
 },
 [0x1D0B7]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL IMIFONON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B7, -- 𝂷
 },
 [0x1D0B8]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL IMIFTHORON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B8, -- 𝂸
 },
 [0x1D0B9]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION DEYTEROU ICHOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0B9, -- 𝂹
 },
 [0x1D0BA]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0BA, -- 𝂺
 },
 [0x1D0BB]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NANA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0BB, -- 𝂻
 },
 [0x1D0BC]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA NAOS ICHOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0BC, -- 𝂼
 },
 [0x1D0BD]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0BD, -- 𝂽
 },
 [0x1D0BE]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON DIATONON DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0BE, -- 𝂾
 },
 [0x1D0BF]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI KE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0BF, -- 𝂿
 },
 [0x1D0C0]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI ZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C0, -- 𝃀
 },
 [0x1D0C1]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI KATO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C1, -- 𝃁
 },
 [0x1D0C2]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI ANO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C2, -- 𝃂
 },
 [0x1D0C3]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA DIFONIAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C3, -- 𝃃
 },
 [0x1D0C4]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA MONOFONIAS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C4, -- 𝃄
 },
 [0x1D0C5]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FHTORA SKLIRON CHROMA VASIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C5, -- 𝃅
 },
 [0x1D0C6]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON CHROMA SYNAFI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C6, -- 𝃆
 },
 [0x1D0C7]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA NENANO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C7, -- 𝃇
 },
 [0x1D0C8]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL CHROA ZYGOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C8, -- 𝃈
 },
 [0x1D0C9]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL CHROA KLITON",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0C9, -- 𝃉
 },
 [0x1D0CA]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL CHROA SPATHI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0CA, -- 𝃊
 },
 [0x1D0CB]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA I YFESIS TETARTIMORION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0CB, -- 𝃋
 },
 [0x1D0CC]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL FTHORA ENARMONIOS ANTIFONIA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0CC, -- 𝃌
 },
 [0x1D0CD]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YFESIS TRITIMORION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0CD, -- 𝃍
 },
 [0x1D0CE]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIESIS TRITIMORION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0CE, -- 𝃎
 },
 [0x1D0CF]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIESIS TETARTIMORION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0CF, -- 𝃏
 },
 [0x1D0D0]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIESIS APLI DYO DODEKATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D0, -- 𝃐
 },
 [0x1D0D1]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIESIS MONOGRAMMOS TESSERA DODEKATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D1, -- 𝃑
 },
 [0x1D0D2]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIESIS DIGRAMMOS EX DODEKATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D2, -- 𝃒
 },
 [0x1D0D3]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIESIS TRIGRAMMOS OKTO DODEKATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D3, -- 𝃓
 },
 [0x1D0D4]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YFESIS APLI DYO DODEKATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D4, -- 𝃔
 },
 [0x1D0D5]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YFESIS MONOGRAMMOS TESSERA DODEKATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D5, -- 𝃕
 },
 [0x1D0D6]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YFESIS DIGRAMMOS EX DODEKATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D6, -- 𝃖
 },
 [0x1D0D7]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL YFESIS TRIGRAMMOS OKTO DODEKATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D7, -- 𝃗
 },
 [0x1D0D8]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GENIKI DIESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D8, -- 𝃘
 },
 [0x1D0D9]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GENIKI YFESIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0D9, -- 𝃙
 },
 [0x1D0DA]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MIKRI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0DA, -- 𝃚
 },
 [0x1D0DB]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MEGALI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0DB, -- 𝃛
 },
 [0x1D0DC]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIASTOLI DIPLI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0DC, -- 𝃜
 },
 [0x1D0DD]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIASTOLI THESEOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0DD, -- 𝃝
 },
 [0x1D0DE]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0DE, -- 𝃞
 },
 [0x1D0DF]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS DISIMOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0DF, -- 𝃟
 },
 [0x1D0E0]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TRISIMOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E0, -- 𝃠
 },
 [0x1D0E1]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TETRASIMOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E1, -- 𝃡
 },
 [0x1D0E2]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E2, -- 𝃢
 },
 [0x1D0E3]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS DISIMOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E3, -- 𝃣
 },
 [0x1D0E4]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TRISIMOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E4, -- 𝃤
 },
 [0x1D0E5]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TETRASIMOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E5, -- 𝃥
 },
 [0x1D0E6]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIGRAMMA GG",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E6, -- 𝃦
 },
 [0x1D0E7]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL DIFTOGGOS OU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E7, -- 𝃧
 },
 [0x1D0E8]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL STIGMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E8, -- 𝃨
 },
 [0x1D0E9]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ARKTIKO PA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0E9, -- 𝃩
 },
 [0x1D0EA]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ARKTIKO VOU",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0EA, -- 𝃪
 },
 [0x1D0EB]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ARKTIKO GA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0EB, -- 𝃫
 },
 [0x1D0EC]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ARKTIKO DI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0EC, -- 𝃬
 },
 [0x1D0ED]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ARKTIKO KE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0ED, -- 𝃭
 },
 [0x1D0EE]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ARKTIKO ZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0EE, -- 𝃮
 },
 [0x1D0EF]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL ARKTIKO NI",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0EF, -- 𝃯
 },
 [0x1D0F0]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KENTIMATA NEO MESO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0F0, -- 𝃰
 },
 [0x1D0F1]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KENTIMA NEO MESO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0F1, -- 𝃱
 },
 [0x1D0F2]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KENTIMATA NEO KATO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0F2, -- 𝃲
 },
 [0x1D0F3]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KENTIMA NEO KATO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0F3, -- 𝃳
 },
 [0x1D0F4]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL KLASMA KATO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0F4, -- 𝃴
 },
 [0x1D0F5]={
  ["category"]="so",
  ["description"]="BYZANTINE MUSICAL SYMBOL GORGON NEO KATO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D0F5, -- 𝃵
 },
 [0x1D100]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SINGLE BARLINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D100, -- 𝄀
 },
 [0x1D101]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DOUBLE BARLINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D101, -- 𝄁
 },
 [0x1D102]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FINAL BARLINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D102, -- 𝄂
 },
 [0x1D103]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL REVERSE FINAL BARLINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D103, -- 𝄃
 },
 [0x1D104]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DASHED BARLINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D104, -- 𝄄
 },
 [0x1D105]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SHORT BARLINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D105, -- 𝄅
 },
 [0x1D106]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL LEFT REPEAT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D106, -- 𝄆
 },
 [0x1D107]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL RIGHT REPEAT SIGN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D107, -- 𝄇
 },
 [0x1D108]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL REPEAT DOTS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D108, -- 𝄈
 },
 [0x1D109]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DAL SEGNO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D109, -- 𝄉
 },
 [0x1D10A]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DA CAPO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D10A, -- 𝄊
 },
 [0x1D10B]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SEGNO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D10B, -- 𝄋
 },
 [0x1D10C]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CODA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D10C, -- 𝄌
 },
 [0x1D10D]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL REPEATED FIGURE-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D10D, -- 𝄍
 },
 [0x1D10E]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL REPEATED FIGURE-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D10E, -- 𝄎
 },
 [0x1D10F]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL REPEATED FIGURE-0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D10F, -- 𝄏
 },
 [0x1D110]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FERMATA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D110, -- 𝄐
 },
 [0x1D111]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FERMATA BELOW",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D111, -- 𝄑
 },
 [0x1D112]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL BREATH MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D112, -- 𝄒
 },
 [0x1D113]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CAESURA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D113, -- 𝄓
 },
 [0x1D114]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL BRACE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D114, -- 𝄔
 },
 [0x1D115]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL BRACKET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D115, -- 𝄕
 },
 [0x1D116]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ONE-LINE STAFF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D116, -- 𝄖
 },
 [0x1D117]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TWO-LINE STAFF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D117, -- 𝄗
 },
 [0x1D118]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL THREE-LINE STAFF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D118, -- 𝄘
 },
 [0x1D119]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FOUR-LINE STAFF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D119, -- 𝄙
 },
 [0x1D11A]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FIVE-LINE STAFF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D11A, -- 𝄚
 },
 [0x1D11B]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SIX-LINE STAFF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D11B, -- 𝄛
 },
 [0x1D11C]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SIX-STRING FRETBOARD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D11C, -- 𝄜
 },
 [0x1D11D]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FOUR-STRING FRETBOARD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D11D, -- 𝄝
 },
 [0x1D11E]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL G CLEF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D11E, -- 𝄞
 },
 [0x1D11F]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL G CLEF OTTAVA ALTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D11F, -- 𝄟
 },
 [0x1D120]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL G CLEF OTTAVA BASSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D120, -- 𝄠
 },
 [0x1D121]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL C CLEF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D121, -- 𝄡
 },
 [0x1D122]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL F CLEF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D122, -- 𝄢
 },
 [0x1D123]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL F CLEF OTTAVA ALTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D123, -- 𝄣
 },
 [0x1D124]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL F CLEF OTTAVA BASSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D124, -- 𝄤
 },
 [0x1D125]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DRUM CLEF-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D125, -- 𝄥
 },
 [0x1D126]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DRUM CLEF-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D126, -- 𝄦
 },
 [0x1D12A]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DOUBLE SHARP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D12A, -- 𝄪
 },
 [0x1D12B]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DOUBLE FLAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D12B, -- 𝄫
 },
 [0x1D12C]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FLAT UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D12C, -- 𝄬
 },
 [0x1D12D]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FLAT DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D12D, -- 𝄭
 },
 [0x1D12E]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL NATURAL UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D12E, -- 𝄮
 },
 [0x1D12F]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL NATURAL DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D12F, -- 𝄯
 },
 [0x1D130]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SHARP UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D130, -- 𝄰
 },
 [0x1D131]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SHARP DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D131, -- 𝄱
 },
 [0x1D132]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL QUARTER TONE SHARP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D132, -- 𝄲
 },
 [0x1D133]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL QUARTER TONE FLAT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D133, -- 𝄳
 },
 [0x1D134]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL COMMON TIME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D134, -- 𝄴
 },
 [0x1D135]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CUT TIME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D135, -- 𝄵
 },
 [0x1D136]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL OTTAVA ALTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D136, -- 𝄶
 },
 [0x1D137]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL OTTAVA BASSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D137, -- 𝄷
 },
 [0x1D138]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL QUINDICESIMA ALTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D138, -- 𝄸
 },
 [0x1D139]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL QUINDICESIMA BASSA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D139, -- 𝄹
 },
 [0x1D13A]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL MULTI REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D13A, -- 𝄺
 },
 [0x1D13B]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL WHOLE REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D13B, -- 𝄻
 },
 [0x1D13C]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL HALF REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D13C, -- 𝄼
 },
 [0x1D13D]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL QUARTER REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D13D, -- 𝄽
 },
 [0x1D13E]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL EIGHTH REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D13E, -- 𝄾
 },
 [0x1D13F]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SIXTEENTH REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D13F, -- 𝄿
 },
 [0x1D140]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL THIRTY-SECOND REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D140, -- 𝅀
 },
 [0x1D141]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SIXTY-FOURTH REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D141, -- 𝅁
 },
 [0x1D142]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D142, -- 𝅂
 },
 [0x1D143]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL X NOTEHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D143, -- 𝅃
 },
 [0x1D144]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL PLUS NOTEHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D144, -- 𝅄
 },
 [0x1D145]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CIRCLE X NOTEHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D145, -- 𝅅
 },
 [0x1D146]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SQUARE NOTEHEAD WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D146, -- 𝅆
 },
 [0x1D147]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SQUARE NOTEHEAD BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D147, -- 𝅇
 },
 [0x1D148]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD UP WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D148, -- 𝅈
 },
 [0x1D149]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD UP BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D149, -- 𝅉
 },
 [0x1D14A]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D14A, -- 𝅊
 },
 [0x1D14B]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D14B, -- 𝅋
 },
 [0x1D14C]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D14C, -- 𝅌
 },
 [0x1D14D]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D14D, -- 𝅍
 },
 [0x1D14E]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D14E, -- 𝅎
 },
 [0x1D14F]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D14F, -- 𝅏
 },
 [0x1D150]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D150, -- 𝅐
 },
 [0x1D151]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D151, -- 𝅑
 },
 [0x1D152]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL MOON NOTEHEAD WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D152, -- 𝅒
 },
 [0x1D153]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL MOON NOTEHEAD BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D153, -- 𝅓
 },
 [0x1D154]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D154, -- 𝅔
 },
 [0x1D155]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D155, -- 𝅕
 },
 [0x1D156]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL PARENTHESIS NOTEHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D156, -- 𝅖
 },
 [0x1D157]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL VOID NOTEHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D157, -- 𝅗
 },
 [0x1D158]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL NOTEHEAD BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D158, -- 𝅘
 },
 [0x1D159]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL NULL NOTEHEAD",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D159, -- 𝅙
 },
 [0x1D15A]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CLUSTER NOTEHEAD WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D15A, -- 𝅚
 },
 [0x1D15B]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CLUSTER NOTEHEAD BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D15B, -- 𝅛
 },
 [0x1D15C]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL BREVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D15C, -- 𝅜
 },
 [0x1D15D]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL WHOLE NOTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D15D, -- 𝅝
 },
 [0x1D15E]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL HALF NOTE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D157, 0x1D165 },
  ["unicodeslot"]=0x1D15E, -- 𝅗𝅥
 },
 [0x1D15F]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL QUARTER NOTE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D158, 0x1D165 },
  ["unicodeslot"]=0x1D15F, -- 𝅘𝅥
 },
 [0x1D160]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL EIGHTH NOTE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D15F, 0x1D16E },
  ["unicodeslot"]=0x1D160, -- 𝅘𝅥𝅮
 },
 [0x1D161]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SIXTEENTH NOTE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D15F, 0x1D16F },
  ["unicodeslot"]=0x1D161, -- 𝅘𝅥𝅯
 },
 [0x1D162]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL THIRTY-SECOND NOTE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D15F, 0x1D170 },
  ["unicodeslot"]=0x1D162, -- 𝅘𝅥𝅰
 },
 [0x1D163]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SIXTY-FOURTH NOTE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D15F, 0x1D171 },
  ["unicodeslot"]=0x1D163, -- 𝅘𝅥𝅱
 },
 [0x1D164]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH NOTE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D15F, 0x1D172 },
  ["unicodeslot"]=0x1D164, -- 𝅘𝅥𝅲
 },
 [0x1D165]={
  ["category"]="mc",
  ["description"]="MUSICAL SYMBOL COMBINING STEM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D165, -- 𝅥
 },
 [0x1D166]={
  ["category"]="mc",
  ["description"]="MUSICAL SYMBOL COMBINING SPRECHGESANG STEM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D166, -- 𝅦
 },
 [0x1D167]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING TREMOLO-0x0001",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D167, -- 𝅧
 },
 [0x1D168]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING TREMOLO-0x0002",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D168, -- 𝅨
 },
 [0x1D169]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING TREMOLO-0x0003",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D169, -- 𝅩
 },
 [0x1D16A]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FINGERED TREMOLO-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D16A, -- 𝅪
 },
 [0x1D16B]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FINGERED TREMOLO-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D16B, -- 𝅫
 },
 [0x1D16C]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FINGERED TREMOLO-0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D16C, -- 𝅬
 },
 [0x1D16D]={
  ["category"]="mc",
  ["description"]="MUSICAL SYMBOL COMBINING AUGMENTATION DOT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D16D, -- 𝅭
 },
 [0x1D16E]={
  ["category"]="mc",
  ["description"]="MUSICAL SYMBOL COMBINING FLAG-0x0001",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D16E, -- 𝅮
 },
 [0x1D16F]={
  ["category"]="mc",
  ["description"]="MUSICAL SYMBOL COMBINING FLAG-0x0002",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D16F, -- 𝅯
 },
 [0x1D170]={
  ["category"]="mc",
  ["description"]="MUSICAL SYMBOL COMBINING FLAG-0x0003",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D170, -- 𝅰
 },
 [0x1D171]={
  ["category"]="mc",
  ["description"]="MUSICAL SYMBOL COMBINING FLAG-0x0004",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D171, -- 𝅱
 },
 [0x1D172]={
  ["category"]="mc",
  ["description"]="MUSICAL SYMBOL COMBINING FLAG-0x0005",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D172, -- 𝅲
 },
 [0x1D173]={
  ["category"]="cf",
  ["description"]="MUSICAL SYMBOL BEGIN BEAM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D173, -- 𝅳
 },
 [0x1D174]={
  ["category"]="cf",
  ["description"]="MUSICAL SYMBOL END BEAM",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D174, -- 𝅴
 },
 [0x1D175]={
  ["category"]="cf",
  ["description"]="MUSICAL SYMBOL BEGIN TIE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D175, -- 𝅵
 },
 [0x1D176]={
  ["category"]="cf",
  ["description"]="MUSICAL SYMBOL END TIE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D176, -- 𝅶
 },
 [0x1D177]={
  ["category"]="cf",
  ["description"]="MUSICAL SYMBOL BEGIN SLUR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D177, -- 𝅷
 },
 [0x1D178]={
  ["category"]="cf",
  ["description"]="MUSICAL SYMBOL END SLUR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D178, -- 𝅸
 },
 [0x1D179]={
  ["category"]="cf",
  ["description"]="MUSICAL SYMBOL BEGIN PHRASE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D179, -- 𝅹
 },
 [0x1D17A]={
  ["category"]="cf",
  ["description"]="MUSICAL SYMBOL END PHRASE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D17A, -- 𝅺
 },
 [0x1D17B]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D17B, -- 𝅻
 },
 [0x1D17C]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING STACCATO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D17C, -- 𝅼
 },
 [0x1D17D]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING TENUTO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D17D, -- 𝅽
 },
 [0x1D17E]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING STACCATISSIMO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D17E, -- 𝅾
 },
 [0x1D17F]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING MARCATO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D17F, -- 𝅿
 },
 [0x1D180]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING MARCATO-STACCATO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D180, -- 𝆀
 },
 [0x1D181]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING ACCENT-STACCATO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D181, -- 𝆁
 },
 [0x1D182]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING LOURE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D182, -- 𝆂
 },
 [0x1D183]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ARPEGGIATO UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D183, -- 𝆃
 },
 [0x1D184]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ARPEGGIATO DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D184, -- 𝆄
 },
 [0x1D185]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING DOIT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D185, -- 𝆅
 },
 [0x1D186]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING RIP",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D186, -- 𝆆
 },
 [0x1D187]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING FLIP",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D187, -- 𝆇
 },
 [0x1D188]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING SMEAR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D188, -- 𝆈
 },
 [0x1D189]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING BEND",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D189, -- 𝆉
 },
 [0x1D18A]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING DOUBLE TONGUE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D18A, -- 𝆊
 },
 [0x1D18B]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING TRIPLE TONGUE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D18B, -- 𝆋
 },
 [0x1D18C]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL RINFORZANDO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D18C, -- 𝆌
 },
 [0x1D18D]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SUBITO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D18D, -- 𝆍
 },
 [0x1D18E]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL Z",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D18E, -- 𝆎
 },
 [0x1D18F]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL PIANO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D18F, -- 𝆏
 },
 [0x1D190]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL MEZZO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D190, -- 𝆐
 },
 [0x1D191]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FORTE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D191, -- 𝆑
 },
 [0x1D192]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CRESCENDO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D192, -- 𝆒
 },
 [0x1D193]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DECRESCENDO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D193, -- 𝆓
 },
 [0x1D194]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL GRACE NOTE SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D194, -- 𝆔
 },
 [0x1D195]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL GRACE NOTE NO SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D195, -- 𝆕
 },
 [0x1D196]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D196, -- 𝆖
 },
 [0x1D197]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TURN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D197, -- 𝆗
 },
 [0x1D198]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL INVERTED TURN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D198, -- 𝆘
 },
 [0x1D199]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TURN SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D199, -- 𝆙
 },
 [0x1D19A]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TURN UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D19A, -- 𝆚
 },
 [0x1D19B]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D19B, -- 𝆛
 },
 [0x1D19C]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D19C, -- 𝆜
 },
 [0x1D19D]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D19D, -- 𝆝
 },
 [0x1D19E]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D19E, -- 𝆞
 },
 [0x1D19F]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D19F, -- 𝆟
 },
 [0x1D1A0]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x0006",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A0, -- 𝆠
 },
 [0x1D1A1]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x0007",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A1, -- 𝆡
 },
 [0x1D1A2]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x0008",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A2, -- 𝆢
 },
 [0x1D1A3]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x0009",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A3, -- 𝆣
 },
 [0x1D1A4]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x000A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A4, -- 𝆤
 },
 [0x1D1A5]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL ORNAMENT STROKE-0x000B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A5, -- 𝆥
 },
 [0x1D1A6]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL HAUPTSTIMME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A6, -- 𝆦
 },
 [0x1D1A7]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL NEBENSTIMME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A7, -- 𝆧
 },
 [0x1D1A8]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL END OF STIMME",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A8, -- 𝆨
 },
 [0x1D1A9]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DEGREE SLASH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1A9, -- 𝆩
 },
 [0x1D1AA]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING DOWN BOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D1AA, -- 𝆪
 },
 [0x1D1AB]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING UP BOW",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D1AB, -- 𝆫
 },
 [0x1D1AC]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING HARMONIC",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D1AC, -- 𝆬
 },
 [0x1D1AD]={
  ["category"]="mn",
  ["description"]="MUSICAL SYMBOL COMBINING SNAP PIZZICATO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D1AD, -- 𝆭
 },
 [0x1D1AE]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL PEDAL MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1AE, -- 𝆮
 },
 [0x1D1AF]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL PEDAL UP MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1AF, -- 𝆯
 },
 [0x1D1B0]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL HALF PEDAL MARK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B0, -- 𝆰
 },
 [0x1D1B1]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL GLISSANDO UP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B1, -- 𝆱
 },
 [0x1D1B2]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL GLISSANDO DOWN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B2, -- 𝆲
 },
 [0x1D1B3]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL WITH FINGERNAILS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B3, -- 𝆳
 },
 [0x1D1B4]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DAMP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B4, -- 𝆴
 },
 [0x1D1B5]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL DAMP ALL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B5, -- 𝆵
 },
 [0x1D1B6]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL MAXIMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B6, -- 𝆶
 },
 [0x1D1B7]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL LONGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B7, -- 𝆷
 },
 [0x1D1B8]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL BREVIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B8, -- 𝆸
 },
 [0x1D1B9]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SEMIBREVIS WHITE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1B9, -- 𝆹
 },
 [0x1D1BA]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SEMIBREVIS BLACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1BA, -- 𝆺
 },
 [0x1D1BB]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL MINIMA",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D1B9, 0x1D165 },
  ["unicodeslot"]=0x1D1BB, -- 𝆹𝅥
 },
 [0x1D1BC]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL MINIMA BLACK",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D1BA, 0x1D165 },
  ["unicodeslot"]=0x1D1BC, -- 𝆺𝅥
 },
 [0x1D1BD]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SEMIMINIMA WHITE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D1BB, 0x1D16E },
  ["unicodeslot"]=0x1D1BD, -- 𝆹𝅥𝅮
 },
 [0x1D1BE]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SEMIMINIMA BLACK",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D1BC, 0x1D16E },
  ["unicodeslot"]=0x1D1BE, -- 𝆺𝅥𝅮
 },
 [0x1D1BF]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FUSA WHITE",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D1BB, 0x1D16F },
  ["unicodeslot"]=0x1D1BF, -- 𝆹𝅥𝅯
 },
 [0x1D1C0]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL FUSA BLACK",
  ["linebreak"]="al",
  ["specials"]={ "char", 0x1D1BC, 0x1D16F },
  ["unicodeslot"]=0x1D1C0, -- 𝆺𝅥𝅯
 },
 [0x1D1C1]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL LONGA PERFECTA REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C1, -- 𝇁
 },
 [0x1D1C2]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL LONGA IMPERFECTA REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C2, -- 𝇂
 },
 [0x1D1C3]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL BREVIS REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C3, -- 𝇃
 },
 [0x1D1C4]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SEMIBREVIS REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C4, -- 𝇄
 },
 [0x1D1C5]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL MINIMA REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C5, -- 𝇅
 },
 [0x1D1C6]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SEMIMINIMA REST",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C6, -- 𝇆
 },
 [0x1D1C7]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C7, -- 𝇇
 },
 [0x1D1C8]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE IMPERFECTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C8, -- 𝇈
 },
 [0x1D1C9]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA DIMINUTION-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1C9, -- 𝇉
 },
 [0x1D1CA]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE PERFECTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1CA, -- 𝇊
 },
 [0x1D1CB]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1CB, -- 𝇋
 },
 [0x1D1CC]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1CC, -- 𝇌
 },
 [0x1D1CD]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1CD, -- 𝇍
 },
 [0x1D1CE]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1CE, -- 𝇎
 },
 [0x1D1CF]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CROIX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1CF, -- 𝇏
 },
 [0x1D1D0]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL GREGORIAN C CLEF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D0, -- 𝇐
 },
 [0x1D1D1]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL GREGORIAN F CLEF",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D1, -- 𝇑
 },
 [0x1D1D2]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SQUARE B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D2, -- 𝇒
 },
 [0x1D1D3]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL VIRGA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D3, -- 𝇓
 },
 [0x1D1D4]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL PODATUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D4, -- 𝇔
 },
 [0x1D1D5]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CLIVIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D5, -- 𝇕
 },
 [0x1D1D6]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SCANDICUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D6, -- 𝇖
 },
 [0x1D1D7]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL CLIMACUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D7, -- 𝇗
 },
 [0x1D1D8]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TORCULUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D8, -- 𝇘
 },
 [0x1D1D9]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL PORRECTUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1D9, -- 𝇙
 },
 [0x1D1DA]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL PORRECTUS FLEXUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1DA, -- 𝇚
 },
 [0x1D1DB]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL SCANDICUS FLEXUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1DB, -- 𝇛
 },
 [0x1D1DC]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL TORCULUS RESUPINUS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1DC, -- 𝇜
 },
 [0x1D1DD]={
  ["category"]="so",
  ["description"]="MUSICAL SYMBOL PES SUBPUNCTIS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D1DD, -- 𝇝
 },
 [0x1D200]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D200, -- 𝈀
 },
 [0x1D201]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D201, -- 𝈁
 },
 [0x1D202]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0003",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D202, -- 𝈂
 },
 [0x1D203]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D203, -- 𝈃
 },
 [0x1D204]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D204, -- 𝈄
 },
 [0x1D205]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0006",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D205, -- 𝈅
 },
 [0x1D206]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0007",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D206, -- 𝈆
 },
 [0x1D207]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0008",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D207, -- 𝈇
 },
 [0x1D208]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0009",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D208, -- 𝈈
 },
 [0x1D209]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x000A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D209, -- 𝈉
 },
 [0x1D20A]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x000B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D20A, -- 𝈊
 },
 [0x1D20B]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x000C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D20B, -- 𝈋
 },
 [0x1D20C]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x000D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D20C, -- 𝈌
 },
 [0x1D20D]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x000E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D20D, -- 𝈍
 },
 [0x1D20E]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x000F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D20E, -- 𝈎
 },
 [0x1D20F]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0010",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D20F, -- 𝈏
 },
 [0x1D210]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0011",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D210, -- 𝈐
 },
 [0x1D211]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0012",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D211, -- 𝈑
 },
 [0x1D212]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0013",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D212, -- 𝈒
 },
 [0x1D213]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0014",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D213, -- 𝈓
 },
 [0x1D214]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0015",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D214, -- 𝈔
 },
 [0x1D215]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0016",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D215, -- 𝈕
 },
 [0x1D216]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0017",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D216, -- 𝈖
 },
 [0x1D217]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0018",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D217, -- 𝈗
 },
 [0x1D218]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0032",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D218, -- 𝈘
 },
 [0x1D219]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0033",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D219, -- 𝈙
 },
 [0x1D21A]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0034",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D21A, -- 𝈚
 },
 [0x1D21B]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0035",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D21B, -- 𝈛
 },
 [0x1D21C]={
  ["category"]="so",
  ["description"]="GREEK VOCAL NOTATION SYMBOL-0x0036",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D21C, -- 𝈜
 },
 [0x1D21D]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0001",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D21D, -- 𝈝
 },
 [0x1D21E]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0002",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D21E, -- 𝈞
 },
 [0x1D21F]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0004",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D21F, -- 𝈟
 },
 [0x1D220]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0005",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D220, -- 𝈠
 },
 [0x1D221]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0007",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D221, -- 𝈡
 },
 [0x1D222]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0008",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D222, -- 𝈢
 },
 [0x1D223]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x000B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D223, -- 𝈣
 },
 [0x1D224]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x000C",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D224, -- 𝈤
 },
 [0x1D225]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x000D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D225, -- 𝈥
 },
 [0x1D226]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x000E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D226, -- 𝈦
 },
 [0x1D227]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0011",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D227, -- 𝈧
 },
 [0x1D228]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0012",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D228, -- 𝈨
 },
 [0x1D229]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0013",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D229, -- 𝈩
 },
 [0x1D22A]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0017",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D22A, -- 𝈪
 },
 [0x1D22B]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0018",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D22B, -- 𝈫
 },
 [0x1D22C]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0019",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D22C, -- 𝈬
 },
 [0x1D22D]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x001A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D22D, -- 𝈭
 },
 [0x1D22E]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x001B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D22E, -- 𝈮
 },
 [0x1D22F]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x001D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D22F, -- 𝈯
 },
 [0x1D230]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x001E",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D230, -- 𝈰
 },
 [0x1D231]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0020",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D231, -- 𝈱
 },
 [0x1D232]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0024",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D232, -- 𝈲
 },
 [0x1D233]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0025",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D233, -- 𝈳
 },
 [0x1D234]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0026",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D234, -- 𝈴
 },
 [0x1D235]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0027",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D235, -- 𝈵
 },
 [0x1D236]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0028",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D236, -- 𝈶
 },
 [0x1D237]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x002A",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D237, -- 𝈷
 },
 [0x1D238]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x002B",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D238, -- 𝈸
 },
 [0x1D239]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x002D",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D239, -- 𝈹
 },
 [0x1D23A]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x002F",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D23A, -- 𝈺
 },
 [0x1D23B]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0030",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D23B, -- 𝈻
 },
 [0x1D23C]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0031",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D23C, -- 𝈼
 },
 [0x1D23D]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0032",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D23D, -- 𝈽
 },
 [0x1D23E]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0033",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D23E, -- 𝈾
 },
 [0x1D23F]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0034",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D23F, -- 𝈿
 },
 [0x1D240]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0035",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D240, -- 𝉀
 },
 [0x1D241]={
  ["category"]="so",
  ["description"]="GREEK INSTRUMENTAL NOTATION SYMBOL-0x0036",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D241, -- 𝉁
 },
 [0x1D242]={
  ["category"]="mn",
  ["description"]="COMBINING GREEK MUSICAL TRISEME",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D242, -- 𝉂
 },
 [0x1D243]={
  ["category"]="mn",
  ["description"]="COMBINING GREEK MUSICAL TETRASEME",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D243, -- 𝉃
 },
 [0x1D244]={
  ["category"]="mn",
  ["description"]="COMBINING GREEK MUSICAL PENTASEME",
  ["linebreak"]="cm",
  ["unicodeslot"]=0x1D244, -- 𝉄
 },
 [0x1D245]={
  ["category"]="so",
  ["description"]="GREEK MUSICAL LEIMMA",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D245, -- 𝉅
 },
 [0x1D300]={
  ["category"]="so",
  ["description"]="MONOGRAM FOR EARTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D300, -- 𝌀
 },
 [0x1D301]={
  ["category"]="so",
  ["description"]="DIGRAM FOR HEAVENLY EARTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D301, -- 𝌁
 },
 [0x1D302]={
  ["category"]="so",
  ["description"]="DIGRAM FOR HUMAN EARTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D302, -- 𝌂
 },
 [0x1D303]={
  ["category"]="so",
  ["description"]="DIGRAM FOR EARTHLY HEAVEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D303, -- 𝌃
 },
 [0x1D304]={
  ["category"]="so",
  ["description"]="DIGRAM FOR EARTHLY HUMAN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D304, -- 𝌄
 },
 [0x1D305]={
  ["category"]="so",
  ["description"]="DIGRAM FOR EARTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D305, -- 𝌅
 },
 [0x1D306]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR CENTRE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D306, -- 𝌆
 },
 [0x1D307]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR FULL CIRCLE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D307, -- 𝌇
 },
 [0x1D308]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR MIRED",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D308, -- 𝌈
 },
 [0x1D309]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR BARRIER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D309, -- 𝌉
 },
 [0x1D30A]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR KEEPING SMALL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D30A, -- 𝌊
 },
 [0x1D30B]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR CONTRARIETY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D30B, -- 𝌋
 },
 [0x1D30C]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR ASCENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D30C, -- 𝌌
 },
 [0x1D30D]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR OPPOSITION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D30D, -- 𝌍
 },
 [0x1D30E]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR BRANCHING OUT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D30E, -- 𝌎
 },
 [0x1D30F]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DEFECTIVENESS OR DISTORTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D30F, -- 𝌏
 },
 [0x1D310]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DIVERGENCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D310, -- 𝌐
 },
 [0x1D311]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR YOUTHFULNESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D311, -- 𝌑
 },
 [0x1D312]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR INCREASE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D312, -- 𝌒
 },
 [0x1D313]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR PENETRATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D313, -- 𝌓
 },
 [0x1D314]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR REACH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D314, -- 𝌔
 },
 [0x1D315]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR CONTACT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D315, -- 𝌕
 },
 [0x1D316]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR HOLDING BACK",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D316, -- 𝌖
 },
 [0x1D317]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR WAITING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D317, -- 𝌗
 },
 [0x1D318]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR FOLLOWING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D318, -- 𝌘
 },
 [0x1D319]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR ADVANCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D319, -- 𝌙
 },
 [0x1D31A]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR RELEASE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D31A, -- 𝌚
 },
 [0x1D31B]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR RESISTANCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D31B, -- 𝌛
 },
 [0x1D31C]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR EASE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D31C, -- 𝌜
 },
 [0x1D31D]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR JOY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D31D, -- 𝌝
 },
 [0x1D31E]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR CONTENTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D31E, -- 𝌞
 },
 [0x1D31F]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR ENDEAVOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D31F, -- 𝌟
 },
 [0x1D320]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DUTIES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D320, -- 𝌠
 },
 [0x1D321]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR CHANGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D321, -- 𝌡
 },
 [0x1D322]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DECISIVENESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D322, -- 𝌢
 },
 [0x1D323]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR BOLD RESOLUTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D323, -- 𝌣
 },
 [0x1D324]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR PACKING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D324, -- 𝌤
 },
 [0x1D325]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR LEGION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D325, -- 𝌥
 },
 [0x1D326]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR CLOSENESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D326, -- 𝌦
 },
 [0x1D327]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR KINSHIP",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D327, -- 𝌧
 },
 [0x1D328]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR GATHERING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D328, -- 𝌨
 },
 [0x1D329]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR STRENGTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D329, -- 𝌩
 },
 [0x1D32A]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR PURITY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D32A, -- 𝌪
 },
 [0x1D32B]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR FULLNESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D32B, -- 𝌫
 },
 [0x1D32C]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR RESIDENCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D32C, -- 𝌬
 },
 [0x1D32D]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR LAW OR MODEL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D32D, -- 𝌭
 },
 [0x1D32E]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR RESPONSE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D32E, -- 𝌮
 },
 [0x1D32F]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR GOING TO MEET",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D32F, -- 𝌯
 },
 [0x1D330]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR ENCOUNTERS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D330, -- 𝌰
 },
 [0x1D331]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR STOVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D331, -- 𝌱
 },
 [0x1D332]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR GREATNESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D332, -- 𝌲
 },
 [0x1D333]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR ENLARGEMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D333, -- 𝌳
 },
 [0x1D334]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR PATTERN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D334, -- 𝌴
 },
 [0x1D335]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR RITUAL",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D335, -- 𝌵
 },
 [0x1D336]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR FLIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D336, -- 𝌶
 },
 [0x1D337]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR VASTNESS OR WASTING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D337, -- 𝌷
 },
 [0x1D338]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR CONSTANCY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D338, -- 𝌸
 },
 [0x1D339]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR MEASURE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D339, -- 𝌹
 },
 [0x1D33A]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR ETERNITY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D33A, -- 𝌺
 },
 [0x1D33B]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR UNITY",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D33B, -- 𝌻
 },
 [0x1D33C]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DIMINISHMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D33C, -- 𝌼
 },
 [0x1D33D]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR CLOSED MOUTH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D33D, -- 𝌽
 },
 [0x1D33E]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR GUARDEDNESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D33E, -- 𝌾
 },
 [0x1D33F]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR GATHERING IN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D33F, -- 𝌿
 },
 [0x1D340]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR MASSING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D340, -- 𝍀
 },
 [0x1D341]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR ACCUMULATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D341, -- 𝍁
 },
 [0x1D342]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR EMBELLISHMENT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D342, -- 𝍂
 },
 [0x1D343]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DOUBT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D343, -- 𝍃
 },
 [0x1D344]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR WATCH",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D344, -- 𝍄
 },
 [0x1D345]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR SINKING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D345, -- 𝍅
 },
 [0x1D346]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR INNER",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D346, -- 𝍆
 },
 [0x1D347]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DEPARTURE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D347, -- 𝍇
 },
 [0x1D348]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DARKENING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D348, -- 𝍈
 },
 [0x1D349]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DIMMING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D349, -- 𝍉
 },
 [0x1D34A]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR EXHAUSTION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D34A, -- 𝍊
 },
 [0x1D34B]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR SEVERANCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D34B, -- 𝍋
 },
 [0x1D34C]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR STOPPAGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D34C, -- 𝍌
 },
 [0x1D34D]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR HARDNESS",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D34D, -- 𝍍
 },
 [0x1D34E]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR COMPLETION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D34E, -- 𝍎
 },
 [0x1D34F]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR CLOSURE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D34F, -- 𝍏
 },
 [0x1D350]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR FAILURE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D350, -- 𝍐
 },
 [0x1D351]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR AGGRAVATION",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D351, -- 𝍑
 },
 [0x1D352]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR COMPLIANCE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D352, -- 𝍒
 },
 [0x1D353]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR ON THE VERGE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D353, -- 𝍓
 },
 [0x1D354]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR DIFFICULTIES",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D354, -- 𝍔
 },
 [0x1D355]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR LABOURING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D355, -- 𝍕
 },
 [0x1D356]={
  ["category"]="so",
  ["description"]="TETRAGRAM FOR FOSTERING",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D356, -- 𝍖
 },
 [0x1D360]={
  ["category"]="no",
  ["description"]="COUNTING ROD UNIT DIGIT ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D360, -- 𝍠
 },
 [0x1D361]={
  ["category"]="no",
  ["description"]="COUNTING ROD UNIT DIGIT TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D361, -- 𝍡
 },
 [0x1D362]={
  ["category"]="no",
  ["description"]="COUNTING ROD UNIT DIGIT THREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D362, -- 𝍢
 },
 [0x1D363]={
  ["category"]="no",
  ["description"]="COUNTING ROD UNIT DIGIT FOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D363, -- 𝍣
 },
 [0x1D364]={
  ["category"]="no",
  ["description"]="COUNTING ROD UNIT DIGIT FIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D364, -- 𝍤
 },
 [0x1D365]={
  ["category"]="no",
  ["description"]="COUNTING ROD UNIT DIGIT SIX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D365, -- 𝍥
 },
 [0x1D366]={
  ["category"]="no",
  ["description"]="COUNTING ROD UNIT DIGIT SEVEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D366, -- 𝍦
 },
 [0x1D367]={
  ["category"]="no",
  ["description"]="COUNTING ROD UNIT DIGIT EIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D367, -- 𝍧
 },
 [0x1D368]={
  ["category"]="no",
  ["description"]="COUNTING ROD UNIT DIGIT NINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D368, -- 𝍨
 },
 [0x1D369]={
  ["category"]="no",
  ["description"]="COUNTING ROD TENS DIGIT ONE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D369, -- 𝍩
 },
 [0x1D36A]={
  ["category"]="no",
  ["description"]="COUNTING ROD TENS DIGIT TWO",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D36A, -- 𝍪
 },
 [0x1D36B]={
  ["category"]="no",
  ["description"]="COUNTING ROD TENS DIGIT THREE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D36B, -- 𝍫
 },
 [0x1D36C]={
  ["category"]="no",
  ["description"]="COUNTING ROD TENS DIGIT FOUR",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D36C, -- 𝍬
 },
 [0x1D36D]={
  ["category"]="no",
  ["description"]="COUNTING ROD TENS DIGIT FIVE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D36D, -- 𝍭
 },
 [0x1D36E]={
  ["category"]="no",
  ["description"]="COUNTING ROD TENS DIGIT SIX",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D36E, -- 𝍮
 },
 [0x1D36F]={
  ["category"]="no",
  ["description"]="COUNTING ROD TENS DIGIT SEVEN",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D36F, -- 𝍯
 },
 [0x1D370]={
  ["category"]="no",
  ["description"]="COUNTING ROD TENS DIGIT EIGHT",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D370, -- 𝍰
 },
 [0x1D371]={
  ["category"]="no",
  ["description"]="COUNTING ROD TENS DIGIT NINE",
  ["linebreak"]="al",
  ["unicodeslot"]=0x1D371, -- 𝍱
 },
 [0x1D400]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D400, -- 𝐀
 },
 [0x1D401]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D401, -- 𝐁
 },
 [0x1D402]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D402, -- 𝐂
 },
 [0x1D403]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D403, -- 𝐃
 },
 [0x1D404]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D404, -- 𝐄
 },
 [0x1D405]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D405, -- 𝐅
 },
 [0x1D406]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D406, -- 𝐆
 },
 [0x1D407]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D407, -- 𝐇
 },
 [0x1D408]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D408, -- 𝐈
 },
 [0x1D409]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D409, -- 𝐉
 },
 [0x1D40A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D40A, -- 𝐊
 },
 [0x1D40B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D40B, -- 𝐋
 },
 [0x1D40C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D40C, -- 𝐌
 },
 [0x1D40D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D40D, -- 𝐍
 },
 [0x1D40E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D40E, -- 𝐎
 },
 [0x1D40F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D40F, -- 𝐏
 },
 [0x1D410]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D410, -- 𝐐
 },
 [0x1D411]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D411, -- 𝐑
 },
 [0x1D412]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D412, -- 𝐒
 },
 [0x1D413]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D413, -- 𝐓
 },
 [0x1D414]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D414, -- 𝐔
 },
 [0x1D415]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D415, -- 𝐕
 },
 [0x1D416]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D416, -- 𝐖
 },
 [0x1D417]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D417, -- 𝐗
 },
 [0x1D418]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D418, -- 𝐘
 },
 [0x1D419]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D419, -- 𝐙
 },
 [0x1D41A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D41A, -- 𝐚
 },
 [0x1D41B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D41B, -- 𝐛
 },
 [0x1D41C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D41C, -- 𝐜
 },
 [0x1D41D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D41D, -- 𝐝
 },
 [0x1D41E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D41E, -- 𝐞
 },
 [0x1D41F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D41F, -- 𝐟
 },
 [0x1D420]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D420, -- 𝐠
 },
 [0x1D421]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D421, -- 𝐡
 },
 [0x1D422]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D422, -- 𝐢
 },
 [0x1D423]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D423, -- 𝐣
 },
 [0x1D424]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D424, -- 𝐤
 },
 [0x1D425]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D425, -- 𝐥
 },
 [0x1D426]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D426, -- 𝐦
 },
 [0x1D427]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D427, -- 𝐧
 },
 [0x1D428]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D428, -- 𝐨
 },
 [0x1D429]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D429, -- 𝐩
 },
 [0x1D42A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D42A, -- 𝐪
 },
 [0x1D42B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D42B, -- 𝐫
 },
 [0x1D42C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D42C, -- 𝐬
 },
 [0x1D42D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D42D, -- 𝐭
 },
 [0x1D42E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D42E, -- 𝐮
 },
 [0x1D42F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D42F, -- 𝐯
 },
 [0x1D430]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D430, -- 𝐰
 },
 [0x1D431]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D431, -- 𝐱
 },
 [0x1D432]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D432, -- 𝐲
 },
 [0x1D433]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D433, -- 𝐳
 },
 [0x1D434]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D434, -- 𝐴
 },
 [0x1D435]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D435, -- 𝐵
 },
 [0x1D436]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D436, -- 𝐶
 },
 [0x1D437]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D437, -- 𝐷
 },
 [0x1D438]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D438, -- 𝐸
 },
 [0x1D439]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D439, -- 𝐹
 },
 [0x1D43A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D43A, -- 𝐺
 },
 [0x1D43B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D43B, -- 𝐻
 },
 [0x1D43C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D43C, -- 𝐼
 },
 [0x1D43D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D43D, -- 𝐽
 },
 [0x1D43E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D43E, -- 𝐾
 },
 [0x1D43F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D43F, -- 𝐿
 },
 [0x1D440]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D440, -- 𝑀
 },
 [0x1D441]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D441, -- 𝑁
 },
 [0x1D442]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D442, -- 𝑂
 },
 [0x1D443]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D443, -- 𝑃
 },
 [0x1D444]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D444, -- 𝑄
 },
 [0x1D445]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D445, -- 𝑅
 },
 [0x1D446]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D446, -- 𝑆
 },
 [0x1D447]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D447, -- 𝑇
 },
 [0x1D448]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D448, -- 𝑈
 },
 [0x1D449]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D449, -- 𝑉
 },
 [0x1D44A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D44A, -- 𝑊
 },
 [0x1D44B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D44B, -- 𝑋
 },
 [0x1D44C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D44C, -- 𝑌
 },
 [0x1D44D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D44D, -- 𝑍
 },
 [0x1D44E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D44E, -- 𝑎
 },
 [0x1D44F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D44F, -- 𝑏
 },
 [0x1D450]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D450, -- 𝑐
 },
 [0x1D451]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D451, -- 𝑑
 },
 [0x1D452]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D452, -- 𝑒
 },
 [0x1D453]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D453, -- 𝑓
 },
 [0x1D454]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D454, -- 𝑔
 },
 [0x1D456]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D456, -- 𝑖
 },
 [0x1D457]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D457, -- 𝑗
 },
 [0x1D458]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D458, -- 𝑘
 },
 [0x1D459]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D459, -- 𝑙
 },
 [0x1D45A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D45A, -- 𝑚
 },
 [0x1D45B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D45B, -- 𝑛
 },
 [0x1D45C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D45C, -- 𝑜
 },
 [0x1D45D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D45D, -- 𝑝
 },
 [0x1D45E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D45E, -- 𝑞
 },
 [0x1D45F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D45F, -- 𝑟
 },
 [0x1D460]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D460, -- 𝑠
 },
 [0x1D461]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D461, -- 𝑡
 },
 [0x1D462]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D462, -- 𝑢
 },
 [0x1D463]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D463, -- 𝑣
 },
 [0x1D464]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D464, -- 𝑤
 },
 [0x1D465]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D465, -- 𝑥
 },
 [0x1D466]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D466, -- 𝑦
 },
 [0x1D467]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D467, -- 𝑧
 },
 [0x1D468]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D468, -- 𝑨
 },
 [0x1D469]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D469, -- 𝑩
 },
 [0x1D46A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D46A, -- 𝑪
 },
 [0x1D46B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D46B, -- 𝑫
 },
 [0x1D46C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D46C, -- 𝑬
 },
 [0x1D46D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D46D, -- 𝑭
 },
 [0x1D46E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D46E, -- 𝑮
 },
 [0x1D46F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D46F, -- 𝑯
 },
 [0x1D470]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D470, -- 𝑰
 },
 [0x1D471]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D471, -- 𝑱
 },
 [0x1D472]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D472, -- 𝑲
 },
 [0x1D473]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D473, -- 𝑳
 },
 [0x1D474]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D474, -- 𝑴
 },
 [0x1D475]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D475, -- 𝑵
 },
 [0x1D476]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D476, -- 𝑶
 },
 [0x1D477]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D477, -- 𝑷
 },
 [0x1D478]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D478, -- 𝑸
 },
 [0x1D479]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D479, -- 𝑹
 },
 [0x1D47A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D47A, -- 𝑺
 },
 [0x1D47B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D47B, -- 𝑻
 },
 [0x1D47C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D47C, -- 𝑼
 },
 [0x1D47D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D47D, -- 𝑽
 },
 [0x1D47E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D47E, -- 𝑾
 },
 [0x1D47F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D47F, -- 𝑿
 },
 [0x1D480]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D480, -- 𝒀
 },
 [0x1D481]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D481, -- 𝒁
 },
 [0x1D482]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D482, -- 𝒂
 },
 [0x1D483]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D483, -- 𝒃
 },
 [0x1D484]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D484, -- 𝒄
 },
 [0x1D485]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D485, -- 𝒅
 },
 [0x1D486]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D486, -- 𝒆
 },
 [0x1D487]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D487, -- 𝒇
 },
 [0x1D488]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D488, -- 𝒈
 },
 [0x1D489]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D489, -- 𝒉
 },
 [0x1D48A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D48A, -- 𝒊
 },
 [0x1D48B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D48B, -- 𝒋
 },
 [0x1D48C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D48C, -- 𝒌
 },
 [0x1D48D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D48D, -- 𝒍
 },
 [0x1D48E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D48E, -- 𝒎
 },
 [0x1D48F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D48F, -- 𝒏
 },
 [0x1D490]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D490, -- 𝒐
 },
 [0x1D491]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D491, -- 𝒑
 },
 [0x1D492]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D492, -- 𝒒
 },
 [0x1D493]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D493, -- 𝒓
 },
 [0x1D494]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D494, -- 𝒔
 },
 [0x1D495]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D495, -- 𝒕
 },
 [0x1D496]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D496, -- 𝒖
 },
 [0x1D497]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D497, -- 𝒗
 },
 [0x1D498]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D498, -- 𝒘
 },
 [0x1D499]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D499, -- 𝒙
 },
 [0x1D49A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D49A, -- 𝒚
 },
 [0x1D49B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D49B, -- 𝒛
 },
 [0x1D49C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D49C, -- 𝒜
 },
 [0x1D49E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D49E, -- 𝒞
 },
 [0x1D49F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D49F, -- 𝒟
 },
 [0x1D4A2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D4A2, -- 𝒢
 },
 [0x1D4A5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D4A5, -- 𝒥
 },
 [0x1D4A6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D4A6, -- 𝒦
 },
 [0x1D4A9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D4A9, -- 𝒩
 },
 [0x1D4AA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D4AA, -- 𝒪
 },
 [0x1D4AB]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D4AB, -- 𝒫
 },
 [0x1D4AC]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D4AC, -- 𝒬
 },
 [0x1D4AE]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D4AE, -- 𝒮
 },
 [0x1D4AF]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D4AF, -- 𝒯
 },
 [0x1D4B0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D4B0, -- 𝒰
 },
 [0x1D4B1]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D4B1, -- 𝒱
 },
 [0x1D4B2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D4B2, -- 𝒲
 },
 [0x1D4B3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D4B3, -- 𝒳
 },
 [0x1D4B4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D4B4, -- 𝒴
 },
 [0x1D4B5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SCRIPT CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D4B5, -- 𝒵
 },
 [0x1D4B6]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D4B6, -- 𝒶
 },
 [0x1D4B7]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D4B7, -- 𝒷
 },
 [0x1D4B8]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D4B8, -- 𝒸
 },
 [0x1D4B9]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D4B9, -- 𝒹
 },
 [0x1D4BB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D4BB, -- 𝒻
 },
 [0x1D4BD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D4BD, -- 𝒽
 },
 [0x1D4BE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D4BE, -- 𝒾
 },
 [0x1D4BF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D4BF, -- 𝒿
 },
 [0x1D4C0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D4C0, -- 𝓀
 },
 [0x1D4C1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D4C1, -- 𝓁
 },
 [0x1D4C2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D4C2, -- 𝓂
 },
 [0x1D4C3]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D4C3, -- 𝓃
 },
 [0x1D4C5]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D4C5, -- 𝓅
 },
 [0x1D4C6]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D4C6, -- 𝓆
 },
 [0x1D4C7]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D4C7, -- 𝓇
 },
 [0x1D4C8]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D4C8, -- 𝓈
 },
 [0x1D4C9]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D4C9, -- 𝓉
 },
 [0x1D4CA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D4CA, -- 𝓊
 },
 [0x1D4CB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D4CB, -- 𝓋
 },
 [0x1D4CC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D4CC, -- 𝓌
 },
 [0x1D4CD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D4CD, -- 𝓍
 },
 [0x1D4CE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D4CE, -- 𝓎
 },
 [0x1D4CF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SCRIPT SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D4CF, -- 𝓏
 },
 [0x1D4D0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D4D0, -- 𝓐
 },
 [0x1D4D1]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D4D1, -- 𝓑
 },
 [0x1D4D2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D4D2, -- 𝓒
 },
 [0x1D4D3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D4D3, -- 𝓓
 },
 [0x1D4D4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D4D4, -- 𝓔
 },
 [0x1D4D5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D4D5, -- 𝓕
 },
 [0x1D4D6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D4D6, -- 𝓖
 },
 [0x1D4D7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D4D7, -- 𝓗
 },
 [0x1D4D8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D4D8, -- 𝓘
 },
 [0x1D4D9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D4D9, -- 𝓙
 },
 [0x1D4DA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D4DA, -- 𝓚
 },
 [0x1D4DB]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D4DB, -- 𝓛
 },
 [0x1D4DC]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D4DC, -- 𝓜
 },
 [0x1D4DD]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D4DD, -- 𝓝
 },
 [0x1D4DE]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D4DE, -- 𝓞
 },
 [0x1D4DF]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D4DF, -- 𝓟
 },
 [0x1D4E0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D4E0, -- 𝓠
 },
 [0x1D4E1]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D4E1, -- 𝓡
 },
 [0x1D4E2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D4E2, -- 𝓢
 },
 [0x1D4E3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D4E3, -- 𝓣
 },
 [0x1D4E4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D4E4, -- 𝓤
 },
 [0x1D4E5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D4E5, -- 𝓥
 },
 [0x1D4E6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D4E6, -- 𝓦
 },
 [0x1D4E7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D4E7, -- 𝓧
 },
 [0x1D4E8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D4E8, -- 𝓨
 },
 [0x1D4E9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD SCRIPT CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D4E9, -- 𝓩
 },
 [0x1D4EA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D4EA, -- 𝓪
 },
 [0x1D4EB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D4EB, -- 𝓫
 },
 [0x1D4EC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D4EC, -- 𝓬
 },
 [0x1D4ED]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D4ED, -- 𝓭
 },
 [0x1D4EE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D4EE, -- 𝓮
 },
 [0x1D4EF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D4EF, -- 𝓯
 },
 [0x1D4F0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D4F0, -- 𝓰
 },
 [0x1D4F1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D4F1, -- 𝓱
 },
 [0x1D4F2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D4F2, -- 𝓲
 },
 [0x1D4F3]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D4F3, -- 𝓳
 },
 [0x1D4F4]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D4F4, -- 𝓴
 },
 [0x1D4F5]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D4F5, -- 𝓵
 },
 [0x1D4F6]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D4F6, -- 𝓶
 },
 [0x1D4F7]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D4F7, -- 𝓷
 },
 [0x1D4F8]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D4F8, -- 𝓸
 },
 [0x1D4F9]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D4F9, -- 𝓹
 },
 [0x1D4FA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D4FA, -- 𝓺
 },
 [0x1D4FB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D4FB, -- 𝓻
 },
 [0x1D4FC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D4FC, -- 𝓼
 },
 [0x1D4FD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D4FD, -- 𝓽
 },
 [0x1D4FE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D4FE, -- 𝓾
 },
 [0x1D4FF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D4FF, -- 𝓿
 },
 [0x1D500]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D500, -- 𝔀
 },
 [0x1D501]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D501, -- 𝔁
 },
 [0x1D502]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D502, -- 𝔂
 },
 [0x1D503]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SCRIPT SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D503, -- 𝔃
 },
 [0x1D504]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D504, -- 𝔄
 },
 [0x1D505]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D505, -- 𝔅
 },
 [0x1D507]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D507, -- 𝔇
 },
 [0x1D508]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D508, -- 𝔈
 },
 [0x1D509]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D509, -- 𝔉
 },
 [0x1D50A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D50A, -- 𝔊
 },
 [0x1D50D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D50D, -- 𝔍
 },
 [0x1D50E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D50E, -- 𝔎
 },
 [0x1D50F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D50F, -- 𝔏
 },
 [0x1D510]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D510, -- 𝔐
 },
 [0x1D511]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D511, -- 𝔑
 },
 [0x1D512]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D512, -- 𝔒
 },
 [0x1D513]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D513, -- 𝔓
 },
 [0x1D514]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D514, -- 𝔔
 },
 [0x1D516]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D516, -- 𝔖
 },
 [0x1D517]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D517, -- 𝔗
 },
 [0x1D518]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D518, -- 𝔘
 },
 [0x1D519]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D519, -- 𝔙
 },
 [0x1D51A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D51A, -- 𝔚
 },
 [0x1D51B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D51B, -- 𝔛
 },
 [0x1D51C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL FRAKTUR CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D51C, -- 𝔜
 },
 [0x1D51E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D51E, -- 𝔞
 },
 [0x1D51F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D51F, -- 𝔟
 },
 [0x1D520]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D520, -- 𝔠
 },
 [0x1D521]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D521, -- 𝔡
 },
 [0x1D522]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D522, -- 𝔢
 },
 [0x1D523]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D523, -- 𝔣
 },
 [0x1D524]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D524, -- 𝔤
 },
 [0x1D525]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D525, -- 𝔥
 },
 [0x1D526]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D526, -- 𝔦
 },
 [0x1D527]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D527, -- 𝔧
 },
 [0x1D528]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D528, -- 𝔨
 },
 [0x1D529]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D529, -- 𝔩
 },
 [0x1D52A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D52A, -- 𝔪
 },
 [0x1D52B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D52B, -- 𝔫
 },
 [0x1D52C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D52C, -- 𝔬
 },
 [0x1D52D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D52D, -- 𝔭
 },
 [0x1D52E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D52E, -- 𝔮
 },
 [0x1D52F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D52F, -- 𝔯
 },
 [0x1D530]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D530, -- 𝔰
 },
 [0x1D531]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D531, -- 𝔱
 },
 [0x1D532]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D532, -- 𝔲
 },
 [0x1D533]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D533, -- 𝔳
 },
 [0x1D534]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D534, -- 𝔴
 },
 [0x1D535]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D535, -- 𝔵
 },
 [0x1D536]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D536, -- 𝔶
 },
 [0x1D537]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL FRAKTUR SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D537, -- 𝔷
 },
 [0x1D538]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D538, -- 𝔸
 },
 [0x1D539]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D539, -- 𝔹
 },
 [0x1D53B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D53B, -- 𝔻
 },
 [0x1D53C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D53C, -- 𝔼
 },
 [0x1D53D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D53D, -- 𝔽
 },
 [0x1D53E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D53E, -- 𝔾
 },
 [0x1D540]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D540, -- 𝕀
 },
 [0x1D541]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D541, -- 𝕁
 },
 [0x1D542]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D542, -- 𝕂
 },
 [0x1D543]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D543, -- 𝕃
 },
 [0x1D544]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D544, -- 𝕄
 },
 [0x1D546]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D546, -- 𝕆
 },
 [0x1D54A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D54A, -- 𝕊
 },
 [0x1D54B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D54B, -- 𝕋
 },
 [0x1D54C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D54C, -- 𝕌
 },
 [0x1D54D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D54D, -- 𝕍
 },
 [0x1D54E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D54E, -- 𝕎
 },
 [0x1D54F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D54F, -- 𝕏
 },
 [0x1D550]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D550, -- 𝕐
 },
 [0x1D552]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D552, -- 𝕒
 },
 [0x1D553]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D553, -- 𝕓
 },
 [0x1D554]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D554, -- 𝕔
 },
 [0x1D555]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D555, -- 𝕕
 },
 [0x1D556]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D556, -- 𝕖
 },
 [0x1D557]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D557, -- 𝕗
 },
 [0x1D558]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D558, -- 𝕘
 },
 [0x1D559]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D559, -- 𝕙
 },
 [0x1D55A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D55A, -- 𝕚
 },
 [0x1D55B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D55B, -- 𝕛
 },
 [0x1D55C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D55C, -- 𝕜
 },
 [0x1D55D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D55D, -- 𝕝
 },
 [0x1D55E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D55E, -- 𝕞
 },
 [0x1D55F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D55F, -- 𝕟
 },
 [0x1D560]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D560, -- 𝕠
 },
 [0x1D561]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D561, -- 𝕡
 },
 [0x1D562]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D562, -- 𝕢
 },
 [0x1D563]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D563, -- 𝕣
 },
 [0x1D564]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D564, -- 𝕤
 },
 [0x1D565]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D565, -- 𝕥
 },
 [0x1D566]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D566, -- 𝕦
 },
 [0x1D567]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D567, -- 𝕧
 },
 [0x1D568]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D568, -- 𝕨
 },
 [0x1D569]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D569, -- 𝕩
 },
 [0x1D56A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D56A, -- 𝕪
 },
 [0x1D56B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D56B, -- 𝕫
 },
 [0x1D56C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D56C, -- 𝕬
 },
 [0x1D56D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D56D, -- 𝕭
 },
 [0x1D56E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D56E, -- 𝕮
 },
 [0x1D56F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D56F, -- 𝕯
 },
 [0x1D570]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D570, -- 𝕰
 },
 [0x1D571]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D571, -- 𝕱
 },
 [0x1D572]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D572, -- 𝕲
 },
 [0x1D573]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D573, -- 𝕳
 },
 [0x1D574]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D574, -- 𝕴
 },
 [0x1D575]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D575, -- 𝕵
 },
 [0x1D576]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D576, -- 𝕶
 },
 [0x1D577]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D577, -- 𝕷
 },
 [0x1D578]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D578, -- 𝕸
 },
 [0x1D579]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D579, -- 𝕹
 },
 [0x1D57A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D57A, -- 𝕺
 },
 [0x1D57B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D57B, -- 𝕻
 },
 [0x1D57C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D57C, -- 𝕼
 },
 [0x1D57D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D57D, -- 𝕽
 },
 [0x1D57E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D57E, -- 𝕾
 },
 [0x1D57F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D57F, -- 𝕿
 },
 [0x1D580]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D580, -- 𝖀
 },
 [0x1D581]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D581, -- 𝖁
 },
 [0x1D582]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D582, -- 𝖂
 },
 [0x1D583]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D583, -- 𝖃
 },
 [0x1D584]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D584, -- 𝖄
 },
 [0x1D585]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD FRAKTUR CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D585, -- 𝖅
 },
 [0x1D586]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D586, -- 𝖆
 },
 [0x1D587]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D587, -- 𝖇
 },
 [0x1D588]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D588, -- 𝖈
 },
 [0x1D589]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D589, -- 𝖉
 },
 [0x1D58A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D58A, -- 𝖊
 },
 [0x1D58B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D58B, -- 𝖋
 },
 [0x1D58C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D58C, -- 𝖌
 },
 [0x1D58D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D58D, -- 𝖍
 },
 [0x1D58E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D58E, -- 𝖎
 },
 [0x1D58F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D58F, -- 𝖏
 },
 [0x1D590]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D590, -- 𝖐
 },
 [0x1D591]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D591, -- 𝖑
 },
 [0x1D592]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D592, -- 𝖒
 },
 [0x1D593]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D593, -- 𝖓
 },
 [0x1D594]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D594, -- 𝖔
 },
 [0x1D595]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D595, -- 𝖕
 },
 [0x1D596]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D596, -- 𝖖
 },
 [0x1D597]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D597, -- 𝖗
 },
 [0x1D598]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D598, -- 𝖘
 },
 [0x1D599]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D599, -- 𝖙
 },
 [0x1D59A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D59A, -- 𝖚
 },
 [0x1D59B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D59B, -- 𝖛
 },
 [0x1D59C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D59C, -- 𝖜
 },
 [0x1D59D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D59D, -- 𝖝
 },
 [0x1D59E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D59E, -- 𝖞
 },
 [0x1D59F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD FRAKTUR SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D59F, -- 𝖟
 },
 [0x1D5A0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D5A0, -- 𝖠
 },
 [0x1D5A1]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D5A1, -- 𝖡
 },
 [0x1D5A2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D5A2, -- 𝖢
 },
 [0x1D5A3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D5A3, -- 𝖣
 },
 [0x1D5A4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D5A4, -- 𝖤
 },
 [0x1D5A5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D5A5, -- 𝖥
 },
 [0x1D5A6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D5A6, -- 𝖦
 },
 [0x1D5A7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D5A7, -- 𝖧
 },
 [0x1D5A8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D5A8, -- 𝖨
 },
 [0x1D5A9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D5A9, -- 𝖩
 },
 [0x1D5AA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D5AA, -- 𝖪
 },
 [0x1D5AB]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D5AB, -- 𝖫
 },
 [0x1D5AC]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D5AC, -- 𝖬
 },
 [0x1D5AD]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D5AD, -- 𝖭
 },
 [0x1D5AE]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D5AE, -- 𝖮
 },
 [0x1D5AF]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D5AF, -- 𝖯
 },
 [0x1D5B0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D5B0, -- 𝖰
 },
 [0x1D5B1]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D5B1, -- 𝖱
 },
 [0x1D5B2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D5B2, -- 𝖲
 },
 [0x1D5B3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D5B3, -- 𝖳
 },
 [0x1D5B4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D5B4, -- 𝖴
 },
 [0x1D5B5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D5B5, -- 𝖵
 },
 [0x1D5B6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D5B6, -- 𝖶
 },
 [0x1D5B7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D5B7, -- 𝖷
 },
 [0x1D5B8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D5B8, -- 𝖸
 },
 [0x1D5B9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D5B9, -- 𝖹
 },
 [0x1D5BA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D5BA, -- 𝖺
 },
 [0x1D5BB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D5BB, -- 𝖻
 },
 [0x1D5BC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D5BC, -- 𝖼
 },
 [0x1D5BD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D5BD, -- 𝖽
 },
 [0x1D5BE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D5BE, -- 𝖾
 },
 [0x1D5BF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D5BF, -- 𝖿
 },
 [0x1D5C0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D5C0, -- 𝗀
 },
 [0x1D5C1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D5C1, -- 𝗁
 },
 [0x1D5C2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D5C2, -- 𝗂
 },
 [0x1D5C3]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D5C3, -- 𝗃
 },
 [0x1D5C4]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D5C4, -- 𝗄
 },
 [0x1D5C5]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D5C5, -- 𝗅
 },
 [0x1D5C6]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D5C6, -- 𝗆
 },
 [0x1D5C7]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D5C7, -- 𝗇
 },
 [0x1D5C8]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D5C8, -- 𝗈
 },
 [0x1D5C9]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D5C9, -- 𝗉
 },
 [0x1D5CA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D5CA, -- 𝗊
 },
 [0x1D5CB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D5CB, -- 𝗋
 },
 [0x1D5CC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D5CC, -- 𝗌
 },
 [0x1D5CD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D5CD, -- 𝗍
 },
 [0x1D5CE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D5CE, -- 𝗎
 },
 [0x1D5CF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D5CF, -- 𝗏
 },
 [0x1D5D0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D5D0, -- 𝗐
 },
 [0x1D5D1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D5D1, -- 𝗑
 },
 [0x1D5D2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D5D2, -- 𝗒
 },
 [0x1D5D3]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D5D3, -- 𝗓
 },
 [0x1D5D4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D5D4, -- 𝗔
 },
 [0x1D5D5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D5D5, -- 𝗕
 },
 [0x1D5D6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D5D6, -- 𝗖
 },
 [0x1D5D7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D5D7, -- 𝗗
 },
 [0x1D5D8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D5D8, -- 𝗘
 },
 [0x1D5D9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D5D9, -- 𝗙
 },
 [0x1D5DA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D5DA, -- 𝗚
 },
 [0x1D5DB]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D5DB, -- 𝗛
 },
 [0x1D5DC]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D5DC, -- 𝗜
 },
 [0x1D5DD]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D5DD, -- 𝗝
 },
 [0x1D5DE]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D5DE, -- 𝗞
 },
 [0x1D5DF]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D5DF, -- 𝗟
 },
 [0x1D5E0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D5E0, -- 𝗠
 },
 [0x1D5E1]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D5E1, -- 𝗡
 },
 [0x1D5E2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D5E2, -- 𝗢
 },
 [0x1D5E3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D5E3, -- 𝗣
 },
 [0x1D5E4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D5E4, -- 𝗤
 },
 [0x1D5E5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D5E5, -- 𝗥
 },
 [0x1D5E6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D5E6, -- 𝗦
 },
 [0x1D5E7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D5E7, -- 𝗧
 },
 [0x1D5E8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D5E8, -- 𝗨
 },
 [0x1D5E9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D5E9, -- 𝗩
 },
 [0x1D5EA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D5EA, -- 𝗪
 },
 [0x1D5EB]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D5EB, -- 𝗫
 },
 [0x1D5EC]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D5EC, -- 𝗬
 },
 [0x1D5ED]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D5ED, -- 𝗭
 },
 [0x1D5EE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D5EE, -- 𝗮
 },
 [0x1D5EF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D5EF, -- 𝗯
 },
 [0x1D5F0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D5F0, -- 𝗰
 },
 [0x1D5F1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D5F1, -- 𝗱
 },
 [0x1D5F2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D5F2, -- 𝗲
 },
 [0x1D5F3]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D5F3, -- 𝗳
 },
 [0x1D5F4]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D5F4, -- 𝗴
 },
 [0x1D5F5]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D5F5, -- 𝗵
 },
 [0x1D5F6]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D5F6, -- 𝗶
 },
 [0x1D5F7]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D5F7, -- 𝗷
 },
 [0x1D5F8]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D5F8, -- 𝗸
 },
 [0x1D5F9]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D5F9, -- 𝗹
 },
 [0x1D5FA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D5FA, -- 𝗺
 },
 [0x1D5FB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D5FB, -- 𝗻
 },
 [0x1D5FC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D5FC, -- 𝗼
 },
 [0x1D5FD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D5FD, -- 𝗽
 },
 [0x1D5FE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D5FE, -- 𝗾
 },
 [0x1D5FF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D5FF, -- 𝗿
 },
 [0x1D600]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D600, -- 𝘀
 },
 [0x1D601]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D601, -- 𝘁
 },
 [0x1D602]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D602, -- 𝘂
 },
 [0x1D603]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D603, -- 𝘃
 },
 [0x1D604]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D604, -- 𝘄
 },
 [0x1D605]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D605, -- 𝘅
 },
 [0x1D606]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D606, -- 𝘆
 },
 [0x1D607]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D607, -- 𝘇
 },
 [0x1D608]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D608, -- 𝘈
 },
 [0x1D609]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D609, -- 𝘉
 },
 [0x1D60A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D60A, -- 𝘊
 },
 [0x1D60B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D60B, -- 𝘋
 },
 [0x1D60C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D60C, -- 𝘌
 },
 [0x1D60D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D60D, -- 𝘍
 },
 [0x1D60E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D60E, -- 𝘎
 },
 [0x1D60F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D60F, -- 𝘏
 },
 [0x1D610]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D610, -- 𝘐
 },
 [0x1D611]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D611, -- 𝘑
 },
 [0x1D612]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D612, -- 𝘒
 },
 [0x1D613]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D613, -- 𝘓
 },
 [0x1D614]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D614, -- 𝘔
 },
 [0x1D615]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D615, -- 𝘕
 },
 [0x1D616]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D616, -- 𝘖
 },
 [0x1D617]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D617, -- 𝘗
 },
 [0x1D618]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D618, -- 𝘘
 },
 [0x1D619]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D619, -- 𝘙
 },
 [0x1D61A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D61A, -- 𝘚
 },
 [0x1D61B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D61B, -- 𝘛
 },
 [0x1D61C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D61C, -- 𝘜
 },
 [0x1D61D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D61D, -- 𝘝
 },
 [0x1D61E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D61E, -- 𝘞
 },
 [0x1D61F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D61F, -- 𝘟
 },
 [0x1D620]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D620, -- 𝘠
 },
 [0x1D621]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D621, -- 𝘡
 },
 [0x1D622]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D622, -- 𝘢
 },
 [0x1D623]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D623, -- 𝘣
 },
 [0x1D624]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D624, -- 𝘤
 },
 [0x1D625]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D625, -- 𝘥
 },
 [0x1D626]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D626, -- 𝘦
 },
 [0x1D627]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D627, -- 𝘧
 },
 [0x1D628]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D628, -- 𝘨
 },
 [0x1D629]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D629, -- 𝘩
 },
 [0x1D62A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D62A, -- 𝘪
 },
 [0x1D62B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D62B, -- 𝘫
 },
 [0x1D62C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D62C, -- 𝘬
 },
 [0x1D62D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D62D, -- 𝘭
 },
 [0x1D62E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D62E, -- 𝘮
 },
 [0x1D62F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D62F, -- 𝘯
 },
 [0x1D630]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D630, -- 𝘰
 },
 [0x1D631]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D631, -- 𝘱
 },
 [0x1D632]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D632, -- 𝘲
 },
 [0x1D633]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D633, -- 𝘳
 },
 [0x1D634]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D634, -- 𝘴
 },
 [0x1D635]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D635, -- 𝘵
 },
 [0x1D636]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D636, -- 𝘶
 },
 [0x1D637]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D637, -- 𝘷
 },
 [0x1D638]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D638, -- 𝘸
 },
 [0x1D639]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D639, -- 𝘹
 },
 [0x1D63A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D63A, -- 𝘺
 },
 [0x1D63B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF ITALIC SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D63B, -- 𝘻
 },
 [0x1D63C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D63C, -- 𝘼
 },
 [0x1D63D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D63D, -- 𝘽
 },
 [0x1D63E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D63E, -- 𝘾
 },
 [0x1D63F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D63F, -- 𝘿
 },
 [0x1D640]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D640, -- 𝙀
 },
 [0x1D641]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D641, -- 𝙁
 },
 [0x1D642]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D642, -- 𝙂
 },
 [0x1D643]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D643, -- 𝙃
 },
 [0x1D644]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D644, -- 𝙄
 },
 [0x1D645]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D645, -- 𝙅
 },
 [0x1D646]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D646, -- 𝙆
 },
 [0x1D647]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D647, -- 𝙇
 },
 [0x1D648]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D648, -- 𝙈
 },
 [0x1D649]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D649, -- 𝙉
 },
 [0x1D64A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D64A, -- 𝙊
 },
 [0x1D64B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D64B, -- 𝙋
 },
 [0x1D64C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D64C, -- 𝙌
 },
 [0x1D64D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D64D, -- 𝙍
 },
 [0x1D64E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D64E, -- 𝙎
 },
 [0x1D64F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D64F, -- 𝙏
 },
 [0x1D650]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D650, -- 𝙐
 },
 [0x1D651]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D651, -- 𝙑
 },
 [0x1D652]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D652, -- 𝙒
 },
 [0x1D653]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D653, -- 𝙓
 },
 [0x1D654]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D654, -- 𝙔
 },
 [0x1D655]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D655, -- 𝙕
 },
 [0x1D656]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D656, -- 𝙖
 },
 [0x1D657]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D657, -- 𝙗
 },
 [0x1D658]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D658, -- 𝙘
 },
 [0x1D659]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D659, -- 𝙙
 },
 [0x1D65A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D65A, -- 𝙚
 },
 [0x1D65B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D65B, -- 𝙛
 },
 [0x1D65C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D65C, -- 𝙜
 },
 [0x1D65D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D65D, -- 𝙝
 },
 [0x1D65E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D65E, -- 𝙞
 },
 [0x1D65F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D65F, -- 𝙟
 },
 [0x1D660]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D660, -- 𝙠
 },
 [0x1D661]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D661, -- 𝙡
 },
 [0x1D662]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D662, -- 𝙢
 },
 [0x1D663]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D663, -- 𝙣
 },
 [0x1D664]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D664, -- 𝙤
 },
 [0x1D665]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D665, -- 𝙥
 },
 [0x1D666]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D666, -- 𝙦
 },
 [0x1D667]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D667, -- 𝙧
 },
 [0x1D668]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D668, -- 𝙨
 },
 [0x1D669]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D669, -- 𝙩
 },
 [0x1D66A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D66A, -- 𝙪
 },
 [0x1D66B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D66B, -- 𝙫
 },
 [0x1D66C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D66C, -- 𝙬
 },
 [0x1D66D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D66D, -- 𝙭
 },
 [0x1D66E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D66E, -- 𝙮
 },
 [0x1D66F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D66F, -- 𝙯
 },
 [0x1D670]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0041 },
  ["unicodeslot"]=0x1D670, -- 𝙰
 },
 [0x1D671]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0042 },
  ["unicodeslot"]=0x1D671, -- 𝙱
 },
 [0x1D672]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0043 },
  ["unicodeslot"]=0x1D672, -- 𝙲
 },
 [0x1D673]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0044 },
  ["unicodeslot"]=0x1D673, -- 𝙳
 },
 [0x1D674]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0045 },
  ["unicodeslot"]=0x1D674, -- 𝙴
 },
 [0x1D675]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0046 },
  ["unicodeslot"]=0x1D675, -- 𝙵
 },
 [0x1D676]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0047 },
  ["unicodeslot"]=0x1D676, -- 𝙶
 },
 [0x1D677]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0048 },
  ["unicodeslot"]=0x1D677, -- 𝙷
 },
 [0x1D678]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0049 },
  ["unicodeslot"]=0x1D678, -- 𝙸
 },
 [0x1D679]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004A },
  ["unicodeslot"]=0x1D679, -- 𝙹
 },
 [0x1D67A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004B },
  ["unicodeslot"]=0x1D67A, -- 𝙺
 },
 [0x1D67B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004C },
  ["unicodeslot"]=0x1D67B, -- 𝙻
 },
 [0x1D67C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004D },
  ["unicodeslot"]=0x1D67C, -- 𝙼
 },
 [0x1D67D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004E },
  ["unicodeslot"]=0x1D67D, -- 𝙽
 },
 [0x1D67E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x004F },
  ["unicodeslot"]=0x1D67E, -- 𝙾
 },
 [0x1D67F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0050 },
  ["unicodeslot"]=0x1D67F, -- 𝙿
 },
 [0x1D680]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0051 },
  ["unicodeslot"]=0x1D680, -- 𝚀
 },
 [0x1D681]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0052 },
  ["unicodeslot"]=0x1D681, -- 𝚁
 },
 [0x1D682]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0053 },
  ["unicodeslot"]=0x1D682, -- 𝚂
 },
 [0x1D683]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0054 },
  ["unicodeslot"]=0x1D683, -- 𝚃
 },
 [0x1D684]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0055 },
  ["unicodeslot"]=0x1D684, -- 𝚄
 },
 [0x1D685]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0056 },
  ["unicodeslot"]=0x1D685, -- 𝚅
 },
 [0x1D686]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0057 },
  ["unicodeslot"]=0x1D686, -- 𝚆
 },
 [0x1D687]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0058 },
  ["unicodeslot"]=0x1D687, -- 𝚇
 },
 [0x1D688]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0059 },
  ["unicodeslot"]=0x1D688, -- 𝚈
 },
 [0x1D689]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL MONOSPACE CAPITAL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x005A },
  ["unicodeslot"]=0x1D689, -- 𝚉
 },
 [0x1D68A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL A",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0061 },
  ["unicodeslot"]=0x1D68A, -- 𝚊
 },
 [0x1D68B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL B",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0062 },
  ["unicodeslot"]=0x1D68B, -- 𝚋
 },
 [0x1D68C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL C",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0063 },
  ["unicodeslot"]=0x1D68C, -- 𝚌
 },
 [0x1D68D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL D",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0064 },
  ["unicodeslot"]=0x1D68D, -- 𝚍
 },
 [0x1D68E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL E",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0065 },
  ["unicodeslot"]=0x1D68E, -- 𝚎
 },
 [0x1D68F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL F",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0066 },
  ["unicodeslot"]=0x1D68F, -- 𝚏
 },
 [0x1D690]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL G",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0067 },
  ["unicodeslot"]=0x1D690, -- 𝚐
 },
 [0x1D691]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL H",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0068 },
  ["unicodeslot"]=0x1D691, -- 𝚑
 },
 [0x1D692]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL I",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0069 },
  ["unicodeslot"]=0x1D692, -- 𝚒
 },
 [0x1D693]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL J",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006A },
  ["unicodeslot"]=0x1D693, -- 𝚓
 },
 [0x1D694]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL K",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006B },
  ["unicodeslot"]=0x1D694, -- 𝚔
 },
 [0x1D695]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL L",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006C },
  ["unicodeslot"]=0x1D695, -- 𝚕
 },
 [0x1D696]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL M",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006D },
  ["unicodeslot"]=0x1D696, -- 𝚖
 },
 [0x1D697]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL N",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006E },
  ["unicodeslot"]=0x1D697, -- 𝚗
 },
 [0x1D698]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL O",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x006F },
  ["unicodeslot"]=0x1D698, -- 𝚘
 },
 [0x1D699]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL P",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0070 },
  ["unicodeslot"]=0x1D699, -- 𝚙
 },
 [0x1D69A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL Q",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0071 },
  ["unicodeslot"]=0x1D69A, -- 𝚚
 },
 [0x1D69B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL R",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0072 },
  ["unicodeslot"]=0x1D69B, -- 𝚛
 },
 [0x1D69C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL S",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0073 },
  ["unicodeslot"]=0x1D69C, -- 𝚜
 },
 [0x1D69D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL T",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0074 },
  ["unicodeslot"]=0x1D69D, -- 𝚝
 },
 [0x1D69E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL U",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0075 },
  ["unicodeslot"]=0x1D69E, -- 𝚞
 },
 [0x1D69F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL V",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0076 },
  ["unicodeslot"]=0x1D69F, -- 𝚟
 },
 [0x1D6A0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL W",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0077 },
  ["unicodeslot"]=0x1D6A0, -- 𝚠
 },
 [0x1D6A1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL X",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0078 },
  ["unicodeslot"]=0x1D6A1, -- 𝚡
 },
 [0x1D6A2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL Y",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0079 },
  ["unicodeslot"]=0x1D6A2, -- 𝚢
 },
 [0x1D6A3]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL MONOSPACE SMALL Z",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x007A },
  ["unicodeslot"]=0x1D6A3, -- 𝚣
 },
 [0x1D6A4]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL DOTLESS I",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="imath",
  ["specials"]={ "font", 0x0131 },
  ["unicodeslot"]=0x1D6A4, -- 𝚤
 },
 [0x1D6A5]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL DOTLESS J",
  ["linebreak"]="al",
  ["mathclass"]="variable",
  ["mathname"]="jmath",
  ["specials"]={ "font", 0x0237 },
  ["unicodeslot"]=0x1D6A5, -- 𝚥
 },
 [0x1D6A8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0391 },
  ["unicodeslot"]=0x1D6A8, -- 𝚨
 },
 [0x1D6A9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0392 },
  ["unicodeslot"]=0x1D6A9, -- 𝚩
 },
 [0x1D6AA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0393 },
  ["unicodeslot"]=0x1D6AA, -- 𝚪
 },
 [0x1D6AB]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0394 },
  ["unicodeslot"]=0x1D6AB, -- 𝚫
 },
 [0x1D6AC]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0395 },
  ["unicodeslot"]=0x1D6AC, -- 𝚬
 },
 [0x1D6AD]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0396 },
  ["unicodeslot"]=0x1D6AD, -- 𝚭
 },
 [0x1D6AE]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0397 },
  ["unicodeslot"]=0x1D6AE, -- 𝚮
 },
 [0x1D6AF]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0398 },
  ["unicodeslot"]=0x1D6AF, -- 𝚯
 },
 [0x1D6B0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0399 },
  ["unicodeslot"]=0x1D6B0, -- 𝚰
 },
 [0x1D6B1]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039A },
  ["unicodeslot"]=0x1D6B1, -- 𝚱
 },
 [0x1D6B2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039B },
  ["unicodeslot"]=0x1D6B2, -- 𝚲
 },
 [0x1D6B3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039C },
  ["unicodeslot"]=0x1D6B3, -- 𝚳
 },
 [0x1D6B4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039D },
  ["unicodeslot"]=0x1D6B4, -- 𝚴
 },
 [0x1D6B5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039E },
  ["unicodeslot"]=0x1D6B5, -- 𝚵
 },
 [0x1D6B6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039F },
  ["unicodeslot"]=0x1D6B6, -- 𝚶
 },
 [0x1D6B7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A0 },
  ["unicodeslot"]=0x1D6B7, -- 𝚷
 },
 [0x1D6B8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A1 },
  ["unicodeslot"]=0x1D6B8, -- 𝚸
 },
 [0x1D6B9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F4 },
  ["unicodeslot"]=0x1D6B9, -- 𝚹
 },
 [0x1D6BA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A3 },
  ["unicodeslot"]=0x1D6BA, -- 𝚺
 },
 [0x1D6BB]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A4 },
  ["unicodeslot"]=0x1D6BB, -- 𝚻
 },
 [0x1D6BC]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A5 },
  ["unicodeslot"]=0x1D6BC, -- 𝚼
 },
 [0x1D6BD]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A6 },
  ["unicodeslot"]=0x1D6BD, -- 𝚽
 },
 [0x1D6BE]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A7 },
  ["unicodeslot"]=0x1D6BE, -- 𝚾
 },
 [0x1D6BF]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A8 },
  ["unicodeslot"]=0x1D6BF, -- 𝚿
 },
 [0x1D6C0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A9 },
  ["unicodeslot"]=0x1D6C0, -- 𝛀
 },
 [0x1D6C1]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL BOLD NABLA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2207 },
  ["unicodeslot"]=0x1D6C1, -- 𝛁
 },
 [0x1D6C2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B1 },
  ["unicodeslot"]=0x1D6C2, -- 𝛂
 },
 [0x1D6C3]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B2 },
  ["unicodeslot"]=0x1D6C3, -- 𝛃
 },
 [0x1D6C4]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B3 },
  ["unicodeslot"]=0x1D6C4, -- 𝛄
 },
 [0x1D6C5]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B4 },
  ["unicodeslot"]=0x1D6C5, -- 𝛅
 },
 [0x1D6C6]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B5 },
  ["unicodeslot"]=0x1D6C6, -- 𝛆
 },
 [0x1D6C7]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B6 },
  ["unicodeslot"]=0x1D6C7, -- 𝛇
 },
 [0x1D6C8]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B7 },
  ["unicodeslot"]=0x1D6C8, -- 𝛈
 },
 [0x1D6C9]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B8 },
  ["unicodeslot"]=0x1D6C9, -- 𝛉
 },
 [0x1D6CA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B9 },
  ["unicodeslot"]=0x1D6CA, -- 𝛊
 },
 [0x1D6CB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BA },
  ["unicodeslot"]=0x1D6CB, -- 𝛋
 },
 [0x1D6CC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BB },
  ["unicodeslot"]=0x1D6CC, -- 𝛌
 },
 [0x1D6CD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BC },
  ["unicodeslot"]=0x1D6CD, -- 𝛍
 },
 [0x1D6CE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BD },
  ["unicodeslot"]=0x1D6CE, -- 𝛎
 },
 [0x1D6CF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BE },
  ["unicodeslot"]=0x1D6CF, -- 𝛏
 },
 [0x1D6D0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BF },
  ["unicodeslot"]=0x1D6D0, -- 𝛐
 },
 [0x1D6D1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C0 },
  ["unicodeslot"]=0x1D6D1, -- 𝛑
 },
 [0x1D6D2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C1 },
  ["unicodeslot"]=0x1D6D2, -- 𝛒
 },
 [0x1D6D3]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL FINAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C2 },
  ["unicodeslot"]=0x1D6D3, -- 𝛓
 },
 [0x1D6D4]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C3 },
  ["unicodeslot"]=0x1D6D4, -- 𝛔
 },
 [0x1D6D5]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C4 },
  ["unicodeslot"]=0x1D6D5, -- 𝛕
 },
 [0x1D6D6]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C5 },
  ["unicodeslot"]=0x1D6D6, -- 𝛖
 },
 [0x1D6D7]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C6 },
  ["unicodeslot"]=0x1D6D7, -- 𝛗
 },
 [0x1D6D8]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C7 },
  ["unicodeslot"]=0x1D6D8, -- 𝛘
 },
 [0x1D6D9]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C8 },
  ["unicodeslot"]=0x1D6D9, -- 𝛙
 },
 [0x1D6DA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C9 },
  ["unicodeslot"]=0x1D6DA, -- 𝛚
 },
 [0x1D6DB]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL BOLD PARTIAL DIFFERENTIAL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2202 },
  ["unicodeslot"]=0x1D6DB, -- 𝛛
 },
 [0x1D6DC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD EPSILON SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F5 },
  ["unicodeslot"]=0x1D6DC, -- 𝛜
 },
 [0x1D6DD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D1 },
  ["unicodeslot"]=0x1D6DD, -- 𝛝
 },
 [0x1D6DE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD KAPPA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F0 },
  ["unicodeslot"]=0x1D6DE, -- 𝛞
 },
 [0x1D6DF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD PHI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D5 },
  ["unicodeslot"]=0x1D6DF, -- 𝛟
 },
 [0x1D6E0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD RHO SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F1 },
  ["unicodeslot"]=0x1D6E0, -- 𝛠
 },
 [0x1D6E1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD PI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D6 },
  ["unicodeslot"]=0x1D6E1, -- 𝛡
 },
 [0x1D6E2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0391 },
  ["unicodeslot"]=0x1D6E2, -- 𝛢
 },
 [0x1D6E3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0392 },
  ["unicodeslot"]=0x1D6E3, -- 𝛣
 },
 [0x1D6E4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0393 },
  ["unicodeslot"]=0x1D6E4, -- 𝛤
 },
 [0x1D6E5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0394 },
  ["unicodeslot"]=0x1D6E5, -- 𝛥
 },
 [0x1D6E6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0395 },
  ["unicodeslot"]=0x1D6E6, -- 𝛦
 },
 [0x1D6E7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0396 },
  ["unicodeslot"]=0x1D6E7, -- 𝛧
 },
 [0x1D6E8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0397 },
  ["unicodeslot"]=0x1D6E8, -- 𝛨
 },
 [0x1D6E9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0398 },
  ["unicodeslot"]=0x1D6E9, -- 𝛩
 },
 [0x1D6EA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0399 },
  ["unicodeslot"]=0x1D6EA, -- 𝛪
 },
 [0x1D6EB]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039A },
  ["unicodeslot"]=0x1D6EB, -- 𝛫
 },
 [0x1D6EC]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039B },
  ["unicodeslot"]=0x1D6EC, -- 𝛬
 },
 [0x1D6ED]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039C },
  ["unicodeslot"]=0x1D6ED, -- 𝛭
 },
 [0x1D6EE]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039D },
  ["unicodeslot"]=0x1D6EE, -- 𝛮
 },
 [0x1D6EF]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039E },
  ["unicodeslot"]=0x1D6EF, -- 𝛯
 },
 [0x1D6F0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039F },
  ["unicodeslot"]=0x1D6F0, -- 𝛰
 },
 [0x1D6F1]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A0 },
  ["unicodeslot"]=0x1D6F1, -- 𝛱
 },
 [0x1D6F2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A1 },
  ["unicodeslot"]=0x1D6F2, -- 𝛲
 },
 [0x1D6F3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F4 },
  ["unicodeslot"]=0x1D6F3, -- 𝛳
 },
 [0x1D6F4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A3 },
  ["unicodeslot"]=0x1D6F4, -- 𝛴
 },
 [0x1D6F5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A4 },
  ["unicodeslot"]=0x1D6F5, -- 𝛵
 },
 [0x1D6F6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A5 },
  ["unicodeslot"]=0x1D6F6, -- 𝛶
 },
 [0x1D6F7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A6 },
  ["unicodeslot"]=0x1D6F7, -- 𝛷
 },
 [0x1D6F8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A7 },
  ["unicodeslot"]=0x1D6F8, -- 𝛸
 },
 [0x1D6F9]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A8 },
  ["unicodeslot"]=0x1D6F9, -- 𝛹
 },
 [0x1D6FA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL ITALIC CAPITAL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A9 },
  ["unicodeslot"]=0x1D6FA, -- 𝛺
 },
 [0x1D6FB]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL ITALIC NABLA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2207 },
  ["unicodeslot"]=0x1D6FB, -- 𝛻
 },
 [0x1D6FC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B1 },
  ["unicodeslot"]=0x1D6FC, -- 𝛼
 },
 [0x1D6FD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B2 },
  ["unicodeslot"]=0x1D6FD, -- 𝛽
 },
 [0x1D6FE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B3 },
  ["unicodeslot"]=0x1D6FE, -- 𝛾
 },
 [0x1D6FF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B4 },
  ["unicodeslot"]=0x1D6FF, -- 𝛿
 },
 [0x1D700]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B5 },
  ["unicodeslot"]=0x1D700, -- 𝜀
 },
 [0x1D701]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B6 },
  ["unicodeslot"]=0x1D701, -- 𝜁
 },
 [0x1D702]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B7 },
  ["unicodeslot"]=0x1D702, -- 𝜂
 },
 [0x1D703]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B8 },
  ["unicodeslot"]=0x1D703, -- 𝜃
 },
 [0x1D704]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B9 },
  ["unicodeslot"]=0x1D704, -- 𝜄
 },
 [0x1D705]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BA },
  ["unicodeslot"]=0x1D705, -- 𝜅
 },
 [0x1D706]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BB },
  ["unicodeslot"]=0x1D706, -- 𝜆
 },
 [0x1D707]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BC },
  ["unicodeslot"]=0x1D707, -- 𝜇
 },
 [0x1D708]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BD },
  ["unicodeslot"]=0x1D708, -- 𝜈
 },
 [0x1D709]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BE },
  ["unicodeslot"]=0x1D709, -- 𝜉
 },
 [0x1D70A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BF },
  ["unicodeslot"]=0x1D70A, -- 𝜊
 },
 [0x1D70B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C0 },
  ["unicodeslot"]=0x1D70B, -- 𝜋
 },
 [0x1D70C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C1 },
  ["unicodeslot"]=0x1D70C, -- 𝜌
 },
 [0x1D70D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL FINAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C2 },
  ["unicodeslot"]=0x1D70D, -- 𝜍
 },
 [0x1D70E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C3 },
  ["unicodeslot"]=0x1D70E, -- 𝜎
 },
 [0x1D70F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C4 },
  ["unicodeslot"]=0x1D70F, -- 𝜏
 },
 [0x1D710]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C5 },
  ["unicodeslot"]=0x1D710, -- 𝜐
 },
 [0x1D711]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C6 },
  ["unicodeslot"]=0x1D711, -- 𝜑
 },
 [0x1D712]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C7 },
  ["unicodeslot"]=0x1D712, -- 𝜒
 },
 [0x1D713]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C8 },
  ["unicodeslot"]=0x1D713, -- 𝜓
 },
 [0x1D714]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC SMALL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C9 },
  ["unicodeslot"]=0x1D714, -- 𝜔
 },
 [0x1D715]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL ITALIC PARTIAL DIFFERENTIAL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2202 },
  ["unicodeslot"]=0x1D715, -- 𝜕
 },
 [0x1D716]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC EPSILON SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F5 },
  ["unicodeslot"]=0x1D716, -- 𝜖
 },
 [0x1D717]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D1 },
  ["unicodeslot"]=0x1D717, -- 𝜗
 },
 [0x1D718]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC KAPPA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F0 },
  ["unicodeslot"]=0x1D718, -- 𝜘
 },
 [0x1D719]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC PHI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D5 },
  ["unicodeslot"]=0x1D719, -- 𝜙
 },
 [0x1D71A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC RHO SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F1 },
  ["unicodeslot"]=0x1D71A, -- 𝜚
 },
 [0x1D71B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL ITALIC PI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D6 },
  ["unicodeslot"]=0x1D71B, -- 𝜛
 },
 [0x1D71C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0391 },
  ["unicodeslot"]=0x1D71C, -- 𝜜
 },
 [0x1D71D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0392 },
  ["unicodeslot"]=0x1D71D, -- 𝜝
 },
 [0x1D71E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0393 },
  ["unicodeslot"]=0x1D71E, -- 𝜞
 },
 [0x1D71F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0394 },
  ["unicodeslot"]=0x1D71F, -- 𝜟
 },
 [0x1D720]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0395 },
  ["unicodeslot"]=0x1D720, -- 𝜠
 },
 [0x1D721]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0396 },
  ["unicodeslot"]=0x1D721, -- 𝜡
 },
 [0x1D722]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0397 },
  ["unicodeslot"]=0x1D722, -- 𝜢
 },
 [0x1D723]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0398 },
  ["unicodeslot"]=0x1D723, -- 𝜣
 },
 [0x1D724]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0399 },
  ["unicodeslot"]=0x1D724, -- 𝜤
 },
 [0x1D725]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039A },
  ["unicodeslot"]=0x1D725, -- 𝜥
 },
 [0x1D726]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039B },
  ["unicodeslot"]=0x1D726, -- 𝜦
 },
 [0x1D727]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039C },
  ["unicodeslot"]=0x1D727, -- 𝜧
 },
 [0x1D728]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039D },
  ["unicodeslot"]=0x1D728, -- 𝜨
 },
 [0x1D729]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039E },
  ["unicodeslot"]=0x1D729, -- 𝜩
 },
 [0x1D72A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039F },
  ["unicodeslot"]=0x1D72A, -- 𝜪
 },
 [0x1D72B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A0 },
  ["unicodeslot"]=0x1D72B, -- 𝜫
 },
 [0x1D72C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A1 },
  ["unicodeslot"]=0x1D72C, -- 𝜬
 },
 [0x1D72D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F4 },
  ["unicodeslot"]=0x1D72D, -- 𝜭
 },
 [0x1D72E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A3 },
  ["unicodeslot"]=0x1D72E, -- 𝜮
 },
 [0x1D72F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A4 },
  ["unicodeslot"]=0x1D72F, -- 𝜯
 },
 [0x1D730]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A5 },
  ["unicodeslot"]=0x1D730, -- 𝜰
 },
 [0x1D731]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A6 },
  ["unicodeslot"]=0x1D731, -- 𝜱
 },
 [0x1D732]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A7 },
  ["unicodeslot"]=0x1D732, -- 𝜲
 },
 [0x1D733]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A8 },
  ["unicodeslot"]=0x1D733, -- 𝜳
 },
 [0x1D734]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD ITALIC CAPITAL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A9 },
  ["unicodeslot"]=0x1D734, -- 𝜴
 },
 [0x1D735]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL BOLD ITALIC NABLA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2207 },
  ["unicodeslot"]=0x1D735, -- 𝜵
 },
 [0x1D736]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B1 },
  ["unicodeslot"]=0x1D736, -- 𝜶
 },
 [0x1D737]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B2 },
  ["unicodeslot"]=0x1D737, -- 𝜷
 },
 [0x1D738]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B3 },
  ["unicodeslot"]=0x1D738, -- 𝜸
 },
 [0x1D739]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B4 },
  ["unicodeslot"]=0x1D739, -- 𝜹
 },
 [0x1D73A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B5 },
  ["unicodeslot"]=0x1D73A, -- 𝜺
 },
 [0x1D73B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B6 },
  ["unicodeslot"]=0x1D73B, -- 𝜻
 },
 [0x1D73C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B7 },
  ["unicodeslot"]=0x1D73C, -- 𝜼
 },
 [0x1D73D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B8 },
  ["unicodeslot"]=0x1D73D, -- 𝜽
 },
 [0x1D73E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B9 },
  ["unicodeslot"]=0x1D73E, -- 𝜾
 },
 [0x1D73F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BA },
  ["unicodeslot"]=0x1D73F, -- 𝜿
 },
 [0x1D740]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BB },
  ["unicodeslot"]=0x1D740, -- 𝝀
 },
 [0x1D741]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BC },
  ["unicodeslot"]=0x1D741, -- 𝝁
 },
 [0x1D742]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BD },
  ["unicodeslot"]=0x1D742, -- 𝝂
 },
 [0x1D743]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BE },
  ["unicodeslot"]=0x1D743, -- 𝝃
 },
 [0x1D744]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BF },
  ["unicodeslot"]=0x1D744, -- 𝝄
 },
 [0x1D745]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C0 },
  ["unicodeslot"]=0x1D745, -- 𝝅
 },
 [0x1D746]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C1 },
  ["unicodeslot"]=0x1D746, -- 𝝆
 },
 [0x1D747]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL FINAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C2 },
  ["unicodeslot"]=0x1D747, -- 𝝇
 },
 [0x1D748]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C3 },
  ["unicodeslot"]=0x1D748, -- 𝝈
 },
 [0x1D749]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C4 },
  ["unicodeslot"]=0x1D749, -- 𝝉
 },
 [0x1D74A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C5 },
  ["unicodeslot"]=0x1D74A, -- 𝝊
 },
 [0x1D74B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C6 },
  ["unicodeslot"]=0x1D74B, -- 𝝋
 },
 [0x1D74C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C7 },
  ["unicodeslot"]=0x1D74C, -- 𝝌
 },
 [0x1D74D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C8 },
  ["unicodeslot"]=0x1D74D, -- 𝝍
 },
 [0x1D74E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC SMALL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C9 },
  ["unicodeslot"]=0x1D74E, -- 𝝎
 },
 [0x1D74F]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL BOLD ITALIC PARTIAL DIFFERENTIAL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2202 },
  ["unicodeslot"]=0x1D74F, -- 𝝏
 },
 [0x1D750]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC EPSILON SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F5 },
  ["unicodeslot"]=0x1D750, -- 𝝐
 },
 [0x1D751]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D1 },
  ["unicodeslot"]=0x1D751, -- 𝝑
 },
 [0x1D752]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC KAPPA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F0 },
  ["unicodeslot"]=0x1D752, -- 𝝒
 },
 [0x1D753]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC PHI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D5 },
  ["unicodeslot"]=0x1D753, -- 𝝓
 },
 [0x1D754]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC RHO SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F1 },
  ["unicodeslot"]=0x1D754, -- 𝝔
 },
 [0x1D755]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD ITALIC PI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D6 },
  ["unicodeslot"]=0x1D755, -- 𝝕
 },
 [0x1D756]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0391 },
  ["unicodeslot"]=0x1D756, -- 𝝖
 },
 [0x1D757]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0392 },
  ["unicodeslot"]=0x1D757, -- 𝝗
 },
 [0x1D758]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0393 },
  ["unicodeslot"]=0x1D758, -- 𝝘
 },
 [0x1D759]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0394 },
  ["unicodeslot"]=0x1D759, -- 𝝙
 },
 [0x1D75A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0395 },
  ["unicodeslot"]=0x1D75A, -- 𝝚
 },
 [0x1D75B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0396 },
  ["unicodeslot"]=0x1D75B, -- 𝝛
 },
 [0x1D75C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0397 },
  ["unicodeslot"]=0x1D75C, -- 𝝜
 },
 [0x1D75D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0398 },
  ["unicodeslot"]=0x1D75D, -- 𝝝
 },
 [0x1D75E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0399 },
  ["unicodeslot"]=0x1D75E, -- 𝝞
 },
 [0x1D75F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039A },
  ["unicodeslot"]=0x1D75F, -- 𝝟
 },
 [0x1D760]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039B },
  ["unicodeslot"]=0x1D760, -- 𝝠
 },
 [0x1D761]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039C },
  ["unicodeslot"]=0x1D761, -- 𝝡
 },
 [0x1D762]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039D },
  ["unicodeslot"]=0x1D762, -- 𝝢
 },
 [0x1D763]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039E },
  ["unicodeslot"]=0x1D763, -- 𝝣
 },
 [0x1D764]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039F },
  ["unicodeslot"]=0x1D764, -- 𝝤
 },
 [0x1D765]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A0 },
  ["unicodeslot"]=0x1D765, -- 𝝥
 },
 [0x1D766]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A1 },
  ["unicodeslot"]=0x1D766, -- 𝝦
 },
 [0x1D767]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F4 },
  ["unicodeslot"]=0x1D767, -- 𝝧
 },
 [0x1D768]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A3 },
  ["unicodeslot"]=0x1D768, -- 𝝨
 },
 [0x1D769]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A4 },
  ["unicodeslot"]=0x1D769, -- 𝝩
 },
 [0x1D76A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A5 },
  ["unicodeslot"]=0x1D76A, -- 𝝪
 },
 [0x1D76B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A6 },
  ["unicodeslot"]=0x1D76B, -- 𝝫
 },
 [0x1D76C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A7 },
  ["unicodeslot"]=0x1D76C, -- 𝝬
 },
 [0x1D76D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A8 },
  ["unicodeslot"]=0x1D76D, -- 𝝭
 },
 [0x1D76E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A9 },
  ["unicodeslot"]=0x1D76E, -- 𝝮
 },
 [0x1D76F]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD NABLA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2207 },
  ["unicodeslot"]=0x1D76F, -- 𝝯
 },
 [0x1D770]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B1 },
  ["unicodeslot"]=0x1D770, -- 𝝰
 },
 [0x1D771]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B2 },
  ["unicodeslot"]=0x1D771, -- 𝝱
 },
 [0x1D772]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B3 },
  ["unicodeslot"]=0x1D772, -- 𝝲
 },
 [0x1D773]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B4 },
  ["unicodeslot"]=0x1D773, -- 𝝳
 },
 [0x1D774]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B5 },
  ["unicodeslot"]=0x1D774, -- 𝝴
 },
 [0x1D775]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B6 },
  ["unicodeslot"]=0x1D775, -- 𝝵
 },
 [0x1D776]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B7 },
  ["unicodeslot"]=0x1D776, -- 𝝶
 },
 [0x1D777]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B8 },
  ["unicodeslot"]=0x1D777, -- 𝝷
 },
 [0x1D778]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B9 },
  ["unicodeslot"]=0x1D778, -- 𝝸
 },
 [0x1D779]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BA },
  ["unicodeslot"]=0x1D779, -- 𝝹
 },
 [0x1D77A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BB },
  ["unicodeslot"]=0x1D77A, -- 𝝺
 },
 [0x1D77B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BC },
  ["unicodeslot"]=0x1D77B, -- 𝝻
 },
 [0x1D77C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BD },
  ["unicodeslot"]=0x1D77C, -- 𝝼
 },
 [0x1D77D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BE },
  ["unicodeslot"]=0x1D77D, -- 𝝽
 },
 [0x1D77E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BF },
  ["unicodeslot"]=0x1D77E, -- 𝝾
 },
 [0x1D77F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C0 },
  ["unicodeslot"]=0x1D77F, -- 𝝿
 },
 [0x1D780]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C1 },
  ["unicodeslot"]=0x1D780, -- 𝞀
 },
 [0x1D781]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL FINAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C2 },
  ["unicodeslot"]=0x1D781, -- 𝞁
 },
 [0x1D782]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C3 },
  ["unicodeslot"]=0x1D782, -- 𝞂
 },
 [0x1D783]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C4 },
  ["unicodeslot"]=0x1D783, -- 𝞃
 },
 [0x1D784]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C5 },
  ["unicodeslot"]=0x1D784, -- 𝞄
 },
 [0x1D785]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C6 },
  ["unicodeslot"]=0x1D785, -- 𝞅
 },
 [0x1D786]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C7 },
  ["unicodeslot"]=0x1D786, -- 𝞆
 },
 [0x1D787]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C8 },
  ["unicodeslot"]=0x1D787, -- 𝞇
 },
 [0x1D788]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C9 },
  ["unicodeslot"]=0x1D788, -- 𝞈
 },
 [0x1D789]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD PARTIAL DIFFERENTIAL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2202 },
  ["unicodeslot"]=0x1D789, -- 𝞉
 },
 [0x1D78A]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F5 },
  ["unicodeslot"]=0x1D78A, -- 𝞊
 },
 [0x1D78B]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D1 },
  ["unicodeslot"]=0x1D78B, -- 𝞋
 },
 [0x1D78C]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD KAPPA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F0 },
  ["unicodeslot"]=0x1D78C, -- 𝞌
 },
 [0x1D78D]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD PHI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D5 },
  ["unicodeslot"]=0x1D78D, -- 𝞍
 },
 [0x1D78E]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD RHO SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F1 },
  ["unicodeslot"]=0x1D78E, -- 𝞎
 },
 [0x1D78F]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD PI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D6 },
  ["unicodeslot"]=0x1D78F, -- 𝞏
 },
 [0x1D790]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0391 },
  ["unicodeslot"]=0x1D790, -- 𝞐
 },
 [0x1D791]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0392 },
  ["unicodeslot"]=0x1D791, -- 𝞑
 },
 [0x1D792]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0393 },
  ["unicodeslot"]=0x1D792, -- 𝞒
 },
 [0x1D793]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0394 },
  ["unicodeslot"]=0x1D793, -- 𝞓
 },
 [0x1D794]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0395 },
  ["unicodeslot"]=0x1D794, -- 𝞔
 },
 [0x1D795]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0396 },
  ["unicodeslot"]=0x1D795, -- 𝞕
 },
 [0x1D796]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0397 },
  ["unicodeslot"]=0x1D796, -- 𝞖
 },
 [0x1D797]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0398 },
  ["unicodeslot"]=0x1D797, -- 𝞗
 },
 [0x1D798]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x0399 },
  ["unicodeslot"]=0x1D798, -- 𝞘
 },
 [0x1D799]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039A },
  ["unicodeslot"]=0x1D799, -- 𝞙
 },
 [0x1D79A]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039B },
  ["unicodeslot"]=0x1D79A, -- 𝞚
 },
 [0x1D79B]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039C },
  ["unicodeslot"]=0x1D79B, -- 𝞛
 },
 [0x1D79C]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039D },
  ["unicodeslot"]=0x1D79C, -- 𝞜
 },
 [0x1D79D]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039E },
  ["unicodeslot"]=0x1D79D, -- 𝞝
 },
 [0x1D79E]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x039F },
  ["unicodeslot"]=0x1D79E, -- 𝞞
 },
 [0x1D79F]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A0 },
  ["unicodeslot"]=0x1D79F, -- 𝞟
 },
 [0x1D7A0]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A1 },
  ["unicodeslot"]=0x1D7A0, -- 𝞠
 },
 [0x1D7A1]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F4 },
  ["unicodeslot"]=0x1D7A1, -- 𝞡
 },
 [0x1D7A2]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A3 },
  ["unicodeslot"]=0x1D7A2, -- 𝞢
 },
 [0x1D7A3]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A4 },
  ["unicodeslot"]=0x1D7A3, -- 𝞣
 },
 [0x1D7A4]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A5 },
  ["unicodeslot"]=0x1D7A4, -- 𝞤
 },
 [0x1D7A5]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A6 },
  ["unicodeslot"]=0x1D7A5, -- 𝞥
 },
 [0x1D7A6]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A7 },
  ["unicodeslot"]=0x1D7A6, -- 𝞦
 },
 [0x1D7A7]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A8 },
  ["unicodeslot"]=0x1D7A7, -- 𝞧
 },
 [0x1D7A8]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03A9 },
  ["unicodeslot"]=0x1D7A8, -- 𝞨
 },
 [0x1D7A9]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC NABLA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2207 },
  ["unicodeslot"]=0x1D7A9, -- 𝞩
 },
 [0x1D7AA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B1 },
  ["unicodeslot"]=0x1D7AA, -- 𝞪
 },
 [0x1D7AB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL BETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B2 },
  ["unicodeslot"]=0x1D7AB, -- 𝞫
 },
 [0x1D7AC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL GAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B3 },
  ["unicodeslot"]=0x1D7AC, -- 𝞬
 },
 [0x1D7AD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL DELTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B4 },
  ["unicodeslot"]=0x1D7AD, -- 𝞭
 },
 [0x1D7AE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL EPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B5 },
  ["unicodeslot"]=0x1D7AE, -- 𝞮
 },
 [0x1D7AF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ZETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B6 },
  ["unicodeslot"]=0x1D7AF, -- 𝞯
 },
 [0x1D7B0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B7 },
  ["unicodeslot"]=0x1D7B0, -- 𝞰
 },
 [0x1D7B1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL THETA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B8 },
  ["unicodeslot"]=0x1D7B1, -- 𝞱
 },
 [0x1D7B2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL IOTA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03B9 },
  ["unicodeslot"]=0x1D7B2, -- 𝞲
 },
 [0x1D7B3]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL KAPPA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BA },
  ["unicodeslot"]=0x1D7B3, -- 𝞳
 },
 [0x1D7B4]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL LAMDA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BB },
  ["unicodeslot"]=0x1D7B4, -- 𝞴
 },
 [0x1D7B5]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL MU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BC },
  ["unicodeslot"]=0x1D7B5, -- 𝞵
 },
 [0x1D7B6]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL NU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BD },
  ["unicodeslot"]=0x1D7B6, -- 𝞶
 },
 [0x1D7B7]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL XI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BE },
  ["unicodeslot"]=0x1D7B7, -- 𝞷
 },
 [0x1D7B8]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMICRON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03BF },
  ["unicodeslot"]=0x1D7B8, -- 𝞸
 },
 [0x1D7B9]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C0 },
  ["unicodeslot"]=0x1D7B9, -- 𝞹
 },
 [0x1D7BA]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL RHO",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C1 },
  ["unicodeslot"]=0x1D7BA, -- 𝞺
 },
 [0x1D7BB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL FINAL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C2 },
  ["unicodeslot"]=0x1D7BB, -- 𝞻
 },
 [0x1D7BC]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL SIGMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C3 },
  ["unicodeslot"]=0x1D7BC, -- 𝞼
 },
 [0x1D7BD]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL TAU",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C4 },
  ["unicodeslot"]=0x1D7BD, -- 𝞽
 },
 [0x1D7BE]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL UPSILON",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C5 },
  ["unicodeslot"]=0x1D7BE, -- 𝞾
 },
 [0x1D7BF]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C6 },
  ["unicodeslot"]=0x1D7BF, -- 𝞿
 },
 [0x1D7C0]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL CHI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C7 },
  ["unicodeslot"]=0x1D7C0, -- 𝟀
 },
 [0x1D7C1]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PSI",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C8 },
  ["unicodeslot"]=0x1D7C1, -- 𝟁
 },
 [0x1D7C2]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03C9 },
  ["unicodeslot"]=0x1D7C2, -- 𝟂
 },
 [0x1D7C3]={
  ["category"]="sm",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC PARTIAL DIFFERENTIAL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x2202 },
  ["unicodeslot"]=0x1D7C3, -- 𝟃
 },
 [0x1D7C4]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F5 },
  ["unicodeslot"]=0x1D7C4, -- 𝟄
 },
 [0x1D7C5]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC THETA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D1 },
  ["unicodeslot"]=0x1D7C5, -- 𝟅
 },
 [0x1D7C6]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC KAPPA SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F0 },
  ["unicodeslot"]=0x1D7C6, -- 𝟆
 },
 [0x1D7C7]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC PHI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D5 },
  ["unicodeslot"]=0x1D7C7, -- 𝟇
 },
 [0x1D7C8]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC RHO SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03F1 },
  ["unicodeslot"]=0x1D7C8, -- 𝟈
 },
 [0x1D7C9]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD ITALIC PI SYMBOL",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03D6 },
  ["unicodeslot"]=0x1D7C9, -- 𝟉
 },
 [0x1D7CA]={
  ["category"]="lu",
  ["description"]="MATHEMATICAL BOLD CAPITAL DIGAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03DC },
  ["unicodeslot"]=0x1D7CA, -- 𝟊
 },
 [0x1D7CB]={
  ["category"]="ll",
  ["description"]="MATHEMATICAL BOLD SMALL DIGAMMA",
  ["linebreak"]="al",
  ["specials"]={ "font", 0x03DD },
  ["unicodeslot"]=0x1D7CB, -- 𝟋
 },
 [0x1D7CE]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT ZERO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0030 },
  ["unicodeslot"]=0x1D7CE, -- 𝟎
 },
 [0x1D7CF]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT ONE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0031 },
  ["unicodeslot"]=0x1D7CF, -- 𝟏
 },
 [0x1D7D0]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT TWO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0032 },
  ["unicodeslot"]=0x1D7D0, -- 𝟐
 },
 [0x1D7D1]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT THREE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0033 },
  ["unicodeslot"]=0x1D7D1, -- 𝟑
 },
 [0x1D7D2]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT FOUR",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0034 },
  ["unicodeslot"]=0x1D7D2, -- 𝟒
 },
 [0x1D7D3]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT FIVE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0035 },
  ["unicodeslot"]=0x1D7D3, -- 𝟓
 },
 [0x1D7D4]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT SIX",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0036 },
  ["unicodeslot"]=0x1D7D4, -- 𝟔
 },
 [0x1D7D5]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT SEVEN",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0037 },
  ["unicodeslot"]=0x1D7D5, -- 𝟕
 },
 [0x1D7D6]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT EIGHT",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0038 },
  ["unicodeslot"]=0x1D7D6, -- 𝟖
 },
 [0x1D7D7]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL BOLD DIGIT NINE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0039 },
  ["unicodeslot"]=0x1D7D7, -- 𝟗
 },
 [0x1D7D8]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT ZERO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0030 },
  ["unicodeslot"]=0x1D7D8, -- 𝟘
 },
 [0x1D7D9]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT ONE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0031 },
  ["unicodeslot"]=0x1D7D9, -- 𝟙
 },
 [0x1D7DA]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT TWO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0032 },
  ["unicodeslot"]=0x1D7DA, -- 𝟚
 },
 [0x1D7DB]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT THREE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0033 },
  ["unicodeslot"]=0x1D7DB, -- 𝟛
 },
 [0x1D7DC]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT FOUR",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0034 },
  ["unicodeslot"]=0x1D7DC, -- 𝟜
 },
 [0x1D7DD]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT FIVE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0035 },
  ["unicodeslot"]=0x1D7DD, -- 𝟝
 },
 [0x1D7DE]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT SIX",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0036 },
  ["unicodeslot"]=0x1D7DE, -- 𝟞
 },
 [0x1D7DF]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT SEVEN",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0037 },
  ["unicodeslot"]=0x1D7DF, -- 𝟟
 },
 [0x1D7E0]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT EIGHT",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0038 },
  ["unicodeslot"]=0x1D7E0, -- 𝟠
 },
 [0x1D7E1]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL DOUBLE-STRUCK DIGIT NINE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0039 },
  ["unicodeslot"]=0x1D7E1, -- 𝟡
 },
 [0x1D7E2]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT ZERO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0030 },
  ["unicodeslot"]=0x1D7E2, -- 𝟢
 },
 [0x1D7E3]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT ONE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0031 },
  ["unicodeslot"]=0x1D7E3, -- 𝟣
 },
 [0x1D7E4]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT TWO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0032 },
  ["unicodeslot"]=0x1D7E4, -- 𝟤
 },
 [0x1D7E5]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT THREE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0033 },
  ["unicodeslot"]=0x1D7E5, -- 𝟥
 },
 [0x1D7E6]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT FOUR",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0034 },
  ["unicodeslot"]=0x1D7E6, -- 𝟦
 },
 [0x1D7E7]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT FIVE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0035 },
  ["unicodeslot"]=0x1D7E7, -- 𝟧
 },
 [0x1D7E8]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT SIX",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0036 },
  ["unicodeslot"]=0x1D7E8, -- 𝟨
 },
 [0x1D7E9]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT SEVEN",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0037 },
  ["unicodeslot"]=0x1D7E9, -- 𝟩
 },
 [0x1D7EA]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT EIGHT",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0038 },
  ["unicodeslot"]=0x1D7EA, -- 𝟪
 },
 [0x1D7EB]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF DIGIT NINE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0039 },
  ["unicodeslot"]=0x1D7EB, -- 𝟫
 },
 [0x1D7EC]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT ZERO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0030 },
  ["unicodeslot"]=0x1D7EC, -- 𝟬
 },
 [0x1D7ED]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT ONE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0031 },
  ["unicodeslot"]=0x1D7ED, -- 𝟭
 },
 [0x1D7EE]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT TWO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0032 },
  ["unicodeslot"]=0x1D7EE, -- 𝟮
 },
 [0x1D7EF]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT THREE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0033 },
  ["unicodeslot"]=0x1D7EF, -- 𝟯
 },
 [0x1D7F0]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT FOUR",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0034 },
  ["unicodeslot"]=0x1D7F0, -- 𝟰
 },
 [0x1D7F1]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT FIVE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0035 },
  ["unicodeslot"]=0x1D7F1, -- 𝟱
 },
 [0x1D7F2]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT SIX",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0036 },
  ["unicodeslot"]=0x1D7F2, -- 𝟲
 },
 [0x1D7F3]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT SEVEN",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0037 },
  ["unicodeslot"]=0x1D7F3, -- 𝟳
 },
 [0x1D7F4]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT EIGHT",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0038 },
  ["unicodeslot"]=0x1D7F4, -- 𝟴
 },
 [0x1D7F5]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL SANS-SERIF BOLD DIGIT NINE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0039 },
  ["unicodeslot"]=0x1D7F5, -- 𝟵
 },
 [0x1D7F6]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT ZERO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0030 },
  ["unicodeslot"]=0x1D7F6, -- 𝟶
 },
 [0x1D7F7]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT ONE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0031 },
  ["unicodeslot"]=0x1D7F7, -- 𝟷
 },
 [0x1D7F8]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT TWO",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0032 },
  ["unicodeslot"]=0x1D7F8, -- 𝟸
 },
 [0x1D7F9]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT THREE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0033 },
  ["unicodeslot"]=0x1D7F9, -- 𝟹
 },
 [0x1D7FA]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT FOUR",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0034 },
  ["unicodeslot"]=0x1D7FA, -- 𝟺
 },
 [0x1D7FB]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT FIVE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0035 },
  ["unicodeslot"]=0x1D7FB, -- 𝟻
 },
 [0x1D7FC]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT SIX",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0036 },
  ["unicodeslot"]=0x1D7FC, -- 𝟼
 },
 [0x1D7FD]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT SEVEN",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0037 },
  ["unicodeslot"]=0x1D7FD, -- 𝟽
 },
 [0x1D7FE]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT EIGHT",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0038 },
  ["unicodeslot"]=0x1D7FE, -- 𝟾
 },
 [0x1D7FF]={
  ["category"]="nd",
  ["description"]="MATHEMATICAL MONOSPACE DIGIT NINE",
  ["linebreak"]="nu",
  ["specials"]={ "font", 0x0039 },
  ["unicodeslot"]=0x1D7FF, -- 𝟿
 },
 [0x20000]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="<CJK Ideograph Extension B, First>",
  ["linebreak"]="id",
  ["unicodeslot"]=0x20000, -- 𠀀
 },
 [0x2A6D6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="<CJK Ideograph Extension B, Last>",
  ["linebreak"]="id",
  ["unicodeslot"]=0x2A6D6, -- 𪛖
 },
 [0x2F800]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0320",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4E3D },
  ["unicodeslot"]=0x2F800, -- 丽
 },
 [0x2F801]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0321",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4E38 },
  ["unicodeslot"]=0x2F801, -- 丸
 },
 [0x2F802]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0322",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4E41 },
  ["unicodeslot"]=0x2F802, -- 乁
 },
 [0x2F803]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0323",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x20122 },
  ["unicodeslot"]=0x2F803, -- 𠄢
 },
 [0x2F804]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0324",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4F60 },
  ["unicodeslot"]=0x2F804, -- 你
 },
 [0x2F805]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0325",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4FAE },
  ["unicodeslot"]=0x2F805, -- 侮
 },
 [0x2F806]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0326",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4FBB },
  ["unicodeslot"]=0x2F806, -- 侻
 },
 [0x2F807]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0327",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5002 },
  ["unicodeslot"]=0x2F807, -- 倂
 },
 [0x2F808]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0328",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x507A },
  ["unicodeslot"]=0x2F808, -- 偺
 },
 [0x2F809]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0329",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5099 },
  ["unicodeslot"]=0x2F809, -- 備
 },
 [0x2F80A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0050A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x50E7 },
  ["unicodeslot"]=0x2F80A, -- 僧
 },
 [0x2F80B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0050B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x50CF },
  ["unicodeslot"]=0x2F80B, -- 像
 },
 [0x2F80C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0050C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x349E },
  ["unicodeslot"]=0x2F80C, -- 㒞
 },
 [0x2F80D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0050D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2063A },
  ["unicodeslot"]=0x2F80D, -- 𠘺
 },
 [0x2F80E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0050E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x514D },
  ["unicodeslot"]=0x2F80E, -- 免
 },
 [0x2F80F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0050F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5154 },
  ["unicodeslot"]=0x2F80F, -- 兔
 },
 [0x2F810]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x032A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5164 },
  ["unicodeslot"]=0x2F810, -- 兤
 },
 [0x2F811]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x032B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5177 },
  ["unicodeslot"]=0x2F811, -- 具
 },
 [0x2F812]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x032C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2051C },
  ["unicodeslot"]=0x2F812, -- 𠔜
 },
 [0x2F813]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x032D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x34B9 },
  ["unicodeslot"]=0x2F813, -- 㒹
 },
 [0x2F814]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x032E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5167 },
  ["unicodeslot"]=0x2F814, -- 內
 },
 [0x2F815]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x032F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x518D },
  ["unicodeslot"]=0x2F815, -- 再
 },
 [0x2F816]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0330",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2054B },
  ["unicodeslot"]=0x2F816, -- 𠕋
 },
 [0x2F817]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0331",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5197 },
  ["unicodeslot"]=0x2F817, -- 冗
 },
 [0x2F818]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0332",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51A4 },
  ["unicodeslot"]=0x2F818, -- 冤
 },
 [0x2F819]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0333",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4ECC },
  ["unicodeslot"]=0x2F819, -- 仌
 },
 [0x2F81A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0051A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51AC },
  ["unicodeslot"]=0x2F81A, -- 冬
 },
 [0x2F81B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0051B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51B5 },
  ["unicodeslot"]=0x2F81B, -- 况
 },
 [0x2F81C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0051C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x291DF },
  ["unicodeslot"]=0x2F81C, -- 𩇟
 },
 [0x2F81D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0051D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x51F5 },
  ["unicodeslot"]=0x2F81D, -- 凵
 },
 [0x2F81E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0051E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5203 },
  ["unicodeslot"]=0x2F81E, -- 刃
 },
 [0x2F81F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0051F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x34DF },
  ["unicodeslot"]=0x2F81F, -- 㓟
 },
 [0x2F820]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0334",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x523B },
  ["unicodeslot"]=0x2F820, -- 刻
 },
 [0x2F821]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0335",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5246 },
  ["unicodeslot"]=0x2F821, -- 剆
 },
 [0x2F822]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0336",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5272 },
  ["unicodeslot"]=0x2F822, -- 割
 },
 [0x2F823]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0337",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5277 },
  ["unicodeslot"]=0x2F823, -- 剷
 },
 [0x2F824]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0338",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3515 },
  ["unicodeslot"]=0x2F824, -- 㔕
 },
 [0x2F825]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0339",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52C7 },
  ["unicodeslot"]=0x2F825, -- 勇
 },
 [0x2F826]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x033A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52C9 },
  ["unicodeslot"]=0x2F826, -- 勉
 },
 [0x2F827]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x033B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52E4 },
  ["unicodeslot"]=0x2F827, -- 勤
 },
 [0x2F828]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x033C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52FA },
  ["unicodeslot"]=0x2F828, -- 勺
 },
 [0x2F829]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x033D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5305 },
  ["unicodeslot"]=0x2F829, -- 包
 },
 [0x2F82A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0052A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5306 },
  ["unicodeslot"]=0x2F82A, -- 匆
 },
 [0x2F82B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0052B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5317 },
  ["unicodeslot"]=0x2F82B, -- 北
 },
 [0x2F82C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0052C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5349 },
  ["unicodeslot"]=0x2F82C, -- 卉
 },
 [0x2F82D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0052D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5351 },
  ["unicodeslot"]=0x2F82D, -- 卑
 },
 [0x2F82E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0052E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x535A },
  ["unicodeslot"]=0x2F82E, -- 博
 },
 [0x2F82F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0052F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5373 },
  ["unicodeslot"]=0x2F82F, -- 即
 },
 [0x2F830]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x033E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x537D },
  ["unicodeslot"]=0x2F830, -- 卽
 },
 [0x2F831]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x033F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x537F },
  ["unicodeslot"]=0x2F831, -- 卿
 },
 [0x2F832]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0340",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x537F },
  ["unicodeslot"]=0x2F832, -- 卿
 },
 [0x2F833]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0341",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x537F },
  ["unicodeslot"]=0x2F833, -- 卿
 },
 [0x2F834]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0342",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x20A2C },
  ["unicodeslot"]=0x2F834, -- 𠨬
 },
 [0x2F835]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0343",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7070 },
  ["unicodeslot"]=0x2F835, -- 灰
 },
 [0x2F836]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0344",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x53CA },
  ["unicodeslot"]=0x2F836, -- 及
 },
 [0x2F837]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0345",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x53DF },
  ["unicodeslot"]=0x2F837, -- 叟
 },
 [0x2F838]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0346",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x20B63 },
  ["unicodeslot"]=0x2F838, -- 𠭣
 },
 [0x2F839]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0347",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x53EB },
  ["unicodeslot"]=0x2F839, -- 叫
 },
 [0x2F83A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0053A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x53F1 },
  ["unicodeslot"]=0x2F83A, -- 叱
 },
 [0x2F83B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0053B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5406 },
  ["unicodeslot"]=0x2F83B, -- 吆
 },
 [0x2F83C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0053C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x549E },
  ["unicodeslot"]=0x2F83C, -- 咞
 },
 [0x2F83D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0053D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5438 },
  ["unicodeslot"]=0x2F83D, -- 吸
 },
 [0x2F83E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0053E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5448 },
  ["unicodeslot"]=0x2F83E, -- 呈
 },
 [0x2F83F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0053F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5468 },
  ["unicodeslot"]=0x2F83F, -- 周
 },
 [0x2F840]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0348",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x54A2 },
  ["unicodeslot"]=0x2F840, -- 咢
 },
 [0x2F841]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0349",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x54F6 },
  ["unicodeslot"]=0x2F841, -- 哶
 },
 [0x2F842]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x034A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5510 },
  ["unicodeslot"]=0x2F842, -- 唐
 },
 [0x2F843]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x034B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5553 },
  ["unicodeslot"]=0x2F843, -- 啓
 },
 [0x2F844]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x034C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5563 },
  ["unicodeslot"]=0x2F844, -- 啣
 },
 [0x2F845]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x034D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5584 },
  ["unicodeslot"]=0x2F845, -- 善
 },
 [0x2F846]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x034E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5584 },
  ["unicodeslot"]=0x2F846, -- 善
 },
 [0x2F847]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x034F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5599 },
  ["unicodeslot"]=0x2F847, -- 喙
 },
 [0x2F848]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0350",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x55AB },
  ["unicodeslot"]=0x2F848, -- 喫
 },
 [0x2F849]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0351",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x55B3 },
  ["unicodeslot"]=0x2F849, -- 喳
 },
 [0x2F84A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0054A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x55C2 },
  ["unicodeslot"]=0x2F84A, -- 嗂
 },
 [0x2F84B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0054B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5716 },
  ["unicodeslot"]=0x2F84B, -- 圖
 },
 [0x2F84C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0054C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5606 },
  ["unicodeslot"]=0x2F84C, -- 嘆
 },
 [0x2F84D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0054D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5717 },
  ["unicodeslot"]=0x2F84D, -- 圗
 },
 [0x2F84E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0054E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5651 },
  ["unicodeslot"]=0x2F84E, -- 噑
 },
 [0x2F84F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0054F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5674 },
  ["unicodeslot"]=0x2F84F, -- 噴
 },
 [0x2F850]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0352",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5207 },
  ["unicodeslot"]=0x2F850, -- 切
 },
 [0x2F851]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0353",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x58EE },
  ["unicodeslot"]=0x2F851, -- 壮
 },
 [0x2F852]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0354",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x57CE },
  ["unicodeslot"]=0x2F852, -- 城
 },
 [0x2F853]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0355",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x57F4 },
  ["unicodeslot"]=0x2F853, -- 埴
 },
 [0x2F854]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0356",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x580D },
  ["unicodeslot"]=0x2F854, -- 堍
 },
 [0x2F855]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0357",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x578B },
  ["unicodeslot"]=0x2F855, -- 型
 },
 [0x2F856]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0358",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5832 },
  ["unicodeslot"]=0x2F856, -- 堲
 },
 [0x2F857]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0359",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5831 },
  ["unicodeslot"]=0x2F857, -- 報
 },
 [0x2F858]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x035A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x58AC },
  ["unicodeslot"]=0x2F858, -- 墬
 },
 [0x2F859]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x035B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x214E4 },
  ["unicodeslot"]=0x2F859, -- 𡓤
 },
 [0x2F85A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0055A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x58F2 },
  ["unicodeslot"]=0x2F85A, -- 売
 },
 [0x2F85B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0055B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x58F7 },
  ["unicodeslot"]=0x2F85B, -- 壷
 },
 [0x2F85C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0055C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5906 },
  ["unicodeslot"]=0x2F85C, -- 夆
 },
 [0x2F85D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0055D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x591A },
  ["unicodeslot"]=0x2F85D, -- 多
 },
 [0x2F85E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0055E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5922 },
  ["unicodeslot"]=0x2F85E, -- 夢
 },
 [0x2F85F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0055F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5962 },
  ["unicodeslot"]=0x2F85F, -- 奢
 },
 [0x2F860]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x035C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x216A8 },
  ["unicodeslot"]=0x2F860, -- 𡚨
 },
 [0x2F861]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x035D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x216EA },
  ["unicodeslot"]=0x2F861, -- 𡛪
 },
 [0x2F862]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x035E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x59EC },
  ["unicodeslot"]=0x2F862, -- 姬
 },
 [0x2F863]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x035F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5A1B },
  ["unicodeslot"]=0x2F863, -- 娛
 },
 [0x2F864]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0360",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5A27 },
  ["unicodeslot"]=0x2F864, -- 娧
 },
 [0x2F865]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0361",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x59D8 },
  ["unicodeslot"]=0x2F865, -- 姘
 },
 [0x2F866]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0362",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5A66 },
  ["unicodeslot"]=0x2F866, -- 婦
 },
 [0x2F867]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0363",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x36EE },
  ["unicodeslot"]=0x2F867, -- 㛮
 },
 [0x2F868]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0364",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x36FC },
  ["unicodeslot"]=0x2F868, -- 㛼
 },
 [0x2F869]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0365",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5B08 },
  ["unicodeslot"]=0x2F869, -- 嬈
 },
 [0x2F86A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0056A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5B3E },
  ["unicodeslot"]=0x2F86A, -- 嬾
 },
 [0x2F86B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0056B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5B3E },
  ["unicodeslot"]=0x2F86B, -- 嬾
 },
 [0x2F86C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0056C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x219C8 },
  ["unicodeslot"]=0x2F86C, -- 𡧈
 },
 [0x2F86D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0056D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5BC3 },
  ["unicodeslot"]=0x2F86D, -- 寃
 },
 [0x2F86E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0056E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5BD8 },
  ["unicodeslot"]=0x2F86E, -- 寘
 },
 [0x2F86F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0056F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5BE7 },
  ["unicodeslot"]=0x2F86F, -- 寧
 },
 [0x2F870]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0366",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5BF3 },
  ["unicodeslot"]=0x2F870, -- 寳
 },
 [0x2F871]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0367",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x21B18 },
  ["unicodeslot"]=0x2F871, -- 𡬘
 },
 [0x2F872]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0368",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5BFF },
  ["unicodeslot"]=0x2F872, -- 寿
 },
 [0x2F873]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0369",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C06 },
  ["unicodeslot"]=0x2F873, -- 将
 },
 [0x2F874]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x036A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5F53 },
  ["unicodeslot"]=0x2F874, -- 当
 },
 [0x2F875]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x036B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C22 },
  ["unicodeslot"]=0x2F875, -- 尢
 },
 [0x2F876]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x036C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3781 },
  ["unicodeslot"]=0x2F876, -- 㞁
 },
 [0x2F877]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x036D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C60 },
  ["unicodeslot"]=0x2F877, -- 屠
 },
 [0x2F878]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x036E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C6E },
  ["unicodeslot"]=0x2F878, -- 屮
 },
 [0x2F879]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x036F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5CC0 },
  ["unicodeslot"]=0x2F879, -- 峀
 },
 [0x2F87A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0057A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5C8D },
  ["unicodeslot"]=0x2F87A, -- 岍
 },
 [0x2F87B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0057B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x21DE4 },
  ["unicodeslot"]=0x2F87B, -- 𡷤
 },
 [0x2F87C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0057C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5D43 },
  ["unicodeslot"]=0x2F87C, -- 嵃
 },
 [0x2F87D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0057D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x21DE6 },
  ["unicodeslot"]=0x2F87D, -- 𡷦
 },
 [0x2F87E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0057E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5D6E },
  ["unicodeslot"]=0x2F87E, -- 嵮
 },
 [0x2F87F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0057F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5D6B },
  ["unicodeslot"]=0x2F87F, -- 嵫
 },
 [0x2F880]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0370",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5D7C },
  ["unicodeslot"]=0x2F880, -- 嵼
 },
 [0x2F881]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0371",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5DE1 },
  ["unicodeslot"]=0x2F881, -- 巡
 },
 [0x2F882]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0372",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5DE2 },
  ["unicodeslot"]=0x2F882, -- 巢
 },
 [0x2F883]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0373",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x382F },
  ["unicodeslot"]=0x2F883, -- 㠯
 },
 [0x2F884]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0374",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5DFD },
  ["unicodeslot"]=0x2F884, -- 巽
 },
 [0x2F885]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0375",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5E28 },
  ["unicodeslot"]=0x2F885, -- 帨
 },
 [0x2F886]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0376",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5E3D },
  ["unicodeslot"]=0x2F886, -- 帽
 },
 [0x2F887]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0377",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5E69 },
  ["unicodeslot"]=0x2F887, -- 幩
 },
 [0x2F888]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0378",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3862 },
  ["unicodeslot"]=0x2F888, -- 㡢
 },
 [0x2F889]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0379",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x22183 },
  ["unicodeslot"]=0x2F889, -- 𢆃
 },
 [0x2F88A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0058A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x387C },
  ["unicodeslot"]=0x2F88A, -- 㡼
 },
 [0x2F88B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0058B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5EB0 },
  ["unicodeslot"]=0x2F88B, -- 庰
 },
 [0x2F88C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0058C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5EB3 },
  ["unicodeslot"]=0x2F88C, -- 庳
 },
 [0x2F88D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0058D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5EB6 },
  ["unicodeslot"]=0x2F88D, -- 庶
 },
 [0x2F88E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0058E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5ECA },
  ["unicodeslot"]=0x2F88E, -- 廊
 },
 [0x2F88F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0058F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2A392 },
  ["unicodeslot"]=0x2F88F, -- 𪎒
 },
 [0x2F890]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x037A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5EFE },
  ["unicodeslot"]=0x2F890, -- 廾
 },
 [0x2F891]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x037B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x22331 },
  ["unicodeslot"]=0x2F891, -- 𢌱
 },
 [0x2F892]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x037C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x22331 },
  ["unicodeslot"]=0x2F892, -- 𢌱
 },
 [0x2F893]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x037D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8201 },
  ["unicodeslot"]=0x2F893, -- 舁
 },
 [0x2F894]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x037E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5F22 },
  ["unicodeslot"]=0x2F894, -- 弢
 },
 [0x2F895]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x037F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5F22 },
  ["unicodeslot"]=0x2F895, -- 弢
 },
 [0x2F896]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0380",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x38C7 },
  ["unicodeslot"]=0x2F896, -- 㣇
 },
 [0x2F897]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0381",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x232B8 },
  ["unicodeslot"]=0x2F897, -- 𣊸
 },
 [0x2F898]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0382",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x261DA },
  ["unicodeslot"]=0x2F898, -- 𦇚
 },
 [0x2F899]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0383",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5F62 },
  ["unicodeslot"]=0x2F899, -- 形
 },
 [0x2F89A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0059A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5F6B },
  ["unicodeslot"]=0x2F89A, -- 彫
 },
 [0x2F89B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0059B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x38E3 },
  ["unicodeslot"]=0x2F89B, -- 㣣
 },
 [0x2F89C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0059C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5F9A },
  ["unicodeslot"]=0x2F89C, -- 徚
 },
 [0x2F89D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0059D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5FCD },
  ["unicodeslot"]=0x2F89D, -- 忍
 },
 [0x2F89E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0059E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5FD7 },
  ["unicodeslot"]=0x2F89E, -- 志
 },
 [0x2F89F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0059F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5FF9 },
  ["unicodeslot"]=0x2F89F, -- 忹
 },
 [0x2F8A0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6081 },
  ["unicodeslot"]=0x2F8A0, -- 悁
 },
 [0x2F8A1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x393A },
  ["unicodeslot"]=0x2F8A1, -- 㤺
 },
 [0x2F8A2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x391C },
  ["unicodeslot"]=0x2F8A2, -- 㤜
 },
 [0x2F8A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6094 },
  ["unicodeslot"]=0x2F8A3, -- 悔
 },
 [0x2F8A4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x226D4 },
  ["unicodeslot"]=0x2F8A4, -- 𢛔
 },
 [0x2F8A5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x60C7 },
  ["unicodeslot"]=0x2F8A5, -- 惇
 },
 [0x2F8A6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6148 },
  ["unicodeslot"]=0x2F8A6, -- 慈
 },
 [0x2F8A7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x614C },
  ["unicodeslot"]=0x2F8A7, -- 慌
 },
 [0x2F8A8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x614E },
  ["unicodeslot"]=0x2F8A8, -- 慎
 },
 [0x2F8A9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008A0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x614C },
  ["unicodeslot"]=0x2F8A9, -- 慌
 },
 [0x2F8AA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008AA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x617A },
  ["unicodeslot"]=0x2F8AA, -- 慺
 },
 [0x2F8AB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008AB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x618E },
  ["unicodeslot"]=0x2F8AB, -- 憎
 },
 [0x2F8AC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008AC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x61B2 },
  ["unicodeslot"]=0x2F8AC, -- 憲
 },
 [0x2F8AD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008AD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x61A4 },
  ["unicodeslot"]=0x2F8AD, -- 憤
 },
 [0x2F8AE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008AE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x61AF },
  ["unicodeslot"]=0x2F8AE, -- 憯
 },
 [0x2F8AF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008AF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x61DE },
  ["unicodeslot"]=0x2F8AF, -- 懞
 },
 [0x2F8B0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x61F2 },
  ["unicodeslot"]=0x2F8B0, -- 懲
 },
 [0x2F8B1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x61F6 },
  ["unicodeslot"]=0x2F8B1, -- 懶
 },
 [0x2F8B2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6210 },
  ["unicodeslot"]=0x2F8B2, -- 成
 },
 [0x2F8B3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x621B },
  ["unicodeslot"]=0x2F8B3, -- 戛
 },
 [0x2F8B4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x625D },
  ["unicodeslot"]=0x2F8B4, -- 扝
 },
 [0x2F8B5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x62B1 },
  ["unicodeslot"]=0x2F8B5, -- 抱
 },
 [0x2F8B6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x62D4 },
  ["unicodeslot"]=0x2F8B6, -- 拔
 },
 [0x2F8B7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6350 },
  ["unicodeslot"]=0x2F8B7, -- 捐
 },
 [0x2F8B8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x22B0C },
  ["unicodeslot"]=0x2F8B8, -- 𢬌
 },
 [0x2F8B9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008B0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x633D },
  ["unicodeslot"]=0x2F8B9, -- 挽
 },
 [0x2F8BA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008BA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x62FC },
  ["unicodeslot"]=0x2F8BA, -- 拼
 },
 [0x2F8BB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008BB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6368 },
  ["unicodeslot"]=0x2F8BB, -- 捨
 },
 [0x2F8BC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008BC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6383 },
  ["unicodeslot"]=0x2F8BC, -- 掃
 },
 [0x2F8BD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008BD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x63E4 },
  ["unicodeslot"]=0x2F8BD, -- 揤
 },
 [0x2F8BE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008BE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x22BF1 },
  ["unicodeslot"]=0x2F8BE, -- 𢯱
 },
 [0x2F8BF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008BF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6422 },
  ["unicodeslot"]=0x2F8BF, -- 搢
 },
 [0x2F8C0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x63C5 },
  ["unicodeslot"]=0x2F8C0, -- 揅
 },
 [0x2F8C1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x63A9 },
  ["unicodeslot"]=0x2F8C1, -- 掩
 },
 [0x2F8C2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3A2E },
  ["unicodeslot"]=0x2F8C2, -- 㨮
 },
 [0x2F8C3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6469 },
  ["unicodeslot"]=0x2F8C3, -- 摩
 },
 [0x2F8C4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x647E },
  ["unicodeslot"]=0x2F8C4, -- 摾
 },
 [0x2F8C5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x649D },
  ["unicodeslot"]=0x2F8C5, -- 撝
 },
 [0x2F8C6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6477 },
  ["unicodeslot"]=0x2F8C6, -- 摷
 },
 [0x2F8C7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3A6C },
  ["unicodeslot"]=0x2F8C7, -- 㩬
 },
 [0x2F8C8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x654F },
  ["unicodeslot"]=0x2F8C8, -- 敏
 },
 [0x2F8C9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008C0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x656C },
  ["unicodeslot"]=0x2F8C9, -- 敬
 },
 [0x2F8CA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008CA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2300A },
  ["unicodeslot"]=0x2F8CA, -- 𣀊
 },
 [0x2F8CB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008CB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x65E3 },
  ["unicodeslot"]=0x2F8CB, -- 旣
 },
 [0x2F8CC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008CC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x66F8 },
  ["unicodeslot"]=0x2F8CC, -- 書
 },
 [0x2F8CD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008CD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6649 },
  ["unicodeslot"]=0x2F8CD, -- 晉
 },
 [0x2F8CE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008CE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3B19 },
  ["unicodeslot"]=0x2F8CE, -- 㬙
 },
 [0x2F8CF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008CF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6691 },
  ["unicodeslot"]=0x2F8CF, -- 暑
 },
 [0x2F8D0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3B08 },
  ["unicodeslot"]=0x2F8D0, -- 㬈
 },
 [0x2F8D1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3AE4 },
  ["unicodeslot"]=0x2F8D1, -- 㫤
 },
 [0x2F8D2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5192 },
  ["unicodeslot"]=0x2F8D2, -- 冒
 },
 [0x2F8D3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5195 },
  ["unicodeslot"]=0x2F8D3, -- 冕
 },
 [0x2F8D4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6700 },
  ["unicodeslot"]=0x2F8D4, -- 最
 },
 [0x2F8D5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x669C },
  ["unicodeslot"]=0x2F8D5, -- 暜
 },
 [0x2F8D6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x80AD },
  ["unicodeslot"]=0x2F8D6, -- 肭
 },
 [0x2F8D7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x43D9 },
  ["unicodeslot"]=0x2F8D7, -- 䏙
 },
 [0x2F8D8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6717 },
  ["unicodeslot"]=0x2F8D8, -- 朗
 },
 [0x2F8D9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008D0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x671B },
  ["unicodeslot"]=0x2F8D9, -- 望
 },
 [0x2F8DA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008DA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6721 },
  ["unicodeslot"]=0x2F8DA, -- 朡
 },
 [0x2F8DB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008DB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x675E },
  ["unicodeslot"]=0x2F8DB, -- 杞
 },
 [0x2F8DC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008DC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6753 },
  ["unicodeslot"]=0x2F8DC, -- 杓
 },
 [0x2F8DD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008DD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x233C3 },
  ["unicodeslot"]=0x2F8DD, -- 𣏃
 },
 [0x2F8DE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008DE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3B49 },
  ["unicodeslot"]=0x2F8DE, -- 㭉
 },
 [0x2F8DF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008DF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x67FA },
  ["unicodeslot"]=0x2F8DF, -- 柺
 },
 [0x2F8E0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6785 },
  ["unicodeslot"]=0x2F8E0, -- 枅
 },
 [0x2F8E1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6852 },
  ["unicodeslot"]=0x2F8E1, -- 桒
 },
 [0x2F8E2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6885 },
  ["unicodeslot"]=0x2F8E2, -- 梅
 },
 [0x2F8E3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2346D },
  ["unicodeslot"]=0x2F8E3, -- 𣑭
 },
 [0x2F8E4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x688E },
  ["unicodeslot"]=0x2F8E4, -- 梎
 },
 [0x2F8E5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x681F },
  ["unicodeslot"]=0x2F8E5, -- 栟
 },
 [0x2F8E6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6914 },
  ["unicodeslot"]=0x2F8E6, -- 椔
 },
 [0x2F8E7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3B9D },
  ["unicodeslot"]=0x2F8E7, -- 㮝
 },
 [0x2F8E8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6942 },
  ["unicodeslot"]=0x2F8E8, -- 楂
 },
 [0x2F8E9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008E0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x69A3 },
  ["unicodeslot"]=0x2F8E9, -- 榣
 },
 [0x2F8EA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008EA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x69EA },
  ["unicodeslot"]=0x2F8EA, -- 槪
 },
 [0x2F8EB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008EB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6AA8 },
  ["unicodeslot"]=0x2F8EB, -- 檨
 },
 [0x2F8EC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008EC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x236A3 },
  ["unicodeslot"]=0x2F8EC, -- 𣚣
 },
 [0x2F8ED]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008ED",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6ADB },
  ["unicodeslot"]=0x2F8ED, -- 櫛
 },
 [0x2F8EE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008EE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3C18 },
  ["unicodeslot"]=0x2F8EE, -- 㰘
 },
 [0x2F8EF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008EF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6B21 },
  ["unicodeslot"]=0x2F8EF, -- 次
 },
 [0x2F8F0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x238A7 },
  ["unicodeslot"]=0x2F8F0, -- 𣢧
 },
 [0x2F8F1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6B54 },
  ["unicodeslot"]=0x2F8F1, -- 歔
 },
 [0x2F8F2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3C4E },
  ["unicodeslot"]=0x2F8F2, -- 㱎
 },
 [0x2F8F3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6B72 },
  ["unicodeslot"]=0x2F8F3, -- 歲
 },
 [0x2F8F4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6B9F },
  ["unicodeslot"]=0x2F8F4, -- 殟
 },
 [0x2F8F5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6BBA },
  ["unicodeslot"]=0x2F8F5, -- 殺
 },
 [0x2F8F6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6BBB },
  ["unicodeslot"]=0x2F8F6, -- 殻
 },
 [0x2F8F7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x23A8D },
  ["unicodeslot"]=0x2F8F7, -- 𣪍
 },
 [0x2F8F8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x21D0B },
  ["unicodeslot"]=0x2F8F8, -- 𡴋
 },
 [0x2F8F9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008F0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x23AFA },
  ["unicodeslot"]=0x2F8F9, -- 𣫺
 },
 [0x2F8FA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008FA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6C4E },
  ["unicodeslot"]=0x2F8FA, -- 汎
 },
 [0x2F8FB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008FB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x23CBC },
  ["unicodeslot"]=0x2F8FB, -- 𣲼
 },
 [0x2F8FC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008FC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6CBF },
  ["unicodeslot"]=0x2F8FC, -- 沿
 },
 [0x2F8FD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008FD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6CCD },
  ["unicodeslot"]=0x2F8FD, -- 泍
 },
 [0x2F8FE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008FE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6C67 },
  ["unicodeslot"]=0x2F8FE, -- 汧
 },
 [0x2F8FF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0008FF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D16 },
  ["unicodeslot"]=0x2F8FF, -- 洖
 },
 [0x2F900]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0384",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D3E },
  ["unicodeslot"]=0x2F900, -- 派
 },
 [0x2F901]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0385",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D77 },
  ["unicodeslot"]=0x2F901, -- 海
 },
 [0x2F902]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0386",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D41 },
  ["unicodeslot"]=0x2F902, -- 流
 },
 [0x2F903]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0387",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D69 },
  ["unicodeslot"]=0x2F903, -- 浩
 },
 [0x2F904]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0388",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D78 },
  ["unicodeslot"]=0x2F904, -- 浸
 },
 [0x2F905]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0389",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D85 },
  ["unicodeslot"]=0x2F905, -- 涅
 },
 [0x2F906]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x038A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x23D1E },
  ["unicodeslot"]=0x2F906, -- 𣴞
 },
 [0x2F907]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x038B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6D34 },
  ["unicodeslot"]=0x2F907, -- 洴
 },
 [0x2F908]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x038C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6E2F },
  ["unicodeslot"]=0x2F908, -- 港
 },
 [0x2F909]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x038D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6E6E },
  ["unicodeslot"]=0x2F909, -- 湮
 },
 [0x2F90A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005AA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3D33 },
  ["unicodeslot"]=0x2F90A, -- 㴳
 },
 [0x2F90B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005AB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6ECB },
  ["unicodeslot"]=0x2F90B, -- 滋
 },
 [0x2F90C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005AC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6EC7 },
  ["unicodeslot"]=0x2F90C, -- 滇
 },
 [0x2F90D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005AD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x23ED1 },
  ["unicodeslot"]=0x2F90D, -- 𣻑
 },
 [0x2F90E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005AE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6DF9 },
  ["unicodeslot"]=0x2F90E, -- 淹
 },
 [0x2F90F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005AF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6F6E },
  ["unicodeslot"]=0x2F90F, -- 潮
 },
 [0x2F910]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x038E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x23F5E },
  ["unicodeslot"]=0x2F910, -- 𣽞
 },
 [0x2F911]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x038F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x23F8E },
  ["unicodeslot"]=0x2F911, -- 𣾎
 },
 [0x2F912]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0390",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x6FC6 },
  ["unicodeslot"]=0x2F912, -- 濆
 },
 [0x2F913]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0391",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7039 },
  ["unicodeslot"]=0x2F913, -- 瀹
 },
 [0x2F914]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0392",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x701E },
  ["unicodeslot"]=0x2F914, -- 瀞
 },
 [0x2F915]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0393",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x701B },
  ["unicodeslot"]=0x2F915, -- 瀛
 },
 [0x2F916]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0394",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3D96 },
  ["unicodeslot"]=0x2F916, -- 㶖
 },
 [0x2F917]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0395",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x704A },
  ["unicodeslot"]=0x2F917, -- 灊
 },
 [0x2F918]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0396",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x707D },
  ["unicodeslot"]=0x2F918, -- 災
 },
 [0x2F919]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0397",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7077 },
  ["unicodeslot"]=0x2F919, -- 灷
 },
 [0x2F91A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005BA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x70AD },
  ["unicodeslot"]=0x2F91A, -- 炭
 },
 [0x2F91B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005BB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x20525 },
  ["unicodeslot"]=0x2F91B, -- 𠔥
 },
 [0x2F91C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005BC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7145 },
  ["unicodeslot"]=0x2F91C, -- 煅
 },
 [0x2F91D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005BD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x24263 },
  ["unicodeslot"]=0x2F91D, -- 𤉣
 },
 [0x2F91E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005BE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x719C },
  ["unicodeslot"]=0x2F91E, -- 熜
 },
 [0x2F91F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005BF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x243AB },
  ["unicodeslot"]=0x2F91F, -- 𤎫
 },
 [0x2F920]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0398",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7228 },
  ["unicodeslot"]=0x2F920, -- 爨
 },
 [0x2F921]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0399",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7235 },
  ["unicodeslot"]=0x2F921, -- 爵
 },
 [0x2F922]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x039A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7250 },
  ["unicodeslot"]=0x2F922, -- 牐
 },
 [0x2F923]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x039B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x24608 },
  ["unicodeslot"]=0x2F923, -- 𤘈
 },
 [0x2F924]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x039C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7280 },
  ["unicodeslot"]=0x2F924, -- 犀
 },
 [0x2F925]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x039D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7295 },
  ["unicodeslot"]=0x2F925, -- 犕
 },
 [0x2F926]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x039E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x24735 },
  ["unicodeslot"]=0x2F926, -- 𤜵
 },
 [0x2F927]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x039F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x24814 },
  ["unicodeslot"]=0x2F927, -- 𤠔
 },
 [0x2F928]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x737A },
  ["unicodeslot"]=0x2F928, -- 獺
 },
 [0x2F929]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x738B },
  ["unicodeslot"]=0x2F929, -- 王
 },
 [0x2F92A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005CA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3EAC },
  ["unicodeslot"]=0x2F92A, -- 㺬
 },
 [0x2F92B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005CB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x73A5 },
  ["unicodeslot"]=0x2F92B, -- 玥
 },
 [0x2F92C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005CC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3EB8 },
  ["unicodeslot"]=0x2F92C, -- 㺸
 },
 [0x2F92D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005CD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3EB8 },
  ["unicodeslot"]=0x2F92D, -- 㺸
 },
 [0x2F92E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005CE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7447 },
  ["unicodeslot"]=0x2F92E, -- 瑇
 },
 [0x2F92F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005CF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x745C },
  ["unicodeslot"]=0x2F92F, -- 瑜
 },
 [0x2F930]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7471 },
  ["unicodeslot"]=0x2F930, -- 瑱
 },
 [0x2F931]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7485 },
  ["unicodeslot"]=0x2F931, -- 璅
 },
 [0x2F932]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x74CA },
  ["unicodeslot"]=0x2F932, -- 瓊
 },
 [0x2F933]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3F1B },
  ["unicodeslot"]=0x2F933, -- 㼛
 },
 [0x2F934]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7524 },
  ["unicodeslot"]=0x2F934, -- 甤
 },
 [0x2F935]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x24C36 },
  ["unicodeslot"]=0x2F935, -- 𤰶
 },
 [0x2F936]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A8",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x753E },
  ["unicodeslot"]=0x2F936, -- 甾
 },
 [0x2F937]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03A9",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x24C92 },
  ["unicodeslot"]=0x2F937, -- 𤲒
 },
 [0x2F938]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03AA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7570 },
  ["unicodeslot"]=0x2F938, -- 異
 },
 [0x2F939]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03AB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2219F },
  ["unicodeslot"]=0x2F939, -- 𢆟
 },
 [0x2F93A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005DA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7610 },
  ["unicodeslot"]=0x2F93A, -- 瘐
 },
 [0x2F93B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005DB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x24FA1 },
  ["unicodeslot"]=0x2F93B, -- 𤾡
 },
 [0x2F93C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005DC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x24FB8 },
  ["unicodeslot"]=0x2F93C, -- 𤾸
 },
 [0x2F93D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005DD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25044 },
  ["unicodeslot"]=0x2F93D, -- 𥁄
 },
 [0x2F93E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005DE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x3FFC },
  ["unicodeslot"]=0x2F93E, -- 㿼
 },
 [0x2F93F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005DF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4008 },
  ["unicodeslot"]=0x2F93F, -- 䀈
 },
 [0x2F940]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03AC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x76F4 },
  ["unicodeslot"]=0x2F940, -- 直
 },
 [0x2F941]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03AD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x250F3 },
  ["unicodeslot"]=0x2F941, -- 𥃳
 },
 [0x2F942]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03AE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x250F2 },
  ["unicodeslot"]=0x2F942, -- 𥃲
 },
 [0x2F943]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03AF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25119 },
  ["unicodeslot"]=0x2F943, -- 𥄙
 },
 [0x2F944]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25133 },
  ["unicodeslot"]=0x2F944, -- 𥄳
 },
 [0x2F945]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x771E },
  ["unicodeslot"]=0x2F945, -- 眞
 },
 [0x2F946]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x771F },
  ["unicodeslot"]=0x2F946, -- 真
 },
 [0x2F947]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x771F },
  ["unicodeslot"]=0x2F947, -- 真
 },
 [0x2F948]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x774A },
  ["unicodeslot"]=0x2F948, -- 睊
 },
 [0x2F949]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4039 },
  ["unicodeslot"]=0x2F949, -- 䀹
 },
 [0x2F94A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005EA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x778B },
  ["unicodeslot"]=0x2F94A, -- 瞋
 },
 [0x2F94B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005EB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4046 },
  ["unicodeslot"]=0x2F94B, -- 䁆
 },
 [0x2F94C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005EC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4096 },
  ["unicodeslot"]=0x2F94C, -- 䂖
 },
 [0x2F94D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005ED",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2541D },
  ["unicodeslot"]=0x2F94D, -- 𥐝
 },
 [0x2F94E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005EE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x784E },
  ["unicodeslot"]=0x2F94E, -- 硎
 },
 [0x2F94F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005EF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x788C },
  ["unicodeslot"]=0x2F94F, -- 碌
 },
 [0x2F950]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x78CC },
  ["unicodeslot"]=0x2F950, -- 磌
 },
 [0x2F951]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x40E3 },
  ["unicodeslot"]=0x2F951, -- 䃣
 },
 [0x2F952]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B8",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25626 },
  ["unicodeslot"]=0x2F952, -- 𥘦
 },
 [0x2F953]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03B9",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7956 },
  ["unicodeslot"]=0x2F953, -- 祖
 },
 [0x2F954]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03BA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2569A },
  ["unicodeslot"]=0x2F954, -- 𥚚
 },
 [0x2F955]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03BB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x256C5 },
  ["unicodeslot"]=0x2F955, -- 𥛅
 },
 [0x2F956]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03BC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x798F },
  ["unicodeslot"]=0x2F956, -- 福
 },
 [0x2F957]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03BD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x79EB },
  ["unicodeslot"]=0x2F957, -- 秫
 },
 [0x2F958]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03BE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x412F },
  ["unicodeslot"]=0x2F958, -- 䄯
 },
 [0x2F959]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03BF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7A40 },
  ["unicodeslot"]=0x2F959, -- 穀
 },
 [0x2F95A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005FA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7A4A },
  ["unicodeslot"]=0x2F95A, -- 穊
 },
 [0x2F95B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005FB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7A4F },
  ["unicodeslot"]=0x2F95B, -- 穏
 },
 [0x2F95C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005FC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2597C },
  ["unicodeslot"]=0x2F95C, -- 𥥼
 },
 [0x2F95D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005FD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25AA7 },
  ["unicodeslot"]=0x2F95D, -- 𥪧
 },
 [0x2F95E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005FE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25AA7 },
  ["unicodeslot"]=0x2F95E, -- 𥪧
 },
 [0x2F95F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x005FF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7AEE },
  ["unicodeslot"]=0x2F95F, -- 竮
 },
 [0x2F960]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4202 },
  ["unicodeslot"]=0x2F960, -- 䈂
 },
 [0x2F961]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25BAB },
  ["unicodeslot"]=0x2F961, -- 𥮫
 },
 [0x2F962]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7BC6 },
  ["unicodeslot"]=0x2F962, -- 篆
 },
 [0x2F963]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7BC9 },
  ["unicodeslot"]=0x2F963, -- 築
 },
 [0x2F964]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4227 },
  ["unicodeslot"]=0x2F964, -- 䈧
 },
 [0x2F965]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25C80 },
  ["unicodeslot"]=0x2F965, -- 𥲀
 },
 [0x2F966]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7CD2 },
  ["unicodeslot"]=0x2F966, -- 糒
 },
 [0x2F967]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x42A0 },
  ["unicodeslot"]=0x2F967, -- 䊠
 },
 [0x2F968]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C8",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7CE8 },
  ["unicodeslot"]=0x2F968, -- 糨
 },
 [0x2F969]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03C9",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7CE3 },
  ["unicodeslot"]=0x2F969, -- 糣
 },
 [0x2F96A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0060A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7D00 },
  ["unicodeslot"]=0x2F96A, -- 紀
 },
 [0x2F96B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0060B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x25F86 },
  ["unicodeslot"]=0x2F96B, -- 𥾆
 },
 [0x2F96C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0060C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7D63 },
  ["unicodeslot"]=0x2F96C, -- 絣
 },
 [0x2F96D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0060D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4301 },
  ["unicodeslot"]=0x2F96D, -- 䌁
 },
 [0x2F96E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0060E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7DC7 },
  ["unicodeslot"]=0x2F96E, -- 緇
 },
 [0x2F96F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0060F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7E02 },
  ["unicodeslot"]=0x2F96F, -- 縂
 },
 [0x2F970]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03CA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7E45 },
  ["unicodeslot"]=0x2F970, -- 繅
 },
 [0x2F971]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03CB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4334 },
  ["unicodeslot"]=0x2F971, -- 䌴
 },
 [0x2F972]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03CC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x26228 },
  ["unicodeslot"]=0x2F972, -- 𦈨
 },
 [0x2F973]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03CD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x26247 },
  ["unicodeslot"]=0x2F973, -- 𦉇
 },
 [0x2F974]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03CE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4359 },
  ["unicodeslot"]=0x2F974, -- 䍙
 },
 [0x2F975]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03CF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x262D9 },
  ["unicodeslot"]=0x2F975, -- 𦋙
 },
 [0x2F976]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7F7A },
  ["unicodeslot"]=0x2F976, -- 罺
 },
 [0x2F977]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2633E },
  ["unicodeslot"]=0x2F977, -- 𦌾
 },
 [0x2F978]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7F95 },
  ["unicodeslot"]=0x2F978, -- 羕
 },
 [0x2F979]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x7FFA },
  ["unicodeslot"]=0x2F979, -- 翺
 },
 [0x2F97A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0061A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8005 },
  ["unicodeslot"]=0x2F97A, -- 者
 },
 [0x2F97B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0061B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x264DA },
  ["unicodeslot"]=0x2F97B, -- 𦓚
 },
 [0x2F97C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0061C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x26523 },
  ["unicodeslot"]=0x2F97C, -- 𦔣
 },
 [0x2F97D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0061D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8060 },
  ["unicodeslot"]=0x2F97D, -- 聠
 },
 [0x2F97E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0061E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x265A8 },
  ["unicodeslot"]=0x2F97E, -- 𦖨
 },
 [0x2F97F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0061F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8070 },
  ["unicodeslot"]=0x2F97F, -- 聰
 },
 [0x2F980]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2335F },
  ["unicodeslot"]=0x2F980, -- 𣍟
 },
 [0x2F981]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x43D5 },
  ["unicodeslot"]=0x2F981, -- 䏕
 },
 [0x2F982]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x80B2 },
  ["unicodeslot"]=0x2F982, -- 育
 },
 [0x2F983]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8103 },
  ["unicodeslot"]=0x2F983, -- 脃
 },
 [0x2F984]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D8",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x440B },
  ["unicodeslot"]=0x2F984, -- 䐋
 },
 [0x2F985]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03D9",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x813E },
  ["unicodeslot"]=0x2F985, -- 脾
 },
 [0x2F986]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03DA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5AB5 },
  ["unicodeslot"]=0x2F986, -- 媵
 },
 [0x2F987]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03DB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x267A7 },
  ["unicodeslot"]=0x2F987, -- 𦞧
 },
 [0x2F988]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03DC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x267B5 },
  ["unicodeslot"]=0x2F988, -- 𦞵
 },
 [0x2F989]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03DD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x23393 },
  ["unicodeslot"]=0x2F989, -- 𣎓
 },
 [0x2F98A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0062A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2339C },
  ["unicodeslot"]=0x2F98A, -- 𣎜
 },
 [0x2F98B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0062B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8201 },
  ["unicodeslot"]=0x2F98B, -- 舁
 },
 [0x2F98C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0062C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8204 },
  ["unicodeslot"]=0x2F98C, -- 舄
 },
 [0x2F98D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0062D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8F9E },
  ["unicodeslot"]=0x2F98D, -- 辞
 },
 [0x2F98E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0062E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x446B },
  ["unicodeslot"]=0x2F98E, -- 䑫
 },
 [0x2F98F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0062F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8291 },
  ["unicodeslot"]=0x2F98F, -- 芑
 },
 [0x2F990]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03DE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x828B },
  ["unicodeslot"]=0x2F990, -- 芋
 },
 [0x2F991]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03DF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x829D },
  ["unicodeslot"]=0x2F991, -- 芝
 },
 [0x2F992]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03E0",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x52B3 },
  ["unicodeslot"]=0x2F992, -- 劳
 },
 [0x2F993]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03E1",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x82B1 },
  ["unicodeslot"]=0x2F993, -- 花
 },
 [0x2F994]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03E2",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x82B3 },
  ["unicodeslot"]=0x2F994, -- 芳
 },
 [0x2F995]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03E3",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x82BD },
  ["unicodeslot"]=0x2F995, -- 芽
 },
 [0x2F996]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03E4",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x82E6 },
  ["unicodeslot"]=0x2F996, -- 苦
 },
 [0x2F997]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03E5",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x26B3C },
  ["unicodeslot"]=0x2F997, -- 𦬼
 },
 [0x2F998]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03E6",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x82E5 },
  ["unicodeslot"]=0x2F998, -- 若
 },
 [0x2F999]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x03E7",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x831D },
  ["unicodeslot"]=0x2F999, -- 茝
 },
 [0x2F99A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0063A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8363 },
  ["unicodeslot"]=0x2F99A, -- 荣
 },
 [0x2F99B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0063B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x83AD },
  ["unicodeslot"]=0x2F99B, -- 莭
 },
 [0x2F99C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0063C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8323 },
  ["unicodeslot"]=0x2F99C, -- 茣
 },
 [0x2F99D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0063D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x83BD },
  ["unicodeslot"]=0x2F99D, -- 莽
 },
 [0x2F99E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0063E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x83E7 },
  ["unicodeslot"]=0x2F99E, -- 菧
 },
 [0x2F99F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0063F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8457 },
  ["unicodeslot"]=0x2F99F, -- 著
 },
 [0x2F9A0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8353 },
  ["unicodeslot"]=0x2F9A0, -- 荓
 },
 [0x2F9A1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x83CA },
  ["unicodeslot"]=0x2F9A1, -- 菊
 },
 [0x2F9A2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x83CC },
  ["unicodeslot"]=0x2F9A2, -- 菌
 },
 [0x2F9A3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x83DC },
  ["unicodeslot"]=0x2F9A3, -- 菜
 },
 [0x2F9A4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x26C36 },
  ["unicodeslot"]=0x2F9A4, -- 𦰶
 },
 [0x2F9A5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x26D6B },
  ["unicodeslot"]=0x2F9A5, -- 𦵫
 },
 [0x2F9A6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x26CD5 },
  ["unicodeslot"]=0x2F9A6, -- 𦳕
 },
 [0x2F9A7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x452B },
  ["unicodeslot"]=0x2F9A7, -- 䔫
 },
 [0x2F9A8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x84F1 },
  ["unicodeslot"]=0x2F9A8, -- 蓱
 },
 [0x2F9A9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009A0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x84F3 },
  ["unicodeslot"]=0x2F9A9, -- 蓳
 },
 [0x2F9AA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009AA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8516 },
  ["unicodeslot"]=0x2F9AA, -- 蔖
 },
 [0x2F9AB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009AB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x273CA },
  ["unicodeslot"]=0x2F9AB, -- 𧏊
 },
 [0x2F9AC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009AC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8564 },
  ["unicodeslot"]=0x2F9AC, -- 蕤
 },
 [0x2F9AD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009AD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x26F2C },
  ["unicodeslot"]=0x2F9AD, -- 𦼬
 },
 [0x2F9AE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009AE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x455D },
  ["unicodeslot"]=0x2F9AE, -- 䕝
 },
 [0x2F9AF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009AF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4561 },
  ["unicodeslot"]=0x2F9AF, -- 䕡
 },
 [0x2F9B0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x26FB1 },
  ["unicodeslot"]=0x2F9B0, -- 𦾱
 },
 [0x2F9B1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x270D2 },
  ["unicodeslot"]=0x2F9B1, -- 𧃒
 },
 [0x2F9B2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x456B },
  ["unicodeslot"]=0x2F9B2, -- 䕫
 },
 [0x2F9B3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8650 },
  ["unicodeslot"]=0x2F9B3, -- 虐
 },
 [0x2F9B4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x865C },
  ["unicodeslot"]=0x2F9B4, -- 虜
 },
 [0x2F9B5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8667 },
  ["unicodeslot"]=0x2F9B5, -- 虧
 },
 [0x2F9B6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8669 },
  ["unicodeslot"]=0x2F9B6, -- 虩
 },
 [0x2F9B7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x86A9 },
  ["unicodeslot"]=0x2F9B7, -- 蚩
 },
 [0x2F9B8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8688 },
  ["unicodeslot"]=0x2F9B8, -- 蚈
 },
 [0x2F9B9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009B0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x870E },
  ["unicodeslot"]=0x2F9B9, -- 蜎
 },
 [0x2F9BA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009BA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x86E2 },
  ["unicodeslot"]=0x2F9BA, -- 蛢
 },
 [0x2F9BB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009BB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8779 },
  ["unicodeslot"]=0x2F9BB, -- 蝹
 },
 [0x2F9BC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009BC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8728 },
  ["unicodeslot"]=0x2F9BC, -- 蜨
 },
 [0x2F9BD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009BD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x876B },
  ["unicodeslot"]=0x2F9BD, -- 蝫
 },
 [0x2F9BE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009BE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8786 },
  ["unicodeslot"]=0x2F9BE, -- 螆
 },
 [0x2F9BF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009BF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x45D7 },
  ["unicodeslot"]=0x2F9BF, -- 䗗
 },
 [0x2F9C0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x87E1 },
  ["unicodeslot"]=0x2F9C0, -- 蟡
 },
 [0x2F9C1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8801 },
  ["unicodeslot"]=0x2F9C1, -- 蠁
 },
 [0x2F9C2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x45F9 },
  ["unicodeslot"]=0x2F9C2, -- 䗹
 },
 [0x2F9C3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8860 },
  ["unicodeslot"]=0x2F9C3, -- 衠
 },
 [0x2F9C4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8863 },
  ["unicodeslot"]=0x2F9C4, -- 衣
 },
 [0x2F9C5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x27667 },
  ["unicodeslot"]=0x2F9C5, -- 𧙧
 },
 [0x2F9C6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x88D7 },
  ["unicodeslot"]=0x2F9C6, -- 裗
 },
 [0x2F9C7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x88DE },
  ["unicodeslot"]=0x2F9C7, -- 裞
 },
 [0x2F9C8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4635 },
  ["unicodeslot"]=0x2F9C8, -- 䘵
 },
 [0x2F9C9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009C0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x88FA },
  ["unicodeslot"]=0x2F9C9, -- 裺
 },
 [0x2F9CA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009CA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x34BB },
  ["unicodeslot"]=0x2F9CA, -- 㒻
 },
 [0x2F9CB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009CB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x278AE },
  ["unicodeslot"]=0x2F9CB, -- 𧢮
 },
 [0x2F9CC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009CC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x27966 },
  ["unicodeslot"]=0x2F9CC, -- 𧥦
 },
 [0x2F9CD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009CD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x46BE },
  ["unicodeslot"]=0x2F9CD, -- 䚾
 },
 [0x2F9CE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009CE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x46C7 },
  ["unicodeslot"]=0x2F9CE, -- 䛇
 },
 [0x2F9CF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009CF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AA0 },
  ["unicodeslot"]=0x2F9CF, -- 誠
 },
 [0x2F9D0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8AED },
  ["unicodeslot"]=0x2F9D0, -- 諭
 },
 [0x2F9D1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8B8A },
  ["unicodeslot"]=0x2F9D1, -- 變
 },
 [0x2F9D2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8C55 },
  ["unicodeslot"]=0x2F9D2, -- 豕
 },
 [0x2F9D3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x27CA8 },
  ["unicodeslot"]=0x2F9D3, -- 𧲨
 },
 [0x2F9D4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8CAB },
  ["unicodeslot"]=0x2F9D4, -- 貫
 },
 [0x2F9D5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8CC1 },
  ["unicodeslot"]=0x2F9D5, -- 賁
 },
 [0x2F9D6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8D1B },
  ["unicodeslot"]=0x2F9D6, -- 贛
 },
 [0x2F9D7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8D77 },
  ["unicodeslot"]=0x2F9D7, -- 起
 },
 [0x2F9D8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x27F2F },
  ["unicodeslot"]=0x2F9D8, -- 𧼯
 },
 [0x2F9D9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009D0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x20804 },
  ["unicodeslot"]=0x2F9D9, -- 𠠄
 },
 [0x2F9DA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009DA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8DCB },
  ["unicodeslot"]=0x2F9DA, -- 跋
 },
 [0x2F9DB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009DB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8DBC },
  ["unicodeslot"]=0x2F9DB, -- 趼
 },
 [0x2F9DC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009DC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8DF0 },
  ["unicodeslot"]=0x2F9DC, -- 跰
 },
 [0x2F9DD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009DD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x208DE },
  ["unicodeslot"]=0x2F9DD, -- 𠣞
 },
 [0x2F9DE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009DE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8ED4 },
  ["unicodeslot"]=0x2F9DE, -- 軔
 },
 [0x2F9DF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009DF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x8F38 },
  ["unicodeslot"]=0x2F9DF, -- 輸
 },
 [0x2F9E0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x285D2 },
  ["unicodeslot"]=0x2F9E0, -- 𨗒
 },
 [0x2F9E1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x285ED },
  ["unicodeslot"]=0x2F9E1, -- 𨗭
 },
 [0x2F9E2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9094 },
  ["unicodeslot"]=0x2F9E2, -- 邔
 },
 [0x2F9E3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x90F1 },
  ["unicodeslot"]=0x2F9E3, -- 郱
 },
 [0x2F9E4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9111 },
  ["unicodeslot"]=0x2F9E4, -- 鄑
 },
 [0x2F9E5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2872E },
  ["unicodeslot"]=0x2F9E5, -- 𨜮
 },
 [0x2F9E6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x911B },
  ["unicodeslot"]=0x2F9E6, -- 鄛
 },
 [0x2F9E7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9238 },
  ["unicodeslot"]=0x2F9E7, -- 鈸
 },
 [0x2F9E8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x92D7 },
  ["unicodeslot"]=0x2F9E8, -- 鋗
 },
 [0x2F9E9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009E0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x92D8 },
  ["unicodeslot"]=0x2F9E9, -- 鋘
 },
 [0x2F9EA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009EA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x927C },
  ["unicodeslot"]=0x2F9EA, -- 鉼
 },
 [0x2F9EB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009EB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x93F9 },
  ["unicodeslot"]=0x2F9EB, -- 鏹
 },
 [0x2F9EC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009EC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9415 },
  ["unicodeslot"]=0x2F9EC, -- 鐕
 },
 [0x2F9ED]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009ED",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x28BFA },
  ["unicodeslot"]=0x2F9ED, -- 𨯺
 },
 [0x2F9EE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009EE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x958B },
  ["unicodeslot"]=0x2F9EE, -- 開
 },
 [0x2F9EF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009EF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4995 },
  ["unicodeslot"]=0x2F9EF, -- 䦕
 },
 [0x2F9F0]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x95B7 },
  ["unicodeslot"]=0x2F9F0, -- 閷
 },
 [0x2F9F1]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x28D77 },
  ["unicodeslot"]=0x2F9F1, -- 𨵷
 },
 [0x2F9F2]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x49E6 },
  ["unicodeslot"]=0x2F9F2, -- 䧦
 },
 [0x2F9F3]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x96C3 },
  ["unicodeslot"]=0x2F9F3, -- 雃
 },
 [0x2F9F4]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x5DB2 },
  ["unicodeslot"]=0x2F9F4, -- 嶲
 },
 [0x2F9F5]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9723 },
  ["unicodeslot"]=0x2F9F5, -- 霣
 },
 [0x2F9F6]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x29145 },
  ["unicodeslot"]=0x2F9F6, -- 𩅅
 },
 [0x2F9F7]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2921A },
  ["unicodeslot"]=0x2F9F7, -- 𩈚
 },
 [0x2F9F8]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4A6E },
  ["unicodeslot"]=0x2F9F8, -- 䩮
 },
 [0x2F9F9]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009F0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4A76 },
  ["unicodeslot"]=0x2F9F9, -- 䩶
 },
 [0x2F9FA]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009FA",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x97E0 },
  ["unicodeslot"]=0x2F9FA, -- 韠
 },
 [0x2F9FB]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009FB",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2940A },
  ["unicodeslot"]=0x2F9FB, -- 𩐊
 },
 [0x2F9FC]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009FC",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4AB2 },
  ["unicodeslot"]=0x2F9FC, -- 䪲
 },
 [0x2F9FD]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009FD",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x29496 },
  ["unicodeslot"]=0x2F9FD, -- 𩒖
 },
 [0x2F9FE]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009FE",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x980B },
  ["unicodeslot"]=0x2F9FE, -- 頋
 },
 [0x2F9FF]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002F0x0009FF",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x980B },
  ["unicodeslot"]=0x2F9FF, -- 頋
 },
 [0x2FA00]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0000",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9829 },
  ["unicodeslot"]=0x2FA00, -- 頩
 },
 [0x2FA01]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0001",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x295B6 },
  ["unicodeslot"]=0x2FA01, -- 𩖶
 },
 [0x2FA02]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0002",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x98E2 },
  ["unicodeslot"]=0x2FA02, -- 飢
 },
 [0x2FA03]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0003",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4B33 },
  ["unicodeslot"]=0x2FA03, -- 䬳
 },
 [0x2FA04]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0004",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9929 },
  ["unicodeslot"]=0x2FA04, -- 餩
 },
 [0x2FA05]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0005",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x99A7 },
  ["unicodeslot"]=0x2FA05, -- 馧
 },
 [0x2FA06]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0006",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x99C2 },
  ["unicodeslot"]=0x2FA06, -- 駂
 },
 [0x2FA07]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0007",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x99FE },
  ["unicodeslot"]=0x2FA07, -- 駾
 },
 [0x2FA08]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0008",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4BCE },
  ["unicodeslot"]=0x2FA08, -- 䯎
 },
 [0x2FA09]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0009",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x29B30 },
  ["unicodeslot"]=0x2FA09, -- 𩬰
 },
 [0x2FA0A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0000A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9B12 },
  ["unicodeslot"]=0x2FA0A, -- 鬒
 },
 [0x2FA0B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0000B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9C40 },
  ["unicodeslot"]=0x2FA0B, -- 鱀
 },
 [0x2FA0C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0000C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9CFD },
  ["unicodeslot"]=0x2FA0C, -- 鳽
 },
 [0x2FA0D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0000D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4CCE },
  ["unicodeslot"]=0x2FA0D, -- 䳎
 },
 [0x2FA0E]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0000E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4CED },
  ["unicodeslot"]=0x2FA0E, -- 䳭
 },
 [0x2FA0F]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0000F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9D67 },
  ["unicodeslot"]=0x2FA0F, -- 鵧
 },
 [0x2FA10]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x000A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2A0CE },
  ["unicodeslot"]=0x2FA10, -- 𪃎
 },
 [0x2FA11]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x000B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4CF8 },
  ["unicodeslot"]=0x2FA11, -- 䳸
 },
 [0x2FA12]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x000C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2A105 },
  ["unicodeslot"]=0x2FA12, -- 𪄅
 },
 [0x2FA13]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x000D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2A20E },
  ["unicodeslot"]=0x2FA13, -- 𪈎
 },
 [0x2FA14]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x000E",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2A291 },
  ["unicodeslot"]=0x2FA14, -- 𪊑
 },
 [0x2FA15]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x000F",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9EBB },
  ["unicodeslot"]=0x2FA15, -- 麻
 },
 [0x2FA16]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0010",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x4D56 },
  ["unicodeslot"]=0x2FA16, -- 䵖
 },
 [0x2FA17]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0011",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9EF9 },
  ["unicodeslot"]=0x2FA17, -- 黹
 },
 [0x2FA18]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0012",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9EFE },
  ["unicodeslot"]=0x2FA18, -- 黾
 },
 [0x2FA19]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0013",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F05 },
  ["unicodeslot"]=0x2FA19, -- 鼅
 },
 [0x2FA1A]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0001A",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F0F },
  ["unicodeslot"]=0x2FA1A, -- 鼏
 },
 [0x2FA1B]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0001B",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F16 },
  ["unicodeslot"]=0x2FA1B, -- 鼖
 },
 [0x2FA1C]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0001C",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x9F3B },
  ["unicodeslot"]=0x2FA1C, -- 鼻
 },
 [0x2FA1D]={
  ["category"]="lo",
  ["cjkwd"]="w",
  ["description"]="CJK COMPATIBILITY IDEOGRAPH-0x0002FA0x0001D",
  ["linebreak"]="id",
  ["specials"]={ "char", 0x2A600 },
  ["unicodeslot"]=0x2FA1D, -- 𪘀
 },
 [0xE0001]={
  ["category"]="cf",
  ["description"]="LANGUAGE TAG",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0001, -- 󠀁
 },
 [0xE0020]={
  ["category"]="cf",
  ["description"]="TAG SPACE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0020, -- 󠀠
 },
 [0xE0021]={
  ["category"]="cf",
  ["description"]="TAG EXCLAMATION MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0021, -- 󠀡
 },
 [0xE0022]={
  ["category"]="cf",
  ["description"]="TAG QUOTATION MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0022, -- 󠀢
 },
 [0xE0023]={
  ["category"]="cf",
  ["description"]="TAG NUMBER SIGN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0023, -- 󠀣
 },
 [0xE0024]={
  ["category"]="cf",
  ["description"]="TAG DOLLAR SIGN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0024, -- 󠀤
 },
 [0xE0025]={
  ["category"]="cf",
  ["description"]="TAG PERCENT SIGN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0025, -- 󠀥
 },
 [0xE0026]={
  ["category"]="cf",
  ["description"]="TAG AMPERSAND",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0026, -- 󠀦
 },
 [0xE0027]={
  ["category"]="cf",
  ["description"]="TAG APOSTROPHE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0027, -- 󠀧
 },
 [0xE0028]={
  ["category"]="cf",
  ["description"]="TAG LEFT PARENTHESIS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0028, -- 󠀨
 },
 [0xE0029]={
  ["category"]="cf",
  ["description"]="TAG RIGHT PARENTHESIS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0029, -- 󠀩
 },
 [0xE002A]={
  ["category"]="cf",
  ["description"]="TAG ASTERISK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE002A, -- 󠀪
 },
 [0xE002B]={
  ["category"]="cf",
  ["description"]="TAG PLUS SIGN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE002B, -- 󠀫
 },
 [0xE002C]={
  ["category"]="cf",
  ["description"]="TAG COMMA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE002C, -- 󠀬
 },
 [0xE002D]={
  ["category"]="cf",
  ["description"]="TAG HYPHEN-MINUS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE002D, -- 󠀭
 },
 [0xE002E]={
  ["category"]="cf",
  ["description"]="TAG FULL STOP",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE002E, -- 󠀮
 },
 [0xE002F]={
  ["category"]="cf",
  ["description"]="TAG SOLIDUS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE002F, -- 󠀯
 },
 [0xE0030]={
  ["category"]="cf",
  ["description"]="TAG DIGIT ZERO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0030, -- 󠀰
 },
 [0xE0031]={
  ["category"]="cf",
  ["description"]="TAG DIGIT ONE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0031, -- 󠀱
 },
 [0xE0032]={
  ["category"]="cf",
  ["description"]="TAG DIGIT TWO",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0032, -- 󠀲
 },
 [0xE0033]={
  ["category"]="cf",
  ["description"]="TAG DIGIT THREE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0033, -- 󠀳
 },
 [0xE0034]={
  ["category"]="cf",
  ["description"]="TAG DIGIT FOUR",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0034, -- 󠀴
 },
 [0xE0035]={
  ["category"]="cf",
  ["description"]="TAG DIGIT FIVE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0035, -- 󠀵
 },
 [0xE0036]={
  ["category"]="cf",
  ["description"]="TAG DIGIT SIX",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0036, -- 󠀶
 },
 [0xE0037]={
  ["category"]="cf",
  ["description"]="TAG DIGIT SEVEN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0037, -- 󠀷
 },
 [0xE0038]={
  ["category"]="cf",
  ["description"]="TAG DIGIT EIGHT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0038, -- 󠀸
 },
 [0xE0039]={
  ["category"]="cf",
  ["description"]="TAG DIGIT NINE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0039, -- 󠀹
 },
 [0xE003A]={
  ["category"]="cf",
  ["description"]="TAG COLON",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE003A, -- 󠀺
 },
 [0xE003B]={
  ["category"]="cf",
  ["description"]="TAG SEMICOLON",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE003B, -- 󠀻
 },
 [0xE003C]={
  ["category"]="cf",
  ["description"]="TAG LESS-THAN SIGN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE003C, -- 󠀼
 },
 [0xE003D]={
  ["category"]="cf",
  ["description"]="TAG EQUALS SIGN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE003D, -- 󠀽
 },
 [0xE003E]={
  ["category"]="cf",
  ["description"]="TAG GREATER-THAN SIGN",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE003E, -- 󠀾
 },
 [0xE003F]={
  ["category"]="cf",
  ["description"]="TAG QUESTION MARK",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE003F, -- 󠀿
 },
 [0xE0040]={
  ["category"]="cf",
  ["description"]="TAG COMMERCIAL AT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0040, -- 󠁀
 },
 [0xE0041]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0041, -- 󠁁
 },
 [0xE0042]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0042, -- 󠁂
 },
 [0xE0043]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0043, -- 󠁃
 },
 [0xE0044]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0044, -- 󠁄
 },
 [0xE0045]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0045, -- 󠁅
 },
 [0xE0046]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0046, -- 󠁆
 },
 [0xE0047]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER G",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0047, -- 󠁇
 },
 [0xE0048]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER H",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0048, -- 󠁈
 },
 [0xE0049]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0049, -- 󠁉
 },
 [0xE004A]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER J",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE004A, -- 󠁊
 },
 [0xE004B]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER K",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE004B, -- 󠁋
 },
 [0xE004C]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER L",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE004C, -- 󠁌
 },
 [0xE004D]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER M",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE004D, -- 󠁍
 },
 [0xE004E]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER N",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE004E, -- 󠁎
 },
 [0xE004F]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE004F, -- 󠁏
 },
 [0xE0050]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER P",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0050, -- 󠁐
 },
 [0xE0051]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER Q",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0051, -- 󠁑
 },
 [0xE0052]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0052, -- 󠁒
 },
 [0xE0053]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER S",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0053, -- 󠁓
 },
 [0xE0054]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER T",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0054, -- 󠁔
 },
 [0xE0055]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0055, -- 󠁕
 },
 [0xE0056]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER V",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0056, -- 󠁖
 },
 [0xE0057]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER W",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0057, -- 󠁗
 },
 [0xE0058]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER X",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0058, -- 󠁘
 },
 [0xE0059]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER Y",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0059, -- 󠁙
 },
 [0xE005A]={
  ["category"]="cf",
  ["description"]="TAG LATIN CAPITAL LETTER Z",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE005A, -- 󠁚
 },
 [0xE005B]={
  ["category"]="cf",
  ["description"]="TAG LEFT SQUARE BRACKET",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE005B, -- 󠁛
 },
 [0xE005C]={
  ["category"]="cf",
  ["description"]="TAG REVERSE SOLIDUS",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE005C, -- 󠁜
 },
 [0xE005D]={
  ["category"]="cf",
  ["description"]="TAG RIGHT SQUARE BRACKET",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE005D, -- 󠁝
 },
 [0xE005E]={
  ["category"]="cf",
  ["description"]="TAG CIRCUMFLEX ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE005E, -- 󠁞
 },
 [0xE005F]={
  ["category"]="cf",
  ["description"]="TAG LOW LINE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE005F, -- 󠁟
 },
 [0xE0060]={
  ["category"]="cf",
  ["description"]="TAG GRAVE ACCENT",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0060, -- 󠁠
 },
 [0xE0061]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0061, -- 󠁡
 },
 [0xE0062]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0062, -- 󠁢
 },
 [0xE0063]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0063, -- 󠁣
 },
 [0xE0064]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0064, -- 󠁤
 },
 [0xE0065]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0065, -- 󠁥
 },
 [0xE0066]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0066, -- 󠁦
 },
 [0xE0067]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER G",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0067, -- 󠁧
 },
 [0xE0068]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER H",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0068, -- 󠁨
 },
 [0xE0069]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER I",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0069, -- 󠁩
 },
 [0xE006A]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER J",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE006A, -- 󠁪
 },
 [0xE006B]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER K",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE006B, -- 󠁫
 },
 [0xE006C]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER L",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE006C, -- 󠁬
 },
 [0xE006D]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER M",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE006D, -- 󠁭
 },
 [0xE006E]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER N",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE006E, -- 󠁮
 },
 [0xE006F]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER O",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE006F, -- 󠁯
 },
 [0xE0070]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER P",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0070, -- 󠁰
 },
 [0xE0071]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER Q",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0071, -- 󠁱
 },
 [0xE0072]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER R",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0072, -- 󠁲
 },
 [0xE0073]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER S",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0073, -- 󠁳
 },
 [0xE0074]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER T",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0074, -- 󠁴
 },
 [0xE0075]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER U",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0075, -- 󠁵
 },
 [0xE0076]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER V",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0076, -- 󠁶
 },
 [0xE0077]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER W",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0077, -- 󠁷
 },
 [0xE0078]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER X",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0078, -- 󠁸
 },
 [0xE0079]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER Y",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0079, -- 󠁹
 },
 [0xE007A]={
  ["category"]="cf",
  ["description"]="TAG LATIN SMALL LETTER Z",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE007A, -- 󠁺
 },
 [0xE007B]={
  ["category"]="cf",
  ["description"]="TAG LEFT CURLY BRACKET",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE007B, -- 󠁻
 },
 [0xE007C]={
  ["category"]="cf",
  ["description"]="TAG VERTICAL LINE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE007C, -- 󠁼
 },
 [0xE007D]={
  ["category"]="cf",
  ["description"]="TAG RIGHT CURLY BRACKET",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE007D, -- 󠁽
 },
 [0xE007E]={
  ["category"]="cf",
  ["description"]="TAG TILDE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE007E, -- 󠁾
 },
 [0xE007F]={
  ["category"]="cf",
  ["description"]="CANCEL TAG",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE007F, -- 󠁿
 },
 [0xE0100]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0011",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0100, -- 󠄀
 },
 [0xE0101]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0012",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0101, -- 󠄁
 },
 [0xE0102]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0013",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0102, -- 󠄂
 },
 [0xE0103]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0014",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0103, -- 󠄃
 },
 [0xE0104]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0015",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0104, -- 󠄄
 },
 [0xE0105]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0016",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0105, -- 󠄅
 },
 [0xE0106]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0017",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0106, -- 󠄆
 },
 [0xE0107]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0018",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0107, -- 󠄇
 },
 [0xE0108]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0019",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0108, -- 󠄈
 },
 [0xE0109]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x001A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0109, -- 󠄉
 },
 [0xE010A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x001B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE010A, -- 󠄊
 },
 [0xE010B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x001C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE010B, -- 󠄋
 },
 [0xE010C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x001D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE010C, -- 󠄌
 },
 [0xE010D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x001E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE010D, -- 󠄍
 },
 [0xE010E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x001F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE010E, -- 󠄎
 },
 [0xE010F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0020",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE010F, -- 󠄏
 },
 [0xE0110]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0021",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0110, -- 󠄐
 },
 [0xE0111]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0022",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0111, -- 󠄑
 },
 [0xE0112]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0023",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0112, -- 󠄒
 },
 [0xE0113]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0024",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0113, -- 󠄓
 },
 [0xE0114]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0025",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0114, -- 󠄔
 },
 [0xE0115]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0026",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0115, -- 󠄕
 },
 [0xE0116]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0027",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0116, -- 󠄖
 },
 [0xE0117]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0028",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0117, -- 󠄗
 },
 [0xE0118]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0029",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0118, -- 󠄘
 },
 [0xE0119]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x002A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0119, -- 󠄙
 },
 [0xE011A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x002B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE011A, -- 󠄚
 },
 [0xE011B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x002C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE011B, -- 󠄛
 },
 [0xE011C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x002D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE011C, -- 󠄜
 },
 [0xE011D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x002E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE011D, -- 󠄝
 },
 [0xE011E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x002F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE011E, -- 󠄞
 },
 [0xE011F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0030",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE011F, -- 󠄟
 },
 [0xE0120]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0031",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0120, -- 󠄠
 },
 [0xE0121]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0032",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0121, -- 󠄡
 },
 [0xE0122]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0033",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0122, -- 󠄢
 },
 [0xE0123]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0034",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0123, -- 󠄣
 },
 [0xE0124]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0035",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0124, -- 󠄤
 },
 [0xE0125]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0036",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0125, -- 󠄥
 },
 [0xE0126]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0037",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0126, -- 󠄦
 },
 [0xE0127]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0038",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0127, -- 󠄧
 },
 [0xE0128]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0039",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0128, -- 󠄨
 },
 [0xE0129]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x003A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0129, -- 󠄩
 },
 [0xE012A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x003B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE012A, -- 󠄪
 },
 [0xE012B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x003C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE012B, -- 󠄫
 },
 [0xE012C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x003D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE012C, -- 󠄬
 },
 [0xE012D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x003E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE012D, -- 󠄭
 },
 [0xE012E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x003F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE012E, -- 󠄮
 },
 [0xE012F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0040",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE012F, -- 󠄯
 },
 [0xE0130]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0041",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0130, -- 󠄰
 },
 [0xE0131]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0042",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0131, -- 󠄱
 },
 [0xE0132]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0043",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0132, -- 󠄲
 },
 [0xE0133]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0044",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0133, -- 󠄳
 },
 [0xE0134]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0045",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0134, -- 󠄴
 },
 [0xE0135]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0046",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0135, -- 󠄵
 },
 [0xE0136]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0047",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0136, -- 󠄶
 },
 [0xE0137]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0048",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0137, -- 󠄷
 },
 [0xE0138]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0049",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0138, -- 󠄸
 },
 [0xE0139]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x004A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0139, -- 󠄹
 },
 [0xE013A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x004B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE013A, -- 󠄺
 },
 [0xE013B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x004C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE013B, -- 󠄻
 },
 [0xE013C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x004D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE013C, -- 󠄼
 },
 [0xE013D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x004E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE013D, -- 󠄽
 },
 [0xE013E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x004F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE013E, -- 󠄾
 },
 [0xE013F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0050",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE013F, -- 󠄿
 },
 [0xE0140]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0051",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0140, -- 󠅀
 },
 [0xE0141]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0052",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0141, -- 󠅁
 },
 [0xE0142]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0053",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0142, -- 󠅂
 },
 [0xE0143]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0054",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0143, -- 󠅃
 },
 [0xE0144]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0055",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0144, -- 󠅄
 },
 [0xE0145]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0056",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0145, -- 󠅅
 },
 [0xE0146]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0057",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0146, -- 󠅆
 },
 [0xE0147]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0058",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0147, -- 󠅇
 },
 [0xE0148]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0059",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0148, -- 󠅈
 },
 [0xE0149]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x005A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0149, -- 󠅉
 },
 [0xE014A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x005B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE014A, -- 󠅊
 },
 [0xE014B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x005C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE014B, -- 󠅋
 },
 [0xE014C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x005D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE014C, -- 󠅌
 },
 [0xE014D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x005E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE014D, -- 󠅍
 },
 [0xE014E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x005F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE014E, -- 󠅎
 },
 [0xE014F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0060",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE014F, -- 󠅏
 },
 [0xE0150]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0061",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0150, -- 󠅐
 },
 [0xE0151]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0062",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0151, -- 󠅑
 },
 [0xE0152]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0063",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0152, -- 󠅒
 },
 [0xE0153]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0064",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0153, -- 󠅓
 },
 [0xE0154]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0065",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0154, -- 󠅔
 },
 [0xE0155]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0066",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0155, -- 󠅕
 },
 [0xE0156]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0067",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0156, -- 󠅖
 },
 [0xE0157]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0068",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0157, -- 󠅗
 },
 [0xE0158]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0069",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0158, -- 󠅘
 },
 [0xE0159]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x006A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0159, -- 󠅙
 },
 [0xE015A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x006B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE015A, -- 󠅚
 },
 [0xE015B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x006C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE015B, -- 󠅛
 },
 [0xE015C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x006D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE015C, -- 󠅜
 },
 [0xE015D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x006E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE015D, -- 󠅝
 },
 [0xE015E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x006F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE015E, -- 󠅞
 },
 [0xE015F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0070",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE015F, -- 󠅟
 },
 [0xE0160]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0071",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0160, -- 󠅠
 },
 [0xE0161]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0072",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0161, -- 󠅡
 },
 [0xE0162]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0073",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0162, -- 󠅢
 },
 [0xE0163]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0074",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0163, -- 󠅣
 },
 [0xE0164]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0075",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0164, -- 󠅤
 },
 [0xE0165]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0076",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0165, -- 󠅥
 },
 [0xE0166]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0077",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0166, -- 󠅦
 },
 [0xE0167]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0078",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0167, -- 󠅧
 },
 [0xE0168]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0079",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0168, -- 󠅨
 },
 [0xE0169]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x007A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0169, -- 󠅩
 },
 [0xE016A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x007B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE016A, -- 󠅪
 },
 [0xE016B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x007C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE016B, -- 󠅫
 },
 [0xE016C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x007D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE016C, -- 󠅬
 },
 [0xE016D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x007E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE016D, -- 󠅭
 },
 [0xE016E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x007F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE016E, -- 󠅮
 },
 [0xE016F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0080",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE016F, -- 󠅯
 },
 [0xE0170]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0081",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0170, -- 󠅰
 },
 [0xE0171]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0082",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0171, -- 󠅱
 },
 [0xE0172]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0083",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0172, -- 󠅲
 },
 [0xE0173]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0084",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0173, -- 󠅳
 },
 [0xE0174]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0085",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0174, -- 󠅴
 },
 [0xE0175]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0086",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0175, -- 󠅵
 },
 [0xE0176]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0087",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0176, -- 󠅶
 },
 [0xE0177]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0088",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0177, -- 󠅷
 },
 [0xE0178]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0089",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0178, -- 󠅸
 },
 [0xE0179]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x008A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0179, -- 󠅹
 },
 [0xE017A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x008B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE017A, -- 󠅺
 },
 [0xE017B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x008C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE017B, -- 󠅻
 },
 [0xE017C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x008D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE017C, -- 󠅼
 },
 [0xE017D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x008E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE017D, -- 󠅽
 },
 [0xE017E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x008F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE017E, -- 󠅾
 },
 [0xE017F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0090",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE017F, -- 󠅿
 },
 [0xE0180]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0091",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0180, -- 󠆀
 },
 [0xE0181]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0092",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0181, -- 󠆁
 },
 [0xE0182]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0093",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0182, -- 󠆂
 },
 [0xE0183]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0094",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0183, -- 󠆃
 },
 [0xE0184]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0095",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0184, -- 󠆄
 },
 [0xE0185]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0096",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0185, -- 󠆅
 },
 [0xE0186]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0097",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0186, -- 󠆆
 },
 [0xE0187]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0098",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0187, -- 󠆇
 },
 [0xE0188]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0099",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0188, -- 󠆈
 },
 [0xE0189]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x009A",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0189, -- 󠆉
 },
 [0xE018A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x009B",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE018A, -- 󠆊
 },
 [0xE018B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x009C",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE018B, -- 󠆋
 },
 [0xE018C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x009D",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE018C, -- 󠆌
 },
 [0xE018D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x009E",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE018D, -- 󠆍
 },
 [0xE018E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x009F",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE018E, -- 󠆎
 },
 [0xE018F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A0",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE018F, -- 󠆏
 },
 [0xE0190]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A1",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0190, -- 󠆐
 },
 [0xE0191]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A2",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0191, -- 󠆑
 },
 [0xE0192]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A3",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0192, -- 󠆒
 },
 [0xE0193]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A4",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0193, -- 󠆓
 },
 [0xE0194]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A5",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0194, -- 󠆔
 },
 [0xE0195]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A6",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0195, -- 󠆕
 },
 [0xE0196]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A7",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0196, -- 󠆖
 },
 [0xE0197]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A8",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0197, -- 󠆗
 },
 [0xE0198]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00A9",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0198, -- 󠆘
 },
 [0xE0199]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00AA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE0199, -- 󠆙
 },
 [0xE019A]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00AB",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE019A, -- 󠆚
 },
 [0xE019B]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00AC",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE019B, -- 󠆛
 },
 [0xE019C]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00AD",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE019C, -- 󠆜
 },
 [0xE019D]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00AE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE019D, -- 󠆝
 },
 [0xE019E]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00AF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE019E, -- 󠆞
 },
 [0xE019F]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B0",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE019F, -- 󠆟
 },
 [0xE01A0]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B1",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A0, -- 󠆠
 },
 [0xE01A1]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B2",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A1, -- 󠆡
 },
 [0xE01A2]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B3",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A2, -- 󠆢
 },
 [0xE01A3]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B4",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A3, -- 󠆣
 },
 [0xE01A4]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B5",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A4, -- 󠆤
 },
 [0xE01A5]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B6",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A5, -- 󠆥
 },
 [0xE01A6]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B7",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A6, -- 󠆦
 },
 [0xE01A7]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B8",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A7, -- 󠆧
 },
 [0xE01A8]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00B9",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A8, -- 󠆨
 },
 [0xE01A9]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00BA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01A9, -- 󠆩
 },
 [0xE01AA]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00BB",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01AA, -- 󠆪
 },
 [0xE01AB]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00BC",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01AB, -- 󠆫
 },
 [0xE01AC]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00BD",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01AC, -- 󠆬
 },
 [0xE01AD]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00BE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01AD, -- 󠆭
 },
 [0xE01AE]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00BF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01AE, -- 󠆮
 },
 [0xE01AF]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C0",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01AF, -- 󠆯
 },
 [0xE01B0]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C1",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B0, -- 󠆰
 },
 [0xE01B1]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C2",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B1, -- 󠆱
 },
 [0xE01B2]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C3",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B2, -- 󠆲
 },
 [0xE01B3]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C4",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B3, -- 󠆳
 },
 [0xE01B4]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C5",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B4, -- 󠆴
 },
 [0xE01B5]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C6",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B5, -- 󠆵
 },
 [0xE01B6]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C7",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B6, -- 󠆶
 },
 [0xE01B7]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C8",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B7, -- 󠆷
 },
 [0xE01B8]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00C9",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B8, -- 󠆸
 },
 [0xE01B9]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00CA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01B9, -- 󠆹
 },
 [0xE01BA]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00CB",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01BA, -- 󠆺
 },
 [0xE01BB]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00CC",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01BB, -- 󠆻
 },
 [0xE01BC]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00CD",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01BC, -- 󠆼
 },
 [0xE01BD]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00CE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01BD, -- 󠆽
 },
 [0xE01BE]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00CF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01BE, -- 󠆾
 },
 [0xE01BF]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D0",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01BF, -- 󠆿
 },
 [0xE01C0]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D1",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C0, -- 󠇀
 },
 [0xE01C1]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D2",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C1, -- 󠇁
 },
 [0xE01C2]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D3",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C2, -- 󠇂
 },
 [0xE01C3]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D4",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C3, -- 󠇃
 },
 [0xE01C4]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D5",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C4, -- 󠇄
 },
 [0xE01C5]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D6",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C5, -- 󠇅
 },
 [0xE01C6]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D7",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C6, -- 󠇆
 },
 [0xE01C7]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D8",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C7, -- 󠇇
 },
 [0xE01C8]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00D9",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C8, -- 󠇈
 },
 [0xE01C9]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00DA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01C9, -- 󠇉
 },
 [0xE01CA]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00DB",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01CA, -- 󠇊
 },
 [0xE01CB]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00DC",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01CB, -- 󠇋
 },
 [0xE01CC]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00DD",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01CC, -- 󠇌
 },
 [0xE01CD]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00DE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01CD, -- 󠇍
 },
 [0xE01CE]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00DF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01CE, -- 󠇎
 },
 [0xE01CF]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E0",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01CF, -- 󠇏
 },
 [0xE01D0]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E1",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D0, -- 󠇐
 },
 [0xE01D1]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E2",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D1, -- 󠇑
 },
 [0xE01D2]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E3",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D2, -- 󠇒
 },
 [0xE01D3]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E4",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D3, -- 󠇓
 },
 [0xE01D4]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E5",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D4, -- 󠇔
 },
 [0xE01D5]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E6",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D5, -- 󠇕
 },
 [0xE01D6]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E7",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D6, -- 󠇖
 },
 [0xE01D7]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E8",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D7, -- 󠇗
 },
 [0xE01D8]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00E9",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D8, -- 󠇘
 },
 [0xE01D9]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00EA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01D9, -- 󠇙
 },
 [0xE01DA]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00EB",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01DA, -- 󠇚
 },
 [0xE01DB]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00EC",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01DB, -- 󠇛
 },
 [0xE01DC]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00ED",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01DC, -- 󠇜
 },
 [0xE01DD]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00EE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01DD, -- 󠇝
 },
 [0xE01DE]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00EF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01DE, -- 󠇞
 },
 [0xE01DF]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F0",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01DF, -- 󠇟
 },
 [0xE01E0]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F1",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E0, -- 󠇠
 },
 [0xE01E1]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F2",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E1, -- 󠇡
 },
 [0xE01E2]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F3",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E2, -- 󠇢
 },
 [0xE01E3]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F4",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E3, -- 󠇣
 },
 [0xE01E4]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F5",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E4, -- 󠇤
 },
 [0xE01E5]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F6",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E5, -- 󠇥
 },
 [0xE01E6]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F7",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E6, -- 󠇦
 },
 [0xE01E7]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F8",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E7, -- 󠇧
 },
 [0xE01E8]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00F9",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E8, -- 󠇨
 },
 [0xE01E9]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00FA",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01E9, -- 󠇩
 },
 [0xE01EA]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00FB",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01EA, -- 󠇪
 },
 [0xE01EB]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00FC",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01EB, -- 󠇫
 },
 [0xE01EC]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00FD",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01EC, -- 󠇬
 },
 [0xE01ED]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00FE",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01ED, -- 󠇭
 },
 [0xE01EE]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x00FF",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01EE, -- 󠇮
 },
 [0xE01EF]={
  ["category"]="mn",
  ["cjkwd"]="a",
  ["description"]="VARIATION SELECTOR-0x0100",
  ["linebreak"]="cm",
  ["unicodeslot"]=0xE01EF, -- 󠇯
 },
 [0xF0000]={
  ["category"]="co",
  ["cjkwd"]="a",
  ["description"]="<Plane 0x000F Private Use, First>",
  ["unicodeslot"]=0xF0000, -- 󰀀
 },
 [0xFFFFD]={
  ["category"]="co",
  ["cjkwd"]="a",
  ["description"]="<Plane 0x000F Private Use, Last>",
  ["unicodeslot"]=0xFFFFD, -- 󿿽
 },
 [0x100000]={
  ["category"]="co",
  ["cjkwd"]="a",
  ["description"]="<Plane 0x0010 Private Use, First>",
  ["unicodeslot"]=0x100000, -- 􀀀
 },
 [0x10FFFD]={
  ["category"]="co",
  ["cjkwd"]="a",
  ["description"]="<Plane 0x0010 Private Use, Last>",
  ["unicodeslot"]=0x10FFFD, -- 􏿽
 },
}
